/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/base/common/extpath","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],re=function(Q){for(var e=[],D=0,j=Q.length;D<j;D++)e[D]=se[Q[D]];return e};define(se[71],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const k=new Map,A=new Map,R=new Map,S=new Map;function u($,y){$.has(y.detail)||$.set(y.detail,-y.timestamp)}function a($,y){const O=$.get(y.detail);O&&(O>=0||$.set(y.detail,O+y.timestamp))}let g=[];typeof Q=="function"&&typeof Q.getStats=="function"&&(g=Q.getStats().slice(0).sort(($,y)=>$.timestamp-y.timestamp));for(const $ of g)switch($.type){case 10:u(k,$);break;case 11:case 12:a(k,$);break;case 21:u(A,$);break;case 22:a(A,$);break;case 33:u(R,$);break;case 34:a(R,$);break;case 31:u(S,$);break;case 32:a(S,$);break}let v=0;R.forEach($=>v+=$);function d($){const y=[];return $.forEach((O,m)=>y.push([m,O])),y}return{amdLoad:d(k),amdInvoke:d(A),nodeRequire:d(R),nodeEval:d(S),nodeRequireTotal:v}}static toMarkdownTable(k,A){let R="";const S=[];return k.forEach((u,a)=>{S[a]=u.length}),A.forEach(u=>{u.forEach((a,g)=>{typeof a>"u"&&(a=u[g]="-");const v=a.toString().length;S[g]=Math.max(v,S[g])})}),k.forEach((u,a)=>{R+=`| ${u+" ".repeat(S[a]-u.toString().length)} `}),R+=`|
`,k.forEach((u,a)=>{R+=`| ${"-".repeat(S[a])} `}),R+=`|
`,A.forEach(u=>{u.forEach((a,g)=>{typeof a<"u"&&(R+=`| ${a+" ".repeat(S[g]-a.toString().length)} `)}),R+=`|
`}),R}}e.$U=D}),define(se[54],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=j,e.$Vh=k,e.$Wh=A;function D(R){return(S,u,a)=>{let g=null,v=null;if(typeof a.value=="function"?(g="value",v=a.value):typeof a.get=="function"&&(g="get",v=a.get),!v)throw new Error("not supported");a[g]=R(v,u)}}function j(R,S,u){let a=null,g=null;if(typeof u.value=="function"?(a="value",g=u.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",g=u.get),!g)throw new Error("not supported");const v=`$memoize$${S}`;u[a]=function(...d){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,d)}),this[v]}}function k(R,S,u){return D((a,g)=>{const v=`$debounce$${g}`,d=`$debounce$result$${g}`;return function(...$){this[d]||(this[d]=u?u():void 0),clearTimeout(this[v]),S&&(this[d]=S(this[d],...$),$=[this[d]]),this[v]=setTimeout(()=>{a.apply(this,$),this[d]=u?u():void 0},R)}})}function A(R,S,u){return D((a,g)=>{const v=`$throttle$timer$${g}`,d=`$throttle$result$${g}`,$=`$throttle$lastRun$${g}`,y=`$throttle$pending$${g}`;return function(...O){if(this[d]||(this[d]=u?u():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),S&&(this[d]=S(this[d],...O)),this[y])return;const m=this[$]+R;m<=Date.now()?(this[$]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0):(this[y]=!0,this[v]=setTimeout(()=>{this[y]=!1,this[$]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0},m-Date.now()))}})}}),define(se[72],re([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=j,e.$cd=k,e.$dd=A,e.$ed=R,e.$fd=S,e.$gd=u;function j(a,g){if(!a)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}function k(a,g="Unreachable"){throw new Error(g)}function A(a){if(!a)throw new D.$cb("Assertion Failed")}function R(a){a||(0,D.$1)(new D.$cb("Soft Assertion Failed"))}function S(a){if(!a()){debugger;a(),(0,D.$1)(new D.$cb("Assertion Failed"))}}function u(a,g){let v=0;for(;v<a.length-1;){const d=a[v],$=a[v+1];if(!g(d,$))return!1;v++}return!0}}),define(se[38],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Bn=R,e.$Cn=v,e.$Dn=d,e.$En=$,e.$Fn=y,e.$Gn=O,e.$Hn=m,e.$In=c,e.$Jn=b,e.$Kn=w,e.$Ln=h,e.$Mn=p;var D;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var j;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(j||(e.SyntaxKind=j={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function R(i,r=!1){let t=0;const n=i.length;let s="",o=0,l=16,P=0;function I(K){let le=0,ue=0;for(;le<K;){const ae=i.charCodeAt(t);if(ae>=48&&ae<=57)ue=ue*16+ae-48;else if(ae>=65&&ae<=70)ue=ue*16+ae-65+10;else if(ae>=97&&ae<=102)ue=ue*16+ae-97+10;else break;t++,le++}return le<K&&(ue=-1),ue}function z(K){t=K,s="",o=0,l=16,P=0}function N(){const K=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return P=3,i.substring(K,t);let le=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;le=t}else P=3;return i.substring(K,le)}function U(){let K="",le=t;for(;;){if(t>=n){K+=i.substring(le,t),P=2;break}const ue=i.charCodeAt(t);if(ue===34){K+=i.substring(le,t),t++;break}if(ue===92){if(K+=i.substring(le,t),t++,t>=n){P=2;break}switch(i.charCodeAt(t++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:{const B=I(4);B>=0?K+=String.fromCharCode(B):P=4;break}default:P=5}le=t;continue}if(ue>=0&&ue<=31)if(u(ue)){K+=i.substring(le,t),P=2;break}else P=6;t++}return K}function V(){if(s="",P=0,o=t,t>=n)return o=n,l=17;let K=i.charCodeAt(t);if(S(K)){do t++,s+=String.fromCharCode(K),K=i.charCodeAt(t);while(S(K));return l=15}if(u(K))return t++,s+=String.fromCharCode(K),K===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),l=14;switch(K){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,s=U(),l=10;case 47:{const le=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!u(i.charCodeAt(t));)t++;return s=i.substring(le,t),l=12}if(i.charCodeAt(t+1)===42){t+=2;const ue=n-1;let ae=!1;for(;t<ue;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,ae=!0;break}t++}return ae||(t++,P=1),s=i.substring(le,t),l=13}return s+=String.fromCharCode(K),t++,l=16}case 45:if(s+=String.fromCharCode(K),t++,t===n||!a(i.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),l=11;default:for(;t<n&&J(K);)t++,K=i.charCodeAt(t);if(o!==t){switch(s=i.substring(o,t),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(K),t++,l=16}}function J(K){if(S(K)||u(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function _(){let K;do K=V();while(K>=12&&K<=15);return K}return{setPosition:z,getPosition:()=>t,scan:r?_:V,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>P}}function S(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var g;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(g||(g={}));function v(i,r){const t=[],n=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(I,z,N,U){o.value=I,o.offset=z,o.length=N,o.type=U,o.colonOffset=void 0,s=o}try{w(i,{onObjectBegin:(I,z)=>{if(r<=I)throw n;s=void 0,l=r>I,t.push("")},onObjectProperty:(I,z,N)=>{if(r<z||(P(I,z,N,"property"),t[t.length-1]=I,r<=z+N))throw n},onObjectEnd:(I,z)=>{if(r<=I)throw n;s=void 0,t.pop()},onArrayBegin:(I,z)=>{if(r<=I)throw n;s=void 0,t.push(0)},onArrayEnd:(I,z)=>{if(r<=I)throw n;s=void 0,t.pop()},onLiteralValue:(I,z,N)=>{if(r<z||(P(I,z,N,p(I)),r<=z+N))throw n},onSeparator:(I,z,N)=>{if(r<=z)throw n;if(I===":"&&s&&s.type==="property")s.colonOffset=z,l=!1,s=void 0;else if(I===","){const U=t[t.length-1];typeof U=="number"?t[t.length-1]=U+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(I){if(I!==n)throw I}return{path:t,previousNode:s,isAtPropertyKey:l,matches:I=>{let z=0;for(let N=0;z<I.length&&N<t.length;N++)if(I[z]===t[N]||I[z]==="*")z++;else if(I[z]!=="**")return!1;return z===I.length}}}function d(i,r=[],t=A.DEFAULT){let n=null,s=[];const o=[];function l(I){Array.isArray(s)?s.push(I):n!==null&&(s[n]=I)}return w(i,{onObjectBegin:()=>{const I={};l(I),o.push(s),s=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const I=[];l(I),o.push(s),s=I,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(I,z,N)=>{r.push({error:I,offset:z,length:N})}},t),s[0]}function $(i,r=[],t=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function o(I){return n.children.push(I),I}w(i,{onObjectBegin:I=>{n=o({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,z,N)=>{n=o({type:"property",offset:z,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:z,length:N,parent:n})},onObjectEnd:(I,z)=>{n.length=I+z-n.offset,n=n.parent,s(I+z)},onArrayBegin:(I,z)=>{n=o({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,z)=>{n.length=I+z-n.offset,n=n.parent,s(I+z)},onLiteralValue:(I,z,N)=>{o({type:p(I),offset:z,length:N,parent:n,value:I}),s(z+N)},onSeparator:(I,z,N)=>{n.type==="property"&&(I===":"?n.colonOffset=z:I===","&&s(z))},onError:(I,z,N)=>{r.push({error:I,offset:z,length:N})}},t);const P=n.children[0];return P&&delete P.parent,P}function y(i,r){if(!i)return;let t=i;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}function O(i){if(!i.parent||!i.parent.children)return[];const r=O(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}function m(i){switch(i.type){case"array":return i.children.map(m);case"object":{const r=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(r[t.children[0].value]=m(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function c(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}function b(i,r,t=!1){if(c(i,r,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const o=b(n[s],r,t);if(o)return o}return i}}function w(i,r,t=A.DEFAULT){const n=R(i,!1);function s(Y){return Y?()=>Y(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Y){return Y?te=>Y(te,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(r.onObjectBegin),P=o(r.onObjectProperty),I=s(r.onObjectEnd),z=s(r.onArrayBegin),N=s(r.onArrayEnd),U=o(r.onLiteralValue),V=o(r.onSeparator),J=s(r.onComment),_=o(r.onError),K=t&&t.disallowComments,le=t&&t.allowTrailingComma;function ue(){for(;;){const Y=n.scan();switch(n.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:K||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(Y){case 12:case 13:K?ae(10):J();break;case 16:ae(1);break;case 15:case 14:break;default:return Y}}}function ae(Y,te=[],C=[]){if(_(Y),te.length+C.length>0){let M=n.getToken();for(;M!==17;){if(te.indexOf(M)!==-1){ue();break}else if(C.indexOf(M)!==-1)break;M=ue()}}}function B(Y){const te=n.getTokenValue();return Y?U(te):P(te),ue(),!0}function Z(){switch(n.getToken()){case 11:{let Y=0;try{Y=JSON.parse(n.getTokenValue()),typeof Y!="number"&&(ae(2),Y=0)}catch{ae(2)}U(Y);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return ue(),!0}function T(){return n.getToken()!==10?(ae(3,[],[2,5]),!1):(B(!1),n.getToken()===6?(V(":"),ue(),X()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function q(){l(),ue();let Y=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ae(4,[],[]),V(","),ue(),n.getToken()===2&&le)break}else Y&&ae(6,[],[]);T()||ae(4,[],[2,5]),Y=!0}return I(),n.getToken()!==2?ae(7,[2],[]):ue(),!0}function W(){z(),ue();let Y=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ae(4,[],[]),V(","),ue(),n.getToken()===4&&le)break}else Y&&ae(6,[],[]);X()||ae(4,[],[4,5]),Y=!0}return N(),n.getToken()!==4?ae(8,[4],[]):ue(),!0}function X(){switch(n.getToken()){case 3:return W();case 1:return q();case 10:return B(!0);default:return Z()}}return ue(),n.getToken()===17?t.allowEmptyContent?!0:(ae(4,[],[]),!1):X()?(n.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}function h(i,r){const t=R(i),n=[];let s,o=0,l;do switch(l=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==l&&n.push(i.substring(o,l)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return n.join("")}function p(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(se[73],re([0,1,38]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=j,e.$On=k,e.$Pn=S,e.$Qn=u;function j(a,g,v){let d,$,y,O,m;if(g){for(O=g.offset,m=O+g.length,y=O;y>0&&!u(a,y-1);)y--;let l=m;for(;l<a.length&&!u(a,l);)l++;$=a.substring(y,l),d=R($,v)}else $=a,d=0,y=0,O=0,m=a.length;const c=S(v,a);let b=!1,w=0,h;v.insertSpaces?h=A(" ",v.tabSize||4):h="	";const p=(0,D.$Bn)($,!1);let i=!1;function r(){return c+A(h,d+w)}function t(){let l=p.scan();for(b=!1;l===15||l===14;)b=b||l===14,l=p.scan();return i=l===16||p.getTokenError()!==0,l}const n=[];function s(l,P,I){!i&&P<m&&I>O&&a.substring(P,I)!==l&&n.push({offset:P,length:I-P,content:l})}let o=t();if(o!==17){const l=p.getTokenOffset()+y,P=A(h,d);s(P,y,l)}for(;o!==17;){let l=p.getTokenOffset()+p.getTokenLength()+y,P=t(),I="";for(;!b&&(P===12||P===13);){const N=p.getTokenOffset()+y;s(" ",l,N),l=p.getTokenOffset()+p.getTokenLength()+y,I=P===12?r():"",P=t()}if(P===2)o!==1&&(w--,I=r());else if(P===4)o!==3&&(w--,I=r());else{switch(o){case 3:case 1:w++,I=r();break;case 5:case 12:I=r();break;case 13:b?I=r():I=" ";break;case 6:I=" ";break;case 10:if(P===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?I=" ":P!==5&&P!==17&&(i=!0);break;case 16:i=!0;break}b&&(P===12||P===13)&&(I=r())}const z=p.getTokenOffset()+y;s(I,l,z),o=P}return n}function k(a,g){const v=JSON.stringify(a,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?v.replace(/\r\n|\r|\n/g,g.eol):v}function A(a,g){let v="";for(let d=0;d<g;d++)v+=a;return v}function R(a,g){let v=0,d=0;const $=g.tabSize||4;for(;v<a.length;){const y=a.charAt(v);if(y===" ")d++;else if(y==="	")d+=$;else break;v++}return Math.floor(d/$)}function S(a,g){for(let v=0;v<g.length;v++){const d=g.charAt(v);if(d==="\r")return v+1<g.length&&g.charAt(v+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return a&&a.eol||`
`}function u(a,g){return`\r
`.indexOf(a.charAt(g))!==-1}}),define(se[74],re([0,1,38,73]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=k,e.$Sn=A,e.$Tn=R,e.$Un=S,e.$Vn=u;function k(a,g,v){return A(a,g,void 0,v)}function A(a,g,v,d,$){const y=g.slice(),O=[],m=(0,D.$En)(a,O);let c,b;for(;y.length>0&&(b=y.pop(),c=(0,D.$Fn)(m,y),c===void 0&&v!==void 0);)typeof b=="string"?v={[b]:v}:v=[v];if(c)if(c.type==="object"&&typeof b=="string"&&Array.isArray(c.children)){const w=(0,D.$Fn)(c,[b]);if(w!==void 0)if(v===void 0){if(!w.parent)throw new Error("Malformed AST");const h=c.children.indexOf(w.parent);let p,i=w.parent.offset+w.parent.length;if(h>0){const r=c.children[h-1];p=r.offset+r.length}else p=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return R(a,{offset:p,length:i-p,content:""},d)}else return R(a,{offset:w.offset,length:w.length,content:JSON.stringify(v)},d);else{if(v===void 0)return[];const h=`${JSON.stringify(b)}: ${JSON.stringify(v)}`,p=$?$(c.children.map(r=>r.children[0].value)):c.children.length;let i;if(p>0){const r=c.children[p-1];i={offset:r.offset+r.length,length:0,content:","+h}}else c.children.length===0?i={offset:c.offset+1,length:0,content:h}:i={offset:c.offset+1,length:0,content:h+","};return R(a,i,d)}}else if(c.type==="array"&&typeof b=="number"&&Array.isArray(c.children))if(v!==void 0){const w=`${JSON.stringify(v)}`;let h;if(c.children.length===0||b===0)h={offset:c.offset+1,length:0,content:c.children.length===0?w:w+","};else{const p=b===-1||b>c.children.length?c.children.length:b,i=c.children[p-1];h={offset:i.offset+i.length,length:0,content:","+w}}return R(a,h,d)}else{const w=b,h=c.children[w];let p;if(c.children.length===1)p={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===w){const i=c.children[w-1],r=i.offset+i.length,t=c.offset+c.length;p={offset:r,length:t-2-r,content:""}}else p={offset:h.offset,length:c.children[w+1].offset-h.offset,content:""};return R(a,p,d)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${c.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return R(a,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(v)},d)}}function R(a,g,v){let d=S(a,g),$=g.offset,y=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;$>0&&!(0,j.$Qn)(d,$-1);)$--;for(;y<d.length&&!(0,j.$Qn)(d,y);)y++}const O=(0,j.$Nn)(d,{offset:$,length:y-$},v);for(let c=O.length-1;c>=0;c--){const b=O[c];d=S(d,b),$=Math.min($,b.offset),y=Math.max(y,b.offset+b.length),y+=b.content.length-b.length}const m=a.length-(d.length-y)-$;return[{offset:$,length:m,content:d.substring($,y)}]}function S(a,g){return a.substring(0,g.offset)+g.content+a.substring(g.offset+g.length)}function u(a,g){const v=g.slice(0).sort(($,y)=>{const O=$.offset-y.offset;return O===0?$.length-y.length:O});let d=a.length;for(let $=v.length-1;$>=0;$--){const y=v[$];if(y.offset+y.length<=d)a=S(a,y);else throw new Error("Overlapping edit");d=y.offset}return a}}),define(se[75],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0,e.$vm=D,e.rot=j;function D(S,u,a){return Math.min(Math.max(S,u),a)}function j(S,u){return(u+S%u)%u}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$xm=k;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ym=A;class R{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const a=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$zm=R}),function(){function Q(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function R(u){A.push(u,Date.now())}function S(){const u=[];for(let a=0;a<A.length;a+=2)u.push({name:A[a],startTime:A[a+1]});return u}return{mark:R,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(k+R.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function D(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var j;typeof global=="object"?j=global:typeof self=="object"?j=self:j={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(j)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(j):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),j.perf=D(j))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var j in D)(typeof exports=="object"?exports:Q)[j]=D[j]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function D(j){if(e[j])return e[j].exports;var k=e[j]={i:j,l:!1,exports:{}};return Q[j].call(k.exports,k,k.exports,D),k.l=!0,k.exports}return D.m=Q,D.c=e,D.d=function(j,k,A){D.o(j,k)||Object.defineProperty(j,k,{enumerable:!0,get:A})},D.r=function(j){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(j,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(j,"__esModule",{value:!0})},D.t=function(j,k){if(1&k&&(j=D(j)),8&k||4&k&&typeof j=="object"&&j&&j.__esModule)return j;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:j}),2&k&&typeof j!="string")for(var R in j)D.d(A,R,function(S){return j[S]}.bind(null,R));return A},D.n=function(j){var k=j&&j.__esModule?function(){return j.default}:function(){return j};return D.d(k,"a",k),k},D.o=function(j,k){return Object.prototype.hasOwnProperty.call(j,k)},D.p="",D(D.s=0)}([function(Q,e,D){(function(j){var k;e=Q.exports=C,k=typeof j=="object"&&j.env&&j.env.NODE_DEBUG&&/\bsemver\b/i.test(j.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],u=e.src=[],a=0,g=a++;u[g]="0|[1-9]\\d*";var v=a++;u[v]="[0-9]+";var d=a++;u[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=a++;u[$]="("+u[g]+")\\.("+u[g]+")\\.("+u[g]+")";var y=a++;u[y]="("+u[v]+")\\.("+u[v]+")\\.("+u[v]+")";var O=a++;u[O]="(?:"+u[g]+"|"+u[d]+")";var m=a++;u[m]="(?:"+u[v]+"|"+u[d]+")";var c=a++;u[c]="(?:-("+u[O]+"(?:\\."+u[O]+")*))";var b=a++;u[b]="(?:-?("+u[m]+"(?:\\."+u[m]+")*))";var w=a++;u[w]="[0-9A-Za-z-]+";var h=a++;u[h]="(?:\\+("+u[w]+"(?:\\."+u[w]+")*))";var p=a++,i="v?"+u[$]+u[c]+"?"+u[h]+"?";u[p]="^"+i+"$";var r="[v=\\s]*"+u[y]+u[b]+"?"+u[h]+"?",t=a++;u[t]="^"+r+"$";var n=a++;u[n]="((?:<|>)?=?)";var s=a++;u[s]=u[v]+"|x|X|\\*";var o=a++;u[o]=u[g]+"|x|X|\\*";var l=a++;u[l]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[c]+")?"+u[h]+"?)?)?";var P=a++;u[P]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[b]+")?"+u[h]+"?)?)?";var I=a++;u[I]="^"+u[n]+"\\s*"+u[l]+"$";var z=a++;u[z]="^"+u[n]+"\\s*"+u[P]+"$";var N=a++;u[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=a++;u[U]="(?:~>?)";var V=a++;u[V]="(\\s*)"+u[U]+"\\s+",S[V]=new RegExp(u[V],"g");var J=a++;u[J]="^"+u[U]+u[l]+"$";var _=a++;u[_]="^"+u[U]+u[P]+"$";var K=a++;u[K]="(?:\\^)";var le=a++;u[le]="(\\s*)"+u[K]+"\\s+",S[le]=new RegExp(u[le],"g");var ue=a++;u[ue]="^"+u[K]+u[l]+"$";var ae=a++;u[ae]="^"+u[K]+u[P]+"$";var B=a++;u[B]="^"+u[n]+"\\s*("+r+")$|^$";var Z=a++;u[Z]="^"+u[n]+"\\s*("+i+")$|^$";var T=a++;u[T]="(\\s*)"+u[n]+"\\s*("+r+"|"+u[l]+")",S[T]=new RegExp(u[T],"g");var q=a++;u[q]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var W=a++;u[W]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var X=a++;u[X]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)k(Y,u[Y]),S[Y]||(S[Y]=new RegExp(u[Y]));function te(x,ee){if(x instanceof C)return x;if(typeof x!="string"||x.length>A||!(ee?S[t]:S[p]).test(x))return null;try{return new C(x,ee)}catch{return null}}function C(x,ee){if(x instanceof C){if(x.loose===ee)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof C))return new C(x,ee);k("SemVer",x,ee),this.loose=ee;var ie=x.trim().match(ee?S[t]:S[p]);if(!ie)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+ie[1],this.minor=+ie[2],this.patch=+ie[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ie[4]?this.prerelease=ie[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ve=+ge;if(ve>=0&&ve<R)return ve}return ge}):this.prerelease=[],this.build=ie[5]?ie[5].split("."):[],this.format()}e.parse=te,e.valid=function(x,ee){var ie=te(x,ee);return ie?ie.version:null},e.clean=function(x,ee){var ie=te(x.trim().replace(/^[=v]+/,""),ee);return ie?ie.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(x){return k("SemVer.compare",this.version,this.loose,x),x instanceof C||(x=new C(x,this.loose)),this.compareMain(x)||this.comparePre(x)},C.prototype.compareMain=function(x){return x instanceof C||(x=new C(x,this.loose)),f(this.major,x.major)||f(this.minor,x.minor)||f(this.patch,x.patch)},C.prototype.comparePre=function(x){if(x instanceof C||(x=new C(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var ee=0;do{var ie=this.prerelease[ee],ge=x.prerelease[ee];if(k("prerelease compare",ee,ie,ge),ie===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ie===void 0)return-1;if(ie!==ge)return f(ie,ge)}while(++ee)},C.prototype.inc=function(x,ee){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ie=this.prerelease.length;--ie>=0;)typeof this.prerelease[ie]=="number"&&(this.prerelease[ie]++,ie=-2);ie===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,ee,ie,ge){typeof ie=="string"&&(ge=ie,ie=void 0);try{return new C(x,ie).inc(ee,ge).version}catch{return null}},e.diff=function(x,ee){if(G(x,ee))return null;var ie=te(x),ge=te(ee);if(ie.prerelease.length||ge.prerelease.length){for(var ve in ie)if((ve==="major"||ve==="minor"||ve==="patch")&&ie[ve]!==ge[ve])return"pre"+ve;return"prerelease"}for(var ve in ie)if((ve==="major"||ve==="minor"||ve==="patch")&&ie[ve]!==ge[ve])return ve},e.compareIdentifiers=f;var M=/^[0-9]+$/;function f(x,ee){var ie=M.test(x),ge=M.test(ee);return ie&&ge&&(x=+x,ee=+ee),ie&&!ge?-1:ge&&!ie?1:x<ee?-1:x>ee?1:0}function E(x,ee,ie){return new C(x,ie).compare(new C(ee,ie))}function L(x,ee,ie){return E(x,ee,ie)>0}function F(x,ee,ie){return E(x,ee,ie)<0}function G(x,ee,ie){return E(x,ee,ie)===0}function H(x,ee,ie){return E(x,ee,ie)!==0}function ne(x,ee,ie){return E(x,ee,ie)>=0}function ce(x,ee,ie){return E(x,ee,ie)<=0}function he(x,ee,ie,ge){var ve;switch(ee){case"===":typeof x=="object"&&(x=x.version),typeof ie=="object"&&(ie=ie.version),ve=x===ie;break;case"!==":typeof x=="object"&&(x=x.version),typeof ie=="object"&&(ie=ie.version),ve=x!==ie;break;case"":case"=":case"==":ve=G(x,ie,ge);break;case"!=":ve=H(x,ie,ge);break;case">":ve=L(x,ie,ge);break;case">=":ve=ne(x,ie,ge);break;case"<":ve=F(x,ie,ge);break;case"<=":ve=ce(x,ie,ge);break;default:throw new TypeError("Invalid operator: "+ee)}return ve}function pe(x,ee){if(x instanceof pe){if(x.loose===ee)return x;x=x.value}if(!(this instanceof pe))return new pe(x,ee);k("comparator",x,ee),this.loose=ee,this.parse(x),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(x,ee){return f(ee,x)},e.major=function(x,ee){return new C(x,ee).major},e.minor=function(x,ee){return new C(x,ee).minor},e.patch=function(x,ee){return new C(x,ee).patch},e.compare=E,e.compareLoose=function(x,ee){return E(x,ee,!0)},e.rcompare=function(x,ee,ie){return E(ee,x,ie)},e.sort=function(x,ee){return x.sort(function(ie,ge){return e.compare(ie,ge,ee)})},e.rsort=function(x,ee){return x.sort(function(ie,ge){return e.rcompare(ie,ge,ee)})},e.gt=L,e.lt=F,e.eq=G,e.neq=H,e.gte=ne,e.lte=ce,e.cmp=he,e.Comparator=pe;var ye={};function fe(x,ee){if(x instanceof fe)return x.loose===ee?x:new fe(x.raw,ee);if(x instanceof pe)return new fe(x.value,ee);if(!(this instanceof fe))return new fe(x,ee);if(this.loose=ee,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(ie){return this.parseRange(ie.trim())},this).filter(function(ie){return ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function me(x){return!x||x.toLowerCase()==="x"||x==="*"}function de(x,ee,ie,ge,ve,De,Pe,Le,Oe,Ae,Me,je,Ne){return((ee=me(ie)?"":me(ge)?">="+ie+".0.0":me(ve)?">="+ie+"."+ge+".0":">="+ee)+" "+(Le=me(Oe)?"":me(Ae)?"<"+(+Oe+1)+".0.0":me(Me)?"<"+Oe+"."+(+Ae+1)+".0":je?"<="+Oe+"."+Ae+"."+Me+"-"+je:"<="+Le)).trim()}function we(x,ee){for(var ie=0;ie<x.length;ie++)if(!x[ie].test(ee))return!1;if(ee.prerelease.length){for(ie=0;ie<x.length;ie++)if(k(x[ie].semver),x[ie].semver!==ye&&x[ie].semver.prerelease.length>0){var ge=x[ie].semver;if(ge.major===ee.major&&ge.minor===ee.minor&&ge.patch===ee.patch)return!0}return!1}return!0}function Ee(x,ee,ie){try{ee=new fe(ee,ie)}catch{return!1}return ee.test(x)}function ke(x,ee,ie,ge){var ve,De,Pe,Le,Oe;switch(x=new C(x,ge),ee=new fe(ee,ge),ie){case">":ve=L,De=ce,Pe=F,Le=">",Oe=">=";break;case"<":ve=F,De=ne,Pe=L,Le="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(x,ee,ge))return!1;for(var Ae=0;Ae<ee.set.length;++Ae){var Me=ee.set[Ae],je=null,Ne=null;if(Me.forEach(function(ze){ze.semver===ye&&(ze=new pe(">=0.0.0")),je=je||ze,Ne=Ne||ze,ve(ze.semver,je.semver,ge)?je=ze:Pe(ze.semver,Ne.semver,ge)&&(Ne=ze)}),je.operator===Le||je.operator===Oe||(!Ne.operator||Ne.operator===Le)&&De(x,Ne.semver)||Ne.operator===Oe&&Pe(x,Ne.semver))return!1}return!0}pe.prototype.parse=function(x){var ee=this.loose?S[B]:S[Z],ie=x.match(ee);if(!ie)throw new TypeError("Invalid comparator: "+x);this.operator=ie[1],this.operator==="="&&(this.operator=""),ie[2]?this.semver=new C(ie[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(x){return k("Comparator.test",x,this.loose),this.semver===ye||(typeof x=="string"&&(x=new C(x,this.loose)),he(x,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(x,ee){if(!(x instanceof pe))throw new TypeError("a Comparator is required");var ie;if(this.operator==="")return ie=new fe(x.value,ee),Ee(this.value,ie,ee);if(x.operator==="")return ie=new fe(this.value,ee),Ee(x.semver,ie,ee);var ge=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),De=this.semver.version===x.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Le=he(this.semver,"<",x.semver,ee)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Oe=he(this.semver,">",x.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ge||ve||De&&Pe||Le||Oe},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(x){var ee=this.loose;x=x.trim(),k("range",x,ee);var ie=ee?S[W]:S[q];x=x.replace(ie,de),k("hyphen replace",x),x=x.replace(S[T],"$1$2$3"),k("comparator trim",x,S[T]),x=(x=(x=x.replace(S[V],"$1~")).replace(S[le],"$1^")).split(/\s+/).join(" ");var ge=ee?S[B]:S[Z],ve=x.split(" ").map(function(De){return function(Pe,Le){return k("comp",Pe),Pe=function(Oe,Ae){return Oe.trim().split(/\s+/).map(function(Me){return function(je,Ne){k("caret",je,Ne);var ze=Ne?S[ae]:S[ue];return je.replace(ze,function(Ce,be,Se,Ie,Re){var Ue;return k("caret",je,Ce,be,Se,Ie,Re),me(be)?Ue="":me(Se)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?Ue=be==="0"?">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+".0 <"+(+be+1)+".0.0":Re?(k("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ue=be==="0"?Se==="0"?">="+be+"."+Se+"."+Ie+Re+" <"+be+"."+Se+"."+(+Ie+1):">="+be+"."+Se+"."+Ie+Re+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Ie+Re+" <"+(+be+1)+".0.0"):(k("no pr"),Ue=be==="0"?Se==="0"?">="+be+"."+Se+"."+Ie+" <"+be+"."+Se+"."+(+Ie+1):">="+be+"."+Se+"."+Ie+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Ie+" <"+(+be+1)+".0.0"),k("caret return",Ue),Ue})}(Me,Ae)}).join(" ")}(Pe,Le),k("caret",Pe),Pe=function(Oe,Ae){return Oe.trim().split(/\s+/).map(function(Me){return function(je,Ne){var ze=Ne?S[_]:S[J];return je.replace(ze,function(Ce,be,Se,Ie,Re){var Ue;return k("tilde",je,Ce,be,Se,Ie,Re),me(be)?Ue="":me(Se)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?Ue=">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":Re?(k("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ue=">="+be+"."+Se+"."+Ie+Re+" <"+be+"."+(+Se+1)+".0"):Ue=">="+be+"."+Se+"."+Ie+" <"+be+"."+(+Se+1)+".0",k("tilde return",Ue),Ue})}(Me,Ae)}).join(" ")}(Pe,Le),k("tildes",Pe),Pe=function(Oe,Ae){return k("replaceXRanges",Oe,Ae),Oe.split(/\s+/).map(function(Me){return function(je,Ne){je=je.trim();var ze=Ne?S[z]:S[I];return je.replace(ze,function(Ce,be,Se,Ie,Re,Ue){k("xRange",je,Ce,be,Se,Ie,Re,Ue);var Te=me(Se),Fe=Te||me(Ie),qe=Fe||me(Re);return be==="="&&qe&&(be=""),Te?Ce=be===">"||be==="<"?"<0.0.0":"*":be&&qe?(Fe&&(Ie=0),qe&&(Re=0),be===">"?(be=">=",Fe?(Se=+Se+1,Ie=0,Re=0):qe&&(Ie=+Ie+1,Re=0)):be==="<="&&(be="<",Fe?Se=+Se+1:Ie=+Ie+1),Ce=be+Se+"."+Ie+"."+Re):Fe?Ce=">="+Se+".0.0 <"+(+Se+1)+".0.0":qe&&(Ce=">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0"),k("xRange return",Ce),Ce})}(Me,Ae)}).join(" ")}(Pe,Le),k("xrange",Pe),Pe=function(Oe,Ae){return k("replaceStars",Oe,Ae),Oe.trim().replace(S[X],"")}(Pe,Le),k("stars",Pe),Pe}(De,ee)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(De){return!!De.match(ge)})),ve=ve.map(function(De){return new pe(De,ee)})},fe.prototype.intersects=function(x,ee){if(!(x instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ie){return ie.every(function(ge){return x.set.some(function(ve){return ve.every(function(De){return ge.intersects(De,ee)})})})})},e.toComparators=function(x,ee){return new fe(x,ee).set.map(function(ie){return ie.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new C(x,this.loose));for(var ee=0;ee<this.set.length;ee++)if(we(this.set[ee],x))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(x,ee,ie){var ge=null,ve=null;try{var De=new fe(ee,ie)}catch{return null}return x.forEach(function(Pe){De.test(Pe)&&(ge&&ve.compare(Pe)!==-1||(ve=new C(ge=Pe,ie)))}),ge},e.minSatisfying=function(x,ee,ie){var ge=null,ve=null;try{var De=new fe(ee,ie)}catch{return null}return x.forEach(function(Pe){De.test(Pe)&&(ge&&ve.compare(Pe)!==1||(ve=new C(ge=Pe,ie)))}),ge},e.validRange=function(x,ee){try{return new fe(x,ee).range||"*"}catch{return null}},e.ltr=function(x,ee,ie){return ke(x,ee,"<",ie)},e.gtr=function(x,ee,ie){return ke(x,ee,">",ie)},e.outside=ke,e.prerelease=function(x,ee){var ie=te(x,ee);return ie&&ie.prerelease.length?ie.prerelease:null},e.intersects=function(x,ee,ie){return x=new fe(x,ie),ee=new fe(ee,ie),x.intersects(ee)},e.coerce=function(x){if(x instanceof C)return x;if(typeof x!="string")return null;var ee=x.match(S[N]);return ee==null?null:te((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,D(1))},function(Q,e){var D,j,k=Q.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function S(m){if(D===setTimeout)return setTimeout(m,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(m,0);try{return D(m,0)}catch{try{return D.call(null,m,0)}catch{return D.call(this,m,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{j=typeof clearTimeout=="function"?clearTimeout:R}catch{j=R}})();var u,a=[],g=!1,v=-1;function d(){g&&u&&(g=!1,u.length?a=u.concat(a):v=-1,a.length&&$())}function $(){if(!g){var m=S(d);g=!0;for(var c=a.length;c;){for(u=a,a=[];++v<c;)u&&u[v].run();v=-1,c=a.length}u=null,g=!1,function(b){if(j===clearTimeout)return clearTimeout(b);if((j===R||!j)&&clearTimeout)return j=clearTimeout,clearTimeout(b);try{j(b)}catch{try{return j.call(null,b)}catch{return j.call(this,b)}}}(m)}}function y(m,c){this.fun=m,this.array=c}function O(){}k.nextTick=function(m){var c=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)c[b-1]=arguments[b];a.push(new y(m,c)),a.length!==1||g||S($)},y.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=O,k.addListener=O,k.once=O,k.off=O,k.removeListener=O,k.removeAllListeners=O,k.emit=O,k.prependListener=O,k.prependOnceListener=O,k.listeners=function(m){return[]},k.binding=function(m){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(m){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(se[76],re([0,1]),function(Q,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=void 0;class j{constructor(S,u,a){this.level=S,this.key=u,this.value=a,this.forward=[]}}const k=void 0;class A{constructor(S,u=2**16){this.comparator=S,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new j(this.c,k,k)}get size(){return this.f}clear(){this.e=new j(this.c,k,k),this.f=0}has(S){return!!A.g(this,S,this.comparator)}get(S){return A.g(this,S,this.comparator)?.value}set(S,u){return A.h(this,S,u,this.comparator)&&(this.f+=1),this}delete(S){const u=A.k(this,S,this.comparator);return u&&(this.f-=1),u}forEach(S,u){let a=this.e.forward[0];for(;a;)S.call(u,a.value,a.key,this),a=a.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",u=this.e.forward[0];for(;u;)S+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return S}static g(S,u,a){let g=S.e;for(let v=S.d-1;v>=0;v--)for(;g.forward[v]&&a(g.forward[v].key,u)<0;)g=g.forward[v];if(g=g.forward[0],g&&a(g.key,u)===0)return g}static h(S,u,a,g){const v=[];let d=S.e;for(let $=S.d-1;$>=0;$--){for(;d.forward[$]&&g(d.forward[$].key,u)<0;)d=d.forward[$];v[$]=d}if(d=d.forward[0],d&&g(d.key,u)===0)return d.value=a,!1;{const $=A.j(S);if($>S.d){for(let y=S.d;y<$;y++)v[y]=S.e;S.d=$}d=new j($,u,a);for(let y=0;y<$;y++)d.forward[y]=v[y].forward[y],v[y].forward[y]=d;return!0}}static j(S,u=.5){let a=1;for(;Math.random()<u&&a<S.c;)a+=1;return a}static k(S,u,a){const g=[];let v=S.e;for(let d=S.d-1;d>=0;d--){for(;v.forward[d]&&a(v.forward[d].key,u)<0;)v=v.forward[d];g[d]=v}if(v=v.forward[0],!v||a(v.key,u)!==0)return!1;for(let d=0;d<S.d&&g[d].forward[d]===v;d++)g[d].forward[d]=v.forward[d];for(;S.d>0&&S.e.forward[S.d-1]===k;)S.d-=1;return!0}}e.$qs=A}),define(se[46],re([0,1,9,2]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=k,e.$oe=A,e.$pe=R,e.$qe=S,e.$re=a,e.$se=g,e.$te=v,e.$ue=d,e.$ve=$,e.$we=y,e.$xe=O,e.$ye=m,e.$ze=c,e.$Ae=b,e.$Be=w;function k(h){const p=h;return p?typeof p.read=="function":!1}function A(h){const p=h;return p?[p.on,p.pause,p.resume,p.destroy].every(i=>typeof i=="function"):!1}function R(h){const p=h;return p?A(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}function S(h,p){return new u(h,p)}class u{constructor(p,i){this.e=p,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(i=>i(p))}h(p){this.c.error.length===0?(0,D.$1)(p):this.c.error.slice(0).forEach(i=>i(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,i){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(p,i){if(this.a.destroyed)return;let r;switch(p){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(h,p){const i=[];let r;for(;(r=h.read())!==null;)i.push(r);return p(i)}function g(h,p,i){const r=[];let t;for(;(t=h.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?p(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return h.read()}}}function v(h,p){return new Promise((i,r)=>{const t=[];d(h,{onData:n=>{p&&t.push(n)},onError:n=>{p?r(n):i(void 0)},onEnd:()=>{i(p?p(t):void 0)}})})}function d(h,p,i){h.on("error",r=>{i?.isCancellationRequested||p.onError(r)}),h.on("end",()=>{i?.isCancellationRequested||p.onEnd()}),h.on("data",r=>{i?.isCancellationRequested||p.onData(r)})}function $(h,p){return new Promise((i,r)=>{const t=new j.$Tc,n=[],s=P=>{if(n.push(P),n.length>p)return t.dispose(),h.pause(),i({stream:h,buffer:n,ended:!1})},o=P=>(t.dispose(),r(P)),l=()=>(t.dispose(),i({stream:h,buffer:n,ended:!0}));t.add((0,j.$Sc)(()=>h.removeListener("error",o))),h.on("error",o),t.add((0,j.$Sc)(()=>h.removeListener("end",l))),h.on("end",l),t.add((0,j.$Sc)(()=>h.removeListener("data",s))),h.on("data",s)})}function y(h,p){const i=S(p);return i.end(h),i}function O(){const h=S(()=>{throw new Error("not supported")});return h.end(),h}function m(h){let p=!1;return{read:()=>p?null:(p=!0,h)}}function c(h,p,i){const r=S(i);return d(h,{onData:t=>r.write(p.data(t)),onError:t=>r.error(p.error?p.error(t):t),onEnd:()=>r.end()}),r}function b(h,p,i){let r=!1;return{read:()=>{const t=p.read();return r?t:(r=!0,t!==null?i([h,t]):h)}}}function w(h,p,i){let r=!1;const t=S(i);return d(p,{onData:n=>r?t.write(n):(r=!0,t.write(i([h,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(h)),t.end()}}),t}}),define(se[14],re([0,1,169,46]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=a,e.$Ee=g,e.$Fe=v,e.$Ge=d,e.$He=$,e.$Ie=y,e.$Je=O,e.$Ke=m,e.$Le=c,e.$Me=b,e.$Ne=w,e.$Oe=h,e.$Pe=p,e.$Qe=i,e.$Re=r,e.$Se=t,e.$Te=n,e.$Ue=s,e.$Ve=o,e.$We=I;const k=typeof Buffer<"u",A=new D.$V(()=>new Uint8Array(256));let R,S;class u{static alloc(N){return k?new u(Buffer.allocUnsafe(N)):new u(new Uint8Array(N))}static wrap(N){return k&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new u(N)}static fromString(N,U){return!(U?.dontUseNodeBuffer||!1)&&k?new u(Buffer.from(N)):(R||(R=new TextEncoder),new u(R.encode(N)))}static fromByteArray(N){const U=u.alloc(N.length);for(let V=0,J=N.length;V<J;V++)U.buffer[V]=N[V];return U}static concat(N,U){if(typeof U>"u"){U=0;for(let _=0,K=N.length;_<K;_++)U+=N[_].byteLength}const V=u.alloc(U);let J=0;for(let _=0,K=N.length;_<K;_++){const le=N[_];V.set(le,J),J+=le.byteLength}return V}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=u.alloc(this.byteLength);return N.set(this),N}toString(){return k?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(N,U){return new u(this.buffer.subarray(N,U))}set(N,U){if(N instanceof u)this.buffer.set(N.buffer,U);else if(N instanceof Uint8Array)this.buffer.set(N,U);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),U);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),U);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return d(this.buffer,N)}writeUInt32BE(N,U){$(this.buffer,N,U)}readUInt32LE(N){return y(this.buffer,N)}writeUInt32LE(N,U){O(this.buffer,N,U)}readUInt8(N){return m(this.buffer,N)}writeUInt8(N,U){c(this.buffer,N,U)}indexOf(N,U=0){return a(this.buffer,N instanceof u?N.buffer:N,U)}}e.$Ce=u;function a(z,N,U=0){const V=N.byteLength,J=z.byteLength;if(V===0)return 0;if(V===1)return z.indexOf(N[0]);if(V>J-U)return-1;const _=A.value;_.fill(N.length);for(let ae=0;ae<N.length;ae++)_[N[ae]]=N.length-ae-1;let K=U+N.length-1,le=K,ue=-1;for(;K<J;)if(z[K]===N[le]){if(le===0){ue=K;break}K--,le--}else K+=Math.max(N.length-le,_[z[K]]),le=N.length-1;return ue}function g(z,N){return z[N+0]<<0>>>0|z[N+1]<<8>>>0}function v(z,N,U){z[U+0]=N&255,N=N>>>8,z[U+1]=N&255}function d(z,N){return z[N]*2**24+z[N+1]*2**16+z[N+2]*2**8+z[N+3]}function $(z,N,U){z[U+3]=N,N=N>>>8,z[U+2]=N,N=N>>>8,z[U+1]=N,N=N>>>8,z[U]=N}function y(z,N){return z[N+0]<<0>>>0|z[N+1]<<8>>>0|z[N+2]<<16>>>0|z[N+3]<<24>>>0}function O(z,N,U){z[U+0]=N&255,N=N>>>8,z[U+1]=N&255,N=N>>>8,z[U+2]=N&255,N=N>>>8,z[U+3]=N&255}function m(z,N){return z[N]}function c(z,N,U){z[U]=N}function b(z){return j.$re(z,N=>u.concat(N))}function w(z){return j.$ye(z)}function h(z){return j.$te(z,N=>u.concat(N))}async function p(z){return z.ended?u.concat(z.buffer):u.concat([...z.buffer,await h(z.stream)])}function i(z){return j.$we(z,N=>u.concat(N))}function r(z){return j.$ze(z,{data:N=>typeof N=="string"?u.fromString(N):u.wrap(N)},N=>u.concat(N))}function t(z){return j.$qe(N=>u.concat(N),z)}function n(z,N){return j.$Ae(z,N,U=>u.concat(U))}function s(z,N){return j.$Be(z,N,U=>u.concat(U))}function o(z){let N=0,U=0,V=0;const J=new Uint8Array(Math.floor(z.length/4*3)),_=le=>{switch(U){case 3:J[V++]=N|le,U=0;break;case 2:J[V++]=N|le>>>2,N=le<<6,U=3;break;case 1:J[V++]=N|le>>>4,N=le<<4,U=2;break;default:N=le<<2,U=1}};for(let le=0;le<z.length;le++){const ue=z.charCodeAt(le);if(ue>=65&&ue<=90)_(ue-65);else if(ue>=97&&ue<=122)_(ue-97+26);else if(ue>=48&&ue<=57)_(ue-48+52);else if(ue===43||ue===45)_(62);else if(ue===47||ue===95)_(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${z[le]}`)}}const K=V;for(;U>0;)_(0);return u.wrap(J).slice(0,K)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:z},N=!0,U=!1){const V=U?P:l;let J="";const _=z.byteLength%3;let K=0;for(;K<z.byteLength-_;K+=3){const le=z[K+0],ue=z[K+1],ae=z[K+2];J+=V[le>>>2],J+=V[(le<<4|ue>>>4)&63],J+=V[(ue<<2|ae>>>6)&63],J+=V[ae&63]}if(_===1){const le=z[K+0];J+=V[le>>>2],J+=V[le<<4&63],N&&(J+="==")}else if(_===2){const le=z[K+0],ue=z[K+1];J+=V[le>>>2],J+=V[(le<<4|ue>>>4)&63],J+=V[ue<<2&63],N&&(J+="=")}return J}}),define(se[43],re([0,1,30]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$ij=void 0,e.$ej=j,e.$fj=k,e.$gj=A,e.$hj=S,e.$jj=O;function j(c){return k(c,0)}function k(c,b){switch(typeof c){case"object":return c===null?A(349,b):Array.isArray(c)?u(c,b):a(c,b);case"string":return S(c,b);case"boolean":return R(c,b);case"number":return A(c,b);case"undefined":return A(937,b);default:return A(617,b)}}function A(c,b){return(b<<5)-b+c|0}function R(c,b){return A(c?433:863,b)}function S(c,b){b=A(149417,b);for(let w=0,h=c.length;w<h;w++)b=A(c.charCodeAt(w),b);return b}function u(c,b){return b=A(104579,b),c.reduce((w,h)=>k(h,w),b)}function a(c,b){return b=A(181387,b),Object.keys(c).sort().reduce((w,h)=>(w=S(h,w),k(c[h],w)),b)}class g{constructor(){this.g=0}get value(){return this.g}hash(b){return this.g=k(b,this.g),this.g}}e.$ij=g;var v;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function d(c,b,w=32){const h=w-b,p=~((1<<h)-1);return(c<<b|(p&c)>>>h)>>>0}function $(c,b=0,w=c.byteLength,h=0){for(let p=0;p<w;p++)c[b+p]=h}function y(c,b,w="0"){for(;c.length<b;)c=w+c;return c}function O(c,b=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(w=>w.toString(16).padStart(2,"0")).join(""):y((c>>>0).toString(16),b/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(b){const w=b.length;if(w===0)return;const h=this.p;let p=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=b.charCodeAt(0),t=0);;){let n=r;if(D.$xf(r))if(t+1<w){const s=b.charCodeAt(t+1);D.$yf(s)?(t++,n=D.$zf(r,s)):n=65533}else{i=r;break}else D.$yf(r)&&(n=65533);if(p=this.w(h,p,n),t++,t<w)r=b.charCodeAt(t);else break}this.r=p,this.u=i}w(b,w,h){return h<128?b[w++]=h:h<2048?(b[w++]=192|(h&1984)>>>6,b[w++]=128|(h&63)>>>0):h<65536?(b[w++]=224|(h&61440)>>>12,b[w++]=128|(h&4032)>>>6,b[w++]=128|(h&63)>>>0):(b[w++]=240|(h&1835008)>>>18,b[w++]=128|(h&258048)>>>12,b[w++]=128|(h&4032)>>>6,b[w++]=128|(h&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,b[0]=b[64],b[1]=b[65],b[2]=b[66]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),O(this.h)+O(this.l)+O(this.m)+O(this.n)+O(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const b=8*this.t;this.q.setUint32(56,Math.floor(b/4294967296),!1),this.q.setUint32(60,b%4294967296,!1),this.y()}y(){const b=m.g,w=this.q;for(let l=0;l<64;l+=4)b.setUint32(l,w.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)b.setUint32(l,d(b.getUint32(l-12,!1)^b.getUint32(l-32,!1)^b.getUint32(l-56,!1)^b.getUint32(l-64,!1),1),!1);let h=this.h,p=this.l,i=this.m,r=this.n,t=this.o,n,s,o;for(let l=0;l<80;l++)l<20?(n=p&i|~p&r,s=1518500249):l<40?(n=p^i^r,s=1859775393):l<60?(n=p&i|p&r|i&r,s=2400959708):(n=p^i^r,s=3395469782),o=d(h,5)+n+t+s+b.getUint32(l*4,!1)&4294967295,t=r,r=i,i=d(p,30),p=h,h=o;this.h=this.h+h&4294967295,this.l=this.l+p&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$kj=m}),define(se[55],re([0,1,30]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var j;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(j||(j={})),function(k){const A="error",R="warning",S="warn",u="info",a="ignore";function g(d){return d?D.$tf(A,d)?k.Error:D.$tf(R,d)||D.$tf(S,d)?k.Warning:D.$tf(u,d)?k.Info:k.Ignore:k.Ignore}k.fromValue=g;function v(d){switch(d){case k.Error:return A;case k.Warning:return R;case k.Info:return u;default:return a}}k.toString=v}(j||(j={})),e.default=j}),define(se[27],re([0,1,3]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=j,e.$Xn=k,e.$Yn=R,e.$Zn=u,e.$1n=a,e.$2n=g,e.$3n=v,e.$4n=d,e.$5n=$,e.$6n=y,e.$7n=O,e.$8n=m;function j(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const b=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([w,h])=>{b[w]=h&&typeof h=="object"?j(h):h}),b}function k(c){if(!c||typeof c!="object")return c;const b=[c];for(;b.length>0;){const w=b.shift();Object.freeze(w);for(const h in w)if(A.call(w,h)){const p=w[h];typeof p=="object"&&!Object.isFrozen(p)&&!(0,D.$7f)(p)&&b.push(p)}}return c}const A=Object.prototype.hasOwnProperty;function R(c,b){return S(c,b,new Set)}function S(c,b,w){if((0,D.$ag)(c))return c;const h=b(c);if(typeof h<"u")return h;if(Array.isArray(c)){const p=[];for(const i of c)p.push(S(i,b,w));return p}if((0,D.$6f)(c)){if(w.has(c))throw new Error("Cannot clone recursive data-structure");w.add(c);const p={};for(const i in c)A.call(c,i)&&(p[i]=S(c[i],b,w));return w.delete(c),p}return c}function u(c,b,w=!0){return(0,D.$6f)(c)?((0,D.$6f)(b)&&Object.keys(b).forEach(h=>{h in c?w&&((0,D.$6f)(c[h])&&(0,D.$6f)(b[h])?u(c[h],b[h],w):c[h]=b[h]):c[h]=b[h]}),c):b}function a(c,b){if(c===b)return!0;if(c==null||b===null||b===void 0||typeof c!=typeof b||typeof c!="object"||Array.isArray(c)!==Array.isArray(b))return!1;let w,h;if(Array.isArray(c)){if(c.length!==b.length)return!1;for(w=0;w<c.length;w++)if(!a(c[w],b[w]))return!1}else{const p=[];for(h in c)p.push(h);p.sort();const i=[];for(h in b)i.push(h);if(i.sort(),!a(p,i))return!1;for(w=0;w<p.length;w++)if(!a(c[p[w]],b[p[w]]))return!1}return!0}function g(c){const b=new Set;return JSON.stringify(c,(w,h)=>{if((0,D.$6f)(h)||Array.isArray(h)){if(b.has(h))return"[Circular]";b.add(h)}return h})}function v(c,b){const w=Object.create(null);return!c||!b||Object.keys(b).forEach(p=>{const i=c[p],r=b[p];a(i,r)||(w[p]=r)}),w}function d(c,b){const w=b.toLowerCase(),h=Object.keys(c).find(p=>p.toLowerCase()===w);return h?c[h]:c[b]}function $(c,b){const w=Object.create(null);for(const[h,p]of Object.entries(c))b(h,p)&&(w[h]=p);return w}function y(c){let b=[];for(;Object.prototype!==c;)b=b.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return b}function O(c){const b=[];for(const w of y(c))typeof c[w]=="function"&&b.push(w);return b}function m(c,b){const w=p=>function(){const i=Array.prototype.slice.call(arguments,0);return b(p,i)},h={};for(const p of c)h[p]=w(p);return h}}),define(se[28],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=j;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function j(k){return D.test(k)}e.$Mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(S){for(let u=0;u<S.length;u++)S[u]=Math.floor(Math.random()*256);return S};const A=new Uint8Array(16),R=[];for(let S=0;S<256;S++)R.push(S.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,a="";return a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+="-",a+=R[A[u++]],a+=R[A[u++]],a+="-",a+=R[A[u++]],a+=R[A[u++]],a+="-",a+=R[A[u++]],a+=R[A[u++]],a+="-",a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a}}()}),define(se[77],re([0,1,33]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=A;const j=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(R){const S=R.replace(/\-/g,":").toLowerCase();return!j.has(S)}function A(){const R=(0,D.networkInterfaces)();for(const S in R){const u=R[S];if(u){for(const{mac:a}of u)if(k(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(se[78],re([7,4]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(se[79],re([0,1,78]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=a,e.$Wm=g,e.$Xm=v;const j=60,k=j*60,A=k*24,R=A*7,S=A*30,u=A*365;function a(d,$,y,O){typeof d!="number"&&(d=d.getTime());const m=Math.round((new Date().getTime()-d)/1e3);if(m<-30)return(0,D.localize)(0,null,a(new Date().getTime()+m*1e3,!1));if(!O&&m<30)return(0,D.localize)(1,null);let c;return m<j?(c=m,$?c===1?y?(0,D.localize)(2,null,c):(0,D.localize)(3,null,c):y?(0,D.localize)(4,null,c):(0,D.localize)(5,null,c):c===1?y?(0,D.localize)(6,null,c):(0,D.localize)(7,null,c):y?(0,D.localize)(8,null,c):(0,D.localize)(9,null,c)):m<k?(c=Math.floor(m/j),$?c===1?y?(0,D.localize)(10,null,c):(0,D.localize)(11,null,c):y?(0,D.localize)(12,null,c):(0,D.localize)(13,null,c):c===1?y?(0,D.localize)(14,null,c):(0,D.localize)(15,null,c):y?(0,D.localize)(16,null,c):(0,D.localize)(17,null,c)):m<A?(c=Math.floor(m/k),$?c===1?y?(0,D.localize)(18,null,c):(0,D.localize)(19,null,c):y?(0,D.localize)(20,null,c):(0,D.localize)(21,null,c):c===1?y?(0,D.localize)(22,null,c):(0,D.localize)(23,null,c):y?(0,D.localize)(24,null,c):(0,D.localize)(25,null,c)):m<R?(c=Math.floor(m/A),$?c===1?(0,D.localize)(26,null,c):(0,D.localize)(27,null,c):c===1?(0,D.localize)(28,null,c):(0,D.localize)(29,null,c)):m<S?(c=Math.floor(m/R),$?c===1?y?(0,D.localize)(30,null,c):(0,D.localize)(31,null,c):y?(0,D.localize)(32,null,c):(0,D.localize)(33,null,c):c===1?y?(0,D.localize)(34,null,c):(0,D.localize)(35,null,c):y?(0,D.localize)(36,null,c):(0,D.localize)(37,null,c)):m<u?(c=Math.floor(m/S),$?c===1?y?(0,D.localize)(38,null,c):(0,D.localize)(39,null,c):y?(0,D.localize)(40,null,c):(0,D.localize)(41,null,c):c===1?y?(0,D.localize)(42,null,c):(0,D.localize)(43,null,c):y?(0,D.localize)(44,null,c):(0,D.localize)(45,null,c)):(c=Math.floor(m/u),$?c===1?y?(0,D.localize)(46,null,c):(0,D.localize)(47,null,c):y?(0,D.localize)(48,null,c):(0,D.localize)(49,null,c):c===1?y?(0,D.localize)(50,null,c):(0,D.localize)(51,null,c):y?(0,D.localize)(52,null,c):(0,D.localize)(53,null,c))}function g(d,$){const y=Math.abs(d/1e3);return y<1?$?(0,D.localize)(54,null,d):(0,D.localize)(55,null,d):y<j?$?(0,D.localize)(56,null,Math.round(d)/1e3):(0,D.localize)(57,null,Math.round(d)/1e3):y<k?$?(0,D.localize)(58,null,Math.round(d/(1e3*j))):(0,D.localize)(59,null,Math.round(d/(1e3*j))):y<A?$?(0,D.localize)(60,null,Math.round(d/(1e3*k))):(0,D.localize)(61,null,Math.round(d/(1e3*k))):(0,D.localize)(62,null,Math.round(d/(1e3*A)))}function v(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(se[80],re([7,4]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(se[34],re([0,1,19,3,80]),function(Q,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=u,e.$cj=a,e.$dj=g;function A(v,d){return d&&(v.stack||v.stacktrace)?k.localize(0,null,S(v),R(v.stack)||R(v.stacktrace)):S(v)}function R(v){return Array.isArray(v)?v.join(`
`):v}function S(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?k.localize(1,null,v.message):v.message||k.localize(2,null)}function u(v=null,d=!1){if(!v)return k.localize(3,null);if(Array.isArray(v)){const $=D.$Hb(v),y=u($[0],d);return $.length>1?k.localize(4,null,y,$.length):y}if(j.$4f(v))return v;if(v.detail){const $=v.detail;if($.error)return A($.error,d);if($.exception)return A($.exception,d)}return v.stack?A(v,d):v.message?v.message:k.localize(5,null)}function a(v){const d=v;return d instanceof Error&&Array.isArray(d.actions)}function g(v,d){let $;return typeof v=="string"?$=new Error(v):$=v,$.actions=d,$}}),define(se[81],re([7,4]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(se[82],re([0,1,81]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=j;function j(k){switch(k){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}}),define(se[56],re([0,1,12]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$gm=A,e.$hm=R;var j;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(j||(e.Source=j={}));var k;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function A(S,...u){const a=u.reduce((d,$)=>(d[$]=!0,d),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(d=>!a[d]).forEach(d=>{for(let $=0;$<g.length;$++)if(d.search(g[$])!==-1){delete S[d];break}})}function R(S){S&&(delete S.DEBUG,D.$j&&delete S.DYLD_LIBRARY_PATH,D.$k&&delete S.LD_PRELOAD)}}),define(se[83],re([0,1,11]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=j,e.$Oq=k,e.$Pq=A,e.log=S;function j(a){const g=a;return g&&typeof g.type=="string"&&typeof g.severity=="string"}function k(a){const g=[];let v;try{const d=JSON.parse(a.arguments),$=d[d.length-1];$&&$.__$stack&&(d.pop(),v=$.__$stack),g.push(...d)}catch{g.push("Unable to log remote console arguments",a.arguments)}return{args:g,stack:v}}function A(a){if(typeof a!="string")return A(k(a).stack);const g=a;if(g){const v=R(g),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(d&&d.length===4)return{uri:D.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function R(a){if(!a)return a;const g=a.indexOf(`
`);return g===-1?a:a.substring(0,g)}function S(a,g){const{args:v,stack:d}=k(a),$=typeof v[0]=="string"&&v.length===1;let y=R(d);y&&(y=`(${y.trim()})`);let O=[];if(typeof v[0]=="string"?y&&$?O=[`%c[${g}] %c${v[0]} %c${y}`,u("blue"),u(""),u("grey")]:O=[`%c[${g}] %c${v[0]}`,u("blue"),u(""),...v.slice(1)]:O=[`%c[${g}]%`,u("blue"),...v],y&&!$&&O.push(y),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,O)}function u(a){return`color: ${a}`}}),define(se[47],re([0,1,14,11]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=k,e.$Yh=A,e.$Zh=S;function k(u){return JSON.stringify(u,R)}function A(u){let a=JSON.parse(u);return a=S(a),a}function R(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function S(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return j.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof D.$Ce||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let g=0;g<u.length;++g)u[g]=S(u[g],a+1);else for(const g in u)Object.hasOwnProperty.call(u,g)&&(u[g]=S(u[g],a+1))}return u}}),define(se[84],re([0,1,71,15,12,11]),function(Q,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RD=g;class R{constructor(d,$,y){this.id=d,this.dependencies=$,this.callback=y}}class S{static{this.INSTANCE=new S}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,$,y)=>{typeof d!="string"&&(y=$,$=d,d=null),(typeof $!="object"||!Array.isArray($))&&(y=$,$=null),this.c.push(new R(d,$,y))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const $=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!$)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(d){return new Promise(($,y)=>{const O=document.createElement("script");O.setAttribute("async","async"),O.setAttribute("type","text/javascript");const m=()=>{O.removeEventListener("load",c),O.removeEventListener("error",b)},c=w=>{m(),$(this.c.pop())},b=w=>{m(),y(w)};O.addEventListener("load",c),O.addEventListener("error",b),this.f&&(d=this.f.createScriptURL(d)),O.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(O)})}i(d){return new Promise(($,y)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),$(this.c.pop())}catch(O){y(O)}})}async j(d){try{const $=globalThis._VSCODE_NODE_MODULES.fs,y=globalThis._VSCODE_NODE_MODULES.vm,O=globalThis._VSCODE_NODE_MODULES.module,m=A.URI.parse(d).fsPath,c=$.readFileSync(m).toString(),b=O.wrap(c.replace(/^#!.*/,""));return new y.Script(b).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const u=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function g(v,d,$){if(D.$T){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[v]&&(v=a[v]);const y=`${v}/${d}`;if(u.has(y))return u.get(y);let O;if(/^\w[\w\d+.-]*:\/\//.test(y))O=y;else{const w=`${$&&!k.$o?j.$Hg:j.$Gg}/${y}`;O=j.$Kg.asBrowserUri(w).toString(!0)}const m=S.INSTANCE.load(O);return u.set(y,m),m}else return await new Promise((y,O)=>{Q([v],y,O)})}}),define(se[85],re([0,1,33,48,28,77,12]),function(Q,e,D,j,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=void 0,e.$zn=u,e.$An=v,e.$yn=new class{c(d){return this.a||(this.a=j.$wi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,$=0;const y=(0,D.networkInterfaces)();for(const O in y){const m=y[O];if(m)for(const{mac:c,internal:b}of m)b||($+=1,this.c(c.toUpperCase())&&(d+=1))}this.b=$>0?d/$:0}return this.b}};let S;async function u(d){return S||(S=(async()=>await a(d)||k.$Mg())()),S}async function a(d){try{const $=await new Promise((O,m)=>{Q(["crypto"],O,m)}),y=(0,A.$xn)();return $.createHash("sha256").update(y,"utf8").digest("hex")}catch($){d($);return}}const g="Software\\Microsoft\\SQMClient";async function v(d){if(R.$i){const $=await new Promise((y,O)=>{Q(["@vscode/windows-registry"],y,O)});try{return $.GetStringRegKey("HKEY_LOCAL_MACHINE",g,"MachineId")||""}catch(y){return d(y),""}}return""}}),define(se[86],re([0,1,33,16,25]),function(Q,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=b,e.$fm=w;const A=/^\d+$/,R=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var u;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class v{constructor(p,i,r){this.exePath=p,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:h=!1}={}){return h?a===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:h=!1,findPreview:p=!1}={}){const i=d({useAlternateBitness:h});if(!i)return null;const r=j.$kc(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const l of await k.Promises.readdir(r)){let P=-1;if(p){const z=l.indexOf("-");if(z<0)continue;const N=l.substring(0,z);if(!A.test(N)||l.substring(z+1)!=="preview")continue;P=parseInt(N,10)}else{if(!A.test(l))continue;P=parseInt(l,10)}if(P<=t)continue;const I=j.$kc(r,l,"pwsh.exe");await k.SymlinkSupport.existsFile(I)&&(n=I,t=P)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",o=p?" Preview":"";return new v(n,`PowerShell${o}${s}`,!0)}async function y({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const p=j.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(p))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=h?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(p))if(i.test(t)){const n=j.$kc(p,t,"pwsh.exe");return new v(n,r)}return null}function O(){const h=j.$kc(D.homedir(),".dotnet","tools","pwsh.exe");return new v(h,".NET Core PowerShell Global Tool")}function m(){const h=j.$kc(process.env.windir,a===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(h,"Windows PowerShell",!0)}async function*c(){let h=await $();h&&(yield h),h=await $({useAlternateBitness:!0}),h&&(yield h),h=await y(),h&&(yield h),h=O(),h&&(yield h),h=await $({findPreview:!0}),h&&(yield h),h=await y({findPreview:!0}),h&&(yield h),h=await $({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=m(),h&&(yield h)}async function*b(){for await(const h of c())await h.exists()&&(yield h)}async function w(){for await(const h of b())return h;return null}}),define(se[57],re([0,1,16,12,35,56,3,25]),function(Q,e,D,j,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$im=u,e.$jm=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(v=k.env){return v.comspec||"cmd.exe"}function a(v){let d=[],$=!1;const y=function(O){if($){d.push(O);return}(!v.send(O,c=>{if(c&&console.error(c),$=!1,d.length>0){const b=d.slice(0);d=[],b.forEach(w=>y(w))}})||j.$i)&&($=!0)};return{send:y}}var g;(function(v){async function d($,y,O){if(D.$jc($))return $;if(y===void 0&&(y=k.cwd()),D.$nc($)!=="."||(O===void 0&&R.$4f(k.env.PATH)&&(O=k.env.PATH.split(D.$uc)),O===void 0||O.length===0))return D.$kc(y,$);async function c(b){if(await S.Promises.exists(b)){let w;try{w=await S.Promises.stat(b)}catch(h){h.message.startsWith("EACCES")&&(w=await S.Promises.lstat(b))}return w?!w.isDirectory():!1}return!1}for(const b of O){let w;if(D.$jc(b)?w=D.$kc(b,$):w=D.$kc(y,b,$),await c(w))return w;let h=w+".com";if(await c(h)||(h=w+".exe",await c(h)))return h}return D.$kc(y,$)}v.findExecutable=d})(g||(e.win32=g={}))}),define(se[87],re([0,1,33,12,86,57]),function(Q,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=R;async function R(v,d){return v===1?j.$i?g():A.$im(d):u(v,d)}let S=null;function u(v,d){if(j.$k&&v===2||j.$j&&v===3)return"/bin/bash";if(!S){let $;if(j.$i)$="/bin/bash";else{if($=d.SHELL,!$)try{$=(0,D.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}S=$}return S}let a=null;async function g(){return a||(a=(await(0,k.$fm)()).exePath),a}});var $e=this&&this.__decorate||function(Q,e,D,j){var k=arguments.length,A=k<3?e:j===null?j=Object.getOwnPropertyDescriptor(e,D):j,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Q,e,D,j);else for(var S=Q.length-1;S>=0;S--)(R=Q[S])&&(A=(k<3?R(A):k>3?R(e,D,A):R(e,D))||A);return k>3&&A&&Object.defineProperty(e,D,A),A};define(se[58],re([0,1,19,8,14,20,54,9,5,2,47,30,3]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.ProxyChannel=e.$$h=e.$8h=e.$7h=e.$6h=e.RequestInitiator=e.$5h=e.$2h=e.$1h=void 0,e.$3h=o,e.$4h=l,e.$9h=V,e.$0h=J;var $;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})($||($={}));function y(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var O;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(O||(O={}));function m(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(c||(c={}));function b(T){let q=0;for(let W=0;;W+=7){const X=T.read(1);if(q|=(X.buffer[0]&127)<<W,!(X.buffer[0]&128))return q}}const w=t(0);function h(T,q){if(q===0){T.write(w);return}let W=0;for(let Y=q;Y!==0;Y=Y>>>7)W++;const X=k.$Ce.alloc(W);for(let Y=0;q!==0;Y++)X.buffer[Y]=q&127,q=q>>>7,q>0&&(X.buffer[Y]|=128);T.write(X)}class p{constructor(q){this.b=q,this.a=0}read(q){const W=this.b.slice(this.a,this.a+q);return this.a+=W.byteLength,W}}e.$1h=p;class i{constructor(){this.a=[]}get buffer(){return k.$Ce.concat(this.a)}write(q){this.a.push(q)}}e.$2h=i;var r;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(r||(r={}));function t(T){const q=k.$Ce.alloc(1);return q.writeUInt8(T,0),q}const n={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(T,q){if(typeof q>"u")T.write(n.Undefined);else if(typeof q=="string"){const W=k.$Ce.fromString(q);T.write(n.String),h(T,W.byteLength),T.write(W)}else if(s&&Buffer.isBuffer(q)){const W=k.$Ce.wrap(q);T.write(n.Buffer),h(T,W.byteLength),T.write(W)}else if(q instanceof k.$Ce)T.write(n.VSBuffer),h(T,q.byteLength),T.write(q);else if(Array.isArray(q)){T.write(n.Array),h(T,q.length);for(const W of q)o(T,W)}else if(typeof q=="number"&&(q|0)===q)T.write(n.Uint),h(T,q);else{const W=k.$Ce.fromString(JSON.stringify(q));T.write(n.Object),h(T,W.byteLength),T.write(W)}}function l(T){switch(T.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return T.read(b(T)).toString();case r.Buffer:return T.read(b(T)).buffer;case r.VSBuffer:return T.read(b(T));case r.Array:{const W=b(T),X=[];for(let Y=0;Y<W;Y++)X.push(l(T));return X}case r.Object:return JSON.parse(T.read(b(T)).toString());case r.Int:return b(T)}}class P{constructor(q,W,X=null,Y=1e3){this.h=q,this.j=W,this.k=X,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(q,W){this.b.set(q,W),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const W=this.o([q.type]);this.k?.logOutgoing(W,0,1,m(q.type));return}case 201:case 202:case 204:case 203:{const W=this.o([q.type,q.id],q.data);this.k?.logOutgoing(W,q.id,1,m(q.type),q.data);return}}}o(q,W=void 0){const X=new i;return o(X,q),o(X,W),this.p(X.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const W=new p(q),X=l(W),Y=l(W),te=X[0];switch(te){case 100:return this.k?.logIncoming(q.byteLength,X[1],1,`${y(te)}: ${X[2]}.${X[3]}`,Y),this.s({type:te,id:X[1],channelName:X[2],name:X[3],arg:Y});case 102:return this.k?.logIncoming(q.byteLength,X[1],1,`${y(te)}: ${X[2]}.${X[3]}`,Y),this.t({type:te,id:X[1],channelName:X[2],name:X[3],arg:Y});case 101:return this.k?.logIncoming(q.byteLength,X[1],1,`${y(te)}`),this.u({type:te,id:X[1]});case 103:return this.k?.logIncoming(q.byteLength,X[1],1,`${y(te)}`),this.u({type:te,id:X[1]})}}s(q){const W=this.b.get(q.channelName);if(!W){this.v(q);return}const X=new A.$me;let Y;try{Y=W.call(this.j,q.name,q.arg,X.token)}catch(M){Y=Promise.reject(M)}const te=q.id;Y.then(M=>{this.m({id:te,data:M,type:201})},M=>{M instanceof Error?this.m({id:te,data:{message:M.message,name:M.name,stack:M.stack?M.stack.split?M.stack.split(`
`):M.stack:void 0},type:202}):this.m({id:te,data:M,type:203})}).finally(()=>{C.dispose(),this.d.delete(q.id)});const C=(0,a.$Sc)(()=>X.cancel());this.d.set(q.id,C)}t(q){const W=this.b.get(q.channelName);if(!W){this.v(q);return}const X=q.id,te=W.listen(this.j,q.name,q.arg)(C=>this.m({id:X,data:C,type:204}));this.d.set(q.id,te)}u(q){const W=this.d.get(q.id);W&&(W.dispose(),this.d.delete(q.id))}v(q){let W=this.g.get(q.channelName);W||(W=[],this.g.set(q.channelName,W));const X=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:q,timeoutTimer:X})}w(q){const W=this.g.get(q);if(W){for(const X of W)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$5h=P;var I;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class z{constructor(q,W=null){this.l=q,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$be,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=W}getChannel(q){const W=this;return{call(X,Y,te){return W.a?Promise.reject(new S.$5):W.m(q,X,Y,te)},listen(X,Y){return W.a?u.Event.None:W.o(q,X,Y)}}}m(q,W,X,Y=A.CancellationToken.None){const te=this.g++,M={id:te,type:100,channelName:q,name:W,arg:X};if(Y.isCancellationRequested)return Promise.reject(new S.$5);let f;return new Promise((L,F)=>{if(Y.isCancellationRequested)return F(new S.$5);const G=()=>{const he=pe=>{switch(pe.type){case 201:this.f.delete(te),L(pe.data);break;case 202:{this.f.delete(te);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,F(ye);break}case 203:this.f.delete(te),F(pe.data);break}};this.f.set(te,he),this.p(M)};let H=null;this.b===c.Idle?G():(H=(0,j.$dh)(he=>this.u()),H.then(()=>{H=null,G()}));const ne=()=>{H?(H.cancel(),H=null):this.p({id:te,type:101}),F(new S.$5)},ce=Y.onCancellationRequested(ne);f=(0,a.$Rc)((0,a.$Sc)(ne),ce),this.d.add(f)}).finally(()=>{f.dispose(),this.d.delete(f)})}o(q,W,X){const Y=this.g++,C={id:Y,type:102,channelName:q,name:W,arg:X};let M=null;const f=new u.$be({onWillAddFirstListener:()=>{M=(0,j.$dh)(L=>this.u()),M.then(()=>{M=null,this.d.add(f),this.p(C)})},onDidRemoveLastListener:()=>{M?(M.cancel(),M=null):(this.d.delete(f),this.p({id:Y,type:103}))}}),E=L=>f.fire(L.data);return this.f.set(Y,E),f.event}p(q){switch(q.type){case 100:case 102:{const W=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(W,q.id,0,`${y(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const W=this.q([q.type,q.id]);this.j?.logOutgoing(W,q.id,0,y(q.type));return}}}q(q,W=void 0){const X=new i;return o(X,q),o(X,W),this.r(X.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const W=new p(q),X=l(W),Y=l(W),te=X[0];switch(te){case 200:return this.j?.logIncoming(q.byteLength,0,0,m(te)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,X[1],0,m(te),Y),this.t({type:X[0],id:X[1],data:Y})}}t(q){if(q.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$6h=z,$e([R.$Uh],z.prototype,"onDidInitializePromise",null);class N{get connections(){const q=[];return this.f.forEach(W=>q.push(W)),q}constructor(q,W,X){this.a=new Map,this.f=new Set,this.g=new u.$be,this.onDidAddConnection=this.g.event,this.h=new u.$be,this.onDidRemoveConnection=this.h.event,this.j=new a.$Tc,this.j.add(q(({protocol:Y,onDidClientDisconnect:te})=>{const C=u.Event.once(Y.onMessage);this.j.add(C(M=>{const f=new p(M),E=l(f),L=new P(Y,E,W,X),F=new z(Y,W);this.a.forEach((H,ne)=>L.registerChannel(ne,H));const G={channelServer:L,channelClient:F,ctx:E};this.f.add(G),this.g.fire(G),this.j.add(te(()=>{L.dispose(),F.dispose(),this.f.delete(G),this.h.fire(G)}))}))}))}getChannel(q,W){const X=this;return{call(Y,te,C){let M;if((0,d.$fg)(W)){const E=(0,D.$4b)(X.connections.filter(W));M=E?Promise.resolve(E):u.Event.toPromise(u.Event.filter(X.onDidAddConnection,W))}else M=W.routeCall(X,Y,te);const f=M.then(E=>E.channelClient.getChannel(q));return V(f).call(Y,te,C)},listen(Y,te){if((0,d.$fg)(W))return X.k(q,W,Y,te);const C=W.routeEvent(X,Y,te).then(M=>M.channelClient.getChannel(q));return V(C).listen(Y,te)}}}k(q,W,X,Y){const te=this;let C;const M=new u.$be({onWillAddFirstListener:()=>{C=new a.$Tc;const f=new u.$he,E=new Map,L=G=>{const ne=G.channelClient.getChannel(q).listen(X,Y),ce=f.add(ne);E.set(G,ce)},F=G=>{const H=E.get(G);H&&(H.dispose(),E.delete(G))};te.connections.filter(W).forEach(L),u.Event.filter(te.onDidAddConnection,W)(L,void 0,C),te.onDidRemoveConnection(F,void 0,C),f.event(M.fire,M,C),C.add(f)},onDidRemoveLastListener:()=>{C?.dispose(),C=void 0}});return M.event}registerChannel(q,W){this.a.set(q,W);for(const X of this.f)X.channelServer.registerChannel(q,W)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$7h=N;class U{constructor(q,W,X=null){const Y=new i;o(Y,W),q.send(Y.buffer),this.a=new z(q,X),this.d=new P(q,W,X)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,W){this.d.registerChannel(q,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$8h=U;function V(T){return{call(q,W,X){return T.then(Y=>Y.call(q,W,X))},listen(q,W){const X=new u.$ke;return T.then(Y=>X.input=Y.listen(q,W)),X.event}}}function J(T){let q=!1;return{call(W,X,Y){return q?T.call(W,X,Y):(0,j.$rh)(0).then(()=>q=!0).then(()=>T.call(W,X,Y))},listen(W,X){if(q)return T.listen(W,X);const Y=new u.$ke;return(0,j.$rh)(0).then(()=>q=!0).then(()=>Y.input=T.listen(W,X)),Y.event}}}class _{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const W of q.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await u.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$$h=_;var K;(function(T){function q(te,C,M){const f=te,E=M&&M.disableMarshalling,L=new Map;for(const F in f)X(F)&&L.set(F,u.Event.buffer(f[F],!0,void 0,C));return new class{listen(F,G,H){const ne=L.get(G);if(ne)return ne;const ce=f[G];if(typeof ce=="function"){if(Y(G))return ce.call(f,H);if(X(G))return L.set(G,u.Event.buffer(f[G],!0,void 0,C)),L.get(G)}throw new S.$bb(`Event not found: ${G}`)}call(F,G,H){const ne=f[G];if(typeof ne=="function"){if(!E&&Array.isArray(H))for(let he=0;he<H.length;he++)H[he]=(0,g.$Zh)(H[he]);let ce=ne.apply(f,H);return ce instanceof Promise||(ce=Promise.resolve(ce)),ce}throw new S.$bb(`Method not found: ${G}`)}}}T.fromService=q;function W(te,C){const M=C&&C.disableMarshalling;return new Proxy({},{get(f,E){if(typeof E=="string")return C?.properties?.has(E)?C.properties.get(E):Y(E)?function(L){return te.listen(E,L)}:X(E)?te.listen(E):async function(...L){let F;C&&!(0,d.$ag)(C.context)?F=[C.context,...L]:F=L;const G=await te.call(E,F);return M?G:(0,g.$Zh)(G)};throw new S.$bb(`Property not found: ${String(E)}`)}})}T.toService=W;function X(te){return te[0]==="o"&&te[1]==="n"&&v.$sf(te.charCodeAt(2))}function Y(te){return/^onDynamic/.test(te)&&v.$sf(te.charCodeAt(9))}})(K||(e.ProxyChannel=K={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const q=T.toString();if(q!=="[object Object]")return q}return T}function ae(T){return Array.isArray(T)?T.map(ue):ue(T)}function B(T,q,W,X,Y,te,C){C=ae(C);const M=le[Y],f=M[X%M.length];let E=[`%c[${T}]%c[${String(q).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test(te)?(E=E.concat(C),E.push(")")):E.push(C),console.log.apply(console,E)}class Z{constructor(q,W){this.d=q,this.f=W,this.a=0,this.b=0}logOutgoing(q,W,X,Y,te){this.b+=q,B(this.d,this.b,q,W,X,Y,te)}logIncoming(q,W,X,Y,te){this.a+=q,B(this.f,this.a,q,W,X,Y,te)}}e.$_h=Z}),define(se[88],re([0,1,59,8,14,20,83,9,5,2,27,57,56,58]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;class y extends $.$5h{constructor(c){super({send:b=>{try{process.send?.(b.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",b=>k.$Ce.wrap(Buffer.from(b,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Rq=y;class O{constructor(c,b){this.i=c,this.j=b,this.c=new Set,this.g=new Map,this.h=new u.$be,this.onDidProcessExit=this.h.event;const w=b&&b.timeout?b.timeout:6e4;this.b=new j.$nh(w),this.d=null,this.f=null}getChannel(c){const b=this;return{call(w,h,p){return b.k(c,w,h,p)},listen(w,h){return b.l(c,w,h)}}}k(c,b,w,h=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const p=this.n(c),i=(0,j.$dh)(n=>p.call(b,w,n)),r=h.onCancellationRequested(()=>i.cancel()),t=(0,a.$Sc)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(c,b,w){if(!this.b)return u.Event.None;this.b.cancel();let h;const p=new u.$be({onWillAddFirstListener:()=>{h=this.n(c).listen(b,w)(p.fire,p),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return p.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],b=Object.create(null);b.env={...(0,g.$Wn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(b.env={...b.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(b.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,d.$hm)(b.env),this.d=(0,D.fork)(this.i,c,b);const w=new u.$be,p=u.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,R.$Nq)(o)){(0,R.log)(o,`IPC Library: ${this.j.serverName}`);return}w.fire(k.$Ce.wrap(Buffer.from(o,"base64")))}),i=this.j.useQueue?(0,v.$jm)(this.d):this.d,r=o=>this.d&&this.d.connected&&i.send(o.buffer.toString("base64")),t=w.event,n={send:r,onMessage:t};this.f=new $.$6h(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,l)=>{process.removeListener("exit",s),p.dispose(),this.c.forEach(P=>(0,a.$Pc)(P)),this.c.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:l})})}return this.f}n(c){let b=this.g.get(c);return b||(b=this.m.getChannel(c),this.g.set(c,b)),b}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sq=O}),define(se[89],re([0,1,8,5,2,47,3]),function(Q,e,D,j,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.StorageState=e.StorageHint=void 0,e.$Pp=u;var S;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function u(d){const $=d;return $?.changed instanceof Map||$?.deleted instanceof Set}var a;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(a||(e.StorageState=a={}));class g extends k.$Uc{static{this.a=100}constructor($,y=Object.create(null)){super(),this.r=$,this.s=y,this.b=this.B(new j.$ee),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new D.$oh(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((y,O)=>this.w(O,y)),$.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w($,y){if(this.c===a.Closed)return;let O=!1;(0,R.$ag)(y)?O=this.f.delete($):this.f.get($)!==y&&(this.f.set($,y),O=!0),O&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,y){const O=this.f.get($);return(0,R.$ag)(O)?y:O}getBoolean($,y){const O=this.get($);return(0,R.$ag)(O)?y:O==="true"}getNumber($,y){const O=this.get($);return(0,R.$ag)(O)?y:parseInt(O,10)}getObject($,y){const O=this.get($);return(0,R.$ag)(O)?y:(0,A.$Yh)(O)}async set($,y,O=!1){if(this.c===a.Closed)return;if((0,R.$ag)(y))return this.delete($,O);const m=(0,R.$6f)(y)||Array.isArray(y)?(0,A.$Xh)(y):String(y);if(this.f.get($)!==m)return this.f.set($,m),this.j.set($,m),this.h.delete($),this.b.fire({key:$,external:O}),this.D()}async delete($,y=!1){if(!(this.c===a.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:y}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(this.z)return this.D($)}async D($){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$Qp=g;class v{constructor(){this.onDidChangeItemsExternal=j.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((y,O)=>this.a.set(O,y)),$.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$Rp=v}),define(se[90],re([7,4]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(se[49],re([0,1,60,8,16,3,25,90]),function(Q,e,D,j,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0,e.zip=m,e.$cq=c,e.$dq=w,e.$_p="end of central directory record signature not found";const u=new RegExp(e.$_p);class a extends Error{constructor(p,i){let r=i.message;switch(p){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=p,this.cause=i}}e.$aq=a;function g(h){const p=h.externalFileAttributes>>16||33188;return[448,56,7].map(i=>p&i).reduce((i,r)=>i+r,p&61440)}function v(h){if(h instanceof a)return h;let p;return u.test(h.message)&&(p="CorruptZip"),new a(p,h)}function d(h,p,i,r,t,n){const s=k.$nc(p),o=k.$kc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(S.localize(0,null,p)));const l=k.$kc(r,p);let P;return n.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(R.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((I,z)=>{if(!n.isCancellationRequested)try{P=(0,D.createWriteStream)(l,{mode:i}),P.once("close",()=>I()),P.once("error",z),h.once("error",z),h.pipe(P)}catch(N){z(N)}}))}function $(h,p,i,r){let t=(0,j.$dh)(()=>Promise.resolve()),n=0;const s=r.onCancellationRequested(()=>{t.cancel(),h.close()});return new Promise((o,l)=>{const P=new j.$lh,I=z=>{z.isCancellationRequested||(n++,h.readEntry())};h.once("error",l),h.once("close",()=>t.then(()=>{r.isCancellationRequested||h.entryCount===n?o():l(new a("Incomplete",new Error(S.localize(1,null,n,h.entryCount))))},l)),h.readEntry(),h.on("entry",z=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(z.fileName)){I(r);return}const N=z.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(N)){const J=k.$kc(p,N);t=(0,j.$dh)(_=>R.Promises.mkdir(J,{recursive:!0}).then(()=>I(_)).then(void 0,l));return}const U=O(h,z),V=g(z);t=(0,j.$dh)(J=>P.queue(()=>U.then(_=>d(_,N,V,p,i,J).then(()=>I(J)))).then(null,l))})}).finally(()=>s.dispose())}async function y(h,p=!1){const{open:i}=await new Promise((r,t)=>{Q(["yauzl"],r,t)});return new Promise((r,t)=>{i(h,p?{lazyEntries:!0}:void 0,(n,s)=>{n?t(v(n)):r((0,A.$cg)(s))})})}function O(h,p){return new Promise((i,r)=>{h.openReadStream(p,(t,n)=>{t?r(v(t)):i((0,A.$cg)(n))})})}async function m(h,p){const{ZipFile:i}=await new Promise((r,t)=>{Q(["yazl"],r,t)});return new Promise((r,t)=>{const n=new i;p.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const s=(0,D.createWriteStream)(h);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(h))})}function c(h,p,i={},r){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=y(h,!0);return i.overwrite&&(n=n.then(s=>R.Promises.rm(p).then(()=>s))),n.then(s=>$(s,p,{sourcePathRegex:t},r))}function b(h,p){return y(h).then(i=>new Promise((r,t)=>{i.on("entry",n=>{n.fileName===p&&O(i,n).then(s=>r(s),s=>t(s))}),i.once("close",()=>t(new Error(S.localize(2,null,p))))}))}function w(h,p){return b(h,p).then(i=>new Promise((r,t)=>{const n=[];i.once("error",t),i.on("data",s=>n.push(s)),i.on("end",()=>r(Buffer.concat(n)))}))}}),define(se[91],re([7,4]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[92],re([7,4]),function(Q,e){return Q.create("vs/platform/contextkey/common/contextkey",e)}),define(se[93],re([7,4]),function(Q,e){return Q.create("vs/platform/contextkey/common/scanner",e)}),define(se[94],re([7,4]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(se[95],re([7,4]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[96],re([7,4]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(se[97],re([7,4]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[98],re([7,4]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[99],re([7,4]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(se[100],re([7,4]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(se[101],re([7,4]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[102],re([7,4]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(se[103],re([7,4]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(se[104],re([7,4]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[105],re([7,4]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(se[106],re([7,4]),function(Q,e){return Q.create("vs/platform/log/common/log",e)}),define(se[107],re([7,4]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(se[108],re([7,4]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(se[109],re([7,4]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[110],re([7,4]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[111],re([7,4]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(se[112],re([0,1,9,93]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.TokenType=void 0;var k;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...a){switch(a.length){case 1:return(0,j.localize)(0,null,a[0]);case 2:return(0,j.localize)(1,null,a[0],a[1]);case 3:return(0,j.localize)(2,null,a[0],a[1],a[2]);default:return}}const R=(0,j.localize)(3,null),S=(0,j.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(g){switch(g.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return g.isTripleEq?"===":"==";case 4:return g.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return g.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return g.lexeme;case 18:return g.lexeme;case 19:return g.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(g)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(g){return this.c=g,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(g){return this.r()||this.c.charCodeAt(this.e)!==g?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(g){this.f.push({type:g,offset:this.d})}l(g){const v=this.d,d=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:d};this.g.push({offset:v,lexeme:d,additionalInfo:g}),this.f.push($)}n(){this.m.lastIndex=this.d;const g=this.m.exec(this.c);if(g){this.e=this.d+g[0].length;const v=this.c.substring(this.d,this.e),d=u.b.get(v);d?this.k(d):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let g=this.e,v=!1,d=!1;for(;;){if(g>=this.c.length){this.e=g,this.l(S);return}const y=this.c.charCodeAt(g);if(v)v=!1;else if(y===47&&!d){g++;break}else y===91?d=!0:y===92?v=!0:y===93&&(d=!1);g++}for(;g<this.c.length&&u.a.has(this.c.charCodeAt(g));)g++;this.e=g;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$lj=u}),define(se[113],re([0,1,79,54,15,16,35,17,11]),function(Q,e,D,j,k,A,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=void 0,e.$1m=g,e.$2m=v,e.$Ym=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,A.$nc)(k.$Kg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$kc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,S.$4g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$4g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,D.$Xm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$kc)(this.userDataPath,"logs",$)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$4g)(u.URI.file((0,A.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$4g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$4g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$4g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=R.env.VSCODE_PORTABLE;return $?u.URI.file((0,A.$kc)($,"argv.json")):(0,S.$4g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,A.$lc)($):(0,A.$ic)((0,A.$kc)(k.$Kg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?u.URI.file((0,A.$lc)($)):u.URI.file((0,A.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,A.$lc)($);const y=R.env.VSCODE_EXTENSIONS;if(y)return y;const O=R.env.VSCODE_PORTABLE;return O?(0,A.$kc)(O,"extensions"):(0,S.$4g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(y=>/^[^:/?#]+?:\/\//.test(y)?u.URI.parse(y):u.URI.file((0,A.$ic)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?u.URI.parse($):u.URI.file((0,A.$ic)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$Ym.test($))}get extensionLogLevel(){const $=[];for(const y of this.args.log||[]){const O=e.$Ym.exec(y);O&&O[1]&&O[2]&&$.push([O[1],O[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,S.$4g)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=R.env.VSCODE_PORTABLE;return $?u.URI.file((0,A.$kc)($,"policy.json")):(0,S.$4g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,y,O){this.a=$,this.b=y,this.c=O,this.editSessionId=this.args.editSessionId}}e.$Zm=a,$e([j.$Uh],a.prototype,"appRoot",null),$e([j.$Uh],a.prototype,"userHome",null),$e([j.$Uh],a.prototype,"userDataPath",null),$e([j.$Uh],a.prototype,"appSettingsHome",null),$e([j.$Uh],a.prototype,"tmpDir",null),$e([j.$Uh],a.prototype,"cacheHome",null),$e([j.$Uh],a.prototype,"stateResource",null),$e([j.$Uh],a.prototype,"userRoamingDataHome",null),$e([j.$Uh],a.prototype,"userDataSyncHome",null),$e([j.$Uh],a.prototype,"sync",null),$e([j.$Uh],a.prototype,"machineSettingsResource",null),$e([j.$Uh],a.prototype,"workspaceStorageHome",null),$e([j.$Uh],a.prototype,"localHistoryHome",null),$e([j.$Uh],a.prototype,"keyboardLayoutResource",null),$e([j.$Uh],a.prototype,"argvResource",null),$e([j.$Uh],a.prototype,"isExtensionDevelopment",null),$e([j.$Uh],a.prototype,"untitledWorkspacesHome",null),$e([j.$Uh],a.prototype,"builtinExtensionsPath",null),$e([j.$Uh],a.prototype,"extensionsPath",null),$e([j.$Uh],a.prototype,"extensionDevelopmentLocationURI",null),$e([j.$Uh],a.prototype,"extensionDevelopmentKind",null),$e([j.$Uh],a.prototype,"extensionTestsLocationURI",null),$e([j.$Uh],a.prototype,"debugExtensionHost",null),$e([j.$Uh],a.prototype,"logLevel",null),$e([j.$Uh],a.prototype,"extensionLogLevel",null),$e([j.$Uh],a.prototype,"serviceMachineIdResource",null),$e([j.$Uh],a.prototype,"disableTelemetry",null),$e([j.$Uh],a.prototype,"disableWorkspaceTrust",null),$e([j.$Uh],a.prototype,"useInMemorySecretStorage",null),$e([j.$Uh],a.prototype,"policyFile",null);function g(d,$){return v(d["inspect-extensions"],d["inspect-brk-extensions"],5870,$,d.debugId,d.extensionEnvironment)}function v(d,$,y,O,m,c){const w=Number($||d)||(O?null:y),h=w?!!$:!1;let p;if(c)try{p=JSON.parse(c)}catch{}return{port:w,break:h,debugId:m,env:p}}}),function(){"use strict";function Q(e,D,j){function k(R,S){const u=A(R,S),a=[u];return e.isAbsolute(u)||a.unshift(j),e.resolve(...a)}function A(R,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,S);const g=R["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(v,"AppData","Roaming")}break;case"darwin":a=e.join(D.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,S)}return{getUserDataPath:k}}if(typeof define=="function")define(se[114],re([170,33,35]),function(e,D,j){return Q(e,D,j.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=Q(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[115],re([0,1,33,113,114]),function(Q,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=void 0,e.$4m=R,e.$5m=S;class A extends j.$Zm{constructor(a,g){super(a,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,k.getUserDataPath)(a,g.nameShort)},g)}}e.$3m=A;function R(u,a){return(0,j.$2m)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}function S(u,a){return(0,j.$2m)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}}),define(se[116],re([0,1,3,97]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=k;function k(R,S,u,a){try{A(R,S,u,a)}catch(g){R.error(g?.message??g)}return S}function A(R,S,u,a){const g=(v,d,$)=>{const y=v[d];if((0,D.$4f)(y)){const O=y,m=O.length;if(m>1&&O[0]==="%"&&O[m-1]==="%"){const c=O.substr(1,m-2);let b=u[c];b===void 0&&a&&(b=a[c]);const w=typeof b=="string"?b:b?.message,h=a?.[c],p=typeof h=="string"?h:h?.message;if(!w){p||R.warn(`[${S.name}]: ${(0,j.localize)(0,null,c)}`);return}if($&&(d==="title"||d==="category")&&p&&p!==w){const i={value:w,original:p};v[d]=i}else v[d]=w}}else if((0,D.$6f)(y))for(const O in y)y.hasOwnProperty(O)&&(O==="commands"?g(y,O,!0):g(y,O,$));else if(Array.isArray(y))for(let O=0;O<y.length;O++)g(y,O,$)};for(const v in S)S.hasOwnProperty(v)&&g(S,v)}}),define(se[117],re([0,1,49,100]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=k;function k(A){return(0,D.$dq)(A,"extension/package.json").then(R=>{try{return JSON.parse(R.toString("utf8"))}catch{throw new Error((0,j.localize)(0,null))}})}}),define(se[50],re([0,1,17,55,101,44]),function(Q,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=u,e.$Bp=a,e.$Cp=g,e.$Dp=v,e.$Ep=d,e.$Fp=$,e.$Gp=y;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function u(c){return c=c.trim(),c==="*"||R.test(c)}function a(c){if(!u(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=c.match(R);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}function g(c){if(!c)return null;const b=c.majorBase,w=c.majorMustEqual,h=c.minorBase;let p=c.minorMustEqual;const i=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(b===0||(p=!1),r=!1);let t=0;if(c.preRelease){const n=S.exec(c.preRelease);if(n){const[,s,o,l]=n;t=Date.UTC(Number(s),Number(o)-1,Number(l))}}return{majorBase:b,majorMustEqual:w,minorBase:h,minorMustEqual:p,patchBase:i,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}function v(c,b,w){let h;typeof c=="string"?h=g(a(c)):h=c;let p;b instanceof Date?p=b.getTime():typeof b=="string"&&(p=new Date(b).getTime());let i;if(typeof w=="string"?i=g(a(w)):i=w,!h||!i)return!1;const r=h.majorBase,t=h.minorBase,n=h.patchBase;let s=i.majorBase,o=i.minorBase,l=i.patchBase;const P=i.notBefore;let I=i.majorMustEqual,z=i.minorMustEqual,N=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||p&&p<P?!1:n>=l:(r===1&&s===0&&(!I||!z||!N)&&(s=1,o=0,l=0,I=!0,z=!1,N=!1),r<s?!1:r>s?!I:t<o?!1:t>o?!z:n<l?!1:n>l?!N:!(p&&p<P))}function d(c,b,w,h,p){const i=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return i.push([j.default.Error,k.localize(0,null)]),i;if(typeof h.name!="string")return i.push([j.default.Error,k.localize(1,null,"name")]),i;if(typeof h.version!="string")return i.push([j.default.Error,k.localize(2,null,"version")]),i;if(!h.engines)return i.push([j.default.Error,k.localize(3,null,"engines")]),i;if(typeof h.engines.vscode!="string")return i.push([j.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof h.extensionDependencies<"u"&&!m(h.extensionDependencies))return i.push([j.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof h.activationEvents<"u"){if(!m(h.activationEvents))return i.push([j.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof h.main>"u"&&typeof h.browser>"u")return i.push([j.default.Error,k.localize(7,null,"activationEvents","main","browser")]),i}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&i.push([j.default.Warning,k.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return i.push([j.default.Error,k.localize(9,null,"main")]),i;{const n=(0,D.$4g)(w,h.main);(0,D.$Xg)(n,w)||i.push([j.default.Warning,k.localize(10,null,n.path,w.path)])}}if(typeof h.browser<"u"){if(typeof h.browser!="string")return i.push([j.default.Error,k.localize(11,null,"browser")]),i;{const n=(0,D.$4g)(w,h.browser);(0,D.$Xg)(n,w)||i.push([j.default.Warning,k.localize(12,null,n.path,w.path)])}}if(!A.valid(h.version))return i.push([j.default.Error,k.localize(13,null)]),i;const r=[];if(!$(c,b,h,p,r))for(const n of r)i.push([j.default.Error,n]);return i}function $(c,b,w,h,p){return h||typeof w.main>"u"&&typeof w.browser>"u"?!0:O(c,b,w.engines.vscode,p)}function y(c,b,w){return c==="*"||O(b,w,c)}function O(c,b,w,h=[]){const p=g(a(w));if(!p)return h.push(k.localize(14,null,w)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return h.push(k.localize(15,null,w)),!1}else if(!p.majorMustEqual)return h.push(k.localize(16,null,w)),!1;return v(c,b,p)?!0:(h.push(k.localize(17,null,c,w)),!1)}function m(c){if(!Array.isArray(c))return!1;for(let b=0,w=c.length;b<w;b++)if(typeof c[b]!="string")return!1;return!0}}),define(se[118],re([0,1,14,28]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=k;async function k(A,R,S){let u=S&&S.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const g=(await R.readFile(A.serviceMachineIdResource)).value.toString();u=(0,j.$Lg)(g)?g:null}catch{u=null}if(!u){u=(0,j.$Mg)();try{await R.writeFile(A.serviceMachineIdResource,D.$Ce.fromString(u))}catch{}}return S?.store("storage.serviceMachineId",u,-1,1),u}}),define(se[51],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=void 0;class D{constructor(k,A=[],R=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.$ni=D}),define(se[119],re([0,1,51]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$os=A,e.$ps=R;const j=[];var k;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function A(S,u,a){u instanceof D.$ni||(u=new D.$ni(u,[],!!a)),j.push([S,u])}function R(){return j}}),define(se[120],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;class D{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$5q=D;class j{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const R of this.a.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const S=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(R);S.outgoing.set(u.key,u),u.incoming.set(S.key,S)}removeNode(A){const R=this.b(A);this.a.delete(R);for(const S of this.a.values())S.outgoing.delete(R),S.incoming.delete(R)}lookupOrInsertNode(A){const R=this.b(A);let S=this.a.get(R);return S||(S=new D(R,A),this.a.set(R,S)),S}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[R,S]of this.a)A.push(`${R}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this.a){const S=new Set([A]),u=this.c(R,S);if(u)return u}}c(A,R){for(const[S,u]of A.outgoing){if(R.has(S))return[...R,S].join(" -> ");R.add(S);const a=this.c(u,R);if(a)return a;R.delete(S)}}}e.$6q=j}),define(se[29],re([0,1,3,11,10]),function(Q,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Wi=void 0,e.$Xi=A,e.$Yi=R,e.$Zi=u,e.$1i=a,e.$2i=g,e.$3i=v,e.$4i=d,e.$5i=y,e.$6i=O,e.$7i=m,e.$Wi=(0,k.$qi)("configurationService");function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof j.URI)}function R(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof j.URI)}var S;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function u(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function g(c,b){const w=Object.create(null);for(const h in c)v(w,h,c[h],b);return w}function v(c,b,w,h){const p=b.split("."),i=p.pop();let r=c;for(let t=0;t<p.length;t++){const n=p[t];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${b} as ${p.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[i]=w}catch{h(`Ignoring ${b} as ${p.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${b} as ${p.join(".")} is ${JSON.stringify(r)}`)}function d(c,b){const w=b.split(".");$(c,w)}function $(c,b){const w=b.shift();if(b.length===0){delete c[w];return}if(Object.keys(c).indexOf(w)!==-1){const h=c[w];typeof h=="object"&&!Array.isArray(h)&&($(h,b),Object.keys(h).length===0&&delete c[w])}}function y(c,b,w){function h(r,t){let n=r;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const p=b.split("."),i=h(c,p);return typeof i>"u"?w:i}function O(c,b,w){Object.keys(b).forEach(h=>{h!=="__proto__"&&(h in c?D.$6f(c[h])&&D.$6f(b[h])?O(c[h],b[h],w):w&&(c[h]=b[h]):c[h]=b[h])})}function m(c){return c.replace(/[\[\]]/g,"")}}),define(se[121],re([0,1,12,30,112,10,92,9]),function(Q,e,D,j,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$oj=e.$nj=e.ContextKeyExprType=void 0,e.$mj=a,e.$pj=r,e.$qj=t,e.$Jj=Y;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",D.$j),u.set("isLinux",D.$k),u.set("isWindows",D.$i),u.set("isWeb",D.$o),u.set("isMacNative",D.$j&&!D.$o),u.set("isEdge",D.$H),u.set("isFirefox",D.$F),u.set("isChrome",D.$E),u.set("isSafari",D.$G);function a(M,f){if(u.get(M)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(M,f)}const g=Object.prototype.hasOwnProperty;var v;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const d={regexParsingWithErrorRecovery:!0},$=(0,R.localize)(0,null),y=(0,R.localize)(1,null),O=(0,R.localize)(2,null),m=(0,R.localize)(3,null),c=(0,R.localize)(4,null),b=(0,R.localize)(5,null),w=(0,R.localize)(6,null),h=(0,R.localize)(7,null);class p{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(f=d){this.k=f,this.d=new k.$lj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(f){if(f===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(f).scan(),this.g=0,this.h=[];try{const E=this.l();if(!this.E()){const L=this.D(),F=L.type===17?b:void 0;throw this.h.push({message:c,offset:L.offset,lexeme:k.$lj.getLexeme(L),additionalInfo:F}),p.c}return E}catch(E){if(E!==p.c)throw E;return}}l(){return this.m()}m(){const f=[this.o()];for(;this.y(16);){const E=this.o();f.push(E)}return f.length===1?f[0]:i.or(...f)}o(){const f=[this.s()];for(;this.y(15);){const E=this.s();f.push(E)}return f.length===1?f[0]:i.and(...f)}s(){if(this.y(2)){const f=this.D();switch(f.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const E=this.l();return this.A(1,m),E?.negate()}case 17:return this.z(),U.create(f.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",f)}}return this.t()}t(){const f=this.D();switch(f.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const E=this.l();return this.A(1,m),E}case 17:{const E=f.lexeme;if(this.z(),this.y(9)){const F=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),F.type!==10)throw this.B("REGEX",F);const G=F.lexeme,H=G.lastIndexOf("/"),ne=H===G.length-1?void 0:this.w(G.substring(H+1));let ce;try{ce=new RegExp(G.substring(1,H),ne)}catch{throw this.B("REGEX",F)}return ue.create(E,ce)}switch(F.type){case 10:case 19:{const G=[F.lexeme];this.z();let H=this.D(),ne=0;for(let fe=0;fe<F.lexeme.length;fe++)F.lexeme.charCodeAt(fe)===40?ne++:F.lexeme.charCodeAt(fe)===41&&ne--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:ne++;break;case 1:ne--;break;case 10:case 18:for(let fe=0;fe<H.lexeme.length;fe++)H.lexeme.charCodeAt(fe)===40?ne++:F.lexeme.charCodeAt(fe)===41&&ne--}if(ne<0)break;G.push(k.$lj.getLexeme(H)),this.z(),H=this.D()}const ce=G.join(""),he=ce.lastIndexOf("/"),pe=he===ce.length-1?void 0:this.w(ce.substring(he+1));let ye;try{ye=new RegExp(ce.substring(1,he),pe)}catch{throw this.B("REGEX",F)}return i.regex(E,ye)}case 18:{const G=F.lexeme;this.z();let H=null;if(!(0,j.$3e)(G)){const ne=G.indexOf("/"),ce=G.lastIndexOf("/");if(ne!==ce&&ne>=0){const he=G.slice(ne+1,ce),pe=G[ce+1]==="i"?"i":"";try{H=new RegExp(he,pe)}catch{throw this.B("REGEX",F)}}}if(H===null)throw this.B("REGEX",F);return ue.create(E,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,O);const F=this.u();return i.notIn(E,F)}switch(this.D().type){case 3:{this.z();const F=this.u();if(this.x().type===18)return i.equals(E,F);switch(F){case"true":return i.has(E);case"false":return i.not(E);default:return i.equals(E,F)}}case 4:{this.z();const F=this.u();if(this.x().type===18)return i.notEquals(E,F);switch(F){case"true":return i.not(E);case"false":return i.has(E);default:return i.notEquals(E,F)}}case 5:return this.z(),K.create(E,this.u());case 6:return this.z(),le.create(E,this.u());case 7:return this.z(),J.create(E,this.u());case 8:return this.z(),_.create(E,this.u());case 13:return this.z(),i.in(E,this.u());default:return i.has(E)}}case 20:throw this.h.push({message:w,offset:f.offset,lexeme:"",additionalInfo:h}),p.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const f=this.D();switch(f.type){case 17:case 18:return this.z(),f.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(f){return f.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(f){return this.C(f)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(f,E){if(this.C(f))return this.z();throw this.B(E,this.D())}B(f,E,L){const F=(0,R.localize)(8,null,f,k.$lj.getLexeme(E)),G=E.offset,H=k.$lj.getLexeme(E);return this.h.push({message:F,offset:G,lexeme:H,additionalInfo:L}),p.c}C(f){return this.D().type===f}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$nj=p;class i{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(f){return l.create(f)}static equals(f,E){return P.create(f,E)}static notEquals(f,E){return N.create(f,E)}static regex(f,E){return ue.create(f,E)}static in(f,E){return I.create(f,E)}static notIn(f,E){return z.create(f,E)}static not(f){return U.create(f)}static and(...f){return Z.create(f,null,!0)}static or(...f){return T.create(f,null,!0)}static greater(f,E){return J.create(f,E)}static greaterEquals(f,E){return _.create(f,E)}static smaller(f,E){return K.create(f,E)}static smallerEquals(f,E){return le.create(f,E)}static{this.c=new p({regexParsingWithErrorRecovery:!1})}static deserialize(f){return f==null?void 0:this.c.parse(f)}}e.$oj=i;function r(M){const f=new p({regexParsingWithErrorRecovery:!1});return M.map(E=>(f.parse(E),f.lexingErrors.length>0?f.lexingErrors.map(L=>({errorMessage:L.additionalInfo?(0,R.localize)(9,null,L.additionalInfo):(0,R.localize)(10,null),offset:L.offset,length:L.lexeme.length})):f.parsingErrors.length>0?f.parsingErrors.map(L=>({errorMessage:L.additionalInfo?`${L.message}. ${L.additionalInfo}`:L.message,offset:L.offset,length:L.lexeme.length})):[]))}function t(M,f){const E=M?M.substituteConstants():void 0,L=f?f.substituteConstants():void 0;return!E&&!L?!0:!E||!L?!1:E.equals(L)}function n(M,f){return M.cmp(f)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return o.INSTANCE}}e.$rj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return s.INSTANCE}}e.$sj=o;class l{static create(f,E=null){const L=u.get(f);return typeof L=="boolean"?L?o.INSTANCE:s.INSTANCE:new l(f,E)}constructor(f,E){this.key=f,this.c=E,this.type=2}cmp(f){return f.type!==this.type?this.type-f.type:W(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}substituteConstants(){const f=u.get(this.key);return typeof f=="boolean"?f?o.INSTANCE:s.INSTANCE:this}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.c||(this.c=U.create(this.key,this)),this.c}}e.$tj=l;class P{static create(f,E,L=null){if(typeof E=="boolean")return E?l.create(f,L):U.create(f,L);const F=u.get(f);return typeof F=="boolean"?E===(F?"true":"false")?o.INSTANCE:s.INSTANCE:new P(f,E,L)}constructor(f,E,L){this.c=f,this.d=E,this.f=L,this.type=4}cmp(f){return f.type!==this.type?this.type-f.type:X(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=u.get(this.c);if(typeof f=="boolean"){const E=f?"true":"false";return this.d===E?o.INSTANCE:s.INSTANCE}return this}evaluate(f){return f.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(f){return f.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$uj=P;class I{static create(f,E){return new I(f,E)}constructor(f,E){this.d=f,this.f=E,this.type=10,this.c=null}cmp(f){return f.type!==this.type?this.type-f.type:X(this.d,this.f,f.d,f.f)}equals(f){return f.type===this.type?this.d===f.d&&this.f===f.f:!1}substituteConstants(){return this}evaluate(f){const E=f.getValue(this.f),L=f.getValue(this.d);return Array.isArray(E)?E.includes(L):typeof L=="string"&&typeof E=="object"&&E!==null?g.call(E,L):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(f){return f.mapIn(this.d,this.f)}negate(){return this.c||(this.c=z.create(this.d,this.f)),this.c}}e.$vj=I;class z{static create(f,E){return new z(f,E)}constructor(f,E){this.d=f,this.f=E,this.type=11,this.c=I.create(f,E)}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(f){return f.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$wj=z;class N{static create(f,E,L=null){if(typeof E=="boolean")return E?U.create(f,L):l.create(f,L);const F=u.get(f);return typeof F=="boolean"?E===(F?"true":"false")?s.INSTANCE:o.INSTANCE:new N(f,E,L)}constructor(f,E,L){this.c=f,this.d=E,this.f=L,this.type=5}cmp(f){return f.type!==this.type?this.type-f.type:X(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=u.get(this.c);if(typeof f=="boolean"){const E=f?"true":"false";return this.d===E?s.INSTANCE:o.INSTANCE}return this}evaluate(f){return f.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(f){return f.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$xj=N;class U{static create(f,E=null){const L=u.get(f);return typeof L=="boolean"?L?s.INSTANCE:o.INSTANCE:new U(f,E)}constructor(f,E){this.c=f,this.d=E,this.type=3}cmp(f){return f.type!==this.type?this.type-f.type:W(this.c,f.c)}equals(f){return f.type===this.type?this.c===f.c:!1}substituteConstants(){const f=u.get(this.c);return typeof f=="boolean"?f?s.INSTANCE:o.INSTANCE:this}evaluate(f){return!f.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(f){return f.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$yj=U;function V(M,f){if(typeof M=="string"){const E=parseFloat(M);isNaN(E)||(M=E)}return typeof M=="string"||typeof M=="number"?f(M):s.INSTANCE}class J{static create(f,E,L=null){return V(E,F=>new J(f,F,L))}constructor(f,E,L){this.c=f,this.d=E,this.f=L,this.type=12}cmp(f){return f.type!==this.type?this.type-f.type:X(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$zj=J;class _{static create(f,E,L=null){return V(E,F=>new _(f,F,L))}constructor(f,E,L){this.c=f,this.d=E,this.f=L,this.type=13}cmp(f){return f.type!==this.type?this.type-f.type:X(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Aj=_;class K{static create(f,E,L=null){return V(E,F=>new K(f,F,L))}constructor(f,E,L){this.c=f,this.d=E,this.f=L,this.type=14}cmp(f){return f.type!==this.type?this.type-f.type:X(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Bj=K;class le{static create(f,E,L=null){return V(E,F=>new le(f,F,L))}constructor(f,E,L){this.c=f,this.d=E,this.f=L,this.type=15}cmp(f){return f.type!==this.type?this.type-f.type:X(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Cj=le;class ue{static create(f,E){return new ue(f,E)}constructor(f,E){this.d=f,this.f=E,this.type=7,this.c=null}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.d<f.d)return-1;if(this.d>f.d)return 1;const E=this.f?this.f.source:"",L=f.f?f.f.source:"";return E<L?-1:E>L?1:0}equals(f){if(f.type===this.type){const E=this.f?this.f.source:"",L=f.f?f.f.source:"";return this.d===f.d&&E===L}return!1}substituteConstants(){return this}evaluate(f){const E=f.getValue(this.d);return this.f?this.f.test(E):!1}serialize(){const f=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${f}`}keys(){return[this.d]}map(f){return f.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$Dj=ue;class ae{static create(f){return new ae(f)}constructor(f){this.c=f,this.type=8}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(f){return new ae(this.c.map(f))}negate(){return this.c}}e.$Ej=ae;function B(M){let f=null;for(let E=0,L=M.length;E<L;E++){const F=M[E].substituteConstants();if(M[E]!==F&&f===null){f=[];for(let G=0;G<E;G++)f[G]=M[G]}f!==null&&(f[E]=F)}return f===null?M:f}class Z{static create(f,E,L){return Z.d(f,E,L)}constructor(f,E){this.expr=f,this.c=E,this.type=6}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let E=0,L=this.expr.length;E<L;E++){const F=n(this.expr[E],f.expr[E]);if(F!==0)return F}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let E=0,L=this.expr.length;E<L;E++)if(!this.expr[E].equals(f.expr[E]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:Z.create(f,this.c,!1)}evaluate(f){for(let E=0,L=this.expr.length;E<L;E++)if(!this.expr[E].evaluate(f))return!1;return!0}static d(f,E,L){const F=[];let G=!1;for(const H of f)if(H){if(H.type===1){G=!0;continue}if(H.type===0)return s.INSTANCE;if(H.type===6){F.push(...H.expr);continue}F.push(H)}if(F.length===0&&G)return o.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(n);for(let H=1;H<F.length;H++)F[H-1].equals(F[H])&&(F.splice(H,1),H--);if(F.length===1)return F[0];for(;F.length>1;){const H=F[F.length-1];if(H.type!==9)break;F.pop();const ne=F.pop(),ce=F.length===0,he=T.create(H.expr.map(pe=>Z.create([pe,ne],null,L)),null,ce);he&&(F.push(he),F.sort(n))}if(F.length===1)return F[0];if(L){for(let H=0;H<F.length;H++)for(let ne=H+1;ne<F.length;ne++)if(F[H].negate().equals(F[ne]))return s.INSTANCE;if(F.length===1)return F[0]}return new Z(F,E)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(const E of this.expr)f.push(...E.keys());return f}map(f){return new Z(this.expr.map(E=>E.map(f)),null)}negate(){if(!this.c){const f=[];for(const E of this.expr)f.push(E.negate());this.c=T.create(f,this,!0)}return this.c}}e.$Fj=Z;class T{static create(f,E,L){return T.d(f,E,L)}constructor(f,E){this.expr=f,this.c=E,this.type=9}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let E=0,L=this.expr.length;E<L;E++){const F=n(this.expr[E],f.expr[E]);if(F!==0)return F}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let E=0,L=this.expr.length;E<L;E++)if(!this.expr[E].equals(f.expr[E]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:T.create(f,this.c,!1)}evaluate(f){for(let E=0,L=this.expr.length;E<L;E++)if(this.expr[E].evaluate(f))return!0;return!1}static d(f,E,L){let F=[],G=!1;if(f){for(let H=0,ne=f.length;H<ne;H++){const ce=f[H];if(ce){if(ce.type===0){G=!0;continue}if(ce.type===1)return o.INSTANCE;if(ce.type===9){F=F.concat(ce.expr);continue}F.push(ce)}}if(F.length===0&&G)return s.INSTANCE;F.sort(n)}if(F.length!==0){if(F.length===1)return F[0];for(let H=1;H<F.length;H++)F[H-1].equals(F[H])&&(F.splice(H,1),H--);if(F.length===1)return F[0];if(L){for(let H=0;H<F.length;H++)for(let ne=H+1;ne<F.length;ne++)if(F[H].negate().equals(F[ne]))return o.INSTANCE;if(F.length===1)return F[0]}return new T(F,E)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(const E of this.expr)f.push(...E.keys());return f}map(f){return new T(this.expr.map(E=>E.map(f)),null)}negate(){if(!this.c){const f=[];for(const E of this.expr)f.push(E.negate());for(;f.length>1;){const E=f.shift(),L=f.shift(),F=[];for(const G of C(E))for(const H of C(L))F.push(Z.create([G,H],null,!1));f.unshift(T.create(F,null,!1))}this.c=T.create(f,this,!0)}return this.c}}e.$Gj=T;class q extends l{static{this.d=[]}static all(){return q.d.values()}constructor(f,E,L){super(f,null),this.f=E,typeof L=="object"?q.d.push({...L,key:f}):L!==!0&&q.d.push({key:f,description:L,type:E!=null?typeof E:void 0})}bindTo(f){return f.createKey(this.key,this.f)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return P.create(this.key,f)}notEqualsTo(f){return N.create(this.key,f)}}e.$Hj=q,e.$Ij=(0,A.$qi)("contextKeyService");function W(M,f){return M<f?-1:M>f?1:0}function X(M,f,E,L){return M<E?-1:M>E?1:f<L?-1:f>L?1:0}function Y(M,f){if(M.type===0||f.type===1)return!0;if(M.type===9)return f.type===9?te(M.expr,f.expr):!1;if(f.type===9){for(const E of f.expr)if(Y(M,E))return!0;return!1}if(M.type===6){if(f.type===6)return te(f.expr,M.expr);for(const E of M.expr)if(Y(E,f))return!0;return!1}return M.equals(f)}function te(M,f){let E=0,L=0;for(;E<M.length&&L<f.length;){const F=M[E].cmp(f[L]);if(F<0)return!1;F===0&&E++,L++}return E===M.length}function C(M){return M.type===9?M.expr:[M]}}),define(se[61],re([0,1,10]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=void 0,e.$Eo=(0,D.$qi)("downloadService")}),define(se[18],re([0,1,10]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=void 0,e.$xi=(0,D.$qi)("environmentService"),e.$yi=(0,D.$ri)(e.$xi)}),define(se[21],re([0,1,95,10]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.ExtensionGalleryErrorCode=e.$1o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$To=k,e.$Uo=A,e.$Vo=R,e.$Wo=S,e.$Xo=u,e.$Yo=a,e.$No="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Oo=new RegExp(e.$No),e.$Po="__web_extension",e.$Qo="skipWalkthrough",e.$Ro="extensionsSync",e.$So="dependecyOrPackExtensionInstall";function k(w){switch(w){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(w){switch(w){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(w,h){switch(w){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function S(w,h){return h==="web"&&!w.includes("web")}function u(w,h,p){return S(h,p)?!1:w==="undefined"||w==="universal"?!0:w==="unknown"?!1:w===p}function a(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}var g;(function(w){w[w.NoneOrRelevance=0]="NoneOrRelevance",w[w.LastUpdatedDate=1]="LastUpdatedDate",w[w.Title=2]="Title",w[w.PublisherName=3]="PublisherName",w[w.InstallCount=4]="InstallCount",w[w.PublishedDate=10]="PublishedDate",w[w.AverageRating=6]="AverageRating",w[w.WeightedRating=12]="WeightedRating"})(g||(e.SortBy=g={}));var v;(function(w){w[w.Default=0]="Default",w[w.Ascending=1]="Ascending",w[w.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var d;(function(w){w.Install="install",w.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var $;(function(w){w[w.None=1]="None",w[w.Install=2]="Install",w[w.Update=3]="Update",w[w.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Zo=(0,j.$qi)("extensionGalleryService");var y;(function(w){w.Unsupported="Unsupported",w.Deprecated="Deprecated",w.Malicious="Malicious",w.Incompatible="Incompatible",w.IncompatibleTargetPlatform="IncompatibleTargetPlatform",w.ReleaseVersionNotFound="ReleaseVersionNotFound",w.Invalid="Invalid",w.Download="Download",w.DownloadSignature="DownloadSignature",w.UpdateMetadata="UpdateMetadata",w.Extract="Extract",w.Scanning="Scanning",w.Delete="Delete",w.Rename="Rename",w.CorruptZip="CorruptZip",w.IncompleteZip="IncompleteZip",w.Signature="Signature",w.NotAllowed="NotAllowed",w.Gallery="Gallery",w.Unknown="Unknown",w.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var O;(function(w){w.UnknownError="UnknownError",w.PackageIsInvalidZip="PackageIsInvalidZip",w.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(O||(e.ExtensionSignaturetErrorCode=O={}));class m extends Error{constructor(h,p){super(h),this.code=p,this.name=p}}e.$1o=m;var c;(function(w){w.Timeout="Timeout",w.Cancelled="Cancelled",w.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class b extends Error{constructor(h,p){super(h),this.code=p,this.name=p}}e.$2o=b,e.$3o=(0,j.$qi)("extensionManagementService"),e.$4o="extensionsIdentifiers/disabled",e.$5o="extensionsIdentifiers/enabled",e.$6o=(0,j.$qi)("IGlobalExtensionEnablementService"),e.$7o=(0,j.$qi)("IExtensionTipsService"),e.$8o=(0,D.localize2)(0,"Extensions"),e.$9o=(0,D.localize2)(1,"Preferences")}),define(se[62],re([0,1,14,9,103,13]),function(Q,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=R;async function R(g,v,d,$,y,O){let m;try{await S(g,v,d,$,y,O)}catch(c){m=c}finally{m&&y.errorTransformer&&(m=y.errorTransformer(m)),typeof m<"u"&&d.error(m),d.end()}}async function S(g,v,d,$,y,O){u(O);const m=await g.open(v,{create:!1});try{u(O);let c=0,b=0,w=y&&typeof y.length=="number"?y.length:void 0,h=D.$Ce.alloc(Math.min(y.bufferSize,typeof w=="number"?w:y.bufferSize)),p=y&&typeof y.position=="number"?y.position:0,i=0;do b=await g.read(m,p,h.buffer,i,h.byteLength-i),p+=b,i+=b,c+=b,typeof w=="number"&&(w-=b),i===h.byteLength&&(await d.write($(h)),h=D.$Ce.alloc(Math.min(y.bufferSize,typeof w=="number"?w:y.bufferSize)),i=0);while(b>0&&(typeof w!="number"||w>0)&&u(O)&&a(c,y));if(i>0){let r=i;typeof w=="number"&&(r=Math.min(i,w)),d.write($(h.slice(0,r)))}}catch(c){throw(0,A.$$k)(c)}finally{await g.close(m)}}function u(g){if(g.isCancellationRequested)throw(0,j.$6)();return!0}function a(g,v){if(typeof v?.limits?.size=="number"&&g>v.limits.size)throw(0,A.$0k)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(se[122],re([0,1,60,2,52,5,11,8]),function(Q,e,D,j,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class u extends j.$Uc{constructor(){super(),this.a=this.B(new A.$be),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$be),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$be),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new j.$4c),this.m=new Set,this.n=5007,this.r=new S.$Nh,this.B(this.f(g=>this.s(g)))}s(g){this.t(g)&&this.w(g)}t(g){return(0,k.$Dq)(g)}async watch(g){this.r.isSettled||this.r.complete(),this.r=new S.$Nh;try{this.h.clear(),this.g.clear();for(const v of g)this.t(v)?this.h.set(v.correlationId,v):this.g.add(v);for(const[v]of this.j)this.h.has(v)||(this.j.deleteAndDispose(v),this.m.delete(v));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(g=>!this.j.has(g.correlationId))])}isSuspended(g){return typeof g.correlationId!="number"?!1:this.m.has(g.correlationId)?"polling":this.j.has(g.correlationId)}async w(g){if(this.j.has(g.correlationId))return;const v=new j.$Tc;this.j.set(g.correlationId,v),await this.r.p,!v.isDisposed&&(this.z(g,v),this.u())}y(g){this.j.deleteAndDispose(g.correlationId),this.m.delete(g.correlationId),this.u()}z(g,v){this.C(g,v)?(this.M(`reusing an existing recursive watcher to monitor ${g.path}`),this.m.delete(g.correlationId)):(this.D(g,v),this.m.add(g.correlationId))}C(g,v){const d=this.L?.subscribe(g.path,($,y)=>{v.isDisposed||($?this.z(g,v):y?.type===1&&this.F(g))});return d?(v.add(d),!0):!1}D(g,v){let d=!1;const $=(y,O)=>{if(v.isDisposed)return;const m=this.G(y),c=this.G(O),b=d;d=m,!m&&(c||b)&&this.F(g)};this.M(`starting fs.watchFile() on ${g.path} (correlationId: ${g.correlationId})`);try{(0,D.watchFile)(g.path,{persistent:!1,interval:this.n},$)}catch(y){this.N(`fs.watchFile() failed with error ${y} on path ${g.path} (correlationId: ${g.correlationId})`)}v.add((0,j.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${g.path} (correlationId: ${g.correlationId})`);try{(0,D.unwatchFile)(g.path,$)}catch(y){this.N(`fs.unwatchFile() failed with error ${y} on path ${g.path} (correlationId: ${g.correlationId})`)}}))}F(g){this.M(`detected ${g.path} exists again, resuming watcher (correlationId: ${g.correlationId})`);const v={resource:R.URI.file(g.path),type:1,cId:g.correlationId};this.a.fire([v]),this.H(v,g),this.y(g)}G(g){return g.ctimeMs===0&&g.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(g,v){const d=` >> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`;this.M(typeof v.correlationId=="number"?`${d} (correlationId: ${v.correlationId})`:d)}I(g){return`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"}, correlationId: ${typeof g.correlationId=="number"?g.correlationId:"<none>"})`}}e.$Uq=u}),define(se[123],re([0,1,5,171,122,12,172,124]),function(Q,e,D,j,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class u extends k.$Uq{constructor(g){super(),this.L=g,this.onDidError=D.Event.None,this.watchers=new Set,this.O=!1}async J(g){g=this.W(g);const v=[],d=new Set(Array.from(this.watchers));for(const $ of g){const y=this.R($);y&&(0,j.$ok)(y.request.excludes,$.excludes)&&(0,j.$ok)(y.request.includes,$.includes)?d.delete(y):v.push($)}v.length&&this.M(`Request to start watching: ${v.map($=>this.I($)).join(",")}`),d.size&&this.M(`Request to stop watching: ${Array.from(d).map($=>this.I($.request)).join(",")}`);for(const $ of d)this.U($);for(const $ of v)this.S($)}R(g){for(const v of this.watchers)if(typeof g.correlationId=="number"||typeof v.request.correlationId=="number"){if(v.request.correlationId===g.correlationId)return v}else if((0,S.$pg)(v.request.path,g.path,!A.$k))return v}S(g){const v=new R.$Zq(g,this.L,$=>this.a.fire($),()=>this.c.fire(g),$=>this.b.fire($),this.O),d={request:g,instance:v};this.watchers.add(d)}async stop(){await super.stop();for(const g of this.watchers)this.U(g)}U(g){this.M("stopping file watcher",g),this.watchers.delete(g),g.instance.dispose()}W(g){const v=new Map;for(const d of g){const $=A.$k?d.path:d.path.toLowerCase();let y=v.get(d.correlationId);y||(y=new Map,v.set(d.correlationId,y)),y.has($)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I(d)}`),y.set($,d)}return Array.from(v.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(g){this.O=g;for(const v of this.watchers)v.instance.setVerboseLogging(g)}M(g,v){this.O&&this.b.fire({type:"trace",message:this.Z(g,v)})}N(g){this.b.fire({type:"warn",message:this.Z(g)})}Z(g,v){return v?`[File Watcher (node.js)] ${g} (${this.I(v.request)})`:`[File Watcher (node.js)] ${g}`}}e.$2q=u}),define(se[125],re([0,1,52,123]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class k extends D.$Gq{constructor(R,S,u){super(R,S,u),this.s()}r(R){return R.add(new j.$2q(void 0))}}e.$3q=k}),define(se[126],re([0,1,15,58,88,52]),function(Q,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class R extends A.$Hq{constructor(u,a,g){super(u,a,g),this.s()}r(u){const a=u.add(new k.$Sq(D.$Kg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:g,signal:v})=>this.t(`terminated by itself with code ${g}, signal: ${v}`))),j.ProxyChannel.toService((0,j.$0h)(a.getChannel("watcher")))}}e.$Tq=R}),define(se[63],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class D{constructor(...k){this.a=new Map;for(const[A,R]of k)this.set(A,R)}set(k,A){const R=this.a.get(k);return this.a.set(k,A),R}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$oi=D}),define(se[127],re([0,1,8,9,2,51,120,10,63,173]),function(Q,e,D,j,k,A,R,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=void 0;const g=!1;class v extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class d{constructor(m=new u.$oi,c=!1,b,w=g){this.i=m,this.j=c,this.k=b,this.l=w,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(S.$pi,this),this._globalGraph=w?b?._globalGraph??new R.$6q(h=>h):void 0}dispose(){if(!this.f){this.f=!0,(0,k.$Pc)(this.h),this.h.clear();for(const m of this.g)(0,k.$Oc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m){this.m();const c=new class extends d{dispose(){this.h.delete(c),super.dispose()}}(m,this.j,this,this.l);return this.h.add(c),c}invokeFunction(m,...c){this.m();const b=y.traceInvocation(this.l,m);let w=!1;try{return m({get:p=>{if(w)throw(0,j.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(p,b);if(!i)throw new Error(`[invokeFunction] unknown service '${p}'`);return i}},...c)}finally{w=!0,b.stop()}}createInstance(m,...c){this.m();let b,w;return m instanceof A.$ni?(b=y.traceCreation(this.l,m.ctor),w=this.o(m.ctor,m.staticArguments.concat(c),b)):(b=y.traceCreation(this.l,m),w=this.o(m,c,b)),b.stop(),w}o(m,c=[],b){const w=S._util.getServiceDependencies(m).sort((i,r)=>i.index-r.index),h=[];for(const i of w){const r=this.s(i.id,b);r||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),h.push(r)}const p=w.length>0?w[0].index:c.length;if(c.length!==p){console.trace(`[createInstance] First service dependency of ${m.name} at position ${p+1} conflicts with ${c.length} static arguments`);const i=p-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,p)}return Reflect.construct(m,c.concat(h))}q(m,c){if(this.i.get(m)instanceof A.$ni)this.i.set(m,c);else if(this.k)this.k.q(m,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const c=this.i.get(m);return!c&&this.k?this.k.r(m):c}s(m,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const b=this.r(m);return b instanceof A.$ni?this.u(m,b,c.branch(m,!0)):(c.branch(m,!1),b)}u(m,c,b){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,c,b)}finally{this.t.delete(m)}}v(m,c,b){const w=new R.$6q(i=>i.id.toString());let h=0;const p=[{id:m,desc:c,_trace:b}];for(;p.length;){const i=p.pop();if(w.lookupOrInsertNode(i),h++>1e3)throw new v(w);for(const r of S._util.getServiceDependencies(i.desc.ctor)){const t=this.r(r.id);if(t||this.y(`[createInstance] ${m} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof A.$ni){const n={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};w.insertEdge(i,n),p.push(n)}}}for(;;){const i=w.roots();if(i.length===0){if(!w.isEmpty())throw new v(w);break}for(const{data:r}of i){if(this.r(r.id)instanceof A.$ni){const n=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,n)}w.removeNode(r)}}return this.r(m)}w(m,c,b=[],w,h){if(this.i.get(m)instanceof A.$ni)return this.x(m,c,b,w,h,this.g);if(this.k)return this.k.w(m,c,b,w,h);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(m,c,b=[],w,h,p){if(w){const i=new d(void 0,this.j,this,this.l);i.c=String(m);const r=new Map,t=new D.$Jh(()=>{const n=i.o(c,b,h);for(const[s,o]of r){const l=n[s];if(typeof l=="function")for(const P of o)P.disposable=l.apply(n,P.listener)}return r.clear(),p.add(n),n});return new Proxy(Object.create(null),{get(n,s){if(!t.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let P=r.get(s);return P||(P=new a.$5c,r.set(s,P)),(z,N,U)=>{if(t.isInitialized)return t.value[s](z,N,U);{const V={listener:[z,N,U],disposable:void 0},J=P.push(V);return(0,k.$Sc)(()=>{J(),V.disposable?.dispose()})}}}if(s in n)return n[s];const o=t.value;let l=o[s];return typeof l!="function"||(l=l.bind(o),n[s]=l),l},set(n,s,o){return t.value[s]=o,!0},getPrototypeOf(n){return c.prototype}})}else{const i=this.o(c,b,h);return p.add(i),i}}y(m,c){if(c&&console.warn(m),this.j)throw new Error(m)}}e.$7q=d;var $;(function(O){O[O.None=0]="None",O[O.Creation=1]="Creation",O[O.Invocation=2]="Invocation",O[O.Branch=3]="Branch"})($||($={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,c){return m?new y(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(m,c){return m?new y(1,c.name):y.c}static{this.f=0}constructor(m,c){this.type=m,this.name=c,this.g=Date.now(),this.h=[]}branch(m,c){const b=new y(3,m.toString());return this.h.push([m,c,b]),b}stop(){const m=Date.now()-this.g;y.f+=m;let c=!1;function b(h,p){const i=[],r=new Array(h+1).join("	");for(const[t,n,s]of p.h)if(n&&s){c=!0,i.push(`${r}CREATES -> ${t}`);const o=b(h+1,s);o&&i.push(o)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(m>2||c)&&y.all.add(w.join(`
`))}}e.$8q=y});var oe=this&&this.__param||function(Q,e){return function(D,j){e(D,j,Q)}};define(se[64],re([0,1,20,2,12,105,21,10]),function(Q,e,D,j,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=void 0,e.$Ir=u;function u(g){return g.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$Jr=(0,S.$qi)("languagePackService");let a=class extends j.$Uc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new D.$me;setTimeout(()=>v.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const y=d.firstPage.filter(O=>O.properties.localizedLanguages?.length&&O.tags.some(m=>m.startsWith("lp-"))).map(O=>{const m=O.properties.localizedLanguages?.[0],c=u(O);return{...this.f(c,m,O),extensionId:O.identifier.id,galleryExtension:O}});return y.push(this.f("en","English")),y}f(v,d,$){const y=d??v;let O;if(y!==v&&(O=`(${v})`),v.toLowerCase()===k.$w.toLowerCase()&&(O??="",O+=(0,A.localize)(0,null)),$?.installCount){O??="";const m=$.installCount;let c;m>1e6?c=`${Math.floor(m/1e5)/10}M`:m>1e3?c=`${Math.floor(m/1e3)}K`:c=String(m),O+=` $(cloud-download) ${c}`}return{id:v,label:y,description:O}}};e.$Kr=a,e.$Kr=a=$e([oe(0,R.$Zo)],a)}),define(se[6],re([0,1,106,34,5,43,2,31,12,17,3,11,121,10]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$Zj=e.LogLevel=e.$Xj=e.$Wj=void 0,e.$Yj=O,e.log=c,e.$$j=l,e.$_j=P,e.$ak=I,e.$bk=z,e.$Wj=(0,$.$qi)("logService"),e.$Xj=(0,$.$qi)("loggerService");function y(){return new Date().toISOString()}function O(N){return(0,g.$8f)(N)}var m;(function(N){N[N.Off=0]="Off",N[N.Trace=1]="Trace",N[N.Debug=2]="Debug",N[N.Info=3]="Info",N[N.Warning=4]="Warning",N[N.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Zj=m.Info;function c(N,U,V){switch(U){case m.Trace:N.trace(V);break;case m.Debug:N.debug(V);break;case m.Info:N.info(V);break;case m.Warning:N.warn(V);break;case m.Error:N.error(V);break;case m.Off:break;default:throw new Error(`Invalid log level ${U}`)}}function b(N,U=!1){let V="";for(let J=0;J<N.length;J++){let _=N[J];if(_ instanceof Error&&(_=(0,j.$bj)(_,U)),typeof _=="object")try{_=JSON.stringify(_)}catch{}V+=(J>0?" ":"")+_}return V}class w extends R.$Uc{constructor(){super(...arguments),this.b=e.$Zj,this.c=this.B(new k.$be),this.onDidChangeLogLevel=this.c.event}setLevel(U){this.b!==U&&(this.b=U,this.c.fire(this.b))}getLevel(){return this.b}f(U){return this.b!==m.Off&&this.b<=U}}e.$2j=w;class h extends w{constructor(U){super(),this.h=U}f(U){return this.h||super.f(U)}trace(U,...V){this.f(m.Trace)&&this.g(m.Trace,b([U,...V],!0))}debug(U,...V){this.f(m.Debug)&&this.g(m.Debug,b([U,...V]))}info(U,...V){this.f(m.Info)&&this.g(m.Info,b([U,...V]))}warn(U,...V){this.f(m.Warning)&&this.g(m.Warning,b([U,...V]))}error(U,...V){if(this.f(m.Error))if(U instanceof Error){const J=Array.prototype.slice.call(arguments);J[0]=U.stack,this.g(m.Error,b(J))}else this.g(m.Error,b([U,...V]))}flush(){}}e.$3j=h;class p extends w{constructor(U=e.$Zj){super(),this.setLevel(U),this.g=!u.$i}trace(U,...V){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,U,...V):console.log(`[main ${y()}]`,U,...V))}debug(U,...V){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,U,...V):console.log(`[main ${y()}]`,U,...V))}info(U,...V){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,U,...V):console.log(`[main ${y()}]`,U,...V))}warn(U,...V){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,U,...V):console.warn(`[main ${y()}]`,U,...V))}error(U,...V){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,U,...V):console.error(`[main ${y()}]`,U,...V))}flush(){}}e.$4j=p;class i extends w{constructor(U=e.$Zj,V=!0){super(),this.g=V,this.setLevel(U)}trace(U,...V){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",U,...V):console.log(U,...V))}debug(U,...V){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",U,...V):console.log(U,...V))}info(U,...V){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",U,...V):console.log(U,...V))}warn(U,...V){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",U,...V):console.log(U,...V))}error(U,...V){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",U,...V):console.error(U,...V))}flush(){}}e.$5j=i;class r extends w{constructor(U,V=e.$Zj){super(),this.g=U,this.setLevel(V)}trace(U,...V){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(U),...V])}debug(U,...V){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(U),...V])}info(U,...V){this.f(m.Info)&&this.g.log(m.Info,[this.h(U),...V])}warn(U,...V){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(U),...V])}error(U,...V){this.f(m.Error)&&this.g.log(m.Error,[this.h(U),...V])}h(U){return typeof U=="string"?U:(0,j.$bj)(U,this.f(m.Trace))}flush(){}}e.$6j=r;class t extends w{constructor(U){super(),this.g=U,U.length&&this.setLevel(U[0].getLevel())}setLevel(U){for(const V of this.g)V.setLevel(U);super.setLevel(U)}trace(U,...V){for(const J of this.g)J.trace(U,...V)}debug(U,...V){for(const J of this.g)J.debug(U,...V)}info(U,...V){for(const J of this.g)J.info(U,...V)}warn(U,...V){for(const J of this.g)J.warn(U,...V)}error(U,...V){for(const J of this.g)J.error(U,...V)}flush(){for(const U of this.g)U.flush()}dispose(){for(const U of this.g)U.dispose();super.dispose()}}e.$7j=t;class n extends R.$Uc{constructor(U,V,J){if(super(),this.h=U,this.j=V,this.b=new S.$Bc,this.c=this.B(new k.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$be),this.onDidChangeVisibility=this.g.event,J)for(const _ of J)this.b.set(_.resource,{logger:void 0,info:_})}m(U){return(0,g.$4f)(U)?[...this.b.values()].find(V=>V.info.id===U):this.b.get(U)}getLogger(U){return this.m(U)?.logger}createLogger(U,V){const J=this.n(U),_=(0,g.$4f)(U)?U:V?.id??(0,A.$ej)(J.toString()).toString(16);let K=this.b.get(J)?.logger;const le=V?.logLevel==="always"?m.Trace:V?.logLevel;K||(K=this.s(J,le??this.getLogLevel(J)??this.h,{...V,id:_}));const ue={logger:K,info:{resource:J,id:_,logLevel:le,name:V?.name,hidden:V?.hidden,extensionId:V?.extensionId,when:V?.when}};return this.registerLogger(ue.info),this.b.set(J,ue),K}n(U){return(0,g.$4f)(U)?(0,a.$4g)(this.j,`${U}.log`):U}setLogLevel(U,V){if(v.URI.isUri(U)){const J=U,_=V,K=this.b.get(J);K&&_!==K.info.logLevel&&(K.info.logLevel=_===this.h?void 0:_,K.logger?.setLevel(_),this.b.set(K.info.resource,K),this.f.fire([J,_]))}else{this.h=U;for(const[J,_]of this.b.entries())this.b.get(J)?.info.logLevel===void 0&&_.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(U,V){const J=this.m(U);J&&V!==!J.info.hidden&&(J.info.hidden=!V,this.b.set(J.info.resource,J),this.g.fire([J.info.resource,V]))}getLogLevel(U){let V;return U&&(V=this.b.get(U)?.info.logLevel),V??this.h}registerLogger(U){const V=this.b.get(U.resource);V?V.info.hidden!==U.hidden&&this.setVisibility(U.resource,!U.hidden):(this.b.set(U.resource,{info:U,logger:void 0}),this.c.fire({added:[U],removed:[]}))}deregisterLogger(U){const V=this.b.get(U);V&&(V.logger&&V.logger.dispose(),this.b.delete(U),this.c.fire({added:[],removed:[V.info]}))}*getRegisteredLoggers(){for(const U of this.b.values())yield U.info}getRegisteredLogger(U){return this.b.get(U)?.info}dispose(){this.b.forEach(U=>U.logger?.dispose()),this.b.clear(),super.dispose()}}e.$8j=n;class s{constructor(){this.onDidChangeLogLevel=new k.$be().event}setLevel(U){}getLevel(){return m.Info}trace(U,...V){}debug(U,...V){}info(U,...V){}warn(U,...V){}error(U,...V){}critical(U,...V){}dispose(){}flush(){}}e.$9j=s;class o extends s{}e.$0j=o;function l(N){if(N.verbose)return m.Trace;if(typeof N.logLevel=="string"){const U=z(N.logLevel.toLowerCase());if(U!==void 0)return U}return e.$Zj}function P(N){switch(N){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function I(N){switch(N){case m.Trace:return{original:"Trace",value:D.localize(0,null)};case m.Debug:return{original:"Debug",value:D.localize(1,null)};case m.Info:return{original:"Info",value:D.localize(2,null)};case m.Warning:return{original:"Warning",value:D.localize(3,null)};case m.Error:return{original:"Error",value:D.localize(4,null)};case m.Off:return{original:"Off",value:D.localize(5,null)}}}function z(N){switch(N){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$ck=new d.$Hj("logLevel",P(m.Info))}),define(se[128],re([0,1,19,8,9,5,2,16,52,6]),function(Q,e,D,j,k,A,R,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class g extends R.$Uc{constructor(d,$){super(),this.a=d,this.b=$,this.c=this.B(new A.$be),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$be),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new j.$oh(0)),this.w=[],this.y=this.B(new j.$oh(0))}watch(d,$){return $.recursive||this.b?.watcher?.forceUniversal?this.n(d,$):this.z(d,$)}n(d,$){const y={path:this.I(d),excludes:$.excludes,includes:$.includes,recursive:$.recursive,correlationId:$.correlationId},O=(0,D.$Ub)(this.j,y);return this.r(),(0,R.$Sc)(()=>{O(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,k.$1)(d))}s(){this.h||(this.h=this.B(this.t($=>this.c.fire((0,u.$Iq)($)),$=>this.G($),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const $ of this.j)(0,u.$Eq)($)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const $ of this.j)(0,u.$Eq)($)&&d.includes($.path)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,$){const y={path:this.I(d),excludes:$.excludes,includes:$.includes,recursive:!1,correlationId:$.correlationId},O=(0,D.$Ub)(this.w,y);return this.C(),(0,R.$Sc)(()=>{O(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,k.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,u.$Iq)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.H(d)}H(d){this.a[d.type](d.message)}I(d){return(0,S.$ic)(d.fsPath)}}e.$Mq=g}),define(se[129],re([0,1,19,8,14,20,5,43,65,2,48,15,130,17,46,102,13,62,6,9]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$,y,O,m,c,b,w){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;let p=class extends a.$Uc{static{h=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new R.$be),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new R.$be),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new R.$be),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new R.$be),this.onDidRunOperation=this.r.event,this.X=this.B(new R.$be),this.Y=this.B(new R.$be),this.onDidFilesChange=this.Y.event,this.Z=this.B(new R.$be),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new j.$zh)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${r}`);const n=new a.$Tc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),n.add(t.onDidChangeFile(s=>{const o=new m.$dl(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Pc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(n){t.push(n)}}),!this.h.has(r)&&await j.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,$.$8g)(r))throw new m.$fl((0,O.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const n=new w.$bb;throw n.message=(0,O.localize)(1,null,r.toString()),n}return t}async m(r){const t=await this.j(r);if((0,m.$3k)(t)||(0,m.$Zk)(t)||(0,m.$4k)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,m.$3k)(t)||(0,m.$Zk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(n){throw(0,m.$al)(n)===m.FileSystemProviderErrorCode.FileNotFound?new m.$fl((0,O.localize)(2,null,this.sb(r)),1):(0,m.$$k)(n)}}async s(r,t){const n=await this.j(r),s=this.S(n),o=t?.resolveTo,l=t?.resolveSingleChildDescendants,P=t?.resolveMetadata,I=await n.stat(r);let z;return this.t(n,r,I,void 0,!!P,(N,U)=>(z||(z=g.$wi.forUris(()=>!s),z.set(r,!0),o&&z.fill(!0,o)),z.get(N.resource)||z.findSuperstr(N.resource.with({query:null,fragment:null}))?!0:N.isDirectory&&l?U===1:!1))}async t(r,t,n,s,o,l){const{providerExtUri:P}=this.R(r),I={resource:t,name:P.basename(t),isFile:(n.type&m.FileType.File)!==0,isDirectory:(n.type&m.FileType.Directory)!==0,isSymbolicLink:(n.type&m.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&m.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&m.FilePermission.Locked),etag:(0,m.$ql)({mtime:n.mtime,size:n.size}),children:void 0};if(I.isDirectory&&l(I,s)){try{const z=await r.readdir(t),N=await j.Promises.settled(z.map(async([U,V])=>{try{const J=P.joinPath(t,U),_=o?await r.stat(J):{type:V};return await this.t(r,J,_,z.length,o,l)}catch(J){return this.b.trace(J),null}}));I.children=(0,D.$Hb)(N)}catch(z){this.b.trace(z),I.children=[]}return I}return I}async resolveAll(r){return j.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),n=await t.stat(r);return this.t(t,r,n,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(n){return n}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new m.$fl((0,O.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=k.$Ce.fromString(""),n){await this.u(r,n);const s=await this.writeFile(r,t);return this.r.fire(new m.$cl(r,0,s)),s}async writeFile(r,t,n){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let l=n;if((0,m.$6k)(s)&&!l?.atomic){const P=s.enforceAtomicWriteFile?.(r);P&&(l={...n,atomic:P})}try{await this.w(s,r,l)||await this.U(s,o.dirname(r));let I;if((0,m.$Zk)(s)&&!(t instanceof k.$Ce))if((0,y.$oe)(t)){const z=await(0,y.$ve)(t,3);z.ended?I=k.$Ce.concat(z.buffer):I=z}else I=(0,y.$se)(t,z=>k.$Ce.concat(z),3);else I=t;!(0,m.$3k)(s)||(0,m.$Zk)(s)&&I instanceof k.$Ce||(0,m.$Zk)(s)&&(0,m.$6k)(s)&&l?.atomic?await this.hb(s,r,l,I):await this.db(s,r,l,I instanceof k.$Ce?(0,k.$Ne)(I):I),this.r.fire(new m.$cl(r,4))}catch(P){throw new m.$fl((0,O.localize)(4,null,this.sb(r),(0,m.$$k)(P).toString()),(0,m.$bl)(P),l)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,n){const s=!!n?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,O.localize)(5,null,this.sb(t)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,O.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,O.localize)(7,null,this.sb(t)));if(s)throw new Error((0,O.localize)(8,null,this.sb(t)))}let l;try{l=await r.stat(t)}catch{return}if(l.type&m.FileType.Directory)throw new m.$fl((0,O.localize)(9,null,this.sb(t)),0,n);if(this.rb(t,l),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==m.$pl&&typeof l.mtime=="number"&&typeof l.size=="number"&&n.mtime<l.mtime&&n.etag!==(0,m.$ql)({mtime:n.mtime,size:l.size}))throw new m.$fl((0,O.localize)(10,null),3,n);return l}async readFile(r,t,n){const s=await this.m(r);return t?.atomic?this.z(s,r,t,n):this.C(s,r,t,n)}async z(r,t,n,s){return new Promise((o,l)=>{this.cb.queueFor(t,async()=>{try{const P=await this.C(r,t,n,s);o(P)}catch(P){l(P)}},this.R(r).providerExtUri)})}async C(r,t,n,s){const o=await this.D(r,t,{...n,preferUnbuffered:!0},s);return{...o,value:await(0,k.$Oe)(o.value)}}async readFileStream(r,t,n){const s=await this.m(r);return this.D(s,r,t,n)}async D(r,t,n,s){const o=new A.$me(s);let l=n;(0,m.$5k)(r)&&r.enforceAtomicReadFile?.(t)&&(l={...n,atomic:!0});const P=this.J(t,l).then(z=>z,z=>{throw o.dispose(!0),z});let I;try{return typeof l?.etag=="string"&&l.etag!==m.$pl&&await P,l?.atomic&&(0,m.$5k)(r)||!((0,m.$3k)(r)||(0,m.$4k)(r))||(0,m.$Zk)(r)&&l?.preferUnbuffered?I=this.I(r,t,l):(0,m.$4k)(r)?I=this.G(r,t,o.token,l):I=this.H(r,t,o.token,l),I.on("end",()=>o.dispose()),I.on("error",()=>o.dispose()),{...await P,value:I}}catch(z){throw I&&await(0,y.$te)(I),this.F(z,t,l)}}F(r,t,n){const s=(0,O.localize)(11,null,this.sb(t),(0,m.$$k)(r).toString());return r instanceof m.$hl?new m.$hl(s,r.stat,n):r instanceof m.$gl?new m.$gl(s,r.fileOperationResult,r.size,r.options):new m.$fl(s,(0,m.$bl)(r),n)}G(r,t,n,s=Object.create(null)){const o=r.readFileStream(t,s,n);return(0,y.$ze)(o,{data:l=>l instanceof k.$Ce?l:k.$Ce.wrap(l),error:l=>this.F(l,t,s)},l=>k.$Ce.concat(l))}H(r,t,n,s=Object.create(null)){const o=(0,k.$Se)();return(0,c.$Bq)(r,t,o,l=>l,{...s,bufferSize:this.a,errorTransformer:l=>this.F(l,t,s)},n),o}I(r,t,n){const s=(0,y.$qe)(o=>k.$Ce.concat(o));return(async()=>{try{let o;n?.atomic&&(0,m.$5k)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.L(t,o.byteLength,n),s.end(k.$Ce.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new m.$fl((0,O.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==m.$pl&&t.etag===n.etag)throw new m.$hl((0,O.localize)(13,null),n,t);return this.L(r,n.size,t),n}L(r,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new m.$gl((0,O.localize)(14,null,this.sb(r)),7,t,n)}async canMove(r,t,n){return this.M(r,t,"move",n)}async canCopy(r,t,n){return this.M(r,t,"copy",n)}async M(r,t,n,s){if(r.toString()!==t.toString())try{const o=n==="move"?this.qb(await this.n(r),r):await this.m(r),l=this.qb(await this.n(t),t);await this.Q(o,r,l,t,n,s)}catch(o){return o}return!0}async move(r,t,n){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"move",!!n),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$cl(r,l==="move"?2:3,P)),P}async copy(r,t,n){const s=await this.m(r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"copy",!!n),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$cl(r,l==="copy"?3:2,P)),P}async N(r,t,n,s,o,l){if(t.toString()===s.toString())return o;const{exists:P,isSameResourceWithDifferentPathCase:I}=await this.Q(r,t,n,s,o,l);if(P&&!I&&l&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),o==="copy"){if(r===n&&(0,m.$1k)(r))await r.copy(t,s,{overwrite:l});else{const z=await this.resolve(t);z.isDirectory?await this.P(r,z,n,s):await this.O(r,t,n,s)}return o}else return r===n?(await r.rename(t,s,{overwrite:l}),o):(await this.N(r,t,n,s,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(r,t,n,s){if((0,m.$3k)(r)&&(0,m.$3k)(n))return this.jb(r,t,n,s);if((0,m.$3k)(r)&&(0,m.$Zk)(n))return this.pb(r,t,n,s);if((0,m.$Zk)(r)&&(0,m.$3k)(n))return this.nb(r,t,n,s);if((0,m.$Zk)(r)&&(0,m.$Zk)(n))return this.lb(r,t,n,s)}async P(r,t,n,s){await n.mkdir(s),Array.isArray(t.children)&&await j.Promises.settled(t.children.map(async o=>{const l=this.R(n).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),n,l):this.O(r,o.resource,n,l)}))}async Q(r,t,n,s,o,l){let P=!1;if(r===n){const{providerExtUri:z,isPathCaseSensitive:N}=this.R(r);if(N||(P=z.isEqual(t,s)),P&&o==="copy")throw new Error((0,O.localize)(15,null,this.sb(t),this.sb(s)));if(!P&&z.isEqualOrParent(s,t))throw new Error((0,O.localize)(16,null,this.sb(t),this.sb(s)))}const I=await this.exists(s);if(I&&!P){if(!l)throw new m.$fl((0,O.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===n){const{providerExtUri:z}=this.R(r);if(z.isEqualOrParent(t,s))throw new Error((0,O.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:P}}R(r){const t=this.S(r);return{providerExtUri:t?$.$Tg:$.$Vg,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new m.$cl(r,0,n)),n}async U(r,t){const n=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&m.FileType.Directory))throw new Error((0,O.localize)(19,null,this.sb(t)));break}catch(o){if((0,m.$al)(o)!==m.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(t)),t=s.dirname(t)}for(let o=n.length-1;o>=0;o--){t=s.joinPath(t,n[o]);try{await r.mkdir(t)}catch(l){if((0,m.$al)(l)!==m.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(r,t){try{await this.W(r,t)}catch(n){return n}return!0}async W(r,t){const n=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,O.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,O.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,O.localize)(22,null,this.sb(r)));let l;try{l=await n.stat(r)}catch{}if(l)this.rb(r,l);else throw new m.$fl((0,O.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const I=await this.resolve(r);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,O.localize)(24,null,this.sb(r)))}return n}async del(r,t){const n=await this.W(r,t);let s=t;if((0,m.$7k)(n)&&!s?.atomic){const I=n.enforceAtomicDelete?.(r);I&&(s={...t,atomic:I})}const o=!!s?.useTrash,l=!!s?.recursive,P=s?.atomic??!1;await n.delete(r,{recursive:l,useTrash:o,atomic:P}),this.r.fire(new m.$cl(r,1))}async cloneFile(r,t){const n=await this.j(r),s=this.qb(await this.n(t),t);if(!(n===s&&this.R(n).providerExtUri.isEqual(r,t)))return n===s&&(0,m.$2k)(n)?n.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),n===s&&(0,m.$1k)(n)?this.cb.queueFor(r,()=>n.copy(r,t,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,s,t),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:h.ab++})}watch(r,t={recursive:!1,excludes:[]}){const n=new a.$Tc;let s=!1,o=()=>{s=!0};n.add((0,a.$Sc)(()=>o())),(async()=>{try{const P=await this.bb(r,t);s?(0,a.$Pc)(P):o=()=>(0,a.$Pc)(P)}catch(P){this.b.error(P)}})();const l=t.correlationId;if(typeof l=="number"){const P=n.add(new R.$be);return n.add(this.X.event(z=>{z.correlates(l)&&P.fire(z)})),{onDidChange:P.event,dispose:()=>n.dispose()}}return n}async bb(r,t){const n=await this.j(r),s=(0,S.$ej)([this.R(n).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:n.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Pc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Pc)(r.disposable);this.$.clear()}async db(r,t,n,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,y.$oe)(s)||(0,y.$pe)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(l){throw(0,m.$$k)(l)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,n){let s=0,o;if((0,y.$pe)(n)){if(n.buffer.length>0){const l=k.$Ce.concat(n.buffer);await this.gb(r,t,l,l.byteLength,s,0),s+=l.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((l,P)=>{(0,y.$ue)(o,{onData:async I=>{o.pause();try{await this.gb(r,t,I,I.byteLength,s,0)}catch(z){return P(z)}s+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>P(I),onEnd:()=>l()})})}async fb(r,t,n){let s=0,o;for(;(o=n.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,n,s,o,l){let P=0;for(;P<s;){const I=await r.write(t,o+P,n.buffer,l+P,s-P);P+=I}}async hb(r,t,n,s){return this.cb.queueFor(t,()=>this.ib(r,t,n,s),this.R(r).providerExtUri)}async ib(r,t,n,s){let o;s instanceof k.$Ce?o=s:(0,y.$oe)(s)?o=await(0,k.$Oe)(s):(0,y.$pe)(s)?o=await(0,k.$Pe)(s):o=(0,k.$Me)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,t,n,s){return this.cb.queueFor(s,()=>this.kb(r,t,n,s),this.R(n).providerExtUri)}async kb(r,t,n,s){let o,l;try{o=await r.open(t,{create:!1}),l=await n.open(s,{create:!0,unlock:!1});const P=k.$Ce.alloc(this.a);let I=0,z=0,N=0;do N=await r.read(o,I,P.buffer,z,P.byteLength-z),await this.gb(n,l,P,N,I,z),I+=N,z+=N,z===P.byteLength&&(z=0);while(N>0)}catch(P){throw(0,m.$$k)(P)}finally{await j.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof l=="number"?n.close(l):Promise.resolve()])}}async lb(r,t,n,s){return this.cb.queueFor(s,()=>this.mb(r,t,n,s),this.R(n).providerExtUri)}async mb(r,t,n,s){return n.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,n,s){return this.cb.queueFor(s,()=>this.ob(r,t,n,s),this.R(n).providerExtUri)}async ob(r,t,n,s){const o=await n.open(s,{create:!0,unlock:!1});try{const l=await r.readFile(t);await this.gb(n,o,k.$Ce.wrap(l),l.byteLength,0,0)}catch(l){throw(0,m.$$k)(l)}finally{await n.close(o)}}async pb(r,t,n,s){const o=await(0,k.$Oe)(this.H(r,t,A.CancellationToken.None));await this.hb(n,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new m.$fl((0,O.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&m.FilePermission.Readonly)throw new m.$fl((0,O.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===v.Schemas.file?r.fsPath:r.toString(!0)}};e.$Cq=p,e.$Cq=p=h=$e([oe(0,b.$Wj)],p)}),define(se[131],re([0,1,60,174,8,31,14,5,124,2,16,12,17,46,25,104,13,62,128,34,126,125]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$,y,O,m,c,b,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0,(()=>{try{(0,j.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,w.$bj)(r)}`)}})();class i extends b.$Mq{static{this.J=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=S.Event.None,this.O=new A.$Bc(s=>d.$Ug.getComparisonKey(s)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,v.$k&&(this.L|=1024)),this.L}async stat(t){try{const{stat:n,symbolicLink:s}=await y.SymlinkSupport.stat(this.I(t));return{type:this.N(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:m.FilePermission.Locked}}catch(n){throw this.gb(n)}}async M(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await y.Promises.readdir(this.I(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,d.$4g)(t,o.name))).type:l=this.N(o),s.push([o.name,l])}catch(l){this.a.trace(l)}})),s}catch(n){throw this.gb(n)}}N(t,n){let s;return n?.dangling?s=m.FileType.Unknown:t.isFile()?s=m.FileType.File:t.isDirectory()?s=m.FileType.Directory:s=m.FileType.Unknown,n&&(s|=m.FileType.SymbolicLink),s}async P(t){const n=this.I(t);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.O.get(t);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const o=new k.$ph;return this.O.set(t,o),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.O.get(t)===o&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.O.delete(t)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),s=await this.P(t));const o=this.I(t);return await y.Promises.readFile(o)}catch(o){throw this.gb(o)}finally{s?.dispose()}}Q(t){i.J&&this.a.trace(t)}readFileStream(t,n,s){const o=(0,$.$qe)(l=>R.$Ce.concat(l.map(P=>R.$Ce.wrap(P))).buffer);return(0,c.$Bq)(this,t,o,l=>l.buffer,{...n,bufferSize:256*1024},s),o}async writeFile(t,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.R(t)?this.S(t,(0,d.$4g)((0,d.$3g)(t),`${(0,d.$1g)(t)}${s.atomic.postfix}`),n,s):this.U(t,n,s)}async R(t){try{const n=this.I(t),{symbolicLink:s}=await y.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async S(t,n,s,o){const l=new a.$Tc;try{l.add(await this.P(t)),l.add(await this.P(n)),await this.U(n,s,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(P){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{l.dispose()}}async U(t,n,s,o){let l;try{const P=this.I(t);if(!s.create||!s.overwrite){if(await y.Promises.exists(P)){if(!s.overwrite)throw(0,m.$0k)((0,O.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,m.$0k)((0,O.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(l,0,n,0,n.byteLength)}catch(P){throw await this.hb(t,P)}finally{typeof l=="number"&&await this.close(l)}}static{this.Z=!0}static configureFlushOnWrite(t){i.Z=t}async open(t,n,s){const o=this.I(t);let l;(0,m.$Xk)(n)&&!s&&(l=await this.P(t));let P;try{if((0,m.$Xk)(n)&&n.unlock)try{const{stat:z}=await y.SymlinkSupport.stat(o);z.mode&128||await y.Promises.chmod(o,z.mode|128)}catch(z){z.code!=="ENOENT"&&this.a.trace(z)}let I;if((0,m.$Xk)(n)){if(v.$i)try{await y.Promises.truncate(o,0),I="r+"}catch(z){z.code!=="ENOENT"&&this.a.trace(z)}I||(I="w")}else I="r";P=await y.Promises.open(o,I)}catch(I){throw l?.dispose(),(0,m.$Xk)(n)?await this.hb(t,I):this.gb(I)}if(this.W.set(P,0),(0,m.$Xk)(n)&&this.Y.set(P,t),l){const I=this.X.get(P);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${o})`),this.X.set(P,l),I&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${o})`),I.dispose())}return P}async close(t){const n=this.X.get(t);try{if(this.W.delete(t),this.Y.delete(t)&&i.Z)try{await y.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await y.Promises.close(t)}catch(s){throw this.gb(s)}finally{n&&(this.X.get(t)===n&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.X.delete(t)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,o,l){const P=this.$(t,n);let I=null;try{I=(await y.Promises.read(t,s,o,l,P)).bytesRead}catch(z){throw this.gb(z)}finally{this.ab(t,P,I)}return I}$(t,n){return n===this.W.get(t)?null:n}ab(t,n,s){const o=this.W.get(t);typeof o=="number"&&(typeof n=="number"||(typeof s=="number"?this.W.set(t,o+s):this.W.delete(t)))}async write(t,n,s,o,l){return(0,k.$Kh)(()=>this.bb(t,n,s,o,l),100,3)}async bb(t,n,s,o,l){const P=this.$(t,n);let I=null;try{I=(await y.Promises.write(t,s,o,l,P)).bytesWritten}catch(z){throw await this.hb(this.Y.get(t),z)}finally{this.ab(t,P,I)}return I}async mkdir(t){try{await y.Promises.mkdir(this.I(t))}catch(n){throw this.gb(n)}}async delete(t,n){try{const s=this.I(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,g.$kc)((0,g.$nc)(s),`${(0,g.$oc)(s)}${n.atomic.postfix}`)),await y.Promises.rm(s,y.RimRafMode.MOVE,o)}else try{await y.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:P,symbolicLink:I}=await y.SymlinkSupport.stat(s);l=P.isDirectory()&&!I}catch{}if(l)await y.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.gb(s)}}async rename(t,n,s){const o=this.I(t),l=this.I(n);if(o!==l)try{await this.cb(t,n,"move",s.overwrite),await y.Promises.rename(o,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,O.localize)(2,null,(0,g.$oc)(o),(0,g.$oc)((0,g.$nc)(l)),P.toString()))),this.gb(P)}}async copy(t,n,s){const o=this.I(t),l=this.I(n);if(o!==l)try{await this.cb(t,n,"copy",s.overwrite),await y.Promises.copy(o,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,O.localize)(3,null,(0,g.$oc)(o),(0,g.$oc)((0,g.$nc)(l)),P.toString()))),this.gb(P)}}async cb(t,n,s,o){const l=this.I(t),P=this.I(n);let I=!1;if(!!(this.capabilities&1024)||(I=(0,u.$pg)(l,P,!0)),I){if(s==="copy")throw(0,m.$0k)((0,O.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const N=await this.M(t);if(!N)throw(0,m.$0k)((0,O.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const U=await this.M(n);if(U){if(!o)throw(0,m.$0k)((0,O.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);N.type&m.FileType.File&&U.type&m.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.db(t,n,!1)}async db(t,n,s){const o=this.I(t),l=this.I(n),P=!!(this.capabilities&1024);if((0,u.$pg)(o,l,!P))return;const I=new a.$Tc;try{I.add(await this.P(t)),I.add(await this.P(n)),s&&await y.Promises.mkdir((0,g.$nc)(l),{recursive:!0}),await y.Promises.copyFile(o,l)}catch(z){if(z.code==="ENOENT"&&!s)return this.db(t,n,!0);throw this.gb(z)}finally{I.dispose()}}t(t,n,s){return new h.$Tq(o=>t(o),o=>n(o),s)}F(t,n,s){return new p.$3q(o=>t(o),o=>n(o),s)}gb(t){if(t instanceof m.$9k)return t;let n=t,s;switch(t.code){case"ENOENT":s=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=m.FileSystemProviderErrorCode.Unknown;break;default:s=m.FileSystemProviderErrorCode.Unknown}return(0,m.$0k)(n,s)}async hb(t,n){let s=this.gb(n);if(t&&s.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.I(t));o.mode&128||(s=(0,m.$0k)(n,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$4q=i}),define(se[132],re([0,1,2,6]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yQ=void 0;class k extends D.$Uc{constructor(R,S=[]){super(),this.a=new j.$7j([R,...S]),this.B(R.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...S){this.a.trace(R,...S)}debug(R,...S){this.a.debug(R,...S)}info(R,...S){this.a.info(R,...S)}warn(R,...S){this.a.warn(R,...S)}error(R,...S){this.a.error(R,...S)}flush(){this.a.flush()}}e.$yQ=k}),define(se[133],re([0,1,13,6]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=void 0;var k;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(k||(k={}));async function A(a,g,v,d,$){try{const y=await new Promise((m,c)=>{Q(["@vscode/spdlog"],m,c)});y.setFlushOn(k.Trace);const O=await y.createAsyncRotatingLogger(a,g,v,d);return $?O.clearFormatters():O.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),O}catch(y){console.error(y)}return null}function R(a,g,v){switch(g){case j.LogLevel.Trace:a.trace(v);break;case j.LogLevel.Debug:a.debug(v);break;case j.LogLevel.Info:a.info(v);break;case j.LogLevel.Warning:a.warn(v);break;case j.LogLevel.Error:a.error(v);break;case j.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function S(a,g){switch(g){case j.LogLevel.Trace:a.setLevel(k.Trace);break;case j.LogLevel.Debug:a.setLevel(k.Debug);break;case j.LogLevel.Info:a.setLevel(k.Info);break;case j.LogLevel.Warning:a.setLevel(k.Warning);break;case j.LogLevel.Error:a.setLevel(k.Error);break;case j.LogLevel.Off:a.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class u extends j.$3j{constructor(g,v,d,$,y){super(),this.m=[],this.setLevel(y),this.n=this.s(g,v,d,$),this.B(this.onDidChangeLogLevel(O=>{this.r&&S(this.r,O)}))}async s(g,v,d,$){const y=d?6:1,O=30/y*D.$sl.MB,m=await A(g,v,O,y,$);if(m){this.r=m,S(this.r,this.getLevel());for(const{level:c,message:b}of this.m)R(this.r,c,b);this.m=[]}}g(g,v){this.r?R(this.r,g,v):this.getLevel()<=g&&this.m.push({level:g,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$nQ=u}),define(se[134],re([0,1,28,6,133]),function(Q,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=void 0;class A extends j.$8j{s(S,u,a){return new k.$nQ((0,D.$Mg)(),S.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.$oQ=A}),define(se[39],re([0,1,5,65,2,10]),function(Q,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ao=e.$_n=e.$$n=void 0,e.$$n=(0,A.$qi)("policy");class R extends k.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$be),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const g=Object.keys(this.f).length;return this.f={...a,...this.f},g!==Object.keys(this.f).length&&await this.j(a),j.Iterable.reduce(this.g.entries(),(v,[d,$])=>({...v,[d]:$}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return j.Iterable.reduce(Object.entries(this.f),(a,[g,v])=>({...a,[g]:{definition:v,value:this.g.get(g)}}),{})}}e.$_n=R;class S{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$ao=S}),define(se[135],re([0,1,8,5,65,3,13,6,39]),function(Q,e,D,j,k,A,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;function a(v,d){const $=[];for(const y of new Set(k.Iterable.concat(v.keys(),d.keys())))v.get(y)!==d.get(y)&&$.push(y);return $}let g=class extends u.$_n{constructor(d,$,y){super(),this.m=d,this.n=$,this.s=y,this.c=this.B(new D.$oh(500));const O=j.Event.filter($.onDidFilesChange,m=>m.affects(d));this.B($.watch(d)),this.B(O(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const $=await this.n.readFile(this.m),y=JSON.parse($.value.toString());if(!(0,A.$6f)(y))throw new Error("Policy file isn't a JSON object");for(const O of Object.keys(y))this.f[O]&&d.set(O,y[O])}catch($){$.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",$)}return d}async w(){const d=await this.u(),$=a(this.g,d);this.g=d,$.length>0&&this.h.fire($)}};e.$Acc=g,e.$Acc=g=$e([oe(1,R.$Wk),oe(2,S.$Wj)],g)}),define(se[136],re([0,1,39,8,2,6]),function(Q,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;let R=class extends D.$_n{constructor(u,a){super(),this.m=u,this.n=a,this.a=new j.$kh,this.b=this.B(new k.$Vc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:a}=await new Promise((g,v)=>{Q(["@vscode/policy-watcher"],g,v)});await this.a.queue(()=>new Promise((g,v)=>{try{this.b.value=a(this.n,u,d=>{this.t(d),g()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),v(d)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const a in u){const g=u[a];g===void 0?this.g.delete(a):this.g.set(a,g)}this.h.fire(Object.keys(u))}};e.$zcc=R,e.$zcc=R=$e([oe(0,A.$Wj)],R)}),define(se[32],re([0,1,10]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$dk=(0,D.$qi)("productService"),e.$ek="vscode://schemas/vscode-product"}),define(se[36],re([0,1,72,3]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=void 0;class k{constructor(){this.a=new Map}add(R,S){D.ok(j.$4f(R)),D.ok(j.$6f(S)),D.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,S)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$9n=new k}),define(se[137],re([0,1,5,36]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0,e.$0n={JSONContribution:"base.contributions.json"};function k(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class A{constructor(){this.b=new D.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,a){this.a[k(u)]=a,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const R=new A;j.$9n.add(e.$0n.JSONContribution,R)}),define(se[40],re([0,1,19,5,3,91,29,137,36]),function(Q,e,D,j,k,A,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ConfigurationScope=e.$bo=e.EditPresentationTypes=void 0,e.$mo=O,e.$no=m,e.$oo=c,e.$po=w,e.$qo=h;var a;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$bo={Configuration:"base.contributions.configuration"};var g;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io="vscode://schemas/settings/resourceLanguage",e.$jo="vscode://schemas/settings/configurationDefaults";const v=u.$9n.as(S.$0n.JSONContribution);class d{constructor(){this.h=new Set,this.i=new j.$be,this.onDidSchemaChange=this.i.event,this.j=new j.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$io,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),v.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),v.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),v.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:n,source:s}of i)for(const o in n)if(r.add(o),e.$lo.test(o)){const l=this.a.get(o),P=l?.valuesSources??new Map;if(s)for(const U of Object.keys(n[o]))P.set(U,s);const I={...l?.value||{},...n[o]};this.a.set(o,{source:s,value:I,valuesSources:P});const z=(0,R.$7i)(o),N={type:"object",default:I,description:A.localize(1,null,z),$ref:e.$io,defaultDefaultValue:I,source:k.$4f(s)?void 0:s,defaultValueSource:s};t.push(...O(o)),this.d[o]=N,this.b.properties[o]=N}else{this.a.set(o,{value:n[o],source:s});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:n}of i)for(const s in t){const o=this.a.get(s),l=k.$4f(n)?n:n?.id,P=k.$4f(o?.source)?o?.source:o?.source?.id;if(l===P)if(r.add(s),this.a.delete(s),e.$lo.test(s))delete this.d[s],delete this.b.properties[s];else{const I=this.d[s];I&&(this.w(s,I),this.r(s,I))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,r){const t=n=>{if(n.properties)for(const s in n.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,r=!0,t,n,s=3,o){s=k.$ag(i.scope)?s:i.scope;const l=i.properties;if(l)for(const I in l){const z=l[I];if(r&&w(I,z)){delete l[I];continue}if(z.source=t,z.defaultDefaultValue=l[I].default,this.w(I,z),e.$lo.test(I)?z.scope=void 0:(z.scope=k.$ag(z.scope)?s:z.scope,z.restricted=k.$ag(z.restricted)?!!n?.includes(I):z.restricted),l[I].hasOwnProperty("included")&&!l[I].included){this.f[I]=l[I],delete l[I];continue}else this.d[I]=l[I],l[I].policy?.name&&this.e.set(l[I].policy.name,I);!l[I].deprecationMessage&&l[I].markdownDeprecationMessage&&(l[I].deprecationMessage=l[I].markdownDeprecationMessage),o.add(I)}const P=i.allOf;if(P)for(const I of P)this.p(I,r,t,n,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const n=t.properties;if(n)for(const o in n)this.r(o,n[o]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$co.properties[i]=r,r.scope){case 1:e.$do.properties[i]=r;break;case 2:e.$eo.properties[i]=r;break;case 6:e.$fo.properties[i]=r;break;case 3:e.$go.properties[i]=r;break;case 4:e.$ho.properties[i]=r;break;case 5:e.$ho.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$co.properties[i],r.scope){case 1:delete e.$do.properties[i];break;case 2:delete e.$eo.properties[i];break;case 6:delete e.$fo.properties[i];break;case 3:delete e.$go.properties[i];break;case 4:case 5:delete e.$ho.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$io};this.w(r,t),e.$co.properties[r]=t,e.$do.properties[r]=t,e.$eo.properties[r]=t,e.$fo.properties[r]=t,e.$go.properties[r]=t,e.$ho.properties[r]=t}}v(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$io};e.$co.patternProperties[e.$ko]=i,e.$do.patternProperties[e.$ko]=i,e.$eo.patternProperties[e.$ko]=i,e.$fo.patternProperties[e.$ko]=i,e.$go.patternProperties[e.$ko]=i,e.$ho.patternProperties[e.$ko]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let n=t?.value,s=t?.source;k.$$f(n)&&(n=r.defaultDefaultValue,s=void 0),k.$$f(n)&&(n=c(r.type)),r.default=n,r.defaultValueSource=s}}const $="\\[([^\\]]+)\\]",y=new RegExp($,"g");e.$ko=`^(${$})+$`,e.$lo=new RegExp(e.$ko);function O(p){const i=[];if(e.$lo.test(p)){let r=y.exec(p);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=y.exec(p)}}return(0,D.$Mb)(i)}function m(p){return p.reduce((i,r)=>`${i}[${r}]`,"")}function c(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const b=new d;u.$9n.add(e.$bo.Configuration,b);function w(p,i){return p.trim()?e.$lo.test(p)?A.localize(7,null,p):b.getConfigurationProperties()[p]!==void 0?A.localize(8,null,p):i.policy?.name&&b.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,p,i.policy?.name,b.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}function h(){const p=[],i=b.getConfigurationProperties();for(const r of Object.keys(i))p.push([r,i[r].scope]);return p.push(["launch",4]),p.push(["task",4]),p}}),define(se[66],re([0,1,19,5,38,2,31,27,3,11,29,40,36]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$uo=e.$to=e.$so=e.$ro=void 0,e.$vo=w;function $(r){return Object.isFrozen(r)?r:S.$Xn(r)}class y{constructor(t={},n=[],s=[],o){this.b=t,this.c=n,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof y)return n;const s=new O("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,g.$5i)(this.contents,t):this.contents}inspect(t,n){const s=this;return{get value(){return $(s.rawConfiguration.getValue(t))},get override(){return n?$(s.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return $(n?s.rawConfiguration.override(n).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:l,identifiers:P,keys:I}of s.rawConfiguration.overrides){const z=new y(l,I).getValue(t);z!==void 0&&o.push({identifiers:P,value:z})}return o.length?$(o):void 0}}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,g.$5i)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return D.$Mb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return D.$Mb(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=S.$Wn(this.contents),s=S.$Wn(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const P of t)if(l.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(n,P.contents);for(const I of P.overrides){const[z]=s.filter(N=>D.$ub(N.identifiers,I.identifiers));z?(this.h(z.contents,I.contents),z.keys.push(...I.keys),z.keys=D.$Mb(z.keys)):s.push(S.$Wn(I))}for(const I of P.keys)o.indexOf(I)===-1&&o.push(I)}return new y(n,o,s,l.every(P=>P instanceof y)?void 0:l)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const o of D.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[o];const P=n[o];P&&(typeof l=="object"&&typeof P=="object"?(l=S.$Wn(l),this.h(l,P)):l=P),s[o]=l}return new y(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&u.$6f(t[s])&&u.$6f(n[s])){this.h(t[s],n[s]);continue}t[s]=S.$Wn(n[s])}}i(t){let n=null,s=null;const o=l=>{l&&(s?this.h(s,l):s=S.$Wn(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?n=l.contents:l.identifiers.includes(t)&&o(l.contents);return o(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,g.$4i)(this.contents,t),v.$lo.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>D.$ub(s.identifiers,(0,v.$mo)(t))),1))}j(t,n,s){(0,g.$3i)(this.contents,t,n,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),v.$lo.test(t)&&this.overrides.push({identifiers:(0,v.$mo)(t),keys:Object.keys(this.contents[t]),contents:(0,g.$2i)(this.contents[t],o=>console.error(o))})}}e.$ro=y;class O{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!u.$ag(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:o,overrides:l,restricted:P,hasExcludedProperties:I}=this.h(t,n);this.b=new y(s,o,l,I?[t]:void 0),this.c=P||[]}g(t){let n={},s=null,o=[];const l=[],P=[];function I(N){Array.isArray(o)?o.push(N):s!==null&&(o[s]=N)}const z={onObjectBegin:()=>{const N={};I(N),l.push(o),o=N,s=null},onObjectProperty:N=>{s=N},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const N=[];I(N),l.push(o),o=N,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:I,onError:(N,U,V)=>{P.push({error:N,offset:U,length:V})}};if(t)try{k.$Kn(t,z),n=o[0]||{}}catch(N){console.error(`Error while parsing settings file ${this.f}: ${N}`),this.d=[N]}return n}h(t,n){const s=d.$9n.as(v.$bo.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,n);t=o.raw;const l=(0,g.$2i)(t,z=>console.error(`Conflict in settings file ${this.f}: ${z}`)),P=Object.keys(t),I=this.j(t,z=>console.error(`Conflict in settings file ${this.f}: ${z}`));return{contents:l,keys:P,overrides:I,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,n,s,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const P={},I=[];for(const z in t)if(v.$lo.test(z)&&s){const N=this.i(t[z],n,!1,o);P[z]=N.raw,l=l||N.hasExcludedProperties,I.push(...N.restricted)}else{const N=n[z],U=N?typeof N.scope<"u"?N.scope:3:void 0;N?.restricted&&I.push(z),!o.exclude?.includes(z)&&(o.include?.includes(z)||(U===void 0||o.scopes===void 0||o.scopes.includes(U))&&!(o.skipRestricted&&N?.restricted))?P[z]=t[z]:l=!0}return{raw:P,restricted:I,hasExcludedProperties:l}}j(t,n){const s=[];for(const o of Object.keys(t))if(v.$lo.test(o)){const l={};for(const P in t[o])l[P]=t[o][P];s.push({identifiers:(0,v.$mo)(o),keys:Object.keys(l),contents:(0,g.$2i)(l,n)})}return s}}e.$so=O;class m extends A.$Uc{constructor(t,n,s,o){super(),this.c=t,this.f=n,this.g=o,this.b=this.B(new j.$be),this.onDidChange=this.b.event,this.a=new O(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(j.Event.any(j.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),j.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$to=m;class c{constructor(t,n,s,o,l,P,I,z,N,U,V,J,_){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=o,this.d=l,this.f=P,this.g=I,this.h=z,this.i=N,this.j=U,this.k=V,this.l=J,this.m=_}get value(){return $(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class b{constructor(t,n,s,o,l=new y,P=new y,I=new R.$Bc,z=new y,N=new R.$Bc){this.c=t,this.d=n,this.f=s,this.g=o,this.h=l,this.i=P,this.j=I,this.l=z,this.m=N,this.a=null,this.b=new R.$Bc,this.n=null}getValue(t,n,s){return this.p(t,n,s).getValue(t)}updateValue(t,n,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new y,this.m.set(s.resource,o))):o=this.l,n===void 0?o.removeValue(t):o.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const o=this.p(t,n,s),l=this.t(n.resource,s),P=n.resource?this.m.get(n.resource)||this.l:this.l,I=new Set;for(const z of o.overrides)for(const N of z.identifiers)o.getOverrideValue(t,N)!==void 0&&I.add(N);return new c(t,n,o.getValue(t),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,P)}keys(t){const n=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:o,updated:l,removed:P}=p(this.c,t);n=[...o,...l,...P]}for(const o of n)for(const l of(0,v.$mo)(o)){const P=this.c.getKeysForOverrideIdentifier(l),I=t.getKeysForOverrideIdentifier(l),z=[...I.filter(N=>P.indexOf(N)===-1),...P.filter(N=>I.indexOf(N)===-1),...P.filter(N=>!S.$1n(this.c.override(l).getValue(N),t.override(l).getValue(N)))];s.push([l,z])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:o}=p(this.d,t),l=[...n,...s,...o];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=p(this.applicationConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateApplicationConfiguration(t),{keys:P,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=p(this.localUserConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateLocalUserConfiguration(t),{keys:P,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=p(this.remoteUserConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateRemoteUserConfiguration(t),{keys:P,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=p(this.workspaceConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateWorkspaceConfiguration(t),{keys:P,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:o,updated:l,removed:P,overrides:I}=p(s,n),z=[...o,...l,...P];return(z.length||!s)&&this.updateFolderConfiguration(t,n),{keys:z,overrides:I}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:l,overrides:P}=p(n,void 0);return{keys:[...s,...o,...l],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,n,s){let o=this.q(n,s);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}q({resource:t},n){let s=this.r();if(n&&t){const o=n.getFolder(t);o&&(s=this.s(o.uri)||s);const l=this.m.get(t);l&&(s=s.merge(l))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let n=this.b.get(t);if(!n){const s=this.r(),o=this.j.get(t);o?(n=s.merge(o),this.b.set(t,n)):n=s}return n}t(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:o,keys:l}=this.j.get(n);return t.push([n,{contents:s,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}v(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.w(t.defaults),s=this.w(t.policy),o=this.w(t.application),l=this.w(t.user),P=this.w(t.workspace),I=t.folders.reduce((z,N)=>(z.set(a.URI.revive(N[0]),this.w(N[1])),z),new R.$Bc);return new b(n,s,o,l,new y,P,I,new y,new R.$Bc)}static w(t){return new y(t.contents,t.keys,t.overrides)}}e.$uo=b;function w(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const o of r)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,P])=>{const I=(0,R.$yc)(n,l,new Set);P.forEach(z=>I.add(z))});const s=[];return n.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...t.values()],overrides:s}}class h{constructor(t,n,s,o){this.change=t,this.f=n,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const P of l)this.affectedKeys.add(P);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=b.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const l=o+s.length;if(l>=this.d.length)return!1;const P=this.d.charCodeAt(l);if(P!==this.b&&P!==this.c)return!1;if(n){const I=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,z=this.g.getValue(t,n,this.h);return!S.$1n(I,z)}return!0}}e.$wo=h;function p(r,t){const{added:n,removed:s,updated:o}=i(t?.rawConfiguration,r?.rawConfiguration),l=[],P=r?.getAllOverrideIdentifiers()||[],I=t?.getAllOverrideIdentifiers()||[];if(t){const z=I.filter(N=>!P.includes(N));for(const N of z)l.push([N,t.getKeysForOverrideIdentifier(N)])}if(r){const z=P.filter(N=>!I.includes(N));for(const N of z)l.push([N,r.getKeysForOverrideIdentifier(N)])}if(t&&r){for(const z of P)if(I.includes(z)){const N=i({contents:r.getOverrideValue(void 0,z)||{},keys:r.getKeysForOverrideIdentifier(z)},{contents:t.getOverrideValue(void 0,z)||{},keys:t.getKeysForOverrideIdentifier(z)});l.push([z,[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:s,updated:o,overrides:l}}function i(r,t){const n=r?t?r.keys.filter(l=>t.keys.indexOf(l)===-1):[...r.keys]:[],s=t?r?t.keys.filter(l=>r.keys.indexOf(l)===-1):[...t.keys]:[],o=[];if(r&&t){for(const l of t.keys)if(r.keys.indexOf(l)!==-1){const P=(0,g.$5i)(t.contents,l),I=(0,g.$5i)(r.contents,l);S.$1n(P,I)||o.push(l)}}return{added:n,removed:s,updated:o}}}),define(se[138],re([0,1,19,5,2,27,3,66,40,6,39,36]),function(Q,e,D,j,k,A,R,S,u,a,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=void 0;class d extends k.$Uc{constructor(){super(...arguments),this.a=this.B(new j.$be),this.onDidChangeConfiguration=this.a.event,this.b=new S.$ro}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$9n.as(u.$bo.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:c})=>this.c(Array.from(m),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(m,c){this.h(m,v.$9n.as(u.$bo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}g(){this.b=new S.$ro;const m=v.$9n.as(u.$bo.Configuration).getConfigurationProperties();this.h(Object.keys(m),m)}h(m,c){const b=this.f();for(const w of m){const h=b[w],p=c[w];h!==void 0?this.b.addValue(w,h):p?this.b.addValue(w,p.default):this.b.removeValue(w)}}}e.$xo=d;class ${constructor(){this.onDidChangeConfiguration=j.Event.None,this.configurationModel=new S.$ro}async initialize(){return this.configurationModel}}e.$yo=$;let y=class extends k.$Uc{get configurationModel(){return this.b}constructor(m,c,b){super(),this.c=m,this.f=c,this.g=b,this.a=this.B(new j.$be),this.onDidChangeConfiguration=this.a.event,this.b=new S.$ro}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const c={},b=[],w=v.$9n.as(u.$bo.Configuration).getConfigurationProperties();for(const h of m){const p=w[h];if(!p){b.push(h);continue}if(p.policy){if(p.type!=="string"&&p.type!=="number"){this.g.warn(`Policy ${p.policy.name} has unsupported type ${p.type}`);continue}b.push(h),c[p.policy.name]={type:p.type}}}return(0,R.$eg)(c)||await this.f.updatePolicyDefinitions(c),b}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const c=v.$9n.as(u.$bo.Configuration).getPolicyConfigurations(),b=(0,D.$Hb)(m.map(w=>c.get(w)));this.m(b,!0)}m(m,c){this.g.trace("PolicyConfiguration#update",m);const b=v.$9n.as(u.$bo.Configuration).getConfigurationProperties(),w=[],h=this.b.isEmpty();for(const p of m){const i=b[p]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(h?r!==void 0:!(0,A.$1n)(this.b.getValue(p),r))&&w.push([p,r])}else this.b.getValue(p)!==void 0&&w.push([p,void 0])}if(w.length){this.g.trace("PolicyConfiguration#changed",w);const p=this.b;this.b=new S.$ro;for(const i of p.keys)this.b.setValue(i,p.getValue(i));for(const[i,r]of w)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);c&&this.a.fire(this.b)}}};e.$zo=y,e.$zo=y=$e([oe(1,g.$$n),oe(2,a.$Wj)],y)}),define(se[139],re([0,1,19,8,14,5,38,74,2,27,12,17,29,66,40,138,39]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$,y,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=void 0;class c extends u.$Uc{constructor(h,p,i,r){super(),this.m=h,this.h=this.B(new A.$be),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new O.$xo),this.c=i instanceof m.$ao?new O.$yo:this.B(new O.$zo(this.b,i,r)),this.f=this.B(new $.$to(this.m,{},v.$Ug,p)),this.a=new $.$uo(this.b.configurationModel,this.c.configurationModel,new $.$ro,new $.$ro),this.j=new b(h,p,this),this.g=this.B(new j.$Ch(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:t,properties:n})=>this.r(t,n))),this.B(this.c.onDidChangeConfiguration(t=>this.s(t))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,p,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new $.$uo(h,p,new $.$ro,i)}getConfigurationData(){return this.a.toData()}getValue(h,p){const i=typeof h=="string"?h:void 0,r=(0,d.$Xi)(h)?h:(0,d.$Xi)(p)?p:{};return this.a.getValue(i,r,void 0)}async updateValue(h,p,i,r,t){const n=(0,d.$Yi)(i)?i:(0,d.$Xi)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,s=n?r:i;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${h} to target ${s}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,D.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(h,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,a.$1n)(p,o.defaultValue)&&(p=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const P=n.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(z=>(0,D.$ub)([...z.identifiers].sort(),P));I&&(n.overrideIdentifiers=I.identifiers)}const l=n?.overrideIdentifiers?.length?[(0,y.$no)(n.overrideIdentifiers),h]:[h];await this.j.write(l,p),await this.reloadConfiguration()}inspect(h,p={}){return this.a.inspect(h,p,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.n(h)}n(h){const p=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(h);this.t(i,p,2)}r(h,p){const i=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(h,p);this.t(r,i,7)}s(h){const p=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(h);this.t(i,p,7)}t(h,p,i){const r=new $.$wo(h,{data:p},this.a);r.source=i,this.h.fire(r)}}e.$Ao=c;class b{constructor(h,p,i){this.b=h,this.c=p,this.d=i,this.a=new j.$xh}write(h,p){return this.a.queue(()=>this.e(h,p))}async e(h,p){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const r=[];if((0,R.$Dn)(i,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.f(i,h,p);i=(0,S.$Vn)(i,t),await this.c.writeFile(this.b,k.$Ce.fromString(i))}f(h,p,i){const{tabSize:r,insertSpaces:t,eol:n}=this.h;if(!p.length){const s=JSON.stringify(i,null,t?" ".repeat(r):"	");return[{content:s,length:s.length,offset:0}]}return(0,S.$Sn)(h,p,i,{tabSize:r,insertSpaces:t,eol:n})}get h(){if(!this.g){let h=g.OS===3||g.OS===2?`
`:`\r
`;const p=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});p&&typeof p=="string"&&p!=="auto"&&(h=p),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(se[67],re([0,1,15]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=j,e.$Cm=k,e.$Dm=A,e.$Em=R;function j(u){return u.scheme===D.Schemas.vscodeRemote?u.authority:void 0}function k(u){if(!u)return;const a=u.indexOf("+");return a<0?u:u.substr(0,a)}function A(u){const{host:a,port:g}=S(u);if(typeof g>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:g}}function R(u,a){let{host:g,port:v}=S(u);return typeof v>"u"&&(v=a),{host:g,port:v}}function S(u){const a=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const g=u.match(/^(\[[0-9a-z:]+\])$/);if(g)return{host:g[1],port:void 0};const v=u.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:u,port:void 0}}}),define(se[37],re([0,1,30,10,67]),function(Q,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Nm=e.$Mm=e.$Lm=e.TargetPlatform=e.ExtensionType=e.$Km=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0,e.$Jm=A,e.$Om=v,e.$Pm=d,e.$Qm=$,e.$Rm=y,e.$Fm="extensions.user.cache",e.$Gm="extensions.builtin.cache",e.$Hm="undefined_publisher",e.$Im=["ui","workspace","web"];function A(O){if(typeof O=="object"&&O!==null&&O.supported!==!0)return O.description}e.$Km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(O){O[O.System=0]="System",O[O.User=1]="User"})(R||(e.ExtensionType=R={}));var S;(function(O){O.WIN32_X64="win32-x64",O.WIN32_ARM64="win32-arm64",O.LINUX_X64="linux-x64",O.LINUX_ARM64="linux-arm64",O.LINUX_ARMHF="linux-armhf",O.ALPINE_X64="alpine-x64",O.ALPINE_ARM64="alpine-arm64",O.DARWIN_X64="darwin-x64",O.DARWIN_ARM64="darwin-arm64",O.WEB="web",O.UNIVERSAL="universal",O.UNKNOWN="unknown",O.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class u{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,c){if(typeof m>"u"||m===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof m=="string"||typeof c=="string"){const b=typeof m=="string"?m:m.value,w=typeof c=="string"?c:c.value;return D.$tf(b,w)}return m._lower===c._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Lm=u;class a{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const c of m)this.add(c)}add(m){this.c.add(u.toKey(m))}delete(m){return this.c.delete(u.toKey(m))}has(m){return this.c.has(u.toKey(m))}}e.$Mm=a;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(u.toKey(m))}get(m){return this.c.get(u.toKey(m))}has(m){return this.c.has(u.toKey(m))}set(m,c){this.c.set(u.toKey(m),c)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Nm=g;function v(O){return d(O)}function d(O){return O.contributes&&O.contributes.localizations?O.contributes.localizations.length>0:!1}function $(O){return O.contributes&&O.contributes.authentication?O.contributes.authentication.length>0:!1}function y(O,m){if(m){const c=`onResolveRemoteAuthority:${(0,k.$Cm)(m)}`;return!!O.activationEvents?.includes(c)}return!1}e.$Sm=(0,j.$qi)("IBuiltinExtensionsScannerService")}),define(se[140],re([0,1,2,37,13]),function(Q,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=void 0;class A extends D.$Uc{constructor(S,u,a,g,v){super(),this.a=S,this.b=u,this.c=a,this.f=v,this.B(g.onDidInstallExtensions(d=>this.g(d))),this.B(g.onDidUninstallExtension(d=>this.h(d)))}g(S){for(const u of S)u.local&&this.invalidate(u.profileLocation)}h(S){S.error||this.invalidate(S.profileLocation)}async invalidate(S){if(S)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,S)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(S){try{await this.b.del(this.c.extUri.joinPath(S.cacheHome,j.$Fm))}catch(u){(0,k.$bl)(u)!==1&&this.f.error(u)}}}e.$vq=A}),define(se[45],re([0,1,14,9,2,107,40,10,6,36]),function(Q,e,D,j,k,A,R,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=void 0,e.$Jp=d,e.$Kp=$,e.$Lp=y,e.$Mp=O,e.$Np=m,e.$Op=c,e.$Hp=(0,S.$qi)("requestService");class g{constructor(p){this.b=p}toJSON(){if(!this.a){const p=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?p[i]="*****":p[i]=this.b[i];this.a=p}return this.a}}class v extends k.$Uc{constructor(p){super(),this.b=0,this.a=p.createLogger("network",{name:(0,A.localize)(0,null),when:u.$ck.isEqualTo((0,u.$_j)(u.LogLevel.Trace)).serialize()})}async c(p,i,r){const t=`${p} #${++this.b}: ${i.url}`;this.a.trace(`${t} - begin`,i.type,new g(i.headers??{}));try{const n=await r();return this.a.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${t} - error`,i.type,(0,j.$0)(n)),n}}}e.$Ip=v;function d(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}function $(h){return h.res.statusCode===204}async function y(h){return $(h)?null:(await(0,D.$Oe)(h.stream)).toString()}async function O(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);return y(h)}async function m(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);if($(h))return null;const i=(await(0,D.$Oe)(h.stream)).toString();try{return JSON.parse(i)}catch(r){throw r.message+=`:
`+i,r}}function c(h){w(h)}let b;function w(h){const p=a.$9n.as(R.$bo.Configuration),i=b;b={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},p.updateConfigurations({add:[b],remove:i?[i]:[]})}w(1)}),define(se[141],re([0,1,20,15,13,45]),function(Q,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NQ=void 0;let R=class{constructor(u,a){this.a=u,this.b=a}async download(u,a,g=D.CancellationToken.None){if(u.scheme===j.Schemas.file||u.scheme===j.Schemas.vscodeRemote){await this.b.copy(u,a);return}const v={type:"GET",url:u.toString(!0)},d=await this.a.request(v,g);if(d.res.statusCode===200)await this.b.writeFile(a,d.stream);else{const $=await(0,A.$Mp)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${$}`)}}};e.$NQ=R,e.$NQ=R=$e([oe(0,A.$Hp),oe(1,k.$Wk)],R)}),define(se[142],re([0,1,143,3]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=A;function k(R,S){return R.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:R.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function A(R,S,u={}){const a=(0,D.parse)(R),g=u.proxyUrl||k(a,S);if(!g)return null;const v=(0,D.parse)(g);if(!/^https?:$/.test(v.protocol||""))return null;const d={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,j.$0f)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise(($,y)=>{Q(["http-proxy-agent"],$,y)})).HttpProxyAgent(g,d):new(await new Promise(($,y)=>{Q(["https-proxy-agent"],$,y)})).HttpsProxyAgent(g,d)}}),define(se[144],re([0,1,59,16,108,20,34,9,12,28,87,175,8,75]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=O;let y;async function O(c,b,w,h){return w["force-disable-user-env"]?(b.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(b.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$um)(h)&&!w["force-user-env"]?(b.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$um)(h)?b.trace("resolveShellEnv(): running (--force-user-env)"):b.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=d.Promises.withAsyncBody(async(p,i)=>{const r=new A.$me;let t=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,$.$vm)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),i(new Error((0,k.localize)(0,null)))},t);try{p(await m(b,r.token))}catch(o){!(0,S.$4)(o)&&!r.token.isCancellationRequested?i(new Error((0,k.localize)(1,null,(0,R.$bj)(o)))):p({})}finally{clearTimeout(s),r.dispose()}})),y)}async function m(c,b){const w=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",w);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",h);const p=(0,a.$Mg)().replace(/-/g,"").substr(0,12),i=new RegExp(p+"({.*})"+p),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,g.$km)(u.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(b.isCancellationRequested)return s(new S.$5);const o=(0,j.$oc)(t);let l,P;const I="";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${I} -p '''${p}'' + JSON.stringify(process.env) + ''${p}'''`,P=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${I} -p '"${p}" + JSON.stringify(process.env) + "${p}"'`,P=["-i","-l","-c"]):o==="xonsh"?(l=`import os, json; print("${p}", json.dumps(dict(os.environ)), "${p}")`,P=["-i","-l","-c"]):(l=`'${process.execPath}' ${I} -p '"${p}" + JSON.stringify(process.env) + "${p}"'`,o==="tcsh"||o==="csh"?P=["-ic"]:P=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const z=(0,D.spawn)(t,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});b.onCancellationRequested(()=>(z.kill(),s(new S.$5))),z.on("error",V=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,R.$bj)(V)),s(V)});const N=[];z.stdout.on("data",V=>N.push(V));const U=[];z.stderr.on("data",V=>U.push(V)),z.on("close",(V,J)=>{const _=Buffer.concat(N).toString("utf8");c.trace("getUnixShellEnvironment#raw",_);const K=Buffer.concat(U).toString("utf8");if(K.trim()&&c.trace("getUnixShellEnvironment#stderr",K),V||J)return s(new Error((0,k.localize)(2,null,V,J)));const le=i.exec(_),ue=le?le[1]:"{}";try{const ae=JSON.parse(ue);w?ae.ELECTRON_RUN_AS_NODE=w:delete ae.ELECTRON_RUN_AS_NODE,h?ae.ELECTRON_NO_ATTACH_CONSOLE=h:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ae),n(ae)}catch(ae){c.error("getUnixShellEnvironment#errorCaught",(0,R.$bj)(ae)),s(ae)}})})}}),define(se[145],re([0,1,10]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=e.$pQ=void 0,e.$pQ=(0,D.$qi)("stateReadService"),e.$qQ=(0,D.$qi)("stateService")}),define(se[68],re([0,1,8,14,2,3,18,13,6]),function(Q,e,D,j,k,A,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tQ=e.$sQ=e.$rQ=e.SaveStrategy=void 0;var a;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class g extends k.$Uc{constructor(y,O,m,c){super(),this.h=y,this.j=O,this.m=m,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new D.$oh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.m.error(y)}}getItem(y,O){const m=this.a[y];return(0,A.$ag)(m)?O:m}setItem(y,O){this.setItems([{key:y,data:O}])}setItems(y){let O=!1;for(const{key:m,data:c}of y)this.a[m]!==c&&((0,A.$ag)(c)?(0,A.$$f)(this.a[m])||(this.a[m]=void 0,O=!0):(this.a[m]=c,O=!0));O&&this.s()}removeItem(y){(0,A.$$f)(this.a[y])||(this.a[y]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.n.writeFile(this.h,j.$Ce.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(O){this.m.error(O)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$rQ=g;let v=class extends k.$Uc{constructor(y,O,m,c){super(),this.a=this.B(new g(O.stateResource,y,m,c))}async init(){await this.a.init()}getItem(y,O){return this.a.getItem(y,O)}};e.$sQ=v,e.$sQ=v=$e([oe(1,R.$xi),oe(2,u.$Wj),oe(3,S.$Wk)],v);class d extends v{setItem(y,O){this.a.setItem(y,O)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$tQ=d}),define(se[69],re([0,1,12,35,28]),function(Q,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=R,e.$$o=S;function A(u){if(D.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function R(u,a,g,v,d,$,y,O,m){const c=Object.create(null);c["common.machineId"]=$,c["common.sqmId"]=y,c.sessionID=(0,k.$Mg)()+Date.now(),c.commitHash=v,c.version=d,c["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,D.$h)(D.$u),c["common.nodePlatform"]=j.$ec,c["common.nodeArch"]=g,c["common.product"]=m||"desktop",O&&(c["common.msftInternal"]=O);let b=0;const w=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>b++,enumerable:!0}}),D.$l&&(c["common.snap"]="true");const h=A(a);return h&&(c["common.platformDetail"]=h),c}function S(u){const a=j.env.USERDNSDOMAIN;if(!a)return!1;const g=a.toLowerCase();return u.some(v=>g===v)}}),define(se[22],re([0,1,10]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl=(0,D.$qi)("telemetryService"),e.$Wl=(0,D.$qi)("customEndpointTelemetryService"),e.$Xl="telemetry.currentSessionDate",e.$Yl="telemetry.firstSessionDate",e.$Zl="telemetry.lastSessionDate",e.$1l="telemetry.machineId",e.$2l="telemetry.sqmId",e.$3l="telemetry",e.$4l="telemetry.telemetryLevel",e.$5l="telemetry.enableCrashReporter",e.$6l="telemetry.enableTelemetry";var j;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(j||(e.TelemetryLevel=j={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(se[70],re([0,1,9,10,6,22]),function(Q,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0,e.$6p=(0,j.$qi)("IExtensionSignatureVerificationService");let R=class{constructor(u,a){this.b=u,this.c=a}d(){return this.a||(this.a=new Promise((u,a)=>Q(["@vscode/vsce-sign"],async g=>u(g),a))),this.a}async verify(u,a,g){let v;try{v=await this.d()}catch(O){return this.b.error("Could not load vsce-sign module",(0,D.$0)(O)),!1}const d=new Date().getTime();let $,y;try{return $=await v.verify(u,a,g),$}catch(O){throw y=O,O}finally{const O=new Date().getTime()-d;this.c.publicLog2("extensionsignature:verification",{duration:O,verified:$,error:y?y.code??"unknown":void 0})}}};e.$7p=R,e.$7p=R=$e([oe(0,k.$Wj),oe(1,A.$Vl)],R)}),define(se[41],re([0,1,27,3,67,69,22]),function(Q,e,D,j,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=g,e.$hp=v,e.$ip=d,e.$jp=$,e.$kp=O,e.$lp=c,e.$mp=b,e.$np=p;class S{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$_o=S;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ap=u,e.$bp=new u;class a{async publicLog(r,t,n){}async publicLogError(r,t,n){}}e.$cp=a,e.$dp="telemetry",e.$ep="extensionTelemetryLog",e.$fp={log:()=>null,flush:()=>Promise.resolve(null)};function g(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry)}function v(i,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function d(i){const r=i.getValue(R.$4l),t=i.getValue(R.$5l);if(i.getValue(R.$6l)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function $(i){const r={},t={},n={};m(i,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const o=n[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}const y=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function O(i){if(!i)return"none";const r=(0,k.$Cm)(i);return y.has(r)?r:"other"}function m(i,r,t=0,n){if(i)for(const s of Object.getOwnPropertyNames(i)){const o=i[s],l=n?n+s:s;Array.isArray(o)?r[l]=(0,D.$2n)(o):o instanceof Date?r[l]=o.toISOString():(0,j.$6f)(o)?t<2?m(o,r,t+1,l+"."):r[l]=(0,D.$2n)(o):r[l]=o}}function c(i,r){const t=i.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,A.$$o)(t)||n}function b(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function w(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const P of r)for(;;){const I=P.exec(i);if(!I)break;n.push([I.index,P.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(t="";;){const P=o.exec(i);if(!P)break;const I=n.some(([z,N])=>P.index<N&&z<o.lastIndex);!s.test(P[0])&&!I&&(t+=i.substring(l,P.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<i.length&&(t+=i.substr(l)),t}function h(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function p(i,r){return(0,D.$Yn)(i,t=>{if(t instanceof S||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=w(n,r);for(const s of r)n=n.replace(s,"");return n=h(n),n}})}}),define(se[26],re([0,1,30,21,37,12,11,9,35,41]),function(Q,e,D,j,k,A,R,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$pp=void 0,e.$op=g,e.$qp=y,e.$rp=O,e.$sp=m,e.$tp=c,e.$up=b,e.$vp=w,e.$wp=h,e.$yp=p,e.$zp=r;function g(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,D.$of)(t.id,n.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const s=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,s,o)}static parse(n){const s=v.exec(n);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?g(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$pp=d;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(t){const n=$.exec(t);return n&&n[1]?[m(n[1]),n[2]]:[m(t),void 0]}function O(t,n){return`${t}.${n}`}function m(t){return t.toLowerCase()}function c(t,n){return m(O(t??k.$Hm,n))}function b(t,n){const s=[],o=l=>{for(const P of s)if(P.some(I=>g(n(I),n(l))))return P;return null};for(const l of t){const P=o(l);P?P.push(l):s.push([l])}return s}function w(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}function h(t){return{id:new a.$_o(t.identifier.id),name:new a.$_o(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$xp=new k.$Lm("pprice.better-merge");function p(t,n){const s=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(P=>!g(P.identifier,{id:l}))){const P=t.filter(I=>g(I.identifier,{id:l}));P.length===1&&(s.push(P[0]),o.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function i(t,n){if(!A.$k)return!1;let s;try{s=(await t.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,S.$0)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,n){const s=await i(t,n),o=(0,j.$Vo)(s?"alpine":A.$u,u.$fc);return n.debug("ComputeTargetPlatform:",o),o}}),define(se[146],re([0,1,20,9,15,17,44,11,96,21,26,37]),function(Q,e,D,j,k,A,R,S,u,a,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;const d=O=>(0,u.localize)(0,null,O),$=(0,u.localize)(1,null,"ms-dotnettools.csharp");let y=class{constructor(m,c,b){this.a=m,this.b=c,this.d=b}get f(){}async listExtensions(m,c,b){let w=await this.b.getInstalled(1,b);const h=v.$Km.map(i=>i.toLowerCase());if(c&&c!==""){if(h.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}w=w.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),h.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),w=w.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let p;for(const i of w)p!==i.identifier.id&&(p=i.identifier.id,this.a.info(m?`${p}@${i.manifest.version}`:p))}async installExtensions(m,c,b,w){const h=[];try{m.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const p=[],i=[],r=(n,s,o)=>{i.push({id:n,version:s!=="prerelease"?s:void 0,installOptions:{...b,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||b.installPreReleaseVersion}})};for(const n of m)if(n instanceof S.URI)p.push({vsix:n,installOptions:b});else{const[s,o]=(0,g.$qp)(n);r(s,o,!1)}for(const n of c)if(n instanceof S.URI)p.push({vsix:n,installOptions:{...b,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,g.$qp)(n);r(s,o,!0)}const t=await this.b.getInstalled(void 0,b.profileLocation);if(p.length&&await Promise.all(p.map(async({vsix:n,installOptions:s})=>{try{await this.h(n,s,w,t)}catch(o){this.a.error(o),h.push(n.toString())}})),i.length){const n=await this.g(i,t,w);h.push(...n)}}catch(p){throw this.a.error((0,u.localize)(5,null,(0,j.$0)(p))),p}if(h.length)throw new Error((0,u.localize)(6,null,h.join(", ")))}async updateExtensions(m){const c=await this.b.getInstalled(1,m),b=[];for(const i of c)i.identifier.uuid&&b.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,u.localize)(7,null,b.length));const w=await this.d.getExtensions(b,{compatible:!0},D.CancellationToken.None),h=[];for(const i of w)for(const r of c)(0,g.$op)(r.identifier,i.identifier)&&(0,R.gt)(i.version,r.manifest.version)&&h.push({extension:i,options:{operation:3,installPreReleaseVersion:r.isPreReleaseVersion}});if(!h.length){this.a.info((0,u.localize)(8,null));return}this.a.info((0,u.localize)(9,null,h.map(i=>i.extension.identifier.id).join(", ")));const p=await this.b.installGalleryExtensions(h);for(const i of p)i.error?this.a.error((0,u.localize)(10,null,i.identifier.id,(0,j.$0)(i.error))):this.a.info((0,u.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async g(m,c,b){if(m=m.filter(({id:i,version:r})=>{const t=c.find(n=>(0,g.$op)(n.identifier,{id:i}));if(t){if(!b&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,u.localize)(12,null,i,t.manifest.version,i)),!1;if(r&&t.manifest.version===r)return this.a.info((0,u.localize)(13,null,`${i}@${r}`)),!1}return!0}),!m.length)return[];const w=[],h=[],p=await this.j(m);if(await Promise.all(m.map(async({id:i,version:r,installOptions:t})=>{const n=p.get(i.toLowerCase());if(!n){this.a.error(`${d(r?`${i}@${r}`:i)}
${$}`),w.push(i);return}try{const o=await this.d.getManifest(n,D.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),w.push(i);return}const s=c.find(o=>(0,g.$op)(o.identifier,n.identifier));if(s){if(n.version===s.manifest.version){this.a.info((0,u.localize)(14,null,r?`${i}@${r}`:i));return}this.a.info((0,u.localize)(15,null,i,n.version))}t.isBuiltin?this.a.info(r?(0,u.localize)(16,null,i,r):(0,u.localize)(17,null,i)):this.a.info(r?(0,u.localize)(18,null,i,r):(0,u.localize)(19,null,i)),h.push({extension:n,options:{...t,installGivenVersion:!!r}})})),h.length){const i=await this.b.installGalleryExtensions(h);for(const r of i)r.error?(this.a.error((0,u.localize)(20,null,r.identifier.id,(0,j.$0)(r.error))),w.push(r.identifier.id)):this.a.info((0,u.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return w}async h(m,c,b,w){const h=await this.b.getManifest(m);if(!h)throw new Error("Invalid vsix");if(await this.l(h,b,c.profileLocation,w))try{await this.b.install(m,c),this.a.info((0,u.localize)(22,null,(0,A.$1g)(m)))}catch(i){if((0,j.$4)(i))this.a.info((0,u.localize)(23,null,(0,A.$1g)(m)));else throw i}}async j(m){const c=new Map,b=m.some(p=>p.installOptions.installPreReleaseVersion),w=await this.b.getTargetPlatform(),h=[];for(const p of m)a.$Oo.test(p.id)&&h.push({...p,preRelease:b});if(h.length){const p=await this.d.getExtensions(h,{targetPlatform:w},D.CancellationToken.None);for(const i of p)c.set(i.identifier.id.toLowerCase(),i)}return c}k(m){return!0}async l(m,c,b,w){if(!c){const h={id:(0,g.$tp)(m.publisher,m.name)},p=w.find(i=>(0,g.$op)(h,i.identifier)&&(0,R.gt)(i.manifest.version,m.version));if(p)return this.a.info((0,u.localize)(24,null,p.identifier.id,p.manifest.version,m.version)),!1}return this.k(m)}async uninstallExtensions(m,c,b){const w=async p=>{if(p instanceof S.URI){const i=await this.b.getManifest(p);return(0,g.$rp)(i.publisher,i.name)}return p},h=[];for(const p of m){const i=await w(p),t=(await this.b.getInstalled(void 0,b)).filter(n=>(0,g.$op)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.m(i)}
${$}`);if(t.some(n=>n.type===0)){this.a.info((0,u.localize)(25,null,i));return}if(!c&&t.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(26,null,i));return}this.a.info((0,u.localize)(27,null,i));for(const n of t)await this.b.uninstall(n,{profileLocation:b}),h.push(n);this.f?this.a.info((0,u.localize)(28,null,i,this.f)):this.a.info((0,u.localize)(29,null,i))}}async locateExtension(m){const c=await this.b.getInstalled();m.forEach(b=>{c.forEach(w=>{if(w.identifier.id===b&&w.location.scheme===k.Schemas.file){this.a.info(w.location.fsPath);return}})})}m(m){return this.f?(0,u.localize)(30,null,m,this.f):(0,u.localize)(31,null,m)}};e.$8p=y,e.$8p=y=$e([oe(1,a.$3o),oe(2,a.$Zo)],y)}),define(se[147],re([0,1,8,9,2,15,17,44,3,28,25,49,29,18,21,26,70,13,6]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$,y,O,m,c,b){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;let h=class extends k.$Uc{static{w=this}static{this.c=".sigzip"}constructor(i,r,t,n,s,o){super(),this.h=r,this.j=t,this.m=n,this.n=s,this.r=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,r,t){await this.g;const n=(0,R.$4g)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,n,o=>this.j.download(i,o,r))}catch(o){throw new y.$1o(o.message,y.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(i)){const o=await this.u(i);try{s=await this.n.verify(n.fsPath,o.fsPath,this.r.getLevel()===b.LogLevel.Trace)}catch(l){const P=l;if(s=P.code,P.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${P.output}`),s===y.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===y.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(I){this.r.error(I)}throw new y.$1o(v.$_p,y.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(l){this.r.error(l)}}}return s===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${i.identifier.id}`),{location:n,verificationStatus:s}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,u.$0f)(r)?r:!0}async u(i){await this.g;const r=(0,R.$4g)(this.extensionsDownloadDir,`${this.z(i)}${w.c}`);try{await this.w(i,r,t=>this.j.downloadSignatureArchive(i,t))}catch(t){throw new y.$1o(t.message,y.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==A.Schemas.file){await t(r);return}const n=(0,R.$4g)(this.extensionsDownloadDir,`.${(0,a.$Mg)()}`);await this.h.exists(n)||await t(n);try{await g.Promises.rename(n.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,j.$0)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],n=[];for(const l of i.children)if(l.name.endsWith(w.c))n.push(l.resource);else{const P=O.$pp.parse(l.name);P&&t.push([P,l])}const s=(0,O.$up)(t,([l])=>l),o=[];for(const l of s)l.sort((P,I)=>S.rcompare(P[0].version,I[0].version)),r.push(...l.slice(1).map(P=>P[1].resource)),o.push(l[0][1]);o.sort((l,P)=>l.mtime-P.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),r.push(...n),await D.Promises.settled(r.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(i){this.r.error(i)}}z(i){return this.f?O.$pp.create(i).toString().toLowerCase():(0,a.$Mg)()}};e.$sq=h,e.$sq=h=w=$e([oe(0,$.$yi),oe(1,c.$Wk),oe(2,y.$Zo),oe(3,d.$Wi),oe(4,m.$6p),oe(5,b.$Wj)],h)}),define(se[148],re([0,1,5,2,31,26,37]),function(Q,e,D,j,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=void 0;class S extends j.$Uc{constructor(a,g,v,d,$,y,O){super(),this.f=a,this.g=g,this.h=v,this.j=d,this.m=$,this.n=y,this.r=O,this.a=this.B(new D.$be),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new j.$4c),this.s().then(null,m=>O.error(m))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(g=>(this.c.set(g.id,(0,j.$Rc)(this.n.watch(this.m.extUri.dirname(g.extensionsResource)),this.n.watch(g.extensionsResource))),this.G(g.extensionsResource))))}catch(g){throw this.r.error(g),g}}async w(a){for(const g of a.extensions)this.I(this.L(g.identifier,g.version),a.profileLocation)}async y(a){for(const g of a.extensions){const v=this.L(g.identifier,g.version);a.error?this.J(v,a.profileLocation):this.I(v,a.profileLocation)}}async z(a){for(const g of a.extensions)this.J(this.L(g.identifier,g.version),a.profileLocation)}async C(a){const g=[],v=[];for(const d of a.extensions){const $=this.L(d.identifier,d.version);a.error?this.I($,a.profileLocation):(this.J($,a.profileLocation),this.b.has($)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),v.push(this.f.scanInstalledExtensionAtLocation(d.location).then(y=>{y?g.push(y):this.r.info("Extension not found at the location",d.location.toString())},y=>this.r.error(y)))))}try{await Promise.all(v),g.length&&await this.H(g)}catch(d){this.r.error(d)}}D(a){for(const g of this.h.profiles)a.contains(g.extensionsResource,0,1)&&this.F(g.extensionsResource)}async F(a){const g=[],v=[],d=await this.j.scanProfileExtensions(a),$=new Set,y=new Set;for(const[O,m]of this.b)m.has(a)&&y.add(O);for(const O of d){const m=this.L(O.identifier,O.version);$.add(m),y.has(m)||(g.push(O.identifier),this.I(m,a))}for(const O of y)if(!$.has(O)){const m=this.M(O);m&&(v.push(m.identifier),this.J(O,a))}(g.length||v.length)&&this.a.fire({added:g.length?{extensions:g,profileLocation:a}:void 0,removed:v.length?{extensions:v,profileLocation:a}:void 0})}async G(a){const g=await this.j.scanProfileExtensions(a);for(const v of g)this.I(this.L(v.identifier,v.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.L(v.identifier,v.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,g){let v=this.b.get(a);v||this.b.set(a,v=new k.$Cc(d=>this.m.extUri.getComparisonKey(d))),v.add(g)}J(a,g){const v=this.b.get(a);v&&v.delete(g),v?.size||this.b.delete(a)}L(a,g){return`${R.$Lm.toKey(a.id)}@${g}`}M(a){const[g,v]=(0,A.$qp)(a);return v?{identifier:{id:g},version:v}:void 0}}e.$wq=S}),define(se[149],re([0,1,118,41]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=k;async function k(A,R,S,u,a,g,v){const d={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${R.nameShort})`};if((0,j.$gp)(R,S)&&(0,j.$ip)(u)===3){const $=await(0,D.$1p)(S,a,g);d["X-Market-User-Id"]=$,d["VSCode-SessionId"]=v.machineId||$}return d}}),define(se[150],re([0,1,176,19,8,2,15,16,25,18,21,26,6,64,11]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=void 0;let O=class extends $.$Kr{constructor(w,h,p,i){super(p),this.h=w,this.j=i,this.g=this.B(new m(h,i)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(w,h){const i=(await this.g.getLanguagePacks())[h];if(!i){this.j.warn(`No language pack found for ${h}`);return}const r=i.translations[w];return r?y.URI.file(r):void 0}async getInstalledLanguages(){const w=await this.g.getLanguagePacks(),h=Object.keys(w).map(p=>{const i=w[p];return{...this.f(p,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return h.push(this.f("en","English")),h.sort((p,i)=>p.label.localeCompare(i.label)),h}async m(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",w.identifier.id),await this.update())}async n(w){const h=await this.g.getLanguagePacks();Object.keys(h).some(p=>h[p]&&h[p].extensions.some(i=>(0,v.$op)(i.extensionIdentifier,w.identifier)))&&(this.j.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,h]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),p=await this.g.update(h);return!(0,j.$ub)(Object.keys(w),Object.keys(p))}};e.$Lr=O,e.$Lr=O=$e([oe(0,g.$3o),oe(1,a.$yi),oe(2,g.$Zo),oe(3,d.$Wj)],O);let m=class extends A.$Uc{constructor(w,h){super(),this.j=h,this.c={},this.f=(0,S.$kc)(w.userDataPath,"languagepacks.json"),this.g=new k.$xh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(w){return this.s(h=>{Object.keys(h).forEach(p=>delete h[p]),this.m(h,...w)}).then(()=>this.c)}m(w,...h){for(const p of h)p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&this.n(w,p);Object.keys(w).forEach(p=>this.r(w[p]))}n(w,h){const p=h.identifier,i=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const r of i)if(h.location.scheme===R.Schemas.file&&c(r)){let t=w[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},w[r.languageId]=t);const n=t.extensions.filter(s=>(0,v.$op)(s.extensionIdentifier,p))[0];n?n.version=h.manifest.version:t.extensions.push({extensionIdentifier:p,version:h.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,S.$kc)(h.location.fsPath,s.path)}}r(w){if(w){const h=(0,D.createHash)("md5");for(const p of w.extensions)h.update(p.extensionIdentifier.uuid||p.extensionIdentifier.id).update(p.version);w.hash=h.digest("hex")}}s(w=()=>null){return this.g.queue(()=>{let h=null;return u.Promises.readFile(this.f,"utf8").then(void 0,p=>p.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(p)).then(p=>{try{return JSON.parse(p)}catch{return{}}}).then(p=>(h=w(p),p)).then(p=>{for(const r of Object.keys(p))p[r]||delete p[r];this.c=p,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),u.Promises.writeFile(this.f,i)}).then(()=>h,p=>this.j.error(p))})}};m=$e([oe(0,a.$yi),oe(1,d.$Wj)],m);function c(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const w of b.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}}),define(se[151],re([0,1,84,9,27,41]),function(Q,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lQ=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",S="https://mobile.events.data.microsoft.com/ping";async function u(g,v,d){const $=await(0,D.$RD)("@microsoft/1ds-core-js","dist/ms.core.js"),y=await(0,D.$RD)("@microsoft/1ds-post-js","dist/ms.post.js"),O=new $.AppInsightsCore,m=new y.PostChannel,c={instrumentationKey:g,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(d){c.extensionConfig={};const b={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};c.extensionConfig[m.identifier]=b}return O.initialize(c,[]),O.addTelemetryInitializer(b=>{b.ext=b.ext??{},b.ext.web=b.ext.web??{},b.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(b.ext.utc=b.ext.utc??{},b.ext.utc.flags=8462029)}),O}class a{constructor(v,d,$,y,O){this.e=v,this.f=d,this.g=$,this.h=O,this.c=R,this.d=S,this.g||(this.g={}),typeof y=="function"?this.a=y():this.a=y,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(d=>{v(d)},d=>{(0,j.$1)(d),console.error(d)})}}log(v,d){if(!this.a)return;d=(0,k.$Zn)(d,this.g),d=(0,A.$jp)(d);const $=this.f+"/"+v;try{this.i(y=>{y.pluginVersionString=d?.properties.version??"Unknown",y.track({name:$,baseData:{name:$,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$lQ=a}),define(se[152],re([0,1,2,27,12,30,109,29,40,153,32,36,22,41]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,b,w){this.k=b,this.l=w,this.d={},this.i=new D.$Tc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,A.$8e)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$8e)(h.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(h=>{(h.affectsConfiguration(d.$4l)||h.affectsConfiguration(d.$6l)||h.affectsConfiguration(d.$5l))&&this.m()}))}setExperimentProperty(c,b){this.d[c]=b}m(){let c=(0,$.$ip)(this.k);const b=this.l.enabledTelemetryLevels;if(b){this.h=this.sendErrorTelemetry?b.error:!1;const w=b.usage?3:b.error?2:0;c=Math.min(c,w)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,b,w){this.g<b||(w=(0,j.$Zn)(w,this.d),w=(0,$.$np)(w,this.j),w=(0,j.$Zn)(w,this.c),this.b.forEach(h=>h.log(c,w)))}publicLog(c,b){this.n(c,3,b)}publicLog2(c,b){this.publicLog(c,b)}publicLogError(c,b){this.h&&this.n(c,2,b)}publicLogError2(c,b){this.publicLogError(c,b)}};e.$Rr=y,e.$Rr=y=$e([oe(1,S.$Wi),oe(2,g.$dk)],y);function O(){const m=(0,R.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),b=k.$o?"":(0,R.localize)(3,null),w=(0,R.localize)(4,null),h=(0,R.localize)(5,null),p=(0,R.localize)(6,null),i=(0,R.localize)(7,null),r=`
|       | ${w} | ${h} | ${p} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,R.localize)(8,null);return`
${m} ${c} ${b}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}v.$9n.as(u.$bo.Configuration).registerConfiguration({id:d.$3l,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[d.$4l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:O(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$9n.as(u.$bo.Configuration).registerConfiguration({id:d.$3l,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[d.$6l]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,R.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,R.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${d.$4l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[154],re([0,1,14,20,177,151]),function(Q,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mQ=void 0;async function R(g,v){const d=await v.request(g,j.CancellationToken.None),$=(await(0,D.$Oe)(d.stream)).toString(),y=d.res.statusCode??200;return{headers:d.res.headers,statusCode:y,responseData:$}}async function S(g){const v={method:g.type,headers:g.headers};return new Promise(($,y)=>{const O=k.request(g.url??"",v,m=>{m.on("data",function(c){$({headers:m.headers,statusCode:m.statusCode??200,responseData:c.toString()})}),m.on("error",function(c){y(c)})});O.write(g.data,m=>{m&&y(m)}),O.end()})}async function u(g,v,d){const $=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),y={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:$};try{const O=g?await R(y,g):await S(y);d(O.statusCode,O.headers,O.responseData)}catch{d(0,{})}}class a extends A.$lQ{constructor(v,d,$,y,O){const m={sendPOST:(c,b)=>{u(v,c,b)}};super(d,$,y,O,m)}}e.$mQ=a}),define(se[155],re([0,1,16,25]),function(Q,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=k;async function k(A,R){const S=Object.create(null),u=(g,v)=>{const d=JSON.parse(g);S[v]=d};if(R){const g=[],v=await j.Promises.readdir(R);for(const $ of v)try{(await j.Promises.stat((0,D.$kc)(R,$))).isDirectory()&&g.push($)}catch{}const d=[];for(const $ of g)(await j.Promises.readdir((0,D.$kc)(R,$))).filter(O=>O==="telemetry.json").length===1&&d.push($);for(const $ of d){const y=(await j.Promises.readFile((0,D.$kc)(R,$,"telemetry.json"))).toString();u(y,$)}}let a=(await j.Promises.readFile((0,D.$kc)(A,"telemetry-core.json"))).toString();return u(a,"vscode-core"),a=(await j.Promises.readFile((0,D.$kc)(A,"telemetry-extensions.json"))).toString(),u(a,"vscode-extensions"),JSON.stringify(S,null,4)}}),define(se[156],re([0,1,12,85,22]),function(Q,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=A,e.$ecc=R;async function A(S,u){let a=S.getItem(k.$1l);return(typeof a!="string"||D.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,j.$zn)(u.error.bind(u))),a}async function R(S,u){let a=S.getItem(k.$2l);return typeof a!="string"&&(a=await(0,j.$An)(u.error.bind(u))),a}}),define(se[23],re([0,1,10]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=void 0,e.$ul=(0,D.$qi)("IUriIdentityService")}),define(se[157],re([0,1,23,119,13,17,76,5,2]),function(Q,e,D,j,k,A,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0;class a{static{this._clock=0}constructor(d){this.uri=d,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let g=class{constructor(d){this.g=d,this.c=new u.$Tc,this.f=2**16;const $=new Map,y=O=>{let m=$.get(O.scheme);return m===void 0&&(m=d.hasProvider(O)&&!this.g.hasCapability(O,1024),$.set(O.scheme,m)),m};this.c.add(S.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(O=>{$.delete(O.scheme)})),this.extUri=new A.$Sg(y),this.d=new R.$qs((O,m)=>this.extUri.compare(O,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$5g)(d));const $=this.d.get(d);return $?$.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new a(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((y,O)=>y[1].time<O[1].time?1:y[1].time>O[1].time?-1:0);a._clock=0,this.d.clear();const $=this.f*.5;for(let y=0;y<$;y++)this.d.set(d[y][0],d[y][1].touch())}};e.$rs=g,e.$rs=g=$e([oe(0,k.$Wk)],g),(0,j.$os)(D.$ul,g,1)}),define(se[158],re([0,1,5,2,13,48,31]),function(Q,e,D,j,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;class S extends j.$Uc{constructor(a,g,v,d,$,y){super(),this.f=a,this.g=g,this.h=v,this.j=d,this.m=$,this.n=y,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$be),this.onDidChangeFile=this.a.event,this.b=A.$wi.forUris(()=>!(this.capabilities&1024)),this.c=new R.$Cc(O=>this.m.extUri.getComparisonKey(this.t(O))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(O=>this.s(O)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,g){return this.g.open(this.t(a),g)}close(a){return this.g.close(a)}read(a,g,v,d,$){return this.g.read(a,g,v,d,$)}write(a,g,v,d,$){return this.g.write(a,g,v,d,$)}watch(a,g){this.b.set(a,a);const v=this.g.watch(this.t(a),g);return(0,j.$Sc)(()=>{this.b.delete(a),v.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,g,v){return this.g.rename(this.t(a),this.t(g),v)}readFile(a,g){return this.g.readFile(this.t(a),g)}readFileStream(a,g,v){return this.g.readFileStream(this.t(a),g,v)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,g,v){return this.g.writeFile(this.t(a),g,v)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,g){return this.g.delete(this.t(a),g)}copy(a,g,v){if((0,k.$1k)(this.g))return this.g.copy(this.t(a),this.t(g),v);throw new Error("copy not supported")}cloneFile(a,g){if((0,k.$2k)(this.g))return this.g.cloneFile(this.t(a),this.t(g));throw new Error("clone not supported")}s(a){const g=[];for(const v of a){if(v.resource.scheme!==this.f)continue;const d=this.u(v.resource);this.b.findSubstr(d)&&g.push({resource:d,type:v.type,cId:v.cId})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Bcc=S}),define(se[159],re([0,1,111,16,48,17,11,10,15]),function(Q,e,D,j,k,A,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Ki=e.$Ji=e.WorkbenchState=e.$Di=e.$Ci=e.$zi=void 0,e.$Ai=a,e.$Bi=g,e.$Ei=v,e.$Fi=d,e.$Gi=$,e.$Hi=O,e.$Ii=m,e.$Li=w,e.$Qi=h,e.$Ri=p,e.$Ti=i,e.$Ui=r,e.$Vi=t,e.$zi=(0,S.$qi)("contextService");function a(n){const s=n;return typeof s?.id=="string"&&R.URI.isUri(s.uri)}function g(n){return typeof n?.id=="string"&&!a(n)&&!d(n)}e.$Ci={id:"ext-dev"},e.$Di={id:"empty-window"};function v(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,j.$oc)(n)}:s?e.$Ci:e.$Di;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function d(n){const s=n;return typeof s?.id=="string"&&R.URI.isUri(s.configPath)}function $(n){const s=n;if(s?.uri)return{id:s.id,uri:R.URI.revive(s.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:R.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}var y;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function O(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function m(n){const s=n;return!!(s&&typeof s=="object"&&R.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class c{constructor(s,o,l,P,I){this.h=s,this.j=l,this.k=P,this.l=I,this.c=k.$wi.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=k.$wi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ji=c;class b{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.$4g)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ki=b;function w(n){return new b({uri:n,index:0,name:(0,A.$Zg)(n)},{uri:n.toString()})}e.$Mi="code-workspace",e.$Ni=`.${e.$Mi}`,e.$Oi=[{name:(0,D.localize)(0,null),extensions:[e.$Mi]}],e.$Pi="workspace.json";function h(n,s){return A.$Ug.isEqualOrParent(n,s.untitledWorkspacesHome)}function p(n){let s;return R.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===u.Schemas.tmp}e.$Si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.$Si}function r(n,s){return!h(n,s)&&!p(n)}function t(n){return(typeof n=="string"?(0,j.$pc)(n):(0,A.$2g)(n))===e.$Ni}}),define(se[24],re([0,1,43,5,2,17,11,110,18,13,10,6,159,31,23,8,28,30,3]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$,y,O,m,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.$wl=e.ProfileResourceType=void 0,e.$vl=h,e.$xl=p,e.$yl=i;var w;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(w||(e.ProfileResourceType=w={}));function h(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&R.URI.isUri(s.location)&&R.URI.isUri(s.globalStorageHome)&&R.URI.isUri(s.settingsResource)&&R.URI.isUri(s.keybindingsResource)&&R.URI.isUri(s.tasksResource)&&R.URI.isUri(s.snippetsHome)&&R.URI.isUri(s.extensionsResource))}e.$wl=(0,g.$qi)("IUserDataProfilesService");function p(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:R.URI.revive(n.location).with({scheme:s}),globalStorageHome:R.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:R.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:R.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:R.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:R.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:R.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:R.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function i(n,s,o,l,P,I){return{id:n,name:s,location:o,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:I&&P?.useDefaultFlags?.globalState?I.globalStorageHome:(0,A.$4g)(o,"globalStorage"),settingsResource:I&&P?.useDefaultFlags?.settings?I.settingsResource:(0,A.$4g)(o,"settings.json"),keybindingsResource:I&&P?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,A.$4g)(o,"keybindings.json"),tasksResource:I&&P?.useDefaultFlags?.tasks?I.tasksResource:(0,A.$4g)(o,"tasks.json"),snippetsHome:I&&P?.useDefaultFlags?.snippets?I.snippetsHome:(0,A.$4g)(o,"snippets"),extensionsResource:I&&P?.useDefaultFlags?.extensions?I.extensionsResource:(0,A.$4g)(o,"extensions.json"),cacheHome:(0,A.$4g)(l,n),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let r=class extends k.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,l,P){super(),this.t=s,this.u=o,this.w=l,this.y=P,this.f=!0,this.h=this.B(new j.$be),this.onDidChangeProfiles=this.h.event,this.j=this.B(new j.$be),this.onWillCreateProfile=this.j.event,this.m=this.B(new j.$be),this.onWillRemoveProfile=this.m.event,this.n=this.B(new j.$be),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new $.$Bc,emptyWindows:new Map},this.profilesHome=(0,A.$4g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$4g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,b.$4f)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}o.push(i((0,A.$1g)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},s))}}catch(I){this.y.error(I)}const l=new $.$Bc,P=new Map;if(o.length)try{const I=this.Q();if(I.workspaces)for(const[z,N]of Object.entries(I.workspaces)){const U=R.URI.parse(z),V=o.find(J=>J.id===N);V&&l.set(U,V)}if(I.emptyWindows)for(const[z,N]of Object.entries(I.emptyWindows)){const U=o.find(V=>V.id===N);U&&P.set(z,U)}}catch(I){this.y.error(I)}this.z={profiles:o,workspaces:l,emptyWindows:P}}return this.z}D(){const s=i("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",l=new RegExp(`${(0,c.$8e)(o)}\\s(\\d+)`);let P=0;for(const z of this.profiles){const N=l.exec(z.name),U=N?parseInt(N[1]):0;P=U>P?U:P}const I=`${o} ${P+1}`;return this.createProfile((0,D.$ej)((0,m.$Mg)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,o,l){return this.createProfile((0,D.$ej)((0,m.$Mg)()).toString(16),s,o,l)}async createProfile(s,o,l,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(s,o,l);return P&&await this.setProfileForWorkspace(P,I),I}async F(s,o,l){if(!(0,b.$4f)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(o);return P||(P=(async()=>{try{if(this.profiles.find(U=>U.name===o||U.id===s))throw new Error(`Profile with ${o} name already exists`);const z=i(s,o,(0,A.$4g)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(z.location);const N=[];return this.j.fire({profile:z,join(U){N.push(U)}}),await O.Promises.settled(N),this.I([z],[],[]),z}finally{this.r.delete(o)}})(),this.r.set(o,P)),P}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(P=>P.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=i(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(P=>P.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:o,join(P){l.push(P)}});try{await Promise.allSettled(l)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(P){(0,a.$bl)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(P=>P.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return R.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,d.$Ai)(s)?s.uri:(0,d.$Fi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,l){const P=[...this.profiles,...s],I=[];this.s.profiles=[];for(let z of P)z.isDefault||o.some(N=>z.id===N.id)||(z=l.find(N=>z.id===N.id)??z,z.isTransient?this.s.profiles.push(z):I.push({location:z.location,name:z.name,shortName:z.shortName,icon:z.icon,useDefaultFlags:z.useDefaultFlags}));this.P(I),this.z=void 0,this.J(s,o,l)}J(s,o,l){this.h.fire({added:s,removed:o,updated:l,all:this.profiles})}L(s,o,l){l=o?.isTransient?!0:l,l||this.L(s,void 0,!0);const P=this.G(s),I=l?this.s:this.C;R.URI.isUri(P)?(I.workspaces.delete(P),o&&I.workspaces.set(P,o)):(I.emptyWindows.delete(P),o&&I.emptyWindows.set(P,o)),l||this.M()}M(){const s={};for(const[l,P]of this.C.workspaces.entries())s[l.toString()]=P.id;const o={};for(const[l,P]of this.C.emptyWindows.entries())o[l.toString()]=P.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},l=this.D();if(s.workspaces)for(const[I,z]of Object.entries(s.workspaces)){const N=R.URI.parse(z);o[I]=this.w.extUri.isEqual(N,l.location)?l.id:this.w.extUri.basename(N)}const P={};if(s.emptyWindows)for(const[I,z]of Object.entries(s.emptyWindows)){const N=R.URI.parse(z);P[I]=this.w.extUri.isEqual(N,l.location)?l.id:this.w.extUri.basename(N)}return{workspaces:o,emptyWindows:P}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$zl=r,e.$zl=r=$e([oe(0,u.$xi),oe(1,a.$Wk),oe(2,y.$ul),oe(3,v.$Wj)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Al=t}),define(se[160],re([0,1,19,8,20,9,5,2,12,3,11,94,21,26,37,6,32,22,23,24]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$,y,O,m,c,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$eq=void 0,e.$fq=p,e.$gq=i;let h=class extends S.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,l,P,I,z){super(),this.z=s,this.C=o,this.D=l,this.F=P,this.G=I,this.H=z,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new R.$be),this.s=this.B(new R.$be),this.t=this.B(new R.$be),this.u=this.B(new R.$be),this.w=this.B(new R.$be),this.y=[],this.B((0,S.$Sc)(()=>{this.j.forEach(({task:N})=>N.cancel()),this.m.forEach(N=>N.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,d.$Xo)(l,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const P=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:I})=>(0,$.$op)(I,s.identifier));if(P?.local)return P?.local;throw P?.error?P.error:new d.$1o(`Unknown error while installing extension ${s.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(l){throw i(l)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new d.$1o(v.localize(0,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],l=[];await Promise.allSettled(s.map(async({extension:P,options:I})=>{try{const z=await this.N(P,!!I?.installGivenVersion,!!I?.installPreReleaseVersion,I.productVersion??{version:this.G.version,date:this.G.date});l.push({...z,options:I})}catch(z){o.push({identifier:P.identifier,operation:2,source:P,error:z})}})),l.length&&o.push(...await this.I(l));for(const P of o)P.error&&(this.F.error("Failed to install extension.",P.identifier.id),this.F.error(P.error),P.source&&!g.URI.isUri(P.source)&&r(this.C,"extensionGallery:install",{extensionData:(0,$.$wp)(P.source),error:P.error}));return o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,y.$Om)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let l=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(l=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const P of this.H.profiles){const I=(await this.getInstalled(1,P.extensionsResource)).find(z=>(0,$.$op)(z.identifier,s.identifier));I?this.w.fire(I):this.u.fire({identifier:s.identifier,profileLocation:P.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const o=new Map,l=new Map,P=[],I=(N,U)=>`${$.$pp.create(N).toString()}-${U.toString()}`,z=(N,U,V,J)=>{const _=this.Y(N,U,V),K=`${(0,$.$tp)(N.publisher,N.name)}-${V.profileLocation.toString()}`;l.set(K,{task:_,root:J}),this.n.fire({identifier:_.identifier,source:U,profileLocation:V.profileLocation}),this.F.info("Installing extension:",_.identifier.id),g.URI.isUri(U)||this.j.set(I(U,V.profileLocation),{task:_,waitingTasks:[]})};try{for(const{manifest:N,extension:U,options:V}of s){const J=V.isApplicationScoped||V.isBuiltin||(0,y.$Om)(N),_={...V,installOnlyNewlyAddedFromExtensionPack:V.installOnlyNewlyAddedFromExtensionPack??!g.URI.isUri(U),isApplicationScoped:J,profileLocation:J?this.H.defaultProfile.extensionsResource:V.profileLocation??this.X(),productVersion:V.productVersion??{version:this.G.version,date:this.G.date}},K=g.URI.isUri(U)?void 0:this.j.get(I(U,_.profileLocation));K?(this.F.info("Extension is already requested to install",K.task.identifier.id),P.push(K.task.waitUntilTaskIsFinished())):z(N,U,_,void 0)}return await Promise.all([...l.values()].map(async({task:N})=>{if(N.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const U=await this.M(N.identifier,N.manifest,!!N.options.installOnlyNewlyAddedFromExtensionPack,!!N.options.installPreReleaseVersion,N.options.profileLocation,N.options.productVersion),V=await this.getInstalled(void 0,N.options.profileLocation,N.options.productVersion),J={...N.options,context:{...N.options.context,[d.$So]:!0}};for(const{gallery:_,manifest:K}of(0,D.$Mb)(U,({gallery:le})=>le.identifier.id)){if(l.has(`${_.identifier.id.toLowerCase()}-${J.profileLocation.toString()}`))continue;const le=this.j.get(I(_,J.profileLocation));if(le){if(this.J(N,le.task)){const ue=le.task.identifier;this.F.info("Waiting for already requested installing extension",ue.id,N.identifier.id),le.waitingTasks.push(N),P.push(R.Event.toPromise(R.Event.filter(this.onDidInstallExtensions,ae=>ae.some(B=>(0,$.$op)(B.identifier,ue)))).then(ae=>{if(this.F.info("Finished waiting for already requested installing extension",ue.id,N.identifier.id),!ae.find(Z=>(0,$.$op)(Z.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else V.some(({identifier:ue})=>(0,$.$op)(ue,_.identifier))||z(K,_,J,N)}}catch(U){if(g.URI.isUri(N.source))(0,D.$Lb)(N.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",N.identifier.id,U.message),(0,D.$Lb)(N.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",N.identifier.id,U.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),U}})),await this.L([...l.entries()].map(async([N,{task:U}])=>{const V=new Date().getTime();try{const J=await U.run();if(await this.L(this.y.map(_=>_.postInstall(J,U.source,U.options,k.CancellationToken.None))),!g.URI.isUri(U.source)){const _=U.operation===3,K=_?void 0:(new Date().getTime()-U.source.lastUpdated)/1e3;if(r(this.C,_?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$wp)(U.source),verificationStatus:U.verificationStatus,duration:new Date().getTime()-V,durationSinceUpdate:K}),u.$o&&U.operation!==3)try{await this.z.reportStatistic(J.manifest.publisher,J.manifest.name,J.manifest.version,"install")}catch{}}o.set(N,{local:J,identifier:U.identifier,operation:U.operation,source:U.source,context:U.options.context,profileLocation:U.profileLocation,applicationScoped:J.isApplicationScoped})}catch(J){throw o.set(N,{error:J,identifier:U.identifier,operation:U.operation,source:U.source,context:U.options.context,profileLocation:U.profileLocation,applicationScoped:U.options.isApplicationScoped}),this.F.error("Error while installing the extension",U.identifier.id,(0,A.$0)(J)),J}})),P.length&&await this.L(P),[...o.values()]}catch(N){const U=(_,K,le)=>{const ue=[];_.manifest.extensionDependencies?.length&&ue.push(..._.manifest.extensionDependencies),_.manifest.extensionPack?.length&&ue.push(..._.manifest.extensionPack);for(const ae of ue){if(le.includes(ae.toLowerCase()))continue;le.push(ae.toLowerCase());const B=o.get(`${ae.toLowerCase()}-${K.toString()}`);B?.local&&(le=U(B.local,K,le))}return le},V=_=>({identifier:_.identifier,operation:2,source:_.source,context:_.options.context,profileLocation:_.profileLocation,error:N}),J=[];for(const[_,{task:K,root:le}]of l){const ue=o.get(_);ue?ue.local&&le&&!o.get(`${le.identifier.id.toLowerCase()}-${K.profileLocation.toString()}`)?.local&&(J.push(this.Z(ue.local,{versionOnly:!0,profileLocation:K.profileLocation})),o.set(_,V(K))):(K.cancel(),o.set(_,V(K)))}for(const[_,{task:K}]of l){const le=o.get(_);if(!le?.local||K.options.donotIncludePackAndDependencies)continue;U(le.local,K.profileLocation,[le.local.identifier.id.toLowerCase()]).slice(1).some(ae=>l.has(`${ae.toLowerCase()}-${K.profileLocation.toString()}`)&&!o.get(`${ae.toLowerCase()}-${K.profileLocation.toString()}`)?.local)&&(J.push(this.Z(le.local,{versionOnly:!0,profileLocation:K.profileLocation})),o.set(_,V(K)))}throw J.length&&await Promise.allSettled(J.map(async _=>{try{await _.run(),this.F.info("Rollback: Uninstalled extension",_.extension.identifier.id)}catch(K){this.F.warn("Rollback: Error while uninstalling extension",_.extension.identifier.id,(0,A.$0)(K))}})),N}finally{for(const{task:N}of l.values())N.source&&!g.URI.isUri(N.source)&&this.j.delete(I(N.source,N.profileLocation));if(o.size){const N=[...o.values()];for(const U of N)U.local&&this.F.info("Extension installed successfully:",U.identifier.id);this.s.fire(N)}}}J(s,o){for(const[,{task:l,waitingTasks:P}]of this.j.entries())if(l===s&&(P.includes(o)||P.some(I=>this.J(I,o)))||l===o&&P[0]&&!this.J(s,P[0]))return!1;return!0}async L(s){const o=[],l=[],P=await Promise.allSettled(s);for(const I of P)I.status==="fulfilled"?o.push(I.value):l.push(I.reason);if(l.length)throw p(l);return o}async M(s,o,l,P,I,z){if(!this.z.isEnabled())return[];const N=await this.getInstalled(void 0,I,z),U=[],V=[],J=async(_,K)=>{U.push(_);const le=K.extensionDependencies||[],ue=[...le];if(K.extensionPack){const ae=l?N.find(B=>(0,$.$op)(B.identifier,_)):void 0;for(const B of K.extensionPack)ae&&ae.manifest.extensionPack&&ae.manifest.extensionPack.some(Z=>(0,$.$op)({id:Z},{id:B}))||ue.every(Z=>!(0,$.$op)({id:Z},{id:B}))&&ue.push(B)}if(ue.length){const ae=ue.filter(B=>U.every(Z=>!(0,$.$op)(Z,{id:B})));if(ae.length){const B=await this.z.getExtensions(ae.map(Z=>({id:Z,preRelease:P})),k.CancellationToken.None);for(const Z of B){if(U.find(W=>(0,$.$op)(W,Z.identifier)))continue;const T=le.some(W=>(0,$.$op)({id:W},Z.identifier));let q;try{q=await this.N(Z,!1,P,z)}catch(W){if(T)throw W;this.F.info("Skipping the packed extension as it cannot be installed",Z.identifier.id,(0,A.$0)(W));continue}V.push({gallery:q.extension,manifest:q.manifest}),await J(q.extension.identifier,q.manifest)}}}};return await J(s,o),V}async N(s,o,l,P){let I;const z=await this.getExtensionsControlManifest();if(z.malicious.some(V=>(0,$.$op)(s.identifier,V)))throw new d.$1o(v.localize(1,null,s.identifier.id),d.ExtensionManagementErrorCode.Malicious);const N=z.deprecated[s.identifier.id.toLowerCase()];if(N?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${N.extension.id}' extension instead.`),I=(await this.z.getExtensions([{id:N.extension.id,preRelease:N.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:P},k.CancellationToken.None))[0],!I)throw new d.$1o(v.localize(2,null,s.identifier.id,N.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const V=await this.getTargetPlatform();throw new d.$1o(v.localize(3,null,s.identifier.id,this.G.nameLong,(0,d.$To)(V)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.O(s,o,l,P),!I)throw!l&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],k.CancellationToken.None))[0]?new d.$1o(v.localize(4,null,s.displayName??s.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$1o(v.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",I.identifier.id);const U=await this.z.getManifest(I,k.CancellationToken.None);if(U===null)throw new d.$1o(`Missing manifest for extension ${I.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(U.version!==I.version)throw new d.$1o(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:U}}async O(s,o,l,P){const I=await this.getTargetPlatform();let z=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(z=(await this.z.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:I,compatible:!0,productVersion:P},k.CancellationToken.None))[0]||null),!z&&await this.z.isExtensionCompatible(s,l,I,P)&&(z=s),z||(o?z=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:I,compatible:!0,productVersion:P},k.CancellationToken.None))[0]||null:z=await this.z.getCompatibleExtension(s,l,I,P)),z}async P(s,o){const l={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},P=J=>`${J.id.toLowerCase()}${l.versionOnly?`-${s.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,I=this.m.get(P(s.identifier));if(I)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),I.waitUntilTaskIsFinished();const z=J=>{const _=this.Z(J,l);return this.m.set(P(_.extension.identifier),_),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${J.identifier.id}@${J.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${J.identifier.id}@${J.manifest.version}`),this.t.fire({identifier:J.identifier,profileLocation:l.profileLocation,applicationScoped:J.isApplicationScoped}),_},N=(J,_)=>{_?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${J.identifier.id}@${J.manifest.version}`,l.profileLocation.toString(),_.message):this.F.error("Failed to uninstall extension:",`${J.identifier.id}@${J.manifest.version}`,_.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${J.identifier.id}@${J.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${J.identifier.id}@${J.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$vp)(J),error:_}),this.u.fire({identifier:J.identifier,error:_?.code,profileLocation:l.profileLocation,applicationScoped:J.isApplicationScoped})},U=[],V=[];try{U.push(z(s));const J=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const _=this.S(s,J);for(const K of _)this.m.has(P(K.identifier))?this.F.info("Extensions is already requested to uninstall",K.identifier.id):U.push(z(K))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(U.map(_=>_.extension),J,s),await this.L(U.map(async _=>{try{if(await _.run(),await this.L(this.y.map(K=>K.postUninstall(_.extension,l,k.CancellationToken.None))),_.extension.identifier.uuid)try{await this.z.reportStatistic(_.extension.manifest.publisher,_.extension.manifest.name,_.extension.manifest.version,"uninstall")}catch{}N(_.extension)}catch(K){const le=K instanceof d.$1o?K:new d.$1o((0,A.$0)(K),d.ExtensionManagementErrorCode.Internal);throw N(_.extension,le),le}finally{V.push(_)}}))}catch(J){const _=J instanceof d.$1o?J:new d.$1o((0,A.$0)(J),d.ExtensionManagementErrorCode.Internal);for(const K of U){try{K.cancel()}catch{}V.includes(K)||N(K.extension,_)}throw _}finally{for(const J of U)this.m.delete(P(J.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",J.extension.identifier.id)}}Q(s,o,l){for(const P of s){const I=this.U(P,o);if(I.length){const z=I.filter(N=>!s.some(U=>(0,$.$op)(U.identifier,N.identifier)));if(z.length)throw new Error(this.R(P,z,l))}}}R(s,o,l){return l===s?o.length===1?v.localize(6,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?v.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):v.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?v.localize(9,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?v.localize(10,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):v.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const P=s.manifest.extensionPack?s.manifest.extensionPack:[];if(P.length){const I=o.filter(N=>!N.isBuiltin&&P.some(U=>(0,$.$op)({id:U},N.identifier))),z=[];for(const N of I)z.push(...this.S(N,o,l));return[...I,...z]}return[]}U(s,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(P=>(0,$.$op)({id:P},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$eq=h,e.$eq=h=$e([oe(0,d.$Zo),oe(1,c.$Vl),oe(2,b.$ul),oe(3,O.$Wj),oe(4,m.$dk),oe(5,w.$wl)],h);function p(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}function i(n){if(n instanceof d.$1o)return n;if(n instanceof d.$2o){const o=new d.$1o(n.message,d.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const s=new d.$1o(n.message,d.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}function r(n,s,{extensionData:o,verificationStatus:l,duration:P,error:I,durationSinceUpdate:z}){let N,U;(0,a.$_f)(l)&&(l===!0?l="Verified":(l===!1||(N=d.ExtensionManagementErrorCode.Signature,U=l),l="Unverified")),I&&(I instanceof d.$1o||I instanceof d.$2o?(N=I.code,I.code===d.ExtensionManagementErrorCode.Signature&&(U=I.message)):N=d.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...o,verificationStatus:l,success:!I,duration:P,errorcode:N,errorcodeDetail:U,durationSinceUpdate:z})}class t{constructor(){this.d=new j.$ph}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,j.$dh)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,j.$dh)(s=>new Promise((o,l)=>{const P=s.onCancellationRequested(()=>{P.dispose(),l(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$hq=t}),define(se[42],re([0,1,8,14,2,5,31,11,21,26,13,10,6,24,23,3,9,22]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$,y,O,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=e.$iq=e.ExtensionsProfileScanningErrorCode=void 0;var b;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(b||(e.ExtensionsProfileScanningErrorCode=b={}));class w extends Error{constructor(t,n){super(t),this.code=n}}e.$iq=w,e.$jq=(0,v.$qi)("IExtensionsProfileScannerService");let h=class extends k.$Uc{constructor(t,n,s,o,l,P){super(),this.j=t,this.m=n,this.n=s,this.r=o,this.s=l,this.t=P,this.b=this.B(new A.$be),this.onAddExtensions=this.b.event,this.c=this.B(new A.$be),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$be),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$be),this.onDidRemoveExtensions=this.g.event,this.h=new R.$Bc}scanProfileExtensions(t,n){return this.u(t,void 0,n)}async addExtensionsToProfile(t,n,s){const o=[],l=[];try{return await this.u(n,P=>{const I=[];if(s)I.push(...P);else for(const z of P)t.some(([N])=>(0,a.$op)(N.identifier,z.identifier)&&N.manifest.version!==z.version)?o.push(z):I.push(z);for(const[z,N]of t){const U=I.findIndex(J=>(0,a.$op)(J.identifier,z.identifier)&&J.version===z.manifest.version),V={identifier:z.identifier,version:z.manifest.version,location:z.location,metadata:N};U===-1?(l.push(V),I.push(V)):I.splice(U,1,V)}return l.length&&this.b.fire({extensions:l,profileLocation:n}),o.length&&this.f.fire({extensions:o,profileLocation:n}),I}),l.length&&this.c.fire({extensions:l,profileLocation:n}),o.length&&this.g.fire({extensions:o,profileLocation:n}),l}catch(P){throw l.length&&this.c.fire({extensions:l,error:P,profileLocation:n}),o.length&&this.g.fire({extensions:o,error:P,profileLocation:n}),P}}async updateMetadata(t,n){const s=[];return await this.u(n,o=>{const l=[];for(const P of o){const I=t.find(([z])=>(0,a.$op)(z.identifier,P.identifier)&&z.manifest.version===P.version);I&&(P.metadata={...P.metadata,...I[1]},s.push(P)),l.push(P)}return l}),s}async removeExtensionFromProfile(t,n){const s=[];try{await this.u(n,o=>{const l=[];for(const P of o)(0,a.$op)(P.identifier,t.identifier)?s.push(P):l.push(P);return s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:n}),o}}async u(t,n,s){return this.F(t).queue(async()=>{let o=[],l;try{const P=await this.m.readFile(t);l=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,g.$bl)(P)!==1)throw P;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new w((0,m.$0)(P),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let P=!1;for(const I of l){p(I)||this.w(t);let z;if((0,O.$4f)(I.relativeLocation)&&I.relativeLocation)z=this.z(I.relativeLocation);else if((0,O.$4f)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{z=S.URI.revive(I.location);const N=this.y(z);N&&(P=!0,I.relativeLocation=N)}(0,O.$$f)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(P=!0,I.metadata.hasPreReleaseVersion=!0),o.push({identifier:I.identifier,location:z,version:I.version,metadata:I.metadata})}P&&await this.m.writeFile(t,j.$Ce.fromString(JSON.stringify(l)))}if(n){o=n(o);const P=o.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(t,j.$Ce.fromString(JSON.stringify(P)))}return o})}w(t){const n=new w(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(l){if((0,g.$bl)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(P=>p(P))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,j.$Ce.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,g.$bl)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,g.$bl)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,g.$bl)(l)!==1&&this.t.error(l)}return o})()),this.C}F(t){let n=this.h.get(t);return n||(n=new D.$xh,this.h.set(t,n)),n}};e.$kq=h,e.$kq=h=$e([oe(1,g.$Wk),oe(2,$.$wl),oe(3,y.$ul),oe(4,c.$Vl),oe(5,d.$Wj)],h);function p(r){return(0,O.$6f)(r)&&(0,u.$Yo)(r.identifier)&&(i(r.location)||(0,O.$4f)(r.location)&&r.location)&&((0,O.$$f)(r.relativeLocation)||(0,O.$4f)(r.relativeLocation))&&r.version&&(0,O.$4f)(r.version)}function i(r){return r?(0,O.$4f)(r.path)&&(0,O.$4f)(r.scheme):!1}}),define(se[53],re([0,1,19,8,27,14,9,38,82,2,15,16,12,17,44,55,3,11,98,18,26,37,50,13,10,6,32,5,47,42,24,23,116]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$,y,O,m,c,b,w,h,p,i,r,t,n,s,o,l,P,I,z,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$pq=e.$oq=e.$nq=e.Translations=void 0,e.$qq=le;var U;(function(ae){function B(Z,T){if(Z===T)return!0;const q=Object.keys(Z),W=new Set;for(const X of Object.keys(T))W.add(X);if(q.length!==W.size)return!1;for(const X of q){if(Z[X]!==T[X])return!1;W.delete(X)}return W.size===0}ae.equals=B})(U||(e.Translations=U={})),e.$nq=(0,t.$qi)("IExtensionsScannerService");let V=class extends a.$Uc{constructor(B,Z,T,q,W,X,Y,te,C,M,f,E){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=Z,this.r=T,this.s=q,this.t=W,this.u=X,this.w=Y,this.y=te,this.z=C,this.C=M,this.D=f,this.F=E,this.g=this.B(new o.$be),this.onDidChangeCache=this.g.event,this.h=(0,$.$4g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(K,this.s,this.h)),this.m=this.B(this.F.createInstance(K,this.s,this.h)),this.n=this.B(this.F.createInstance(_,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,h.$zp)(this.w,this.y)),this.G}async scanAllExtensions(B,Z,T){const[q,W]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(Z)]),X=T?await this.scanExtensionsUnderDevelopment(B,[...q,...W]):[];return this.L(q,W,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const Z=[];Z.push(this.M(!!B.useCache,B.language)),Z.push(this.N(B.language,!!B.checkControlFile));const[T,q]=await Promise.all(Z);return this.J([...T,...q],0,B,!1)}async scanUserExtensions(B){const Z=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const T=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.P(Z,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,T,B.productVersion??this.R()),W=B.useCache&&!q.devMode&&q.excludeObsolete?this.m:this.n;let X;try{X=await W.scanExtensions(q)}catch(Y){if(Y instanceof P.$iq&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await W.scanExtensions(q);else throw Y}return X=await this.J(X,1,B,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(B,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(q=>q.scheme===g.Schemas.file).map(async q=>{const W=await this.P(q,!1,1,!0,B.language,!1,void 0,B.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(W)).map(Y=>(Y.type=Z.find(te=>(0,h.$op)(te.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,W)))}))).flat();return this.J(T,"development",B,!0)}return[]}async scanExistingExtension(B,Z,T){const q=await this.P(B,!1,Z,!0,T.language,!0,void 0,T.productVersion??this.R()),W=await this.n.scanExtension(q);return!W||!T.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(B,Z,T){const q=await this.P(B,!1,Z,!0,T.language,!0,void 0,T.productVersion??this.R()),W=await this.n.scanOneOrMultipleExtensions(q);return this.J(W,Z,T,!0)}async scanMultipleExtensions(B,Z,T){const q=[];return await Promise.all(B.map(async W=>{const X=await this.scanOneOrMultipleExtensions(W,Z,T);q.push(...X)})),this.J(q,Z,T,!0)}async scanMetadata(B){const Z=(0,$.$4g)(B,"package.json"),T=(await this.w.readFile(Z)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(B,Z){const T=(0,$.$4g)(B,"package.json"),q=(await this.w.readFile(T)).value.toString(),W=JSON.parse(q);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,W.__metadata={...W.__metadata,...Z},await this.w.writeFile((0,$.$4g)(B,"package.json"),A.$Ce.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof P.$iq&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$Ce.fromString(JSON.stringify([])))}catch(Z){(0,r.$bl)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.$0)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,Z,T,q){return T.includeAllVersions||(B=this.L(Z===0?B:void 0,Z===1?B:void 0,Z==="development"?B:void 0,await this.getTargetPlatform(),q)),T.includeInvalid||(B=B.filter(W=>W.isValid)),B.sort((W,X)=>{const Y=v.$oc(W.location.fsPath),te=v.$oc(X.location.fsPath);return Y<te?-1:Y>te?1:0})}L(B,Z,T,q,W){const X=(te,C,M)=>{if(te.isValid&&!C.isValid)return!1;if(te.isValid===C.isValid){if(W&&y.gt(te.manifest.version,C.manifest.version))return this.y.debug(`Skipping extension ${C.location.path} with lower version ${C.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(y.eq(te.manifest.version,C.manifest.version)){if(te.type===0)return this.y.debug(`Skipping extension ${C.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===q)return this.y.debug(`Skipping extension ${C.location.path} from different target platform ${C.targetPlatform}`),!1}}return M?this.y.warn(`Overwriting user extension ${te.location.path} with ${C.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${C.location.path}.`),!0},Y=new p.$Nm;return B?.forEach(te=>{const C=Y.get(te.identifier.id);(!C||X(C,te,!1))&&Y.set(te.identifier.id,te)}),Z?.forEach(te=>{const C=Y.get(te.identifier.id);if(!C&&B&&te.type===0){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!C||X(C,te,!1))&&Y.set(te.identifier.id,te)}),T?.forEach(te=>{const C=Y.get(te.identifier.id);(!C||X(C,te,!0))&&Y.set(te.identifier.id,te),Y.set(te.identifier.id,te)}),[...Y.values()]}async M(B,Z){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0,this.R()),W=await(B&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",W.length),W}async N(B,Z){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const q=Z?await this.O():{},W=[],X=c.URI.file(v.$ic(v.$kc(g.$Kg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of T){const C=q[te.name]||"marketplace";switch(C){case"disabled":break;case"marketplace":W.push((0,$.$4g)(X,te.name));break;default:W.push(c.URI.file(C));break}}const Y=await Promise.all(W.map(async te=>this.n.scanExtension(await this.P(te,!1,0,!0,B,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,D.$Hb)(Y)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,Z,T,q,W,X,Y,te){const C=await this.f(W??d.$w),M=await this.Q(B),f=Z&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,E=f?await this.Q(f):void 0;return new J(B,M,f,E,Z,Y,T,q,X,te.version,te.date,this.C.commit,!this.z.isBuilt,W,C)}async Q(B){try{const Z=await this.w.stat(B);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$oq=V,e.$oq=V=$e([oe(4,I.$wl),oe(5,P.$jq),oe(6,r.$Wk),oe(7,n.$Wj),oe(8,w.$xi),oe(9,s.$dk),oe(10,z.$ul),oe(11,t.$pi)],V);class J{constructor(B,Z,T,q,W,X,Y,te,C,M,f,E,L,F,G){this.location=B,this.mtime=Z,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=q,this.profile=W,this.profileScanOptions=X,this.type=Y,this.excludeObsolete=te,this.validate=C,this.productVersion=M,this.productDate=f,this.productCommit=E,this.devMode=L,this.language=F,this.translations=G}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,Z){return(0,$.$Wg)(B.location,Z.location)&&B.mtime===Z.mtime&&(0,$.$Wg)(B.applicationExtensionslocation,Z.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&B.profile===Z.profile&&k.$1n(B.profileScanOptions,Z.profileScanOptions)&&B.type===Z.type&&B.excludeObsolete===Z.excludeObsolete&&B.validate===Z.validate&&B.productVersion===Z.productVersion&&B.productDate===Z.productDate&&B.productCommit===Z.productCommit&&B.devMode===Z.devMode&&B.language===Z.language&&U.equals(B.translations,Z.translations)}}e.$pq=J;let _=class extends a.$Uc{constructor(B,Z,T,q,W){super(),this.f=B,this.g=Z,this.h=T,this.j=q,this.m=W}async scanExtensions(B){const Z=B.profile?await this.r(B):await this.n(B);let T={};if(B.excludeObsolete&&B.type===1)try{const q=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(q)}catch{}return(0,m.$eg)(T)?Z:Z.filter(q=>!T[h.$pp.create(q).toString()])}async n(B){const Z=await this.j.resolve(B.location);if(!Z.children?.length)return[];const T=await Promise.all(Z.children.map(async q=>{if(!q.isDirectory||B.type===1&&(0,$.$1g)(q.resource).indexOf(".")===0)return null;const W=new J(q.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(W)}));return(0,D.$Hb)(T).sort((q,W)=>q.location.path<W.location.path?-1:1)}async r(B){let Z=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){Z=Z.filter(q=>!q.metadata?.isApplicationScoped);const T=await this.s(B.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,B);Z.push(...T)}return Z}async s(B,Z,T){const q=await this.g.scanProfileExtensions(B,T.profileScanOptions);if(!q.length)return[];const W=await Promise.all(q.map(async X=>{if(Z(X)){const Y=new J(X.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Y,X.metadata)}return null}));return(0,D.$Hb)(W)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,$.$4g)(B.location,"package.json"))){const Z=await this.scanExtension(B);return Z?[Z]:[]}else return await this.scanExtensions(B)}catch(Z){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,R.$0)(Z)),[]}}async scanExtension(B,Z){try{let T=await this.scanExtensionManifest(B.location);if(T){T.publisher||(T.publisher=p.$Hm),Z=Z??T.__metadata,delete T.__metadata;const q=(0,h.$tp)(T.publisher,T.name),W=Z?.id?{id:q,uuid:Z.id}:{id:q},X=Z?.isSystem?0:B.type,Y=X===0||!!Z?.isBuiltin;T=await this.t(B.location,T,J.createNlsConfiguration(B));const te={type:X,identifier:W,manifest:T,location:B.location,isBuiltin:Y,targetPlatform:Z?.targetPlatform??"undefined",metadata:Z,isValid:!0,validations:[]};return B.validate?this.validate(te,B):te}}catch(T){B.type!==0&&this.m.error(T)}return null}validate(B,Z){let T=!0;const q=(0,i.$Ep)(Z.productVersion,Z.productDate,Z.location,B.manifest,B.isBuiltin);for(const[W,X]of q)W===O.default.Error&&(T=!1,this.m.error(this.z(Z.location,X)));return B.isValid=T,B.validations=q,B}async scanExtensionManifest(B){const Z=(0,$.$4g)(B,"package.json");let T;try{T=(await this.j.readFile(Z)).value.toString()}catch(W){return(0,r.$bl)(W)!==1&&this.m.error(this.z(B,(0,b.localize)(0,null,Z.path,W.message))),null}let q;try{q=JSON.parse(T)}catch{const X=[];(0,S.$Dn)(T,X);for(const Y of X)this.m.error(this.z(B,(0,b.localize)(1,null,Z.path,Y.offset,Y.length,(0,u.$lq)(Y.error))));return null}return(0,S.$Mn)(q)!=="object"?(this.m.error(this.z(B,(0,b.localize)(2,null,Z.path))),null):q}async t(B,Z,T){const q=await this.u(B,Z,T);if(q)try{const W=[],X=await this.w(q.default,W);if(W.length>0)return W.forEach(te=>{this.m.error(this.z(B,(0,b.localize)(3,null,q.default?.path,(0,u.$lq)(te.error))))}),Z;if((0,S.$Mn)(q)!=="object")return this.m.error(this.z(B,(0,b.localize)(4,null,q.default?.path))),Z;const Y=q.values||Object.create(null);return(0,N.$mq)(this.m,Z,Y,X)}catch{}return Z}async u(B,Z,T){const q=(0,$.$4g)(B,"package.nls.json"),W=(C,M)=>{M.forEach(f=>{this.m.error(this.z(B,(0,b.localize)(5,null,C?.path,(0,u.$lq)(f.error))))})},X=C=>{this.m.error(this.z(B,(0,b.localize)(6,null,C?.path)))},Y=`${Z.publisher}.${Z.name}`,te=T.translations[Y];if(te)try{const C=c.URI.file(te),M=(await this.j.readFile(C)).value.toString(),f=[],E=(0,S.$Dn)(M,f);return f.length>0?(W(C,f),{values:void 0,default:q}):(0,S.$Mn)(E)!=="object"?(X(C),{values:void 0,default:q}):{values:E.contents?E.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.j.exists(q))return;let M;try{M=await this.y(B,T)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const f=(await this.j.readFile(M.localized)).value.toString(),E=[],L=(0,S.$Dn)(f,E);return E.length>0?(W(M.localized,E),{values:void 0,default:M.original}):(0,S.$Mn)(L)!=="object"?(X(M.localized),{values:void 0,default:M.original}):{values:L,default:M.original}}catch{return{values:void 0,default:M.original}}}}async w(B,Z){if(B)try{const T=(await this.j.readFile(B)).value.toString();return(0,S.$Dn)(T,Z)}catch{}}y(B,Z){return new Promise((T,q)=>{const W=X=>{const Y=(0,$.$4g)(B,`package.nls.${X}.json`);this.j.exists(Y).then(te=>{te&&T({localized:Y,original:(0,$.$4g)(B,"package.nls.json")});const C=X.lastIndexOf("-");C===-1?T({localized:(0,$.$4g)(B,"package.nls.json"),original:null}):(X=X.substring(0,C),W(X))})};if(Z.devMode||Z.pseudo||!Z.language)return T({localized:(0,$.$4g)(B,"package.nls.json"),original:null});W(Z.language)})}z(B,Z){return`[${B.path}]: ${Z}`}};_=$e([oe(1,P.$jq),oe(2,z.$ul),oe(3,r.$Wk),oe(4,n.$Wj)],_);let K=class extends _{constructor(B,Z,T,q,W,X,Y){super(Z,q,W,X,Y),this.G=B,this.H=T,this.D=this.B(new j.$oh(3e3)),this.F=this.B(new o.$be),this.onDidChangeCache=this.F.event}async scanExtensions(B){const Z=this.M(B),T=await this.I(Z);if(this.C=B,T&&T.input&&J.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),T.result.map(W=>(W.location=c.URI.revive(W.location),W));const q=await super.scanExtensions(B);return await this.J(Z,{input:B,result:q}),q}async I(B){try{const Z=await this.j.readFile(B),T=JSON.parse(Z.value.toString());return{result:T.result,input:(0,l.$Zh)(T.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",B.path,(0,R.$0)(Z))}return null}async J(B,Z){try{await this.j.writeFile(B,A.$Ce.fromString(JSON.stringify(Z)))}catch(T){this.m.debug("Error while writing the extension cache file:",B.path,(0,R.$0)(T))}}async L(){if(!this.C)return;const B=this.M(this.C),Z=await this.I(B);if(!Z)return;const T=Z.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!k.$1n(q,T))try{this.m.info("Invalidating Cache",T,q),await this.j.del(B),this.F.fire()}catch(W){this.m.error(W)}}M(B){const Z=this.N(B);return this.h.extUri.joinPath(Z.cacheHome,B.type===0?p.$Gm:p.$Fm)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(B.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};K=$e([oe(2,I.$wl),oe(3,P.$jq),oe(4,z.$ul),oe(5,r.$Wk),oe(6,n.$Wj)],K);function le(ae,B){const Z=(0,h.$rp)(ae.manifest.publisher,ae.manifest.name);return{id:Z,identifier:new p.$Lm(Z),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:B,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}class ue extends V{constructor(B,Z,T,q,W,X,Y,te,C,M,f,E){super(B,Z,(0,$.$4g)(T,".vscode-oss-dev","extensions","control.json"),q,W,X,Y,te,C,M,f,E),this.S=(async()=>{if(d.$z)try{const L=await this.w.readFile(c.URI.file(d.$z));return JSON.parse(L.value.toString())}catch{}return Object.create(null)})()}f(B){return this.S}}e.$rq=ue}),define(se[161],re([0,1,59,8,34,5,2,15,16,25,6,24]),function(Q,e,D,j,k,A,R,S,u,a,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=void 0;let d=class extends R.$Uc{constructor(y,O){super(),this.b=y,this.f=O,this.a=new j.$wh(5)}async postUninstall(y){const O=this.g(y,"uninstall");O&&(this.f.info(y.identifier.id,y.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(O.script,"uninstall",O.args,!0,y),this.f.info("Finished running post uninstall script",y.identifier.id,y.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",y.identifier.id,y.manifest.version),this.f.error(m)}}));try{await a.Promises.rm(this.m(y))}catch(m){this.f.error("Error while removing extension storage path",y.identifier.id),this.f.error(m)}}g(y,O){const m=`vscode:${O}`;if(y.location.scheme===S.Schemas.file&&y.manifest&&y.manifest.scripts&&typeof y.manifest.scripts[m]=="string"){const c=y.manifest.scripts[m].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(y.identifier.id,y.manifest.version,`${m} should be a node script`),null):{script:(0,u.$kc)(y.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(y,O,m,c,b){return new Promise((w,h)=>{const p=this.j(y,O,m,b);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?h(t):w(void 0)};p.on("error",t=>{r((0,k.$bj)(t)||"Unknown")}),p.on("exit",(t,n)=>{r(t?`post-${O} process exited with code ${t}`:void 0)}),c&&(i=setTimeout(()=>{i=null,p.kill(),h("timed out")},5e3))})}j(y,O,m,c){const b={silent:!0,execArgv:void 0},w=(0,D.fork)(y,[`--type=extension-post-${O}`,...m],b);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const h=A.Event.fromNodeEventEmitter(w.stdout,"data"),p=A.Event.fromNodeEventEmitter(w.stderr,"data");h(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${O}`,t)),p(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${O}`,t));const i=A.Event.any(A.Event.map(h,t=>({data:`%c${t}`,format:[""]})),A.Event.map(p,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),w}m(y){return(0,u.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,y.identifier.id.toLowerCase())}};e.$tq=d,e.$tq=d=$e([oe(0,v.$wl),oe(1,g.$Wj)],d)}),define(se[162],re([0,1,8,14,20,34,9,5,43,2,31,15,16,17,44,3,11,28,25,49,99,61,18,160,21,26,42,53,147,161,117,140,148,50,13,10,6,32,22,23,24]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$,y,O,m,c,b,w,h,p,i,r,t,n,s,o,l,P,I,z,N,U,V,J,_,K,le,ue,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=e.$yq=e.$xq=void 0,e.$xq=(0,J.$ri)(t.$3o);const B=".vsctmp";let Z=class extends r.$eq{constructor(C,M,f,E,L,F,G,H,ne,ce,he,pe){super(C,M,he,f,ce,pe),this.eb=L,this.fb=F,this.gb=G,this.hb=ne,this.db=new Map,this.qb=new g.$Cc;const ye=this.B(H.createInstance(P.$tq));this.ab=this.B(H.createInstance(T,me=>ye.postUninstall(me))),this.bb=this.B(new z.$vq(pe,ne,he,this,this.F)),this.cb=this.B(H.createInstance(l.$sq));const fe=this.B(new N.$wq(this,this.eb,pe,F,he,ne,f));this.B(fe.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,n.$zp)(this.hb,this.F)),this.ib}async zip(C){this.F.trace("ExtensionManagementService#zip",C.identifier.id);const M=await this.ob(C),f=await(0,w.zip)((0,$.$4g)(this.cb.extensionsDownloadDir,(0,c.$Mg)()).fsPath,M);return m.URI.file(f)}async unzip(C){return this.F.trace("ExtensionManagementService#unzip",C.toString()),(await this.install(C)).identifier}async getManifest(C){const{location:M,cleanup:f}=await this.kb(C),E=d.$lc(M.fsPath);try{return await(0,I.$uq)(E)}finally{await f()}}getInstalled(C,M=this.H.defaultProfile.extensionsResource,f={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(C??null,M,f)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(C){return this.ab.scanUserExtensionAtLocation(C)}async install(C,M={}){this.F.trace("ExtensionManagementService#install",C.toString());const{location:f,cleanup:E}=await this.kb(C);try{const L=await(0,I.$uq)(d.$lc(f.fsPath)),F=(0,n.$tp)(L.publisher,L.name);if(L.engines&&L.engines.vscode&&!(0,U.$Gp)(L.engines.vscode,this.G.version,this.G.date))throw new Error(h.localize(0,null,F,this.G.version));const H=(await this.I([{manifest:L,extension:f,options:M}])).find(({identifier:ne})=>(0,n.$op)(ne,{id:F}));if(H?.local)return H.local;throw H?.error?H.error:(0,r.$gq)(new Error(`Unknown error while installing extension ${F}`))}finally{await E()}}async installFromLocation(C,M){this.F.trace("ExtensionManagementService#installFromLocation",C.toString());const f=await this.ab.scanUserExtensionAtLocation(C);if(!f||!f.manifest.name||!f.manifest.version)throw new Error(`Cannot find a valid extension from the location ${C.toString()}`);return await this.tb([[f,{source:"resource"}]],M),this.F.info("Successfully installed extension",f.identifier.id,M.toString()),f}async installExtensionsFromProfile(C,M,f){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",C,M.toString(),f.toString());const E=(await this.getInstalled(1,M)).filter(L=>C.some(F=>(0,n.$op)(F,L.identifier)));if(E.length){const L=await Promise.all(E.map(F=>this.ab.scanMetadata(F,M)));await this.tb(E.map((F,G)=>[F,L[G]]),f),this.F.info("Successfully installed extensions",E.map(F=>F.identifier.id),f.toString())}return E}async updateMetadata(C,M,f=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",C.identifier.id),M.isPreReleaseVersion&&(M.preRelease=!0,M.hasPreReleaseVersion=!0),M.isMachineScoped===!1&&(M.isMachineScoped=void 0),M.isBuiltin===!1&&(M.isBuiltin=void 0),M.pinned===!1&&(M.pinned=void 0),C=await this.ab.updateMetadata(C,M,f),this.bb.invalidate(f),this.w.fire(C),C}async reinstallFromGallery(C){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",C.identifier.id),!this.z.isEnabled())throw new Error(h.localize(1,null));const M=await this.getTargetPlatform(),[f]=await this.z.getExtensions([{...C.identifier,preRelease:C.preRelease}],{targetPlatform:M,compatible:!0},k.CancellationToken.None);if(!f)throw new Error(h.localize(2,null));await this.ab.setUninstalled(C);try{await this.ab.removeUninstalledExtension(C)}catch(E){throw new Error(h.localize(3,null,(0,A.$bj)(E)))}return this.installFromGallery(f)}$(C,M,f,E){return this.ab.copyExtension(C,M,f,E)}copyExtensions(C,M){return this.ab.copyExtensions(C,M,{version:this.G.version,date:this.G.date})}markAsUninstalled(...C){return this.ab.setUninstalled(...C)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(C){this.F.error(C)}}async download(C,M,f){const{location:E}=await this.cb.download(C,M,!f);return E}async kb(C){if(C.scheme===v.Schemas.file)return{location:C,async cleanup(){}};this.F.trace("Downloading extension from",C.toString());const M=(0,$.$4g)(this.cb.extensionsDownloadDir,(0,c.$Mg)());return await this.gb.download(C,M),this.F.info("Downloaded extension to",M.toString()),{location:M,cleanup:async()=>{try{await this.hb.del(M)}catch(E){this.F.error(E)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(C,M,f){if(m.URI.isUri(M))return new X(C,M,f,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const E=n.$pp.create(M).toString();let L=this.db.get(E);return L||(this.db.set(E,L=new W(C,M,f,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),L.waitUntilTaskIsFinished().finally(()=>this.db.delete(E))),L}Z(C,M){return new Y(C,M.profileLocation,this.fb)}async ob(C){const M=async E=>{let L=await b.Promises.readdir(E);L=L.map(H=>d.$kc(E,H));const F=await Promise.all(L.map(H=>b.Promises.stat(H)));let G=Promise.resolve([]);return F.forEach((H,ne)=>{const ce=L[ne];H.isFile()&&(G=G.then(he=>[...he,ce])),H.isDirectory()&&(G=G.then(he=>M(ce).then(pe=>[...he,...pe])))}),G};return(await M(C.location.fsPath)).map(E=>({path:`extension/${d.$mc(C.location.fsPath,E)}`,localPath:E}))}async pb({added:C,removed:M}){if(M){const f=C&&this.D.extUri.isEqual(M.profileLocation,C.profileLocation)?M.extensions.filter(E=>C.extensions.every(L=>!(0,n.$op)(L,E))):M.extensions;for(const E of f)this.F.info("Extensions removed from another source",E.id,M.profileLocation.toString()),this.u.fire({identifier:E,profileLocation:M.profileLocation})}if(C){const E=(await this.getInstalled(1,C.profileLocation)).filter(L=>C.extensions.some(F=>(0,n.$op)(F,L.identifier)));this.s.fire(E.map(L=>(this.F.info("Extensions added from another source",L.identifier.id,C.profileLocation.toString()),{identifier:L.identifier,local:L,profileLocation:C.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(M=>this.qb.add(M)));const C=await this.hb.resolve(this.eb.userExtensionsLocation);for(const M of C.children??[])M.isDirectory&&this.qb.add(M.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(M=>this.sb(M)))}async sb(C){if(!C.affects(this.eb.userExtensionsLocation,1))return;const M=[];for(const f of C.rawAdded){if(this.qb.has(f)||!this.D.extUri.isEqual(this.D.extUri.dirname(f),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(f,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(f).startsWith(".")||!(await this.hb.stat(f)).isDirectory)continue;const E=await this.ab.scanUserExtensionAtLocation(f);E&&E.installedTimestamp===void 0&&(this.qb.add(f),M.push(E))}M.length&&(await this.tb(M.map(f=>[f,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",M.map(f=>f.identifier.id)))}async tb(C,M){const f=C.map(E=>E[0]);await this.ub(f),await this.fb.addExtensionsToProfile(C,M),this.s.fire(f.map(E=>({local:E,identifier:E.identifier,operation:1,profileLocation:M})))}async ub(C){const M=await this.ab.getUninstalledExtensions();for(const f of C){const E=n.$pp.create(f);M[E.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",E.id),await this.ab.setInstalled(E),this.F.info("Removed the extension from uninstalled list:",E.id))}}};e.$yq=Z,e.$yq=Z=$e([oe(0,t.$Zo),oe(1,le.$Vl),oe(2,_.$Wj),oe(3,i.$yi),oe(4,o.$nq),oe(5,s.$jq),oe(6,p.$Eo),oe(7,J.$pi),oe(8,V.$Wk),oe(9,K.$dk),oe(10,ue.$ul),oe(11,ae.$wl)],Z);let T=class extends a.$Uc{constructor(C,M,f,E,L,F){super(),this.j=C,this.m=M,this.n=f,this.s=E,this.t=L,this.u=F,this.h=this.B(new S.$be),this.onExtract=this.h.event,this.c=(0,$.$4g)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$xh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(C,M,f){const E={includeInvalid:!0,profileLocation:M,productVersion:f};let L=[];return C===null||C===0?L.push(...await this.n.scanAllExtensions({includeInvalid:!0},E,!1)):C===1&&L.push(...await this.n.scanUserExtensions(E)),L=C!==null?L.filter(F=>F.type===C):L,Promise.all(L.map(F=>this.F(F)))}async scanAllUserExtensions(C){const M=await this.n.scanUserExtensions({includeAllVersions:!C,includeInvalid:!0});return Promise.all(M.map(f=>this.F(f)))}async scanUserExtensionAtLocation(C){try{const M=await this.n.scanExistingExtension(C,1,{includeInvalid:!0});if(M)return await this.F(M)}catch(M){this.u.error(M)}return null}async extractUserExtension(C,M,f,E,L){const F=C.toString(),G=m.URI.file(d.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Mg)()}`)),H=m.URI.file(d.$kc(this.n.userExtensionsLocation.fsPath,F));let ne=await this.m.exists(H);if(ne&&E){try{await this.y(C.id,H,"removeExisting")}catch{throw new t.$1o(h.localize(4,null,H.fsPath,C.id),t.ExtensionManagementErrorCode.Delete)}ne=!1}if(ne)await this.n.updateMetadata(H,f);else try{try{this.u.trace(`Started extracting the extension from ${M} to ${H.fsPath}`),await(0,w.$cq)(M,G.fsPath,{sourcePath:"extension",overwrite:!0},L),this.u.info(`Extracted extension to ${H}:`,C.id)}catch(ce){let he=t.ExtensionManagementErrorCode.Extract;throw ce instanceof w.$aq&&(ce.type==="CorruptZip"?he=t.ExtensionManagementErrorCode.CorruptZip:ce.type==="Incomplete"&&(he=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$1o(ce.message,he)}await this.n.updateMetadata(G,f);try{this.u.trace(`Started renaming the extension from ${G.fsPath} to ${H.fsPath}`),await this.C(G.fsPath,H.fsPath),this.u.info("Renamed to",H.fsPath)}catch(ce){if(ce.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);else throw this.u.info(`Rename failed because of ${(0,R.$0)(ce)}. Deleted from extracted location`,G),ce}this.h.fire(H)}catch(ce){try{await this.m.del(G,{recursive:!0})}catch{}throw ce}return this.D(H,1)}async scanMetadata(C,M){return M?(await this.w(C,M))?.metadata:this.n.scanMetadata(C.location)}async w(C,M){return(await this.s.scanProfileExtensions(M)).find(E=>(0,n.$op)(E.identifier,C.identifier))}async updateMetadata(C,M,f){return f?await this.s.updateMetadata([[C,M]],f):await this.n.updateMetadata(C.location,M),this.D(C.location,C.type,f)}getUninstalledExtensions(){return this.z()}async setUninstalled(...C){const M=C.map(f=>n.$pp.create(f));await this.z(f=>M.forEach(E=>{f[E.toString()]=!0,this.u.info("Marked extension as uninstalled",E.toString())}))}async setInstalled(C){await this.z(M=>delete M[C.toString()])}async removeExtension(C,M){if(this.t.extUri.isEqualOrParent(C.location,this.n.userExtensionsLocation))return this.y(C.identifier.id,C.location,M)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.z(M=>delete M[n.$pp.create(C).toString()])}async copyExtension(C,M,f,E){const L=await this.w(C,M),F=await this.w(C,f);if(E={...L?.metadata,...E},F)if(this.t.extUri.isEqual(F.location,C.location))await this.s.updateMetadata([[C,{...F.metadata,...E}]],f);else{const G=await this.D(F.location,C.type,f);await this.s.removeExtensionFromProfile(G,f),await this.s.addExtensionsToProfile([[C,{...F.metadata,...E}]],f)}else await this.s.addExtensionsToProfile([[C,E]],f);return this.D(C.location,C.type,f)}async copyExtensions(C,M,f){const E=await this.scanExtensions(1,C,f),L=await Promise.all(E.filter(F=>!F.isApplicationScoped).map(async F=>[F,await this.scanMetadata(F,C)]));await this.s.addExtensionsToProfile(L,M)}async y(C,M,f){this.u.trace(`Deleting ${f} extension from disk`,C,M.fsPath);const E=this.t.extUri.joinPath(this.t.extUri.dirname(M),`${this.t.extUri.basename(M)}.${(0,u.$ej)((0,c.$Mg)()).toString(16)}${B}`);await this.C(M.fsPath,E.fsPath),await this.m.del(E,{recursive:!0}),this.u.info(`Deleted ${f} extension from disk`,C,M.fsPath)}async z(C){return this.g.queue(async()=>{let M;try{M=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(E){if((0,V.$bl)(E)!==1)throw E}let f={};if(M)try{f=JSON.parse(M)}catch{}return C&&(C(f),Object.keys(f).length?await this.m.writeFile(this.c,j.$Ce.fromString(JSON.stringify(f))):await this.m.del(this.c)),f})}async C(C,M){try{await b.Promises.rename(C,M,2*60*1e3)}catch(f){throw new t.$1o(f.message||h.localize(5,null,C,M),f.code||t.ExtensionManagementErrorCode.Rename)}}async D(C,M,f){if(f){const L=(await this.n.scanUserExtensions({profileLocation:f})).find(F=>this.t.extUri.isEqual(F.location,C));if(L)return this.F(L)}else{const E=await this.n.scanExistingExtension(C,M,{includeInvalid:!0});if(E)return this.F(E)}throw new Error(h.localize(6,null,C.path))}async F(C){const M=await this.m.resolve(C.location);let f,E;return M.children&&(f=M.children.find(({name:L})=>/^readme(\.txt|\.md|)$/i.test(L))?.resource,E=M.children.find(({name:L})=>/^changelog(\.txt|\.md|)$/i.test(L))?.resource),{identifier:C.identifier,type:C.type,isBuiltin:C.isBuiltin||!!C.metadata?.isBuiltin,location:C.location,manifest:C.manifest,targetPlatform:C.targetPlatform,validations:C.validations,isValid:C.isValid,readmeUrl:f,changelogUrl:E,publisherDisplayName:C.metadata?.publisherDisplayName||null,publisherId:C.metadata?.publisherId||null,isApplicationScoped:!!C.metadata?.isApplicationScoped,isMachineScoped:!!C.metadata?.isMachineScoped,isPreReleaseVersion:!!C.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!C.metadata?.hasPreReleaseVersion,preRelease:!!C.metadata?.preRelease,installedTimestamp:C.metadata?.installedTimestamp,updated:!!C.metadata?.updated,pinned:!!C.metadata?.pinned,isWorkspaceScoped:!1,source:C.metadata?.source??(C.identifier.uuid?"gallery":"vsix")}}async G(){const C=await this.getUninstalledExtensions();if(Object.keys(C).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(C));const M=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),f=new Set;for(const L of M)C[n.$pp.create(L).toString()]||f.add(L.identifier.id.toLowerCase());try{const L=(0,n.$up)(M,F=>F.identifier);await D.Promises.settled(L.map(async F=>{const G=F.sort((H,ne)=>y.rcompare(H.manifest.version,ne.manifest.version))[0];f.has(G.identifier.id.toLowerCase())||await this.j(await this.F(G))}))}catch(L){this.u.error(L)}const E=M.filter(L=>L.metadata&&C[n.$pp.create(L).toString()]);await Promise.allSettled(E.map(L=>this.removeUninstalledExtension(L)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let C;try{C=await this.m.resolve(this.n.userExtensionsLocation)}catch(M){(0,V.$bl)(M)!==1&&this.u.error(M);return}if(C?.children)try{await Promise.allSettled(C.children.map(async M=>{if(!(!M.isDirectory||!M.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",M.resource.toString());try{await this.m.del(M.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",M.resource.toString())}catch(f){(0,V.$bl)(f)!==1&&this.u.error(f)}}}))}catch{}}};e.$zq=T,e.$zq=T=$e([oe(1,V.$Wk),oe(2,o.$nq),oe(3,s.$jq),oe(4,ue.$ul),oe(5,_.$Wj)],T);class q extends r.$hq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,O.$$f)(this.options.operation)?this.l:this.options.operation}constructor(C,M,f,E,L,F,G,H,ne,ce){super(),this.manifest=C,this.identifier=M,this.source=f,this.options=E,this.m=L,this.n=F,this.o=G,this.p=H,this.q=ne,this.s=ce,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(C){const[M,f]=await this.x(C);return this.j=M.isBuiltin||M.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[M,f]],this.j,!M.isValid),M}async u({zipPath:C,key:M,metadata:f},E,L){let F=await this.v(M);return F?F=await this.m.updateMetadata(F,f):(this.s.trace("Extracting extension...",M.id),F=await this.m.extractUserExtension(M,C,f,E,L),this.s.info("Extracting extension completed.",M.id)),F}async v(C){return await this.w(C)?(this.s.trace("Removing the extension from uninstalled list:",C.id),await this.m.setInstalled(C),this.s.info("Removed the extension from uninstalled list:",C.id),(await this.m.scanAllUserExtensions(!0)).find(E=>n.$pp.create(E).equals(C))):void 0}async w(C){return!!(await this.m.getUninstalledExtensions())[C.toString()]}}class W extends q{constructor(C,M,f,E,L,F,G,H,ne,ce,he){super(C,M.identifier,M,f,L,F,G,H,ne,ce),this.y=M,this.z=E,this.A=he}async x(C){let M;try{M=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(L){throw new t.$1o(L,t.ExtensionManagementErrorCode.Scanning)}const f=M.find(L=>(0,n.$op)(L.identifier,this.y.identifier));f&&(this.l=3);const E={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||f?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||f?.isMachineScoped,isBuiltin:this.options.isBuiltin||f?.isBuiltin,isSystem:f?.type===0?!0:void 0,updated:!!f,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:f?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??f?.pinned,preRelease:(0,O.$0f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||f?.preRelease,source:"gallery"};if(f&&f.type!==0&&f.manifest.version===this.y.version)try{return[await this.m.updateMetadata(f,E),E]}catch(L){throw new t.$1o((0,R.$0)(L),t.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(E,C)}catch(L){if(L instanceof t.$1o&&(L.code===t.ExtensionManagementErrorCode.CorruptZip||L.code===t.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const F=await this.C(E,C);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),F}catch(F){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),F}}else throw L}}async C(C,M){const{location:f,verificationStatus:E}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=E,this.D(f.fsPath),[await this.u({zipPath:f.fsPath,key:n.$pp.create(this.y),metadata:C},!1,M),C]}catch(L){try{await this.z.delete(f)}catch(F){this.s.warn("Error while deleting the downloaded file",f.toString(),(0,R.$0)(F))}throw L}}async D(C){try{await(0,I.$uq)(C)}catch(M){throw new t.$1o((0,r.$fq)(M).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$Aq=W;class X extends q{constructor(C,M,f,E,L,F,G,H,ne,ce){super(C,{id:(0,n.$tp)(C.publisher,C.name)},M,f,L,F,G,H,ne,ce),this.y=M,this.z=E}async h(C){const M=await super.h(C);return this.C(M,C),M}async x(C){const M=new n.$pp(this.identifier,this.manifest.version),E=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(G=>(0,n.$op)(this.identifier,G.identifier)),L={isApplicationScoped:this.options.isApplicationScoped||E?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||E?.isMachineScoped,isBuiltin:this.options.isBuiltin||E?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??E?.pinned,source:"vsix"};if(E)if(this.l=3,M.equals(new n.$pp(E.identifier,E.manifest.version)))try{await this.m.removeExtension(E,"existing")}catch{throw new Error(h.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&y.gt(E.manifest.version,this.manifest.version)&&await this.m.setUninstalled(E);else{const G=await this.v(M);if(G)try{await this.m.removeExtension(G,"existing")}catch{throw new Error(h.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:d.$lc(this.y.fsPath),key:M,metadata:L},!0,C),L]}async C(C,M){try{let[f]=await this.z.getExtensions([{id:C.identifier.id,version:C.manifest.version}],M);if(f||([f]=await this.z.getExtensions([{id:C.identifier.id}],M)),f){const E={id:f.identifier.uuid,publisherDisplayName:f.publisherDisplayName,publisherId:f.publisherId,isPreReleaseVersion:f.properties.isPreReleaseVersion,hasPreReleaseVersion:C.hasPreReleaseVersion||f.properties.isPreReleaseVersion,preRelease:f.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(C,E,this.options.profileLocation)}}catch{}}}class Y extends r.$hq{constructor(C,M,f){super(),this.extension=C,this.j=M,this.k=f}async h(C){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(se[163],re([0,1,6,24,23,22,42,13,18,11]),function(Q,e,D,j,k,A,R,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xQ=void 0;let g=class extends R.$kq{constructor(d,$,y,O,m,c){super(a.URI.file(d.extensionsPath),$,y,O,m,c)}};e.$xQ=g,e.$xQ=g=$e([oe(0,u.$yi),oe(1,S.$Wk),oe(2,j.$wl),oe(3,k.$ul),oe(4,A.$Vl),oe(5,D.$Wj)],g)}),define(se[164],re([0,1,11,18,42,53,13,10,6,32,23,24]),function(Q,e,D,j,k,A,R,S,u,a,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=void 0;let d=class extends A.$rq{constructor(y,O,m,c,b,w,h,p){super(D.URI.file(b.builtinExtensionsPath),D.URI.file(b.extensionsPath),b.userHome,y.defaultProfile,y,O,m,c,b,w,h,p)}};e.$acc=d,e.$acc=d=$e([oe(0,v.$wl),oe(1,k.$jq),oe(2,R.$Wk),oe(3,u.$Wj),oe(4,j.$yi),oe(5,a.$dk),oe(6,g.$ul),oe(7,S.$pi)],d)}),define(se[165],re([0,1,8,5,2,130,3,89,10,24]),function(Q,e,D,j,k,A,R,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Wp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Up=e.$Tp=e.$Sp=void 0,e.$Vp=$,e.$Xp=O,e.$Zp=c,e.$Sp="__$__isNewStorageMarker",e.$Tp="__$__targetStorageMarker",e.$Up=(0,u.$qi)("storageService");var g;(function(b){b[b.NONE=0]="NONE",b[b.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var v;(function(b){b[b.APPLICATION=-1]="APPLICATION",b[b.PROFILE=0]="PROFILE",b[b.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var d;(function(b){b[b.USER=0]="USER",b[b.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function $(b){const w=b.get(e.$Tp);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}class y extends k.$Uc{static{this.a=60*1e3}constructor(w={flushInterval:y.a}){super(),this.m=w,this.b=this.B(new j.$ee),this.c=this.B(new j.$ee),this.onDidChangeTarget=this.c.event,this.f=this.B(new j.$be),this.onWillSaveState=this.f.event,this.h=this.B(new D.$Ch(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(w,h,p){return j.Event.filter(this.b.event,i=>i.scope===w&&(h===void 0||i.key===h),p)}n(){this.j.value=(0,D.$Gh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(w,h){const{key:p,external:i}=h;if(p===e.$Tp){switch(w){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:w})}else this.b.fire({scope:w,key:p,target:this.J(w)[p],external:i})}w(w){this.f.fire({reason:w})}get(w,h,p){return this.P(h)?.get(w,p)}getBoolean(w,h,p){return this.P(h)?.getBoolean(w,p)}getNumber(w,h,p){return this.P(h)?.getNumber(w,p)}getObject(w,h,p){return this.P(h)?.getObject(w,p)}storeAll(w,h){this.y(()=>{for(const p of w)this.store(p.key,p.value,p.scope,p.target,h)})}store(w,h,p,i,r=!1){if((0,R.$ag)(h)){this.remove(w,p,r);return}this.y(()=>{this.z(w,p,i),this.P(p)?.set(w,h,r)})}remove(w,h,p=!1){this.y(()=>{this.z(w,h,void 0),this.P(h)?.delete(w,p)})}y(w){this.b.pause(),this.c.pause();try{w()}finally{this.b.resume(),this.c.resume()}}keys(w,h){const p=[],i=this.J(w);for(const r of Object.keys(i))i[r]===h&&p.push(r);return p}z(w,h,p,i=!1){const r=this.J(h);typeof p=="number"?r[w]!==p&&(r[w]=p,this.P(h)?.set(e.$Tp,JSON.stringify(r),i)):typeof r[w]=="number"&&(delete r[w],this.P(h)?.set(e.$Tp,JSON.stringify(r),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(w){switch(w){case-1:return this.I;case 0:return this.G;default:return this.D}}L(w){const h=this.P(w);return h?$(h):Object.create(null)}isNew(w){return this.getBoolean(e.$Sp,w)===!0}async flush(w=g.NONE){this.f.fire({reason:w});const h=this.P(-1),p=this.P(0),i=this.P(1);switch(w){case g.NONE:await D.Promises.settled([h?.whenFlushed()??Promise.resolve(),p?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await D.Promises.settled([h?.flush(0)??Promise.resolve(),p?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.P(-1)?.items??new Map,h=this.P(0)?.items??new Map,p=this.P(1)?.items??new Map;return c(w,h,p,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(w){return await this.flush(),this.P(w)?.optimize()}async switch(w,h){return this.w(g.NONE),(0,a.$vl)(w)?this.R(w,h):this.S(w,h)}M(w,h){return!(w.id===h.id||O(h)&&O(w))}N(w,h,p){this.y(()=>{const i=new Set;for(const[r,t]of w)i.add(r),h.get(r)!==t&&this.u(p,{key:r,external:!0});for(const[r]of h.items)i.has(r)||this.u(p,{key:r,external:!0})})}}e.$Wp=y;function O(b){return b.isDefault||!!b.useDefaultFlags?.globalState}class m extends y{constructor(){super(),this.U=this.B(new S.$Qp(new S.$Rp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$Qp(new S.$Rp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$Qp(new S.$Rp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(w=>this.u(1,w))),this.B(this.W.onDidChangeStorage(w=>this.u(0,w))),this.B(this.U.onDidChangeStorage(w=>this.u(-1,w)))}P(w){switch(w){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(w){return!1}}e.$Yp=m;async function c(b,w,h,p,i,r){const t=U=>{try{return JSON.parse(U)}catch{return U}},n=new Map,s=new Map;b.forEach((U,V)=>{n.set(V,U),s.set(V,t(U))});const o=new Map,l=new Map;w.forEach((U,V)=>{o.set(V,U),l.set(V,t(U))});const P=new Map,I=new Map;h.forEach((U,V)=>{P.set(V,U),I.set(V,t(U))}),console.group(p!==i?`Storage: Application (path: ${p})`:`Storage: Application & Profile (path: ${p}, default profile)`);const z=[];if(n.forEach((U,V)=>{z.push({key:V,value:U})}),console.table(z),console.groupEnd(),console.log(s),p!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const U=[];o.forEach((V,J)=>{U.push({key:J,value:V})}),console.table(U),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const N=[];P.forEach((U,V)=>{N.push({key:V,value:U})}),console.table(N),console.groupEnd(),console.log(I)}}),define(se[166],re([0,1,19,20,9,12,35,3,11,29,18,21,26,50,13,6,32,45,149,165,22,178]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$,y,O,m,c,b,w,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0,e.$3p=X;const i=A.$o?"web":(0,v.$Vo)(A.$u,R.$fc),r="X-Market-Search-Activity-Id";var t;(function(E){E[E.None=0]="None",E[E.IncludeVersions=1]="IncludeVersions",E[E.IncludeFiles=2]="IncludeFiles",E[E.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",E[E.IncludeSharedAccounts=8]="IncludeSharedAccounts",E[E.IncludeVersionProperties=16]="IncludeVersionProperties",E[E.ExcludeNonValidated=32]="ExcludeNonValidated",E[E.IncludeInstallationTargets=64]="IncludeInstallationTargets",E[E.IncludeAssetUri=128]="IncludeAssetUri",E[E.IncludeStatistics=256]="IncludeStatistics",E[E.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",E[E.Unpublished=4096]="Unpublished",E[E.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...E){return String(E.reduce((L,F)=>L|F,0))}var s;(function(E){E[E.Tag=1]="Tag",E[E.ExtensionId=4]="ExtensionId",E[E.Category=5]="Category",E[E.ExtensionName=7]="ExtensionName",E[E.Target=8]="Target",E[E.Featured=9]="Featured",E[E.SearchText=10]="SearchText",E[E.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class z{constructor(L=I){this.d=L}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(L,F=this.d.pageSize){return new z({...this.d,pageNumber:L,pageSize:F})}withFilter(L,...F){const G=[...this.d.criteria,...F.length?F.map(H=>({filterType:L,value:H})):[{filterType:L}]];return new z({...this.d,criteria:G})}withSortBy(L){return new z({...this.d,sortBy:L})}withSortOrder(L){return new z({...this.d,sortOrder:L})}withFlags(...L){return new z({...this.d,flags:L.reduce((F,G)=>F|G,0)})}withAssetTypes(...L){return new z({...this.d,assetTypes:L})}withSource(L){return new z({...this.d,source:L})}get raw(){const{criteria:L,pageNumber:F,pageSize:G,sortBy:H,sortOrder:ne,flags:ce,assetTypes:he}=this.d;return{filters:[{criteria:L,pageNumber:F,pageSize:G,sortBy:H,sortOrder:ne}],assetTypes:he,flags:ce}}get searchText(){const L=this.d.criteria.filter(F=>F.filterType===s.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(L=>String(L.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function N(E,L){const F=(E||[]).filter(G=>G.statisticName===L)[0];return F?F.value:0}function U(E){const L="Microsoft.VisualStudio.Code.Translation.";return E.files.filter(G=>G.assetType.indexOf(L)===0).reduce((G,H)=>{const ne=_(E,H.assetType);return ne&&G.push([H.assetType.substring(L.length),ne]),G},[])}function V(E){if(E.properties){const L=E.properties.filter(H=>H.key===o.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=L.filter(H=>F.test(H.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return _(E,o.Repository)}function J(E){return{uri:`${E.fallbackAssetUri}/${o.VSIX}?redirect=true${E.targetPlatform?`&targetPlatform=${E.targetPlatform}`:""}`,fallbackUri:`${E.fallbackAssetUri}/${o.VSIX}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`}}function _(E,L){return E.files.filter(G=>G.assetType===L)[0]?{uri:`${E.assetUri}/${L}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`,fallbackUri:`${E.fallbackAssetUri}/${L}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`}:null}function K(E,L){const F=E.properties?E.properties.filter(H=>H.key===L):[],G=F.length>0&&F[0].value;return G?G.split(",").map(H=>(0,d.$sp)(H)):[]}function le(E){const L=E.properties?E.properties.filter(F=>F.key===l.Engine):[];return L.length>0&&L[0].value||""}function ue(E){const L=E.properties?E.properties.filter(F=>F.key===l.PreRelease):[];return L.length>0&&L[0].value==="true"}function ae(E){const L=E.properties?E.properties.filter(G=>G.key===l.LocalizedLanguages):[],F=L.length>0&&L[0].value||"";return F?F.split(","):[]}function B(E){return E.properties?.find(L=>L.key===l.SponsorLink)?.value}function Z(E){return E.properties?.find(L=>L.key===l.SupportLink)?.value}function T(E){return E.indexOf("preview")!==-1}function q(E){return E.targetPlatform?(0,v.$Uo)(E.targetPlatform):"undefined"}function W(E){const L=(0,D.$Mb)(E.versions.map(q)),F=!!E.tags?.includes(v.$Po),G=L.indexOf("web");return F?G===-1&&L.push("web"):G!==-1&&L.splice(G,1),L}function X(E,L){for(let F=0;F<E.length;F++){const G=E[F];if(G.version===E[F-1]?.version){let H=F;if(q(G)===L)for(;H>0&&E[H-1].version===G.version;)H--;H!==F&&(E.splice(F,1),E.splice(H,0,G))}}return E}function Y(E,L,F){E.telemetryData={index:L,querySource:F,queryActivityId:E.queryContext?.[r]}}function te(E,L,F,G){const H=E.versions[0],ne={manifest:_(L,o.Manifest),readme:_(L,o.Details),changelog:_(L,o.Changelog),license:_(L,o.License),repository:V(L),download:J(L),icon:_(L,o.Icon),signature:_(L,o.Signature),coreTranslations:U(L)};return{identifier:{id:(0,d.$tp)(E.publisher.publisherName,E.extensionName),uuid:E.extensionId},name:E.extensionName,version:L.version,displayName:E.displayName,publisherId:E.publisher.publisherId,publisher:E.publisher.publisherName,publisherDisplayName:E.publisher.displayName,publisherDomain:E.publisher.domain?{link:E.publisher.domain,verified:!!E.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(H),description:E.shortDescription??"",installCount:N(E.statistics,"install"),rating:N(E.statistics,"averagerating"),ratingCount:N(E.statistics,"ratingcount"),categories:E.categories||[],tags:E.tags||[],releaseDate:Date.parse(E.releaseDate),lastUpdated:Date.parse(E.lastUpdated),allTargetPlatforms:F,assets:ne,properties:{dependencies:K(L,l.Dependency),extensionPack:K(L,l.ExtensionPack),engine:le(L),localizedLanguages:ae(L),targetPlatform:q(L),isPreReleaseVersion:ue(L)},hasPreReleaseVersion:ue(H),hasReleaseVersion:!0,preview:T(E.flags),isSigned:!!ne.signature,queryContext:G,supportLink:Z(H)}}let C=class{constructor(L,F,G,H,ne,ce,he,pe){this.k=F,this.l=G,this.n=H,this.o=ne,this.q=ce,this.u=he,this.w=pe;const ye=he.extensionsGallery,fe=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=fe?ye.servicePPEUrl:ye?.serviceUrl,this.g=fe?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,b.$2p)(he.version,he,this.n,this.w,this.q,L,this.o)}x(L=""){return`${this.d}${L}`}isEnabled(){return!!this.d}async getExtensions(L,F,G){const H=j.CancellationToken.isCancellationToken(F)?{}:F,ne=j.CancellationToken.isCancellationToken(F)?F:G,ce=[],he=[],pe=[],ye=[];let fe=!0;for(const we of L){we.uuid?he.push(we.uuid):ce.push(we.id);const Ee=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:Ee}),we.version&&ye.push({id:we.id,uuid:we.uuid,version:we.version}),fe=fe&&!!we.hasPreRelease&&!Ee}if(!he.length&&!ce.length)return[];let me=new z().withPage(1,L.length);he.length&&(me=me.withFilter(s.ExtensionId,...he)),ce.length&&(me=me.withFilter(s.ExtensionName,...ce)),(H.queryAllVersions||fe)&&(me=me.withFlags(me.flags,t.IncludeVersions)),H.source&&(me=me.withSource(H.source));const{extensions:de}=await this.z(me,{targetPlatform:H.targetPlatform??i,includePreRelease:pe,versions:ye,compatible:!!H.compatible,productVersion:H.productVersion??{version:this.u.version,date:this.u.date}},ne);return H.source&&de.forEach((we,Ee)=>Y(we,Ee,H.source)),de}async getCompatibleExtension(L,F,G,H={version:this.u.version,date:this.u.date}){if((0,v.$Wo)(L.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(L,F,G))return L;const ne=new z().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,L.identifier.uuid),{extensions:ce}=await this.z(ne,{targetPlatform:G,compatible:!0,includePreRelease:F,productVersion:H},j.CancellationToken.None);return ce[0]||null}async isExtensionCompatible(L,F,G,H={version:this.u.version,date:this.u.date}){if(!(0,v.$Xo)(L.properties.targetPlatform,L.allTargetPlatforms,G)||!F&&L.properties.isPreReleaseVersion)return!1;let ne=L.properties.engine;if(!ne){const ce=await this.getManifest(L,j.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ne=ce.engines.vscode}return(0,$.$Gp)(ne,H.version,H.date)}async y(L,F,G,H,ne,ce,he={version:this.u.version,date:this.u.date}){if(!(0,v.$Xo)(q(F),ne,ce)||G!=="any"&&ue(F)!==(G==="prerelease"))return!1;if(H)try{const pe=await this.E(L,F);if(!(0,$.$Gp)(pe,he.version,he.date))return!1}catch(pe){return this.l.error(`Error while getting the engine for the version ${F.version}.`,(0,k.$0)(pe)),!1}return!0}async query(L,F){let G=L.text||"";const H=L.pageSize??50;let ne=new z().withPage(1,H);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(ne=ne.withFilter(s.Category,de||me),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(ne=ne.withFilter(s.Tag,de||me),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(ne=ne.withFilter(s.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),ne=ne.withFilter(s.SearchText,G)),ne=ne.withSortBy(0)):L.ids?ne=ne.withFilter(s.ExtensionId,...L.ids):L.names?ne=ne.withFilter(s.ExtensionName,...L.names):ne=ne.withSortBy(4),typeof L.sortBy=="number"&&(ne=ne.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(ne=ne.withSortOrder(L.sortOrder)),L.source&&(ne=ne.withSource(L.source));const ce=async(fe,me)=>{const{extensions:de,total:we}=await this.z(fe,{targetPlatform:i,compatible:!1,includePreRelease:!!L.includePreRelease,productVersion:L.productVersion??{version:this.u.version,date:this.u.date}},me);return de.forEach((Ee,ke)=>Y(Ee,(fe.pageNumber-1)*fe.pageSize+ke,L.source)),{extensions:de,total:we}},{extensions:he,total:pe}=await ce(ne,F),ye=async(fe,me)=>{if(me.isCancellationRequested)throw new k.$5;const{extensions:de}=await ce(ne.withPage(fe+1),me);return de};return{firstPage:he,total:pe,pageSize:ne.pageSize,getPage:ye}}async z(L,F,G){const H=L.flags;L.flags&t.IncludeLatestVersionOnly&&L.flags&t.IncludeVersions&&(L=L.withFlags(L.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(L.flags&t.IncludeLatestVersionOnly)&&!(L.flags&t.IncludeVersions)&&(L=L.withFlags(L.flags,t.IncludeLatestVersionOnly)),F.versions?.length&&(L=L.withFlags(L.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),L=L.withFlags(L.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ne,total:ce,context:he}=await this.B(L,G);if(!(L.flags&t.IncludeLatestVersionOnly)){const me=[];for(const de of ne){const we=await this.A(de,F,he);we&&me.push(we)}return{extensions:me,total:ce}}const ye=[],fe=new Map;for(let me=0;me<ne.length;me++){const de=ne[me],we={id:(0,d.$tp)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ee=(0,S.$0f)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(x=>(0,d.$op)(x,we))?.includePreRelease;if(F.compatible&&(0,v.$Wo)(W(de),F.targetPlatform))continue;const ke=await this.A(de,F,he);!ke||ke.properties.isPreReleaseVersion&&(!Ee||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==F.targetPlatform&&ke.hasPreReleaseVersion?fe.set(de.extensionId,me):ye.push([me,ke])}if(fe.size){const me=new p.$0d,de=new z().withFlags(H&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:we}=await this.z(de,F,G);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:fe.size});for(const Ee of we){const ke=fe.get(Ee.identifier.uuid);ye.push([ke,Ee])}}return{extensions:ye.sort((me,de)=>me[0]-de[0]).map(([,me])=>me),total:ce}}async A(L,F,G){const H={id:(0,d.$tp)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},ne=F.versions?.find(ye=>(0,d.$op)(ye,H))?.version,ce=(0,S.$0f)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(ye=>(0,d.$op)(ye,H))?.includePreRelease,he=W(L),pe=X(L.versions,F.targetPlatform);if(F.compatible&&(0,v.$Wo)(he,F.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const fe=pe[ye];if(!(ne&&fe.version!==ne)){if(await this.y((0,d.$tp)(L.publisher.publisherName,L.extensionName),fe,ce?"any":"release",F.compatible,he,F.targetPlatform,F.productVersion))return te(L,fe,he,G);if(ne&&fe.version===ne)return null}}return ne||F.compatible?null:te(L,L.versions[0],he)}async B(L,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(t.Unpublished));const G=await this.j,H=JSON.stringify(L.raw),ne={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},ce=new p.$0d;let he,pe,ye=0;try{if(he=await this.k.request({type:"POST",url:this.g&&L.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:H,headers:ne},F),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:ye};const fe=await(0,c.$Np)(he);if(fe){const me=fe.results[0],de=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ye=we&&we.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[r]:he.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(fe){const me=(0,k.$4)(fe)?v.ExtensionGalleryErrorCode.Cancelled:(0,k.$0)(fe).startsWith("XHR timeout")?v.ExtensionGalleryErrorCode.Timeout:v.ExtensionGalleryErrorCode.Failed;throw pe=new v.$2o((0,k.$0)(fe),me),pe}finally{this.o.publicLog2("galleryService:query",{...L.telemetryData,requestBodySize:String(H.length),duration:ce.elapsed(),success:!!he&&(0,c.$Jp)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:pe?.code,count:String(ye)})}}async reportStatistic(L,F,G,H){if(!this.isEnabled())return;const ne=A.$o?this.x(`/itemName/${L}.${F}/version/${G}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${L}/extensions/${F}/${G}/stats?statType=${H}`),ce=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ce};try{await this.k.request({type:"POST",url:ne,headers:pe},j.CancellationToken.None)}catch{}}async download(L,F,G){this.l.trace("ExtensionGalleryService#download",L.identifier.id);const H=(0,d.$wp)(L),ne=new Date().getTime(),ce=me=>this.o.publicLog("galleryService:downloadVSIX",{...H,duration:me}),he=G===2?"install":G===3?"update":"",pe=he?{uri:`${L.assets.download.uri}${u.URI.parse(L.assets.download.uri).query?"&":"?"}${he}=true`,fallbackUri:`${L.assets.download.fallbackUri}${u.URI.parse(L.assets.download.fallbackUri).query?"&":"?"}${he}=true`}:L.assets.download,ye=L.queryContext?.[r]?{[r]:L.queryContext[r]}:void 0,fe=await this.D(L.identifier.id,pe,o.VSIX,ye?{headers:ye}:void 0);await this.q.writeFile(F,fe.stream),ce(new Date().getTime()-ne)}async downloadSignatureArchive(L,F){if(!L.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",L.identifier.id);const G=await this.D(L.identifier.id,L.assets.signature,o.Signature);await this.q.writeFile(F,G.stream)}async getReadme(L,F){if(L.assets.readme){const G=await this.D(L.identifier.id,L.assets.readme,o.Details,{},F);return await(0,c.$Mp)(G)||""}return""}async getManifest(L,F){if(L.assets.manifest){const G=await this.D(L.identifier.id,L.assets.manifest,o.Manifest,{},F),H=await(0,c.$Mp)(G);return H?JSON.parse(H):null}return null}async C(L,F,G){const H=_(F,o.Manifest);if(!H)throw new Error("Manifest was not found");const ne={"Accept-Encoding":"gzip"},ce=await this.D(L,H,o.Manifest,{headers:ne});return await(0,c.$Np)(ce)}async getCoreTranslation(L,F){const G=L.assets.coreTranslations.filter(H=>H[0]===F.toUpperCase())[0];if(G){const H=await this.D(L.identifier.id,G[1],G[0]),ne=await(0,c.$Mp)(H);return ne?JSON.parse(ne):null}return null}async getChangelog(L,F){if(L.assets.changelog){const G=await this.D(L.identifier.id,L.assets.changelog,o.Changelog,{},F);return await(0,c.$Mp)(G)||""}return""}async getAllCompatibleVersions(L,F,G){let H=new z().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);L.identifier.uuid?H=H.withFilter(s.ExtensionId,L.identifier.uuid):H=H.withFilter(s.ExtensionName,L.identifier.id);const{galleryExtensions:ne}=await this.B(H,j.CancellationToken.None);if(!ne.length)return[];const ce=W(ne[0]);if((0,v.$Wo)(ce,G))return[];const he=[];await Promise.all(ne[0].versions.map(async fe=>{try{await this.y(L.identifier.id,fe,F?"any":"release",!0,ce,G)&&he.push(fe)}catch{}}));const pe=[],ye=new Set;for(const fe of X(he,G))ye.has(fe.version)||(ye.add(fe.version),pe.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:ue(fe)}));return pe}async D(L,F,G,H={},ne=j.CancellationToken.None){const ce=await this.j,he={type:"GET"},pe={...ce,...H.headers||{}};H={...H,...he,headers:pe};const ye=F.uri,fe=F.fallbackUri,me={...H,url:ye};try{const de=await this.k.request(me,ne);if(de.res.statusCode===200)return de;const we=await(0,c.$Mp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${we}`)}catch(de){if((0,k.$4)(de))throw de;const we=(0,k.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{extension:L,assetType:G,message:we});const Ee={...H,url:fe};return this.k.request(Ee,ne)}}async E(L,F){let G=le(F);if(!G){this.o.publicLog2("galleryService:engineFallback",{extension:L,version:F.version});const H=await this.C(L,F,j.CancellationToken.None);if(!H)throw new Error("Manifest was not found");G=H.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const L=await this.k.request({type:"GET",url:this.h},j.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,c.$Np)(L),G=[],H={},ne=[];if(F){for(const ce of F.malicious)G.push({id:ce});if(F.migrateToPreRelease)for(const[ce,he]of Object.entries(F.migrateToPreRelease))(!he.engine||(0,$.$Gp)(he.engine,this.u.version,this.u.date))&&(H[ce.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(F.deprecated)for(const[ce,he]of Object.entries(F.deprecated))he&&(H[ce.toLowerCase()]=(0,S.$0f)(he)?{}:he);if(F.search)for(const ce of F.search)ne.push(ce)}return{malicious:G,deprecated:H,search:ne}}};C=$e([oe(1,c.$Hp),oe(2,O.$Wj),oe(3,g.$xi),oe(4,h.$Vl),oe(5,y.$Wk),oe(6,m.$dk),oe(7,a.$Wi)],C);let M=class extends C{constructor(L,F,G,H,ne,ce,he,pe){super(L,F,G,H,ne,ce,he,pe)}};e.$4p=M,e.$4p=M=$e([oe(0,w.$Up),oe(1,c.$Hp),oe(2,O.$Wj),oe(3,g.$xi),oe(4,h.$Vl),oe(5,y.$Wk),oe(6,m.$dk),oe(7,a.$Wi)],M);let f=class extends C{constructor(L,F,G,H,ne,ce,he){super(void 0,L,F,G,H,ne,ce,he)}};e.$5p=f,e.$5p=f=$e([oe(0,c.$Hp),oe(1,O.$Wj),oe(2,g.$xi),oe(3,h.$Vl),oe(4,y.$Wk),oe(5,m.$dk),oe(6,a.$Wi)],f)}),define(se[167],re([0,1,11,18,13,6,145,23,24,3,68]),function(Q,e,D,j,k,A,R,S,u,a,g){"use strict";var v,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$wQ=e.$vQ=e.$uQ=void 0;let $=class extends u.$zl{static{v=this}static{this.a="profileAssociationsMigration"}constructor(c,b,w,h,p){super(w,h,b,p),this.U=c,this.W=w}O(){return this.U.getItem(v.b,[]).map(b=>({...b,location:(0,a.$4f)(b.location)?this.w.extUri.joinPath(this.profilesHome,b.location):D.URI.revive(b.location)}))}Q(){const c=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(D.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$uQ=$,e.$uQ=$=v=$e([oe(0,R.$pQ),oe(1,S.$ul),oe(2,j.$yi),oe(3,k.$Wk),oe(4,A.$Wj)],$);let y=d=class extends ${constructor(c,b,w,h,p){super(c,b,w,h,p),this.$=c}P(c){c.length?this.$.setItem(d.b,c.map(b=>({...b,location:this.w.extUri.basename(b.location)}))):this.$.removeItem(d.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(d.c,c):this.$.removeItem(d.c)}Q(){const c="workspaceAndProfileInfo",b=this.$.getItem(c,void 0);if(b){this.$.removeItem(c);const h=b.reduce((p,{workspace:i,profile:r})=>(p[D.URI.revive(i).toString()]=D.URI.revive(r).toString(),p),{});this.$.setItem(d.c,{workspaces:h})}const w=super.Q();return this.$.getItem(d.a,!1)||(this.R(w),this.$.setItem(d.a,!0)),w}};e.$vQ=y,e.$vQ=y=d=$e([oe(0,R.$qQ),oe(1,S.$ul),oe(2,j.$yi),oe(3,k.$Wk),oe(4,A.$Wj)],y);let O=class extends y{constructor(c,b,w,h){super(new g.$tQ(0,b,h,w),c,b,w,h)}async init(){return await this.$.init(),super.init()}};e.$wQ=O,e.$wQ=O=$e([oe(0,S.$ul),oe(1,j.$yi),oe(2,k.$Wk),oe(3,A.$Wj)],O)}),define(se[168],re([0,1,143,8,14,9,3,29,18,144,6,45,142,179]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=void 0,e.$Qr=m;let y=class extends v.$Ip{constructor(b,w,h,p){super(p),this.m=b,this.n=w,this.r=h,this.s(),this.B(b.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const b=this.m.getValue("http");this.f=b?.proxy,this.g=!!b?.proxyStrictSSL,this.h=b?.proxyAuthorization}async request(b,w){const{f:h,g:p}=this;let i;try{i=await(0,a.$Am)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$0)(n)))}const r={...process.env,...i},t=b.agent?b.agent:await(0,d.$Or)(b.url||"",r,{proxyUrl:h,strictSSL:p});return b.agent=t,b.strictSSL=p,this.h&&(b.headers={...b.headers||{},"Proxy-Authorization":this.h}),this.c(b.isChromiumNetwork?"electron":"node",b,()=>m(b,w))}async resolveProxy(b){}async loadCertificates(){return(await new Promise((w,h)=>{Q(["@vscode/proxy-agent"],w,h)})).loadSystemCertificates({log:this.r})}};e.$Pr=y,e.$Pr=y=$e([oe(0,S.$Wi),oe(1,u.$yi),oe(2,g.$Wj),oe(3,g.$Xj)],y);async function O(c){return((0,D.parse)(c.url).protocol==="https:"?await new Promise((h,p)=>{Q(["https"],h,p)}):await new Promise((h,p)=>{Q(["http"],h,p)})).request}async function m(c,b){return j.Promises.withAsyncBody(async(w,h)=>{const p=(0,D.parse)(c.url),i=c.getRawRequest?c.getRawRequest(c):await O(c),r={hostname:p.hostname,port:p.port?parseInt(p.port):p.protocol==="https:"?443:80,protocol:p.protocol,path:p.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,R.$0f)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=i(r,n=>{const s=(0,R.$8f)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)m({...c,url:n.headers.location,followRedirects:s-1},b).then(w,h);else{let o=n;!c.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,$.createGunzip)())),w({res:n,stream:(0,k.$Re)(o)})}});t.on("error",h),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),b.onCancellationRequested(()=>{t.abort(),h(new A.$5)})})}}),define(se[180],re([0,1,33,8,34,9,2,15,16,12,35,11,25,29,139,61,141,18,115,166,21,70,146,42,53,162,164,13,129,131,51,127,63,64,150,6,135,39,136,153,32,45,168,68,69,22,152,41,154,155,23,157,24,167,156,163,132,134,4,158,181]),function(Q,e,D,j,k,A,R,S,u,a,g,v,d,$,y,O,m,c,b,w,h,p,i,r,t,n,s,o,l,P,I,z,N,U,V,J,_,K,le,ue,ae,B,Z,T,q,W,X,Y,te,C,M,f,E,L,F,G,H,ne,ce,he,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=fe;class ye extends R.$Uc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,we]=await this.f();return de.invokeFunction(async Ee=>{const ke=Ee.get(J.$Wj),x=Ee.get(o.$Wk),ee=Ee.get(c.$yi),ie=Ee.get(E.$wl);ke.info("CLI main",this.b),this.h(ke),await this.j(ee,x,ie,de),await Promise.all(we.map(ge=>{(0,j.$hh)(ge.flush(),1e3)}))})}async f(){const de=new N.$oi,we={_serviceBrand:void 0,...ue.default};de.set(ae.$dk,we);const Ee=new b.$3m(this.b,we);de.set(c.$yi,Ee),await Promise.all([this.g(Ee.appSettingsHome.with({scheme:S.Schemas.file}).fsPath),this.g(Ee.extensionsPath)].map(be=>be?d.Promises.mkdir(be,{recursive:!0}):void 0));const ke=new ne.$oQ((0,J.$$j)(Ee),Ee.logsHome);de.set(J.$Xj,ke);const x=this.B(ke.createLogger("cli",{name:(0,ce.localize)(0,null)})),ee=[];ke.getLogLevel()===J.LogLevel.Trace&&ee.push(new J.$5j(ke.getLogLevel()));const ie=this.B(new H.$yQ(x,ee));de.set(J.$Wj,ie);const ge=this.B(new l.$Cq(ie));de.set(o.$Wk,ge);const ve=this.B(new P.$4q(ie));ge.registerProvider(S.Schemas.file,ve);const De=new f.$rs(ge);de.set(M.$ul,De);const Pe=new T.$sQ(1,Ee,ie,ge),Le=new L.$uQ(Pe,De,Ee,ge,ie);de.set(E.$wl,Le),ge.registerProvider(S.Schemas.vscodeUserData,new he.$Bcc(S.Schemas.file,ve,S.Schemas.vscodeUserData,Le,De,ie));const Oe=a.$i&&we.win32RegValueName?this.B(new le.$zcc(ie,we.win32RegValueName)):Ee.policyFile?this.B(new _.$Acc(Ee.policyFile,ge,ie)):new K.$ao;de.set(K.$$n,Oe);const Ae=this.B(new y.$Ao(Le.defaultProfile.settingsResource,ge,Oe,ie));de.set($.$Wi,Ae),await Promise.all([Pe.init(),Ae.initialize()]);let Me;try{Me=await(0,F.$dcc)(Pe,ie)}catch(be){be.code!=="ENOENT"&&ie.error(be)}const je=await(0,F.$ecc)(Pe,ie);Le.init(),de.set(M.$ul,new f.$rs(ge));const Ne=new Z.$Pr(Ae,Ee,ie,ke);de.set(B.$Hp,Ne),de.set(O.$Eo,new I.$ni(m.$NQ,void 0,!0)),de.set(r.$jq,new I.$ni(G.$xQ,void 0,!0)),de.set(t.$nq,new I.$ni(s.$acc,void 0,!0)),de.set(p.$6p,new I.$ni(p.$7p,void 0,!0)),de.set(n.$xq,new I.$ni(n.$yq,void 0,!0)),de.set(h.$Zo,new I.$ni(w.$5p,void 0,!0)),de.set(U.$Jr,new I.$ni(V.$Lr,void 0,!1));const ze=[],Ce=(0,Y.$lp)(we,Ae);if((0,Y.$gp)(we,Ee)){we.aiConfig&&we.aiConfig.ariaKey&&ze.push(new te.$mQ(Ne,Ce,"monacoworkbench",null,we.aiConfig.ariaKey));const be={appenders:ze,sendErrorTelemetry:!1,commonProperties:(0,q.$0o)((0,D.release)(),(0,D.hostname)(),process.arch,we.commit,we.version,Me,je,Ce),piiPaths:(0,Y.$mp)(Ee)};de.set(W.$Vl,new I.$ni(X.$Rr,[be],!1))}else de.set(W.$Vl,Y.$bp);return[new z.$7q(de),ze]}g(de){if(a.$i){const we=(0,pe.getUNCHost)(de);we&&(0,pe.addUNCHostToAllowlist)(we)}return de}h(de){(0,A.setUnexpectedErrorHandler)(we=>{const Ee=(0,k.$bj)(we,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",we=>{(0,A.$Z)(we)||(0,A.$1)(we)}),process.on("unhandledRejection",we=>(0,A.$1)(we))}async j(de,we,Ee,ke){let x;if(de.args.profile&&(x=Ee.profiles.find(ie=>ie.name===de.args.profile),!x))throw new Error(`Profile '${de.args.profile}' not found.`);const ee=(x??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(i.$8p,new J.$5j(J.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,ee);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ie={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:ee};return ke.createInstance(i.$8p,new J.$5j(J.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ie,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(i.$8p,new J.$5j(J.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,ee);if(this.b["update-extensions"])return ke.createInstance(i.$8p,new J.$5j(J.LogLevel.Info,!1)).updateExtensions(ee);if(this.b["locate-extension"])return ke.createInstance(i.$8p,new J.$5j(J.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,C.$Zcc)(de.appRoot,de.extensionsPath))}}m(de){return de.map(we=>/\.vsix$/i.test(we)?v.URI.file((0,u.$jc)(we)?we:(0,u.$kc)((0,g.cwd)(),we)):we)}}async function fe(me){const de=new ye(me);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f8d35f6a712c59f96078161799435d0e83461556/core/vs/code/node/cliProcessMain.js.map
