/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","crypto","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ee=function(le){for(var e=[],u=0,N=le.length;u<N;u++)e[u]=ke[le[u]];return e};define(ke[162],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class u{static get(){const L=new Map,R=new Map,M=new Map,p=new Map;function b(E,v){E.has(v.detail)||E.set(v.detail,-v.timestamp)}function S(E,v){const a=E.get(v.detail);a&&(a>=0||E.set(v.detail,a+v.timestamp))}let A=[];typeof le=="function"&&typeof le.getStats=="function"&&(A=le.getStats().slice(0).sort((E,v)=>E.timestamp-v.timestamp));for(const E of A)switch(E.type){case 10:b(L,E);break;case 11:case 12:S(L,E);break;case 21:b(R,E);break;case 22:S(R,E);break;case 33:b(M,E);break;case 34:S(M,E);break;case 31:b(p,E);break;case 32:S(p,E);break}let P=0;M.forEach(E=>P+=E);function $(E){const v=[];return E.forEach((a,m)=>v.push([m,a])),v}return{amdLoad:$(L),amdInvoke:$(R),nodeRequire:$(M),nodeEval:$(p),nodeRequireTotal:P}}static toMarkdownTable(L,R){let M="";const p=[];return L.forEach((b,S)=>{p[S]=b.length}),R.forEach(b=>{b.forEach((S,A)=>{typeof S>"u"&&(S=b[A]="-");const P=S.toString().length;p[A]=Math.max(P,p[A])})}),L.forEach((b,S)=>{M+=`| ${b+" ".repeat(p[S]-b.toString().length)} `}),M+=`|
`,L.forEach((b,S)=>{M+=`| ${"-".repeat(p[S])} `}),M+=`|
`,R.forEach(b=>{b.forEach((S,A)=>{typeof S<"u"&&(M+=`| ${S+" ".repeat(p[A]-S.toString().length)} `)}),M+=`|
`}),M}}e.$U=u}),define(ke[163],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=u,e.$gb=N,e.$hb=L,e.$ib=R,e.$jb=M,e.$kb=p,e.$lb=b,e.$nb=A,e.$ob=P,e.$pb=$,e.$qb=E,e.$rb=v;function u(a,m){const o=N(a,m);if(o!==-1)return a[o]}function N(a,m,o=a.length-1){for(let n=o;n>=0;n--){const i=a[n];if(m(i))return n}return-1}function L(a,m){const o=R(a,m);return o===-1?void 0:a[o]}function R(a,m,o=0,n=a.length){let i=o,r=n;for(;i<r;){const s=Math.floor((i+r)/2);m(a[s])?i=s+1:r=s}return i-1}function M(a,m){const o=p(a,m);return o===a.length?void 0:a[o]}function p(a,m,o=0,n=a.length){let i=o,r=n;for(;i<r;){const s=Math.floor((i+r)/2);m(a[s])?r=s:i=s+1}return i}function b(a,m,o=0,n=a.length){const i=p(a,m,o,n);return i===a.length?-1:i}class S{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(S.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!m(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const o=R(this.e,m,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=S;function A(a,m){if(a.length===0)return;let o=a[0];for(let n=1;n<a.length;n++){const i=a[n];m(i,o)>0&&(o=i)}return o}function P(a,m){if(a.length===0)return;let o=a[0];for(let n=1;n<a.length;n++){const i=a[n];m(i,o)>=0&&(o=i)}return o}function $(a,m){return A(a,(o,n)=>-m(o,n))}function E(a,m){if(a.length===0)return-1;let o=0;for(let n=1;n<a.length;n++){const i=a[n];m(i,a[o])>0&&(o=n)}return o}function v(a,m){for(const o of a){const n=m(o);if(n!==void 0)return n}}}),define(ke[73],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=u,e.$L=N,e.$M=L,e.$N=R;function u(M,p){const b=Object.create(null);for(const S of M){const A=p(S);let P=b[A];P||(P=b[A]=[]),P.push(S)}return b}function N(M,p){const b=[],S=[];for(const A of M)p.has(A)||b.push(A);for(const A of p)M.has(A)||S.push(A);return{removed:b,added:S}}function L(M,p){const b=[],S=[];for(const[A,P]of M)p.has(A)||b.push(P);for(const[A,P]of p)M.has(A)||S.push(P);return{removed:b,added:S}}function R(M,p){const b=new Set;for(const S of p)M.has(S)&&b.add(S);return b}}),define(ke[55],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=N,e.$Vh=L,e.$Wh=R;function u(M){return(p,b,S)=>{let A=null,P=null;if(typeof S.value=="function"?(A="value",P=S.value):typeof S.get=="function"&&(A="get",P=S.get),!P)throw new Error("not supported");S[A]=M(P,b)}}function N(M,p,b){let S=null,A=null;if(typeof b.value=="function"?(S="value",A=b.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(S="get",A=b.get),!A)throw new Error("not supported");const P=`$memoize$${p}`;b[S]=function(...$){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,$)}),this[P]}}function L(M,p,b){return u((S,A)=>{const P=`$debounce$${A}`,$=`$debounce$result$${A}`;return function(...E){this[$]||(this[$]=b?b():void 0),clearTimeout(this[P]),p&&(this[$]=p(this[$],...E),E=[this[$]]),this[P]=setTimeout(()=>{S.apply(this,E),this[$]=b?b():void 0},M)}})}function R(M,p,b){return u((S,A)=>{const P=`$throttle$timer$${A}`,$=`$throttle$result$${A}`,E=`$throttle$lastRun$${A}`,v=`$throttle$pending$${A}`;return function(...a){if(this[$]||(this[$]=b?b():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),p&&(this[$]=p(this[$],...a)),this[v])return;const m=this[E]+M;m<=Date.now()?(this[E]=Date.now(),S.apply(this,[this[$]]),this[$]=b?b():void 0):(this[v]=!0,this[P]=setTimeout(()=>{this[v]=!1,this[E]=Date.now(),S.apply(this,[this[$]]),this[$]=b?b():void 0},m-Date.now()))}})}}),define(ke[13],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=L,e.$1=R,e.$2=M,e.$3=p,e.$4=S,e.$6=P,e.$7=$,e.$8=E,e.$0=a;class u{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(f=>{f(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=u,e.$X=new u;function N(s){e.$X.setUnexpectedErrorHandler(s)}function L(s){if(!s||typeof s!="object")return!1;const t=s;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(s){S(s)||e.$X.onUnexpectedError(s)}function M(s){S(s)||e.$X.onUnexpectedExternalError(s)}function p(s){if(s instanceof Error){const{name:t,message:f}=s,d=s.stacktrace||s.stack;return{$isError:!0,name:t,message:f,stack:d,noTelemetry:i.isErrorNoTelemetry(s)}}return s}const b="Canceled";function S(s){return s instanceof A?!0:s instanceof Error&&s.name===b&&s.message===b}class A extends Error{constructor(){super(b),this.name=this.message}}e.$5=A;function P(){const s=new Error(b);return s.name=s.message,s}function $(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function E(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function a(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const f=new i;return f.message=t.message,f.stack=t.stack,f}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(ke[19],Ee([1,0,13,163]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=L,e.$tb=R,e.$ub=M,e.$vb=p,e.$wb=b,e.$xb=S,e.$yb=A,e.$zb=P,e.$Ab=$,e.$Bb=E,e.$Cb=v,e.$Db=a,e.$Eb=m,e.top=o,e.$Gb=n,e.$Hb=r,e.$Ib=s,e.$Jb=t,e.$Kb=f,e.$Lb=d,e.$Mb=l,e.$Nb=c,e.$Ob=h,e.$Pb=g,e.$Qb=D,e.$Rb=w,e.$Sb=k,e.$Tb=y,e.$Ub=C,e.$Vb=I,e.$Wb=F,e.$Xb=j,e.$Yb=z,e.$Zb=O,e.$1b=T,e.$2b=B,e.$3b=W,e.$4b=Z,e.$5b=x,e.$6b=X,e.$7b=ne,e.$8b=$e,e.$$b=U;function L(oe,ae=0){return oe[oe.length-(1+ae)]}function R(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}function M(oe,ae,re=(G,te)=>G===te){if(oe===ae)return!0;if(!oe||!ae||oe.length!==ae.length)return!1;for(let G=0,te=oe.length;G<te;G++)if(!re(oe[G],ae[G]))return!1;return!0}function p(oe,ae){const re=oe.length-1;ae<re&&(oe[ae]=oe[re]),oe.pop()}function b(oe,ae,re){return S(oe.length,G=>re(oe[G],ae))}function S(oe,ae){let re=0,G=oe-1;for(;re<=G;){const te=(re+G)/2|0,ge=ae(te);if(ge<0)re=te+1;else if(ge>0)G=te-1;else return te}return-(re+1)}function A(oe,ae,re){if(oe=oe|0,oe>=ae.length)throw new TypeError("invalid index");const G=ae[Math.floor(ae.length*Math.random())],te=[],ge=[],we=[];for(const Re of ae){const fe=re(Re,G);fe<0?te.push(Re):fe>0?ge.push(Re):we.push(Re)}return oe<te.length?A(oe,te,re):oe<te.length+we.length?we[0]:A(oe-(te.length+we.length),ge,re)}function P(oe,ae){const re=[];let G;for(const te of oe.slice(0).sort(ae))!G||ae(G[0],te)!==0?(G=[te],re.push(G)):G.push(te);return re}function*$(oe,ae){let re,G;for(const te of oe)G!==void 0&&ae(G,te)?re.push(te):(re&&(yield re),re=[te]),G=te;re&&(yield re)}function E(oe,ae){for(let re=0;re<=oe.length;re++)ae(re===0?void 0:oe[re-1],re===oe.length?void 0:oe[re])}function v(oe,ae){for(let re=0;re<oe.length;re++)ae(re===0?void 0:oe[re-1],oe[re],re+1===oe.length?void 0:oe[re+1])}function a(oe,ae,re){const G=[];function te(Re,fe,Se){if(fe===0&&Se.length===0)return;const Ae=G[G.length-1];Ae&&Ae.start+Ae.deleteCount===Re?(Ae.deleteCount+=fe,Ae.toInsert.push(...Se)):G.push({start:Re,deleteCount:fe,toInsert:Se})}let ge=0,we=0;for(;;){if(ge===oe.length){te(ge,0,ae.slice(we));break}if(we===ae.length){te(ge,oe.length-ge,[]);break}const Re=oe[ge],fe=ae[we],Se=re(Re,fe);Se===0?(ge+=1,we+=1):Se<0?(te(ge,1,[]),ge+=1):Se>0&&(te(ge,0,[fe]),we+=1)}return G}function m(oe,ae,re){const G=a(oe,ae,re),te=[],ge=[];for(const we of G)te.push(...oe.slice(we.start,we.start+we.deleteCount)),ge.push(...we.toInsert);return{removed:te,added:ge}}function o(oe,ae,re){if(re===0)return[];const G=oe.slice(0,re).sort(ae);return i(oe,ae,G,re,oe.length),G}function n(oe,ae,re,G,te){return re===0?Promise.resolve([]):new Promise((ge,we)=>{(async()=>{const Re=oe.length,fe=oe.slice(0,re).sort(ae);for(let Se=re,Ae=Math.min(re+G,Re);Se<Re;Se=Ae,Ae=Math.min(Ae+G,Re)){if(Se>re&&await new Promise(Fe=>setTimeout(Fe)),te&&te.isCancellationRequested)throw new u.$5;i(oe,ae,fe,Se,Ae)}return fe})().then(ge,we)})}function i(oe,ae,re,G,te){for(const ge=re.length;G<te;G++){const we=oe[G];if(ae(we,re[ge-1])<0){re.pop();const Re=(0,N.$kb)(re,fe=>ae(we,fe)<0);re.splice(Re,0,we)}}}function r(oe){return oe.filter(ae=>!!ae)}function s(oe){let ae=0;for(let re=0;re<oe.length;re++)oe[re]&&(oe[ae]=oe[re],ae+=1);oe.length=ae}function t(oe,ae,re){oe.splice(re,0,oe.splice(ae,1)[0])}function f(oe){return!Array.isArray(oe)||oe.length===0}function d(oe){return Array.isArray(oe)&&oe.length>0}function l(oe,ae=re=>re){const re=new Set;return oe.filter(G=>{const te=ae(G);return re.has(te)?!1:(re.add(te),!0)})}function c(oe){const ae=new Set;return re=>{const G=oe(re);return ae.has(G)?!1:(ae.add(G),!0)}}function h(oe,ae){return oe.length>0?oe[0]:ae}function g(oe,ae){return oe.length>0?oe[oe.length-1]:ae}function D(oe,ae,re=(G,te)=>G===te){let G=0;for(let te=0,ge=Math.min(oe.length,ae.length);te<ge&&re(oe[te],ae[te]);te++)G++;return G}function w(oe){return[].concat(...oe)}function k(oe,ae){let re=typeof ae=="number"?oe:0;typeof ae=="number"?re=oe:(re=0,ae=oe);const G=[];if(re<=ae)for(let te=re;te<ae;te++)G.push(te);else for(let te=re;te>ae;te--)G.push(te);return G}function y(oe,ae,re){return oe.reduce((G,te)=>(G[ae(te)]=re?re(te):te,G),Object.create(null))}function C(oe,ae){return oe.push(ae),()=>I(oe,ae)}function I(oe,ae){const re=oe.indexOf(ae);if(re>-1)return oe.splice(re,1),ae}function F(oe,ae,re){const G=oe.slice(0,ae),te=oe.slice(ae);return G.concat(re,te)}function j(oe,ae){let re;if(typeof ae=="number"){let G=ae;re=()=>{const te=Math.sin(G++)*179426549;return te-Math.floor(te)}}else re=Math.random;for(let G=oe.length-1;G>0;G-=1){const te=Math.floor(re()*(G+1)),ge=oe[G];oe[G]=oe[te],oe[te]=ge}}function z(oe,ae){const re=oe.indexOf(ae);re>-1&&(oe.splice(re,1),oe.unshift(ae))}function O(oe,ae){const re=oe.indexOf(ae);re>-1&&(oe.splice(re,1),oe.push(ae))}function T(oe,ae){for(const re of ae)oe.push(re)}function B(oe,ae){return Array.isArray(oe)?oe.map(ae):ae(oe)}function W(oe){return Array.isArray(oe)?oe:[oe]}function Z(oe){return oe[Math.floor(Math.random()*oe.length)]}function x(oe,ae,re){const G=Y(oe,ae),te=oe.length,ge=re.length;oe.length=te+ge;for(let we=te-1;we>=G;we--)oe[we+ge]=oe[we];for(let we=0;we<ge;we++)oe[we+G]=re[we]}function X(oe,ae,re,G){const te=Y(oe,ae);let ge=oe.splice(te,re);return ge===void 0&&(ge=[]),x(oe,te,G),ge}function Y(oe,ae){return ae<0?Math.max(ae+oe.length,0):Math.min(ae,oe.length)}var ce;(function(oe){function ae(ge){return ge<0}oe.isLessThan=ae;function re(ge){return ge<=0}oe.isLessThanOrEqual=re;function G(ge){return ge>0}oe.isGreaterThan=G;function te(ge){return ge===0}oe.isNeitherLessOrGreaterThan=te,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(ce||(e.CompareResult=ce={}));function ne(oe,ae){return(re,G)=>ae(oe(re),oe(G))}function $e(...oe){return(ae,re)=>{for(const G of oe){const te=G(ae,re);if(!ce.isNeitherLessOrGreaterThan(te))return te}return ce.neitherLessOrGreaterThan}}const Ce=(oe,ae)=>oe-ae;e.$9b=Ce;const ee=(oe,ae)=>(0,e.$9b)(oe?1:0,ae?1:0);e.$0b=ee;function U(oe){return(ae,re)=>-oe(ae,re)}class ie{constructor(ae){this.g=ae,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ae){let re=this.c;for(;re<this.g.length&&ae(this.g[re]);)re++;const G=re===this.c?null:this.g.slice(this.c,re);return this.c=re,G}takeFromEndWhile(ae){let re=this.d;for(;re>=0&&ae(this.g[re]);)re--;const G=re===this.d?null:this.g.slice(re+1,this.d+1);return this.d=re,G}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ae=this.g[this.c];return this.c++,ae}removeLast(){const ae=this.g[this.d];return this.d--,ae}takeCount(ae){const re=this.g.slice(this.c,this.c+ae);return this.c+=ae,re}}e.$_b=ie;class be{static{this.empty=new be(ae=>{})}constructor(ae){this.iterate=ae}forEach(ae){this.iterate(re=>(ae(re),!0))}toArray(){const ae=[];return this.iterate(re=>(ae.push(re),!0)),ae}filter(ae){return new be(re=>this.iterate(G=>ae(G)?re(G):!0))}map(ae){return new be(re=>this.iterate(G=>re(ae(G))))}some(ae){let re=!1;return this.iterate(G=>(re=ae(G),!re)),re}findFirst(ae){let re;return this.iterate(G=>ae(G)?(re=G,!1):!0),re}findLast(ae){let re;return this.iterate(G=>(ae(G)&&(re=G),!0)),re}findLastMaxBy(ae){let re,G=!0;return this.iterate(te=>((G||ce.isGreaterThan(ae(te,re)))&&(G=!1,re=te),!0)),re}}e.$ac=be;class Pe{constructor(ae){this.c=ae}static createSortPermutation(ae,re){const G=Array.from(ae.keys()).sort((te,ge)=>re(ae[te],ae[ge]));return new Pe(G)}apply(ae){return ae.map((re,G)=>ae[this.c[G]])}inverse(){const ae=this.c.slice();for(let re=0;re<this.c.length;re++)ae[this.c[re]]=re;return new Pe(ae)}}e.$bc=Pe}),define(ke[62],Ee([1,0,13]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$cd=L,e.$dd=R,e.$ed=M,e.$fd=p,e.$gd=b;function N(S,A){if(!S)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function L(S,A="Unreachable"){throw new Error(A)}function R(S){if(!S)throw new u.$cb("Assertion Failed")}function M(S){S||(0,u.$1)(new u.$cb("Soft Assertion Failed"))}function p(S){if(!S()){debugger;S(),(0,u.$1)(new u.$cb("Assertion Failed"))}}function b(S,A){let P=0;for(;P<S.length-1;){const $=S[P],E=S[P+1];if(!A($,E))return!1;P++}return!0}}),define(ke[74],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=u;function u(N,L){const R=this;let M=!1,p;return function(){if(M)return p;if(M=!0,L)try{p=N.apply(R,arguments)}finally{L()}else p=N.apply(R,arguments);return p}}}),define(ke[124],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=void 0;class u{constructor(L){this.a=L,this.b=0}nextId(){return this.a+ ++this.b}}e.$fP=u,e.$gP=new u("id#")}),define(ke[45],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(N){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=L;const R=Object.freeze([]);function M(){return R}N.empty=M;function*p(t){yield t}N.single=p;function b(t){return L(t)?t:p(t)}N.wrap=b;function S(t){return t||R}N.from=S;function*A(t){for(let f=t.length-1;f>=0;f--)yield t[f]}N.reverse=A;function P(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=P;function $(t){return t[Symbol.iterator]().next().value}N.first=$;function E(t,f){for(const d of t)if(f(d))return!0;return!1}N.some=E;function v(t,f){for(const d of t)if(f(d))return d}N.find=v;function*a(t,f){for(const d of t)f(d)&&(yield d)}N.filter=a;function*m(t,f){let d=0;for(const l of t)yield f(l,d++)}N.map=m;function*o(...t){for(const f of t)yield*f}N.concat=o;function n(t,f,d){let l=d;for(const c of t)l=f(l,c);return l}N.reduce=n;function*i(t,f,d=t.length){for(f<0&&(f+=t.length),d<0?d+=t.length:d>t.length&&(d=t.length);f<d;f++)yield t[f]}N.slice=i;function r(t,f=Number.POSITIVE_INFINITY){const d=[];if(f===0)return[d,t];const l=t[Symbol.iterator]();for(let c=0;c<f;c++){const h=l.next();if(h.done)return[d,N.empty()];d.push(h.value)}return[d,{[Symbol.iterator](){return l}}]}N.consume=r;async function s(t){const f=[];for await(const d of t)f.push(d);return Promise.resolve(f)}N.asyncToArray=s})(u||(e.Iterable=u={}))}),define(ke[164],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Bn=M,e.$Cn=P,e.$Dn=$,e.$En=E,e.$Fn=v,e.$Gn=a,e.$Hn=m,e.$In=o,e.$Jn=n,e.$Kn=i,e.$Ln=r,e.$Mn=s;var u;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(u||(e.ScanError=u={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function M(t,f=!1){let d=0;const l=t.length;let c="",h=0,g=16,D=0;function w(z){let O=0,T=0;for(;O<z;){const B=t.charCodeAt(d);if(B>=48&&B<=57)T=T*16+B-48;else if(B>=65&&B<=70)T=T*16+B-65+10;else if(B>=97&&B<=102)T=T*16+B-97+10;else break;d++,O++}return O<z&&(T=-1),T}function k(z){d=z,c="",h=0,g=16,D=0}function y(){const z=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&S(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&S(t.charCodeAt(d)))for(d++;d<t.length&&S(t.charCodeAt(d));)d++;else return D=3,t.substring(z,d);let O=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&S(t.charCodeAt(d))){for(d++;d<t.length&&S(t.charCodeAt(d));)d++;O=d}else D=3;return t.substring(z,O)}function C(){let z="",O=d;for(;;){if(d>=l){z+=t.substring(O,d),D=2;break}const T=t.charCodeAt(d);if(T===34){z+=t.substring(O,d),d++;break}if(T===92){if(z+=t.substring(O,d),d++,d>=l){D=2;break}switch(t.charCodeAt(d++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const W=w(4);W>=0?z+=String.fromCharCode(W):D=4;break}default:D=5}O=d;continue}if(T>=0&&T<=31)if(b(T)){z+=t.substring(O,d),D=2;break}else D=6;d++}return z}function I(){if(c="",D=0,h=d,d>=l)return h=l,g=17;let z=t.charCodeAt(d);if(p(z)){do d++,c+=String.fromCharCode(z),z=t.charCodeAt(d);while(p(z));return g=15}if(b(z))return d++,c+=String.fromCharCode(z),z===13&&t.charCodeAt(d)===10&&(d++,c+=`
`),g=14;switch(z){case 123:return d++,g=1;case 125:return d++,g=2;case 91:return d++,g=3;case 93:return d++,g=4;case 58:return d++,g=6;case 44:return d++,g=5;case 34:return d++,c=C(),g=10;case 47:{const O=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<l&&!b(t.charCodeAt(d));)d++;return c=t.substring(O,d),g=12}if(t.charCodeAt(d+1)===42){d+=2;const T=l-1;let B=!1;for(;d<T;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,B=!0;break}d++}return B||(d++,D=1),c=t.substring(O,d),g=13}return c+=String.fromCharCode(z),d++,g=16}case 45:if(c+=String.fromCharCode(z),d++,d===l||!S(t.charCodeAt(d)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=y(),g=11;default:for(;d<l&&F(z);)d++,z=t.charCodeAt(d);if(h!==d){switch(c=t.substring(h,d),c){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return c+=String.fromCharCode(z),d++,g=16}}function F(z){if(p(z)||b(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let z;do z=I();while(z>=12&&z<=15);return z}return{setPosition:k,getPosition:()=>d,scan:f?j:I,getToken:()=>g,getTokenValue:()=>c,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>D}}function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function P(t,f){const d=[],l=new Object;let c;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function D(w,k,y,C){h.value=w,h.offset=k,h.length=y,h.type=C,h.colonOffset=void 0,c=h}try{i(t,{onObjectBegin:(w,k)=>{if(f<=w)throw l;c=void 0,g=f>w,d.push("")},onObjectProperty:(w,k,y)=>{if(f<k||(D(w,k,y,"property"),d[d.length-1]=w,f<=k+y))throw l},onObjectEnd:(w,k)=>{if(f<=w)throw l;c=void 0,d.pop()},onArrayBegin:(w,k)=>{if(f<=w)throw l;c=void 0,d.push(0)},onArrayEnd:(w,k)=>{if(f<=w)throw l;c=void 0,d.pop()},onLiteralValue:(w,k,y)=>{if(f<k||(D(w,k,y,s(w)),f<=k+y))throw l},onSeparator:(w,k,y)=>{if(f<=k)throw l;if(w===":"&&c&&c.type==="property")c.colonOffset=k,g=!1,c=void 0;else if(w===","){const C=d[d.length-1];typeof C=="number"?d[d.length-1]=C+1:(g=!0,d[d.length-1]=""),c=void 0}}})}catch(w){if(w!==l)throw w}return{path:d,previousNode:c,isAtPropertyKey:g,matches:w=>{let k=0;for(let y=0;k<w.length&&y<d.length;y++)if(w[k]===d[y]||w[k]==="*")k++;else if(w[k]!=="**")return!1;return k===w.length}}}function $(t,f=[],d=R.DEFAULT){let l=null,c=[];const h=[];function g(w){Array.isArray(c)?c.push(w):l!==null&&(c[l]=w)}return i(t,{onObjectBegin:()=>{const w={};g(w),h.push(c),c=w,l=null},onObjectProperty:w=>{l=w},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{const w=[];g(w),h.push(c),c=w,l=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:g,onError:(w,k,y)=>{f.push({error:w,offset:k,length:y})}},d),c[0]}function E(t,f=[],d=R.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(w){l.type==="property"&&(l.length=w-l.offset,l=l.parent)}function h(w){return l.children.push(w),w}i(t,{onObjectBegin:w=>{l=h({type:"object",offset:w,length:-1,parent:l,children:[]})},onObjectProperty:(w,k,y)=>{l=h({type:"property",offset:k,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:w,offset:k,length:y,parent:l})},onObjectEnd:(w,k)=>{l.length=w+k-l.offset,l=l.parent,c(w+k)},onArrayBegin:(w,k)=>{l=h({type:"array",offset:w,length:-1,parent:l,children:[]})},onArrayEnd:(w,k)=>{l.length=w+k-l.offset,l=l.parent,c(w+k)},onLiteralValue:(w,k,y)=>{h({type:s(w),offset:k,length:y,parent:l,value:w}),c(k+y)},onSeparator:(w,k,y)=>{l.type==="property"&&(w===":"?l.colonOffset=k:w===","&&c(k))},onError:(w,k,y)=>{f.push({error:w,offset:k,length:y})}},d);const D=l.children[0];return D&&delete D.parent,D}function v(t,f){if(!t)return;let d=t;for(const l of f)if(typeof l=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let c=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===l){d=h.children[1],c=!0;break}if(!c)return}else{const c=l;if(d.type!=="array"||c<0||!Array.isArray(d.children)||c>=d.children.length)return;d=d.children[c]}return d}function a(t){if(!t.parent||!t.parent.children)return[];const f=a(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;f.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&f.push(d)}return f}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const f=Object.create(null);for(const d of t.children){const l=d.children[1];l&&(f[d.children[0].value]=m(l))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,f,d=!1){return f>=t.offset&&f<t.offset+t.length||d&&f===t.offset+t.length}function n(t,f,d=!1){if(o(t,f,d)){const l=t.children;if(Array.isArray(l))for(let c=0;c<l.length&&l[c].offset<=f;c++){const h=n(l[c],f,d);if(h)return h}return t}}function i(t,f,d=R.DEFAULT){const l=M(t,!1);function c(ne){return ne?()=>ne(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(ne){return ne?$e=>ne($e,l.getTokenOffset(),l.getTokenLength()):()=>!0}const g=c(f.onObjectBegin),D=h(f.onObjectProperty),w=c(f.onObjectEnd),k=c(f.onArrayBegin),y=c(f.onArrayEnd),C=h(f.onLiteralValue),I=h(f.onSeparator),F=c(f.onComment),j=h(f.onError),z=d&&d.disallowComments,O=d&&d.allowTrailingComma;function T(){for(;;){const ne=l.scan();switch(l.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:z||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ne){case 12:case 13:z?B(10):F();break;case 16:B(1);break;case 15:case 14:break;default:return ne}}}function B(ne,$e=[],Ce=[]){if(j(ne),$e.length+Ce.length>0){let ee=l.getToken();for(;ee!==17;){if($e.indexOf(ee)!==-1){T();break}else if(Ce.indexOf(ee)!==-1)break;ee=T()}}}function W(ne){const $e=l.getTokenValue();return ne?C($e):D($e),T(),!0}function Z(){switch(l.getToken()){case 11:{let ne=0;try{ne=JSON.parse(l.getTokenValue()),typeof ne!="number"&&(B(2),ne=0)}catch{B(2)}C(ne);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return T(),!0}function x(){return l.getToken()!==10?(B(3,[],[2,5]),!1):(W(!1),l.getToken()===6?(I(":"),T(),ce()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function X(){g(),T();let ne=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ne||B(4,[],[]),I(","),T(),l.getToken()===2&&O)break}else ne&&B(6,[],[]);x()||B(4,[],[2,5]),ne=!0}return w(),l.getToken()!==2?B(7,[2],[]):T(),!0}function Y(){k(),T();let ne=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ne||B(4,[],[]),I(","),T(),l.getToken()===4&&O)break}else ne&&B(6,[],[]);ce()||B(4,[],[4,5]),ne=!0}return y(),l.getToken()!==4?B(8,[4],[]):T(),!0}function ce(){switch(l.getToken()){case 3:return Y();case 1:return X();case 10:return W(!0);default:return Z()}}return T(),l.getToken()===17?d.allowEmptyContent?!0:(B(4,[],[]),!1):ce()?(l.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function r(t,f){const d=M(t),l=[];let c,h=0,g;do switch(g=d.getPosition(),c=d.scan(),c){case 12:case 13:case 17:h!==g&&l.push(t.substring(h,g)),f!==void 0&&l.push(d.getTokenValue().replace(/[^\r\n]/g,f)),h=d.getPosition();break}while(c!==17);return l.join("")}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[46],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class u{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=u}),define(ke[75],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class u{static{this.Undefined=new u(void 0)}constructor(R){this.element=R,this.next=u.Undefined,this.prev=u.Undefined}}class N{constructor(){this.a=u.Undefined,this.b=u.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===u.Undefined}clear(){let R=this.a;for(;R!==u.Undefined;){const M=R.next;R.prev=u.Undefined,R.next=u.Undefined,R=M}this.a=u.Undefined,this.b=u.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,M){const p=new u(R);if(this.a===u.Undefined)this.a=p,this.b=p;else if(M){const S=this.b;this.b=p,p.prev=S,S.next=p}else{const S=this.a;this.a=p,p.next=S,S.prev=p}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(p))}}shift(){if(this.a!==u.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==u.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==u.Undefined&&R.next!==u.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===u.Undefined&&R.next===u.Undefined?(this.a=u.Undefined,this.b=u.Undefined):R.next===u.Undefined?(this.b=this.b.prev,this.b.next=u.Undefined):R.prev===u.Undefined&&(this.a=this.a.next,this.a.prev=u.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==u.Undefined;)yield R.element,R=R.next}}e.$5c=N}),define(ke[27],Ee([1,0]),function(le,e){"use strict";var u,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=M,e.$Ac=p,e.$Ic=n;function R(i,r,s){let t=i.get(r);return t===void 0&&(t=s,i.set(r,t)),t}function M(i){const r=[];return i.forEach((s,t)=>{r.push(`${t} => ${s}`)}),`Map(${i.size}) {${r.join(", ")}}`}function p(i){const r=[];return i.forEach(s=>{r.push(s)}),`Set(${i.size}) {${r.join(", ")}}`}class b{constructor(r,s){this.uri=r,this.value=s}}function S(i){return Array.isArray(i)}class A{static{this.c=r=>r.toString()}constructor(r,s){if(this[u]="ResourceMap",r instanceof A)this.d=new Map(r.d),this.e=s??A.c;else if(S(r)){this.d=new Map,this.e=s??A.c;for(const[t,f]of r)this.set(t,f)}else this.d=new Map,this.e=r??A.c}set(r,s){return this.d.set(this.e(r),new b(r,s)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[t,f]of this.d)r(f.value,f.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(u=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Bc=A;class P{constructor(r,s){this[N]="ResourceSet",!r||typeof r=="function"?this.c=new A(r):(this.c=new A(s),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,s){this.c.forEach((t,f)=>r.call(s,f,f,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=P;var $;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})($||(e.Touch=$={}));class E{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,s=0){const t=this.c.get(r);if(t)return s!==0&&this.l(t,s),t.value}set(r,s,t=0){let f=this.c.get(r);if(f)f.value=s,t!==0&&this.l(f,t);else{switch(f={key:r,value:s,next:void 0,previous:void 0},t){case 0:this.j(f);break;case 1:this.i(f);break;case 2:this.j(f);break;default:this.j(f);break}this.c.set(r,f),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this.c.get(r);if(s)return this.c.delete(r),this.k(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,s){const t=this.g;let f=this.d;for(;f;){if(s?r.bind(s)(f.value,f.key,this):r(f.value,f.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.key,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}values(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.value,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}entries(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:[t.key,t.value],done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this.d,t=this.size;for(;s&&t>r;)this.c.delete(s.key),s=s.next,t--;this.d=s,this.f=t,s&&(s.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const s=r.next,t=r.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}r.next=void 0,r.previous=void 0,this.g++}l(r,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this.d)return;const t=r.next,f=r.previous;r===this.e?(f.next=void 0,this.e=f):(t.previous=f,f.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(s===2){if(r===this.e)return;const t=r.next,f=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=f,f.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((s,t)=>{r.push([t,s])}),r}fromJSON(r){this.clear();for(const[s,t]of r)this.set(s,t)}}e.$Dc=E;class v extends E{constructor(r,s=1){super(),this.m=r,this.n=Math.min(Math.max(0,s),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=v;class a{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let s=this.c.get(r)||0;return s===0?!1:(s--,s===0?this.c.delete(r):this.c.set(r,s),!0)}has(r){return this.c.has(r)}}e.$Fc=a;class m{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[s,t]of r)this.set(s,t)}clear(){this.c.clear(),this.d.clear()}set(r,s){this.c.set(r,s),this.d.set(s,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const s=this.c.get(r);return s===void 0?!1:(this.c.delete(r),this.d.delete(s),!0)}forEach(r,s){this.c.forEach((t,f)=>{r.call(s,t,f,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=m;class o{constructor(){this.c=new Map}add(r,s){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(s)}delete(r,s){const t=this.c.get(r);t&&(t.delete(s),t.size===0&&this.c.delete(r))}forEach(r,s){const t=this.c.get(r);t&&t.forEach(s)}get(r){const s=this.c.get(r);return s||new Set}}e.$Hc=o;function n(i,r){if(i===r)return!0;if(i.size!==r.size)return!1;for(const[s,t]of i)if(!r.has(s)||r.get(s)!==t)return!1;for(const[s]of r)if(!i.has(s))return!1;return!0}}),define(ke[3],Ee([1,0,19,73,27,74,45]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=A,e.$Lc=P,e.$Mc=$,e.$Nc=a,e.$Oc=m,e.$Pc=o,e.$Qc=n,e.$Rc=i,e.$Sc=r,e.$3c=w;const p=!1;let b=null;class S{constructor(){this.b=new Map}static{this.a=0}c(C){let I=this.b.get(C);return I||(I={parent:null,source:null,isSingleton:!1,value:C,idx:S.a++},this.b.set(C,I)),I}trackDisposable(C){const I=this.c(C);I.source||(I.source=new Error().stack)}setParent(C,I){const F=this.c(C);F.parent=I}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,I){const F=I.get(C);if(F)return F;const j=C.parent?this.f(this.c(C.parent),I):C;return I.set(C,j),j}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,C).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(C=10,I){let F;if(I)F=I;else{const B=new Map,W=[...this.b.values()].filter(x=>x.source!==null&&!this.f(x,B).isSingleton);if(W.length===0)return;const Z=new Set(W.map(x=>x.value));if(F=W.filter(x=>!(x.parent&&Z.has(x.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function j(B){function W(x,X){for(;x.length>0&&X.some(Y=>typeof Y=="string"?Y===x[0]:x[0].match(Y));)x.shift()}const Z=B.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return W(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const z=new L.$Hc;for(const B of F){const W=j(B);for(let Z=0;Z<=W.length;Z++)z.add(W.slice(0,Z).join(`
`),B)}F.sort((0,u.$7b)(B=>B.idx,u.$9b));let O="",T=0;for(const B of F.slice(0,C)){T++;const W=j(B),Z=[];for(let x=0;x<W.length;x++){let X=W[x];X=`(shared with ${z.get(W.slice(0,x+1).join(`
`)).size}/${F.length} leaks) at ${X}`;const ce=z.get(W.slice(0,x).join(`
`)),ne=(0,N.$K)([...ce].map($e=>j($e)[x]),$e=>$e);delete ne[W[x]];for(const[$e,Ce]of Object.entries(ne))Z.unshift(`    - stacktraces of ${Ce.length} other leaks continue with ${$e}`);Z.unshift(X)}O+=`


==================== Leaking disposable ${T}/${F.length}: ${B.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return F.length>C&&(O+=`


... and ${F.length-C} more leaking disposables

`),{leaks:F,details:O}}}e.$Jc=S;function A(y){b=y}if(p){const y="__is_disposable_tracked__";A(new class{trackDisposable(C){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[y]||console.log(I)},3e3)}setParent(C,I){if(C&&C!==t.None)try{C[y]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[y]=!0}catch{}}markAsSingleton(C){}})}function P(y){return b?.trackDisposable(y),y}function $(y){b?.markAsDisposed(y)}function E(y,C){b?.setParent(y,C)}function v(y,C){if(b)for(const I of y)b.setParent(I,C)}function a(y){return b?.markAsSingleton(y),y}function m(y){return typeof y=="object"&&y!==null&&typeof y.dispose=="function"&&y.dispose.length===0}function o(y){if(M.Iterable.is(y)){const C=[];for(const I of y)if(I)try{I.dispose()}catch(F){C.push(F)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}function n(y){for(const C of y)m(C)&&C.dispose();return[]}function i(...y){const C=r(()=>o(y));return v(y,C),C}function r(y){const C=P({dispose:(0,R.$db)(()=>{$(C),y()})});return C}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return E(C,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),E(C,null))}}e.$Tc=s;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,P(this),E(this.q,this)}dispose(){$(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Uc=t;class f{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&E(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&E(C,null),C}}e.$Vc=f;class d{constructor(C){this.a=new f,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=d;class l{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=l;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(C){let I=C;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,$(this))},this}}e.$Yc=c;class h{constructor(){this.a=new Map}acquire(C,...I){let F=this.a.get(C);F||(F={counter:0,object:this.b(C,...I)},this.a.set(C,F));const{object:j}=F,z=(0,R.$db)(()=>{--F.counter===0&&(this.c(C,F.object),this.a.delete(C))});return F.counter++,{object:j,dispose:z}}}e.$Zc=h;class g{constructor(C){this.a=C}async acquire(C,...I){const F=this.a.acquire(C,...I);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(j){throw F.dispose(),j}}}e.$1c=g;class D{constructor(C){this.object=C}dispose(){}}e.$2c=D;function w(y){const C=new s;try{y(C)}finally{C.dispose()}}class k{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,I,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(C)?.dispose(),this.a.set(C,I)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=k}),function(le,e){typeof define=="function"&&define.amd?define(ke[165],Ee([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(oe,ae){for(var re=0;re<ae.length;re++){var G=ae[re];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(oe,G.key,G)}}function u(oe,ae,re){return ae&&e(oe.prototype,ae),re&&e(oe,re),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function N(oe,ae){if(oe){if(typeof oe=="string")return L(oe,ae);var re=Object.prototype.toString.call(oe).slice(8,-1);if(re==="Object"&&oe.constructor&&(re=oe.constructor.name),re==="Map"||re==="Set")return Array.from(oe);if(re==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(re))return L(oe,ae)}}function L(oe,ae){(ae==null||ae>oe.length)&&(ae=oe.length);for(var re=0,G=new Array(ae);re<ae;re++)G[re]=oe[re];return G}function R(oe,ae){var re=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(re)return(re=re.call(oe)).next.bind(re);if(Array.isArray(oe)||(re=N(oe))||ae&&oe&&typeof oe.length=="number"){re&&(oe=re);var G=0;return function(){return G>=oe.length?{done:!0}:{done:!1,value:oe[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=M();function p(oe){le.defaults=oe}var b=/[&<>"']/,S=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ae){return $[ae]};function v(oe,ae){if(ae){if(b.test(oe))return oe.replace(S,E)}else if(A.test(oe))return oe.replace(P,E);return oe}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(oe){return oe.replace(a,function(ae,re){return re=re.toLowerCase(),re==="colon"?":":re.charAt(0)==="#"?re.charAt(1)==="x"?String.fromCharCode(parseInt(re.substring(2),16)):String.fromCharCode(+re.substring(1)):""})}var o=/(^|[^\[])\^/g;function n(oe,ae){oe=typeof oe=="string"?oe:oe.source,ae=ae||"";var re={replace:function(te,ge){return ge=ge.source||ge,ge=ge.replace(o,"$1"),oe=oe.replace(te,ge),re},getRegex:function(){return new RegExp(oe,ae)}};return re}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(oe,ae,re){if(oe){var G;try{G=decodeURIComponent(m(re)).replace(i,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}ae&&!r.test(re)&&(re=c(ae,re));try{re=encodeURI(re).replace(/%25/g,"%")}catch{return null}return re}var t={},f=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(oe,ae){t[" "+oe]||(f.test(oe)?t[" "+oe]=oe+"/":t[" "+oe]=w(oe,"/",!0)),oe=t[" "+oe];var re=oe.indexOf(":")===-1;return ae.substring(0,2)==="//"?re?ae:oe.replace(d,"$1")+ae:ae.charAt(0)==="/"?re?ae:oe.replace(l,"$1")+ae:oe+ae}var h={exec:function(){}};function g(oe){for(var ae=1,re,G;ae<arguments.length;ae++){re=arguments[ae];for(G in re)Object.prototype.hasOwnProperty.call(re,G)&&(oe[G]=re[G])}return oe}function D(oe,ae){var re=oe.replace(/\|/g,function(ge,we,Re){for(var fe=!1,Se=we;--Se>=0&&Re[Se]==="\\";)fe=!fe;return fe?"|":" |"}),G=re.split(/ \|/),te=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>ae)G.splice(ae);else for(;G.length<ae;)G.push("");for(;te<G.length;te++)G[te]=G[te].trim().replace(/\\\|/g,"|");return G}function w(oe,ae,re){var G=oe.length;if(G===0)return"";for(var te=0;te<G;){var ge=oe.charAt(G-te-1);if(ge===ae&&!re)te++;else if(ge!==ae&&re)te++;else break}return oe.slice(0,G-te)}function k(oe,ae){if(oe.indexOf(ae[1])===-1)return-1;for(var re=oe.length,G=0,te=0;te<re;te++)if(oe[te]==="\\")te++;else if(oe[te]===ae[0])G++;else if(oe[te]===ae[1]&&(G--,G<0))return te;return-1}function y(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(oe,ae){if(ae<1)return"";for(var re="";ae>1;)ae&1&&(re+=oe),ae>>=1,oe+=oe;return re+oe}function I(oe,ae,re,G){var te=ae.href,ge=ae.title?v(ae.title):null,we=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){G.state.inLink=!0;var Re={type:"link",raw:re,href:te,title:ge,text:we,tokens:G.inlineTokens(we)};return G.state.inLink=!1,Re}return{type:"image",raw:re,href:te,title:ge,text:v(we)}}function F(oe,ae){var re=oe.match(/^(\s+)(?:```)/);if(re===null)return ae;var G=re[1];return ae.split(`
`).map(function(te){var ge=te.match(/^\s+/);if(ge===null)return te;var we=ge[0];return we.length>=G.length?te.slice(G.length):te}).join(`
`)}var j=function(){function oe(re){this.options=re||le.defaults}var ae=oe.prototype;return ae.space=function(G){var te=this.rules.block.newline.exec(G);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},ae.code=function(G){var te=this.rules.block.code.exec(G);if(te){var ge=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:w(ge,`
`)}}},ae.fences=function(G){var te=this.rules.block.fences.exec(G);if(te){var ge=te[0],we=F(ge,te[3]||"");return{type:"code",raw:ge,lang:te[2]?te[2].trim():te[2],text:we}}},ae.heading=function(G){var te=this.rules.block.heading.exec(G);if(te){var ge=te[2].trim();if(/#$/.test(ge)){var we=w(ge,"#");(this.options.pedantic||!we||/ $/.test(we))&&(ge=we.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:ge,tokens:this.lexer.inline(ge)}}},ae.hr=function(G){var te=this.rules.block.hr.exec(G);if(te)return{type:"hr",raw:te[0]}},ae.blockquote=function(G){var te=this.rules.block.blockquote.exec(G);if(te){var ge=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ae.list=function(G){var te=this.rules.block.list.exec(G);if(te){var ge,we,Re,fe,Se,Ae,Fe,q,V,Q,J,he,pe=te[1].trim(),ze=pe.length>1,Ve={type:"list",raw:"",ordered:ze,start:ze?+pe.slice(0,-1):"",loose:!1,items:[]};pe=ze?"\\d{1,9}\\"+pe.slice(-1):"\\"+pe,this.options.pedantic&&(pe=ze?pe:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+pe+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(he=!1,!(!(te=Ze.exec(G))||this.rules.block.hr.test(G)));){if(ge=te[0],G=G.substring(ge.length),q=te[2].split(`
`,1)[0],V=G.split(`
`,1)[0],this.options.pedantic?(fe=2,J=q.trimLeft()):(fe=te[2].search(/[^ ]/),fe=fe>4?1:fe,J=q.slice(fe),fe+=te[1].length),Ae=!1,!q&&/^ *$/.test(V)&&(ge+=V+`
`,G=G.substring(V.length+1),he=!0),!he)for(var tt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");G&&(Q=G.split(`
`,1)[0],q=Q,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(q)||st.test(q)||tt.test(q)||ot.test(G)));){if(q.search(/[^ ]/)>=fe||!q.trim())J+=`
`+q.slice(fe);else if(!Ae)J+=`
`+q;else break;!Ae&&!q.trim()&&(Ae=!0),ge+=Q+`
`,G=G.substring(Q.length+1)}Ve.loose||(Fe?Ve.loose=!0:/\n *\n *$/.test(ge)&&(Fe=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(J),we&&(Re=we[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:ge,task:!!we,checked:Re,loose:!1,text:J}),Ve.raw+=ge}Ve.items[Ve.items.length-1].raw=ge.trimRight(),Ve.items[Ve.items.length-1].text=J.trimRight(),Ve.raw=Ve.raw.trimRight();var De=Ve.items.length;for(Se=0;Se<De;Se++){this.lexer.state.top=!1,Ve.items[Se].tokens=this.lexer.blockTokens(Ve.items[Se].text,[]);var Be=Ve.items[Se].tokens.filter(function(Le){return Le.type==="space"}),He=Be.every(function(Le){for(var Xe=Le.raw.split(""),se=0,ue=R(Xe),Ie;!(Ie=ue()).done;){var Ge=Ie.value;if(Ge===`
`&&(se+=1),se>1)return!0}return!1});!Ve.loose&&Be.length&&He&&(Ve.loose=!0,Ve.items[Se].loose=!0)}return Ve}},ae.html=function(G){var te=this.rules.block.html.exec(G);if(te){var ge={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]);ge.type="paragraph",ge.text=we,ge.tokens=this.lexer.inline(we)}return ge}},ae.def=function(G){var te=this.rules.block.def.exec(G);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var ge=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:te[0],href:te[2],title:te[3]}}},ae.table=function(G){var te=this.rules.block.table.exec(G);if(te){var ge={type:"table",header:D(te[1]).map(function(Fe){return{text:Fe}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=te[0];var we=ge.align.length,Re,fe,Se,Ae;for(Re=0;Re<we;Re++)/^ *-+: *$/.test(ge.align[Re])?ge.align[Re]="right":/^ *:-+: *$/.test(ge.align[Re])?ge.align[Re]="center":/^ *:-+ *$/.test(ge.align[Re])?ge.align[Re]="left":ge.align[Re]=null;for(we=ge.rows.length,Re=0;Re<we;Re++)ge.rows[Re]=D(ge.rows[Re],ge.header.length).map(function(Fe){return{text:Fe}});for(we=ge.header.length,fe=0;fe<we;fe++)ge.header[fe].tokens=this.lexer.inline(ge.header[fe].text);for(we=ge.rows.length,fe=0;fe<we;fe++)for(Ae=ge.rows[fe],Se=0;Se<Ae.length;Se++)Ae[Se].tokens=this.lexer.inline(Ae[Se].text);return ge}}},ae.lheading=function(G){var te=this.rules.block.lheading.exec(G);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},ae.paragraph=function(G){var te=this.rules.block.paragraph.exec(G);if(te){var ge=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:ge,tokens:this.lexer.inline(ge)}}},ae.text=function(G){var te=this.rules.block.text.exec(G);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},ae.escape=function(G){var te=this.rules.inline.escape.exec(G);if(te)return{type:"escape",raw:te[0],text:v(te[1])}},ae.tag=function(G){var te=this.rules.inline.tag.exec(G);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]):te[0]}},ae.link=function(G){var te=this.rules.inline.link.exec(G);if(te){var ge=te[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var we=w(ge.slice(0,-1),"\\");if((ge.length-we.length)%2===0)return}else{var Re=k(te[2],"()");if(Re>-1){var fe=te[0].indexOf("!")===0?5:4,Se=fe+te[1].length+Re;te[2]=te[2].substring(0,Re),te[0]=te[0].substring(0,Se).trim(),te[3]=""}}var Ae=te[2],Fe="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);q&&(Ae=q[1],Fe=q[3])}else Fe=te[3]?te[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(ge)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),I(te,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},ae.reflink=function(G,te){var ge;if((ge=this.rules.inline.reflink.exec(G))||(ge=this.rules.inline.nolink.exec(G))){var we=(ge[2]||ge[1]).replace(/\s+/g," ");if(we=te[we.toLowerCase()],!we||!we.href){var Re=ge[0].charAt(0);return{type:"text",raw:Re,text:Re}}return I(ge,we,ge[0],this.lexer)}},ae.emStrong=function(G,te,ge){ge===void 0&&(ge="");var we=this.rules.inline.emStrong.lDelim.exec(G);if(we&&!(we[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Re=we[1]||we[2]||"";if(!Re||Re&&(ge===""||this.rules.inline.punctuation.exec(ge))){var fe=we[0].length-1,Se,Ae,Fe=fe,q=0,V=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,te=te.slice(-1*G.length+fe);(we=V.exec(te))!=null;)if(Se=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!Se){if(Ae=Se.length,we[3]||we[4]){Fe+=Ae;continue}else if((we[5]||we[6])&&fe%3&&!((fe+Ae)%3)){q+=Ae;continue}if(Fe-=Ae,!(Fe>0)){if(Ae=Math.min(Ae,Ae+Fe+q),Math.min(fe,Ae)%2){var Q=G.slice(1,fe+we.index+Ae);return{type:"em",raw:G.slice(0,fe+we.index+Ae+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var J=G.slice(2,fe+we.index+Ae-1);return{type:"strong",raw:G.slice(0,fe+we.index+Ae+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},ae.codespan=function(G){var te=this.rules.inline.code.exec(G);if(te){var ge=te[2].replace(/\n/g," "),we=/[^ ]/.test(ge),Re=/^ /.test(ge)&&/ $/.test(ge);return we&&Re&&(ge=ge.substring(1,ge.length-1)),ge=v(ge,!0),{type:"codespan",raw:te[0],text:ge}}},ae.br=function(G){var te=this.rules.inline.br.exec(G);if(te)return{type:"br",raw:te[0]}},ae.del=function(G){var te=this.rules.inline.del.exec(G);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},ae.autolink=function(G,te){var ge=this.rules.inline.autolink.exec(G);if(ge){var we,Re;return ge[2]==="@"?(we=v(this.options.mangle?te(ge[1]):ge[1]),Re="mailto:"+we):(we=v(ge[1]),Re=we),{type:"link",raw:ge[0],text:we,href:Re,tokens:[{type:"text",raw:we,text:we}]}}},ae.url=function(G,te){var ge;if(ge=this.rules.inline.url.exec(G)){var we,Re;if(ge[2]==="@")we=v(this.options.mangle?te(ge[0]):ge[0]),Re="mailto:"+we;else{var fe;do fe=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(fe!==ge[0]);we=v(ge[0]),ge[1]==="www."?Re="http://"+we:Re=we}return{type:"link",raw:ge[0],text:we,href:Re,tokens:[{type:"text",raw:we,text:we}]}}},ae.inlineText=function(G,te){var ge=this.rules.inline.text.exec(G);if(ge){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):v(ge[0]):ge[0]:we=v(this.options.smartypants?te(ge[0]):ge[0]),{type:"text",raw:ge[0],text:we}}},oe}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=g({},z),z.gfm=g({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=g({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=n(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=n(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=n(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=n(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=n(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=n(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=n(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=n(O.reflink).replace("label",O._label).replace("ref",z._label).getRegex(),O.nolink=n(O.nolink).replace("ref",z._label).getRegex(),O.reflinkSearch=n(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=g({},O),O.pedantic=g({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=g({},O.normal,{escape:n(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=n(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=g({},O.gfm,{br:n(O.br).replace("{2,}","*").getRegex(),text:n(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(oe){var ae="",re,G,te=oe.length;for(re=0;re<te;re++)G=oe.charCodeAt(re),Math.random()>.5&&(G="x"+G.toString(16)),ae+="&#"+G+";";return ae}var W=function(){function oe(re){this.tokens=[],this.tokens.links=Object.create(null),this.options=re||le.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:z.normal,inline:O.normal};this.options.pedantic?(G.block=z.pedantic,G.inline=O.pedantic):this.options.gfm&&(G.block=z.gfm,this.options.breaks?G.inline=O.breaks:G.inline=O.gfm),this.tokenizer.rules=G}oe.lex=function(G,te){var ge=new oe(te);return ge.lex(G)},oe.lexInline=function(G,te){var ge=new oe(te);return ge.inlineTokens(G)};var ae=oe.prototype;return ae.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},ae.blockTokens=function(G,te){var ge=this;te===void 0&&(te=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(Fe,q,V){return q+"    ".repeat(V.length)});for(var we,Re,fe,Se;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Fe){return(we=Fe.call({lexer:ge},G,te))?(G=G.substring(we.raw.length),te.push(we),!0):!1}))){if(we=this.tokenizer.space(G)){G=G.substring(we.raw.length),we.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(we);continue}if(we=this.tokenizer.code(G)){G=G.substring(we.raw.length),Re=te[te.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+we.raw,Re.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):te.push(we);continue}if(we=this.tokenizer.fences(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.heading(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.hr(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.blockquote(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.list(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.html(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.def(G)){G=G.substring(we.raw.length),Re=te[te.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+we.raw,Re.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.lheading(G)){G=G.substring(we.raw.length),te.push(we);continue}if(fe=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var Fe=1/0,q=G.slice(1),V=void 0;ge.options.extensions.startBlock.forEach(function(Q){V=Q.call({lexer:this},q),typeof V=="number"&&V>=0&&(Fe=Math.min(Fe,V))}),Fe<1/0&&Fe>=0&&(fe=G.substring(0,Fe+1))}(),this.state.top&&(we=this.tokenizer.paragraph(fe))){Re=te[te.length-1],Se&&Re.type==="paragraph"?(Re.raw+=`
`+we.raw,Re.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):te.push(we),Se=fe.length!==G.length,G=G.substring(we.raw.length);continue}if(we=this.tokenizer.text(G)){G=G.substring(we.raw.length),Re=te[te.length-1],Re&&Re.type==="text"?(Re.raw+=`
`+we.raw,Re.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):te.push(we);continue}if(G){var Ae="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,te},ae.inline=function(G,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:G,tokens:te}),te},ae.inlineTokens=function(G,te){var ge=this;te===void 0&&(te=[]);var we,Re,fe,Se=G,Ae,Fe,q;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)V.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Se))!=null;)Se=Se.slice(0,Ae.index)+"++"+Se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(Fe||(q=""),Fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(we=J.call({lexer:ge},G,te))?(G=G.substring(we.raw.length),te.push(we),!0):!1}))){if(we=this.tokenizer.escape(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.tag(G)){G=G.substring(we.raw.length),Re=te[te.length-1],Re&&we.type==="text"&&Re.type==="text"?(Re.raw+=we.raw,Re.text+=we.text):te.push(we);continue}if(we=this.tokenizer.link(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(we.raw.length),Re=te[te.length-1],Re&&we.type==="text"&&Re.type==="text"?(Re.raw+=we.raw,Re.text+=we.text):te.push(we);continue}if(we=this.tokenizer.emStrong(G,Se,q)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.codespan(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.br(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.del(G)){G=G.substring(we.raw.length),te.push(we);continue}if(we=this.tokenizer.autolink(G,B)){G=G.substring(we.raw.length),te.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(G,B))){G=G.substring(we.raw.length),te.push(we);continue}if(fe=G,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,he=G.slice(1),pe=void 0;ge.options.extensions.startInline.forEach(function(ze){pe=ze.call({lexer:this},he),typeof pe=="number"&&pe>=0&&(J=Math.min(J,pe))}),J<1/0&&J>=0&&(fe=G.substring(0,J+1))}(),we=this.tokenizer.inlineText(fe,T)){G=G.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(q=we.raw.slice(-1)),Fe=!0,Re=te[te.length-1],Re&&Re.type==="text"?(Re.raw+=we.raw,Re.text+=we.text):te.push(we);continue}if(G){var Q="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return te},u(oe,null,[{key:"rules",get:function(){return{block:z,inline:O}}}]),oe}(),Z=function(){function oe(re){this.options=re||le.defaults}var ae=oe.prototype;return ae.code=function(G,te,ge){var we=(te||"").match(/\S*/)[0];if(this.options.highlight){var Re=this.options.highlight(G,we);Re!=null&&Re!==G&&(ge=!0,G=Re)}return G=G.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+v(we,!0)+'">'+(ge?G:v(G,!0))+`</code></pre>
`:"<pre><code>"+(ge?G:v(G,!0))+`</code></pre>
`},ae.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},ae.html=function(G){return G},ae.heading=function(G,te,ge,we){if(this.options.headerIds){var Re=this.options.headerPrefix+we.slug(ge);return"<h"+te+' id="'+Re+'">'+G+"</h"+te+`>
`}return"<h"+te+">"+G+"</h"+te+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(G,te,ge){var we=te?"ol":"ul",Re=te&&ge!==1?' start="'+ge+'"':"";return"<"+we+Re+`>
`+G+"</"+we+`>
`},ae.listitem=function(G){return"<li>"+G+`</li>
`},ae.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(G){return"<p>"+G+`</p>
`},ae.table=function(G,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+te+`</table>
`},ae.tablerow=function(G){return`<tr>
`+G+`</tr>
`},ae.tablecell=function(G,te){var ge=te.header?"th":"td",we=te.align?"<"+ge+' align="'+te.align+'">':"<"+ge+">";return we+G+("</"+ge+`>
`)},ae.strong=function(G){return"<strong>"+G+"</strong>"},ae.em=function(G){return"<em>"+G+"</em>"},ae.codespan=function(G){return"<code>"+G+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(G){return"<del>"+G+"</del>"},ae.link=function(G,te,ge){if(G=s(this.options.sanitize,this.options.baseUrl,G),G===null)return ge;var we='<a href="'+v(G)+'"';return te&&(we+=' title="'+te+'"'),we+=">"+ge+"</a>",we},ae.image=function(G,te,ge){if(G=s(this.options.sanitize,this.options.baseUrl,G),G===null)return ge;var we='<img src="'+G+'" alt="'+ge+'"';return te&&(we+=' title="'+te+'"'),we+=this.options.xhtml?"/>":">",we},ae.text=function(G){return G},oe}(),x=function(){function oe(){}var ae=oe.prototype;return ae.strong=function(G){return G},ae.em=function(G){return G},ae.codespan=function(G){return G},ae.del=function(G){return G},ae.html=function(G){return G},ae.text=function(G){return G},ae.link=function(G,te,ge){return""+ge},ae.image=function(G,te,ge){return""+ge},ae.br=function(){return""},oe}(),X=function(){function oe(){this.seen={}}var ae=oe.prototype;return ae.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(G,te){var ge=G,we=0;if(this.seen.hasOwnProperty(ge)){we=this.seen[G];do we++,ge=G+"-"+we;while(this.seen.hasOwnProperty(ge))}return te||(this.seen[G]=we,this.seen[ge]=0),ge},ae.slug=function(G,te){te===void 0&&(te={});var ge=this.serialize(G);return this.getNextSafeSlug(ge,te.dryrun)},oe}(),Y=function(){function oe(re){this.options=re||le.defaults,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new X}oe.parse=function(G,te){var ge=new oe(te);return ge.parse(G)},oe.parseInline=function(G,te){var ge=new oe(te);return ge.parseInline(G)};var ae=oe.prototype;return ae.parse=function(G,te){te===void 0&&(te=!0);var ge="",we,Re,fe,Se,Ae,Fe,q,V,Q,J,he,pe,ze,Ve,Ze,tt,ot,it,st,De=G.length;for(we=0;we<De;we++){if(J=G[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(st=this.options.extensions.renderers[J.type].call({parser:this},J),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){ge+=st||"";continue}switch(J.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(J.tokens),J.depth,m(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(V="",q="",Se=J.header.length,Re=0;Re<Se;Re++)q+=this.renderer.tablecell(this.parseInline(J.header[Re].tokens),{header:!0,align:J.align[Re]});for(V+=this.renderer.tablerow(q),Q="",Se=J.rows.length,Re=0;Re<Se;Re++){for(Fe=J.rows[Re],q="",Ae=Fe.length,fe=0;fe<Ae;fe++)q+=this.renderer.tablecell(this.parseInline(Fe[fe].tokens),{header:!1,align:J.align[fe]});Q+=this.renderer.tablerow(q)}ge+=this.renderer.table(V,Q);continue}case"blockquote":{Q=this.parse(J.tokens),ge+=this.renderer.blockquote(Q);continue}case"list":{for(he=J.ordered,pe=J.start,ze=J.loose,Se=J.items.length,Q="",Re=0;Re<Se;Re++)Ze=J.items[Re],tt=Ze.checked,ot=Ze.task,Ve="",Ze.task&&(it=this.renderer.checkbox(tt),ze?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=it+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=it+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:it}):Ve+=it),Ve+=this.parse(Ze.tokens,ze),Q+=this.renderer.listitem(Ve,ot,tt);ge+=this.renderer.list(Q,he,pe);continue}case"html":{ge+=this.renderer.html(J.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(Q=J.tokens?this.parseInline(J.tokens):J.text;we+1<De&&G[we+1].type==="text";)J=G[++we],Q+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);ge+=te?this.renderer.paragraph(Q):Q;continue}default:{var Be='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return ge},ae.parseInline=function(G,te){te=te||this.renderer;var ge="",we,Re,fe,Se=G.length;for(we=0;we<Se;we++){if(Re=G[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(fe=this.options.extensions.renderers[Re.type].call({parser:this},Re),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Re.type))){ge+=fe||"";continue}switch(Re.type){case"escape":{ge+=te.text(Re.text);break}case"html":{ge+=te.html(Re.text);break}case"link":{ge+=te.link(Re.href,Re.title,this.parseInline(Re.tokens,te));break}case"image":{ge+=te.image(Re.href,Re.title,Re.text);break}case"strong":{ge+=te.strong(this.parseInline(Re.tokens,te));break}case"em":{ge+=te.em(this.parseInline(Re.tokens,te));break}case"codespan":{ge+=te.codespan(Re.text);break}case"br":{ge+=te.br();break}case"del":{ge+=te.del(this.parseInline(Re.tokens,te));break}case"text":{ge+=te.text(Re.text);break}default:{var Ae='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return ge},oe}();function ce(oe,ae,re){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof ae=="function"&&(re=ae,ae=null),ae=g({},ce.defaults,ae||{}),y(ae),re){var G=ae.highlight,te;try{te=W.lex(oe,ae)}catch(Se){return re(Se)}var ge=function(Ae){var Fe;if(!Ae)try{ae.walkTokens&&ce.walkTokens(te,ae.walkTokens),Fe=Y.parse(te,ae)}catch(q){Ae=q}return ae.highlight=G,Ae?re(Ae):re(null,Fe)};if(!G||G.length<3||(delete ae.highlight,!te.length))return ge();var we=0;ce.walkTokens(te,function(Se){Se.type==="code"&&(we++,setTimeout(function(){G(Se.text,Se.lang,function(Ae,Fe){if(Ae)return ge(Ae);Fe!=null&&Fe!==Se.text&&(Se.text=Fe,Se.escaped=!0),we--,we===0&&ge()})},0))}),we===0&&ge();return}function Re(Se){if(Se.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+v(Se.message+"",!0)+"</pre>";throw Se}try{var fe=W.lex(oe,ae);if(ae.walkTokens){if(ae.async)return Promise.all(ce.walkTokens(fe,ae.walkTokens)).then(function(){return Y.parse(fe,ae)}).catch(Re);ce.walkTokens(fe,ae.walkTokens)}return Y.parse(fe,ae)}catch(Se){Re(Se)}}ce.options=ce.setOptions=function(oe){return g(ce.defaults,oe),p(ce.defaults),ce},ce.getDefaults=M,ce.defaults=le.defaults,ce.use=function(){for(var oe=arguments.length,ae=new Array(oe),re=0;re<oe;re++)ae[re]=arguments[re];var G=g.apply(void 0,[{}].concat(ae)),te=ce.defaults.extensions||{renderers:{},childTokens:{}},ge;ae.forEach(function(we){if(we.extensions&&(ge=!0,we.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var Se=te.renderers?te.renderers[fe.name]:null;Se?te.renderers[fe.name]=function(){for(var Ae=arguments.length,Fe=new Array(Ae),q=0;q<Ae;q++)Fe[q]=arguments[q];var V=fe.renderer.apply(this,Fe);return V===!1&&(V=Se.apply(this,Fe)),V}:te.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[fe.level]?te[fe.level].unshift(fe.tokenizer):te[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?te.startBlock?te.startBlock.push(fe.start):te.startBlock=[fe.start]:fe.level==="inline"&&(te.startInline?te.startInline.push(fe.start):te.startInline=[fe.start]))}fe.childTokens&&(te.childTokens[fe.name]=fe.childTokens)})),we.renderer&&function(){var fe=ce.defaults.renderer||new Z,Se=function(q){var V=fe[q];fe[q]=function(){for(var Q=arguments.length,J=new Array(Q),he=0;he<Q;he++)J[he]=arguments[he];var pe=we.renderer[q].apply(fe,J);return pe===!1&&(pe=V.apply(fe,J)),pe}};for(var Ae in we.renderer)Se(Ae);G.renderer=fe}(),we.tokenizer&&function(){var fe=ce.defaults.tokenizer||new j,Se=function(q){var V=fe[q];fe[q]=function(){for(var Q=arguments.length,J=new Array(Q),he=0;he<Q;he++)J[he]=arguments[he];var pe=we.tokenizer[q].apply(fe,J);return pe===!1&&(pe=V.apply(fe,J)),pe}};for(var Ae in we.tokenizer)Se(Ae);G.tokenizer=fe}(),we.walkTokens){var Re=ce.defaults.walkTokens;G.walkTokens=function(fe){var Se=[];return Se.push(we.walkTokens.call(this,fe)),Re&&(Se=Se.concat(Re.call(this,fe))),Se}}ge&&(G.extensions=te),ce.setOptions(G)})},ce.walkTokens=function(oe,ae){for(var re=[],G=function(){var Re=ge.value;switch(re=re.concat(ae.call(ce,Re)),Re.type){case"table":{for(var fe=R(Re.header),Se;!(Se=fe()).done;){var Ae=Se.value;re=re.concat(ce.walkTokens(Ae.tokens,ae))}for(var Fe=R(Re.rows),q;!(q=Fe()).done;)for(var V=q.value,Q=R(V),J;!(J=Q()).done;){var he=J.value;re=re.concat(ce.walkTokens(he.tokens,ae))}break}case"list":{re=re.concat(ce.walkTokens(Re.items,ae));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Re.type]?ce.defaults.extensions.childTokens[Re.type].forEach(function(pe){re=re.concat(ce.walkTokens(Re[pe],ae))}):Re.tokens&&(re=re.concat(ce.walkTokens(Re.tokens,ae)))}},te=R(oe),ge;!(ge=te()).done;)G();return re},ce.parseInline=function(oe,ae){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");ae=g({},ce.defaults,ae||{}),y(ae);try{var re=W.lexInline(oe,ae);return ae.walkTokens&&ce.walkTokens(re,ae.walkTokens),Y.parseInline(re,ae)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+v(G.message+"",!0)+"</pre>";throw G}},ce.Parser=Y,ce.parser=Y.parse,ce.Renderer=Z,ce.TextRenderer=x,ce.Lexer=W,ce.lexer=W.lex,ce.Tokenizer=j,ce.Slugger=X,ce.parse=ce;var ne=ce.options,$e=ce.setOptions,Ce=ce.use,ee=ce.walkTokens,U=ce.parseInline,ie=ce,be=Y.parse,Pe=W.lex;le.Lexer=W,le.Parser=Y,le.Renderer=Z,le.Slugger=X,le.TextRenderer=x,le.Tokenizer=j,le.getDefaults=M,le.lexer=Pe,le.marked=ce,le.options=ne,le.parse=ie,le.parseInline=U,le.parser=be,le.setOptions=$e,le.use=Ce,le.walkTokens=ee,Object.defineProperty(le,"__esModule",{value:!0})}),define(ke[166],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=u;function u(a){const m=R(a);if(m&&m.length>0)return new Uint32Array(m)}let N=0;const L=new Uint32Array(10);function R(a){if(N=0,M(a,P,4352),N>0||(M(a,$,4449),N>0)||(M(a,E,4520),N>0)||(M(a,v,12593),N))return L.subarray(0,N);if(a>=44032&&a<=55203){const m=a-44032,o=m%588,n=Math.floor(m/588),i=Math.floor(o/28),r=o%28-1;if(n<P.length?M(n,P,0):4352+n-12593<v.length&&M(4352+n,v,12593),i<$.length?M(i,$,0):4449+i-12593<v.length&&M(4449+i-12593,v,12593),r>=0&&(r<E.length?M(r,E,0):4520+r-12593<v.length&&M(4520+r-12593,v,12593)),N>0)return L.subarray(0,N)}}function M(a,m,o){a>=o&&a<o+m.length&&p(m[a-o])}function p(a){a!==0&&(L[N++]=a&255,a>>8&&(L[N++]=a>>8&255),a>>16&&(L[N++]=a>>16&255))}var b;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var S;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(S||(S={}));var A;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(A||(A={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),$=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),E=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Ee([1,0,27]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=void 0,e.$8l=L,e.$9l=M;const N=new u.$Ec(1e4);function L(S){return b(S,"NFC",N)}const R=new u.$Ec(1e4);function M(S){return b(S,"NFD",R)}const p=/[^\u0000-\u0080]/;function b(S,A,P){if(!S)return S;const $=P.get(S);if($)return $;let E;return p.test(S)?E=S.normalize(A):E=S,P.set(S,E),E}e.$0l=function(){const S=/[\u0300-\u036f]/g;return function(A){return M(A).replace(S,"")}}()}),define(ke[125],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0,e.$vm=u,e.rot=N;function u(p,b,S){return Math.min(Math.max(p,b),S)}function N(p,b){return(b+p%b)%b}class L{constructor(){this.a=0}getNext(){return this.a++}}e.$xm=L;class R{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ym=R;class M{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const S=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$zm=M}),function(){function le(L){const R=[];typeof L=="number"&&R.push("code/timeOrigin",L);function M(b){R.push(b,Date.now())}function p(){const b=[];for(let S=0;S<R.length;S+=2)b.push({name:R[S],startTime:R[S+1]});return b}return{mark:M,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(L+M.startTime)});return R}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function u(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=u(N))}(),define(ke[167],Ee([1,0,45]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2O=void 0;const N=Symbol("unset");class L{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||u.Iterable.empty()}insert(b,S,A){this.d(b,P=>P._value=S,A)}mutate(b,S){this.d(b,A=>A._value=S(A._value===N?void 0:A._value))}delete(b){const S=this.c(b);if(!S)return;let A=S.length-1;const P=S[A].node._value;if(P!==N){for(this.b--,S[A].node._value=N;A>0;A--){const{node:$,part:E}=S[A];if($.children?.size||$._value!==N)break;S[A-1].node.children.delete(E)}return P}}*deleteRecursive(b){const S=this.c(b);if(!S)return;const A=S[S.length-1].node;for(let P=S.length-1;P>0;P--){const $=S[P-1];if($.node.children.delete(S[P].part),$.node.children.size>0||$.node._value!==N)break}for(const P of R(A))P._value!==N&&(this.b--,yield P._value)}find(b){let S=this.a;for(const A of b){const P=S.children?.get(A);if(!P)return;S=P}return S._value===N?void 0:S._value}hasKeyOrParent(b){let S=this.a;for(const A of b){const P=S.children?.get(A);if(!P)return!1;if(P._value!==N)return!0;S=P}return!1}hasKeyOrChildren(b){let S=this.a;for(const A of b){const P=S.children?.get(A);if(!P)return!1;S=P}return!0}hasKey(b){let S=this.a;for(const A of b){const P=S.children?.get(A);if(!P)return!1;S=P}return S._value!==N}c(b){const S=[{part:"",node:this.a}];let A=0;for(const P of b){const $=S[A].node.children?.get(P);if(!$)return;S.push({part:P,node:$}),A++}return S}d(b,S,A){let P=this.a;for(const v of b){if(P.children)if(P.children.has(v))P=P.children.get(v);else{const a=new M;P.children.set(v,a),P=a}else{const a=new M;P.children=new Map([[v,a]]),P=a}A?.(P)}const $=P._value===N?0:1;S(P);const E=P._value===N?0:1;this.b+=E-$}*values(){for(const{_value:b}of R(this.a))b!==N&&(yield b)}}e.$2O=L;function*R(p){const b=[p];for(;b.length>0;){const S=b.pop();if(yield S,S.children)for(const A of S.children.values())b.push(A)}}class M{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value(b){this._value=b===void 0?N:b}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var N in u)(typeof exports=="object"?exports:le)[N]=u[N]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function u(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return le[N].call(L.exports,L,L.exports,u),L.l=!0,L.exports}return u.m=le,u.c=e,u.d=function(N,L,R){u.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:R})},u.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},u.t=function(N,L){if(1&L&&(N=u(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var R=Object.create(null);if(u.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var M in N)u.d(R,M,function(p){return N[p]}.bind(null,M));return R},u.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return u.d(L,"a",L),L},u.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},u.p="",u(u.s=0)}([function(le,e,u){(function(N){var L;e=le.exports=Ce,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],b=e.src=[],S=0,A=S++;b[A]="0|[1-9]\\d*";var P=S++;b[P]="[0-9]+";var $=S++;b[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=S++;b[E]="("+b[A]+")\\.("+b[A]+")\\.("+b[A]+")";var v=S++;b[v]="("+b[P]+")\\.("+b[P]+")\\.("+b[P]+")";var a=S++;b[a]="(?:"+b[A]+"|"+b[$]+")";var m=S++;b[m]="(?:"+b[P]+"|"+b[$]+")";var o=S++;b[o]="(?:-("+b[a]+"(?:\\."+b[a]+")*))";var n=S++;b[n]="(?:-?("+b[m]+"(?:\\."+b[m]+")*))";var i=S++;b[i]="[0-9A-Za-z-]+";var r=S++;b[r]="(?:\\+("+b[i]+"(?:\\."+b[i]+")*))";var s=S++,t="v?"+b[E]+b[o]+"?"+b[r]+"?";b[s]="^"+t+"$";var f="[v=\\s]*"+b[v]+b[n]+"?"+b[r]+"?",d=S++;b[d]="^"+f+"$";var l=S++;b[l]="((?:<|>)?=?)";var c=S++;b[c]=b[P]+"|x|X|\\*";var h=S++;b[h]=b[A]+"|x|X|\\*";var g=S++;b[g]="[v=\\s]*("+b[h]+")(?:\\.("+b[h]+")(?:\\.("+b[h]+")(?:"+b[o]+")?"+b[r]+"?)?)?";var D=S++;b[D]="[v=\\s]*("+b[c]+")(?:\\.("+b[c]+")(?:\\.("+b[c]+")(?:"+b[n]+")?"+b[r]+"?)?)?";var w=S++;b[w]="^"+b[l]+"\\s*"+b[g]+"$";var k=S++;b[k]="^"+b[l]+"\\s*"+b[D]+"$";var y=S++;b[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=S++;b[C]="(?:~>?)";var I=S++;b[I]="(\\s*)"+b[C]+"\\s+",p[I]=new RegExp(b[I],"g");var F=S++;b[F]="^"+b[C]+b[g]+"$";var j=S++;b[j]="^"+b[C]+b[D]+"$";var z=S++;b[z]="(?:\\^)";var O=S++;b[O]="(\\s*)"+b[z]+"\\s+",p[O]=new RegExp(b[O],"g");var T=S++;b[T]="^"+b[z]+b[g]+"$";var B=S++;b[B]="^"+b[z]+b[D]+"$";var W=S++;b[W]="^"+b[l]+"\\s*("+f+")$|^$";var Z=S++;b[Z]="^"+b[l]+"\\s*("+t+")$|^$";var x=S++;b[x]="(\\s*)"+b[l]+"\\s*("+f+"|"+b[g]+")",p[x]=new RegExp(b[x],"g");var X=S++;b[X]="^\\s*("+b[g]+")\\s+-\\s+("+b[g]+")\\s*$";var Y=S++;b[Y]="^\\s*("+b[D]+")\\s+-\\s+("+b[D]+")\\s*$";var ce=S++;b[ce]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)L(ne,b[ne]),p[ne]||(p[ne]=new RegExp(b[ne]));function $e(V,Q){if(V instanceof Ce)return V;if(typeof V!="string"||V.length>R||!(Q?p[d]:p[s]).test(V))return null;try{return new Ce(V,Q)}catch{return null}}function Ce(V,Q){if(V instanceof Ce){if(V.loose===Q)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Ce))return new Ce(V,Q);L("SemVer",V,Q),this.loose=Q;var J=V.trim().match(Q?p[d]:p[s]);if(!J)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var pe=+he;if(pe>=0&&pe<M)return pe}return he}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=$e,e.valid=function(V,Q){var J=$e(V,Q);return J?J.version:null},e.clean=function(V,Q){var J=$e(V.trim().replace(/^[=v]+/,""),Q);return J?J.version:null},e.SemVer=Ce,Ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ce.prototype.toString=function(){return this.version},Ce.prototype.compare=function(V){return L("SemVer.compare",this.version,this.loose,V),V instanceof Ce||(V=new Ce(V,this.loose)),this.compareMain(V)||this.comparePre(V)},Ce.prototype.compareMain=function(V){return V instanceof Ce||(V=new Ce(V,this.loose)),U(this.major,V.major)||U(this.minor,V.minor)||U(this.patch,V.patch)},Ce.prototype.comparePre=function(V){if(V instanceof Ce||(V=new Ce(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Q=0;do{var J=this.prerelease[Q],he=V.prerelease[Q];if(L("prerelease compare",Q,J,he),J===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(J===void 0)return-1;if(J!==he)return U(J,he)}while(++Q)},Ce.prototype.inc=function(V,Q){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Q,J,he){typeof J=="string"&&(he=J,J=void 0);try{return new Ce(V,J).inc(Q,he).version}catch{return null}},e.diff=function(V,Q){if(oe(V,Q))return null;var J=$e(V),he=$e(Q);if(J.prerelease.length||he.prerelease.length){for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==he[pe])return"pre"+pe;return"prerelease"}for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==he[pe])return pe},e.compareIdentifiers=U;var ee=/^[0-9]+$/;function U(V,Q){var J=ee.test(V),he=ee.test(Q);return J&&he&&(V=+V,Q=+Q),J&&!he?-1:he&&!J?1:V<Q?-1:V>Q?1:0}function ie(V,Q,J){return new Ce(V,J).compare(new Ce(Q,J))}function be(V,Q,J){return ie(V,Q,J)>0}function Pe(V,Q,J){return ie(V,Q,J)<0}function oe(V,Q,J){return ie(V,Q,J)===0}function ae(V,Q,J){return ie(V,Q,J)!==0}function re(V,Q,J){return ie(V,Q,J)>=0}function G(V,Q,J){return ie(V,Q,J)<=0}function te(V,Q,J,he){var pe;switch(Q){case"===":typeof V=="object"&&(V=V.version),typeof J=="object"&&(J=J.version),pe=V===J;break;case"!==":typeof V=="object"&&(V=V.version),typeof J=="object"&&(J=J.version),pe=V!==J;break;case"":case"=":case"==":pe=oe(V,J,he);break;case"!=":pe=ae(V,J,he);break;case">":pe=be(V,J,he);break;case">=":pe=re(V,J,he);break;case"<":pe=Pe(V,J,he);break;case"<=":pe=G(V,J,he);break;default:throw new TypeError("Invalid operator: "+Q)}return pe}function ge(V,Q){if(V instanceof ge){if(V.loose===Q)return V;V=V.value}if(!(this instanceof ge))return new ge(V,Q);L("comparator",V,Q),this.loose=Q,this.parse(V),this.semver===we?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(V,Q){return U(Q,V)},e.major=function(V,Q){return new Ce(V,Q).major},e.minor=function(V,Q){return new Ce(V,Q).minor},e.patch=function(V,Q){return new Ce(V,Q).patch},e.compare=ie,e.compareLoose=function(V,Q){return ie(V,Q,!0)},e.rcompare=function(V,Q,J){return ie(Q,V,J)},e.sort=function(V,Q){return V.sort(function(J,he){return e.compare(J,he,Q)})},e.rsort=function(V,Q){return V.sort(function(J,he){return e.rcompare(J,he,Q)})},e.gt=be,e.lt=Pe,e.eq=oe,e.neq=ae,e.gte=re,e.lte=G,e.cmp=te,e.Comparator=ge;var we={};function Re(V,Q){if(V instanceof Re)return V.loose===Q?V:new Re(V.raw,Q);if(V instanceof ge)return new Re(V.value,Q);if(!(this instanceof Re))return new Re(V,Q);if(this.loose=Q,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function fe(V){return!V||V.toLowerCase()==="x"||V==="*"}function Se(V,Q,J,he,pe,ze,Ve,Ze,tt,ot,it,st,De){return((Q=fe(J)?"":fe(he)?">="+J+".0.0":fe(pe)?">="+J+"."+he+".0":">="+Q)+" "+(Ze=fe(tt)?"":fe(ot)?"<"+(+tt+1)+".0.0":fe(it)?"<"+tt+"."+(+ot+1)+".0":st?"<="+tt+"."+ot+"."+it+"-"+st:"<="+Ze)).trim()}function Ae(V,Q){for(var J=0;J<V.length;J++)if(!V[J].test(Q))return!1;if(Q.prerelease.length){for(J=0;J<V.length;J++)if(L(V[J].semver),V[J].semver!==we&&V[J].semver.prerelease.length>0){var he=V[J].semver;if(he.major===Q.major&&he.minor===Q.minor&&he.patch===Q.patch)return!0}return!1}return!0}function Fe(V,Q,J){try{Q=new Re(Q,J)}catch{return!1}return Q.test(V)}function q(V,Q,J,he){var pe,ze,Ve,Ze,tt;switch(V=new Ce(V,he),Q=new Re(Q,he),J){case">":pe=be,ze=G,Ve=Pe,Ze=">",tt=">=";break;case"<":pe=Pe,ze=re,Ve=be,Ze="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(V,Q,he))return!1;for(var ot=0;ot<Q.set.length;++ot){var it=Q.set[ot],st=null,De=null;if(it.forEach(function(Be){Be.semver===we&&(Be=new ge(">=0.0.0")),st=st||Be,De=De||Be,pe(Be.semver,st.semver,he)?st=Be:Ve(Be.semver,De.semver,he)&&(De=Be)}),st.operator===Ze||st.operator===tt||(!De.operator||De.operator===Ze)&&ze(V,De.semver)||De.operator===tt&&Ve(V,De.semver))return!1}return!0}ge.prototype.parse=function(V){var Q=this.loose?p[W]:p[Z],J=V.match(Q);if(!J)throw new TypeError("Invalid comparator: "+V);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new Ce(J[2],this.loose):this.semver=we},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(V){return L("Comparator.test",V,this.loose),this.semver===we||(typeof V=="string"&&(V=new Ce(V,this.loose)),te(V,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(V,Q){if(!(V instanceof ge))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Re(V.value,Q),Fe(this.value,J,Q);if(V.operator==="")return J=new Re(this.value,Q),Fe(V.semver,J,Q);var he=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),ze=this.semver.version===V.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ze=te(this.semver,"<",V.semver,Q)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),tt=te(this.semver,">",V.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return he||pe||ze&&Ve||Ze||tt},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(V){var Q=this.loose;V=V.trim(),L("range",V,Q);var J=Q?p[Y]:p[X];V=V.replace(J,Se),L("hyphen replace",V),V=V.replace(p[x],"$1$2$3"),L("comparator trim",V,p[x]),V=(V=(V=V.replace(p[I],"$1~")).replace(p[O],"$1^")).split(/\s+/).join(" ");var he=Q?p[W]:p[Z],pe=V.split(" ").map(function(ze){return function(Ve,Ze){return L("comp",Ve),Ve=function(tt,ot){return tt.trim().split(/\s+/).map(function(it){return function(st,De){L("caret",st,De);var Be=De?p[B]:p[T];return st.replace(Be,function(He,Le,Xe,se,ue){var Ie;return L("caret",st,He,Le,Xe,se,ue),fe(Le)?Ie="":fe(Xe)?Ie=">="+Le+".0.0 <"+(+Le+1)+".0.0":fe(se)?Ie=Le==="0"?">="+Le+"."+Xe+".0 <"+Le+"."+(+Xe+1)+".0":">="+Le+"."+Xe+".0 <"+(+Le+1)+".0.0":ue?(L("replaceCaret pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),Ie=Le==="0"?Xe==="0"?">="+Le+"."+Xe+"."+se+ue+" <"+Le+"."+Xe+"."+(+se+1):">="+Le+"."+Xe+"."+se+ue+" <"+Le+"."+(+Xe+1)+".0":">="+Le+"."+Xe+"."+se+ue+" <"+(+Le+1)+".0.0"):(L("no pr"),Ie=Le==="0"?Xe==="0"?">="+Le+"."+Xe+"."+se+" <"+Le+"."+Xe+"."+(+se+1):">="+Le+"."+Xe+"."+se+" <"+Le+"."+(+Xe+1)+".0":">="+Le+"."+Xe+"."+se+" <"+(+Le+1)+".0.0"),L("caret return",Ie),Ie})}(it,ot)}).join(" ")}(Ve,Ze),L("caret",Ve),Ve=function(tt,ot){return tt.trim().split(/\s+/).map(function(it){return function(st,De){var Be=De?p[j]:p[F];return st.replace(Be,function(He,Le,Xe,se,ue){var Ie;return L("tilde",st,He,Le,Xe,se,ue),fe(Le)?Ie="":fe(Xe)?Ie=">="+Le+".0.0 <"+(+Le+1)+".0.0":fe(se)?Ie=">="+Le+"."+Xe+".0 <"+Le+"."+(+Xe+1)+".0":ue?(L("replaceTilde pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),Ie=">="+Le+"."+Xe+"."+se+ue+" <"+Le+"."+(+Xe+1)+".0"):Ie=">="+Le+"."+Xe+"."+se+" <"+Le+"."+(+Xe+1)+".0",L("tilde return",Ie),Ie})}(it,ot)}).join(" ")}(Ve,Ze),L("tildes",Ve),Ve=function(tt,ot){return L("replaceXRanges",tt,ot),tt.split(/\s+/).map(function(it){return function(st,De){st=st.trim();var Be=De?p[k]:p[w];return st.replace(Be,function(He,Le,Xe,se,ue,Ie){L("xRange",st,He,Le,Xe,se,ue,Ie);var Ge=fe(Xe),Me=Ge||fe(se),nt=Me||fe(ue);return Le==="="&&nt&&(Le=""),Ge?He=Le===">"||Le==="<"?"<0.0.0":"*":Le&&nt?(Me&&(se=0),nt&&(ue=0),Le===">"?(Le=">=",Me?(Xe=+Xe+1,se=0,ue=0):nt&&(se=+se+1,ue=0)):Le==="<="&&(Le="<",Me?Xe=+Xe+1:se=+se+1),He=Le+Xe+"."+se+"."+ue):Me?He=">="+Xe+".0.0 <"+(+Xe+1)+".0.0":nt&&(He=">="+Xe+"."+se+".0 <"+Xe+"."+(+se+1)+".0"),L("xRange return",He),He})}(it,ot)}).join(" ")}(Ve,Ze),L("xrange",Ve),Ve=function(tt,ot){return L("replaceStars",tt,ot),tt.trim().replace(p[ce],"")}(Ve,Ze),L("stars",Ve),Ve}(ze,Q)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(ze){return!!ze.match(he)})),pe=pe.map(function(ze){return new ge(ze,Q)})},Re.prototype.intersects=function(V,Q){if(!(V instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(he){return V.set.some(function(pe){return pe.every(function(ze){return he.intersects(ze,Q)})})})})},e.toComparators=function(V,Q){return new Re(V,Q).set.map(function(J){return J.map(function(he){return he.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new Ce(V,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Ae(this.set[Q],V))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(V,Q,J){var he=null,pe=null;try{var ze=new Re(Q,J)}catch{return null}return V.forEach(function(Ve){ze.test(Ve)&&(he&&pe.compare(Ve)!==-1||(pe=new Ce(he=Ve,J)))}),he},e.minSatisfying=function(V,Q,J){var he=null,pe=null;try{var ze=new Re(Q,J)}catch{return null}return V.forEach(function(Ve){ze.test(Ve)&&(he&&pe.compare(Ve)!==1||(pe=new Ce(he=Ve,J)))}),he},e.validRange=function(V,Q){try{return new Re(V,Q).range||"*"}catch{return null}},e.ltr=function(V,Q,J){return q(V,Q,"<",J)},e.gtr=function(V,Q,J){return q(V,Q,">",J)},e.outside=q,e.prerelease=function(V,Q){var J=$e(V,Q);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(V,Q,J){return V=new Re(V,J),Q=new Re(Q,J),V.intersects(Q)},e.coerce=function(V){if(V instanceof Ce)return V;if(typeof V!="string")return null;var Q=V.match(p[y]);return Q==null?null:$e((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,u(1))},function(le,e){var u,N,L=le.exports={};function R(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function p(m){if(u===setTimeout)return setTimeout(m,0);if((u===R||!u)&&setTimeout)return u=setTimeout,setTimeout(m,0);try{return u(m,0)}catch{try{return u.call(null,m,0)}catch{return u.call(this,m,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:R}catch{u=R}try{N=typeof clearTimeout=="function"?clearTimeout:M}catch{N=M}})();var b,S=[],A=!1,P=-1;function $(){A&&b&&(A=!1,b.length?S=b.concat(S):P=-1,S.length&&E())}function E(){if(!A){var m=p($);A=!0;for(var o=S.length;o;){for(b=S,S=[];++P<o;)b&&b[P].run();P=-1,o=S.length}b=null,A=!1,function(n){if(N===clearTimeout)return clearTimeout(n);if((N===M||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(n);try{N(n)}catch{try{return N.call(null,n)}catch{return N.call(this,n)}}}(m)}}function v(m,o){this.fun=m,this.array=o}function a(){}L.nextTick=function(m){var o=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)o[n-1]=arguments[n];S.push(new v(m,o)),S.length!==1||A||p(E)},v.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=a,L.addListener=a,L.once=a,L.off=a,L.removeListener=a,L.removeAllListeners=a,L.emit=a,L.prependListener=a,L.prependOnceListener=a,L.listeners=function(m){return[]},L.binding=function(m){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(m){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ke[39],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=void 0;const u=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(R){return new N(R)}constructor(R){this.c=u&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$0d=N}),define(ke[4],Ee([1,0,13,74,3,75,39]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$_d=e.Event=void 0,e.$ae=E;const p=!1,b=!1,S=!1;var A;(function(I){I.None=()=>L.$Uc.None;function F(Re){if(S){const{onDidAddListener:fe}=Re,Se=a.create();let Ae=0;Re.onDidAddListener=()=>{++Ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),fe?.()}}}function j(Re,fe){return ce(Re,()=>{},0,void 0,!0,void 0,fe)}I.defer=j;function z(Re){return(fe,Se=null,Ae)=>{let Fe=!1,q;return q=Re(V=>{if(!Fe)return q?q.dispose():Fe=!0,fe.call(Se,V)},null,Ae),Fe&&q.dispose(),q}}I.once=z;function O(Re,fe,Se){return X((Ae,Fe=null,q)=>Re(V=>Ae.call(Fe,fe(V)),null,q),Se)}I.map=O;function T(Re,fe,Se){return X((Ae,Fe=null,q)=>Re(V=>{fe(V),Ae.call(Fe,V)},null,q),Se)}I.forEach=T;function B(Re,fe,Se){return X((Ae,Fe=null,q)=>Re(V=>fe(V)&&Ae.call(Fe,V),null,q),Se)}I.filter=B;function W(Re){return Re}I.signal=W;function Z(...Re){return(fe,Se=null,Ae)=>{const Fe=(0,L.$Rc)(...Re.map(q=>q(V=>fe.call(Se,V))));return Y(Fe,Ae)}}I.any=Z;function x(Re,fe,Se,Ae){let Fe=Se;return O(Re,q=>(Fe=fe(Fe,q),Fe),Ae)}I.reduce=x;function X(Re,fe){let Se;const Ae={onWillAddFirstListener(){Se=Re(Fe.fire,Fe)},onDidRemoveLastListener(){Se?.dispose()}};fe||F(Ae);const Fe=new s(Ae);return fe?.add(Fe),Fe.event}function Y(Re,fe){return fe instanceof Array?fe.push(Re):fe&&fe.add(Re),Re}function ce(Re,fe,Se=100,Ae=!1,Fe=!1,q,V){let Q,J,he,pe=0,ze;const Ve={leakWarningThreshold:q,onWillAddFirstListener(){Q=Re(tt=>{pe++,J=fe(J,tt),Ae&&!he&&(Ze.fire(J),J=void 0),ze=()=>{const ot=J;J=void 0,he=void 0,(!Ae||pe>1)&&Ze.fire(ot),pe=0},typeof Se=="number"?(clearTimeout(he),he=setTimeout(ze,Se)):he===void 0&&(he=0,queueMicrotask(ze))})},onWillRemoveListener(){Fe&&pe>0&&ze?.()},onDidRemoveLastListener(){ze=void 0,Q.dispose()}};V||F(Ve);const Ze=new s(Ve);return V?.add(Ze),Ze.event}I.debounce=ce;function ne(Re,fe=0,Se){return I.debounce(Re,(Ae,Fe)=>Ae?(Ae.push(Fe),Ae):[Fe],fe,void 0,!0,void 0,Se)}I.accumulate=ne;function $e(Re,fe=(Ae,Fe)=>Ae===Fe,Se){let Ae=!0,Fe;return B(Re,q=>{const V=Ae||!fe(q,Fe);return Ae=!1,Fe=q,V},Se)}I.latch=$e;function Ce(Re,fe,Se){return[I.filter(Re,fe,Se),I.filter(Re,Ae=>!fe(Ae),Se)]}I.split=Ce;function ee(Re,fe=!1,Se=[],Ae){let Fe=Se.slice(),q=Re(J=>{Fe?Fe.push(J):Q.fire(J)});Ae&&Ae.add(q);const V=()=>{Fe?.forEach(J=>Q.fire(J)),Fe=null},Q=new s({onWillAddFirstListener(){q||(q=Re(J=>Q.fire(J)),Ae&&Ae.add(q))},onDidAddFirstListener(){Fe&&(fe?setTimeout(V):V())},onDidRemoveLastListener(){q&&q.dispose(),q=null}});return Ae&&Ae.add(Q),Q.event}I.buffer=ee;function U(Re,fe){return(Ae,Fe,q)=>{const V=fe(new be);return Re(function(Q){const J=V.evaluate(Q);J!==ie&&Ae.call(Fe,J)},void 0,q)}}I.chain=U;const ie=Symbol("HaltChainable");class be{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(Se=>(fe(Se),Se)),this}filter(fe){return this.f.push(Se=>fe(Se)?Se:ie),this}reduce(fe,Se){let Ae=Se;return this.f.push(Fe=>(Ae=fe(Ae,Fe),Ae)),this}latch(fe=(Se,Ae)=>Se===Ae){let Se=!0,Ae;return this.f.push(Fe=>{const q=Se||!fe(Fe,Ae);return Se=!1,Ae=Fe,q?Fe:ie}),this}evaluate(fe){for(const Se of this.f)if(fe=Se(fe),fe===ie)break;return fe}}function Pe(Re,fe,Se=Ae=>Ae){const Ae=(...Q)=>V.fire(Se(...Q)),Fe=()=>Re.on(fe,Ae),q=()=>Re.removeListener(fe,Ae),V=new s({onWillAddFirstListener:Fe,onDidRemoveLastListener:q});return V.event}I.fromNodeEventEmitter=Pe;function oe(Re,fe,Se=Ae=>Ae){const Ae=(...Q)=>V.fire(Se(...Q)),Fe=()=>Re.addEventListener(fe,Ae),q=()=>Re.removeEventListener(fe,Ae),V=new s({onWillAddFirstListener:Fe,onDidRemoveLastListener:q});return V.event}I.fromDOMEventEmitter=oe;function ae(Re){return new Promise(fe=>z(Re)(fe))}I.toPromise=ae;function re(Re){const fe=new s;return Re.then(Se=>{fe.fire(Se)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}I.fromPromise=re;function G(Re,fe,Se){return fe(Se),Re(Ae=>fe(Ae))}I.runAndSubscribe=G;class te{constructor(fe,Se){this._observable=fe,this.f=0,this.g=!1;const Ae={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};Se||F(Ae),this.emitter=new s(Ae),Se&&Se.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,Se){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ge(Re,fe){return new te(Re,fe).emitter.event}I.fromObservable=ge;function we(Re){return(fe,Se,Ae)=>{let Fe=0,q=!1;const V={beginUpdate(){Fe++},endUpdate(){Fe--,Fe===0&&(Re.reportChanges(),q&&(q=!1,fe.call(Se)))},handlePossibleChange(){},handleChange(){q=!0}};Re.addObserver(V),Re.reportChanges();const Q={dispose(){Re.removeObserver(V)}};return Ae instanceof L.$Tc?Ae.add(Q):Array.isArray(Ae)&&Ae.push(Q),Q}}I.fromObservableLight=we})(A||(e.Event=A={}));class P{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${P.f++}`,P.all.add(this)}start(F){this.g=new M.$0d,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$_d=P;let $=-1;function E(I){const F=$;return $=I,{dispose(){$=F}}}class v{constructor(F,j=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=j,this.g=0}dispose(){this.f?.clear()}check(F,j){const z=this.threshold;if(z<=0||j<z)return;this.f||(this.f=new Map);const O=this.f.get(F.value)||0;if(this.f.set(F.value,O+1),this.g-=1,this.g<=0){this.g=z*.5;let T,B=0;for(const[W,Z]of this.f)(!T||B<Z)&&(T=W,B=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${j} listeners already. MOST frequent listener (${B}):`),console.warn(T)}return()=>{const T=this.f.get(F.value)||0;this.f.set(F.value,T-1)}}}class a{static create(){return new a(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class o{constructor(F){this.value=F,this.id=m++}}const n=2,i=(I,F)=>{if(I instanceof o)F(I);else for(let j=0;j<I.length;j++){const z=I[j];z&&F(z)}},r=p?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class s{constructor(F){this.w=0,this.f=F,this.g=$>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const F=this.t;queueMicrotask(()=>{i(F,j=>j.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,j,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Uc.None;if(this.m)return L.$Uc.None;j&&(F=F.bind(j));const O=new o(F);let T,B;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(O.stack=a.create(),T=this.g.check(O.stack,this.w+1)),b&&(O.stack=B??a.create()),this.t?this.t instanceof o?(this.u??=new f,this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,L.$Sc)(()=>{r?.unregister(W),T?.(),this.x(O)});if(z instanceof L.$Tc?z.add(W):Array.isArray(z)&&z.push(W),r){const Z=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(W,Z,W)}return W},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const j=this.t,z=j.indexOf(F);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,j[z]=void 0;const O=this.u.current===this;if(this.w*n<=j.length){let T=0;for(let B=0;B<j.length;B++)j[B]?j[T++]=j[B]:O&&(this.u.end--,T<this.u.i&&this.u.i--);j.length=T}}y(F,j){if(!F)return;const z=this.f?.onListenerError||u.$1;if(!z){F.value(j);return}try{F.value(j)}catch(O){z(O)}}z(F){const j=F.current.t;for(;F.i<F.end;)this.y(j[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof o)this.y(this.t,F);else{const j=this.u;j.enqueue(this,F,this.t.length),this.z(j)}this.j?.stop()}hasListeners(){return this.w>0}}e.$be=s;const t=()=>new f;e.$ce=t;class f{constructor(){this.i=-1,this.end=0}enqueue(F,j,z){this.i=0,this.end=z,this.current=F,this.value=j}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class d extends s{async fireAsync(F,j,z){if(this.t)for(this.h||(this.h=new R.$5c),i(this.t,O=>this.h.push([O.value,F]));this.h.size>0&&!j.isCancellationRequested;){const[O,T]=this.h.shift(),B=[],W={...T,token:j,waitUntil:Z=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");z&&(Z=z(Z,O)),B.push(Z)}};try{O(W)}catch(Z){(0,u.$1)(Z);continue}Object.freeze(B),await Promise.allSettled(B).then(Z=>{for(const x of Z)x.status==="rejected"&&(0,u.$1)(x.reason)})}}}e.$de=d;class l extends s{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new R.$5c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$ee=l;class c extends l{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$fe=c;class h extends s{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(j=>super.fire(j)),this.h=[]}))}}e.$ge=h;class g{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const j={event:F,listener:null};this.h.push(j),this.g&&this.m(j);const z=()=>{this.g&&this.o(j);const O=this.h.indexOf(j);this.h.splice(O,1)};return(0,L.$Sc)((0,N.$db)(z))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(j=>this.f.fire(j))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$he=g;class D{constructor(F,j,z,O){this.f=new L.$Tc;const T=this.f.add(new g),B=this.f.add(new L.$4c);function W(Z){B.set(Z,T.add(O(Z)))}for(const Z of F)W(Z);this.f.add(j(Z=>{W(Z)})),this.f.add(z(Z=>{B.deleteAndDispose(Z)})),this.event=T.event}dispose(){this.f.dispose()}}e.$ie=D;class w{constructor(){this.f=[]}wrapEvent(F){return(j,z,O)=>F(T=>{const B=this.f[this.f.length-1];B?B.push(()=>j.call(z,T)):j.call(z,T)},void 0,O)}bufferEvents(F){const j=[];this.f.push(j);const z=F();return this.f.pop(),j.forEach(O=>O()),z}}e.$je=w;class k{constructor(){this.f=!1,this.g=A.None,this.h=L.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ke=k;class y{static const(F){return new C(F)}constructor(F){this.g=F,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$le=y;class C{constructor(F){this.value=F,this.onDidChange=A.None}}}),define(ke[22],Ee([1,0,4]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$me=e.CancellationToken=void 0;const N=Object.freeze(function(p,b){const S=setTimeout(p.bind(b),0);return{dispose(){clearTimeout(S)}}});var L;(function(p){function b(S){return S===p.None||S===p.Cancelled||S instanceof R?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}p.isCancellationToken=b,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new u.$be),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=L.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=L.None}}e.$me=M}),define(ke[168],Ee([1,0,22]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ze=e.$Ye=e.$Xe=void 0;class N{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new u.$me,b=this.b(p.token);return this.a={promise:b,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$Xe=N;class L{constructor(p,b=JSON.stringify){this.c=p,this.d=b,this.a=void 0,this.b=void 0}get(p){const b=this.d(p);return this.b!==b&&(this.b=b,this.a=this.c(p)),this.a}}e.$Ye=L;class R{get cachedValues(){return this.a}constructor(p){this.b=p,this.a=new Map}get(p){if(this.a.has(p))return this.a.get(p);const b=this.b(p);return this.a.set(p,b),b}}e.$Ze=R}),define(ke[98],Ee([1,0,13,3]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=L,e.$oe=R,e.$pe=M,e.$qe=p,e.$re=S,e.$se=A,e.$te=P,e.$ue=$,e.$ve=E,e.$we=v,e.$xe=a,e.$ye=m,e.$ze=o,e.$Ae=n,e.$Be=i;function L(r){const s=r;return s?typeof s.read=="function":!1}function R(r){const s=r;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}function M(r){const s=r;return s?R(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function p(r,s){return new b(r,s)}class b{constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,u.$1)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let f;switch(s){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const d=f.indexOf(t);d>=0&&f.splice(d,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(r,s){const t=[];let f;for(;(f=r.read())!==null;)t.push(f);return s(t)}function A(r,s,t){const f=[];let d;for(;(d=r.read())!==null&&f.length<t;)f.push(d);return d===null&&f.length>0?s(f):{read:()=>{if(f.length>0)return f.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return r.read()}}}function P(r,s){return new Promise((t,f)=>{const d=[];$(r,{onData:l=>{s&&d.push(l)},onError:l=>{s?f(l):t(void 0)},onEnd:()=>{t(s?s(d):void 0)}})})}function $(r,s,t){r.on("error",f=>{t?.isCancellationRequested||s.onError(f)}),r.on("end",()=>{t?.isCancellationRequested||s.onEnd()}),r.on("data",f=>{t?.isCancellationRequested||s.onData(f)})}function E(r,s){return new Promise((t,f)=>{const d=new N.$Tc,l=[],c=D=>{if(l.push(D),l.length>s)return d.dispose(),r.pause(),t({stream:r,buffer:l,ended:!1})},h=D=>(d.dispose(),f(D)),g=()=>(d.dispose(),t({stream:r,buffer:l,ended:!0}));d.add((0,N.$Sc)(()=>r.removeListener("error",h))),r.on("error",h),d.add((0,N.$Sc)(()=>r.removeListener("end",g))),r.on("end",g),d.add((0,N.$Sc)(()=>r.removeListener("data",c))),r.on("data",c)})}function v(r,s){const t=p(s);return t.end(r),t}function a(){const r=p(()=>{throw new Error("not supported")});return r.end(),r}function m(r){let s=!1;return{read:()=>s?null:(s=!0,r)}}function o(r,s,t){const f=p(t);return $(r,{onData:d=>f.write(s.data(d)),onError:d=>f.error(s.error?s.error(d):d),onEnd:()=>f.end()}),f}function n(r,s,t){let f=!1;return{read:()=>{const d=s.read();return f?d:(f=!0,d!==null?t([r,d]):r)}}}function i(r,s,t){let f=!1;const d=p(t);return $(s,{onData:l=>f?d.write(l):(f=!0,d.write(t([r,l]))),onError:l=>d.error(l),onEnd:()=>{f||(f=!0,d.write(r)),d.end()}}),d}}),define(ke[21],Ee([1,0,46,98]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=S,e.$Ee=A,e.$Fe=P,e.$Ge=$,e.$He=E,e.$Ie=v,e.$Je=a,e.$Ke=m,e.$Le=o,e.$Me=n,e.$Ne=i,e.$Oe=r,e.$Pe=s,e.$Qe=t,e.$Re=f,e.$Se=d,e.$Te=l,e.$Ue=c,e.$Ve=h,e.$We=w;const L=typeof Buffer<"u",R=new u.$V(()=>new Uint8Array(256));let M,p;class b{static alloc(y){return L?new b(Buffer.allocUnsafe(y)):new b(new Uint8Array(y))}static wrap(y){return L&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new b(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&L?new b(Buffer.from(y)):(M||(M=new TextEncoder),new b(M.encode(y)))}static fromByteArray(y){const C=b.alloc(y.length);for(let I=0,F=y.length;I<F;I++)C.buffer[I]=y[I];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let j=0,z=y.length;j<z;j++)C+=y[j].byteLength}const I=b.alloc(C);let F=0;for(let j=0,z=y.length;j<z;j++){const O=y[j];I.set(O,F),F+=O.byteLength}return I}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=b.alloc(this.byteLength);return y.set(this),y}toString(){return L?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(y,C){return new b(this.buffer.subarray(y,C))}set(y,C){if(y instanceof b)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return $(this.buffer,y)}writeUInt32BE(y,C){E(this.buffer,y,C)}readUInt32LE(y){return v(this.buffer,y)}writeUInt32LE(y,C){a(this.buffer,y,C)}readUInt8(y){return m(this.buffer,y)}writeUInt8(y,C){o(this.buffer,y,C)}indexOf(y,C=0){return S(this.buffer,y instanceof b?y.buffer:y,C)}}e.$Ce=b;function S(k,y,C=0){const I=y.byteLength,F=k.byteLength;if(I===0)return 0;if(I===1)return k.indexOf(y[0]);if(I>F-C)return-1;const j=R.value;j.fill(y.length);for(let B=0;B<y.length;B++)j[y[B]]=y.length-B-1;let z=C+y.length-1,O=z,T=-1;for(;z<F;)if(k[z]===y[O]){if(O===0){T=z;break}z--,O--}else z+=Math.max(y.length-O,j[k[z]]),O=y.length-1;return T}function A(k,y){return k[y+0]<<0>>>0|k[y+1]<<8>>>0}function P(k,y,C){k[C+0]=y&255,y=y>>>8,k[C+1]=y&255}function $(k,y){return k[y]*2**24+k[y+1]*2**16+k[y+2]*2**8+k[y+3]}function E(k,y,C){k[C+3]=y,y=y>>>8,k[C+2]=y,y=y>>>8,k[C+1]=y,y=y>>>8,k[C]=y}function v(k,y){return k[y+0]<<0>>>0|k[y+1]<<8>>>0|k[y+2]<<16>>>0|k[y+3]<<24>>>0}function a(k,y,C){k[C+0]=y&255,y=y>>>8,k[C+1]=y&255,y=y>>>8,k[C+2]=y&255,y=y>>>8,k[C+3]=y&255}function m(k,y){return k[y]}function o(k,y,C){k[C]=y}function n(k){return N.$re(k,y=>b.concat(y))}function i(k){return N.$ye(k)}function r(k){return N.$te(k,y=>b.concat(y))}async function s(k){return k.ended?b.concat(k.buffer):b.concat([...k.buffer,await r(k.stream)])}function t(k){return N.$we(k,y=>b.concat(y))}function f(k){return N.$ze(k,{data:y=>typeof y=="string"?b.fromString(y):b.wrap(y)},y=>b.concat(y))}function d(k){return N.$qe(y=>b.concat(y),k)}function l(k,y){return N.$Ae(k,y,C=>b.concat(C))}function c(k,y){return N.$Be(k,y,C=>b.concat(C))}function h(k){let y=0,C=0,I=0;const F=new Uint8Array(Math.floor(k.length/4*3)),j=O=>{switch(C){case 3:F[I++]=y|O,C=0;break;case 2:F[I++]=y|O>>>2,y=O<<6,C=3;break;case 1:F[I++]=y|O>>>4,y=O<<4,C=2;break;default:y=O<<2,C=1}};for(let O=0;O<k.length;O++){const T=k.charCodeAt(O);if(T>=65&&T<=90)j(T-65);else if(T>=97&&T<=122)j(T-97+26);else if(T>=48&&T<=57)j(T-48+52);else if(T===43||T===45)j(62);else if(T===47||T===95)j(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${k[O]}`)}}const z=I;for(;C>0;)j(0);return b.wrap(F).slice(0,z)}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:k},y=!0,C=!1){const I=C?D:g;let F="";const j=k.byteLength%3;let z=0;for(;z<k.byteLength-j;z+=3){const O=k[z+0],T=k[z+1],B=k[z+2];F+=I[O>>>2],F+=I[(O<<4|T>>>4)&63],F+=I[(T<<2|B>>>6)&63],F+=I[B&63]}if(j===1){const O=k[z+0];F+=I[O>>>2],F+=I[O<<4&63],y&&(F+="==")}else if(j===2){const O=k[z+0],T=k[z+1];F+=I[O>>>2],F+=I[(O<<4|T>>>4)&63],F+=I[T<<2&63],y&&(F+="=")}return F}}),define(ke[14],Ee([1,0,168,46]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=e.$1f=e.GraphemeBreakType=e.$Qf=e.$Jf=e.$Cf=e.$Bf=void 0,e.$3e=L,e.$4e=M,e.$5e=b,e.$6e=S,e.$7e=A,e.$8e=P,e.$9e=$,e.$0e=E,e.$$e=v,e.$_e=a,e.$af=m,e.$bf=o,e.$cf=n,e.$df=i,e.$ef=r,e.$ff=s,e.$gf=t,e.$hf=f,e.$if=d,e.$jf=l,e.$kf=c,e.$lf=h,e.$mf=g,e.$nf=D,e.$of=w,e.$pf=k,e.$qf=y,e.$rf=C,e.$sf=I,e.$tf=F,e.$uf=j,e.$vf=z,e.$wf=O,e.$xf=T,e.$yf=B,e.$zf=W,e.$Af=Z,e.$Df=ce,e.$Ef=ne,e.$Ff=$e,e.$Gf=Ce,e.$Hf=ie,e.$If=Pe,e.$Kf=oe,e.$Lf=ae,e.$Mf=re,e.$Nf=G,e.$Of=ge,e.$Pf=we,e.$Rf=Re,e.$Sf=fe,e.$Tf=Se,e.$Uf=Ae,e.$Vf=Fe,e.$Wf=q,e.$Xf=V,e.$Yf=Q,e.$Zf=Ve;function L(De){return!De||typeof De!="string"?!0:De.trim().length===0}const R=/{(\d+)}/g;function M(De,...Be){return Be.length===0?De:De.replace(R,function(He,Le){const Xe=parseInt(Le,10);return isNaN(Xe)||Xe<0||Xe>=Be.length?He:Be[Xe]})}const p=/{([^}]+)}/g;function b(De,Be){return Object.keys(Be).length===0?De:De.replace(p,(He,Le)=>Be[Le]??He)}function S(De){return De.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function A(De){return De.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function P(De){return De.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function $(De,Be){let He=0;const Le=Be.charCodeAt(0);for(let Xe=De.length-1;Xe>=0;Xe--)De.charCodeAt(Xe)===Le&&He++;return He}function E(De,Be,He="\u2026"){return De.length<=Be?De:`${De.substr(0,Be)}${He}`}function v(De,Be,He="\u2026"){if(De.length<=Be)return De;const Le=Math.ceil(Be/2)-He.length/2,Xe=Math.floor(Be/2)-He.length/2;return`${De.substr(0,Le)}${He}${De.substr(De.length-Xe)}`}function a(De,Be=" "){const He=m(De,Be);return o(He,Be)}function m(De,Be){if(!De||!Be)return De;const He=Be.length;if(He===0||De.length===0)return De;let Le=0;for(;De.indexOf(Be,Le)===Le;)Le=Le+He;return De.substring(Le)}function o(De,Be){if(!De||!Be)return De;const He=Be.length,Le=De.length;if(He===0||Le===0)return De;let Xe=Le,se=-1;for(;se=De.lastIndexOf(Be,Xe-1),!(se===-1||se+He!==Xe);){if(se===0)return"";Xe=se}return De.substring(0,Xe)}function n(De){return De.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(De){return De.replace(/\*/g,"")}function r(De,Be,He={}){if(!De)throw new Error("Cannot create regex from empty string");Be||(De=P(De)),He.wholeWord&&(/\B/.test(De.charAt(0))||(De="\\b"+De),/\B/.test(De.charAt(De.length-1))||(De=De+"\\b"));let Le="";return He.global&&(Le+="g"),He.matchCase||(Le+="i"),He.multiline&&(Le+="m"),He.unicode&&(Le+="u"),new RegExp(De,Le)}function s(De){return De.source==="^"||De.source==="^$"||De.source==="$"||De.source==="^\\s*$"?!1:!!(De.exec("")&&De.lastIndex===0)}function t(De){return De.split(/\r\n|\r|\n/)}function f(De){const Be=[],He=De.split(/(\r\n|\r|\n)/);for(let Le=0;Le<Math.ceil(He.length/2);Le++)Be.push(He[2*Le]+(He[2*Le+1]??""));return Be}function d(De){for(let Be=0,He=De.length;Be<He;Be++){const Le=De.charCodeAt(Be);if(Le!==32&&Le!==9)return Be}return-1}function l(De,Be=0,He=De.length){for(let Le=Be;Le<He;Le++){const Xe=De.charCodeAt(Le);if(Xe!==32&&Xe!==9)return De.substring(Be,Le)}return De.substring(Be,He)}function c(De,Be=De.length-1){for(let He=Be;He>=0;He--){const Le=De.charCodeAt(He);if(Le!==32&&Le!==9)return He}return-1}function h(De,Be,He){const Le=[];let Xe=0;for(const se of De.matchAll(Be)){if(Le.push(De.slice(Xe,se.index)),se.index===void 0)throw new Error("match.index should be defined");Xe=se.index+se[0].length,Le.push(He(se[0],...se.slice(1),se.index,De,se.groups))}return Le.push(De.slice(Xe)),Promise.all(Le).then(se=>se.join(""))}function g(De,Be){return De<Be?-1:De>Be?1:0}function D(De,Be,He=0,Le=De.length,Xe=0,se=Be.length){for(;He<Le&&Xe<se;He++,Xe++){const Ge=De.charCodeAt(He),Me=Be.charCodeAt(Xe);if(Ge<Me)return-1;if(Ge>Me)return 1}const ue=Le-He,Ie=se-Xe;return ue<Ie?-1:ue>Ie?1:0}function w(De,Be){return k(De,Be,0,De.length,0,Be.length)}function k(De,Be,He=0,Le=De.length,Xe=0,se=Be.length){for(;He<Le&&Xe<se;He++,Xe++){let Ge=De.charCodeAt(He),Me=Be.charCodeAt(Xe);if(Ge===Me)continue;if(Ge>=128||Me>=128)return D(De.toLowerCase(),Be.toLowerCase(),He,Le,Xe,se);C(Ge)&&(Ge-=32),C(Me)&&(Me-=32);const nt=Ge-Me;if(nt!==0)return nt}const ue=Le-He,Ie=se-Xe;return ue<Ie?-1:ue>Ie?1:0}function y(De){return De>=48&&De<=57}function C(De){return De>=97&&De<=122}function I(De){return De>=65&&De<=90}function F(De,Be){return De.length===Be.length&&k(De,Be)===0}function j(De,Be){const He=Be.length;return Be.length>De.length?!1:k(De,Be,0,He)===0}function z(De,Be){const He=Math.min(De.length,Be.length);let Le;for(Le=0;Le<He;Le++)if(De.charCodeAt(Le)!==Be.charCodeAt(Le))return Le;return He}function O(De,Be){const He=Math.min(De.length,Be.length);let Le;const Xe=De.length-1,se=Be.length-1;for(Le=0;Le<He;Le++)if(De.charCodeAt(Xe-Le)!==Be.charCodeAt(se-Le))return Le;return He}function T(De){return 55296<=De&&De<=56319}function B(De){return 56320<=De&&De<=57343}function W(De,Be){return(De-55296<<10)+(Be-56320)+65536}function Z(De,Be,He){const Le=De.charCodeAt(He);if(T(Le)&&He+1<Be){const Xe=De.charCodeAt(He+1);if(B(Xe))return W(Le,Xe)}return Le}function x(De,Be){const He=De.charCodeAt(Be-1);if(B(He)&&Be>1){const Le=De.charCodeAt(Be-2);if(T(Le))return W(Le,He)}return He}class X{get offset(){return this.e}constructor(Be,He=0){this.c=Be,this.d=Be.length,this.e=He}setOffset(Be){this.e=Be}prevCodePoint(){const Be=x(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=Z(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$Bf=X;class Y{get offset(){return this.c.offset}constructor(Be,He=0){this.c=new X(Be,He)}nextGraphemeLength(){const Be=pe.getInstance(),He=this.c,Le=He.offset;let Xe=Be.getGraphemeBreakType(He.nextCodePoint());for(;!He.eol();){const se=He.offset,ue=Be.getGraphemeBreakType(He.nextCodePoint());if(J(Xe,ue)){He.setOffset(se);break}Xe=ue}return He.offset-Le}prevGraphemeLength(){const Be=pe.getInstance(),He=this.c,Le=He.offset;let Xe=Be.getGraphemeBreakType(He.prevCodePoint());for(;He.offset>0;){const se=He.offset,ue=Be.getGraphemeBreakType(He.prevCodePoint());if(J(ue,Xe)){He.setOffset(se);break}Xe=ue}return Le-He.offset}eol(){return this.c.eol()}}e.$Cf=Y;function ce(De,Be){return new Y(De,Be).nextGraphemeLength()}function ne(De,Be){return new Y(De,Be).prevGraphemeLength()}function $e(De,Be){Be>0&&B(De.charCodeAt(Be))&&Be--;const He=Be+ce(De,Be);return[He-ne(De,He),He]}function Ce(De){const Be=new Y(De);let He=0;for(;!Be.eol();)He++,Be.nextGraphemeLength();return He}let ee;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ie(De){return ee||(ee=U()),ee.test(De)}const be=/^[\t\n\r\x20-\x7E]*$/;function Pe(De){return be.test(De)}e.$Jf=/[\u2028\u2029]/;function oe(De){return e.$Jf.test(De)}function ae(De){return De>=11904&&De<=55215||De>=63744&&De<=64255||De>=65281&&De<=65374}function re(De){return De>=127462&&De<=127487||De===8986||De===8987||De===9200||De===9203||De>=9728&&De<=10175||De===11088||De===11093||De>=127744&&De<=128591||De>=128640&&De<=128764||De>=128992&&De<=129008||De>=129280&&De<=129535||De>=129648&&De<=129782}function G(De,Be,He=""){const Le=De.trimStart();if(Le.length<Be)return Le;const Xe=/\b/g;let se=0;for(;Xe.test(Le)&&!(Le.length-Xe.lastIndex<Be);)se=Xe.lastIndex,Xe.lastIndex+=1;return se===0?Le:He+Le.substring(se).trimStart()}const te=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ge(De){let Be=0;for(const He of De.matchAll(te))Be!==He.index&&(yield{isCode:!1,str:De.substring(Be,He.index)}),yield{isCode:!0,str:He[0]},Be=He.index+He[0].length;Be!==De.length&&(yield{isCode:!1,str:De.substring(Be)})}function we(De){return De&&(De=De.replace(te,"")),De}e.$Qf="\uFEFF";function Re(De){return!!(De&&De.length>0&&De.charCodeAt(0)===65279)}function fe(De){return Re(De)?De.substr(1):De}function Se(De,Be){if(!De||!Be||De.length<Be.length)return!1;const He=Be.length,Le=De.toLowerCase();let Xe=0,se=-1;for(;Xe<He;){const ue=Le.indexOf(Be[Xe],se+1);if(ue<0)return!1;se=ue,Xe++}return!0}function Ae(De,Be=!1){return De?(Be&&(De=De.replace(/\\./g,"")),De.toLowerCase()!==De):!1}function Fe(De){return De.charAt(0).toUpperCase()+De.slice(1)}function q(De,Be=1){if(Be===0)return"";let He=-1;do He=De.indexOf(`
`,He+1),Be--;while(Be>0&&He>=0);return He===-1?De:(De[He-1]==="\r"&&He--,De.substr(0,He))}function V(De){return De=De%(2*26),De<26?String.fromCharCode(97+De):String.fromCharCode(65+De-26)}function Q(De){return pe.getInstance().getGraphemeBreakType(De)}function J(De,Be){return De===0?Be!==5&&Be!==7:De===2&&Be===3?!1:De===4||De===2||De===3||Be===4||Be===2||Be===3?!0:!(De===8&&(Be===8||Be===9||Be===11||Be===12)||(De===11||De===9)&&(Be===9||Be===10)||(De===12||De===10)&&Be===10||Be===5||Be===13||Be===7||De===1||De===13&&Be===14||De===6&&Be===6)}var he;(function(De){De[De.Other=0]="Other",De[De.Prepend=1]="Prepend",De[De.CR=2]="CR",De[De.LF=3]="LF",De[De.Control=4]="Control",De[De.Extend=5]="Extend",De[De.Regional_Indicator=6]="Regional_Indicator",De[De.SpacingMark=7]="SpacingMark",De[De.L=8]="L",De[De.V=9]="V",De[De.T=10]="T",De[De.LV=11]="LV",De[De.LVT=12]="LVT",De[De.ZWJ=13]="ZWJ",De[De.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class pe{static{this.c=null}static getInstance(){return pe.c||(pe.c=new pe),pe.c}constructor(){this.d=ze()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const He=this.d,Le=He.length/3;let Xe=1;for(;Xe<=Le;)if(Be<He[3*Xe])Xe=2*Xe;else if(Be>He[3*Xe+1])Xe=2*Xe+1;else return He[3*Xe+2];return 0}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(De,Be){if(De===0)return 0;const He=Ze(De,Be);if(He!==void 0)return He;const Le=new X(Be,De);return Le.prevCodePoint(),Le.offset}function Ze(De,Be){const He=new X(Be,De);let Le=He.prevCodePoint();for(;tt(Le)||Le===65039||Le===8419;){if(He.offset===0)return;Le=He.prevCodePoint()}if(!re(Le))return;let Xe=He.offset;return Xe>0&&He.prevCodePoint()===8205&&(Xe=He.offset),Xe}function tt(De){return 127995<=De&&De<=127999}var ot;(function(De){De[De.zwj=8205]="zwj",De[De.emojiVariantSelector=65039]="emojiVariantSelector",De[De.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={})),e.$1f="\xA0";class it{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new u.$Ye(Be=>{function He(nt){const lt=new Map;for(let wt=0;wt<nt.length;wt+=2)lt.set(nt[wt],nt[wt+1]);return lt}function Le(nt,lt){const wt=new Map(nt);for(const[It,jt]of lt)wt.set(It,jt);return wt}function Xe(nt,lt){if(!nt)return lt;const wt=new Map;for(const[It,jt]of nt)lt.has(It)&&wt.set(It,jt);return wt}const se=this.c.value;let ue=Be.filter(nt=>!nt.startsWith("_")&&nt in se);ue.length===0&&(ue=["_default"]);let Ie;for(const nt of ue){const lt=He(se[nt]);Ie=Xe(Ie,lt)}const Ge=He(se._common),Me=Le(Ge,Ie);return new it(Me)})}static getInstance(Be){return it.d.get(Array.from(Be))}static{this.e=new N.$V(()=>Object.keys(it.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return it.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$2f=it;class st{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(st.c())),this.d}static isInvisibleCharacter(Be){return st.e().has(Be)}static get codePoints(){return st.e()}}e.$3f=st}),define(ke[126],Ee([1,0,27,166,14]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.FuzzyScore=e.$sk=e.$rk=void 0,e.or=R,e.$tk=p,e.$uk=b,e.$vk=P,e.$wk=h,e.$xk=g,e.$yk=I,e.$zk=F,e.$Ak=j,e.$Bk=z,e.$Ck=ie,e.$Ek=ae,e.$Fk=te,e.$Gk=ge;function R(...fe){return function(Se,Ae){for(let Fe=0,q=fe.length;Fe<q;Fe++){const V=fe[Fe](Se,Ae);if(V)return V}return null}}e.$rk=M.bind(void 0,!1),e.$sk=M.bind(void 0,!0);function M(fe,Se,Ae){if(!Ae||Ae.length<Se.length)return null;let Fe;return fe?Fe=L.$uf(Ae,Se):Fe=Ae.indexOf(Se)===0,Fe?Se.length>0?[{start:0,end:Se.length}]:[]:null}function p(fe,Se){const Ae=Se.toLowerCase().indexOf(fe.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+fe.length}]}function b(fe,Se){return S(fe.toLowerCase(),Se.toLowerCase(),0,0)}function S(fe,Se,Ae,Fe){if(Ae===fe.length)return[];if(Fe===Se.length)return null;if(fe[Ae]===Se[Fe]){let q=null;return(q=S(fe,Se,Ae+1,Fe+1))?r({start:Fe,end:Fe+1},q):null}return S(fe,Se,Ae,Fe+1)}function A(fe){return 97<=fe&&fe<=122}function P(fe){return 65<=fe&&fe<=90}function $(fe){return 48<=fe&&fe<=57}function E(fe){return fe===32||fe===9||fe===10||fe===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>v.add(fe.charCodeAt(0)));function a(fe){return E(fe)||v.has(fe)}function m(fe,Se){return fe===Se||a(fe)&&a(Se)}const o=new Map;function n(fe){if(o.has(fe))return o.get(fe);let Se;const Ae=(0,N.$pk)(fe);return Ae&&(Se=Ae),o.set(fe,Se),Se}function i(fe){return A(fe)||P(fe)||$(fe)}function r(fe,Se){return Se.length===0?Se=[fe]:fe.end===Se[0].start?Se[0].start=fe.start:Se.unshift(fe),Se}function s(fe,Se){for(let Ae=Se;Ae<fe.length;Ae++){const Fe=fe.charCodeAt(Ae);if(P(Fe)||$(Fe)||Ae>0&&!i(fe.charCodeAt(Ae-1)))return Ae}return fe.length}function t(fe,Se,Ae,Fe){if(Ae===fe.length)return[];if(Fe===Se.length)return null;if(fe[Ae]!==Se[Fe].toLowerCase())return null;{let q=null,V=Fe+1;for(q=t(fe,Se,Ae+1,Fe+1);!q&&(V=s(Se,V))<Se.length;)q=t(fe,Se,Ae+1,V),V++;return q===null?null:r({start:Fe,end:Fe+1},q)}}function f(fe){let Se=0,Ae=0,Fe=0,q=0,V=0;for(let ze=0;ze<fe.length;ze++)V=fe.charCodeAt(ze),P(V)&&Se++,A(V)&&Ae++,i(V)&&Fe++,$(V)&&q++;const Q=Se/fe.length,J=Ae/fe.length,he=Fe/fe.length,pe=q/fe.length;return{upperPercent:Q,lowerPercent:J,alphaPercent:he,numericPercent:pe}}function d(fe){const{upperPercent:Se,lowerPercent:Ae}=fe;return Ae===0&&Se>.6}function l(fe){const{upperPercent:Se,lowerPercent:Ae,alphaPercent:Fe,numericPercent:q}=fe;return Ae>.2&&Se<.8&&Fe>.6&&q<.2}function c(fe){let Se=0,Ae=0,Fe=0,q=0;for(let V=0;V<fe.length;V++)Fe=fe.charCodeAt(V),P(Fe)&&Se++,A(Fe)&&Ae++,E(Fe)&&q++;return(Se===0||Ae===0)&&q===0?fe.length<=30:Se<=5}function h(fe,Se){if(!Se||(Se=Se.trim(),Se.length===0)||!c(fe))return null;Se.length>60&&(Se=Se.substring(0,60));const Ae=f(Se);if(!l(Ae)){if(!d(Ae))return null;Se=Se.toLowerCase()}let Fe=null,q=0;for(fe=fe.toLowerCase();q<Se.length&&(Fe=t(fe,Se,0,q))===null;)q=s(Se,q+1);return Fe}function g(fe,Se,Ae=!1){if(!Se||Se.length===0)return null;let Fe=null,q=0;for(fe=fe.toLowerCase(),Se=Se.toLowerCase();q<Se.length&&(Fe=D(fe,Se,0,q,Ae),Fe===null);)q=w(Se,q+1);return Fe}function D(fe,Se,Ae,Fe,q){let V=0;if(Ae===fe.length)return[];if(Fe===Se.length)return null;if(!m(fe.charCodeAt(Ae),Se.charCodeAt(Fe))){const he=n(fe.charCodeAt(Ae));if(!he)return null;for(let pe=0;pe<he.length;pe++)if(!m(he[pe],Se.charCodeAt(Fe+pe)))return null;V+=he.length-1}let Q=null,J=Fe+V+1;if(Q=D(fe,Se,Ae+1,J,q),!q)for(;!Q&&(J=w(Se,J))<Se.length;)Q=D(fe,Se,Ae+1,J,q),J++;if(!Q)return null;if(fe.charCodeAt(Ae)!==Se.charCodeAt(Fe)){const he=n(fe.charCodeAt(Ae));if(!he)return Q;for(let pe=0;pe<he.length;pe++)if(he[pe]!==Se.charCodeAt(Fe+pe))return Q}return r({start:Fe,end:Fe+V+1},Q)}function w(fe,Se){for(let Ae=Se;Ae<fe.length;Ae++)if(a(fe.charCodeAt(Ae))||Ae>0&&a(fe.charCodeAt(Ae-1)))return Ae;return fe.length}const k=R(e.$sk,h,p),y=R(e.$sk,h,b),C=new u.$Ec(1e4);function I(fe,Se,Ae=!1){if(typeof fe!="string"||typeof Se!="string")return null;let Fe=C.get(fe);Fe||(Fe=new RegExp(L.$cf(fe),"i"),C.set(fe,Fe));const q=Fe.exec(Se);return q?[{start:q.index,end:q.index+q[0].length}]:Ae?y(fe,Se):k(fe,Se)}function F(fe,Se){const Ae=ae(fe,fe.toLowerCase(),0,Se,Se.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?z(Ae):null}function j(fe,Se,Ae,Fe,q,V){const Q=Math.min(13,fe.length);for(;Ae<Q;Ae++){const J=ae(fe,Se,Ae,Fe,q,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,V]}function z(fe){if(typeof fe>"u")return[];const Se=[],Ae=fe[1];for(let Fe=fe.length-1;Fe>1;Fe--){const q=fe[Fe]+Ae,V=Se[Se.length-1];V&&V.end===q?V.end=q+1:Se.push({start:q,end:q+1})}return Se}const O=128;function T(){const fe=[],Se=[];for(let Ae=0;Ae<=O;Ae++)Se[Ae]=0;for(let Ae=0;Ae<=O;Ae++)fe.push(Se.slice(0));return fe}function B(fe){const Se=[];for(let Ae=0;Ae<=fe;Ae++)Se[Ae]=0;return Se}const W=B(2*O),Z=B(2*O),x=T(),X=T(),Y=T(),ce=!1;function ne(fe,Se,Ae,Fe,q){function V(J,he,pe=" "){for(;J.length<he;)J=pe+J;return J}let Q=` |   |${Fe.split("").map(J=>V(J,3)).join("|")}
`;for(let J=0;J<=Ae;J++)J===0?Q+=" |":Q+=`${Se[J-1]}|`,Q+=fe[J].slice(0,q+1).map(he=>V(he.toString(),3)).join("|")+`
`;return Q}function $e(fe,Se,Ae,Fe){fe=fe.substr(Se),Ae=Ae.substr(Fe),console.log(ne(X,fe,fe.length,Ae,Ae.length)),console.log(ne(Y,fe,fe.length,Ae,Ae.length)),console.log(ne(x,fe,fe.length,Ae,Ae.length))}function Ce(fe,Se){if(Se<0||Se>=fe.length)return!1;const Ae=fe.codePointAt(Se);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$Mf(Ae)}}function ee(fe,Se){if(Se<0||Se>=fe.length)return!1;switch(fe.charCodeAt(Se)){case 32:case 9:return!0;default:return!1}}function U(fe,Se,Ae){return Se[fe]!==Ae[fe]}function ie(fe,Se,Ae,Fe,q,V,Q=!1){for(;Se<Ae&&q<V;)fe[Se]===Fe[q]&&(Q&&(W[Se]=q),Se+=1),q+=1;return Se===Ae}var be;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(be||(be={}));var Pe;(function(fe){fe.Default=[-100,0];function Se(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}fe.isDefault=Se})(Pe||(e.FuzzyScore=Pe={}));class oe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Se,Ae){this.firstMatchCanBeWeak=Se,this.boostFullMatch=Ae}}e.$Dk=oe;function ae(fe,Se,Ae,Fe,q,V,Q=oe.default){const J=fe.length>O?O:fe.length,he=Fe.length>O?O:Fe.length;if(Ae>=J||V>=he||J-Ae>he-V||!ie(Se,Ae,J,q,V,he,!0))return;re(J,he,Ae,V,Se,q);let pe=1,ze=1,Ve=Ae,Ze=V;const tt=[!1];for(pe=1,Ve=Ae;Ve<J;pe++,Ve++){const Be=W[Ve],He=Z[Ve],Le=Ve+1<J?Z[Ve+1]:he;for(ze=Be-V+1,Ze=Be;Ze<Le;ze++,Ze++){let Xe=Number.MIN_SAFE_INTEGER,se=!1;Ze<=He&&(Xe=G(fe,Se,Ve,Ae,Fe,q,Ze,he,V,x[pe-1][ze-1]===0,tt));let ue=0;Xe!==Number.MAX_SAFE_INTEGER&&(se=!0,ue=Xe+X[pe-1][ze-1]);const Ie=Ze>Be,Ge=Ie?X[pe][ze-1]+(x[pe][ze-1]>0?-5:0):0,Me=Ze>Be+1&&x[pe][ze-1]>0,nt=Me?X[pe][ze-2]+(x[pe][ze-2]>0?-5:0):0;if(Me&&(!Ie||nt>=Ge)&&(!se||nt>=ue))X[pe][ze]=nt,Y[pe][ze]=3,x[pe][ze]=0;else if(Ie&&(!se||Ge>=ue))X[pe][ze]=Ge,Y[pe][ze]=2,x[pe][ze]=0;else if(se)X[pe][ze]=ue,Y[pe][ze]=1,x[pe][ze]=x[pe-1][ze-1]+1;else throw new Error("not possible")}}if(ce&&$e(fe,Ae,Fe,V),!tt[0]&&!Q.firstMatchCanBeWeak)return;pe--,ze--;const ot=[X[pe][ze],V];let it=0,st=0;for(;pe>=1;){let Be=ze;do{const He=Y[pe][Be];if(He===3)Be=Be-2;else if(He===2)Be=Be-1;else break}while(Be>=1);it>1&&Se[Ae+pe-1]===q[V+ze-1]&&!U(Be+V-1,Fe,q)&&it+1>x[pe][Be]&&(Be=ze),Be===ze?it++:it=1,st||(st=Be),pe--,ze=Be-1,ot.push(ze)}he===J&&Q.boostFullMatch&&(ot[0]+=2);const De=st-J;return ot[0]-=De,ot}function re(fe,Se,Ae,Fe,q,V){let Q=fe-1,J=Se-1;for(;Q>=Ae&&J>=Fe;)q[Q]===V[J]&&(Z[Q]=J,Q--),J--}function G(fe,Se,Ae,Fe,q,V,Q,J,he,pe,ze){if(Se[Ae]!==V[Q])return Number.MIN_SAFE_INTEGER;let Ve=1,Ze=!1;return Q===Ae-Fe?Ve=fe[Ae]===q[Q]?7:5:U(Q,q,V)&&(Q===0||!U(Q-1,q,V))?(Ve=fe[Ae]===q[Q]?7:5,Ze=!0):Ce(V,Q)&&(Q===0||!Ce(V,Q-1))?Ve=5:(Ce(V,Q-1)||ee(V,Q-1))&&(Ve=5,Ze=!0),Ve>1&&Ae===Fe&&(ze[0]=!0),Ze||(Ze=U(Q,q,V)||Ce(V,Q-1)||ee(V,Q-1)),Ae===Fe?Q>he&&(Ve-=Ze?3:5):pe?Ve+=Ze?2:0:Ve+=Ze?0:1,Q+1===J&&(Ve-=Ze?3:5),Ve}function te(fe,Se,Ae,Fe,q,V,Q){return we(fe,Se,Ae,Fe,q,V,!0,Q)}function ge(fe,Se,Ae,Fe,q,V,Q){return we(fe,Se,Ae,Fe,q,V,!1,Q)}function we(fe,Se,Ae,Fe,q,V,Q,J){let he=ae(fe,Se,Ae,Fe,q,V,J);if(he&&!Q)return he;if(fe.length>=3){const pe=Math.min(7,fe.length-1);for(let ze=Ae+1;ze<pe;ze++){const Ve=Re(fe,ze);if(Ve){const Ze=ae(Ve,Ve.toLowerCase(),Ae,Fe,q,V,J);Ze&&(Ze[0]-=3,(!he||Ze[0]>he[0])&&(he=Ze))}}}return he}function Re(fe,Se){if(Se+1>=fe.length)return;const Ae=fe[Se],Fe=fe[Se+1];if(Ae!==Fe)return fe.slice(0,Se)+Fe+Ae+fe.slice(Se+2)}}),define(ke[56],Ee([1,0,14]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$ij=void 0,e.$ej=N,e.$fj=L,e.$gj=R,e.$hj=p,e.$jj=a;function N(o){return L(o,0)}function L(o,n){switch(typeof o){case"object":return o===null?R(349,n):Array.isArray(o)?b(o,n):S(o,n);case"string":return p(o,n);case"boolean":return M(o,n);case"number":return R(o,n);case"undefined":return R(937,n);default:return R(617,n)}}function R(o,n){return(n<<5)-n+o|0}function M(o,n){return R(o?433:863,n)}function p(o,n){n=R(149417,n);for(let i=0,r=o.length;i<r;i++)n=R(o.charCodeAt(i),n);return n}function b(o,n){return n=R(104579,n),o.reduce((i,r)=>L(r,i),n)}function S(o,n){return n=R(181387,n),Object.keys(o).sort().reduce((i,r)=>(i=p(r,i),L(o[r],i)),n)}class A{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=L(n,this.g),this.g}}e.$ij=A;var P;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function $(o,n,i=32){const r=i-n,s=~((1<<r)-1);return(o<<n|(s&o)>>>r)>>>0}function E(o,n=0,i=o.byteLength,r=0){for(let s=0;s<i;s++)o[n+s]=r}function v(o,n,i="0"){for(;o.length<n;)o=i+o;return o}function a(o,n=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(i=>i.toString(16).padStart(2,"0")).join(""):v((o>>>0).toString(16),n/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const r=this.p;let s=this.r,t=this.u,f,d;for(t!==0?(f=t,d=-1,t=0):(f=n.charCodeAt(0),d=0);;){let l=f;if(u.$xf(f))if(d+1<i){const c=n.charCodeAt(d+1);u.$yf(c)?(d++,l=u.$zf(f,c)):l=65533}else{t=f;break}else u.$yf(f)&&(l=65533);if(s=this.w(r,s,l),d++,d<i)f=n.charCodeAt(d);else break}this.r=s,this.u=t}w(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,E(this.p,this.r),this.r>56&&(this.y(),E(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=m.g,i=this.q;for(let g=0;g<64;g+=4)n.setUint32(g,i.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)n.setUint32(g,$(n.getUint32(g-12,!1)^n.getUint32(g-32,!1)^n.getUint32(g-56,!1)^n.getUint32(g-64,!1),1),!1);let r=this.h,s=this.l,t=this.m,f=this.n,d=this.o,l,c,h;for(let g=0;g<80;g++)g<20?(l=s&t|~s&f,c=1518500249):g<40?(l=s^t^f,c=1859775393):g<60?(l=s&t|s&f|t&f,c=2400959708):(l=s^t^f,c=3395469782),h=$(r,5)+l+d+c+n.getUint32(g*4,!1)&4294967295,d=f,f=t,t=$(s,30),s=r,r=h;this.h=this.h+r&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+f&4294967295,this.o=this.o+d&4294967295}}e.$kj=m}),define(ke[40],Ee([1,0,14]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const R="error",M="warning",p="warn",b="info",S="ignore";function A($){return $?u.$tf(R,$)?L.Error:u.$tf(M,$)||u.$tf(p,$)?L.Warning:u.$tf(b,$)?L.Info:L.Ignore:L.Ignore}L.fromValue=A;function P($){switch($){case L.Error:return R;case L.Warning:return M;case L.Info:return b;default:return S}}L.toString=P}(N||(N={})),e.default=N}),define(ke[169],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(ke[77],Ee([1,0,19,14]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class L{constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const v=E.charCodeAt(0),a=this.b.charCodeAt(this.c);return v-a}value(){return this.b[this.c]}}e.$si=L;class R{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,N.$nf)(E,this.b,0,E.length,this.c,this.d):(0,N.$pf)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ti=R;class M{constructor(E=!0,v=!0){this.f=E,this.g=v}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let v=E.length-1;v>=0;v--,this.c--){const a=this.b.charCodeAt(v);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,N.$nf)(E,this.b,0,E.length,this.d,this.e):(0,N.$pf)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ui=M;var p;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(p||(p={}));class b{constructor(E,v){this.f=E,this.g=v,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,N.$of)(E,this.c.scheme);if(this.d[this.e]===2)return(0,N.$of)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,N.$mf)(E,this.c.query);if(this.d[this.e]===5)return(0,N.$mf)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$vi=b;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(A||(A={}));class P{static forUris(E=()=>!1,v=()=>!1){return new P(new b(E,v))}static forPaths(E=!1){return new P(new M(void 0,!E))}static forStrings(){return new P(new L)}static forConfigKeys(){return new P(new R)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,v){if(v){const a=v.slice(0);(0,u.$Xb)(a);for(const m of a)this.set(m,E)}else{const a=E.slice(0);(0,u.$Xb)(a);for(const m of a)this.set(m[0],m[1])}}set(E,v){const a=this.b.reset(E);let m;this.c||(this.c=new S,this.c.segment=a.value());const o=[];for(m=this.c;;){const i=a.cmp(m.segment);if(i>0)m.left||(m.left=new S,m.left.segment=a.value()),o.push([-1,m]),m=m.left;else if(i<0)m.right||(m.right=new S,m.right.segment=a.value()),o.push([1,m]),m=m.right;else if(a.hasNext())a.next(),m.mid||(m.mid=new S,m.mid.segment=a.value()),o.push([0,m]),m=m.mid;else break}const n=m.value;m.value=v,m.key=E;for(let i=o.length-1;i>=0;i--){const r=o[i][1];r.updateHeight();const s=r.balanceFactor();if(s<-1||s>1){const t=o[i][0],f=o[i+1][0];if(t===1&&f===1)o[i][1]=r.rotateLeft();else if(t===-1&&f===-1)o[i][1]=r.rotateRight();else if(t===1&&f===-1)r.right=o[i+1][1]=o[i+1][1].rotateRight(),o[i][1]=r.rotateLeft();else if(t===-1&&f===1)r.left=o[i+1][1]=o[i+1][1].rotateLeft(),o[i][1]=r.rotateRight();else throw new Error;if(i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}return n}get(E){return this.d(E)?.value}d(E){const v=this.b.reset(E);let a=this.c;for(;a;){const m=v.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(v.hasNext())v.next(),a=a.mid;else break}return a}has(E){const v=this.d(E);return!(v?.value===void 0&&v?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,v){const a=this.b.reset(E),m=[];let o=this.c;for(;o;){const n=a.cmp(o.segment);if(n>0)m.push([-1,o]),o=o.left;else if(n<0)m.push([1,o]),o=o.right;else if(a.hasNext())a.next(),m.push([0,o]),o=o.mid;else break}if(o){if(v?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const n=this.f(o.right);if(n.key){const{key:i,value:r,segment:s}=n;this.e(n.key,!1),o.key=i,o.value=r,o.segment=s}}else{const n=o.left??o.right;if(m.length>0){const[i,r]=m[m.length-1];switch(i){case-1:r.left=n;break;case 0:r.mid=n;break;case 1:r.right=n;break}}else this.c=n}for(let n=m.length-1;n>=0;n--){const i=m[n][1];i.updateHeight();const r=i.balanceFactor();if(r>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),m[n][1]=i.rotateLeft()):r<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),m[n][1]=i.rotateRight()),n>0)switch(m[n-1][0]){case-1:m[n-1][1].left=m[n][1];break;case 1:m[n-1][1].right=m[n][1];break;case 0:m[n-1][1].mid=m[n][1];break}else this.c=m[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const v=this.b.reset(E);let a=this.c,m;for(;a;){const o=v.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(v.hasNext())v.next(),m=a.value||m,a=a.mid;else break}return a&&a.value||m}findSuperstr(E){return this.g(E,!1)}g(E,v){const a=this.b.reset(E);let m=this.c;for(;m;){const o=a.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(a.hasNext())a.next(),m=m.mid;else return m.mid?this.h(m.mid):v?m.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[v,a]of this)E(a,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const v=[];return this.j(E,v),v[Symbol.iterator]()}j(E,v){E&&(E.left&&this.j(E.left,v),E.value&&v.push([E.key,E.value]),E.mid&&this.j(E.mid,v),E.right&&this.j(E.right,v))}_isBalanced(){const E=v=>{if(!v)return!0;const a=v.balanceFactor();return a<-1||a>1?!1:E(v.left)&&E(v.right)};return E(this.c)}}e.$wi=P}),define(ke[18],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=u,e.$5f=N,e.$6f=L,e.$7f=R,e.$8f=M,e.$9f=p,e.$0f=b,e.$$f=S,e.$_f=A,e.$ag=P,e.$bg=$,e.$cg=E,e.$dg=v,e.$eg=m,e.$fg=o,e.$gg=n,e.$hg=i,e.$ig=r;function u(s){return typeof s=="string"}function N(s){return Array.isArray(s)&&s.every(t=>u(t))}function L(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function R(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}function M(s){return typeof s=="number"&&!isNaN(s)}function p(s){return!!s&&typeof s[Symbol.iterator]=="function"}function b(s){return s===!0||s===!1}function S(s){return typeof s>"u"}function A(s){return!P(s)}function P(s){return S(s)||s===null}function $(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function E(s){if(P(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function v(...s){const t=[];for(let f=0;f<s.length;f++){const d=s[f];if(P(d))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);t.push(d)}return t}const a=Object.prototype.hasOwnProperty;function m(s){if(!L(s))return!1;for(const t in s)if(a.call(s,t))return!1;return!0}function o(s){return typeof s=="function"}function n(...s){return s.length>0&&s.every(o)}function i(s,t){const f=Math.min(s.length,t.length);for(let d=0;d<f;d++)r(s[d],t[d])}function r(s,t){if(u(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(s instanceof t)return}catch{}if(!P(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],Ee([1,0,18]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kj=L,e.$Lj=R;const N=Object.create(null);function L(M,p){if((0,u.$4f)(p)){const b=N[p];if(b===void 0)throw new Error(`${M} references an unknown codicon: ${p}`);p=b}return N[M]=p,{id:M}}function R(){return N}}),define(ke[170],Ee([1,0,99]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=void 0,e.$Mj={add:(0,u.$Kj)("add",6e4),plus:(0,u.$Kj)("plus",6e4),gistNew:(0,u.$Kj)("gist-new",6e4),repoCreate:(0,u.$Kj)("repo-create",6e4),lightbulb:(0,u.$Kj)("lightbulb",60001),lightBulb:(0,u.$Kj)("light-bulb",60001),repo:(0,u.$Kj)("repo",60002),repoDelete:(0,u.$Kj)("repo-delete",60002),gistFork:(0,u.$Kj)("gist-fork",60003),repoForked:(0,u.$Kj)("repo-forked",60003),gitPullRequest:(0,u.$Kj)("git-pull-request",60004),gitPullRequestAbandoned:(0,u.$Kj)("git-pull-request-abandoned",60004),recordKeys:(0,u.$Kj)("record-keys",60005),keyboard:(0,u.$Kj)("keyboard",60005),tag:(0,u.$Kj)("tag",60006),gitPullRequestLabel:(0,u.$Kj)("git-pull-request-label",60006),tagAdd:(0,u.$Kj)("tag-add",60006),tagRemove:(0,u.$Kj)("tag-remove",60006),person:(0,u.$Kj)("person",60007),personFollow:(0,u.$Kj)("person-follow",60007),personOutline:(0,u.$Kj)("person-outline",60007),personFilled:(0,u.$Kj)("person-filled",60007),gitBranch:(0,u.$Kj)("git-branch",60008),gitBranchCreate:(0,u.$Kj)("git-branch-create",60008),gitBranchDelete:(0,u.$Kj)("git-branch-delete",60008),sourceControl:(0,u.$Kj)("source-control",60008),mirror:(0,u.$Kj)("mirror",60009),mirrorPublic:(0,u.$Kj)("mirror-public",60009),star:(0,u.$Kj)("star",60010),starAdd:(0,u.$Kj)("star-add",60010),starDelete:(0,u.$Kj)("star-delete",60010),starEmpty:(0,u.$Kj)("star-empty",60010),comment:(0,u.$Kj)("comment",60011),commentAdd:(0,u.$Kj)("comment-add",60011),alert:(0,u.$Kj)("alert",60012),warning:(0,u.$Kj)("warning",60012),search:(0,u.$Kj)("search",60013),searchSave:(0,u.$Kj)("search-save",60013),logOut:(0,u.$Kj)("log-out",60014),signOut:(0,u.$Kj)("sign-out",60014),logIn:(0,u.$Kj)("log-in",60015),signIn:(0,u.$Kj)("sign-in",60015),eye:(0,u.$Kj)("eye",60016),eyeUnwatch:(0,u.$Kj)("eye-unwatch",60016),eyeWatch:(0,u.$Kj)("eye-watch",60016),circleFilled:(0,u.$Kj)("circle-filled",60017),primitiveDot:(0,u.$Kj)("primitive-dot",60017),closeDirty:(0,u.$Kj)("close-dirty",60017),debugBreakpoint:(0,u.$Kj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,u.$Kj)("debug-breakpoint-disabled",60017),debugHint:(0,u.$Kj)("debug-hint",60017),terminalDecorationSuccess:(0,u.$Kj)("terminal-decoration-success",60017),primitiveSquare:(0,u.$Kj)("primitive-square",60018),edit:(0,u.$Kj)("edit",60019),pencil:(0,u.$Kj)("pencil",60019),info:(0,u.$Kj)("info",60020),issueOpened:(0,u.$Kj)("issue-opened",60020),gistPrivate:(0,u.$Kj)("gist-private",60021),gitForkPrivate:(0,u.$Kj)("git-fork-private",60021),lock:(0,u.$Kj)("lock",60021),mirrorPrivate:(0,u.$Kj)("mirror-private",60021),close:(0,u.$Kj)("close",60022),removeClose:(0,u.$Kj)("remove-close",60022),x:(0,u.$Kj)("x",60022),repoSync:(0,u.$Kj)("repo-sync",60023),sync:(0,u.$Kj)("sync",60023),clone:(0,u.$Kj)("clone",60024),desktopDownload:(0,u.$Kj)("desktop-download",60024),beaker:(0,u.$Kj)("beaker",60025),microscope:(0,u.$Kj)("microscope",60025),vm:(0,u.$Kj)("vm",60026),deviceDesktop:(0,u.$Kj)("device-desktop",60026),file:(0,u.$Kj)("file",60027),fileText:(0,u.$Kj)("file-text",60027),more:(0,u.$Kj)("more",60028),ellipsis:(0,u.$Kj)("ellipsis",60028),kebabHorizontal:(0,u.$Kj)("kebab-horizontal",60028),mailReply:(0,u.$Kj)("mail-reply",60029),reply:(0,u.$Kj)("reply",60029),organization:(0,u.$Kj)("organization",60030),organizationFilled:(0,u.$Kj)("organization-filled",60030),organizationOutline:(0,u.$Kj)("organization-outline",60030),newFile:(0,u.$Kj)("new-file",60031),fileAdd:(0,u.$Kj)("file-add",60031),newFolder:(0,u.$Kj)("new-folder",60032),fileDirectoryCreate:(0,u.$Kj)("file-directory-create",60032),trash:(0,u.$Kj)("trash",60033),trashcan:(0,u.$Kj)("trashcan",60033),history:(0,u.$Kj)("history",60034),clock:(0,u.$Kj)("clock",60034),folder:(0,u.$Kj)("folder",60035),fileDirectory:(0,u.$Kj)("file-directory",60035),symbolFolder:(0,u.$Kj)("symbol-folder",60035),logoGithub:(0,u.$Kj)("logo-github",60036),markGithub:(0,u.$Kj)("mark-github",60036),github:(0,u.$Kj)("github",60036),terminal:(0,u.$Kj)("terminal",60037),console:(0,u.$Kj)("console",60037),repl:(0,u.$Kj)("repl",60037),zap:(0,u.$Kj)("zap",60038),symbolEvent:(0,u.$Kj)("symbol-event",60038),error:(0,u.$Kj)("error",60039),stop:(0,u.$Kj)("stop",60039),variable:(0,u.$Kj)("variable",60040),symbolVariable:(0,u.$Kj)("symbol-variable",60040),array:(0,u.$Kj)("array",60042),symbolArray:(0,u.$Kj)("symbol-array",60042),symbolModule:(0,u.$Kj)("symbol-module",60043),symbolPackage:(0,u.$Kj)("symbol-package",60043),symbolNamespace:(0,u.$Kj)("symbol-namespace",60043),symbolObject:(0,u.$Kj)("symbol-object",60043),symbolMethod:(0,u.$Kj)("symbol-method",60044),symbolFunction:(0,u.$Kj)("symbol-function",60044),symbolConstructor:(0,u.$Kj)("symbol-constructor",60044),symbolBoolean:(0,u.$Kj)("symbol-boolean",60047),symbolNull:(0,u.$Kj)("symbol-null",60047),symbolNumeric:(0,u.$Kj)("symbol-numeric",60048),symbolNumber:(0,u.$Kj)("symbol-number",60048),symbolStructure:(0,u.$Kj)("symbol-structure",60049),symbolStruct:(0,u.$Kj)("symbol-struct",60049),symbolParameter:(0,u.$Kj)("symbol-parameter",60050),symbolTypeParameter:(0,u.$Kj)("symbol-type-parameter",60050),symbolKey:(0,u.$Kj)("symbol-key",60051),symbolText:(0,u.$Kj)("symbol-text",60051),symbolReference:(0,u.$Kj)("symbol-reference",60052),goToFile:(0,u.$Kj)("go-to-file",60052),symbolEnum:(0,u.$Kj)("symbol-enum",60053),symbolValue:(0,u.$Kj)("symbol-value",60053),symbolRuler:(0,u.$Kj)("symbol-ruler",60054),symbolUnit:(0,u.$Kj)("symbol-unit",60054),activateBreakpoints:(0,u.$Kj)("activate-breakpoints",60055),archive:(0,u.$Kj)("archive",60056),arrowBoth:(0,u.$Kj)("arrow-both",60057),arrowDown:(0,u.$Kj)("arrow-down",60058),arrowLeft:(0,u.$Kj)("arrow-left",60059),arrowRight:(0,u.$Kj)("arrow-right",60060),arrowSmallDown:(0,u.$Kj)("arrow-small-down",60061),arrowSmallLeft:(0,u.$Kj)("arrow-small-left",60062),arrowSmallRight:(0,u.$Kj)("arrow-small-right",60063),arrowSmallUp:(0,u.$Kj)("arrow-small-up",60064),arrowUp:(0,u.$Kj)("arrow-up",60065),bell:(0,u.$Kj)("bell",60066),bold:(0,u.$Kj)("bold",60067),book:(0,u.$Kj)("book",60068),bookmark:(0,u.$Kj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,u.$Kj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,u.$Kj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,u.$Kj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,u.$Kj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,u.$Kj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,u.$Kj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,u.$Kj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,u.$Kj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,u.$Kj)("debug-breakpoint-log-disabled",60075),briefcase:(0,u.$Kj)("briefcase",60076),broadcast:(0,u.$Kj)("broadcast",60077),browser:(0,u.$Kj)("browser",60078),bug:(0,u.$Kj)("bug",60079),calendar:(0,u.$Kj)("calendar",60080),caseSensitive:(0,u.$Kj)("case-sensitive",60081),check:(0,u.$Kj)("check",60082),checklist:(0,u.$Kj)("checklist",60083),chevronDown:(0,u.$Kj)("chevron-down",60084),chevronLeft:(0,u.$Kj)("chevron-left",60085),chevronRight:(0,u.$Kj)("chevron-right",60086),chevronUp:(0,u.$Kj)("chevron-up",60087),chromeClose:(0,u.$Kj)("chrome-close",60088),chromeMaximize:(0,u.$Kj)("chrome-maximize",60089),chromeMinimize:(0,u.$Kj)("chrome-minimize",60090),chromeRestore:(0,u.$Kj)("chrome-restore",60091),circleOutline:(0,u.$Kj)("circle-outline",60092),circle:(0,u.$Kj)("circle",60092),debugBreakpointUnverified:(0,u.$Kj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,u.$Kj)("terminal-decoration-incomplete",60092),circleSlash:(0,u.$Kj)("circle-slash",60093),circuitBoard:(0,u.$Kj)("circuit-board",60094),clearAll:(0,u.$Kj)("clear-all",60095),clippy:(0,u.$Kj)("clippy",60096),closeAll:(0,u.$Kj)("close-all",60097),cloudDownload:(0,u.$Kj)("cloud-download",60098),cloudUpload:(0,u.$Kj)("cloud-upload",60099),code:(0,u.$Kj)("code",60100),collapseAll:(0,u.$Kj)("collapse-all",60101),colorMode:(0,u.$Kj)("color-mode",60102),commentDiscussion:(0,u.$Kj)("comment-discussion",60103),creditCard:(0,u.$Kj)("credit-card",60105),dash:(0,u.$Kj)("dash",60108),dashboard:(0,u.$Kj)("dashboard",60109),database:(0,u.$Kj)("database",60110),debugContinue:(0,u.$Kj)("debug-continue",60111),debugDisconnect:(0,u.$Kj)("debug-disconnect",60112),debugPause:(0,u.$Kj)("debug-pause",60113),debugRestart:(0,u.$Kj)("debug-restart",60114),debugStart:(0,u.$Kj)("debug-start",60115),debugStepInto:(0,u.$Kj)("debug-step-into",60116),debugStepOut:(0,u.$Kj)("debug-step-out",60117),debugStepOver:(0,u.$Kj)("debug-step-over",60118),debugStop:(0,u.$Kj)("debug-stop",60119),debug:(0,u.$Kj)("debug",60120),deviceCameraVideo:(0,u.$Kj)("device-camera-video",60121),deviceCamera:(0,u.$Kj)("device-camera",60122),deviceMobile:(0,u.$Kj)("device-mobile",60123),diffAdded:(0,u.$Kj)("diff-added",60124),diffIgnored:(0,u.$Kj)("diff-ignored",60125),diffModified:(0,u.$Kj)("diff-modified",60126),diffRemoved:(0,u.$Kj)("diff-removed",60127),diffRenamed:(0,u.$Kj)("diff-renamed",60128),diff:(0,u.$Kj)("diff",60129),diffSidebyside:(0,u.$Kj)("diff-sidebyside",60129),discard:(0,u.$Kj)("discard",60130),editorLayout:(0,u.$Kj)("editor-layout",60131),emptyWindow:(0,u.$Kj)("empty-window",60132),exclude:(0,u.$Kj)("exclude",60133),extensions:(0,u.$Kj)("extensions",60134),eyeClosed:(0,u.$Kj)("eye-closed",60135),fileBinary:(0,u.$Kj)("file-binary",60136),fileCode:(0,u.$Kj)("file-code",60137),fileMedia:(0,u.$Kj)("file-media",60138),filePdf:(0,u.$Kj)("file-pdf",60139),fileSubmodule:(0,u.$Kj)("file-submodule",60140),fileSymlinkDirectory:(0,u.$Kj)("file-symlink-directory",60141),fileSymlinkFile:(0,u.$Kj)("file-symlink-file",60142),fileZip:(0,u.$Kj)("file-zip",60143),files:(0,u.$Kj)("files",60144),filter:(0,u.$Kj)("filter",60145),flame:(0,u.$Kj)("flame",60146),foldDown:(0,u.$Kj)("fold-down",60147),foldUp:(0,u.$Kj)("fold-up",60148),fold:(0,u.$Kj)("fold",60149),folderActive:(0,u.$Kj)("folder-active",60150),folderOpened:(0,u.$Kj)("folder-opened",60151),gear:(0,u.$Kj)("gear",60152),gift:(0,u.$Kj)("gift",60153),gistSecret:(0,u.$Kj)("gist-secret",60154),gist:(0,u.$Kj)("gist",60155),gitCommit:(0,u.$Kj)("git-commit",60156),gitCompare:(0,u.$Kj)("git-compare",60157),compareChanges:(0,u.$Kj)("compare-changes",60157),gitMerge:(0,u.$Kj)("git-merge",60158),githubAction:(0,u.$Kj)("github-action",60159),githubAlt:(0,u.$Kj)("github-alt",60160),globe:(0,u.$Kj)("globe",60161),grabber:(0,u.$Kj)("grabber",60162),graph:(0,u.$Kj)("graph",60163),gripper:(0,u.$Kj)("gripper",60164),heart:(0,u.$Kj)("heart",60165),home:(0,u.$Kj)("home",60166),horizontalRule:(0,u.$Kj)("horizontal-rule",60167),hubot:(0,u.$Kj)("hubot",60168),inbox:(0,u.$Kj)("inbox",60169),issueReopened:(0,u.$Kj)("issue-reopened",60171),issues:(0,u.$Kj)("issues",60172),italic:(0,u.$Kj)("italic",60173),jersey:(0,u.$Kj)("jersey",60174),json:(0,u.$Kj)("json",60175),kebabVertical:(0,u.$Kj)("kebab-vertical",60176),key:(0,u.$Kj)("key",60177),law:(0,u.$Kj)("law",60178),lightbulbAutofix:(0,u.$Kj)("lightbulb-autofix",60179),linkExternal:(0,u.$Kj)("link-external",60180),link:(0,u.$Kj)("link",60181),listOrdered:(0,u.$Kj)("list-ordered",60182),listUnordered:(0,u.$Kj)("list-unordered",60183),liveShare:(0,u.$Kj)("live-share",60184),loading:(0,u.$Kj)("loading",60185),location:(0,u.$Kj)("location",60186),mailRead:(0,u.$Kj)("mail-read",60187),mail:(0,u.$Kj)("mail",60188),markdown:(0,u.$Kj)("markdown",60189),megaphone:(0,u.$Kj)("megaphone",60190),mention:(0,u.$Kj)("mention",60191),milestone:(0,u.$Kj)("milestone",60192),gitPullRequestMilestone:(0,u.$Kj)("git-pull-request-milestone",60192),mortarBoard:(0,u.$Kj)("mortar-board",60193),move:(0,u.$Kj)("move",60194),multipleWindows:(0,u.$Kj)("multiple-windows",60195),mute:(0,u.$Kj)("mute",60196),noNewline:(0,u.$Kj)("no-newline",60197),note:(0,u.$Kj)("note",60198),octoface:(0,u.$Kj)("octoface",60199),openPreview:(0,u.$Kj)("open-preview",60200),package:(0,u.$Kj)("package",60201),paintcan:(0,u.$Kj)("paintcan",60202),pin:(0,u.$Kj)("pin",60203),play:(0,u.$Kj)("play",60204),run:(0,u.$Kj)("run",60204),plug:(0,u.$Kj)("plug",60205),preserveCase:(0,u.$Kj)("preserve-case",60206),preview:(0,u.$Kj)("preview",60207),project:(0,u.$Kj)("project",60208),pulse:(0,u.$Kj)("pulse",60209),question:(0,u.$Kj)("question",60210),quote:(0,u.$Kj)("quote",60211),radioTower:(0,u.$Kj)("radio-tower",60212),reactions:(0,u.$Kj)("reactions",60213),references:(0,u.$Kj)("references",60214),refresh:(0,u.$Kj)("refresh",60215),regex:(0,u.$Kj)("regex",60216),remoteExplorer:(0,u.$Kj)("remote-explorer",60217),remote:(0,u.$Kj)("remote",60218),remove:(0,u.$Kj)("remove",60219),replaceAll:(0,u.$Kj)("replace-all",60220),replace:(0,u.$Kj)("replace",60221),repoClone:(0,u.$Kj)("repo-clone",60222),repoForcePush:(0,u.$Kj)("repo-force-push",60223),repoPull:(0,u.$Kj)("repo-pull",60224),repoPush:(0,u.$Kj)("repo-push",60225),report:(0,u.$Kj)("report",60226),requestChanges:(0,u.$Kj)("request-changes",60227),rocket:(0,u.$Kj)("rocket",60228),rootFolderOpened:(0,u.$Kj)("root-folder-opened",60229),rootFolder:(0,u.$Kj)("root-folder",60230),rss:(0,u.$Kj)("rss",60231),ruby:(0,u.$Kj)("ruby",60232),saveAll:(0,u.$Kj)("save-all",60233),saveAs:(0,u.$Kj)("save-as",60234),save:(0,u.$Kj)("save",60235),screenFull:(0,u.$Kj)("screen-full",60236),screenNormal:(0,u.$Kj)("screen-normal",60237),searchStop:(0,u.$Kj)("search-stop",60238),server:(0,u.$Kj)("server",60240),settingsGear:(0,u.$Kj)("settings-gear",60241),settings:(0,u.$Kj)("settings",60242),shield:(0,u.$Kj)("shield",60243),smiley:(0,u.$Kj)("smiley",60244),sortPrecedence:(0,u.$Kj)("sort-precedence",60245),splitHorizontal:(0,u.$Kj)("split-horizontal",60246),splitVertical:(0,u.$Kj)("split-vertical",60247),squirrel:(0,u.$Kj)("squirrel",60248),starFull:(0,u.$Kj)("star-full",60249),starHalf:(0,u.$Kj)("star-half",60250),symbolClass:(0,u.$Kj)("symbol-class",60251),symbolColor:(0,u.$Kj)("symbol-color",60252),symbolConstant:(0,u.$Kj)("symbol-constant",60253),symbolEnumMember:(0,u.$Kj)("symbol-enum-member",60254),symbolField:(0,u.$Kj)("symbol-field",60255),symbolFile:(0,u.$Kj)("symbol-file",60256),symbolInterface:(0,u.$Kj)("symbol-interface",60257),symbolKeyword:(0,u.$Kj)("symbol-keyword",60258),symbolMisc:(0,u.$Kj)("symbol-misc",60259),symbolOperator:(0,u.$Kj)("symbol-operator",60260),symbolProperty:(0,u.$Kj)("symbol-property",60261),wrench:(0,u.$Kj)("wrench",60261),wrenchSubaction:(0,u.$Kj)("wrench-subaction",60261),symbolSnippet:(0,u.$Kj)("symbol-snippet",60262),tasklist:(0,u.$Kj)("tasklist",60263),telescope:(0,u.$Kj)("telescope",60264),textSize:(0,u.$Kj)("text-size",60265),threeBars:(0,u.$Kj)("three-bars",60266),thumbsdown:(0,u.$Kj)("thumbsdown",60267),thumbsup:(0,u.$Kj)("thumbsup",60268),tools:(0,u.$Kj)("tools",60269),triangleDown:(0,u.$Kj)("triangle-down",60270),triangleLeft:(0,u.$Kj)("triangle-left",60271),triangleRight:(0,u.$Kj)("triangle-right",60272),triangleUp:(0,u.$Kj)("triangle-up",60273),twitter:(0,u.$Kj)("twitter",60274),unfold:(0,u.$Kj)("unfold",60275),unlock:(0,u.$Kj)("unlock",60276),unmute:(0,u.$Kj)("unmute",60277),unverified:(0,u.$Kj)("unverified",60278),verified:(0,u.$Kj)("verified",60279),versions:(0,u.$Kj)("versions",60280),vmActive:(0,u.$Kj)("vm-active",60281),vmOutline:(0,u.$Kj)("vm-outline",60282),vmRunning:(0,u.$Kj)("vm-running",60283),watch:(0,u.$Kj)("watch",60284),whitespace:(0,u.$Kj)("whitespace",60285),wholeWord:(0,u.$Kj)("whole-word",60286),window:(0,u.$Kj)("window",60287),wordWrap:(0,u.$Kj)("word-wrap",60288),zoomIn:(0,u.$Kj)("zoom-in",60289),zoomOut:(0,u.$Kj)("zoom-out",60290),listFilter:(0,u.$Kj)("list-filter",60291),listFlat:(0,u.$Kj)("list-flat",60292),listSelection:(0,u.$Kj)("list-selection",60293),selection:(0,u.$Kj)("selection",60293),listTree:(0,u.$Kj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,u.$Kj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,u.$Kj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,u.$Kj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,u.$Kj)("debug-stackframe-active",60297),circleSmallFilled:(0,u.$Kj)("circle-small-filled",60298),debugStackframeDot:(0,u.$Kj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,u.$Kj)("terminal-decoration-mark",60298),debugStackframe:(0,u.$Kj)("debug-stackframe",60299),debugStackframeFocused:(0,u.$Kj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,u.$Kj)("debug-breakpoint-unsupported",60300),symbolString:(0,u.$Kj)("symbol-string",60301),debugReverseContinue:(0,u.$Kj)("debug-reverse-continue",60302),debugStepBack:(0,u.$Kj)("debug-step-back",60303),debugRestartFrame:(0,u.$Kj)("debug-restart-frame",60304),debugAlt:(0,u.$Kj)("debug-alt",60305),callIncoming:(0,u.$Kj)("call-incoming",60306),callOutgoing:(0,u.$Kj)("call-outgoing",60307),menu:(0,u.$Kj)("menu",60308),expandAll:(0,u.$Kj)("expand-all",60309),feedback:(0,u.$Kj)("feedback",60310),gitPullRequestReviewer:(0,u.$Kj)("git-pull-request-reviewer",60310),groupByRefType:(0,u.$Kj)("group-by-ref-type",60311),ungroupByRefType:(0,u.$Kj)("ungroup-by-ref-type",60312),account:(0,u.$Kj)("account",60313),gitPullRequestAssignee:(0,u.$Kj)("git-pull-request-assignee",60313),bellDot:(0,u.$Kj)("bell-dot",60314),debugConsole:(0,u.$Kj)("debug-console",60315),library:(0,u.$Kj)("library",60316),output:(0,u.$Kj)("output",60317),runAll:(0,u.$Kj)("run-all",60318),syncIgnored:(0,u.$Kj)("sync-ignored",60319),pinned:(0,u.$Kj)("pinned",60320),githubInverted:(0,u.$Kj)("github-inverted",60321),serverProcess:(0,u.$Kj)("server-process",60322),serverEnvironment:(0,u.$Kj)("server-environment",60323),pass:(0,u.$Kj)("pass",60324),issueClosed:(0,u.$Kj)("issue-closed",60324),stopCircle:(0,u.$Kj)("stop-circle",60325),playCircle:(0,u.$Kj)("play-circle",60326),record:(0,u.$Kj)("record",60327),debugAltSmall:(0,u.$Kj)("debug-alt-small",60328),vmConnect:(0,u.$Kj)("vm-connect",60329),cloud:(0,u.$Kj)("cloud",60330),merge:(0,u.$Kj)("merge",60331),export:(0,u.$Kj)("export",60332),graphLeft:(0,u.$Kj)("graph-left",60333),magnet:(0,u.$Kj)("magnet",60334),notebook:(0,u.$Kj)("notebook",60335),redo:(0,u.$Kj)("redo",60336),checkAll:(0,u.$Kj)("check-all",60337),pinnedDirty:(0,u.$Kj)("pinned-dirty",60338),passFilled:(0,u.$Kj)("pass-filled",60339),circleLargeFilled:(0,u.$Kj)("circle-large-filled",60340),circleLarge:(0,u.$Kj)("circle-large",60341),circleLargeOutline:(0,u.$Kj)("circle-large-outline",60341),combine:(0,u.$Kj)("combine",60342),gather:(0,u.$Kj)("gather",60342),table:(0,u.$Kj)("table",60343),variableGroup:(0,u.$Kj)("variable-group",60344),typeHierarchy:(0,u.$Kj)("type-hierarchy",60345),typeHierarchySub:(0,u.$Kj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,u.$Kj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,u.$Kj)("git-pull-request-create",60348),runAbove:(0,u.$Kj)("run-above",60349),runBelow:(0,u.$Kj)("run-below",60350),notebookTemplate:(0,u.$Kj)("notebook-template",60351),debugRerun:(0,u.$Kj)("debug-rerun",60352),workspaceTrusted:(0,u.$Kj)("workspace-trusted",60353),workspaceUntrusted:(0,u.$Kj)("workspace-untrusted",60354),workspaceUnknown:(0,u.$Kj)("workspace-unknown",60355),terminalCmd:(0,u.$Kj)("terminal-cmd",60356),terminalDebian:(0,u.$Kj)("terminal-debian",60357),terminalLinux:(0,u.$Kj)("terminal-linux",60358),terminalPowershell:(0,u.$Kj)("terminal-powershell",60359),terminalTmux:(0,u.$Kj)("terminal-tmux",60360),terminalUbuntu:(0,u.$Kj)("terminal-ubuntu",60361),terminalBash:(0,u.$Kj)("terminal-bash",60362),arrowSwap:(0,u.$Kj)("arrow-swap",60363),copy:(0,u.$Kj)("copy",60364),personAdd:(0,u.$Kj)("person-add",60365),filterFilled:(0,u.$Kj)("filter-filled",60366),wand:(0,u.$Kj)("wand",60367),debugLineByLine:(0,u.$Kj)("debug-line-by-line",60368),inspect:(0,u.$Kj)("inspect",60369),layers:(0,u.$Kj)("layers",60370),layersDot:(0,u.$Kj)("layers-dot",60371),layersActive:(0,u.$Kj)("layers-active",60372),compass:(0,u.$Kj)("compass",60373),compassDot:(0,u.$Kj)("compass-dot",60374),compassActive:(0,u.$Kj)("compass-active",60375),azure:(0,u.$Kj)("azure",60376),issueDraft:(0,u.$Kj)("issue-draft",60377),gitPullRequestClosed:(0,u.$Kj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,u.$Kj)("git-pull-request-draft",60379),debugAll:(0,u.$Kj)("debug-all",60380),debugCoverage:(0,u.$Kj)("debug-coverage",60381),runErrors:(0,u.$Kj)("run-errors",60382),folderLibrary:(0,u.$Kj)("folder-library",60383),debugContinueSmall:(0,u.$Kj)("debug-continue-small",60384),beakerStop:(0,u.$Kj)("beaker-stop",60385),graphLine:(0,u.$Kj)("graph-line",60386),graphScatter:(0,u.$Kj)("graph-scatter",60387),pieChart:(0,u.$Kj)("pie-chart",60388),bracket:(0,u.$Kj)("bracket",60175),bracketDot:(0,u.$Kj)("bracket-dot",60389),bracketError:(0,u.$Kj)("bracket-error",60390),lockSmall:(0,u.$Kj)("lock-small",60391),azureDevops:(0,u.$Kj)("azure-devops",60392),verifiedFilled:(0,u.$Kj)("verified-filled",60393),newline:(0,u.$Kj)("newline",60394),layout:(0,u.$Kj)("layout",60395),layoutActivitybarLeft:(0,u.$Kj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,u.$Kj)("layout-activitybar-right",60397),layoutPanelLeft:(0,u.$Kj)("layout-panel-left",60398),layoutPanelCenter:(0,u.$Kj)("layout-panel-center",60399),layoutPanelJustify:(0,u.$Kj)("layout-panel-justify",60400),layoutPanelRight:(0,u.$Kj)("layout-panel-right",60401),layoutPanel:(0,u.$Kj)("layout-panel",60402),layoutSidebarLeft:(0,u.$Kj)("layout-sidebar-left",60403),layoutSidebarRight:(0,u.$Kj)("layout-sidebar-right",60404),layoutStatusbar:(0,u.$Kj)("layout-statusbar",60405),layoutMenubar:(0,u.$Kj)("layout-menubar",60406),layoutCentered:(0,u.$Kj)("layout-centered",60407),target:(0,u.$Kj)("target",60408),indent:(0,u.$Kj)("indent",60409),recordSmall:(0,u.$Kj)("record-small",60410),errorSmall:(0,u.$Kj)("error-small",60411),terminalDecorationError:(0,u.$Kj)("terminal-decoration-error",60411),arrowCircleDown:(0,u.$Kj)("arrow-circle-down",60412),arrowCircleLeft:(0,u.$Kj)("arrow-circle-left",60413),arrowCircleRight:(0,u.$Kj)("arrow-circle-right",60414),arrowCircleUp:(0,u.$Kj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,u.$Kj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,u.$Kj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,u.$Kj)("layout-sidebar-left-off",60418),blank:(0,u.$Kj)("blank",60419),heartFilled:(0,u.$Kj)("heart-filled",60420),map:(0,u.$Kj)("map",60421),mapHorizontal:(0,u.$Kj)("map-horizontal",60421),foldHorizontal:(0,u.$Kj)("fold-horizontal",60421),mapFilled:(0,u.$Kj)("map-filled",60422),mapHorizontalFilled:(0,u.$Kj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,u.$Kj)("fold-horizontal-filled",60422),circleSmall:(0,u.$Kj)("circle-small",60423),bellSlash:(0,u.$Kj)("bell-slash",60424),bellSlashDot:(0,u.$Kj)("bell-slash-dot",60425),commentUnresolved:(0,u.$Kj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,u.$Kj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,u.$Kj)("git-pull-request-new-changes",60428),searchFuzzy:(0,u.$Kj)("search-fuzzy",60429),commentDraft:(0,u.$Kj)("comment-draft",60430),send:(0,u.$Kj)("send",60431),sparkle:(0,u.$Kj)("sparkle",60432),insert:(0,u.$Kj)("insert",60433),mic:(0,u.$Kj)("mic",60434),thumbsdownFilled:(0,u.$Kj)("thumbsdown-filled",60435),thumbsupFilled:(0,u.$Kj)("thumbsup-filled",60436),coffee:(0,u.$Kj)("coffee",60437),snake:(0,u.$Kj)("snake",60438),game:(0,u.$Kj)("game",60439),vr:(0,u.$Kj)("vr",60440),chip:(0,u.$Kj)("chip",60441),piano:(0,u.$Kj)("piano",60442),music:(0,u.$Kj)("music",60443),micFilled:(0,u.$Kj)("mic-filled",60444),repoFetch:(0,u.$Kj)("repo-fetch",60445),copilot:(0,u.$Kj)("copilot",60446),lightbulbSparkle:(0,u.$Kj)("lightbulb-sparkle",60447),robot:(0,u.$Kj)("robot",60448),sparkleFilled:(0,u.$Kj)("sparkle-filled",60449),diffSingle:(0,u.$Kj)("diff-single",60450),diffMultiple:(0,u.$Kj)("diff-multiple",60451),surroundWith:(0,u.$Kj)("surround-with",60452),share:(0,u.$Kj)("share",60453),gitStash:(0,u.$Kj)("git-stash",60454),gitStashApply:(0,u.$Kj)("git-stash-apply",60455),gitStashPop:(0,u.$Kj)("git-stash-pop",60456),vscode:(0,u.$Kj)("vscode",60457),vscodeInsiders:(0,u.$Kj)("vscode-insiders",60458),codeOss:(0,u.$Kj)("code-oss",60459),runCoverage:(0,u.$Kj)("run-coverage",60460),runAllCoverage:(0,u.$Kj)("run-all-coverage",60461),coverage:(0,u.$Kj)("coverage",60462),githubProject:(0,u.$Kj)("github-project",60463),mapVertical:(0,u.$Kj)("map-vertical",60464),foldVertical:(0,u.$Kj)("fold-vertical",60464),mapVerticalFilled:(0,u.$Kj)("map-vertical-filled",60465),foldVerticalFilled:(0,u.$Kj)("fold-vertical-filled",60465)}}),define(ke[78],Ee([1,0,99,170]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=void 0,e.$Nj=L;function L(){return Object.values(e.$Pj)}e.$Oj={dialogError:(0,u.$Kj)("dialog-error","error"),dialogWarning:(0,u.$Kj)("dialog-warning","warning"),dialogInfo:(0,u.$Kj)("dialog-info","info"),dialogClose:(0,u.$Kj)("dialog-close","close"),treeItemExpanded:(0,u.$Kj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,u.$Kj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,u.$Kj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,u.$Kj)("tree-filter-clear","close"),treeItemLoading:(0,u.$Kj)("tree-item-loading","loading"),menuSelection:(0,u.$Kj)("menu-selection","check"),menuSubmenu:(0,u.$Kj)("menu-submenu","chevron-right"),menuBarMore:(0,u.$Kj)("menubar-more","more"),scrollbarButtonLeft:(0,u.$Kj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,u.$Kj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,u.$Kj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,u.$Kj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,u.$Kj)("toolbar-more","more"),quickInputBack:(0,u.$Kj)("quick-input-back","arrow-left"),dropDownButton:(0,u.$Kj)("drop-down-button",60084),symbolCustomColor:(0,u.$Kj)("symbol-customcolor",60252),exportIcon:(0,u.$Kj)("export",60332),workspaceUnspecified:(0,u.$Kj)("workspace-unspecified",60355),newLine:(0,u.$Kj)("newline",60394),thumbsDownFilled:(0,u.$Kj)("thumbsdown-filled",60435),thumbsUpFilled:(0,u.$Kj)("thumbsup-filled",60436),gitFetch:(0,u.$Kj)("git-fetch",60445),lightbulbSparkleAutofix:(0,u.$Kj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,u.$Kj)("debug-breakpoint-pending",60377)},e.$Pj={...N.$Mj,...e.$Oj}}),define(ke[24],Ee([1,0,18]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=N,e.$Xn=L,e.$Yn=M,e.$Zn=b,e.$1n=S,e.$2n=A,e.$3n=P,e.$4n=$,e.$5n=E,e.$6n=v,e.$7n=a,e.$8n=m;function N(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const n=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([i,r])=>{n[i]=r&&typeof r=="object"?N(r):r}),n}function L(o){if(!o||typeof o!="object")return o;const n=[o];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const r in i)if(R.call(i,r)){const s=i[r];typeof s=="object"&&!Object.isFrozen(s)&&!(0,u.$7f)(s)&&n.push(s)}}return o}const R=Object.prototype.hasOwnProperty;function M(o,n){return p(o,n,new Set)}function p(o,n,i){if((0,u.$ag)(o))return o;const r=n(o);if(typeof r<"u")return r;if(Array.isArray(o)){const s=[];for(const t of o)s.push(p(t,n,i));return s}if((0,u.$6f)(o)){if(i.has(o))throw new Error("Cannot clone recursive data-structure");i.add(o);const s={};for(const t in o)R.call(o,t)&&(s[t]=p(o[t],n,i));return i.delete(o),s}return o}function b(o,n,i=!0){return(0,u.$6f)(o)?((0,u.$6f)(n)&&Object.keys(n).forEach(r=>{r in o?i&&((0,u.$6f)(o[r])&&(0,u.$6f)(n[r])?b(o[r],n[r],i):o[r]=n[r]):o[r]=n[r]}),o):n}function S(o,n){if(o===n)return!0;if(o==null||n===null||n===void 0||typeof o!=typeof n||typeof o!="object"||Array.isArray(o)!==Array.isArray(n))return!1;let i,r;if(Array.isArray(o)){if(o.length!==n.length)return!1;for(i=0;i<o.length;i++)if(!S(o[i],n[i]))return!1}else{const s=[];for(r in o)s.push(r);s.sort();const t=[];for(r in n)t.push(r);if(t.sort(),!S(s,t))return!1;for(i=0;i<s.length;i++)if(!S(o[s[i]],n[s[i]]))return!1}return!0}function A(o){const n=new Set;return JSON.stringify(o,(i,r)=>{if((0,u.$6f)(r)||Array.isArray(r)){if(n.has(r))return"[Circular]";n.add(r)}return r})}function P(o,n){const i=Object.create(null);return!o||!n||Object.keys(n).forEach(s=>{const t=o[s],f=n[s];S(t,f)||(i[s]=f)}),i}function $(o,n){const i=n.toLowerCase(),r=Object.keys(o).find(s=>s.toLowerCase()===i);return r?o[r]:o[n]}function E(o,n){const i=Object.create(null);for(const[r,s]of Object.entries(o))n(r,s)&&(i[r]=s);return i}function v(o){let n=[];for(;Object.prototype!==o;)n=n.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return n}function a(o){const n=[];for(const i of v(o))typeof o[i]=="function"&&n.push(i);return n}function m(o,n){const i=s=>function(){const t=Array.prototype.slice.call(arguments,0);return n(s,t)},r={};for(const s of o)r[s]=i(s);return r}}),define(ke[57],Ee([1,0,78]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Qj=L;var N;(function(M){function p(b){return b&&typeof b=="object"&&typeof b.id=="string"}M.isThemeColor=p})(N||(e.ThemeColor=N={}));function L(M){return{id:M}}var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function b(n){const i=p.exec(n.id);if(!i)return b(u.$Pj.error);const[,r,s]=i,t=["codicon","codicon-"+r];return s&&t.push("codicon-modifier-"+s.substring(1)),t}M.asClassNameArray=b;function S(n){return b(n).join(" ")}M.asClassName=S;function A(n){return"."+b(n).join(".")}M.asCSSSelector=A;function P(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}M.isThemeIcon=P;const $=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function E(n){const i=$.exec(n);if(!i)return;const[,r]=i;return{id:r}}M.fromString=E;function v(n){return{id:n}}M.fromId=v;function a(n,i){let r=n.id;const s=r.lastIndexOf("~");return s!==-1&&(r=r.substring(0,s)),i&&(r=`${r}~${i}`),{id:r}}M.modify=a;function m(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}M.getModifier=m;function o(n,i){return n.id===i.id&&n.color?.id===i.color?.id}M.isEqual=o})(R||(e.ThemeIcon=R={}))}),define(ke[171],Ee([1,0,126,14,57]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=b,e.$Ik=A,e.$Jk=$,e.$Kk=E,e.$Lk=a,e.$Mk=m;const R="$(",M=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${M.source}`,"g");function b(o){return o.replace(p,(n,i)=>i?n:`\\${n}`)}const S=new RegExp(`\\\\${M.source}`,"g");function A(o){return o.replace(S,n=>`\\${n}`)}const P=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function $(o){return o.indexOf(R)===-1?o:o.replace(P,(n,i,r,s)=>r?n:i||s||"")}function E(o){return o?o.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(o){v.lastIndex=0;let n="";const i=[];let r=0;for(;;){const s=v.lastIndex,t=v.exec(o),f=o.substring(s,t?.index);if(f.length>0){n+=f;for(let d=0;d<f.length;d++)i.push(r)}if(!t)break;r+=t[0].length}return{text:n,iconOffsets:i}}function m(o,n,i=!1){const{text:r,iconOffsets:s}=n;if(!s||s.length===0)return(0,u.$yk)(o,r,i);const t=(0,N.$af)(r," "),f=r.length-t.length,d=(0,u.$yk)(o,t,i);if(d)for(const l of d){const c=s[l.start+f]+f;l.start+=c,l.end+=c}return d}}),define(ke[127],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$1e=N,e.$2e=L;var u;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u||(e.Constants=u={}));function N(R){return R<0?0:R>255?255:R|0}function L(R){return R<0?0:R>4294967295?4294967295:R|0}}),define(ke[30],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=N;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return u.test(L)}e.$Mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(p){for(let b=0;b<p.length;b++)p[b]=Math.floor(Math.random()*256);return p};const R=new Uint8Array(16),M=[];for(let p=0;p<256;p++)M.push(p.toString(16).padStart(2,"0"));return function(){L(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let b=0,S="";return S+=M[R[b++]],S+=M[R[b++]],S+=M[R[b++]],S+=M[R[b++]],S+="-",S+=M[R[b++]],S+=M[R[b++]],S+="-",S+=M[R[b++]],S+=M[R[b++]],S+="-",S+=M[R[b++]],S+=M[R[b++]],S+="-",S+=M[R[b++]],S+=M[R[b++]],S+=M[R[b++]],S+=M[R[b++]],S+=M[R[b++]],S+=M[R[b++]],S}}()}),define(ke[172],Ee([1,0,19,45,30]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.$It=void 0,e.$Gt=R,e.$Ht=M,e.$Jt=S;function R(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}function M(P,$,E){const v={id:(0,L.$Mg)(),name:P,uri:$,data:E};return{asString:async()=>"",asFile:()=>v,value:void 0}}class p{constructor(){this.a=new Map}get size(){let $=0;for(const E of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const E=[...this.a.keys()];return N.Iterable.some(this,([v,a])=>a.asFile())&&E.push("files"),A(b($),E)}get($){return this.a.get(this.b($))?.[0]}append($,E){const v=this.a.get($);v?v.push(E):this.a.set(this.b($),[E])}replace($,E){this.a.set(this.b($),[E])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,E]of this.a)for(const v of E)yield[$,v]}b($){return b($)}}e.$It=p;function b(P){return P.toLowerCase()}function S(P,$){return A(b(P),$.map(b))}function A(P,$){if(P==="*/*")return $.length>0;if($.includes(P))return!0;const E=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[v,a,m]=E;return m==="*"?$.some(o=>o.startsWith(a+"/")):!1}e.$Kt=Object.freeze({create:P=>(0,u.$Mb)(P.map($=>$.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$Kt.split(P).filter($=>!$.startsWith("#"))})}),define(ke[173],Ee([1,0,63]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pg=void 0,e.$Og=N,e.$Qg=R;function N(p,b,S,A=1){let P=!1;return new Promise($=>{const E=setTimeout(()=>{if(!P)return P=!0,$(0)},S);L(p,b,A,v=>{if(!P)return P=!0,clearTimeout(E),$(v)})})}function L(p,b,S,A){if(b===0)return A(0);const P=new u.Socket;P.once("connect",()=>(M(P),L(p+S,b-1,S,A))),P.once("data",()=>{}),P.once("error",$=>(M(P),$.code!=="ECONNREFUSED"?L(p+S,b-1,S,A):A(p))),P.connect(p,"127.0.0.1")}e.$Pg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(p,b,S,A="127.0.0.1"){let P=!1,$,E=1;const v=u.createServer({pauseOnConnect:!0});function a(m,o){P||(P=!0,v.removeAllListeners(),v.close(),$&&clearTimeout($),o(m))}return new Promise(m=>{$=setTimeout(()=>{a(0,m)},S),v.on("listening",()=>{a(p,m)}),v.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&E<b?(p++,E++,v.listen(p,A)):a(0,m)}),v.on("close",()=>{a(0,m)}),v.listen(p,A)})}function M(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch(b){console.error(b)}}}),define(ke[128],Ee([1,0,127]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=e.$yt=void 0;class N{constructor(p){const b=(0,u.$1e)(p);this.c=b,this.a=N.d(b),this.b=new Map}static d(p){const b=new Uint8Array(256);return b.fill(p),b}set(p,b){const S=(0,u.$1e)(b);p>=0&&p<256?this.a[p]=S:this.b.set(p,S)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$yt=N;var L;(function(M){M[M.False=0]="False",M[M.True=1]="True"})(L||(L={}));class R{constructor(){this.a=new N(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}e.$zt=R}),define(ke[174],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Nt=N;var u;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(u||(e.StringEOL=u={}));function N(L){let R=0,M=0,p=0,b=0;for(let S=0,A=L.length;S<A;S++){const P=L.charCodeAt(S);P===13?(R===0&&(M=S),R++,S+1<A&&L.charCodeAt(S+1)===10?(b|=2,S++):b|=3,p=S+1):P===10&&(b|=1,R===0&&(M=S),R++,p=S+1)}return R===0&&(M=L.length),[R,M,L.length-p,b]}}),define(ke[50],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=void 0;class u{constructor(L,R){this.lineNumber=L,this.column=R}with(L=this.lineNumber,R=this.column){return L===this.lineNumber&&R===this.column?this:new u(L,R)}delta(L=0,R=0){return this.with(this.lineNumber+L,this.column+R)}equals(L){return u.equals(this,L)}static equals(L,R){return!L&&!R?!0:!!L&&!!R&&L.lineNumber===R.lineNumber&&L.column===R.column}isBefore(L){return u.isBefore(this,L)}static isBefore(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<R.column}isBeforeOrEqual(L){return u.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,R){return L.lineNumber<R.lineNumber?!0:R.lineNumber<L.lineNumber?!1:L.column<=R.column}static compare(L,R){const M=L.lineNumber|0,p=R.lineNumber|0;if(M===p){const b=L.column|0,S=R.column|0;return b-S}return M-p}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new u(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$jt=u}),define(ke[29],Ee([1,0,50]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0;class N{constructor(R,M,p,b){R>p||R===p&&M>b?(this.startLineNumber=p,this.startColumn=b,this.endLineNumber=R,this.endColumn=M):(this.startLineNumber=R,this.startColumn=M,this.endLineNumber=p,this.endColumn=b)}isEmpty(){return N.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return N.containsPosition(this,R)}static containsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<R.startColumn||M.lineNumber===R.endLineNumber&&M.column>R.endColumn)}static strictContainsPosition(R,M){return!(M.lineNumber<R.startLineNumber||M.lineNumber>R.endLineNumber||M.lineNumber===R.startLineNumber&&M.column<=R.startColumn||M.lineNumber===R.endLineNumber&&M.column>=R.endColumn)}containsRange(R){return N.containsRange(this,R)}static containsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>R.endColumn)}strictContainsRange(R){return N.strictContainsRange(this,R)}static strictContainsRange(R,M){return!(M.startLineNumber<R.startLineNumber||M.endLineNumber<R.startLineNumber||M.startLineNumber>R.endLineNumber||M.endLineNumber>R.endLineNumber||M.startLineNumber===R.startLineNumber&&M.startColumn<=R.startColumn||M.endLineNumber===R.endLineNumber&&M.endColumn>=R.endColumn)}plusRange(R){return N.plusRange(this,R)}static plusRange(R,M){let p,b,S,A;return M.startLineNumber<R.startLineNumber?(p=M.startLineNumber,b=M.startColumn):M.startLineNumber===R.startLineNumber?(p=M.startLineNumber,b=Math.min(M.startColumn,R.startColumn)):(p=R.startLineNumber,b=R.startColumn),M.endLineNumber>R.endLineNumber?(S=M.endLineNumber,A=M.endColumn):M.endLineNumber===R.endLineNumber?(S=M.endLineNumber,A=Math.max(M.endColumn,R.endColumn)):(S=R.endLineNumber,A=R.endColumn),new N(p,b,S,A)}intersectRanges(R){return N.intersectRanges(this,R)}static intersectRanges(R,M){let p=R.startLineNumber,b=R.startColumn,S=R.endLineNumber,A=R.endColumn;const P=M.startLineNumber,$=M.startColumn,E=M.endLineNumber,v=M.endColumn;return p<P?(p=P,b=$):p===P&&(b=Math.max(b,$)),S>E?(S=E,A=v):S===E&&(A=Math.min(A,v)),p>S||p===S&&b>A?null:new N(p,b,S,A)}equalsRange(R){return N.equalsRange(this,R)}static equalsRange(R,M){return!R&&!M?!0:!!R&&!!M&&R.startLineNumber===M.startLineNumber&&R.startColumn===M.startColumn&&R.endLineNumber===M.endLineNumber&&R.endColumn===M.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(R){return new u.$jt(R.endLineNumber,R.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(R){return new u.$jt(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,M){return new N(this.startLineNumber,this.startColumn,R,M)}setStartPosition(R,M){return new N(R,M,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(R){return new N(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(R){return new N(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new N(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,M=R){return new N(R.lineNumber,R.column,M.lineNumber,M.column)}static lift(R){return R?new N(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<R.startColumn)}static areIntersecting(R,M){return!(R.endLineNumber<M.startLineNumber||R.endLineNumber===M.startLineNumber&&R.endColumn<=M.startColumn||M.endLineNumber<R.startLineNumber||M.endLineNumber===R.startLineNumber&&M.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,M){if(R&&M){const S=R.startLineNumber|0,A=M.startLineNumber|0;if(S===A){const P=R.startColumn|0,$=M.startColumn|0;if(P===$){const E=R.endLineNumber|0,v=M.endLineNumber|0;if(E===v){const a=R.endColumn|0,m=M.endColumn|0;return a-m}return E-v}return P-$}return S-A}return(R?1:0)-(M?1:0)}static compareRangesUsingEnds(R,M){return R.endLineNumber===M.endLineNumber?R.endColumn===M.endColumn?R.startLineNumber===M.startLineNumber?R.startColumn-M.startColumn:R.startLineNumber-M.startLineNumber:R.endColumn-M.endColumn:R.endLineNumber-M.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$kt=N}),define(ke[175],Ee([1,0,29]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=void 0;class N{static insert(R,M){return{range:new u.$kt(R.lineNumber,R.column,R.lineNumber,R.column),text:M,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,M){return{range:R,text:M}}static replaceMove(R,M){return{range:R,text:M,forceMoveMarkers:!0}}}e.$lt=N}),define(ke[176],Ee([1,0,50,29]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.SelectionDirection=void 0;var L;(function(M){M[M.LTR=0]="LTR",M[M.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class R extends N.$kt{constructor(p,b,S,A){super(p,b,S,A),this.selectionStartLineNumber=p,this.selectionStartColumn=b,this.positionLineNumber=S,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return R.selectionsEqual(this,p)}static selectionsEqual(p,b){return p.selectionStartLineNumber===b.selectionStartLineNumber&&p.selectionStartColumn===b.selectionStartColumn&&p.positionLineNumber===b.positionLineNumber&&p.positionColumn===b.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,b){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,p,b):new R(p,b,this.startLineNumber,this.startColumn)}getPosition(){return new u.$jt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.$jt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,b){return this.getDirection()===0?new R(p,b,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,p,b)}static fromPositions(p,b=p){return new R(p.lineNumber,p.column,b.lineNumber,b.column)}static fromRange(p,b){return b===0?new R(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new R(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new R(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,b){if(p&&!b||!p&&b)return!1;if(!p&&!b)return!0;if(p.length!==b.length)return!1;for(let S=0,A=p.length;S<A;S++)if(!this.selectionsEqual(p[S],b[S]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,b,S,A,P){return P===0?new R(p,b,S,A):new R(S,A,p,b)}}e.$mt=R}),define(ke[177],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[178],Ee([1,0,27,128]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.WordCharacterClass=void 0,e.$Bt=p;var L;(function(b){b[b.Regular=0]="Regular",b[b.Whitespace=1]="Whitespace",b[b.WordSeparator=2]="WordSeparator"})(L||(e.WordCharacterClass=L={}));class R extends N.$yt{constructor(S,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let P=0,$=S.length;P<$;P++)this.set(S.charCodeAt(P),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(S,A){let P=null;for(const $ of this.h(S)){if($.index>A)break;P=$}return P}findNextIntlWordAtOrAfterOffset(S,A){for(const P of this.h(S))if(!(P.index<A))return P;return null}h(S){return this.e?this.f===S?this.g:(this.f=S,this.g=this.j(this.e.segment(S)),this.g):[]}j(S){const A=[];for(const P of S)this.k(P)&&A.push(P);return A}k(S){return!!S.isWordLike}}e.$At=R;const M=new u.$Ec(10);function p(b,S){const A=`${b}/${S.join(",")}`;let P=M.get(A);return P||(P=new R(b,S),M.set(A,P)),P}}),define(ke[129],Ee([1,0,45,3,75]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.$Vs=void 0,e.$Xs=M,e.$Ys=b,e.$Zs=S,e.$Vs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const E of e.$Vs)P.indexOf(E)>=0||($+="\\"+E);return $+="\\s]+)",new RegExp($,"g")}e.$Ws=R();function M(P){let $=e.$Ws;if(P&&P instanceof RegExp)if(P.global)$=P;else{let E="g";P.ignoreCase&&(E+="i"),P.multiline&&(E+="m"),P.unicode&&(E+="u"),$=new RegExp(P.source,E)}return $.lastIndex=0,$}const p=new L.$5c;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function b(P){const $=p.unshift(P);return(0,N.$Sc)($)}function S(P,$,E,v,a){if($=M($),a||(a=u.Iterable.first(p)),E.length>a.maxLen){let r=P-a.maxLen/2;return r<0?r=0:v+=r,E=E.substring(r,P+a.maxLen/2),S(P,$,E,v,a)}const m=Date.now(),o=P-1-v;let n=-1,i=null;for(let r=1;!(Date.now()-m>=a.timeBudget);r++){const s=o-a.windowSize*r;$.lastIndex=Math.max(0,s);const t=A($,E,o,n);if(!t&&i||(i=t,s<=0))break;n=s}if(i){const r={word:i[0],startColumn:v+1+i.index,endColumn:v+1+i.index+i[0].length};return $.lastIndex=0,r}return null}function A(P,$,E,v){let a;for(;a=P.exec($);){const m=a.index||0;if(m<=E&&P.lastIndex>=E)return a;if(v>0&&m>v)return null}return null}}),define(ke[179],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=e.$au=e.IndentAction=void 0;var u;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(u||(e.IndentAction=u={}));class N{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let b=0,S=p.notIn.length;b<S;b++)switch(p.notIn[b]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,b){if(p.getTokenCount()===0)return!0;const S=p.findTokenIndexAtOffset(b-2),A=p.getStandardTokenType(S);return this.isOK(A)}g(p,b){for(let S=p;S<=b;S++){const A=String.fromCharCode(S);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$au=N;class L{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of p)R(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),R(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),R(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),R(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&R(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.$bu=L;function R(M,p,b){M.has(p)?M.get(p).push(b):M.set(p,[b])}}),define(ke[180],Ee([1,0,128]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$22=e.$12=e.State=void 0,e.$32=$;var N;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class L{constructor(v,a,m){const o=new Uint8Array(v*a);for(let n=0,i=v*a;n<i;n++)o[n]=m;this.a=o,this.rows=v,this.cols=a}get(v,a){return this.a[v*this.cols+a]}set(v,a,m){this.a[v*this.cols+a]=m}}class R{constructor(v){let a=0,m=0;for(let n=0,i=v.length;n<i;n++){const[r,s,t]=v[n];s>a&&(a=s),r>m&&(m=r),t>m&&(m=t)}a++,m++;const o=new L(m,a,0);for(let n=0,i=v.length;n<i;n++){const[r,s,t]=v[n];o.set(r,s,t)}this.a=o,this.b=a}nextState(v,a){return a<0||a>=this.b?0:this.a.get(v,a)}}e.$12=R;let M=null;function p(){return M===null&&(M=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),M}var b;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(b||(b={}));let S=null;function A(){if(S===null){S=new u.$yt(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<E.length;a++)S.set(E.charCodeAt(a),1);const v=".,;:";for(let a=0;a<v.length;a++)S.set(v.charCodeAt(a),2)}return S}class P{static a(v,a,m,o,n){let i=n-1;do{const r=a.charCodeAt(i);if(v.get(r)!==2)break;i--}while(i>o);if(o>0){const r=a.charCodeAt(o-1),s=a.charCodeAt(i);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&i--}return{range:{startLineNumber:m,startColumn:o+1,endLineNumber:m,endColumn:i+2},url:a.substring(o,i+1)}}static computeLinks(v,a=p()){const m=A(),o=[];for(let n=1,i=v.getLineCount();n<=i;n++){const r=v.getLineContent(n),s=r.length;let t=0,f=0,d=0,l=1,c=!1,h=!1,g=!1,D=!1;for(;t<s;){let w=!1;const k=r.charCodeAt(t);if(l===13){let y;switch(k){case 40:c=!0,y=0;break;case 41:y=c?0:1;break;case 91:g=!0,h=!0,y=0;break;case 93:g=!1,y=h?0:1;break;case 123:D=!0,y=0;break;case 125:y=D?0:1;break;case 39:case 34:case 96:d===k?y=1:d===39||d===34||d===96?y=0:y=1;break;case 42:y=d===42?1:0;break;case 124:y=d===124?1:0;break;case 32:y=g?0:1;break;default:y=m.get(k)}y===1&&(o.push(P.a(m,r,n,f,t)),w=!0)}else if(l===12){let y;k===91?(h=!0,y=0):y=m.get(k),y===1?w=!0:l=13}else l=a.nextState(l,k),l===0&&(w=!0);w&&(l=1,c=!1,h=!1,D=!1,f=t+1,d=k),t++}l===13&&o.push(P.a(m,r,n,f,s))}return o}}e.$22=P;function $(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:P.computeLinks(E)}}),define(ke[79],Ee([1,0,24]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$vv=e.$uv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$wv=v,e.$Av=r;var N;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var L;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var R;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var M;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(M||(e.MinimapSectionHeaderStyle=M={}));var p;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(p||(e.InjectedTextCursorStops=p={}));var b;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var S;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(S||(e.DefaultEndOfLine=S={}));var A;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,u.$1n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$uv=P;class ${constructor(t,f){this._findMatchBrand=void 0,this.range=t,this.matches=f}}e.$vv=$;var E;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(E||(e.TrackedRangeStickiness=E={}));function v(s){return s&&typeof s.read=="function"}var a;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var m;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class o{constructor(t,f,d,l,c,h){this.identifier=t,this.range=f,this.text=d,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=c,this._isTracked=h}}e.$xv=o;class n{constructor(t,f,d){this.regex=t,this.wordSeparators=f,this.simpleSearch=d}}e.$yv=n;class i{constructor(t,f,d){this.reverseEdits=t,this.changes=f,this.trimAutoWhitespaceLineNumbers=d}}e.$zv=i;function r(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),define(ke[181],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rC=e.NodeColor=e.$qC=void 0,e.$sC=L,e.$tC=R,e.$uC=S,e.$vC=A,e.$wC=P,e.$xC=$,e.$yC=E,e.$zC=v;class u{constructor(m,o){this.piece=m,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$rC)return L(this.right);let m=this;for(;m.parent!==e.$rC&&m.parent.left!==m;)m=m.parent;return m.parent===e.$rC?e.$rC:m.parent}prev(){if(this.left!==e.$rC)return R(this.left);let m=this;for(;m.parent!==e.$rC&&m.parent.right!==m;)m=m.parent;return m.parent===e.$rC?e.$rC:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$qC=u;var N;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$rC=new u(null,0),e.$rC.parent=e.$rC,e.$rC.left=e.$rC,e.$rC.right=e.$rC,e.$rC.color=0;function L(a){for(;a.left!==e.$rC;)a=a.left;return a}function R(a){for(;a.right!==e.$rC;)a=a.right;return a}function M(a){return a===e.$rC?0:a.size_left+a.piece.length+M(a.right)}function p(a){return a===e.$rC?0:a.lf_left+a.piece.lineFeedCnt+p(a.right)}function b(){e.$rC.parent=e.$rC}function S(a,m){const o=m.right;o.size_left+=m.size_left+(m.piece?m.piece.length:0),o.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=o.left,o.left!==e.$rC&&(o.left.parent=m),o.parent=m.parent,m.parent===e.$rC?a.root=o:m.parent.left===m?m.parent.left=o:m.parent.right=o,o.left=m,m.parent=o}function A(a,m){const o=m.left;m.left=o.right,o.right!==e.$rC&&(o.right.parent=m),o.parent=m.parent,m.size_left-=o.size_left+(o.piece?o.piece.length:0),m.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),m.parent===e.$rC?a.root=o:m===m.parent.right?m.parent.right=o:m.parent.left=o,o.right=m,m.parent=o}function P(a,m){let o,n;if(m.left===e.$rC?(n=m,o=n.right):m.right===e.$rC?(n=m,o=n.left):(n=L(m.right),o=n.right),n===a.root){a.root=o,o.color=0,m.detach(),b(),a.root.parent=e.$rC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=o:n.parent.right=o,n===m?(o.parent=n.parent,v(a,o)):(n.parent===m?o.parent=n:o.parent=n.parent,v(a,o),n.left=m.left,n.right=m.right,n.parent=m.parent,n.color=m.color,m===a.root?a.root=n:m===m.parent.left?m.parent.left=n:m.parent.right=n,n.left!==e.$rC&&(n.left.parent=n),n.right!==e.$rC&&(n.right.parent=n),n.size_left=m.size_left,n.lf_left=m.lf_left,v(a,n)),m.detach(),o.parent.left===o){const s=M(o),t=p(o);if(s!==o.parent.size_left||t!==o.parent.lf_left){const f=s-o.parent.size_left,d=t-o.parent.lf_left;o.parent.size_left=s,o.parent.lf_left=t,E(a,o.parent,f,d)}}if(v(a,o.parent),i){b();return}let r;for(;o!==a.root&&o.color===0;)o===o.parent.left?(r=o.parent.right,r.color===1&&(r.color=0,o.parent.color=1,S(a,o.parent),r=o.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.right.color===0&&(r.left.color=0,r.color=1,A(a,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=0,r.right.color=0,S(a,o.parent),o=a.root)):(r=o.parent.left,r.color===1&&(r.color=0,o.parent.color=1,A(a,o.parent),r=o.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.left.color===0&&(r.right.color=0,r.color=1,S(a,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=0,r.left.color=0,A(a,o.parent),o=a.root));o.color=0,b()}function $(a,m){for(v(a,m);m!==a.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const o=m.parent.parent.right;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,S(a,m)),m.parent.color=0,m.parent.parent.color=1,A(a,m.parent.parent))}else{const o=m.parent.parent.left;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,A(a,m)),m.parent.color=0,m.parent.parent.color=1,S(a,m.parent.parent))}a.root.color=0}function E(a,m,o,n){for(;m!==a.root&&m!==e.$rC;)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=n),m=m.parent}function v(a,m){let o=0,n=0;if(m!==a.root){for(;m!==a.root&&m===m.parent.right;)m=m.parent;if(m!==a.root)for(m=m.parent,o=M(m.left)-m.size_left,n=p(m.left)-m.lf_left,m.size_left+=o,m.lf_left+=n;m!==a.root&&(o!==0||n!==0);)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=n),m=m.parent}}}),define(ke[182],Ee([1,0,19,127]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.$Mv=void 0;class L{constructor(b){this.a=b,this.b=new Uint32Array(b.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(b,S){b=(0,N.$2e)(b);const A=this.a,P=this.b,$=S.length;return $===0?!1:(this.a=new Uint32Array(A.length+$),this.a.set(A.subarray(0,b),0),this.a.set(A.subarray(b),b+$),this.a.set(S,b),b-1<this.c[0]&&(this.c[0]=b-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(b,S){return b=(0,N.$2e)(b),S=(0,N.$2e)(S),this.a[b]===S?!1:(this.a[b]=S,b-1<this.c[0]&&(this.c[0]=b-1),!0)}removeValues(b,S){b=(0,N.$2e)(b),S=(0,N.$2e)(S);const A=this.a,P=this.b;if(b>=A.length)return!1;const $=A.length-b;return S>=$&&(S=$),S===0?!1:(this.a=new Uint32Array(A.length-S),this.a.set(A.subarray(0,b),0),this.a.set(A.subarray(b+S),b),this.b=new Uint32Array(this.a.length),b-1<this.c[0]&&(this.c[0]=b-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(b){return b<0?0:(b=(0,N.$2e)(b),this.d(b))}d(b){if(b<=this.c[0])return this.b[b];let S=this.c[0]+1;S===0&&(this.b[0]=this.a[0],S++),b>=this.a.length&&(b=this.a.length-1);for(let A=S;A<=b;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],b),this.b[b]}getIndexOf(b){b=Math.floor(b),this.getTotalSum();let S=0,A=this.a.length-1,P=0,$=0,E=0;for(;S<=A;)if(P=S+(A-S)/2|0,$=this.b[P],E=$-this.a[P],b<E)A=P-1;else if(b>=$)S=P+1;else break;return new M(P,b-E)}}e.$Mv=L;class R{constructor(b){this.a=b,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(b){return this.g(),b===0?0:this.d[b-1]}getIndexOf(b){this.g();const S=this.e[b],A=S>0?this.d[S-1]:0;return new M(S,b-A)}removeValues(b,S){this.a.splice(b,S),this.f(b)}insertValues(b,S){this.a=(0,u.$Wb)(this.a,b,S),this.f(b)}f(b){this.b=!1,this.c=Math.min(this.c,b-1)}g(){if(!this.b){for(let b=this.c+1,S=this.a.length;b<S;b++){const A=this.a[b],P=b>0?this.d[b-1]:0;this.d[b]=P+A;for(let $=0;$<A;$++)this.e[P+$]=b}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(b,S){this.a[b]!==S&&(this.a[b]=S,this.f(b))}}e.$Nv=R;class M{constructor(b,S){this.index=b,this.remainder=S,this._prefixSumIndexOfResultBrand=void 0,this.index=b,this.remainder=S}}e.$Ov=M}),define(ke[183],Ee([1,0,14,50,182]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pv=void 0;class R{constructor(p,b,S,A){this.d=p,this.f=b,this.g=S,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(p){p.eol&&p.eol!==this.g&&(this.g=p.eol,this.j=null);const b=p.changes;for(const S of b)this.o(S.range),this.p(new N.$jt(S.range.startLineNumber,S.range.startColumn),S.text);this.h=p.versionId,this.k=null}l(){if(!this.j){const p=this.g.length,b=this.f.length,S=new Uint32Array(b);for(let A=0;A<b;A++)S[A]=this.f[A].length+p;this.j=new L.$Mv(S)}}n(p,b){this.f[p]=b,this.j&&this.j.setValue(p,this.f[p].length+this.g.length)}o(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.startLineNumber-1].substring(p.endColumn-1));return}this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.endLineNumber-1].substring(p.endColumn-1)),this.f.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this.j&&this.j.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}p(p,b){if(b.length===0)return;const S=(0,u.$gf)(b);if(S.length===1){this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+S[0]+this.f[p.lineNumber-1].substring(p.column-1));return}S[S.length-1]+=this.f[p.lineNumber-1].substring(p.column-1),this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+S[0]);const A=new Uint32Array(S.length-1);for(let P=1;P<S.length;P++)this.f.splice(p.lineNumber+P-1,0,S[P]),A[P-1]=S[P].length+this.g.length;this.j&&this.j.insertValues(p.lineNumber,A)}}e.$Pv=R}),define(ke[100],Ee([1,0,14,178,50,29,79]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FC=e.$DC=e.$AC=void 0,e.$BC=S,e.$CC=A,e.$EC=a;const p=999;class b{constructor(n,i,r,s){this.searchString=n,this.isRegex=i,this.matchCase=r,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=S(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=u.$ef(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let r=!this.isRegex&&!n;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new M.$yv(i,this.wordSeparators?(0,N.$Bt)(this.wordSeparators,[]):null,r?this.searchString:null)}}e.$AC=b;function S(o){if(!o||o.length===0)return!1;for(let n=0,i=o.length;n<i;n++){const r=o.charCodeAt(n);if(r===10)return!0;if(r===92){if(n++,n>=i)break;const s=o.charCodeAt(n);if(s===110||s===114||s===87)return!0}}return!1}function A(o,n,i){if(!i)return new M.$vv(o,null);const r=[];for(let s=0,t=n.length;s<t;s++)r[s]=n[s];return new M.$vv(o,r)}class P{constructor(n){const i=[];let r=0;for(let s=0,t=n.length;s<t;s++)n.charCodeAt(s)===10&&(i[r++]=s);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let r=0,s=i.length-1;if(s===-1||n<=i[0])return 0;for(;r<s;){const t=r+((s-r)/2>>0);i[t]>=n?s=t-1:i[t+1]>=n?(r=t,s=t):r=t+1}return r+1}}class ${static findMatches(n,i,r,s,t){const f=i.parseSearchRequest();return f?f.regex.multiline?this.b(n,r,new m(f.wordSeparators,f.regex),s,t):this.c(n,r,f,s,t):[]}static a(n,i,r,s,t,f){let d,l=0;s?(l=s.findLineFeedCountBeforeOffset(t),d=i+t+l):d=i+t;let c;if(s){const w=s.findLineFeedCountBeforeOffset(t+f.length)-l;c=d+f.length+w}else c=d+f.length;const h=n.getPositionAt(d),g=n.getPositionAt(c);return new R.$kt(h.lineNumber,h.column,g.lineNumber,g.column)}static b(n,i,r,s,t){const f=n.getOffsetAt(i.getStartPosition()),d=n.getValueInRange(i,1),l=n.getEOL()===`\r
`?new P(d):null,c=[];let h=0,g;for(r.reset(0);g=r.next(d);)if(c[h++]=A(this.a(n,f,d,l,g.index,g[0]),g,s),h>=t)return c;return c}static c(n,i,r,s,t){const f=[];let d=0;if(i.startLineNumber===i.endLineNumber){const c=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return d=this.d(r,c,i.startLineNumber,i.startColumn-1,d,f,s,t),f}const l=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);d=this.d(r,l,i.startLineNumber,i.startColumn-1,d,f,s,t);for(let c=i.startLineNumber+1;c<i.endLineNumber&&d<t;c++)d=this.d(r,n.getLineContent(c),c,0,d,f,s,t);if(d<t){const c=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);d=this.d(r,c,i.endLineNumber,0,d,f,s,t)}return f}static d(n,i,r,s,t,f,d,l){const c=n.wordSeparators;if(!d&&n.simpleSearch){const D=n.simpleSearch,w=D.length,k=i.length;let y=-w;for(;(y=i.indexOf(D,y+w))!==-1;)if((!c||a(c,i,k,y,w))&&(f[t++]=new M.$vv(new R.$kt(r,y+1+s,r,y+1+w+s),null),t>=l))return t;return t}const h=new m(n.wordSeparators,n.regex);let g;h.reset(0);do if(g=h.next(i),g&&(f[t++]=A(new R.$kt(r,g.index+1+s,r,g.index+1+g[0].length+s),g,d),t>=l))return t;while(g);return t}static findNextMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,r,f,s):this.f(n,r,f,s)}static e(n,i,r,s){const t=new L.$jt(i.lineNumber,1),f=n.getOffsetAt(t),d=n.getLineCount(),l=n.getValueInRange(new R.$kt(t.lineNumber,t.column,d,n.getLineMaxColumn(d)),1),c=n.getEOL()===`\r
`?new P(l):null;r.reset(i.column-1);const h=r.next(l);return h?A(this.a(n,f,l,c,h.index,h[0]),h,s):i.lineNumber!==1||i.column!==1?this.e(n,new L.$jt(1,1),r,s):null}static f(n,i,r,s){const t=n.getLineCount(),f=i.lineNumber,d=n.getLineContent(f),l=this.g(r,d,f,i.column,s);if(l)return l;for(let c=1;c<=t;c++){const h=(f+c-1)%t,g=n.getLineContent(h+1),D=this.g(r,g,h+1,1,s);if(D)return D}return null}static g(n,i,r,s,t){n.reset(s-1);const f=n.next(i);return f?A(new R.$kt(r,f.index+1,r,f.index+1+f[0].length),f,t):null}static findPreviousMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,r,f,s):this.j(n,r,f,s)}static h(n,i,r,s){const t=this.b(n,new R.$kt(1,1,i.lineNumber,i.column),r,s,10*p);if(t.length>0)return t[t.length-1];const f=n.getLineCount();return i.lineNumber!==f||i.column!==n.getLineMaxColumn(f)?this.h(n,new L.$jt(f,n.getLineMaxColumn(f)),r,s):null}static j(n,i,r,s){const t=n.getLineCount(),f=i.lineNumber,d=n.getLineContent(f).substring(0,i.column-1),l=this.k(r,d,f,s);if(l)return l;for(let c=1;c<=t;c++){const h=(t+f-c-1)%t,g=n.getLineContent(h+1),D=this.k(r,g,h+1,s);if(D)return D}return null}static k(n,i,r,s){let t=null,f;for(n.reset(0);f=n.next(i);)t=A(new R.$kt(r,f.index+1,r,f.index+1+f[0].length),f,s);return t}}e.$DC=$;function E(o,n,i,r,s){if(r===0)return!0;const t=n.charCodeAt(r-1);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=n.charCodeAt(r);if(o.get(f)!==0)return!0}return!1}function v(o,n,i,r,s){if(r+s===i)return!0;const t=n.charCodeAt(r+s);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=n.charCodeAt(r+s-1);if(o.get(f)!==0)return!0}return!1}function a(o,n,i,r,s){return E(o,n,i,r,s)&&v(o,n,i,r,s)}class m{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let r;do{if(this.b+this.c===i||(r=this.a.exec(n),!r))return null;const s=r.index,t=r[0].length;if(s===this.b&&t===this.c){if(t===0){u.$Af(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=t,!this._wordSeparators||a(this._wordSeparators,n,i,s,t))return r}while(r);return null}}e.$FC=m}),define(ke[130],Ee([1,0,50,29,79,181,100]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=e.$JC=e.$IC=void 0,e.$GC=A,e.$HC=P;const p=65535;function b(o){let n;return o[o.length-1]<65536?n=new Uint16Array(o.length):n=new Uint32Array(o.length),n.set(o,0),n}class S{constructor(n,i,r,s,t){this.lineStarts=n,this.cr=i,this.lf=r,this.crlf=s,this.isBasicASCII=t}}function A(o,n=!0){const i=[0];let r=1;for(let s=0,t=o.length;s<t;s++){const f=o.charCodeAt(s);f===13?s+1<t&&o.charCodeAt(s+1)===10?(i[r++]=s+2,s++):i[r++]=s+1:f===10&&(i[r++]=s+1)}return n?b(i):i}function P(o,n){o.length=0,o[0]=0;let i=1,r=0,s=0,t=0,f=!0;for(let l=0,c=n.length;l<c;l++){const h=n.charCodeAt(l);h===13?l+1<c&&n.charCodeAt(l+1)===10?(t++,o[i++]=l+2,l++):(r++,o[i++]=l+1):h===10?(s++,o[i++]=l+1):f&&h!==9&&(h<32||h>126)&&(f=!1)}const d=new S(b(o),r,s,t,f);return o.length=0,d}class ${constructor(n,i,r,s,t){this.bufferIndex=n,this.start=i,this.end=r,this.lineFeedCnt=s,this.length=t}}e.$IC=$;class E{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$JC=E;class v{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==R.$rC&&n.iterate(n.root,r=>(r!==R.$rC&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class a{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartOffset<=n&&r.nodeStartOffset+r.node.piece.length>=n)return r}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<n&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=n)return r}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const r=this.b;for(let s=0;s<r.length;s++){const t=r[s];if(t.node.parent===null||t.nodeStartOffset>=n){r[s]=null,i=!0;continue}}if(i){const s=[];for(const t of r)t!==null&&s.push(t);this.b=s}}}class m{constructor(n,i,r){this.create(n,i,r)}create(n,i,r){this.a=[new E("",[0])],this.g={line:0,column:0},this.root=R.$rC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=r;let s=null;for(let t=0,f=n.length;t<f;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const d=new $(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),s=this.S(s,d)}this.h=new a(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=p,r=i-Math.floor(i/3),s=r*2;let t="",f=0;const d=[];if(this.iterate(this.root,l=>{const c=this.R(l),h=c.length;if(f<=r||f+h<s)return t+=c,f+=h,!0;const g=t.replace(/\r\n|\r|\n/g,n);return d.push(new E(g,A(g))),t=c,f=h,!0}),f>0){const l=t.replace(/\r\n|\r|\n/g,n);d.push(new E(l,A(l)))}this.create(d,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,s=>{if(s===R.$rC)return!0;const t=this.R(s),f=t.length,d=n.G(i),l=n.G(i+f),c=n.getValueInRange2(d,l);return i+=f,t===c})}getOffsetAt(n,i){let r=0,s=this.root;for(;s!==R.$rC;)if(s.left!==R.$rC&&s.lf_left+1>=n)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=n){r+=s.size_left;const t=this.B(s,n-s.lf_left-2);return r+=t+i-1}else n-=s.lf_left+s.piece.lineFeedCnt,r+=s.size_left+s.piece.length,s=s.right;return r}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,r=0;const s=n;for(;i!==R.$rC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(r+=i.lf_left+t.index,t.index===0){const f=this.getOffsetAt(r+1,1),d=s-f;return new u.$jt(r+1,d+1)}return new u.$jt(r+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,r+=i.lf_left+i.piece.lineFeedCnt,i.right===R.$rC){const t=this.getOffsetAt(r+1,1),f=s-n-t;return new u.$jt(r+1,f+1)}else i=i.right;return new u.$jt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const r=this.H(n.startLineNumber,n.startColumn),s=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(r,s);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const d=n.node,l=this.a[d.piece.bufferIndex].buffer,c=this.u(d.piece.bufferIndex,d.piece.start);return l.substring(c+n.remainder,c+i.remainder)}let r=n.node;const s=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let f=s.substring(t+n.remainder,t+r.piece.length);for(r=r.next();r!==R.$rC;){const d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(r===i.node){f+=d.substring(l,l+i.remainder);break}else f+=d.substr(l,r.piece.length);r=r.next()}return f}getLinesContent(){const n=[];let i=0,r="",s=!1;return this.iterate(this.root,t=>{if(t===R.$rC)return!0;const f=t.piece;let d=f.length;if(d===0)return!0;const l=this.a[f.bufferIndex].buffer,c=this.a[f.bufferIndex].lineStarts,h=f.start.line,g=f.end.line;let D=c[h]+f.start.column;if(s&&(l.charCodeAt(D)===10&&(D++,d--),n[i++]=r,r="",s=!1,d===0))return!0;if(h===g)return!this.f&&l.charCodeAt(D+d-1)===13?(s=!0,r+=l.substr(D,d-1)):r+=l.substr(D,d),!0;r+=this.f?l.substring(D,Math.max(D,c[h+1]-this.e)):l.substring(D,c[h+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;for(let w=h+1;w<g;w++)r=this.f?l.substring(c[w],c[w+1]-this.e):l.substring(c[w],c[w+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;return!this.f&&l.charCodeAt(c[g]+f.end.column-1)===13?(s=!0,f.end.column===0?i--:r=l.substr(c[g],f.end.column-1)):r=l.substr(c[g],f.end.column),!0}),s&&(n[i++]=r,r=""),n[i++]=r,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const r=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start);return r.buffer.charCodeAt(s)}else{const i=this.a[n.node.piece.bufferIndex],s=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(s)}}getLineCharCode(n,i){const r=this.H(n,i+1);return this.l(r)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,r,s,t,f,d,l,c,h,g){const D=this.a[n.piece.bufferIndex],w=this.u(n.piece.bufferIndex,n.piece.start),k=this.u(n.piece.bufferIndex,t),y=this.u(n.piece.bufferIndex,f);let C;const I={line:0,column:0};let F,j;i._wordSeparators?(F=D.buffer.substring(k,y),j=z=>z+k,i.reset(0)):(F=D.buffer,j=z=>z,i.reset(k));do if(C=i.next(F),C){if(j(C.index)>=y)return h;this.s(n,j(C.index)-w,I);const z=this.t(n.piece.bufferIndex,t,I),O=I.line===t.line?I.column-t.column+s:I.column+1,T=O+C[0].length;if(g[h++]=(0,M.$CC)(new N.$kt(r+z,O,r+z,T),C,l),j(C.index)+C[0].length>=y||h>=c)return h}while(C);return h}findMatchesLineByLine(n,i,r,s){const t=[];let f=0;const d=new M.$FC(i.wordSeparators,i.regex);let l=this.H(n.startLineNumber,n.startColumn);if(l===null)return[];const c=this.H(n.endLineNumber,n.endColumn);if(c===null)return[];let h=this.s(l.node,l.remainder);const g=this.s(c.node,c.remainder);if(l.node===c.node)return this.findMatchesInNode(l.node,d,n.startLineNumber,n.startColumn,h,g,i,r,s,f,t),t;let D=n.startLineNumber,w=l.node;for(;w!==c.node;){const y=this.t(w.piece.bufferIndex,h,w.piece.end);if(y>=1){const I=this.a[w.piece.bufferIndex].lineStarts,F=this.u(w.piece.bufferIndex,w.piece.start),j=I[h.line+y],z=D===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode(w,d,D,z,h,this.s(w,j-F),i,r,s,f,t),f>=s)return t;D+=y}const C=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const I=this.getLineContent(D).substring(C,n.endColumn-1);return f=this.n(i,d,I,n.endLineNumber,C,f,t,r,s),t}if(f=this.n(i,d,this.getLineContent(D).substr(C),D,C,f,t,r,s),f>=s)return t;D++,l=this.H(D,1),w=l.node,h=this.s(l.node,l.remainder)}if(D===n.endLineNumber){const y=D===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(D).substring(y,n.endColumn-1);return f=this.n(i,d,C,n.endLineNumber,y,f,t,r,s),t}const k=D===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(c.node,d,D,k,h,g,i,r,s,f,t),t}n(n,i,r,s,t,f,d,l,c){const h=n.wordSeparators;if(!l&&n.simpleSearch){const D=n.simpleSearch,w=D.length,k=r.length;let y=-w;for(;(y=r.indexOf(D,y+w))!==-1;)if((!h||(0,M.$EC)(h,r,k,y,w))&&(d[f++]=new L.$vv(new N.$kt(s,y+1+t,s,y+1+w+t),null),f>=c))return f;return f}let g;i.reset(0);do if(g=i.next(r),g&&(d[f++]=(0,M.$CC)(new N.$kt(s,g.index+1+t,s,g.index+1+g[0].length+t),g,l),f>=c))return f;while(g);return f}insert(n,i,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==R.$rC){const{node:s,remainder:t,nodeStartOffset:f}=this.G(n),d=s.piece,l=d.bufferIndex,c=this.s(s,t);if(s.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&f+d.length===n&&i.length<p){this.F(s,i),this.y();return}if(f===n)this.o(i,s),this.h.validate(n);else if(f+s.piece.length>n){const h=[];let g=new $(d.bufferIndex,c,d.end,this.t(d.bufferIndex,c,d.end),this.u(l,d.end)-this.u(l,c));if(this.K()&&this.M(i)&&this.I(s,t)===10){const y={line:g.start.line+1,column:0};g=new $(g.bufferIndex,y,g.end,this.t(g.bufferIndex,y,g.end),g.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(s,t-1)===13){const y=this.s(s,t-1);this.C(s,y),i="\r"+i,s.piece.length===0&&h.push(s)}else this.C(s,c);else this.C(s,c);const D=this.w(i);g.length>0&&this.S(s,g);let w=s;for(let k=0;k<D.length;k++)w=this.S(w,D[k]);this.v(h)}else this.q(i,s)}else{const s=this.w(i);let t=this.T(null,s[0]);for(let f=1;f<s.length;f++)t=this.S(t,s[f])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===R.$rC)return;const r=this.G(n),s=this.G(n+i),t=r.node,f=s.node;if(t===f){const D=this.s(t,r.remainder),w=this.s(t,s.remainder);if(r.nodeStartOffset===n){if(i===t.piece.length){const k=t.next();(0,R.$wC)(this,t),this.N(k),this.y();return}this.D(t,w),this.h.validate(n),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,w),this.y();return}const d=[],l=this.s(t,r.remainder);this.C(t,l),this.h.validate(n),t.piece.length===0&&d.push(t);const c=this.s(f,s.remainder);this.D(f,c),f.piece.length===0&&d.push(f);const h=t.next();for(let D=h;D!==R.$rC&&D!==f;D=D.next())d.push(D);const g=t.piece.length===0?t.prev():t;this.v(d),this.O(g),this.y()}o(n,i){const r=[];if(this.K()&&this.M(n)&&this.L(i)){const f=i.piece,d={line:f.start.line+1,column:0},l=new $(f.bufferIndex,d,f.end,this.t(f.bufferIndex,d,f.end),f.length-1);i.piece=l,n+=`
`,(0,R.$yC)(this,i,-1,-1),i.piece.length===0&&r.push(i)}const s=this.w(n);let t=this.T(i,s[s.length-1]);for(let f=s.length-2;f>=0;f--)t=this.T(t,s[f]);this.N(t),this.v(r)}q(n,i){this.Q(n,i)&&(n+=`
`);const r=this.w(n),s=this.S(i,r[0]);let t=s;for(let f=1;f<r.length;f++)t=this.S(t,r[f]);this.N(s)}s(n,i,r){const s=n.piece,t=n.piece.bufferIndex,f=this.a[t].lineStarts,l=f[s.start.line]+s.start.column+i;let c=s.start.line,h=s.end.line,g=0,D=0,w=0;for(;c<=h&&(g=c+(h-c)/2|0,w=f[g],g!==h);)if(D=f[g+1],l<w)h=g-1;else if(l>=D)c=g+1;else break;return r?(r.line=g,r.column=l-w,null):{line:g,column:l-w}}t(n,i,r){if(r.column===0)return r.line-i.line;const s=this.a[n].lineStarts;if(r.line===s.length-1)return r.line-i.line;const t=s[r.line+1],f=s[r.line]+r.column;if(t>f+1)return r.line-i.line;const d=f-1;return this.a[n].buffer.charCodeAt(d)===13?r.line-i.line+1:r.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,R.$wC)(this,n[i])}w(n){if(n.length>p){const h=[];for(;n.length>p;){const D=n.charCodeAt(p-1);let w;D===13||D>=55296&&D<=56319?(w=n.substring(0,p-1),n=n.substring(p-1)):(w=n.substring(0,p),n=n.substring(p));const k=A(w);h.push(new $(this.a.length,{line:0,column:0},{line:k.length-1,column:w.length-k[k.length-1]},k.length-1,w.length)),this.a.push(new E(w,k))}const g=A(n);return h.push(new $(this.a.length,{line:0,column:0},{line:g.length-1,column:n.length-g[g.length-1]},g.length-1,n.length)),this.a.push(new E(n,g)),h}let i=this.a[0].buffer.length;const r=A(n,!1);let s=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},s=this.g;for(let h=0;h<r.length;h++)r[h]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let h=0;h<r.length;h++)r[h]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[f],l={line:f,column:d},c=new $(0,s,l,this.t(0,s,l),t-i);return this.g=l,[c]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let r=this.root,s="";const t=this.h.get2(n);if(t){r=t.node;const f=this.B(r,n-t.nodeStartLineNumber-1),d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===n)s=d.substring(l+f,l+r.piece.length);else{const c=this.B(r,n-t.nodeStartLineNumber);return d.substring(l+f,l+c-i)}}else{let f=0;const d=n;for(;r!==R.$rC;)if(r.left!==R.$rC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const l=this.B(r,n-r.lf_left-2),c=this.B(r,n-r.lf_left-1),h=this.a[r.piece.bufferIndex].buffer,g=this.u(r.piece.bufferIndex,r.piece.start);return f+=r.size_left,this.h.set({node:r,nodeStartOffset:f,nodeStartLineNumber:d-(n-1-r.lf_left)}),h.substring(g+l,g+c-i)}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const l=this.B(r,n-r.lf_left-2),c=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);s=c.substring(h+l,h+r.piece.length);break}else n-=r.lf_left+r.piece.lineFeedCnt,f+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==R.$rC;){const f=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const d=this.B(r,0),l=this.u(r.piece.bufferIndex,r.piece.start);return s+=f.substring(l,l+d-i),s}else{const d=this.u(r.piece.bufferIndex,r.piece.start);s+=f.substr(d,r.piece.length)}r=r.next()}return s}y(){let n=this.root,i=1,r=0;for(;n!==R.$rC;)i+=n.lf_left+n.piece.lineFeedCnt,r+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=r,this.h.validate(this.c)}A(n,i){const r=n.piece,s=this.s(n,i),t=s.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===i){const f=this.t(n.piece.bufferIndex,r.start,s);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:s.column}}B(n,i){if(i<0)return 0;const r=n.piece,s=this.a[r.bufferIndex].lineStarts,t=r.start.line+i+1;return t>r.end.line?s[r.end.line]+r.end.column-s[r.start.line]-r.start.column:s[t]-s[r.start.line]-r.start.column}C(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),f=i,d=this.u(r.bufferIndex,f),l=this.t(r.bufferIndex,r.start,f),c=l-s,h=d-t,g=r.length+h;n.piece=new $(r.bufferIndex,r.start,f,l,g),(0,R.$yC)(this,n,h,c)}D(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),f=i,d=this.t(r.bufferIndex,f,r.end),l=this.u(r.bufferIndex,f),c=d-s,h=t-l,g=r.length+h;n.piece=new $(r.bufferIndex,f,r.end,d,g),(0,R.$yC)(this,n,h,c)}E(n,i,r){const s=n.piece,t=s.start,f=s.end,d=s.length,l=s.lineFeedCnt,c=i,h=this.t(s.bufferIndex,s.start,c),g=this.u(s.bufferIndex,i)-this.u(s.bufferIndex,t);n.piece=new $(s.bufferIndex,s.start,c,h,g),(0,R.$yC)(this,n,g-d,h-l);const D=new $(s.bufferIndex,r,f,this.t(s.bufferIndex,r,f),this.u(s.bufferIndex,f)-this.u(s.bufferIndex,r)),w=this.S(n,D);this.N(w)}F(n,i){this.Q(i,n)&&(i+=`
`);const r=this.K()&&this.L(i)&&this.M(n),s=this.a[0].buffer.length;this.a[0].buffer+=i;const t=A(i,!1);for(let w=0;w<t.length;w++)t[w]+=s;if(r){const w=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:s-w}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[f],l={line:f,column:d},c=n.piece.length+i.length,h=n.piece.lineFeedCnt,g=this.t(0,n.piece.start,l),D=g-h;n.piece=new $(n.piece.bufferIndex,n.piece.start,l,g,c),this.g=l,(0,R.$yC)(this,n,i.length,D)}G(n){let i=this.root;const r=this.h.get(n);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:n-r.nodeStartOffset};let s=0;for(;i!==R.$rC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){s+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:s};return this.h.set(t),t}else n-=i.size_left+i.piece.length,s+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let r=this.root,s=0;for(;r!==R.$rC;)if(r.left!==R.$rC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const t=this.B(r,n-r.lf_left-2),f=this.B(r,n-r.lf_left-1);return s+=r.size_left,{node:r,remainder:Math.min(t+i-1,f),nodeStartOffset:s}}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const t=this.B(r,n-r.lf_left-2);if(t+i-1<=r.piece.length)return{node:r,remainder:t+i-1,nodeStartOffset:s};i-=r.piece.length-t;break}else n-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==R.$rC;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),f=this.J(r);return{node:r,remainder:Math.min(i-1,t),nodeStartOffset:f}}else if(r.piece.length>=i-1){const t=this.J(r);return{node:r,remainder:i-1,nodeStartOffset:t}}else i-=r.piece.length;r=r.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const r=this.a[n.piece.bufferIndex],s=this.u(n.piece.bufferIndex,n.piece.start)+i;return r.buffer.charCodeAt(s)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===R.$rC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,r=this.a[i.bufferIndex].lineStarts,s=i.start.line,t=r[s]+i.start.column;return s===r.length-1||r[s+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===R.$rC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const r=[],s=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:s[n.piece.end.line]-s[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,d=n.piece.lineFeedCnt-1;n.piece=new $(n.piece.bufferIndex,n.piece.start,t,d,f),(0,R.$yC)(this,n,-1,-1),n.piece.length===0&&r.push(n);const l={line:i.piece.start.line+1,column:0},c=i.piece.length-1,h=this.t(i.piece.bufferIndex,l,i.piece.end);i.piece=new $(i.piece.bufferIndex,l,i.piece.end,h,c),(0,R.$yC)(this,i,-1,-1),i.piece.length===0&&r.push(i);const g=this.w(`\r
`);this.S(n,g[0]);for(let D=0;D<r.length;D++)(0,R.$wC)(this,r[D])}Q(n,i){if(this.K()&&this.M(n)){const r=i.next();if(this.L(r)){if(n+=`
`,r.piece.length===1)(0,R.$wC)(this,r);else{const s=r.piece,t={line:s.start.line+1,column:0},f=s.length-1,d=this.t(s.bufferIndex,t,s.end);r.piece=new $(s.bufferIndex,t,s.end,d,f),(0,R.$yC)(this,r,-1,-1)}return!0}}return!1}iterate(n,i){if(n===R.$rC)return i(R.$rC);const r=this.iterate(n.left,i);return r&&i(n)&&this.iterate(n.right,i)}R(n){if(n===R.$rC)return"";const i=this.a[n.piece.bufferIndex],r=n.piece,s=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return i.buffer.substring(s,t)}getPieceContent(n){const i=this.a[n.bufferIndex],r=this.u(n.bufferIndex,n.start),s=this.u(n.bufferIndex,n.end);return i.buffer.substring(r,s)}S(n,i){const r=new R.$qC(i,1);if(r.left=R.$rC,r.right=R.$rC,r.parent=R.$rC,r.size_left=0,r.lf_left=0,this.root===R.$rC)this.root=r,r.color=0;else if(n.right===R.$rC)n.right=r,r.parent=n;else{const t=(0,R.$sC)(n.right);t.left=r,r.parent=t}return(0,R.$xC)(this,r),r}T(n,i){const r=new R.$qC(i,1);if(r.left=R.$rC,r.right=R.$rC,r.parent=R.$rC,r.size_left=0,r.lf_left=0,this.root===R.$rC)this.root=r,r.color=0;else if(n.left===R.$rC)n.left=r,r.parent=n;else{const s=(0,R.$tC)(n.left);s.right=r,r.parent=s}return(0,R.$xC)(this,r),r}U(n){let i="";return this.iterate(n,r=>(i+=this.R(r),!0)),i}}e.$KC=m}),define(ke[184],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N0=e.$M0=void 0;class u{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const M=this.a.get(R);return this.a.delete(R),M}}addDragOperationTransfer(R,M){this.a.set(R,M)}}e.$M0=u;class N{constructor(R){this.identifier=R}}e.$N0=N}),define(ke[185],Ee([1,0,4,3]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mt=void 0;class L{constructor(){this.a=new Map,this.b=new Map,this.c=new u.$be,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,b){return this.a.set(p,b),this.handleChange([p]),(0,N.$Sc)(()=>{this.a.get(p)===b&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,b){this.b.get(p)?.dispose();const S=new R(this,p,b);return this.b.set(p,S),(0,N.$Sc)(()=>{const A=this.b.get(p);!A||A!==S||(this.b.delete(p),A.dispose())})}async getOrCreate(p){const b=this.get(p);if(b)return b;const S=this.b.get(p);return!S||S.isResolved?null:(await S.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const S=this.b.get(p);return!!(!S||S.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Mt=L;class R extends N.$Uc{get isResolved(){return this.c}constructor(p,b,S){super(),this.f=p,this.g=b,this.h=S,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(ke[186],Ee([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(ke[187],Ee([1,0,4,3,186]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=void 0,e.$aj=A;class R extends N.$Uc{constructor($,E="",v="",a=!0,m){super(),this.h=this.B(new u.$be),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=E,this.u=v,this.w=a,this.C=m}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,E){this.C&&await this.C($)}}e.$8i=R;class M extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new u.$be),this.onWillRun=this.f.event,this.m=this.B(new u.$be),this.onDidRun=this.m.event}async run($,E){if(!$.enabled)return;this.f.fire({action:$});let v;try{await this.u($,E)}catch(a){v=a}this.m.fire({action:$,error:v})}async u($,E){await $.run(E)}}e.$9i=M;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let E=[];for(const v of $)v.length&&(E.length?E=[...E,new p,...v]:E=v);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$0i=p;class b{get actions(){return this.a}constructor($,E,v,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=E,this.class=a,this.a=v}async run(){}}e.$$i=b;class S extends R{static{this.ID="vs.actions.empty"}constructor(){super(S.ID,L.localize(0,null),void 0,!1)}}e.$_i=S;function A(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...$)=>P.run(...$),tooltip:P.label}}}),define(ke[188],Ee([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(ke[189],Ee([1,0,188]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=S,e.$Wm=A,e.$Xm=P;const N=60,L=N*60,R=L*24,M=R*7,p=R*30,b=R*365;function S($,E,v,a){typeof $!="number"&&($=$.getTime());const m=Math.round((new Date().getTime()-$)/1e3);if(m<-30)return(0,u.localize)(0,null,S(new Date().getTime()+m*1e3,!1));if(!a&&m<30)return(0,u.localize)(1,null);let o;return m<N?(o=m,E?o===1?v?(0,u.localize)(2,null,o):(0,u.localize)(3,null,o):v?(0,u.localize)(4,null,o):(0,u.localize)(5,null,o):o===1?v?(0,u.localize)(6,null,o):(0,u.localize)(7,null,o):v?(0,u.localize)(8,null,o):(0,u.localize)(9,null,o)):m<L?(o=Math.floor(m/N),E?o===1?v?(0,u.localize)(10,null,o):(0,u.localize)(11,null,o):v?(0,u.localize)(12,null,o):(0,u.localize)(13,null,o):o===1?v?(0,u.localize)(14,null,o):(0,u.localize)(15,null,o):v?(0,u.localize)(16,null,o):(0,u.localize)(17,null,o)):m<R?(o=Math.floor(m/L),E?o===1?v?(0,u.localize)(18,null,o):(0,u.localize)(19,null,o):v?(0,u.localize)(20,null,o):(0,u.localize)(21,null,o):o===1?v?(0,u.localize)(22,null,o):(0,u.localize)(23,null,o):v?(0,u.localize)(24,null,o):(0,u.localize)(25,null,o)):m<M?(o=Math.floor(m/R),E?o===1?(0,u.localize)(26,null,o):(0,u.localize)(27,null,o):o===1?(0,u.localize)(28,null,o):(0,u.localize)(29,null,o)):m<p?(o=Math.floor(m/M),E?o===1?v?(0,u.localize)(30,null,o):(0,u.localize)(31,null,o):v?(0,u.localize)(32,null,o):(0,u.localize)(33,null,o):o===1?v?(0,u.localize)(34,null,o):(0,u.localize)(35,null,o):v?(0,u.localize)(36,null,o):(0,u.localize)(37,null,o)):m<b?(o=Math.floor(m/p),E?o===1?v?(0,u.localize)(38,null,o):(0,u.localize)(39,null,o):v?(0,u.localize)(40,null,o):(0,u.localize)(41,null,o):o===1?v?(0,u.localize)(42,null,o):(0,u.localize)(43,null,o):v?(0,u.localize)(44,null,o):(0,u.localize)(45,null,o)):(o=Math.floor(m/b),E?o===1?v?(0,u.localize)(46,null,o):(0,u.localize)(47,null,o):v?(0,u.localize)(48,null,o):(0,u.localize)(49,null,o):o===1?v?(0,u.localize)(50,null,o):(0,u.localize)(51,null,o):v?(0,u.localize)(52,null,o):(0,u.localize)(53,null,o))}function A($,E){const v=Math.abs($/1e3);return v<1?E?(0,u.localize)(54,null,$):(0,u.localize)(55,null,$):v<N?E?(0,u.localize)(56,null,Math.round($)/1e3):(0,u.localize)(57,null,Math.round($)/1e3):v<L?E?(0,u.localize)(58,null,Math.round($/(1e3*N))):(0,u.localize)(59,null,Math.round($/(1e3*N))):v<R?E?(0,u.localize)(60,null,Math.round($/(1e3*L))):(0,u.localize)(61,null,Math.round($/(1e3*L))):(0,u.localize)(62,null,Math.round($/(1e3*R)))}function P($){return $.getFullYear()+"-"+String($.getMonth()+1).padStart(2,"0")+"-"+String($.getDate()).padStart(2,"0")+"T"+String($.getHours()).padStart(2,"0")+":"+String($.getMinutes()).padStart(2,"0")+":"+String($.getSeconds()).padStart(2,"0")+"."+($.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[190],Ee([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(ke[47],Ee([1,0,19,18,190]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=b,e.$cj=S,e.$dj=A;function R(P,$){return $&&(P.stack||P.stacktrace)?L.localize(0,null,p(P),M(P.stack)||M(P.stacktrace)):p(P)}function M(P){return Array.isArray(P)?P.join(`
`):P}function p(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?L.localize(1,null,P.message):P.message||L.localize(2,null)}function b(P=null,$=!1){if(!P)return L.localize(3,null);if(Array.isArray(P)){const E=u.$Hb(P),v=b(E[0],$);return E.length>1?L.localize(4,null,v,E.length):v}if(N.$4f(P))return P;if(P.detail){const E=P.detail;if(E.error)return R(E.error,$);if(E.exception)return R(E.exception,$)}return P.stack?R(P,$):P.message?P.message:L.localize(5,null)}function S(P){const $=P;return $ instanceof Error&&Array.isArray($.actions)}function A(P,$){let E;return typeof P=="string"?E=new Error(P):E=P,E.actions=$,E}}),define(ke[191],Ee([9,10]),function(le,e){return le.create("vs/base/common/platform",e)}),define(ke[11],Ee([1,0,191]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=f,e.$D=D,e.$J=w,e.$g="en";let N=!1,L=!1,R=!1,M=!1,p=!1,b=!1,S=!1,A=!1,P=!1,$=!1,E,v=e.$g,a=e.$g,m,o;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const r=typeof i?.versions?.electron=="string",s=r&&i?.type==="renderer";if(typeof i=="object"){N=i.platform==="win32",L=i.platform==="darwin",R=i.platform==="linux",M=R&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,S=r,P=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.$g,v=e.$g;const k=i.env.VSCODE_NLS_CONFIG;if(k)try{const y=JSON.parse(k),C=y.availableLanguages["*"];E=y.locale,a=y.osLocale,v=C||e.$g,m=y._translationsConfigFile}catch{}p=!0}else typeof navigator=="object"&&!s?(o=navigator.userAgent,N=o.indexOf("Windows")>=0,L=o.indexOf("Macintosh")>=0,A=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=o.indexOf("Linux")>=0,$=o?.indexOf("Mobi")>=0,b=!0,E=u.getConfiguredDefaultLocale(u.localize(0,null))||e.$g,v=E,a=navigator.language):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function f(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let d=0;L?d=1:N?d=3:R&&(d=2),e.$i=N,e.$j=L,e.$k=R,e.$l=M,e.$m=p,e.$n=S,e.$o=b,e.$p=b&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=A,e.$s=$,e.$t=P,e.$u=d,e.$v=o,e.$w=v;var l;(function(k){function y(){return e.$w}k.value=y;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=C;function I(){return e.$w==="en"}k.isDefault=I})(l||(e.Language=l={})),e.$x=E,e.$y=a,e.$z=m,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const k=[];n.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let I=0,F=k.length;I<F;I++){const j=k[I];if(j.id===C.data.vscodeScheduleAsyncWork){k.splice(I,1),j.callback();return}}});let y=0;return C=>{const I=++y;k.push({id:I,callback:C}),n.postMessage({vscodeScheduleAsyncWork:I},"*")}}return k=>setTimeout(k)})();var c;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=L||A?2:N?1:3;let h=!0,g=!1;function D(){if(!g){g=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,h=new Uint16Array(k.buffer)[0]===513}return h}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(k){return parseFloat(k)>=20}}),define(ke[51],Ee([1,0,11]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const R=L.process;N={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return u.$i?"win32":u.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$ec=N.platform,e.$fc=N.arch}),define(ke[17],Ee([1,0,51]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const N=65,L=97,R=90,M=122,p=46,b=47,S=92,A=58,P=63;class $ extends Error{constructor(f,d,l){let c;typeof d=="string"&&d.indexOf("not ")===0?(c="must not be",d=d.replace(/^not /,"")):c="must be";const h=f.indexOf(".")!==-1?"property":"argument";let g=`The "${f}" ${h} ${c} of type ${d}`;g+=`. Received type ${typeof l}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function E(t,f){if(t===null||typeof t!="object")throw new $(f,"Object",t)}function v(t,f){if(typeof t!="string")throw new $(f,"string",t)}const a=u.$ec==="win32";function m(t){return t===b||t===S}function o(t){return t===b}function n(t){return t>=N&&t<=R||t>=L&&t<=M}function i(t,f,d,l){let c="",h=0,g=-1,D=0,w=0;for(let k=0;k<=t.length;++k){if(k<t.length)w=t.charCodeAt(k);else{if(l(w))break;w=b}if(l(w)){if(!(g===k-1||D===1))if(D===2){if(c.length<2||h!==2||c.charCodeAt(c.length-1)!==p||c.charCodeAt(c.length-2)!==p){if(c.length>2){const y=c.lastIndexOf(d);y===-1?(c="",h=0):(c=c.slice(0,y),h=c.length-1-c.lastIndexOf(d)),g=k,D=0;continue}else if(c.length!==0){c="",h=0,g=k,D=0;continue}}f&&(c+=c.length>0?`${d}..`:"..",h=2)}else c.length>0?c+=`${d}${t.slice(g+1,k)}`:c=t.slice(g+1,k),h=k-g-1;g=k,D=0}else w===p&&D!==-1?++D:D=-1}return c}function r(t,f){E(f,"pathObject");const d=f.dir||f.root,l=f.base||`${f.name||""}${f.ext||""}`;return d?d===f.root?`${d}${l}`:`${d}${t}${l}`:l}e.$gc={resolve(...t){let f="",d="",l=!1;for(let c=t.length-1;c>=-1;c--){let h;if(c>=0){if(h=t[c],v(h,"path"),h.length===0)continue}else f.length===0?h=u.cwd():(h=u.env[`=${f}`]||u.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==f.toLowerCase()&&h.charCodeAt(2)===S)&&(h=`${f}\\`));const g=h.length;let D=0,w="",k=!1;const y=h.charCodeAt(0);if(g===1)m(y)&&(D=1,k=!0);else if(m(y))if(k=!0,m(h.charCodeAt(1))){let C=2,I=C;for(;C<g&&!m(h.charCodeAt(C));)C++;if(C<g&&C!==I){const F=h.slice(I,C);for(I=C;C<g&&m(h.charCodeAt(C));)C++;if(C<g&&C!==I){for(I=C;C<g&&!m(h.charCodeAt(C));)C++;(C===g||C!==I)&&(w=`\\\\${F}\\${h.slice(I,C)}`,D=C)}}}else D=1;else n(y)&&h.charCodeAt(1)===A&&(w=h.slice(0,2),D=2,g>2&&m(h.charCodeAt(2))&&(k=!0,D=3));if(w.length>0)if(f.length>0){if(w.toLowerCase()!==f.toLowerCase())continue}else f=w;if(l){if(f.length>0)break}else if(d=`${h.slice(D)}\\${d}`,l=k,k&&f.length>0)break}return d=i(d,!l,"\\",m),l?`${f}\\${d}`:`${f}${d}`||"."},normalize(t){v(t,"path");const f=t.length;if(f===0)return".";let d=0,l,c=!1;const h=t.charCodeAt(0);if(f===1)return o(h)?"\\":t;if(m(h))if(c=!0,m(t.charCodeAt(1))){let D=2,w=D;for(;D<f&&!m(t.charCodeAt(D));)D++;if(D<f&&D!==w){const k=t.slice(w,D);for(w=D;D<f&&m(t.charCodeAt(D));)D++;if(D<f&&D!==w){for(w=D;D<f&&!m(t.charCodeAt(D));)D++;if(D===f)return`\\\\${k}\\${t.slice(w)}\\`;D!==w&&(l=`\\\\${k}\\${t.slice(w,D)}`,d=D)}}}else d=1;else n(h)&&t.charCodeAt(1)===A&&(l=t.slice(0,2),d=2,f>2&&m(t.charCodeAt(2))&&(c=!0,d=3));let g=d<f?i(t.slice(d),!c,"\\",m):"";return g.length===0&&!c&&(g="."),g.length>0&&m(t.charCodeAt(f-1))&&(g+="\\"),l===void 0?c?`\\${g}`:g:c?`${l}\\${g}`:`${l}${g}`},isAbsolute(t){v(t,"path");const f=t.length;if(f===0)return!1;const d=t.charCodeAt(0);return m(d)||f>2&&n(d)&&t.charCodeAt(1)===A&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let f,d;for(let h=0;h<t.length;++h){const g=t[h];v(g,"path"),g.length>0&&(f===void 0?f=d=g:f+=`\\${g}`)}if(f===void 0)return".";let l=!0,c=0;if(typeof d=="string"&&m(d.charCodeAt(0))){++c;const h=d.length;h>1&&m(d.charCodeAt(1))&&(++c,h>2&&(m(d.charCodeAt(2))?++c:l=!1))}if(l){for(;c<f.length&&m(f.charCodeAt(c));)c++;c>=2&&(f=`\\${f.slice(c)}`)}return e.$gc.normalize(f)},relative(t,f){if(v(t,"from"),v(f,"to"),t===f)return"";const d=e.$gc.resolve(t),l=e.$gc.resolve(f);if(d===l||(t=d.toLowerCase(),f=l.toLowerCase(),t===f))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===S;)c++;let h=t.length;for(;h-1>c&&t.charCodeAt(h-1)===S;)h--;const g=h-c;let D=0;for(;D<f.length&&f.charCodeAt(D)===S;)D++;let w=f.length;for(;w-1>D&&f.charCodeAt(w-1)===S;)w--;const k=w-D,y=g<k?g:k;let C=-1,I=0;for(;I<y;I++){const j=t.charCodeAt(c+I);if(j!==f.charCodeAt(D+I))break;j===S&&(C=I)}if(I!==y){if(C===-1)return l}else{if(k>y){if(f.charCodeAt(D+I)===S)return l.slice(D+I+1);if(I===2)return l.slice(D+I)}g>y&&(t.charCodeAt(c+I)===S?C=I:I===2&&(C=3)),C===-1&&(C=0)}let F="";for(I=c+C+1;I<=h;++I)(I===h||t.charCodeAt(I)===S)&&(F+=F.length===0?"..":"\\..");return D+=C,F.length>0?`${F}${l.slice(D,w)}`:(l.charCodeAt(D)===S&&++D,l.slice(D,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const f=e.$gc.resolve(t);if(f.length<=2)return t;if(f.charCodeAt(0)===S){if(f.charCodeAt(1)===S){const d=f.charCodeAt(2);if(d!==P&&d!==p)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(n(f.charCodeAt(0))&&f.charCodeAt(1)===A&&f.charCodeAt(2)===S)return`\\\\?\\${f}`;return t},dirname(t){v(t,"path");const f=t.length;if(f===0)return".";let d=-1,l=0;const c=t.charCodeAt(0);if(f===1)return m(c)?t:".";if(m(c)){if(d=l=1,m(t.charCodeAt(1))){let D=2,w=D;for(;D<f&&!m(t.charCodeAt(D));)D++;if(D<f&&D!==w){for(w=D;D<f&&m(t.charCodeAt(D));)D++;if(D<f&&D!==w){for(w=D;D<f&&!m(t.charCodeAt(D));)D++;if(D===f)return t;D!==w&&(d=l=D+1)}}}}else n(c)&&t.charCodeAt(1)===A&&(d=f>2&&m(t.charCodeAt(2))?3:2,l=d);let h=-1,g=!0;for(let D=f-1;D>=l;--D)if(m(t.charCodeAt(D))){if(!g){h=D;break}}else g=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,f){f!==void 0&&v(f,"ext"),v(t,"path");let d=0,l=-1,c=!0,h;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let g=f.length-1,D=-1;for(h=t.length-1;h>=d;--h){const w=t.charCodeAt(h);if(m(w)){if(!c){d=h+1;break}}else D===-1&&(c=!1,D=h+1),g>=0&&(w===f.charCodeAt(g)?--g===-1&&(l=h):(g=-1,l=D))}return d===l?l=D:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=d;--h)if(m(t.charCodeAt(h))){if(!c){d=h+1;break}}else l===-1&&(c=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){v(t,"path");let f=0,d=-1,l=0,c=-1,h=!0,g=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(f=l=2);for(let D=t.length-1;D>=f;--D){const w=t.charCodeAt(D);if(m(w)){if(!h){l=D+1;break}continue}c===-1&&(h=!1,c=D+1),w===p?d===-1?d=D:g!==1&&(g=1):d!==-1&&(g=-1)}return d===-1||c===-1||g===0||g===1&&d===c-1&&d===l+1?"":t.slice(d,c)},format:r.bind(null,"\\"),parse(t){v(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const d=t.length;let l=0,c=t.charCodeAt(0);if(d===1)return m(c)?(f.root=f.dir=t,f):(f.base=f.name=t,f);if(m(c)){if(l=1,m(t.charCodeAt(1))){let C=2,I=C;for(;C<d&&!m(t.charCodeAt(C));)C++;if(C<d&&C!==I){for(I=C;C<d&&m(t.charCodeAt(C));)C++;if(C<d&&C!==I){for(I=C;C<d&&!m(t.charCodeAt(C));)C++;C===d?l=C:C!==I&&(l=C+1)}}}}else if(n(c)&&t.charCodeAt(1)===A){if(d<=2)return f.root=f.dir=t,f;if(l=2,m(t.charCodeAt(2))){if(d===3)return f.root=f.dir=t,f;l=3}}l>0&&(f.root=t.slice(0,l));let h=-1,g=l,D=-1,w=!0,k=t.length-1,y=0;for(;k>=l;--k){if(c=t.charCodeAt(k),m(c)){if(!w){g=k+1;break}continue}D===-1&&(w=!1,D=k+1),c===p?h===-1?h=k:y!==1&&(y=1):h!==-1&&(y=-1)}return D!==-1&&(h===-1||y===0||y===1&&h===D-1&&h===g+1?f.base=f.name=t.slice(g,D):(f.name=t.slice(g,h),f.base=t.slice(g,D),f.ext=t.slice(h,D))),g>0&&g!==l?f.dir=t.slice(0,g-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(a){const t=/\\/g;return()=>{const f=u.cwd().replace(t,"/");return f.slice(f.indexOf("/"))}}return()=>u.cwd()})();e.$hc={resolve(...t){let f="",d=!1;for(let l=t.length-1;l>=-1&&!d;l--){const c=l>=0?t[l]:s();v(c,"path"),c.length!==0&&(f=`${c}/${f}`,d=c.charCodeAt(0)===b)}return f=i(f,!d,"/",o),d?`/${f}`:f.length>0?f:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===b,d=t.charCodeAt(t.length-1)===b;return t=i(t,!f,"/",o),t.length===0?f?"/":d?"./":".":(d&&(t+="/"),f?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let f;for(let d=0;d<t.length;++d){const l=t[d];v(l,"path"),l.length>0&&(f===void 0?f=l:f+=`/${l}`)}return f===void 0?".":e.$hc.normalize(f)},relative(t,f){if(v(t,"from"),v(f,"to"),t===f||(t=e.$hc.resolve(t),f=e.$hc.resolve(f),t===f))return"";const d=1,l=t.length,c=l-d,h=1,g=f.length-h,D=c<g?c:g;let w=-1,k=0;for(;k<D;k++){const C=t.charCodeAt(d+k);if(C!==f.charCodeAt(h+k))break;C===b&&(w=k)}if(k===D)if(g>D){if(f.charCodeAt(h+k)===b)return f.slice(h+k+1);if(k===0)return f.slice(h+k)}else c>D&&(t.charCodeAt(d+k)===b?w=k:k===0&&(w=0));let y="";for(k=d+w+1;k<=l;++k)(k===l||t.charCodeAt(k)===b)&&(y+=y.length===0?"..":"/..");return`${y}${f.slice(h+w)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===b;let d=-1,l=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===b){if(!l){d=c;break}}else l=!1;return d===-1?f?"/":".":f&&d===1?"//":t.slice(0,d)},basename(t,f){f!==void 0&&v(f,"ext"),v(t,"path");let d=0,l=-1,c=!0,h;if(f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let g=f.length-1,D=-1;for(h=t.length-1;h>=0;--h){const w=t.charCodeAt(h);if(w===b){if(!c){d=h+1;break}}else D===-1&&(c=!1,D=h+1),g>=0&&(w===f.charCodeAt(g)?--g===-1&&(l=h):(g=-1,l=D))}return d===l?l=D:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===b){if(!c){d=h+1;break}}else l===-1&&(c=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){v(t,"path");let f=-1,d=0,l=-1,c=!0,h=0;for(let g=t.length-1;g>=0;--g){const D=t.charCodeAt(g);if(D===b){if(!c){d=g+1;break}continue}l===-1&&(c=!1,l=g+1),D===p?f===-1?f=g:h!==1&&(h=1):f!==-1&&(h=-1)}return f===-1||l===-1||h===0||h===1&&f===l-1&&f===d+1?"":t.slice(f,l)},format:r.bind(null,"/"),parse(t){v(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const d=t.charCodeAt(0)===b;let l;d?(f.root="/",l=1):l=0;let c=-1,h=0,g=-1,D=!0,w=t.length-1,k=0;for(;w>=l;--w){const y=t.charCodeAt(w);if(y===b){if(!D){h=w+1;break}continue}g===-1&&(D=!1,g=w+1),y===p?c===-1?c=w:k!==1&&(k=1):c!==-1&&(k=-1)}if(g!==-1){const y=h===0&&d?1:h;c===-1||k===0||k===1&&c===g-1&&c===h+1?f.base=f.name=t.slice(y,g):(f.name=t.slice(y,c),f.base=t.slice(y,g),f.ext=t.slice(c,g))}return h>0?f.dir=t.slice(0,h-1):d&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=a?e.$gc.normalize:e.$hc.normalize,e.$jc=a?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=a?e.$gc.join:e.$hc.join,e.$lc=a?e.$gc.resolve:e.$hc.resolve,e.$mc=a?e.$gc.relative:e.$hc.relative,e.$nc=a?e.$gc.dirname:e.$hc.dirname,e.$oc=a?e.$gc.basename:e.$hc.basename,e.$pc=a?e.$gc.extname:e.$hc.extname,e.$qc=a?e.$gc.format:e.$hc.format,e.$rc=a?e.$gc.parse:e.$hc.parse,e.$sc=a?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=a?e.$gc.sep:e.$hc.sep,e.$uc=a?e.$gc.delimiter:e.$hc.delimiter}),define(ke[131],Ee([1,0,46,17]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=p,e.$_q=b,e.$ar=S,e.$br=A,e.$cr=P,e.$dr=$,e.$er=E,e.$fr=v,e.$gr=a,e.$hr=m,e.$ir=c,e.$jr=h,e.$kr=g;const L=new u.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(D,w,k=!1){const y=D||"",C=w||"",I=L.value.collator.compare(y,C);return L.value.collatorIsNumeric&&I===0&&y!==C?y<C?-1:1:I}function b(D,w){const k=R.value.collator;return D=D||"",w=w||"",r(k,D,w)}function S(D,w){const k=R.value.collator;return D=D||"",w=w||"",d(D,w)||r(k,D,w)}function A(D,w){const k=R.value.collator;return D=D||"",w=w||"",f(D,w)||r(k,D,w)}function P(D,w){return D=D||"",w=w||"",D===w?0:D<w?-1:1}function $(D,w){const[k,y]=n(D),[C,I]=n(w);let F=L.value.collator.compare(y,I);if(F===0){if(L.value.collatorIsNumeric&&y!==I)return y<I?-1:1;if(F=L.value.collator.compare(k,C),L.value.collatorIsNumeric&&F===0&&k!==C)return k<C?-1:1}return F}function E(D,w){D=D||"",w=w||"";const k=i(D),y=i(w),C=R.value.collator,I=M.value.collator;return r(I,k,y)||r(C,D,w)}function v(D,w){D=D||"",w=w||"";const k=i(D),y=i(w),C=R.value.collator,I=M.value.collator;return r(I,k,y)||d(D,w)||r(C,D,w)}function a(D,w){D=D||"",w=w||"";const k=i(D),y=i(w),C=R.value.collator,I=M.value.collator;return r(I,k,y)||f(D,w)||r(C,D,w)}function m(D,w){D=D||"",w=w||"";const k=i(D).toLowerCase(),y=i(w).toLowerCase();return k!==y?k<y?-1:1:D!==w?D<w?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function n(D,w=!1){const k=D?o.exec(D):[];let y=[k&&k[1]||"",k&&k[3]||""];return w&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(D){const w=D?o.exec(D):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function r(D,w,k){const y=D.compare(w,k);return y!==0?y:w.length!==k.length?w.length<k.length?-1:1:0}function s(D){const w=D.charAt(0);return w.toLocaleUpperCase()!==w}function t(D){const w=D.charAt(0);return w.toLocaleLowerCase()!==w}function f(D,w){return s(D)&&t(w)?-1:t(D)&&s(w)?1:0}function d(D,w){return t(D)&&s(w)?-1:s(D)&&t(w)?1:0}function l(D,w,k=!1){return k||(D=D&&D.toLowerCase(),w=w&&w.toLowerCase()),D===w?0:D<w?-1:1}function c(D,w,k=!1){const y=D.split(N.sep),C=w.split(N.sep),I=y.length-1,F=C.length-1;let j,z;for(let O=0;;O++){if(j=I===O,z=F===O,j&&z)return p(y[O],C[O],k);if(j)return-1;if(z)return 1;const T=l(y[O],C[O],k);if(T!==0)return T}}function h(D,w,k){const y=D.toLowerCase(),C=w.toLowerCase(),I=g(D,w,k);if(I)return I;const F=y.endsWith(k),j=C.endsWith(k);if(F!==j)return F?-1:1;const z=p(y,C);return z!==0?z:y.localeCompare(C)}function g(D,w,k){const y=D.toLowerCase(),C=w.toLowerCase(),I=y.startsWith(k),F=C.startsWith(k);if(I!==F)return I?-1:1;if(I&&F){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}}),define(ke[34],Ee([1,0,17,11,14,18]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=M,e.$kg=p,e.$lg=b,e.$mg=S,e.$ng=A,e.$og=v,e.$pg=a,e.$qg=m,e.$rg=o,e.$sg=n,e.$tg=i,e.$ug=r,e.$vg=s,e.$wg=t,e.$xg=f,e.$yg=c;function M(h){return h===47||h===92}function p(h){return h.replace(/[\\/]/g,u.$hc.sep)}function b(h){return h.indexOf("/")===-1&&(h=p(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}function S(h,g=u.$hc.sep){if(!h)return"";const D=h.length,w=h.charCodeAt(0);if(M(w)){if(M(h.charCodeAt(1))&&!M(h.charCodeAt(2))){let y=3;const C=y;for(;y<D&&!M(h.charCodeAt(y));y++);if(C!==y&&!M(h.charCodeAt(y+1))){for(y+=1;y<D;y++)if(M(h.charCodeAt(y)))return h.slice(0,y+1).replace(/[\\/]/g,g)}}return g}else if(o(w)&&h.charCodeAt(1)===58)return M(h.charCodeAt(2))?h.slice(0,2)+g:h.slice(0,2);let k=h.indexOf("://");if(k!==-1){for(k+=3;k<D;k++)if(M(h.charCodeAt(k)))return h.slice(0,k+1)}return""}function A(h){if(!N.$i||!h||h.length<5)return!1;let g=h.charCodeAt(0);if(g!==92||(g=h.charCodeAt(1),g!==92))return!1;let D=2;const w=D;for(;D<h.length&&(g=h.charCodeAt(D),g!==92);D++);return!(w===D||(g=h.charCodeAt(D+1),isNaN(g)||g===92))}const P=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(h,g=N.$i){const D=g?P:$;return!(!h||h.length===0||/^\s+$/.test(h)||(D.lastIndex=0,D.test(h))||g&&E.test(h)||h==="."||h===".."||g&&h[h.length-1]==="."||g&&h.length!==h.trim().length||h.length>255)}function a(h,g,D){const w=h===g;return!D||w?w:!h||!g?!1:(0,L.$tf)(h,g)}function m(h,g,D,w=u.sep){if(h===g)return!0;if(!h||!g||g.length>h.length)return!1;if(D){if(!(0,L.$uf)(h,g))return!1;if(g.length===h.length)return!0;let y=g.length;return g.charAt(g.length-1)===w&&y--,h.charAt(y)===w}return g.charAt(g.length-1)!==w&&(g+=w),h.indexOf(g)===0}function o(h){return h>=65&&h<=90||h>=97&&h<=122}function n(h,g){return N.$i&&h.endsWith(":")&&(h+=u.sep),(0,u.$jc)(h)||(h=(0,u.$kc)(g,h)),h=(0,u.$ic)(h),N.$i?(h=(0,L.$bf)(h,u.sep),h.endsWith(":")&&(h+=u.sep)):(h=(0,L.$bf)(h,u.sep),h||(h=u.sep)),h}function i(h){const g=(0,u.$ic)(h);return N.$i?h.length>3?!1:r(g)&&(h.length===2||g.charCodeAt(2)===92):g===u.$hc.sep}function r(h,g=N.$i){return g?o(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}function s(h,g=N.$i){return r(h,g)?h[0]:void 0}function t(h,g,D){return g.length>h.length?-1:h===g?0:(D&&(h=h.toLowerCase(),g=g.toLowerCase()),h.indexOf(g))}function f(h){const g=h.split(":");let D,w,k;for(const y of g){const C=Number(y);(0,R.$8f)(C)?w===void 0?w=C:k===void 0&&(k=C):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:w!==void 0?w:void 0,column:k!==void 0?k:w!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(h,g,D=8){let w="";for(let y=0;y<D;y++){let C;y===0&&N.$i&&!g&&(D===3||D===4)?C=l:C=d,w+=C.charAt(Math.floor(Math.random()*C.length))}let k;return g?k=`${g}-${w}`:k=w,h?(0,u.$kc)(h,k):k}}),define(ke[132],Ee([1,0,131,126,56,17,11,14]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=A,e.$mr=m,e.$nr=d,e.$or=k,e.$pr=z,e.$qr=T;const b=0,S=[b,[]];function A(B,W,Z,x){if(!B||!W)return S;const X=B.length,Y=W.length;if(X<Y)return S;const ce=B.toLowerCase();return P(W,Z,Y,B,ce,X,x)}function P(B,W,Z,x,X,Y,ce){const ne=[],$e=[];for(let ie=0;ie<Z;ie++){const be=ie*Y,Pe=be-Y,oe=ie>0,ae=B[ie],re=W[ie];for(let G=0;G<Y;G++){const te=G>0,ge=be+G,we=ge-1,Re=Pe+G-1,fe=te?ne[we]:0,Se=oe&&te?ne[Re]:0,Ae=oe&&te?$e[Re]:0;let Fe;!Se&&oe?Fe=0:Fe=$(ae,re,x,X,G,Ae),Fe&&Se+Fe>=fe&&(ce||oe||X.startsWith(W,G))?($e[ge]=Ae+1,ne[ge]=Se+Fe):($e[ge]=b,ne[ge]=fe)}}const Ce=[];let ee=Z-1,U=Y-1;for(;ee>=0&&U>=0;){const ie=ee*Y+U;$e[ie]===b||(Ce.push(U),ee--),U--}return[ne[Z*Y-1],Ce.reverse()]}function $(B,W,Z,x,X,Y){let ce=0;if(!E(W,x[X]))return ce;if(ce+=1,Y>0&&(ce+=Y*5),B===Z[X]&&(ce+=1),X===0)ce+=8;else{const ne=v(Z.charCodeAt(X-1));ne?ce+=ne:(0,N.$vk)(Z.charCodeAt(X))&&Y===0&&(ce+=2)}return ce}function E(B,W){return B===W?!0:B==="/"||B==="\\"?W==="/"||W==="\\":!1}function v(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function m(B,W,Z=0,x=0){const X=W;return X.values&&X.values.length>1?o(B,X.values,Z,x):n(B,W,Z,x)}function o(B,W,Z,x){let X=0;const Y=[];for(const ce of W){const[ne,$e]=n(B,ce,Z,x);if(typeof ne!="number")return a;X+=ne,Y.push(...$e)}return[X,D(Y)]}function n(B,W,Z,x){const X=(0,N.$Ek)(W.original,W.originalLowercase,Z,B,B.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,N.$Bk)(X)]:a}const i=Object.freeze({score:0}),r=1<<18,s=1<<17,t=65536;function f(B,W,Z,x){const X=x.values?x.values:[x];return(0,L.$ej)({[x.normalized]:{values:X.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:B,description:W,allowNonContiguousMatches:Z}})}function d(B,W,Z,x,X){if(!B||!W.normalized)return i;const Y=x.getItemLabel(B);if(!Y)return i;const ce=x.getItemDescription(B),ne=f(Y,ce,Z,W),$e=X[ne];if($e)return $e;const Ce=l(Y,ce,x.getItemPath(B),W,Z);return X[ne]=Ce,Ce}function l(B,W,Z,x,X){const Y=!Z||!x.containsPathSeparator;return Z&&(M.$k?x.pathNormalized===Z:(0,p.$tf)(x.pathNormalized,Z))?{score:r,labelMatch:[{start:0,end:B.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:x.values&&x.values.length>1?c(B,W,Z,x.values,Y,X):h(B,W,Z,x,Y,X)}function c(B,W,Z,x,X,Y){let ce=0;const ne=[],$e=[];for(const Ce of x){const{score:ee,labelMatch:U,descriptionMatch:ie}=h(B,W,Z,Ce,X,Y);if(ee===b)return i;ce+=ee,U&&ne.push(...U),ie&&$e.push(...ie)}return{score:ce,labelMatch:D(ne),descriptionMatch:D($e)}}function h(B,W,Z,x,X,Y){if(X||!W){const[ce,ne]=A(B,x.normalized,x.normalizedLowercase,Y&&!x.expectContiguousMatch);if(ce){const $e=(0,N.$sk)(x.normalized,B);let Ce;if($e){Ce=s;const ee=Math.round(x.normalized.length/B.length*100);Ce+=ee}else Ce=t;return{score:Ce+ce,labelMatch:$e||g(ne)}}}if(W){let ce=W;Z&&(ce=`${W}${R.sep}`);const ne=ce.length,$e=`${ce}${B}`,[Ce,ee]=A($e,x.normalized,x.normalizedLowercase,Y&&!x.expectContiguousMatch);if(Ce){const U=g(ee),ie=[],be=[];return U.forEach(Pe=>{Pe.start<ne&&Pe.end>ne?(ie.push({start:0,end:Pe.end-ne}),be.push({start:Pe.start,end:ne})):Pe.start>=ne?ie.push({start:Pe.start-ne,end:Pe.end-ne}):be.push(Pe)}),{score:Ce,labelMatch:ie,descriptionMatch:be}}}return i}function g(B){const W=[];if(!B)return W;let Z;for(const x of B)Z&&Z.end===x?Z.end+=1:(Z={start:x,end:x+1},W.push(Z));return W}function D(B){const W=B.sort((X,Y)=>X.start-Y.start),Z=[];let x;for(const X of W)!x||!w(x,X)?(x=X,Z.push(X)):(x.start=Math.min(x.start,X.start),x.end=Math.max(x.end,X.end));return Z}function w(B,W){return!(B.end<W.start||W.end<B.start)}function k(B,W,Z,x,X,Y){const ce=d(B,Z,x,X,Y),ne=d(W,Z,x,X,Y),$e=ce.score,Ce=ne.score;if(($e===r||Ce===r)&&$e!==Ce)return $e===r?-1:1;if($e>t||Ce>t){if($e!==Ce)return $e>Ce?-1:1;if($e<s&&Ce<s){const ae=C(ce.labelMatch,ne.labelMatch);if(ae!==0)return ae}const Pe=X.getItemLabel(B)||"",oe=X.getItemLabel(W)||"";if(Pe.length!==oe.length)return Pe.length-oe.length}if($e!==Ce)return $e>Ce?-1:1;const ee=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,U=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(ee&&!U)return-1;if(U&&!ee)return 1;const ie=y(B,ce,X),be=y(W,ne,X);return ie&&be&&ie!==be?be>ie?-1:1:I(B,W,Z,X)}function y(B,W,Z){let x=-1,X=-1;if(W.descriptionMatch&&W.descriptionMatch.length?x=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(x=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(X=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const Y=Z.getItemDescription(B);Y&&(X+=Y.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(X=W.descriptionMatch[W.descriptionMatch.length-1].end);return X-x}function C(B,W){if(!B&&!W||(!B||!B.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!B||!B.length)return 1;const Z=B[0].start,X=B[B.length-1].end-Z,Y=W[0].start,ne=W[W.length-1].end-Y;return X===ne?0:ne<X?1:-1}function I(B,W,Z,x){const X=x.getItemLabel(B)||"",Y=x.getItemLabel(W)||"",ce=x.getItemDescription(B),ne=x.getItemDescription(W),$e=X.length+(ce?ce.length:0),Ce=Y.length+(ne?ne.length:0);if($e!==Ce)return $e-Ce;const ee=x.getItemPath(B),U=x.getItemPath(W);return ee&&U&&ee.length!==U.length?ee.length-U.length:X!==Y?(0,u.$jr)(X,Y,Z.normalized):ce&&ne&&ce!==ne?(0,u.$jr)(ce,ne,Z.normalized):ee&&U&&ee!==U?(0,u.$jr)(ee,U,Z.normalized):0}function F(B){return B.startsWith('"')&&B.endsWith('"')}const j=" ";function z(B){typeof B!="string"&&(B="");const W=B.toLowerCase(),{pathNormalized:Z,normalized:x,normalizedLowercase:X}=O(B),Y=Z.indexOf(R.sep)>=0,ce=F(B);let ne;const $e=B.split(j);if($e.length>1)for(const Ce of $e){const ee=F(Ce),{pathNormalized:U,normalized:ie,normalizedLowercase:be}=O(Ce);ie&&(ne||(ne=[]),ne.push({original:Ce,originalLowercase:Ce.toLowerCase(),pathNormalized:U,normalized:ie,normalizedLowercase:be,expectContiguousMatch:ee}))}return{original:B,originalLowercase:W,pathNormalized:Z,normalized:x,normalizedLowercase:X,values:ne,containsPathSeparator:Y,expectContiguousMatch:ce}}function O(B){let W;M.$i?W=B.replace(/\//g,R.sep):W=B.replace(/\\/g,R.sep);const Z=(0,p.$df)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:Z,normalizedLowercase:Z.toLowerCase()}}function T(B){return Array.isArray(B)?z(B.map(W=>W.original).join(j)):z(B.original)}}),define(ke[101],Ee([1,0,17]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Is=R,e.$Js=M,e.$Ks=p,e.$Ls=S,e.$Hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const P=(0,u.$pc)(A),$=N[P.toLowerCase()];return $!==void 0?$:M(A)}function M(A){const P=(0,u.$pc)(A);return L[P.toLowerCase()]}function p(A){for(const P in L)if(L[P]===A)return P}const b=/^(.+)\/(.+?)(;.+)?$/;function S(A,P){const $=b.exec(A);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:P?void 0:A}}),define(ke[102],Ee([1,0,11]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$gm=R,e.$hm=M;var N;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function R(p,...b){const S=b.reduce(($,E)=>($[E]=!0,$),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter($=>!S[$]).forEach($=>{for(let E=0;E<A.length;E++)if($.search(A[E])!==-1){delete p[$];break}})}function M(p){p&&(delete p.DEBUG,u.$j&&delete p.DYLD_LIBRARY_PATH,u.$k&&delete p.LD_PRELOAD)}}),define(ke[2],Ee([1,0,17,11]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=v,e.$xc=r;const L=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function p(l,c){if(!l.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!L.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!R.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(l,c){return!l&&!c?"file":l}function S(l,c){switch(l){case"https":case"http":case"file":c?c[0]!==P&&(c=P+c):c=P;break}return c}const A="",P="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{static isUri(c){return c instanceof E?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,h,g,D,w,k=!1){typeof c=="object"?(this.scheme=c.scheme||A,this.authority=c.authority||A,this.path=c.path||A,this.query=c.query||A,this.fragment=c.fragment||A):(this.scheme=b(c,k),this.authority=h||A,this.path=S(this.scheme,g||A),this.query=D||A,this.fragment=w||A,p(this,k))}get fsPath(){return r(this,!1)}with(c){if(!c)return this;let{scheme:h,authority:g,path:D,query:w,fragment:k}=c;return h===void 0?h=this.scheme:h===null&&(h=A),g===void 0?g=this.authority:g===null&&(g=A),D===void 0?D=this.path:D===null&&(D=A),w===void 0?w=this.query:w===null&&(w=A),k===void 0?k=this.fragment:k===null&&(k=A),h===this.scheme&&g===this.authority&&D===this.path&&w===this.query&&k===this.fragment?this:new m(h,g,D,w,k)}static parse(c,h=!1){const g=$.exec(c);return g?new m(g[2]||A,d(g[4]||A),d(g[5]||A),d(g[7]||A),d(g[9]||A),h):new m(A,A,A,A,A)}static file(c){let h=A;if(N.$i&&(c=c.replace(/\\/g,P)),c[0]===P&&c[1]===P){const g=c.indexOf(P,2);g===-1?(h=c.substring(2),c=P):(h=c.substring(2,g),c=c.substring(g)||P)}return new m("file",h,c,A,A)}static from(c,h){return new m(c.scheme,c.authority,c.path,c.query,c.fragment,h)}static joinPath(c,...h){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return N.$i&&c.scheme==="file"?g=E.file(u.$gc.join(r(c,!0),...h)).path:g=u.$hc.join(c.path,...h),c.with({path:g})}toString(c=!1){return s(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof E)return c;{const h=new m(c);return h._formatted=c.external??null,h._fsPath=c._sep===a?c.fsPath??null:null,h}}else return c}}e.URI=E;function v(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const a=N.$i?1:void 0;class m extends E{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(c=!1){return c?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=a),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const o={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(l,c,h){let g,D=-1;for(let w=0;w<l.length;w++){const k=l.charCodeAt(w);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||c&&k===47||h&&k===91||h&&k===93||h&&k===58)D!==-1&&(g+=encodeURIComponent(l.substring(D,w)),D=-1),g!==void 0&&(g+=l.charAt(w));else{g===void 0&&(g=l.substr(0,w));const y=o[k];y!==void 0?(D!==-1&&(g+=encodeURIComponent(l.substring(D,w)),D=-1),g+=y):D===-1&&(D=w)}}return D!==-1&&(g+=encodeURIComponent(l.substring(D))),g!==void 0?g:l}function i(l){let c;for(let h=0;h<l.length;h++){const g=l.charCodeAt(h);g===35||g===63?(c===void 0&&(c=l.substr(0,h)),c+=o[g]):c!==void 0&&(c+=l[h])}return c!==void 0?c:l}function r(l,c){let h;return l.authority&&l.path.length>1&&l.scheme==="file"?h=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?c?h=l.path.substr(1):h=l.path[1].toLowerCase()+l.path.substr(2):h=l.path,N.$i&&(h=h.replace(/\//g,"\\")),h}function s(l,c){const h=c?i:n;let g="",{scheme:D,authority:w,path:k,query:y,fragment:C}=l;if(D&&(g+=D,g+=":"),(w||D==="file")&&(g+=P,g+=P),w){let I=w.indexOf("@");if(I!==-1){const F=w.substr(0,I);w=w.substr(I+1),I=F.lastIndexOf(":"),I===-1?g+=h(F,!1,!1):(g+=h(F.substr(0,I),!1,!1),g+=":",g+=h(F.substr(I+1),!1,!0)),g+="@"}w=w.toLowerCase(),I=w.lastIndexOf(":"),I===-1?g+=h(w,!1,!0):(g+=h(w.substr(0,I),!1,!0),g+=w.substr(I))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const I=k.charCodeAt(1);I>=65&&I<=90&&(k=`/${String.fromCharCode(I+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const I=k.charCodeAt(0);I>=65&&I<=90&&(k=`${String.fromCharCode(I+32)}:${k.substr(2)}`)}g+=h(k,!0,!1)}return y&&(g+="?",g+=h(y,!1,!1)),C&&(g+="#",g+=c?C:n(C,!1,!1)),g}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(l){return l.match(f)?l.replace(f,c=>t(c)):l}}),define(ke[192],Ee([1,0,2]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=N,e.$Oq=L,e.$Pq=R,e.log=p;function N(S){const A=S;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function L(S){const A=[];let P;try{const $=JSON.parse(S.arguments),E=$[$.length-1];E&&E.__$stack&&($.pop(),P=E.__$stack),A.push(...$)}catch{A.push("Unable to log remote console arguments",S.arguments)}return{args:A,stack:P}}function R(S){if(typeof S!="string")return R(L(S).stack);const A=S;if(A){const P=M(A),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if($&&$.length===4)return{uri:u.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}function M(S){if(!S)return S;const A=S.indexOf(`
`);return A===-1?S:S.substring(0,A)}function p(S,A){const{args:P,stack:$}=L(S),E=typeof P[0]=="string"&&P.length===1;let v=M($);v&&(v=`(${v.trim()})`);let a=[];if(typeof P[0]=="string"?v&&E?a=[`%c[${A}] %c${P[0]} %c${v}`,b("blue"),b(""),b("grey")]:a=[`%c[${A}] %c${P[0]}`,b("blue"),b(""),...P.slice(1)]:a=[`%c[${A}]%`,b("blue"),...P],v&&!E&&a.push(v),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,a)}function b(S){return`color: ${S}`}}),define(ke[58],Ee([1,0,21,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=L,e.$Yh=R,e.$Zh=p;function L(b){return JSON.stringify(b,M)}function R(b){let S=JSON.parse(b);return S=p(S),S}function M(b,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:S.flags}:S}function p(b,S=0){if(!b||S>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return N.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof u.$Ce||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let A=0;A<b.length;++A)b[A]=p(b[A],S+1);else for(const A in b)Object.hasOwnProperty.call(b,A)&&(b[A]=p(b[A],S+1))}return b}}),define(ke[15],Ee([1,0,13,11,14,2,17]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Dg=e.$Cg=e.$Bg=e.Schemas=void 0,e.$zg=b,e.$Ag=S,e.$Eg=P;var p;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.commentsInput="comment",v.codeSetting="code-setting"})(p||(e.Schemas=p={}));function b(v,a){return R.URI.isUri(v)?(0,L.$tf)(v.scheme,a):(0,L.$uf)(v,a+":")}function S(v,...a){return a.some(m=>b(v,m))}e.$Bg="vscode-tkn",e.$Cg="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,m){this.f=P(a,m)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,p.vscodeRemoteResource)}set(a,m,o){this.a[a]=m,this.b[a]=o}setConnectionToken(a,m){this.c[a]=m}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(s){return u.$1(s),a}const m=a.authority;let o=this.a[m];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const n=this.b[m],i=this.c[m];let r=`path=${encodeURIComponent(a.path)}`;return typeof i=="string"&&(r+=`&${e.$Cg}=${encodeURIComponent(i)}`),R.URI.from({scheme:N.$o?this.d:p.vscodeRemoteResource,authority:`${o}:${n}`,path:this.g,query:r})}}e.$Dg=new A;function P(v,a){return M.$hc.join(a??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$Fg="vs/../../extensions",e.$Gg="vs/../../node_modules",e.$Hg="vs/../../node_modules.asar",e.$Ig="vs/../../node_modules.asar.unpacked",e.$Jg="vscode-app";class ${static{this.a=e.$Jg}asBrowserUri(a){const m=this.b(a,le);return this.uriToBrowserUri(m)}uriToBrowserUri(a){return a.scheme===p.vscodeRemote?e.$Dg.rewrite(a):a.scheme===p.file&&(N.$m||N.$q===`${p.vscodeFileResource}://${$.a}`)?a.with({scheme:p.vscodeFileResource,authority:a.authority||$.a,query:null,fragment:null}):a}asFileUri(a){const m=this.b(a,le);return this.uriToFileUri(m)}uriToFileUri(a){return a.scheme===p.vscodeFileResource?a.with({scheme:p.file,authority:a.authority!==$.a?a.authority:null,query:null,fragment:null}):a}b(a,m){return R.URI.isUri(a)?a:R.URI.parse(m.toUrl(a))}}e.$Kg=new $;var E;(function(v){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(a.get("3"));const m="vscode-coi";function o(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:R.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const s=r?.get(m);if(s)return a.get(s)}v.getHeadersFromQuery=o;function n(i,r,s){if(!globalThis.crossOriginIsolated)return;const t=r&&s?"3":s?"2":"1";i instanceof URLSearchParams?i.set(m,t):i[m]=t}v.addSearchParam=n})(E||(e.COI=E={}))}),define(ke[193],Ee([1,0,162,15,11,2]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RD=A;class M{constructor($,E,v){this.id=$,this.dependencies=E,this.callback=v}}class p{static{this.INSTANCE=new p}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,E,v)=>{typeof $!="string"&&(v=E,E=$,$=null),(typeof E!="object"||!Array.isArray(E))&&(v=E,E=null),this.c.push(new M($,E,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const E=await(this.a?this.i($):this.b?this.h($):this.j($));if(!E)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(E.dependencies)&&E.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${E.dependencies.join(", ")}`);return typeof E.callback=="function"?E.callback([]):E.callback}h($){return new Promise((E,v)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const m=()=>{a.removeEventListener("load",o),a.removeEventListener("error",n)},o=i=>{m(),E(this.c.pop())},n=i=>{m(),v(i)};a.addEventListener("load",o),a.addEventListener("error",n),this.f&&($=this.f.createScriptURL($)),a.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(a)})}i($){return new Promise((E,v)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),E(this.c.pop())}catch(a){v(a)}})}async j($){try{const E=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,m=R.URI.parse($).fsPath,o=E.readFileSync(m).toString(),n=a.wrap(o.replace(/^#!.*/,""));return new v.Script(n).runInThisContext().apply(),this.c.pop()}catch(E){throw E}}}const b=new Map;let S={};typeof globalThis.require=="object"&&(S=globalThis.require.paths??{});async function A(P,$,E){if(u.$T){E===void 0&&(E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),S[P]&&(P=S[P]);const v=`${P}/${$}`;if(b.has(v))return b.get(v);let a;if(/^\w[\w\d+.-]*:\/\//.test(v))a=v;else{const i=`${E&&!L.$o?N.$Hg:N.$Gg}/${v}`;a=N.$Kg.asBrowserUri(i).toString(!0)}const m=p.INSTANCE.load(a);return b.set(v,m),m}else return await new Promise((v,a)=>{le([P],v,a)})}}),define(ke[23],Ee([1,0,34,15,17,11,14,2]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0,e.$Rg=b,e.$ah=A,e.$bh=$;function b(E){return(0,p.$xc)(E,!0)}class S{constructor(v){this.a=v}compare(v,a,m=!1){return v===a?0:(0,M.$mf)(this.getComparisonKey(v,m),this.getComparisonKey(a,m))}isEqual(v,a,m=!1){return v===a?!0:!v||!a?!1:this.getComparisonKey(v,m)===this.getComparisonKey(a,m)}getComparisonKey(v,a=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,a,m=!1){if(v.scheme===a.scheme){if(v.scheme===N.Schemas.file)return u.$qg(b(v),b(a),this.a(v))&&v.query===a.query&&(m||v.fragment===a.fragment);if((0,e.$9g)(v.authority,a.authority))return u.$qg(v.path,a.path,this.a(v),"/")&&v.query===a.query&&(m||v.fragment===a.fragment)}return!1}joinPath(v,...a){return p.URI.joinPath(v,...a)}basenameOrAuthority(v){return(0,e.$1g)(v)||v.authority}basename(v){return L.$hc.basename(v.path)}extname(v){return L.$hc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let a;return v.scheme===N.Schemas.file?a=p.URI.file(L.$nc(b(v))).path:(a=L.$hc.dirname(v.path),v.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),a="/")),v.with({path:a})}normalizePath(v){if(!v.path.length)return v;let a;return v.scheme===N.Schemas.file?a=p.URI.file(L.$ic(b(v))).path:a=L.$hc.normalize(v.path),v.with({path:a})}relativePath(v,a){if(v.scheme!==a.scheme||!(0,e.$9g)(v.authority,a.authority))return;if(v.scheme===N.Schemas.file){const n=L.$mc(b(v),b(a));return R.$i?u.$kg(n):n}let m=v.path||"/";const o=a.path||"/";if(this.a(v)){let n=0;for(const i=Math.min(m.length,o.length);n<i&&!(m.charCodeAt(n)!==o.charCodeAt(n)&&m.charAt(n).toLowerCase()!==o.charAt(n).toLowerCase());n++);m=o.substr(0,n)+m.substr(n)}return L.$hc.relative(m,o)}resolvePath(v,a){if(v.scheme===N.Schemas.file){const m=p.URI.file(L.$lc(b(v),a));return v.with({authority:m.authority,path:m.path})}return a=u.$lg(a),v.with({path:L.$hc.resolve(v.path,a)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,a){return v===a||v!==void 0&&a!==void 0&&(0,M.$tf)(v,a)}hasTrailingPathSeparator(v,a=L.sep){if(v.scheme===N.Schemas.file){const m=b(v);return m.length>u.$mg(m).length&&m[m.length-1]===a}else{const m=v.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,a=L.sep){return(0,e.$0g)(v,a)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,a=L.sep){let m=!1;if(v.scheme===N.Schemas.file){const o=b(v);m=o!==void 0&&o.length===u.$mg(o).length&&o[o.length-1]===a}else{a="/";const o=v.path;m=o.length===1&&o.charCodeAt(o.length-1)===47}return!m&&!(0,e.$0g)(v,a)?v.with({path:v.path+"/"}):v}}e.$Sg=S,e.$Tg=new S(()=>!1),e.$Ug=new S(E=>E.scheme===N.Schemas.file?!R.$k:!0),e.$Vg=new S(E=>!0),e.$Wg=e.$Tg.isEqual.bind(e.$Tg),e.$Xg=e.$Tg.isEqualOrParent.bind(e.$Tg),e.$Yg=e.$Tg.getComparisonKey.bind(e.$Tg),e.$Zg=e.$Tg.basenameOrAuthority.bind(e.$Tg),e.$1g=e.$Tg.basename.bind(e.$Tg),e.$2g=e.$Tg.extname.bind(e.$Tg),e.$3g=e.$Tg.dirname.bind(e.$Tg),e.$4g=e.$Tg.joinPath.bind(e.$Tg),e.$5g=e.$Tg.normalizePath.bind(e.$Tg),e.$6g=e.$Tg.relativePath.bind(e.$Tg),e.$7g=e.$Tg.resolvePath.bind(e.$Tg),e.$8g=e.$Tg.isAbsolutePath.bind(e.$Tg),e.$9g=e.$Tg.isEqualAuthority.bind(e.$Tg),e.$0g=e.$Tg.hasTrailingPathSeparator.bind(e.$Tg),e.$$g=e.$Tg.removeTrailingPathSeparator.bind(e.$Tg),e.$_g=e.$Tg.addTrailingPathSeparator.bind(e.$Tg);function A(E,v){const a=[];for(let m=0;m<E.length;m++){const o=v(E[m]);E.some((n,i)=>i===m?!1:(0,e.$Xg)(o,v(n)))||a.push(E[m])}return a}var P;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function v(a){const m=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(i=>{const[r,s]=i.split(":");r&&s&&m.set(r,s)});const n=a.path.substring(0,a.path.indexOf(";"));return n&&m.set(E.META_DATA_MIME,n),m}E.parseMetaData=v})(P||(e.DataUri=P={}));function $(E,v,a){if(v){let m=E.path;return m&&m[0]!==L.$hc.sep&&(m=L.$hc.sep+m),E.with({scheme:a,authority:v,path:m})}return E.with({scheme:a})}}),define(ke[7],Ee([1,0,22,13,4,3,23,11,169,46]),function(le,e,u,N,L,R,M,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.Promises=e.$Nh=e.$Mh=e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0,e.$ch=A,e.$dh=P,e.$eh=$,e.$fh=E,e.$gh=v,e.$hh=a,e.$ih=m,e.$jh=o,e.$rh=h,e.$sh=g,e.$th=D,e.$uh=w,e.$vh=k,e.$Kh=X,e.$Sh=oe;function A(re){return!!re&&typeof re.then=="function"}function P(re){const G=new u.$me,te=re(G.token),ge=new Promise((we,Re)=>{const fe=G.token.onCancellationRequested(()=>{fe.dispose(),Re(new N.$5)});Promise.resolve(te).then(Se=>{fe.dispose(),G.dispose(),we(Se)},Se=>{fe.dispose(),G.dispose(),Re(Se)})});return new class{cancel(){G.cancel(),G.dispose()}then(we,Re){return ge.then(we,Re)}catch(we){return this.then(void 0,we)}finally(we){return ge.finally(we)}}}function $(re,G,te){return new Promise((ge,we)=>{const Re=G.onCancellationRequested(()=>{Re.dispose(),ge(te)});re.then(ge,we).finally(()=>Re.dispose())})}function E(re,G){return new Promise((te,ge)=>{const we=G.onCancellationRequested(()=>{we.dispose(),ge(new N.$5)});re.then(te,ge).finally(()=>we.dispose())})}async function v(re){let G=-1;const te=re.map((ge,we)=>ge.then(Re=>(G=we,Re)));try{return await Promise.race(te)}finally{re.forEach((ge,we)=>{we!==G&&ge.cancel()})}}function a(re,G,te){let ge;const we=setTimeout(()=>{ge?.(void 0),te?.()},G);return Promise.race([re.finally(()=>clearTimeout(we)),new Promise(Re=>ge=Re)])}function m(re){return new Promise((G,te)=>{const ge=re();A(ge)?ge.then(G,te):G(ge)})}function o(){let re,G;return{promise:new Promise((ge,we)=>{re=ge,G=we}),resolve:re,reject:G}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(G){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=G,!this.b){const te=()=>{if(this.b=null,this.f)return;const ge=this.queue(this.d);return this.d=null,ge};this.b=new Promise(ge=>{this.a.then(te,te).then(ge)})}return new Promise((te,ge)=>{this.b.then(te,ge)})}return this.a=G(),new Promise((te,ge)=>{this.a.then(we=>{this.a=null,te(we)},we=>{this.a=null,ge(we)})})}dispose(){this.f=!0}}e.$kh=n;class i{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.$lh=i;class r{constructor(){this.a=new Map}queue(G,te){const we=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.a.get(G)===we&&this.a.delete(G)});return this.a.set(G,we),we}}e.$mh=r;const s=(re,G)=>{let te=!0;const ge=setTimeout(()=>{te=!1,G()},re);return{isTriggered:()=>te,dispose:()=>{clearTimeout(ge),te=!1}}},t=re=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,re())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class f{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,te=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((we,Re)=>{this.d=we,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const ge=()=>{this.a=null,this.d?.(null)};return this.a=te===b.$$d?t(ge):s(te,ge),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$nh=f;class d{constructor(G){this.a=new f(G),this.b=new n}trigger(G,te){return this.a.trigger(()=>this.b.queue(G),te)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$oh=d;class l{constructor(){this.a=!1,this.b=new Promise((G,te)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ph=l;class c extends l{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.$qh=c;function h(re,G){return G?new Promise((te,ge)=>{const we=setTimeout(()=>{Re.dispose(),te()},re),Re=G.onCancellationRequested(()=>{clearTimeout(we),Re.dispose(),ge(new N.$5)})}):P(te=>h(re,te))}function g(re,G=0,te){const ge=setTimeout(()=>{re(),te&&we.dispose()},G),we=(0,R.$Sc)(()=>{clearTimeout(ge),te?.deleteAndLeak(we)});return te?.add(we),we}function D(re){const G=[];let te=0;const ge=re.length;function we(){return te<ge?re[te++]():null}function Re(fe){fe!=null&&G.push(fe);const Se=we();return Se?Se.then(Re):Promise.resolve(G)}return Promise.resolve(null).then(Re)}function w(re,G=ge=>!!ge,te=null){let ge=0;const we=re.length,Re=()=>{if(ge>=we)return Promise.resolve(te);const fe=re[ge++];return Promise.resolve(fe()).then(Ae=>G(Ae)?Promise.resolve(Ae):Re())};return Re()}function k(re,G=ge=>!!ge,te=null){if(re.length===0)return Promise.resolve(te);let ge=re.length;const we=()=>{ge=-1;for(const Re of re)Re.cancel?.()};return new Promise((Re,fe)=>{for(const Se of re)Se.then(Ae=>{--ge>=0&&G(Ae)?(we(),Re(Ae)):ge===0&&Re(te)}).catch(Ae=>{--ge>=0&&(we(),fe(Ae))})})}class y{constructor(G){this.a=0,this.b=!1,this.f=G,this.g=[],this.d=0,this.h=new L.$be}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(G){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((te,ge)=>{this.g.push({factory:G,c:te,e:ge}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const G=this.g.shift();this.d++;const te=G.factory();te.then(G.c,G.e),te.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$wh=y;class C extends y{constructor(){super(1)}}e.$xh=C;class I{constructor(){this.a=new Y,this.b=0}queue(G){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,G())):this.a.run(this.b++,G())}}e.$yh=I;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const G=new $e;return this.b.add(G),G.p}g(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueSize(G,te=M.$Tg){const ge=te.getComparisonKey(G);return this.a.get(ge)?.size??0}queueFor(G,te,ge=M.$Tg){const we=ge.getComparisonKey(G);let Re=this.a.get(we);if(!Re){Re=new C;const fe=this.f++,Se=L.Event.once(Re.onDrained)(()=>{Re?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(fe,Se),this.a.set(we,Re)}return Re.queue(te)}h(){this.g()&&this.j()}j(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$zh=F;class j{constructor(G,te){this.a=-1,typeof G=="function"&&typeof te=="number"&&this.setIfNotSet(G,te)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,te){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},te)}setIfNotSet(G,te){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},te))}}e.$Ah=j;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(G,te,ge=globalThis){this.cancel();const we=ge.setInterval(()=>{G()},te);this.d=(0,R.$Sc)(()=>{ge.clearInterval(we),this.d=void 0})}dispose(){this.cancel()}}e.$Bh=z;class O{constructor(G,te){this.b=-1,this.a=G,this.d=te,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ch=O;class T{constructor(G,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.a=G,this.b=te,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dh=T;class B extends O{constructor(G,te){super(G,te),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.$Eh=B;class W extends R.$Uc{constructor(G,te){super(),this.g=G,this.h=te,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const te of G)this.a.push(te);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new O(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Hh=(re,G)=>{(0,p.$B)(()=>{if(te)return;const ge=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e.$Hh=(re,G,te)=>{const ge=re.requestIdleCallback(G,typeof te=="number"?{timeout:te}:void 0);let we=!1;return{dispose(){we||(we=!0,re.cancelIdleCallback(ge))}}},e.$Gh=re=>(0,e.$Hh)(globalThis,re)}();class Z{constructor(G,te){this.g=!1,this.d=()=>{try{this.j=te()}catch(ge){this.l=ge}finally{this.g=!0}},this.f=(0,e.$Hh)(G,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ih=Z;class x extends Z{constructor(G){super(globalThis,G)}}e.$Jh=x;async function X(re,G,te){let ge;for(let we=0;we<te;we++)try{return await re()}catch(Re){ge=Re,await h(G)}throw ge}class Y{isRunning(G){return typeof G=="number"?this.a?.taskId===G:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(G,te,ge){return this.a={taskId:G,cancel:()=>ge?.(),promise:te},te.then(()=>this.d(G),()=>this.d(G)),te}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this.b)this.b.run=G;else{const{promise:te,resolve:ge,reject:we}=o();this.b={run:G,promise:te,promiseResolve:ge,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lh=Y;class ce{constructor(G,te=()=>Date.now()){this.d=G,this.f=te,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.$Mh=ce;var ne;(function(re){re[re.Resolved=0]="Resolved",re[re.Rejected=1]="Rejected"})(ne||(ne={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((G,te)=>{this.a=G,this.b=te})}complete(G){return new Promise(te=>{this.a(G),this.d={outcome:0,value:G},te()})}error(G){return new Promise(te=>{this.b(G),this.d={outcome:1,value:G},te()})}cancel(){return this.error(new N.$5)}}e.$Nh=$e;var Ce;(function(re){async function G(ge){let we;const Re=await Promise.all(ge.map(fe=>fe.then(Se=>Se,Se=>{we||(we=Se)})));if(typeof we<"u")throw we;return Re}re.settled=G;function te(ge){return new Promise(async(we,Re)=>{try{await ge(we,Re)}catch(fe){Re(fe)}})}re.withAsyncBody=te})(Ce||(e.Promises=Ce={}));class ee{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(G){this.a=void 0,this.b=void 0,this.d=!1,this.promise=G.then(te=>(this.a=te,this.d=!0,te),te=>{throw this.b=te,this.d=!0,te})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Oh=ee;class U{constructor(G){this.b=G,this.a=new S.$V(()=>new ee(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Ph=U;var ie;(function(re){re[re.Initial=0]="Initial",re[re.DoneOK=1]="DoneOK",re[re.DoneError=2]="DoneError"})(ie||(ie={}));class be{static fromArray(G){return new be(te=>{te.emitMany(G)})}static fromPromise(G){return new be(async te=>{te.emitMany(await G)})}static fromPromises(G){return new be(async te=>{await Promise.all(G.map(async ge=>te.emitOne(await ge)))})}static merge(G){return new be(async te=>{await Promise.all(G.map(async ge=>{for await(const we of ge)te.emitOne(we)}))})}static{this.EMPTY=be.fromArray([])}constructor(G){this.a=0,this.b=[],this.d=null,this.f=new L.$be,queueMicrotask(async()=>{const te={emitOne:ge=>this.g(ge),emitMany:ge=>this.h(ge),reject:ge=>this.k(ge)};try{await Promise.resolve(G(te)),this.j()}catch(ge){this.k(ge)}finally{te.emitOne=void 0,te.emitMany=void 0,te.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.f.event)}while(!0)}}}static map(G,te){return new be(async ge=>{for await(const we of G)ge.emitOne(te(we))})}map(G){return be.map(this,G)}static filter(G,te){return new be(async ge=>{for await(const we of G)te(we)&&ge.emitOne(we)})}filter(G){return be.filter(this,G)}static coalesce(G){return be.filter(G,te=>!!te)}coalesce(){return be.coalesce(this)}static async toPromise(G){const te=[];for await(const ge of G)te.push(ge);return te}toPromise(){return be.toPromise(this)}g(G){this.a===0&&(this.b.push(G),this.f.fire())}h(G){this.a===0&&(this.b=this.b.concat(G),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(G){this.a===0&&(this.a=2,this.d=G,this.f.fire())}}e.$Qh=be;class Pe extends be{constructor(G,te){super(te),this.l=G}cancel(){this.l.cancel()}}e.$Rh=Pe;function oe(re){const G=new u.$me,te=re(G.token);return new Pe(G,async ge=>{const we=G.token.onCancellationRequested(()=>{we.dispose(),G.dispose(),ge.reject(new N.$5)});try{for await(const Re of te){if(G.token.isCancellationRequested)return;ge.emitOne(Re)}we.dispose(),G.dispose()}catch(Re){we.dispose(),G.dispose(),ge.reject(Re)}})}class ae{constructor(){this.a=new $e,this.b=new be(ge=>{if(G){ge.reject(G);return}return te&&ge.emitMany(te),this.d=we=>ge.reject(we),this.f=we=>ge.emitOne(we),this.a.p});let G,te;this.f=ge=>{te||(te=[]),te.push(ge)},this.d=ge=>{G||(G=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(G){this.d(G),this.a.complete()}emitOne(G){this.f(G)}}e.$Th=ae}),define(ke[35],Ee([1,0,19,7,34,27,17,11,14]),function(le,e,u,N,L,R,M,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$fk=S,e.$ik=v,e.$jk=C,e.$kk=I,e.$lk=F,e.$mk=j,e.$nk=z,e.$ok=W;function S(){return Object.create(null)}e.$gk="**",e.$hk="/";const A="[/\\\\]",P="[^/\\\\]",$=/\//g;function E(Z,x){switch(Z){case 0:return"";case 1:return`${P}*?`;default:return`(?:${A}|${P}+${A}${x?`|${A}${P}+`:""})*?`}}function v(Z,x){if(!Z)return[];const X=[];let Y=!1,ce=!1,ne="";for(const $e of Z){switch($e){case x:if(!Y&&!ce){X.push(ne),ne="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ne+=$e}return ne&&X.push(ne),X}function a(Z){if(!Z)return"";let x="";const X=v(Z,e.$hk);if(X.every(Y=>Y===e.$gk))x=".*";else{let Y=!1;X.forEach((ce,ne)=>{if(ce===e.$gk){if(Y)return;x+=E(2,ne===X.length-1)}else{let $e=!1,Ce="",ee=!1,U="";for(const ie of ce){if(ie!=="}"&&$e){Ce+=ie;continue}if(ee&&(ie!=="]"||!U)){let be;ie==="-"?be=ie:(ie==="^"||ie==="!")&&!U?be="^":ie===e.$hk?be="":be=(0,b.$8e)(ie),U+=be;continue}switch(ie){case"{":$e=!0;continue;case"[":ee=!0;continue;case"}":{const Pe=`(?:${v(Ce,",").map(oe=>a(oe)).join("|")})`;x+=Pe,$e=!1,Ce="";break}case"]":{x+="["+U+"]",ee=!1,U="";break}case"?":x+=P;continue;case"*":x+=E(1);continue;default:x+=(0,b.$8e)(ie)}}ne<X.length-1&&(X[ne+1]!==e.$gk||ne+2<X.length)&&(x+=A)}Y=ce===e.$gk})}return x}const m=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Ec(1e4),f=function(){return!1},d=function(){return null};function l(Z,x){if(!Z)return d;let X;typeof Z!="string"?X=Z.pattern:X=Z,X=X.trim();const Y=`${X}_${!!x.trimForExclusions}`;let ce=t.get(Y);if(ce)return c(ce,Z);let ne;return m.test(X)?ce=g(X.substr(4),X):(ne=o.exec(h(X,x)))?ce=D(ne[1],X):(x.trimForExclusions?i:n).test(X)?ce=w(X,x):(ne=r.exec(h(X,x)))?ce=k(ne[1].substr(1),X,!0):(ne=s.exec(h(X,x)))?ce=k(ne[1],X,!1):ce=y(X),t.set(Y,ce),c(ce,Z)}function c(Z,x){if(typeof x=="string")return Z;const X=function(Y,ce){return(0,L.$qg)(Y,x.base,!p.$k)?Z((0,b.$af)(Y.substr(x.base.length),M.sep),ce):null};return X.allBasenames=Z.allBasenames,X.allPaths=Z.allPaths,X.basenames=Z.basenames,X.patterns=Z.patterns,X}function h(Z,x){return x.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function g(Z,x){return function(X,Y){return typeof X=="string"&&X.endsWith(Z)?x:null}}function D(Z,x){const X=`/${Z}`,Y=`\\${Z}`,ce=function($e,Ce){return typeof $e!="string"?null:Ce?Ce===Z?x:null:$e===Z||$e.endsWith(X)||$e.endsWith(Y)?x:null},ne=[Z];return ce.basenames=ne,ce.patterns=[x],ce.allBasenames=ne,ce}function w(Z,x){const X=B(Z.slice(1,-1).split(",").map(Ce=>l(Ce,x)).filter(Ce=>Ce!==d),Z),Y=X.length;if(!Y)return d;if(Y===1)return X[0];const ce=function(Ce,ee){for(let U=0,ie=X.length;U<ie;U++)if(X[U](Ce,ee))return Z;return null},ne=X.find(Ce=>!!Ce.allBasenames);ne&&(ce.allBasenames=ne.allBasenames);const $e=X.reduce((Ce,ee)=>ee.allPaths?Ce.concat(ee.allPaths):Ce,[]);return $e.length&&(ce.allPaths=$e),ce}function k(Z,x,X){const Y=M.sep===M.$hc.sep,ce=Y?Z:Z.replace($,M.sep),ne=M.sep+ce,$e=M.$hc.sep+Z;let Ce;return X?Ce=function(ee,U){return typeof ee=="string"&&(ee===ce||ee.endsWith(ne)||!Y&&(ee===Z||ee.endsWith($e)))?x:null}:Ce=function(ee,U){return typeof ee=="string"&&(ee===ce||!Y&&ee===Z)?x:null},Ce.allPaths=[(X?"*/":"./")+Z],Ce}function y(Z){try{const x=new RegExp(`^${a(Z)}$`);return function(X){return x.lastIndex=0,typeof X=="string"&&x.test(X)?Z:null}}catch{return d}}function C(Z,x,X){return!Z||typeof x!="string"?!1:I(Z)(x,void 0,X)}function I(Z,x={}){if(!Z)return f;if(typeof Z=="string"||F(Z)){const X=l(Z,x);if(X===d)return f;const Y=function(ce,ne){return!!X(ce,ne)};return X.allBasenames&&(Y.allBasenames=X.allBasenames),X.allPaths&&(Y.allPaths=X.allPaths),Y}return O(Z,x)}function F(Z){const x=Z;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}function j(Z){return Z.allBasenames||[]}function z(Z){return Z.allPaths||[]}function O(Z,x){const X=B(Object.getOwnPropertyNames(Z).map(Ce=>T(Ce,Z[Ce],x)).filter(Ce=>Ce!==d)),Y=X.length;if(!Y)return d;if(!X.some(Ce=>!!Ce.requiresSiblings)){if(Y===1)return X[0];const Ce=function(ie,be){let Pe;for(let oe=0,ae=X.length;oe<ae;oe++){const re=X[oe](ie,be);if(typeof re=="string")return re;(0,N.$ch)(re)&&(Pe||(Pe=[]),Pe.push(re))}return Pe?(async()=>{for(const oe of Pe){const ae=await oe;if(typeof ae=="string")return ae}return null})():null},ee=X.find(ie=>!!ie.allBasenames);ee&&(Ce.allBasenames=ee.allBasenames);const U=X.reduce((ie,be)=>be.allPaths?ie.concat(be.allPaths):ie,[]);return U.length&&(Ce.allPaths=U),Ce}const ce=function(Ce,ee,U){let ie,be;for(let Pe=0,oe=X.length;Pe<oe;Pe++){const ae=X[Pe];ae.requiresSiblings&&U&&(ee||(ee=(0,M.$oc)(Ce)),ie||(ie=ee.substr(0,ee.length-(0,M.$pc)(Ce).length)));const re=ae(Ce,ee,ie,U);if(typeof re=="string")return re;(0,N.$ch)(re)&&(be||(be=[]),be.push(re))}return be?(async()=>{for(const Pe of be){const oe=await Pe;if(typeof oe=="string")return oe}return null})():null},ne=X.find(Ce=>!!Ce.allBasenames);ne&&(ce.allBasenames=ne.allBasenames);const $e=X.reduce((Ce,ee)=>ee.allPaths?Ce.concat(ee.allPaths):Ce,[]);return $e.length&&(ce.allPaths=$e),ce}function T(Z,x,X){if(x===!1)return d;const Y=l(Z,X);if(Y===d)return d;if(typeof x=="boolean")return Y;if(x){const ce=x.when;if(typeof ce=="string"){const ne=($e,Ce,ee,U)=>{if(!U||!Y($e,Ce))return null;const ie=ce.replace("$(basename)",()=>ee),be=U(ie);return(0,N.$ch)(be)?be.then(Pe=>Pe?Z:null):be?Z:null};return ne.requiresSiblings=!0,ne}}return Y}function B(Z,x){const X=Z.filter(Ce=>!!Ce.basenames);if(X.length<2)return Z;const Y=X.reduce((Ce,ee)=>{const U=ee.basenames;return U?Ce.concat(U):Ce},[]);let ce;if(x){ce=[];for(let Ce=0,ee=Y.length;Ce<ee;Ce++)ce.push(x)}else ce=X.reduce((Ce,ee)=>{const U=ee.patterns;return U?Ce.concat(U):Ce},[]);const ne=function(Ce,ee){if(typeof Ce!="string")return null;if(!ee){let ie;for(ie=Ce.length;ie>0;ie--){const be=Ce.charCodeAt(ie-1);if(be===47||be===92)break}ee=Ce.substr(ie)}const U=Y.indexOf(ee);return U!==-1?ce[U]:null};ne.basenames=Y,ne.patterns=ce,ne.allBasenames=Y;const $e=Z.filter(Ce=>!Ce.basenames);return $e.push(ne),$e}function W(Z,x){return(0,u.$ub)(Z,x,(X,Y)=>typeof X=="string"&&typeof Y=="string"?X===Y:typeof X!="string"&&typeof Y!="string"?X.base===Y.base&&X.pattern===Y.pattern:!1)}}),define(ke[80],Ee([1,0,13,171,23,14,2]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.MarkdownStringTextNewlineStyle=void 0,e.$Ok=S,e.$Pk=A,e.$Qk=P,e.$Rk=$,e.$Sk=E,e.$Tk=v,e.$Uk=a,e.$Vk=m;var p;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class b{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,u.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=$(this.supportThemeIcons?(0,N.$Hk)(n):n).replace(/([ \t]+)/g,(r,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${E(i,n)}
`,this}appendLink(n,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(n,i){const r=new RegExp((0,R.$8e)(i),"g");return n.replace(r,(s,t)=>n.charAt(t-1)!=="\\"?`\\${s}`:s)}}e.$Nk=b;function S(o){return A(o)?!o.value:Array.isArray(o)?o.every(S):!0}function A(o){return o instanceof b?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function P(o,n){return o===n?!0:!o||!n?!1:o.value===n.value&&o.isTrusted===n.isTrusted&&o.supportThemeIcons===n.supportThemeIcons&&o.supportHtml===n.supportHtml&&(o.baseUri===n.baseUri||!!o.baseUri&&!!n.baseUri&&(0,L.$Wg)(M.URI.from(o.baseUri),M.URI.from(n.baseUri)))}function $(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(o,n){const i=o.match(/^`+/gm)?.reduce((s,t)=>s.length>t.length?s:t).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${n}`,o,`${"`".repeat(r)}`].join(`
`)}function v(o){return o.replace(/"/g,"&quot;")}function a(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(o){const n=[],i=o.split("|").map(s=>s.trim());o=i[0];const r=i[1];if(r){const s=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),f=s?s[1]:"",d=t?t[1]:"",l=isFinite(parseInt(d)),c=isFinite(parseInt(f));l&&n.push(`width="${d}"`),c&&n.push(`height="${f}"`)}return{href:o,dimensions:n}}}),define(ke[103],Ee([1,0,19,34,17,11,23,14]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=b,e.$pw=A,e.$qw=$,e.$rw=E,e.$sw=o,e.$tw=i,e.$uw=r,e.$vw=s,e.$ww=t,e.$xw=f;function b(l,c){const{os:h,tildify:g,relative:D}=c;if(D){const y=S(l,D,h);if(typeof y=="string")return y}let w=l.fsPath;if(h===1&&!R.$i?w=w.replace(/\//g,"\\"):h!==1&&R.$i&&(w=w.replace(/\\/g,"/")),h!==1&&g?.userHome){const y=g.userHome.fsPath;let C;l.scheme!==g.userHome.scheme&&l.path[0]===L.$hc.sep&&l.path[1]!==L.$hc.sep?C=g.userHome.with({path:l.path}).fsPath:C=w,w=$(C,y,h)}return(h===1?L.$gc:L.$hc).normalize(A(w,h===1))}function S(l,c,h){const g=h===1?L.$gc:L.$hc,D=h===3?M.$Tg:M.$Vg,w=c.getWorkspace(),k=(0,u.$Ob)(w.folders);if(!k)return;l.scheme!==k.uri.scheme&&l.path[0]===L.$hc.sep&&l.path[1]!==L.$hc.sep&&(l=k.uri.with({path:l.path}));const y=c.getWorkspaceFolder(l);if(!y)return;let C;if(D.isEqual(y.uri,l)?C="":C=D.relativePath(y.uri,l)??"",C&&(C=g.normalize(C)),w.folders.length>1&&!c.noPrefix){const I=y.name?y.name:D.basenameOrAuthority(y.uri);C=C?`${I} \u2022 ${C}`:I}return C}function A(l,c=R.$i){return(0,N.$ug)(l,c)?l.charAt(0).toUpperCase()+l.slice(1):l}let P=Object.create(null);function $(l,c,h=R.OS){if(h===1||!l||!c)return l;let g=P.original===c?P.normalized:void 0;g||(g=c,R.$i&&(g=(0,N.$kg)(g)),g=`${(0,p.$bf)(g,L.$hc.sep)}${L.$hc.sep}`,P={original:c,normalized:g});let D=l;return R.$i&&(D=(0,N.$kg)(D)),(h===3?D.startsWith(g):(0,p.$uf)(D,g))?`~/${D.substr(g.length)}`:l}function E(l,c){return l.replace(/^~($|\/|\\)/,`${c}$1`)}const v="\u2026",a="\\\\",m="~";function o(l,c=L.sep){const h=new Array(l.length);let g=!1;for(let D=0;D<l.length;D++){const w=l[D];if(w===""){h[D]=`.${c}`;continue}if(!w){h[D]=w;continue}g=!0;let k="",y=w;y.indexOf(a)===0?(k=y.substr(0,y.indexOf(a)+a.length),y=y.substr(y.indexOf(a)+a.length)):y.indexOf(c)===0?(k=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length)):y.indexOf(m)===0&&(k=y.substr(0,y.indexOf(m)+m.length),y=y.substr(y.indexOf(m)+m.length));const C=y.split(c);for(let I=1;g&&I<=C.length;I++)for(let F=C.length-I;g&&F>=0;F--){g=!1;let j=C.slice(F,F+I).join(c);for(let z=0;!g&&z<l.length;z++)if(z!==D&&l[z]&&l[z].indexOf(j)>-1){const O=F+I===C.length,T=F>0&&l[z].indexOf(c)>-1?c+j:j,B=l[z].endsWith(T);g=!O||B}if(!g){let z="";(C[0].endsWith(":")||k!=="")&&(F===1&&(F=0,I++,j=C[0]+c+j),F>0&&(z=C[0]+c),z=k+z),F>0&&(z=z+v+c),z=z+j,F+I<C.length&&(z=z+c+v),h[D]=z}}g&&(h[D]=w)}return h}var n;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(l,c=Object.create(null)){const h=[];let g=!1,D="";for(const w of l)if(w==="$"||g&&w==="{")D&&h.push({value:D,type:n.TEXT}),D="",g=!0;else if(w==="}"&&g){const k=c[D];if(typeof k=="string")k.length&&h.push({value:k,type:n.VARIABLE});else if(k){const y=h[h.length-1];(!y||y.type!==n.SEPARATOR)&&h.push({value:k.label,type:n.SEPARATOR})}D="",g=!1}else D+=w;return D&&!g&&h.push({value:D,type:n.TEXT}),h.filter((w,k)=>{if(w.type===n.SEPARATOR){const y=h[k-1],C=h[k+1];return[y,C].every(I=>I&&(I.type===n.VARIABLE||I.type===n.TEXT)&&I.value.length>0)}return!0}).map(w=>w.value).join("")}function r(l,c){return R.$j||c?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):l.replace(/&&|&/g,h=>h==="&"?"&&":"&")}function s(l,c){return R.$j||c?l.replace(/\(&&\w\)|&&/g,""):R.$i?l.replace(/&&|&/g,h=>h==="&"?"&&":"&"):l.replace(/&&/g,"_")}function t(l){return l.replace(/&/g,"&&")}function f(l){if(l.endsWith("]")){const c=l.lastIndexOf(" [",l.length-2);if(c!==-1){const h=d(l.substring(0,c)),g=l.substring(c);return{name:h.name+g,parentPath:h.parentPath}}}return d(l)}function d(l){const c=l.indexOf("/")!==-1?L.$hc:L.$gc,h=c.basename(l),g=c.dirname(l);return h.length?{name:h,parentPath:g}:{name:g,parentPath:""}}}),define(ke[133],Ee([1,0,21,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=void 0,e.$un=p,e.$vn=S,e.$wn=A;function L(P){return P.toJSON()}class R{constructor($){this.a=$}transformIncoming($){const E=this.a.transformIncoming($);return E===$?$:L(N.URI.from(E))}transformOutgoing($){const E=this.a.transformOutgoing($);return E===$?$:L(N.URI.from(E))}transformOutgoingURI($){const E=this.a.transformOutgoing($);return E===$?$:N.URI.from(E)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$sn=R,e.$tn=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function M(P,$,E){if(!P||E>200)return null;if(typeof P=="object"){if(P instanceof N.URI)return $.transformOutgoing(P);for(const v in P)if(Object.hasOwnProperty.call(P,v)){const a=M(P[v],$,E+1);a!==null&&(P[v]=a)}}return null}function p(P,$){const E=M(P,$,0);return E===null?P:E}function b(P,$,E,v){if(!P||v>200)return null;if(typeof P=="object"){if(P.$mid===1)return E?N.URI.revive($.transformIncoming(P)):$.transformIncoming(P);if(P instanceof u.$Ce)return null;for(const a in P)if(Object.hasOwnProperty.call(P,a)){const m=b(P[a],$,E,v+1);m!==null&&(P[a]=m)}}return null}function S(P,$){const E=b(P,$,!1,0);return E===null?P:E}function A(P,$){const E=b(P,$,!0,0);return E===null?P:E}}),define(ke[31],Ee([1,0,52,64,396,7,34,76,17,11,23,2]),function(le,e,u,N,L,R,M,p,b,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=h,e.writeFileSync=D;var $;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function E(T,B=$.UNLINK,W){if((0,M.$tg)(T))throw new Error("rimraf - will refuse to recursively delete root");return B===$.UNLINK?a(T):v(T,W)}async function v(T,B=(0,M.$yg)((0,N.tmpdir)())){try{try{await u.promises.rename(T,B)}catch(W){return W.code==="ENOENT"?void 0:a(T)}a(B).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function a(T){return(0,L.promisify)(u.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function m(T){if((0,M.$tg)(T))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}async function o(T,B){return r(await(B?n(T):(0,L.promisify)(u.readdir)(T)))}async function n(T){try{return await(0,L.promisify)(u.readdir)(T,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const B=[],W=await o(T);for(const Z of W){let x=!1,X=!1,Y=!1;try{const ce=await e.Promises.lstat((0,b.$kc)(T,Z));x=ce.isFile(),X=ce.isDirectory(),Y=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}B.push({name:Z,isFile:()=>x,isDirectory:()=>X,isSymbolicLink:()=>Y})}return B}function i(T){return r(u.readdirSync(T))}function r(T){return T.map(B=>typeof B=="string"?S.$j?(0,p.$8l)(B):B:(B.name=S.$j?(0,p.$8l)(B.name):B.name,B))}async function s(T){const B=await o(T),W=[];for(const Z of B)await f.existsDirectory((0,b.$kc)(T,Z))&&W.push(Z);return W}function t(T,B=1e3){return new Promise(W=>{let Z=!1;const x=setInterval(()=>{Z||(Z=!0,u.access(T,X=>{Z=!1,X&&(clearInterval(x),W(void 0))}))},B)})}var f;(function(T){async function B(x){let X;try{if(X=await e.Promises.lstat(x),!X.isSymbolicLink())return{stat:X}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:X?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};if(S.$i&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};throw ce}throw Y}}T.stat=B;async function W(x){try{const{stat:X,symbolicLink:Y}=await T.stat(x);return X.isFile()&&Y?.dangling!==!0}catch{}return!1}T.existsFile=W;async function Z(x){try{const{stat:X,symbolicLink:Y}=await T.stat(x);return X.isDirectory()&&Y?.dangling!==!0}catch{}return!1}T.existsDirectory=Z})(f||(e.SymlinkSupport=f={}));const d=new R.$zh;function l(T,B,W){return d.queueFor(P.URI.file(T),()=>{const Z=w(W);return new Promise((x,X)=>g(T,B,Z,Y=>Y?X(Y):x()))},A.$Ug)}let c=!0;function h(T){c=T}function g(T,B,W,Z){if(!c)return u.writeFile(T,B,{mode:W.mode,flag:W.flag},Z);u.open(T,W.flag,W.mode,(x,X)=>{if(x)return Z(x);u.writeFile(X,B,Y=>{if(Y)return u.close(X,()=>Z(Y));u.fdatasync(X,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),h(!1)),u.close(X,ne=>Z(ne))))})})}function D(T,B,W){const Z=w(W);if(!c)return u.writeFileSync(T,B,{mode:Z.mode,flag:Z.flag});const x=u.openSync(T,Z.flag,Z.mode);try{u.writeFileSync(x,B);try{u.fdatasyncSync(x)}catch(X){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",X),h(!1)}}finally{u.closeSync(x)}}function w(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function k(T,B,W=6e4){if(T!==B)try{S.$i&&typeof W=="number"?await y(T,B,Date.now(),W):await(0,L.promisify)(u.rename)(T,B)}catch(Z){if(T.toLowerCase()!==B.toLowerCase()&&Z.code==="EXDEV"||T.endsWith("."))await C(T,B,{preserveSymlinks:!1}),await E(T,$.MOVE);else throw Z}}async function y(T,B,W,Z,x=0){try{return await(0,L.promisify)(u.rename)(T,B)}catch(X){if(X.code!=="EACCES"&&X.code!=="EPERM"&&X.code!=="EBUSY")throw X;if(Date.now()-W>=Z)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${X}`),X;if(x===0){let Y=!1;try{const{stat:ce}=await f.stat(B);ce.isFile()||(Y=!0)}catch{}if(Y)throw X}return await(0,R.$rh)(Math.min(100,x*10)),y(T,B,W,Z,x+1)}}async function C(T,B,W){return F(T,B,{root:{source:T,target:B},options:W,handledSourcePaths:new Set})}const I=511;async function F(T,B,W){if(W.handledSourcePaths.has(T))return;W.handledSourcePaths.add(T);const{stat:Z,symbolicLink:x}=await f.stat(T);if(x){if(W.options.preserveSymlinks)try{return await O(T,B,W)}catch{}if(x.dangling)return}return Z.isDirectory()?j(T,B,Z.mode&I,W):z(T,B,Z.mode&I)}async function j(T,B,W,Z){await e.Promises.mkdir(B,{recursive:!0,mode:W});const x=await o(T);for(const X of x)await F((0,b.$kc)(T,X),(0,b.$kc)(B,X),Z)}async function z(T,B,W){await e.Promises.copyFile(T,B),await e.Promises.chmod(B,W)}async function O(T,B,W){let Z=await e.Promises.readlink(T);(0,M.$qg)(Z,W.root.source,!S.$k)&&(Z=(0,b.$kc)(W.root.target,Z.substr(W.root.source.length+1))),await e.Promises.symlink(Z,B)}e.Promises=new class{get access(){return(0,L.promisify)(u.access)}get stat(){return(0,L.promisify)(u.stat)}get lstat(){return(0,L.promisify)(u.lstat)}get utimes(){return(0,L.promisify)(u.utimes)}get read(){return(T,B,W,Z,x)=>new Promise((X,Y)=>{u.read(T,B,W,Z,x,(ce,ne,$e)=>ce?Y(ce):X({bytesRead:ne,buffer:$e}))})}get readFile(){return(0,L.promisify)(u.readFile)}get write(){return(T,B,W,Z,x)=>new Promise((X,Y)=>{u.write(T,B,W,Z,x,(ce,ne,$e)=>ce?Y(ce):X({bytesWritten:ne,buffer:$e}))})}get appendFile(){return(0,L.promisify)(u.appendFile)}get fdatasync(){return(0,L.promisify)(u.fdatasync)}get truncate(){return(0,L.promisify)(u.truncate)}get copyFile(){return(0,L.promisify)(u.copyFile)}get open(){return(0,L.promisify)(u.open)}get close(){return(0,L.promisify)(u.close)}get symlink(){return(0,L.promisify)(u.symlink)}get readlink(){return(0,L.promisify)(u.readlink)}get chmod(){return(0,L.promisify)(u.chmod)}get mkdir(){return(0,L.promisify)(u.mkdir)}get unlink(){return(0,L.promisify)(u.unlink)}get rmdir(){return(0,L.promisify)(u.rmdir)}get realpath(){return(0,L.promisify)(u.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return s}get writeFile(){return l}get rm(){return E}get rename(){return k}get copy(){return C}}}),define(ke[104],Ee([1,0,52,17,11,14,31]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=p,e.$Wq=b,e.$Xq=S,e.$Yq=A;function p($){if(L.$k)return $;const E=(0,N.$nc)($);if($===E)return $;const v=((0,N.$oc)($)||$).toLowerCase();try{const m=(0,M.readdirSync)(E).filter(o=>o.toLowerCase()===v);if(m.length===1){const o=p(E);if(o)return(0,N.$kc)(o,m[0])}else if(m.length>1){const o=m.indexOf(v);if(o>=0){const n=p(E);if(n)return(0,N.$kc)(n,m[o])}}}catch{}return null}async function b($,E){if(L.$k)return $;const v=(0,N.$nc)($);if($===v)return $;const a=((0,N.$oc)($)||$).toLowerCase();try{if(E?.isCancellationRequested)return null;const o=(await M.Promises.readdir(v)).filter(n=>n.toLowerCase()===a);if(o.length===1){const n=await b(v,E);if(n)return(0,N.$kc)(n,o[0])}else if(o.length>1){const n=o.indexOf(a);if(n>=0){const i=await b(v,E);if(i)return(0,N.$kc)(i,o[n])}}}catch{}return null}async function S($){try{return await M.Promises.realpath($)}catch{const v=P($);return await M.Promises.access(v,u.constants.R_OK),v}}function A($){try{return u.realpathSync($)}catch{const v=P($);return u.accessSync(v,u.constants.R_OK),v}}function P($){return(0,R.$bf)((0,N.$ic)($),N.sep)}}),define(ke[105],Ee([1,0,17,11,51,102,18,31]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$im=b,e.$jm=S,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function b(P=L.env){return P.comspec||"cmd.exe"}function S(P){let $=[],E=!1;const v=function(a){if(E){$.push(a);return}(!P.send(a,o=>{if(o&&console.error(o),E=!1,$.length>0){const n=$.slice(0);$=[],n.forEach(i=>v(i))}})||N.$i)&&(E=!0)};return{send:v}}var A;(function(P){async function $(E,v,a){if(u.$jc(E))return E;if(v===void 0&&(v=L.cwd()),u.$nc(E)!=="."||(a===void 0&&M.$4f(L.env.PATH)&&(a=L.env.PATH.split(u.$uc)),a===void 0||a.length===0))return u.$kc(v,E);async function o(n){if(await p.Promises.exists(n)){let i;try{i=await p.Promises.stat(n)}catch(r){r.message.startsWith("EACCES")&&(i=await p.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of a){let i;if(u.$jc(n)?i=u.$kc(n,E):i=u.$kc(v,n,E),await o(i))return i;let r=i+".com";if(await o(r)||(r=i+".exe",await o(r)))return r}return u.$kc(v,E)}P.findExecutable=$})(A||(e.win32=A={}))});var Je=this&&this.__decorate||function(le,e,u,N){var L=arguments.length,R=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,u):N,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(le,e,u,N);else for(var p=le.length-1;p>=0;p--)(M=le[p])&&(R=(L<3?M(R):L>3?M(e,u,R):M(e,u))||R);return L>3&&R&&Object.defineProperty(e,u,R),R};define(ke[81],Ee([1,0,19,7,21,22,55,13,4,3,58,14,18]),function(le,e,u,N,L,R,M,p,b,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.ProxyChannel=e.$$h=e.$8h=e.$7h=e.$6h=e.RequestInitiator=e.$5h=e.$2h=e.$1h=void 0,e.$3h=h,e.$4h=g,e.$9h=I,e.$0h=F;var E;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(E||(E={}));function v(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(a||(a={}));function m(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(o||(o={}));function n(x){let X=0;for(let Y=0;;Y+=7){const ce=x.read(1);if(X|=(ce.buffer[0]&127)<<Y,!(ce.buffer[0]&128))return X}}const i=d(0);function r(x,X){if(X===0){x.write(i);return}let Y=0;for(let ne=X;ne!==0;ne=ne>>>7)Y++;const ce=L.$Ce.alloc(Y);for(let ne=0;X!==0;ne++)ce.buffer[ne]=X&127,X=X>>>7,X>0&&(ce.buffer[ne]|=128);x.write(ce)}class s{constructor(X){this.b=X,this.a=0}read(X){const Y=this.b.slice(this.a,this.a+X);return this.a+=Y.byteLength,Y}}e.$1h=s;class t{constructor(){this.a=[]}get buffer(){return L.$Ce.concat(this.a)}write(X){this.a.push(X)}}e.$2h=t;var f;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(f||(f={}));function d(x){const X=L.$Ce.alloc(1);return X.writeUInt8(x,0),X}const l={Undefined:d(f.Undefined),String:d(f.String),Buffer:d(f.Buffer),VSBuffer:d(f.VSBuffer),Array:d(f.Array),Object:d(f.Object),Uint:d(f.Int)},c=typeof Buffer<"u";function h(x,X){if(typeof X>"u")x.write(l.Undefined);else if(typeof X=="string"){const Y=L.$Ce.fromString(X);x.write(l.String),r(x,Y.byteLength),x.write(Y)}else if(c&&Buffer.isBuffer(X)){const Y=L.$Ce.wrap(X);x.write(l.Buffer),r(x,Y.byteLength),x.write(Y)}else if(X instanceof L.$Ce)x.write(l.VSBuffer),r(x,X.byteLength),x.write(X);else if(Array.isArray(X)){x.write(l.Array),r(x,X.length);for(const Y of X)h(x,Y)}else if(typeof X=="number"&&(X|0)===X)x.write(l.Uint),r(x,X);else{const Y=L.$Ce.fromString(JSON.stringify(X));x.write(l.Object),r(x,Y.byteLength),x.write(Y)}}function g(x){switch(x.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return x.read(n(x)).toString();case f.Buffer:return x.read(n(x)).buffer;case f.VSBuffer:return x.read(n(x));case f.Array:{const Y=n(x),ce=[];for(let ne=0;ne<Y;ne++)ce.push(g(x));return ce}case f.Object:return JSON.parse(x.read(n(x)).toString());case f.Int:return n(x)}}class D{constructor(X,Y,ce=null,ne=1e3){this.h=X,this.j=Y,this.k=ce,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage($e=>this.q($e)),this.m({type:200})}registerChannel(X,Y){this.b.set(X,Y),setTimeout(()=>this.w(X),0)}m(X){switch(X.type){case 200:{const Y=this.o([X.type]);this.k?.logOutgoing(Y,0,1,m(X.type));return}case 201:case 202:case 204:case 203:{const Y=this.o([X.type,X.id],X.data);this.k?.logOutgoing(Y,X.id,1,m(X.type),X.data);return}}}o(X,Y=void 0){const ce=new t;return h(ce,X),h(ce,Y),this.p(ce.buffer)}p(X){try{return this.h.send(X),X.byteLength}catch{return 0}}q(X){const Y=new s(X),ce=g(Y),ne=g(Y),$e=ce[0];switch($e){case 100:return this.k?.logIncoming(X.byteLength,ce[1],1,`${v($e)}: ${ce[2]}.${ce[3]}`,ne),this.s({type:$e,id:ce[1],channelName:ce[2],name:ce[3],arg:ne});case 102:return this.k?.logIncoming(X.byteLength,ce[1],1,`${v($e)}: ${ce[2]}.${ce[3]}`,ne),this.t({type:$e,id:ce[1],channelName:ce[2],name:ce[3],arg:ne});case 101:return this.k?.logIncoming(X.byteLength,ce[1],1,`${v($e)}`),this.u({type:$e,id:ce[1]});case 103:return this.k?.logIncoming(X.byteLength,ce[1],1,`${v($e)}`),this.u({type:$e,id:ce[1]})}}s(X){const Y=this.b.get(X.channelName);if(!Y){this.v(X);return}const ce=new R.$me;let ne;try{ne=Y.call(this.j,X.name,X.arg,ce.token)}catch(ee){ne=Promise.reject(ee)}const $e=X.id;ne.then(ee=>{this.m({id:$e,data:ee,type:201})},ee=>{ee instanceof Error?this.m({id:$e,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split?ee.stack.split(`
`):ee.stack:void 0},type:202}):this.m({id:$e,data:ee,type:203})}).finally(()=>{Ce.dispose(),this.d.delete(X.id)});const Ce=(0,S.$Sc)(()=>ce.cancel());this.d.set(X.id,Ce)}t(X){const Y=this.b.get(X.channelName);if(!Y){this.v(X);return}const ce=X.id,$e=Y.listen(this.j,X.name,X.arg)(Ce=>this.m({id:ce,data:Ce,type:204}));this.d.set(X.id,$e)}u(X){const Y=this.d.get(X.id);Y&&(Y.dispose(),this.d.delete(X.id))}v(X){let Y=this.g.get(X.channelName);Y||(Y=[],this.g.set(X.channelName,Y));const ce=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.m({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:X,timeoutTimer:ce})}w(X){const Y=this.g.get(X);if(Y){for(const ce of Y)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.s(ce.request);break;case 102:this.t(ce.request);break}this.g.delete(X)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.$Pc)(this.d.values()),this.d.clear()}}e.$5h=D;var w;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class k{constructor(X,Y=null){this.l=X,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$be,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=Y}getChannel(X){const Y=this;return{call(ce,ne,$e){return Y.a?Promise.reject(new p.$5):Y.m(X,ce,ne,$e)},listen(ce,ne){return Y.a?b.Event.None:Y.o(X,ce,ne)}}}m(X,Y,ce,ne=R.CancellationToken.None){const $e=this.g++,ee={id:$e,type:100,channelName:X,name:Y,arg:ce};if(ne.isCancellationRequested)return Promise.reject(new p.$5);let U;return new Promise((be,Pe)=>{if(ne.isCancellationRequested)return Pe(new p.$5);const oe=()=>{const te=ge=>{switch(ge.type){case 201:this.f.delete($e),be(ge.data);break;case 202:{this.f.delete($e);const we=new Error(ge.data.message);we.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,we.name=ge.data.name,Pe(we);break}case 203:this.f.delete($e),Pe(ge.data);break}};this.f.set($e,te),this.p(ee)};let ae=null;this.b===o.Idle?oe():(ae=(0,N.$dh)(te=>this.u()),ae.then(()=>{ae=null,oe()}));const re=()=>{ae?(ae.cancel(),ae=null):this.p({id:$e,type:101}),Pe(new p.$5)},G=ne.onCancellationRequested(re);U=(0,S.$Rc)((0,S.$Sc)(re),G),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(X,Y,ce){const ne=this.g++,Ce={id:ne,type:102,channelName:X,name:Y,arg:ce};let ee=null;const U=new b.$be({onWillAddFirstListener:()=>{ee=(0,N.$dh)(be=>this.u()),ee.then(()=>{ee=null,this.d.add(U),this.p(Ce)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.d.delete(U),this.p({id:ne,type:103}))}}),ie=be=>U.fire(be.data);return this.f.set(ne,ie),U.event}p(X){switch(X.type){case 100:case 102:{const Y=this.q([X.type,X.id,X.channelName,X.name],X.arg);this.j?.logOutgoing(Y,X.id,0,`${v(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const Y=this.q([X.type,X.id]);this.j?.logOutgoing(Y,X.id,0,v(X.type));return}}}q(X,Y=void 0){const ce=new t;return h(ce,X),h(ce,Y),this.r(ce.buffer)}r(X){try{return this.l.send(X),X.byteLength}catch{return 0}}s(X){const Y=new s(X),ce=g(Y),ne=g(Y),$e=ce[0];switch($e){case 200:return this.j?.logIncoming(X.byteLength,0,0,m($e)),this.t({type:ce[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(X.byteLength,ce[1],0,m($e),ne),this.t({type:ce[0],id:ce[1],data:ne})}}t(X){if(X.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(X.id)?.(X)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.$Pc)(this.d.values()),this.d.clear()}}e.$6h=k,Je([M.$Uh],k.prototype,"onDidInitializePromise",null);class y{get connections(){const X=[];return this.f.forEach(Y=>X.push(Y)),X}constructor(X,Y,ce){this.a=new Map,this.f=new Set,this.g=new b.$be,this.onDidAddConnection=this.g.event,this.h=new b.$be,this.onDidRemoveConnection=this.h.event,this.j=new S.$Tc,this.j.add(X(({protocol:ne,onDidClientDisconnect:$e})=>{const Ce=b.Event.once(ne.onMessage);this.j.add(Ce(ee=>{const U=new s(ee),ie=g(U),be=new D(ne,ie,Y,ce),Pe=new k(ne,Y);this.a.forEach((ae,re)=>be.registerChannel(re,ae));const oe={channelServer:be,channelClient:Pe,ctx:ie};this.f.add(oe),this.g.fire(oe),this.j.add($e(()=>{be.dispose(),Pe.dispose(),this.f.delete(oe),this.h.fire(oe)}))}))}))}getChannel(X,Y){const ce=this;return{call(ne,$e,Ce){let ee;if((0,$.$fg)(Y)){const ie=(0,u.$4b)(ce.connections.filter(Y));ee=ie?Promise.resolve(ie):b.Event.toPromise(b.Event.filter(ce.onDidAddConnection,Y))}else ee=Y.routeCall(ce,ne,$e);const U=ee.then(ie=>ie.channelClient.getChannel(X));return I(U).call(ne,$e,Ce)},listen(ne,$e){if((0,$.$fg)(Y))return ce.k(X,Y,ne,$e);const Ce=Y.routeEvent(ce,ne,$e).then(ee=>ee.channelClient.getChannel(X));return I(Ce).listen(ne,$e)}}}k(X,Y,ce,ne){const $e=this;let Ce;const ee=new b.$be({onWillAddFirstListener:()=>{Ce=new S.$Tc;const U=new b.$he,ie=new Map,be=oe=>{const re=oe.channelClient.getChannel(X).listen(ce,ne),G=U.add(re);ie.set(oe,G)},Pe=oe=>{const ae=ie.get(oe);ae&&(ae.dispose(),ie.delete(oe))};$e.connections.filter(Y).forEach(be),b.Event.filter($e.onDidAddConnection,Y)(be,void 0,Ce),$e.onDidRemoveConnection(Pe,void 0,Ce),U.event(ee.fire,ee,Ce),Ce.add(U)},onDidRemoveLastListener:()=>{Ce?.dispose(),Ce=void 0}});return ee.event}registerChannel(X,Y){this.a.set(X,Y);for(const ce of this.f)ce.channelServer.registerChannel(X,Y)}dispose(){this.j.dispose();for(const X of this.f)X.channelClient.dispose(),X.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$7h=y;class C{constructor(X,Y,ce=null){const ne=new t;h(ne,Y),X.send(ne.buffer),this.a=new k(X,ce),this.d=new D(X,Y,ce)}getChannel(X){return this.a.getChannel(X)}registerChannel(X,Y){this.d.registerChannel(X,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.$8h=C;function I(x){return{call(X,Y,ce){return x.then(ne=>ne.call(X,Y,ce))},listen(X,Y){const ce=new b.$ke;return x.then(ne=>ce.input=ne.listen(X,Y)),ce.event}}}function F(x){let X=!1;return{call(Y,ce,ne){return X?x.call(Y,ce,ne):(0,N.$rh)(0).then(()=>X=!0).then(()=>x.call(Y,ce,ne))},listen(Y,ce){if(X)return x.listen(Y,ce);const ne=new b.$ke;return(0,N.$rh)(0).then(()=>X=!0).then(()=>ne.input=x.listen(Y,ce)),ne.event}}}class j{constructor(X){this.a=X}routeCall(X){return this.b(X)}routeEvent(X){return this.b(X)}async b(X){for(const Y of X.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await b.Event.toPromise(X.onDidAddConnection),await this.b(X)}}e.$$h=j;var z;(function(x){function X($e,Ce,ee){const U=$e,ie=ee&&ee.disableMarshalling,be=new Map;for(const Pe in U)ce(Pe)&&be.set(Pe,b.Event.buffer(U[Pe],!0,void 0,Ce));return new class{listen(Pe,oe,ae){const re=be.get(oe);if(re)return re;const G=U[oe];if(typeof G=="function"){if(ne(oe))return G.call(U,ae);if(ce(oe))return be.set(oe,b.Event.buffer(U[oe],!0,void 0,Ce)),be.get(oe)}throw new p.$bb(`Event not found: ${oe}`)}call(Pe,oe,ae){const re=U[oe];if(typeof re=="function"){if(!ie&&Array.isArray(ae))for(let te=0;te<ae.length;te++)ae[te]=(0,A.$Zh)(ae[te]);let G=re.apply(U,ae);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new p.$bb(`Method not found: ${oe}`)}}}x.fromService=X;function Y($e,Ce){const ee=Ce&&Ce.disableMarshalling;return new Proxy({},{get(U,ie){if(typeof ie=="string")return Ce?.properties?.has(ie)?Ce.properties.get(ie):ne(ie)?function(be){return $e.listen(ie,be)}:ce(ie)?$e.listen(ie):async function(...be){let Pe;Ce&&!(0,$.$ag)(Ce.context)?Pe=[Ce.context,...be]:Pe=be;const oe=await $e.call(ie,Pe);return ee?oe:(0,A.$Zh)(oe)};throw new p.$bb(`Property not found: ${String(ie)}`)}})}x.toService=Y;function ce($e){return $e[0]==="o"&&$e[1]==="n"&&P.$sf($e.charCodeAt(2))}function ne($e){return/^onDynamic/.test($e)&&P.$sf($e.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const X=x.toString();if(X!=="[object Object]")return X}return x}function B(x){return Array.isArray(x)?x.map(T):T(x)}function W(x,X,Y,ce,ne,$e,Ce){Ce=B(Ce);const ee=O[ne],U=ee[ce%ee.length];let ie=[`%c[${x}]%c[${String(X).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${$e}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test($e)?(ie=ie.concat(Ce),ie.push(")")):ie.push(Ce),console.log.apply(console,ie)}class Z{constructor(X,Y){this.d=X,this.f=Y,this.a=0,this.b=0}logOutgoing(X,Y,ce,ne,$e){this.b+=X,W(this.d,this.b,X,Y,ce,ne,$e)}logIncoming(X,Y,ce,ne,$e){this.a+=X,W(this.f,this.a,X,Y,ce,ne,$e)}}e.$_h=Z}),define(ke[82],Ee([1,0,21,4,3,81]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.ProtocolConstants=e.$ai=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(M||(e.SocketDiagnosticsEventType=M={}));var p;(function(l){l.enableDiagnostics=!1,l.records=[];const c=new WeakMap;let h=0;function g(w,k){if(!c.has(w)){const y=String(++h);c.set(w,y)}return c.get(w)}function D(w,k,y,C){if(!l.enableDiagnostics)return;const I=g(w,k);if(C instanceof u.$Ce||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const F=u.$Ce.alloc(C.byteLength);F.set(C),l.records.push({timestamp:Date.now(),id:I,label:k,type:y,buff:F})}else l.records.push({timestamp:Date.now(),id:I,label:k,type:y,data:C})}l.traceSocketEvent=D})(p||(e.SocketDiagnostics=p={}));var b;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let S=null;function A(){return S||(S=u.$Ce.alloc(0)),S}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,h){if(c===0)return A();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const k=this.a[0];return h&&(this.a.shift(),this.b-=c),k}if(this.a[0].byteLength>c){const k=this.a[0].slice(0,c);return h&&(this.a[0]=this.a[0].slice(c),this.b-=c),k}const g=u.$Ce.alloc(c);let D=0,w=0;for(;c>0;){const k=this.a[w];if(k.byteLength>c){const y=k.slice(0,c);g.set(y,D),D+=c,h&&(this.a[w]=k.slice(c),this.b-=c),c-=c}else g.set(k,D),D+=k.byteLength,h?(this.a.shift(),this.b-=k.byteLength):w++,c-=k.byteLength}return g}}e.$ai=P;var $;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})($||($={}));function E(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class a{constructor(c,h,g,D){this.type=c,this.id=h,this.ack=g,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends L.$Uc{constructor(c){super(),this.f=this.B(new N.$be),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new P,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const g=this.g.messageType,D=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new a(g,D,w,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=u.$Ce.alloc(13);h.writeUInt8(c.type,0),h.writeUInt32BE(c.id,1),h.writeUInt32BE(c.ack,5),h.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(h,c.data)}g(c,h){const g=this.f===0;return this.d.push(c,h),this.f+=c.byteLength+h.byteLength,g}h(){const c=u.$Ce.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,h){this.g(c,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class n extends L.$Uc{constructor(c){super(),this.f=new N.$be,this.onMessage=this.f.event,this.g=new N.$be,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new o(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new a(1,0,0,c))}}e.$bi=n;class i extends R.$8h{static fromSocket(c,h){return new i(new n(c),h)}get onDidDispose(){return this.b.onDidDispose}constructor(c,h,g=null){super(c,h,g),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$ci=i;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$be({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$di=r;class s{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,h=this.a;for(;h;)h=h.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let h=0,g=this.a;for(;g;)c[h++]=g.data,g=g.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const h=new s(c);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class f{static{this.a=10}static{this.b=null}static getInstance(){return f.b||(f.b=new f),f.b}constructor(){this.c=[];const c=Date.now();for(let h=0;h<f.a;h++)this.c[h]=c-1e3*h;setInterval(()=>{for(let h=f.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),h=(1+f.a)*1e3;let g=0;for(let D=0;D<f.a;D++)c-this.c[D]<=h&&g++;return 1-g/f.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??f.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Tc,this.o=c.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new a(5,0,0,A());this.p.write(c),this.p.flush()}sendPause(){const c=new a(7,0,0,A());this.p.write(c)}sendResume(){const c=new a(8,0,0,A());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,h){this.a=!0,this.r.dispose(),this.r=new L.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new a(3,0,this.h,A());this.p.write(c);const h=this.b.toArray();for(let g=0,D=h.length;g<D;g++)this.p.write(h[g]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const h=this.b.peek();if(h&&h.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new a(6,0,0,A())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let g=0,D=h.length;g<D;g++)this.p.write(h[g]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const h=++this.c;this.h=this.g;const g=new a(1,h,this.h,c);this.b.push(g),this.a||(this.p.write(g),this.B())}sendControl(c){const h=new a(2,0,0,c);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),h=Date.now()-c.writtenTime,g=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(h>=2e4&&g>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:g});return}const w=Math.max(2e4-h,2e4-g,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new a(3,0,this.h,A());this.p.write(c)}D(){this.h=this.g;const c=new a(9,0,this.h,A());this.p.write(c)}}e.$ei=d}),define(ke[194],Ee([1,0,53,7,21,22,192,13,4,3,24,105,102,81]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;class v extends E.$5h{constructor(o){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",n=>L.$Ce.wrap(Buffer.from(n,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Rq=v;class a{constructor(o,n){this.i=o,this.j=n,this.c=new Set,this.g=new Map,this.h=new b.$be,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new N.$nh(i),this.d=null,this.f=null}getChannel(o){const n=this;return{call(i,r,s){return n.k(o,i,r,s)},listen(i,r){return n.l(o,i,r)}}}k(o,n,i,r=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(p.$6());this.b.cancel();const s=this.n(o),t=(0,N.$dh)(l=>s.call(n,i,l)),f=r.onCancellationRequested(()=>t.cancel()),d=(0,S.$Sc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{f.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,n,i){if(!this.b)return b.Event.None;this.b.cancel();let r;const s=new b.$be({onWillAddFirstListener:()=>{r=this.n(o).listen(n,i)(s.fire,s),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,A.$Wn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,$.$hm)(n.env),this.d=(0,u.fork)(this.i,o,n);const i=new b.$be,s=b.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,M.$Nq)(h)){(0,M.log)(h,`IPC Library: ${this.j.serverName}`);return}i.fire(L.$Ce.wrap(Buffer.from(h,"base64")))}),t=this.j.useQueue?(0,P.$jm)(this.d):this.d,f=h=>this.d&&this.d.connected&&t.send(h.buffer.toString("base64")),d=i.event,l={send:f,onMessage:d};this.f=new E.$6h(l);const c=()=>this.o();process.once("exit",c),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,g)=>{process.removeListener("exit",c),s.dispose(),this.c.forEach(D=>(0,S.$Pc)(D)),this.c.clear(),h!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+g),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:g})})}return this.f}n(o){let n=this.g.get(o);return n||(n=this.m.getChannel(o),this.g.set(o,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sq=a}),define(ke[195],Ee([1,0,7,4,3,58,18]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.StorageState=e.StorageHint=void 0,e.$Pp=b;var p;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function b($){const E=$;return E?.changed instanceof Map||E?.deleted instanceof Set}var S;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(S||(e.StorageState=S={}));class A extends L.$Uc{static{this.a=100}constructor(E,v=Object.create(null)){super(),this.r=E,this.s=v,this.b=this.B(new N.$ee),this.onDidChangeStorage=this.b.event,this.c=S.None,this.f=new Map,this.g=this.B(new u.$oh(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((v,a)=>this.w(a,v)),E.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(E,v){if(this.c===S.Closed)return;let a=!1;(0,M.$ag)(v)?a=this.f.delete(E):this.f.get(E)!==v&&(this.f.set(E,v),a=!0),a&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===S.None&&(this.c=S.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,v){const a=this.f.get(E);return(0,M.$ag)(a)?v:a}getBoolean(E,v){const a=this.get(E);return(0,M.$ag)(a)?v:a==="true"}getNumber(E,v){const a=this.get(E);return(0,M.$ag)(a)?v:parseInt(a,10)}getObject(E,v){const a=this.get(E);return(0,M.$ag)(a)?v:(0,R.$Yh)(a)}async set(E,v,a=!1){if(this.c===S.Closed)return;if((0,M.$ag)(v))return this.delete(E,a);const m=(0,M.$6f)(v)||Array.isArray(v)?(0,R.$Xh)(v):String(v);if(this.f.get(E)!==m)return this.f.set(E,m),this.j.set(E,m),this.h.delete(E),this.b.fire({key:E,external:a}),this.D()}async delete(E,v=!1){if(!(this.c===S.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:v}),this.D()}async optimize(){if(this.c!==S.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=S.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(this.z)return this.D(E)}async D(E){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$Qp=A;class P{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((v,a)=>this.a.set(a,v)),E.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$Rp=P}),define(ke[196],Ee([1,0,14,11,21]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$tt=A,e.$ut=P;let R;function M(){return R||(R=new TextDecoder("UTF-16LE")),R}let p;function b(){return p||(p=new TextDecoder("UTF-16BE")),p}let S;function A(){return S||(S=N.$D()?M():b()),S}function P(v,a,m){const o=new Uint16Array(v.buffer,a,m);return m>0&&(o[0]===65279||o[0]===65534)?$(v,a,m):M().decode(o)}function $(v,a,m){const o=[];let n=0;for(let i=0;i<m;i++){const r=L.$Ee(v,a);a+=2,o[n++]=String.fromCharCode(r)}return o.join("")}class E{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return A().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const m=this.a-this.d;m<=1&&(m===0||u.$xf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const m=a.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=a;return}for(let o=0;o<m;o++)this.b[this.d++]=a.charCodeAt(o)}}e.$vt=E}),define(ke[197],Ee([1,0,21,196]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$xt=M;function L(b){return b.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(S,A,P,$){this.oldPosition=S,this.oldText=A,this.newPosition=P,this.newText=$}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static a(S){return 4+2*S.length}static c(S,A,P){const $=A.length;u.$He(S,$,P),P+=4;for(let E=0;E<$;E++)u.$Fe(S,A.charCodeAt(E),P),P+=2;return P}static d(S,A){const P=u.$Ge(S,A);return A+=4,(0,N.$ut)(S,A,P)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(S,A){return u.$He(S,this.oldPosition,A),A+=4,u.$He(S,this.newPosition,A),A+=4,A=R.c(S,this.oldText,A),A=R.c(S,this.newText,A),A}static read(S,A,P){const $=u.$Ge(S,A);A+=4;const E=u.$Ge(S,A);A+=4;const v=R.d(S,A);A+=R.a(v);const a=R.d(S,A);return A+=R.a(a),P.push(new R($,v,E,a)),A}}e.$wt=R;function M(b,S){return b===null||b.length===0?S:new p(b,S).compress()}class p{constructor(S,A){this.a=S,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let S=0,A=0,P=this.n(S),$=this.l(A);for(;S<this.f||A<this.h;){if(P===null){this.k($),$=this.l(++A);continue}if($===null){this.m(P),P=this.n(++S);continue}if($.oldEnd<=P.newPosition){this.k($),$=this.l(++A);continue}if(P.newEnd<=$.oldPosition){this.m(P),P=this.n(++S);continue}if($.oldPosition<P.newPosition){const[o,n]=p.r($,P.newPosition-$.oldPosition);this.k(o),$=n;continue}if(P.newPosition<$.oldPosition){const[o,n]=p.q(P,$.oldPosition-P.newPosition);this.m(o),P=n;continue}let a,m;if($.oldEnd===P.newEnd)a=P,m=$,P=this.n(++S),$=this.l(++A);else if($.oldEnd<P.newEnd){const[o,n]=p.q(P,$.oldLength);a=o,m=$,P=n,$=this.l(++A)}else{const[o,n]=p.r($,P.newLength);a=P,m=o,P=this.n(++S),$=n}this.d[this.e++]=new R(a.oldPosition,a.oldText,m.newPosition,m.newText),this.g+=a.newLength-a.oldLength,this.j+=m.newLength-m.oldLength}const E=p.s(this.d);return p.t(E)}k(S){this.d[this.e++]=p.o(this.g,S),this.j+=S.newLength-S.oldLength}l(S){return S<this.h?this.c[S]:null}m(S){this.d[this.e++]=p.p(this.j,S),this.g+=S.newLength-S.oldLength}n(S){return S<this.f?this.a[S]:null}static o(S,A){return new R(A.oldPosition-S,A.oldText,A.newPosition,A.newText)}static p(S,A){return new R(A.oldPosition,A.oldText,A.newPosition+S,A.newText)}static q(S,A){const P=S.newText.substr(0,A),$=S.newText.substr(A);return[new R(S.oldPosition,S.oldText,S.newPosition,P),new R(S.oldEnd,"",S.newPosition+A,$)]}static r(S,A){const P=S.oldText.substr(0,A),$=S.oldText.substr(A);return[new R(S.oldPosition,P,S.newPosition,S.newText),new R(S.oldPosition+A,$,S.newEnd,"")]}static s(S){if(S.length===0)return S;const A=[];let P=0,$=S[0];for(let E=1;E<S.length;E++){const v=S[E];$.oldEnd===v.oldPosition?$=new R($.oldPosition,$.oldText+v.oldText,$.newPosition,$.newText+v.newText):(A[P++]=$,$=v)}return A[P++]=$,A}static t(S){if(S.length===0)return S;const A=[];let P=0;for(let $=0;$<S.length;$++){const E=S[$];E.oldText!==E.newText&&(A[P++]=E)}return A}}}),define(ke[198],Ee([1,0,35,17]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=L,e.$Vt=R;function L(M,p,b,S,A,P){if(Array.isArray(M)){let $=0;for(const E of M){const v=L(E,p,b,S,A,P);if(v===10)return v;v>$&&($=v)}return $}else{if(typeof M=="string")return S?M==="*"?5:M===b?10:0:0;if(M){const{language:$,pattern:E,scheme:v,hasAccessToAllModels:a,notebookType:m}=M;if(!S&&!a)return 0;m&&A&&(p=A);let o=0;if(v)if(v===p.scheme)o=10;else if(v==="*")o=5;else return 0;if($)if($===b)o=10;else if($==="*")o=Math.max(o,5);else return 0;if(m)if(m===P)o=10;else if(m==="*"&&P!==void 0)o=Math.max(o,5);else return 0;if(E){let n;if(typeof E=="string"?n=E:n={...E,base:(0,N.$ic)(E.base)},n===p.fsPath||(0,u.$jk)(n,p.fsPath))o=10;else return 0}return o}else return 0}}function R(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(R):!!M.notebookType}}),define(ke[199],Ee([1,0,4,14,29,79,130,174,197,3]),function(le,e,u,N,L,R,M,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=void 0;class A extends S.$Uc{constructor($,E,v,a,m,o,n){super(),this.m=this.B(new u.$be),this.onDidChangeContent=this.m.event,this.f=E,this.j=!o,this.g=a,this.h=m,this.c=new M.$KC($,v,n)}equals($){return!($ instanceof A)||this.f!==$.f||this.getEOL()!==$.getEOL()?!1:this.c.equal($.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot($){return this.c.createSnapshot($?this.f:"")}getOffsetAt($,E){return this.c.getOffsetAt($,E)}getPositionAt($){return this.c.getPositionAt($)}getRangeAt($,E){const v=$+E,a=this.getPositionAt($),m=this.getPositionAt(v);return new L.$kt(a.lineNumber,a.column,m.lineNumber,m.column)}getValueInRange($,E=0){if($.isEmpty())return"";const v=this.n(E);return this.c.getValueInRange($,v)}getValueLengthInRange($,E=0){if($.isEmpty())return 0;if($.startLineNumber===$.endLineNumber)return $.endColumn-$.startColumn;const v=this.getOffsetAt($.startLineNumber,$.startColumn),a=this.getOffsetAt($.endLineNumber,$.endColumn);let m=0;const o=this.n(E),n=this.getEOL();if(o.length!==n.length){const i=o.length-n.length,r=$.endLineNumber-$.startLineNumber;m=i*r}return a-v+m}getCharacterCountInRange($,E=0){if(this.j){let v=0;const a=$.startLineNumber,m=$.endLineNumber;for(let o=a;o<=m;o++){const n=this.getLineContent(o),i=o===a?$.startColumn-1:0,r=o===m?$.endColumn-1:n.length;for(let s=i;s<r;s++)N.$xf(n.charCodeAt(s))?(v=v+1,s=s+1):v=v+1}return v+=this.n(E).length*(m-a),v}return this.getValueLengthInRange($,E)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent($){return this.c.getLineContent($)}getLineCharCode($,E){return this.c.getLineCharCode($,E)}getCharCode($){return this.c.getCharCode($)}getLineLength($){return this.c.getLineLength($)}getLineMinColumn($){return 1}getLineMaxColumn($){return this.getLineLength($)+1}getLineFirstNonWhitespaceColumn($){const E=N.$if(this.getLineContent($));return E===-1?0:E+1}getLineLastNonWhitespaceColumn($){const E=N.$kf(this.getLineContent($));return E===-1?0:E+2}n($){switch($){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL($){this.c.setEOL($)}applyEdits($,E,v){let a=this.g,m=this.h,o=this.j,n=!0,i=[];for(let c=0;c<$.length;c++){const h=$[c];n&&h._isTracked&&(n=!1);const g=h.range;if(h.text){let C=!0;o||(C=!N.$If(h.text),o=C),!a&&C&&(a=N.$Hf(h.text)),!m&&C&&(m=N.$Kf(h.text))}let D="",w=0,k=0,y=0;if(h.text){let C;[w,k,y,C]=(0,p.$Nt)(h.text);const I=this.getEOL();C===0||C===(I===`\r
`?2:1)?D=h.text:D=h.text.replace(/\r\n|\r|\n/g,I)}i[c]={sortIndex:c,identifier:h.identifier||null,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g),text:D,eolCount:w,firstLineLength:k,lastLineLength:y,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}i.sort(A.u);let r=!1;for(let c=0,h=i.length-1;c<h;c++){const g=i[c].range.getEndPosition(),D=i[c+1].range.getStartPosition();if(D.isBeforeOrEqual(g)){if(D.isBefore(g))throw new Error("Overlapping ranges are not allowed!");r=!0}}n&&(i=this.s(i));const s=v||E?A._getInverseEditRanges(i):[],t=[];if(E)for(let c=0;c<i.length;c++){const h=i[c],g=s[c];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let D=g.startLineNumber;D<=g.endLineNumber;D++){let w="";D===g.startLineNumber&&(w=this.getLineContent(h.range.startLineNumber),N.$if(w)!==-1)||t.push({lineNumber:D,oldContent:w})}}let f=null;if(v){let c=0;f=[];for(let h=0;h<i.length;h++){const g=i[h],D=s[h],w=this.getValueInRange(g.range),k=g.rangeOffset+c;c+=g.text.length-w.length,f[h]={sortIndex:g.sortIndex,identifier:g.identifier,range:D,text:w,textChange:new b.$wt(g.rangeOffset,w,k,g.text)}}r||f.sort((h,g)=>h.sortIndex-g.sortIndex)}this.g=a,this.h=m,this.j=o;const d=this.t(i);let l=null;if(E&&t.length>0){t.sort((c,h)=>h.lineNumber-c.lineNumber),l=[];for(let c=0,h=t.length;c<h;c++){const g=t[c].lineNumber;if(c>0&&t[c-1].lineNumber===g)continue;const D=t[c].oldContent,w=this.getLineContent(g);w.length===0||w===D||N.$if(w)!==-1||l.push(g)}}return this.m.fire(),new R.$zv(f,d,l)}s($){return $.length<1e3?$:[this._toSingleEditOperation($)]}_toSingleEditOperation($){let E=!1;const v=$[0].range,a=$[$.length-1].range,m=new L.$kt(v.startLineNumber,v.startColumn,a.endLineNumber,a.endColumn);let o=v.startLineNumber,n=v.startColumn;const i=[];for(let d=0,l=$.length;d<l;d++){const c=$[d],h=c.range;E=E||c.forceMoveMarkers,i.push(this.getValueInRange(new L.$kt(o,n,h.startLineNumber,h.startColumn))),c.text.length>0&&i.push(c.text),o=h.endLineNumber,n=h.endColumn}const r=i.join(""),[s,t,f]=(0,p.$Nt)(r);return{sortIndex:0,identifier:$[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:r,eolCount:s,firstLineLength:t,lastLineLength:f,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t($){$.sort(A.w);const E=[];for(let v=0;v<$.length;v++){const a=$[v],m=a.range.startLineNumber,o=a.range.startColumn,n=a.range.endLineNumber,i=a.range.endColumn;if(m===n&&o===i&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const r=new L.$kt(m,o,n,i);E.push({range:r,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return E}findMatchesLineByLine($,E,v,a){return this.c.findMatchesLineByLine($,E,v,a)}getPieceTree(){return this.c}static _getInverseEditRange($,E){const v=$.startLineNumber,a=$.startColumn,[m,o,n]=(0,p.$Nt)(E);let i;if(E.length>0){const r=m+1;r===1?i=new L.$kt(v,a,v,a+o):i=new L.$kt(v,a,v+r-1,n+1)}else i=new L.$kt(v,a,v,a);return i}static _getInverseEditRanges($){const E=[];let v=0,a=0,m=null;for(let o=0,n=$.length;o<n;o++){const i=$[o];let r,s;m?m.range.endLineNumber===i.range.startLineNumber?(r=v,s=a+(i.range.startColumn-m.range.endColumn)):(r=v+(i.range.startLineNumber-m.range.endLineNumber),s=i.range.startColumn):(r=i.range.startLineNumber,s=i.range.startColumn);let t;if(i.text.length>0){const f=i.eolCount+1;f===1?t=new L.$kt(r,s,r,s+i.firstLineLength):t=new L.$kt(r,s,r+f-1,i.lastLineLength+1)}else t=new L.$kt(r,s,r,s);v=t.endLineNumber,a=t.endColumn,E.push(t),m=i}return E}static u($,E){const v=L.$kt.compareRangesUsingEnds($.range,E.range);return v===0?$.sortIndex-E.sortIndex:v}static w($,E){const v=L.$kt.compareRangesUsingEnds($.range,E.range);return v===0?E.sortIndex-$.sortIndex:-v}}e.$LC=A}),define(ke[200],Ee([1,0,14,130,199]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=void 0;class R{constructor(b,S,A,P,$,E,v,a,m){this.a=b,this.b=S,this.c=A,this.d=P,this.e=$,this.f=E,this.g=v,this.h=a,this.j=m}k(b){const S=this.c+this.d+this.e,A=this.c+this.e;return S===0?b===1?`
`:`\r
`:A>S/2?`\r
`:`
`}create(b){const S=this.k(b),A=this.a;if(this.j&&(S===`\r
`&&(this.c>0||this.d>0)||S===`
`&&(this.c>0||this.e>0)))for(let $=0,E=A.length;$<E;$++){const v=A[$].buffer.replace(/\r\n|\r|\n/g,S),a=(0,N.$GC)(v);A[$]=new N.$JC(v,a)}const P=new L.$LC(A,this.b,S,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(b){return this.a[0].buffer.substr(0,b).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(b){if(b.length===0)return;this.a.length===0&&u.$Rf(b)&&(this.b=u.$Qf,b=b.substr(1));const S=b.charCodeAt(b.length-1);S===13||S>=55296&&S<=56319?(this.m(b.substr(0,b.length-1),!1),this.c=!0,this.d=S):(this.m(b,!1),this.c=!1,this.d=S)}m(b,S){!S&&b.length===0||(this.c?this.n(String.fromCharCode(this.d)+b):this.n(b))}n(b){const S=(0,N.$HC)(this.e,b);this.a.push(new N.$JC(b,S.lineStarts)),this.f+=S.cr,this.g+=S.lf,this.h+=S.crlf,S.isBasicASCII||(this.l=!1,this.j||(this.j=u.$Hf(b)),this.k||(this.k=u.$Kf(b)))}finish(b=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,b)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const b=this.a[this.a.length-1];b.buffer+=String.fromCharCode(this.d);const S=(0,N.$GC)(b.buffer);b.lineStarts=S,this.d===13&&this.f++}}}e.$MC=M}),define(ke[134],Ee([1,0,21,11]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbb=b,e.$ibb=A;var L;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(L||(L={}));function R(P){for(let $=0,E=P.length;$<E;$+=4){const v=P[$+0],a=P[$+1],m=P[$+2],o=P[$+3];P[$+0]=o,P[$+1]=m,P[$+2]=a,P[$+3]=v}}function M(P){const $=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return N.$D()||R($),u.$Ce.wrap($)}function p(P){const $=P.buffer;if(N.$D()||R($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const E=new Uint8Array($.byteLength);return E.set($),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function b(P){const $=new Uint32Array(S(P));let E=0;if($[E++]=P.id,P.type==="full")$[E++]=1,$[E++]=P.data.length,$.set(P.data,E),E+=P.data.length;else{$[E++]=2,$[E++]=P.deltas.length;for(const v of P.deltas)$[E++]=v.start,$[E++]=v.deleteCount,v.data?($[E++]=v.data.length,$.set(v.data,E),E+=v.data.length):$[E++]=0}return M($)}function S(P){let $=0;if($+=2,P.type==="full")$+=1+P.data.length;else{$+=1,$+=3*P.deltas.length;for(const E of P.deltas)E.data&&($+=E.data.length)}return $}function A(P){const $=p(P);let E=0;const v=$[E++];if($[E++]===1){const n=$[E++],i=$.subarray(E,E+n);return E+=n,{id:v,type:"full",data:i}}const m=$[E++],o=[];for(let n=0;n<m;n++){const i=$[E++],r=$[E++],s=$[E++];let t;s>0&&(t=$.subarray(E,E+s),E+=s),o[n]={start:i,deleteCount:r,data:t}}return{id:v,type:"delta",deltas:o}}}),define(ke[201],Ee([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(ke[135],Ee([1,0,19,24,11,177,129,201]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=m,e.clampedInt=n,e.clampedFloat=r,e.stringSet=f,e.cursorStyleToString=y,e.filterValidationDecorations=we;var b;(function(se){se[se.None=0]="None",se[se.Keep=1]="Keep",se[se.Brackets=2]="Brackets",se[se.Advanced=3]="Advanced",se[se.Full=4]="Full"})(b||(e.EditorAutoIndentStrategy=b={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=S;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class P{constructor(ue,Ie,Ge,Me){this.id=ue,this.name=Ie,this.defaultValue=Ge,this.schema=Me}applyUpdate(ue,Ie){return E(ue,Ie)}compute(ue,Ie,Ge){return Ge}}class ${constructor(ue,Ie){this.newValue=ue,this.didChange=Ie}}e.ApplyUpdateResult=$;function E(se,ue){if(typeof se!="object"||typeof ue!="object"||!se||!ue)return new $(ue,se!==ue);if(Array.isArray(se)||Array.isArray(ue)){const Ge=Array.isArray(se)&&Array.isArray(ue)&&u.$ub(se,ue);return new $(ue,!Ge)}let Ie=!1;for(const Ge in ue)if(ue.hasOwnProperty(Ge)){const Me=E(se[Ge],ue[Ge]);Me.didChange&&(se[Ge]=Me.newValue,Ie=!0)}return new $(se,Ie)}class v{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ie){return E(ue,Ie)}validate(ue){return this.defaultValue}}class a{constructor(ue,Ie,Ge,Me){this.id=ue,this.name=Ie,this.defaultValue=Ge,this.schema=Me}applyUpdate(ue,Ie){return E(ue,Ie)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ie,Ge){return Ge}}function m(se,ue){return typeof se>"u"?ue:se==="false"?!1:!!se}class o extends a{constructor(ue,Ie,Ge,Me=void 0){typeof Me<"u"&&(Me.type="boolean",Me.default=Ge),super(ue,Ie,Ge,Me)}validate(ue){return m(ue,this.defaultValue)}}function n(se,ue,Ie,Ge){if(typeof se>"u")return ue;let Me=parseInt(se,10);return isNaN(Me)?ue:(Me=Math.max(Ie,Me),Me=Math.min(Ge,Me),Me|0)}class i extends a{static clampedInt(ue,Ie,Ge,Me){return n(ue,Ie,Ge,Me)}constructor(ue,Ie,Ge,Me,nt,lt=void 0){typeof lt<"u"&&(lt.type="integer",lt.default=Ge,lt.minimum=Me,lt.maximum=nt),super(ue,Ie,Ge,lt),this.minimum=Me,this.maximum=nt}validate(ue){return i.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function r(se,ue,Ie,Ge){if(typeof se>"u")return ue;const Me=s.float(se,ue);return s.clamp(Me,Ie,Ge)}class s extends a{static clamp(ue,Ie,Ge){return ue<Ie?Ie:ue>Ge?Ge:ue}static float(ue,Ie){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ie;const Ge=parseFloat(ue);return isNaN(Ge)?Ie:Ge}constructor(ue,Ie,Ge,Me,nt){typeof nt<"u"&&(nt.type="number",nt.default=Ge),super(ue,Ie,Ge,nt),this.validationFn=Me}validate(ue){return this.validationFn(s.float(ue,this.defaultValue))}}class t extends a{static string(ue,Ie){return typeof ue!="string"?Ie:ue}constructor(ue,Ie,Ge,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.default=Ge),super(ue,Ie,Ge,Me)}validate(ue){return t.string(ue,this.defaultValue)}}function f(se,ue,Ie,Ge){return typeof se!="string"?ue:Ge&&se in Ge?Ge[se]:Ie.indexOf(se)===-1?ue:se}class d extends a{constructor(ue,Ie,Ge,Me,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Me,nt.default=Ge),super(ue,Ie,Ge,nt),this.c=Me}validate(ue){return f(ue,this.defaultValue,this.c)}}class l extends P{constructor(ue,Ie,Ge,Me,nt,lt,wt=void 0){typeof wt<"u"&&(wt.type="string",wt.enum=nt,wt.default=Me),super(ue,Ie,Ge,wt),this.c=nt,this.d=lt}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function c(se){switch(se){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ie,Ge){return Ge===0?ue.accessibilitySupport:Ge}}class g extends P{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:p.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertSpace:m(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(se){se[se.Hidden=0]="Hidden",se[se.Blink=1]="Blink",se[se.Smooth=2]="Smooth",se[se.Phase=3]="Phase",se[se.Expand=4]="Expand",se[se.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function w(se){switch(se){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var k;(function(se){se[se.Line=1]="Line",se[se.Block=2]="Block",se[se.Underline=3]="Underline",se[se.LineThin=4]="LineThin",se[se.BlockOutline=5]="BlockOutline",se[se.UnderlineThin=6]="UnderlineThin"})(k||(e.TextEditorCursorStyle=k={}));function y(se){switch(se){case k.Line:return"line";case k.Block:return"block";case k.Underline:return"underline";case k.LineThin:return"line-thin";case k.BlockOutline:return"block-outline";case k.UnderlineThin:return"underline-thin"}}function C(se){switch(se){case"line":return k.Line;case"block":return k.Block;case"underline":return k.Underline;case"line-thin":return k.LineThin;case"block-outline":return k.BlockOutline;case"underline-thin":return k.UnderlineThin}}class I extends v{constructor(){super(142)}compute(ue,Ie,Ge){const Me=["monaco-editor"];return Ie.get(39)&&Me.push(Ie.get(39)),ue.extraEditorClassName&&Me.push(ue.extraEditorClassName),Ie.get(74)==="default"?Me.push("mouse-default"):Ie.get(74)==="copy"&&Me.push("mouse-copy"),Ie.get(111)&&Me.push("showUnused"),Ie.get(140)&&Me.push("showDeprecated"),Me.join(" ")}}class F extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(ue,Ie,Ge){return Ge&&ue.emptySelectionClipboard}}class j extends P{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:p.localize(16,null),included:L.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:p.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{cursorMoveOnType:m(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":f(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":f(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(Ie.loop,this.defaultValue.loop)}}}class z extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"||ue.length===0?z.OFF:ue==="true"?z.ON:ue:ue?z.ON:z.OFF}}e.EditorFontLigatures=z;class O extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?O.OFF:ue==="true"?O.TRANSLATE:ue:ue?O.TRANSLATE:O.OFF}compute(ue,Ie,Ge){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class T extends v{constructor(){super(50)}compute(ue,Ie,Ge){return ue.fontInfo}}class B extends a{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(ue){const Ie=s.float(ue,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(Ie,6,100)}compute(ue,Ie,Ge){return ue.fontInfo.fontSize}}class W extends P{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.d,maximum:W.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(i.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,W.d,W.e))}}class Z extends P{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ge,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ge,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ge,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ge,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ge,description:p.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{multiple:f(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??f(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??f(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??f(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??f(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??f(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends P{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:p.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:m(Ie.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(Ie.above,this.defaultValue.above)}}}var X;(function(se){se[se.None=0]="None",se[se.Text=1]="Text",se[se.Blocks=2]="Blocks"})(X||(e.RenderMinimap=X={}));class Y extends v{constructor(){super(145)}compute(ue,Ie,Ge){return Y.computeLayout(Ie,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ie=ue.height/ue.lineHeight,Ge=Math.floor(ue.paddingTop/ue.lineHeight);let Me=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(Me=Math.max(Me,Ie-1));const nt=(Ge+ue.viewLineCount+Me)/(ue.pixelRatio*ue.height),lt=Math.floor(ue.viewLineCount/nt);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:Me,desiredRatio:nt,minimapLineCount:lt}}static c(ue,Ie){const Ge=ue.outerWidth,Me=ue.outerHeight,nt=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Me),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Me};const lt=Ie.stableMinimapLayoutInput,wt=lt&&ue.outerHeight===lt.outerHeight&&ue.lineHeight===lt.lineHeight&&ue.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&ue.pixelRatio===lt.pixelRatio&&ue.scrollBeyondLastLine===lt.scrollBeyondLastLine&&ue.paddingTop===lt.paddingTop&&ue.paddingBottom===lt.paddingBottom&&ue.minimap.enabled===lt.minimap.enabled&&ue.minimap.side===lt.minimap.side&&ue.minimap.size===lt.minimap.size&&ue.minimap.showSlider===lt.minimap.showSlider&&ue.minimap.renderCharacters===lt.minimap.renderCharacters&&ue.minimap.maxColumn===lt.minimap.maxColumn&&ue.minimap.scale===lt.minimap.scale&&ue.verticalScrollbarWidth===lt.verticalScrollbarWidth&&ue.isViewportWrapping===lt.isViewportWrapping,It=ue.lineHeight,jt=ue.typicalHalfwidthCharacterWidth,Kt=ue.scrollBeyondLastLine,xt=ue.minimap.renderCharacters;let St=nt>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const qt=ue.minimap.maxColumn,Ht=ue.minimap.size,et=ue.minimap.side,ri=ue.verticalScrollbarWidth,_t=ue.viewLineCount,ft=ue.remainingWidth,$t=ue.isViewportWrapping,ei=xt?2:3;let ti=Math.floor(nt*Me);const zt=ti/nt;let gt=!1,Bt=!1,ii=ei*St,Ot=St/nt,xe=1;if(Ht==="fill"||Ht==="fit"){const{typicalViewportLineCount:Wt,extraLinesBeforeFirstLine:Jt,extraLinesBeyondLastLine:Qt,desiredRatio:oi,minimapLineCount:At}=Y.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:Kt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:Me,lineHeight:It,pixelRatio:nt});if(_t/At>1)gt=!0,Bt=!0,St=1,ii=1,Ot=St/nt;else{let Ct=!1,Dt=St+1;if(Ht==="fit"){const pt=Math.ceil((Jt+_t+Qt)*ii);$t&&wt&&ft<=Ie.stableFitRemainingWidth?(Ct=!0,Dt=Ie.stableFitMaxMinimapScale):Ct=pt>ti}if(Ht==="fill"||Ct){gt=!0;const pt=St;ii=Math.min(It*nt,Math.max(1,Math.floor(1/oi))),$t&&wt&&ft<=Ie.stableFitRemainingWidth&&(Dt=Ie.stableFitMaxMinimapScale),St=Math.min(Dt,Math.max(1,Math.floor(ii/ei))),St>pt&&(xe=Math.min(2,St/pt)),Ot=St/nt/xe,ti=Math.ceil(Math.max(Wt,Jt+_t+Qt)*ii),$t?(Ie.stableMinimapLayoutInput=ue,Ie.stableFitRemainingWidth=ft,Ie.stableFitMaxMinimapScale=St):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const si=Math.floor(qt*Ot),Gt=Math.min(si,Math.max(0,Math.floor((ft-ri-2)*Ot/(jt+Ot)))+e.MINIMAP_GUTTER_WIDTH);let Ut=Math.floor(nt*Gt);const mt=Ut/nt;Ut=Math.floor(Ut*xe);const Tt=xt?1:2,Lt=et==="left"?0:Ge-Gt-ri;return{renderMinimap:Tt,minimapLeft:Lt,minimapWidth:Gt,minimapHeightIsEditorHeight:gt,minimapIsSampling:Bt,minimapScale:St,minimapLineHeight:ii,minimapCanvasInnerWidth:Ut,minimapCanvasInnerHeight:ti,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:zt}}static computeLayout(ue,Ie){const Ge=Ie.outerWidth|0,Me=Ie.outerHeight|0,nt=Ie.lineHeight|0,lt=Ie.lineNumbersDigitCount|0,wt=Ie.typicalHalfwidthCharacterWidth,It=Ie.maxDigitWidth,jt=Ie.pixelRatio,Kt=Ie.viewLineCount,xt=ue.get(137),St=xt==="inherit"?ue.get(136):xt,qt=St==="inherit"?ue.get(132):St,Ht=ue.get(135),et=Ie.isDominatedByLongLines,ri=ue.get(57),_t=ue.get(68).renderType!==0,ft=ue.get(69),$t=ue.get(105),ei=ue.get(84),ti=ue.get(73),zt=ue.get(103),gt=zt.verticalScrollbarSize,Bt=zt.verticalHasArrows,ii=zt.arrowSize,Ot=zt.horizontalScrollbarSize,xe=ue.get(43),si=ue.get(110)!=="never";let Gt=ue.get(66);xe&&si&&(Gt+=16);let Ut=0;if(_t){const li=Math.max(lt,ft);Ut=Math.round(li*It)}let mt=0;ri&&(mt=nt*Ie.glyphMarginDecorationLaneCount);let Tt=0,Lt=Tt+mt,Wt=Lt+Ut,Jt=Wt+Gt;const Qt=Ge-mt-Ut-Gt;let oi=!1,At=!1,Nt=-1;St==="inherit"&&et?(oi=!0,At=!0):qt==="on"||qt==="bounded"?At=!0:qt==="wordWrapColumn"&&(Nt=Ht);const Ct=Y.c({outerWidth:Ge,outerHeight:Me,lineHeight:nt,typicalHalfwidthCharacterWidth:wt,pixelRatio:jt,scrollBeyondLastLine:$t,paddingTop:ei.top,paddingBottom:ei.bottom,minimap:ti,verticalScrollbarWidth:gt,viewLineCount:Kt,remainingWidth:Qt,isViewportWrapping:At},Ie.memory||new A);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(Tt+=Ct.minimapWidth,Lt+=Ct.minimapWidth,Wt+=Ct.minimapWidth,Jt+=Ct.minimapWidth);const Dt=Qt-Ct.minimapWidth,pt=Math.max(1,Math.floor((Dt-gt-2)/wt)),Pt=Bt?ii:0;return At&&(Nt=Math.max(1,pt),qt==="bounded"&&(Nt=Math.min(Nt,Ht))),{width:Ge,height:Me,glyphMarginLeft:Tt,glyphMarginWidth:mt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Lt,lineNumbersWidth:Ut,decorationsLeft:Wt,decorationsWidth:Gt,contentLeft:Jt,contentWidth:Dt,minimap:Ct,viewportColumn:pt,isWordWrapMinified:oi,isViewportWrapping:At,wrappingColumn:Nt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Ot,overviewRuler:{top:Pt,width:gt,height:Me-2*Pt,right:0}}}}e.EditorLayoutInfoComputer=Y;class ce extends P{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(ue){return f(ue,"simple",["simple","advanced"])}compute(ue,Ie,Ge){return Ie.get(2)===2?"advanced":Ge}}var ne;(function(se){se.Off="off",se.OnCode="onCode",se.On="on"})(ne||(e.ShowLightbulbIconMode=ne={}));class $e extends P{constructor(){const ue={enabled:ne.On};super(65,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ne.Off,ne.OnCode,ne.On],default:ue.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:f(ue.enabled,this.defaultValue.enabled,[ne.Off,ne.OnCode,ne.On])}}}class Ce extends P{constructor(){const ue={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:p.localize(57,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ee extends P{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:p.localize(65,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:f(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:m(Ie.padding,this.defaultValue.padding)}}}class U extends P{constructor(){super(66,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):i.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ie,Ge){return Ge<0?i.clampedInt(-Ge*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class ie extends s{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>s.clamp(ue,0,150),{markdownDescription:p.localize(66,null)})}compute(ue,Ie,Ge){return ue.fontInfo.lineHeight}}class be extends P{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:ue.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ue.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ue.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ue.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),autohide:m(Ie.autohide,this.defaultValue.autohide),size:f(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(Ie.side,this.defaultValue.side,["right","left"]),showSlider:f(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ie.scale,1,1,3),maxColumn:i.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:m(Ie.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:m(Ie.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:s.clamp(Ie.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Pe(se){return se==="ctrlCmd"?L.$j?"metaKey":"ctrlKey":"altKey"}class oe extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{top:i.clampedInt(Ie.top,0,0,1e3),bottom:i.clampedInt(Ie.bottom,0,0,1e3)}}}class ae extends P{constructor(){const ue={enabled:!0,cycle:!0};super(86,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:p.localize(84,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),cycle:m(Ie.cycle,this.defaultValue.cycle)}}}class re extends v{constructor(){super(143)}compute(ue,Ie,Ge){return ue.pixelRatio}}class G extends P{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ue.strings,description:p.localize(88,null)},comments:{anyOf:Ie,default:ue.comments,description:p.localize(89,null)},other:{anyOf:Ie,default:ue.other,description:p.localize(90,null)}},default:ue,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const jt=ue?"on":"off";return{comments:jt,strings:jt,other:jt}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ie,comments:Ge,strings:Me}=ue,nt=["on","inline","off"];let lt,wt,It;return typeof Ie=="boolean"?lt=Ie?"on":"off":lt=f(Ie,this.defaultValue.other,nt),typeof Ge=="boolean"?wt=Ge?"on":"off":wt=f(Ge,this.defaultValue.comments,nt),typeof Me=="boolean"?It=Me?"on":"off":It=f(Me,this.defaultValue.strings,nt),{other:lt,comments:wt,strings:It}}}var te;(function(se){se[se.Off=0]="Off",se[se.On=1]="On",se[se.Relative=2]="Relative",se[se.Interval=3]="Interval",se[se.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class ge extends P{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(ue){let Ie=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ie=4,Ge=ue):ue==="interval"?Ie=3:ue==="relative"?Ie=2:ue==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ge}}}function we(se){const ue=se.get(98);return ue==="editable"?se.get(91):ue!=="on"}class Re extends P{constructor(){const ue=[],Ie={type:"number",description:p.localize(97,null)};super(102,"rulers",ue,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:ue,description:p.localize(99,null)})}validate(ue){if(Array.isArray(ue)){const Ie=[];for(const Ge of ue)if(typeof Ge=="number")Ie.push({column:i.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const Me=Ge;Ie.push({column:i.clampedInt(Me.column,0,0,1e4),color:Me.color})}return Ie.sort((Ge,Me)=>Ge.column-Me.column),Ie}return this.defaultValue}}class fe extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Se(se,ue){if(typeof se!="string")return ue;switch(se){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends P{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue,Ge=i.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Me=i.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Se(Ie.vertical,this.defaultValue.vertical),horizontal:Se(Ie.horizontal,this.defaultValue.horizontal),useShadows:m(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:i.clampedInt(Ie.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:Me,verticalSliderSize:i.clampedInt(Ie.verticalSliderSize,Me,0,1e3),scrollByPage:m(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Fe extends P{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:p.localize(118,null)}})}applyUpdate(ue,Ie){let Ge=!1;Ie.allowedCharacters&&ue&&(N.$1n(ue.allowedCharacters,Ie.allowedCharacters)||(ue={...ue,allowedCharacters:Ie.allowedCharacters},Ge=!0)),Ie.allowedLocales&&ue&&(N.$1n(ue.allowedLocales,Ie.allowedLocales)||(ue={...ue,allowedLocales:Ie.allowedLocales},Ge=!0));const Me=super.applyUpdate(ue,Ie);return Ge?new $(Me.newValue,!0):Me}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{nonBasicASCII:he(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ie){if(typeof ue!="object"||!ue)return Ie;const Ge={};for(const[Me,nt]of Object.entries(ue))nt===!0&&(Ge[Me]=!0);return Ge}}class q extends P{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ue.fontFamily,description:p.localize(125,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),mode:f(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(Ie.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily)}}}class V extends P{constructor(){const ue={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ue,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ue.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ue.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ue.backgroundColoring,description:p.localize(132,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showToolbar:f(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),keepOnBlur:m(Ie.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:m(Ie.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Q extends P{constructor(){const ue={enabled:R.$Us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$Us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends P{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:ue.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:ue.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:ue.highlightActiveIndentation,description:p.localize(148,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{bracketPairs:he(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(se,ue,Ie){const Ge=Ie.indexOf(se);return Ge===-1?ue:Ie[Ge]}class pe extends P{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:ue.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:ue.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertMode:f(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:m(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:m(Ie.preview,this.defaultValue.preview),previewMode:f(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(Ie.showMethods,this.defaultValue.showMethods),showFunctions:m(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:m(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(Ie.showFields,this.defaultValue.showFields),showVariables:m(Ie.showVariables,this.defaultValue.showVariables),showClasses:m(Ie.showClasses,this.defaultValue.showClasses),showStructs:m(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:m(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:m(Ie.showModules,this.defaultValue.showModules),showProperties:m(Ie.showProperties,this.defaultValue.showProperties),showEvents:m(Ie.showEvents,this.defaultValue.showEvents),showOperators:m(Ie.showOperators,this.defaultValue.showOperators),showUnits:m(Ie.showUnits,this.defaultValue.showUnits),showValues:m(Ie.showValues,this.defaultValue.showValues),showConstants:m(Ie.showConstants,this.defaultValue.showConstants),showEnums:m(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:m(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(Ie.showKeywords,this.defaultValue.showKeywords),showWords:m(Ie.showWords,this.defaultValue.showWords),showColors:m(Ie.showColors,this.defaultValue.showColors),showFiles:m(Ie.showFiles,this.defaultValue.showFiles),showReferences:m(Ie.showReferences,this.defaultValue.showReferences),showFolders:m(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:m(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:m(Ie.showUsers,this.defaultValue.showUsers),showIssues:m(Ie.showIssues,this.defaultValue.showIssues)}}}class ze extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(ue.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends P{constructor(){const ue=[];super(130,"wordSegmenterLocales",ue,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ue){if(typeof ue=="string"&&(ue=[ue]),Array.isArray(ue)){const Ie=[];for(const Ge of ue)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&Ie.push(Ge)}catch{}return Ie}return this.defaultValue}}var Ze;(function(se){se[se.None=0]="None",se[se.Same=1]="Same",se[se.Indent=2]="Indent",se[se.DeepIndent=3]="DeepIndent"})(Ze||(e.WrappingIndent=Ze={}));class tt extends P{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ie,Ge){return Ie.get(2)===2?0:Ge}}class ot extends v{constructor(){super(146)}compute(ue,Ie,Ge){const Me=Ie.get(145);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:Me.isWordWrapMinified,isViewportWrapping:Me.isViewportWrapping,wrappingColumn:Me.wrappingColumn}}}class it extends P{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showDropSelector:f(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends P{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:m(Ie.enabled,this.defaultValue.enabled),showPasteSelector:f(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const De="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.$j?Be:L.$k?He:De,fontWeight:"normal",fontSize:L.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(se){return e.editorOptionsRegistry[se.id]=se,se}var Xe;(function(se){se[se.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",se[se.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",se[se.accessibilitySupport=2]="accessibilitySupport",se[se.accessibilityPageSize=3]="accessibilityPageSize",se[se.ariaLabel=4]="ariaLabel",se[se.ariaRequired=5]="ariaRequired",se[se.autoClosingBrackets=6]="autoClosingBrackets",se[se.autoClosingComments=7]="autoClosingComments",se[se.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",se[se.autoClosingDelete=9]="autoClosingDelete",se[se.autoClosingOvertype=10]="autoClosingOvertype",se[se.autoClosingQuotes=11]="autoClosingQuotes",se[se.autoIndent=12]="autoIndent",se[se.automaticLayout=13]="automaticLayout",se[se.autoSurround=14]="autoSurround",se[se.bracketPairColorization=15]="bracketPairColorization",se[se.guides=16]="guides",se[se.codeLens=17]="codeLens",se[se.codeLensFontFamily=18]="codeLensFontFamily",se[se.codeLensFontSize=19]="codeLensFontSize",se[se.colorDecorators=20]="colorDecorators",se[se.colorDecoratorsLimit=21]="colorDecoratorsLimit",se[se.columnSelection=22]="columnSelection",se[se.comments=23]="comments",se[se.contextmenu=24]="contextmenu",se[se.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",se[se.cursorBlinking=26]="cursorBlinking",se[se.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",se[se.cursorStyle=28]="cursorStyle",se[se.cursorSurroundingLines=29]="cursorSurroundingLines",se[se.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",se[se.cursorWidth=31]="cursorWidth",se[se.disableLayerHinting=32]="disableLayerHinting",se[se.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",se[se.domReadOnly=34]="domReadOnly",se[se.dragAndDrop=35]="dragAndDrop",se[se.dropIntoEditor=36]="dropIntoEditor",se[se.emptySelectionClipboard=37]="emptySelectionClipboard",se[se.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",se[se.extraEditorClassName=39]="extraEditorClassName",se[se.fastScrollSensitivity=40]="fastScrollSensitivity",se[se.find=41]="find",se[se.fixedOverflowWidgets=42]="fixedOverflowWidgets",se[se.folding=43]="folding",se[se.foldingStrategy=44]="foldingStrategy",se[se.foldingHighlight=45]="foldingHighlight",se[se.foldingImportsByDefault=46]="foldingImportsByDefault",se[se.foldingMaximumRegions=47]="foldingMaximumRegions",se[se.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",se[se.fontFamily=49]="fontFamily",se[se.fontInfo=50]="fontInfo",se[se.fontLigatures=51]="fontLigatures",se[se.fontSize=52]="fontSize",se[se.fontWeight=53]="fontWeight",se[se.fontVariations=54]="fontVariations",se[se.formatOnPaste=55]="formatOnPaste",se[se.formatOnType=56]="formatOnType",se[se.glyphMargin=57]="glyphMargin",se[se.gotoLocation=58]="gotoLocation",se[se.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",se[se.hover=60]="hover",se[se.inDiffEditor=61]="inDiffEditor",se[se.inlineSuggest=62]="inlineSuggest",se[se.inlineEdit=63]="inlineEdit",se[se.letterSpacing=64]="letterSpacing",se[se.lightbulb=65]="lightbulb",se[se.lineDecorationsWidth=66]="lineDecorationsWidth",se[se.lineHeight=67]="lineHeight",se[se.lineNumbers=68]="lineNumbers",se[se.lineNumbersMinChars=69]="lineNumbersMinChars",se[se.linkedEditing=70]="linkedEditing",se[se.links=71]="links",se[se.matchBrackets=72]="matchBrackets",se[se.minimap=73]="minimap",se[se.mouseStyle=74]="mouseStyle",se[se.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",se[se.mouseWheelZoom=76]="mouseWheelZoom",se[se.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",se[se.multiCursorModifier=78]="multiCursorModifier",se[se.multiCursorPaste=79]="multiCursorPaste",se[se.multiCursorLimit=80]="multiCursorLimit",se[se.occurrencesHighlight=81]="occurrencesHighlight",se[se.overviewRulerBorder=82]="overviewRulerBorder",se[se.overviewRulerLanes=83]="overviewRulerLanes",se[se.padding=84]="padding",se[se.pasteAs=85]="pasteAs",se[se.parameterHints=86]="parameterHints",se[se.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",se[se.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",se[se.quickSuggestions=89]="quickSuggestions",se[se.quickSuggestionsDelay=90]="quickSuggestionsDelay",se[se.readOnly=91]="readOnly",se[se.readOnlyMessage=92]="readOnlyMessage",se[se.renameOnType=93]="renameOnType",se[se.renderControlCharacters=94]="renderControlCharacters",se[se.renderFinalNewline=95]="renderFinalNewline",se[se.renderLineHighlight=96]="renderLineHighlight",se[se.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",se[se.renderValidationDecorations=98]="renderValidationDecorations",se[se.renderWhitespace=99]="renderWhitespace",se[se.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",se[se.roundedSelection=101]="roundedSelection",se[se.rulers=102]="rulers",se[se.scrollbar=103]="scrollbar",se[se.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",se[se.scrollBeyondLastLine=105]="scrollBeyondLastLine",se[se.scrollPredominantAxis=106]="scrollPredominantAxis",se[se.selectionClipboard=107]="selectionClipboard",se[se.selectionHighlight=108]="selectionHighlight",se[se.selectOnLineNumbers=109]="selectOnLineNumbers",se[se.showFoldingControls=110]="showFoldingControls",se[se.showUnused=111]="showUnused",se[se.snippetSuggestions=112]="snippetSuggestions",se[se.smartSelect=113]="smartSelect",se[se.smoothScrolling=114]="smoothScrolling",se[se.stickyScroll=115]="stickyScroll",se[se.stickyTabStops=116]="stickyTabStops",se[se.stopRenderingLineAfter=117]="stopRenderingLineAfter",se[se.suggest=118]="suggest",se[se.suggestFontSize=119]="suggestFontSize",se[se.suggestLineHeight=120]="suggestLineHeight",se[se.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",se[se.suggestSelection=122]="suggestSelection",se[se.tabCompletion=123]="tabCompletion",se[se.tabIndex=124]="tabIndex",se[se.unicodeHighlighting=125]="unicodeHighlighting",se[se.unusualLineTerminators=126]="unusualLineTerminators",se[se.useShadowDOM=127]="useShadowDOM",se[se.useTabStops=128]="useTabStops",se[se.wordBreak=129]="wordBreak",se[se.wordSegmenterLocales=130]="wordSegmenterLocales",se[se.wordSeparators=131]="wordSeparators",se[se.wordWrap=132]="wordWrap",se[se.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",se[se.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",se[se.wordWrapColumn=135]="wordWrapColumn",se[se.wordWrapOverride1=136]="wordWrapOverride1",se[se.wordWrapOverride2=137]="wordWrapOverride2",se[se.wrappingIndent=138]="wrappingIndent",se[se.wrappingStrategy=139]="wrappingStrategy",se[se.showDeprecated=140]="showDeprecated",se[se.inlayHints=141]="inlayHints",se[se.editorClassName=142]="editorClassName",se[se.pixelRatio=143]="pixelRatio",se[se.tabFocusMode=144]="tabFocusMode",se[se.layoutInfo=145]="layoutInfo",se[se.wrappingInfo=146]="wrappingInfo",se[se.defaultColorDecorators=147]="defaultColorDecorators",se[se.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",se[se.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:Le(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:Le(new h),accessibilityPageSize:Le(new i(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",p.localize(218,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Le(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:Le(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:Le(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:Le(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:Le(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:Le(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:Le(new Q),bracketPairGuides:Le(new J),stickyTabStops:Le(new o(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:Le(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:Le(new d(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:Le(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:Le(new g),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:Le(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:Le(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:Le(new l(28,"cursorStyle",k.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:p.localize(260,null)})),cursorSurroundingLines:Le(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:Le(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:Le(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:Le(new F),dropIntoEditor:Le(new it),stickyScroll:Le(new Ce),experimentalWhitespaceRendering:Le(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new s(40,"fastScrollSensitivity",5,se=>se<=0?5:se,{markdownDescription:p.localize(271,null)})),find:Le(new j),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:Le(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:Le(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:Le(new T),fontLigatures2:Le(new z),fontSize:Le(new B),fontWeight:Le(new W),fontVariations:Le(new O),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:Le(new Z),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:Le(new x),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new s(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,se=>s.clamp(se,-5,20),{description:p.localize(285,null)})),lightbulb:Le(new $e),lineDecorationsWidth:Le(new U),lineHeight:Le(new ie),lineNumbers:Le(new ge),lineNumbersMinChars:Le(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:Le(new o(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:Le(new d(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:Le(new be),mouseStyle:Le(new d(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new s(75,"mouseWheelScrollSensitivity",1,se=>se===0?1:se,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:Le(new o(76,"mouseWheelZoom",!1,{markdownDescription:L.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:Le(new o(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:Le(new l(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Pe,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:Le(new d(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:Le(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:Le(new d(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:Le(new o(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:Le(new i(83,"overviewRulerLanes",3,0,3)),padding:Le(new oe),pasteAs:Le(new st),parameterHints:Le(new ae),peekWidgetDefaultFocus:Le(new d(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:Le(new o(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:Le(new G),quickSuggestionsDelay:Le(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:Le(new o(91,"readOnly",!1)),readOnlyMessage:Le(new fe),renameOnType:Le(new o(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:Le(new o(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:Le(new d(95,"renderFinalNewline",L.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:Le(new d(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:Le(new d(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new d(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:Le(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:Le(new Re),scrollbar:Le(new Ae),scrollBeyondLastColumn:Le(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:Le(new o(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:Le(new o(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:Le(new o(107,"selectionClipboard",!0,{description:p.localize(325,null),included:L.$k})),selectionHighlight:Le(new o(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:Le(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Le(new d(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:Le(new o(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:Le(new o(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:Le(new ee),snippetSuggestions:Le(new d(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:Le(new ze),smoothScrolling:Le(new o(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:Le(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new pe),inlineSuggest:Le(new q),inlineEdit:Le(new V),inlineCompletionsAccessibilityVerbose:Le(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:Le(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:Le(new d(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:Le(new d(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:Le(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new Fe),unusualLineTerminators:Le(new d(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:Le(new o(127,"useShadowDOM",!0)),useTabStops:Le(new o(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:Le(new d(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:Le(new Ve),wordSeparators:Le(new t(131,"wordSeparators",M.$Vs,{description:p.localize(359,null)})),wordWrap:Le(new d(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:Le(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:Le(new d(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new d(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new I),defaultColorDecorators:Le(new o(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:Le(new re),tabFocusMode:Le(new o(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:Le(new Y),wrappingInfo:Le(new ot),wrappingIndent:Le(new tt),wrappingStrategy:Le(new ce)}}),define(ke[202],Ee([9,10]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(ke[83],Ee([1,0,78,2,175,29,185,202]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$8t=e.$7t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$6t=e.$5t=e.SymbolKinds=e.SymbolTag=e.$3t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$1t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Zt=e.$Yt=e.$Xt=void 0,e.$2t=f,e.$4t=l;class b{constructor(Z,x,X){this.offset=Z,this.type=x,this.language=X,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Xt=b;class S{constructor(Z,x){this.tokens=Z,this.endState=x,this._tokenizationResultBrand=void 0}}e.$Yt=S;class A{constructor(Z,x){this.tokens=Z,this.endState=x,this._encodedTokenizationResultBrand=void 0}}e.$Zt=A;var P;(function(W){W[W.Method=0]="Method",W[W.Function=1]="Function",W[W.Constructor=2]="Constructor",W[W.Field=3]="Field",W[W.Variable=4]="Variable",W[W.Class=5]="Class",W[W.Struct=6]="Struct",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Event=10]="Event",W[W.Operator=11]="Operator",W[W.Unit=12]="Unit",W[W.Value=13]="Value",W[W.Constant=14]="Constant",W[W.Enum=15]="Enum",W[W.EnumMember=16]="EnumMember",W[W.Keyword=17]="Keyword",W[W.Text=18]="Text",W[W.Color=19]="Color",W[W.File=20]="File",W[W.Reference=21]="Reference",W[W.Customcolor=22]="Customcolor",W[W.Folder=23]="Folder",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue",W[W.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var $;(function(W){const Z=new Map;Z.set(0,u.$Pj.symbolMethod),Z.set(1,u.$Pj.symbolFunction),Z.set(2,u.$Pj.symbolConstructor),Z.set(3,u.$Pj.symbolField),Z.set(4,u.$Pj.symbolVariable),Z.set(5,u.$Pj.symbolClass),Z.set(6,u.$Pj.symbolStruct),Z.set(7,u.$Pj.symbolInterface),Z.set(8,u.$Pj.symbolModule),Z.set(9,u.$Pj.symbolProperty),Z.set(10,u.$Pj.symbolEvent),Z.set(11,u.$Pj.symbolOperator),Z.set(12,u.$Pj.symbolUnit),Z.set(13,u.$Pj.symbolValue),Z.set(15,u.$Pj.symbolEnum),Z.set(14,u.$Pj.symbolConstant),Z.set(15,u.$Pj.symbolEnum),Z.set(16,u.$Pj.symbolEnumMember),Z.set(17,u.$Pj.symbolKeyword),Z.set(27,u.$Pj.symbolSnippet),Z.set(18,u.$Pj.symbolText),Z.set(19,u.$Pj.symbolColor),Z.set(20,u.$Pj.symbolFile),Z.set(21,u.$Pj.symbolReference),Z.set(22,u.$Pj.symbolCustomColor),Z.set(23,u.$Pj.symbolFolder),Z.set(24,u.$Pj.symbolTypeParameter),Z.set(25,u.$Pj.account),Z.set(26,u.$Pj.issues);function x(ce){let ne=Z.get(ce);return ne||(console.info("No codicon found for CompletionItemKind "+ce),ne=u.$Pj.symbolProperty),ne}W.toIcon=x;const X=new Map;X.set("method",0),X.set("function",1),X.set("constructor",2),X.set("field",3),X.set("variable",4),X.set("class",5),X.set("struct",6),X.set("interface",7),X.set("module",8),X.set("property",9),X.set("event",10),X.set("operator",11),X.set("unit",12),X.set("value",13),X.set("constant",14),X.set("enum",15),X.set("enum-member",16),X.set("enumMember",16),X.set("keyword",17),X.set("snippet",27),X.set("text",18),X.set("color",19),X.set("file",20),X.set("reference",21),X.set("customcolor",22),X.set("folder",23),X.set("type-parameter",24),X.set("typeParameter",24),X.set("account",25),X.set("issue",26);function Y(ce,ne){let $e=X.get(ce);return typeof $e>"u"&&!ne&&($e=9),$e}W.fromString=Y})($||(e.CompletionItemKinds=$={}));var E;(function(W){W[W.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var v;(function(W){W[W.None=0]="None",W[W.KeepWhitespace=1]="KeepWhitespace",W[W.InsertAsSnippet=4]="InsertAsSnippet"})(v||(e.CompletionItemInsertTextRule=v={}));var a;(function(W){W[W.Word=0]="Word",W[W.Line=1]="Line",W[W.Suggest=2]="Suggest"})(a||(e.PartialAcceptTriggerKind=a={}));var m;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var o;(function(W){W[W.Automatic=0]="Automatic",W[W.Explicit=1]="Explicit"})(o||(e.InlineCompletionTriggerKind=o={}));class n{constructor(Z,x,X,Y){this.range=Z,this.text=x,this.completionKind=X,this.isSnippetText=Y}equals(Z){return R.$kt.lift(this.range).equalsRange(Z.range)&&this.text===Z.text&&this.completionKind===Z.completionKind&&this.isSnippetText===Z.isSnippetText}}e.$1t=n;var i;(function(W){W[W.Invoke=1]="Invoke",W[W.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(W){W[W.Automatic=0]="Automatic",W[W.PasteAs=1]="PasteAs"})(r||(e.DocumentPasteTriggerKind=r={}));var s;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(s||(e.SignatureHelpTriggerKind=s={}));var t;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function f(W){return W&&N.URI.isUri(W.uri)&&R.$kt.isIRange(W.range)&&(R.$kt.isIRange(W.originSelectionRange)||R.$kt.isIRange(W.targetSelectionRange))}var d;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(d||(e.SymbolKind=d={})),e.$3t={17:(0,p.localize)(0,null),16:(0,p.localize)(1,null),4:(0,p.localize)(2,null),13:(0,p.localize)(3,null),8:(0,p.localize)(4,null),9:(0,p.localize)(5,null),21:(0,p.localize)(6,null),23:(0,p.localize)(7,null),7:(0,p.localize)(8,null),0:(0,p.localize)(9,null),11:(0,p.localize)(10,null),10:(0,p.localize)(11,null),19:(0,p.localize)(12,null),5:(0,p.localize)(13,null),1:(0,p.localize)(14,null),2:(0,p.localize)(15,null),20:(0,p.localize)(16,null),15:(0,p.localize)(17,null),18:(0,p.localize)(18,null),24:(0,p.localize)(19,null),3:(0,p.localize)(20,null),6:(0,p.localize)(21,null),14:(0,p.localize)(22,null),22:(0,p.localize)(23,null),25:(0,p.localize)(24,null),12:(0,p.localize)(25,null)};function l(W,Z){return(0,p.localize)(26,null,W,e.$3t[Z])}var c;(function(W){W[W.Deprecated=1]="Deprecated"})(c||(e.SymbolTag=c={}));var h;(function(W){const Z=new Map;Z.set(0,u.$Pj.symbolFile),Z.set(1,u.$Pj.symbolModule),Z.set(2,u.$Pj.symbolNamespace),Z.set(3,u.$Pj.symbolPackage),Z.set(4,u.$Pj.symbolClass),Z.set(5,u.$Pj.symbolMethod),Z.set(6,u.$Pj.symbolProperty),Z.set(7,u.$Pj.symbolField),Z.set(8,u.$Pj.symbolConstructor),Z.set(9,u.$Pj.symbolEnum),Z.set(10,u.$Pj.symbolInterface),Z.set(11,u.$Pj.symbolFunction),Z.set(12,u.$Pj.symbolVariable),Z.set(13,u.$Pj.symbolConstant),Z.set(14,u.$Pj.symbolString),Z.set(15,u.$Pj.symbolNumber),Z.set(16,u.$Pj.symbolBoolean),Z.set(17,u.$Pj.symbolArray),Z.set(18,u.$Pj.symbolObject),Z.set(19,u.$Pj.symbolKey),Z.set(20,u.$Pj.symbolNull),Z.set(21,u.$Pj.symbolEnumMember),Z.set(22,u.$Pj.symbolStruct),Z.set(23,u.$Pj.symbolEvent),Z.set(24,u.$Pj.symbolOperator),Z.set(25,u.$Pj.symbolTypeParameter);function x(X){let Y=Z.get(X);return Y||(console.info("No codicon found for SymbolKind "+X),Y=u.$Pj.symbolProperty),Y}W.toIcon=x})(h||(e.SymbolKinds=h={}));class g{static asEditOperation(Z){return L.$lt.replace(R.$kt.lift(Z.range),Z.text)}}e.$5t=g;class D{static{this.Comment=new D("comment")}static{this.Imports=new D("imports")}static{this.Region=new D("region")}static fromValue(Z){switch(Z){case"comment":return D.Comment;case"imports":return D.Imports;case"region":return D.Region}return new D(Z)}constructor(Z){this.value=Z}}e.$6t=D;var w;(function(W){W[W.AIGenerated=1]="AIGenerated"})(w||(e.NewSymbolNameTag=w={}));var k;(function(W){function Z(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}W.is=Z})(k||(e.Command=k={}));var y;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(y||(e.CommentThreadCollapsibleState=y={}));var C;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(C||(e.CommentThreadState=C={}));var I;(function(W){W[W.Current=0]="Current",W[W.Outdated=1]="Outdated"})(I||(e.CommentThreadApplicability=I={}));var F;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(F||(e.CommentMode=F={}));var j;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(j||(e.CommentState=j={}));var z;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(z||(e.InlayHintKind=z={}));class O{constructor(Z){this.b=Z,this.a=null}dispose(){this.a&&this.a.then(Z=>{Z&&Z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$7t=O,e.$8t=new M.$Mt;var T;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(T||(e.ExternalUriOpenerPriority=T={}));var B;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(B||(e.InlineEditTriggerKind=B={}))}),define(ke[203],Ee([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[204],Ee([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[205],Ee([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(ke[206],Ee([9,10]),function(le,e){return le.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[207],Ee([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[208],Ee([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[209],Ee([9,10]),function(le,e){return le.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[210],Ee([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(ke[211],Ee([9,10]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(ke[212],Ee([9,10]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[213],Ee([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(ke[214],Ee([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(ke[215],Ee([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[216],Ee([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[217],Ee([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(ke[218],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[219],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[220],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[221],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[222],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[223],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[224],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[225],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[226],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[227],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[228],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[229],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[230],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[231],Ee([9,10]),function(le,e){return le.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[232],Ee([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(ke[233],Ee([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(ke[234],Ee([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(ke[235],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[236],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[237],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[238],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[239],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[240],Ee([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[241],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[242],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[243],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[244],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[245],Ee([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[246],Ee([1,0,13,205]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.TokenType=void 0;var L;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(L||(e.TokenType=L={}));function R(...S){switch(S.length){case 1:return(0,N.localize)(0,null,S[0]);case 2:return(0,N.localize)(1,null,S[0],S[1]);case 3:return(0,N.localize)(2,null,S[0],S[1],S[2]);default:return}}const M=(0,N.localize)(3,null),p=(0,N.localize)(4,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,u.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const P=this.d,$=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:$};this.g.push({offset:P,lexeme:$,additionalInfo:A}),this.f.push(E)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const P=this.c.substring(this.d,this.e),$=b.b.get(P);$?this.k($):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,P=!1,$=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(p);return}const v=this.c.charCodeAt(A);if(P)P=!1;else if(v===47&&!$){A++;break}else v===91?$=!0:v===92?P=!0:v===93&&($=!1);A++}for(;A<this.c.length&&b.a.has(this.c.charCodeAt(A));)A++;this.e=A;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}e.$lj=b}),define(ke[247],Ee([1,0,23,40,208,397]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=b,e.$Bp=S,e.$Cp=A,e.$Dp=P,e.$Ep=$,e.$Fp=E,e.$Gp=v;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function b(o){return o=o.trim(),o==="*"||M.test(o)}function S(o){if(!b(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=o.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function A(o){if(!o)return null;const n=o.majorBase,i=o.majorMustEqual,r=o.minorBase;let s=o.minorMustEqual;const t=o.patchBase;let f=o.patchMustEqual;o.hasCaret&&(n===0||(s=!1),f=!1);let d=0;if(o.preRelease){const l=p.exec(o.preRelease);if(l){const[,c,h,g]=l;d=Date.UTC(Number(c),Number(h)-1,Number(g))}}return{majorBase:n,majorMustEqual:i,minorBase:r,minorMustEqual:s,patchBase:t,patchMustEqual:f,isMinimum:o.hasGreaterEquals,notBefore:d}}function P(o,n,i){let r;typeof o=="string"?r=A(S(o)):r=o;let s;n instanceof Date?s=n.getTime():typeof n=="string"&&(s=new Date(n).getTime());let t;if(typeof i=="string"?t=A(S(i)):t=i,!r||!t)return!1;const f=r.majorBase,d=r.minorBase,l=r.patchBase;let c=t.majorBase,h=t.minorBase,g=t.patchBase;const D=t.notBefore;let w=t.majorMustEqual,k=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?f>c?!0:f<c?!1:d>h?!0:d<h||s&&s<D?!1:l>=g:(f===1&&c===0&&(!w||!k||!y)&&(c=1,h=0,g=0,w=!0,k=!1,y=!1),f<c?!1:f>c?!w:d<h?!1:d>h?!k:l<g?!1:l>g?!y:!(s&&s<D))}function $(o,n,i,r,s){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([N.default.Error,L.localize(0,null)]),t;if(typeof r.name!="string")return t.push([N.default.Error,L.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([N.default.Error,L.localize(2,null,"version")]),t;if(!r.engines)return t.push([N.default.Error,L.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([N.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!m(r.extensionDependencies))return t.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!m(r.activationEvents))return t.push([N.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([N.default.Error,L.localize(9,null,"main")]),t;{const l=(0,u.$4g)(i,r.main);(0,u.$Xg)(l,i)||t.push([N.default.Warning,L.localize(10,null,l.path,i.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([N.default.Error,L.localize(11,null,"browser")]),t;{const l=(0,u.$4g)(i,r.browser);(0,u.$Xg)(l,i)||t.push([N.default.Warning,L.localize(12,null,l.path,i.path)])}}if(!R.valid(r.version))return t.push([N.default.Error,L.localize(13,null)]),t;const f=[];if(!E(o,n,r,s,f))for(const l of f)t.push([N.default.Error,l]);return t}function E(o,n,i,r,s){return r||typeof i.main>"u"&&typeof i.browser>"u"?!0:a(o,n,i.engines.vscode,s)}function v(o,n,i){return o==="*"||a(n,i,o)}function a(o,n,i,r=[]){const s=A(S(i));if(!s)return r.push(L.localize(14,null,i)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return r.push(L.localize(15,null,i)),!1}else if(!s.majorMustEqual)return r.push(L.localize(16,null,i)),!1;return P(o,n,s)?!0:(r.push(L.localize(17,null,o,i)),!1)}function m(o){if(!Array.isArray(o))return!1;for(let n=0,i=o.length;n<i;n++)if(typeof o[n]!="string")return!1;return!0}}),define(ke[106],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=void 0;class u{constructor(L,R=[],M=!1){this.ctor=L,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.$ni=u}),define(ke[84],Ee([1,0,106]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$os=R,e.$ps=M;const N=[];var L;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function R(p,b,S){b instanceof u.$ni||(b=new u.$ni(b,[],!!S)),N.push([p,b])}function M(){return N}}),define(ke[248],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;class u{constructor(R,M){this.key=R,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$5q=u;class N{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const M of this.a.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const p=this.lookupOrInsertNode(R),b=this.lookupOrInsertNode(M);p.outgoing.set(b.key,b),b.incoming.set(p.key,p)}removeNode(R){const M=this.b(R);this.a.delete(M);for(const p of this.a.values())p.outgoing.delete(M),p.incoming.delete(M)}lookupOrInsertNode(R){const M=this.b(R);let p=this.a.get(M);return p||(p=new u(M,R),this.a.set(M,p)),p}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[M,p]of this.a)R.push(`${M}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this.a){const p=new Set([R]),b=this.c(M,p);if(b)return b}}c(R,M){for(const[p,b]of R.outgoing){if(M.has(p))return[...M,p].join(" -> ");M.add(p);const S=this.c(b,M);if(S)return S;M.delete(p)}}}e.$6q=N}),define(ke[5],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e._util=void 0,e.$qi=L,e.$ri=R;var u;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function p(b){return b[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=p})(u||(e._util=u={})),e.$pi=L("instantiationService");function N(M,p,b){p[u.DI_TARGET]===p?p[u.DI_DEPENDENCIES].push({id:M,index:b}):(p[u.DI_DEPENDENCIES]=[{id:M,index:b}],p[u.DI_TARGET]=p)}function L(M){if(u.serviceIds.has(M))return u.serviceIds.get(M);const p=function(b,S,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(p,b,A)};return p.toString=()=>M,u.serviceIds.set(M,p),p}function R(M){return M}}),define(ke[54],Ee([1,0,18,2,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Wi=void 0,e.$Xi=R,e.$Yi=M,e.$Zi=b,e.$1i=S,e.$2i=A,e.$3i=P,e.$4i=$,e.$5i=v,e.$6i=a,e.$7i=m,e.$Wi=(0,L.$qi)("configurationService");function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof N.URI)}function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof N.URI)}var p;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function b(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function S(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function A(o,n){const i=Object.create(null);for(const r in o)P(i,r,o[r],n);return i}function P(o,n,i,r){const s=n.split("."),t=s.pop();let f=o;for(let d=0;d<s.length;d++){const l=s[d];let c=f[l];switch(typeof c){case"undefined":c=f[l]=Object.create(null);break;case"object":break;default:r(`Ignoring ${n} as ${s.slice(0,d+1).join(".")} is ${JSON.stringify(c)}`);return}f=c}if(typeof f=="object"&&f!==null)try{f[t]=i}catch{r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(f)}`)}else r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(f)}`)}function $(o,n){const i=n.split(".");E(o,i)}function E(o,n){const i=n.shift();if(n.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const r=o[i];typeof r=="object"&&!Array.isArray(r)&&(E(r,n),Object.keys(r).length===0&&delete o[i])}}function v(o,n,i){function r(f,d){let l=f;for(const c of d){if(typeof l!="object"||l===null)return;l=l[c]}return l}const s=n.split("."),t=r(o,s);return typeof t>"u"?i:t}function a(o,n,i){Object.keys(n).forEach(r=>{r!=="__proto__"&&(r in o?u.$6f(o[r])&&u.$6f(n[r])?a(o[r],n[r],i):i&&(o[r]=n[r]):o[r]=n[r])})}function m(o){return o.replace(/[\[\]]/g,"")}}),define(ke[37],Ee([1,0,11,14,246,5,204,13]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$oj=e.$nj=e.ContextKeyExprType=void 0,e.$mj=S,e.$pj=f,e.$qj=d,e.$Jj=ne;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",u.$j),b.set("isLinux",u.$k),b.set("isWindows",u.$i),b.set("isWeb",u.$o),b.set("isMacNative",u.$j&&!u.$o),b.set("isEdge",u.$H),b.set("isFirefox",u.$F),b.set("isChrome",u.$E),b.set("isSafari",u.$G);function S(ee,U){if(b.get(ee)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(ee,U)}const A=Object.prototype.hasOwnProperty;var P;(function(ee){ee[ee.False=0]="False",ee[ee.True=1]="True",ee[ee.Defined=2]="Defined",ee[ee.Not=3]="Not",ee[ee.Equals=4]="Equals",ee[ee.NotEquals=5]="NotEquals",ee[ee.And=6]="And",ee[ee.Regex=7]="Regex",ee[ee.NotRegex=8]="NotRegex",ee[ee.Or=9]="Or",ee[ee.In=10]="In",ee[ee.NotIn=11]="NotIn",ee[ee.Greater=12]="Greater",ee[ee.GreaterEquals=13]="GreaterEquals",ee[ee.Smaller=14]="Smaller",ee[ee.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const $={regexParsingWithErrorRecovery:!0},E=(0,M.localize)(0,null),v=(0,M.localize)(1,null),a=(0,M.localize)(2,null),m=(0,M.localize)(3,null),o=(0,M.localize)(4,null),n=(0,M.localize)(5,null),i=(0,M.localize)(6,null),r=(0,M.localize)(7,null);class s{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=$){this.k=U,this.d=new L.$lj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const be=this.D(),Pe=be.type===17?n:void 0;throw this.h.push({message:o,offset:be.offset,lexeme:L.$lj.getLexeme(be),additionalInfo:Pe}),s.c}return ie}catch(ie){if(ie!==s.c)throw ie;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ie=this.o();U.push(ie)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ie=this.s();U.push(ie)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,m),ie?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,m),ie}case 17:{const ie=U.lexeme;if(this.z(),this.y(9)){const Pe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Pe.type!==10)throw this.B("REGEX",Pe);const oe=Pe.lexeme,ae=oe.lastIndexOf("/"),re=ae===oe.length-1?void 0:this.w(oe.substring(ae+1));let G;try{G=new RegExp(oe.substring(1,ae),re)}catch{throw this.B("REGEX",Pe)}return T.create(ie,G)}switch(Pe.type){case 10:case 19:{const oe=[Pe.lexeme];this.z();let ae=this.D(),re=0;for(let Re=0;Re<Pe.lexeme.length;Re++)Pe.lexeme.charCodeAt(Re)===40?re++:Pe.lexeme.charCodeAt(Re)===41&&re--;for(;!this.E()&&ae.type!==15&&ae.type!==16;){switch(ae.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let Re=0;Re<ae.lexeme.length;Re++)ae.lexeme.charCodeAt(Re)===40?re++:Pe.lexeme.charCodeAt(Re)===41&&re--}if(re<0)break;oe.push(L.$lj.getLexeme(ae)),this.z(),ae=this.D()}const G=oe.join(""),te=G.lastIndexOf("/"),ge=te===G.length-1?void 0:this.w(G.substring(te+1));let we;try{we=new RegExp(G.substring(1,te),ge)}catch{throw this.B("REGEX",Pe)}return t.regex(ie,we)}case 18:{const oe=Pe.lexeme;this.z();let ae=null;if(!(0,N.$3e)(oe)){const re=oe.indexOf("/"),G=oe.lastIndexOf("/");if(re!==G&&re>=0){const te=oe.slice(re+1,G),ge=oe[G+1]==="i"?"i":"";try{ae=new RegExp(te,ge)}catch{throw this.B("REGEX",Pe)}}}if(ae===null)throw this.B("REGEX",Pe);return T.create(ie,ae)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,a);const Pe=this.u();return t.notIn(ie,Pe)}switch(this.D().type){case 3:{this.z();const Pe=this.u();if(this.x().type===18)return t.equals(ie,Pe);switch(Pe){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,Pe)}}case 4:{this.z();const Pe=this.u();if(this.x().type===18)return t.notEquals(ie,Pe);switch(Pe){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,Pe)}}case 5:return this.z(),z.create(ie,this.u());case 6:return this.z(),O.create(ie,this.u());case 7:return this.z(),F.create(ie,this.u());case 8:return this.z(),j.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:r}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ie){if(this.C(U))return this.z();throw this.B(ie,this.D())}B(U,ie,be){const Pe=(0,M.localize)(8,null,U,L.$lj.getLexeme(ie)),oe=ie.offset,ae=L.$lj.getLexeme(ie);return this.h.push({message:Pe,offset:oe,lexeme:ae,additionalInfo:be}),s.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$nj=s;class t{static false(){return c.INSTANCE}static true(){return h.INSTANCE}static has(U){return g.create(U)}static equals(U,ie){return D.create(U,ie)}static notEquals(U,ie){return y.create(U,ie)}static regex(U,ie){return T.create(U,ie)}static in(U,ie){return w.create(U,ie)}static notIn(U,ie){return k.create(U,ie)}static not(U){return C.create(U)}static and(...U){return Z.create(U,null,!0)}static or(...U){return x.create(U,null,!0)}static greater(U,ie){return F.create(U,ie)}static greaterEquals(U,ie){return j.create(U,ie)}static smaller(U,ie){return z.create(U,ie)}static smallerEquals(U,ie){return O.create(U,ie)}static{this.c=new s({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$oj=t;function f(ee){const U=new s({regexParsingWithErrorRecovery:!1});return ee.map(ie=>(U.parse(ie),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,M.localize)(9,null,be.additionalInfo):(0,M.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function d(ee,U){const ie=ee?ee.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!ie&&!be?!0:!ie||!be?!1:ie.equals(be)}function l(ee,U){return ee.cmp(U)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$rj=c;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return c.INSTANCE}}e.$sj=h;class g{static create(U,ie=null){const be=b.get(U);return typeof be=="boolean"?be?h.INSTANCE:c.INSTANCE:new g(U,ie)}constructor(U,ie){this.key=U,this.c=ie,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=b.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:c.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$tj=g;class D{static create(U,ie,be=null){if(typeof ie=="boolean")return ie?g.create(U,be):C.create(U,be);const Pe=b.get(U);return typeof Pe=="boolean"?ie===(Pe?"true":"false")?h.INSTANCE:c.INSTANCE:new D(U,ie,be)}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=b.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?h.INSTANCE:c.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$uj=D;class w{static create(U,ie){return new w(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(ie)?ie.includes(be):typeof be=="string"&&typeof ie=="object"&&ie!==null?A.call(ie,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$vj=w;class k{static create(U,ie){return new k(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=11,this.c=w.create(U,ie)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$wj=k;class y{static create(U,ie,be=null){if(typeof ie=="boolean")return ie?C.create(U,be):g.create(U,be);const Pe=b.get(U);return typeof Pe=="boolean"?ie===(Pe?"true":"false")?c.INSTANCE:h.INSTANCE:new y(U,ie,be)}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=b.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?c.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$xj=y;class C{static create(U,ie=null){const be=b.get(U);return typeof be=="boolean"?be?c.INSTANCE:h.INSTANCE:new C(U,ie)}constructor(U,ie){this.c=U,this.d=ie,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:Y(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=b.get(this.c);return typeof U=="boolean"?U?c.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$yj=C;function I(ee,U){if(typeof ee=="string"){const ie=parseFloat(ee);isNaN(ie)||(ee=ie)}return typeof ee=="string"||typeof ee=="number"?U(ee):c.INSTANCE}class F{static create(U,ie,be=null){return I(ie,Pe=>new F(U,Pe,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$zj=F;class j{static create(U,ie,be=null){return I(ie,Pe=>new j(U,Pe,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Aj=j;class z{static create(U,ie,be=null){return I(ie,Pe=>new z(U,Pe,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Bj=z;class O{static create(U,ie,be=null){return I(ie,Pe=>new O(U,Pe,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ce(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Cj=O;class T{static create(U,ie){return new T(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ie=this.f?this.f.source:"",be=U.f?U.f.source:"";return ie<be?-1:ie>be?1:0}equals(U){if(U.type===this.type){const ie=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&ie===be}return!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Dj=T;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$Ej=B;function W(ee){let U=null;for(let ie=0,be=ee.length;ie<be;ie++){const Pe=ee[ie].substituteConstants();if(ee[ie]!==Pe&&U===null){U=[];for(let oe=0;oe<ie;oe++)U[oe]=ee[oe]}U!==null&&(U[ie]=Pe)}return U===null?ee:U}class Z{static create(U,ie,be){return Z.d(U,ie,be)}constructor(U,ie){this.expr=U,this.c=ie,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,be=this.expr.length;ie<be;ie++){const Pe=l(this.expr[ie],U.expr[ie]);if(Pe!==0)return Pe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:Z.create(U,this.c,!1)}evaluate(U){for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].evaluate(U))return!1;return!0}static d(U,ie,be){const Pe=[];let oe=!1;for(const ae of U)if(ae){if(ae.type===1){oe=!0;continue}if(ae.type===0)return c.INSTANCE;if(ae.type===6){Pe.push(...ae.expr);continue}Pe.push(ae)}if(Pe.length===0&&oe)return h.INSTANCE;if(Pe.length!==0){if(Pe.length===1)return Pe[0];Pe.sort(l);for(let ae=1;ae<Pe.length;ae++)Pe[ae-1].equals(Pe[ae])&&(Pe.splice(ae,1),ae--);if(Pe.length===1)return Pe[0];for(;Pe.length>1;){const ae=Pe[Pe.length-1];if(ae.type!==9)break;Pe.pop();const re=Pe.pop(),G=Pe.length===0,te=x.create(ae.expr.map(ge=>Z.create([ge,re],null,be)),null,G);te&&(Pe.push(te),Pe.sort(l))}if(Pe.length===1)return Pe[0];if(be){for(let ae=0;ae<Pe.length;ae++)for(let re=ae+1;re<Pe.length;re++)if(Pe[ae].negate().equals(Pe[re]))return c.INSTANCE;if(Pe.length===1)return Pe[0]}return new Z(Pe,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new Z(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());this.c=x.create(U,this,!0)}return this.c}}e.$Fj=Z;class x{static create(U,ie,be){return x.d(U,ie,be)}constructor(U,ie){this.expr=U,this.c=ie,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,be=this.expr.length;ie<be;ie++){const Pe=l(this.expr[ie],U.expr[ie]);if(Pe!==0)return Pe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:x.create(U,this.c,!1)}evaluate(U){for(let ie=0,be=this.expr.length;ie<be;ie++)if(this.expr[ie].evaluate(U))return!0;return!1}static d(U,ie,be){let Pe=[],oe=!1;if(U){for(let ae=0,re=U.length;ae<re;ae++){const G=U[ae];if(G){if(G.type===0){oe=!0;continue}if(G.type===1)return h.INSTANCE;if(G.type===9){Pe=Pe.concat(G.expr);continue}Pe.push(G)}}if(Pe.length===0&&oe)return c.INSTANCE;Pe.sort(l)}if(Pe.length!==0){if(Pe.length===1)return Pe[0];for(let ae=1;ae<Pe.length;ae++)Pe[ae-1].equals(Pe[ae])&&(Pe.splice(ae,1),ae--);if(Pe.length===1)return Pe[0];if(be){for(let ae=0;ae<Pe.length;ae++)for(let re=ae+1;re<Pe.length;re++)if(Pe[ae].negate().equals(Pe[re]))return h.INSTANCE;if(Pe.length===1)return Pe[0]}return new x(Pe,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new x(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());for(;U.length>1;){const ie=U.shift(),be=U.shift(),Pe=[];for(const oe of Ce(ie))for(const ae of Ce(be))Pe.push(Z.create([oe,ae],null,!1));U.unshift(x.create(Pe,null,!1))}this.c=x.create(U,this,!0)}return this.c}}e.$Gj=x;class X extends g{static{this.d=[]}static all(){return X.d.values()}constructor(U,ie,be){super(U,null),this.f=ie,typeof be=="object"?X.d.push({...be,key:U}):be!==!0&&X.d.push({key:U,description:be,type:ie!=null?typeof ie:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return y.create(this.key,U)}}e.$Hj=X,e.$Ij=(0,R.$qi)("contextKeyService");function Y(ee,U){return ee<U?-1:ee>U?1:0}function ce(ee,U,ie,be){return ee<ie?-1:ee>ie?1:U<be?-1:U>be?1:0}function ne(ee,U){if(ee.type===0||U.type===1)return!0;if(ee.type===9)return U.type===9?$e(ee.expr,U.expr):!1;if(U.type===9){for(const ie of U.expr)if(ne(ee,ie))return!0;return!1}if(ee.type===6){if(U.type===6)return $e(U.expr,ee.expr);for(const ie of ee.expr)if(ne(ie,U))return!0;return!1}return ee.equals(U)}function $e(ee,U){let ie=0,be=0;for(;ie<ee.length&&be<U.length;){const Pe=ee[ie].cmp(U[be]);if(Pe<0)return!1;Pe===0&&ie++,be++}return ie===ee.length}function Ce(ee){return ee.type===9?ee.expr:[ee]}}),define(ke[249],Ee([1,0,23,40,206,5,103,11,24]),function(le,e,u,N,L,R,M,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Aw=e.$zw=e.$yw=void 0,e.$Bw=E,e.$Cw=v,e.$yw=(0,R.$qi)("dialogService");var S;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(S||(S={}));class A{a(m){return this.d(m,S.Confirmation)}b(m){return this.d(m,S.Prompt)}c(m){return this.d(m,S.Input)}d(m,o){const n=[];switch(o){case S.Confirmation:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(1,null));break}case S.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(r=>r.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,L.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,L.localize)(3,null))),n.length===0&&n.push((0,L.localize)(4,null));break}case S.Input:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,L.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,L.localize)(6,null));break}}return n}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===N.default.Info?"info":m===N.default.Error?"error":m===N.default.Warning?"warning":"none"}f(m,o,n){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let r=i[o]?.run({checkboxChecked:n});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:n}}}e.$zw=A,e.$Aw=(0,R.$qi)("fileDialogService");var P;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const $=10;function E(a){const m=[];return m.push(...a.slice(0,$).map(o=>typeof o=="string"?o:(0,u.$1g)(o))),a.length>$&&(a.length-$===1?m.push((0,L.localize)(7,null)):m.push((0,L.localize)(8,null,a.length-$))),m.push(""),m.join(`
`)}function v(a,m){const o=(0,b.$Wn)(a);let n=(o.buttons??[]).map(t=>(0,M.$vw)(t)),i=(a.buttons||[]).map((t,f)=>f),r=0,s=o.cancelId??n.length-1;if(n.length>1){const t=typeof s=="number"?n[s]:void 0;if(p.$k||p.$j){if(typeof t=="string"&&n.length>1&&s!==1){n.splice(s,1),n.splice(1,0,t);const f=i[s];i.splice(s,1),i.splice(1,0,f),s=1}p.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),r=n.length-1,typeof t=="string"&&(s=r-1))}else if(p.$i&&typeof t=="string"&&n.length>1&&s!==n.length-1){n.splice(s,1),n.push(t);const f=i[s];i.splice(s,1),i.push(f),s=n.length-1}}return o.buttons=n,o.defaultId=r,o.cancelId=s,o.noLink=!0,o.title=o.title||m.nameLong,{options:o,buttonIndeces:i}}}),define(ke[136],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=void 0,e.$xi=(0,u.$qi)("environmentService"),e.$yi=(0,u.$ri)(e.$xi)}),define(ke[137],Ee([1,0,207,5]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.ExtensionGalleryErrorCode=e.$1o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$To=L,e.$Uo=R,e.$Vo=M,e.$Wo=p,e.$Xo=b,e.$Yo=S,e.$No="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Oo=new RegExp(e.$No),e.$Po="__web_extension",e.$Qo="skipWalkthrough",e.$Ro="extensionsSync",e.$So="dependecyOrPackExtensionInstall";function L(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(i,r){return r==="web"&&!i.includes("web")}function b(i,r,s){return p(r,s)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===s}function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var P;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var $;(function(i){i.Install="install",i.Uninstall="uninstall"})($||(e.StatisticType=$={}));var E;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$Zo=(0,N.$qi)("extensionGalleryService");var v;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var a;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class m extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$1o=m;var o;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class n extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$2o=n,e.$3o=(0,N.$qi)("extensionManagementService"),e.$4o="extensionsIdentifiers/disabled",e.$5o="extensionsIdentifiers/enabled",e.$6o=(0,N.$qi)("IGlobalExtensionEnablementService"),e.$7o=(0,N.$qi)("IExtensionTipsService"),e.$8o=(0,u.localize2)(0,"Extensions"),e.$9o=(0,u.localize2)(1,"Preferences")}),define(ke[250],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c6b=e.$b6b=void 0,e.$b6b=(0,u.$qi)("externalTerminal"),e.$c6b="Terminal.app"}),define(ke[251],Ee([1,0,53,55,15,17,11,102,31,105,209,250]),function(le,e,u,N,L,R,M,p,b,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=e.$kbc=e.$jbc=void 0;const $=A.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends E{static{this.b="cmd.exe"}openTerminal(s,t){return this.spawnTerminal(u,s,S.$im(),t)}spawnTerminal(s,t,f,d){const l=t.windowsExec||v.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const c=R.$oc(l,".exe").toLowerCase();if(c==="cmder")return s.spawn(l,d?[d]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return l.indexOf(" ")>=0&&h.push('""'),h.push(l),c==="wt"&&h.push("-d ."),new Promise((g,D)=>{const w=o(process),k=s.spawn(f,h,{cwd:d,env:w,detached:!0});k.on("error",D),k.on("exit",()=>g())})}async runInTerminal(s,t,f,d,l){const c="windowsExec"in l&&l.windowsExec?l.windowsExec:v.getDefaultTerminalWindows(),h=await v.f();return new Promise((g,D)=>{const w=`"${t} - ${$}"`,k=`"${f.join('" "')}" & pause`,y=Object.assign({},o(process),d);Object.keys(y).filter(z=>y[z]===null).forEach(z=>delete y[z]);const C={cwd:t,env:y,windowsVerbatimArguments:!0};let I,F;R.$oc(c,".exe")==="wt"?(I=c,F=["-d",".",v.b,"/c",k]):h?(I=h,F=["-d",".",c,"/c",k]):(I=v.b,F=["/c","start",w,"/wait",c,"/c",`"${k}"`]),u.spawn(I,F,C).on("error",z=>{D(n(z))}),g(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const s=await S.win32.findExecutable("wt");return await b.Promises.exists(s)?s:void 0}catch{return}}}e.$jbc=v,Je([N.$Uh],v,"f",null);class a extends E{static{this.b="/usr/bin/osascript"}openTerminal(s,t){return this.spawnTerminal(u,s,t)}runInTerminal(s,t,f,d,l){const c=l.osxExec||P.$c6b;return new Promise((h,g)=>{if(c===P.$c6b||c==="iTerm.app"){const D=c===P.$c6b?"TerminalHelper":"iTermHelper",k=[L.$Kg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",s||$,"-w",t];for(const I of f)k.push("-a"),k.push(I);if(d){const I=Object.assign({},o(process),d);for(const F in I){const j=I[F];j===null?(k.push("-u"),k.push(F)):(k.push("-e"),k.push(`${F}=${j}`))}}let y="";const C=u.spawn(a.b,k);C.on("error",I=>{g(n(I))}),C.stderr.on("data",I=>{y+=I.toString()}),C.on("exit",I=>{if(I===0)h(void 0);else if(y){const F=y.split(`
`,1);g(new Error(F[0]))}else g(new Error(A.localize(1,null,D,I)))})}else g(new Error(A.localize(2,null,c)))})}spawnTerminal(s,t,f){const d=t.osxExec||P.$c6b;return new Promise((l,c)=>{const h=["-a",d];f&&h.push(f);const g=o(process),D=s.spawn("/usr/bin/open",h,{cwd:f,env:g});D.on("error",c),D.on("exit",()=>l())})}}e.$kbc=a;class m extends E{static{this.b=A.localize(3,null)}openTerminal(s,t){return this.spawnTerminal(u,s,t)}runInTerminal(s,t,f,d,l){const c=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((h,g)=>{const D=[];c.then(w=>{w.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const k=`${i(f)}; echo; read -p "${m.b}" -n1;`;D.push(`''${k}''`);const y=Object.assign({},o(process),d);Object.keys(y).filter(j=>y[j]===null).forEach(j=>delete y[j]);const C={cwd:t,env:y};let I="";const F=u.spawn(w,D,C);F.on("error",j=>{g(n(j))}),F.stderr.on("data",j=>{I+=j.toString()}),F.on("exit",j=>{if(j===0)h(void 0);else if(I){const z=I.split(`
`,1);g(new Error(z[0]))}else g(new Error(A.localize(4,null,w,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!M.$k)m.d=Promise.resolve("xterm");else{const s=await b.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{s?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(s,t,f){const d=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,c)=>{d.then(h=>{const g=o(process),D=s.spawn(h,[],{cwd:f,env:g});D.on("error",c),D.on("exit",()=>l())})})}}e.$lbc=m;function o(r){const s={...r.env};return(0,p.$gm)(s),s}function n(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(A.localize(5,null,r.path)):r}function i(r){let s="";for(const t of r)t.indexOf(" ")>=0?s+='"'+t+'"':s+=t,s+=" ";return s}}),define(ke[32],Ee([1,0,77,17,14,18,2,210,5,11,15,46]),function(le,e,u,N,L,R,M,p,b,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$pl=e.FileKind=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.FileOperationResult=e.$hl=e.$gl=e.$fl=e.$dl=e.FileChangeType=e.$cl=e.FileOperation=e.$9k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Wk=void 0,e.$Xk=$,e.$Yk=a,e.$Zk=o,e.$1k=n,e.$2k=i,e.$3k=r,e.$4k=s,e.$5k=t,e.$6k=f,e.$7k=d,e.$8k=l,e.$0k=g,e.$$k=D,e.$_k=w,e.$al=k,e.$bl=y,e.$el=z,e.$ql=x,e.$rl=X,e.$tl=ce,e.$Wk=(0,b.$qi)("fileService");function $(ne){return ne.create===!0}var E;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var v;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function a(ne){const $e=ne;return!!$e&&typeof $e.onDidChange=="function"}var m;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function o(ne){return!!(ne.capabilities&2)}function n(ne){return!!(ne.capabilities&8)}function i(ne){return!!(ne.capabilities&131072)}function r(ne){return!!(ne.capabilities&4)}function s(ne){return!!(ne.capabilities&16)}function t(ne){return o(ne)?!!(ne.capabilities&16384):!1}function f(ne){return o(ne)?!!(ne.capabilities&32768):!1}function d(ne){return!!(ne.capabilities&65536)}function l(ne){return!!(ne.capabilities&2048)}var c;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class h extends Error{static create($e,Ce){const ee=new h($e.toString(),Ce);return w(ee,Ce),ee}constructor($e,Ce){super($e),this.code=Ce}}e.$9k=h;function g(ne,$e){return h.create(ne,$e)}function D(ne){return ne||g((0,p.localize)(0,null),c.Unknown)}function w(ne,$e){return ne.name=$e?`${$e} (FileSystemError)`:"FileSystemError",ne}function k(ne){if(!ne)return c.Unknown;if(ne instanceof h)return ne.code;const $e=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!$e)return c.Unknown;switch($e[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}function y(ne){if(ne instanceof O)return ne.fileOperationResult;switch(k(ne)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}var C;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class I{constructor($e,Ce,ee){this.resource=$e,this.operation=Ce,this.target=ee}isOperation($e){return this.operation===$e}}e.$cl=I;var F;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class j{static{this.a=null}constructor($e,Ce){this.c=Ce,this.b=void 0,this.d=new P.$V(()=>{const ee=u.$wi.forUris(()=>this.c);return ee.fill(this.rawAdded.map(U=>[U,!0])),ee}),this.f=new P.$V(()=>{const ee=u.$wi.forUris(()=>this.c);return ee.fill(this.rawUpdated.map(U=>[U,!0])),ee}),this.g=new P.$V(()=>{const ee=u.$wi.forUris(()=>this.c);return ee.fill(this.rawDeleted.map(U=>[U,!0])),ee}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ee of $e){switch(ee.type){case 1:this.rawAdded.push(ee.resource);break;case 0:this.rawUpdated.push(ee.resource);break;case 2:this.rawDeleted.push(ee.resource);break}this.b!==j.a&&(typeof ee.cId=="number"?this.b===void 0?this.b=ee.cId:this.b!==ee.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains($e,...Ce){return this.h($e,{includeChildren:!1},...Ce)}affects($e,...Ce){return this.h($e,{includeChildren:!0},...Ce)}h($e,Ce,...ee){if(!$e)return!1;const U=ee.length>0;return!!((!U||ee.includes(1))&&(this.d.value.get($e)||Ce.includeChildren&&this.d.value.findSuperstr($e))||(!U||ee.includes(0))&&(this.f.value.get($e)||Ce.includeChildren&&this.f.value.findSuperstr($e))||(!U||ee.includes(2))&&(this.g.value.findSubstr($e)||Ce.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$dl=j;function z(ne,$e,Ce){return!ne||!$e||ne===$e||$e.length>ne.length?!1:($e.charAt($e.length-1)!==N.sep&&($e+=N.sep),Ce?(0,L.$uf)(ne,$e):ne.indexOf($e)===0)}class O extends Error{constructor($e,Ce,ee){super($e),this.fileOperationResult=Ce,this.options=ee}}e.$fl=O;class T extends O{constructor($e,Ce,ee,U){super($e,Ce,U),this.fileOperationResult=Ce,this.size=ee}}e.$gl=T;class B extends O{constructor($e,Ce,ee){super($e,2,ee),this.stat=Ce}}e.$hl=B;var W;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$il={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$jl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$kl="files.associations",e.$ll="files.exclude",e.$ml="files.readonlyInclude",e.$nl="files.readonlyExclude",e.$ol="files.readonlyFromPermissions";var Z;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z||(e.FileKind=Z={})),e.$pl="";function x(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function X(ne,$e){if(!$e.hasProvider(M.URI.from({scheme:ne.scheme})))return new Promise(Ce=>{const ee=$e.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===ne.scheme&&U.added&&(ee.dispose(),Ce())})})}class Y{static{this.KB=1024}static{this.MB=Y.KB*Y.KB}static{this.GB=Y.MB*Y.KB}static{this.TB=Y.GB*Y.KB}static formatSize($e){return(0,R.$8f)($e)||($e=0),$e<Y.KB?(0,p.localize)(1,null,$e.toFixed(0)):$e<Y.MB?(0,p.localize)(2,null,($e/Y.KB).toFixed(2)):$e<Y.GB?(0,p.localize)(3,null,($e/Y.MB).toFixed(2)):$e<Y.TB?(0,p.localize)(4,null,($e/Y.GB).toFixed(2)):(0,p.localize)(5,null,($e/Y.TB).toFixed(2))}}e.$sl=Y;function ce(ne){const $e=typeof ne=="string"||ne?.scheme===A.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===A.Schemas.file?1024*Y.MB:$e?10*Y.MB:S.$o?50*Y.MB:1024*Y.MB}}),define(ke[252],Ee([1,0,21,13,211,32]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=M;async function M(A,P,$,E,v,a){let m;try{await p(A,P,$,E,v,a)}catch(o){m=o}finally{m&&v.errorTransformer&&(m=v.errorTransformer(m)),typeof m<"u"&&$.error(m),$.end()}}async function p(A,P,$,E,v,a){b(a);const m=await A.open(P,{create:!1});try{b(a);let o=0,n=0,i=v&&typeof v.length=="number"?v.length:void 0,r=u.$Ce.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),s=v&&typeof v.position=="number"?v.position:0,t=0;do n=await A.read(m,s,r.buffer,t,r.byteLength-t),s+=n,t+=n,o+=n,typeof i=="number"&&(i-=n),t===r.byteLength&&(await $.write(E(r)),r=u.$Ce.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&b(a)&&S(o,v));if(t>0){let f=t;typeof i=="number"&&(f=Math.min(t,i)),$.write(E(r.slice(0,f)))}}catch(o){throw(0,R.$$k)(o)}finally{await A.close(m)}}function b(A){if(A.isCancellationRequested)throw(0,N.$6)();return!0}function S(A,P){if(typeof P?.limits?.size=="number"&&A>P.limits.size)throw(0,R.$0k)((0,L.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[65],Ee([1,0,35,3,17,11,2,32]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=void 0,e.$Dq=b,e.$Eq=S,e.$Iq=E,e.$Jq=v,e.$Kq=a,e.$Lq=m;function b(n){return typeof n.correlationId=="number"}function S(n){return n.recursive===!0}class A extends N.$Uc{static{this.a=5}constructor(i,r,s,t){super(),this.h=i,this.j=r,this.m=s,this.n=t,this.c=this.B(new N.$Vc),this.f=void 0,this.g=0}s(){const i=new N.$Tc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Fq=A;class P extends A{constructor(i,r,s){super(i,r,s,{type:"node.js",restartOnError:!1})}}e.$Gq=P;class $ extends A{constructor(i,r,s){super(i,r,s,{type:"universal",restartOnError:!0})}}e.$Hq=$;function E(n){return n.map(i=>({type:i.type,resource:M.URI.revive(i.resource),cId:i.cId}))}function v(n){const i=new o;for(const r of n)i.processEvent(r);return i.coalesce()}function a(n,i){return typeof i=="string"&&!i.startsWith(u.$gk)&&!(0,L.$jc)(i)?{base:n,pattern:i}:i}function m(n,i){const r=[];for(const s of i)r.push((0,u.$kk)(a(n,s)));return r}class o{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let s=!1;if(r){const t=r.type,f=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?s=!0:t===1&&f===2?(this.b.delete(this.c(i)),this.a.delete(r)):t===2&&f===1?r.type=0:t===1&&f===0||(r.type=f)}else s=!0;s&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(s=>s.type!==2?(i.push(s),!1):!0).sort((s,t)=>s.resource.fsPath.length-t.resource.fsPath.length).filter(s=>r.some(t=>(0,p.$el)(s.resource.fsPath,t,!R.$k))?!1:(r.push(s.resource.fsPath),!0)).concat(i)}}}),define(ke[253],Ee([1,0,52,3,65,4,2,7]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class b extends N.$Uc{constructor(){super(),this.a=this.B(new R.$be),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$be),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$be),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$4c),this.m=new Set,this.n=5007,this.r=new p.$Nh,this.B(this.f(A=>this.s(A)))}s(A){this.t(A)&&this.w(A)}t(A){return(0,L.$Dq)(A)}async watch(A){this.r.isSettled||this.r.complete(),this.r=new p.$Nh;try{this.h.clear(),this.g.clear();for(const P of A)this.t(P)?this.h.set(P.correlationId,P):this.g.add(P);for(const[P]of this.j)this.h.has(P)||(this.j.deleteAndDispose(P),this.m.delete(P));return await this.u()}finally{this.r.complete()}}u(){return this.J([...this.g,...Array.from(this.h.values()).filter(A=>!this.j.has(A.correlationId))])}isSuspended(A){return typeof A.correlationId!="number"?!1:this.m.has(A.correlationId)?"polling":this.j.has(A.correlationId)}async w(A){if(this.j.has(A.correlationId))return;const P=new N.$Tc;this.j.set(A.correlationId,P),await this.r.p,!P.isDisposed&&(this.z(A,P),this.u())}y(A){this.j.deleteAndDispose(A.correlationId),this.m.delete(A.correlationId),this.u()}z(A,P){this.C(A,P)?(this.M(`reusing an existing recursive watcher to monitor ${A.path}`),this.m.delete(A.correlationId)):(this.D(A,P),this.m.add(A.correlationId))}C(A,P){const $=this.L?.subscribe(A.path,(E,v)=>{P.isDisposed||(E?this.z(A,P):v?.type===1&&this.F(A))});return $?(P.add($),!0):!1}D(A,P){let $=!1;const E=(v,a)=>{if(P.isDisposed)return;const m=this.G(v),o=this.G(a),n=$;$=m,!m&&(o||n)&&this.F(A)};this.M(`starting fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,u.watchFile)(A.path,{persistent:!1,interval:this.n},E)}catch(v){this.N(`fs.watchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}P.add((0,N.$Sc)(()=>{this.M(`stopping fs.watchFile() on ${A.path} (correlationId: ${A.correlationId})`);try{(0,u.unwatchFile)(A.path,E)}catch(v){this.N(`fs.unwatchFile() failed with error ${v} on path ${A.path} (correlationId: ${A.correlationId})`)}}))}F(A){this.M(`detected ${A.path} exists again, resuming watcher (correlationId: ${A.correlationId})`);const P={resource:M.URI.file(A.path),type:1,cId:A.correlationId};this.a.fire([P]),this.H(P,A),this.y(A)}G(A){return A.ctimeMs===0&&A.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(A,P){const $=` >> normalized ${A.type===1?"[ADDED]":A.type===2?"[DELETED]":"[CHANGED]"} ${A.resource.fsPath}`;this.M(typeof P.correlationId=="number"?`${$} (correlationId: ${P.correlationId})`:$)}I(A){return`${A.path} (excludes: ${A.excludes.length>0?A.excludes:"<none>"}, includes: ${A.includes&&A.includes.length>0?JSON.stringify(A.includes):"<all>"}, correlationId: ${typeof A.correlationId=="number"?A.correlationId:"<none>"})`}}e.$Uq=b}),define(ke[254],Ee([1,0,52,7,22,34,3,76,17,11,23,2,104,31,65]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0,e.$1q=m;class a extends M.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.m}get failed(){return this.n}constructor(n,i,r,s,t,f){super(),this.r=n,this.s=i,this.t=r,this.u=s,this.w=t,this.y=f,this.c=this.B(new N.$Fh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.t(d))),this.f=this.B(new N.$Eh(d=>this.L(d),a.b)),this.g=(0,v.$Lq)(this.r.path,this.r.excludes),this.h=this.r.includes?(0,v.$Lq)(this.r.path,this.r.includes):void 0,this.j=new L.$me,this.ready=this.z(),this.m=!1,this.n=!1}async z(){try{const n=await this.D(this.r);if(this.j.token.isCancellationRequested)return;const i=await E.Promises.stat(n);if(this.j.token.isCancellationRequested)return;this.B(await this.F(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.N(n):this.P(`ignoring a path for watching who's stat info failed to resolve: ${this.r.path} (error: ${n})`),this.C()}}C(){this.n=!0,this.u?.()}async D(n){let i=n.path;try{i=await E.Promises.realpath(n.path),n.path===i&&(i=await(0,$.$Wq)(n.path,this.j.token)??n.path),n.path!==i&&this.P(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async F(n,i){const r=new M.$Tc;return this.G(n,i,r)?(this.P(`reusing an existing recursive watcher for ${this.r.path}`),this.m=!0):(this.m=!1,await this.H(n,i,r)),r}G(n,i,r){if(i)return!1;const s=P.URI.file(this.r.path),t=this.s?.subscribe(this.r.path,async(f,d)=>{if(!r.isDisposed)if(f){const l=await this.F(n,i);r.isDisposed?l.dispose():r.add(l)}else d&&(typeof d.cId=="number"||typeof this.r.correlationId=="number")&&this.t([{resource:s,type:d.type,cId:this.r.correlationId}])});return t?(r.add(t),!0):!1}async H(n,i,r){if(S.$j&&(0,R.$qg)(n,"/Volumes/",!0)){this.N(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const s=new L.$me(this.j.token);r.add((0,M.$Sc)(()=>s.dispose(!0)));const t=new M.$Tc;r.add(t);try{const f=P.URI.file(this.r.path),d=(0,b.$oc)(n),l=(0,u.watch)(n);t.add((0,M.$Sc)(()=>{l.removeAllListeners(),l.close()})),this.P(`Started watching: '${n}'`);const c=new Set;if(i)try{for(const g of await E.Promises.readdir(n))c.add(g)}catch(g){this.N(g)}if(s.token.isCancellationRequested)return;const h=new Map;t.add((0,M.$Sc)(()=>{for(const[,g]of h)g.dispose();h.clear()})),l.on("error",(g,D)=>{s.token.isCancellationRequested||(this.N(`Failed to watch ${n} for changes using fs.watch() (${g}, ${D})`),this.C())}),l.on("change",(g,D)=>{if(s.token.isCancellationRequested)return;this.P(`[raw] ["${g}"] ${D}`);let w="";if(D&&(w=D.toString(),S.$j&&(w=(0,p.$8l)(w))),!(!w||g!=="change"&&g!=="rename"))if(i)if(g==="rename"){h.get(w)?.dispose();const k=setTimeout(async()=>{if(h.delete(w),w===d&&!await E.Promises.exists(n)){this.I(f);return}if(s.token.isCancellationRequested)return;const y=await this.M((0,b.$kc)(n,w));if(s.token.isCancellationRequested)return;let C;y?c.has(w)?C=0:(C=1,c.add(w)):(c.delete(w),C=2),this.J({resource:(0,A.$4g)(f,w),type:C,cId:this.r.correlationId})},a.a);h.set(w,(0,M.$Sc)(()=>clearTimeout(k)))}else{let k;c.has(w)?k=0:(k=1,c.add(w)),this.J({resource:(0,A.$4g)(f,w),type:k,cId:this.r.correlationId})}else if(g==="rename"||w!==d){const k=setTimeout(async()=>{const y=await E.Promises.exists(n);s.token.isCancellationRequested||(y?(this.J({resource:f,type:0,cId:this.r.correlationId},!0),t.add(await this.F(n,!1))):this.I(f))},a.a);t.clear(),t.add((0,M.$Sc)(()=>clearTimeout(k)))}else this.J({resource:f,type:0,cId:this.r.correlationId},!0)})}catch(f){s.token.isCancellationRequested||this.N(`Failed to watch ${n} for changes using fs.watch() (${f.toString()})`),this.C()}}I(n){this.O("Watcher shutdown because watched path got deleted"),this.J({resource:n,type:2,cId:this.r.correlationId},!0),this.f.flush(),this.C()}J(n,i=!1){this.j.token.isCancellationRequested||(this.y&&this.P(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(r=>r(n.resource.fsPath))?this.y&&this.P(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(r=>r(n.resource.fsPath))?this.y&&this.P(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}L(n){const i=(0,v.$Jq)(n);if(i.length>0){if(this.y)for(const s of i)this.P(` >> normalized ${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.P(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.O(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async M(n){if(S.$k)return E.Promises.exists(n);try{const i=(0,b.$oc)(n);return(await E.Promises.readdir((0,b.$nc)(n))).some(s=>s===i)}catch(i){return this.P(i),!1}}setVerboseLogging(n){this.y=n}N(n){this.j.token.isCancellationRequested||this.w?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}O(n){this.j.token.isCancellationRequested||this.w?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}P(n){!this.j.token.isCancellationRequested&&this.y&&this.w?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Zq=a;async function m(o,n,i,r,s=512){const t=await E.Promises.open(o,"r"),f=Buffer.allocUnsafe(s),d=new L.$me(r);let l,c=!1;const h={path:o,excludes:[],recursive:!1},g=new a(h,void 0,D=>{(async()=>{for(const{type:w}of D)if(w===0){if(c)return;c=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:k}=await E.Promises.read(t,f,0,s,null);if(!k||d.token.isCancellationRequested)break;n(f.slice(0,k))}}catch(k){l=new Error(k),d.dispose(!0)}finally{c=!1}}})()});return await g.ready,i(),new Promise((D,w)=>{d.token.onCancellationRequested(async()=>{g.dispose();try{await E.Promises.close(t)}catch(k){l=new Error(k)}l?w(l):D()})})}}),define(ke[255],Ee([1,0,4,35,253,11,254,34]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class b extends L.$Uq{constructor(A){super(),this.L=A,this.onDidError=u.Event.None,this.watchers=new Set,this.O=!1}async J(A){A=this.W(A);const P=[],$=new Set(Array.from(this.watchers));for(const E of A){const v=this.R(E);v&&(0,N.$ok)(v.request.excludes,E.excludes)&&(0,N.$ok)(v.request.includes,E.includes)?$.delete(v):P.push(E)}P.length&&this.M(`Request to start watching: ${P.map(E=>this.I(E)).join(",")}`),$.size&&this.M(`Request to stop watching: ${Array.from($).map(E=>this.I(E.request)).join(",")}`);for(const E of $)this.U(E);for(const E of P)this.S(E)}R(A){for(const P of this.watchers)if(typeof A.correlationId=="number"||typeof P.request.correlationId=="number"){if(P.request.correlationId===A.correlationId)return P}else if((0,p.$pg)(P.request.path,A.path,!R.$k))return P}S(A){const P=new M.$Zq(A,this.L,E=>this.a.fire(E),()=>this.c.fire(A),E=>this.b.fire(E),this.O),$={request:A,instance:P};this.watchers.add($)}async stop(){await super.stop();for(const A of this.watchers)this.U(A)}U(A){this.M("stopping file watcher",A),this.watchers.delete(A),A.instance.dispose()}W(A){const P=new Map;for(const $ of A){const E=R.$k?$.path:$.path.toLowerCase();let v=P.get($.correlationId);v||(v=new Map,P.set($.correlationId,v)),v.has(E)&&this.M(`ignoring a request for watching who's path is already watched: ${this.I($)}`),v.set(E,$)}return Array.from(P.values()).map($=>Array.from($.values())).flat()}async setVerboseLogging(A){this.O=A;for(const P of this.watchers)P.instance.setVerboseLogging(A)}M(A,P){this.O&&this.b.fire({type:"trace",message:this.Z(A,P)})}N(A){this.b.fire({type:"warn",message:this.Z(A)})}Z(A,P){return P?`[File Watcher (node.js)] ${A} (${this.I(P.request)})`:`[File Watcher (node.js)] ${A}`}}e.$2q=b}),define(ke[256],Ee([1,0,65,255]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class L extends u.$Gq{constructor(M,p,b){super(M,p,b),this.s()}r(M){return M.add(new N.$2q(void 0))}}e.$3q=L}),define(ke[257],Ee([1,0,15,81,194,65]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class M extends R.$Hq{constructor(b,S,A){super(b,S,A),this.s()}r(b){const S=b.add(new L.$Sq(u.$Kg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(S.onDidProcessExit(({code:A,signal:P})=>this.t(`terminated by itself with code ${A}, signal: ${P}`))),N.ProxyChannel.toService((0,N.$0h)(S.getChannel("watcher")))}}e.$Tq=M}),define(ke[107],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class u{constructor(...L){this.a=new Map;for(const[R,M]of L)this.set(R,M)}set(L,R){const M=this.a.get(L);return this.a.set(L,R),M}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$oi=u}),define(ke[258],Ee([1,0,7,13,3,106,248,5,107,75]),function(le,e,u,N,L,R,M,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=void 0;const A=!1;class P extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class ${constructor(m=new b.$oi,o=!1,n,i=A){this.i=m,this.j=o,this.k=n,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$pi,this),this._globalGraph=i?n?._globalGraph??new M.$6q(r=>r):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Pc)(this.h),this.h.clear();for(const m of this.g)(0,L.$Oc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m){this.m();const o=new class extends ${dispose(){this.h.delete(o),super.dispose()}}(m,this.j,this,this.l);return this.h.add(o),o}invokeFunction(m,...o){this.m();const n=v.traceInvocation(this.l,m);let i=!1;try{return m({get:s=>{if(i)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(s,n);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...o)}finally{i=!0,n.stop()}}createInstance(m,...o){this.m();let n,i;return m instanceof R.$ni?(n=v.traceCreation(this.l,m.ctor),i=this.o(m.ctor,m.staticArguments.concat(o),n)):(n=v.traceCreation(this.l,m),i=this.o(m,o,n)),n.stop(),i}o(m,o=[],n){const i=p._util.getServiceDependencies(m).sort((t,f)=>t.index-f.index),r=[];for(const t of i){const f=this.s(t.id,n);f||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(f)}const s=i.length>0?i[0].index:o.length;if(o.length!==s){console.trace(`[createInstance] First service dependency of ${m.name} at position ${s+1} conflicts with ${o.length} static arguments`);const t=s-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,s)}return Reflect.construct(m,o.concat(r))}q(m,o){if(this.i.get(m)instanceof R.$ni)this.i.set(m,o);else if(this.k)this.k.q(m,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const o=this.i.get(m);return!o&&this.k?this.k.r(m):o}s(m,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const n=this.r(m);return n instanceof R.$ni?this.u(m,n,o.branch(m,!0)):(o.branch(m,!1),n)}u(m,o,n){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,o,n)}finally{this.t.delete(m)}}v(m,o,n){const i=new M.$6q(t=>t.id.toString());let r=0;const s=[{id:m,desc:o,_trace:n}];for(;s.length;){const t=s.pop();if(i.lookupOrInsertNode(t),r++>1e3)throw new P(i);for(const f of p._util.getServiceDependencies(t.desc.ctor)){const d=this.r(f.id);if(d||this.y(`[createInstance] ${m} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),d instanceof R.$ni){const l={id:f.id,desc:d,_trace:t._trace.branch(f.id,!0)};i.insertEdge(t,l),s.push(l)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new P(i);break}for(const{data:f}of t){if(this.r(f.id)instanceof R.$ni){const l=this.w(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.q(f.id,l)}i.removeNode(f)}}return this.r(m)}w(m,o,n=[],i,r){if(this.i.get(m)instanceof R.$ni)return this.x(m,o,n,i,r,this.g);if(this.k)return this.k.w(m,o,n,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(m,o,n=[],i,r,s){if(i){const t=new $(void 0,this.j,this,this.l);t.c=String(m);const f=new Map,d=new u.$Jh(()=>{const l=t.o(o,n,r);for(const[c,h]of f){const g=l[c];if(typeof g=="function")for(const D of h)D.disposable=g.apply(l,D.listener)}return f.clear(),s.add(l),l});return new Proxy(Object.create(null),{get(l,c){if(!d.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let D=f.get(c);return D||(D=new S.$5c,f.set(c,D)),(k,y,C)=>{if(d.isInitialized)return d.value[c](k,y,C);{const I={listener:[k,y,C],disposable:void 0},F=D.push(I);return(0,L.$Sc)(()=>{F(),I.disposable?.dispose()})}}}if(c in l)return l[c];const h=d.value;let g=h[c];return typeof g!="function"||(g=g.bind(h),l[c]=g),g},set(l,c,h){return d.value[c]=h,!0},getPrototypeOf(l){return o.prototype}})}else{const t=this.o(o,n,r);return s.add(t),t}}y(m,o){if(o&&console.warn(m),this.j)throw new Error(m)}}e.$7q=$;var E;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(E||(E={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,o){return m?new v(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(m,o){return m?new v(1,o.name):v.c}static{this.f=0}constructor(m,o){this.type=m,this.name=o,this.g=Date.now(),this.h=[]}branch(m,o){const n=new v(3,m.toString());return this.h.push([m,o,n]),n}stop(){const m=Date.now()-this.g;v.f+=m;let o=!1;function n(r,s){const t=[],f=new Array(r+1).join("	");for(const[d,l,c]of s.h)if(l&&c){o=!0,t.push(`${f}CREATES -> ${d}`);const h=n(r+1,c);h&&t.push(h)}else t.push(`${f}uses -> ${d}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(m>2||o)&&v.all.add(i.join(`
`))}}e.$8q=v}),define(ke[12],Ee([1,0,213,47,4,56,3,27,11,23,18,2,37,5]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$Zj=e.LogLevel=e.$Xj=e.$Wj=void 0,e.$Yj=a,e.log=o,e.$$j=g,e.$_j=D,e.$ak=w,e.$bk=k,e.$Wj=(0,E.$qi)("logService"),e.$Xj=(0,E.$qi)("loggerService");function v(){return new Date().toISOString()}function a(y){return(0,A.$8f)(y)}var m;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Zj=m.Info;function o(y,C,I){switch(C){case m.Trace:y.trace(I);break;case m.Debug:y.debug(I);break;case m.Info:y.info(I);break;case m.Warning:y.warn(I);break;case m.Error:y.error(I);break;case m.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(y,C=!1){let I="";for(let F=0;F<y.length;F++){let j=y[F];if(j instanceof Error&&(j=(0,N.$bj)(j,C)),typeof j=="object")try{j=JSON.stringify(j)}catch{}I+=(F>0?" ":"")+j}return I}class i extends M.$Uc{constructor(){super(...arguments),this.b=e.$Zj,this.c=this.B(new L.$be),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==m.Off&&this.b<=C}}e.$2j=i;class r extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...I){this.f(m.Trace)&&this.g(m.Trace,n([C,...I],!0))}debug(C,...I){this.f(m.Debug)&&this.g(m.Debug,n([C,...I]))}info(C,...I){this.f(m.Info)&&this.g(m.Info,n([C,...I]))}warn(C,...I){this.f(m.Warning)&&this.g(m.Warning,n([C,...I]))}error(C,...I){if(this.f(m.Error))if(C instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=C.stack,this.g(m.Error,n(F))}else this.g(m.Error,n([C,...I]))}flush(){}}e.$3j=r;class s extends i{constructor(C=e.$Zj){super(),this.setLevel(C),this.g=!b.$i}trace(C,...I){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...I):console.log(`[main ${v()}]`,C,...I))}debug(C,...I){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...I):console.log(`[main ${v()}]`,C,...I))}info(C,...I){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...I):console.log(`[main ${v()}]`,C,...I))}warn(C,...I){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,C,...I):console.warn(`[main ${v()}]`,C,...I))}error(C,...I){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,C,...I):console.error(`[main ${v()}]`,C,...I))}flush(){}}e.$4j=s;class t extends i{constructor(C=e.$Zj,I=!0){super(),this.g=I,this.setLevel(C)}trace(C,...I){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...I):console.log(C,...I))}debug(C,...I){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...I):console.log(C,...I))}info(C,...I){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...I):console.log(C,...I))}warn(C,...I){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...I):console.log(C,...I))}error(C,...I){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...I):console.error(C,...I))}flush(){}}e.$5j=t;class f extends i{constructor(C,I=e.$Zj){super(),this.g=C,this.setLevel(I)}trace(C,...I){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(C),...I])}debug(C,...I){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(C),...I])}info(C,...I){this.f(m.Info)&&this.g.log(m.Info,[this.h(C),...I])}warn(C,...I){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(C),...I])}error(C,...I){this.f(m.Error)&&this.g.log(m.Error,[this.h(C),...I])}h(C){return typeof C=="string"?C:(0,N.$bj)(C,this.f(m.Trace))}flush(){}}e.$6j=f;class d extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const I of this.g)I.setLevel(C);super.setLevel(C)}trace(C,...I){for(const F of this.g)F.trace(C,...I)}debug(C,...I){for(const F of this.g)F.debug(C,...I)}info(C,...I){for(const F of this.g)F.info(C,...I)}warn(C,...I){for(const F of this.g)F.warn(C,...I)}error(C,...I){for(const F of this.g)F.error(C,...I)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$7j=d;class l extends M.$Uc{constructor(C,I,F){if(super(),this.h=C,this.j=I,this.b=new p.$Bc,this.c=this.B(new L.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$be),this.onDidChangeVisibility=this.g.event,F)for(const j of F)this.b.set(j.resource,{logger:void 0,info:j})}m(C){return(0,A.$4f)(C)?[...this.b.values()].find(I=>I.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,I){const F=this.n(C),j=(0,A.$4f)(C)?C:I?.id??(0,R.$ej)(F.toString()).toString(16);let z=this.b.get(F)?.logger;const O=I?.logLevel==="always"?m.Trace:I?.logLevel;z||(z=this.s(F,O??this.getLogLevel(F)??this.h,{...I,id:j}));const T={logger:z,info:{resource:F,id:j,logLevel:O,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(T.info),this.b.set(F,T),z}n(C){return(0,A.$4f)(C)?(0,S.$4g)(this.j,`${C}.log`):C}setLogLevel(C,I){if(P.URI.isUri(C)){const F=C,j=I,z=this.b.get(F);z&&j!==z.info.logLevel&&(z.info.logLevel=j===this.h?void 0:j,z.logger?.setLevel(j),this.b.set(z.info.resource,z),this.f.fire([F,j]))}else{this.h=C;for(const[F,j]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&j.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,I){const F=this.m(C);F&&I!==!F.info.hidden&&(F.info.hidden=!I,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,I]))}getLogLevel(C){let I;return C&&(I=this.b.get(C)?.info.logLevel),I??this.h}registerLogger(C){const I=this.b.get(C.resource);I?I.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const I=this.b.get(C);I&&(I.logger&&I.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$8j=l;class c{constructor(){this.onDidChangeLogLevel=new L.$be().event}setLevel(C){}getLevel(){return m.Info}trace(C,...I){}debug(C,...I){}info(C,...I){}warn(C,...I){}error(C,...I){}critical(C,...I){}dispose(){}flush(){}}e.$9j=c;class h extends c{}e.$0j=h;function g(y){if(y.verbose)return m.Trace;if(typeof y.logLevel=="string"){const C=k(y.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Zj}function D(y){switch(y){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function w(y){switch(y){case m.Trace:return{original:"Trace",value:u.localize(0,null)};case m.Debug:return{original:"Debug",value:u.localize(1,null)};case m.Info:return{original:"Info",value:u.localize(2,null)};case m.Warning:return{original:"Warning",value:u.localize(3,null)};case m.Error:return{original:"Error",value:u.localize(4,null)};case m.Off:return{original:"Off",value:u.localize(5,null)}}}function k(y){switch(y){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$ck=new $.$Hj("logLevel",D(m.Info))}),define(ke[259],Ee([1,0,19,7,13,4,3,17,65,12]),function(le,e,u,N,L,R,M,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class A extends M.$Uc{constructor($,E){super(),this.a=$,this.b=E,this.c=this.B(new R.$be),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$be),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$oh(0)),this.w=[],this.y=this.B(new N.$oh(0))}watch($,E){return E.recursive||this.b?.watcher?.forceUniversal?this.n($,E):this.z($,E)}n($,E){const v={path:this.I($),excludes:E.excludes,includes:E.includes,recursive:E.recursive,correlationId:E.correlationId},a=(0,u.$Ub)(this.j,v);return this.r(),(0,M.$Sc)(()=>{a(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,L.$1)($))}s(){this.h||(this.h=this.B(this.t(E=>this.c.fire((0,b.$Iq)(E)),E=>this.G(E),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const E of this.j)(0,b.$Eq)(E)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const E of this.j)(0,b.$Eq)(E)&&$.includes(E.path)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,E){const v={path:this.I($),excludes:E.excludes,includes:E.includes,recursive:!1,correlationId:E.correlationId},a=(0,u.$Ub)(this.w,v);return this.C(),(0,M.$Sc)(()=>{a(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,L.$1)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,b.$Iq)($)),$=>this.G($),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,p.$ic)($.fsPath)}}e.$Mq=A}),define(ke[260],Ee([1,0,52,398,7,27,21,4,34,3,17,11,23,98,31,212,32,252,259,47,257,256]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0,(()=>{try{(0,N.gracefulify)(u)}catch(f){console.error(`Error enabling graceful-fs: ${(0,i.$bj)(f)}`)}})();class t extends n.$Mq{static{this.J=!1}constructor(d,l){super(d,l),this.onDidChangeCapabilities=p.Event.None,this.O=new R.$Bc(c=>$.$Ug.getComparisonKey(c)),this.W=new Map,this.X=new Map,this.Y=new Map}get capabilities(){return this.L||(this.L=253982,P.$k&&(this.L|=1024)),this.L}async stat(d){try{const{stat:l,symbolicLink:c}=await v.SymlinkSupport.stat(this.I(d));return{type:this.N(l,c),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:m.FilePermission.Locked}}catch(l){throw this.gb(l)}}async M(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const l=await v.Promises.readdir(this.I(d),{withFileTypes:!0}),c=[];return await Promise.all(l.map(async h=>{try{let g;h.isSymbolicLink()?g=(await this.stat((0,$.$4g)(d,h.name))).type:g=this.N(h),c.push([h.name,g])}catch(g){this.a.trace(g)}})),c}catch(l){throw this.gb(l)}}N(d,l){let c;return l?.dangling?c=m.FileType.Unknown:d.isFile()?c=m.FileType.File:d.isDirectory()?c=m.FileType.Directory:c=m.FileType.Unknown,l&&(c|=m.FileType.SymbolicLink),c}async P(d){const l=this.I(d);this.Q(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let c;for(;c=this.O.get(d);)this.Q(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await c.wait();const h=new L.$ph;return this.O.set(d,h),this.Q(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,S.$Sc)(()=>{this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.O.get(d)===h&&(this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.O.delete(d)),this.Q(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),h.open()})}async readFile(d,l){let c;try{l?.atomic&&(this.Q(`[Disk FileSystemProvider]: atomic read operation started (${this.I(d)})`),c=await this.P(d));const h=this.I(d);return await v.Promises.readFile(h)}catch(h){throw this.gb(h)}finally{c?.dispose()}}Q(d){t.J&&this.a.trace(d)}readFileStream(d,l,c){const h=(0,E.$qe)(g=>M.$Ce.concat(g.map(D=>M.$Ce.wrap(D))).buffer);return(0,o.$Bq)(this,d,h,g=>g.buffer,{...l,bufferSize:256*1024},c),h}async writeFile(d,l,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.R(d)?this.S(d,(0,$.$4g)((0,$.$3g)(d),`${(0,$.$1g)(d)}${c.atomic.postfix}`),l,c):this.U(d,l,c)}async R(d){try{const l=this.I(d),{symbolicLink:c}=await v.SymlinkSupport.stat(l);if(c)return!1}catch{}return!0}async S(d,l,c,h){const g=new S.$Tc;try{g.add(await this.P(d)),g.add(await this.P(l)),await this.U(l,c,h,!0);try{await this.rename(l,d,{overwrite:!0})}catch(D){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{g.dispose()}}async U(d,l,c,h){let g;try{const D=this.I(d);if(!c.create||!c.overwrite){if(await v.Promises.exists(D)){if(!c.overwrite)throw(0,m.$0k)((0,a.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,m.$0k)((0,a.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(d,{create:!0,unlock:c.unlock},h),await this.write(g,0,l,0,l.byteLength)}catch(D){throw await this.hb(d,D)}finally{typeof g=="number"&&await this.close(g)}}static{this.Z=!0}static configureFlushOnWrite(d){t.Z=d}async open(d,l,c){const h=this.I(d);let g;(0,m.$Xk)(l)&&!c&&(g=await this.P(d));let D;try{if((0,m.$Xk)(l)&&l.unlock)try{const{stat:k}=await v.SymlinkSupport.stat(h);k.mode&128||await v.Promises.chmod(h,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let w;if((0,m.$Xk)(l)){if(P.$i)try{await v.Promises.truncate(h,0),w="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}w||(w="w")}else w="r";D=await v.Promises.open(h,w)}catch(w){throw g?.dispose(),(0,m.$Xk)(l)?await this.hb(d,w):this.gb(w)}if(this.W.set(D,0),(0,m.$Xk)(l)&&this.Y.set(D,d),g){const w=this.X.get(D);this.Q(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${h})`),this.X.set(D,g),w&&(this.Q(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${h})`),w.dispose())}return D}async close(d){const l=this.X.get(d);try{if(this.W.delete(d),this.Y.delete(d)&&t.Z)try{await v.Promises.fdatasync(d)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await v.Promises.close(d)}catch(c){throw this.gb(c)}finally{l&&(this.X.get(d)===l&&(this.Q(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.X.delete(d)),this.Q(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),l.dispose())}}async read(d,l,c,h,g){const D=this.$(d,l);let w=null;try{w=(await v.Promises.read(d,c,h,g,D)).bytesRead}catch(k){throw this.gb(k)}finally{this.ab(d,D,w)}return w}$(d,l){return l===this.W.get(d)?null:l}ab(d,l,c){const h=this.W.get(d);typeof h=="number"&&(typeof l=="number"||(typeof c=="number"?this.W.set(d,h+c):this.W.delete(d)))}async write(d,l,c,h,g){return(0,L.$Kh)(()=>this.bb(d,l,c,h,g),100,3)}async bb(d,l,c,h,g){const D=this.$(d,l);let w=null;try{w=(await v.Promises.write(d,c,h,g,D)).bytesWritten}catch(k){throw await this.hb(this.Y.get(d),k)}finally{this.ab(d,D,w)}return w}async mkdir(d){try{await v.Promises.mkdir(this.I(d))}catch(l){throw this.gb(l)}}async delete(d,l){try{const c=this.I(d);if(l.recursive){let h;l?.atomic!==!1&&l.atomic.postfix&&(h=(0,A.$kc)((0,A.$nc)(c),`${(0,A.$oc)(c)}${l.atomic.postfix}`)),await v.Promises.rm(c,v.RimRafMode.MOVE,h)}else try{await v.Promises.unlink(c)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let g=!1;try{const{stat:D,symbolicLink:w}=await v.SymlinkSupport.stat(c);g=D.isDirectory()&&!w}catch{}if(g)await v.Promises.rmdir(c);else throw h}else throw h}}catch(c){throw this.gb(c)}}async rename(d,l,c){const h=this.I(d),g=this.I(l);if(h!==g)try{await this.cb(d,l,"move",c.overwrite),await v.Promises.rename(h,g)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,a.localize)(2,null,(0,A.$oc)(h),(0,A.$oc)((0,A.$nc)(g)),D.toString()))),this.gb(D)}}async copy(d,l,c){const h=this.I(d),g=this.I(l);if(h!==g)try{await this.cb(d,l,"copy",c.overwrite),await v.Promises.copy(h,g,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,a.localize)(3,null,(0,A.$oc)(h),(0,A.$oc)((0,A.$nc)(g)),D.toString()))),this.gb(D)}}async cb(d,l,c,h){const g=this.I(d),D=this.I(l);let w=!1;if(!!(this.capabilities&1024)||(w=(0,b.$pg)(g,D,!0)),w){if(c==="copy")throw(0,m.$0k)((0,a.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const y=await this.M(d);if(!y)throw(0,m.$0k)((0,a.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const C=await this.M(l);if(C){if(!h)throw(0,m.$0k)((0,a.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&C.type&m.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,l){return this.db(d,l,!1)}async db(d,l,c){const h=this.I(d),g=this.I(l),D=!!(this.capabilities&1024);if((0,b.$pg)(h,g,!D))return;const w=new S.$Tc;try{w.add(await this.P(d)),w.add(await this.P(l)),c&&await v.Promises.mkdir((0,A.$nc)(g),{recursive:!0}),await v.Promises.copyFile(h,g)}catch(k){if(k.code==="ENOENT"&&!c)return this.db(d,l,!0);throw this.gb(k)}finally{w.dispose()}}t(d,l,c){return new r.$Tq(h=>d(h),h=>l(h),c)}F(d,l,c){return new s.$3q(h=>d(h),h=>l(h),c)}gb(d){if(d instanceof m.$9k)return d;let l=d,c;switch(d.code){case"ENOENT":c=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=m.FileSystemProviderErrorCode.Unknown;break;default:c=m.FileSystemProviderErrorCode.Unknown}return(0,m.$0k)(l,c)}async hb(d,l){let c=this.gb(l);if(d&&c.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await v.SymlinkSupport.stat(this.I(d));h.mode&128||(c=(0,m.$0k)(l,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return c}}e.$4q=t}),define(ke[261],Ee([1,0,3,12]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yQ=void 0;class L extends u.$Uc{constructor(M,p=[]){super(),this.a=new N.$7j([M,...p]),this.B(M.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...p){this.a.trace(M,...p)}debug(M,...p){this.a.debug(M,...p)}info(M,...p){this.a.info(M,...p)}warn(M,...p){this.a.warn(M,...p)}error(M,...p){this.a.error(M,...p)}flush(){this.a.flush()}}e.$yQ=L}),define(ke[262],Ee([1,0,32,12]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=void 0;var L;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(L||(L={}));async function R(S,A,P,$,E){try{const v=await new Promise((m,o)=>{le(["@vscode/spdlog"],m,o)});v.setFlushOn(L.Trace);const a=await v.createAsyncRotatingLogger(S,A,P,$);return E?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(v){console.error(v)}return null}function M(S,A,P){switch(A){case N.LogLevel.Trace:S.trace(P);break;case N.LogLevel.Debug:S.debug(P);break;case N.LogLevel.Info:S.info(P);break;case N.LogLevel.Warning:S.warn(P);break;case N.LogLevel.Error:S.error(P);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function p(S,A){switch(A){case N.LogLevel.Trace:S.setLevel(L.Trace);break;case N.LogLevel.Debug:S.setLevel(L.Debug);break;case N.LogLevel.Info:S.setLevel(L.Info);break;case N.LogLevel.Warning:S.setLevel(L.Warning);break;case N.LogLevel.Error:S.setLevel(L.Error);break;case N.LogLevel.Off:S.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class b extends N.$3j{constructor(A,P,$,E,v){super(),this.m=[],this.setLevel(v),this.n=this.s(A,P,$,E),this.B(this.onDidChangeLogLevel(a=>{this.r&&p(this.r,a)}))}async s(A,P,$,E){const v=$?6:1,a=30/v*u.$sl.MB,m=await R(A,P,a,v,E);if(m){this.r=m,p(this.r,this.getLevel());for(const{level:o,message:n}of this.m)M(this.r,o,n);this.m=[]}}g(A,P){this.r?M(this.r,A,P):this.getLevel()<=A&&this.m.push({level:A,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$nQ=b}),define(ke[138],Ee([1,0,40,214,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var M;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(b){function S(v,a){return a-v}b.compare=S;const A=Object.create(null);A[b.Error]=(0,N.localize)(0,null),A[b.Warning]=(0,N.localize)(1,null),A[b.Info]=(0,N.localize)(2,null);function P(v){return A[v]||""}b.toString=P;function $(v){switch(v){case u.default.Error:return b.Error;case u.default.Warning:return b.Warning;case u.default.Info:return b.Info;case u.default.Ignore:return b.Hint}}b.fromSeverity=$;function E(v){switch(v){case b.Error:return u.default.Error;case b.Warning:return u.default.Warning;case b.Info:return u.default.Info;case b.Hint:return u.default.Ignore}}b.toSeverity=E}(M||(e.MarkerSeverity=M={}));var p;(function(b){const S="";function A($){return P($,!0)}b.makeKey=A;function P($,E){const v=[S];return $.source?v.push($.source.replace("\xA6","\\\xA6")):v.push(S),$.code?typeof $.code=="string"?v.push($.code.replace("\xA6","\\\xA6")):v.push($.code.value.replace("\xA6","\\\xA6")):v.push(S),$.severity!==void 0&&$.severity!==null?v.push(M.toString($.severity)):v.push(S),$.message&&E?v.push($.message.replace("\xA6","\\\xA6")):v.push(S),$.startLineNumber!==void 0&&$.startLineNumber!==null?v.push($.startLineNumber.toString()):v.push(S),$.startColumn!==void 0&&$.startColumn!==null?v.push($.startColumn.toString()):v.push(S),$.endLineNumber!==void 0&&$.endLineNumber!==null?v.push($.endLineNumber.toString()):v.push(S),$.endColumn!==void 0&&$.endColumn!==null?v.push($.endColumn.toString()):v.push(S),v.push(S),v.join("\xA6")}b.makeKeyOptionalMessage=P})(p||(e.IMarkerData=p={})),e.$Tt=(0,L.$qi)("markerService")}),define(ke[263],Ee([1,0,4,40,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Tv=e.Severity=void 0,e.$Uv=p,e.Severity=N.default,e.$Tv=(0,L.$qi)("notificationService");var R;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var M;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function p(P){if(P){const $=P;return typeof $.id=="string"&&typeof $.label=="string"}return!1}var b;(function(P){P[P.OFF=0]="OFF",P[P.ERROR=1]="ERROR"})(b||(e.NotificationsFilter=b={}));class S{constructor(){this.progress=new A,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity($){}updateMessage($){}updateActions($){}close(){}}e.$Vv=S;class A{infinite(){}done(){}total($){}worked($){}}e.$Wv=A}),define(ke[264],Ee([1,0,51]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const R=L.context.configuration();if(R)N=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,u.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:R.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ke[139],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$dk=(0,u.$qi)("productService"),e.$ek="vscode://schemas/vscode-product"});var qe=this&&this.__param||function(le,e){return function(u,N){e(u,N,le)}};define(ke[108],Ee([1,0,7,22,3,5]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.ProgressLocation=e.$Xv=void 0,e.$Xv=(0,R.$qi)("progressService");var M;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Yv=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor($){this.b=$}report($){this.a=$,this.b(this.a)}}e.$Zv=p;class b{get value(){return this.a}constructor($){this.e=$}report($){this.b?this.b.push($):this.b=[$],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const $=this.b.shift();this.a=$,await this.e(this.a)}}finally{this.c=!1;const $=this.d;this.d=void 0,$?.()}}drain(){return this.c?new Promise($=>{const E=this.d;this.d=()=>{E?.(),$()}}):Promise.resolve()}}e.$1v=b;let S=class extends L.$Uc{constructor($,E){super(),this.a=new u.$Nh,E.withProgress($,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,L.$Sc)(()=>this.a.complete()))}report($){this.b?this.b.report($):this.c=$}};e.$2v=S,e.$2v=S=Je([qe(1,e.$Xv)],S);class A extends L.$Uc{constructor($){super(),this.g=$,this.a=0,this.b=this.B(new L.$Tc)}start($){this.stop();const E=++this.a,v=new N.$me;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},$),this.b.add((0,L.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,L.$Sc)(()=>v.cancel())),this.b.add((0,L.$Sc)(()=>this.c?this.c.done():void 0)),{id:E,token:v.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h($){this.a===$&&this.b.clear()}}e.$3v=A,e.$4v=(0,R.$qi)("editorProgressService")}),define(ke[38],Ee([1,0,62,18]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=void 0;class L{constructor(){this.a=new Map}add(M,p){u.ok(N.$4f(M)),u.ok(N.$6f(p)),u.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,p)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$9n=new L}),define(ke[109],Ee([1,0,4,38]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0,e.$0n={JSONContribution:"base.contributions.json"};function L(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class R{constructor(){this.b=new u.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,S){this.a[L(b)]=S,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const M=new R;N.$9n.add(e.$0n.JSONContribution,M)}),define(ke[85],Ee([1,0,19,4,18,203,54,109,38]),function(le,e,u,N,L,R,M,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ConfigurationScope=e.$bo=e.EditPresentationTypes=void 0,e.$mo=a,e.$no=m,e.$oo=o,e.$po=i,e.$qo=r;var S;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(S||(e.EditPresentationTypes=S={})),e.$bo={Configuration:"base.contributions.configuration"};var A;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io="vscode://schemas/settings/resourceLanguage",e.$jo="vscode://schemas/settings/configurationDefaults";const P=b.$9n.as(p.$0n.JSONContribution);class ${constructor(){this.h=new Set,this.i=new N.$be,this.onDidSchemaChange=this.i.event,this.j=new N.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$io,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const d=new Set;this.n(t,f,d),P.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const f=new Set;this.o(t,f),P.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const d=new Set;this.o(f,d),this.n(t,!1,d),P.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const d=[];for(const{overrides:l,source:c}of t)for(const h in l)if(f.add(h),e.$lo.test(h)){const g=this.a.get(h),D=g?.valuesSources??new Map;if(c)for(const C of Object.keys(l[h]))D.set(C,c);const w={...g?.value||{},...l[h]};this.a.set(h,{source:c,value:w,valuesSources:D});const k=(0,M.$7i)(h),y={type:"object",default:w,description:R.localize(1,null,k),$ref:e.$io,defaultDefaultValue:w,source:L.$4f(c)?void 0:c,defaultValueSource:c};d.push(...a(h)),this.d[h]=y,this.b.properties[h]=y}else{this.a.set(h,{value:l[h],source:c});const g=this.d[h];g&&(this.w(h,g),this.r(h,g))}this.m(d)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:d,source:l}of t)for(const c in d){const h=this.a.get(c),g=L.$4f(l)?l:l?.id,D=L.$4f(h?.source)?h?.source:h?.source?.id;if(g===D)if(f.add(c),this.a.delete(c),e.$lo.test(c))delete this.d[c],delete this.b.properties[c];else{const w=this.d[c];w&&(this.w(c,w),this.r(c,w))}}this.u()}deltaConfiguration(t){let f=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,d){t.forEach(l=>{this.p(l,f,l.extensionInfo,l.restrictedProperties,void 0,d),this.c.push(l),this.q(l)})}o(t,f){const d=l=>{if(l.properties)for(const c in l.properties){f.add(c);const h=this.d[c];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[c],this.s(c,l.properties[c])}l.allOf?.forEach(c=>d(c))};for(const l of t){d(l);const c=this.c.indexOf(l);c!==-1&&this.c.splice(c,1)}}p(t,f=!0,d,l,c=3,h){c=L.$ag(t.scope)?c:t.scope;const g=t.properties;if(g)for(const w in g){const k=g[w];if(f&&i(w,k)){delete g[w];continue}if(k.source=d,k.defaultDefaultValue=g[w].default,this.w(w,k),e.$lo.test(w)?k.scope=void 0:(k.scope=L.$ag(k.scope)?c:k.scope,k.restricted=L.$ag(k.restricted)?!!l?.includes(w):k.restricted),g[w].hasOwnProperty("included")&&!g[w].included){this.f[w]=g[w],delete g[w];continue}else this.d[w]=g[w],g[w].policy?.name&&this.e.set(g[w].policy.name,w);!g[w].deprecationMessage&&g[w].markdownDeprecationMessage&&(g[w].deprecationMessage=g[w].markdownDeprecationMessage),h.add(w)}const D=t.allOf;if(D)for(const w of D)this.p(w,f,d,l,c,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=d=>{const l=d.properties;if(l)for(const h in l)this.r(h,l[h]);d.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$co.properties[t]=f,f.scope){case 1:e.$do.properties[t]=f;break;case 2:e.$eo.properties[t]=f;break;case 6:e.$fo.properties[t]=f;break;case 3:e.$go.properties[t]=f;break;case 4:e.$ho.properties[t]=f;break;case 5:e.$ho.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$co.properties[t],f.scope){case 1:delete e.$do.properties[t];break;case 2:delete e.$eo.properties[t];break;case 6:delete e.$fo.properties[t];break;case 3:delete e.$go.properties[t];break;case 4:case 5:delete e.$ho.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,d={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$io};this.w(f,d),e.$co.properties[f]=d,e.$do.properties[f]=d,e.$eo.properties[f]=d,e.$fo.properties[f]=d,e.$go.properties[f]=d,e.$ho.properties[f]=d}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$io};e.$co.patternProperties[e.$ko]=t,e.$do.patternProperties[e.$ko]=t,e.$eo.patternProperties[e.$ko]=t,e.$fo.patternProperties[e.$ko]=t,e.$go.patternProperties[e.$ko]=t,e.$ho.patternProperties[e.$ko]=t,this.i.fire()}w(t,f){const d=this.a.get(t);let l=d?.value,c=d?.source;L.$$f(l)&&(l=f.defaultDefaultValue,c=void 0),L.$$f(l)&&(l=o(f.type)),f.default=l,f.defaultValueSource=c}}const E="\\[([^\\]]+)\\]",v=new RegExp(E,"g");e.$ko=`^(${E})+$`,e.$lo=new RegExp(e.$ko);function a(s){const t=[];if(e.$lo.test(s)){let f=v.exec(s);for(;f?.length;){const d=f[1].trim();d&&t.push(d),f=v.exec(s)}}return(0,u.$Mb)(t)}function m(s){return s.reduce((t,f)=>`${t}[${f}]`,"")}function o(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new $;b.$9n.add(e.$bo.Configuration,n);function i(s,t){return s.trim()?e.$lo.test(s)?R.localize(7,null,s):n.getConfigurationProperties()[s]!==void 0?R.localize(8,null,s):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,s,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function r(){const s=[],t=n.getConfigurationProperties();for(const f of Object.keys(t))s.push([f,t[f].scope]);return s.push(["launch",4]),s.push(["task",4]),s}}),define(ke[265],Ee([1,0,19,4,164,3,27,24,18,2,54,85,38]),function(le,e,u,N,L,R,M,p,b,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$uo=e.$to=e.$so=e.$ro=void 0,e.$vo=i;function E(f){return Object.isFrozen(f)?f:p.$Xn(f)}class v{constructor(d={},l=[],c=[],h){this.b=d,this.c=l,this.d=c,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(l=>{if(l instanceof v)return l;const c=new a("");return c.parseRaw(l),c.configurationModel});this.f=d.reduce((l,c)=>c===l?c:l.merge(c),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$5i)(this.contents,d):this.contents}inspect(d,l){const c=this;return{get value(){return E(c.rawConfiguration.getValue(d))},get override(){return l?E(c.rawConfiguration.getOverrideValue(d,l)):void 0},get merged(){return E(l?c.rawConfiguration.override(l).getValue(d):c.rawConfiguration.getValue(d))},get overrides(){const h=[];for(const{contents:g,identifiers:D,keys:w}of c.rawConfiguration.overrides){const k=new v(g,w).getValue(d);k!==void 0&&h.push({identifiers:D,value:k})}return h.length?E(h):void 0}}}getOverrideValue(d,l){const c=this.i(l);return c?d?(0,A.$5i)(c,d):c:void 0}getKeysForOverrideIdentifier(d){const l=[];for(const c of this.overrides)c.identifiers.includes(d)&&l.push(...c.keys);return u.$Mb(l)}getAllOverrideIdentifiers(){const d=[];for(const l of this.overrides)d.push(...l.identifiers);return u.$Mb(d)}override(d){let l=this.a.get(d);return l||(l=this.g(d),this.a.set(d,l)),l}merge(...d){const l=p.$Wn(this.contents),c=p.$Wn(this.overrides),h=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const D of d)if(g.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(l,D.contents);for(const w of D.overrides){const[k]=c.filter(y=>u.$ub(y.identifiers,w.identifiers));k?(this.h(k.contents,w.contents),k.keys.push(...w.keys),k.keys=u.$Mb(k.keys)):c.push(p.$Wn(w))}for(const w of D.keys)h.indexOf(w)===-1&&h.push(w)}return new v(l,h,c,g.every(D=>D instanceof v)?void 0:g)}g(d){const l=this.i(d);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const c={};for(const h of u.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let g=this.contents[h];const D=l[h];D&&(typeof g=="object"&&typeof D=="object"?(g=p.$Wn(g),this.h(g,D)):g=D),c[h]=g}return new v(c,this.keys,this.overrides)}h(d,l){for(const c of Object.keys(l)){if(c in d&&b.$6f(d[c])&&b.$6f(l[c])){this.h(d[c],l[c]);continue}d[c]=p.$Wn(l[c])}}i(d){let l=null,c=null;const h=g=>{g&&(c?this.h(c,g):c=p.$Wn(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===d?l=g.contents:g.identifiers.includes(d)&&h(g.contents);return h(l),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,l){this.j(d,l,!0)}setValue(d,l){this.j(d,l,!1)}removeValue(d){const l=this.keys.indexOf(d);l!==-1&&(this.keys.splice(l,1),(0,A.$4i)(this.contents,d),P.$lo.test(d)&&this.overrides.splice(this.overrides.findIndex(c=>u.$ub(c.identifiers,(0,P.$mo)(d))),1))}j(d,l,c){(0,A.$3i)(this.contents,d,l,h=>console.error(h)),c=c||this.keys.indexOf(d)===-1,c&&this.keys.push(d),P.$lo.test(d)&&this.overrides.push({identifiers:(0,P.$mo)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$2i)(this.contents[d],h=>console.error(h))})}}e.$ro=v;class a{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,l){if(!b.$ag(d)){const c=this.g(d);this.parseRaw(c,l)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,l){this.a=d;const{contents:c,keys:h,overrides:g,restricted:D,hasExcludedProperties:w}=this.h(d,l);this.b=new v(c,h,g,w?[d]:void 0),this.c=D||[]}g(d){let l={},c=null,h=[];const g=[],D=[];function w(y){Array.isArray(h)?h.push(y):c!==null&&(h[c]=y)}const k={onObjectBegin:()=>{const y={};w(y),g.push(h),h=y,c=null},onObjectProperty:y=>{c=y},onObjectEnd:()=>{h=g.pop()},onArrayBegin:()=>{const y=[];w(y),g.push(h),h=y,c=null},onArrayEnd:()=>{h=g.pop()},onLiteralValue:w,onError:(y,C,I)=>{D.push({error:y,offset:C,length:I})}};if(d)try{L.$Kn(d,k),l=h[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return l}h(d,l){const c=$.$9n.as(P.$bo.Configuration).getConfigurationProperties(),h=this.i(d,c,!0,l);d=h.raw;const g=(0,A.$2i)(d,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),D=Object.keys(d),w=this.j(d,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:g,keys:D,overrides:w,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,l,c,h){let g=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:g};const D={},w=[];for(const k in d)if(P.$lo.test(k)&&c){const y=this.i(d[k],l,!1,h);D[k]=y.raw,g=g||y.hasExcludedProperties,w.push(...y.restricted)}else{const y=l[k],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&w.push(k),!h.exclude?.includes(k)&&(h.include?.includes(k)||(C===void 0||h.scopes===void 0||h.scopes.includes(C))&&!(h.skipRestricted&&y?.restricted))?D[k]=d[k]:g=!0}return{raw:D,restricted:w,hasExcludedProperties:g}}j(d,l){const c=[];for(const h of Object.keys(d))if(P.$lo.test(h)){const g={};for(const D in d[h])g[D]=d[h][D];c.push({identifiers:(0,P.$mo)(h),keys:Object.keys(g),contents:(0,A.$2i)(g,l)})}return c}}e.$so=a;class m extends R.$Uc{constructor(d,l,c,h){super(),this.c=d,this.f=l,this.g=h,this.b=this.B(new N.$be),this.onDidChange=this.b.event,this.a=new a(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,g=>g.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,g=>(g.isOperation(0)||g.isOperation(3)||g.isOperation(1)||g.isOperation(4))&&c.isEqual(g.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$to=m;class o{constructor(d,l,c,h,g,D,w,k,y,C,I,F,j){this.a=d,this.b=l,this.c=c,this.overrideIdentifiers=h,this.d=g,this.f=D,this.g=w,this.h=k,this.i=y,this.j=C,this.k=I,this.l=F,this.m=j}get value(){return E(this.c)}n(d){return d?.value!==void 0||d?.override!==void 0||d?.overrides!==void 0?d:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(d,l,c,h,g=new v,D=new v,w=new M.$Bc,k=new v,y=new M.$Bc){this.c=d,this.d=l,this.f=c,this.g=h,this.h=g,this.i=D,this.j=w,this.l=k,this.m=y,this.a=null,this.b=new M.$Bc,this.n=null}getValue(d,l,c){return this.p(d,l,c).getValue(d)}updateValue(d,l,c={}){let h;c.resource?(h=this.m.get(c.resource),h||(h=new v,this.m.set(c.resource,h))):h=this.l,l===void 0?h.removeValue(d):h.setValue(d,l),c.resource||(this.a=null)}inspect(d,l,c){const h=this.p(d,l,c),g=this.t(l.resource,c),D=l.resource?this.m.get(l.resource)||this.l:this.l,w=new Set;for(const k of h.overrides)for(const y of k.identifiers)h.getOverrideValue(d,y)!==void 0&&w.add(y);return new o(d,l,h.getValue(d),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,g||void 0,D)}keys(d){const l=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,l){this.j.set(d,l),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,l){const c=[];if(!l){const{added:h,updated:g,removed:D}=s(this.c,d);l=[...h,...g,...D]}for(const h of l)for(const g of(0,P.$mo)(h)){const D=this.c.getKeysForOverrideIdentifier(g),w=d.getKeysForOverrideIdentifier(g),k=[...w.filter(y=>D.indexOf(y)===-1),...D.filter(y=>w.indexOf(y)===-1),...D.filter(y=>!p.$1n(this.c.override(g).getValue(y),d.override(g).getValue(y)))];c.push([g,k])}return this.updateDefaultConfiguration(d),{keys:l,overrides:c}}compareAndUpdatePolicyConfiguration(d){const{added:l,updated:c,removed:h}=s(this.d,d),g=[...l,...c,...h];return g.length&&this.updatePolicyConfiguration(d),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.applicationConfiguration,d),D=[...l,...c,...h];return D.length&&this.updateApplicationConfiguration(d),{keys:D,overrides:g}}compareAndUpdateLocalUserConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.localUserConfiguration,d),D=[...l,...c,...h];return D.length&&this.updateLocalUserConfiguration(d),{keys:D,overrides:g}}compareAndUpdateRemoteUserConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.remoteUserConfiguration,d),D=[...l,...c,...h];return D.length&&this.updateRemoteUserConfiguration(d),{keys:D,overrides:g}}compareAndUpdateWorkspaceConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.workspaceConfiguration,d),D=[...l,...c,...h];return D.length&&this.updateWorkspaceConfiguration(d),{keys:D,overrides:g}}compareAndUpdateFolderConfiguration(d,l){const c=this.folderConfigurations.get(d),{added:h,updated:g,removed:D,overrides:w}=s(c,l),k=[...h,...g,...D];return(k.length||!c)&&this.updateFolderConfiguration(d,l),{keys:k,overrides:w}}compareAndDeleteFolderConfiguration(d){const l=this.folderConfigurations.get(d);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:c,updated:h,removed:g,overrides:D}=s(l,void 0);return{keys:[...c,...h,...g],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,l,c){let h=this.q(l,c);return l.overrideIdentifier&&(h=h.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}q({resource:d},l){let c=this.r();if(l&&d){const h=l.getFolder(d);h&&(c=this.s(h.uri)||c);const g=this.m.get(d);g&&(c=c.merge(g))}return c}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let l=this.b.get(d);if(!l){const c=this.r(),h=this.j.get(d);h?(l=c.merge(h),this.b.set(d,l)):l=c}return l}t(d,l){if(l&&d){const c=l.getFolder(d);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,l)=>{const{contents:c,overrides:h,keys:g}=this.j.get(l);return d.push([l,{contents:c,overrides:h,keys:g}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(l=>d.add(l)),this.userConfiguration.keys.forEach(l=>d.add(l)),this.i.keys.forEach(l=>d.add(l)),this.j.forEach(l=>l.keys.forEach(c=>d.add(c))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(c=>d.add(c))),[...d.values()]}v(d){const l=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.i.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(d).forEach(h=>l.add(h))),[...l.values()]}static parse(d){const l=this.w(d.defaults),c=this.w(d.policy),h=this.w(d.application),g=this.w(d.user),D=this.w(d.workspace),w=d.folders.reduce((k,y)=>(k.set(S.URI.revive(y[0]),this.w(y[1])),k),new M.$Bc);return new n(l,c,h,g,new v,D,w,new v,new M.$Bc)}static w(d){return new v(d.contents,d.keys,d.overrides)}}e.$uo=n;function i(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const d=new Set,l=new Map;for(const h of f)h.keys.forEach(g=>d.add(g)),h.overrides.forEach(([g,D])=>{const w=(0,M.$yc)(l,g,new Set);D.forEach(k=>w.add(k))});const c=[];return l.forEach((h,g)=>c.push([g,[...h.values()]])),{keys:[...d.values()],overrides:c}}class r{constructor(d,l,c,h){this.change=d,this.f=l,this.g=c,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const g of d.keys)this.affectedKeys.add(g);for(const[,g]of d.overrides)for(const D of g)this.affectedKeys.add(D);this.d=this.a;for(const g of this.affectedKeys)this.d+=g+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(d,l){const c=this.a+d,h=this.d.indexOf(c);if(h<0)return!1;const g=h+c.length;if(g>=this.d.length)return!1;const D=this.d.charCodeAt(g);if(D!==this.b&&D!==this.c)return!1;if(l){const w=this.previousConfiguration?this.previousConfiguration.getValue(d,l,this.f?.workspace):void 0,k=this.g.getValue(d,l,this.h);return!p.$1n(w,k)}return!0}}e.$wo=r;function s(f,d){const{added:l,removed:c,updated:h}=t(d?.rawConfiguration,f?.rawConfiguration),g=[],D=f?.getAllOverrideIdentifiers()||[],w=d?.getAllOverrideIdentifiers()||[];if(d){const k=w.filter(y=>!D.includes(y));for(const y of k)g.push([y,d.getKeysForOverrideIdentifier(y)])}if(f){const k=D.filter(y=>!w.includes(y));for(const y of k)g.push([y,f.getKeysForOverrideIdentifier(y)])}if(d&&f){for(const k of D)if(w.includes(k)){const y=t({contents:f.getOverrideValue(void 0,k)||{},keys:f.getKeysForOverrideIdentifier(k)},{contents:d.getOverrideValue(void 0,k)||{},keys:d.getKeysForOverrideIdentifier(k)});g.push([k,[...y.added,...y.removed,...y.updated]])}}return{added:l,removed:c,updated:h,overrides:g}}function t(f,d){const l=f?d?f.keys.filter(g=>d.keys.indexOf(g)===-1):[...f.keys]:[],c=d?f?d.keys.filter(g=>f.keys.indexOf(g)===-1):[...d.keys]:[],h=[];if(f&&d){for(const g of d.keys)if(f.keys.indexOf(g)!==-1){const D=(0,A.$5i)(d.contents,g),w=(0,A.$5i)(f.contents,g);p.$1n(D,w)||h.push(g)}}return{added:l,removed:c,updated:h}}}),define(ke[266],Ee([1,0,21,4,3,82]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nsb=e.$lsb=e.$ksb=void 0,e.$msb=p;const M=(S,A,P)=>{const $=new Uint8Array(16);for(let a=0;a<16;a++)$[a]=Math.round(Math.random()*256);const E=(0,u.$We)(u.$Ce.wrap($));return[`GET ws://localhost${S}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`].join(`\r
`)+`\r
\r
`};e.$ksb=M,e.$lsb=u.$Ce.fromString(`\r
\r
`);async function p(S,A,P,$,E){S.write(u.$Ce.fromString((0,e.$ksb)(A,P,$)));const v=new L.$Tc;try{return await new Promise((a,m)=>{let o;v.add(S.onData(n=>{o?o=u.$Ce.concat([o,n],o.byteLength+n.byteLength):o=n;const i=o.indexOf(e.$lsb);if(i===-1)return;a(S),S.pauseData();const r=o.slice(i+e.$lsb.byteLength);r.byteLength&&E.onData.fire(r)})),v.add(S.onClose(n=>m(n??new Error("socket closed")))),v.add(S.onEnd(()=>m(new Error("socket ended"))))})}catch(a){throw S.dispose(),a}finally{v.dispose()}}class b extends L.$Uc{constructor(A,P){super(),this.g=A,this.a=this.B(new N.$ee),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new N.$be),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event($=>this.a.fire($))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,P){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$nsb=b}),define(ke[66],Ee([1,0,13,5]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.RemoteAuthorityResolverErrorCode=e.$Dl=e.$Cl=e.RemoteConnectionType=e.$Bl=void 0,e.$Fl=S,e.$Bl=(0,N.$qi)("remoteAuthorityResolverService");var L;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class R{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$Cl=R;class M{constructor(P,$){this.host=P,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Dl=M;var p;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class b extends u.$bb{static isNotAvailable(P){return P instanceof b&&P._code===p.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof b&&P._code===p.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof b&&P._code===p.NoResolverFound}static isInvalidAuthority(P){return P instanceof b&&P._code===p.InvalidAuthority}static isHandled(P){return P instanceof b&&P.isHandled}constructor(P,$=p.Unknown,E){super(P),this._message=P,this._code=$,this._detail=E,this.isHandled=$===p.NotAvailable&&E===!0,Object.setPrototypeOf(this,b.prototype)}}e.$El=b;function S(A){const P=A.indexOf("+");return P===-1?A:A.substring(0,P)}}),define(ke[267],Ee([1,0,7,21,22,13,4,3,15,59,39,30,82,66]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Kl=D,e.$Ll=w,e.$Ml=y;const v=30*1e3;var a;(function(ee){ee[ee.Management=1]="Management",ee[ee.ExtensionHost=2]="ExtensionHost",ee[ee.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function m(ee){switch(ee){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(ee){const U=new L.$me;return setTimeout(()=>U.cancel(),ee),U.token}function n(ee,U){if(ee.isCancellationRequested||U.isCancellationRequested)return L.CancellationToken.Cancelled;const ie=new L.$me;return ee.onCancellationRequested(()=>ie.cancel()),U.onCancellationRequested(()=>ie.cancel()),ie.token}class i{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new p.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,u.$jh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function r(ee,U){const ie=new i(U);return ie.registerDisposable(ee.onControlMessage(be=>{const Pe=JSON.parse(be.toString()),oe=X(Pe);oe?ie.reject(oe):ie.resolve(Pe)})),ie.promise}function s(ee,U,ie,be,Pe,oe,ae,re){const G=new i(re),te=A.$0d.create(!1);return ee.info(`Creating a socket (${ae})...`),S.mark(`code/willCreateSocket/${oe}`),U.connect(ie,be,Pe,ae).then(ge=>{G.didTimeout?(S.mark(`code/didCreateSocketError/${oe}`),ee.info(`Creating a socket (${ae}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),ge?.dispose()):(S.mark(`code/didCreateSocketOK/${oe}`),ee.info(`Creating a socket (${ae}) was successful after ${te.elapsed()} ms.`),G.resolve(ge))},ge=>{S.mark(`code/didCreateSocketError/${oe}`),ee.info(`Creating a socket (${ae}) returned an error after ${te.elapsed()} ms.`),ee.error(ge),G.reject(ge)}),G.promise}function t(ee,U){const ie=new i(U);return ee.then(be=>{ie.didTimeout||ie.resolve(be)},be=>{ie.didTimeout||ie.reject(be)}),ie.promise}async function f(ee,U,ie,be){const Pe=$e(ee,U);ee.logService.trace(`${Pe} 1/6. invoking socketFactory.connect().`);let oe;try{oe=await s(ee.logService,ee.remoteSocketFactoryService,ee.connectTo,b.$Dg.getServerRootPath(),`reconnectionToken=${ee.reconnectionToken}&reconnection=${ee.reconnectionProtocol?"true":"false"}`,m(U),`renderer-${m(U)}-${ee.reconnectionToken}`,be)}catch(ge){throw ee.logService.error(`${Pe} socketFactory.connect() failed or timed out. Error:`),ee.logService.error(ge),ge}ee.logService.trace(`${Pe} 2/6. socketFactory.connect() was successful.`);let ae,re;ee.reconnectionProtocol?(ee.reconnectionProtocol.beginAcceptReconnection(oe,null),ae=ee.reconnectionProtocol,re=!1):(ae=new $.$ei({socket:oe}),re=!0),ee.logService.trace(`${Pe} 3/6. sending AuthRequest control message.`);const G=await t(ee.signService.createNewMessage((0,P.$Mg)()),be),te={type:"auth",auth:ee.connectionToken||"00000000000000000000",data:G.data};ae.sendControl(N.$Ce.fromString(JSON.stringify(te)));try{const ge=await r(ae,n(be,o(1e4)));if(ge.type!=="sign"||typeof ge.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(ee.logService.trace(`${Pe} 4/6. received SignRequest control message.`),!await t(ee.signService.validate(G,ge.signedData),be)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const Re=await t(ee.signService.sign(ge.data),be),fe={type:"connectionType",commit:ee.commit,signedData:Re,desiredConnectionType:U};return ie&&(fe.args=ie),ee.logService.trace(`${Pe} 5/6. sending ConnectionTypeRequest control message.`),ae.sendControl(N.$Ce.fromString(JSON.stringify(fe))),{protocol:ae,ownsProtocol:re}}catch(ge){throw ge&&ge.code==="ETIMEDOUT"&&(ee.logService.error(`${Pe} the handshake timed out. Error:`),ee.logService.error(ge)),ge&&ge.code==="VSCODE_CONNECTION_ERROR"&&(ee.logService.error(`${Pe} received error control message when negotiating connection. Error:`),ee.logService.error(ge)),re&&x(ae),ge}}async function d(ee,U,ie,be){const Pe=Date.now(),oe=$e(ee,U),{protocol:ae,ownsProtocol:re}=await f(ee,U,ie,be),G=new i(be);return G.registerDisposable(ae.onControlMessage(te=>{const ge=JSON.parse(te.toString()),we=X(ge);we?(ee.logService.error(`${oe} received error control message when negotiating connection. Error:`),ee.logService.error(we),re&&x(ae),G.reject(we)):(ee.reconnectionProtocol?.endAcceptReconnection(),ee.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${Ce(Pe)}!`),G.resolve({protocol:ae,firstMessage:ge}))})),G.promise}async function l(ee,U){const{protocol:ie}=await d(ee,1,void 0,U);return{protocol:ie}}async function c(ee,U,ie){const{protocol:be,firstMessage:Pe}=await d(ee,2,U,ie),oe=Pe&&Pe.debugPort;return{protocol:be,debugPort:oe}}async function h(ee,U,ie){const be=Date.now(),Pe=$e(ee,3),{protocol:oe}=await f(ee,3,U,ie);return ee.logService.trace(`${Pe} 6/6. handshake finished, connection is up and running after ${Ce(be)}!`),oe}async function g(ee,U,ie){const{connectTo:be,connectionToken:Pe}=await ee.addressProvider.getAddress();return{commit:ee.commit,quality:ee.quality,connectTo:be,connectionToken:Pe,reconnectionToken:U,reconnectionProtocol:ie,remoteSocketFactoryService:ee.remoteSocketFactoryService,signService:ee.signService,logService:ee.logService}}async function D(ee,U,ie){return k(ee,async be=>{const{protocol:Pe}=await l(be,L.CancellationToken.None);return new W(ee,U,ie,be.reconnectionToken,Pe)})}async function w(ee,U){return k(ee,async ie=>{const{protocol:be,debugPort:Pe}=await c(ie,U,L.CancellationToken.None);return new Z(ee,U,ie.reconnectionToken,be,Pe)})}async function k(ee,U){for(let be=1;;be++)try{const Pe=(0,P.$Mg)(),oe=await g(ee,Pe,null);return await U(oe)}catch(Pe){if(be<5)ee.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),ee.logService.error(Pe);else throw ee.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ee.logService.error(Pe),B.triggerPermanentFailure(0,0,E.$El.isHandled(Pe)),Pe}}async function y(ee,U,ie){const be=await g(ee,(0,P.$Mg)(),null);return await h(be,{host:U,port:ie},L.CancellationToken.None)}function C(ee){return(0,u.$dh)(U=>new Promise((ie,be)=>{const Pe=setTimeout(ie,ee*1e3);U.onCancellationRequested(()=>{clearTimeout(Pe),ie()})}))}var I;(function(ee){ee[ee.ConnectionLost=0]="ConnectionLost",ee[ee.ReconnectionWait=1]="ReconnectionWait",ee[ee.ReconnectionRunning=2]="ReconnectionRunning",ee[ee.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ee[ee.ConnectionGain=4]="ConnectionGain"})(I||(e.PersistentConnectionEventType=I={}));class F{constructor(U,ie){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.type=0}}e.$Nl=F;class j{constructor(U,ie,be,Pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.durationSeconds=be,this.c=Pe,this.type=1}skipWait(){this.c.cancel()}}e.$Ol=j;class z{constructor(U,ie,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.type=2}}e.$Pl=z;class O{constructor(U,ie,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.type=4}}e.$Ql=O;class T{constructor(U,ie,be,Pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.handled=Pe,this.type=3}}e.$Rl=T;class B extends p.$Uc{static triggerPermanentFailure(U,ie,be){this._permanentFailure=!0,this.f=U,this.g=ie,this.h=be,this.j.forEach(Pe=>Pe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(U,ie,be,Pe,oe){super(),this.t=U,this.u=ie,this.reconnectionToken=be,this.protocol=Pe,this.w=oe,this.m=this.B(new M.$be),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new O(this.reconnectionToken,0,0)),this.B(Pe.onSocketClose(ae=>{const re=ne(this.t,this.reconnectionToken,!0);ae?ae.type===0?(this.u.logService.info(`${re} received socket close event (hadError: ${ae.hadError}).`),ae.error&&this.u.logService.error(ae.error)):(this.u.logService.info(`${re} received socket close event (wasClean: ${ae.wasClean}, code: ${ae.code}, reason: ${ae.reason}).`),ae.event&&this.u.logService.error(ae.event)):this.u.logService.info(`${re} received socket close event.`),this.y()})),this.B(Pe.onSocketTimeout(ae=>{const re=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${ae.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ae.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ae.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,p.$Sc)(()=>{const ae=B.j.indexOf(this);ae>=0&&B.j.splice(ae,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const Pe=be<ie.length?ie[be]:ie[ie.length-1];try{if(Pe>0){const ae=C(Pe);this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Pe,ae)),this.u.logService.info(`${U} waiting for ${Pe} seconds before reconnecting...`);try{await ae}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this.u.logService.info(`${U} resolving connection...`);const oe=await g(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${oe.connectTo}...`),await this.G(oe,o(v)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(oe){if(oe.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(E.$El.isTemporarilyNotAvailable(oe)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(oe);continue}if((oe.code==="ETIMEDOUT"||oe.code==="ENETUNREACH"||oe.code==="ECONNREFUSED"||oe.code==="ECONNRESET")&&oe.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(oe);continue}if((0,R.$4)(oe)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(oe);continue}if(oe instanceof E.$El){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,E.$El.isHandled(oe));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(oe),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this.n&&!this.s)}C(U,ie,be){this.w?B.triggerPermanentFailure(U,ie,be):this.D(U,ie,be)}D(U,ie,be){this.m.fire(new T(this.reconnectionToken,U,ie,be)),x(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Sl=B;class W extends B{constructor(U,ie,be,Pe,oe){super(1,U,Pe,oe,!0),this.client=this.B(new $.$ci(oe,{remoteAuthority:ie,clientId:be},U.ipcLogger))}async G(U,ie){await l(U,ie)}}e.$Tl=W;class Z extends B{constructor(U,ie,be,Pe,oe){super(2,U,be,Pe,!1),this.H=ie,this.debugPort=oe}async G(U,ie){await c(U,this.H,ie)}}e.$Ul=Z;function x(ee){try{ee.acceptDisconnect();const U=ee.getSocket();ee.dispose(),U.dispose()}catch(U){(0,R.$1)(U)}}function X(ee){if(ee&&ee.type==="error"){const U=new Error(`Connection error: ${ee.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function Y(ee,U){for(;ee.length<U;)ee+=" ";return ee}function ce(ee,U){return`[remote-connection][${Y(m(ee),13)}][${U.substr(0,5)}\u2026]`}function ne(ee,U,ie){return`${ce(ee,U)}[${ie?"reconnect":"initial"}]`}function $e(ee,U){return`${ne(U,ee.reconnectionToken,!!ee.reconnectionProtocol)}[${ee.connectTo}]`}function Ce(ee){return`${Date.now()-ee} ms`}}),define(ke[86],Ee([1,0,15]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=N,e.$Cm=L,e.$Dm=R,e.$Em=M;function N(b){return b.scheme===u.Schemas.vscodeRemote?b.authority:void 0}function L(b){if(!b)return;const S=b.indexOf("+");return S<0?b:b.substr(0,S)}function R(b){const{host:S,port:A}=p(b);if(typeof A>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:S,port:A}}function M(b,S){let{host:A,port:P}=p(b);return typeof P>"u"&&(P=S),{host:A,port:P}}function p(b){const S=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(S)return{host:S[1],port:parseInt(S[2],10)};const A=b.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const P=b.match(/(.*):(\d+)$/);return P?{host:P[1],port:parseInt(P[2],10)}:{host:b,port:void 0}}}),define(ke[25],Ee([1,0,14,5,86]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Nm=e.$Mm=e.$Lm=e.TargetPlatform=e.ExtensionType=e.$Km=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0,e.$Jm=R,e.$Om=P,e.$Pm=$,e.$Qm=E,e.$Rm=v,e.$Fm="extensions.user.cache",e.$Gm="extensions.builtin.cache",e.$Hm="undefined_publisher",e.$Im=["ui","workspace","web"];function R(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$Km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(M||(e.ExtensionType=M={}));var p;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class b{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,o){if(typeof m>"u"||m===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof m=="string"||typeof o=="string"){const n=typeof m=="string"?m:m.value,i=typeof o=="string"?o:o.value;return u.$tf(n,i)}return m._lower===o._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Lm=b;class S{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const o of m)this.add(o)}add(m){this.c.add(b.toKey(m))}delete(m){return this.c.delete(b.toKey(m))}has(m){return this.c.has(b.toKey(m))}}e.$Mm=S;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(b.toKey(m))}get(m){return this.c.get(b.toKey(m))}has(m){return this.c.has(b.toKey(m))}set(m,o){this.c.set(b.toKey(m),o)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Nm=A;function P(a){return $(a)}function $(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}function E(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}function v(a,m){if(m){const o=`onResolveRemoteAuthority:${(0,L.$Cm)(m)}`;return!!a.activationEvents?.includes(o)}return!1}e.$Sm=(0,N.$qi)("IBuiltinExtensionsScannerService")}),define(ke[140],Ee([1,0,13,25]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=e.$cG=void 0;class L{constructor(){this.a=new Map,this.b=new WeakMap}register(M,p){this.a.set(M,p)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const p=Object.create(null);for(const b of M){const S=this.readActivationEvents(b);S.length>0&&(p[N.$Lm.toKey(b.identifier)]=S)}return p}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const p=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let b=0;b<p.length;b++)p[b]==="onUri"&&(p[b]=`onUri:${N.$Lm.toKey(M.identifier)}`);if(!M.contributes)return p;for(const b in M.contributes){const S=this.a.get(b);if(!S)continue;const A=M.contributes[b],P=Array.isArray(A)?A:[A];try{S(P,p)}catch($){(0,u.$1)($)}}return p}}e.$cG=L,e.$dG=new L}),define(ke[268],Ee([1,0,3,5]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$Gl=void 0,e.$Gl=(0,N.$qi)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(M,p){return this.a[M]??=[],this.a[M].push(p),(0,u.$Sc)(()=>{const b=this.a[M]?.indexOf(p);typeof b=="number"&&b>=0&&this.a[M]?.splice(b,1)})}b(M){return(this.a[M.type]||[]).find(b=>b.supports(M))}connect(M,p,b,S){const A=this.b(M);if(!A)throw new Error(`No socket factory found for ${M}`);return A.connect(M,p,b,S)}}e.$Hl=L}),define(ke[269],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C0b=void 0;class u{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const R=await this.c();if(R){const M=String(u.a++);return this.b.set(M,R),{id:M,data:R.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,R){if(!L.id)return!0;const M=this.b.get(L.id);if(!M)return!1;this.b.delete(L.id);try{return M.validate(R)==="ok"}catch{return!1}finally{M.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$C0b=u}),define(ke[110],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.$Il=void 0,e.$Il="signService",e.$Jl=(0,u.$qi)(e.$Il)}),define(ke[141],Ee([1,0,269]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class N extends u.$C0b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(M=>new M.signer().sign(R))}h(){return new Promise((R,M)=>le(["vsda"],R,M))}}e.$ycc=N}),define(ke[270],Ee([1,0,11,51,30]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=M,e.$$o=p;function R(b){if(u.$u===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}function M(b,S,A,P,$,E,v,a,m){const o=Object.create(null);o["common.machineId"]=E,o["common.sqmId"]=v,o.sessionID=(0,L.$Mg)()+Date.now(),o.commitHash=P,o.version=$,o["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,u.$h)(u.$u),o["common.nodePlatform"]=N.$ec,o["common.nodeArch"]=A,o["common.product"]=m||"desktop",a&&(o["common.msftInternal"]=a);let n=0;const i=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),u.$l&&(o["common.snap"]="true");const r=R(S);return r&&(o["common.platformDetail"]=r),o}function p(b){const S=N.env.USERDNSDOMAIN;if(!S)return!1;const A=S.toLowerCase();return b.some(P=>A===P)}}),define(ke[271],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl=(0,u.$qi)("telemetryService"),e.$Wl=(0,u.$qi)("customEndpointTelemetryService"),e.$Xl="telemetry.currentSessionDate",e.$Yl="telemetry.firstSessionDate",e.$Zl="telemetry.lastSessionDate",e.$1l="telemetry.machineId",e.$2l="telemetry.sqmId",e.$3l="telemetry",e.$4l="telemetry.telemetryLevel",e.$5l="telemetry.enableCrashReporter",e.$6l="telemetry.enableTelemetry";var N;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ke[87],Ee([1,0,24,18,86,270,271]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=A,e.$hp=P,e.$ip=$,e.$jp=E,e.$kp=a,e.$lp=o,e.$mp=n,e.$np=s;class p{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$_o=p;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ap=b,e.$bp=new b;class S{async publicLog(f,d,l){}async publicLogError(f,d,l){}}e.$cp=S,e.$dp="telemetry",e.$ep="extensionTelemetryLog",e.$fp={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function P(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function $(t){const f=t.getValue(M.$4l),d=t.getValue(M.$5l);if(t.getValue(M.$6l)===!1||d===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function E(t){const f={},d={},l={};m(t,l);for(let c in l){c=c.length>150?c.substr(c.length-149):c;const h=l[c];typeof h=="number"?d[c]=h:typeof h=="boolean"?d[c]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${h.length}`),f[c]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(f[c]=h)}return{properties:f,measurements:d}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(t){if(!t)return"none";const f=(0,L.$Cm)(t);return v.has(f)?f:"other"}function m(t,f,d=0,l){if(t)for(const c of Object.getOwnPropertyNames(t)){const h=t[c],g=l?l+c:c;Array.isArray(h)?f[g]=(0,u.$2n)(h):h instanceof Date?f[g]=h.toISOString():(0,N.$6f)(h)?d<2?m(h,f,d+1,g+"."):f[g]=(0,u.$2n)(h):f[g]=h}}function o(t,f){const d=t.msftInternalDomains||[],l=f.getValue("telemetry.internalTesting");return(0,R.$$o)(d)||l}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let d=t;const l=[];for(const D of f)for(;;){const w=D.exec(t);if(!w)break;l.push([w.index,D.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(d="";;){const D=h.exec(t);if(!D)break;const w=l.some(([k,y])=>D.index<y&&k<h.lastIndex);!c.test(D[0])&&!w&&(d+=t.substring(g,D.index)+"<REDACTED: user-file-path>",g=h.lastIndex)}return g<t.length&&(d+=t.substr(g)),d}function r(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of f)if(d.regex.test(t))return`<REDACTED: ${d.label}>`;return t}function s(t,f){return(0,u.$Yn)(t,d=>{if(d instanceof p||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=i(l,f);for(const c of f)l=l.replace(c,"");return l=r(l),l}})}}),define(ke[272],Ee([1,0,14,137,25,11,2,13,51,87]),function(le,e,u,N,L,R,M,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$pp=void 0,e.$op=A,e.$qp=v,e.$rp=a,e.$sp=m,e.$tp=o,e.$up=n,e.$vp=i,e.$wp=r,e.$yp=s,e.$zp=f;function A(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,u.$of)(d.id,l.id)===0}const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(l){const c=l.manifest?l.manifest.version:l.version,h=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new $(l.identifier,c,h)}static parse(l){const c=P.exec(l);return c&&c[1]&&c[2]?new $({id:c[1]},c[2],c[4]||void 0):null}constructor(l,c,h="undefined"){this.version=c,this.targetPlatform=h,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof $?A(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$pp=$;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(d){const l=E.exec(d);return l&&l[1]?[m(l[1]),l[2]]:[m(d),void 0]}function a(d,l){return`${d}.${l}`}function m(d){return d.toLowerCase()}function o(d,l){return m(a(d??L.$Hm,l))}function n(d,l){const c=[],h=g=>{for(const D of c)if(D.some(w=>A(l(w),l(g))))return D;return null};for(const g of d){const D=h(g);D?D.push(g):c.push([g])}return c}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function r(d){return{id:new S.$_o(d.identifier.id),name:new S.$_o(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$xp=new L.$Lm("pprice.better-merge");function s(d,l){const c=[],h=l.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const g=h.shift();if(g&&c.every(D=>!A(D.identifier,{id:g}))){const D=d.filter(w=>A(w.identifier,{id:g}));D.length===1&&(c.push(D[0]),h.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}async function t(d,l){if(!R.$k)return!1;let c;try{c=(await d.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await d.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){l.debug("Error while getting the os-release file.",(0,p.$0)(g))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(d,l){const c=await t(d,l),h=(0,N.$Vo)(c?"alpine":R.$u,b.$fc);return l.debug("ComputeTargetPlatform:",h),h}}),define(ke[273],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=u,e.$ds=N,e.$es=L,e.$fs=R,e.$gs=M,e.$hs=p;function u(b){return[...b.entries()]}function N(b){return b?[...b.entries()]:[]}function L(b){return new Map(b)}function R(b){return new Map(b??[])}function M(b){return Array.from(b.entries()).map(S=>[S[0],u(S[1].map),N(S[1].descriptionMap)])}function p(b){return new Map(b.map(S=>[S[0],{map:L(S[1]),descriptionMap:R(S[2])}]))}}),define(ke[274],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fsb=void 0;class u{constructor(L){this.b=L,this.a=new Map}dispose(){for(const L of this.a.values())L.dispose()}startBuffering(L,R,M=5){const p=R(b=>{const S=typeof b=="string"?b:b.data;let A=this.a.get(L);if(A){A.data.push(S);return}const P=setTimeout(()=>this.flushBuffer(L),M);A={data:[S],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(L),p.dispose()}},this.a.set(L,A)});return p}stopBuffering(L){this.a.get(L)?.dispose()}flushBuffer(L){const R=this.a.get(L);R&&(this.a.delete(L),this.b(L,R.data.join("")))}}e.$Fsb=u}),define(ke[275],Ee([1,0,7,78,99,57,4,18,2,215,109,38]),function(le,e,u,N,L,R,M,p,b,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0w=e.$9w=e.$8w=e.$7w=e.$6w=e.$5w=e.IconFontDefinition=e.IconContribution=e.$2w=void 0,e.$3w=m,e.$4w=o,e.$2w={IconContribution:"base.contributions.icons"};var $;(function(s){function t(f,d){let l=f.defaults;for(;R.ThemeIcon.isThemeIcon(l);){const c=a.getIcon(l.id);if(!c)return;l=c.defaults}return l}s.getDefinition=t})($||(e.IconContribution=$={}));var E;(function(s){function t(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}s.toJSONObject=t;function f(d){const l=c=>(0,p.$4f)(c)?c:void 0;if(d&&Array.isArray(d.src)&&d.src.every(c=>(0,p.$4f)(c.format)&&(0,p.$4f)(c.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(c=>({format:c.format,location:b.URI.parse(c.location)}))}}s.fromJSONObject=f})(E||(e.IconFontDefinition=E={}));class v{constructor(){this.a=new M.$be,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,d,l){const c=this.b[t];if(c){if(d&&!c.description){c.description=d,this.d.properties[t].markdownDescription=`${d} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=d),this.a.fire()}return c}const h={id:t,description:d,defaults:f,deprecationMessage:l};this.b[t]=h;const g={$ref:"#/definitions/icons"};return l&&(g.deprecationMessage=l),d&&(g.markdownDescription=`${d}: $(${t})`),this.d.properties[t]=g,this.e.enum.push(t),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const d=this.f[t];return d||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(c,h)=>c.id.localeCompare(h.id),f=c=>{for(;R.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(c=>this.b[c]);for(const c of l.filter(h=>!!h.description).sort(t))d.push(`|<i class="${f(c)}"></i>|${c.id}|${R.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const c of l.filter(h=>!R.ThemeIcon.isThemeIcon(h.defaults)).sort(t))d.push(`|<i class="${f(c)}"></i>|${c.id}|`);return d.join(`
`)}}const a=new v;P.$9n.add(e.$2w.IconContribution,a);function m(s,t,f,d){return a.registerIcon(s,t,f,d)}function o(){return a}function n(){const s=(0,L.$Lj)();for(const t in s){const f="\\"+s[t].toString(16);a.registerIcon(t,{fontCharacter:f})}}n(),e.$5w="vscode://schemas/icons";const i=P.$9n.as(A.$0n.JSONContribution);i.registerSchema(e.$5w,a.getIconSchema());const r=new u.$Ch(()=>i.notifySchemaChanged(e.$5w),200);a.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$6w=m("widget-close",N.$Pj.close,(0,S.localize)(2,null)),e.$7w=m("goto-previous-location",N.$Pj.arrowUp,(0,S.localize)(3,null)),e.$8w=m("goto-next-location",N.$Pj.arrowDown,(0,S.localize)(4,null)),e.$9w=R.ThemeIcon.modify(N.$Pj.sync,"spin"),e.$0w=R.ThemeIcon.modify(N.$Pj.loading,"spin")}),define(ke[88],Ee([1,0,4,2,54,5,12]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$_v=e.$0v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$6v=e.$5v=void 0,e.$7v=S,e.$8v=P,e.$9v=$,e.$$v=E,e.$aw=v,e.$bw=a,e.$5v=(0,R.$qi)("tunnelService"),e.$6v=(0,R.$qi)("sharedTunnelsService");var p;(function(n){n.Http="http",n.Https="https"})(p||(e.TunnelProtocol=p={}));var b;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(b||(e.TunnelPrivacyId=b={}));function S(n){return!!n.forwardPort}var A;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function P(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function $(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const r of i){const s=r.split("=")[1];if(/^https?:/.exec(s)){const t=P(N.URI.parse(s));if(t)return t}}}e.$0v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(n){return e.$0v.indexOf(n)>=0}e.$_v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(n){return e.$_v.indexOf(n)>=0}function a(n,i,r,s){if(r===1)return!1;if(r===2&&v(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class m{constructor(i,r,s){this.remoteAddress=i,this.localAddress=r,this.b=s,this.a=new u.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$cw=m;let o=class{constructor(i,r){this.k=i,this.l=r,this.a=new u.$be,this.onTunnelOpened=this.a.event,this.b=new u.$be,this.onTunnelClosed=this.b.event,this.c=new u.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],r=Array.from(this.e.values());for(const s of r){const t=Array.from(s.values());for(const f of t){const d=await f.value;d&&typeof d!="string"&&i.push(d)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,s,t,f){this.q(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:s,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(v(i)||E(i))&&(i=e.$0v[0]);const s=this.s(i,r);if(s)return++s.refcount,s.value}openTunnel(i,r,s,t,f,d=!1,l,c){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${s} on local port ${f}.`);const h=this.f??i;if(!h)return;if(r||(r="localhost"),t||(t=this.m),this.f&&this.j.has(s)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const g=this.t(h,r,s,t,f,d,l,c);return g?g.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(r,s),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(r,s);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.o(D);return(D.tunnelRemoteHost!==r||D.tunnelRemotePort!==s)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&D.privacy!==l&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const s=r.get(i.tunnelRemotePort);s&&(s.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async p(i,r,s){if(s.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const t=s.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),t}}async closeTunnel(i,r){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const s=this.e.get(i);if(s&&s.has(r)){const t=s.get(r);t.refcount=0,await this.p(i,r,t)}}q(i,r,s){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:s})}async r(i,r){const s=this.e.get(i);if(s){const t=s.get(r),f=t?await t.value:void 0;(!f||typeof f=="string")&&s.delete(r),s.size===0&&this.e.delete(i)}}s(i,r){const s=[i];E(i)?(s.push(...e.$0v),s.push(...e.$_v)):v(i)&&s.push(...e.$_v);const t=s.map(f=>this.e.get(f));for(const f of t){const d=f?.get(r);if(d)return d}}canTunnel(i){return!!P(i)}u(i,r,s,t,f,d,l){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${s} on local port ${t}.`);const c=s;this.j.add(c);const h=t===void 0?s:t,g={elevationRequired:f?this.isPortPrivileged(h):!1},D={remoteAddress:{host:r,port:s},localAddressPort:t,privacy:d,public:d?d!==b.Private:void 0,protocol:l},w=i.forwardPort(D,g);return w?(this.q(r,s,w),w.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(c)})):this.j.delete(c),w}};e.$dw=o,e.$dw=o=Je([qe(0,M.$Wj),qe(1,L.$Wi)],o)}),define(ke[276],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=void 0,e.$ul=(0,u.$qi)("IUriIdentityService")}),define(ke[277],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ew=void 0,e.$ew=(0,u.$qi)("editSessionIdentityService");var N;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(ke[278],Ee([1,0,15]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=N,e.$nM=L,e.$oM=R,e.$pM=M,e.$qM=p;function N(b){return b.scheme!==u.Schemas.file&&b.scheme!==u.Schemas.vscodeRemote}function L(b){if(b.folders.length)return b.folders.every(S=>N(S.uri))?b.folders[0].uri:void 0;if(b.configuration&&N(b.configuration))return b.configuration}function R(b){return L(b)?.scheme}function M(b){return L(b)?.authority}function p(b){return L(b)!==void 0}}),define(ke[41],Ee([1,0,217,17,77,23,2,5,15]),function(le,e,u,N,L,R,M,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Ki=e.$Ji=e.WorkbenchState=e.$Di=e.$Ci=e.$zi=void 0,e.$Ai=S,e.$Bi=A,e.$Ei=P,e.$Fi=$,e.$Gi=E,e.$Hi=a,e.$Ii=m,e.$Li=i,e.$Qi=r,e.$Ri=s,e.$Ti=t,e.$Ui=f,e.$Vi=d,e.$zi=(0,p.$qi)("contextService");function S(l){const c=l;return typeof c?.id=="string"&&M.URI.isUri(c.uri)}function A(l){return typeof l?.id=="string"&&!S(l)&&!$(l)}e.$Ci={id:"ext-dev"},e.$Di={id:"empty-window"};function P(l,c){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,N.$oc)(l)}:c?e.$Ci:e.$Di;const h=l;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}function $(l){const c=l;return typeof c?.id=="string"&&M.URI.isUri(c.configPath)}function E(l){const c=l;if(c?.uri)return{id:c.id,uri:M.URI.revive(c.uri)};const h=l;if(h?.configPath)return{id:h.id,configPath:M.URI.revive(h.configPath)};if(l?.id)return{id:l.id}}var v;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function a(l){const c=l;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}function m(l){const c=l;return!!(c&&typeof c=="object"&&M.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}class o{constructor(c,h,g,D,w){this.h=c,this.j=g,this.k=D,this.l=w,this.c=L.$wi.forUris(this.l,()=>!0),this.folders=h}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=L.$wi.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ji=o;class n{constructor(c,h){this.raw=h,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,R.$4g)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ki=n;function i(l){return new n({uri:l,index:0,name:(0,R.$Zg)(l)},{uri:l.toString()})}e.$Mi="code-workspace",e.$Ni=`.${e.$Mi}`,e.$Oi=[{name:(0,u.localize)(0,null),extensions:[e.$Mi]}],e.$Pi="workspace.json";function r(l,c){return R.$Ug.isEqualOrParent(l,c.untitledWorkspacesHome)}function s(l){let c;return M.URI.isUri(l)?c=l:c=l.configuration,c?.scheme===b.Schemas.tmp}e.$Si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$Si}function f(l,c){return!r(l,c)&&!s(l)}function d(l){return(typeof l=="string"?(0,N.$pc)(l):(0,R.$2g)(l))===e.$Ni}}),define(ke[279],Ee([1,0,56,4,3,23,2,216,136,32,5,12,41,27,276,7,30,14,18]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.$wl=e.ProfileResourceType=void 0,e.$vl=r,e.$xl=s,e.$yl=t;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(l){const c=l;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&M.URI.isUri(c.location)&&M.URI.isUri(c.globalStorageHome)&&M.URI.isUri(c.settingsResource)&&M.URI.isUri(c.keybindingsResource)&&M.URI.isUri(c.tasksResource)&&M.URI.isUri(c.snippetsHome)&&M.URI.isUri(c.extensionsResource))}e.$wl=(0,A.$qi)("IUserDataProfilesService");function s(l,c){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:M.URI.revive(l.location).with({scheme:c}),globalStorageHome:M.URI.revive(l.globalStorageHome).with({scheme:c}),settingsResource:M.URI.revive(l.settingsResource).with({scheme:c}),keybindingsResource:M.URI.revive(l.keybindingsResource).with({scheme:c}),tasksResource:M.URI.revive(l.tasksResource).with({scheme:c}),snippetsHome:M.URI.revive(l.snippetsHome).with({scheme:c}),extensionsResource:M.URI.revive(l.extensionsResource).with({scheme:c}),cacheHome:M.URI.revive(l.cacheHome).with({scheme:c}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function t(l,c,h,g,D,w){return{id:l,name:c,location:h,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:w&&D?.useDefaultFlags?.globalState?w.globalStorageHome:(0,R.$4g)(h,"globalStorage"),settingsResource:w&&D?.useDefaultFlags?.settings?w.settingsResource:(0,R.$4g)(h,"settings.json"),keybindingsResource:w&&D?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,R.$4g)(h,"keybindings.json"),tasksResource:w&&D?.useDefaultFlags?.tasks?w.tasksResource:(0,R.$4g)(h,"tasks.json"),snippetsHome:w&&D?.useDefaultFlags?.snippets?w.snippetsHome:(0,R.$4g)(h,"snippets"),extensionsResource:w&&D?.useDefaultFlags?.extensions?w.extensionsResource:(0,R.$4g)(h,"extensions.json"),cacheHome:(0,R.$4g)(g,l),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let f=class extends L.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,h,g,D){super(),this.t=c,this.u=h,this.w=g,this.y=D,this.f=!0,this.h=this.B(new N.$be),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$be),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$be),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$be),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new E.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$4g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$4g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),h=[c];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,n.$4f)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}h.push(t((0,R.$1g)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},c))}}catch(w){this.y.error(w)}const g=new E.$Bc,D=new Map;if(h.length)try{const w=this.Q();if(w.workspaces)for(const[k,y]of Object.entries(w.workspaces)){const C=M.URI.parse(k),I=h.find(F=>F.id===y);I&&g.set(C,I)}if(w.emptyWindows)for(const[k,y]of Object.entries(w.emptyWindows)){const C=h.find(I=>I.id===y);C&&D.set(k,C)}}catch(w){this.y.error(w)}this.z={profiles:h,workspaces:g,emptyWindows:D}}return this.z}D(){const c=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const h="Temp",g=new RegExp(`${(0,o.$8e)(h)}\\s(\\d+)`);let D=0;for(const k of this.profiles){const y=g.exec(k.name),C=y?parseInt(y[1]):0;D=C>D?C:D}const w=`${h} ${D+1}`;return this.createProfile((0,u.$ej)((0,m.$Mg)()).toString(16),w,{transient:!0},c)}async createNamedProfile(c,h,g){return this.createProfile((0,u.$ej)((0,m.$Mg)()).toString(16),c,h,g)}async createProfile(c,h,g,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(c,h,g);return D&&await this.setProfileForWorkspace(D,w),w}async F(c,h,g){if(!(0,n.$4f)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(h);return D||(D=(async()=>{try{if(this.profiles.find(C=>C.name===h||C.id===c))throw new Error(`Profile with ${h} name already exists`);const k=t(c,h,(0,R.$4g)(this.profilesHome,c),this.g,g,this.defaultProfile);await this.u.createFolder(k.location);const y=[];return this.j.fire({profile:k,join(C){y.push(C)}}),await a.Promises.settled(y),this.I([k],[],[]),k}finally{this.r.delete(h)}})(),this.r.set(h,D)),D}async updateProfile(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let g=this.profiles.find(D=>D.id===c.id);if(!g)throw new Error(`Profile '${c.name}' does not exist`);return g=t(g.id,h.name??g.name,g.location,this.g,{shortName:h.shortName??g.shortName,icon:h.icon===null?void 0:h.icon??g.icon,transient:h.transient??g.isTransient,useDefaultFlags:h.useDefaultFlags??g.useDefaultFlags},this.defaultProfile),this.I([],[],[g]),g}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(D=>D.id===c.id);if(!h)throw new Error(`Profile '${c.name}' does not exist`);const g=[];this.m.fire({profile:h,join(D){g.push(D)}});try{await Promise.allSettled(g)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(D){(0,S.$bl)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=this.profiles.find(D=>D.id===h.id);if(!g)throw new Error(`Profile '${h.name}' does not exist`);this.L(c,g)}unsetWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(h=>h.isDirectory&&this.profiles.every(g=>!this.w.extUri.isEqual(g.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(c.map(h=>this.removeProfile(h)))}getProfileForWorkspace(c){const h=this.G(c);return M.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(c){return(0,$.$Ai)(c)?c.uri:(0,$.$Fi)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location)))}I(c,h,g){const D=[...this.profiles,...c],w=[];this.s.profiles=[];for(let k of D)k.isDefault||h.some(y=>k.id===y.id)||(k=g.find(y=>k.id===y.id)??k,k.isTransient?this.s.profiles.push(k):w.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(w),this.z=void 0,this.J(c,h,g)}J(c,h,g){this.h.fire({added:c,removed:h,updated:g,all:this.profiles})}L(c,h,g){g=h?.isTransient?!0:g,g||this.L(c,void 0,!0);const D=this.G(c),w=g?this.s:this.C;M.URI.isUri(D)?(w.workspaces.delete(D),h&&w.workspaces.set(D,h)):(w.emptyWindows.delete(D),h&&w.emptyWindows.set(D,h)),g||this.M()}M(){const c={};for(const[g,D]of this.C.workspaces.entries())c[g.toString()]=D.id;const h={};for(const[g,D]of this.C.emptyWindows.entries())h[g.toString()]=D.id;this.R({workspaces:c,emptyWindows:h}),this.z=void 0}N(c){const h={},g=this.D();if(c.workspaces)for(const[w,k]of Object.entries(c.workspaces)){const y=M.URI.parse(k);h[w]=this.w.extUri.isEqual(y,g.location)?g.id:this.w.extUri.basename(y)}const D={};if(c.emptyWindows)for(const[w,k]of Object.entries(c.emptyWindows)){const y=M.URI.parse(k);D[w]=this.w.extUri.isEqual(y,g.location)?g.id:this.w.extUri.basename(y)}return{workspaces:h,emptyWindows:D}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$zl=f,e.$zl=f=Je([qe(0,b.$xi),qe(1,S.$Wk),qe(2,v.$ul),qe(3,P.$Wj)],f);class d extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Al=d}),define(ke[280],Ee([1,0,7,4,3,59,18,195,5,279]),function(le,e,u,N,L,R,M,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Wp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Up=e.$Tp=e.$Sp=void 0,e.$Vp=E,e.$Xp=a,e.$Zp=o,e.$Sp="__$__isNewStorageMarker",e.$Tp="__$__targetStorageMarker",e.$Up=(0,b.$qi)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var P;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var $;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function E(n){const i=n.get(e.$Tp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends L.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:v.a}){super(),this.m=i,this.b=this.B(new N.$ee),this.c=this.B(new N.$ee),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$be),this.onWillSaveState=this.f.event,this.h=this.B(new u.$Ch(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,s){return N.Event.filter(this.b.event,t=>t.scope===i&&(r===void 0||t.key===r),s)}n(){this.j.value=(0,u.$Gh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:s,external:t}=r;if(s===e.$Tp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:s,target:this.J(i)[s],external:t})}w(i){this.f.fire({reason:i})}get(i,r,s){return this.P(r)?.get(i,s)}getBoolean(i,r,s){return this.P(r)?.getBoolean(i,s)}getNumber(i,r,s){return this.P(r)?.getNumber(i,s)}getObject(i,r,s){return this.P(r)?.getObject(i,s)}storeAll(i,r){this.y(()=>{for(const s of i)this.store(s.key,s.value,s.scope,s.target,r)})}store(i,r,s,t,f=!1){if((0,M.$ag)(r)){this.remove(i,s,f);return}this.y(()=>{this.z(i,s,t),this.P(s)?.set(i,r,f)})}remove(i,r,s=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,s)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const s=[],t=this.J(i);for(const f of Object.keys(t))t[f]===r&&s.push(f);return s}z(i,r,s,t=!1){const f=this.J(r);typeof s=="number"?f[i]!==s&&(f[i]=s,this.P(r)?.set(e.$Tp,JSON.stringify(f),t)):typeof f[i]=="number"&&(delete f[i],this.P(r)?.set(e.$Tp,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?E(r):Object.create(null)}isNew(i){return this.getBoolean(e.$Sp,i)===!0}async flush(i=A.NONE){this.f.fire({reason:i});const r=this.P(-1),s=this.P(0),t=this.P(1);switch(i){case A.NONE:await u.Promises.settled([r?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await u.Promises.settled([r?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,s=this.P(1)?.items??new Map;return o(i,r,s,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(A.NONE),(0,S.$vl)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||a(r)&&a(i))}N(i,r,s){this.y(()=>{const t=new Set;for(const[f,d]of i)t.add(f),r.get(f)!==d&&this.u(s,{key:f,external:!0});for(const[f]of r.items)t.has(f)||this.u(s,{key:f,external:!0})})}}e.$Wp=v;function a(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class m extends v{constructor(){super(),this.U=this.B(new p.$Qp(new p.$Rp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$Qp(new p.$Rp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$Qp(new p.$Rp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$Yp=m;async function o(n,i,r,s,t,f){const d=C=>{try{return JSON.parse(C)}catch{return C}},l=new Map,c=new Map;n.forEach((C,I)=>{l.set(I,C),c.set(I,d(C))});const h=new Map,g=new Map;i.forEach((C,I)=>{h.set(I,C),g.set(I,d(C))});const D=new Map,w=new Map;r.forEach((C,I)=>{D.set(I,C),w.set(I,d(C))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const k=[];if(l.forEach((C,I)=>{k.push({key:I,value:C})}),console.table(k),console.groupEnd(),console.log(c),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];h.forEach((I,F)=>{C.push({key:F,value:I})}),console.table(C),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${f})`);const y=[];D.forEach((C,I)=>{y.push({key:I,value:C})}),console.table(y),console.groupEnd(),console.log(w)}}),define(ke[111],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;class u{static{this.a=!1}constructor(L){this.d=L,this.b=new Map,this.c=1}add(L){const R=this.c++;return this.b.set(R,L),this.e(),R}get(L,R){return this.b.has(L)?this.b.get(L)[R]:void 0}delete(L){this.b.delete(L),this.e()}e(){u.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Zjc=u}),define(ke[60],Ee([1,0,15,23,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6jc=e.$5jc=void 0;class R{constructor(){this.a=new Set(Object.keys(u.Schemas)),this.b=new Map,this.extUri=new N.$Sg(p=>{const b=this.b.get(p.scheme);return!(b===void 0||b&1024)})}$acceptProviderInfos(p,b){b===null?this.b.delete(p.scheme):this.b.set(p.scheme,b)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$5jc=R,e.$6jc=(0,L.$qi)("IExtHostFileSystemInfo")}),define(ke[28],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=void 0,e.$qP=(0,u.$qi)("IExtHostInitDataService")}),define(ke[281],Ee([1,0,223,12,261,28]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;let M=class extends L.$yQ{constructor(b,S,A){const P=A.remote.isRemote?"remoteexthost":b?"workerexthost":"exthost",$=A.remote.isRemote?(0,u.localize)(0,null):b?(0,u.localize)(1,null):(0,u.localize)(2,null);super(S.createLogger(P,{name:$}))}};e.$_lc=M,e.$_lc=M=Je([qe(1,N.$Xj),qe(2,R.$qP)],M)}),define(ke[282],Ee([1,0,7]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=e.$Kkc=void 0;class N{constructor(M,p,b){this.h=new Map,this.a=M,this.b=p,this.c=b,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(S=>(this.f=S,this)),this.g=this.c.onDidChangeStorage(S=>{S.shared===this.b&&S.key===this.a&&(this.f=S.value)}),this.i=new u.$Ch(()=>{const S=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of S.values())A.complete()}catch(A){for(const P of S.values())P.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,p){let b=this.f[M];return typeof b>"u"&&(b=p),b}update(M,p){this.f[M]=p;const b=this.h.get(M);if(b!==void 0)return b.p;const S=new u.$Nh;return this.h.set(M,S),this.i.isScheduled()||this.i.schedule(),S.p}dispose(){this.g.dispose()}}e.$Kkc=N;class L extends N{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,p){super(M.identifier.value,!0,p),this.j=M}}e.$Lkc=L}),define(ke[283],Ee([1,0,4,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0;class L{constructor(M){this.c=M,this.a=new u.$be,this.onDidSaveNotebookDocument=this.a.event,this.b=new u.$be,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,p,b,S){const P=this.c.getNotebookDocument(N.URI.revive(M)).acceptModelChanged(p.value,b,S);this.b.fire(P)}$acceptDirtyStateChanged(M,p){this.c.getNotebookDocument(N.URI.revive(M)).acceptDirty(p)}$acceptModelSaved(M){const p=this.c.getNotebookDocument(N.URI.revive(M));this.a.fire(p.apiNotebook)}}e.$zlc=L}),define(ke[20],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=void 0,e.$aP=(0,u.$qi)("IExtHostRpcService");class N{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$bP=N}),define(ke[284],Ee([1,0,25,4]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=void 0;class L{#e;constructor(M,p){this.b=new N.$be,this.onDidChange=this.b.event,this.a=u.$Lm.toKey(M.identifier),this.#e=p,this.#e.onDidChangePassword(b=>{b.extensionId===this.a&&this.b.fire({key:b.key})})}get(M){return this.#e.get(this.a,M)}store(M,p){return this.#e.store(this.a,M,p)}delete(M){return this.#e.delete(this.a,M)}}e.$Ukc=L}),define(ke[67],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=e.$ikc=void 0,e.$ikc=(0,u.$qi)("IURITransformerService");class N{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$jkc=N}),define(ke[285],Ee([1,0,21]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnb=L,e.$Ynb=M;class N{constructor(){this.buffers=[]}add(b){let S=this.buffers.indexOf(b);return S<0&&(S=this.buffers.length,this.buffers.push(b)),S}}function L(p,b){if(b.serializeBuffersForPostMessage){const S=new N,P=JSON.stringify(p,(E,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:S.add(v)};if(ArrayBuffer.isView(v)){const a=R(v);if(a)return{$$vscode_array_buffer_reference$$:!0,index:S.add(v.buffer),view:{type:a,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),$=S.buffers.map(E=>{const v=new Uint8Array(E);return u.$Ce.wrap(v)});return{message:P,buffers:$}}else return{message:JSON.stringify(p),buffers:[]}}function R(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(p,b){const S=b.map($=>{const E=new ArrayBuffer($.byteLength);return new Uint8Array(E).set($.buffer),E}),A=b.length?($,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const v=E,{index:a}=v,m=S[a];if(v.view)switch(v.view.type){case 1:return new Int8Array(m,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return E}:void 0;return{message:JSON.parse(p,A),arrayBuffers:S}}}),define(ke[286],Ee([1,0,287,399,400,63,2,12,401]),function(le,e,u,N,L,R,M,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=A;const S=!1;function A(i,r,s,t,f,d){const l=d.environment.useHostProxy,c=typeof l=="boolean"?l:!d.remote.isRemote,h={resolveProxy:w=>i.resolveProxy(w),lookupProxyAuthorization:m.bind(void 0,t,f,r,{},d.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>$(r),addCertificatesV2:()=>E(r),log:t,getLogLevel:()=>{const w=t.getLevel();switch(w){case p.LogLevel.Trace:return b.LogLevel.Trace;case p.LogLevel.Debug:return b.LogLevel.Debug;case p.LogLevel.Info:return b.LogLevel.Info;case p.LogLevel.Warning:return b.LogLevel.Warning;case p.LogLevel.Error:return b.LogLevel.Error;case p.LogLevel.Off:return b.LogLevel.Off;default:return k(w)}function k(y){return t.error("Unknown log level",y),b.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,loadAdditionalCertificates:async()=>{const w=[];if(d.remote.isRemote&&w.push((0,b.loadSystemCertificates)({log:t})),c){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const k=i.loadCertificates();k.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),w.push(k)}return(await Promise.all(w)).flat()},env:process.env},g=(0,b.createProxyResolver)(h),D=P(h,g);return a(s,D)}function P(i,r){return{http:Object.assign(u,(0,b.createHttpPatch)(i,u,r)),https:Object.assign(N,(0,b.createHttpPatch)(i,N,r)),net:Object.assign(R,(0,b.createNetPatch)(i,R)),tls:Object.assign(L,(0,b.createTlsPatch)(i,L))}}function $(i){const r=i.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",S)&&!!r.get("systemCertificates")}function E(i){const r=i.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",S)&&!!r.get("systemCertificates")}const v=new Map;function a(i,r){return i.getExtensionPathIndex().then(s=>{const t=globalThis._VSCODE_NODE_MODULES.module,f=t._load;t._load=function(l,c,h){if(l==="net")return r.net;if(l==="tls")return r.tls;if(l!=="http"&&l!=="https")return f.apply(this,arguments);const g=s.findSubstr(M.URI.file(c.filename));let D=v.get(g);if(D||v.set(g,D={}),!D[l]){const w=r[l];D[l]={...w}}return D[l]}})}async function m(i,r,s,t,f,d,l,c){const h=t[d];l&&(t[d]=l),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${h}`);const g=l||h,D=Array.isArray(g)?g:typeof g=="string"?[g]:[];if(n(r,D,f),D.some(w=>/^(Negotiate|Kerberos)( |$)/i.test(w))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const w=await new Promise((F,j)=>{le(["kerberos"],F,j)}),k=new URL(d),y=s.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${k.hostname}`:`HTTP@${k.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${y}`),"Negotiate "+await(await w.initializeClient(y)).step("")}catch(w){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",w)}}let o=!1;function n(i,r,s){o||!r.length||(o=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:s?"remote":"local"}))}}),define(ke[288],Ee([1,0,133]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=L;function N(R){return{transformIncoming:M=>M.scheme==="vscode-remote"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="file"?{scheme:"vscode-local",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoing:M=>M.scheme==="file"?{scheme:"vscode-remote",authority:R,path:M.path,query:M.query,fragment:M.fragment}:M.scheme==="vscode-local"?{scheme:"file",path:M.path,query:M.query,fragment:M.fragment}:M,transformOutgoingScheme:M=>M==="file"?"vscode-remote":M==="vscode-local"?"file":M}}function L(R){return new u.$sn(N(R))}}),define(ke[142],Ee([1,0,233,18,2,3,5,38,32,15,47,187,40]),function(le,e,u,N,L,R,M,p,b,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$BF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$sF=e.EditorInputCapabilities=e.$rF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=void 0,e.$iF=a,e.$jF=m,e.$kF=o,e.$lF=n,e.$mF=i,e.$nF=r,e.$oF=s,e.$pF=t,e.$qF=f,e.$tF=D,e.$uF=k,e.$vF=y,e.$wF=C,e.$xF=I,e.$yF=F,e.$zF=j,e.$AF=Z,e.$CF=Y,e.$DF=ne,e.$EF=$e,e.$FF=Ce,e.$dF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$eF={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.$fF="workbench.editor.sidebysideEditor",e.$gF="workbench.editors.textDiffEditor",e.$hF="workbench.editors.binaryResourceDiffEditor";var E;(function(ee){ee[ee.PROGRAMMATIC=1]="PROGRAMMATIC",ee[ee.USER=2]="USER",ee[ee.EDIT=3]="EDIT",ee[ee.NAVIGATION=4]="NAVIGATION",ee[ee.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var v;(function(ee){ee[ee.IDENTICAL=1]="IDENTICAL",ee[ee.SIMILAR=2]="SIMILAR",ee[ee.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function a(ee){const U=ee;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function m(ee){const U=ee;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function o(ee,U,ie){for(const be of ie.visibleEditorPanes)if(be.group.id===U&&ee.matches(be.input))return be.getViewState()}function n(ee){if(D(ee))return!1;const U=ee;return L.URI.isUri(U?.resource)}function i(ee){if(D(ee))return!1;const U=ee;return U?.original!==void 0&&U.modified!==void 0}function r(ee){if(D(ee))return!1;const U=ee;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function s(ee){if(D(ee)||i(ee))return!1;const U=ee;return U?.primary!==void 0&&U.secondary!==void 0}function t(ee){if(D(ee))return!1;const U=ee;return U?U.resource===void 0||U.resource.scheme===S.Schemas.untitled||U.forceUntitled===!0:!1}function f(ee){if(D(ee))return!1;const U=ee;return L.URI.isUri(U?.base?.resource)&&L.URI.isUri(U?.input1?.resource)&&L.URI.isUri(U?.input2?.resource)&&L.URI.isUri(U?.result?.resource)}var d;(function(ee){ee[ee.SHORT=0]="SHORT",ee[ee.MEDIUM=1]="MEDIUM",ee[ee.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(ee){ee[ee.EXPLICIT=1]="EXPLICIT",ee[ee.AUTO=2]="AUTO",ee[ee.FOCUS_CHANGE=3]="FOCUS_CHANGE",ee[ee.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class c{constructor(){this.a=new Map}registerSource(U,ie){let be=this.a.get(U);return be||(be={source:U,label:ie},this.a.set(U,be)),be.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$rF=new c;var h;(function(ee){ee[ee.None=0]="None",ee[ee.Readonly=2]="Readonly",ee[ee.Untitled=4]="Untitled",ee[ee.Singleton=8]="Singleton",ee[ee.RequiresTrust=16]="RequiresTrust",ee[ee.CanSplitInGroup=32]="CanSplitInGroup",ee[ee.ForceDescription=64]="ForceDescription",ee[ee.CanDropIntoEditor=128]="CanDropIntoEditor",ee[ee.MultipleEditors=256]="MultipleEditors",ee[ee.Scratchpad=512]="Scratchpad"})(h||(e.EditorInputCapabilities=h={}));class g extends R.$Uc{}e.$sF=g;function D(ee){return ee instanceof g}function w(ee){const U=ee;return L.URI.isUri(U?.preferredResource)}function k(ee){const U=ee;return D(U?.primary)&&D(U?.secondary)}function y(ee){const U=ee;return D(U?.modified)&&D(U?.original)}function C(ee,U,ie,be,Pe){return Ce(be,[(0,P.$aj)({id:"workbench.action.openLargeFile",label:(0,u.localize)(2,null),run:()=>{const oe={...ie,limits:{size:Number.MAX_VALUE}};ee.openEditor(U,oe)}}),(0,P.$aj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,u.localize)(3,null),run:()=>Pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}function I(ee){return D(ee?.editor)}function F(ee){const U=ee;return I(ee)&&U?.group!==void 0}function j(ee){const U=ee;return typeof U?.groupId=="number"&&D(U.editor)}var z;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.REPLACE=1]="REPLACE",ee[ee.MOVE=2]="MOVE",ee[ee.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var O;(function(ee){ee[ee.GROUP_ACTIVE=0]="GROUP_ACTIVE",ee[ee.GROUP_INDEX=1]="GROUP_INDEX",ee[ee.GROUP_LABEL=2]="GROUP_LABEL",ee[ee.GROUP_LOCKED=3]="GROUP_LOCKED",ee[ee.EDITOR_OPEN=4]="EDITOR_OPEN",ee[ee.EDITOR_CLOSE=5]="EDITOR_CLOSE",ee[ee.EDITOR_MOVE=6]="EDITOR_MOVE",ee[ee.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ee[ee.EDITOR_LABEL=8]="EDITOR_LABEL",ee[ee.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ee[ee.EDITOR_PIN=10]="EDITOR_PIN",ee[ee.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ee[ee.EDITOR_STICKY=12]="EDITOR_STICKY",ee[ee.EDITOR_DIRTY=13]="EDITOR_DIRTY",ee[ee.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var T;(function(ee){ee[ee.PRIMARY=1]="PRIMARY",ee[ee.SECONDARY=2]="SECONDARY",ee[ee.BOTH=3]="BOTH",ee[ee.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class B{getOriginalUri(U,ie){if(!U)return;if(f(U))return e.$BF.getOriginalUri(U.result,ie);if(ie?.supportSideBySide){const{primary:Pe,secondary:oe}=this.a(U);if(Pe&&oe){if(ie?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(Pe,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(oe,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===T.ANY)return this.getOriginalUri(Pe,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(oe,{filterByScheme:ie.filterByScheme});U=ie.supportSideBySide===T.PRIMARY?Pe:oe}}if(i(U)||r(U)||s(U)||f(U))return;const be=w(U)?U.preferredResource:U.resource;return!be||!ie||!ie.filterByScheme?be:this.b(be,ie.filterByScheme)}a(U){return k(U)||s(U)?{primary:U.primary,secondary:U.secondary}:y(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,ie){if(!U)return;if(f(U))return e.$BF.getCanonicalUri(U.result,ie);if(ie?.supportSideBySide){const{primary:Pe,secondary:oe}=this.a(U);if(Pe&&oe){if(ie?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(Pe,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(oe,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===T.ANY)return this.getCanonicalUri(Pe,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(oe,{filterByScheme:ie.filterByScheme});U=ie.supportSideBySide===T.PRIMARY?Pe:oe}}if(i(U)||r(U)||s(U)||f(U))return;const be=U.resource;return!be||!ie||!ie.filterByScheme?be:this.b(be,ie.filterByScheme)}b(U,ie){if(Array.isArray(ie)){if(ie.some(be=>U.scheme===be))return U}else if(ie===U.scheme)return U}}var W;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.KEYBOARD=1]="KEYBOARD",ee[ee.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function Z(ee,U,ie,be){if(!ee.isSticky(U))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return ie===W.MOUSE||ie===W.KEYBOARD;case"mouse":return ie===W.MOUSE;case"keyboard":return ie===W.KEYBOARD}return!1}e.$BF=new B;var x;(function(ee){ee[ee.LEFT=0]="LEFT",ee[ee.RIGHT=1]="RIGHT"})(x||(e.CloseDirection=x={}));class X{constructor(){this.c=new Map,this.d=new Map}start(U){const ie=this.a=U.get(M.$pi);for(const[be,Pe]of this.c)this.e(be,Pe,ie);this.c.clear()}e(U,ie,be){const Pe=be.createInstance(ie);this.d.set(U,Pe)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,N.$cg)(this.b)}registerEditorSerializer(U,ie){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,ie,this.a):this.c.set(U,ie),(0,R.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}p.$9n.add(e.$dF.EditorFactory,new X);async function Y(ee,U,ie){return!ee||!ee.length?[]:await Promise.all(ee.map(async be=>{const Pe=L.URI.revive(be.fileUri);if(!Pe){ie.info("Cannot resolve the path because it is not valid.",be);return}if(!await U.canHandleResource(Pe)){ie.info("Cannot resolve the path because it cannot be handled",be);return}let ae=be.exists,re=be.type;if(typeof ae!="boolean"||typeof re!="number")try{re=(await U.stat(Pe)).isDirectory?b.FileType.Directory:b.FileType.Unknown,ae=!0}catch(te){ie.error(te),ae=!1}if(!ae&&be.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",be);return}if(re===b.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",be);return}const G={...be.options,pinned:!0};return ae?{resource:Pe,options:G}:{resource:Pe,options:G,forceUntitled:!0}}))}var ce;(function(ee){ee[ee.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ee[ee.SEQUENTIAL=1]="SEQUENTIAL"})(ce||(e.EditorsOrder=ce={}));function ne(ee){const U=ee;if(!U)return!1;const ie=U;if(ie.modified)return ne(ie.modified);const be=U;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function $e(ee){return(0,A.$cj)(ee)}function Ce(ee,U,ie){const be=(0,A.$dj)(ee,U);return be.forceMessage=ie?.forceMessage,be.forceSeverity=ie?.forceSeverity,be.allowDialog=ie?.allowDialog,be}}),define(ke[289],Ee([1,0,4,234,5,3,27,38,19,24,78,275]),function(le,e,u,N,L,R,M,p,b,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NF=e.$MF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$LF=e.ViewContentGroups=e.$JF=e.ViewContainerLocation=e.Extensions=e.$IF=e.$HF=e.$GF=void 0,e.$KF=v,e.$GF="views",e.$HF=(0,N.localize)(0,null),e.$IF=(0,P.$3w)("default-view-icon",A.$Pj.window,(0,N.localize)(1,null));var $;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})($||(e.Extensions=$={}));var E;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.$JF=[0,1,2];function v(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class a extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$be),this.onDidRegister=this.c.event,this.f=this.B(new u.$be),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,b.$Rb)([...this.g.values()])}registerViewContainer(d,l,c){const h=this.get(d.id);if(h)return h;const g=d;return g.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,M.$yc)(this.g,l,[]).push(g),c?.isDefault&&this.h.push(g),this.c.fire({viewContainer:g,viewContainerLocation:l}),g}deregisterViewContainer(d){for(const l of this.g.keys()){const c=this.g.get(l),h=c?.indexOf(d);if(h!==-1){c?.splice(h,1),c.length===0&&this.g.delete(l),this.f.fire({viewContainer:d,viewContainerLocation:l});return}}}get(d){return this.all.filter(l=>l.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(c=>c?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(l=>this.getViewContainerLocation(l)===d)}}p.$9n.add($.ViewContainersRegistry,new a);var m;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(m||(e.ViewContentGroups=m={}));function o(f,d){const l=f.group??m.More,c=d.group??m.More;return l!==c?l.localeCompare(c):(f.order??5)-(d.order??5)}class n extends R.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$be),this.onViewsRegistered=this.c.event,this.f=this.B(new u.$be),this.onViewsDeregistered=this.f.event,this.g=this.B(new u.$be),this.onDidChangeContainer=this.g.event,this.h=this.B(new u.$be),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(d,l){this.registerViews2([{views:d,viewContainer:l}])}registerViews2(d){d.forEach(({views:l,viewContainer:c})=>this.r(l,c)),this.c.fire(d)}deregisterViews(d,l){const c=this.s(d,l);c.length&&this.f.fire({views:c,viewContainer:l})}moveViews(d,l){for(const c of this.m.keys())if(c!==l){const h=this.s(d,c);h.length&&(this.r(h,l),this.g.fire({views:h,from:c,to:l}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const l of this.j){const c=(this.m.get(l)||[]).filter(h=>h.id===d)[0];if(c)return c}return null}getViewContainer(d){for(const l of this.j)if((this.m.get(l)||[]).filter(h=>h.id===d)[0])return l;return null}registerViewWelcomeContent(d,l){return this.n.add(d,l),this.h.fire(d),(0,R.$Sc)(()=>{this.n.delete(d,l),this.h.fire(d)})}registerViewWelcomeContent2(d,l){const c=new Map;for(const[h,g]of l)this.n.add(d,g),c.set(h,(0,R.$Sc)(()=>{this.n.delete(d,g),this.h.fire(d)}));return this.h.fire(d),c}getViewWelcomeContent(d){const l=[];return this.n.forEach(d,c=>l.push(c)),l.sort(o)}r(d,l){let c=this.m.get(l);c||(c=[],this.m.set(l,c),this.j.push(l));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,N.localize)(2,null,h.id));c.push(h)}}s(d,l){const c=this.m.get(l);if(!c)return[];const h=[],g=[];for(const D of c)d.includes(D)?h.push(D):g.push(D);return h.length&&(g.length?this.m.set(l,g):(this.m.delete(l),this.j.splice(this.j.indexOf(l),1))),h}}p.$9n.add($.ViewsRegistry,new n),e.$LF=(0,L.$qi)("viewDescriptorService");var i;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var r;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class s{constructor(d,l){this.c=!1,this.d=!1,(0,S.$Zn)(this,d),this.d=!!l,this.resolve=async c=>{if(l&&!this.c){const h=await l(c);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$MF=s;class t extends Error{constructor(d){super((0,N.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$NF=t}),define(ke[290],Ee([1,0,235,37]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0,e.$RF=new N.$Hj("chatSessionResponseVote","",{type:"string",description:(0,u.localize)(0,null)}),e.$SF=new N.$Hj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,u.localize)(1,null)}),e.$TF=new N.$Hj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,u.localize)(2,null)}),e.$UF=new N.$Hj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,u.localize)(3,null)}),e.$VF=new N.$Hj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,u.localize)(4,null)}),e.$WF=new N.$Hj("chatResponse",!1,{type:"boolean",description:(0,u.localize)(5,null)}),e.$XF=new N.$Hj("chatRequest",!1,{type:"boolean",description:(0,u.localize)(6,null)}),e.$YF=new N.$Hj("chatInputHasText",!1,{type:"boolean",description:(0,u.localize)(7,null)}),e.$ZF=new N.$Hj("chatInputHasFocus",!1,{type:"boolean",description:(0,u.localize)(8,null)}),e.$1F=new N.$Hj("inChatInput",!1,{type:"boolean",description:(0,u.localize)(9,null)}),e.$2F=new N.$Hj("inChat",!1,{type:"boolean",description:(0,u.localize)(10,null)}),e.$3F=new N.$Hj("hasChatProvider",!1,{type:"boolean",description:(0,u.localize)(11,null)}),e.$4F=new N.$Hj("chatCursorAtTop",!1),e.$5F=new N.$Hj("chatInputHasAgent",!1),e.$6F=new N.$Hj("chatLocation",void 0)}),define(ke[291],Ee([1,0,4,45,3,37,5,290]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5G=e.$4G=e.$3G=e.ChatAgentLocation=void 0;var b;(function(P){P.Panel="panel",P.Terminal="terminal",P.Notebook="notebook",P.Editor="editor"})(b||(e.ChatAgentLocation=b={})),function(P){function $(E){switch(E){case"panel":return P.Panel;case"terminal":return P.Terminal;case"notebook":return P.Notebook;case"editor":return P.Editor}return P.Panel}P.fromRaw=$}(b||(e.ChatAgentLocation=b={})),e.$3G=(0,M.$qi)("chatAgentService");let S=class{static{this.AGENT_LEADER="@"}constructor($){this.f=$,this.b=[],this.d=new u.$be,this.onDidChangeAgents=this.d.event,this.e=p.$3F.bindTo(this.f)}registerAgent($,E){if(this.getAgent($))throw new Error(`Agent already registered: ${JSON.stringify($)}`);const a=this,m=E.slashCommands;E={...E,get slashCommands(){return m.filter(n=>!n.when||a.f.contextMatchesRules(R.$oj.deserialize(n.when)))}};const o={data:E};return this.b.push(o),(0,L.$Sc)(()=>{this.b=this.b.filter(n=>n!==o),this.d.fire(void 0)})}registerAgentImplementation($,E){const v=this.g($);if(!v)throw new Error(`Unknown agent: ${JSON.stringify($)}`);if(v.impl)throw new Error(`Agent already has implementation: ${JSON.stringify($)}`);return v.data.isDefault&&this.e.set(!0),v.impl=E,this.d.fire(new A(v.data,E)),(0,L.$Sc)(()=>{v.impl=void 0,this.d.fire(void 0),v.data.isDefault&&this.e.set(!1)})}registerDynamicAgent($,E){const v={data:$,impl:E};return this.b.push(v),this.d.fire(new A($,E)),(0,L.$Sc)(()=>{this.b=this.b.filter(a=>a!==v),this.d.fire(void 0)})}updateAgent($,E){const v=this.g($);if(!v?.impl)throw new Error(`No activated agent with id ${JSON.stringify($)} registered`);v.data.metadata={...v.data.metadata,...E},this.d.fire(new A(v.data,v.impl))}getDefaultAgent($){return this.getActivatedAgents().find(E=>!!E.isDefault&&E.locations.includes($))}getContributedDefaultAgent($){return this.getAgents().find(E=>!!E.isDefault&&E.locations.includes($))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),$=>!!$.data.metadata.isSecondary)?.data}g($){return this.b.find(E=>E.data.id===$)}getAgent($){return this.g($)?.data}getAgents(){return this.b.map($=>$.data)}getActivatedAgents(){return Array.from(this.b.values()).filter($=>!!$.impl).map($=>new A($.data,$.impl))}getAgentsByName($){return this.getAgents().filter(E=>E.name===$)}async invokeAgent($,E,v,a,m){const o=this.g($);if(!o?.impl)throw new Error(`No activated agent with id ${$}`);return await o.impl.invoke(E,v,a,m)}async getFollowups($,E,v,a,m){const o=this.g($);if(!o?.impl)throw new Error(`No activated agent with id ${$}`);return o.impl?.provideFollowups?o.impl.provideFollowups(E,v,a,m):[]}};e.$4G=S,e.$4G=S=Je([qe(0,R.$Ij)],S);class A{constructor($,E){this.b=$,this.d=E}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke($,E,v,a){return this.d.invoke($,E,v,a)}async provideFollowups($,E,v,a){return this.d.provideFollowups?this.d.provideFollowups($,E,v,a):[]}provideWelcomeMessage($){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage($)}provideSampleQuestions($){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions($)}}e.$5G=A}),define(ke[292],Ee([1,0,2,29,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bG=e.$aG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$$F=R,e.$_F=M;function R(S){return!!S&&typeof S=="object"&&"uri"in S&&S.uri instanceof u.URI&&"version"in S&&typeof S.version=="number"&&"ranges"in S&&Array.isArray(S.ranges)&&S.ranges.every(N.$kt.isIRange)}function M(S){return!!S&&typeof S=="object"&&"documents"in S&&Array.isArray(S.documents)&&S.documents.every(R)}var p;(function(S){S[S.Down=0]="Down",S[S.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var b;(function(S){S[S.Action=1]="Action",S[S.Toolbar=2]="Toolbar"})(b||(e.ChatCopyKind=b={})),e.$aG=(0,L.$qi)("IChatService"),e.$bG="accessibility.voice.keywordActivation"}),define(ke[143],Ee([1,0,4,7,236]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sob=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new u.$be,this.o=new u.$be,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,b,S,A){const P={command:p};if(b&&Object.keys(b).length>0&&(P.arguments=b),this.u("request",P),typeof A=="number"){const $=setTimeout(()=>{clearTimeout($);const E=this.f.get(P.seq);if(E){this.f.delete(P.seq);const v={type:"response",seq:0,request_seq:P.seq,success:!1,command:p,message:(0,L.localize)(0,null,A,p)};E(v)}},A)}return S&&this.f.set(P.seq,S),P.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,b){return p.type!=="event"||b.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,N.$rh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const b=p,S=this.f.get(b.request_seq);S&&(this.f.delete(b.request_seq),S(b));break}}}}u(p,b){b.type=p,b.seq=this.d++,this.sendMessage(b)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((b,S)=>p.set(S,b)),await(0,N.$rh)(500),p.forEach((b,S)=>{b({type:"response",seq:0,request_seq:S,success:!1,command:"canceled",message:"canceled"}),this.f.delete(S)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$sob=R}),define(ke[293],Ee([1,0,2,237,37,5]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$iJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$gJ=e.MemoryRangeType=e.State=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=void 0,e.$fJ=b,e.$hJ=A,e.$6H="workbench.view.debug",e.$7H="workbench.debug.variablesView",e.$8H="workbench.debug.watchExpressionsView",e.$9H="workbench.debug.callStackView",e.$0H="workbench.debug.loadedScriptsView",e.$$H="workbench.debug.breakPointsView",e.$_H="workbench.debug.disassemblyView",e.$aI="workbench.panel.repl",e.$bI="workbench.panel.repl.view",e.$cI=new L.$Hj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$dI=new L.$Hj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$eI=new L.$Hj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$fI="debugUx",e.$gI=new L.$Hj(e.$fI,"default",{type:"string",description:N.localize(3,null)}),e.$hI=new L.$Hj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$iI=new L.$Hj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$jI=new L.$Hj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$kI=new L.$Hj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$lI=new L.$Hj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$mI=new L.$Hj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$nI=new L.$Hj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$oI=new L.$Hj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$pI=new L.$Hj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$qI=new L.$Hj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$rI=new L.$Hj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$sI=new L.$Hj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$tI=new L.$Hj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$uI=new L.$Hj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$vI=new L.$Hj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$wI=new L.$Hj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$xI=new L.$Hj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$yI=new L.$Hj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$zI=new L.$Hj("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$AI=new L.$Hj("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$BI=new L.$Hj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$CI=new L.$Hj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$DI=new L.$Hj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$EI=new L.$Hj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$FI=new L.$Hj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$GI=new L.$Hj("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$HI=new L.$Hj("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$II=new L.$Hj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$JI=new L.$Hj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$KI=new L.$Hj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$LI=new L.$Hj("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$MI=new L.$Hj("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$NI=new L.$Hj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$OI=new L.$Hj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$PI=new L.$Hj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$QI=new L.$Hj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$RI=new L.$Hj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$SI=new L.$Hj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$TI=new L.$Hj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$UI=new L.$Hj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$VI=new L.$Hj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$WI=new L.$Hj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$XI=new L.$Hj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$YI=new L.$Hj("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$ZI=new L.$Hj("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$1I=new L.$Hj("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$2I=new L.$Hj("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$3I=new L.$Hj("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$4I=new L.$Hj("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$5I=new L.$Hj("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$6I=new L.$Hj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$7I=new L.$Hj("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$8I=new L.$Hj("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$9I=new L.$Hj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$0I=new L.$Hj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$$I=new L.$Hj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$_I=new L.$Hj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const M=i=>N.localize(61,null,i);e.$aJ=M,e.$bJ="editor.contrib.debug",e.$cJ="editor.contrib.breakpoint",e.$dJ="debug",e.$eJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var p;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(p||(e.State=p={}));function b(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var S;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$gJ="vscode-debug-memory";function A(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var P;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(P||(e.DataBreakpointSetType=P={}));var $;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var E;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$iJ=(0,R.$qi)("debugService");var v;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var a;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var m;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(m||(e.DebugTreeItemCollapsibleState=m={}));var o;(function(i){i.deserialize=r=>r,i.serialize=r=>r})(o||(e.IDebugVisualizationTreeItem=o={}));var n;(function(i){i.deserialize=r=>({id:r.id,name:r.name,iconPath:r.iconPath&&{light:u.URI.revive(r.iconPath.light),dark:u.URI.revive(r.iconPath.dark)},iconClass:r.iconClass,visualization:r.visualization}),i.serialize=r=>r})(n||(e.IDebugVisualization=n={}))}),define(ke[294],Ee([1,0,14,2,17,24,15,29,22,19]),function(le,e,u,N,L,R,M,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hH=void 0,e.$8G=P,e.$9G=$,e.$0G=E,e.$$G=v,e.$_G=a,e.$aH=m,e.$bH=o,e.$cH=i,e.$dH=t,e.$eH=f,e.$fH=l,e.$gH=h;const A=/{([^}]+)}/g;function P(D,w,k){return D.replace(A,function(y,C){return w&&C.length>0&&C[0]!=="_"?y:k&&k.hasOwnProperty(C)?k[C]:y})}function $(D){const w={};for(const k of Object.keys(D))k.startsWith("!")||(w[k]=D[k]);return w}function E(D){return D.configuration.request==="attach"&&!v(D)&&(!D.parentSession||E(D.parentSession))}function v(D){let w=D.configuration.type;if(w)return w==="vslsShare"&&(w=D.configuration.adapterProxy.configuration.type),(0,u.$tf)(w,"extensionhost")||(0,u.$tf)(w,"pwa-extensionhost")?D:D.parentSession?v(D.parentSession):void 0}function a(D){return D.type&&(D.label||D.program||D.runtime)}function m(D,w,k){let y,C=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let F=null;for(;F=I.exec(D);){const j=F.index+1,z=j+F[0].length;if(j<=w&&z>=k){y=F[0],C=j;break}}if(y){const j=/\w+/g;let z=null;for(;(z=j.exec(y))&&!(z.index+1+C+z[0].length>=k););z&&(y=y.substring(0,j.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}async function o(D,w,k,y){if(D.evaluatableExpressionProvider.has(w)){const C=D.evaluatableExpressionProvider.ordered(w),I=(0,S.$Hb)(await Promise.all(C.map(async F=>{try{return await F.provideEvaluatableExpression(w,k,y??b.CancellationToken.None)}catch{return}})));if(I.length>0){let F=I[0].expression;const j=I[0].range;return F||(F=w.getLineContent(k.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:F}}}else{const C=w.getLineContent(k.lineNumber),{start:I,end:F}=m(C,k.column,k.column),j=C.substring(I-1,F);return{matchingExpression:j,range:new p.$kt(k.lineNumber,I,k.lineNumber,I+j.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function r(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return N.URI.parse(D.path);if((0,L.$jc)(D.path))return N.URI.file(D.path)}return D.path}function s(D){if(typeof D.path=="object"){const w=N.URI.revive(D.path);if(w)return w.scheme===M.Schemas.file?w.fsPath:w.toString()}return D.path}function t(D,w){const k=w?r:s,y=(0,R.$Wn)(D);return d(y,(C,I)=>{C&&I&&(I.path=k(I))}),y}function f(D,w){const k=w?r:s,y=(0,R.$Wn)(D);return d(y,(C,I)=>{!C&&I&&(I.path=k(I))}),y}function d(D,w){switch(D.type){case"event":{const k=D;switch(k.event){case"output":w(!1,k.body.source);break;case"loadedSource":w(!1,k.body.source);break;case"breakpoint":w(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=D;switch(k.command){case"setBreakpoints":w(!0,k.arguments.source);break;case"breakpointLocations":w(!0,k.arguments.source);break;case"source":w(!0,k.arguments.source);break;case"gotoTargets":w(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(y=>w(!1,y));break;default:break}break}case"response":{const k=D;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(y=>w(!1,y.source));break;case"loadedSources":k.body.sources.forEach(y=>w(!1,y));break;case"scopes":k.body.scopes.forEach(y=>w(!1,y.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(y=>w(!1,y.source));break;case"setBreakpoints":k.body.breakpoints.forEach(y=>w(!1,y.source));break;case"disassemble":k.body?.instructions.forEach(C=>w(!1,C.location));break;default:break}break}}}function l(D){return D.filter(w=>!w.presentation?.hidden).sort((w,k)=>w.presentation?k.presentation?w.presentation.group?k.presentation.group?w.presentation.group!==k.presentation.group?w.presentation.group.localeCompare(k.presentation.group):c(w.presentation.order,k.presentation.order):-1:k.presentation.group?1:c(w.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function c(D,w){return typeof D!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:D-w}async function h(D,w){const k=D.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(k!=="none"&&(await w.saveAll(),k==="allEditorsInActiveGroup")){const y=w.activeEditorPane;y&&y.input.resource?.scheme===M.Schemas.untitled&&await w.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}const g=(D,w)=>!D||!w?D===w:D.name===w.name&&D.path===w.path&&D.sourceReference===w.sourceReference;e.$hH=g}),define(ke[295],Ee([1,0,53,63,24,17,11,14,31,238,143]),function(le,e,u,N,L,R,M,p,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=e.$hmc=e.$gmc=e.$fmc=void 0;class P extends A.$sob{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(o,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,o.on("data",i=>this.v(i))}sendMessage(o){if(this.l){const n=JSON.stringify(o);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${P.a}${n}`,"utf8")}}v(o){for(this.p=Buffer.concat([this.p,o]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(P.a);if(n!==-1){const r=this.p.toString("utf8",0,n).split(P.b);for(const s of r){const t=s.split(P.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+P.a.length);continue}}break}}}e.$fmc=P;class $ extends P{startSession(){return new Promise((o,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),o(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",r=>{i?this.n.fire(r):n(r)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$gmc=$;class E extends ${constructor(o){super(),this.z=o}y(o){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$hmc=E;class v extends ${constructor(o){super(),this.z=o}y(o){return N.createConnection(this.z.path,o)}}e.$imc=v;class a extends P{constructor(o,n){super(),this.y=o,this.z=n}async startSession(){const o=this.y.command,n=this.y.args,i=this.y.options||{};try{if(o)if(R.$jc(o)){if(!await b.Promises.exists(o))throw new Error(S.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(S.localize(1,null,this.z));let r=process.env;if(i.env&&Object.keys(i.env).length>0&&(r=L.$Zn(L.$Wn(process.env),i.env)),o==="node")if(Array.isArray(n)&&n.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const f=u.fork(n[0],n.slice(1),t);if(!f.pid)throw new Error(S.localize(2,null,n[0]));this.x=f}else throw new Error(S.localize(3,null));else{const s={env:r};i.cwd&&(s.cwd=i.cwd),this.x=u.spawn(o,n,s)}this.x.on("error",s=>{this.n.fire(s)}),this.x.on("exit",(s,t)=>{this.o.fire(s)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",s=>{this.n.fire(s)}),this.x.stdin.on("error",s=>{this.n.fire(s)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(r){this.n.fire(r)}}async stopSession(){return this.x?(await this.w(),M.$i?new Promise((o,n)=>{const i=u.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,s,t){if(r)return n(r)});i.on("exit",o),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,n){if(!o)return;const i=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?i.runtime=R.$kc(n,o.runtime):i.runtime=o.runtime),o.runtimeArgs&&(i.runtimeArgs=o.runtimeArgs),o.program&&(R.$jc(o.program)?i.program=o.program:i.program=R.$kc(n,o.program)),o.args&&(i.args=o.args);const r=o;return r.win&&(i.win=a.A(r.win,n)),r.winx86&&(i.winx86=a.A(r.winx86,n)),r.windows&&(i.windows=a.A(r.windows,n)),r.osx&&(i.osx=a.A(r.osx,n)),r.linux&&(i.linux=a.A(r.linux,n)),i}static platformAdapterExecutable(o,n){let i=Object.create(null);n=n.toLowerCase();for(const l of o)if(l.contributes){const c=l.contributes.debuggers;c&&c.length>0&&c.filter(h=>typeof h.type=="string"&&p.$tf(h.type,n)).forEach(h=>{const g=a.A(h,l.extensionLocation.fsPath);i=L.$Zn(i,g,l.isBuiltin)})}let r;M.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=i.winx86||i.win||i.windows:M.$i?r=i.win||i.windows:M.$j?r=i.osx:M.$k&&(r=i.linux),r=r||i;const s=r.program||i.program,t=r.args||i.args,f=r.runtime||i.runtime,d=r.runtimeArgs||i.runtimeArgs;if(f)return{type:"executable",command:f,args:(d||[]).concat(typeof s=="string"?[s]:[]).concat(t||[])};if(s)return{type:"executable",command:s,args:t||[]}}}e.$jmc=a}),define(ke[296],Ee([1,0,53,34,11]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=M,e.$lmc=b;function R(S,A){return new Promise((P,$)=>{let E="";const v=u.spawn(S,A);v.pid&&v.stdout.on("data",a=>{E+=a.toString()}),v.on("error",a=>{$(a)}),v.on("close",a=>{P(E)})})}async function M(S){if(S)if(L.$i){const A=await new Promise((P,$)=>{le(["@vscode/windows-process-tree"],P,$)});return new Promise(P=>{A.getProcessTree(S,$=>{P(!!$&&$.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(S)]).then(A=>{const P=A.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var p;(function(S){S[S.cmd=0]="cmd",S[S.powershell=1]="powershell",S[S.bash=2]="bash"})(p||(p={}));function b(S,A,P,$){S=S.trim().toLowerCase();let E;S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0?E=1:S.indexOf("cmd.exe")>=0?E=0:S.indexOf("bash")>=0?E=2:L.$i?E=0:E=2;let v,a=" ";switch(E){case 1:if(v=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),$){const m=(0,N.$vg)($);m&&(a+=`${m}:; `),a+=`cd ${v($)}; `}if(A.length>0){const m=A.shift(),o=P?m:v(m);a+=o[0]==="'"?`& ${o} `:`${o} `;for(const n of A)a+=n==="<"||n===">"||P?n:v(n),a+=" "}break;case 0:if(v=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(o=>m.includes(o))||m.length===0?`"${m}"`:m),$){const m=(0,N.$vg)($);m&&(a+=`${m}: && `),a+=`cd ${v($)} && `}for(const m of A)a+=m==="<"||m===">"||P?m:v(m),a+=" ";break;case 2:{v=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m),$&&(a+=`cd ${v($)} ; `);for(const m of A)a+=m==="<"||m===">"||P?m:v(m),a+=" ";break}}return a}}),define(ke[297],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vK=e.CellExecutionUpdateType=void 0;var N;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$vK=(0,u.$qi)("INotebookExecutionService")}),define(ke[298],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mib=e.$lib=e.ProxyKernelState=e.$kib=void 0,e.$kib=100;var N;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$lib=(0,u.$qi)("INotebookKernelService"),e.$mib=(0,u.$qi)("INotebookKernelHistoryService")}),define(ke[299],Ee([1,0,3,29,200,100]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Vb=void 0;class M extends u.$Uc{constructor(b,S,A){super(),this._source=b,this.b=S,this.c=A,this.a=void 0}f(b){const S=b.getLineCount();return new N.$kt(1,1,S,this.g(b,S))}g(b,S){if(S<1||S>b.getLineCount())throw new Error("Illegal value for lineNumber");return b.getLineLength(S)+1}get inputTextBuffer(){if(!this.b){const b=new L.$MC;b.acceptChunk(this._source);const S=b.finish(!0),{textBuffer:A,disposable:P}=S.create(1);this.b=A,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(b=>{const S=new L.$MC;S.acceptChunk(b);const A=S.finish(!0),{textBuffer:P,disposable:$}=A.create(1);return this.B($),P})),this.a}findInInputs(b){const A=new R.$AC(b,!1,!1,null).parseSearchRequest();if(!A)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,A,!0,5e3)}findInOutputs(b){const A=new R.$AC(b,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(P=>{const $=P.findMatchesLineByLine(this.f(P),A,!0,5e3);if($.length!==0)return{textBuffer:P,matches:$}}).filter(P=>!!P):[]}}e.$_Vb=M}),define(ke[68],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(R){R.Delimiter="\0"})(u||(e.TestIdPathParts=u={}));var N;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class L{static fromExtHostTestItem(M,p,b=M.parent){if(M._isRoot)return new L([p]);const S=[M.id];for(let A=b;A&&A.id!==p;A=A.parent)S.push(A.id);return S.push(p),new L(S.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const p=M.indexOf("\0");return p===-1?M:M.slice(0,p)}static fromString(M){return new L(M.split("\0"))}static join(M,p){return new L([...M.path,p])}static joinToString(M,p){return M.toString()+"\0"+p}static parentId(M){const p=M.lastIndexOf("\0");return p===-1?void 0:M.slice(0,p)}static localId(M){const p=M.lastIndexOf("\0");return p===-1?M:M.slice(p+1)}static isChild(M,p){return p.startsWith(M)&&p[M.length]==="\0"}static compare(M,p){return M===p?0:L.isChild(M,p)?2:L.isChild(p,M)?3:1}constructor(M,p=M.length){if(this.path=M,this.d=p,M.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.d>1?new L(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new L(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new L(this.path,M)}compare(M){if(typeof M=="string")return L.compare(this.toString(),M);for(let p=0;p<M.d&&p<this.d;p++)if(M.path[p]!==this.path[p])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$BL=L}),define(ke[89],Ee([1,0,2,50,29,68]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$JL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$IL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$HL=e.$GL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$FL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$EL=e.$DL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$CL=e.TestResultState=void 0;var M;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$CL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(O){O[O.Run=1]="Run",O[O.Debug=2]="Debug",O[O.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var b;(function(O){O[O.Run=2]="Run",O[O.Debug=4]="Debug",O[O.Coverage=8]="Coverage",O[O.HasNonDefaultProfile=16]="HasNonDefaultProfile",O[O.HasConfigurable=32]="HasConfigurable",O[O.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$DL=[2,4,8,16,32,64];const S=O=>"runId"in O;e.$EL=S;var A;(function(O){O.serialize=T=>({range:T.range.toJSON(),uri:T.uri.toJSON()}),O.deserialize=(T,B)=>({range:L.$kt.lift(B.range),uri:T.asCanonicalUri(u.URI.revive(B.uri))})})(A||(e.IRichLocation=A={}));var P;(function(O){O[O.Error=0]="Error",O[O.Output=1]="Output"})(P||(e.TestMessageType=P={}));var $;(function(O){O.serialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&A.serialize(T.location)}),O.deserialize=(T,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&A.deserialize(T,B.location)})})($||(e.ITestErrorMessage=$={}));const E=(O,T)=>`${T?"s":"e"}${O}`;e.$FL=E;var v;(function(O){O.serialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&A.serialize(T.location)}),O.deserialize=(T,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&A.deserialize(T,B.location)})})(v||(e.ITestOutputMessage=v={}));var a;(function(O){O.serialize=T=>T.type===0?$.serialize(T):v.serialize(T),O.deserialize=(T,B)=>B.type===0?$.deserialize(T,B):v.deserialize(T,B)})(a||(e.ITestMessage=a={}));var m;(function(O){O.serializeWithoutMessages=T=>({state:T.state,duration:T.duration,messages:[]}),O.serialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(a.serialize)}),O.deserialize=(T,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(W=>a.deserialize(T,W))})})(m||(e.ITestTaskState=m={}));const o="\0",n=(O,T)=>O+o+T;e.$GL=n;const i=O=>{const T=O.indexOf(o);return{ctrlId:O.slice(0,T),tagId:O.slice(T+1)}};e.$HL=i;var r;(function(O){O.serialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?.toJSON(),range:T.range?.toJSON()||null,description:T.description,error:T.error,sortText:T.sortText}),O.deserialize=(T,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?T.asCanonicalUri(u.URI.revive(B.uri)):void 0,range:B.range?L.$kt.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(r||(e.ITestItem=r={}));var s;(function(O){O[O.NotExpandable=0]="NotExpandable",O[O.Expandable=1]="Expandable",O[O.BusyExpanding=2]="BusyExpanding",O[O.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var t;(function(O){O.serialize=T=>({expand:T.expand,item:r.serialize(T.item)}),O.deserialize=(T,B)=>({controllerId:R.$BL.root(B.item.extId),expand:B.expand,item:r.deserialize(T,B.item)})})(t||(e.InternalTestItem=t={}));var f;(function(O){O.serialize=T=>{let B;return T.item&&(B={},T.item.label!==void 0&&(B.label=T.item.label),T.item.tags!==void 0&&(B.tags=T.item.tags),T.item.busy!==void 0&&(B.busy=T.item.busy),T.item.uri!==void 0&&(B.uri=T.item.uri?.toJSON()),T.item.range!==void 0&&(B.range=T.item.range?.toJSON()),T.item.description!==void 0&&(B.description=T.item.description),T.item.error!==void 0&&(B.error=T.item.error),T.item.sortText!==void 0&&(B.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:B}},O.deserialize=T=>{let B;return T.item&&(B={},T.item.label!==void 0&&(B.label=T.item.label),T.item.tags!==void 0&&(B.tags=T.item.tags),T.item.busy!==void 0&&(B.busy=T.item.busy),T.item.range!==void 0&&(B.range=T.item.range?L.$kt.lift(T.item.range):null),T.item.description!==void 0&&(B.description=T.item.description),T.item.error!==void 0&&(B.error=T.item.error),T.item.sortText!==void 0&&(B.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:B}}})(f||(e.ITestItemUpdate=f={}));const d=(O,T)=>{T.expand!==void 0&&(O.expand=T.expand),T.item!==void 0&&(O.item=O.item?Object.assign(O.item,T.item):T.item)};e.$IL=d;var l;(function(O){O.serializeWithoutMessages=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.serializeWithoutMessages)}),O.serialize=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.serialize)}),O.deserialize=(T,B)=>({...t.deserialize(T,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(W=>m.deserialize(T,W)),retired:!0})})(l||(e.TestResultItem=l={}));var c;(function(O){O.empty=()=>({covered:0,total:0}),O.sum=(T,B)=>{T.covered+=B.covered,T.total+=B.total}})(c||(e.ICoverageCount=c={}));var h;(function(O){O.serialize=T=>({id:T.id,statement:T.statement,branch:T.branch,declaration:T.declaration,uri:T.uri.toJSON()}),O.deserialize=(T,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:T.asCanonicalUri(u.URI.revive(B.uri))})})(h||(e.IFileCoverage=h={}));function g(O){return{...O,location:O.location?.toJSON()}}function D(O){return O.location=O.location?N.$jt.isIPosition(O.location)?N.$jt.lift(O.location):L.$kt.lift(O.location):void 0,O}e.$JL=3;var w;(function(O){O[O.Declaration=0]="Declaration",O[O.Statement=1]="Statement",O[O.Branch=2]="Branch"})(w||(e.DetailType=w={}));var k;(function(O){O.serialize=T=>T.type===0?C.serialize(T):I.serialize(T),O.deserialize=T=>T.type===0?C.deserialize(T):I.deserialize(T)})(k||(e.CoverageDetails=k={}));var y;(function(O){O.serialize=g,O.deserialize=D})(y||(e.IBranchCoverage=y={}));var C;(function(O){O.serialize=g,O.deserialize=D})(C||(e.IDeclarationCoverage=C={}));var I;(function(O){O.serialize=T=>({...g(T),branches:T.branches?.map(y.serialize)}),O.deserialize=T=>({...D(T),branches:T.branches?.map(y.deserialize)})})(I||(e.IStatementCoverage=I={}));var F;(function(O){O[O.Add=0]="Add",O[O.Update=1]="Update",O[O.DocumentSynced=2]="DocumentSynced",O[O.Remove=3]="Remove",O[O.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",O[O.Retire=5]="Retire",O[O.AddTag=6]="AddTag",O[O.RemoveTag=7]="RemoveTag"})(F||(e.TestDiffOpType=F={}));var j;(function(O){O.deserialize=(T,B)=>B.op===0?{op:B.op,item:t.deserialize(T,B.item)}:B.op===1?{op:B.op,item:f.deserialize(B.item)}:B.op===2?{op:B.op,uri:T.asCanonicalUri(u.URI.revive(B.uri)),docv:B.docv}:B,O.serialize=T=>T.op===0?{op:T.op,item:t.serialize(T.item)}:T.op===1?{op:T.op,item:f.serialize(T.item)}:T})(j||(e.TestsDiffOp=j={}));class z{constructor(T){this.k=T,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(T){const B=this.v();for(const W of T)switch(W.op){case 0:this.l(t.deserialize(this.k,W.item),B);break;case 1:this.o(f.deserialize(W.item),B);break;case 3:this.p(W.itemId,B);break;case 5:this.q(W.itemId);break;case 4:this.updatePendingRoots(W.amount);break;case 6:this.c.set(W.tag.id,W.tag);break;case 7:this.c.delete(W.id);break}B.complete?.()}l(T,B){const W=R.$BL.parentId(T.item.extId)?.toString();let Z;if(!W)Z=this.w(T),this.g.add(Z),this.f.set(T.item.extId,Z);else if(this.f.has(W)){const x=this.f.get(W);x.children.add(T.item.extId),Z=this.w(T,x),this.f.set(T.item.extId,Z)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(T)}`);return}return B.add?.(Z),T.expand===2&&this.h++,Z}o(T,B){const W=this.f.get(T.extId);if(W)return T.expand!==void 0&&(W.expand===2&&this.h--,T.expand===2&&this.h++),(0,e.$IL)(W,T),B.update?.(W),W}p(T,B){const W=this.f.get(T);if(!W)return;const Z=R.$BL.parentId(W.item.extId)?.toString();Z?this.f.get(Z).children.delete(W.item.extId):this.g.delete(W);const x=[[T]];for(;x.length;)for(const X of x.pop()){const Y=this.f.get(X);Y&&(x.push(Y.children),this.f.delete(X),B.remove?.(Y,Y!==W),Y.expand===2&&this.h--)}}q(T){}updatePendingRoots(T){this.j+=T}v(){return{}}}e.$KL=z}),define(ke[112],Ee([1,0,7,4,3,62,89,68]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.TestItemEventOp=void 0;var b;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const S=(n,i)=>n===i,P=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:S,label:S,description:S,error:S,sortText:S,tags:(n,i)=>!(n.length!==i.length||n.some(r=>!i.includes(r)))}),$=(n,i)=>{let r;for(const[s,t]of P)t(n[s],i[s])||(r?r[s]=i[s]:r={[s]:i[s]});return r};class E extends L.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new u.$Ch(()=>this.flushDiff(),200)),this.g=this.B(new N.$be),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===i.uri){r.docv=i.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===i.item.extId){(0,M.$IL)(r.item,i.item);return}if(r.op===0&&r.item.item.extId===i.item.extId){(0,M.$IL)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const s=this.tree.get(i);if(s){if((s.expandLevels===void 0||r>s.expandLevels)&&(s.expandLevels=r),s.expand===1){const t=this.M(s);return t.isOpen()?this.L(s,r-1):t.wait().then(()=>this.L(s,r-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.L(s,r-1)):this.L(s,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case 3:this.O(p.$BL.joinToString(i.fullId,r.id));break;case 0:this.z(r.item,i);break;case 5:for(const s of r.ops)this.w(i,s);break;case 1:this.C(r.new,r.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:r.update}});break;case 6:this.y(i.actual.uri);break;default:(0,R.$cd)(r)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const s=p.$BL.fromExtHostTestItem(i,this.root.id,r?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(i.id);let f=this.tree.get(s.toString());if(!f){f={fullId:s,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(i,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(i)}}),this.I(i,f,r);return}if(f.actual===i){this.H(i,f,r);return}if(f.actual.uri?.toString()!==i.uri?.toString())return this.O(s.toString()),this.z(i,r);const d=this.s.getChildren(f.actual),l=f.actual,c=$(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,f.actual=i,f.resolveBarrier=void 0,f.expand=0,c&&(c.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,s.toString()),delete c.tags),this.w(f,{op:4,update:c})),this.I(i,f,r);for(const[g,D]of d)this.s.getChildren(i).get(D.id)||this.O(p.$BL.joinToString(s,D.id));const h=f.expandLevels;h!==void 0&&queueMicrotask(()=>{f.expand===1&&(f.expandLevels=void 0,this.expand(s.toString(),h))}),this.y(f.actual.uri)}C(i,r,s){const t=new Set(r.map(f=>f.id));for(const f of i)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:s,item:{tags:i.map(f=>(0,M.$GL)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$GL)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$GL)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,s){this.G(i,s);const t=this.s.getApiFor(i);t.parent=s?.actual,t.listener=f=>this.w(r,f),this.J(r)}I(i,r,s){this.H(i,r,s);for(const[t,f]of this.s.getChildren(i))this.z(f,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?3:2:r=i.actual.canResolveChildren?1:0:r=0,r!==i.expand&&(i.expand=r,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:r}}),r===1&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const s=[];for(const[t,f]of this.s.getChildren(i.actual)){const d=this.expand(p.$BL.joinToString(i.fullId,f.id),r);(0,u.$ch)(d)&&s.push(d)}if(s.length)return Promise.all(s).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const f=new u.$ph;return f.open(),f}i.expand=2,this.N(i);const r=i.resolveBarrier=new u.$ph,s=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(f){s(f)}return(0,u.$ch)(t)?t.catch(s).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const s=[r];for(;s.length;){const t=s.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,d]of this.s.getChildren(t.actual))s.push(this.tree.get(p.$BL.joinToString(t.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$3O=E;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$4O=v;class a extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$5O=a;class m extends Error{constructor(i,r,s){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${s}".`)}}e.$6O=m;const o=(n,i,r)=>{let s=new Map;return{get size(){return s.size},forEach(t,f){for(const d of s.values())t.call(f,d,this)},[Symbol.iterator](){return s.entries()},replace(t){const f=new Map,d=new Set(s.keys()),l={op:5,ops:[]};for(const c of t){if(!(c instanceof r))throw new a(c.id);const h=i(c).controllerId;if(h!==n.controllerId)throw new m(c.id,h,n.controllerId);if(f.has(c.id))throw new v(c.id);f.set(c.id,c),d.delete(c.id),l.ops.push({op:0,item:c})}for(const c of d.keys())l.ops.push({op:3,id:c});n.listener?.(l),s=f},add(t){if(!(t instanceof r))throw new a(t.id);s.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){s.delete(t)&&n.listener?.({op:3,id:t})},get(t){return s.get(t)},toJSON(){return Array.from(s.values())}}};e.$7O=o}),define(ke[144],Ee([1,0,112]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$8O=void 0;const N=new WeakMap,L=(M,p)=>{const b={controllerId:p};return N.set(M,b),b};e.$8O=L;const R=M=>{const p=N.get(M);if(!p)throw new u.$5O(M?.id||"<unknown>");return p};e.$9O=R}),define(ke[113],Ee([1,0,15,2]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fxb=e.$Exb=e.$Dxb=void 0,e.$Gxb=L,e.$Hxb=M,e.$Dxb="vscode-cdn.net",e.$Exb=`vscode-resource.${e.$Dxb}`,e.$Fxb=`'self' https://*.${e.$Dxb}`;function L(p,b){return p.scheme===u.Schemas.http||p.scheme===u.Schemas.https?p:(b&&b.authority&&b.isRemote&&p.scheme===u.Schemas.file&&(p=N.URI.from({scheme:u.Schemas.vscodeRemote,authority:b.authority,path:p.path})),N.URI.from({scheme:u.Schemas.https,authority:`${p.scheme}+${R(p.authority)}.${e.$Exb}`,path:p.path,fragment:p.fragment,query:p.query}))}function R(p){return p.replace(/./g,b=>{const S=b.charCodeAt(0);return S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57?b:"-"+S.toString(16).padStart(4,"0")})}function M(p){return p.replace(/-([0-9a-f]{4})/g,(b,S)=>String.fromCharCode(parseInt(S,16)))}}),define(ke[300],Ee([1,0,4,3,113]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=void 0;class R{constructor(p,b,S){this.d=p,this.e=b,this.f=S,this.a=0,this.b=new N.$Tc,this.c=new Map,this.b.add(b.onDidChangeVisibleTextEditors(()=>{const A=b.getVisibleTextEditors();for(const P of this.c.values())A.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,b,S,A,P){let $;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===p){$=i;break}if(!$)throw new Error("not a visible editor");const E=this,v=this.a++,a=new u.$be,m=new u.$be,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,L.$Gxb)(i,E.f)}get cspSource(){return L.$Fxb}set options(i){this.b=i,E.d.$setOptions(v,i)}get options(){return this.b}set html(i){this.a=i,E.d.$setHtml(v,i)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(i){return E.d.$postMessage(v,i)}},n=new class{constructor(){this.editor=p,this.line=b,this.height=S,this.webview=o,this.onDidDispose=m.event}dispose(){E.c.has(v)&&(E.c.delete(v),E.d.$disposeEditorInset(v),m.fire(),m.dispose(),a.dispose())}};return this.d.$createEditorInset(v,$.id,$.value.document.uri,b+1,S,A||{},P.identifier,P.extensionLocation),this.c.set(v,{editor:p,inset:n,onDidReceiveMessage:a}),n}$onDidDispose(p){const b=this.c.get(p);b&&b.inset.dispose()}$onDidReceiveMessage(p,b){this.c.get(p)?.onDidReceiveMessage.fire(b)}}e.$gkc=R}),define(ke[145],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=e.$RL=void 0,e.$RL="__",e.$SL=(0,u.$qi)("IAuthenticationService"),e.$TL=(0,u.$qi)("IAuthenticationExtensionsService")}),define(ke[301],Ee([1,0,5]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=e.VariableKind=e.$YP=void 0,e.$YP=(0,u.$qi)("configurationResolverService");var N;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class L extends Error{constructor(M,p){super(p),this.variable=M}}e.$ZP=L}),define(ke[302],Ee([1,0,17,51,18,24,11,103,241,301,14]),function(le,e,u,N,L,R,M,p,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cQ=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,v,a,m){this.h=new Map,this.a=E,this.b=v,this.g=a,m&&(this.c=m.then(o=>this.i(o)))}i(E){if(M.$i){const v=Object.create(null);return Object.keys(E).forEach(a=>{v[a.toLowerCase()]=E[a]}),v}return E}resolveWithEnvironment(E,v,a){return this.l({env:this.i(E),userHome:void 0},v?v.uri:void 0,a)}async resolveAsync(E,v){const a={env:await this.c,userHome:await this.g};return this.l(a,E?E.uri:void 0,v)}async j(E,v,a,m){const o=R.$Wn(v);M.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):M.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):M.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,E?E.uri:void 0,o,a,m)}async resolveAnyAsync(E,v,a){return this.j(E,v,a)}async resolveAnyMap(E,v,a){const m=new Map;return{newConfig:await this.j(E,v,a,m),resolvedVariables:m}}resolveWithInteractionReplace(E,v,a,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,v,a,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,v){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,v)}async l(E,v,a,m,o){if(L.$4f(a))return this.m(E,v,a,m,o);if(Array.isArray(a))return Promise.all(a.map(n=>this.l(E,v,n,m,o)));if(L.$6f(a)){const n=Object.create(null),i=await Promise.all(Object.keys(a).map(async r=>[await this.m(E,v,r,m,o),await this.l(E,v,a[r],m,o)]));for(const[r,s]of i)n[r]=s;return n}return a}m(E,v,a,m,o){return(0,A.$lf)(a,P.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(P.VARIABLE_LHS))return n;let r=await this.o(E,n,i,v,m);return o?.set(i,r),r!==n&&L.$4f(r)&&r.match(P.VARIABLE_REGEXP)&&(r=await this.m(E,v,r,m,o)),r})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,v,a,m,o){let n;const i=a.split(":");i.length>1&&(a=i[0],n=i[1]);const r=f=>{const d=this.a.getFilePath();if(d)return(0,p.$pw)(d);throw new S.$ZP(f,(0,b.localize)(0,null,v))},s=f=>{const d=r(f);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,p.$pw)(l)}throw new S.$ZP(f,(0,b.localize)(1,null,v,u.$oc(d)))},t=f=>{if(n){const d=this.a.getFolderUri(n);if(d)return d;throw new S.$ZP(f,(0,b.localize)(2,null,v,n))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new S.$ZP(f,(0,b.localize)(3,null,v)):new S.$ZP(f,(0,b.localize)(4,null,v))};switch(a){case"env":if(n){if(E.env){const f=E.env[M.$i?n.toLowerCase():n];if(L.$4f(f))return f}return""}throw new S.$ZP(S.VariableKind.Env,(0,b.localize)(5,null,v));case"config":if(n){const f=this.a.getConfigurationValue(m,n);if(L.$ag(f))throw new S.$ZP(S.VariableKind.Config,(0,b.localize)(6,null,v,n));if(L.$6f(f))throw new S.$ZP(S.VariableKind.Config,(0,b.localize)(7,null,v,n));return f}throw new S.$ZP(S.VariableKind.Config,(0,b.localize)(8,null,v));case"command":return this.p(S.VariableKind.Command,v,n,o,"command");case"input":return this.p(S.VariableKind.Input,v,n,o,"input");case"extensionInstallFolder":if(n){const f=await this.a.getExtension(n);if(!f)throw new S.$ZP(S.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,v,n));return this.n(f.extensionLocation)}throw new S.$ZP(S.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,v));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,p.$pw)(this.n(t(S.VariableKind.WorkspaceFolder)));case"cwd":return m||n?(0,p.$pw)(this.n(t(S.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$pw)(u.$oc(this.n(t(S.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new S.$ZP(S.VariableKind.UserHome,(0,b.localize)(11,null,v))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new S.$ZP(S.VariableKind.LineNumber,(0,b.localize)(12,null,v))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new S.$ZP(S.VariableKind.SelectedText,(0,b.localize)(13,null,v))}case"file":return r(S.VariableKind.File);case"fileWorkspaceFolder":return s(S.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return u.$oc(s(S.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||n?u.$mc(this.n(t(S.VariableKind.RelativeFile)),r(S.VariableKind.RelativeFile)):r(S.VariableKind.RelativeFile);case"relativeFileDirname":{const f=u.$nc(r(S.VariableKind.RelativeFileDirname));if(m||n){const d=u.$mc(this.n(t(S.VariableKind.RelativeFileDirname)),f);return d.length===0?".":d}return f}case"fileDirname":return u.$nc(r(S.VariableKind.FileDirname));case"fileExtname":return u.$pc(r(S.VariableKind.FileExtname));case"fileBasename":return u.$oc(r(S.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=u.$oc(r(S.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-u.$pc(f).length)}case"fileDirnameBasename":return u.$oc(u.$nc(r(S.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||v}case"execInstallFolder":{const f=this.a.getAppRoot();return f||v}case"pathSeparator":case"/":return u.sep;default:try{const f=n?`${a}:${n}`:a;return this.p(S.VariableKind.Unknown,v,f,o,void 0)}catch{return v}}}}p(E,v,a,m,o){if(a&&m){const n=o===void 0?m[a]:m[o+":"+a];if(typeof n=="string")return n;throw new S.$ZP(E,(0,b.localize)(14,null,v))}return v}}e.$cQ=P}),define(ke[146],Ee([1,0,5,142]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$ID=void 0,e.$JD=S,e.$KD=$,e.$LD=E,e.$ID=(0,u.$qi)("editorGroupsService");var L;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var R;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var M;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var p;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var b;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function S(v){const a=v;return(0,N.$tF)(a?.editor)&&(0,N.$tF)(a?.replacement)}var A;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var P;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function $(v){const a=v;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function E(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[303],Ee([1,0,5,146]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PD=e.$OD=e.$ND=e.$MD=void 0,e.$QD=L,e.$MD=(0,u.$qi)("editorService"),e.$ND=-1,e.$OD=-2,e.$PD=-3;function L(R){const M=R;return typeof R=="number"||(0,N.$KD)(M)}}),define(ke[147],Ee([1,0,5,136]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=void 0,e.$aM=(0,u.$ri)(N.$xi)}),define(ke[148],Ee([1,0,25,4,17,3,7]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$b=e.$E$b=e.$D$b=e.$C$b=e.$B$b=void 0;class p{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$B$b=p;class b{static isHostExtension(n,i,r){if(i.getExtensionDescription(n))return!1;const s=r.getExtensionDescription(n);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(n,i){this.j=n,this.c=new N.$be,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(a),this.f=new u.$Nm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=m(this.e,i),this.e=this.e.concat(n);const r=b.l(this.e);return this.e=m(this.e,r.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,r)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const c=i.getArcs(d);for(let h=0;h<c.length;h++)if(!l.has(c[h]))return!1;return!0}getNodes(){return this.e}},r=new u.$Nm;for(const d of n)if(r.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)i.addArc(u.$Lm.toKey(d.identifier),u.$Lm.toKey(l));const s=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>s.add(d));const t=i.getNodes().filter(d=>!s.has(d));let f;do{f=!1;for(let d=0;d<t.length;d++){const l=t[d];i.hasOnlyGoodArcs(l,s)&&(t.splice(d,1),d--,s.add(l),f=!0)}}while(f);return t.map(d=>r.get(d))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new S(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$C$b=b;class S{constructor(n,i){this.versionId=n,this.extensions=i}}e.$D$b=S;class A{constructor(n){this.d=new E,this.c=new b(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new P(this,i)}deltaExtensions(n,i,r){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$E$b=A;class P extends R.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$F$b=P;class ${constructor(n){this.name=n;const i=(0,M.$jh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class E{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new $(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};n.resolve((0,R.$Sc)(s))}}var v;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(v||(v={}));function a(o,n){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,r=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==r)return i-r;const s=L.$hc.basename(o.extensionLocation.path),t=L.$hc.basename(n.extensionLocation.path);return s<t?-1:s>t?1:0}function m(o,n){const i=new u.$Mm(n);return o.filter(r=>!i.has(r.identifier))}}),define(ke[304],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=e.ExtHostConnectionType=void 0,e.$hn=p,e.$in=b;var u;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(u||(e.ExtHostConnectionType=u={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[N.ENV_KEY]=this.pipeName}}e.$en=N;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[L.ENV_KEY]="1"}}e.$fn=L;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[R.ENV_KEY]="1"}}e.$gn=R;function M(A){delete A[N.ENV_KEY],delete A[L.ENV_KEY],delete A[R.ENV_KEY]}function p(A,P){M(P),A.serialize(P)}function b(A){if(A[N.ENV_KEY])return S(A,new N(A[N.ENV_KEY]));if(A[L.ENV_KEY])return S(A,new L);if(A[R.ENV_KEY])return S(A,new R);throw new Error("No connection information defined in environment!")}function S(A,P){return M(A),P}}),define(ke[114],Ee([1,0,21]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Tm=M,e.$Um=p;var N;(function(S){S[S.Desktop=1]="Desktop",S[S.Web=2]="Web"})(N||(e.UIKind=N={}));var L;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var R;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function M(S){const A=u.$Ce.alloc(1);switch(S){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function p(S,A){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var b;(function(S){S.Start="START_NATIVE_LOG",S.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(ke[90],Ee([1,0,5,4,12,28,114,86,87,24,2,3,226]),function(le,e,u,N,L,R,M,p,b,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uP=e.$sP=e.$rP=void 0,e.$tP=a;let E=class extends P.$Uc{constructor(o,n){super(),this.s=o,this.t=n,this.a=this.B(new N.$be),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$be),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:b.$ep,name:(0,$.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,L.$Yj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,n,i){const r=this.getTelemetryDetails(),s=new v(n,i,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(o,n,i){this.f=o,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const n=Object.create(null);switch(n["common.extname"]=`${o.publisher}.${o.name}`,n["common.extversion"]=o.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$Cm)((0,b.$kp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const n=this.getTelemetryDetails();this.r.forEach((i,r)=>{const s=i.filter(t=>!t.isDisposed);s.length===0?this.r.delete(r):this.r.set(r,s)}),this.r.forEach(i=>{for(const r of i)r.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,n){const r=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(o.value),!1;let s=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(n),s=!0);return s}};e.$rP=E,e.$rP=E=Je([qe(0,R.$qP),qe(1,L.$Xj)],E);class v{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,n,i,r,s,t,f){this.g=i,this.h=r,this.i=s,this.j=t,this.a=new N.$be,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(o,n){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let n="properties"in o?o.properties??{}:o;return n=(0,b.$np)(n,[]),this.c&&(n=(0,S.$Zn)(n,this.c)),this.b||(n=(0,S.$Zn)(n,this.j)),"properties"in o?o.properties=n:o=n,o}k(o,n){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(o,n),this.h.trace(o,n))}logUsage(o,n){this.d.isUsageEnabled&&this.k(o,n)}logError(o,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,n);else{const i={name:o.name,message:o.message,stack:o.stack,cause:o.cause},r=(0,b.$np)(i,[]),s=new Error(r.message,{cause:r.cause});s.stack=r.stack,s.name=r.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(s,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const o=this,n={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$sP=v;function a(m){const o=Date.now()-new Date(m).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$uP=(0,u.$qi)("IExtHostTelemetry")}),define(ke[26],Ee([1,0,4,2,272,140,25,5]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DG=e.ActivationKind=e.$AG=e.$zG=e.$wG=e.ExtensionHostStartup=e.$vG=e.$uG=e.$tG=e.$sG=void 0,e.$xG=$,e.$yG=E,e.$BG=o,e.$CG=n,e.$sG=Object.freeze({identifier:new M.$Lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$tG="extensions.webWorker",e.$uG=(0,p.$qi)("extensionService");class b{constructor(s){this.dependency=s}}e.$vG=b;var S;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(S||(e.ExtensionHostStartup=S={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(s,t,f){this.c=s,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$dG.createActivationEventsMap(this.d)}}set(s,t,f){if(this.c>s)throw new Error(`ExtensionHostExtensions: invalid versionId ${s} (current: ${this.c})`);const d=[],l=[],c=[],h=[],g=P(this.d),D=P(t),w=(F,j)=>F.extensionLocation.toString()===j.extensionLocation.toString()||F.isBuiltin===j.isBuiltin||F.isUserBuiltin===j.isUserBuiltin||F.isUnderDevelopment===j.isUnderDevelopment;for(const F of this.d){const j=D.get(F.identifier);if(!j){d.push(F.identifier),g.delete(F.identifier);continue}if(!w(F,j)){d.push(F.identifier),g.delete(F.identifier);continue}}for(const F of t){const j=g.get(F.identifier);if(!j){l.push(F);continue}if(!w(j,F)){d.push(j.identifier),g.delete(j.identifier);continue}}const k=new M.$Mm(this.e),y=new M.$Mm(f);for(const F of this.e)y.has(F)||c.push(F);for(const F of f)k.has(F)||h.push(F);const C=R.$dG.createActivationEventsMap(l),I={versionId:s,toRemove:d,toAdd:l,addActivationEvents:C,myToRemove:c,myToAdd:h};return this.delta(I),I}delta(s){if(this.c>=s.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:d,myToAdd:l}=s,c=new M.$Mm(t),h=new M.$Mm(d);for(let g=0;g<this.d.length;g++)c.has(this.d[g].identifier)&&(this.d.splice(g,1),g--);for(let g=0;g<this.e.length;g++)h.has(this.e[g])&&(this.e.splice(g,1),g--);for(const g of f)this.d.push(g);for(const g of l)this.e.push(g);return this.f=null,s}containsExtension(s){for(const t of this.e)if(M.$Lm.equals(t,s))return!0;return!1}containsActivationEvent(s){return this.f||(this.f=this.g()),this.f.has(s)}g(){const s=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=R.$dG.readActivationEvents(t);for(const d of f)s.add(d)}return s}}e.$wG=A;function P(r){const s=new M.$Nm;for(const t of r)s.set(t.identifier,t);return s}function $(r,s){return r.enabledApiProposals?r.enabledApiProposals.includes(s):!1}function E(r,s){if(!$(r,s))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class v{constructor(s,t,f,d){this.codeLoadingTime=s,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=d}}e.$zG=v;class a{constructor(s,t){this.description=s,this.value=t}}e.$AG=a;var m;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,L.$tp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function n(r,s){return{identifier:new M.$Lm((0,L.$rp)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!s,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None,this.onWillStop=u.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activateById(s,t){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(s,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$DG=i}),define(ke[305],Ee([1,0,13,148,25,26,12,7]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkc=e.$Gkc=e.$Fkc=e.$Ekc=e.$Dkc=e.$Ckc=void 0;class b{static{this.NONE=new b(!1,-1,-1,-1)}constructor(o,n,i,r){this.startup=o,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=r}}e.$Ckc=b;class S{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,n){return o===-1||n===-1?-1:n-o}build(){return new b(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Dkc=S;class A{constructor(o,n,i,r,s,t){this.activationFailed=o,this.activationFailedError=n,this.activationTimes=i,this.module=r,this.exports=s,this.subscriptions=t}}e.$Ekc=A;class P extends A{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Fkc=P;class $ extends A{constructor(){super(!1,null,b.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Gkc=$;class E extends A{constructor(o){super(!0,o,b.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(o,n,i,r){this.g=r,this.a=o,this.b=n,this.c=i,this.d=new L.$Nm,this.f=Object.create(null)}dispose(){for(const[o,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const o=[];for(const[n,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const n=this.d.get(o);return!!(n&&n.value)}getActivatedExtension(o){const n=this.d.get(o);if(!n||!n.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return n.value}async activateByEvent(o,n){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(r=>({id:r.identifier,reason:{startup:n,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,n){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(o){const n=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const n=this.a.getExtensionDescription(o.id);if(!n){const s=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new E(s));return this.c.onExtensionActivationError(o.id,s,new R.$vG(o.id.value)),t}const i=[],r=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const s of r){if(this.m(s))continue;const t=this.d.get(s);if(t){i.push(t);continue}if(this.l(s)){i.push(this.j({id:this.b.getExtensionDescription(s).identifier,reason:o.reason}));continue}const f=this.a.getExtensionDescription(s);if(f){if(!f.main&&!f.browser)continue;i.push(this.j({id:f.identifier,reason:o.reason}));continue}const d=n.displayName||n.identifier.value,l=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${s}'`),c=this.k(o,n.displayName,[],new E(l));return this.c.onExtensionActivationError(n.identifier,l,new R.$vG(s)),c}return this.k(o,n.displayName,i,null)}k(o,n,i,r){const s=new a(o.id,n,o.reason,i,r,this.c,this.g);return this.d.set(o.id,s),s}l(o){return N.$C$b.isHostExtension(o,this.a,this.b)}m(o){const n=this.b.getExtensionDescription(o);return n?!n.main&&!n.browser:!1}};e.$Hkc=v,e.$Hkc=v=Je([qe(3,M.$Wj)],v);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,n,i,r,s,t,f){this.c=o,this.d=n,this.f=i,this.g=r,this.h=s,this.j=t,this.k=f,this.a=new p.$ph,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const n=this.g[o];if(n.value&&!n.value.activationFailed){this.g.splice(o,1),o--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new E(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const n=new Error;if(o&&o.name&&(n.name=o.name),o&&o.message?n.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(n.stack=o.stack),this.h=new E(n),this.b&&u.$4(o))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};a=Je([qe(6,M.$Wj)],a)}),define(ke[306],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[307],Ee([1,0,243,13,40,137,109,38,25,306,139,140]),function(le,e,u,N,L,R,M,p,b,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=void 0;const $=p.$9n.as(M.$0n.JSONContribution);class E{constructor(s,t,f){this.a=s,this.b=t,this.c=f}d(s,t){this.a({type:s,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(s){this.d(L.default.Error,s)}warn(s){this.d(L.default.Warning,s)}info(s){this.d(L.default.Info,s)}}e.$mG=E;class v{static a(s){const t=new b.$Mm;for(let f=0,d=s.length;f<d;f++)t.add(s[f].description.identifier);return t}static compute(s,t){if(!s||!s.length)return new v(t,[]);if(!t||!t.length)return new v([],s);const f=this.a(s),d=this.a(t),l=t.filter(h=>!f.has(h.description.identifier)),c=s.filter(h=>!d.has(h.description.identifier));return new v(l,c)}constructor(s,t){this.added=s,this.removed=t}}e.$nG=v;class a{constructor(s,t){this.name=s,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(s){if(this.a!==null)throw new Error("Handler already set!");this.a=s,this.d()}acceptUsers(s){this.c=v.compute(this.b,s),this.b=s,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(s){(0,N.$1)(s)}}}e.$oG=a;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$pG={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.$Km},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}},api:{markdownDescription:u.localize(15,null),type:"string",enum:["none"],enumDescriptions:[u.localize(16,null)]},activationEvents:{description:u.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:u.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:u.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(32,null)},{label:"onUri",body:"onUri",description:u.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(37,null)},{label:"onRenderer",description:u.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:u.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:u.localize(42,null)},{label:"*",description:u.localize(43,null),body:"*"}]}},badges:{type:"array",description:u.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(45,null)},href:{type:"string",description:u.localize(46,null)},description:{type:"string",description:u.localize(47,null)}}}},markdown:{type:"string",description:u.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$No}},extensionPack:{description:u.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$No}},extensionKind:{description:u.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(53,null)},{body:["workspace"],description:u.localize(54,null)},{body:["ui","workspace"],description:u.localize(55,null)},{body:["workspace","ui"],description:u.localize(56,null)},{body:[],description:u.localize(57,null)}]},capabilities:{description:u.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(61,null),u.localize(62,null),u.localize(63,null)]},description:{type:"string",markdownDescription:u.localize(64,null)}}},untrustedWorkspaces:{description:u.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(67,null),u.localize(68,null),u.localize(69,null)]},restrictedConfigurations:{description:u.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(71,null)}}}}},sponsor:{description:u.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(74,null),type:"string"},"vscode:uninstall":{description:u.localize(75,null),type:"string"}}},icon:{type:"string",description:u.localize(76,null)},l10n:{type:"string",description:u.localize(77,null)},pricing:{type:"string",markdownDescription:u.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(s){if(this.a.has(s.extensionPoint))throw new Error("Duplicate extension point: "+s.extensionPoint);const t=new a(s.extensionPoint,s.defaultExtensionKind);return this.a.set(s.extensionPoint,t),s.activationEventsGenerator&&P.$dG.register(s.extensionPoint,s.activationEventsGenerator),e.$pG.properties.contributes.properties[s.extensionPoint]=s.jsonSchema,$.registerSchema(o,e.$pG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$qG=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};p.$9n.add(i.ExtensionsRegistry,new n),e.$rG=p.$9n.as(i.ExtensionsRegistry),$.registerSchema(o,e.$pG),$.registerSchema(A.$ek,{properties:{extensionEnabledApiProposals:{description:u.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}}]}}}})}),define(ke[308],Ee([1,0,239,18,24,307,37,4]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UH=void 0;const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var S;(function($){function E(v,a,m){if(!v)return;const o=N.$4f(v.type)?v.type:void 0;if(!o||o.length===0){m.error(u.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const i of v.required)N.$4f(i)&&n.push(i);return{extensionId:a.value,taskType:o,required:n,properties:v.properties?L.$Wn(v.properties):{},when:v.when?M.$oj.deserialize(v.when):void 0}}$.from=E})(S||(S={}));const A=R.$rG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,E)=>{for(const v of $)v.type&&E.push(`onTaskType:${v.type}`)},jsonSchema:{description:u.localize(4,null),type:"array",items:b}});class P{constructor(){this.d=new p.$be,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,v)=>{A.setHandler((a,m)=>{this.c=void 0;try{for(const o of m.removed){const n=o.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of m.added){const n=o.value;for(const i of n){const r=S.from(i,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const v of this.all()){const a={type:"object",additionalProperties:!1};v.required.length>0&&(a.required=v.required.slice(0)),v.properties!==void 0?a.properties=L.$Wn(v.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[v.taskType]},E.push(a)}this.c={oneOf:E}}return this.c}}e.$UH=new P}),define(ke[309],Ee([1,0,240,18,23,24,37,308]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$5H=e.JsonSchemaVersion=e.ExecutionEngine=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$YH=e.ShellQuoting=e.$XH=e.$WH=e.$VH=void 0,e.$VH="settings",e.$WH=new M.$Hj("taskRunning",!1,u.localize(0,null)),e.$XH=u.localize2(2,"Tasks");var b;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(b||(e.ShellQuoting=b={})),e.$YH="$customized",function(O){function T(B){if(!B)return O.Strong;switch(B.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=T}(b||(e.ShellQuoting=b={}));var S;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(S||(e.CommandOptions=S={}));var A;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(A||(e.RevealKind=A={})),function(O){function T(B){switch(B.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=T}(A||(e.RevealKind=A={}));var P;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(O){function T(B){switch(B.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=T}(P||(e.RevealProblemKind=P={}));var $;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})($||(e.PanelKind=$={})),function(O){function T(B){switch(B.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=T}($||(e.PanelKind=$={}));var E;(function(O){O.defaults={echo:!0,reveal:A.Always,revealProblems:P.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var v;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(O){function T(W){switch(W.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=T;function B(W){switch(W){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=B}(v||(e.RuntimeType=v={}));var a;(function(O){function T(B){return N.$4f(B)?B:B.value}O.value=T})(a||(e.CommandString=a={}));var m;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function T(W){return W===O.Clean._id||W===O.Build._id||W===O.Rebuild._id||W===O.Test._id}O.is=T;function B(W){if(W!==void 0)return N.$4f(W)?T(W)?{_id:W,isDefault:!1}:void 0:W}O.from=B})(m||(e.TaskGroup=m={}));var o;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var n;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function T(B){switch(B){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=T})(n||(e.TaskSourceKind=n={}));var i;(function(O){O.parallel="parallel",O.sequence="sequence"})(i||(e.DependsOrder=i={}));var r;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var s;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class t{constructor(T,B,W,Z,x,X){this._label="",this._id=T,B&&(this._label=B),W&&(this.type=W),this.runOptions=Z,this.configurationProperties=x,this._source=X}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,B=!1){if(T===void 0)return!1;if(N.$4f(T))return T===this._label||T===this.configurationProperties.identifier||B&&T===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$ZH=t;class f extends t{constructor(T,B,W,Z,x,X,Y,ce){super(T,W,void 0,Y,ce,B),this.command={},this._source=B,this.hasDefinedMatchers=X,x&&(this.command=x)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case v.Shell:B="shell";break;case v.Process:B="process";break;case v.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(T){return T instanceof f}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.$YH,folder:T,id:B};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$1g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new f(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$1H=f;class d extends t{constructor(T,B,W,Z,x,X,Y){super(T,W,Z,X,Y,B),this._source=B,this.configures=x}static is(T){return T instanceof d}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$1g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.$YH,folder:T,id:B};return JSON.stringify(W)}}e.$2H=d;class l extends t{constructor(T,B,W,Z,x,X,Y,ce,ne){super(T,W,Z,ce,ne,B),this.defines=x,this.hasDefinedMatchers=Y,this.command=X,this.icon=ne.icon,this.hide=ne.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof l}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new l(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$3H=l;class c extends t{constructor(T,B,W,Z,x,X){super(T,W,Z,x,X,B),this._source=B}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new c(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$4H=c;var h;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(O){O._default=O.Terminal}(h||(e.ExecutionEngine=h={}));var g;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(g||(e.JsonSchemaVersion=g={}));class D{constructor(T){this.c=new Map;for(let B=0;B<T.length;B++)this.c.set(T[B].uri.toString(),B)}compare(T,B){const W=T.getWorkspaceFolder(),Z=B.getWorkspaceFolder();if(W&&Z){let x=this.c.get(W.uri.toString());x=x===void 0?0:x+1;let X=this.c.get(Z.uri.toString());return X=X===void 0?0:X+1,x===X?T._label.localeCompare(B._label):x-X}else return!W&&Z?-1:W&&!Z?1:0}}e.$5H=D;var w;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(w||(e.TaskEventKind=w={}));var k;(function(O){O.SingleRun="singleRun",O.Background="background"})(k||(e.TaskRunType=k={}));var y;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(O){function T(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?"background":"singleRun",group:ce.configurationProperties.group,__task:ce}}function B(ce,ne,$e){return{...T(ce),kind:"start",terminalId:ne,resolvedVariables:$e}}O.start=B;function W(ce,ne,$e){return{...T(ce),kind:"processStarted",terminalId:ne,processId:$e}}O.processStarted=W;function Z(ce,ne,$e){return{...T(ce),kind:"processEnded",terminalId:ne,exitCode:$e}}O.processEnded=Z;function x(ce,ne,$e){return{...T(ce),kind:"terminated",exitReason:$e,terminalId:ne}}O.terminated=x;function X(ce,ne,$e){return{...T(ne),kind:ce,terminalId:$e}}O.general=X;function Y(){return{kind:"changed"}}O.changed=Y})(C||(e.TaskEvent=C={}));var I;(function(O){function T(W){const Z=Object.keys(W).sort();let x="";for(const X of Z){let Y=W[X];Y instanceof Object?Y=T(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),x+=X+","+Y+","}return x}function B(W){const x={_key:T(W),type:W.taskType};return Object.assign(x,W),x}O.create=B})(I||(e.KeyedTaskIdentifier=I={}));var F;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection",O.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var j;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(O){function T(B,W){const Z=p.$UH.get(B.type);if(Z===void 0){const ce=R.$Wn(B);return delete ce._key,I.create(ce)}const x=Object.create(null);x.type=Z.taskType;const X=new Set;Z.required.forEach(ce=>X.add(ce));const Y=Z.properties;for(const ce of Object.keys(Y)){const ne=B[ce];if(ne!=null)x[ce]=ne;else if(X.has(ce)){const $e=Y[ce];if($e.default!==void 0)x[ce]=R.$Wn($e.default);else switch($e.type){case"boolean":x[ce]=!1;break;case"number":case"integer":x[ce]=0;break;case"string":x[ce]="";break;default:W.error(u.localize(1,null,JSON.stringify(B,void 0,0),ce));return}}}return I.create(x)}O.createTaskIdentifier=T})(z||(e.TaskDefinition=z={}))}),define(ke[310],Ee([1,0,13]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=e.$G$b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,p)=>{this.b=M,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,u.$1)(M))}then(M,p){return this.j().then(M,p)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$G$b=N;class L extends N{constructor(){super(),this.h=!0,this.i=new u.$5}}e.$H$b=L}),define(ke[48],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$jw=void 0,e.$kw=L,e.$lw=R;class u{static{this.count=0}constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++u.count}}e.$jw=u;const N=[];function L(p){const b=new u(p);return N[b.nid]=b,b}function R(p){return N[p].sid}class M{constructor(b){this.value=b}}e.$mw=M}),define(ke[6],Ee([1,0,48]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$OM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var L;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(L||(e.TabInputKind=L={}));var R;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var M;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var p;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var b;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var S;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(S||(e.NotebookEditorRevealType=S={}));var A;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class P{static{this.a=0}static mixin(m){return m._id=P.a++,m}}e.$OM=P;var $;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var E;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var v;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$PM={MainThreadAuthentication:(0,u.$kw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,u.$kw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,u.$kw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,u.$kw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,u.$kw)("MainThreadChatVariables"),MainThreadClipboard:(0,u.$kw)("MainThreadClipboard"),MainThreadCommands:(0,u.$kw)("MainThreadCommands"),MainThreadComments:(0,u.$kw)("MainThreadComments"),MainThreadConfiguration:(0,u.$kw)("MainThreadConfiguration"),MainThreadConsole:(0,u.$kw)("MainThreadConsole"),MainThreadDebugService:(0,u.$kw)("MainThreadDebugService"),MainThreadDecorations:(0,u.$kw)("MainThreadDecorations"),MainThreadDiagnostics:(0,u.$kw)("MainThreadDiagnostics"),MainThreadDialogs:(0,u.$kw)("MainThreadDiaglogs"),MainThreadDocuments:(0,u.$kw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,u.$kw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,u.$kw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,u.$kw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,u.$kw)("MainThreadEditorTabs"),MainThreadErrors:(0,u.$kw)("MainThreadErrors"),MainThreadTreeViews:(0,u.$kw)("MainThreadTreeViews"),MainThreadDownloadService:(0,u.$kw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,u.$kw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,u.$kw)("MainThreadLanguages"),MainThreadLogger:(0,u.$kw)("MainThreadLogger"),MainThreadMessageService:(0,u.$kw)("MainThreadMessageService"),MainThreadOutputService:(0,u.$kw)("MainThreadOutputService"),MainThreadProgress:(0,u.$kw)("MainThreadProgress"),MainThreadQuickDiff:(0,u.$kw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,u.$kw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,u.$kw)("MainThreadStatusBar"),MainThreadSecretState:(0,u.$kw)("MainThreadSecretState"),MainThreadStorage:(0,u.$kw)("MainThreadStorage"),MainThreadSpeech:(0,u.$kw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,u.$kw)("MainThreadTelemetry"),MainThreadTerminalService:(0,u.$kw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,u.$kw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,u.$kw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,u.$kw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,u.$kw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,u.$kw)("MainThreadCustomEditors"),MainThreadUrls:(0,u.$kw)("MainThreadUrls"),MainThreadUriOpeners:(0,u.$kw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,u.$kw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,u.$kw)("MainThreadWorkspace"),MainThreadFileSystem:(0,u.$kw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,u.$kw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,u.$kw)("MainThreadExtensionService"),MainThreadSCM:(0,u.$kw)("MainThreadSCM"),MainThreadSearch:(0,u.$kw)("MainThreadSearch"),MainThreadShare:(0,u.$kw)("MainThreadShare"),MainThreadTask:(0,u.$kw)("MainThreadTask"),MainThreadWindow:(0,u.$kw)("MainThreadWindow"),MainThreadLabelService:(0,u.$kw)("MainThreadLabelService"),MainThreadNotebook:(0,u.$kw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,u.$kw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,u.$kw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,u.$kw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,u.$kw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,u.$kw)("MainThreadInteractive"),MainThreadInlineChat:(0,u.$kw)("MainThreadInlineChatShape"),MainThreadTheming:(0,u.$kw)("MainThreadTheming"),MainThreadTunnelService:(0,u.$kw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,u.$kw)("MainThreadManagedSockets"),MainThreadTimeline:(0,u.$kw)("MainThreadTimeline"),MainThreadTesting:(0,u.$kw)("MainThreadTesting"),MainThreadLocalization:(0,u.$kw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,u.$kw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,u.$kw)("MainThreadAiEmbeddingVector")},e.$QM={ExtHostCommands:(0,u.$kw)("ExtHostCommands"),ExtHostConfiguration:(0,u.$kw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,u.$kw)("ExtHostDiagnostics"),ExtHostDebugService:(0,u.$kw)("ExtHostDebugService"),ExtHostDecorations:(0,u.$kw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,u.$kw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,u.$kw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,u.$kw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,u.$kw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,u.$kw)("ExtHostEditors"),ExtHostTreeViews:(0,u.$kw)("ExtHostTreeViews"),ExtHostFileSystem:(0,u.$kw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,u.$kw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,u.$kw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,u.$kw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,u.$kw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,u.$kw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,u.$kw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,u.$kw)("ExtHostStatusBar"),ExtHostShare:(0,u.$kw)("ExtHostShare"),ExtHostExtensionService:(0,u.$kw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,u.$kw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,u.$kw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,u.$kw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,u.$kw)("ExtHostSCM"),ExtHostSearch:(0,u.$kw)("ExtHostSearch"),ExtHostTask:(0,u.$kw)("ExtHostTask"),ExtHostWorkspace:(0,u.$kw)("ExtHostWorkspace"),ExtHostWindow:(0,u.$kw)("ExtHostWindow"),ExtHostWebviews:(0,u.$kw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,u.$kw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,u.$kw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,u.$kw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,u.$kw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,u.$kw)("ExtHostEditorTabs"),ExtHostProgress:(0,u.$kw)("ExtHostProgress"),ExtHostComments:(0,u.$kw)("ExtHostComments"),ExtHostSecretState:(0,u.$kw)("ExtHostSecretState"),ExtHostStorage:(0,u.$kw)("ExtHostStorage"),ExtHostUrls:(0,u.$kw)("ExtHostUrls"),ExtHostUriOpeners:(0,u.$kw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,u.$kw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,u.$kw)("ExtHostOutputService"),ExtHostLabelService:(0,u.$kw)("ExtHostLabelService"),ExtHostNotebook:(0,u.$kw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,u.$kw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,u.$kw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,u.$kw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,u.$kw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,u.$kw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,u.$kw)("ExtHostInteractive"),ExtHostInlineChat:(0,u.$kw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,u.$kw)("ExtHostChatAgents"),ExtHostChatVariables:(0,u.$kw)("ExtHostChatVariables"),ExtHostChatProvider:(0,u.$kw)("ExtHostChatProvider"),ExtHostSpeech:(0,u.$kw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,u.$kw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,u.$kw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,u.$kw)("ExtHostTheming"),ExtHostTunnelService:(0,u.$kw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,u.$kw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,u.$kw)("ExtHostAuthentication"),ExtHostTimeline:(0,u.$kw)("ExtHostTimeline"),ExtHostTesting:(0,u.$kw)("ExtHostTesting"),ExtHostTelemetry:(0,u.$kw)("ExtHostTelemetry"),ExtHostLocalization:(0,u.$kw)("ExtHostLocalization")}}),define(ke[91],Ee([1,0,5,12,6,20]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4jc=e.$3jc=e.$2jc=void 0,e.$2jc=(0,u.$qi)("IExtHostApiDeprecationService");let M=class{constructor(b,S){this.c=S,this.a=new Set,this.b=b.getProxy(L.$PM.MainThreadTelemetry)}report(b,S,A){const P=this.d(b,S);this.a.has(P)||(this.a.add(P),S.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${b}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:S.identifier.value,apiId:b}))}d(b,S){return`${b}-${S.identifier.value}`}};e.$3jc=M,e.$3jc=M=Je([qe(0,R.$aP),qe(1,N.$Wj)],M),e.$4jc=Object.freeze(new class{report(p,b,S){}})}),define(ke[311],Ee([1,0,6]),function(le,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class N{constructor(R){const M=R.getProxy(u.$PM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(p){return M.$writeText(p)}})}}e.$ekc=N}),define(ke[312],Ee([1,0,24,6,28,20]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;let M=class{constructor(A,P){this.a=A.getProxy(N.$PM.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,P){const $=this,E=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){$.e(A,P,E,arguments)}})}e(A,P,$,E){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:b(E,this.b)}),this.c&&this.f(A,$,E)}};e.$$lc=M,e.$$lc=M=Je([qe(0,R.$aP),qe(1,L.$qP)],M);const p=1e5;function b(S,A){const P=[];if(S.length)for(let $=0;$<S.length;$++){let E=S[$];if(typeof E>"u")E="undefined";else if(E instanceof Error){const v=E;v.stack?E=v.stack:E=v.toString()}P.push(E)}if(A){const $=new Error().stack;$&&P.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,u.$2n)(P);return $.length>p?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(ke[313],Ee([1,0,2,6,26]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=void 0;class R{constructor(p){this.a=p.getProxy(N.$PM.MainThreadDialogs)}showOpenDialog(p,b){return b?.allowUIResources&&(0,L.$yG)(p,"showLocal"),this.a.$showOpenDialog(b).then(S=>S?S.map(A=>u.URI.revive(A)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(b=>b?u.URI.revive(b):void 0)}}e.$blc=R}),define(ke[314],Ee([1,0,3,6]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;class L{constructor(M){this.b=0,this.a=M.getProxy(N.$PM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,M),(0,u.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$vlc=L}),define(ke[115],Ee([1,0,11,14,2,5,12,6,28,20]),function(le,e,u,N,L,R,M,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=e.$Vkc=void 0;let A=class{constructor($,E,v){this.f=v,this.d=new Map,this.a=E.getProxy(p.$PM.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===u.$g}getMessage($,E){const{message:v,args:a,comment:m}=E;if(this.c)return(0,N.$5e)(v,a??{});let o=v;m&&m.length>0&&(o+=`/${Array.isArray(m)?m.join(""):m}`);const n=this.d.get($)?.contents[o];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,N.$5e)(n??v,a??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let E;const v=await this.g($);if(!v){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(v),m=JSON.parse(a);E=$.isBuiltin?m.contents?.bundle:m}catch(a){this.f.error(`Failed to load translations for ${$.identifier.value} from ${v}: ${a.message}`);return}E&&this.d.set($.identifier.value,{contents:E,uri:v})}async g($){if($.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return L.URI.revive(E)}return $.l10n?L.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Vkc=A,e.$Vkc=A=Je([qe(0,b.$qP),qe(1,S.$aP),qe(2,M.$Wj)],A),e.$Wkc=(0,R.$qi)("IExtHostLocalizationService")}),define(ke[149],Ee([1,0,12,6,28,20,2,58]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;let b=class extends u.$8j{constructor(P,$){super($.logLevel,$.logsLocation,$.loggers.map(E=>(0,p.$Zh)(E))),this.r=P.getProxy(N.$PM.MainThreadLogger)}$setLogLevel(P,$){$?this.setLogLevel(M.URI.revive($),P):this.setLogLevel(P)}setVisibility(P,$){super.setVisibility(P,$),this.r.$setVisibility(P,$)}s(P,$,E){return new S(this.r,P,$,E)}};e.$0lc=b,e.$0lc=b=Je([qe(0,R.$aP),qe(1,L.$qP)],b);class S extends u.$3j{constructor(P,$,E,v){super(v?.logLevel==="always"),this.r=P,this.s=$,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger($,v).then(()=>{this.u(this.n),this.m=!0})}g(P,$){const E=[[P,$]];this.m?this.u(E):this.n.push(...E)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Ee([1,0,6,5,3,20,21]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ykc=e.$Xkc=void 0,e.$Xkc=(0,N.$qi)("IExtHostManagedSockets");let p=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(u.$PM.MainThreadManagedSockets)}setFactory(P,$){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new b(P,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const $=++this.b,E=await this.c.makeConnection(),v=new L.$Tc;return this.d.set($,new S($,E,v)),v.add((0,L.$Sc)(()=>this.d.delete($))),v.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),v.dispose()})),v.add(E.onDidClose(a=>{this.a.$onDidManagedSocketClose($,a?.stack??a?.message),v.dispose()})),v.add(E.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData($,M.$Ce.wrap(a)))),$}$remoteSocketWrite(P,$){this.d.get(P)?.actual.send($.buffer)}$remoteSocketEnd(P){const $=this.d.get(P);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$Ykc=p,e.$Ykc=p=Je([qe(0,R.$aP)],p);class b{constructor(P,$){this.socketFactoryId=P,this.makeConnection=$}}class S extends L.$Uc{constructor(P,$,E){super(),this.socketId=P,this.actual=$,this.B(E)}}}),define(ke[315],Ee([1,0,6,12,26]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;function R(p){return p&&p.title}let M=class{constructor(b,S){this.b=S,this.a=b.getProxy(u.$PM.MainThreadMessageService)}showMessage(b,S,A,P,$){const E={source:{identifier:b.identifier,label:b.displayName||b.name}};let v;typeof P=="string"||R(P)?v=[P,...$]:(E.modal=P?.modal,E.useCustom=P?.useCustom,E.detail=P?.detail,v=$),E.useCustom&&(0,L.$yG)(b,"resolvers");const a=[];let m=!1;for(let o=0;o<v.length;o++){const n=v[o];if(typeof n=="string")a.push({title:n,handle:o,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:r}=n;a.push({title:i,isCloseAffordance:!!r,handle:o}),r&&(m?this.b.warn(`[${b.identifier}] Only one message item can have 'isCloseAffordance':`,n):m=!0)}else this.b.warn(`[${b.identifier}] Invalid message item:`,n)}return this.a.$showMessage(S,A,E,a).then(o=>{if(typeof o=="number")return v[o]})}};e.$xlc=M,e.$xlc=M=Je([qe(1,N.$Wj)],M)}),define(ke[316],Ee([1,0,3,18,2,26,6]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=void 0;class p{constructor(S){this.b=new Map,this.a=S.getProxy(M.$PM.MainThreadProfileContentHandlers)}registerProfileContentHandler(S,A,P){if((0,R.$yG)(S,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,P),this.a.$registerProfileContentHandler(A,P.name,P.description,S.identifier.value),(0,u.$Sc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(S,A,P,$){const E=this.b.get(S);if(!E)throw new Error(`Unknown handler with id: ${S}`);return E.saveProfile(A,P,$)}async $readProfile(S,A,P){const $=this.b.get(S);if(!$)throw new Error(`Unknown handler with id: ${S}`);return $.readProfile((0,N.$4f)(A)?A:L.URI.revive(A),P)}}e.$Glc=p}),define(ke[117],Ee([1,0,6,4,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=e.$Skc=void 0;class R{constructor(p){this.b=new N.$be,this.onDidChangePassword=this.b.event,this.a=p.getProxy(u.$PM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,b){return this.a.$getPassword(p,b)}store(p,b,S){return this.a.$setPassword(p,b,S)}delete(p,b){return this.a.$deletePassword(p,b)}}e.$Skc=R,e.$Tkc=(0,L.$qi)("IExtHostSecretState")}),define(ke[317],Ee([1,0,22,3,6]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=void 0;class R{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(L.$PM.MainThreadSpeech)}async $createSpeechToTextSession(p,b,S){const A=this.c.get(p);if(!A)return;const P=new N.$Tc,$=new u.$me;this.d.set(b,$);const E=P.add(A.provideSpeechToTextSession($.token,S?{language:S}:void 0));P.add(E.onDidChange(v=>{$.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(b,v)})),P.add($.token.onCancellationRequested(()=>P.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,b){const S=this.c.get(p);if(!S)return;const A=new N.$Tc,P=new u.$me;this.d.set(b,P);const $=A.add(S.provideKeywordRecognitionSession(P.token));A.add($.onDidChange(E=>{P.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(b,E)})),A.add(P.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,b,S){const A=R.a++;return this.c.set(A,S),this.b.$registerProvider(A,b,{extension:p,displayName:p.value}),(0,N.$Sc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Nlc=R}),define(ke[118],Ee([1,0,6,4,5]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=e.$Ikc=void 0;class R{constructor(p,b){this.c=b,this.b=new N.$be,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(u.$PM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,b){this.a.$registerExtensionStorageKeysToSync(p,b)}async initializeExtensionStorage(p,b,S){const A=await this.a.$initializeExtensionStorage(p,b);let P;return A&&(P=this.d(p,b,A)),P||S}setValue(p,b,S){return this.a.$setValue(p,b,S)}$acceptValue(p,b,S){const A=this.d(p,b,S);A&&this.b.fire({shared:p,key:b,value:A})}d(p,b,S){try{return JSON.parse(S)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${b}, global: ${p}): ${A}`)}}}e.$Ikc=R,e.$Jkc=(0,L.$qi)("IExtHostStorage")}),define(ke[318],Ee([1,0,3,15,2,6]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=void 0;class M{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor(b){this.c=new Map,this.b=b.getProxy(R.$PM.MainThreadUriOpeners)}registerExternalUriOpener(b,S,A,P){if(this.c.has(S))throw new Error(`Opener with id '${S}' already registered`);const $=P.schemes.find(E=>!M.a.has(E));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(S,A),this.b.$registerUriOpener(S,P.schemes,b,P.label),(0,u.$Sc)(()=>{this.c.delete(S),this.b.$unregisterUriOpener(S)})}async $canOpenUri(b,S,A){const P=this.c.get(b);if(!P)throw new Error(`Unknown opener with id: ${b}`);const $=L.URI.revive(S);return P.canOpenExternalUri($,A)}async $openUri(b,S,A){const P=this.c.get(b);if(!P)throw new Error(`Unknown opener id: '${b}'`);return P.openExternalUri(L.URI.revive(S.resolvedUri),{sourceUri:L.URI.revive(S.sourceUri)},A)}}e.$4lc=M}),define(ke[319],Ee([1,0,6,2,3,13,25]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0;class p{static{this.a=0}constructor(S){this.c=new M.$Mm,this.d=new Map,this.b=S.getProxy(u.$PM.MainThreadUrls)}registerUriHandler(S,A){const P=S.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const $=p.a++;return this.c.add(P),this.d.set($,A),this.b.$registerUriHandler($,P,S.displayName||S.name),(0,L.$Sc)(()=>{this.c.delete(P),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(S,A){const P=this.d.get(S);if(!P)return Promise.resolve(void 0);try{P.handleUri(N.URI.revive(A))}catch($){(0,R.$1)($)}return Promise.resolve(void 0)}async createAppUri(S){return N.URI.revive(await this.b.$createAppUri(S))}}e.$5lc=p}),define(ke[92],Ee([1,0,4,3,15,24,2,247,285,113,6]),function(le,e,u,N,L,R,M,p,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=e.$tkc=void 0,e.$ukc=$,e.$wkc=a,e.$xkc=m;class P{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,s,t,f,d,l,c){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new u.$be,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new u.$be,this._onDidDispose=this.#h.event,this.#e=r,this.#t=s,this.#o=t,this.#n=f,this.#s=d,this.#r=l,this.#l=$(l),this.#d=E(l),this.#i=c}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,S.$Gxb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===L.Schemas.https||r.scheme===L.Schemas.http){let s=r.toString();return s.endsWith("/")||(s+="/"),s+" "+S.$Fxb}return S.$Fxb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),R.$1n(this.#o,r)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const s=(0,b.$Xnb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,s.message,...s.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const s=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,d,l,c,h,g)=>{const D=M.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),w=(0,S.$Gxb)(D,{isRemote:s,authority:t}).toString();return`${d}${w}${g}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,d,l,c,h,g)=>{const D=M.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),w=(0,S.$Gxb)(D,{isRemote:s,authority:t}).toString();return`${d}${w}${g}`})}}e.$tkc=P;function $(i){try{const r=(0,p.$Cp)((0,p.$Bp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function E(i){try{const r=(0,p.$Cp)((0,p.$Bp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class v extends N.$Uc{constructor(r,s,t,f,d){super(),this.c=s,this.f=t,this.g=f,this.h=d,this.b=new Map,this.a=r.getProxy(A.$PM.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,s,t){const f=this.j(r);if(f){const{message:d}=(0,b.$Ynb)(s,t.value);f._onMessageEmitter.fire(d)}}$onMissingCsp(r,s){this.g.warn(`${s} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,s,t){const f=new P(r,this.a,o(s),this.c,this.f,t,this.h);this.b.set(r,f);const d=f._onDidDispose(()=>{d.dispose(),this.deleteWebview(r)});return f}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$vkc=v;function a(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,r,s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots||n(i,r)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>M.URI.from(r))}}function n(i,r){return[...(r?.getWorkspaceFolders()||[]).map(s=>s.uri),i.extensionLocation]}}),define(ke[150],Ee([1,0,4,6,2,15,14,5,20,26]),function(le,e,u,N,L,R,M,p,b,S){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=e.$7lc=void 0;let P=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(E){const v=this.d;return{get focused(){return v.focused},get active(){return(0,S.$yG)(E,"windowActivity"),v.active}}}constructor(E){this.c=new u.$be,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=E.getProxy(N.$PM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:a})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",a)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,v){v!==this.d[E]&&(this.d={...this.d,[E]:v},this.c.fire(this.d))}openUri(E,v){let a;if(typeof E=="string"){a=E;try{E=L.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,M.$3e)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,a,v)}async asExternalUri(E,v){if((0,M.$3e)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const a=await this.b.$asExternalUri(E,v);return L.URI.from(a)}};e.$7lc=P,e.$7lc=P=A=Je([qe(0,b.$aP)],P),e.$8lc=(0,p.$qi)("IExtHostWindow")}),define(ke[320],Ee([1,0,312,28,20]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jmc=void 0;const R=1024*1024;let M=class extends u.$$lc{constructor(b,S){super(b,S),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(b,S,A){const P=b==="error"||b==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),S.apply(console,A),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(b,S){const A=process[b],P=A.write;let $="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(E,v,a)=>{if(!this.g){$+=E.toString(v);const m=$.length>R?$.length:$.lastIndexOf(`
`);m!==-1&&(console[S]($.slice(0,m)),$=$.slice(m+1))}P.call(A,E,v,a)}})}};e.$Jmc=M,e.$Jmc=M=Je([qe(0,L.$aP),qe(1,N.$qP)],M)}),define(ke[321],Ee([1,0,149,15,262,30]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=void 0;class M extends u.$0lc{s(b,S,A){return b.scheme===N.Schemas.file?new L.$nQ(A?.name||(0,R.$Mg)(),b.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,S):super.s(b,S,A)}registerLogger(b){super.registerLogger(b),this.r.$registerLogger(b)}deregisterLogger(b){super.deregisterLogger(b),this.r.$deregisterLogger(b)}}e.$Vmc=M}),define(ke[322],Ee([1,0,7,21,22,13,4,3,133,310,48]),function(le,e,u,N,L,R,M,p,b,S,A){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$I$b=m,e.$J$b=o;function $(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const E="$$ref$$",v={[E]:-1};class a{constructor(C,I){this.jsonString=C,this.referencedBuffers=I}}function m(y,C=null,I=!1){const F=[];return{jsonString:(I?$:JSON.stringify)(y,(z,O)=>{if(typeof O>"u")return v;if(typeof O=="object"){if(O instanceof N.$Ce){const T=F.push(O)-1;return{[E]:T}}if(C)return C(z,O)}return O}),referencedBuffers:F}}function o(y,C,I){return JSON.parse(y,(F,j)=>{if(j){const z=j[E];if(typeof z=="number")return C[z];if(I&&j.$mid===1)return I.transformIncoming(j)}return j})}function n(y,C){return JSON.stringify(y,C)}function i(y){return y?(C,I)=>I&&I.$mid===1?y.transformOutgoing(I):I:null}var r;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var s;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const t=()=>{},f=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class l extends p.$Uc{static{P=f}static{this.a=3*1e3}constructor(C,I=null,F=null){super(),this[P]=!0,this.b=this.B(new M.$be),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=I,this.g=F,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,z=A.$jw.count;j<z;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new u.$Ch(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const I=this.w[C];delete this.w[C],I.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,b.$vn)(C,this.g):C}getProxy(C){const{nid:I,sid:F}=C;return this.s[I]||(this.s[I]=this.J(I,F)),this.s[I]}J(C,I){const F={get:(j,z)=>(typeof z=="string"&&!j[z]&&z.charCodeAt(0)===36&&(j[z]=(...O)=>this.U(C,z,O)),z===d?I:j[z])};return new Proxy(Object.create(null),F)}set(C,I){return this.m[C.nid]=I,I}assertRegistered(C){for(let I=0,F=C.length;I<F;I++){const j=C[I];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(C){if(this.j)return;const I=C.byteLength,F=h.read(C,0),j=F.readUInt8(),z=F.readUInt32();switch(j){case 1:case 2:{let{rpcId:O,method:T,args:B}=D.deserializeRequestJSONArgs(F);this.g&&(B=(0,b.$vn)(B,this.g)),this.M(I,z,O,T,B,j===2);break}case 3:case 4:{let{rpcId:O,method:T,args:B}=D.deserializeRequestMixedArgs(F);this.g&&(B=(0,b.$vn)(B,this.g)),this.M(I,z,O,T,B,j===4);break}case 5:{this.f?.logIncoming(I,z,0,"ack"),this.G(z);break}case 6:{this.N(I,z);break}case 7:{this.O(I,z,void 0);break}case 9:{let O=D.deserializeReplyOKJSON(F);this.g&&(O=(0,b.$vn)(O,this.g)),this.O(I,z,O);break}case 10:{const O=D.deserializeReplyOKJSONWithBuffers(F,this.g);this.O(I,z,O);break}case 8:{const O=D.deserializeReplyOKVSBuffer(F);this.O(I,z,O);break}case 11:{let O=D.deserializeReplyErrError(F);this.g&&(O=(0,b.$vn)(O,this.g)),this.P(I,z,O);break}case 12:{this.P(I,z,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,I,F,j,z,O){this.f?.logIncoming(C,I,1,`receiveRequest ${(0,A.$lw)(F)}.${j}(`,z);const T=String(I);let B,W;if(O){const x=new L.$me;z.push(x.token),B=this.Q(F,j,z),W=()=>x.cancel()}else B=this.Q(F,j,z),W=t;this.u[T]=W;const Z=D.serializeAcknowledged(I);this.f?.logOutgoing(Z.byteLength,I,1,"ack"),this.c.send(Z),B.then(x=>{delete this.u[T];const X=D.serializeReplyOK(I,x,this.h);this.f?.logOutgoing(X.byteLength,I,1,"reply:",x),this.c.send(X)},x=>{delete this.u[T];const X=D.serializeReplyErr(I,x);this.f?.logOutgoing(X.byteLength,I,1,"replyErr:",x),this.c.send(X)})}N(C,I){this.f?.logIncoming(C,I,1,"receiveCancel");const F=String(I);this.u[F]?.()}O(C,I,F){this.f?.logIncoming(C,I,0,"receiveReply:",F);const j=String(I);if(!this.w.hasOwnProperty(j))return;const z=this.w[j];delete this.w[j],z.resolveOk(F)}P(C,I,F){this.f?.logIncoming(C,I,0,"receiveReplyErr:",F);const j=String(I);if(!this.w.hasOwnProperty(j))return;const z=this.w[j];delete this.w[j];let O;F&&(F.$isError?(O=new Error,O.name=F.name,O.message=F.message,O.stack=F.stack):O=F),z.resolveErr(O)}Q(C,I,F){try{return Promise.resolve(this.S(C,I,F))}catch(j){return Promise.reject(j)}}S(C,I,F){const j=this.m[C];if(!j)throw new Error("Unknown actor "+(0,A.$lw)(C));const z=j[I];if(typeof z!="function")throw new Error("Unknown method "+I+" on actor "+(0,A.$lw)(C));return z.apply(j,F)}U(C,I,F){if(this.j)return new S.$H$b;let j=null;if(F.length>0&&L.CancellationToken.isCancellationToken(F[F.length-1])&&(j=F.pop()),j&&j.isCancellationRequested)return Promise.reject(R.$6());const z=D.serializeRequestArguments(F,this.h),O=++this.t,T=String(O),B=new S.$G$b,W=new p.$Tc;j&&W.add(j.onCancellationRequested(()=>{const x=D.serializeCancel(O);this.f?.logOutgoing(x.byteLength,O,0,"cancel"),this.c.send(D.serializeCancel(O))})),this.w[T]=new c(B,W),this.F(O);const Z=D.serializeRequest(O,C,I,z,!!j);return this.f?.logOutgoing(Z.byteLength,O,0,`request: ${(0,A.$lw)(C)}.${I}(`,F),this.c.send(Z),B}}e.$K$b=l;class c{constructor(C,I){this.a=C,this.b=I}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class h{static alloc(C,I,F){const j=new h(N.$Ce.alloc(F+1+4),0);return j.writeUInt8(C),j.writeUInt32(I),j}static read(C,I){return new h(C,I)}get buffer(){return this.a}constructor(C,I){this.a=C,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const F=this.a.slice(this.b,this.b+C).toString();return this.b+=C,F}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+C).toString();return this.b+=C,F}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+C);return this.b+=C,I}static sizeMixedArray(C){let I=0;I+=1;for(let F=0,j=C.length;F<j;F++){const z=C[F];switch(I+=1,z.type){case 1:I+=this.sizeLongString(z.value);break;case 2:I+=this.sizeVSBuffer(z.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(z.value);for(let O=0;O<z.buffers.length;++O)I+=this.sizeVSBuffer(z.buffers[O]);break;case 4:break}}return I}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let I=0,F=C.length;I<F;I++){const j=C[I];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let z=0;z<j.buffers.length;++z)this.writeBuffer(j.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const I=new Array(C);for(let F=0;F<C;F++)switch(this.readUInt8()){case 1:I[F]=this.readLongString();break;case 2:I[F]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),O=this.readLongString(),T=[];for(let B=0;B<z;++B)T.push(this.readVSBuffer());I[F]=new A.$mw(o(O,T,null));break}case 4:I[F]=void 0;break}return I}}var g;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(g||(g={}));class D{static a(C){for(let I=0,F=C.length;I<F;I++)if(C[I]instanceof N.$Ce||C[I]instanceof A.$mw||typeof C[I]>"u")return!0;return!1}static serializeRequestArguments(C,I){if(this.a(C)){const F=[];for(let j=0,z=C.length;j<z;j++){const O=C[j];if(O instanceof N.$Ce)F[j]={type:2,value:O};else if(typeof O>"u")F[j]={type:4};else if(O instanceof A.$mw){const{jsonString:T,referencedBuffers:B}=m(O.value,I);F[j]={type:3,value:N.$Ce.fromString(T),buffers:B}}else F[j]={type:1,value:N.$Ce.fromString(n(O,I))}}return{type:1,args:F}}return{type:0,args:n(C,I)}}static serializeRequest(C,I,F,j,z){switch(j.type){case 0:return this.b(C,I,F,j.args,z);case 1:return this.c(C,I,F,j.args,z)}}static b(C,I,F,j,z){const O=N.$Ce.fromString(F),T=N.$Ce.fromString(j);let B=0;B+=h.sizeUInt8(),B+=h.sizeShortString(O),B+=h.sizeLongString(T);const W=h.alloc(z?2:1,C,B);return W.writeUInt8(I),W.writeShortString(O),W.writeLongString(T),W.buffer}static deserializeRequestJSONArgs(C){const I=C.readUInt8(),F=C.readShortString(),j=C.readLongString();return{rpcId:I,method:F,args:JSON.parse(j)}}static c(C,I,F,j,z){const O=N.$Ce.fromString(F);let T=0;T+=h.sizeUInt8(),T+=h.sizeShortString(O),T+=h.sizeMixedArray(j);const B=h.alloc(z?4:3,C,T);return B.writeUInt8(I),B.writeShortString(O),B.writeMixedArray(j),B.buffer}static deserializeRequestMixedArgs(C){const I=C.readUInt8(),F=C.readShortString(),j=C.readMixedArray(),z=new Array(j.length);for(let O=0,T=j.length;O<T;O++){const B=j[O];typeof B=="string"?z[O]=JSON.parse(B):z[O]=B}return{rpcId:I,method:F,args:z}}static serializeAcknowledged(C){return h.alloc(5,C,0).buffer}static serializeCancel(C){return h.alloc(6,C,0).buffer}static serializeReplyOK(C,I,F){if(typeof I>"u")return this.d(C);if(I instanceof N.$Ce)return this.e(C,I);if(I instanceof A.$mw){const{jsonString:j,referencedBuffers:z}=m(I.value,F,!0);return this.g(C,j,z)}else return this.f(C,$(I,F))}static d(C){return h.alloc(7,C,0).buffer}static e(C,I){let F=0;F+=h.sizeVSBuffer(I);const j=h.alloc(8,C,F);return j.writeVSBuffer(I),j.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,I){const F=N.$Ce.fromString(I);let j=0;j+=h.sizeLongString(F);const z=h.alloc(9,C,j);return z.writeLongString(F),z.buffer}static g(C,I,F){const j=N.$Ce.fromString(I);let z=0;z+=h.sizeUInt32,z+=h.sizeLongString(j);for(const T of F)z+=h.sizeVSBuffer(T);const O=h.alloc(10,C,z);O.writeUInt32(F.length),O.writeLongString(j);for(const T of F)O.writeBuffer(T);return O.buffer}static deserializeReplyOKJSON(C){const I=C.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(C,I){const F=C.readUInt32(),j=C.readLongString(),z=[];for(let O=0;O<F;++O)z.push(C.readVSBuffer());return new A.$mw(o(j,z,I))}static serializeReplyErr(C,I){const F=I?$(R.$3(I),null):void 0;if(typeof F!="string")return this.h(C);const j=N.$Ce.fromString(F);let z=0;z+=h.sizeLongString(j);const O=h.alloc(11,C,z);return O.writeLongString(j),O.buffer}static deserializeReplyErrError(C){const I=C.readLongString();return JSON.parse(I)}static h(C){return h.alloc(12,C,0).buffer}}var w;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var k;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(k||(k={}))}),define(ke[323],Ee([1,0,21,27,15,84,5]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uK=e.$rK=void 0,e.$sK=A,e.$tK=P,e.$rK=(0,M.$qi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],b=new RegExp(`^[${p.join("")}]+`),S=7;function A(E){if(E.scheme!==L.Schemas.vscodeNotebookCell)return;const v=E.fragment.indexOf("s");if(v<0)return;const a=parseInt(E.fragment.substring(0,v).replace(b,""),S),m=(0,u.$Ve)(E.fragment.substring(v+1)).toString();if(!isNaN(a))return{handle:a,notebook:E.with({scheme:m,fragment:null})}}function P(E,v){const a=v.toString(S),o=`${a.length<p.length?p[a.length-1]:"z"}${a}s${(0,u.$We)(u.$Ce.fromString(E.scheme),!0,!0)}`;return E.with({scheme:L.Schemas.vscodeNotebookCell,fragment:o})}class ${constructor(){this.a=new N.$Bc}getNotebook(v){if(v.scheme===L.Schemas.vscodeNotebookCell){const a=A(v);if(a){const m=this.a.get(a.notebook);if(m)return m}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$uK=$,(0,R.$os)(e.$rK,$,1)}),define(ke[119],Ee([1,0,21,35,45,101,15,17,11,37,323]),function(le,e,u,N,L,R,M,p,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=e.CellStatusbarAlignment=e.$KK=e.NotebookEditorPriority=e.$HK=e.$GK=e.$EK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$DK=e.$CK=e.$BK=e.$AK=e.CellKind=e.$zK=e.$yK=e.$xK=void 0,e.$FK=f,e.$IK=l,e.$JK=c,e.$MK=D,e.$NK=k,e.$xK="workbench.editor.notebook",e.$yK="workbench.editor.notebookTextDiffEditor",e.$zK="workbench.editor.interactive";var P;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(P||(e.CellKind=P={})),e.$AK=["application/json","application/javascript","text/html","image/svg+xml",R.$Hs.latex,R.$Hs.markdown,"image/png","image/jpeg",R.$Hs.text],e.$BK=[R.$Hs.latex,R.$Hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Hs.text],e.$CK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$DK="_notAvailable";var $;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})($||(e.NotebookRunState=$={}));var E;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var v;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var a;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var o;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var n;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(B){B.scheme=M.Schemas.vscodeNotebookCell;function W(ne,$e){return(0,A.$tK)(ne,$e)}B.generate=W;function Z(ne){return(0,A.$sK)(ne)}B.parse=Z;function x(ne,$e){return ne.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${ne.scheme!==M.Schemas.file?ne.scheme:""}`})}B.generateCellOutputUri=x;function X(ne){if(ne.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ne.fragment);if(!$e)return;const Ce=$e[1]&&$e[1]!==""?$e[1]:void 0,ee=$e[2];return{outputId:Ce,notebook:ne.with({scheme:ee||M.Schemas.file,fragment:null})}}B.parseCellOutputUri=X;function Y(ne,$e,Ce){return B.generate(ne,$e).with({scheme:Ce})}B.generateCellPropertyUri=Y;function ce(ne,$e){if(ne.scheme===$e)return B.parse(ne.with({scheme:B.scheme}))}B.parseCellPropertyUri=ce})(r||(e.CellUri=r={}));const s=B=>b.$i?B.replace(/\//g,"\\"):B;class t{constructor(W=[],Z=e.$AK){this.e=Z,this.d=[...new Set(W)].map(x=>({pattern:x,matches:N.$kk(s(x))}))}sort(W){const Z=new Map(L.Iterable.map(W,X=>[X,s(X)]));let x=[];for(const{matches:X}of this.d)for(const[Y,ce]of Z)if(X(ce)){x.push(Y),Z.delete(Y);break}return Z.size&&(x=x.concat([...Z.keys()].sort((X,Y)=>this.e.indexOf(X)-this.e.indexOf(Y)))),x}prioritize(W,Z){const x=this.f(W);if(x===-1){this.d.unshift({pattern:W,matches:N.$kk(s(W))});return}const X=new Set(Z.map(ce=>this.f(ce,x)));X.delete(-1);const Y=Array.from(X).sort();this.d.splice(x+1,0,...Y.map(ce=>this.d[ce]));for(let ce=Y.length-1;ce>=0;ce--)this.d.splice(Y[ce],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,Z=this.d.length){const x=s(W);for(let X=0;X<Z;X++)if(this.d[X].matches(x))return X;return-1}}e.$EK=t;function f(B,W,Z,x=(X,Y)=>X===Y){const X=[];function Y($e,Ce,ee){if(Ce===0&&ee.length===0)return;const U=X[X.length-1];U&&U.start+U.deleteCount===$e?(U.deleteCount+=Ce,U.toInsert.push(...ee)):X.push({start:$e,deleteCount:Ce,toInsert:ee})}let ce=0,ne=0;for(;;){if(ce===B.length){Y(ce,0,W.slice(ne));break}if(ne===W.length){Y(ce,B.length-ce,[]);break}const $e=B[ce],Ce=W[ne];if(x($e,Ce)){ce+=1,ne+=1;continue}Z(Ce)?(Y(ce,1,[]),ce+=1):(Y(ce,0,[Ce]),ne+=1)}return X}e.$GK=new S.$Hj("notebookEditorCursorAtBoundary","none"),e.$HK=new S.$Hj("notebookEditorCursorAtLineBoundary","none");var d;(function(B){B.default="default",B.option="option"})(d||(e.NotebookEditorPriority=d={}));function l(B){const W=B;return!!((typeof W.include=="string"||N.$lk(W.include))&&(typeof W.exclude=="string"||N.$lk(W.exclude)))}function c(B,W,Z){if(Array.isArray(B.viewType)&&B.viewType.indexOf(W)>=0||B.viewType===W)return!0;if(B.filenamePattern){const x=l(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,X=l(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(N.$jk(x,(0,p.$oc)(Z.fsPath).toLowerCase()))return!(X&&N.$jk(X,(0,p.$oc)(Z.fsPath).toLowerCase()))}return!1}e.$KK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var h;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(h||(e.CellStatusbarAlignment=h={}));class g{static{this.d="notebook/"}static create(W){return`${g.d}${W}`}static parse(W){if(W.startsWith(g.d))return W.substring(g.d.length)}}e.$LK=g;function D(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const w=new TextDecoder;function k(B){const W=[];let Z=!1;for(const ce of B)(W.length===0||Z)&&(W.push(ce),Z=!0);let x=I(W);const X=u.$Ce.concat(W.map(ce=>u.$Ce.wrap(ce))),Y=T(X);return x=x||Y.byteLength!==X.byteLength,{data:Y,didCompression:x}}e.$OK="\x1B[A";const y=e.$OK.split("").map(B=>B.charCodeAt(0)),C=10;function I(B){let W=!1;return B.forEach((Z,x)=>{if(x===0||Z.length<e.$OK.length)return;const X=B[x-1],Y=Z.subarray(0,e.$OK.length);if(Y[0]===y[0]&&Y[1]===y[1]&&Y[2]===y[2]){const ce=X.lastIndexOf(C);if(ce===-1)return;W=!0,B[x-1]=X.subarray(0,ce),B[x]=Z.subarray(e.$OK.length)}}),W}function F(B){let W=B;do B=W,W=B.replace(/[^\n]\x08/gm,"");while(W.length<B.length);return B}function j(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const W=B.match(/^(.*)\r+/m)[1];let Z=B.match(/\r+(.*)$/m)[1];Z=Z+W.slice(Z.length,W.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Z)}return B}const z=8,O=13;function T(B){return!B.buffer.includes(z)&&!B.buffer.includes(O)?B:u.$Ce.fromString(j(F(w.decode(B.buffer))))}}),define(ke[8],Ee([1,0,19,13,80,27,101,14,18,2,30,25,32,66,119]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v){"use strict";var a,m,o,n,i,r,s,t,f,d,l,c,h,g,D,w,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$1O=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$ZO=e.$YO=e.$XO=e.$WO=e.ChatLocation=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$MO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$zO=e.$yO=e.$xO=e.$wO=e.$uO=e.$tO=e.$sO=e.$rO=e.TestRunProfileKind=e.TestResultState=e.$qO=e.$pO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$oO=e.NotebookVariablesRequestKind=e.$nO=e.$mO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$lO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.ColorThemeKind=e.$fO=e.$eO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$dO=e.$cO=e.DebugConsoleMode=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$9N=e.$8N=e.FileChangeType=e.$7N=e.NewSymbolNameTag=e.$6N=e.$5N=e.$4N=e.$3N=e.InlineCompletionTriggerKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$PN=e.ConfigurationTarget=e.$ON=e.$NN=e.$MN=e.$LN=e.DocumentPasteTriggerKind=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$EN=e.ViewBadge=e.ProgressLocation=e.$DN=e.$CN=e.TaskScope=e.ShellQuoting=e.$BN=e.$AN=e.$zN=e.TaskPanelKind=e.TaskRevealKind=e.$yN=e.TerminalLocation=e.$xN=e.$wN=e.$vN=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$uN=e.$tN=e.$sN=e.$rN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$pN=e.$oN=e.$nN=e.$mN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$lN=e.$kN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.LanguageStatusSeverity=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.CodeActionTriggerKind=e.$$M=e.$0M=e.SymbolTag=e.SymbolKind=e.$9M=e.$8M=e.DocumentHighlightKind=e.$7M=e.$6M=e.$5M=e.$4M=e.DiagnosticSeverity=e.DiagnosticTag=e.$3M=e.$2M=e.FileEditType=e.$1M=e.$ZM=e.$YM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$qN=lt,e.$QN=ye,e.$vO=yt;function y(H){return Object.assign(H,{apply:function(...me){if(me.length===0)return Reflect.construct(H,[]);{const Te=me.length===1?[]:me[1];return Reflect.construct(H,Te,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(H,[]);{const[Te,...Ye]=me;return Reflect.construct(H,Ye,Te.constructor)}}})}var C;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var I;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let F=a=class{static from(...K){let me=K;return new a(function(){if(me){for(const Te of me)Te&&typeof Te.dispose=="function"&&Te.dispose();me=void 0}})}#e;constructor(K){this.#e=K}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$RM=F,e.$RM=F=a=Je([y],F);let j=m=class{static Min(...K){if(K.length===0)throw new TypeError;let me=K[0];for(let Te=1;Te<K.length;Te++){const Ye=K[Te];Ye.isBefore(me)&&(me=Ye)}return me}static Max(...K){if(K.length===0)throw new TypeError;let me=K[0];for(let Te=1;Te<K.length;Te++){const Ye=K[Te];Ye.isAfter(me)&&(me=Ye)}return me}static isPosition(K){if(!K)return!1;if(K instanceof m)return!0;const{line:me,character:Te}=K;return typeof me=="number"&&typeof Te=="number"}static of(K){if(K instanceof m)return K;if(this.isPosition(K))return new m(K.line,K.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(K,me){if(K<0)throw(0,N.$7)("line must be non-negative");if(me<0)throw(0,N.$7)("character must be non-negative");this.c=K,this.e=me}isBefore(K){return this.c<K.c?!0:K.c<this.c?!1:this.e<K.e}isBeforeOrEqual(K){return this.c<K.c?!0:K.c<this.c?!1:this.e<=K.e}isAfter(K){return!this.isBeforeOrEqual(K)}isAfterOrEqual(K){return!this.isBefore(K)}isEqual(K){return this.c===K.c&&this.e===K.e}compareTo(K){return this.c<K.c?-1:this.c>K.line?1:this.e<K.e?-1:this.e>K.e?1:0}translate(K,me=0){if(K===null||me===null)throw(0,N.$7)();let Te;return typeof K>"u"?Te=0:typeof K=="number"?Te=K:(Te=typeof K.lineDelta=="number"?K.lineDelta:0,me=typeof K.characterDelta=="number"?K.characterDelta:0),Te===0&&me===0?this:new m(this.line+Te,this.character+me)}with(K,me=this.character){if(K===null||me===null)throw(0,N.$7)();let Te;return typeof K>"u"?Te=this.line:typeof K=="number"?Te=K:(Te=typeof K.line=="number"?K.line:this.line,me=typeof K.character=="number"?K.character:this.character),Te===this.line&&me===this.character?this:new m(Te,me)}toJSON(){return{line:this.line,character:this.character}}};e.$SM=j,e.$SM=j=m=Je([y],j);let z=o=class{static isRange(K){return K instanceof o?!0:K?j.isPosition(K.start)&&j.isPosition(K.end):!1}static of(K){if(K instanceof o)return K;if(this.isRange(K))return new o(K.start,K.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(K,me,Te,Ye){let rt,dt;if(typeof K=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ye=="number"?(rt=new j(K,me),dt=new j(Te,Ye)):j.isPosition(K)&&j.isPosition(me)&&(rt=j.of(K),dt=j.of(me)),!rt||!dt)throw new Error("Invalid arguments");rt.isBefore(dt)?(this.c=rt,this.e=dt):(this.c=dt,this.e=rt)}contains(K){return o.isRange(K)?this.contains(K.start)&&this.contains(K.end):j.isPosition(K)?!(j.of(K).isBefore(this.c)||this.e.isBefore(K)):!1}isEqual(K){return this.c.isEqual(K.c)&&this.e.isEqual(K.e)}intersection(K){const me=j.Max(K.start,this.c),Te=j.Min(K.end,this.e);if(!me.isAfter(Te))return new o(me,Te)}union(K){if(this.contains(K))return this;if(K.contains(this))return K;const me=j.Min(K.start,this.c),Te=j.Max(K.end,this.end);return new o(me,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(K,me=this.end){if(K===null||me===null)throw(0,N.$7)();let Te;return K?j.isPosition(K)?Te=K:(Te=K.start||this.start,me=K.end||this.end):Te=this.start,Te.isEqual(this.c)&&me.isEqual(this.end)?this:new o(Te,me)}toJSON(){return[this.start,this.end]}};e.$TM=z,e.$TM=z=o=Je([y],z);let O=n=class extends z{static isSelection(K){return K instanceof n?!0:K?z.isRange(K)&&j.isPosition(K.anchor)&&j.isPosition(K.active)&&typeof K.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(K,me,Te,Ye){let rt,dt;if(typeof K=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ye=="number"?(rt=new j(K,me),dt=new j(Te,Ye)):j.isPosition(K)&&j.isPosition(me)&&(rt=j.of(K),dt=j.of(me)),!rt||!dt)throw new Error("Invalid arguments");super(rt,dt),this.f=rt,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$UM=O,e.$UM=O=n=Je([y],O);const T=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,N.$7)("connectionToken")};class B{static isResolvedAuthority(K){return K&&typeof K=="object"&&typeof K.host=="string"&&typeof K.port=="number"&&(K.connectionToken===void 0||typeof K.connectionToken=="string")}constructor(K,me,Te){if(typeof K!="string"||K.length===0)throw(0,N.$7)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,N.$7)("port");typeof Te<"u"&&T(Te),this.host=K,this.port=Math.round(me),this.connectionToken=Te}}e.$VM=B;class W{static isManagedResolvedAuthority(K){return K&&typeof K=="object"&&typeof K.makeConnection=="function"&&(K.connectionToken===void 0||typeof K.connectionToken=="string")}constructor(K,me){this.makeConnection=K,this.connectionToken=me,typeof me<"u"&&T(me)}}e.$WM=W;class Z extends Error{static NotAvailable(K,me){return new Z(K,E.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(K){return new Z(K,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(K,me=E.RemoteAuthorityResolverErrorCode.Unknown,Te){super(K),this._message=K,this._code=me,this._detail=Te,Object.setPrototypeOf(this,Z.prototype)}}e.$XM=Z;var x;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(x||(e.EndOfLine=x={}));var X;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let Y=i=class{static isTextEdit(K){return K instanceof i?!0:K?z.isRange(K)&&typeof K.newText=="string":!1}static replace(K,me){return new i(K,me)}static insert(K,me){return i.replace(new z(K,K),me)}static delete(K){return i.replace(K,"")}static setEndOfLine(K){const me=new i(new z(new j(0,0),new j(0,0)),"");return me.newEol=K,me}get range(){return this.c}set range(K){if(K&&!z.isRange(K))throw(0,N.$7)("range");this.c=K}get newText(){return this.e||""}set newText(K){if(K&&typeof K!="string")throw(0,N.$7)("newText");this.e=K}get newEol(){return this.f}set newEol(K){if(K&&typeof K!="number")throw(0,N.$7)("newEol");this.f=K}constructor(K,me){this.c=K,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$YM=Y,e.$YM=Y=i=Je([y],Y);let ce=r=class{static isNotebookCellEdit(K){return K instanceof r?!0:K?fi.isNotebookRange(K)&&Array.isArray(K.newCells):!1}static replaceCells(K,me){return new r(K,me)}static insertCells(K,me){return new r(new fi(K,K),me)}static deleteCells(K){return new r(K,[])}static updateCellMetadata(K,me){const Te=new r(new fi(K,K),[]);return Te.newCellMetadata=me,Te}static updateNotebookMetadata(K){const me=new r(new fi(0,0),[]);return me.newNotebookMetadata=K,me}constructor(K,me){this.range=K,this.newCells=me}};e.$ZM=ce,e.$ZM=ce=r=Je([y],ce);class ne{static isSnippetTextEdit(K){return K instanceof ne?!0:K?z.isRange(K.range)&&ee.isSnippetString(K.snippet):!1}static replace(K,me){return new ne(K,me)}static insert(K,me){return ne.replace(new z(K,K),me)}constructor(K,me){this.range=K,this.snippet=me}}e.$1M=ne;var $e;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let Ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(K,me,Te,Ye){this.c.push({_type:1,from:K,to:me,options:Te,metadata:Ye})}createFile(K,me,Te){this.c.push({_type:1,from:void 0,to:K,options:me,metadata:Te})}deleteFile(K,me,Te){this.c.push({_type:1,from:K,to:void 0,options:me,metadata:Te})}e(K,me,Te){this.c.push({_type:3,metadata:Te,uri:K,edit:{editType:5,metadata:me},notebookMetadata:me})}f(K,me,Te,Ye){const rt=me.start,dt=me.end;(rt!==dt||Te.length>0)&&this.c.push({_type:5,uri:K,index:rt,count:dt-rt,cells:Te,metadata:Ye})}g(K,me,Te,Ye){this.c.push({_type:3,metadata:Ye,uri:K,edit:{editType:3,index:me,metadata:Te}})}replace(K,me,Te,Ye){this.c.push({_type:2,uri:K,edit:new Y(me,Te),metadata:Ye})}insert(K,me,Te,Ye){this.replace(K,new z(me,me),Te,Ye)}delete(K,me,Te){this.replace(K,me,"",Te)}has(K){return this.c.some(me=>me._type===2&&me.uri.toString()===K.toString())}set(K,me){if(me)for(const Te of me){if(!Te)continue;let Ye,rt;Array.isArray(Te)?(Ye=Te[0],rt=Te[1]):Ye=Te,ce.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(K,Ye.range.start,Ye.newCellMetadata,rt):Ye.newNotebookMetadata?this.e(K,Ye.newNotebookMetadata,rt):this.f(K,Ye.range,Ye.newCells,rt):ne.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:K,range:Ye.range,edit:Ye.snippet,metadata:rt}):this.c.push({_type:2,uri:K,edit:Ye,metadata:rt})}else{for(let Te=0;Te<this.c.length;Te++){const Ye=this.c[Te];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===K.toString()&&(this.c[Te]=void 0);break}}(0,u.$Ib)(this.c)}}get(K){const me=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===K.toString()&&me.push(Te.edit);return me}entries(){const K=new R.$Bc;for(const me of this.c)if(me._type===2){let Te=K.get(me.uri);Te||(Te=[me.uri,[]],K.set(me.uri,Te)),Te[1].push(me.edit)}return[...K.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$2M=Ce,e.$2M=Ce=Je([y],Ce);let ee=s=class{static isSnippetString(K){return K instanceof s?!0:K?typeof K.value=="string":!1}static c(K){return K.replace(/\$|}|\\/g,"\\$&")}constructor(K){this.e=1,this.value=K||""}appendText(K){return this.value+=s.c(K),this}appendTabstop(K=this.e++){return this.value+="$",this.value+=K,this}appendPlaceholder(K,me=this.e++){if(typeof K=="function"){const Te=new s;Te.e=this.e,K(Te),this.e=Te.e,K=Te.value}else K=s.c(K);return this.value+="${",this.value+=me,this.value+=":",this.value+=K,this.value+="}",this}appendChoice(K,me=this.e++){const Te=K.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(K,me){if(typeof me=="function"){const Te=new s;Te.e=this.e,me(Te),this.e=Te.e,me=Te.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=K,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$3M=ee,e.$3M=ee=s=Je([y],ee);var U;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ie;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let be=t=class{static isLocation(K){return K instanceof t?!0:K?z.isRange(K.range)&&S.URI.isUri(K.uri):!1}constructor(K,me){if(this.uri=K,me)if(z.isRange(me))this.range=z.of(me);else if(j.isPosition(me))this.range=new z(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$4M=be,e.$4M=be=t=Je([y],be);let Pe=class{static is(K){return K?typeof K.message=="string"&&K.location&&z.isRange(K.location.range)&&S.URI.isUri(K.location.uri):!1}constructor(K,me){this.location=K,this.message=me}static isEqual(K,me){return K===me?!0:!K||!me?!1:K.message===me.message&&K.location.range.isEqual(me.location.range)&&K.location.uri.toString()===me.location.uri.toString()}};e.$5M=Pe,e.$5M=Pe=Je([y],Pe);let oe=class{constructor(K,me,Te=ie.Error){if(!z.isRange(K))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=K,this.message=me,this.severity=Te}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(K,me){return K===me?!0:!K||!me?!1:K.message===me.message&&K.severity===me.severity&&K.code===me.code&&K.severity===me.severity&&K.source===me.source&&K.range.isEqual(me.range)&&(0,u.$ub)(K.tags,me.tags)&&(0,u.$ub)(K.relatedInformation,me.relatedInformation,Pe.isEqual)}};e.$6M=oe,e.$6M=oe=Je([y],oe);let ae=class{constructor(K,me){if(!K)throw new Error("Illegal argument, contents must be defined");Array.isArray(K)?this.contents=K:this.contents=[K],this.range=me}};e.$7M=ae,e.$7M=ae=Je([y],ae);var re;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let G=class{constructor(K,me=re.Text){this.range=K,this.kind=me}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$8M=G,e.$8M=G=Je([y],G);let te=class{constructor(K,me){this.uri=K,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(K=>K.toJSON())}}};e.$9M=te,e.$9M=te=Je([y],te);var ge;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(ge||(e.SymbolKind=ge={}));var we;(function(H){H[H.Deprecated=1]="Deprecated"})(we||(e.SymbolTag=we={}));let Re=f=class{static validate(K){if(!K.name)throw new Error("name must not be falsy")}constructor(K,me,Te,Ye,rt){this.name=K,this.kind=me,this.containerName=rt,typeof Te=="string"&&(this.containerName=Te),Ye instanceof be?this.location=Ye:Te instanceof z&&(this.location=new be(Ye,Te)),f.validate(this)}toJSON(){return{name:this.name,kind:ge[this.kind],location:this.location,containerName:this.containerName}}};e.$0M=Re,e.$0M=Re=f=Je([y],Re);let fe=d=class{static validate(K){if(!K.name)throw new Error("name must not be falsy");if(!K.range.contains(K.selectionRange))throw new Error("selectionRange must be contained in fullRange");K.children?.forEach(d.validate)}constructor(K,me,Te,Ye,rt){this.name=K,this.detail=me,this.kind=Te,this.range=Ye,this.selectionRange=rt,this.children=[],d.validate(this)}};e.$$M=fe,e.$$M=fe=d=Je([y],fe);var Se;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(Se||(e.CodeActionTriggerKind=Se={}));let Ae=class{constructor(K,me){this.title=K,this.kind=me}};e.$_M=Ae,e.$_M=Ae=Je([y],Ae);let Fe=class{static{l=this}static{this.c="."}constructor(K){this.value=K}append(K){return new l(this.value?this.value+l.c+K:K)}intersects(K){return this.contains(K)||K.contains(this)}contains(K){return this.value===K.value||K.value.startsWith(this.value+l.c)}};e.$aN=Fe,e.$aN=Fe=l=Je([y],Fe),Fe.Empty=new Fe(""),Fe.QuickFix=Fe.Empty.append("quickfix"),Fe.Refactor=Fe.Empty.append("refactor"),Fe.RefactorExtract=Fe.Refactor.append("extract"),Fe.RefactorInline=Fe.Refactor.append("inline"),Fe.RefactorMove=Fe.Refactor.append("move"),Fe.RefactorRewrite=Fe.Refactor.append("rewrite"),Fe.Source=Fe.Empty.append("source"),Fe.SourceOrganizeImports=Fe.Source.append("organizeImports"),Fe.SourceFixAll=Fe.Source.append("fixAll"),Fe.Notebook=Fe.Empty.append("notebook");let q=class{constructor(K,me){if(this.range=K,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$bN=q,e.$bN=q=Je([y],q);class V{constructor(K,me,Te,Ye,rt,dt){this.kind=K,this.name=me,this.detail=Te,this.uri=Ye,this.range=rt,this.selectionRange=dt}}e.$cN=V;class Q{constructor(K,me){this.fromRanges=me,this.from=K}}e.$dN=Q;class J{constructor(K,me){this.fromRanges=me,this.to=K}}e.$eN=J;var he;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(he||(e.LanguageStatusSeverity=he={}));let pe=class{constructor(K,me){this.range=K,this.command=me}get isResolved(){return!!this.command}};e.$fN=pe,e.$fN=pe=Je([y],pe);let ze=c=class{#e;static isMarkdownString(K){return K instanceof c?!0:K&&K.appendCodeblock&&K.appendMarkdown&&K.appendText&&K.value!==void 0}constructor(K,me=!1){this.#e=new L.$Nk(K,{supportThemeIcons:me})}get value(){return this.#e.value}set value(K){this.#e.value=K}get isTrusted(){return this.#e.isTrusted}set isTrusted(K){this.#e.isTrusted=K}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(K){this.#e.supportThemeIcons=K}get supportHtml(){return this.#e.supportHtml}set supportHtml(K){this.#e.supportHtml=K}get baseUri(){return this.#e.baseUri}set baseUri(K){this.#e.baseUri=K}appendText(K){return this.#e.appendText(K),this}appendMarkdown(K){return this.#e.appendMarkdown(K),this}appendCodeblock(K,me){return this.#e.appendCodeblock(me??"",K),this}};e.$gN=ze,e.$gN=ze=c=Je([y],ze);let Ve=class{constructor(K,me){this.label=K,this.documentation=me}};e.$hN=Ve,e.$hN=Ve=Je([y],Ve);let Ze=class{constructor(K,me){this.label=K,this.documentation=me,this.parameters=[]}};e.$iN=Ze,e.$iN=Ze=Je([y],Ze);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$jN=tt,e.$jN=tt=Je([y],tt);var ot;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var it;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let st=class{constructor(K){this.value=K}};e.$kN=st,e.$kN=st=Je([y],st);let De=class{constructor(K,me,Te){this.position=K,this.label=me,this.kind=Te}};e.$lN=De,e.$lN=De=Je([y],De);var Be;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var He;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(He||(e.CompletionItemKind=He={}));var Le;(function(H){H[H.Deprecated=1]="Deprecated"})(Le||(e.CompletionItemTag=Le={}));let Xe=class{constructor(K,me){this.label=K,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$mN=Xe,e.$mN=Xe=Je([y],Xe);let se=class{constructor(K=[],me=!1){this.items=K,this.isIncomplete=me}};e.$nN=se,e.$nN=se=Je([y],se);let ue=class{constructor(K,me,Te){this.insertText=K,this.range=me,this.command=Te}};e.$oN=ue,e.$oN=ue=Je([y],ue);let Ie=class{constructor(K){this.commands=void 0,this.suppressSuggestions=void 0,this.items=K}};e.$pN=Ie,e.$pN=Ie=Je([y],Ie);var Ge;(function(H){H[H.Unknown=0]="Unknown",H[H.Word=1]="Word",H[H.Line=2]="Line",H[H.Suggest=3]="Suggest"})(Ge||(e.PartialAcceptTriggerKind=Ge={}));var Me;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(Me||(e.ViewColumn=Me={}));var nt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function lt(H,K){return`${P.$Lm.toKey(H)}.${K}`}var wt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval"})(wt||(e.TextEditorLineNumbersStyle=wt={}));var It;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(It||(e.TextDocumentSaveReason=It={}));var jt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(jt||(e.TextEditorRevealType=jt={}));var Kt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Kt||(e.TextEditorSelectionChangeKind=Kt={}));var xt;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(xt||(e.TextDocumentChangeReason=xt={}));var St;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(St||(e.DecorationRangeBehavior=St={})),function(H){function K(me){switch(me){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=K}(Kt||(e.TextEditorSelectionChangeKind=Kt={}));var qt;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(qt||(e.SyntaxTokenType=qt={})),function(H){function K(me){switch(me){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=K}(qt||(e.SyntaxTokenType=qt={}));let Ht=class{constructor(K,me){if(me&&!S.URI.isUri(me))throw(0,N.$7)("target");if(!z.isRange(K)||K.isEmpty)throw(0,N.$7)("range");this.range=K,this.target=me}};e.$rN=Ht,e.$rN=Ht=Je([y],Ht);let et=class{constructor(K,me,Te,Ye){this.red=K,this.green=me,this.blue=Te,this.alpha=Ye}};e.$sN=et,e.$sN=et=Je([y],et);let ri=class{constructor(K,me){if(me&&!(me instanceof et))throw(0,N.$7)("color");if(!z.isRange(K)||K.isEmpty)throw(0,N.$7)("range");this.range=K,this.color=me}};e.$tN=ri,e.$tN=ri=Je([y],ri);let _t=class{constructor(K){if(!K||typeof K!="string")throw(0,N.$7)("label");this.label=K}};e.$uN=_t,e.$uN=_t=Je([y],_t);var ft;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(ft||(e.ColorFormat=ft={}));var $t;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})($t||(e.SourceControlInputBoxValidationType=$t={}));var ei;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ei||(e.TerminalExitReason=ei={}));class ti{constructor(K,me,Te){if(this.startIndex=K,this.length=me,this.tooltip=Te,typeof K!="number"||K<0)throw(0,N.$7)("startIndex");if(typeof me!="number"||me<1)throw(0,N.$7)("length");if(Te!==void 0&&typeof Te!="string")throw(0,N.$7)("tooltip")}}e.$vN=ti;class zt{constructor(K){this.uri=K}}e.$wN=zt;class gt{constructor(K){this.terminalCommand=K}}e.$xN=gt;var Bt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(Bt||(e.TerminalLocation=Bt={}));class ii{constructor(K){if(this.options=K,typeof K!="object")throw(0,N.$7)("options")}}e.$yN=ii;var Ot;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Ot||(e.TaskRevealKind=Ot={}));var xe;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(xe||(e.TaskPanelKind=xe={}));let si=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(K){switch(K){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(K,me){if(this.label=me,typeof K!="string"||typeof me!="string")throw(0,N.$7)("name");this.c=K}get id(){return this.c}};e.$zN=si,e.$zN=si=h=Je([y],si);function Gt(H){let K="";for(let me=0;me<H.length;me++)K+=H[me].replace(/,/g,",,")+",";return K}let Ut=class{constructor(K,me,Te){if(typeof K!="string")throw(0,N.$7)("process");this.e=[],this.c=K,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Te):this.f=me)}get process(){return this.c}set process(K){if(typeof K!="string")throw(0,N.$7)("process");this.c=K}get args(){return this.e}set args(K){Array.isArray(K)||(K=[]),this.e=K}get options(){return this.f}set options(K){this.f=K}computeId(){const K=[];if(K.push("process"),this.c!==void 0&&K.push(this.c),this.e&&this.e.length>0)for(const me of this.e)K.push(me);return Gt(K)}};e.$AN=Ut,e.$AN=Ut=Je([y],Ut);let mt=class{constructor(K,me,Te){if(this.f=[],Array.isArray(me)){if(!K)throw(0,N.$7)("command can't be undefined or null");if(typeof K!="string"&&typeof K.value!="string")throw(0,N.$7)("command");this.e=K,this.f=me,this.g=Te}else{if(typeof K!="string")throw(0,N.$7)("commandLine");this.c=K,this.g=me}}get commandLine(){return this.c}set commandLine(K){if(typeof K!="string")throw(0,N.$7)("commandLine");this.c=K}get command(){return this.e?this.e:""}set command(K){if(typeof K!="string"&&typeof K.value!="string")throw(0,N.$7)("command");this.e=K}get args(){return this.f}set args(K){this.f=K||[]}get options(){return this.g}set options(K){this.g=K}computeId(){const K=[];if(K.push("shell"),this.c!==void 0&&K.push(this.c),this.e!==void 0&&K.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)K.push(typeof me=="string"?me:me.value);return Gt(K)}};e.$BN=mt,e.$BN=mt=Je([y],mt);var Tt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Tt||(e.ShellQuoting=Tt={}));var Lt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Lt||(e.TaskScope=Lt={}));class Wt{constructor(K){this.c=K}computeId(){return"customExecution"+(0,A.$Mg)()}set callback(K){this.c=K}get callback(){return this.c}}e.$CN=Wt;let Jt=class{static{g=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(K,me,Te,Ye,rt,dt){this.k=!1,this.l=this.definition=K;let bt;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Te,this.execution=Ye,bt=rt,this.k=!0):me===Lt.Global||me===Lt.Workspace?(this.target=me,this.o=this.name=Te,this.w=this.source=Ye,this.execution=rt,bt=dt):(this.target=me,this.o=this.name=Te,this.w=this.source=Ye,this.execution=rt,bt=dt),typeof bt=="string"?(this.r=[bt],this.t=!0):Array.isArray(bt)?(this.r=bt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(K){this.j=K}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ut?this.l={type:g.e,id:this.q.computeId()}:this.q instanceof mt?this.l={type:g.f,id:this.q.computeId()}:this.q instanceof Wt?this.l={type:g.c,id:this.q.computeId()}:this.l={type:g.g,id:(0,A.$Mg)()}}get definition(){return this.l}set definition(K){if(K==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=K}get scope(){return this.m}set target(K){this.B(),this.m=K}get name(){return this.o}set name(K){if(typeof K!="string")throw(0,N.$7)("name");this.B(),this.o=K}get execution(){return this.q}set execution(K){K===null&&(K=void 0),this.B(),this.q=K;const me=this.l.type;(g.g===me||g.e===me||g.f===me||g.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(K){if(Array.isArray(K))this.B(),this.r=K,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(K){K!==!0&&K!==!1&&(K=!1),this.B(),this.u=K}get source(){return this.w}set source(K){if(typeof K!="string"||K.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=K}get group(){return this.x}set group(K){K===null&&(K=void 0),this.B(),this.x=K}get detail(){return this.A}set detail(K){K===null&&(K=void 0),this.A=K}get presentationOptions(){return this.y}set presentationOptions(K){K==null&&(K=Object.create(null)),this.B(),this.y=K}get runOptions(){return this.z}set runOptions(K){K==null&&(K=Object.create(null)),this.B(),this.z=K}};e.$DN=Jt,e.$DN=Jt=g=Je([y],Jt);var Qt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Qt||(e.ProgressLocation=Qt={}));var oi;(function(H){function K(me){const Te=me;return(0,b.$8f)(Te.value)?Te.tooltip&&!(0,b.$4f)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}H.isViewBadge=K})(oi||(e.ViewBadge=oi={}));let At=D=class{static isTreeItem(K,me){const Te=K;if(Te.checkboxState!==void 0){const Ye=(0,b.$8f)(Te.checkboxState)?Te.checkboxState:(0,b.$6f)(Te.checkboxState)&&(0,b.$8f)(Te.checkboxState.state)?Te.checkboxState.state:void 0,rt=!(0,b.$8f)(Te.checkboxState)&&(0,b.$6f)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==Ct.Checked&&Ye!==Ct.Unchecked||rt!==void 0&&!(0,b.$4f)(rt))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(K instanceof D)return!0;if(Te.label!==void 0&&!(0,b.$4f)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,b.$4f)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,b.$4f)(Te.iconPath)&&!S.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,b.$4f)(Te.iconPath.id))){const Ye=Te.iconPath;if(!Ye||!(0,b.$4f)(Ye.light)&&!S.URI.isUri(Ye.light)&&!(0,b.$4f)(Ye.dark)&&!S.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,b.$4f)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!S.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,b.$4f)(Te.tooltip)&&!(Te.tooltip instanceof ze)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<Nt.None&&Te.collapsibleState>Nt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,b.$4f)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(K,me=Nt.None){this.collapsibleState=me,S.URI.isUri(K)?this.resourceUri=K:this.label=K}};e.$EN=At,e.$EN=At=D=Je([y],At);var Nt;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Nt||(e.TreeItemCollapsibleState=Nt={}));var Ct;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(Ct||(e.TreeItemCheckboxState=Ct={}));let Dt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(K){this.value=K}};e.$FN=Dt,e.$FN=Dt=Je([y],Dt);class pt extends Dt{}e.$GN=pt;class Pt extends pt{#e;constructor(K){super(""),this.#e=K}asFile(){return this.#e}}e.$HN=Pt;class li{constructor(K,me,Te,Ye){this.name=K,this.uri=me,this._itemId=Te,this.c=Ye}data(){return this.c()}}e.$IN=li;let kt=class{#e=new Map;constructor(K){for(const[me,Te]of K??[]){const Ye=this.#e.get(this.#t(me));Ye?Ye.push(Te):this.#e.set(this.#t(me),[Te])}}get(K){return this.#e.get(this.#t(K))?.[0]}set(K,me){this.#e.set(this.#t(K),[me])}forEach(K,me){for(const[Te,Ye]of this.#e)for(const rt of Ye)K.call(me,rt,Te,this)}*[Symbol.iterator](){for(const[K,me]of this.#e)for(const Te of me)yield[K,Te]}#t(K){return K.toLowerCase()}};e.$JN=kt,e.$JN=kt=Je([y],kt);let hi=class{constructor(K,me,Te){this.insertText=K,this.title=me,this.kind=Te}};e.$KN=hi,e.$KN=hi=Je([y],hi);var Zt;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(Zt||(e.DocumentPasteTriggerKind=Zt={}));class ai{static{this.c="."}constructor(K){this.value=K}append(...K){return new ai((this.value?[this.value,...K]:K).join(ai.c))}intersects(K){return this.contains(K)||K.contains(this)}contains(K){return this.value===K.value||K.value.startsWith(this.value+ai.c)}}e.$LN=ai,ai.Empty=new ai("");class bi{constructor(K,me,Te){this.title=me,this.insertText=K,this.kind=Te}}e.$MN=bi;let ni=class{constructor(K,me){this.id=K,this.color=me}static isThemeIcon(K){return typeof K.id!="string"?(console.log("INVALID ThemeIcon, invalid id",K.id),!1):!0}};e.$NN=ni,e.$NN=ni=Je([y],ni),ni.File=new ni("file"),ni.Folder=new ni("folder");let Rt=class{constructor(K){this.id=K}};e.$ON=Rt,e.$ON=Rt=Je([y],Rt);var yi;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(yi||(e.ConfigurationTarget=yi={}));let Ne=class{get base(){return this.c}set base(K){this.c=K,this.e=S.URI.file(K)}get baseUri(){return this.e}set baseUri(K){this.e=K,this.c=K.fsPath}constructor(K,me){if(typeof K!="string"&&(!K||!S.URI.isUri(K)&&!S.URI.isUri(K.uri)))throw(0,N.$7)("base");if(typeof me!="string")throw(0,N.$7)("pattern");typeof K=="string"?this.baseUri=S.URI.file(K):S.URI.isUri(K)?this.baseUri=K:this.baseUri=K.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$PN=Ne,e.$PN=Ne=Je([y],Ne);const je=new WeakMap;function ye(H,K){je.set(H,K)}let _=class{constructor(K,me,Te,Ye,rt){this.enabled=typeof K=="boolean"?K:!0,typeof me=="string"&&(this.condition=me),typeof Te=="string"&&(this.hitCondition=Te),typeof Ye=="string"&&(this.logMessage=Ye),typeof rt=="string"&&(this.mode=rt)}get id(){return this.c||(this.c=je.get(this)??(0,A.$Mg)()),this.c}};e.$RN=_,e.$RN=_=Je([y],_);let Oe=class extends _{constructor(K,me,Te,Ye,rt,dt){if(super(me,Te,Ye,rt,dt),K===null)throw(0,N.$7)("location");this.location=K}};e.$SN=Oe,e.$SN=Oe=Je([y],Oe);let Ke=class extends _{constructor(K,me,Te,Ye,rt,dt){super(me,Te,Ye,rt,dt),this.functionName=K}};e.$TN=Ke,e.$TN=Ke=Je([y],Ke);let _e=class extends _{constructor(K,me,Te,Ye,rt,dt,bt,Vt){if(super(Ye,rt,dt,bt,Vt),!me)throw(0,N.$7)("dataId");this.label=K,this.dataId=me,this.canPersist=Te}};e.$UN=_e,e.$UN=_e=Je([y],_e);let Qe=class{constructor(K,me,Te){this.command=K,this.args=me||[],this.options=Te}};e.$VN=Qe,e.$VN=Qe=Je([y],Qe);let ht=class{constructor(K,me){this.port=K,this.host=me}};e.$WN=ht,e.$WN=ht=Je([y],ht);let Et=class{constructor(K){this.path=K}};e.$XN=Et,e.$XN=Et=Je([y],Et);let Ft=class{constructor(K){this.implementation=K}};e.$YN=Ft,e.$YN=Ft=Je([y],Ft);class Xt{constructor(K,me,Te){this.session=K,this.threadId=me,this.frameId=Te}}e.$ZN=Xt;class ut{constructor(K,me){this.session=K,this.threadId=me}}e.$1N=ut;let Yt=class{constructor(K,me){this.range=K,this.expression=me}};e.$2N=Yt,e.$2N=Yt=Je([y],Yt);var mi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(mi||(e.InlineCompletionTriggerKind=mi={}));let pi=class{constructor(K,me){this.range=K,this.text=me}};e.$3N=pi,e.$3N=pi=Je([y],pi);let Si=class{constructor(K,me,Te=!0){this.range=K,this.variableName=me,this.caseSensitiveLookup=Te}};e.$4N=Si,e.$4N=Si=Je([y],Si);let Mi=class{constructor(K,me){this.range=K,this.expression=me}};e.$5N=Mi,e.$5N=Mi=Je([y],Mi);let Li=class{constructor(K,me){this.frameId=K,this.stoppedLocation=me}};e.$6N=Li,e.$6N=Li=Je([y],Li);var Vi;(function(H){H[H.AIGenerated=1]="AIGenerated"})(Vi||(e.NewSymbolNameTag=Vi={}));class Ki{constructor(K,me){this.newSymbolName=K,this.tags=me}}e.$7N=Ki;var Hi;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Hi||(e.FileChangeType=Hi={}));let Di=w=class extends Error{static FileExists(K){return new w(K,$.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(K){return new w(K,$.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(K){return new w(K,$.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(K){return new w(K,$.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(K){return new w(K,$.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(K){return new w(K,$.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}constructor(K,me=$.FileSystemProviderErrorCode.Unknown,Te){super(S.URI.isUri(K)?K.toString(!0):K),this.code=Te?.name??"Unknown",(0,$.$_k)(this,me),Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};e.$8N=Di,e.$8N=Di=w=Je([y],Di);let Ni=class{constructor(K,me,Te){this.start=K,this.end=me,this.kind=Te}};e.$9N=Ni,e.$9N=Ni=Je([y],Ni);var Pi;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Pi||(e.FoldingRangeKind=Pi={}));var Ci;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Ci||(e.CommentThreadCollapsibleState=Ci={}));var Gi;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(Gi||(e.CommentMode=Gi={}));var Ji;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Ji||(e.CommentState=Ji={}));var vi;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));var Qi;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));class un{constructor(K,me=[]){this.tokenTypes=K,this.tokenModifiers=me}}e.$0N=un;function ln(H){return typeof H>"u"||(0,b.$5f)(H)}class ki{constructor(K){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,K){this.m=!0;for(let me=0,Te=K.tokenTypes.length;me<Te;me++)this.k.set(K.tokenTypes[me],me);for(let me=0,Te=K.tokenModifiers.length;me<Te;me++)this.l.set(K.tokenModifiers[me],me)}}push(K,me,Te,Ye,rt){if(typeof K=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ye=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this.q(K,me,Te,Ye,rt);if(z.isRange(K)&&typeof me=="string"&&ln(Te))return this.o(K,me,Te);throw(0,N.$7)()}o(K,me,Te){if(!this.m)throw new Error("Legend must be provided in constructor");if(K.start.line!==K.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Ye=K.start.line,rt=K.start.character,dt=K.end.character-K.start.character,bt=this.k.get(me);let Vt=0;if(Te)for(const ui of Te){if(!this.l.has(ui))throw new Error("`tokenModifier` is not in the provided legend");const gi=this.l.get(ui);Vt|=1<<gi>>>0}this.q(Ye,rt,dt,bt,Vt)}q(K,me,Te,Ye,rt){if(this.f&&(K<this.c||K===this.c&&me<this.e)){this.f=!1;const Vt=this.g.length/5|0;let ui=0,gi=0;for(let $i=0;$i<Vt;$i++){let wi=this.g[5*$i],Wi=this.g[5*$i+1];wi===0?(wi=ui,Wi+=gi):wi+=ui,this.g[5*$i]=wi,this.g[5*$i+1]=Wi,ui=wi,gi=Wi}}let dt=K,bt=me;this.f&&this.j>0&&(dt-=this.c,dt===0&&(bt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=bt,this.g[this.j++]=Te,this.g[this.j++]=Ye,this.g[this.j++]=rt,this.c=K,this.e=me}static r(K){const me=[],Te=K.length/5|0;for(let bt=0;bt<Te;bt++)me[bt]=bt;me.sort((bt,Vt)=>{const ui=K[5*bt],gi=K[5*Vt];if(ui===gi){const $i=K[5*bt+1],wi=K[5*Vt+1];return $i-wi}return ui-gi});const Ye=new Uint32Array(K.length);let rt=0,dt=0;for(let bt=0;bt<Te;bt++){const Vt=5*me[bt],ui=K[Vt+0],gi=K[Vt+1],$i=K[Vt+2],wi=K[Vt+3],Wi=K[Vt+4],Mn=ui-rt,or=Mn===0?gi-dt:gi,qi=5*bt;Ye[qi+0]=Mn,Ye[qi+1]=or,Ye[qi+2]=$i,Ye[qi+3]=wi,Ye[qi+4]=Wi,rt=ui,dt=gi}return Ye}build(K){return this.f?new Oi(new Uint32Array(this.g),K):new Oi(ki.r(this.g),K)}}e.$$N=ki;class Oi{constructor(K,me){this.resultId=me,this.data=K}}e.$_N=Oi;class Zi{constructor(K,me,Te){this.start=K,this.deleteCount=me,this.data=Te}}e.$aO=Zi;class hn{constructor(K,me){this.resultId=me,this.edits=K}}e.$bO=hn;var Ti;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Ti||(e.DebugConsoleMode=Ti={}));class dn{constructor(K){this.name=K}}e.$cO=dn;let Fi=class{static{this.Back={iconPath:new ni("arrow-left")}}constructor(){}};e.$dO=Fi,e.$dO=Fi=Je([y],Fi);var Xi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Xi||(e.QuickPickItemKind=Xi={}));var Yi;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(Yi||(e.InputBoxValidationSeverity=Yi={}));var Ii;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Ii||(e.ExtensionKind=Ii={}));class xi{static validate(K){if(typeof K.badge=="string"){let me=(0,p.$Df)(K.badge,0);if(me<K.badge.length&&(me+=(0,p.$Df)(K.badge,me)),K.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(K.badge&&!ni.isThemeIcon(K.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!K.color&&!K.badge&&!K.tooltip)throw new Error("The decoration is empty");return!0}constructor(K,me,Te){this.badge=K,this.tooltip=me,this.color=Te}}e.$eO=xi;let We=class{constructor(K){this.kind=K}};e.$fO=We,e.$fO=We=Je([y],We);var di;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(di||(e.ColorThemeKind=di={}));class fi{static isNotebookRange(K){return K instanceof fi?!0:K?typeof K.start=="number"&&typeof K.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(K,me){if(K<0)throw(0,N.$7)("start must be positive");if(me<0)throw(0,N.$7)("end must be positive");K<=me?(this.c=K,this.e=me):(this.c=me,this.e=K)}with(K){let me=this.c,Te=this.e;return K.start!==void 0&&(me=K.start),K.end!==void 0&&(Te=K.end),me===this.c&&Te===this.e?this:new fi(me,Te)}}e.$gO=fi;class at{static validate(K){if(typeof K.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof K.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof K.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(K){return Array.isArray(K)&&K.every(me=>at.isNotebookCellData(me))}static isNotebookCellData(K){return!0}constructor(K,me,Te,Ye,rt,dt,bt){this.kind=K,this.value=me,this.languageId=Te,this.mime=Ye,this.outputs=rt??[],this.metadata=dt,this.executionSummary=bt,at.validate(this)}}e.$hO=at;class vt{constructor(K){this.cells=K}}e.$iO=vt;class ci{static isNotebookCellOutputItem(K){return K instanceof ci?!0:K?typeof K.mime=="string"&&K.data instanceof Uint8Array:!1}static error(K){const me={name:K.name,message:K.message,stack:K.stack};return ci.json(me,"application/vnd.code.notebook.error")}static stdout(K){return ci.text(K,"application/vnd.code.notebook.stdout")}static stderr(K){return ci.text(K,"application/vnd.code.notebook.stderr")}static bytes(K,me="application/octet-stream"){return new ci(K,me)}static#e=new TextEncoder;static text(K,me=M.$Hs.text){const Te=ci.#e.encode(String(K));return new ci(Te,me)}static json(K,me="text/x-json"){const Te=JSON.stringify(K,void 0,"	");return ci.text(Te,me)}constructor(K,me){this.data=K,this.mime=me;const Te=(0,M.$Ls)(me,!0);if(!Te)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.$jO=ci;class Ai{static isNotebookCellOutput(K){return K instanceof Ai?!0:!K||typeof K!="object"?!1:typeof K.id=="string"&&Array.isArray(K.items)}static ensureUniqueMimeTypes(K,me=!1){const Te=new Set,Ye=new Set;for(let rt=0;rt<K.length;rt++){const dt=K[rt],bt=(0,M.$Ls)(dt.mime);if(!Te.has(bt)||(0,v.$MK)(bt)){Te.add(bt);continue}Ye.add(rt),me&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ye.size===0?K:K.filter((rt,dt)=>!Ye.has(dt))}constructor(K,me,Te){this.items=Ai.ensureUniqueMimeTypes(K,!0),typeof me=="string"?(this.id=me,this.metadata=Te):(this.id=(0,A.$Mg)(),this.metadata=me??Te)}}e.$kO=Ai;var ji;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(ji||(e.NotebookCellKind=ji={}));var _i;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(_i||(e.NotebookCellExecutionState=_i={}));var Ei;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Ei||(e.NotebookCellStatusBarAlignment=Ei={}));var en;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(K,me){this.text=K,this.alignment=me}}e.$lO=fn;var tn;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(tn||(e.NotebookControllerAffinity=tn={}));var zi;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(zi||(e.NotebookControllerAffinity2=zi={}));class gn{constructor(K,me=[]){this.uri=K,this.provides=(0,u.$3b)(me)}}e.$mO=gn;class mn{constructor(K){this.label=K}}e.$nO=mn;var nn;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let Bi=class{constructor(K,me){this.label=K,this.timestamp=me}};e.$oO=Bi,e.$oO=Bi=Je([y],Bi);var rn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(K,me){this.ranges=K,this.wordPattern=me}}e.$pO=$n;class bn{constructor(K){this.c=K}get autoForwardAction(){return this.c}}e.$qO=bn;var an;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var cn;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let de=class{constructor(K=void 0,me=void 0,Te=void 0,Ye=!1){this.include=K,this.exclude=me,this.profile=Te,this.continuous=Ye}};e.$rO=de,e.$rO=de=Je([y],de);let ve=k=class{static diff(K,me,Te){const Ye=new k(K);return Ye.expectedOutput=me,Ye.actualOutput=Te,Ye}constructor(K){this.message=K}};e.$sO=ve,e.$sO=ve=k=Je([y],ve);let Ue=class{constructor(K){this.id=K}};e.$tO=Ue,e.$tO=Ue=Je([y],Ue);class ct{constructor(K,me){this.covered=K,this.total=me,yt(this)}}e.$uO=ct;function yt(H){if(H){if(H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`);if(H.total<0)throw new Error(`The number of covered items (${H.total}) cannot be negative`)}}class Mt{static fromDetails(K,me){const Te=new ct(0,0),Ye=new ct(0,0),rt=new ct(0,0);for(const bt of me)if("branches"in bt){Te.total+=1,Te.covered+=bt.executed?1:0;for(const Vt of bt.branches)Ye.total+=1,Ye.covered+=Vt.executed?1:0}else rt.total+=1,rt.covered+=bt.executed?1:0;const dt=new Mt(K,Te,Ye.total>0?Ye:void 0,rt.total>0?rt:void 0);return dt.detailedCoverage=me,dt}constructor(K,me,Te,Ye){this.uri=K,this.statementCoverage=me,this.branchCoverage=Te,this.declarationCoverage=Ye}}e.$wO=Mt;class Ui{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,me,Te=[]){this.executed=K,this.location=me,this.branches=Te}}e.$xO=Ui;class Ln{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,me,Te){this.executed=K,this.location=me,this.label=Te}}e.$yO=Ln;class Nn{get executionCount(){return+this.executed}set executionCount(K){this.executed=K}constructor(K,me,Te){this.name=K,this.executed=me,this.location=Te}}e.$zO=Nn;var pn;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(pn||(e.ExternalUriOpenerPriority=pn={}));var wn;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(wn||(e.WorkspaceTrustState=wn={}));var vn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(vn||(e.PortAutoForwardAction=vn={}));class On{constructor(K,me,Te,Ye,rt,dt){this.kind=K,this.name=me,this.detail=Te,this.uri=Ye,this.range=rt,this.selectionRange=dt}}e.$AO=On;class Tn{constructor(K){this.uri=K}}e.$BO=Tn;class Fn{constructor(K,me){this.original=K,this.modified=me}}e.$CO=Fn;class jn{constructor(K,me,Te,Ye){this.base=K,this.input1=me,this.input2=Te,this.result=Ye}}e.$DO=jn;class zn{constructor(K,me){this.uri=K,this.viewType=me}}e.$EO=zn;class Bn{constructor(K){this.viewType=K}}e.$FO=Bn;class Un{constructor(K,me){this.uri=K,this.notebookType=me}}e.$GO=Un;class Wn{constructor(K,me,Te){this.original=K,this.modified=me,this.notebookType=Te}}e.$HO=Wn;class qn{constructor(){}}e.$IO=qn;class Vn{constructor(K,me){this.uri=K,this.inputBoxUri=me}}e.$JO=Vn;class Kn{constructor(){}}e.$KO=Kn;class Hn{constructor(K){this.textDiffs=K}}e.$LO=Hn;var yn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var kn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var En;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class Gn{constructor(K,me){this.label=K,this.values=me}}e.$MO=Gn;var Sn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var Dn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(Dn||(e.ChatResultFeedbackKind=Dn={}));class Jn{constructor(K){this.value=typeof K=="string"?new ze(K):K}}e.$NO=Jn;class Qn{constructor(K,me){this.value=K,this.baseUri=me}}e.$OO=Qn;class Zn{constructor(K,me){this.value=K,this.title=me}}e.$PO=Zn;class Xn{constructor(K){this.value=K}}e.$QO=Xn;class Yn{constructor(K){this.value=K}}e.$RO=Yn;class xn{constructor(K){this.value=K}}e.$SO=xn;class _n{constructor(K,me){this.uri=K,this.edits=Array.isArray(me)?me:[me]}}e.$TO=_n;class er{constructor(K,me,Te,Ye){this.prompt=K,this.command=me,this.variables=Te,this.participant=Ye}}e.$UO=er;class tr{constructor(K,me,Te,Ye){this.response=K,this.result=me,this.participant=Te,this.command=Ye}}e.$VO=tr;var Pn;(function(H){H[H.Panel=1]="Panel",H[H.Terminal=2]="Terminal",H[H.Notebook=3]="Notebook",H[H.Editor=4]="Editor"})(Pn||(e.ChatLocation=Pn={}));class ir{constructor(K){this.content=K}}e.$WO=ir;class nr{constructor(K,me){this.content=K,this.name=me}}e.$XO=nr;class rr{constructor(K,me){this.content=K,this.name=me}}e.$YO=rr;class Ri extends Error{static NotFound(K){return new Ri(K,Ri.NotFound.name)}static NoPermissions(K){return new Ri(K,Ri.NoPermissions.name)}constructor(K,me,Te){super(K,{cause:Te}),this.name="LanguageModelError",this.code=me??""}}e.$ZO=Ri;var Cn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Cn||(e.RelatedInformationType=Cn={}));var In;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped",H[H.Error=5]="Error"})(In||(e.SpeechToTextStatus=In={}));var An;(function(H){H[H.Recognized=1]="Recognized",H[H.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}));class sr{constructor(K,me){this.text=K,this.range=me}}e.$1O=sr;var Rn;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Rn||(e.InlineEditTriggerKind=Rn={}))}),define(ke[324],Ee([1,0,6,8]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(u.$PM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,p,b){if(this.a.size===0)throw new Error("No related information providers registered");const S=this.a.get(M);if(!S)throw new Error("related information provider not found");return await S.provideRelatedInformation(p,b)??[]}getRelatedInformation(M,p,b){return this.c.$getAiRelatedInformation(p,b)}registerRelatedInformationProvider(M,p,b){const S=this.b;return this.b++,this.a.set(S,b),this.c.$registerAiRelatedInformationProvider(S,p),new N.$RM(()=>{this.c.$unregisterAiRelatedInformationProvider(S),this.a.delete(S)})}}e.$1jc=L}),define(ke[120],Ee([1,0,4,6,8,25,145,5,20]),function(le,e,u,N,L,R,M,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=e.$_jc=void 0,e.$_jc=(0,p.$qi)("IExtHostAuthentication");let S=class{constructor($){this.b=new Map,this.c=new u.$be,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=$.getProxy(N.$PM.MainThreadAuthentication)}async getSession($,E,v,a={}){const m=R.$Lm.toKey($.identifier),o=[...v].sort().join(" ");return await this.d.getOrCreate(`${m} ${E} ${o}`,async()=>{await this.a.$ensureProvider(E);const n=$.displayName||$.name;return this.a.$getSession(E,v,m,n,a)})}async getSessions($,E,v){const a=R.$Lm.toKey($.identifier),m=[...v].sort().join(" ");return await this.f.getOrCreate(`${a} ${m}`,async()=>{await this.a.$ensureProvider(E);const o=$.displayName||$.name;return this.a.$getSessions(E,v,a,o)})}async removeSession($,E){const v=this.b.get($);return v?v.provider.removeSession(E):this.a.$removeSession($,E)}registerAuthenticationProvider($,E,v,a){if(this.b.get($))throw new Error(`An authentication provider with id '${$}' is already registered.`);this.b.set($,{label:E,provider:v,options:a??{supportsMultipleAccounts:!1}});const m=v.onDidChangeSessions(o=>this.a.$sendDidChangeSessions($,o));return this.a.$registerAuthenticationProvider($,E,a?.supportsMultipleAccounts??!1),new L.$RM(()=>{m.dispose(),this.b.delete($),this.a.$unregisterAuthenticationProvider($)})}$createSession($,E,v){const a=this.b.get($);if(a)return Promise.resolve(a.provider.createSession(E,v));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$removeSession($,E){const v=this.b.get($);if(v)return Promise.resolve(v.provider.removeSession(E));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$getSessions($,E){const v=this.b.get($);if(v)return Promise.resolve(v.provider.getSessions(E));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$onDidChangeAuthenticationSessions($,E){return $.startsWith(M.$RL)||this.c.fire({provider:{id:$,label:E}}),Promise.resolve()}};e.$akc=S,e.$akc=S=Je([qe(0,b.$aP)],S);class A{constructor(){this.a=new Map}getOrCreate($,E){const v=this.a.get($);if(v)return v;const a=E().finally(()=>this.a.delete($));return this.a.set($,a),a}}}),define(ke[151],Ee([1,0,2,6,8,5,20,12,19,14,17,26]),function(le,e,u,N,L,R,M,p,b,S,A,P){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=e.$_kc=void 0;let E=class{static{$=this}static{this.c=0}static{this.d=250}constructor(a,m){this.h=m,this.f=new Map,this.g=a.getProxy(N.$PM.MainThreadDecorations)}registerFileDecorationProvider(a,m){const o=$.c++;this.f.set(o,{provider:a,extensionDescription:m}),this.g.$registerDecorationProvider(o,m.identifier.value);const n=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const r=(0,b.$3b)(i);if(r.length<=$.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,r.length);const s=r.map(d=>({uri:d,rank:(0,S.$9e)(d.path,"/")})),t=(0,b.$zb)(s,(d,l)=>d.rank-l.rank||(0,S.$mf)(d.uri.path,l.uri.path)),f=[];e:for(const d of t){let l;for(const c of d){const h=(0,A.$nc)(c.uri.path);if(l!==h&&(l=h,f.push(c.uri)>=$.d))break e}}this.g.$onDidChange(o,f)});return new L.$RM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(a,m,o){if(!this.f.has(a))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(a);return await Promise.all(m.map(async s=>{try{const{uri:t,id:f}=s,d=await Promise.resolve(i.provideFileDecoration(u.URI.revive(t),o));if(!d)return;try{L.$eO.validate(d),d.badge&&typeof d.badge!="string"&&(0,P.$yG)(r,"codiconDecoration"),n[f]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),n}};e.$_kc=E,e.$_kc=E=$=Je([qe(0,M.$aP),qe(1,p.$Wj)],E),e.$alc=(0,R.$qi)("IExtHostDecorations")}),define(ke[325],Ee([1,0,13,2,8,6,15,22,14]),function(le,e,u,N,L,R,M,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;class S{static{this.a=0}constructor(P,$,E){this.d=$,this.e=E,this.b=new Map,this.c=P.getProxy(R.$PM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,$){if(Object.keys(M.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const E=S.a++;this.b.set(E,$),this.c.$registerTextContentProvider(E,P);let v;if(typeof $.onDidChange=="function"){let a;v=$.onDidChange(async m=>{if(m.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;a&&await a;const o=this.$provideTextDocumentContent(E,m).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(m);if(!i)return;const r=(0,b.$gf)(n);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(m,n)}).catch(u.$1).finally(()=>{a===o&&(a=void 0)});a=o})}return new L.$RM(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(P,$){const E=this.b.get(P);return E?Promise.resolve(E.provideTextDocumentContent(N.URI.revive($),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$clc=S}),define(ke[152],Ee([1,0,62,15,14,183,129,8,19]),function(le,e,u,N,L,R,M,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eP=e.$dP=void 0,e.$cP=A;const S=new Map;function A(v,a){a?S.set(v,a):S.delete(v)}function P(v){return S.get(v)}class $ extends R.$Pv{constructor(a,m,o,n,i,r,s){super(m,o,n,i),this.c=a,this.m=r,this.q=s,this.b=!1}dispose(){(0,u.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,b.$ub)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===N.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(m){return m?a.s(m):a.getText()},get eol(){return a.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(m){return a.t(m)},offsetAt(m){return a.u(m)},positionAt(m){return a.v(m)},validateRange(m){return a.w(m)},validatePosition(m){return a.x(m)},getWordRangeAtPosition(m,o){return a.y(m,o)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,u.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,u.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const m=this.w(a);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const o=this.g,n=m.start.line,i=m.end.line,r=[];r.push(this.f[n].substring(m.start.character));for(let s=n+1;s<i;s++)r.push(this.f[s]);return r.push(this.f[i].substring(0,m.end.character)),r.join(o)}t(a){let m;if(a instanceof p.$SM?m=a.line:typeof a=="number"&&(m=a),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new E(m,this.f[m],m===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const m=this.j.getIndexOf(a),o=this.f[m.index].length;return new p.$SM(m.index,Math.min(m.remainder,o))}w(a){if(!(a instanceof p.$TM))throw new Error("Invalid argument");const m=this.x(a.start),o=this.x(a.end);return m===a.start&&o===a.end?a:new p.$TM(m.line,m.character,o.line,o.character)}x(a){if(!(a instanceof p.$SM))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:m,character:o}=a,n=!1;if(m<0)m=0,o=0,n=!0;else if(m>=this.f.length)m=this.f.length-1,o=this.f[m].length,n=!0;else{const i=this.f[m].length;o<0?(o=0,n=!0):o>i&&(o=i,n=!0)}return n?new p.$SM(m,o):a}y(a,m){const o=this.x(a);if(!m)m=P(this.m);else if((0,L.$ff)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const n=(0,M.$Zs)(o.character+1,(0,M.$Xs)(m),this.f[o.line],0);if(n)return new p.$TM(o.line,n.startColumn-1,o.line,n.endColumn-1)}}e.$dP=$;class E{constructor(a,m,o){this.a=a,this.b=m,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$TM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$TM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$eP=E}),define(ke[326],Ee([1,0,6,8]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=void 0;class L{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(u.$PM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,p,b){if(this.a.size===0)throw new Error("No embedding vector providers registered");const S=this.a.get(M);if(!S)throw new Error("Embedding vector provider not found");const A=await S.provideEmbeddingVector(p,b);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(M,p,b){const S=this.b;return this.b++,this.a.set(S,b),this.c.$registerAiEmbeddingVectorProvider(p,S),new N.$RM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(S),this.a.delete(S)})}}e.$elc=L}),define(ke[69],Ee([1,0,6,32,8,21,5,20,60,3,7,23,15]),function(le,e,u,N,L,R,M,p,b,S,A,P,$){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=e.$pkc=void 0;let v=E=class{constructor(m,o){this.b=new Map,this.c=new A.$zh,this.a=m.getProxy(u.$PM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let r;const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),r=await s.impl.stat(i)):r=await n.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===N.FilePermission.Readonly?1:void 0}}catch(r){E.e(r)}},async readDirectory(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(r){return E.e(r)}},async createDirectory(i){try{const r=n.b.get(i.scheme);return r&&!r.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(r.impl,r.extUri,i)):await n.a.$mkdir(i)}catch(r){return E.e(r)}},async readFile(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(r){return E.e(r)}},async writeFile(i,r){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(s.impl,s.extUri,s.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(s.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,R.$Ce.wrap(r))}catch(s){return E.e(s)}},async delete(i,r){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly&&!r?.useTrash?(await n.a.$ensureActivation(i.scheme),await s.impl.delete(i,{recursive:!1,...r})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(s){return E.e(s)}},async rename(i,r,s){try{return await n.a.$rename(i,r,{overwrite:!1,...s})}catch(t){return E.e(t)}},async copy(i,r,s){try{return await n.a.$copy(i,r,{overwrite:!1,...s})}catch(t){return E.e(t)}},isWritableFileSystem(i){const r=o.getCapabilities(i);if(typeof r=="number")return!(r&2048)}})}async d(m,o,n){const i=[];for(;!o.isEqual(n,o.dirname(n));)try{if(!((await m.stat(n)).type&N.FileType.Directory))throw L.$8N.FileExists(`Unable to create folder '${n.scheme===$.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(N.$al(r)!==N.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(o.basename(n)),n=o.dirname(n)}for(let r=i.length-1;r>=0;r--){n=o.joinPath(n,i[r]);try{await m.createDirectory(n)}catch(s){if(N.$al(s)!==N.FileSystemProviderErrorCode.FileExists)throw s}}}static e(m){if(m instanceof L.$8N)throw m;if(m instanceof N.$9k)switch(m.code){case N.FileSystemProviderErrorCode.FileExists:throw L.$8N.FileExists(m.message);case N.FileSystemProviderErrorCode.FileNotFound:throw L.$8N.FileNotFound(m.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw L.$8N.FileNotADirectory(m.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw L.$8N.FileIsADirectory(m.message);case N.FileSystemProviderErrorCode.NoPermissions:throw L.$8N.NoPermissions(m.message);case N.FileSystemProviderErrorCode.Unavailable:throw L.$8N.Unavailable(m.message);default:throw new L.$8N(m.message,m.name)}if(!(m instanceof Error))throw new L.$8N(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw L.$8N.Unavailable(m.message);switch(m.name){case N.FileSystemProviderErrorCode.FileExists:throw L.$8N.FileExists(m.message);case N.FileSystemProviderErrorCode.FileNotFound:throw L.$8N.FileNotFound(m.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw L.$8N.FileNotADirectory(m.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw L.$8N.FileIsADirectory(m.message);case N.FileSystemProviderErrorCode.NoPermissions:throw L.$8N.NoPermissions(m.message);case N.FileSystemProviderErrorCode.Unavailable:throw L.$8N.Unavailable(m.message);default:throw new L.$8N(m.message,m.name)}}addFileSystemProvider(m,o,n){return this.b.set(m,{impl:o,extUri:n?.isCaseSensitive?P.$Tg:P.$Vg,isReadonly:!!n?.isReadonly}),(0,S.$Sc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??P.$Tg}};e.$pkc=v,e.$pkc=v=E=Je([qe(0,p.$aP),qe(1,b.$6jc)],v),e.$qkc=(0,M.$qi)("IExtHostConsumerFileSystem")}),define(ke[93],Ee([1,0,5,28,12,69,2]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=e.$rkc=void 0,e.$rkc=(0,u.$qi)("IExtensionStoragePaths");let p=class{constructor(S,A,P){this.d=A,this.f=P,this.a=S.workspace??void 0,this.b=S.environment,this.whenReady=this.h().then($=>this.c=$)}async g(S){return M.URI.joinPath(this.b.workspaceStorageHome,S)}async h(){if(!this.a)return Promise.resolve(void 0);const S=this.a.id,A=await this.g(S);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(M.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(S){if(this.c)return M.URI.joinPath(this.c,S.identifier.value)}globalValue(S){return M.URI.joinPath(this.b.globalStorageHome,S.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$skc=p,e.$skc=p=Je([qe(0,N.$qP),qe(1,L.$Wj),qe(2,R.$qkc)],p)}),define(ke[327],Ee([1,0,8,20,4]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=void 0;let R=class{constructor(p){this.a=new u.$fO(u.ColorThemeKind.Dark),this.b=new L.$be}get activeColorTheme(){return this.a}$onColorThemeChange(p){let b;switch(p){case"light":b=u.ColorThemeKind.Light;break;case"hcDark":b=u.ColorThemeKind.HighContrast;break;case"hcLight":b=u.ColorThemeKind.HighContrastLight;break;default:b=u.ColorThemeKind.Dark}this.a=new u.$fO(b),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Zlc=R,e.$Zlc=R=Je([qe(0,N.$aP)],R)}),define(ke[70],Ee([1,0,22,4,3,229,5,12,88,6,28,20,8]),function(le,e,u,N,L,R,M,p,b,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pCb=e.$oCb=e.TunnelDtoConverter=void 0;class E extends b.$cw{}var v;(function(m){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?b.TunnelPrivacyId.Public:b.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=o;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==b.TunnelPrivacyId.ConstantPrivate&&i.privacy!==b.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$oCb=(0,M.$qi)("IExtHostTunnelService");let a=class extends L.$Uc{constructor(o,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$be,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(S.$PM.MainThreadTunnelService)}async openTunnel(o,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,o.displayName);if(i){const r=new E(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,n){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:n}),this.a.$registerPortsAttributesProvider(o,i),new $.$RM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,n,i,r,s){const t=[];for(const d of o){const l=this.r.get(d);if(!l)return[];t.push(...await Promise.all(n.map(async c=>{let h;try{h=await l.provider.providePortAttributes({port:c,pid:i,commandLine:r},s)}catch{h=await l.provider.providePortAttributes(c,i,r,s)}return{providedAttributes:h,port:c}})))}const f=t.filter(d=>!!d.providedAttributes);return f.length>0?f.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,s)=>await o.provideTunnel(r,s,u.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,L.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,n){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const s=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(s)}}else this.b=void 0;return(0,L.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,n){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(n&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const s=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:s}),v.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),i=o.filter((r,s)=>n[s]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$pCb=a,e.$pCb=a=Je([qe(0,P.$aP),qe(1,A.$qP),qe(2,p.$Wj)],a)}),define(ke[16],Ee([1,0,19,21,172,74,80,27,165,58,101,24,167,23,18,2,29,83,138,144,142,291,119,68,89,303,26,8]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f,d,l,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$0O=B,e.$$O=Z,e.$_O=x;var g;(function(Ne){function je(_){const{selectionStartLineNumber:Oe,selectionStartColumn:Ke,positionLineNumber:_e,positionColumn:Qe}=_,ht=new h.$SM(Oe-1,Ke-1),Et=new h.$SM(_e-1,Qe-1);return new h.$UM(ht,Et)}Ne.to=je;function ye(_){const{anchor:Oe,active:Ke}=_;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}Ne.from=ye})(g||(e.Selection=g={}));var D;(function(Ne){function je(_){if(!_)return;const{start:Oe,end:Ke}=_;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}Ne.from=je;function ye(_){if(!_)return;const{startLineNumber:Oe,startColumn:Ke,endLineNumber:_e,endColumn:Qe}=_;return new h.$TM(Oe-1,Ke-1,_e-1,Qe-1)}Ne.to=ye})(D||(e.Range=D={}));var w;(function(Ne){function je(_){return{uri:_.uri,range:D.from(_.range)}}Ne.from=je;function ye(_){return new h.$4M(a.URI.revive(_.uri),D.to(_.range))}Ne.to=ye})(w||(e.Location=w={}));var k;(function(Ne){function je(ye){switch(ye){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}Ne.to=je})(k||(e.TokenType=k={}));var y;(function(Ne){function je(_){return new h.$SM(_.lineNumber-1,_.column-1)}Ne.to=je;function ye(_){return{lineNumber:_.line+1,column:_.character+1}}Ne.from=ye})(y||(e.Position=y={}));var C;(function(Ne){function je(Oe,Ke,_e){return(0,u.$Hb)((0,u.$3b)(Oe).map(Qe=>ye(Qe,Ke,_e)))}Ne.from=je;function ye(Oe,Ke,_e){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:_e?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:_(Oe.scheme,Ke),pattern:Ie.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:_e?.isBuiltin}}function _(Oe,Ke){return Ke&&typeof Oe=="string"?Ke.transformOutgoingScheme(Oe):Oe}})(C||(e.DocumentSelector=C={}));var I;(function(Ne){function je(_){switch(_){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}Ne.from=je;function ye(_){switch(_){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}Ne.to=ye})(I||(e.DiagnosticTag=I={}));var F;(function(Ne){function je(_){let Oe;return _.code&&((0,v.$4f)(_.code)||(0,v.$8f)(_.code)?Oe=String(_.code):Oe={value:String(_.code.value),target:_.code.target}),{...D.from(_.range),message:_.message,source:_.source,code:Oe,severity:z.from(_.severity),relatedInformation:_.relatedInformation&&_.relatedInformation.map(j.from),tags:Array.isArray(_.tags)?(0,u.$Hb)(_.tags.map(I.from)):void 0}}Ne.from=je;function ye(_){const Oe=new h.$6M(D.to(_),_.message,z.to(_.severity));return Oe.source=_.source,Oe.code=(0,v.$4f)(_.code)?_.code:_.code?.value,Oe.relatedInformation=_.relatedInformation&&_.relatedInformation.map(j.to),Oe.tags=_.tags&&(0,u.$Hb)(_.tags.map(I.to)),Oe}Ne.to=ye})(F||(e.Diagnostic=F={}));var j;(function(Ne){function je(_){return{...D.from(_.location.range),message:_.message,resource:_.location.uri}}Ne.from=je;function ye(_){return new h.$5M(new h.$4M(_.resource,D.to(_)),_.message)}Ne.to=ye})(j||(e.DiagnosticRelatedInformation=j={}));var z;(function(Ne){function je(_){switch(_){case h.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Ne.from=je;function ye(_){switch(_){case n.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}Ne.to=ye})(z||(e.DiagnosticSeverity=z={}));var O;(function(Ne){function je(_){return typeof _=="number"&&_>=h.ViewColumn.One?_-1:_===h.ViewColumn.Beside?l.$OD:l.$ND}Ne.from=je;function ye(_){if(typeof _=="number"&&_>=0)return _+1;throw new Error("invalid 'EditorGroupColumn'")}Ne.to=ye})(O||(e.ViewColumn=O={}));function T(Ne){return typeof Ne.range<"u"}function B(Ne){return Ne.length===0?!0:!!T(Ne[0])}var W;(function(Ne){function je(Qe){return Qe.map(Ne.from)}Ne.fromMany=je;function ye(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function _(Qe){let ht;if(ye(Qe)){const{language:ut,value:Yt}=Qe;ht={value:"```"+ut+`
`+Yt+"\n```\n"}}else h.$gN.isMarkdownString(Qe)?ht={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ht={value:Qe}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const Ft=ut=>{try{let Yt=a.URI.parse(ut,!0);Yt=Yt.with({query:Oe(Yt.query,Et)}),Et[ut]=Yt}catch{}return""},Xt=new b.marked.Renderer;return Xt.link=Ft,Xt.image=ut=>typeof ut=="string"?Ft(M.$Vk(ut).href):"",(0,b.marked)(ht.value,{renderer:Xt}),ht}Ne.from=_;function Oe(Qe,ht){if(!Qe)return Qe;let Et;try{Et=(0,S.$Yh)(Qe)}catch{}if(!Et)return Qe;let Ft=!1;return Et=(0,P.$Yn)(Et,Xt=>{if(a.URI.isUri(Xt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[ut]=Xt,Ft=!0,ut}else return}),Ft?JSON.stringify(Et):Qe}function Ke(Qe){const ht=new h.$gN(Qe.value,Qe.supportThemeIcons);return ht.isTrusted=Qe.isTrusted,ht.supportHtml=Qe.supportHtml,ht.baseUri=Qe.baseUri?a.URI.from(Qe.baseUri):void 0,ht}Ne.to=Ke;function _e(Qe){if(Qe)return typeof Qe=="string"?Qe:Ne.from(Qe)}Ne.fromStrict=_e})(W||(e.MarkdownString=W={}));function Z(Ne){return B(Ne)?Ne.map(je=>({range:D.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?W.fromMany(je.hoverMessage):je.hoverMessage?W.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Ne.map(je=>({range:D.from(je)}))}function x(Ne){return typeof Ne>"u"?Ne:typeof Ne=="string"?a.URI.file(Ne):Ne}var X;(function(Ne){function je(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?x(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Ne.from=je})(X||(e.ThemableDecorationAttachmentRenderOptions=X={}));var Y;(function(Ne){function je(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?x(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?X.from(ye.before):void 0,after:ye.after?X.from(ye.after):void 0}}Ne.from=je})(Y||(e.ThemableDecorationRenderOptions=Y={}));var ce;(function(Ne){function je(ye){if(typeof ye>"u")return ye;switch(ye){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}Ne.from=je})(ce||(e.DecorationRangeBehavior=ce={}));var ne;(function(Ne){function je(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?ce.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?Y.from(ye.light):void 0,dark:ye.dark?Y.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?x(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?X.from(ye.before):void 0,after:ye.after?X.from(ye.after):void 0}}Ne.from=je})(ne||(e.DecorationRenderOptions=ne={}));var $e;(function(Ne){function je(_){return{text:_.newText,eol:_.newEol&&He.from(_.newEol),range:D.from(_.range)}}Ne.from=je;function ye(_){const Oe=new h.$YM(D.to(_.range),_.text);return Oe.newEol=typeof _.eol>"u"?void 0:He.to(_.eol),Oe}Ne.to=ye})($e||(e.TextEdit=$e={}));var Ce;(function(Ne){function je(_,Oe){const Ke={edits:[]};if(_ instanceof h.$2M){const _e=new p.$Cc;for(const Qe of _._allEntries())Qe._type===1&&a.URI.isUri(Qe.to)&&Qe.from===void 0&&_e.add(Qe.to);for(const Qe of _._allEntries())if(Qe._type===1){let ht;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ht={type:"base64",value:(0,N.$We)(N.$Ce.wrap(Qe.options.contents))}:ht={type:"dataTransferItem",id:Qe.options.contents._itemId}),Ke.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ht},metadata:Qe.metadata})}else Qe._type===2?Ke.edits.push({resource:Qe.uri,textEdit:$e.from(Qe.edit),versionId:_e.has(Qe.uri)?void 0:Oe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?Ke.edits.push({resource:Qe.uri,textEdit:{range:D.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:_e.has(Qe.uri)?void 0:Oe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?Ke.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&Ke.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(Kt.from)}})}return Ke}Ne.from=je;function ye(_){const Oe=new h.$2M,Ke=new p.$Bc;for(const _e of _.edits)if(_e.textEdit){const Qe=_e,ht=a.URI.revive(Qe.resource),Et=D.to(Qe.textEdit.range),Ft=Qe.textEdit.text,Xt=Qe.textEdit.insertAsSnippet;let ut;Xt?ut=h.$1M.replace(Et,new h.$3M(Ft)):ut=h.$YM.replace(Et,Ft);const Yt=Ke.get(ht);Yt?Yt.push(ut):Ke.set(ht,[ut])}else Oe.renameFile(a.URI.revive(_e.oldResource),a.URI.revive(_e.newResource),_e.options);for(const[_e,Qe]of Ke)Oe.set(_e,Qe);return Oe}Ne.to=ye})(Ce||(e.WorkspaceEdit=Ce={}));var ee;(function(Ne){const je=Object.create(null);je[h.SymbolKind.File]=0,je[h.SymbolKind.Module]=1,je[h.SymbolKind.Namespace]=2,je[h.SymbolKind.Package]=3,je[h.SymbolKind.Class]=4,je[h.SymbolKind.Method]=5,je[h.SymbolKind.Property]=6,je[h.SymbolKind.Field]=7,je[h.SymbolKind.Constructor]=8,je[h.SymbolKind.Enum]=9,je[h.SymbolKind.Interface]=10,je[h.SymbolKind.Function]=11,je[h.SymbolKind.Variable]=12,je[h.SymbolKind.Constant]=13,je[h.SymbolKind.String]=14,je[h.SymbolKind.Number]=15,je[h.SymbolKind.Boolean]=16,je[h.SymbolKind.Array]=17,je[h.SymbolKind.Object]=18,je[h.SymbolKind.Key]=19,je[h.SymbolKind.Null]=20,je[h.SymbolKind.EnumMember]=21,je[h.SymbolKind.Struct]=22,je[h.SymbolKind.Event]=23,je[h.SymbolKind.Operator]=24,je[h.SymbolKind.TypeParameter]=25;function ye(Oe){return typeof je[Oe]=="number"?je[Oe]:6}Ne.from=ye;function _(Oe){for(const Ke in je)if(je[Ke]===Oe)return Number(Ke);return h.SymbolKind.Property}Ne.to=_})(ee||(e.SymbolKind=ee={}));var U;(function(Ne){function je(_){switch(_){case h.SymbolTag.Deprecated:return 1}}Ne.from=je;function ye(_){switch(_){case 1:return h.SymbolTag.Deprecated}}Ne.to=ye})(U||(e.SymbolTag=U={}));var ie;(function(Ne){function je(_){return{name:_.name,kind:ee.from(_.kind),tags:_.tags&&_.tags.map(U.from),containerName:_.containerName,location:re.from(_.location)}}Ne.from=je;function ye(_){const Oe=new h.$0M(_.name,ee.to(_.kind),_.containerName,re.to(_.location));return Oe.tags=_.tags&&_.tags.map(U.to),Oe}Ne.to=ye})(ie||(e.WorkspaceSymbol=ie={}));var be;(function(Ne){function je(_){const Oe={name:_.name||"!!MISSING: name!!",detail:_.detail,range:D.from(_.range),selectionRange:D.from(_.selectionRange),kind:ee.from(_.kind),tags:_.tags?.map(U.from)??[]};return _.children&&(Oe.children=_.children.map(je)),Oe}Ne.from=je;function ye(_){const Oe=new h.$$M(_.name,_.detail,ee.to(_.kind),D.to(_.range),D.to(_.selectionRange));return(0,u.$Lb)(_.tags)&&(Oe.tags=_.tags.map(U.to)),_.children&&(Oe.children=_.children.map(ye)),Oe}Ne.to=ye})(be||(e.DocumentSymbol=be={}));var Pe;(function(Ne){function je(_){const Oe=new h.$cN(ee.to(_.kind),_.name,_.detail||"",a.URI.revive(_.uri),D.to(_.range),D.to(_.selectionRange));return Oe._sessionId=_._sessionId,Oe._itemId=_._itemId,Oe}Ne.to=je;function ye(_,Oe,Ke){if(Oe=Oe??_._sessionId,Ke=Ke??_._itemId,Oe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ke,name:_.name,detail:_.detail,kind:ee.from(_.kind),uri:_.uri,range:D.from(_.range),selectionRange:D.from(_.selectionRange),tags:_.tags?.map(U.from)}}Ne.from=ye})(Pe||(e.CallHierarchyItem=Pe={}));var oe;(function(Ne){function je(ye){return new h.$dN(Pe.to(ye.from),ye.fromRanges.map(_=>D.to(_)))}Ne.to=je})(oe||(e.CallHierarchyIncomingCall=oe={}));var ae;(function(Ne){function je(ye){return new h.$eN(Pe.to(ye.to),ye.fromRanges.map(_=>D.to(_)))}Ne.to=je})(ae||(e.CallHierarchyOutgoingCall=ae={}));var re;(function(Ne){function je(_){return{range:_.range&&D.from(_.range),uri:_.uri}}Ne.from=je;function ye(_){return new h.$4M(a.URI.revive(_.uri),D.to(_.range))}Ne.to=ye})(re||(e.location=re={}));var G;(function(Ne){function je(_){const Oe=_,Ke=_;return{originSelectionRange:Oe.originSelectionRange?D.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Ke.uri,range:D.from(Oe.targetRange?Oe.targetRange:Ke.range),targetSelectionRange:Oe.targetSelectionRange?D.from(Oe.targetSelectionRange):void 0}}Ne.from=je;function ye(_){return{targetUri:a.URI.revive(_.uri),targetRange:D.to(_.range),targetSelectionRange:_.targetSelectionRange?D.to(_.targetSelectionRange):void 0,originSelectionRange:_.originSelectionRange?D.to(_.originSelectionRange):void 0}}Ne.to=ye})(G||(e.DefinitionLink=G={}));var te;(function(Ne){function je(_){return{range:D.from(_.range),contents:W.fromMany(_.contents)}}Ne.from=je;function ye(_){return new h.$7M(_.contents.map(W.to),D.to(_.range))}Ne.to=ye})(te||(e.Hover=te={}));var ge;(function(Ne){function je(_){return{range:D.from(_.range),expression:_.expression}}Ne.from=je;function ye(_){return new h.$2N(D.to(_.range),_.expression)}Ne.to=ye})(ge||(e.EvaluatableExpression=ge={}));var we;(function(Ne){function je(_){if(_ instanceof h.$3N)return{type:"text",range:D.from(_.range),text:_.text};if(_ instanceof h.$4N)return{type:"variable",range:D.from(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};if(_ instanceof h.$5N)return{type:"expression",range:D.from(_.range),expression:_.expression};throw new Error("Unknown 'InlineValue' type")}Ne.from=je;function ye(_){switch(_.type){case"text":return{range:D.to(_.range),text:_.text};case"variable":return{range:D.to(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};case"expression":return{range:D.to(_.range),expression:_.expression}}}Ne.to=ye})(we||(e.InlineValue=we={}));var Re;(function(Ne){function je(_){return{frameId:_.frameId,stoppedLocation:D.from(_.stoppedLocation)}}Ne.from=je;function ye(_){return new h.$6N(_.frameId,D.to(_.stoppedLocation))}Ne.to=ye})(Re||(e.InlineValueContext=Re={}));var fe;(function(Ne){function je(_){return{range:D.from(_.range),kind:_.kind}}Ne.from=je;function ye(_){return new h.$8M(D.to(_.range),_.kind)}Ne.to=ye})(fe||(e.DocumentHighlight=fe={}));var Se;(function(Ne){function je(_){return{uri:_.uri,highlights:_.highlights.map(fe.from)}}Ne.from=je;function ye(_){return new h.$9M(a.URI.revive(_.uri),_.highlights.map(fe.to))}Ne.to=ye})(Se||(e.MultiDocumentHighlight=Se={}));var Ae;(function(Ne){function je(ye){switch(ye){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}Ne.to=je})(Ae||(e.CompletionTriggerKind=Ae={}));var Fe;(function(Ne){function je(ye){return{triggerKind:Ae.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Ne.to=je})(Fe||(e.CompletionContext=Fe={}));var q;(function(Ne){function je(_){switch(_){case h.CompletionItemTag.Deprecated:return 1}}Ne.from=je;function ye(_){switch(_){case 1:return h.CompletionItemTag.Deprecated}}Ne.to=ye})(q||(e.CompletionItemTag=q={}));var V;(function(Ne){const je=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function ye(Ke){return je.get(Ke)??9}Ne.from=ye;const _=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Oe(Ke){return _.get(Ke)??h.CompletionItemKind.Property}Ne.to=Oe})(V||(e.CompletionItemKind=V={}));var Q;(function(Ne){function je(ye,_){const Oe=new h.$mN(ye.label);return Oe.insertText=ye.insertText,Oe.kind=V.to(ye.kind),Oe.tags=ye.tags?.map(q.to),Oe.detail=ye.detail,Oe.documentation=M.$Pk(ye.documentation)?W.to(ye.documentation):ye.documentation,Oe.sortText=ye.sortText,Oe.filterText=ye.filterText,Oe.preselect=ye.preselect,Oe.commitCharacters=ye.commitCharacters,m.$kt.isIRange(ye.range)?Oe.range=D.to(ye.range):typeof ye.range=="object"&&(Oe.range={inserting:D.to(ye.range.insert),replacing:D.to(ye.range.replace)}),Oe.keepWhitespace=typeof ye.insertTextRules>"u"?!1:!!(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?Oe.insertText=new h.$3M(ye.insertText):(Oe.insertText=ye.insertText,Oe.textEdit=Oe.range instanceof h.$TM?new h.$YM(Oe.range,Oe.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Oe.additionalTextEdits=ye.additionalTextEdits.map(Ke=>$e.to(Ke))),Oe.command=_&&ye.command?_.fromInternal(ye.command):void 0,Oe}Ne.to=je})(Q||(e.CompletionItem=Q={}));var J;(function(Ne){function je(_){if(typeof _.label!="string"&&!Array.isArray(_.label))throw new TypeError("Invalid label");return{label:_.label,documentation:W.fromStrict(_.documentation)}}Ne.from=je;function ye(_){return{label:_.label,documentation:M.$Pk(_.documentation)?W.to(_.documentation):_.documentation}}Ne.to=ye})(J||(e.ParameterInformation=J={}));var he;(function(Ne){function je(_){return{label:_.label,documentation:W.fromStrict(_.documentation),parameters:Array.isArray(_.parameters)?_.parameters.map(J.from):[],activeParameter:_.activeParameter}}Ne.from=je;function ye(_){return{label:_.label,documentation:M.$Pk(_.documentation)?W.to(_.documentation):_.documentation,parameters:Array.isArray(_.parameters)?_.parameters.map(J.to):[],activeParameter:_.activeParameter}}Ne.to=ye})(he||(e.SignatureInformation=he={}));var pe;(function(Ne){function je(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(he.from):[]}}Ne.from=je;function ye(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(he.to):[]}}Ne.to=ye})(pe||(e.SignatureHelp=pe={}));var ze;(function(Ne){function je(ye,_){const Oe=new h.$lN(y.to(_.position),typeof _.label=="string"?_.label:_.label.map(Ve.to.bind(void 0,ye)),_.kind&&Ze.to(_.kind));return Oe.textEdits=_.textEdits&&_.textEdits.map($e.to),Oe.tooltip=M.$Pk(_.tooltip)?W.to(_.tooltip):_.tooltip,Oe.paddingLeft=_.paddingLeft,Oe.paddingRight=_.paddingRight,Oe}Ne.to=je})(ze||(e.InlayHint=ze={}));var Ve;(function(Ne){function je(ye,_){const Oe=new h.$kN(_.label);return Oe.tooltip=M.$Pk(_.tooltip)?W.to(_.tooltip):_.tooltip,o.Command.is(_.command)&&(Oe.command=ye.fromInternal(_.command)),_.location&&(Oe.location=re.to(_.location)),Oe}Ne.to=je})(Ve||(e.InlayHintLabelPart=Ve={}));var Ze;(function(Ne){function je(_){return _}Ne.from=je;function ye(_){return _}Ne.to=ye})(Ze||(e.InlayHintKind=Ze={}));var tt;(function(Ne){function je(_){return{range:D.from(_.range),url:_.target,tooltip:_.tooltip}}Ne.from=je;function ye(_){let Oe;if(_.url)try{Oe=typeof _.url=="string"?a.URI.parse(_.url,!0):a.URI.revive(_.url)}catch{}return new h.$rN(D.to(_.range),Oe)}Ne.to=ye})(tt||(e.DocumentLink=tt={}));var ot;(function(Ne){function je(_){const Oe=new h.$uN(_.label);return _.textEdit&&(Oe.textEdit=$e.to(_.textEdit)),_.additionalTextEdits&&(Oe.additionalTextEdits=_.additionalTextEdits.map(Ke=>$e.to(Ke))),Oe}Ne.to=je;function ye(_){return{label:_.label,textEdit:_.textEdit?$e.from(_.textEdit):void 0,additionalTextEdits:_.additionalTextEdits?_.additionalTextEdits.map(Oe=>$e.from(Oe)):void 0}}Ne.from=ye})(ot||(e.ColorPresentation=ot={}));var it;(function(Ne){function je(_){return new h.$sN(_[0],_[1],_[2],_[3])}Ne.to=je;function ye(_){return[_.red,_.green,_.blue,_.alpha]}Ne.from=ye})(it||(e.Color=it={}));var st;(function(Ne){function je(_){return{range:D.from(_.range)}}Ne.from=je;function ye(_){return new h.$bN(D.to(_.range))}Ne.to=ye})(st||(e.SelectionRange=st={}));var De;(function(Ne){function je(ye){switch(ye){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}Ne.to=je})(De||(e.TextDocumentSaveReason=De={}));var Be;(function(Ne){function je(_){switch(_){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.Interval:return 3;case h.TextEditorLineNumbersStyle.On:default:return 1}}Ne.from=je;function ye(_){switch(_){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 3:return h.TextEditorLineNumbersStyle.Interval;case 1:default:return h.TextEditorLineNumbersStyle.On}}Ne.to=ye})(Be||(e.TextEditorLineNumbersStyle=Be={}));var He;(function(Ne){function je(_){if(_===h.EndOfLine.CRLF)return 1;if(_===h.EndOfLine.LF)return 0}Ne.from=je;function ye(_){if(_===1)return h.EndOfLine.CRLF;if(_===0)return h.EndOfLine.LF}Ne.to=ye})(He||(e.EndOfLine=He={}));var Le;(function(Ne){function je(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ne.from=je})(Le||(e.ProgressLocation=Le={}));var Xe;(function(Ne){function je(_){const Oe={start:_.start+1,end:_.end+1};return _.kind&&(Oe.kind=se.from(_.kind)),Oe}Ne.from=je;function ye(_){const Oe={start:_.start-1,end:_.end-1};return _.kind&&(Oe.kind=se.to(_.kind)),Oe}Ne.to=ye})(Xe||(e.FoldingRange=Xe={}));var se;(function(Ne){function je(_){if(_)switch(_){case h.FoldingRangeKind.Comment:return o.$6t.Comment;case h.FoldingRangeKind.Imports:return o.$6t.Imports;case h.FoldingRangeKind.Region:return o.$6t.Region}}Ne.from=je;function ye(_){if(_)switch(_.value){case o.$6t.Comment.value:return h.FoldingRangeKind.Comment;case o.$6t.Imports.value:return h.FoldingRangeKind.Imports;case o.$6t.Region.value:return h.FoldingRangeKind.Region}}Ne.to=ye})(se||(e.FoldingRangeKind=se={}));var ue;(function(Ne){function je(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?D.from(ye.selection):void 0,override:typeof ye.override=="boolean"?r.$eF.id:void 0}}Ne.from=je})(ue||(e.TextEditorOpenOptions=ue={}));var Ie;(function(Ne){function je(Ke){return Ke instanceof h.$PN?Ke.toJSON():typeof Ke=="string"?Ke:ye(Ke)||_(Ke)?new h.$PN(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}Ne.from=je;function ye(Ke){const _e=Ke;return _e?a.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function _(Ke){const _e=Ke;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Oe(Ke){return typeof Ke=="string"?Ke:new h.$PN(a.URI.revive(Ke.baseUri),Ke.pattern)}Ne.to=Oe})(Ie||(e.GlobPattern=Ie={}));var Ge;(function(Ne){function je(ye){if(ye){if(Array.isArray(ye))return ye.map(je);if(typeof ye=="string")return ye;{const _=ye;return{language:_.language,scheme:_.scheme,pattern:Ie.from(_.pattern),exclusive:_.exclusive,notebookType:_.notebookType}}}else return}Ne.from=je})(Ge||(e.LanguageSelector=Ge={}));var Me;(function(Ne){function je(_){return!!_&&typeof _=="object"&&"documents"in _&&Array.isArray(_.documents)&&_.documents.every(Oe=>Array.isArray(Oe)&&Oe.every(Ke=>Ke&&typeof Ke=="object"&&"uri"in Ke&&a.URI.isUri(Ke.uri)&&"version"in Ke&&typeof Ke.version=="number"&&"ranges"in Ke&&Array.isArray(Ke.ranges)&&Ke.ranges.every(_e=>_e instanceof h.$TM)))}Ne.is=je;function ye(_){return{documents:_.documents.map(Oe=>Oe.map(Ke=>({uri:a.URI.from(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(_e=>D.from(_e))})))}}Ne.from=ye})(Me||(e.MappedEditsContext=Me={}));var nt;(function(Ne){function je(_){return{start:_.start,end:_.end}}Ne.from=je;function ye(_){return new h.$gO(_.start,_.end)}Ne.to=ye})(nt||(e.NotebookRange=nt={}));var lt;(function(Ne){function je(_){return{timing:typeof _.runStartTime=="number"&&typeof _.runEndTime=="number"?{startTime:_.runStartTime,endTime:_.runEndTime}:void 0,executionOrder:_.executionOrder,success:_.lastRunSuccess}}Ne.to=je;function ye(_){return{lastRunSuccess:_.success,runStartTime:_.timing?.startTime,runEndTime:_.timing?.endTime,executionOrder:_.executionOrder}}Ne.from=ye})(lt||(e.NotebookCellExecutionSummary=lt={}));var wt;(function(Ne){function je(ye){if(ye===t.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(ye===t.NotebookCellExecutionState.Pending)return;if(ye===t.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Ne.to=je})(wt||(e.NotebookCellExecutionState=wt={}));var It;(function(Ne){function je(_){switch(_){case h.NotebookCellKind.Markup:return t.CellKind.Markup;case h.NotebookCellKind.Code:default:return t.CellKind.Code}}Ne.from=je;function ye(_){switch(_){case t.CellKind.Markup:return h.NotebookCellKind.Markup;case t.CellKind.Code:default:return h.NotebookCellKind.Code}}Ne.to=ye})(It||(e.NotebookCellKind=It={}));var jt;(function(Ne){function je(_){const Oe={metadata:_.metadata??Object.create(null),cells:[]};for(const Ke of _.cells)h.$hO.validate(Ke),Oe.cells.push(Kt.from(Ke));return Oe}Ne.from=je;function ye(_){const Oe=new h.$iO(_.cells.map(Kt.to));return(0,v.$eg)(_.metadata)||(Oe.metadata=_.metadata),Oe}Ne.to=ye})(jt||(e.NotebookData=jt={}));var Kt;(function(Ne){function je(_){return{cellKind:It.from(_.kind),language:_.languageId,mime:_.mime,source:_.value,metadata:_.metadata,internalMetadata:lt.from(_.executionSummary??{}),outputs:_.outputs?_.outputs.map(St.from):[]}}Ne.from=je;function ye(_){return new h.$hO(It.to(_.cellKind),_.source,_.language,_.mime,_.outputs?_.outputs.map(St.to):void 0,_.metadata,_.internalMetadata?lt.to(_.internalMetadata):void 0)}Ne.to=ye})(Kt||(e.NotebookCellData=Kt={}));var xt;(function(Ne){function je(_){return{mime:_.mime,valueBytes:N.$Ce.wrap(_.data)}}Ne.from=je;function ye(_){return new h.$jO(_.valueBytes.buffer,_.mime)}Ne.to=ye})(xt||(e.NotebookCellOutputItem=xt={}));var St;(function(Ne){function je(_){return{outputId:_.id,items:_.items.map(xt.from),metadata:_.metadata}}Ne.from=je;function ye(_){const Oe=_.items.map(xt.to);return new h.$kO(Oe,_.outputId,_.metadata)}Ne.to=ye})(St||(e.NotebookCellOutput=St={}));var qt;(function(Ne){function je(Oe){return _(Oe)?{include:Ie.from(Oe.include)??void 0,exclude:Ie.from(Oe.exclude)??void 0}:Ie.from(Oe)??void 0}Ne.from=je;function ye(Oe){return _(Oe)?{include:Ie.to(Oe.include),exclude:Ie.to(Oe.exclude)}:Ie.to(Oe)}Ne.to=ye;function _(Oe){const Ke=Oe;return Ke?!(0,v.$ag)(Ke.include)&&!(0,v.$ag)(Ke.exclude):!1}})(qt||(e.NotebookExclusiveDocumentPattern=qt={}));var Ht;(function(Ne){function je(ye,_,Oe){const Ke=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:_.toInternal(Ke,Oe),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Ne.from=je})(Ht||(e.NotebookStatusBarItem=Ht={}));var et;(function(Ne){function je(ye,_,Oe){const Ke=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:_.toInternal(Ke,Oe),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Ne.from=je})(et||(e.NotebookKernelSourceAction=et={}));var ri;(function(Ne){function je(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Ne.from=je})(ri||(e.NotebookDocumentContentOptions=ri={}));var _t;(function(Ne){function je(_){return{uri:_.uri,provides:_.provides}}Ne.from=je;function ye(_){return new h.$mO(a.URI.revive(_.uri),_.provides)}Ne.to=ye})(_t||(e.NotebookRendererScript=_t={}));var ft;(function(Ne){function je(_){return{message:W.fromStrict(_.message)||"",type:0,expected:_.expectedOutput,actual:_.actualOutput,contextValue:_.contextValue,location:_.location&&{range:D.from(_.location.range),uri:_.location.uri}}}Ne.from=je;function ye(_){const Oe=new h.$sO(typeof _.message=="string"?_.message:W.to(_.message));return Oe.actualOutput=_.actual,Oe.expectedOutput=_.expected,Oe.contextValue=_.contextValue,Oe.location=_.location?re.to(_.location):void 0,Oe}Ne.to=ye})(ft||(e.TestMessage=ft={}));var $t;(function(Ne){Ne.namespace=d.$GL,Ne.denamespace=d.$HL})($t||(e.TestTag=$t={}));var ei;(function(Ne){function je(_){const Oe=(0,i.$9O)(_).controllerId;return{extId:f.$BL.fromExtHostTestItem(_,Oe).toString(),label:_.label,uri:a.URI.revive(_.uri),busy:_.busy,tags:_.tags.map(Ke=>$t.namespace(Oe,Ke.id)),range:m.$kt.lift(D.from(_.range)),description:_.description||null,sortText:_.sortText||null,error:_.error&&W.fromStrict(_.error)||null}}Ne.from=je;function ye(_){return{parent:void 0,error:void 0,id:f.$BL.fromString(_.extId).localId,label:_.label,uri:a.URI.revive(_.uri),tags:(_.tags||[]).map(Oe=>{const{tagId:Ke}=$t.denamespace(Oe);return new h.$tO(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(_.range||void 0),canResolveChildren:!1,busy:_.busy,description:_.description||void 0,sortText:_.sortText||void 0}}Ne.toPlain=ye})(ei||(e.TestItem=ei={})),function(Ne){function je(_){return{id:_.id}}Ne.from=je;function ye(_){return new h.$tO(_.id)}Ne.to=ye}($t||(e.TestTag=$t={}));var ti;(function(Ne){const je=(_,Oe)=>{const Ke=_.value;if(!Ke)return;const _e={...ei.toPlain(Ke.item),parent:Oe,taskStates:Ke.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ht=>ht.type===0).map(ft.to)})),children:[]};if(_.children)for(const Qe of _.children.values()){const ht=je(Qe,_e);ht&&_e.children.push(ht)}return _e};function ye(_){const Oe=new $.$2O;for(const Qe of _.items)Oe.insert(f.$BL.fromString(Qe.item.extId).path,Qe);const Ke=[Oe.nodes],_e=[];for(;Ke.length;)for(const Qe of Ke.pop())Qe.value?_e.push(Qe):Qe.children&&Ke.push(Qe.children.values());return{completedAt:_.completedAt,results:_e.map(Qe=>je(Qe)).filter(v.$_f)}}Ne.to=ye})(ti||(e.TestResults=ti={}));var zt;(function(Ne){function je(Ke){return{covered:Ke.covered,total:Ke.total}}function ye(Ke){return"line"in Ke?y.from(Ke):D.from(Ke)}function _(Ke){if(typeof Ke.executed=="number"&&Ke.executed<0)throw new Error(`Invalid coverage count ${Ke.executed}`);return"branches"in Ke?{count:Ke.executed,location:ye(Ke.location),type:1,branches:Ke.branches.length?Ke.branches.map(_e=>({count:_e.executed,location:_e.location&&ye(_e.location),label:_e.label})):void 0}:{type:0,name:Ke.name,count:Ke.executed,location:ye(Ke.location)}}Ne.fromDetails=_;function Oe(Ke,_e){return h.$vO(_e.statementCoverage),h.$vO(_e.branchCoverage),h.$vO(_e.declarationCoverage),{id:Ke,uri:_e.uri,statement:je(_e.statementCoverage),branch:_e.branchCoverage&&je(_e.branchCoverage),declaration:_e.declarationCoverage&&je(_e.declarationCoverage)}}Ne.fromFile=Oe})(zt||(e.TestCoverage=zt={}));var gt;(function(Ne){function je(ye){switch(ye){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}Ne.to=je})(gt||(e.CodeActionTriggerKind=gt={}));var Bt;(function(Ne){function je(_){const Oe=new h.$AO(ee.to(_.kind),_.name,_.detail||"",a.URI.revive(_.uri),D.to(_.range),D.to(_.selectionRange));return Oe._sessionId=_._sessionId,Oe._itemId=_._itemId,Oe}Ne.to=je;function ye(_,Oe,Ke){if(Oe=Oe??_._sessionId,Ke=Ke??_._itemId,Oe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Ke,kind:ee.from(_.kind),name:_.name,detail:_.detail??"",uri:_.uri,range:D.from(_.range),selectionRange:D.from(_.selectionRange),tags:_.tags?.map(U.from)}}Ne.from=ye})(Bt||(e.TypeHierarchyItem=Bt={}));var ii;(function(Ne){function je(ye){if(ye)return{value:ye.value,tooltip:ye.tooltip}}Ne.from=je})(ii||(e.ViewBadge=ii={}));var Ot;(function(Ne){function je(Ke,_e,Qe){const ht=_e.fileData;return ht?new h.$HN(new h.$IN(ht.name,a.URI.revive(ht.uri),ht.id,(0,R.$db)(()=>Qe(ht.id)))):Ke===A.$Hs.uriList&&_e.uriListData?new h.$GN(Oe(_e.uriListData)):new h.$GN(_e.asString)}Ne.to=je;async function ye(Ke,_e){const Qe=await _e.asString();if(Ke===A.$Hs.uriList)return{asString:Qe,fileData:void 0,uriListData:_(Qe)};const ht=_e.asFile();return{asString:Qe,fileData:ht?{name:ht.name,uri:ht.uri,id:ht._itemId??ht.id}:void 0}}Ne.from=ye;function _(Ke){return L.$Kt.split(Ke).map(_e=>{if(_e.startsWith("#"))return _e;try{return a.URI.parse(_e)}catch{}return _e})}function Oe(Ke){return L.$Kt.create(Ke.map(_e=>typeof _e=="string"?_e:a.URI.revive(_e)))}})(Ot||(e.DataTransferItem=Ot={}));var xe;(function(Ne){function je(_,Oe){const Ke=_.items.map(([_e,Qe])=>[_e,Ot.to(_e,Qe,Oe)]);return new h.$JN(Ke)}Ne.toDataTransfer=je;async function ye(_){const Oe={items:[]},Ke=[];for(const[_e,Qe]of _)Ke.push((async()=>{Oe.items.push([_e,await Ot.from(_e,Qe)])})());return await Promise.all(Ke),Oe}Ne.from=ye})(xe||(e.DataTransfer=xe={}));var si;(function(Ne){function je(_,Oe){return{kind:"reply",agentId:_.participant??Oe?.agentId??"",subCommand:_.command??Oe?.command,message:_.prompt,title:_.label}}Ne.from=je;function ye(_){return{prompt:_.message,label:_.title,participant:_.agentId,command:_.subCommand}}Ne.to=ye})(si||(e.ChatFollowup=si={}));var Gt;(function(Ne){function je(ye){return"commandId"in ye?{kind:"command",title:ye.title??"",commandId:ye.commandId??"",when:ye.when??"",args:ye.args}:{kind:"reply",message:ye.message,title:ye.title,tooltip:ye.tooltip}}Ne.from=je})(Gt||(e.ChatInlineFollowup=Gt={}));var Ut;(function(Ne){function je(_){switch(_.role){case 0:return new h.$WO(_.content);case 1:return new h.$XO(_.content);case 2:return new h.$YO(_.content)}}Ne.to=je;function ye(_){if(_ instanceof h.$WO)return{role:0,content:_.content};if(_ instanceof h.$XO)return{role:1,content:_.content};if(_ instanceof h.$YO)return{role:2,content:_.content};throw new Error("Invalid LanguageModelMessage")}Ne.from=ye})(Ut||(e.LanguageModelMessage=Ut={}));var mt;(function(Ne){function je(Oe){const Ke={};for(const _e of Object.keys(Oe))Ke[_e]=Oe[_e].map(Ne.to);return Ke}Ne.objectTo=je;function ye(Oe){return{level:Tt.to(Oe.level),kind:Oe.kind,value:(0,a.$wc)(Oe.value)?a.URI.revive(Oe.value):Oe.value,description:Oe.description}}Ne.to=ye;function _(Oe){return{level:Tt.from(Oe.level),kind:Oe.kind,value:Oe.value,description:Oe.description}}Ne.from=_})(mt||(e.ChatVariable=mt={}));var Tt;(function(Ne){function je(_){switch(_){case"short":return h.ChatVariableLevel.Short;case"medium":return h.ChatVariableLevel.Medium;case"full":default:return h.ChatVariableLevel.Full}}Ne.to=je;function ye(_){switch(_){case h.ChatVariableLevel.Short:return"short";case h.ChatVariableLevel.Medium:return"medium";case h.ChatVariableLevel.Full:default:return"full"}}Ne.from=ye})(Tt||(e.ChatVariableLevel=Tt={}));var Lt;(function(Ne){function je(ye){switch(ye){case 1:return h.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return h.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return h.InteractiveEditorResponseFeedbackKind.Undone;case 3:return h.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return h.InteractiveEditorResponseFeedbackKind.Bug}}Ne.to=je})(Lt||(e.InteractiveEditorResponseFeedbackKind=Lt={}));var Wt;(function(Ne){function je(_){return{kind:"markdownContent",content:W.from(_.value)}}Ne.from=je;function ye(_){return new h.$NO(W.to(_.content))}Ne.to=ye})(Wt||(e.ChatResponseMarkdownPart=Wt={}));var Jt;(function(Ne){function je(_){const{value:Oe,baseUri:Ke}=_;function _e(Qe,ht){return Qe.map(Et=>{const Ft=a.URI.joinPath(ht,Et.name);return{label:Et.name,uri:Ft,children:Et.children&&_e(Et.children,Ft)}})}return{kind:"treeData",treeData:{label:(0,E.$1g)(Ke),uri:Ke,children:_e(Oe,Ke)}}}Ne.from=je;function ye(_){const Oe=(0,S.$Zh)(_.treeData);function Ke(ht){return ht.map(Et=>({name:Et.label,children:Et.children&&Ke(Et.children)}))}const _e=Oe.uri,Qe=Oe.children?Ke(Oe.children):[];return new h.$OO(Qe,_e)}Ne.to=ye})(Jt||(e.ChatResponseFilesPart=Jt={}));var Qt;(function(Ne){function je(_){return{kind:"inlineReference",name:_.title,inlineReference:a.URI.isUri(_.value)?_.value:w.from(_.value)}}Ne.from=je;function ye(_){const Oe=(0,S.$Zh)(_);return new h.$PO(a.URI.isUri(Oe.inlineReference)?Oe.inlineReference:w.to(Oe.inlineReference),_.name)}Ne.to=ye})(Qt||(e.ChatResponseAnchorPart=Qt={}));var oi;(function(Ne){function je(_){return{kind:"progressMessage",content:W.from(_.value)}}Ne.from=je;function ye(_){return new h.$QO(_.content.value)}Ne.to=ye})(oi||(e.ChatResponseProgressPart=oi={}));var At;(function(Ne){function je(_,Oe,Ke){return{kind:"command",command:Oe.toInternal(_.value,Ke)??{command:_.value.command,title:_.value.title}}}Ne.from=je;function ye(_,Oe){return new h.$RO(Oe.fromInternal(_.command)??{command:_.command.id,title:_.command.title})}Ne.to=ye})(At||(e.ChatResponseCommandButtonPart=At={}));var Nt;(function(Ne){function je(_){return{kind:"textEdit",uri:_.uri,edits:_.edits.map(Oe=>$e.from(Oe))}}Ne.from=je;function ye(_){return new h.$TO(a.URI.revive(_.uri),_.edits.map(Oe=>$e.to(Oe)))}Ne.to=ye})(Nt||(e.ChatResponseTextEditPart=Nt={}));var Ct;(function(Ne){function je(_){return"variableName"in _.value?{kind:"reference",reference:{variableName:_.value.variableName,value:a.URI.isUri(_.value.value)||!_.value.value?_.value.value:w.from(_.value.value)}}:{kind:"reference",reference:a.URI.isUri(_.value)?_.value:w.from(_.value)}}Ne.from=je;function ye(_){const Oe=(0,S.$Zh)(_),Ke=_e=>a.URI.isUri(_e)?_e:w.to(_e);return new h.$SO("variableName"in Oe.reference?{variableName:Oe.reference.variableName,value:Oe.reference.value&&Ke(Oe.reference.value)}:Ke(Oe.reference))}Ne.to=ye})(Ct||(e.ChatResponseReferencePart=Ct={}));var Dt;(function(Ne){function je(Oe,Ke,_e){return Oe instanceof h.$NO?Wt.from(Oe):Oe instanceof h.$PO?Qt.from(Oe):Oe instanceof h.$SO?Ct.from(Oe):Oe instanceof h.$QO?oi.from(Oe):Oe instanceof h.$OO?Jt.from(Oe):Oe instanceof h.$RO?At.from(Oe,Ke,_e):Oe instanceof h.$TO?Nt.from(Oe):{kind:"content",content:""}}Ne.from=je;function ye(Oe,Ke){switch(Oe.kind){case"reference":return Ct.to(Oe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return _(Oe,Ke)}}Ne.to=ye;function _(Oe,Ke){switch(Oe.kind){case"markdownContent":return Wt.to(Oe);case"inlineReference":return Qt.to(Oe);case"progressMessage":return;case"treeData":return Jt.to(Oe);case"command":return At.to(Oe,Ke)}}Ne.toContent=_})(Dt||(e.ChatResponsePart=Dt={}));var pt;(function(Ne){function je(_,Oe){return"markdownContent"in Oe?((0,c.$yG)(_,"chatParticipantAdditions"),{content:W.from(Oe.markdownContent),kind:"markdownContent"}):"content"in Oe?"vulnerabilities"in Oe&&Oe.vulnerabilities?((0,c.$yG)(_,"chatParticipantAdditions"),{content:Oe.content,vulnerabilities:Oe.vulnerabilities,kind:"vulnerability"}):typeof Oe.content=="string"?{content:Oe.content,kind:"content"}:((0,c.$yG)(_,"chatParticipantAdditions"),{content:W.from(Oe.content),kind:"markdownContent"}):"documents"in Oe?{documents:Oe.documents.map(Ke=>({uri:Ke.uri,version:Ke.version,ranges:Ke.ranges.map(_e=>D.from(_e))})),kind:"usedContext"}:"reference"in Oe?{reference:"uri"in Oe.reference?{uri:Oe.reference.uri,range:D.from(Oe.reference.range)}:Oe.reference,kind:"reference"}:"inlineReference"in Oe?{inlineReference:"uri"in Oe.inlineReference?{uri:Oe.inlineReference.uri,range:D.from(Oe.inlineReference.range)}:Oe.inlineReference,name:Oe.title,kind:"inlineReference"}:"participant"in Oe?((0,c.$yG)(_,"chatParticipantAdditions"),{agentId:Oe.participant,command:Oe.command,kind:"agentDetection"}):"message"in Oe?{content:W.from(Oe.message),kind:"progressMessage"}:void 0}Ne.from=je;function ye(_,Oe){switch(_.kind){case"markdownContent":return{content:_.content.value};case"inlineReference":return{inlineReference:(0,a.$wc)(_.inlineReference)?a.URI.revive(_.inlineReference):w.to(_.inlineReference),title:_.name};case"command":return{command:Oe.fromInternal(_.command)??{command:_.command.id,title:_.command.title}};default:return}}Ne.toProgressContent=ye})(pt||(e.ChatResponseProgress=pt={}));var Pt;(function(Ne){function je(ye){return{prompt:ye.message,command:ye.command,attempt:ye.attempt??0,enableCommandDetection:ye.enableCommandDetection??!0,variables:ye.variables.variables.map(kt.to),location:li.to(ye.location)}}Ne.to=je})(Pt||(e.ChatAgentRequest=Pt={}));var li;(function(Ne){function je(ye){switch(ye){case s.ChatAgentLocation.Notebook:return h.ChatLocation.Notebook;case s.ChatAgentLocation.Terminal:return h.ChatLocation.Terminal;case s.ChatAgentLocation.Panel:return h.ChatLocation.Panel;case s.ChatAgentLocation.Editor:return h.ChatLocation.Editor}}Ne.to=je})(li||(e.ChatLocation=li={}));var kt;(function(Ne){function je(ye){return{name:ye.name,range:ye.range&&[ye.range.start,ye.range.endExclusive],values:ye.values.map(mt.to)}}Ne.to=je})(kt||(e.ChatAgentResolvedVariable=kt={}));var hi;(function(Ne){function je(ye){return{label:ye.label,values:ye.values.map(mt.from),insertText:ye.insertText,detail:ye.detail,documentation:ye.documentation}}Ne.from=je})(hi||(e.ChatAgentCompletionItem=hi={}));var Zt;(function(Ne){function je(ye){return{errorDetails:ye.errorDetails,metadata:ye.metadata}}Ne.to=je})(Zt||(e.ChatAgentResult=Zt={}));var ai;(function(Ne){function je(ye,_,Oe){if(_.action.kind==="vote")return;const Ke=Zt.to(ye);return _.action.kind==="command"?{action:{kind:"command",commandButton:pt.toProgressContent(_.action.commandButton,Oe)},result:Ke}:_.action.kind==="followUp"?{action:{kind:"followUp",followup:si.to(_.action.followup)},result:Ke}:{action:_.action,result:Ke}}Ne.to=je})(ai||(e.ChatAgentUserActionEvent=ai={}));var bi;(function(Ne){function je(ye,_,Oe){return"terminalCommand"in ye?{terminalCommand:ye.terminalCommand,shouldExecute:ye.shouldExecute}:"uri"in ye?{uri:ye.uri}:_.toInternal(ye,Oe)}Ne.from=je})(bi||(e.TerminalQuickFix=bi={}));var ni;(function(Ne){function je(ye){return{kind:Rt.to(ye.kind)}}Ne.to=je})(ni||(e.PartialAcceptInfo=ni={}));var Rt;(function(Ne){function je(ye){switch(ye){case 0:return h.PartialAcceptTriggerKind.Word;case 1:return h.PartialAcceptTriggerKind.Line;case 2:return h.PartialAcceptTriggerKind.Suggest;default:return h.PartialAcceptTriggerKind.Unknown}}Ne.to=je})(Rt||(e.PartialAcceptTriggerKind=Rt={}));var yi;(function(Ne){function je(ye,_){return{id:_,label:ye.label,description:ye.description,canEdit:ye.canEdit,collapsibleState:ye.collapsibleState||0,contextValue:ye.contextValue}}Ne.from=je})(yi||(e.DebugTreeItem=yi={}))}),define(ke[328],Ee([1,0,6,20,16,48]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bkc=void 0;let M=class{constructor(b,S){this.a=b.getProxy(u.$PM.MainThreadBulkEdits),this.b={getTextDocumentVersion:A=>S.getDocument(A)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,S,A){const P=new R.$mw(L.WorkspaceEdit.from(b,this.b));return this.a.$tryApplyWorkspaceEdit(P,void 0,A?.isRefactoring??!1)}};e.$bkc=M,e.$bkc=M=Je([qe(0,N.$aP)],M)}),define(ke[329],Ee([1,0,19,7,47,4,45,3,39,18,2,218,25,6,16,8,292,26]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=void 0;class n{constructor(t,f,d,l,c,h){this.i=t,this.j=f,this.k=d,this.l=l,this.m=c,this.n=h,this.b=b.$0d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let f=function(l){if(t.c){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,l),c}};const t=this;this.b.reset();const d=l=>{typeof this.d>"u"&&"content"in l&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,l)};this.g={markdown(l){f(this.markdown);const c=new a.$NO(l),h=v.ChatResponseMarkdownPart.from(c);return d(h),this},filetree(l,c){f(this.filetree);const h=new a.$OO(l,c),g=v.ChatResponseFilesPart.from(h);return d(g),this},anchor(l,c){f(this.anchor);const h=new a.$PO(l,c),g=v.ChatResponseAnchorPart.from(h);return d(g),this},button(l){f(this.anchor);const c=new a.$RO(l),h=v.ChatResponseCommandButtonPart.from(c,t.m,t.n);return d(h),this},progress(l){f(this.progress);const c=new a.$QO(l),h=v.ChatResponseProgressPart.from(c);return d(h),this},reference(l){if(f(this.reference),"variableName"in l&&!l.value){const c=t.j.variables.variables.find(h=>h.name===l.variableName);if(c){let h;if(c.references?.length)h=c.references.map(g=>({kind:"reference",reference:{variableName:l.variableName,value:g.reference}}));else{const g=new a.$SO(l);h=[v.ChatResponseReferencePart.from(g)]}return h.forEach(g=>d(g)),this}}else{const c=new a.$SO(l),h=v.ChatResponseReferencePart.from(c);d(h)}return this},textEdit(l,c){f(this.textEdit),(0,o.$yG)(t.i,"chatParticipantAdditions");const h=new a.$TO(l,c),g=v.ChatResponseTextEditPart.from(h);return d(g),this},push(l){if(f(this.push),l instanceof a.$TO&&(0,o.$yG)(t.i,"chatParticipantAdditions"),l instanceof a.$SO)this.reference(l.value);else{const c=v.ChatResponsePart.from(l,t.m,t.n);d(c)}return this},report(l){if(f(this.report),"placeholder"in l&&"resolvedContent"in l)return;const c=v.ChatResponseProgress.from(t.i,l);if(!c){t.l.error("Unknown progress type: "+JSON.stringify(l));return}return d(c),this}}}return this.g}}class i{static{this.b=0}constructor(t,f,d){this.i=f,this.j=d,this.c=new Map,this.g=new p.$4c,this.d=t.getProxy(E.$PM.MainThreadChatAgents2)}transferActiveChat(t){this.d.$transferActiveChatSession(t)}createChatAgent(t,f,d){const l=i.b++,c=new r(t,f,this.d,l,d);return this.c.set(l,c),this.d.$registerAgent(l,t.identifier,f,{},void 0),c.apiAgent}createDynamicChatAgent(t,f,d,l,c){const h=i.b++,g=new r(t,f,this.d,h,c);return this.c.set(h,g),this.d.$registerAgent(h,t.identifier,f,{isSticky:!0},{name:d,description:l}),g.apiAgent}async $invokeAgent(t,f,d,l){const c=this.c.get(t);if(!c)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let h=this.g.get(f.sessionId);h||(h=new p.$Tc,this.g.set(f.sessionId,h));const g=new n(c.extension,f,this.d,this.i,this.j.converter,h);try{const D=await this.k(f.agentId,d),w=c.invoke(v.ChatAgentRequest.to(f),{history:D},g.apiObject,l);return await(0,N.$eh)(Promise.resolve(w).then(k=>{if(k?.metadata)try{JSON.stringify(k.metadata)}catch(y){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${c.extension.identifier.value}] [@${c.id}] ${C}`,c.extension),{errorDetails:{message:C},timings:g.timings}}return{errorDetails:k?.errorDetails,timings:g.timings,metadata:k?.metadata}}),l)}catch(D){return this.i.error(D,c.extension),{errorDetails:{message:(0,P.localize)(0,null,(0,L.$bj)(D)),responseIsIncomplete:!0}}}finally{g.close()}}async k(t,f){const d=[];for(const l of f.history){const c=v.ChatAgentResult.to(l.result),h=t===l.request.agentId?c:{...c,metadata:void 0};d.push(new a.$UO(l.request.message,l.request.command,l.request.variables.variables.map(v.ChatAgentResolvedVariable.to),l.request.agentId));const g=(0,u.$Hb)(l.response.map(D=>v.ChatResponsePart.toContent(D,this.j.converter)));d.push(new a.$VO(g,h,l.request.agentId,l.request.command))}return d}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,f,d,l,c){const h=this.c.get(f);if(!h)return Promise.resolve([]);const g=await this.k(h.id,l),D=v.ChatAgentResult.to(d);return(await h.provideFollowups(D,{history:g},c)).filter(w=>{const k=!w.participant||M.Iterable.some(this.c.values(),y=>y.id===w.participant&&$.$Lm.equals(y.extension.identifier,h.extension.identifier));return k||this.i.warn(`[@${h.id}] ChatFollowup refers to an unknown participant: ${w.participant}`),k}).map(w=>v.ChatFollowup.from(w,t))}$acceptFeedback(t,f,d,l){const c=this.c.get(t);if(!c)return;const h=v.ChatAgentResult.to(f);let g;switch(d){case m.InteractiveSessionVoteDirection.Down:g=a.ChatResultFeedbackKind.Unhelpful;break;case m.InteractiveSessionVoteDirection.Up:g=a.ChatResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(l?{result:h,kind:g,reportIssue:l}:{result:h,kind:g}))}$acceptAction(t,f,d){const l=this.c.get(t);if(!l||d.action.kind==="vote")return;const c=v.ChatAgentUserActionEvent.to(f,d,this.j.converter);c&&l.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(t,f,d){const l=this.c.get(t);return l?(await l.invokeCompletionProvider(f,d)).map(v.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,f){const d=this.c.get(t);if(d)return await d.provideWelcomeMessage(f)}async $provideSampleQuestions(t,f){const d=this.c.get(t);if(d)return(await d.provideSampleQuestions(f)).map(l=>v.ChatFollowup.from(l,void 0))}}e.$ckc=i;class r{constructor(t,f,d,l,c){this.extension=t,this.id=f,this.u=d,this.w=l,this.x=c,this.n=new R.$be,this.o=new R.$be}acceptFeedback(t){this.n.fire(t)}acceptAction(t){this.o.fire(t)}async invokeCompletionProvider(t,f){return this.q?await this.q.provider.provideCompletionItems(t,f)??[]:[]}async provideFollowups(t,f,d){if(!this.b)return[];const l=await this.b.provideFollowups(t,f,d);return l?l.filter(c=>!(c&&"commandId"in c)).filter(c=>!(c&&"message"in c)):[]}async provideWelcomeMessage(t){if(!this.s)return[];const f=await this.s.provideWelcomeMessage(t);return f?f.map(d=>typeof d=="string"?d:v.MarkdownString.from(d)):[]}async provideSampleQuestions(t){if(!this.s||!this.s.provideSampleQuestions)return[];const f=await this.s.provideSampleQuestions(t);return f||[]}get apiAgent(){let t=!1,f=!1;const d=()=>{t||f||(f=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof A.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof a.$NN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:v.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,requester:this.t}),f=!1}))},l=this;return{get id(){return l.id},get fullName(){return(0,o.$yG)(l.extension,"defaultChatParticipant"),l.c??l.extension.displayName??l.extension.name},set fullName(c){(0,o.$yG)(l.extension,"defaultChatParticipant"),l.c=c,d()},get iconPath(){return l.d},set iconPath(c){l.d=c,d()},get requestHandler(){return l.x},set requestHandler(c){(0,S.$bg)(typeof c=="function","Invalid request handler"),l.x=c},get followupProvider(){return l.b},set followupProvider(c){l.b=c,d()},get isDefault(){return(0,o.$yG)(l.extension,"defaultChatParticipant"),l.g},set isDefault(c){(0,o.$yG)(l.extension,"defaultChatParticipant"),l.g=c,d()},get helpTextPrefix(){return(0,o.$yG)(l.extension,"defaultChatParticipant"),l.i},set helpTextPrefix(c){(0,o.$yG)(l.extension,"defaultChatParticipant"),l.i=c,d()},get helpTextVariablesPrefix(){return(0,o.$yG)(l.extension,"defaultChatParticipant"),l.j},set helpTextVariablesPrefix(c){(0,o.$yG)(l.extension,"defaultChatParticipant"),l.j=c,d()},get helpTextPostfix(){return(0,o.$yG)(l.extension,"defaultChatParticipant"),l.k},set helpTextPostfix(c){(0,o.$yG)(l.extension,"defaultChatParticipant"),l.k=c,d()},get isSecondary(){return(0,o.$yG)(l.extension,"defaultChatParticipant"),l.m},set isSecondary(c){(0,o.$yG)(l.extension,"defaultChatParticipant"),l.m=c,d()},get sampleRequest(){return l.l},set sampleRequest(c){l.l=c,d()},get supportIssueReporting(){return(0,o.$yG)(l.extension,"chatParticipantAdditions"),l.p},set supportIssueReporting(c){(0,o.$yG)(l.extension,"chatParticipantAdditions"),l.p=c,d()},get onDidReceiveFeedback(){return l.n.event},set participantVariableProvider(c){if((0,o.$yG)(l.extension,"chatParticipantAdditions"),l.q=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");l.u.$registerAgentCompletionsProvider(l.w,c.triggerCharacters)}else l.u.$unregisterAgentCompletionsProvider(l.w)},get participantVariableProvider(){return(0,o.$yG)(l.extension,"chatParticipantAdditions"),l.q},set welcomeMessageProvider(c){(0,o.$yG)(l.extension,"defaultChatParticipant"),l.s=c,d()},get welcomeMessageProvider(){return(0,o.$yG)(l.extension,"defaultChatParticipant"),l.s},onDidPerformAction:(0,o.$xG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(c){l.t=c,d()},get requester(){return l.t},dispose(){t=!0,l.b=void 0,l.n.dispose(),l.u.$unregisterAgent(l.w)}}}invoke(t,f,d,l){return this.x(t,f,d,l)}}}),define(ke[330],Ee([1,0,13,3,6,16,8,26]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;class b{static{this.a=0}constructor(P){this.b=new Map,this.c=P.getProxy(L.$PM.MainThreadChatVariables)}async $resolveVariable(P,$,E,v){const a=this.b.get(P);if(a)try{if(a.resolver.resolve2){(0,p.$yG)(a.extension,"chatParticipantAdditions");const m=new S($,this.c),o=await a.resolver.resolve2(a.data.name,{prompt:E},m.apiObject,v);if(o)return o.map(R.ChatVariable.from)}else{const m=await a.resolver.resolve(a.data.name,{prompt:E},v);if(m)return m.map(R.ChatVariable.from)}}catch(m){(0,u.$2)(m)}}registerVariableResolver(P,$,E,v){const a=b.a++;return this.b.set(a,{extension:P,data:{name:$,description:E},resolver:v}),this.c.$registerVariable(a,{name:$,description:E}),(0,N.$Sc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$dkc=b;class S{constructor(P,$){this.c=P,this.d=$,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let $=function(v){if(P.a){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,v),a}};const P=this,E=v=>{this.d.$handleProgressChunk(this.c,v)};this.b={progress(v){$(this.progress);const a=new M.$QO(v),m=R.ChatResponseProgressPart.from(a);return E(m),this},reference(v){$(this.reference);const a=new M.$SO(v),m=R.ChatResponseReferencePart.from(a);return E(m),this},push(v){return $(this.push),v instanceof M.$SO?E(R.ChatResponseReferencePart.from(v)):v instanceof M.$QO&&E(R.ChatResponseProgressPart.from(v)),this}}}return this.b}}}),define(ke[331],Ee([1,0,7,55,4,3,2,83,25,16,8,6,26]),function(le,e,u,N,L,R,M,p,b,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=E;function E(v,a,m){const o=v.getProxy(P.$PM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new b.$Nm,a.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===6){const D=this.b.get(g.handle);return D?D.value:g}else if(g&&g.$mid===7){const D=g,w=this.b.get(D.commentControlHandle);if(!w)return D;const k=w.getCommentThread(D.commentThreadHandle);return k?k.value:D}else if(g&&(g.$mid===9||g.$mid===8)){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const w=D.getCommentThread(g.thread.commentThreadHandle);return w?g.$mid===8?w.value:{thread:w.value,text:g.text}:g}else if(g&&g.$mid===10){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const w=D.getCommentThread(g.thread.commentThreadHandle);if(!w)return g;const k=g.commentUniqueId,y=w.getCommentByUniqueId(k);return y||g}else if(g&&g.$mid===11){const D=this.b.get(g.thread.commentControlHandle);if(!D)return g;const w=D.getCommentThread(g.thread.commentThreadHandle);if(!w)return g;const k=g.text,y=g.commentUniqueId,C=w.getCommentByUniqueId(y);return C?(typeof C.body=="string"?C.body=k:C.body=new A.$gN(k),C):g}return g}})}createCommentController(g,D,w){const k=n.a++,y=new r(g,k,D,w);this.b.set(y.handle,y);const C=this.c.get(g.identifier)||[];return C.push(y),this.c.set(g.identifier,C),y.value}async $createCommentThreadTemplate(g,D,w){const k=this.b.get(g);k&&k.$createCommentThreadTemplate(D,w)}async $setActiveComment(g,D){const w=this.b.get(g);w&&w.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(g,D,w){const k=this.b.get(g);k&&k.$updateCommentThreadTemplate(D,w)}$deleteCommentThread(g,D){this.b.get(g)?.$deleteCommentThread(D)}async $provideCommentingRanges(g,D,w){const k=this.b.get(g);if(!k||!k.commentingRangeProvider)return Promise.resolve(void 0);const y=await m.ensureDocumentData(M.URI.revive(D));return(0,u.$ih)(async()=>{const C=await k.commentingRangeProvider.provideCommentingRanges(y.document,w);let I;return Array.isArray(C)?I={ranges:C,fileComments:!1}:C?I={ranges:C.ranges||[],fileComments:C.fileComments||!1}:I=C??void 0,I}).then(C=>{let I;return C&&(I={ranges:C.ranges.map(F=>S.Range.from(F)),fileComments:C.fileComments}),I})}$toggleReaction(g,D,w,k,y){const C=this.b.get(g);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,u.$ih)(()=>{const I=C.getCommentThread(D);if(I){const F=I.getCommentByUniqueId(k.uniqueIdInThread);if(C!==void 0&&F&&C.reactionHandler)return C.reactionHandler(F,f(y))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(g){this.n=g}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(g){(g===void 0!=(this.p===void 0)||!g||!this.p||!g.isEqual(this.p))&&(this.p=g,this.b.range=g,this.c.fire())}get range(){return this.p}set canReply(g){this.d!==g&&(this.d=g,this.b.canReply=g,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(g){this.e=g,this.b.label=g,this.c.fire()}get contextValue(){return this.f}set contextValue(g){this.f=g,this.b.contextValue=g,this.c.fire()}get comments(){return this.q}set comments(g){this.q=g,this.b.comments=g,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(g){this.g=g,this.b.collapsibleState=g,this.c.fire()}get state(){return this.h}set state(g){this.h=g,typeof g=="object"?((0,$.$yG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=g.resolved,this.b.applicability=g.applicability):this.b.state=g,this.c.fire()}get isDisposed(){return this.j}constructor(g,D,w,k,y,C,I,F){this.m=D,this.n=w,this.o=k,this.p=y,this.q=C,this.extensionDescription=I,this.r=F,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new L.$be,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Vc,this.l.value=new R.$Tc,this.n===void 0&&(this.n=`${g}.${this.handle}`),o.$createCommentThread(D,this.handle,this.n,this.o,S.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{o.$deleteCommentThread(D,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(z){j.range=z},get comments(){return j.comments},set comments(z){j.comments=z},get collapsibleState(){return j.collapsibleState},set collapsibleState(z){j.collapsibleState=z},get canReply(){return j.canReply},set canReply(z){j.canReply=z},get contextValue(){return j.contextValue},set contextValue(z){j.contextValue=z},get label(){return j.label},set label(z){j.label=z},get state(){return j.state},set state(z){j.state=z},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Tc);const g=w=>Object.prototype.hasOwnProperty.call(this.b,w),D={};g("range")&&(D.range=S.Range.from(this.p)),g("label")&&(D.label=this.label),g("contextValue")&&(D.contextValue=this.contextValue??null),g("comments")&&(D.comments=this.q.map(w=>s(this,w,this.k,this.extensionDescription))),g("collapsibleState")&&(D.collapseState=d(this.g)),g("canReply")&&(D.canReply=this.canReply),g("state")&&(D.state=l(this.h)),g("applicability")&&(D.applicability=c(this.h)),g("isTemplate")&&(D.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(g){for(const D of this.k){const w=D[0],k=D[1];if(g===k)return w}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(g=>g.dispose())}}Je([(0,N.$Vh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(g){this.b=g,g?.resourceHints&&(0,$.$yG)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,g?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(g){this.c=g,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!g})}get options(){return this.d}set options(g){this.d=g,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,$.$yG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,$.$yG)(this.h,"activeComment"),this.f}constructor(g,D,w,k){this.h=g,this.i=D,this.j=w,this.k=k,this.a=new Map,o.$registerCommentController(this.handle,w,k,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(C){y.options=C},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(C){y.commentingRangeProvider=C},get reactionHandler(){return y.reactionHandler},set reactionHandler(C){y.reactionHandler=C},get activeCommentThread(){return y.activeCommentThread},createCommentThread(C,I,F){return y.createCommentThread(C,I,F).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(g,D,w){D===void 0&&(0,$.$yG)(this.h,"fileComments");const k=new i(this.id,this.handle,void 0,g,D,w,this.h,!1);return this.a.set(k.handle,k),k}$setActiveComment(g){if(!g){this.e=void 0,this.f=void 0;return}const D=this.a.get(g.commentThreadHandle);D&&(this.e=g.uniqueIdInThread?D.getCommentByUniqueId(g.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(g,D){const w=new i(this.id,this.handle,void 0,M.URI.revive(g),S.Range.to(D),[],this.h,!0);return w.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(w.handle,w),w}$updateCommentThreadTemplate(g,D){const w=this.a.get(g);w&&(w.range=S.Range.to(D))}$deleteCommentThread(g){this.a.get(g)?.dispose(),this.a.delete(g)}getCommentThread(g){return this.a.get(g)}dispose(){this.a.forEach(g=>{g.dispose()}),this.g.forEach(g=>g.dispose())}}function s(h,g,D,w){let k=D.get(g);return k||(k=++h.commentHandle,D.set(g,k)),g.state!==void 0&&(0,$.$yG)(w,"commentsDraftState"),g.reactions?.some(y=>y.reactors!==void 0)&&(0,$.$yG)(w,"commentReactor"),{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:k,body:typeof g.body=="string"?g.body:S.MarkdownString.from(g.body),userName:g.author.name,userIconPath:g.author.iconPath,label:g.label,commentReactions:g.reactions?g.reactions.map(y=>t(y)):void 0,state:g.state,timestamp:g.timestamp?.toJSON()}}function t(h){return{label:h.label,iconPath:h.iconPath?S.$_O(h.iconPath):void 0,count:h.count,hasReacted:h.authorHasReacted,reactors:h.reactors&&h.reactors.length>0&&typeof h.reactors[0]!="string"?h.reactors.map(g=>g.name):h.reactors}}function f(h){return{label:h.label||"",count:h.count||0,iconPath:h.iconPath?M.URI.revive(h.iconPath):"",authorHasReacted:h.hasReacted||!1,reactors:h.reactors?.map(g=>({name:g}))}}function d(h){if(h!==void 0)switch(h){case A.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function l(h){let g;if(typeof h=="object"?g=h.resolved:g=h,g!==void 0)switch(g){case A.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function c(h){let g;if(typeof h=="object"&&(g=h.applicability),g!==void 0)switch(g){case A.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(ke[332],Ee([1,0,22,56,3,15,23,2,16,92,111,6,8]),function(le,e,u,N,L,R,M,p,b,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class E{constructor(f,d){this.document=f,this.b=d,this.a=1,this.c=new A.$Zjc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,d){await this.f(f).undo(),d||this.disposeBackup()}async redo(f,d){await this.f(f).redo(),d||this.disposeBackup()}disposeEdits(f){for(const d of f)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=s(this.document.uri)+this.a++;return(0,M.$4g)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const d=this.c.get(f,0);if(!d)throw new Error("No edit found");return d}}class v{constructor(){this.a=new Map}get(f,d){return this.a.get(this.b(f,d))}add(f,d,l){const c=this.b(f,d.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${f} resource:${d.uri}`);const h=new E(d,l);return this.a.set(c,h),h}delete(f,d){const l=this.b(f,d.uri);this.a.delete(l)}b(f,d){return`${f}@@@${d}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class m{constructor(){this.a=new Map}addTextProvider(f,d,l){return this.b(0,f,d,l)}addCustomProvider(f,d,l){return this.b(1,f,d,l)}get(f){return this.a.get(f)}b(f,d,l,c){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:f,extension:l,provider:c}),new $.$RM(()=>this.a.delete(d))}}class o{constructor(f,d,l,c,h){this.d=d,this.f=l,this.g=c,this.h=h,this.b=new m,this.c=new v,this.a=f.getProxy(P.$PM.MainThreadCustomEditors)}registerCustomEditorProvider(f,d,l,c){const h=new L.$Tc;return i(l)?(h.add(this.b.addTextProvider(d,f,l)),this.a.$registerTextEditorProvider((0,S.$wkc)(f),d,c.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,S.$ukc)(f))):(h.add(this.b.addCustomProvider(d,f,l)),n(l)&&h.add(l.onDidChangeCustomDocument(g=>{const D=this.i(d,g.document.uri);if(r(g)){const w=D.addEdit(g);this.a.$onDidEdit(g.document.uri,d,w,g.label)}else this.a.$onContentChange(g.document.uri,d)})),this.a.$registerCustomEditorProvider((0,S.$wkc)(f),d,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,S.$ukc)(f))),$.$RM.from(h,new $.$RM(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(f,d,l,c,h){const g=this.b.get(d);if(!g)throw new Error(`No provider found for '${d}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${d}'`);const D=p.URI.revive(f),w=await g.provider.openCustomDocument(D,{backupId:l,untitledDocumentData:c?.buffer},h);let k;return n(g.provider)&&this.f&&(k=this.f.workspaceValue(g.extension)??this.f.globalValue(g.extension)),this.c.add(d,w,k),{editable:n(g.provider)}}async $disposeCustomDocument(f,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${d}'`);const c=p.URI.revive(f),{document:h}=this.i(d,c);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(f,d,l,c,h,g){const D=this.b.get(l);if(!D)throw new Error(`No provider found for '${l}'`);const w=b.ViewColumn.to(h),k=this.g.createNewWebview(d,c.contentOptions,D.extension),y=this.h.createNewWebviewPanel(d,l,c.title,w,c.options,k,c.active),C=p.URI.revive(f);switch(D.type){case 1:{const{document:I}=this.i(l,C);return D.provider.resolveCustomEditor(I,y,g)}case 0:{const I=this.d.getDocument(C);return D.provider.resolveCustomTextEditor(I,y,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,d,l){this.i(d,f).disposeEdits(l)}async $onMoveCustomEditor(f,d,l){const c=this.b.get(l);if(!c)throw new Error(`No provider found for '${l}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const h=this.h.getWebviewPanel(f);if(!h)throw new Error("No webview found");const g=p.URI.revive(d),D=this.d.getDocument(g);await c.provider.moveCustomTextEditor(D,h,u.CancellationToken.None)}async $undo(f,d,l,c){return this.i(d,f).undo(l,c)}async $redo(f,d,l,c){return this.i(d,f).redo(l,c)}async $revert(f,d,l){const c=this.i(d,f);await this.j(d).revertCustomDocument(c.document,l),c.disposeBackup()}async $onSave(f,d,l){const c=this.i(d,f);await this.j(d).saveCustomDocument(c.document,l),c.disposeBackup()}async $onSaveAs(f,d,l,c){const h=this.i(d,f);return this.j(d).saveCustomDocumentAs(h.document,p.URI.revive(l),c)}async $backup(f,d,l){const c=this.i(d,f),g=await this.j(d).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},l);return c.updateBackup(g),g.id}i(f,d){const l=this.c.get(f,p.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(f){const l=this.b.get(f)?.provider;if(!l||!n(l))throw new Error("Custom document is not editable");return l}}e.$zkc=o;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function s(t){const f=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,N.$ej)(f)+""}}),define(ke[333],Ee([1,0,219,138,2,6,8,16,4,12,27,60]),function(le,e,u,N,L,R,M,p,b,S,A,P){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=e.$7jc=void 0;class E{#e;#t;#i;constructor(m,o,n,i,r,s,t,f){this.d=m,this.e=o,this.f=n,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,n),this.#i=new A.$Bc(d=>s.getComparisonKey(d)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,o){if(!m){this.clear();return}this.j();let n=[];if(L.URI.isUri(m)){if(!o){this.delete(m);return}this.#i.set(m,o.slice()),n=[m]}else if(Array.isArray(m)){n=[];let s;m=[...m].sort(E.k);for(const t of m){const[f,d]=t;if((!s||f.toString()!==s.toString())&&(s&&this.#i.get(s).length===0&&this.#i.delete(s),s=f,n.push(f),this.#i.set(f,[])),d)this.#i.get(f)?.push(...d);else{const l=this.#i.get(f);l&&(l.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let r=0;for(const s of n){let t=[];const f=this.#i.get(s);if(f)if(f.length>this.g){t=[];const d=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const c of f)if(c.severity===d[l]&&t.push({...p.Diagnostic.from(c),modelVersionId:this.h(s)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,u.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(d=>({...p.Diagnostic.from(d),modelVersionId:this.h(s)}));if(i.push([s,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,o){this.j();for(const[n,i]of this)m.call(o,n,i,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const o=this.#i.get(m);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,o){return m[0].toString()<o[0].toString()?-1:m[0].toString()>o[0].toString()?1:0}}e.$7jc=E;let v=class{static{$=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*$.d}static _mapper(m){const o=new A.$Bc;for(const n of m)o.set(n,n);return{uris:Object.freeze(Array.from(o.values()))}}constructor(m,o,n,i){this.j=o,this.k=n,this.l=i,this.g=new Map,this.h=new b.$fe({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this.h.event,$._mapper),this.f=m.getProxy(R.$PM.MainThreadDiagnostics)}createDiagnosticCollection(m,o){const{g:n,f:i,h:r,j:s,k:t,l:f}=this,d=new class{$changeMany(h,g){i.$changeMany(h,g),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,h,g.length===0?"CLEARING":g)}$clear(h){i.$clear(h),s.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,h)}dispose(){i.dispose()}};let l;if(!o)o="_generated_diagnostic_collection_name_#"+$.c++,l=o;else if(!n.has(o))l=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do l=o+$.c++;while(n.has(l))}return new class extends E{constructor(){super(o,l,$.e,$.d,h=>f.getDocument(h)?.version,t.extUri,d,r),n.set(l,this)}dispose(){super.dispose(),n.delete(l)}}}getDiagnostics(m){if(m)return this.m(m);{const o=new Map,n=[];for(const i of this.g.values())i.forEach((r,s)=>{let t=o.get(r.toString());typeof t>"u"&&(t=n.length,o.set(r.toString(),t),n.push([r,[]])),n[t][1]=n[t][1].concat(...s)});return n}}m(m){let o=[];for(const n of this.g.values())n.has(m)&&(o=o.concat(n.get(m)));return o}$acceptMarkersChange(m){if(!this.n){const o="_generated_mirror",n=new E(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,n),this.n=n}for(const[o,n]of m)this.n.set(L.URI.revive(o),n.map(p.Diagnostic.to))}};e.$8jc=v,e.$8jc=v=$=Je([qe(1,S.$Wj),qe(2,P.$6jc)],v)}),define(ke[334],Ee([1,0,2,13,8,16,75,48]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=void 0;class b{constructor(A,P,$,E={timeout:1500,errors:3}){this.c=A,this.d=P,this.f=$,this.g=E,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(A){return(P,$,E)=>{const a={dispose:this.a.push([P,$,A])};return Array.isArray(E)&&E.push(a),a}}async $participateInSave(A,P){const $=u.URI.revive(A);let E=!1;const v=setTimeout(()=>E=!0,this.g.timeout),a=[];try{for(const m of[...this.a]){if(E)break;const o=this.d.getDocument($),n=await this.h(m,{document:o,reason:R.TextDocumentSaveReason.to(P)});a.push(n)}}finally{clearTimeout(v)}return a}h([A,P,$],E){const v=this.b.get(A);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i($,A,P,E).then(()=>!0,a=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' threw ERROR`),this.c.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const m=this.b.get(A);this.b.set(A,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(A,P,$,E){const v=[],a=Date.now(),{document:m,reason:o}=E,{version:n}=m,i=Object.freeze({document:m,reason:o,waitUntil(r){if(Object.isFrozen(v))throw(0,N.$8)("waitUntil can not be called async");v.push(Promise.resolve(r))}});try{P.apply($,[i])}catch(r){return Promise.reject(r)}return Object.freeze(v),new Promise((r,s)=>{const t=setTimeout(()=>s(new Error("timeout")),this.g.timeout);return Promise.all(v).then(f=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(t),r(f)}).catch(f=>{clearTimeout(t),s(f)})}).then(r=>{const s={edits:[]};for(const t of r)if(Array.isArray(t)&&t.every(f=>f instanceof L.$YM))for(const{newText:f,newEol:d,range:l}of t)s.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:l&&R.Range.from(l),text:f,eol:d&&R.EndOfLine.from(d)}});if(s.edits.length!==0)return n===m.version?this.f.$tryApplyWorkspaceEdit(new p.$mw(s)):Promise.reject(new Error("concurrent_edits"))})}}e.$dlc=b}),define(ke[335],Ee([1,0,4,3,2,6,152,16,18,24,8]),function(le,e,u,N,L,R,M,p,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=void 0;class P{constructor(E,v){this.a=new u.$be,this.b=new u.$be,this.c=new u.$be,this.d=new u.$be,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Tc,this.h=new Map,this.f=E.getProxy(R.$PM.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(a=>{for(const m of a)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const m of a)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const v=this.g.getDocument(E);if(v)return v}getDocument(E){const v=this.getDocumentData(E);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return v.document}ensureDocumentData(E){const v=this.g.getDocument(E);if(v)return Promise.resolve(v);let a=this.h.get(E.toString());return a||(a=this.f.$tryOpenDocument(E).then(m=>{this.h.delete(E.toString());const o=L.URI.revive(m);return(0,b.$cg)(this.g.getDocument(o))},m=>(this.h.delete(E.toString()),Promise.reject(m))),this.h.set(E.toString(),a)),a}createDocumentData(E){return this.f.$tryCreateDocument(E).then(v=>L.URI.revive(v))}$acceptModelLanguageChanged(E,v){const a=L.URI.revive(E),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(v),this.a.fire(m.document)}$acceptModelSaved(E){const v=L.URI.revive(E),a=this.g.getDocument(v);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(E,v){const a=L.URI.revive(E),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");m._acceptIsDirty(v),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,v,a){const m=L.URI.revive(E),o=this.g.getDocument(m);if(!o)throw new Error("unknown document");o._acceptIsDirty(a),o.onEvents(v);let n;v.isUndoing?n=A.TextDocumentChangeReason.Undo:v.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,S.$Xn)({document:o.document,contentChanges:v.changes.map(i=>({range:p.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(E,v){(0,M.$cP)(E,v)}}e.$9jc=P}),define(ke[71],Ee([1,0,73,4,18,2,5,6,20,16,8]),function(le,e,u,N,L,R,M,p,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=e.$Akc=void 0,e.$Akc=(0,M.$qi)("IExtHostEditorTabs");class P{constructor(m,o,n){this.e=n,this.d=o,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$BO(R.URI.revive(this.b.input.uri));case 2:return new A.$CO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$DO(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$EO(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$FO(this.b.input.viewType);case 4:return new A.$GO(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$HO(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$IO;case 9:return new A.$JO(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$KO;case 11:return new A.$LO(this.b.input.diffEditors.map(m=>new A.$CO(R.URI.revive(m.original),R.URI.revive(m.modified))));default:return}}}class ${constructor(m,o){this.c=[],this.d="",this.b=m,this.e=o;for(const n of m.tabs)n.isActive&&(this.d=n.id),this.c.push(new P(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return S.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(n=>n.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(n=>n.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const n=new P(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,n),m.tabDto.isActive&&(this.d=n.tabId),n}else if(m.kind===1){const n=this.c.splice(m.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(m.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,n),n}const o=this.c.find(n=>n.tabId===m.tabDto.id);if(!o)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(m.tabDto),o}activeTabId(){return this.d}}let E=class{constructor(m){this.b=new N.$be,this.c=new N.$be,this.e=[],this.a=m.getProxy(p.$PM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,o={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(n=>n.apiObject))},get activeTabGroup(){const n=m.d;return(0,L.$cg)(m.e.find(r=>r.groupId===n)?.apiObject)},close:async(n,i)=>{const r=Array.isArray(n)?n:[n];return r.length?v(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(m){const o=new Set(this.e.map(d=>d.groupId)),n=new Set(m.map(d=>d.groupId)),i=(0,u.$L)(o,n),r=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),s=[],t=[];this.e=m.map(d=>{const l=new $(d,()=>this.d);return i.added.includes(l.groupId)?s.push(l.apiObject):t.push(l.apiObject),l});const f=(0,L.$cg)(m.find(d=>d.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:s,closed:r,changed:t}))}$acceptTabGroupUpdate(m){const o=this.e.find(n=>n.groupId===m.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const o=this.e.find(i=>i.groupId===m.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const n=o.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(m){for(const o of this.e)for(const n of o.tabs)if(n.apiObject===m)return n}h(m){return this.e.find(o=>o.apiObject===m)}async i(m,o){const n=[];for(const i of m){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");n.push(r.tabId)}return this.a.$closeTab(n,o)}async j(m,o){const n=[];for(const i of m){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");n.push(r.groupId)}return this.a.$closeGroup(n,o)}};e.$Bkc=E,e.$Bkc=E=Je([qe(0,b.$aP)],E);function v(a){return a.tabs!==void 0}}),define(ke[336],Ee([1,0,2,6,3,8,16,180,14,21,26,80]),function(le,e,u,N,L,R,M,p,b,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;class ${constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const m=this.a.indexOf(a);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),m=[];let o,n,i=14,r=14;for(const s of a){let t=o?(0,b.$vf)(o,s):0;for(t===0?n=1:n=r;t<s.length;t++)t+1===s.length?(i=r,r=9):r+=1,m.push([n,s.toUpperCase().charCodeAt(t),r]),m.push([n,s.toLowerCase().charCodeAt(t),r]),n=r;o=s,r=i}m.push([9,58,10]),m.push([10,47,12]),this.b=new p.$12(m)}}provideDocumentLinks(a){this.c();const m=[],o=p.$22.computeLinks({getLineContent(n){return a.lineAt(n-1).text},getLineCount(){return a.lineCount}},this.b);for(const n of o){const i=M.DocumentLink.to(n);i.target&&m.push(i)}return m}}class E{constructor(a,m){this.i=m,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(N.$PM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,m,o,n={}){if(E.j(o),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const i=this.h++;this.b.add(m),this.d.add(m),this.c.set(i,o);let r=2;n.isCaseSensitive&&(r+=1024),n.isReadonly&&(r+=2048),typeof o.copy=="function"&&(r+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,A.$yG)(a,"fsChunks"),r+=4);let s;n.isReadonly&&(0,P.$Pk)(n.isReadonly)&&n.isReadonly.value!==""&&(s={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,m,r,s).catch(f=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${m}`),console.error(f)});const t=o.onDidChangeFile(f=>{const d=[];for(const l of f){const{uri:c,type:h}=l;if(c.scheme!==m)continue;let g;switch(h){case R.FileChangeType.Changed:g=0;break;case R.FileChangeType.Created:g=1;break;case R.FileChangeType.Deleted:g=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:c,type:g})}this.a.$onFileSystemChange(i,d)});return(0,L.$Sc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:m,ctime:o,mtime:n,size:i,permissions:r}=a;return{type:m,ctime:o,mtime:n,size:i,permissions:r}}$stat(a,m){return Promise.resolve(this.l(a).stat(u.URI.revive(m))).then(o=>E.k(o))}$readdir(a,m){return Promise.resolve(this.l(a).readDirectory(u.URI.revive(m)))}$readFile(a,m){return Promise.resolve(this.l(a).readFile(u.URI.revive(m))).then(o=>S.$Ce.wrap(o))}$writeFile(a,m,o,n){return Promise.resolve(this.l(a).writeFile(u.URI.revive(m),o.buffer,n))}$delete(a,m,o){return Promise.resolve(this.l(a).delete(u.URI.revive(m),o))}$rename(a,m,o,n){return Promise.resolve(this.l(a).rename(u.URI.revive(m),u.URI.revive(o),n))}$copy(a,m,o,n){const i=this.l(a);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(u.URI.revive(m),u.URI.revive(o),n))}$mkdir(a,m){return Promise.resolve(this.l(a).createDirectory(u.URI.revive(m)))}$watch(a,m,o,n){const i=this.l(a).watch(u.URI.revive(o),n);this.f.set(m,i)}$unwatch(a,m){const o=this.f.get(m);o&&(o.dispose(),this.f.delete(m))}$open(a,m,o){const n=this.l(a);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(u.URI.revive(m),o))}$close(a,m){const o=this.l(a);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(m))}$read(a,m,o,n){const i=this.l(a);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const r=S.$Ce.alloc(n);return Promise.resolve(i.read(m,o,r.buffer,0,n)).then(s=>r.slice(0,s))}$write(a,m,o,n){const i=this.l(a);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(m,o,n.buffer,0,n.byteLength))}l(a){const m=this.c.get(a);if(!m){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return m}}e.$flc=E}),define(ke[337],Ee([1,0,4,35,2,6,16,8,46]),function(le,e,u,N,L,R,M,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;class S{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(E,v,a,m,o,n){this.a=Math.random(),this.b=new u.$be,this.c=new u.$be,this.d=new u.$be,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,N.$kk)(o),r=typeof o=="string",s=n?.correlate,t=m(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(s&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const d of f.created){const l=L.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.b.fire(l)}if(!n?.ignoreChangeEvents)for(const d of f.changed){const l=L.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.c.fire(l)}if(!n?.ignoreDeleteEvents)for(const d of f.deleted){const l=L.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=p.$RM.from(this.i(E,a,o,n,n?.correlate),this.b,this.c,this.d,t)}i(E,v,a,m,o){const n=p.$RM.from();if(typeof a=="string")return n;const i=E.getProxy(R.$PM.MainThreadFileSystemEventService);let r=!1;return(a.pattern.includes(N.$gk)||a.pattern.includes(N.$hk))&&(r=!0),i.$watch(v.identifier.value,this.a,a.baseUri,{recursive:r,excludes:m?.excludes??[]},!!o),p.$RM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(E){this.a=E,this.session=this.a.session,this.b=new b.$V(()=>this.a.created.map(L.URI.revive)),this.c=new b.$V(()=>this.a.changed.map(L.URI.revive)),this.d=new b.$V(()=>this.a.deleted.map(L.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(E,v,a){this.j=E,this.k=v,this.l=a,this.a=new u.$be,this.b=new u.$be,this.c=new u.$be,this.d=new u.$be,this.g=new u.$de,this.h=new u.$de,this.i=new u.$de,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,v,a,m){return new S(this.j,E,v,this.a.event,M.GlobPattern.from(a),m)}$onFileEvent(E){this.a.fire(new A(E))}$onDidRunFileOperation(E,v){switch(E){case 2:this.b.fire(Object.freeze({files:v.map(a=>({oldUri:L.URI.revive(a.source),newUri:L.URI.revive(a.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(a=>L.URI.revive(a.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(a=>L.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,v){return(a,m,o)=>{const n=function(r){a.call(m,r)};return n.extension=E,v.event(n,void 0,o)}}async $onWillRunFileOperation(E,v,a,m){switch(E){case 2:return await this.n(this.g,{files:v.map(o=>({oldUri:L.URI.revive(o.source),newUri:L.URI.revive(o.target)}))},a,m);case 1:return await this.n(this.i,{files:v.map(o=>L.URI.revive(o.target))},a,m);case 0:case 3:return await this.n(this.h,{files:v.map(o=>L.URI.revive(o.target))},a,m)}}async n(E,v,a,m){const o=new Set,n=[];if(await E.fireAsync(v,m,async(r,s)=>{const t=Date.now(),f=await Promise.resolve(r);f instanceof p.$2M&&(n.push([s.extension,f]),o.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-t>a&&this.k.warn("SLOW file-participant",s.extension.identifier)}),m.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,r]of n){const{edits:s}=M.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(s)}return{edit:i,extensionNames:Array.from(o)}}}e.$glc=P}),define(ke[338],Ee([1,0,19,7,22,13,124,3,24,39,14,18,2,29,176,83,134,221,25,16,8,26,111,6]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=void 0;class d{constructor(q,V){this.d=q,this.e=V}async provideDocumentSymbols(q,V){const Q=this.d.getDocument(q),J=await this.e.provideDocumentSymbols(Q,V);if(!(0,u.$Kb)(J))return J[0]instanceof r.$$M?J.map(i.DocumentSymbol.from):d.f(J)}static f(q){q=q.slice(0).sort((J,he)=>{let pe=J.location.range.start.compareTo(he.location.range.start);return pe===0&&(pe=he.location.range.end.compareTo(J.location.range.end)),pe});const V=[],Q=[];for(const J of q){const he={name:J.name||"!!MISSING: name!!",kind:i.SymbolKind.from(J.kind),tags:J.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:i.Range.from(J.location.range),selectionRange:i.Range.from(J.location.range),children:[]};for(;;){if(Q.length===0){Q.push(he),V.push(he);break}const pe=Q[Q.length-1];if(E.$kt.containsRange(pe.range,he.range)&&!E.$kt.equalsRange(pe.range,he.range)){pe.children?.push(he),Q.push(he);break}Q.pop()}}return V}}class l{constructor(q,V,Q,J,he,pe){this.f=q,this.g=V,this.h=Q,this.j=J,this.k=he,this.l=pe,this.d=new t.$Zjc("CodeLens"),this.e=new Map}async provideCodeLenses(q,V){const Q=this.f.getDocument(q),J=await this.h.provideCodeLenses(Q,V);if(!J||V.isCancellationRequested)return;const he=this.d.add(J),pe=new p.$Tc;this.e.set(he,pe);const ze={cacheId:he,lenses:[]};for(let Ve=0;Ve<J.length;Ve++)ze.lenses.push({cacheId:[he,Ve],range:i.Range.from(J[Ve].range),command:this.g.toInternal(J[Ve].command,pe)});return ze}async resolveCodeLens(q,V){const Q=q.cacheId&&this.d.get(...q.cacheId);if(!Q)return;let J;if(typeof this.h.resolveCodeLens!="function"||Q.isResolved?J=Q:J=await this.h.resolveCodeLens(Q,V),J||(J=Q),V.isCancellationRequested)return;const he=q.cacheId&&this.e.get(q.cacheId[0]);if(he){if(!J.command){const pe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,pe),this.l.error(pe);return}return q.command=this.g.toInternal(J.command,he),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function c(Fe){return Array.isArray(Fe)?Fe.map(i.DefinitionLink.from):Fe?[i.DefinitionLink.from(Fe)]:[]}class h{constructor(q,V){this.d=q,this.e=V}async provideDefinition(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideDefinition(J,he,Q);return c(pe)}}class g{constructor(q,V){this.d=q,this.e=V}async provideDeclaration(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideDeclaration(J,he,Q);return c(pe)}}class D{constructor(q,V){this.d=q,this.e=V}async provideImplementation(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideImplementation(J,he,Q);return c(pe)}}class w{constructor(q,V){this.d=q,this.e=V}async provideTypeDefinition(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideTypeDefinition(J,he,Q);return c(pe)}}class k{constructor(q,V){this.d=q,this.e=V}async provideHover(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideHover(J,he,Q);if(!(!pe||(0,u.$Kb)(pe.contents)))return pe.range||(pe.range=J.getWordRangeAtPosition(he)),pe.range||(pe.range=new r.$TM(he,he)),i.Hover.from(pe)}}class y{constructor(q,V){this.d=q,this.e=V}async provideEvaluatableExpression(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideEvaluatableExpression(J,he,Q);if(pe)return i.EvaluatableExpression.from(pe)}}class C{constructor(q,V){this.d=q,this.e=V}async provideInlineValues(q,V,Q,J){const he=this.d.getDocument(q),pe=await this.e.provideInlineValues(he,i.Range.to(V),i.InlineValueContext.to(Q),J);if(Array.isArray(pe))return pe.map(ze=>i.InlineValue.from(ze))}}class I{constructor(q,V){this.d=q,this.e=V}async provideDocumentHighlights(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideDocumentHighlights(J,he,Q);if(Array.isArray(pe))return pe.map(i.DocumentHighlight.from)}}class F{constructor(q,V){this.d=q,this.e=V}async provideMultiDocumentHighlights(q,V,Q,J){const he=this.d.getDocument(q),pe=Q.map(Ze=>this.d.getDocument(Ze)),ze=i.Position.to(V),Ve=await this.e.provideMultiDocumentHighlights(he,ze,pe,J);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class j{constructor(q,V){this.d=q,this.e=V}async provideLinkedEditingRanges(q,V,Q){const J=this.d.getDocument(q),he=i.Position.to(V),pe=await this.e.provideLinkedEditingRanges(J,he,Q);if(pe&&Array.isArray(pe.ranges))return{ranges:(0,u.$Hb)(pe.ranges.map(i.Range.from)),wordPattern:pe.wordPattern}}}class z{constructor(q,V){this.d=q,this.e=V}async provideReferences(q,V,Q,J){const he=this.d.getDocument(q),pe=i.Position.to(V),ze=await this.e.provideReferences(he,pe,Q,J);if(Array.isArray(ze))return ze.map(i.location.from)}}class O{static{this.d=1e3}constructor(q,V,Q,J,he,pe,ze){this.g=q,this.h=V,this.j=Q,this.k=J,this.l=he,this.m=pe,this.n=ze,this.e=new t.$Zjc("CodeAction"),this.f=new Map}async provideCodeActions(q,V,Q,J){const he=this.g.getDocument(q),pe=v.$mt.isISelection(V)?i.Selection.to(V):i.Range.to(V),ze=[];for(const st of this.j.getDiagnostics(q))if(pe.intersection(st.range)&&ze.push(st)>O.d)break;const Ve={diagnostics:ze,only:Q.only?new r.$aN(Q.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Q.trigger)},Ze=await this.k.provideCodeActions(he,pe,Ve,J);if(!(0,u.$Lb)(Ze)||J.isCancellationRequested)return;const tt=this.e.add(Ze),ot=new p.$Tc;this.f.set(tt,ot);const it=[];for(let st=0;st<Ze.length;st++){const De=Ze[st];if(De)if(O.o(De))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:De.title,command:this.h.toInternal(De,ot)});else{Ve.only&&(De.kind?Ve.only.contains(De.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${De.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=De.ranges??[];it.push({cacheId:[tt,st],title:De.title,command:De.command&&this.h.toInternal(De.command,ot),diagnostics:De.diagnostics&&De.diagnostics.map(i.Diagnostic.from),edit:De.edit&&i.WorkspaceEdit.from(De.edit,void 0),kind:De.kind&&De.kind.value,isPreferred:De.isPreferred,isAI:(0,s.$xG)(this.m,"codeActionAI")?De.isAI:!1,ranges:(0,s.$xG)(this.m,"codeActionRanges")?(0,u.$Hb)(Be.map(i.Range.from)):void 0,disabled:De.disabled?.reason})}}return{cacheId:tt,actions:it}}async resolveCodeAction(q,V){const[Q,J]=q,he=this.e.get(Q,J);if(!he||O.o(he))return{};if(!this.k.resolveCodeAction)return{};const pe=await this.k.resolveCodeAction(he,V)??he;let ze;pe.edit&&(ze=i.WorkspaceEdit.from(pe.edit,void 0));let Ve;if(pe.command){const Ze=this.f.get(Q);Ze&&(Ve=this.h.toInternal(pe.command,Ze))}return{edit:ze,command:Ve}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class T{constructor(q,V,Q,J,he){this.e=q,this.f=V,this.g=Q,this.h=J,this.j=he,this.d=new t.$Zjc("DocumentPasteEdit")}async prepareDocumentPaste(q,V,Q,J){if(!this.g.prepareDocumentPaste)return;const he=this.f.getDocument(q),pe=V.map(Ze=>i.Range.to(Ze)),ze=i.DataTransfer.toDataTransfer(Q,()=>{throw new R.$$});if(await this.g.prepareDocumentPaste(he,pe,ze,J),J.isCancellationRequested)return;const Ve=Array.from(ze).filter(([,Ze])=>!(Ze instanceof r.$GN));return i.DataTransfer.from(Ve)}async providePasteEdits(q,V,Q,J,he,pe){if(!this.g.provideDocumentPasteEdits)return[];const ze=this.f.getDocument(V),Ve=Q.map(it=>i.Range.to(it)),Ze=i.DataTransfer.toDataTransfer(J,async it=>(await this.e.$resolvePasteFileData(this.h,q,it)).buffer),tt=await this.g.provideDocumentPasteEdits(ze,Ve,Ze,{only:he.only?new r.$LN(he.only):void 0,triggerKind:he.triggerKind},pe);if(!tt||pe.isCancellationRequested)return[];const ot=this.d.add(tt);return tt.map((it,st)=>({_cacheId:[ot,st],title:it.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:it.kind,yieldTo:it.yieldTo?.map(De=>De.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?i.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,V){const[Q,J]=q,he=this.d.get(Q,J);if(!he||!this.g.resolveDocumentPasteEdit)return{};const pe=await this.g.resolveDocumentPasteEdit(he,V)??he;return{additionalEdit:pe.additionalEdit?i.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class B{constructor(q,V){this.d=q,this.e=V}async provideDocumentFormattingEdits(q,V,Q){const J=this.d.getDocument(q),he=await this.e.provideDocumentFormattingEdits(J,V,Q);if(Array.isArray(he))return he.map(i.TextEdit.from)}}class W{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeFormattingEdits(q,V,Q,J){const he=this.d.getDocument(q),pe=i.Range.to(V),ze=await this.e.provideDocumentRangeFormattingEdits(he,pe,Q,J);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,V,Q,J){(0,P.$bg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const he=this.d.getDocument(q),pe=V.map(i.Range.to),ze=await this.e.provideDocumentRangesFormattingEdits(he,pe,Q,J);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class Z{constructor(q,V){this.d=q,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,V,Q,J,he){const pe=this.d.getDocument(q),ze=i.Position.to(V),Ve=await this.e.provideOnTypeFormattingEdits(pe,ze,Q,J,he);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class x{constructor(q,V){this.e=q,this.f=V,this.d=new t.$Zjc("WorkspaceSymbols")}async provideWorkspaceSymbols(q,V){const Q=await this.e.provideWorkspaceSymbols(q,V);if(!(0,u.$Lb)(Q))return{symbols:[]};const J=this.d.add(Q),he={cacheId:J,symbols:[]};for(let pe=0;pe<Q.length;pe++){const ze=Q[pe];if(!ze||!ze.name){this.f.warn("INVALID SymbolInformation",ze);continue}he.symbols.push({...i.WorkspaceSymbol.from(ze),cacheId:[J,pe]})}return he}async resolveWorkspaceSymbol(q,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const Q=this.d.get(...q.cacheId);if(Q){const J=await this.e.resolveWorkspaceSymbol(Q,V);return J&&(0,b.$Zn)(q,i.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class X{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,V,Q){this.d=q,this.e=V,this.f=Q}async provideRenameEdits(q,V,Q,J){const he=this.d.getDocument(q),pe=i.Position.to(V);try{const ze=await this.e.provideRenameEdits(he,pe,Q,J);return ze?i.WorkspaceEdit.from(ze):void 0}catch(ze){const Ve=X.g(ze);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(ze)}}async resolveRenameLocation(q,V,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(q),he=i.Position.to(V);try{const pe=await this.e.prepareRename(J,he,Q);let ze,Ve;if(r.$TM.isRange(pe)?(ze=pe,Ve=J.getText(pe)):(0,P.$6f)(pe)&&(ze=pe.range,Ve=pe.placeholder),!ze||!Ve)return;if(ze.start.line>he.line||ze.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(ze),text:Ve}}catch(pe){const ze=X.g(pe);return ze?{rejectReason:ze,range:void 0,text:void 0}:Promise.reject(pe)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class Y{constructor(q,V,Q){this.d=q,this.e=V,this.f=Q}async provideNewSymbolNames(q,V,Q){const J=this.d.getDocument(q),he=i.Range.to(V);try{const pe=await this.e.provideNewSymbolNames(J,he,Q);return pe?pe.map(ze=>typeof ze=="string"?{newSymbolName:ze}:{newSymbolName:ze.newSymbolName,tags:ze.tags}):void 0}catch(pe){this.f.error(Y.g(pe)??JSON.stringify(pe,null,"	"));return}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class ce{constructor(q,V){this.resultId=q,this.tokens=V}}class ne{constructor(q,V){this.f=q,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,V,Q){const J=this.f.getDocument(q),he=V!==0?this.d.get(V):null;let pe=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,he.resultId,Q):await this.g.provideDocumentSemanticTokens(J,Q);return he&&this.d.delete(V),pe?(pe=ne.h(pe),this.o(ne.n(he,pe),pe)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return ne.j(q)?ne.k(q)?q:new r.$_N(new Uint32Array(q.data),q.resultId):ne.l(q)?ne.m(q)?q:new r.$bO(q.edits.map(V=>new r.$aO(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const V of q.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(q,V){if(!ne.j(V)||!q||!q.tokens)return V;const Q=q.tokens,J=Q.length,he=V.data,pe=he.length;let ze=0;const Ve=Math.min(J,pe);for(;ze<Ve&&Q[ze]===he[ze];)ze++;if(ze===J&&ze===pe)return new r.$bO([],V.resultId);let Ze=0;const tt=Ve-ze;for(;Ze<tt&&Q[J-Ze-1]===he[pe-Ze-1];)Ze++;return new r.$bO([{start:ze,deleteCount:J-ze-Ze,data:he.subarray(ze,pe-Ze)}],V.resultId)}o(q,V){if(ne.j(q)){const Q=this.e++;return this.d.set(Q,new ce(q.resultId,q.data)),(0,m.$hbb)({id:Q,type:"full",data:q.data})}if(ne.l(q)){const Q=this.e++;return ne.j(V)?this.d.set(Q,new ce(V.resultId,V.data)):this.d.set(Q,new ce(q.resultId)),(0,m.$hbb)({id:Q,type:"delta",deltas:(q.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class $e{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeSemanticTokens(q,V,Q){const J=this.d.getDocument(q),he=await this.e.provideDocumentRangeSemanticTokens(J,i.Range.to(V),Q);return he?this.f(he):null}f(q){return(0,m.$hbb)({id:0,type:"full",data:q.data})}}class Ce{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,V,Q,J,he){this.f=q,this.g=V,this.h=Q,this.j=J,this.k=he,this.d=new t.$Zjc("CompletionItem"),this.e=new Map}async provideCompletionItems(q,V,Q,J){const he=this.f.getDocument(q),pe=i.Position.to(V),ze=he.getWordRangeAtPosition(pe)||new r.$TM(pe,pe),Ve=ze.with({end:pe}),Ze=new S.$0d,tt=await this.h.provideCompletionItems(he,pe,J,i.CompletionContext.to(Q));if(!tt||J.isCancellationRequested)return;const ot=Array.isArray(tt)?new r.$nN(tt):tt,it=Ce.supportsResolving(this.h)?this.d.add(ot.items):this.d.add([]),st=new p.$Tc;this.e.set(it,st);const De=[],Be={x:it,b:De,a:{replace:i.Range.from(ze),insert:i.Range.from(Ve)},c:ot.isIncomplete||void 0,d:Ze.elapsed()};for(let He=0;He<ot.items.length;He++){const Le=ot.items[He],Xe=this.l(Le,[it,He],Ve,ze);De.push(Xe)}return Be}async resolveCompletionItem(q,V){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...q);if(!Q)return;const J=this.l(Q,q),he=await this.h.resolveCompletionItem(Q,V);if(!he)return;const pe=this.l(he,q);return(J.h!==pe.h||J.i!==pe.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==pe.n||J.o!==pe.o||!(0,b.$1n)(J.p,pe.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:pe.d,c:pe.c,l:pe.l,h:pe.h,i:pe.i,n:pe.n,o:pe.o,p:pe.p}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V,Q,J){const he=this.e.get(V[0]);if(!he)throw Error("DisposableStore is missing...");const pe=this.g.toInternal(q.command,he),ze={x:V,a:q.label,b:q.kind!==void 0?i.CompletionItemKind.from(q.kind):void 0,m:q.tags&&q.tags.map(i.CompletionItemTag.from),c:q.detail,d:typeof q.documentation>"u"?void 0:i.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters?.join(""),l:q.additionalTextEdits&&q.additionalTextEdits.map(i.TextEdit.from),n:pe?.$ident,o:pe?.id,p:pe?.$ident?void 0:pe?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ze.h=q.textEdit.newText):typeof q.insertText=="string"?ze.h=q.insertText:q.insertText instanceof r.$3M&&(ze.h=q.insertText.value,ze.i|=4);let Ve;return q.textEdit?Ve=q.textEdit.range:q.range&&(Ve=q.range),r.$TM.isRange(Ve)?ze.j=i.Range.from(Ve):Ve&&(!Q?.isEqual(Ve.inserting)||!J?.isEqual(Ve.replacing))&&(ze.j={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),ze}}class ee{async provideInlineCompletions(q,V,Q,J){}disposeCompletions(q){}handleDidShowCompletionItem(q,V,Q){}handlePartialAccept(q,V,Q,J){}}class U extends ee{constructor(q,V,Q,J){super(),this.f=q,this.g=V,this.h=Q,this.j=J,this.d=new be,this.e=(0,s.$xG)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.$xG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,V,Q,J){const he=this.g.getDocument(q),pe=i.Position.to(V),ze=await this.h.provideInlineCompletionItems(he,pe,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:i.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},J);if(!ze||J.isCancellationRequested)return;const Ve=Array.isArray(ze)?ze:ze.items,Ze=this.e?Array.isArray(ze)?[]:ze.commands||[]:[],tt=this.e&&!Array.isArray(ze)?ze.enableForwardStability:void 0;let ot;return{pid:this.d.createReferenceId({dispose(){ot?.dispose()},items:Ve}),items:Ve.map((st,De)=>{let Be;st.command&&(ot||(ot=new p.$Tc),Be=this.j.toInternal(st.command,ot));const He=st.insertText;return{insertText:typeof He=="string"?He:{snippet:He.value},filterText:st.filterText,range:st.range?i.Range.from(st.range):void 0,command:Be,idx:De,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:Ze.map(st=>(ot||(ot=new p.$Tc),this.j.toInternal(st,ot))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,V,Q){const J=this.d.get(q)?.items[V];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,Q)}handlePartialAccept(q,V,Q,J){const he=this.d.get(q)?.items[V];he&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(he,Q),this.h.handleDidPartiallyAcceptCompletionItem(he,i.PartialAcceptInfo.to(J)))}}class ie{async provideInlineEdits(q,V,Q){const J=this.f.getDocument(q),he=await this.g.provideInlineEdit(J,{triggerKind:this.e[V.triggerKind]},Q);if(!he||Q.isCancellationRequested)return;let pe;const ze=this.d.createReferenceId({dispose(){pe?.dispose()},item:he});let Ve;he.accepted&&(pe||(pe=new p.$Tc),Ve=this.h.toInternal(he.accepted,pe));let Ze;return he.rejected&&(pe||(pe=new p.$Tc),Ze=this.h.toInternal(he.rejected,pe)),{pid:ze,text:he.text,range:i.Range.from(he.range),accepted:Ve,rejected:Ze}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,V,Q,J){this.f=V,this.g=Q,this.h=J,this.d=new be,this.e={[a.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const V=this.e++;return this.d.set(V,q),V}disposeReferenceId(q){const V=this.d.get(q);return this.d.delete(q),V}get(q){return this.d.get(q)}}class Pe{constructor(q,V){this.e=q,this.f=V,this.d=new t.$Zjc("SignatureHelp")}async provideSignatureHelp(q,V,Q,J){const he=this.e.getDocument(q),pe=i.Position.to(V),ze=this.g(Q),Ve=await this.f.provideSignatureHelp(he,pe,J,ze);if(Ve){const Ze=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Ze}}}g(q){let V;if(q.activeSignatureHelp){const Q=i.SignatureHelp.to(q.activeSignatureHelp),J=this.d.get(q.activeSignatureHelp.id,0);J?(V=J,V.activeSignature=Q.activeSignature,V.activeParameter=Q.activeParameter):V=Q}return{...q,activeSignatureHelp:V}}releaseSignatureHelp(q){this.d.delete(q)}}class oe{constructor(q,V,Q,J,he){this.f=q,this.g=V,this.h=Q,this.j=J,this.k=he,this.d=new t.$Zjc("InlayHints"),this.e=new Map}async provideInlayHints(q,V,Q){const J=this.f.getDocument(q),he=i.Range.to(V),pe=await this.h.provideInlayHints(J,he,Q);if(!Array.isArray(pe)||pe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(Q.isCancellationRequested)return;const ze=this.d.add(pe);this.e.set(ze,new p.$Tc);const Ve={hints:[],cacheId:ze};for(let Ze=0;Ze<pe.length;Ze++)this.l(pe[Ze],he)&&Ve.hints.push(this.m(pe[Ze],[ze,Ze]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),Ve}async resolveInlayHint(q,V){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...q);if(!Q)return;const J=await this.h.resolveInlayHint(Q,V);if(J&&this.l(J))return this.m(J,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V){return q.label.length===0||Array.isArray(q.label)&&q.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(V&&!V.contains(q.position))}m(q,V){const Q=this.e.get(V[0]);if(!Q)throw Error("DisposableStore is missing...");const J={label:"",cacheId:V,tooltip:i.MarkdownString.fromStrict(q.tooltip),position:i.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(i.TextEdit.from),kind:q.kind&&i.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")J.label=q.label;else{const he=[];J.label=he;for(const pe of q.label){if(!pe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const ze={label:pe.value,tooltip:i.MarkdownString.fromStrict(pe.tooltip)};r.$4M.isLocation(pe.location)&&(ze.location=i.location.from(pe.location)),pe.command&&(ze.command=this.g.toInternal(pe.command,Q)),he.push(ze)}}return J}}class ae{constructor(q,V){this.e=q,this.f=V,this.d=new t.$Zjc("DocumentLink")}async provideLinks(q,V){const Q=this.e.getDocument(q),J=await this.f.provideDocumentLinks(Q,V);if(!(!Array.isArray(J)||J.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ae.g).map(i.DocumentLink.from)};{const he=this.d.add(J),pe={links:[],cacheId:he};for(let ze=0;ze<J.length;ze++){if(!ae.g(J[ze]))continue;const Ve=i.DocumentLink.from(J[ze]);Ve.cacheId=[he,ze],pe.links.push(Ve)}return pe}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,V){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...q);if(!Q)return;const J=await this.f.resolveDocumentLink(Q,V);if(!(!J||!ae.g(J)))return i.DocumentLink.from(J)}releaseLinks(q){this.d.delete(q)}}class re{constructor(q,V){this.d=q,this.e=V}async provideColors(q,V){const Q=this.d.getDocument(q),J=await this.e.provideDocumentColors(Q,V);return Array.isArray(J)?J.map(pe=>({color:i.Color.from(pe.color),range:i.Range.from(pe.range)})):[]}async provideColorPresentations(q,V,Q){const J=this.d.getDocument(q),he=i.Range.to(V.range),pe=i.Color.to(V.color),ze=await this.e.provideColorPresentations(pe,{document:J,range:he},Q);if(Array.isArray(ze))return ze.map(i.ColorPresentation.from)}}class G{constructor(q,V){this.d=q,this.e=V}async provideFoldingRanges(q,V,Q){const J=this.d.getDocument(q),he=await this.e.provideFoldingRanges(J,V,Q);if(Array.isArray(he))return he.map(i.FoldingRange.from)}}class te{constructor(q,V,Q){this.d=q,this.e=V,this.f=Q}async provideSelectionRanges(q,V,Q){const J=this.d.getDocument(q),he=V.map(i.Position.to),pe=await this.e.provideSelectionRanges(J,he,Q);if(!(0,u.$Lb)(pe))return[];if(pe.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ze=[];for(let Ve=0;Ve<he.length;Ve++){const Ze=[];ze.push(Ze);let tt=he[Ve],ot=pe[Ve];for(;;){if(!ot.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Ze.push(i.SelectionRange.from(ot)),!ot.parent)break;tt=ot.range,ot=ot.parent}}return ze}}class ge{constructor(q,V){this.f=q,this.g=V,this.d=new M.$fP(""),this.e=new Map}async prepareSession(q,V,Q){const J=this.f.getDocument(q),he=i.Position.to(V),pe=await this.g.prepareCallHierarchy(J,he,Q);if(!pe)return;const ze=this.d.nextId();return this.e.set(ze,new Map),Array.isArray(pe)?pe.map(Ve=>this.h(ze,Ve)):[this.h(ze,pe)]}async provideCallsTo(q,V,Q){const J=this.j(q,V);if(!J)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(J,Q);if(he)return he.map(pe=>({from:this.h(q,pe.from),fromRanges:pe.fromRanges.map(ze=>i.Range.from(ze))}))}async provideCallsFrom(q,V,Q){const J=this.j(q,V);if(!J)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(J,Q);if(he)return he.map(pe=>({to:this.h(q,pe.to),fromRanges:pe.fromRanges.map(ze=>i.Range.from(ze))}))}releaseSession(q){this.e.delete(q)}h(q,V){const Q=this.e.get(q),J=i.CallHierarchyItem.from(V,q,Q.size.toString(36));return Q.set(J._itemId,V),J}j(q,V){return this.e.get(q)?.get(V)}}class we{constructor(q,V){this.f=q,this.g=V,this.d=new M.$fP(""),this.e=new Map}async prepareSession(q,V,Q){const J=this.f.getDocument(q),he=i.Position.to(V),pe=await this.g.prepareTypeHierarchy(J,he,Q);if(!pe)return;const ze=this.d.nextId();return this.e.set(ze,new Map),Array.isArray(pe)?pe.map(Ve=>this.h(ze,Ve)):[this.h(ze,pe)]}async provideSupertypes(q,V,Q){const J=this.j(q,V);if(!J)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(J,Q);if(he)return he.map(pe=>this.h(q,pe))}async provideSubtypes(q,V,Q){const J=this.j(q,V);if(!J)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(J,Q);if(he)return he.map(pe=>this.h(q,pe))}releaseSession(q){this.e.delete(q)}h(q,V){const Q=this.e.get(q),J=i.TypeHierarchyItem.from(V,q,Q.size.toString(36));return Q.set(J._itemId,V),J}j(q,V){return this.e.get(q)?.get(V)}}class Re{constructor(q,V,Q,J,he){this.e=q,this.f=V,this.g=Q,this.h=J,this.j=he,this.d=new t.$Zjc("DocumentDropEdit")}async provideDocumentOnDropEdits(q,V,Q,J,he){const pe=this.f.getDocument(V),ze=i.Position.to(Q),Ve=i.DataTransfer.toDataTransfer(J,async it=>(await this.e.$resolveDocumentOnDropFileData(this.h,q,it)).buffer),Ze=await this.g.provideDocumentDropEdits(pe,ze,Ve,he);if(!Ze)return;const tt=(0,u.$3b)(Ze),ot=this.d.add(tt);return tt.map((it,st)=>({_cacheId:[ot,st],title:it.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:it.kind?.value,yieldTo:it.yieldTo?.map(De=>De.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?i.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}async resolveDropEdit(q,V){const[Q,J]=q,he=this.d.get(Q,J);if(!he||!this.g.resolveDocumentDropEdit)return{};const pe=await this.g.resolveDocumentDropEdit(he,V)??he;return{additionalEdit:pe.additionalEdit?i.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}releaseDropEdits(q){this.d.delete(q)}}class fe{constructor(q,V){this.d=q,this.e=V}async provideMappedEdits(q,V,Q,J){const he=$.URI.revive(q),pe=this.d.getDocument(he),ze=Q.documents.map(tt=>tt.map(ot=>({uri:$.URI.revive(ot.uri),version:ot.version,ranges:ot.ranges.map(it=>i.Range.to(it))}))),Ve={documents:ze,selections:ze[0]?.[0]?.ranges??[]},Ze=await this.e.provideMappedEdits(pe,V,Ve,J);return Ze?i.WorkspaceEdit.from(Ze):null}}class Se{constructor(q,V){this.adapter=q,this.extension=V}}class Ae{static{this.d=0}constructor(q,V,Q,J,he,pe,ze,Ve){this.g=V,this.h=Q,this.j=J,this.k=he,this.l=pe,this.m=ze,this.n=Ve,this.f=new Map,this.e=q.getProxy(f.$PM.MainThreadLanguageFeatures)}o(q,V){return i.DocumentSelector.from(q,this.g,V)}p(q){return new r.$RM(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Ae.d++}async s(q,V,Q,J,he,pe=!1){const ze=this.f.get(q);if(!ze||!(ze.adapter instanceof V))return J;const Ve=Date.now();pe||this.l.trace(`[${ze.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const Ze=Q(ze.adapter,ze.extension);return Promise.resolve(Ze).catch(tt=>{(0,R.$4)(tt)||(this.l.error(`[${ze.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(ze.extension.identifier,tt))}).finally(()=>{pe||this.l.trace(`[${ze.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),L.CancellationToken.isCancellationToken(he)?(0,N.$fh)(Ze,he):Ze}t(q,V){const Q=this.q();return this.f.set(Q,new Se(q,V)),Q}static u(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,V,Q,J){const he=this.t(new d(this.h,Q),q),pe=J&&J.label||Ae.u(q);return this.e.$registerDocumentSymbolProvider(he,this.o(V,q),pe),this.p(he)}$provideDocumentSymbols(q,V,Q){return this.s(q,d,J=>J.provideDocumentSymbols($.URI.revive(V),Q),void 0,Q)}registerCodeLensProvider(q,V,Q){const J=this.q(),he=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new Se(new l(this.h,this.j.converter,Q,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(J,this.o(V,q),he);let pe=this.p(J);if(he!==void 0){const ze=Q.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(he));pe=r.$RM.from(pe,ze)}return pe}$provideCodeLenses(q,V,Q){return this.s(q,l,J=>J.provideCodeLenses($.URI.revive(V),Q),void 0,Q)}$resolveCodeLens(q,V,Q){return this.s(q,l,J=>J.resolveCodeLens(V,Q),void 0,void 0)}$releaseCodeLenses(q,V){this.s(q,l,Q=>Promise.resolve(Q.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(q,V,Q){const J=this.t(new h(this.h,Q),q);return this.e.$registerDefinitionSupport(J,this.o(V,q)),this.p(J)}$provideDefinition(q,V,Q,J){return this.s(q,h,he=>he.provideDefinition($.URI.revive(V),Q,J),[],J)}registerDeclarationProvider(q,V,Q){const J=this.t(new g(this.h,Q),q);return this.e.$registerDeclarationSupport(J,this.o(V,q)),this.p(J)}$provideDeclaration(q,V,Q,J){return this.s(q,g,he=>he.provideDeclaration($.URI.revive(V),Q,J),[],J)}registerImplementationProvider(q,V,Q){const J=this.t(new D(this.h,Q),q);return this.e.$registerImplementationSupport(J,this.o(V,q)),this.p(J)}$provideImplementation(q,V,Q,J){return this.s(q,D,he=>he.provideImplementation($.URI.revive(V),Q,J),[],J)}registerTypeDefinitionProvider(q,V,Q){const J=this.t(new w(this.h,Q),q);return this.e.$registerTypeDefinitionSupport(J,this.o(V,q)),this.p(J)}$provideTypeDefinition(q,V,Q,J){return this.s(q,w,he=>he.provideTypeDefinition($.URI.revive(V),Q,J),[],J)}registerHoverProvider(q,V,Q,J){const he=this.t(new k(this.h,Q),q);return this.e.$registerHoverProvider(he,this.o(V,q)),this.p(he)}$provideHover(q,V,Q,J){return this.s(q,k,he=>he.provideHover($.URI.revive(V),Q,J),void 0,J)}registerEvaluatableExpressionProvider(q,V,Q,J){const he=this.t(new y(this.h,Q),q);return this.e.$registerEvaluatableExpressionProvider(he,this.o(V,q)),this.p(he)}$provideEvaluatableExpression(q,V,Q,J){return this.s(q,y,he=>he.provideEvaluatableExpression($.URI.revive(V),Q,J),void 0,J)}registerInlineValuesProvider(q,V,Q,J){const he=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,pe=this.t(new C(this.h,Q),q);this.e.$registerInlineValuesProvider(pe,this.o(V,q),he);let ze=this.p(pe);if(he!==void 0){const Ve=Q.onDidChangeInlineValues(Ze=>this.e.$emitInlineValuesEvent(he));ze=r.$RM.from(ze,Ve)}return ze}$provideInlineValues(q,V,Q,J,he){return this.s(q,C,pe=>pe.provideInlineValues($.URI.revive(V),Q,J,he),void 0,he)}registerDocumentHighlightProvider(q,V,Q){const J=this.t(new I(this.h,Q),q);return this.e.$registerDocumentHighlightProvider(J,this.o(V,q)),this.p(J)}registerMultiDocumentHighlightProvider(q,V,Q){const J=this.t(new F(this.h,Q),q);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(V,q)),this.p(J)}$provideDocumentHighlights(q,V,Q,J){return this.s(q,I,he=>he.provideDocumentHighlights($.URI.revive(V),Q,J),void 0,J)}$provideMultiDocumentHighlights(q,V,Q,J,he){return this.s(q,F,pe=>pe.provideMultiDocumentHighlights($.URI.revive(V),Q,J.map(ze=>$.URI.revive(ze)),he),void 0,he)}registerLinkedEditingRangeProvider(q,V,Q){const J=this.t(new j(this.h,Q),q);return this.e.$registerLinkedEditingRangeProvider(J,this.o(V,q)),this.p(J)}$provideLinkedEditingRanges(q,V,Q,J){return this.s(q,j,async he=>{const pe=await he.provideLinkedEditingRanges($.URI.revive(V),Q,J);if(pe)return{ranges:pe.ranges,wordPattern:pe.wordPattern?Ae.w(pe.wordPattern):void 0}},void 0,J)}registerReferenceProvider(q,V,Q){const J=this.t(new z(this.h,Q),q);return this.e.$registerReferenceSupport(J,this.o(V,q)),this.p(J)}$provideReferences(q,V,Q,J,he){return this.s(q,z,pe=>pe.provideReferences($.URI.revive(V),Q,J,he),void 0,he)}registerCodeActionProvider(q,V,Q,J){const he=new p.$Tc,pe=this.t(new O(this.h,this.j.converter,this.k,Q,this.l,q,this.m),q);return this.e.$registerQuickFixSupport(pe,this.o(V,q),{providedKinds:J?.providedCodeActionKinds?.map(ze=>ze.value),documentation:J?.documentation?.map(ze=>({kind:ze.kind.value,command:this.j.converter.toInternal(ze.command,he)}))},Ae.u(q),!!Q.resolveCodeAction),he.add(this.p(pe)),he}$provideCodeActions(q,V,Q,J,he){return this.s(q,O,pe=>pe.provideCodeActions($.URI.revive(V),Q,J,he),void 0,he)}$resolveCodeAction(q,V,Q){return this.s(q,O,J=>J.resolveCodeAction(V,Q),{},void 0)}$releaseCodeActions(q,V){this.s(q,O,Q=>Promise.resolve(Q.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(q,V,Q){const J=this.t(new B(this.h,Q),q);return this.e.$registerDocumentFormattingSupport(J,this.o(V,q),q.identifier,q.displayName||q.name),this.p(J)}$provideDocumentFormattingEdits(q,V,Q,J){return this.s(q,B,he=>he.provideDocumentFormattingEdits($.URI.revive(V),Q,J),void 0,J)}registerDocumentRangeFormattingEditProvider(q,V,Q){const J=typeof Q.provideDocumentRangesFormattingEdits=="function",he=this.t(new W(this.h,Q),q);return this.e.$registerRangeFormattingSupport(he,this.o(V,q),q.identifier,q.displayName||q.name,J),this.p(he)}$provideDocumentRangeFormattingEdits(q,V,Q,J,he){return this.s(q,W,pe=>pe.provideDocumentRangeFormattingEdits($.URI.revive(V),Q,J,he),void 0,he)}$provideDocumentRangesFormattingEdits(q,V,Q,J,he){return this.s(q,W,pe=>pe.provideDocumentRangesFormattingEdits($.URI.revive(V),Q,J,he),void 0,he)}registerOnTypeFormattingEditProvider(q,V,Q,J){const he=this.t(new Z(this.h,Q),q);return this.e.$registerOnTypeFormattingSupport(he,this.o(V,q),J,q.identifier),this.p(he)}$provideOnTypeFormattingEdits(q,V,Q,J,he,pe){return this.s(q,Z,ze=>ze.provideOnTypeFormattingEdits($.URI.revive(V),Q,J,he,pe),void 0,pe)}registerWorkspaceSymbolProvider(q,V){const Q=this.t(new x(V,this.l),q);return this.e.$registerNavigateTypeSupport(Q,typeof V.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(q,V,Q){return this.s(q,x,J=>J.provideWorkspaceSymbols(V,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(q,V,Q){return this.s(q,x,J=>J.resolveWorkspaceSymbol(V,Q),void 0,void 0)}$releaseWorkspaceSymbols(q,V){this.s(q,x,Q=>Q.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(q,V,Q){const J=this.t(new X(this.h,Q,this.l),q);return this.e.$registerRenameSupport(J,this.o(V,q),X.supportsResolving(Q)),this.p(J)}$provideRenameEdits(q,V,Q,J,he){return this.s(q,X,pe=>pe.provideRenameEdits($.URI.revive(V),Q,J,he),void 0,he)}$resolveRenameLocation(q,V,Q,J){return this.s(q,X,he=>he.resolveRenameLocation($.URI.revive(V),Q,J),void 0,J)}registerNewSymbolNamesProvider(q,V,Q){const J=this.t(new Y(this.h,Q,this.l),q);return this.e.$registerNewSymbolNamesProvider(J,this.o(V,q)),this.p(J)}$provideNewSymbolNames(q,V,Q,J){return this.s(q,Y,he=>he.provideNewSymbolNames($.URI.revive(V),Q,J),void 0,J)}registerDocumentSemanticTokensProvider(q,V,Q,J){const he=this.t(new ne(this.h,Q),q),pe=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(V,q),J,pe);let ze=this.p(he);if(pe){const Ve=Q.onDidChangeSemanticTokens(Ze=>this.e.$emitDocumentSemanticTokensEvent(pe));ze=r.$RM.from(ze,Ve)}return ze}$provideDocumentSemanticTokens(q,V,Q,J){return this.s(q,ne,he=>he.provideDocumentSemanticTokens($.URI.revive(V),Q,J),null,J)}$releaseDocumentSemanticTokens(q,V){this.s(q,ne,Q=>Q.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,V,Q,J){const he=this.t(new $e(this.h,Q),q);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(V,q),J),this.p(he)}$provideDocumentRangeSemanticTokens(q,V,Q,J){return this.s(q,$e,he=>he.provideDocumentRangeSemanticTokens($.URI.revive(V),Q,J),null,J)}registerCompletionItemProvider(q,V,Q,J){const he=this.t(new Ce(this.h,this.j.converter,Q,this.m,q),q);return this.e.$registerCompletionsProvider(he,this.o(V,q),J,Ce.supportsResolving(Q),q.identifier),this.p(he)}$provideCompletionItems(q,V,Q,J,he){return this.s(q,Ce,pe=>pe.provideCompletionItems($.URI.revive(V),Q,J,he),void 0,he)}$resolveCompletionItem(q,V,Q){return this.s(q,Ce,J=>J.resolveCompletionItem(V,Q),void 0,Q)}$releaseCompletionItems(q,V){this.s(q,Ce,Q=>Q.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(q,V,Q,J){const he=new U(q,this.h,Q,this.j.converter),pe=this.t(he,q);return this.e.$registerInlineCompletionsSupport(pe,this.o(V,q),he.supportsHandleEvents,n.$Lm.toKey(q.identifier.value),J?.yieldTo?.map(ze=>n.$Lm.toKey(ze))||[]),this.p(pe)}$provideInlineCompletions(q,V,Q,J,he){return this.s(q,ee,pe=>pe.provideInlineCompletions($.URI.revive(V),Q,J,he),void 0,he)}$handleInlineCompletionDidShow(q,V,Q,J){this.s(q,ee,async he=>{he.handleDidShowCompletionItem(V,Q,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,V,Q,J,he){this.s(q,ee,async pe=>{pe.handlePartialAccept(V,Q,J,he)},void 0,void 0)}$freeInlineCompletionsList(q,V){this.s(q,ee,async Q=>{Q.disposeCompletions(V)},void 0,void 0)}registerInlineEditProvider(q,V,Q){const J=new ie(q,this.h,Q,this.j.converter),he=this.t(J,q);return this.e.$registerInlineEditProvider(he,this.o(V,q),q.identifier),this.p(he)}$provideInlineEdit(q,V,Q,J){return this.s(q,ie,he=>he.provideInlineEdits($.URI.revive(V),Q,J),void 0,J)}$freeInlineEdit(q,V){this.s(q,ie,async Q=>{Q.disposeEdit(V)},void 0,void 0)}registerSignatureHelpProvider(q,V,Q,J){const he=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,pe=this.t(new Pe(this.h,Q),q);return this.e.$registerSignatureHelpProvider(pe,this.o(V,q),he),this.p(pe)}$provideSignatureHelp(q,V,Q,J,he){return this.s(q,Pe,pe=>pe.provideSignatureHelp($.URI.revive(V),Q,J,he),void 0,he)}$releaseSignatureHelp(q,V){this.s(q,Pe,Q=>Q.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(q,V,Q){const J=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new oe(this.h,this.j.converter,Q,this.l,q),q);this.e.$registerInlayHintsProvider(he,this.o(V,q),typeof Q.resolveInlayHint=="function",J,Ae.u(q));let pe=this.p(he);if(J!==void 0){const ze=Q.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(J));pe=r.$RM.from(pe,ze)}return pe}$provideInlayHints(q,V,Q,J){return this.s(q,oe,he=>he.provideInlayHints($.URI.revive(V),Q,J),void 0,J)}$resolveInlayHint(q,V,Q){return this.s(q,oe,J=>J.resolveInlayHint(V,Q),void 0,Q)}$releaseInlayHints(q,V){this.s(q,oe,Q=>Q.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(q,V,Q){const J=this.t(new ae(this.h,Q),q);return this.e.$registerDocumentLinkProvider(J,this.o(V,q),typeof Q.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(q,V,Q){return this.s(q,ae,J=>J.provideLinks($.URI.revive(V),Q),void 0,Q,V.scheme==="output")}$resolveDocumentLink(q,V,Q){return this.s(q,ae,J=>J.resolveLink(V,Q),void 0,void 0,!0)}$releaseDocumentLinks(q,V){this.s(q,ae,Q=>Q.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(q,V,Q){const J=this.t(new re(this.h,Q),q);return this.e.$registerDocumentColorProvider(J,this.o(V,q)),this.p(J)}$provideDocumentColors(q,V,Q){return this.s(q,re,J=>J.provideColors($.URI.revive(V),Q),[],Q)}$provideColorPresentations(q,V,Q,J){return this.s(q,re,he=>he.provideColorPresentations($.URI.revive(V),Q,J),void 0,J)}registerFoldingRangeProvider(q,V,Q){const J=this.q(),he=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new Se(new G(this.h,Q),q)),this.e.$registerFoldingRangeProvider(J,this.o(V,q),q.identifier,he);let pe=this.p(J);if(he!==void 0){const ze=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));pe=r.$RM.from(pe,ze)}return pe}$provideFoldingRanges(q,V,Q,J){return this.s(q,G,he=>he.provideFoldingRanges($.URI.revive(V),Q,J),void 0,J)}registerSelectionRangeProvider(q,V,Q){const J=this.t(new te(this.h,Q,this.l),q);return this.e.$registerSelectionRangeProvider(J,this.o(V,q)),this.p(J)}$provideSelectionRanges(q,V,Q,J){return this.s(q,te,he=>he.provideSelectionRanges($.URI.revive(V),Q,J),[],J)}registerCallHierarchyProvider(q,V,Q){const J=this.t(new ge(this.h,Q),q);return this.e.$registerCallHierarchyProvider(J,this.o(V,q)),this.p(J)}$prepareCallHierarchy(q,V,Q,J){return this.s(q,ge,he=>Promise.resolve(he.prepareSession($.URI.revive(V),Q,J)),void 0,J)}$provideCallHierarchyIncomingCalls(q,V,Q,J){return this.s(q,ge,he=>he.provideCallsTo(V,Q,J),void 0,J)}$provideCallHierarchyOutgoingCalls(q,V,Q,J){return this.s(q,ge,he=>he.provideCallsFrom(V,Q,J),void 0,J)}$releaseCallHierarchy(q,V){this.s(q,ge,Q=>Promise.resolve(Q.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(q,V,Q){const J=this.t(new we(this.h,Q),q);return this.e.$registerTypeHierarchyProvider(J,this.o(V,q)),this.p(J)}$prepareTypeHierarchy(q,V,Q,J){return this.s(q,we,he=>Promise.resolve(he.prepareSession($.URI.revive(V),Q,J)),void 0,J)}$provideTypeHierarchySupertypes(q,V,Q,J){return this.s(q,we,he=>he.provideSupertypes(V,Q,J),void 0,J)}$provideTypeHierarchySubtypes(q,V,Q,J){return this.s(q,we,he=>he.provideSubtypes(V,Q,J),void 0,J)}$releaseTypeHierarchy(q,V){this.s(q,we,Q=>Promise.resolve(Q.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(q,V,Q,J){const he=this.q();return this.f.set(he,new Se(new Re(this.e,this.h,Q,he,q),q)),this.e.$registerDocumentOnDropEditProvider(he,this.o(V,q),(0,s.$xG)(q,"documentPaste")&&J?{supportsResolve:!!Q.resolveDocumentDropEdit,dropMimeTypes:J.dropMimeTypes}:void 0),this.p(he)}$provideDocumentOnDropEdits(q,V,Q,J,he,pe){return this.s(q,Re,ze=>Promise.resolve(ze.provideDocumentOnDropEdits(V,$.URI.revive(Q),J,he,pe)),void 0,void 0)}$resolveDropEdit(q,V,Q){return this.s(q,Re,J=>J.resolveDropEdit(V,Q),{},void 0)}$releaseDropEdits(q,V){this.s(q,Re,Q=>Promise.resolve(Q.releaseDropEdits(V)),void 0,void 0)}registerMappedEditsProvider(q,V,Q){const J=this.t(new fe(this.h,Q),q);return this.e.$registerMappedEditsProvider(J,this.o(V,q)),this.p(J)}$provideMappedEdits(q,V,Q,J,he){return this.s(q,fe,pe=>Promise.resolve(pe.provideMappedEdits(V,Q,J,he)),null,he)}registerDocumentPasteEditProvider(q,V,Q,J){const he=this.q();return this.f.set(he,new Se(new T(this.e,this.h,Q,he,q),q)),this.e.$registerPasteEditProvider(he,this.o(V,q),{supportsCopy:!!Q.prepareDocumentPaste,supportsPaste:!!Q.provideDocumentPasteEdits,supportsResolve:!!Q.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(pe=>pe.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(he)}$prepareDocumentPaste(q,V,Q,J,he){return this.s(q,T,pe=>pe.prepareDocumentPaste($.URI.revive(V),Q,J,he),void 0,he)}$providePasteEdits(q,V,Q,J,he,pe,ze){return this.s(q,T,Ve=>Ve.providePasteEdits(V,$.URI.revive(Q),J,he,pe,ze),void 0,ze)}$resolvePasteEdit(q,V,Q){return this.s(q,T,J=>J.resolvePasteEdit(V,Q),{},void 0)}$releasePasteEdits(q,V){this.s(q,T,Q=>Promise.resolve(Q.releasePasteEdits(V)),void 0,void 0)}static w(q){return{pattern:q.source,flags:q.flags}}static y(q){return{decreaseIndentPattern:Ae.w(q.decreaseIndentPattern),increaseIndentPattern:Ae.w(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ae.w(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ae.w(q.unIndentedLinePattern):void 0}}static z(q){return{beforeText:Ae.w(q.beforeText),afterText:q.afterText?Ae.w(q.afterText):void 0,previousLineText:q.previousLineText?Ae.w(q.previousLineText):void 0,action:q.action}}static B(q){return q.map(Ae.z)}static C(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(V=>r.SyntaxTokenType.toString(V)):void 0}}static D(q){return q.map(Ae.C)}setLanguageConfiguration(q,V,Q){const{wordPattern:J}=Q;if(J&&(0,A.$ff)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(V,J):this.h.setWordDefinitionFor(V,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const he=this.q(),pe={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?Ae.w(Q.wordPattern):void 0,indentationRules:Q.indentationRules?Ae.y(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?Ae.B(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport,autoClosingPairs:Q.autoClosingPairs?Ae.D(Q.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(he,V,pe),this.p(he)}$setWordDefinitions(q){for(const V of q)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$0jc=Ae}),define(ke[121],Ee([1,0,3,6,16,8,108,25,7,4,222,145,13,5,20,120,12]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=e.$Qkc=void 0,e.$Qkc=(0,E.$qi)("IExtHostLanguageModels");class n{constructor(t,f){this.option=t,this.stream=new b.$Th,this.stream=f??new b.$Th}}class i{constructor(){this.a=new Map,this.b=new b.$Th,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let f=this.a.get(t.index);f||(this.a.size===0?f=new n(t.index,this.b):f=new n(t.index),this.a.set(t.index,f)),f.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const f of this.f())f.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let r=class{static{o=this}static{this.a=1}constructor(t,f,d){this.j=f,this.k=d,this.c=new S.$be,this.d=new S.$be,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new p.$Nm,this.i=new Map,this.o=new Set,this.b=t.getProxy(N.$PM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,f,d,l){const c=o.a++;this.f.set(c,{extension:t.identifier,provider:d,languageModelId:f});let h;return l.auth&&(h={providerLabel:t.displayName||t.name,accountLabel:typeof l.auth=="object"?l.auth.label:void 0}),this.b.$registerLanguageModelProvider(c,f,{extension:t.identifier,identifier:f,model:l.name??"",auth:h}),(0,u.$Sc)(()=>{this.f.delete(c),this.b.$unregisterProvider(c)})}async $provideLanguageModelResponse(t,f,d,l,c,h){const g=this.f.get(t);if(!g)return;const D=new M.$Zv(async w=>{if(h.isCancellationRequested){this.j.warn(`[CHAT](${g.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:w.index,part:w.part})});return g.provider.provideLanguageModelResponse2(l.map(L.LanguageModelMessage.to),c,p.$Lm.toKey(d),D,h)}$updateLanguageModels(t){const f=[],d=[];if(t.added)for(const l of t.added)this.g.set(l.identifier,l),f.push(l.model);if(t.removed)for(const l of t.removed){this.g.delete(l),d.push(l);for(const[c,h]of this.i)h.languageModelId===l&&(h.res.reject(new $.$5),this.i.delete(c))}this.d.fire(Object.freeze({added:Object.freeze(f),removed:Object.freeze(d)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const f=new Array;for(const{from:d,to:l,enabled:c}of t){const h=this.h.get(d)??new p.$Mm;if(h.has(l)!==c){c?h.add(l):h.delete(l),this.h.set(d,h);const D={from:d,to:l};f.push(D),this.c.fire(D)}}}async sendChatRequest(t,f,d,l,c){const h=t.identifier,g=await this.b.$prepareChatAccess(h,f,l.justification);if(!g||!this.g.has(f))throw R.$ZO.NotFound(`Language model '${f}' is unknown.`);if(this.m(h,g)&&(!await this.l(t,{identifier:g.extension,displayName:g.auth.providerLabel},l.justification,l.silent)||!this.h.get(h)?.has(g.extension)))throw R.$ZO.NoPermissions(`Language model '${f}' cannot be used by '${h.value}'.`);const D=Math.random()*1e6|0,w=this.b.$fetchResponse(h,f,D,d.map(L.LanguageModelMessage.from),l.modelOptions??{},c),k=new b.$ph,y=new i;this.i.set(D,{languageModelId:f,res:y});let C;if(w.catch(I=>{k.isOpen()?y.reject(I):C=I}).finally(()=>{this.i.delete(D),y.resolve(),k.open()}),await k.wait(),C)throw new R.$ZO(`Language model '${f}' errored, check cause for more details`,"Unknown",C);return y.apiObject}async $handleResponseFragment(t,f){const d=this.i.get(t);d&&d.res.handleFragment(f)}async l(t,f,d,l){const c=P.$RL+f.identifier.value;if(await this.k.getSession(t,c,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0;if(l)return!1;try{const g=d?(0,A.localize)(0,null,f.displayName,d):(0,A.localize)(1,null,f.displayName);return await this.k.getSession(t,c,[],{forceNewSession:{detail:g}}),this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0}catch{return!1}}m(t,f){return!!f.auth&&!p.$Lm.equals(f.extension,t)}async n(t){for(const f of this.o)try{await this.l(f,{identifier:t.extension,displayName:""},void 0,!0)}catch(d){this.j.error("Fake Auth request failed"),this.j.error(d)}}createLanguageModelAccessInformation(t){this.o.add(t);const f=this,d=S.Event.signal(S.Event.filter(this.c.event,c=>p.$Lm.equals(c.from,t.identifier))),l=S.Event.signal(this.d.event);return{get onDidChange(){return S.Event.any(d,l)},canSendRequest(c){const h=f.g.get(c);if(!h)return;if(!f.m(t.identifier,h))return!0;const g=f.h.get(t.identifier);if(g)return g.has(h.extension)}}}};e.$Rkc=r,e.$Rkc=r=o=Je([qe(0,v.$aP),qe(1,m.$Wj),qe(2,a.$_jc)],r)}),define(ke[339],Ee([1,0,6,16,8,40,7,3,26]),function(le,e,u,N,L,R,M,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class S{constructor(P,$,E,v){this.c=$,this.d=E,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(u.$PM.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,$){await this.a.$changeLanguage(P,$);const E=this.c.getDocumentData(P);if(!E)throw new Error(`document '${P.toString()}' NOT found`);return E.document}async tokenAtPosition(P,$){const E=P.version,v=N.Position.from($),a=await this.a.$tokensAtPosition(P.uri,v),m={type:L.StandardTokenType.Other,range:P.getWordRangeAtPosition($)??new L.$TM($.line,$.character,$.line,$.character)};if(!a)return m;const o={range:N.Range.to(a.range),type:N.TokenType.to(a.type)};return!o.range.contains($)||E!==P.version?m:o}createLanguageStatusItem(P,$,E){const v=this.f++,a=this.a,m=this.g,o=`${P.identifier.value}/${$}`;if(m.has(o))throw new Error(`LanguageStatusItem with id '${$}' ALREADY exists`);m.add(o);const n={selector:E,id:$,name:P.displayName??P.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new p.$Tc,s=()=>{if(i?.dispose(),!m.has(o)){console.warn(`LanguageStatusItem (${$}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$sh)(()=>{r.clear(),this.a.$setLanguageStatus(v,{id:o,name:n.name??P.displayName??P.name,source:P.displayName??P.name,selector:N.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===L.LanguageStatusSeverity.Error?R.default.Error:n.severity===L.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:n.command&&this.d.toInternal(n.command,r),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){r.dispose(),i?.dispose(),a.$removeLanguageStatus(v),m.delete(o)},get id(){return n.id},get name(){return n.name},set name(f){n.name=f,s()},get selector(){return n.selector},set selector(f){n.selector=f,s()},get text(){return n.text},set text(f){n.text=f,s()},set text2(f){(0,b.$yG)(P,"languageStatusText"),n.text=f,s()},get text2(){return(0,b.$yG)(P,"languageStatusText"),n.text},get detail(){return n.detail},set detail(f){n.detail=f,s()},get severity(){return n.severity},set severity(f){n.severity=f,s()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(f){n.accessibilityInformation=f,s()},get command(){return n.command},set command(f){n.command=f,s()},get busy(){return n.busy},set busy(f){n.busy=f,s()}};return s(),t}}e.$wlc=S}),define(ke[340],Ee([1,0,15,2,16,8,119]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=e.$ilc=void 0;class p{constructor(P,$,E,v){this.start=P,this.deletedCount=$,this.deletedItems=E,this.items=v}asApiEvent(){return{range:new R.$gO(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class b{static asModelAddData(P){return{EOL:P.eol,lines:P.source,languageId:P.language,uri:P.uri,isDirty:!1,versionId:1}}constructor(P,$,E){this.notebook=P,this.h=$,this.j=E,this.handle=E.handle,this.uri=N.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(L.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(L.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:L.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return P.g},set mime(v){P.g=v},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(E)}return this.f}setOutputs(P){this.a=P.map(L.NotebookCellOutput.to)}setOutputItems(P,$,E){const v=E.map(L.NotebookCellOutputItem.to),a=this.a.find(m=>m.id===P);if(a&&($||(a.items.length=0),a.items.push(...v),a.items.length>1&&a.items.every(m=>M.$MK(m.mime)))){const m=new Map,o=[];a.items.forEach(n=>{let i;m.has(n.mime)?i=m.get(n.mime):(i=[],m.set(n.mime,i),o.push(n.mime)),i.push(n.data)}),a.items.length=0,o.forEach(n=>{const i=M.$NK(m.get(n));a.items.push({mime:n,data:i.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(L.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$ilc=b;class S{static{this.a=0}constructor(P,$,E,v,a){this.k=P,this.l=$,this.m=E,this.uri=v,this.handle=S.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,$={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===u.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(E){return E=P.n(E),P.b[E].apiCell},getCells(E){return(E?P.p(E):P.b).map(a=>a.apiCell)},save(){return P.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,$,E){this.g=P.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:E});const v={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},a=[];for(const o of P.rawEvents)o.kind===M.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,v.contentChanges):o.kind===M.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,v.contentChanges):o.kind===M.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),a.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),a.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),a.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===M.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),a.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),a.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const m=new Map;for(let o=0;o<a.length;o++){const n=a[o],i=m.get(n.cell);if(i===void 0){const r=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});m.set(n.cell,r-1)}else v.cellChanges[i]={...v.cellChanges[i],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let $=P.start|0,E=P.end|0;return $<0&&($=0),E>this.b.length&&(E=this.b.length),P.with({start:$,end:E})}p(P){P=this.o(P);const $=[];for(let E=P.start;E<P.end;E++)$.push(this.b[E]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,$,E){if(this.j)return;const v=[],a=[],m=[];if(P.reverse().forEach(o=>{const i=o[2].map(t=>{const f=new b(this,this.l,t);return $||a.push(b.asModelAddData(t)),f}),r=new p(o[0],o[1],[],i),s=this.b.splice(o[0],o[1],...i);for(const t of s)m.push(t.uri),r.deletedItems.push(t.apiCell);v.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:m}),E)for(const o of v)E.push(o.asApiEvent())}s(P,$,E,v){const a=this.b.splice(P,$);this.b.splice(E,0,...a);const m=[new p(P,$,a.map(o=>o.apiCell),[]),new p(E,0,[],a)];for(const o of m)v.push(o.asApiEvent())}t(P,$){this.b[P].setOutputs($)}u(P,$,E,v){this.b[P].setOutputItems($,E,v)}v(P,$){const E=this.b[P];E.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(E.uri,$)}w(P,$){const E=this.b[P];E.apiCell.mime=$}x(P,$){this.b[P].setMetadata($)}y(P,$){this.b[P].setInternalMetadata($)}getCellFromApiCell(P){return this.b.find($=>$.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find($=>$.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$jlc=S}),define(ke[341],Ee([1,0,4,2,16,8,48]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;class p{constructor(S,A,P,$={timeout:1500,errors:3}){this.b=S,this.c=A,this.d=P,this.f=$,this.a=new u.$de}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(A,P,$)=>{const E=function(a){A.call(P,a)};return E.extension=S,this.a.event(E,void 0,$)}}async $participateInSave(S,A,P){const $=N.URI.revive(S),E=this.c.getNotebookDocument($);if(!E)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:L.TextDocumentSaveReason.to(A)},P,async(m,o)=>{const n=Date.now(),i=await await Promise.resolve(m);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!P.isCancellationRequested&&i&&(i instanceof R.$2M?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(v.length===0)return!0;const a={edits:[]};for(const m of v){const{edits:o}=L.WorkspaceEdit.from(m);a.edits=a.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new M.$mw(a))}}e.$ylc=p}),define(ke[153],Ee([1,0,13,16,8]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,b,S,A,P,$){this.id=p,this.f=b,this.notebookData=S,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=A,this.c=$}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(b){this.selections=[b]},get selections(){return p.a},set selections(b){if(!Array.isArray(b)||!b.every(L.$gO.isNotebookRange))throw(0,u.$7)("selections");p.a=b,p.g(b)},get visibleRanges(){return p.b},revealRange(b,S){p.f.$tryRevealRange(p.id,N.NotebookRange.from(b),S??L.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(N.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$klc=R}),define(ke[342],Ee([1,0,4,12,16]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0;let R=class{constructor(p,b){this.c=p,this.d=b,this.a=new u.$be,this.b=new u.$be,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,b);const S=this.d.getEditorById(p);b.visibleRanges&&S._acceptVisibleRanges(b.visibleRanges.ranges.map(L.NotebookRange.to)),b.selections&&S._acceptSelections(b.selections.selections.map(L.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:S.apiEditor,visibleRanges:S.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:S.apiEditor,selections:S.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const b in p)this.d.getEditorById(b)._acceptViewColumn(L.ViewColumn.to(p[b]))}};e.$Alc=R,e.$Alc=R=Je([qe(0,N.$Wj)],R)}),define(ke[343],Ee([1,0,4,6,153]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=void 0;class R{constructor(p,b){this.c=b,this.a=new Map,this.b=p.getProxy(N.$PM.MainThreadNotebookRenderers)}$postRendererMessage(p,b,S){const A=this.c.getEditorById(p);this.a.get(b)?.fire({editor:A.apiEditor,message:S})}createRendererMessaging(p,b){if(!p.contributes?.notebookRenderer?.some(A=>A.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(A,P,$)=>this.d(b).event(A,P,$),postMessage:(A,P)=>{L.$klc.apiEditorsToExtHost.has(A)&&([A,P]=[P,A]);const $=P&&L.$klc.apiEditorsToExtHost.get(P);return this.b.$postMessage($?.id,b,A)}}}d(p){let b=this.a.get(p);return b||(b=new u.$be({onDidRemoveLastListener:()=>{b?.dispose(),this.a.delete(p)}}),this.a.set(p,b),b)}}e.$Dlc=R}),define(ke[344],Ee([1,0,16,108,22,55,13]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=void 0;class p{constructor(P){this.b=0,this.c=new Map,this.a=P}async withProgress(P,$,E){const v=this.b++,{title:a,location:m,cancellable:o}=$,n={label:P.displayName||P.name,id:P.identifier.value};return this.a.$startProgress(v,{location:u.ProgressLocation.from(m),title:a,source:n,cancellable:o},P.isUnderDevelopment?void 0:P.identifier.value).catch(M.$2),this.d(v,E,!!o)}d(P,$,E){let v;E&&(v=new L.$me,this.c.set(P,v));const a=o=>{this.a.$progressEnd(o),this.c.delete(o),v?.dispose()};let m;try{m=$(new S(this.a,P),E&&v?v.token:L.CancellationToken.None)}catch(o){throw a(P),o}return m.then(o=>a(P),o=>a(P)),m}$acceptProgressCanceled(P){const $=this.c.get(P);$&&($.cancel(),this.c.delete(P))}}e.$Hlc=p;function b(A,P){return A.message=P.message,typeof P.increment=="number"&&(typeof A.increment=="number"?A.increment+=P.increment:A.increment=P.increment),A}class S extends N.$Zv{constructor(P,$){super(E=>this.throttledReport(E)),this.c=P,this.d=$}throttledReport(P){this.c.$progressReport(this.d,P)}}Je([(0,R.$Wh)(100,(A,P)=>b(A,P),()=>Object.create(null))],S.prototype,"throttledReport",null)}),define(ke[345],Ee([1,0,2,6,7,16]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=void 0;class M{static{this.a=0}constructor(b,S){this.d=S,this.c=new Map,this.b=b.getProxy(N.$PM.MainThreadQuickDiff)}$provideOriginalResource(b,S,A){const P=u.URI.revive(S),$=this.c.get(b);return $?(0,L.$ih)(()=>$.provideOriginalResource(P,A)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(b,S,A,P){const $=M.a++;return this.c.set($,S),this.b.$registerQuickDiffProvider($,R.DocumentSelector.from(b,this.d),A,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$Ilc=M}),define(ke[346],Ee([1,0,22,4,3,6,2,8,13,19,40,57,26,16]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=v;function v(a,m,o){const n=a.getProxy(R.$PM.MainThreadQuickOpen);class i{constructor(g,D){this.e=new Map,this.f=0,this.a=g,this.b=D}showQuickPick(g,D,w,k=u.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),C=++this.f,I=n.$show(C,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},k),F={},j=I.then(()=>F);return Promise.race([j,y]).then(z=>{if(z===F)return;const O=(0,$.$xG)(g,"quickPickItemTooltip");return y.then(T=>{const B=[];for(let W=0;W<T.length;W++){const Z=T[W];if(typeof Z=="string")B.push({label:Z,handle:W});else if(Z.kind===p.QuickPickItemKind.Separator)B.push({type:"separator",label:Z.label});else{Z.tooltip&&!O&&console.warn(`Extension '${g.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${g.identifier.value}`);const x=Z.iconPath?d(Z.iconPath):void 0;B.push({label:Z.label,iconPath:x?.iconPath,iconClass:x?.iconClass,description:Z.description,detail:Z.detail,picked:Z.picked,alwaysShow:Z.alwaysShow,tooltip:O?E.MarkdownString.fromStrict(Z.tooltip):void 0,handle:W})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=W=>{w.onDidSelectItem(T[W])}),n.$setItems(C,B),I.then(W=>{if(typeof W=="number")return T[W];if(Array.isArray(W))return W.map(Z=>T[Z])})})}).then(void 0,z=>{if(!(0,b.$4)(z))return n.$setError(C,z),Promise.reject(z)})}$onItemSelected(g){this.c?.(g)}showInput(g,D=u.CancellationToken.None){return this.d=g?.validateInput,n.$input(g,typeof this.d=="function",D).then(void 0,w=>{if(!(0,b.$4)(w))return Promise.reject(w)})}async $validateInput(g){if(!this.d)return;const D=await this.d(g);if(!D||typeof D=="string")return D;let w;switch(D.severity){case p.InputBoxValidationSeverity.Info:w=A.default.Info;break;case p.InputBoxValidationSeverity.Warning:w=A.default.Warning;break;case p.InputBoxValidationSeverity.Error:w=A.default.Error;break;default:w=D.message?A.default.Error:A.default.Ignore;break}return{content:D.message,severity:w}}async showWorkspaceFolderPick(g,D=u.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[g]);if(!w)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(y=>y.uri.toString()===w.uri.toString())}createQuickPick(g){const D=new l(g,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(g){const D=new c(g,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(g,D){this.e.get(g)?._fireDidChangeValue(D)}$onDidAccept(g){this.e.get(g)?._fireDidAccept()}$onDidChangeActive(g,D){const w=this.e.get(g);w instanceof l&&w._fireDidChangeActive(D)}$onDidChangeSelection(g,D){const w=this.e.get(g);w instanceof l&&w._fireDidChangeSelection(D)}$onDidTriggerButton(g,D){this.e.get(g)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(g,D,w){const k=this.e.get(g);k instanceof l&&k._fireDidTriggerItemButton(D,w)}$onDidHide(g){this.e.get(g)?._fireDidHide()}}class r{static{this.a=1}constructor(g,D){this.x=g,this.y=D,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$be,this.q=new N.$be,this.r=new N.$be,this.s=new N.$be,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(g){this.b=g,this.z({title:g})}get step(){return this.c}set step(g){this.c=g,this.z({step:g})}get totalSteps(){return this.d}set totalSteps(g){this.d=g,this.z({totalSteps:g})}get enabled(){return this.g}set enabled(g){this.g=g,this.z({enabled:g})}get busy(){return this.j}set busy(g){this.j=g,this.z({busy:g})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(g){this.k=g,this.z({ignoreFocusOut:g})}get value(){return this.l}set value(g){this.l=g,this.z({value:g})}get placeholder(){return this.m}set placeholder(g){this.m=g,this.z({placeholder:g})}get buttons(){return this.n}set buttons(g){this.n=g.slice(),this.o.clear(),g.forEach((D,w)=>{const k=D===p.$dO.Back?-1:w;this.o.set(k,D)}),this.z({buttons:g.map((D,w)=>({...d(D.iconPath),tooltip:D.tooltip,handle:D===p.$dO.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(g){this.l=g,this.q.fire(g)}_fireDidTriggerButton(g){const D=this.o.get(g);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,L.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(g){if(!this.v){for(const D of Object.keys(g)){const w=g[D];this.u[D]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function s(h){if(h instanceof p.$NN)return{id:h.id};const g=f(h),D=t(h);return{dark:typeof g=="string"?M.URI.file(g):g,light:typeof D=="string"?M.URI.file(D):D}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function f(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const g=s(h);let D,w;return"id"in g?w=P.ThemeIcon.asClassName(g):D=g,{iconPath:D,iconClass:w}}class l extends r{constructor(g,D){super(g.identifier,D),this.O=g,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$be,this.L=[],this.M=new N.$be,this.N=new N.$be,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(g){this.B=g.slice(),this.C.clear(),this.D.clear(),g.forEach((k,y)=>{this.C.set(y,k),this.D.set(k,y)});const D=(0,$.$xG)(this.O,"quickPickItemTooltip"),w=[];for(let k=0;k<g.length;k++){const y=g[k];if(y.kind===p.QuickPickItemKind.Separator)w.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?d(y.iconPath):void 0;w.push({handle:k,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?E.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((I,F)=>({...d(I.iconPath),tooltip:I.tooltip,handle:F}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(g){this.E=g,this.z({canSelectMany:g})}get matchOnDescription(){return this.F}set matchOnDescription(g){this.F=g,this.z({matchOnDescription:g})}get matchOnDetail(){return this.G}set matchOnDetail(g){this.G=g,this.z({matchOnDetail:g})}get sortByLabel(){return this.H}set sortByLabel(g){this.H=g,this.z({sortByLabel:g})}get keepScrollPosition(){return this.I}set keepScrollPosition(g){this.I=g,this.z({keepScrollPosition:g})}get activeItems(){return this.J}set activeItems(g){this.J=g.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(g){this.L=g.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(g){const D=(0,S.$Hb)(g.map(w=>this.C.get(w)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(g){const D=(0,S.$Hb)(g.map(w=>this.C.get(w)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(g,D){const w=this.C.get(g);if(!w||!w.buttons||!w.buttons.length)return;const k=w.buttons[D];k&&this.N.fire({button:k,item:w})}}class c extends r{constructor(g,D){super(g.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(g){this.B=g,this.z({password:g})}get prompt(){return this.C}set prompt(g){this.C=g,this.z({prompt:g})}get valueSelection(){return this.D}set valueSelection(g){this.D=g,this.z({valueSelection:g})}get validationMessage(){return this.E}set validationMessage(g){this.E=g,g?typeof g=="string"?this.z({validationMessage:g,severity:A.default.Error}):this.z({validationMessage:g.message,severity:g.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new i(m,o)}}),define(ke[347],Ee([1,0,2,4,55,3,7,6,19,131,12,25,57,16,26,15,11]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=e.$Klc=void 0;function n(C){return C instanceof u.URI}function i(C,I){return C.scheme===a.Schemas.file&&I.scheme===a.Schemas.file&&m.$k?C.toString()===I.toString():C.toString().toLowerCase()===I.toString().toLowerCase()}function r(C){if(C)return typeof C.iconPath=="string"?u.URI.file(C.iconPath):u.URI.isUri(C.iconPath)||$.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function s(C){if(C.icon){if(u.URI.isUri(C.icon))return C.icon;if($.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const I=C.icon;return{light:I.light,dark:I.dark}}}else return}function t(C,I){if(!C.iconPath&&!I.iconPath)return 0;if(C.iconPath){if(!I.iconPath)return 1}else return-1;const F=typeof C.iconPath=="string"?C.iconPath:u.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,j=typeof I.iconPath=="string"?I.iconPath:u.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,S.$ir)(F,j)}function f(C,I){let F=0;if(C.strikeThrough!==I.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==I.faded)return C.faded?1:-1;if(C.tooltip!==I.tooltip)return(C.tooltip||"").localeCompare(I.tooltip||"");if(F=t(C,I),F!==0)return F;if(C.light&&I.light)F=t(C.light,I.light);else{if(C.light)return 1;if(I.light)return-1}if(F!==0)return F;if(C.dark&&I.dark)F=t(C.dark,I.dark);else{if(C.dark)return 1;if(I.dark)return-1}return F}function d(C,I){if(C.command!==I.command)return C.command<I.command?-1:1;if(C.title!==I.title)return C.title<I.title?-1:1;if(C.tooltip!==I.tooltip){if(C.tooltip!==void 0&&I.tooltip!==void 0)return C.tooltip<I.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(C.arguments===I.arguments)return 0;if(C.arguments)if(I.arguments){if(C.arguments.length!==I.arguments.length)return C.arguments.length-I.arguments.length}else return 1;else return-1;for(let F=0;F<C.arguments.length;F++){const j=C.arguments[F],z=I.arguments[F];if(j!==z&&!(n(j)&&n(z)&&i(j,z)))return j<z?-1:1}return 0}function l(C,I){let F=(0,S.$ir)(C.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(F!==0)return F;if(C.command&&I.command)F=d(C.command,I.command);else{if(C.command)return 1;if(I.command)return-1}if(F!==0)return F;if(C.decorations&&I.decorations)F=f(C.decorations,I.decorations);else{if(C.decorations)return 1;if(I.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)F=(0,S.$ir)(C.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)F=(0,S.$ir)(C.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return F}function c(C,I){for(let F=0;F<C.length;F++)if(C[F]!==I[F])return!1;return!0}function h(C,I){return C.command===I.command&&C.title===I.title&&C.tooltip===I.tooltip&&(C.arguments&&I.arguments?c(C.arguments,I.arguments):C.arguments===I.arguments)}function g(C,I){return(0,b.$ub)(C,I,h)}class D{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,v.$yG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,v.$yG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,v.$yG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,F,j,z,O){this.k=I,this.l=z,this.m=O,this.d="",this.e=new N.$be,this.f="",this.h=!0,this.j=!0,this.#t=F,this.#e=j}showValidationMessage(I,F){(0,v.$yG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,F)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$Klc=D;class w{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,F,j,z,O,T,B){this.q=I,this.s=F,this.t=j,this.u=z,this.v=O,this.multiDiffEditorEnableViewChanges=T,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$be,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$be,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=w.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,F){const j=this.h.get(I);return j?(0,M.$ih)(()=>this.s.executeCommand(j.command,...j.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(l),j=(0,b.$Db)(this.o,I,l).map(T=>{const B=T.toInsert.map(W=>{const Z=this.e++;this.g.set(Z,W);const x=W.resourceUri;let X;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"||W.command.command==="vscode.changes"){const re=new R.$Tc;X=this.s.converter.toInternal(W.command,re),this.j.set(Z,re)}else this.h.set(Z,W.command);const Y=(0,v.$xG)(this.w,"scmMultiDiffEditor"),ce=Y?W.multiDiffEditorOriginalUri:void 0,ne=Y?W.multiFileDiffEditorModifiedUri:void 0,$e=r(W.decorations),Ce=W.decorations&&r(W.decorations.light)||$e,ee=W.decorations&&r(W.decorations.dark)||$e,U=[Ce,ee],ie=W.decorations&&W.decorations.tooltip||"",be=W.decorations&&!!W.decorations.strikeThrough,Pe=W.decorations&&!!W.decorations.faded,oe=W.contextValue||"";return{rawResource:[Z,x,U,ie,be,Pe,oe,X,ce,ne],handle:Z}});return{start:T.start,deleteCount:T.deleteCount,toInsert:B}}),z=j.map(({start:T,deleteCount:B,toInsert:W})=>[T,B,W.map(Z=>Z.rawResource)]),O=j.reverse();for(const{start:T,deleteCount:B,toInsert:W}of O){const Z=W.map(X=>X.handle),x=this.n.splice(T,B,...Z);for(const X of x)this.g.delete(X),this.h.delete(X),this.j.get(X)?.dispose(),this.j.delete(X)}return this.o=I,z}dispose(){this.l=!0,this.m.fire()}}class k{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let F;(0,v.$xG)(this.x,"quickDiffProvider")&&(F=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:F})}get historyProvider(){return(0,v.$yG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,v.$yG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new R.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new R.$Tc,this.o=I;const F=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:F})}get actionButton(){return(0,v.$yG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,v.$yG)(this.x,"scmActionButton"),this.p.value=new R.$Tc,this.q=I;const F=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(j=>j.map(z=>this.y.converter.toInternal(z,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:F??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&g(this.t,I))return;this.s.value=new R.$Tc,this.t=I;const F=(I||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:F})}get selected(){return this.u}constructor(I,F,j,z,O,T,B){this.x=I,this.y=z,this.z=O,this.A=T,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Vc,this.m=void 0,this.n=new R.$Vc,this.o=void 0,this.p=new R.$Vc,this.s=new R.$Vc,this.t=void 0,this.u=!1,this.v=new N.$be,this.onDidChangeSelection=this.v.event,this.w=k.d++,this.C=new Map,this.D=new Set,this.#e=j;const W=u.URI.from({scheme:a.Schemas.vscodeSourceControl,path:`${O}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new D(I,F,this.#e,this.w,W),this.#e.$registerSourceControl(this.w,O,T,B,W)}createResourceGroup(I,F,j){const z=(0,v.$xG)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,O=new w(this.#e,this.y,this.w,I,F,z,this.x),T=N.Event.once(O.onDidDispose)(()=>this.C.delete(O));return this.C.set(O,T),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const I=[],F=[];for(const[j,z]of this.C){z.dispose();const O=j.onDidUpdateResourceStates(()=>{this.D.add(j),this.eventuallyUpdateResourceStates()});N.Event.once(j.onDidDispose)(()=>{this.D.delete(j),O.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),I.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const T=j._takeResourceStateSnapshot();T.length>0&&F.push([j.handle,T]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,I,F),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(F=>{const j=F._takeResourceStateSnapshot();j.length!==0&&I.push([F.handle,j])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,L.$Vh)(100)],k.prototype,"eventuallyAddResourceGroups",null),Je([(0,L.$Vh)(100)],k.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,F,j,z){this.l=F,this.m=j,this.n=z,this.g=new Map,this.h=new P.$Nm,this.j=new N.$be,this.e=I.getProxy(p.$PM.MainThreadSCM),this.f=I.getProxy(p.$PM.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const T=this.g.get(O.sourceControlHandle);if(!T)return O;const B=T.getResourceGroup(O.groupHandle);return B?B.getResourceState(O.handle):O}else if(O&&O.$mid===4){const T=this.g.get(O.sourceControlHandle);return T?T.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const T=this.g.get(O.handle);return T||O}return O}})}createSourceControl(I,F,j,z){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,F,j,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const O=o.d++,T=new k(I,this.m,this.e,this.l,F,j,z);this.g.set(O,T);const B=this.h.get(I.identifier)||[];return B.push(T),this.h.set(I.identifier,B),T}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const F=this.h.get(I.identifier),j=F&&F[F.length-1];return j&&j.inputBox}$provideOriginalResource(I,F,j){const z=u.URI.revive(F);this.n.trace("ExtHostSCM#$provideOriginalResource",I,z.toString());const O=this.g.get(I);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$ih)(()=>O.quickDiffProvider.provideOriginalResource(z,j)).then(T=>T||null)}$onInputBoxValueChange(I,F){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const j=this.g.get(I);return j&&j.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(I,F,j,z){this.n.trace("ExtHostSCM#$executeResourceCommand",I,F,j);const O=this.g.get(I);if(!O)return Promise.resolve(void 0);const T=O.getResourceGroup(F);return T?T.$executeResourceCommand(j,z):Promise.resolve(void 0)}$validateInput(I,F,j){this.n.trace("ExtHostSCM#$validateInput",I);const z=this.g.get(I);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,M.$ih)(()=>z.inputBox.validateInput(F,j)).then(O=>{if(!O)return Promise.resolve(void 0);const T=E.MarkdownString.fromStrict(O.message);return T?Promise.resolve([T,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,F,j,z){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(F,j,z)??void 0}async $provideHistoryItems(I,F,j,z){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(F,j,z))?.map(B=>({...B,icon:s(B)}))??void 0}async $provideHistoryItemSummary(I,F,j,z){const O=this.g.get(I)?.historyProvider;if(typeof O?.provideHistoryItemSummary!="function")return;const T=await O.provideHistoryItemSummary(F,j,z);return T?{...T,icon:s(T)}:void 0}async $provideHistoryItemChanges(I,F,j,z){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(F,j,z)??void 0}};e.$Llc=y,e.$Llc=y=o=Je([qe(3,A.$Wj)],y)}),define(ke[348],Ee([1,0,6,16,2]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;class R{static{this.a=0}constructor(p,b){this.d=b,this.c=new Map,this.b=p.getProxy(u.$PM.MainThreadShare)}async $provideShare(p,b,S){return await this.c.get(p)?.provideShare({selection:N.Range.to(b.selection),resourceUri:L.URI.revive(b.resourceUri)},S)??void 0}registerShareProvider(p,b){const S=R.a++;return this.c.set(S,b),this.b.$registerShareProvider(S,N.DocumentSelector.from(p,this.d),b.id,b.label,b.priority),{dispose:()=>{this.b.$unregisterShareProvider(S),this.c.delete(S)}}}}e.$Mlc=R}),define(ke[349],Ee([1,0,8,6,225,3,16,18]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=e.$Olc=void 0;class b{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new u.$ON("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.$ON("statusBarItem.warningForeground")]])}#e;#t;constructor($,E,v,a,m,o=u.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new R.$Tc,this.#e=$,this.#t=E,m&&a){this.c=(0,u.$qN)(a.identifier,m);const i=v.get(this.c);i&&(o=i.alignLeft?u.StatusBarAlignment.Left:u.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(b.a++);this.e=a,this.f=m,this.g=o,this.h=this.u(n)}u($){if((0,p.$8f)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!b.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new R.$Tc,typeof $=="string"?this.r={fromApi:$,internal:this.#t.toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:this.#t.toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let E;this.m?E=this.m:E=(0,L.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=b.b.get(this.o.id));const a=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,$,this.e?.identifier.value,E,this.k,a,this.r?.internal,v,this.o,this.g===u.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Olc=b;class S{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,L.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const E={message:$};return this.b.unshift(E),this.c(),new u.$RM(()=>{const v=this.b.indexOf(E);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor($,E){this.e=new Map,this.a=$.getProxy(N.$PM.MainThreadStatusBar),this.b=E,this.c=new S(this)}$acceptStaticEntries($){for(const E of $)this.e.set(E.entryId,E)}createStatusBarEntry($,E,v,a){return new b(this.a,this.b,this.e,$,E,v,a)}setStatusBarMessage($,E){const v=this.c.setMessage($);let a;return typeof E=="number"?a=setTimeout(()=>v.dispose(),E):typeof E<"u"&&E.then(()=>v.dispose(),()=>v.dispose()),new u.$RM(()=>{v.dispose(),clearTimeout(a)})}}e.$Plc=A}),define(ke[154],Ee([1,0,29,144,68,112,89,16,2]),function(le,e,u,N,L,R,M,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=e.$oP=e.$nP=e.$mP=void 0;const S=(i,r,s,t)=>{let f=r;return{enumerable:!0,configurable:!1,get(){return f},set(d){if(!s(f,d)){const l=f;f=d,i.listener?.(t(d,l))}}}},A=(i,r)=>i===r,P={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,r)=>!(i.length!==r.length||i.some(s=>!r.find(t=>s.id===t.id)))},$=i=>r=>({op:4,update:i(r)}),E=(i,r)=>({range:(()=>{let s;const t=$(f=>({range:u.$kt.lift(p.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return s},set(f){i.listener?.({op:6}),P.range(s,f)||(s=f,i.listener?.(t(f)))}}})(),label:S(i,r,P.label,$(s=>({label:s}))),description:S(i,void 0,P.description,$(s=>({description:s}))),sortText:S(i,void 0,P.sortText,$(s=>({sortText:s}))),canResolveChildren:S(i,!1,P.canResolveChildren,s=>({op:2,state:s})),busy:S(i,!1,P.busy,$(s=>({busy:s}))),error:S(i,void 0,P.error,$(s=>({error:p.MarkdownString.fromStrict(s)||null}))),tags:S(i,[],P.tags,(s,t)=>({op:1,new:s.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),v=i=>{const r=L.$BL.fromString(i.extId),s=new m(r.controllerId,r.localId,i.label,b.URI.revive(i.uri)||void 0);return s.range=p.Range.to(i.range||void 0),s.description=i.description||void 0,s.sortText=i.sortText||void 0,s.tags=i.tags.map(t=>p.TestTag.to({id:(0,M.$HL)(t).tagId})),s},a=i=>{let r;for(const s of i.tests){const t=v(s.item);(0,N.$9O)(t).parent=r,r=t}return r};e.$mP=a;class m{constructor(r,s,t,f){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const d=(0,N.$8O)(this,r);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof o?void 0:d.parent}},children:{value:(0,R.$7O)(d,N.$9O,m),enumerable:!0,writable:!1},...E(d,t)})}}e.$nP=m;class o extends m{constructor(r,s){super(r,r,s,void 0),this._isRoot=!0}}e.$oP=o;class n extends R.$3O{constructor(r,s,t){super({controllerId:r,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:N.$9O,getChildren:f=>f.children,root:new o(r,s),toITestItem:p.TestItem.from})}}e.$pP=n}),define(ke[33],Ee([1,0,18,8,16,24,6,19,12,58,29,50,2,3,5,20,154,21,48,47,39,87,90,30]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=void 0;let d=class{#e;#t;#i;constructor(w,k,y){this.b=new Map,this.c=new Map,this.#e=w.getProxy(M.$PM.MainThreadCommands),this.d=k,this.#i=y,this.#t=w.getProxy(M.$PM.MainThreadTelemetry),this.converter=new l(this,C=>{const I=this.c.get(C);return I?.result===h.Void?I:void 0},k),this.f=[{processArgument(C){return(0,S.$Zh)(C)}},{processArgument(C){return(0,R.$Yn)(C,function(I){if(A.$kt.isIRange(I))return L.Range.to(I);if(P.$jt.isIPosition(I))return L.Position.to(I);if(A.$kt.isIRange(I.range)&&$.URI.isUri(I.uri))return L.location.to(I);if(I instanceof o.$Ce)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const k=this.registerCommand(!1,w.id,async(...y)=>{const C=w.args.map((F,j)=>{if(!F.validate(y[j]))throw new Error(`Invalid argument '${F.name}' when running '${w.id}', received: ${typeof y[j]=="object"?JSON.stringify(y[j],null,"	"):y[j]} `);return F.convert(y[j])}),I=await this.executeCommand(w.internalId,...C);return w.result.convert(I,y,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new N.$RM(()=>{k.dispose(),this.c.delete(w.id)})}registerCommand(w,k,y,C,I,F){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:y,thisArg:C,metadata:I,extension:F}),w&&this.#e.$registerCommand(k),new N.$RM(()=>{this.b.delete(k)&&w&&this.#e.$unregisterCommand(k)})}executeCommand(w,...k){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,k,!0)}async g(w,k,y){if(this.b.has(w))return this.#e.$fireCommandActivationEvent(w),this.h(w,k,!1);{let C=!1;const I=(0,R.$Yn)(k,function(F){if(F instanceof N.$SM)return L.Position.from(F);if(F instanceof N.$TM)return L.Range.from(F);if(F instanceof N.$4M)return L.location.from(F);if(N.$gO.isNotebookRange(F))return L.NotebookRange.from(F);if(F instanceof ArrayBuffer)return C=!0,o.$Ce.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return C=!0,o.$Ce.wrap(F);if(F instanceof o.$Ce)return C=!0,F;if(!Array.isArray(F))return F});try{const F=await this.#e.$executeCommand(w,C?new n.$mw(I):I,y);return(0,S.$Zh)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this.g(w,k,!1);throw F}}}async h(w,k,y){const C=this.b.get(w);if(!C)throw new Error("Unknown command");const{callback:I,thisArg:F,metadata:j}=C;if(j?.args)for(let O=0;O<j.args.length;O++)try{(0,u.$ig)(k[O],j.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${j.args[O].name}' - ${j.args[O].description}`)}const z=r.$0d.create();try{return await I.apply(F,k)}catch(O){if(w===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...k);T&&(w=T.command)}if(this.d.error(O,w,C.extension?.identifier),!y)throw O;if(C.extension?.identifier){const T=this.#i.onExtensionError(C.extension.identifier,O);this.d.trace("forwarded error to extension?",T,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$bj)(O)),this.id=w,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,w,z.elapsed())}}j(w,k,y){w.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new s.$_o(k),duration:y})}$executeContributedCommand(w,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const y=this.b.get(w);return y?(k=k.map(C=>this.f.reduce((I,F)=>F.processArgument(I,y.extension?.identifier),C)),this.h(w,k,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),this.#e.$getCommands().then(k=>(w&&(k=k.filter(y=>y[0]!=="_")),k))}$getContributedCommandMetadata(){const w=Object.create(null);for(const[k,y]of this.b){const{metadata:C}=y;C&&(w[k]=C)}return Promise.resolve(w)}};e.$vP=d,e.$vP=d=Je([qe(0,a.$aP),qe(1,b.$Wj),qe(2,t.$uP)],d),e.$wP=(0,v.$qi)("IExtHostCommands");class l{constructor(w,k,y){this.d=w,this.f=k,this.g=y,this.delegatingCommandId=`__vsc${(0,f.$Mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,k){if(!w)return;const y={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return y;const C=this.f(w.command);if(C)y.id=C.internalId,y.arguments=C.args.map((I,F)=>I.convert(w.arguments&&w.arguments[F]));else if((0,p.$Lb)(w.arguments)){const I=`${w.command} /${++this.c}`;this.b.set(I,w),k.add((0,E.$Sc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),y.$ident=I,y.id=this.delegatingCommandId,y.arguments=[I],this.g.trace("CommandsConverter#CREATE",w.command,I)}return y}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const k=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.$xP=l;class c{static{this.Uri=new c("uri","Uri of a text document",w=>$.URI.isUri(w),w=>w)}static{this.Position=new c("position","A position in a text document",w=>N.$SM.isPosition(w),L.Position.from)}static{this.Range=new c("range","A range in a text document",w=>N.$TM.isRange(w),L.Range.from)}static{this.Selection=new c("selection","A selection in a text document",w=>N.$UM.isSelection(w),L.Selection.from)}static{this.Number=new c("number","",w=>typeof w=="number",w=>w)}static{this.String=new c("string","",w=>typeof w=="string",w=>w)}static{this.StringArray=c.Arr(c.String)}static Arr(w){return new c(`${w.name}_array`,`Array of ${w.name}, ${w.description}`,k=>Array.isArray(k)&&k.every(y=>w.validate(y)),k=>k.map(y=>w.convert(y)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",w=>w instanceof N.$cN,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",w=>w instanceof N.$AO,L.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",w=>w instanceof m.$nP,L.TestItem.from)}constructor(w,k,y,C){this.name=w,this.description=k,this.validate=y,this.convert=C}optional(){return new c(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,k){return new c(w??this.name,k??this.description,this.validate,this.convert)}}e.$yP=c;class h{static{this.Void=new h("no result",w=>w)}constructor(w,k){this.description=w,this.convert=k}}e.$zP=h;class g{constructor(w,k,y,C,I){this.id=w,this.internalId=k,this.description=y,this.args=C,this.result=I}}e.$AP=g}),define(ke[350],Ee([1,0,19,15,2,83,134,37,33,16,8]),function(le,e,u,N,L,R,M,p,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$jc=void 0;const P=[new b.$AP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of DocumentHighlight-instances.",E(S.DocumentHighlight.to))),new b.$AP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$yP.Uri],new b.$zP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,m)=>{if((0,u.$Kb)(a))return;class o extends A.$0M{static to(i){const r=new o(i.name,S.SymbolKind.to(i.kind),i.containerName||"",new A.$4M(m[0],S.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=S.Range.to(i.selectionRange),r.children=i.children?i.children.map(o.to):[],r}}return a.map(o.to)})),new b.$AP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$yP.Uri,new b.$yP("options","Formatting options",a=>!0,a=>a)],new b.$zP("A promise that resolves to an array of TextEdits.",E(S.TextEdit.to))),new b.$AP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$yP.Uri,b.$yP.Range,new b.$yP("options","Formatting options",a=>!0,a=>a)],new b.$zP("A promise that resolves to an array of TextEdits.",E(S.TextEdit.to))),new b.$AP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$yP.Uri,b.$yP.Position,new b.$yP("ch","Trigger character",a=>typeof a=="string",a=>a),new b.$yP("options","Formatting options",a=>!0,a=>a)],new b.$zP("A promise that resolves to an array of TextEdits.",E(S.TextEdit.to))),new b.$AP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$AP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$AP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$AP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of Location or LocationLink instances.",v)),new b.$AP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of Location-instances.",E(S.location.to))),new b.$AP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of Hover-instances.",E(S.Hover.to))),new b.$AP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$yP.Uri,new b.$yP("position","A position in a text document",a=>Array.isArray(a)&&a.every(m=>A.$SM.isPosition(m)),a=>a.map(S.Position.from))],new b.$zP("A promise that resolves to an array of ranges.",a=>a.map(m=>{let o;for(const n of m.reverse())o=new A.$bN(S.Range.to(n),o);return o}))),new b.$AP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$yP.String.with("query","Search string")],new b.$zP("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(S.WorkspaceSymbol.to))),new b.$AP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(S.CallHierarchyItem.to))),new b.$AP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$yP.CallHierarchyItem],new b.$zP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(S.CallHierarchyIncomingCall.to))),new b.$AP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$yP.CallHierarchyItem],new b.$zP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(S.CallHierarchyOutgoingCall.to))),new b.$AP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:S.Range.to(a.range),placeholder:a.text}})),new b.$AP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$yP.Uri,b.$yP.Position,b.$yP.String.with("newName","The new symbol name")],new b.$zP("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return S.WorkspaceEdit.to(a)}})),new b.$AP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$yP.Uri,b.$yP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$zP("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(S.DocumentLink.to))),new b.$AP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$yP.Uri],new b.$zP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$0N(a.tokenTypes,a.tokenModifiers)})),new b.$AP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$yP.Uri],new b.$zP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,M.$ibb)(a);if(m.type==="full")return new A.$_N(m.data,void 0)})),new b.$AP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$yP.Uri,b.$yP.Range.optional()],new b.$zP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$0N(a.tokenTypes,a.tokenModifiers)})),new b.$AP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$yP.Uri,b.$yP.Range],new b.$zP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,M.$ibb)(a);if(m.type==="full")return new A.$_N(m.data,void 0)})),new b.$AP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$yP.Uri,b.$yP.Position,b.$yP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$yP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$zP("A promise that resolves to a CompletionList-instance.",(a,m,o)=>{if(!a)return new A.$nN([]);const n=a.suggestions.map(i=>S.CompletionItem.to(i,o));return new A.$nN(n,a.incomplete)})),new b.$AP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$yP.Uri,b.$yP.Position,b.$yP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$zP("A promise that resolves to SignatureHelp.",a=>{if(a)return S.SignatureHelp.to(a)})),new b.$AP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$yP.Uri,b.$yP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$zP("A promise that resolves to an array of CodeLens-instances.",(a,m,o)=>E(n=>new A.$fN(S.Range.to(n.range),n.command&&o.fromInternal(n.command)))(a))),new b.$AP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$yP.Uri,new b.$yP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>A.$TM.isRange(a),a=>A.$UM.isSelection(a)?S.Selection.from(a):S.Range.from(a)),b.$yP.String.with("kind","Code action kind to return code actions for").optional(),b.$yP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$zP("A promise that resolves to an array of Command-instances.",(a,m,o)=>E(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(n.command)}else{const i=new A.$_M(n.title,n.kind?new A.$aN(n.kind):void 0);return n.edit&&(i.edit=S.WorkspaceEdit.to(n.edit)),n.command&&(i.command=o.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(a))),new b.$AP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$yP.Uri],new b.$zP("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new A.$tN(S.Range.to(m.range),S.Color.to(m.color))):[])),new b.$AP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$yP("color","The color to show and insert",a=>a instanceof A.$sN,S.Color.from),new b.$yP("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:S.Range.from(a.range)}))],new b.$zP("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(S.ColorPresentation.to):[])),new b.$AP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$yP.Uri,b.$yP.Range],new b.$zP("A promise that resolves to an array of Inlay objects",(a,m,o)=>a.map(S.InlayHint.to.bind(void 0,o)))),new b.$AP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$yP.Uri],new b.$zP("A promise that resolves to an array of FoldingRange objects",(a,m)=>{if(a)return a.map(S.FoldingRange.to)})),new b.$AP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$zP("A promise that resolves to an array of NotebookContentProvider static info objects.",E(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(m=>S.NotebookExclusiveDocumentPattern.to(m))})))),new b.$AP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$yP.Uri,b.$yP.Range,new b.$yP("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof A.$TM,a=>S.InlineValueContext.from(a))],new b.$zP("A promise that resolves to an array of InlineValue objects",a=>a.map(S.InlineValue.to))),new b.$AP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$yP("uriOrString","Uri-instance or string (only http/https)",a=>L.URI.isUri(a)||typeof a=="string"&&(0,N.$Ag)(a,N.Schemas.http,N.Schemas.https),a=>a),new b.$yP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[S.ViewColumn.from(a),void 0]:[S.ViewColumn.from(a.viewColumn),S.TextEditorOpenOptions.from(a)])).optional(),b.$yP.String.with("label","").optional()],b.$zP.Void),new b.$AP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$yP.Uri.with("resource","Resource to open"),b.$yP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new b.$yP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[S.ViewColumn.from(a),void 0]:[S.ViewColumn.from(a.viewColumn),S.TextEditorOpenOptions.from(a)])).optional()],b.$zP.Void),new b.$AP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$yP.Uri.with("left","Left-hand side resource of the diff editor"),b.$yP.Uri.with("right","Right-hand side resource of the diff editor"),b.$yP.String.with("title","Human readable title for the diff editor").optional(),new b.$yP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[S.ViewColumn.from(a.viewColumn),S.TextEditorOpenOptions.from(a)]).optional()],b.$zP.Void),new b.$AP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[b.$yP.String.with("title","Human readable title for the changes editor"),new b.$yP("resourceList","List of resources to compare",a=>{for(const m of a){if(m.length!==3)return!1;const[o,n,i]=m;if(!L.URI.isUri(o)||!L.URI.isUri(n)&&n!==void 0&&n!==null||!L.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},a=>a)],b.$zP.Void),new b.$AP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$yP.Uri,b.$yP.Position],new b.$zP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(S.TypeHierarchyItem.to))),new b.$AP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$yP.TypeHierarchyItem],new b.$zP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(S.TypeHierarchyItem.to))),new b.$AP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$yP.TypeHierarchyItem],new b.$zP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(S.TypeHierarchyItem.to))),new b.$AP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$yP.TestItem],b.$zP.Void),new b.$AP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$yP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$zP.Void),new b.$AP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$yP.String.with("name","The context key name"),new b.$yP("value","The context key value",()=>!0,a=>a)],b.$zP.Void),new b.$AP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[b.$yP.Uri,b.$yP.StringArray,new b.$yP("MappedEditsContext","Mapped Edits Context",a=>S.MappedEditsContext.is(a),a=>S.MappedEditsContext.from(a))],new b.$zP("A promise that resolves to a workspace edit or null",a=>a?S.WorkspaceEdit.to(a):null))];class ${static register(m){P.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",p.$pj)}}e.$$jc=$;function E(a){return m=>{if(Array.isArray(m))return m.map(a)}}function v(a){if(!Array.isArray(a))return;const m=[];for(const o of a)R.$2t(o)?m.push(S.DefinitionLink.to(o)):m.push(S.location.to(o));return m}}),define(ke[351],Ee([1,0,7,3,2,6,33,16,8]),function(le,e,u,N,L,R,M,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;class S{static{this.a=0}constructor(E,v){this.extension=E,this.provider=v,this.handle=S.a++}}class A{constructor(E){this.session=E,this.responses=[]}}class P{static{this.a=0}constructor(E,v,a,m){this.f=a,this.g=m,this.b=new Map,this.d=new Map,this.e=E.getProxy(R.$PM.MainThreadInlineChat),v.registerApiCommand(new M.$AP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$yP("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?p.Range.from(o.initialRange):void 0,initialSelection:b.$UM.isSelection(o.initialSelection)?p.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?p.Position.from(o.position):void 0}})],M.$zP.Void))}registerProvider(E,v,a){const m=new S(E,v);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,a?.label??E.displayName??E.name,E.identifier,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",a?.supportReportIssue??!1),(0,N.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(E,v,a,m){const o=this.b.get(E);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(L.URI.revive(v)),i=p.Selection.to(a),r=await o.provider.prepareInteractiveEditorSession({document:n,selection:i},m);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const s=P.a++;return this.d.set(s,new A(r)),{id:s,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:p.Range.from(r.wholeRange),message:r.message}}async $provideResponse(E,v,a,m){const o=this.b.get(E);if(!o)return;const n=this.d.get(v.id);if(!n)return;const i={prompt:a.prompt,selection:p.Selection.to(a.selection),wholeRange:p.Range.to(a.wholeRange),attempt:a.attempt,live:a.live,previewDocument:this.f.getDocument(L.URI.revive(a.previewDocument)),withIntentDetection:a.withIntentDetection};let r=!1;const s={report:async D=>{if(!a.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||m.isCancellationRequested||await this.e.$handleProgressChunk(a.requestId,{message:D.message,edits:D.edits?.map(p.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:b.$gN.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(n.session,i,s,m));let f;try{f=await(0,u.$eh)(t,m)}finally{r=!0}if(!f)return;const d=n.responses.push(f)-1,l={wholeRange:p.Range.from(f.wholeRange),placeholder:f.placeholder};if(!P.h(f))return{...l,id:d,type:"editorEdit",message:p.MarkdownString.from(f.contents),edits:[]};const{edits:c,contents:h}=f,g=h!==void 0?p.MarkdownString.from(h):void 0;return c instanceof b.$2M?{...l,id:d,type:"bulkEdit",edits:p.WorkspaceEdit.from(c),message:g}:{...l,id:d,type:"editorEdit",edits:c.map(p.TextEdit.from),message:g}}async $provideFollowups(E,v,a,m){const o=this.b.get(E),n=this.d.get(v),i=n?.responses[a];if(o&&i&&o.provider.provideFollowups){const r=Promise.resolve(o.provider.provideFollowups(n.session,i,m));return(await(0,u.$eh)(r,m))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(E,v,a,m){const o=this.b.get(E),n=this.d.get(v),i=n?.responses[a];if(o&&i){const r=p.InteractiveEditorResponseFeedbackKind.to(m);o.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,r)}}$releaseSession(E,v){}static h(E){return typeof E=="object"&&typeof E.edits=="object"}}e.$hlc=P}),define(ke[352],Ee([1,0,2,33]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class L{constructor(M,p,b,S,A){this.a=p,this.b=b,this.c=S;const P=new N.$AP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$yP("showOptions","Show Options",$=>!0,$=>$),new N.$yP("resource","Interactive resource Uri",$=>!0,$=>$),new N.$yP("controllerId","Notebook controller Id",$=>!0,$=>$),new N.$yP("title","Interactive editor title",$=>!0,$=>$)],new N.$zP("Notebook and input URI",$=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const E=this.a.getEditorById($.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:u.URI.revive($.notebookUri),inputUri:u.URI.revive($.inputUri),notebookEditor:E.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:u.URI.revive($.notebookUri),inputUri:u.URI.revive($.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(M,p,b,S){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:b,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$ulc=L}),define(ke[353],Ee([1,0,19,7,22,4,3,27,2,25,12,6,33,16,8,113,297,26,48,298]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=void 0,e.$Clc=c;let r=class{constructor(g,D,w,k,y){this.m=D,this.n=w,this.o=k,this.q=y,this.b=new p.$Bc,this.c=new p.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$be,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=g.getProxy(P.$PM.MainThreadNotebookKernels);const C=new $.$AP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new $.$yP("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const j=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:j}}else if(F&&"notebookEditor"in F){const j=this.n.getIdByEditor(F.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return F})],$.$zP.Void),I=new $.$AP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[$.$yP.Uri],new $.$zP("A promise that resolves to an array of variables",(F,j)=>F.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(I)}createNotebookController(g,D,w,k,y,C){for(const $e of this.j.values())if($e.controller.id===D&&S.$Lm.equals(g.identifier,$e.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const I=this.k++,F=this;this.q.trace(`NotebookController[${I}], CREATED by ${g.identifier.value}, ${D}`);const j=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${g.identifier}'`);let z=!1;const O=new R.$be,T=new R.$be,B={id:c(g.identifier,D),notebookType:w,extensionId:g.identifier,extensionLocation:g.extensionLocation,label:k||g.identifier.value,preloads:C?C.map(E.NotebookRendererScript.from):[]};let W=y??j,Z,x;this.a.$addKernel(I,B).catch($e=>{console.log($e),z=!0});let X=0;const Y=()=>{if(z)return;const $e=++X;Promise.resolve().then(()=>{$e===X&&this.a.$updateKernel(I,B)})},ce=new p.$Bc,ne={get id(){return D},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return B.label},set label($e){B.label=$e??g.displayName??g.name,Y()},get detail(){return B.detail??""},set detail($e){B.detail=$e,Y()},get description(){return B.description??""},set description($e){B.description=$e,Y()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages($e){B.supportedLanguages=$e,Y()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder($e){B.supportsExecutionOrder=$e,Y()},get rendererScripts(){return B.preloads?B.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler($e){W=$e??j},get interruptHandler(){return Z},set interruptHandler($e){Z=$e,B.supportsInterrupt=!!$e,Y()},set variableProvider($e){(0,o.$yG)(g,"notebookVariableProvider"),x=$e,B.hasVariableProvider=!!$e,$e?.onDidChangeVariables(Ce=>F.a.$variablesUpdated(Ce.uri)),Y()},get variableProvider(){return x},createNotebookCellExecution($e){if(z)throw new Error("notebook controller is DISPOSED");if(!ce.has($e.notebook.uri))throw F.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return F._createNotebookCellExecution($e,c(g.identifier,this.id))},createNotebookExecution($e){if((0,o.$yG)(g,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!ce.has($e.uri))throw F.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return F._createNotebookExecution($e,c(g.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${I}], DISPOSED`),z=!0,this.j.delete(I),O.dispose(),T.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity($e,Ce){Ce===v.NotebookControllerAffinity2.Hidden&&(0,o.$yG)(g,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(I,$e.uri,Ce)},onDidReceiveMessage:T.event,postMessage($e,Ce){return(0,o.$yG)(g,"notebookMessaging"),F.a.$postMessage(I,Ce&&F.n.getIdByEditor(Ce),$e)},asWebviewUri($e){return(0,o.$yG)(g,"notebookMessaging"),(0,a.$Gxb)($e,F.m.remote)}};return this.j.set(I,{extensionId:g.identifier,controller:ne,onDidReceiveMessage:T,onDidChangeSelection:O,associatedNotebooks:ce}),ne}getIdByController(g){for(const[D,w]of this.j)if(w.controller===g)return c(w.extensionId,g.id);return null}createNotebookControllerDetectionTask(g,D){const w=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${w}], CREATED by ${g.identifier.value}`),this.a.$addKernelDetectionTask(w,D);const y={dispose:()=>{this.f.delete(w),k.a.$removeKernelDetectionTask(w)}};return this.f.set(w,y),y}registerKernelSourceActionProvider(g,D,w){const k=this.i++,y=typeof w.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,C=this;this.h.set(k,w),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${g.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,D);let I;return y!==void 0&&(I=w.onDidChangeNotebookKernelSourceActions(F=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(k),C.a.$removeKernelSourceActionProvider(k,k),I?.dispose()}}}async $provideKernelSourceActions(g,D){const w=this.h.get(g);if(w){const k=new M.$Tc;return(await w.provideNotebookKernelSourceActions(D)??[]).map(C=>E.NotebookKernelSourceAction.from(C,this.o.converter,k))}return[]}$acceptNotebookAssociation(g,D,w){const k=this.j.get(g);if(k){const y=this.n.getNotebookDocument(b.URI.revive(D));w?k.associatedNotebooks.set(y.uri,!0):k.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${g}] ASSOCIATE notebook`,y.uri.toString(),w),k.onDidChangeSelection.fire({selected:w,notebook:y.apiNotebook})}}async $executeCells(g,D,w){const k=this.j.get(g);if(!k)return;const y=this.n.getNotebookDocument(b.URI.revive(D)),C=[];for(const I of w){const F=y.getCell(I);F&&C.push(F.apiCell)}try{this.q.trace(`NotebookController[${g}] EXECUTE cells`,y.uri.toString(),C.length),await k.controller.executeHandler.call(k.controller,C,y.apiNotebook,k.controller)}catch(I){this.q.error(`NotebookController[${g}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(g,D,w){const k=this.j.get(g);if(!k)return;const y=this.n.getNotebookDocument(b.URI.revive(D));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,y.apiNotebook);else for(const C of w){const I=y.getCell(C);I&&this.b.get(I.uri)?.cancel()}if(k.controller.interruptHandler){const C=this.c.get(y.uri);w.length&&Array.isArray(C)&&C.length&&C.forEach(I=>I.dispose())}}async $provideVariables(g,D,w,k,y,C,I){const F=this.j.get(g);if(!F)return;const j=this.n.getNotebookDocument(b.URI.revive(w)),z=F.controller.variableProvider;if(!z)return;let O;if(k!==void 0){if(O=this.s[k],!O)return}else this.s={};const T=y==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,B=z.provideVariables(j.apiNotebook,O,T,C,I);let W=0;for await(const Z of B){if(I.isCancellationRequested)return;const x={id:this.r++,name:Z.variable.name,value:Z.variable.value,type:Z.variable.type,interfaces:Z.variable.interfaces,language:Z.variable.language,expression:Z.variable.expression,hasNamedChildren:Z.hasNamedChildren,indexedChildrenCount:Z.indexedChildrenCount,extensionId:F.extensionId.value};if(this.s[x.id]=Z.variable,this.a.$receiveVariable(D,x),W++>=i.$kib)return}}$acceptKernelMessageFromRenderer(g,D,w){const k=this.j.get(g);if(!k)return;const y=this.n.getEditorById(D);k.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:w}))}$cellExecutionChanged(g,D,w){const y=this.n.getNotebookDocument(b.URI.revive(g)).getCell(D);if(y){const C=w?E.NotebookCellExecutionState.to(w):v.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:y.apiCell,state:C})}}_createNotebookCellExecution(g,D){if(g.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(g.notebook.uri).getCellFromApiCell(g);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const y=new t(D,k,this.a);this.b.set(k.uri,y);const C=y.onDidChangeState(()=>{y.state===s.Resolved&&(y.dispose(),C.dispose(),this.b.delete(k.uri))});return y.asApiObject()}_createNotebookExecution(g,D){const w=this.n.getNotebookDocument(g.uri),k=g.getCells().find(I=>{const F=w.getCellFromApiCell(I);return F&&this.b.has(F.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(w.uri))throw new Error(`duplicate notebook execution for ${w.uri}`);const y=new d(D,w,this.a),C=y.onDidChangeState(()=>{y.state===f.Resolved&&(y.dispose(),C.dispose(),this.c.delete(w.uri))});return this.c.set(w.uri,[y,C]),y.asApiObject()}};e.$Blc=r,e.$Blc=r=Je([qe(4,A.$Wj)],r);var s;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(s||(s={}));class t extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(g,D,w){super(),this.m=D,this.n=w,this.b=t.a++,this.c=new R.$be,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new L.$me),this.h=new l(10,k=>this.s(k)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,g,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(g){await this.h.addItem(g)}async s(g){const D=Array.isArray(g)?g:[g];return this.n.$updateExecution(this.b,new n.$mw(D))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(g){let D=this.m;if(g&&(D=this.m.notebook.getCellFromApiCell(g)),!D)throw new Error("INVALID cell");return D.handle}y(g){return g.map(D=>{const w=v.$kO.ensureUniqueMimeTypes(D.items,!0);return w===D.items?E.NotebookCellOutput.from(D):E.NotebookCellOutput.from({items:w,id:D.id,metadata:D.metadata})})}async z(g,D,w){const k=this.w(D),y=this.y((0,u.$3b)(g));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:k,append:w,outputs:y})}async C(g,D,w){return g=v.$kO.ensureUniqueMimeTypes((0,u.$3b)(g),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:g.map(E.NotebookCellOutputItem.from),outputId:D.id,append:w})}asApiObject(){const g=this;return Object.freeze({get token(){return g.g.token},get cell(){return g.m.apiCell},get executionOrder(){return g.j},set executionOrder(w){g.j=w,g.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:g.j}])},start(w){if(g.f===s.Resolved||g.f===s.Started)throw new Error("Cannot call start again");g.f=s.Started,g.c.fire(),g.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:w})},end(w,k,y){if(g.f===s.Resolved)throw new Error("Cannot call resolve twice");g.f=s.Resolved,g.c.fire(),g.h.flush();const C=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;g.n.$completeExecution(g.b,new n.$mw({runEndTime:k,lastRunSuccess:w,error:C}))},clearOutput(w){return g.t(),g.z([],w,!1)},appendOutput(w,k){return g.t(),g.z(w,k,!0)},replaceOutput(w,k){return g.t(),g.z(w,k,!1)},appendOutputItems(w,k){return g.t(),g.C(w,k,!0)},replaceOutputItems(w,k){return g.t(),g.C(w,k,!1)}})}}var f;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(f||(f={}));class d extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(g,D,w){super(),this.h=D,this.j=w,this.b=d.a++,this.c=new R.$be,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new L.$me),this.j.$createNotebookExecution(this.b,g,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(g,D){this.f=g,this.g=D,this.a=[],this.b=Date.now()}addItem(g){return this.a.push(g),this.c||(this.c=new N.$Nh,this.b=Date.now(),(0,N.$rh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const g=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>g.complete())}}function c(h,g){return`${h.value}/${g}`}}),define(ke[42],Ee([1,0,4,6,5,2,20,3,8,227,13,273,22,30,274,57,7,16,33]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=e.$Okc=e.$Nkc=e.$Mkc=void 0,e.$Mkc=(0,L.$qi)("IExtHostTerminalService");class i extends p.$Uc{constructor(w,k,y,C){super(),this.u=w,this._id=k,this.w=y,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new u.$be),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(F=>this.g=F);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(F,j=!0){I.C(),I.u.$sendText(I._id,F,j)},show(F){I.C(),I.u.$show(I._id,F)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(w,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??k?.cwd??void 0,env:w.env??void 0,icon:c(w.iconPath)??void 0,color:a.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,forceShellIntegration:k?.forceShellIntegration??void 0,isFeatureTerminal:k?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:k?.useShellEnvironment??void 0,location:k?.location||this.z(w.location,k?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,k,y,C,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:a.ThemeColor.isThemeColor(I)?I.id:void 0,location:k?.location||this.z(w,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(w,k){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&k?{parentTerminal:k}:"viewColumn"in w?{viewColumn:o.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.y=w}setExitStatus(w,k){this.j=Object.freeze({code:w,reason:k})}setDimensions(w,k){return w===this.f&&k===this.h||w===0||k===0?!1:(this.f=w,this.h=k,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(w){this.n=w}_setProcessId(w){this.g?(this.g(w),this.g=void 0):this.b.then(k=>{k!==w&&(this.b=Promise.resolve(w))})}}e.$Nkc=i;class r{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new u.$be,this.onProcessData=this.a.event,this.b=new u.$be,this.d=new u.$be,this.onDidChangeProperty=this.d.event,this.f=new u.$be,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,k){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${k}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,k){this.g.setDimensions?.({columns:w,rows:k})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(k=>this.a.fire(k)),this.g.onDidClose?.((k=void 0)=>{this.f.fire(k===void 0?void 0:k)}),this.g.onDidOverrideDimensions?.(k=>{k&&this.d.fire({type:"overrideDimensions",value:{cols:k.columns,rows:k.rows}})}),this.g.onDidChangeName?.(k=>{this.d.fire({type:"title",value:k})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,t=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,k,y){super(),this.Q=k,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new u.$be,this.onDidCloseTerminal=this.H.event,this.I=new u.$be,this.onDidOpenTerminal=this.I.event,this.J=new u.$be,this.onDidChangeActiveTerminal=this.J.event,this.L=new u.$be,this.onDidChangeTerminalDimensions=this.L.event,this.M=new u.$be,this.onDidChangeTerminalState=this.M.event,this.N=new u.$be,this.onDidChangeShell=this.N.event,this.O=new u.$be({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new u.$be({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(N.$PM.MainThreadTerminalService),this.y=new v.$Fsb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:C=>{const I=F=>{const j=F;return this.getTerminalById(j.instanceId)?.value};switch(C?.$mid){case 15:return I(C);default:{if(Array.isArray(C))for(let F=0;F<C.length&&C[F].$mid===15;F++)C[F]=I(C[F]);return C}}}}),this.B({dispose:()=>{for(const[C,I]of this.g)I.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,k){const y=new i(this.a,(0,E.$Mg)(),w,w.name),C=new r(w.pty);return y.createExtensionTerminal(w.location,k,this.R(w,k).resolvedExtHostIdentifier,c(w.iconPath),h(w.color)).then(I=>{const F=this.S(I,C);this.h[I]=F}),this.f.push(y),y.value}R(w,k){if(k=k||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const y=w.location.parentTerminal;if(y){const C=this.f.find(I=>I.value===y);C&&(k.resolvedExtHostIdentifier=C._id)}}else w.location&&typeof w.location!="object"?k.location=w.location:k.location&&typeof k.location=="object"&&"splitActiveTerminal"in k.location&&(k.location={splitActiveTerminal:!0});return k}attachPtyToTerminal(w,k){if(!this.getTerminalById(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const C=new r(k),I=this.S(w,C);this.h[w]=I}async $acceptActiveTerminalChanged(w){const k=this.b;if(w===null){this.b=void 0,k!==this.b&&this.J.fire(this.b);return}const y=this.getTerminalById(w);y&&(this.b=y,k!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,k){const y=this.getTerminalById(w);y&&this.O.fire({terminal:y.value,data:k})}async $acceptTerminalDimensions(w,k,y){const C=this.getTerminalById(w);C&&C.setDimensions(k,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(w,k){const y=this.getTerminalById(w);y&&this.P.fire({terminal:y.value,...k})}async $acceptTerminalMaximumDimensions(w,k,y){this.g.get(w)?.resize(k,y)}async $acceptTerminalTitleChange(w,k){const y=this.getTerminalById(w);y&&(y.name=k)}async $acceptTerminalClosed(w,k,y){const C=this.X(this.f,w);if(C!==null){const I=this.f.splice(C,1)[0];I.setExitStatus(k,y),this.H.fire(I.value)}}$acceptTerminalOpened(w,k,y,C){if(k){const j=this.X(this.f,k);if(j!==null){this.f[j]._id=w,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const I={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:R.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},F=new i(this.a,w,I,y);this.f.push(F),this.I.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(w,k){this.getTerminalById(w)?._setProcessId(k)}async $startExtensionTerminal(w,k){const y=this.getTerminalById(w);if(!y)return{message:(0,S.localize)(0,null,w)};y.isOpen||await new Promise(I=>{const F=this.onDidOpenTerminal(async j=>{j===y.value&&(F.dispose(),I())})});const C=this.g.get(w);C?C.startSendingEvents(k):this.j[w]={initialDimensions:k}}S(w,k){const y=new p.$Tc;y.add(k.onProcessReady(I=>this.a.$sendProcessReady(w,I.pid,I.cwd,I.windowsPty))),y.add(k.onDidChangeProperty(I=>this.a.$sendProcessProperty(w,I))),this.y.startBuffering(w,k.onProcessData),y.add(k.onProcessExit(I=>this.U(w,I))),this.g.set(w,k);const C=this.j[w];return C&&k instanceof r&&(k.startSendingEvents(C.initialDimensions),delete this.j[w]),y}$acceptProcessAckDataEvent(w,k){this.g.get(w)?.acknowledgeDataEvent(k)}$acceptProcessInput(w,k){this.g.get(w)?.input(k)}$acceptTerminalInteraction(w){const k=this.getTerminalById(w);k?.setInteractedWith()&&this.M.fire(k.value)}$acceptTerminalSelection(w,k){this.getTerminalById(w)?.setSelection(k)}$acceptProcessResize(w,k,y){try{this.g.get(w)?.resize(k,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(w,k){this.g.get(w)?.shutdown(k)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(k=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:k}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(k=>this.a.$sendProcessProperty(w,{type:"cwd",value:k}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new b.$RM(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,k,y){if(this.C.has(k))throw new Error(`Terminal profile provider "${k}" already registered`);return this.C.set(k,y),this.a.$registerProfileProvider(k,w.identifier.value),new b.$RM(()=>{this.C.delete(k),this.a.$unregisterProfileProvider(k)})}registerTerminalQuickFixProvider(w,k,y){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,y),this.a.$registerQuickFixProvider(w,k),new b.$RM(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,k){const y=new $.$me().token;if(y.isCancellationRequested)return;const C=this.D.get(w);if(!C)return;const I=await C.provideTerminalQuickFixes(k,y);if(I===null||Array.isArray(I)&&I.length===0)return;const F=new p.$Tc;if(this.w.value=F,!Array.isArray(I))return I?o.TerminalQuickFix.from(I,this.Q.converter,F):void 0;const j=[];for(const z of I){const O=o.TerminalQuickFix.from(z,this.Q.converter,F);O&&j.push(O)}return j}async $createContributedProfileTerminal(w,k){const y=new $.$me().token;let C=await this.C.get(w)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,k);return}this.createTerminalFromOptions(C.options,k)}}async $provideLinks(w,k){const y=this.getTerminalById(w);if(!y)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const I=new $.$me;this.G.set(w,I);const F=[],j={terminal:y.value,line:k},z=[];for(const B of this.z)z.push(m.Promises.withAsyncBody(async W=>{I.token.onCancellationRequested(()=>W({provider:B,links:[]}));const Z=await B.provideTerminalLinks(j,I.token)||[];I.token.isCancellationRequested||W({provider:B,links:Z})}));const O=await Promise.all(z);if(I.token.isCancellationRequested)return[];const T=new Map;for(const B of O)B&&B.links.length>0&&F.push(...B.links.map(W=>{const Z={id:s++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return T.set(Z.id,{provider:B.provider,link:W}),Z}));return this.F.set(w,T),F}$activateLink(w,k){const y=this.F.get(w)?.get(k);y&&y.provider.handleTerminalLink(y.link)}U(w,k){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const y=this.h[w];y&&(y.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,k)}getTerminalById(w){return this.W(this.f,w)}getTerminalIdByApiObject(w){const k=this.f.findIndex(y=>y.value===w);return k>=0?k:null}W(w,k){const y=this.X(w,k);return y!==null?w[y]:null}X(w,k){const y=w.findIndex(C=>C._id===k);return y>=0?y:null}getEnvironmentVariableCollection(w){let k=this.n.get(w.identifier.value);return k||(k=new f,this.Z(w.identifier.value,k)),k.getScopedEnvironmentVariableCollection(void 0)}Y(w,k){const y=(0,P.$cs)(k.map),C=(0,P.$ds)(k.descriptionMap);this.a.$setEnvironmentVariableCollection(w,k.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(w){w.forEach(k=>{const y=k[0],C=new f(k[1]);this.Z(y,C)})}$acceptDefaultProfile(w,k){const y=this.s;this.s=w,this.u=k,y?.path!==w.path&&this.N.fire(w.path)}Z(w,k){this.n.set(w,k),k.onDidChangeCollection(()=>{this.Y(w,k)})}};e.$Okc=t,e.$Okc=t=Je([qe(1,n.$wP),qe(2,M.$aP)],t);class f{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new u.$be,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const k=this.h(w);let y=this.a.get(k);return y||(y=new d(this,w),this.a.set(k,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(w,k,y,C){this.f(w,{value:k,type:b.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(w,k,y,C){this.f(w,{value:k,type:b.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(w,k,y,C){this.f(w,{value:k,type:b.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(w,k){if(k.options&&k.options.applyAtProcessCreation===!1&&!k.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(w,k.scope),C=this.map.get(y),I=k.options?{applyAtProcessCreation:k.options.applyAtProcessCreation??!1,applyAtShellIntegration:k.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==k.value||C.type!==k.type||C.options?.applyAtProcessCreation!==I.applyAtProcessCreation||C.options?.applyAtShellIntegration!==I.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==k.scope?.workspaceFolder?.index){const F=this.g(w,k.scope),j={variable:w,...k,options:I};this.map.set(F,j),this.d.fire()}}get(w,k){const y=this.g(w,k),C=this.map.get(y);return C?g(C):void 0}g(w,k){const y=this.h(k);return y.length?`${w}:::${y}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const k=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(w)&&k.set(C.variable,g(C));return k}delete(w,k){const y=this.g(w,k);this.map.delete(y),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[k,y]of this.map)y.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(k);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,k){const y=this.h(k),C=this.descriptionMap.get(y);if(!C||C.description!==w){let I;typeof w=="string"?I=w:I=w?.value.split(`

`)[0];const F={description:I,scope:k};this.descriptionMap.set(y,F),this.d.fire()}}getDescription(w){const k=this.h(w);return this.descriptionMap.get(k)?.description}k(w){const k=this.h(w);this.descriptionMap.delete(k)}}class d{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,k){this.b=w,this.d=k,this.a=new u.$be}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,k,y){this.b.replace(w,k,y,this.d)}append(w,k,y){this.b.append(w,k,y,this.d)}prepend(w,k,y){this.b.prepend(w,k,y,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,k){this.b.getVariableMap(this.d).forEach((y,C)=>w.call(k,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends t{constructor(w,k){super(!1,w,k)}createTerminal(w,k,y){throw new A.$_}createTerminalFromOptions(w,k){throw new A.$_}};e.$Pkc=l,e.$Pkc=l=Je([qe(0,n.$wP),qe(1,M.$aP)],l);function c(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function h(D){return a.ThemeColor.isThemeColor(D)?D:void 0}function g(D){const w={...D};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(ke[155],Ee([1,0,3,5,6,20,42,4,2,7]),function(le,e,u,N,L,R,M,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=void 0,e.$Tlc=(0,N.$qi)("IExtHostTerminalShellIntegration");let A=class extends u.$Uc{constructor(a,m){super(),this.h=m,this.b=new Map,this.c=new p.$be,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$be,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$be,this.onDidEndTerminalShellExecution=this.g.event,this.a=a.getProxy(L.$PM.MainThreadTerminalShellIntegration),this.B((0,u.$Sc)(()=>{for(const[o,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(a){const m=this.h.getTerminalById(a);if(!m)return;const o=m.value;let n=this.b.get(a);n||(n=new P(m.value,this.f),this.b.set(a,n),n.store.add(m.onWillDispose(()=>this.b.get(a)?.dispose())),n.store.add(n.onDidRequestShellExecution(i=>this.a.$executeCommand(a,i))),n.store.add(n.onDidRequestEndExecution(i=>this.g.fire(i))),n.store.add(n.onDidRequestChangeShellIntegration(i=>this.c.fire(i))),m.shellIntegration=n.value),this.c.fire({terminal:o,shellIntegration:n.value})}$shellExecutionStart(a,m,o){this.b.has(a)||this.$shellIntegrationChange(a),this.b.get(a)?.startShellExecution(m,o)}$shellExecutionEnd(a,m,o){this.b.get(a)?.endShellExecution(m,o)}$shellExecutionData(a,m){this.b.get(a)?.emitData(m)}$cwdChange(a,m){this.b.get(a)?.setCwd(m)}$closeTerminal(a){this.b.get(a)?.dispose(),this.b.delete(a)}};e.$Ulc=A,e.$Ulc=A=Je([qe(0,R.$aP),qe(1,M.$Mkc)],A);class P extends u.$Uc{get currentExecution(){return this.a}constructor(a,m){super(),this.j=a,this.m=m,this.b=!1,this.store=this.B(new u.$Tc),this.f=this.B(new p.$be),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$be),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$be),this.onDidRequestEndExecution=this.h.event;const o=this;this.value={get cwd(){return o.c},executeCommand(n){o.g.fire(n);const i=o.startShellExecution(n,o.c,!0).value;return o.b=!0,i}}}startShellExecution(a,m,o){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0,void 0),this.h.fire({execution:this.a.value,exitCode:void 0}));const n=this.a=new $(this.j,a,m);o?queueMicrotask(()=>this.m.fire(n.value)):this.m.fire(this.a.value)}return this.a}emitData(a){this.currentExecution?.emitData(a)}endShellExecution(a,m){this.a&&(this.a.endExecution(a,m),this.h.fire({execution:this.a.value,exitCode:m}),this.a=void 0)}setCwd(a){let m=!1;b.URI.isUri(this.c)?m=!b.URI.isUri(a)||this.c.toString()!==a.toString():this.c!==a&&(m=!0),m&&(this.c=a,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class ${constructor(a,m,o){this.terminal=a,this.c=m,this.cwd=o,this.b=!1;const n=this;this.value={get terminal(){return n.terminal},get commandLine(){return n.c},get cwd(){return n.cwd},readData(){return n.d()}}}d(){if(!this.a){if(this.b)return S.$Qh.EMPTY;this.a=new E}return this.a.createIterable()}emitData(a){this.a?.emitData(a)}endExecution(a,m){a&&(this.c=a),this.a?.endExecution(),this.a=void 0,this.b=!0}}class E extends u.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const a=this.a=new S.$ph;return new S.$Qh(async o=>{this.b.push(o),await a.wait()})}emitData(a){for(const m of this.b)m.emitOne(a)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[354],Ee([1,0,7,21,22,4,74,56,3,18,30,12,6,20,154,16,8,68,112,89]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=e.$Xlc=e.$Wlc=e.$Vlc=void 0;let r=class extends b.$Uc{constructor(I,F,j,z){super(),this.w=z,this.f=this.B(new R.$be),this.g=new Map,this.s=this.B(new R.$be),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy($.$PM.MainThreadTesting),this.m=new D(this.h),this.j=new d(this.h,F),j.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const T=O,B=T.tests[T.tests.length-1].item.extId;return this.g.get(o.$BL.root(B))?.collection.tree.get(B)?.actual??(0,v.$mP)(O)}case 18:{const{test:T,message:B}=O,W=T.item.extId;return{test:this.g.get(o.$BL.root(W))?.collection.tree.get(W)?.actual??(0,v.$mP)({$mid:16,tests:[T]}),message:a.TestMessage.to(B)}}default:return O}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await j.executeCommand("_testing.getExplorerSelection"),T=B=>{const W=this.g.get(o.$BL.root(B));if(W)return o.$BL.isRoot(B)?W.controller:W.collection.tree.get(B)?.actual};return{include:O?.include.map(T).filter(S.$_f)||[],exclude:O?.exclude.map(T).filter(S.$_f)||[]}})}createTestController(I,F,j,z){if(this.g.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const O=new b.$Tc,T=O.add(new v.$pP(F,j,this.w));T.root.label=j;const B=new Map,W=new Set,Z=this.h,x={items:T.root.children,get label(){return j},set label(Y){j=Y,T.root.label=Y,Z.$updateController(F,{label:j})},get refreshHandler(){return z},set refreshHandler(Y){z=Y,Z.$updateController(F,{canRefresh:!!Y})},get id(){return F},createRunProfile:(Y,ce,ne,$e,Ce,ee)=>{let U=(0,p.$ej)(Y);for(;B.has(U);)U++;return new k(this.h,B,W,this.s.event,F,U,Y,ce,ne,$e,Ce,ee)},createTestItem(Y,ce,ne){return new v.$nP(F,Y,ce,ne)},createTestRun:(Y,ce,ne=!0)=>this.j.createTestRun(F,T,Y,ce,ne),invalidateTestResults:Y=>{if(Y===void 0)this.h.$markTestRetired(void 0);else{const ce=Y instanceof Array?Y:[Y];this.h.$markTestRetired(ce.map(ne=>o.$BL.fromExtHostTestItem(ne,F).toString()))}},set resolveHandler(Y){T.resolveHandler=Y},get resolveHandler(){return T.resolveHandler},dispose:()=>{O.dispose()}};Z.$registerTestController(F,j,!!z),O.add((0,b.$Sc)(()=>Z.$unregisterTestController(F)));const X={controller:x,collection:T,profiles:B,extension:I,activeProfiles:W};return this.g.set(F,X),O.add((0,b.$Sc)(()=>this.g.delete(F))),O.add(T.onDidGenerateDiff(Y=>Z.$publishDiff(F,Y.map(i.TestsDiffOp.serialize)))),x}createTestObserver(){return this.m.checkout()}async runTests(I,F=L.CancellationToken.None){const j=l(I);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.g.get(j.controllerId);if(!z)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:I.include?.map(O=>o.$BL.fromExtHostTestItem(O,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:y[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:I.exclude?.map(O=>O.id)},F)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,F){return(await this.j.getCoverageDetails(I,F))?.map(a.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,F){this.g.get(I)?.profiles.get(F)?.configureHandler?.()}$setDefaultRunProfiles(I){const F=new Map;for(const[j,z]of Object.entries(I)){const O=this.g.get(j);if(!O)continue;const T=new Map,B=z.filter(Z=>!O.activeProfiles.has(Z)),W=[...O.activeProfiles].filter(Z=>!z.includes(Z));for(const Z of B)T.set(Z,!0),O.activeProfiles.add(Z);for(const Z of W)T.set(Z,!1),O.activeProfiles.delete(Z);T.size&&F.set(j,T)}this.s.fire(F)}async $refreshTests(I,F){await this.g.get(I)?.controller.refreshHandler?.(F)}$publishTestResults(I){this.results=Object.freeze(I.map(a.TestResults.to).concat(this.results).sort((F,j)=>j.completedAt-F.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,F){const j=this.g.get(o.$BL.fromString(I).controllerId)?.collection;j&&(await j.expand(I,F<0?1/0:F),j.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(F=>i.TestsDiffOp.deserialize({asCanonicalUri:j=>j},F)))}async $runControllerTests(I,F){return Promise.all(I.map(j=>this.y(j,!1,F)))}async $startContinuousRun(I,F){const j=new L.$me(F),z=await Promise.all(I.map(O=>this.y(O,!0,j.token)));return!F.isCancellationRequested&&!z.some(O=>O.error)&&await new Promise(O=>F.onCancellationRequested(O)),j.dispose(!0),z}async y(I,F,j){const z=this.g.get(I.controllerId);if(!z)return{};const{collection:O,profiles:T}=z,B=T.get(I.profileId);if(!B)return{};const W=I.testIds.map(Y=>O.tree.get(Y)).filter(S.$_f),Z=I.excludeExtIds.map(Y=>z.collection.tree.get(Y)).filter(S.$_f).filter(Y=>W.some(ce=>ce.fullId.compare(Y.fullId)===2));if(!W.length)return{};const x=new m.$rO(W.some(Y=>Y.actual instanceof v.$oP)?void 0:W.map(Y=>Y.actual),Z.map(Y=>Y.actual),B,F),X=(0,i.$EL)(I)&&this.j.prepareForMainThreadTestRun(x,c.fromInternal(I,z.collection),B,j);try{return await B.runHandler(x,j),{}}catch(Y){return{error:String(Y)}}finally{X&&X.hasRunningTasks&&!j.isCancellationRequested&&await R.Event.toPromise(X.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$Vlc=r,e.$Vlc=r=Je([qe(0,E.$aP),qe(1,P.$Wj)],r);const s=1e4;var t;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(t||(t={}));class f extends b.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,F,j,z,O){super(),this.y=I,this.z=F,this.C=j,this.D=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$be),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new L.$me(O));const T=this.B(new u.$Ch(()=>this.F(),s));this.B(this.j.token.onCancellationRequested(()=>T.schedule()));const B=new R.$be;this.s=B.event,this.B((0,b.$Sc)(()=>{B.fire(),B.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,F){const[,j,z]=o.$BL.fromString(I).path,O=this.w.get(z);if(!O)return[];const T=this.g.get(j);if(!T)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(T.run,O,F)??[]}createRun(I){const F=this.y.id,j=this.y.controllerId,z=(0,A.$Mg)(),O=Z=>(x,...X)=>{if(B){this.C.warn(`Setting the state of test "${x.id}" is a no-op after the run ends.`);return}this.y.isIncluded(x)&&(this.H(x),Z(x,...X))},T=(Z,x)=>{const X=x instanceof Array?x.map(a.TestMessage.from):[a.TestMessage.from(x)];if(Z.uri&&Z.range){const Y={range:a.Range.from(Z.range),uri:Z.uri};for(const ce of X)ce.location=ce.location||Y}this.z.$appendTestMessagesInRun(F,z,o.$BL.fromExtHostTestItem(Z,j).toString(),X)};let B=!1;const W={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:Z=>{const x=Z.uri.toString(),X=new o.$BL([F,z,x]).toString();this.w.set(x,Z),this.z.$appendCoverage(F,z,a.TestCoverage.fromFile(X,Z))},enqueued:O(Z=>{this.z.$updateTestStateInRun(F,z,o.$BL.fromExtHostTestItem(Z,j).toString(),1)}),skipped:O(Z=>{this.z.$updateTestStateInRun(F,z,o.$BL.fromExtHostTestItem(Z,j).toString(),5)}),started:O(Z=>{this.z.$updateTestStateInRun(F,z,o.$BL.fromExtHostTestItem(Z,j).toString(),2)}),errored:O((Z,x,X)=>{T(Z,x),this.z.$updateTestStateInRun(F,z,o.$BL.fromExtHostTestItem(Z,j).toString(),6,X)}),failed:O((Z,x,X)=>{T(Z,x),this.z.$updateTestStateInRun(F,z,o.$BL.fromExtHostTestItem(Z,j).toString(),4,X)}),passed:O((Z,x)=>{this.z.$updateTestStateInRun(F,z,o.$BL.fromExtHostTestItem(Z,this.y.controllerId).toString(),3,x)}),appendOutput:(Z,x,X)=>{B||(X&&(this.y.isIncluded(X)?this.H(X):X=void 0),this.z.$appendOutputToRun(F,z,N.$Ce.fromString(Z),x&&a.location.from(x),X&&o.$BL.fromExtHostTestItem(X,j).toString()))},end:()=>{B||(B=!0,this.z.$finishedTestRunTask(F,z),--this.f||this.G())}};return this.f++,this.g.set(z,{run:W}),this.z.$startedTestRunTask(F,{id:z,name:I,running:!0}),W}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof v.$nP))throw new n.$5O(I.id);if(this.h.has(o.$BL.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const F=[],j=this.y.colllection.root;for(;;){const z=a.TestItem.from(I);if(F.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),I===j))break;I=I.parent||j}this.z.$addTestsToRun(this.y.controllerId,this.y.id,F)}dispose(){this.G(),super.dispose()}}class d{get trackers(){return this.c.values()}constructor(I,F){this.g=I,this.h=F,this.c=new Map,this.f=new Map}getCoverageDetails(I,F){const j=o.$BL.root(I);return this.f.get(j)?.getCoverageDetails(I,F)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[F,{id:j}]of this.c)j===I&&this.c.delete(F)}prepareForMainThreadTestRun(I,F,j,z){return this.j(I,F,j,z)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,F,j,z,O){const T=this.c.get(j);if(T)return T.createRun(z);const B=c.fromPublic(I,F,j,O),W=l(j);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!j.continuous,profile:W&&{group:y[W.kind],id:W.profileId},exclude:j.exclude?.map(x=>o.$BL.fromExtHostTestItem(x,F.root.id).toString())??[],id:B.id,include:j.include?.map(x=>o.$BL.fromExtHostTestItem(x,F.root.id).toString())??[F.root.id],persist:O});const Z=this.j(j,B,j.profile);return R.Event.once(Z.onEnd)(()=>{this.g.$finishedExtensionTestRun(B.id)}),Z.createRun(z)}j(I,F,j,z){const O=new f(F,this.g,this.h,j,z);return this.c.set(I,O),this.f.set(O.id,O),O}}e.$Wlc=d;const l=C=>{if(C.profile){if(!(C.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class c{static fromPublic(I,F,j,z){return new c(I,(0,A.$Mg)(),j.include?.map(O=>o.$BL.fromExtHostTestItem(O,I).toString())??[I],j.exclude?.map(O=>o.$BL.fromExtHostTestItem(O,I).toString())??[],z,F)}static fromInternal(I,F){return new c(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,F)}constructor(I,F,j,z,O,T){this.controllerId=I,this.id=F,this.isPersisted=O,this.colllection=T,this.c=j.map(B=>B+"\0"),this.f=z.map(B=>B+"\0")}isIncluded(I){const F=o.$BL.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const j of this.f)if(F===j||F.startsWith(j))return!1;for(const j of this.c)if(F===j||F.startsWith(j))return!0;return!1}}e.$Xlc=c;class h{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,a.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const F=o.$BL.parentId(I.item.extId);if(F&&this.h.has(F.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:F,g:j}=this;return{get added(){return[...I].map(z=>z.revived)},get updated(){return[...F].map(z=>z.revived)},get removed(){return[...j].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class g extends i.$KL{constructor(){super(...arguments),this.s=new R.$be,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,F){return{...I,revived:a.TestItem.toPlain(I.item),depth:F?F.depth+1:0,children:new Set}}v(){return new h(this.s)}}class D{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(F=>F.revived)},dispose:(0,M.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new g({asCanonicalUri:F=>F});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const w=(C,I,F,j)=>{F?Object.assign(F,j):I.$updateTestRunConfig(C.controllerId,C.profileId,j)};class k{#e;#t;#i;#n;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,w(this,this.#e,this.#n,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,w(this,this.#e,this.#n,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),w(this,this.#e,this.#n,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,w(this,this.#e,this.#n,{tag:I?a.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,w(this,this.#e,this.#n,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return R.Event.chain(this.#i,I=>I.map(F=>F.get(this.controllerId)?.get(this.profileId)).filter(S.$_f))}constructor(I,F,j,z,O,T,B,W,Z,x=!1,X=void 0,Y=!1){this.controllerId=O,this.profileId=T,this.f=B,this.kind=W,this.runHandler=Z,this._tag=X,this.g=Y,this.#e=I,this.#s=F,this.#t=j,this.#i=z,F.set(T,this);const ce=y[W];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${W}`);x&&j.add(T),this.#n={profileId:T,controllerId:O,tag:X?a.TestTag.namespace(this.controllerId,X.id):null,label:B,group:ce,isDefault:x,hasConfigurationHandler:!1,supportsContinuousRun:Y},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Ylc=k;const y={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(ke[156],Ee([1,0,62,13,124,16,8]),function(le,e,u,N,L,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jP=e.$iP=e.$hP=void 0;class p{static{this.c=new L.$fP("TextEditorDecorationType")}constructor($,E,v){const a=p.c.nextId();$.$registerTextEditorDecorationType(E.identifier,a,R.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:a,dispose(){$.$removeTextEditorDecorationType(a)}})}}e.$hP=p;class b{constructor($,E){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,E){this.k();let v=null;if($ instanceof M.$SM)v=new M.$TM($,$);else if($ instanceof M.$TM)v=$;else throw new Error("Unrecognized location");this.l(v,E,!1)}insert($,E){this.k(),this.l(new M.$TM($,$),E,!0)}delete($){this.k();let E=null;if($ instanceof M.$TM)E=$;else throw new Error("Unrecognized location");this.l(E,null,!0)}l($,E,v){const a=this.c.validateRange($);this.g.push({range:a,text:E,forceMoveMarkers:v})}setEndOfLine($){if(this.k(),$!==M.EndOfLine.LF&&$!==M.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=$}}class S{constructor($,E,v,a){this.c=$,this.d=E,this._accept(v),this.e=a;const m=this;this.value={get tabSize(){return m.f},set tabSize(o){m.n(o)},get indentSize(){return m.g},set indentSize(o){m.p(o)},get insertSpaces(){return m.j},set insertSpaces(o){m.s(o)},get cursorStyle(){return m.k},set cursorStyle(o){m.t(o)},get lineNumbers(){return m.l},set lineNumbers(o){m.u(o)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.originalIndentSize,this.j=$.insertSpaces,this.k=$.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to($.lineNumbers)}m($){if($==="auto")return"auto";if(typeof $=="number"){const E=Math.floor($);return E>0?E:null}if(typeof $=="string"){const E=parseInt($,10);return isNaN(E)?null:E>0?E:null}return null}n($){const E=this.m($);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const E=Math.floor($);return E>0?E:null}if(typeof $=="string"){const E=parseInt($,10);return isNaN(E)?null:E>0?E:null}return null}p($){const E=this.o($);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q($){return $==="auto"?"auto":$==="false"?!1:!!$}s($){const E=this.q($);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t($){this.k!==$&&(this.k=$,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}u($){this.l!==$&&(this.l=$,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from($)})))}assign($){const E={};let v=!1;if(typeof $.tabSize<"u"){const a=this.m($.tabSize);a==="auto"?(v=!0,E.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,v=!0,E.tabSize=a)}if(typeof $.indentSize<"u"){const a=this.o($.indentSize);a==="tabSize"?(v=!0,E.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,v=!0,E.indentSize=a)}if(typeof $.insertSpaces<"u"){const a=this.q($.insertSpaces);a==="auto"?(v=!0,E.insertSpaces=a):this.j!==a&&(this.j=a,v=!0,E.insertSpaces=a)}typeof $.cursorStyle<"u"&&this.k!==$.cursorStyle&&(this.k=$.cursorStyle,v=!0,E.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.l!==$.lineNumbers&&(this.l=$.lineNumbers,v=!0,E.lineNumbers=R.TextEditorLineNumbersStyle.from($.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v($,E){E.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(v)})}}e.$iP=S;class A{constructor($,E,v,a,m,o,n,i){this.id=$,this.j=E,this.k=v,this.g=!1,this.h=new Set,this.c=m,this.d=new S(this.j,this.id,o,v),this.e=n,this.f=i;const r=this;this.value=Object.freeze({get document(){return a.value},set document(s){throw new N.$9("document")},get selection(){return r.c&&r.c[0]},set selection(s){if(!(s instanceof M.$UM))throw(0,N.$7)("selection");r.c=[s],r.l()},get selections(){return r.c},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof M.$UM)))throw(0,N.$7)("selections");r.c=s,r.l()},get visibleRanges(){return r.e},set visibleRanges(s){throw new N.$9("visibleRanges")},get options(){return r.d.value},set options(s){r.g||r.d.assign(s)},get viewColumn(){return r.f},set viewColumn(s){throw new N.$9("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new b(a.value,t);return s(f),r.m(f)},insertSnippet(s,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=r.c.map(l=>R.Range.from(l));else if(t instanceof M.$SM){const{lineNumber:l,column:c}=R.Position.from(t);d=[{startLineNumber:l,startColumn:c,endLineNumber:l,endColumn:c}]}else if(t instanceof M.$TM)d=[R.Range.from(t)];else{d=[];for(const l of t)if(l instanceof M.$TM)d.push(R.Range.from(l));else{const{lineNumber:c,column:h}=R.Position.from(l);d.push({startLineNumber:c,startColumn:h,endLineNumber:c,endColumn:h})}}return E.$tryInsertSnippet($,a.value.version,s.value,d,f)},setDecorations(s,t){const f=t.length===0;f&&!r.h.has(s.key)||(f?r.h.delete(s.key):r.h.add(s.key),r.n(()=>{if(R.$0O(t))return E.$trySetDecorations($,s.key,R.$$O(t));{const d=new Array(4*t.length);for(let l=0,c=t.length;l<c;l++){const h=t[l];d[4*l]=h.start.line+1,d[4*l+1]=h.start.character+1,d[4*l+2]=h.end.line+1,d[4*l+3]=h.end.character+1}return E.$trySetDecorationsFast($,s.key,d)}}))},revealRange(s,t){r.n(()=>E.$tryRevealRange($,R.Range.from(s),t||M.TextEditorRevealType.Default))},show(s){E.$tryShowEditor($,R.ViewColumn.from(s))},hide(){E.$tryHideEditor($)}})}dispose(){(0,u.ok)(!this.g),this.g=!0}_acceptOptions($){(0,u.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,u.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,u.ok)(!this.g),this.f=$}_acceptSelections($){(0,u.ok)(!this.g),this.c=$}async l(){const $=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const E=$.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const v=E.edits.map(m=>m.range);v.sort((m,o)=>m.end.line===o.end.line?m.end.character===o.end.character?m.start.line===o.start.line?m.start.character-o.start.character:m.start.line-o.start.line:m.end.character-o.end.character:m.end.line-o.end.line);for(let m=0,o=v.length-1;m<o;m++){const n=v[m].end;if(v[m+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=E.edits.map(m=>({range:R.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,a,{setEndOfLine:typeof E.setEndOfLine=="number"?R.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$jP=A}),define(ke[72],Ee([1,0,62,4,3,2,5,6,152,20,156,16,12,27,15,45,46]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=e.$kP=void 0;class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(r,s){this.h=r,this.i=s,this.a=null,this.b=new Map,this.c=new E.$Bc,this.d=new N.$be,this.e=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const s=[],t=[],f=[];if(r.removedDocuments)for(const d of r.removedDocuments){const l=R.URI.revive(d),c=this.c.get(l);c?.unref()&&(this.c.delete(l),s.push(c.value))}if(r.addedDocuments)for(const d of r.addedDocuments){const l=R.URI.revive(d.uri);let c=this.c.get(l);if(c&&l.scheme!==v.Schemas.vscodeNotebookCell&&l.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);c||(c=new o(new b.$dP(this.h.getProxy(p.$PM.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,c),t.push(c.value)),c.ref()}if(r.removedEditors)for(const d of r.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&f.push(l)}if(r.addedEditors)for(const d of r.addedEditors){const l=R.URI.revive(d.documentUri);u.ok(this.c.has(l),`document '${l}' does not exist`),u.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const c=this.c.get(l).value,h=new A.$jP(d.id,this.h.getProxy(p.$PM.MainThreadTextEditors),this.i,new m.$V(()=>c.document),d.selections.map(P.Selection.to),d.options,d.visibleRanges.map(g=>P.Range.to(g)),typeof d.editorPosition=="number"?P.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}r.newActiveEditor!==void 0&&(u.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,L.$Pc)(s),(0,L.$Pc)(f),r.removedDocuments&&this.e.fire(s),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return a.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const s=this.b.get(this.a);return r?s:s?.value}allEditors(){return[...this.b.values()]}};e.$kP=n,e.$kP=n=Je([qe(0,S.$aP),qe(1,$.$Wj)],n),e.$lP=(0,M.$qi)("IExtHostDocumentsAndEditors")}),define(ke[355],Ee([1,0,19,4,6,156,16,8]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;class b{constructor(A,P){this.i=P,this.a=new N.$be,this.b=new N.$be,this.c=new N.$be,this.d=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(L.$PM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors($=>this.g.fire($)),this.i.onDidChangeActiveTextEditor($=>this.f.fire($))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const P=this.i.allEditors();return A?P:P.map($=>$.value)}async showTextDocument(A,P,$){let E;typeof P=="number"?E={position:M.ViewColumn.from(P),preserveFocus:$}:typeof P=="object"?E={position:M.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?M.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:E={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(A.uri,E),a=v&&this.i.getEditor(v);if(a)return a.value;throw v?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,P){return new R.$hP(this.h,A,P).value}$acceptEditorPropertiesChanged(A,P){const $=this.i.getEditor(A);if(!$)throw new Error("unknown text editor");if(P.options&&$._acceptOptions(P.options),P.selections){const E=P.selections.selections.map(M.Selection.to);$._acceptSelections(E)}if(P.visibleRanges){const E=u.$Hb(P.visibleRanges.map(M.Range.to));$._acceptVisibleRanges(E)}if(P.options&&this.b.fire({textEditor:$.value,options:{...P.options,lineNumbers:M.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const E=p.TextEditorSelectionChangeKind.fromValue(P.selections.source),v=P.selections.selections.map(M.Selection.to);this.a.fire({textEditor:$.value,selections:v,kind:E})}if(P.visibleRanges){const E=u.$Hb(P.visibleRanges.map(M.Range.to));this.c.fire({textEditor:$.value,visibleRanges:E})}}$acceptEditorPositionData(A){for(const P in A){const $=this.i.getEditor(P);if(!$)throw new Error("Unknown text editor");const E=M.ViewColumn.to(A[P]);$.value.viewColumn!==E&&($._acceptViewColumn(E),this.d.fire({textEditor:$.value,viewColumn:E}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$fkc=b}),define(ke[356],Ee([1,0,2,5,6,3,8,16,25,18]),function(le,e,u,N,L,R,M,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=e.$1lc=void 0,e.$1lc=(0,N.$qi)("IExtHostTimeline");class A{constructor(E,v){this.b=new Map,this.c=new Map,this.a=E.getProxy(L.$PM.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(a,m)=>{if(a&&a.$mid===12)if(this.b.get(a.source)&&b.$Lm.equals(m,this.b.get(a.source)?.extension)){const o=a.uri===void 0?void 0:u.URI.revive(a.uri);return this.c.get(a.source)?.get(P(o))?.get(a.handle)}else return;return a}})}async $getTimeline(E,v,a,m){return this.b.get(E)?.provider.provideTimeline(u.URI.revive(v),a,m)}registerTimelineProvider(E,v,a,m){const o=new R.$Tc,n=this.d(v.id,m,o).bind(this);let i;v.onDidChange&&(i=v.onDidChange(s=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:v.id}),this));const r=this.c;return this.f({...v,scheme:E,onDidChange:void 0,async provideTimeline(s,t,f){t?.resetCache&&(o.clear(),r.get(v.id)?.clear());const d=await v.provideTimeline(s,t,f);if(d==null)return;const l=n(s,t);return{...d,source:v.id,items:d.items.map(l)}},dispose(){for(const s of r.values())s.get(v.id)?.clear();i?.dispose(),o.dispose()}},a)}d(E,v,a){return(m,o)=>{let n;if(o?.cacheResults){let i=this.c.get(E);i===void 0&&(i=new Map,this.c.set(E,i));const r=P(m);n=i.get(r),n===void 0&&(n=new Map,i.set(r,n))}return i=>{const{iconPath:r,...s}=i,t=`${E}|${i.id??i.timestamp}`;n?.set(t,i);let f,d,l;i.iconPath&&(r instanceof M.$NN?l={id:r.id,color:r.color}:u.URI.isUri(r)?(f=r,d=r):{light:f,dark:d}=r);let c;return M.$gN.isMarkdownString(s.tooltip)?c=p.MarkdownString.from(s.tooltip):(0,S.$4f)(s.tooltip)?c=s.tooltip:M.$gN.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=p.MarkdownString.from(s.detail)):(0,S.$4f)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=s.detail),{...s,id:s.id??void 0,handle:t,source:E,command:i.command?v.toInternal(i.command,a):void 0,icon:f,iconDark:d,themeIcon:l,tooltip:c,accessibilityInformation:i.accessibilityInformation}}}}f(E,v){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:v}),(0,R.$Sc)(()=>{for(const m of this.c.values())m.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.$2lc=A;function P($){return $?.toString()}}),define(ke[357],Ee([1,0,228,23,2,4,3,289,7,8,18,19,16,80,22,184,26]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=void 0;function o(r,s){if((0,A.$4f)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class n extends M.$Uc{constructor(s,t,f){super(),this.f=s,this.g=t,this.h=f,this.a=new Map,this.b=new a.$M0;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(c=>d(c)?this.r(c):c):l})}registerTreeDataProvider(s,t,f){const d=this.createTreeView(s,{treeDataProvider:t},f);return{dispose:()=>d.dispose()}}createTreeView(s,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,g=this.m(s,t,f),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:c,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(s,D),k={get onDidCollapseElement(){return g.onDidCollapseElement},get onDidExpandElement(){return g.onDidExpandElement},get selection(){return g.selectedElements},get onDidChangeSelection(){return g.onDidChangeSelection},get activeItem(){return(0,m.$yG)(f,"treeViewActiveItem"),g.focusedElement},get onDidChangeActiveItem(){return(0,m.$yG)(f,"treeViewActiveItem"),g.onDidChangeActiveItem},get visible(){return g.visible},get onDidChangeVisibility(){return g.onDidChangeVisibility},get onDidChangeCheckboxState(){return g.onDidChangeCheckboxState},get message(){return g.message},set message(y){(0,E.$Pk)(y)&&(0,m.$yG)(f,"treeViewMarkdownMessage"),g.message=y},get title(){return g.title},set title(y){g.title=y},get description(){return g.description},set description(y){g.description=y},get badge(){return g.badge},set badge(y){y!==void 0&&S.ViewBadge.isViewBadge(y)?g.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(g.badge=void 0)},reveal:(y,C)=>g.reveal(y,C),dispose:async()=>{await w,this.a.delete(s),g.dispose()}};return this.B(k),k}$getChildren(s,t){const f=this.a.get(s);return f?f.getChildren(t):Promise.reject(new p.$NF(s))}async $handleDrop(s,t,f,d,l,c,h,g){const D=this.a.get(s);if(!D)return Promise.reject(new p.$NF(s));const w=$.DataTransfer.toDataTransfer(f,async k=>(await this.f.$resolveDropFileData(s,t,k)).buffer);return h===s&&g&&await this.j(w,D,g,l,c),D.onDrop(w,d,l)}async j(s,t,f,d,l){const c=this.b.removeDragOperationTransfer(l);if(c)(await c)?.forEach((h,g)=>{h&&s.set(g,h)});else if(l&&t.handleDrag){const h=t.handleDrag(f,s,d);this.b.addDragOperationTransfer(l,h),await h}return s}async $handleDrag(s,t,f,d){const l=this.a.get(s);if(!l)return Promise.reject(new p.$NF(s));const c=await this.j(new S.$JN,l,t,d,f);if(!(!c||d.isCancellationRequested))return $.DataTransfer.from(c)}async $hasResolve(s){const t=this.a.get(s);if(!t)throw new p.$NF(s);return t.hasResolve}$resolve(s,t,f){const d=this.a.get(s);if(!d)throw new p.$NF(s);return d.resolveTreeItem(t,f)}$setExpanded(s,t,f){const d=this.a.get(s);if(!d)throw new p.$NF(s);d.setExpanded(t,f)}$setSelectionAndFocus(s,t,f){const d=this.a.get(s);if(!d)throw new p.$NF(s);d.setSelectionAndFocus(t,f)}$setVisible(s,t){const f=this.a.get(s);if(!f){if(!t)return;throw new p.$NF(s)}f.setVisible(t)}$changeCheckboxState(s,t){const f=this.a.get(s);if(!f)throw new p.$NF(s);f.setCheckboxState(t)}m(s,t,f){const d=this.B(new i(s,t,this.f,this.g.converter,this.h,f));return this.a.set(s,d),d}r(s){const t=this.a.get(s.$treeViewId);return t&&"$treeItemHandle"in s?t.getExtensionElement(s.$treeItemHandle):t&&"$focusedTreeItem"in s&&s.$focusedTreeItem?t.focusedElement:null}}e.$3lc=n;class i extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(s=>this.getExtensionElement(s)).filter(s=>!(0,A.$ag)(s))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(s,t,f,d,l,c){if(super(),this.I=s,this.J=f,this.L=d,this.M=l,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$be),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$be),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$be),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$be),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$be),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$be),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$be),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$me,c.contributes&&c.contributes.views)for(const w in c.contributes.views)for(const k of c.contributes.views[w])k.id===s&&(this.P=k.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>this.F.fire({message:!1,element:w})));let h,g;const D=R.Event.debounce(this.F.event,(w,k)=>(w||(w={message:!1,elements:[]}),k.element!==!1&&(h||(h=new Promise(y=>g=y),this.G=this.G.then(()=>h)),Array.isArray(k.element)?w.elements.push(...k.element):w.elements.push(k.element)),k.message&&(w.message=!0),w),200,!0);this.B(D(({message:w,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const y=g;return h=null,this.$(k).then(()=>y())})),w&&this.J.$setMessage(this.I,$.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(s){const t=s?this.getExtensionElement(s):void 0;if(s&&!t)return this.M.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let f=this.X(s);return f||(f=await this.Y(t)),f?f.map(d=>d.item):void 0}getExtensionElement(s){return this.j.get(s)}reveal(s,t){t=t||{select:!0,focus:!1};const f=(0,A.$ag)(t.select)?!0:t.select,d=(0,A.$ag)(t.focus)?!1:t.focus,l=(0,A.$ag)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.G.then(()=>this.S(s)).then(c=>this.W(s,c[c.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:c.map(g=>g.item)},{select:f,focus:d,expand:l})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:f,focus:d,expand:l})}get message(){return this.O}set message(s){this.O=s,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(s){this.P=s,this.J.$setTitle(this.I,s,this.Q)}get description(){return this.Q}set description(s){this.Q=s,this.J.$setTitle(this.I,this.P,s)}get badge(){return this.R}set badge(s){this.R?.value===s?.value&&this.R?.tooltip===s?.tooltip||(this.R=$.ViewBadge.from(s),this.J.$setBadge(this.I,s))}setExpanded(s,t){const f=this.getExtensionElement(s);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(s,t){const f=!(0,P.$ub)(this.s,s);this.s=s;const d=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(s){s!==this.r&&(this.r=s,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(s){const t=(await Promise.all(s.map(async f=>{const d=this.getExtensionElement(f.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:f.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(s,t,f){const d=[];for(const l of s){const c=this.getExtensionElement(l);c&&d.push(c)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(s,t,f){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,b.$ih)(()=>this.g?.handleDrop?this.g.handleDrop(d,s,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(s,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(s);if(f){const d=this.m.get(f);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,f,t)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(s){return this.U(s).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(d=>(f.push(d),f))):Promise.resolve([]))}U(s){const t=this.m.get(s);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,b.$ih)(()=>this.f.getParent(s))}W(s,t){const f=this.m.get(s);return f?Promise.resolve(f):(0,b.$ih)(()=>this.f.getTreeItem(s)).then(d=>this.kb(s,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const c=this.m.get(l);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(s){if(s){let t;if(typeof s=="string"){const f=this.getExtensionElement(s);t=f?this.m.get(f):void 0}else t=s;return t&&t.children||void 0}return this.h}async Y(s){this.rb(s);const t=new v.$me(this.Z.token);try{const f=s?this.m.get(s):void 0,d=await this.f.getChildren(s);if(t.token.isCancellationRequested)return;const l=(0,P.$Hb)(d||[]),c=await Promise.all((0,P.$Hb)(l).map(g=>this.f.getTreeItem(g)));if(t.token.isCancellationRequested)return;const h=c.map((g,D)=>g?this.db(l[D],g,f):null);return(0,P.$Hb)(h)}finally{t.dispose()}}$(s){if(s.some(f=>!f))return this.Z.dispose(!0),this.Z=new v.$me,this.tb(),this.J.$refresh(this.I);{const f=this.ab(s);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(s){const t=new Set,f=s.map(l=>this.m.get(l));for(const l of f)if(l&&!t.has(l.item.handle)){let c=l;for(;c&&c.parent&&f.findIndex(h=>c&&c.parent&&h&&h.item.handle===c.parent.item.handle)===-1;){const h=this.j.get(c.parent.item.handle);c=h?this.m.get(h):void 0}c&&!c.parent&&t.add(l.item.handle)}const d=[];return t.forEach(l=>{const c=this.j.get(l);if(c){const h=this.m.get(c);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(l)}}),d}bb(s){const t={};return Promise.all(s.map(f=>this.cb(f).then(d=>{d&&(t[f]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(s){const t=this.getExtensionElement(s);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,b.$ih)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const l=this.ib(t,d,f.parent);return this.pb(t,l,f,f.parent),f.dispose(),l}return null})}return Promise.resolve(null)}db(s,t,f){const d=this.ib(s,t,f);if(t.id&&this.j.has(d.item.handle))throw new Error((0,u.localize)(0,null,t.id));return this.ob(s,d),this.qb(d,f),d}eb(s){return S.$gN.isMarkdownString(s)?$.MarkdownString.from(s):s}fb(s,t){return t?{...this.L.toInternal(t,s),originalId:t.command}:void 0}gb(s){if(s.checkboxState===void 0)return;let t,f,d;return typeof s.checkboxState=="number"?t=s.checkboxState:(t=s.checkboxState.state,f=s.checkboxState.tooltip,d=s.checkboxState.accessibilityInformation),{isChecked:t===S.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:d}}hb(s){if(!S.$EN.isTreeItem(s,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(s,t,f){this.hb(t);const d=this.B(new M.$Tc),l=this.kb(s,t,f),c=this.lb(t);return{item:{handle:l,parentHandle:f?f.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,A.$ag)(t.collapsibleState)?S.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(s){return s.iconPath instanceof S.$NN?s.iconPath:void 0}kb(s,{id:t,label:f,resourceUri:d},l,c){if(t)return`${i.b}/${t}`;const h=o(f,this.N),g=l?l.item.handle:i.a;let D=h?h.label:d?(0,N.$1g)(d):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const w=this.m.has(s)?this.m.get(s).item.handle:void 0,k=this.X(l)||[];let y,C=0;do{if(y=`${g}/${C}:${D}`,c||!this.j.has(y)||w===y)break;C++}while(C<=k.length);return y}lb(s){if(s.iconPath&&!(s.iconPath instanceof S.$NN))return typeof s.iconPath=="string"||L.URI.isUri(s.iconPath)?this.nb(s.iconPath):this.nb(s.iconPath.light)}mb(s){if(s.iconPath&&!(s.iconPath instanceof S.$NN)&&s.iconPath.dark)return this.nb(s.iconPath.dark)}nb(s){return L.URI.isUri(s)?s:L.URI.file(s)}ob(s,t){this.j.set(t.item.handle,s),this.m.set(s,t)}pb(s,t,f,d){this.j.delete(t.item.handle),this.m.delete(s),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(s,t);const l=this.X(d)||[],c=l.filter(h=>h.item.handle===f.item.handle)[0];c&&l.splice(l.indexOf(c),1,t)}qb(s,t){t?(t.children||(t.children=[]),t.children.push(s)):(this.h||(this.h=[]),this.h.push(s))}rb(s){if(s){const t=this.m.get(s);if(t){if(t.children)for(const f of t.children){const d=this.j.get(f.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(s){const t=this.m.get(s);if(t){if(t.children)for(const f of t.children){const d=this.j.get(f.item.handle);d&&this.sb(d)}this.m.delete(s),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(s=>s.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[358],Ee([1,0,4,3,2,30,16,92,6,8]),function(le,e,u,N,L,R,M,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=void 0;class A extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(v,a,m,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new u.$be),this.onDidDispose=this.#d.event,this.#h=this.B(new u.$be),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=a,this.#n=m,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,L.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:M.ViewColumn.from(v),preserveFocus:!!a})}c(){if(this.#l)throw new Error("Webview is disposed")}}class P extends N.$Uc{static c(){return(0,R.$Mg)()}constructor(v,a,m){super(),this.j=a,this.m=m,this.g=new Map,this.h=new Map,this.f=v.getProxy(b.$PM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,a,m,o,n={}){const i=typeof o=="object"?o.viewColumn:o,r={viewColumn:M.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},s=(0,p.$ukc)(v),t=P.c();this.f.$createWebviewPanel((0,p.$wkc)(v),t,a,{title:m,panelOptions:$(n),webviewOptions:(0,p.$xkc)(v,this.m,n),serializeBuffersForPostMessage:s},r);const f=this.j.createNewWebview(t,n,v);return this.createNewWebviewPanel(t,a,m,i,n,f,!0)}$onDidChangeWebviewPanelViewStates(v){const a=Object.keys(v);a.sort((m,o)=>{const n=v[m],i=v[o];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const m of a){const o=this.getWebviewPanel(m);if(!o)continue;const n=v[m];o._updateViewState({active:n.active,visible:n.visible,viewColumn:M.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,a,m){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:m,extension:v}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,p.$ukc)(v)}),new S.$RM(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(v,a,m,o){const n=this.h.get(a);if(!n)throw new Error(`No serializer found for '${a}'`);const{serializer:i,extension:r}=n,s=this.j.createNewWebview(v,m.webviewOptions,r),t=this.createNewWebviewPanel(v,a,m.title,o,m.panelOptions,s,m.active);await i.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(v,a,m,o,n,i,r){const s=new A(v,this.f,i,{viewType:a,title:m,viewColumn:o,panelOptions:n,active:r});return this.g.set(v,s),s}getWebviewPanel(v){return this.g.get(v)}}e.$ykc=P;function $(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(ke[359],Ee([1,0,4,3,92,16,6,8]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class b extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(P,$,E,v,a,m){super(),this.#s=!1,this.#u=this.B(new u.$be),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new u.$be),this.onDidDispose=this.#l.event,this.#i=E,this.#a=v,this.#e=P,this.#t=$,this.#n=a,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(P){this.a(),this.#a!==P&&(this.#a=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.a(),this.#o}set description(P){this.a(),this.#o!==P&&(this.#o=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(P){P===this.#r||this.#s||(this.#r=P,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(P){this.a(),!(P?.value===this.#c?.value&&P?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.a(),this.#t.$show(this.#e,!!P)}a(){if(this.#s)throw new Error("Webview is disposed")}}class S{constructor(P,$){this.d=$,this.b=new Map,this.c=new Map,this.a=P.getProxy(M.$PM.MainThreadWebviewViews)}registerWebviewViewProvider(P,$,E,v){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:E,extension:P}),this.a.$registerWebviewViewProvider((0,L.$wkc)(P),$,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.$ukc)(P)}),new p.$RM(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(P,$,E,v,a){const m=this.b.get($);if(!m)throw new Error(`No view provider found for '${$}'`);const{provider:o,extension:n}=m,i=this.d.createNewWebview(P,{},n),r=new b(P,this.a,$,E,i,!0);this.c.set(P,r),await o.resolveWebviewView(r,{state:v},a)}async $onDidChangeWebviewViewVisibility(P,$){this.e(P)._setVisible($)}async $disposeWebviewView(P){const $=this.e(P);this.c.delete(P),$.dispose(),this.d.deleteWebview(P)}e(P){const $=this.c.get(P);if(!$)throw new Error("No webview found");return $}}e.$6lc=S}),define(ke[360],Ee([1,0,69,15,12,260,32,11]),function(le,e,u,N,L,R,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=void 0;let b=class{constructor(P,$){P.addFileSystemProvider(N.Schemas.file,new S($),{isCaseSensitive:p.$k})}};e.$Kmc=b,e.$Kmc=b=Je([qe(0,u.$qkc),qe(1,L.$Wj)],b);class S{constructor(P){this.b=P,this.a=new R.$4q(this.b)}async stat(P){const $=await this.a.stat(P);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===M.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,$,E){return this.a.writeFile(P,$,{...E,unlock:!1,atomic:!1})}delete(P,$){return this.a.delete(P,{...$,useTrash:!1,atomic:!1})}rename(P,$,E){return this.a.rename(P,$,E)}copy(P,$,E){return this.a.copy(P,$,E)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,$){throw new Error("Method not implemented.")}}}),define(ke[361],Ee([1,0,17,64,30,33,3,6,2,20]),function(le,e,u,N,L,R,M,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;let A=class extends M.$Uc{constructor($,E){super();const v=$.getProxy(p.$PM.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async a=>{const m=b.URI.file((0,u.$kc)((0,N.tmpdir)(),(0,L.$Mg)()));return await v.$download(a,m),m})}};e.$Imc=A,e.$Imc=A=Je([qe(0,S.$aP),qe(1,R.$wP)],A)}),define(ke[362],Ee([1,0,52,17,2,93,3,15,7,31]),function(le,e,u,N,L,R,M,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=void 0;class A extends R.$skc{constructor(){super(...arguments),this.i=null}async g(t){const f=await super.g(t);if(f.scheme!==p.Schemas.file)return f;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const d=f.fsPath;let l=0;do{let c;l===0?c=d:c=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await P(c);const h=N.$kc(c,"vscode.lock"),g=await a(this.d,h,!1);if(g)return this.i=g,process.on("exit",()=>{g.dispose()}),L.URI.file(c);l++}while(l<10);return f}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Umc=A;async function P(s){try{await S.Promises.stat(s);return}catch{}try{await S.Promises.mkdir(s,{recursive:!0})}catch{}}const $=1e3,E=10*60*1e3;class v extends M.$Uc{constructor(t,f){super(),this.b=t,this.c=f,this.a=this.B(new b.$Bh),this.a.cancelAndSet(async()=>{const d=await m(t,f);(!d||d.pid!==process.pid)&&(t.info(`Lock '${f}': The lock was lost unexpectedly.`),this.a.cancel());try{await S.Promises.utimes(f,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${f}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{u.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+t};await S.Promises.writeFile(this.c,JSON.stringify(f),{flag:"w"})}catch(f){this.b.error(f)}}}async function a(s,t,f){try{const l={pid:process.pid,willReleaseAt:0};await S.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){s.error(l)}const d=await m(s,t);return!d||d.pid!==process.pid?f?(s.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(s,t)):(s.info(`Lock '${t}': Lock acquired.`),new v(s,t))}async function m(s,t){let f;try{f=await S.Promises.readFile(t)}catch(d){return s.error(d),null}try{return JSON.parse(String(f))}catch(d){return s.error(d),null}}async function o(s,t){let f;try{f=await S.Promises.stat(t)}catch(d){return s.error(d),0}return f.mtime.getTime()}function n(s){try{return process.kill(s,0),!0}catch{return!1}}async function i(s,t){const f=await m(s,t);if(!f)return s.info(`Lock '${t}': Could not read pid of lock holder.`),r(s,t);if(f.willReleaseAt){let g=f.willReleaseAt-Date.now();if(g<5e3){for(g>0?s.info(`Lock '${t}': The lockfile is scheduled to be released in ${g} ms.`):s.info(`Lock '${t}': The lockfile is scheduled to have been released.`);g>0;){if(await(0,b.$rh)(Math.min(100,g)),await o(s,t)===0)return r(s,t);g=f.willReleaseAt-Date.now()}return r(s,t)}}if(!n(f.pid))return s.info(`Lock '${t}': The pid ${f.pid} appears to be gone.`),r(s,t);const d=await o(s,t),l=Date.now()-d;if(l<=E)return s.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;s.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,b.$rh)(2e3);const c=await o(s,t),h=Date.now()-c;return h<=E?(s.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(s.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(s,t))}async function r(s,t){s.info(`Lock '${t}': Deleting a stale lock.`);try{await S.Promises.unlink(t)}catch{}return a(s,t,!0)}}),define(ke[363],Ee([1,0,30,20,42,33]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;let M=class extends L.$Okc{constructor(b,S){super(!0,b,S)}createTerminal(b,S,A){return this.createTerminalFromOptions({name:b,shellPath:S,shellArgs:A})}createTerminalFromOptions(b,S){const A=new L.$Nkc(this.a,(0,u.$Mg)(),b,b.name);return this.f.push(A),A.create(b,this.R(b,S)),A.value}};e.$dmc=M,e.$dmc=M=Je([qe(0,R.$wP),qe(1,N.$aP)],M)}),define(ke[364],Ee([1,0,4,38,37,5]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=e.OutputChannelUpdateMode=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=void 0,e.$XL="text/x-code-output",e.$YL="output",e.$ZL="Log",e.$1L="text/x-code-log-output",e.$2L="log",e.$3L="workbench.panel.output",e.$4L=new L.$Hj("inOutput",!1),e.$5L=new L.$Hj("activeLogOutput",!1),e.$6L=new L.$Hj("activeLogOutput.levelSettable",!1),e.$7L=new L.$Hj("activeLogOutput.level",""),e.$8L=new L.$Hj("activeLogOutput.levelIsDefault",!1),e.$9L=new L.$Hj("outputView.scrollLock",!1),e.$0L=(0,R.$qi)("outputService");var M;(function(b){b[b.Append=1]="Append",b[b.Replace=2]="Replace",b[b.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$$L={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new u.$be,this.onDidRegisterChannel=this.b.event,this.c=new u.$be,this.onDidRemoveChannel=this.c.event}registerChannel(S){this.a.has(S.id)||(this.a.set(S.id,S),this.b.fire(S.id))}getChannels(){const S=[];return this.a.forEach(A=>S.push(A)),S}getChannel(S){return this.a.get(S)}removeChannel(S){this.a.delete(S),this.c.fire(S)}}N.$9n.add(e.$$L.OutputChannels,new p),e.$_L=new L.$Hj("activeOutputChannel","")}),define(ke[157],Ee([1,0,6,5,20,25,12,364,69,28,60,189,21,18,32,4,3]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=e.$Elc=void 0;class o extends M.$3j{get disposed(){return this.n}constructor(s,t,f,d,l){super(),this.id=s,this.name=t,this.r=f,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,s)}replace(s){const t=this.m;this.info(s),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(s,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof s=="boolean"?s:t))}hide(){this.s.$close(this.id)}g(s,t){this.m+=$.$Ce.fromString(t).byteLength,(0,M.log)(this.r,s,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends o{appendLine(s){this.append(s)}}let i=class{constructor(s,t,f,d,l,c){this.i=t,this.j=f,this.k=d,this.l=l,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=s.getProxy(u.$PM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$Xm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.h=s;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(s,t,f){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,l=(0,E.$4f)(t)?t:void 0;if((0,E.$4f)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const h=this.i.environment.extensionLogLevel?.find(([D])=>R.$Lm.equals(f.identifier,D))?.[1];h&&(c=(0,M.$bk)(h));const g=d?this.o(s,c,f):this.n(s,l,f);return g.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),d?this.r(s,c??this.m.getLevel(),g):this.q(s,g)}async n(s,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(s,l,t,f.identifier.value);return new o(h,s,c,this.a,f)}async o(s,t,f){const d=await this.p(f),l=s.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(d,`${l}.log`),h=`${f.identifier.value}.${l}`,g=this.l.createLogger(c,{id:h,name:s,logLevel:t,extensionId:f.identifier.value});return new n(h,s,g,this.a,f)}p(s){let t=this.d.get(s.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,s.identifier.value);this.d.set(s.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(d){if((0,v.$al)(d)!==v.FileSystemProviderErrorCode.FileExists)throw d}return f})())}return t}q(s,t){let f=!1;const d=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return s},append(l){d(),t.then(c=>c.append(l))},appendLine(l){d(),t.then(c=>c.appendLine(l))},clear(){d(),t.then(l=>l.clear())},replace(l){d(),t.then(c=>c.replace(l))},show(l,c){d(),t.then(h=>h.show(l,c))},hide(){d(),t.then(l=>l.hide())},dispose(){f=!0,t.then(l=>l.dispose())}}}r(s,t,f){const d=new m.$Tc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},c=d.add(new a.$be);function h(g){t=g,c.fire(g)}return f.then(g=>{d.add(g),g.logLevel!==t&&h(g.logLevel),d.add(g.onDidChangeLogLevel(D=>h(D)))}),{...this.q(s,f),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(g,...D){l(),f.then(w=>w.trace(g,...D))},debug(g,...D){l(),f.then(w=>w.debug(g,...D))},info(g,...D){l(),f.then(w=>w.info(g,...D))},warn(g,...D){l(),f.then(w=>w.warn(g,...D))},error(g,...D){l(),f.then(w=>w.error(g,...D))},dispose(){d.dispose()}}}};e.$Elc=i,e.$Elc=i=Je([qe(0,L.$aP),qe(1,S.$qP),qe(2,b.$qkc),qe(3,A.$6jc),qe(4,M.$Xj),qe(5,M.$Wj)],i),e.$Flc=(0,N.$qi)("IExtHostOutputService")}),define(ke[158],Ee([1,0,5,7]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=void 0,e.$an=(0,u.$qi)("remoteAgentService"),e.$bn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let R=1/0;for(let p=0;p<this.maxSampleCount;p++){const b=await L.getRoundTripTime();if(b===void 0)return;R=Math.min(R,b/2),await(0,N.$rh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(R):M=this.initial.reduce((p,b)=>p+b,0)/this.initial.length,this.lastMeasurement={initial:M,current:R,average:this.average.reduce((p,b)=>p+b,0)/this.average.length,high:typeof M>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[365],Ee([1,0,232,85,38,41,54,3,4,158,11,24,7]),function(le,e,u,N,L,R,M,p,b,S,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=void 0,e.$qJ=Object.freeze({id:"application",order:100,title:(0,u.localize)(0,null),type:"object"}),e.$rJ=Object.freeze({id:"workbench",order:7,title:(0,u.localize)(1,null),type:"object"}),e.$sJ=Object.freeze({id:"security",scope:1,title:(0,u.localize)(2,null),type:"object",order:7}),e.$tJ=Object.freeze({id:"problems",title:(0,u.localize)(3,null),type:"object",order:101}),e.$uJ={ConfigurationMigration:"base.contributions.configuration.migration"};class E{constructor(){this.migrations=[],this.a=new b.$be,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const v=new E;L.$9n.add(e.$uJ.ConfigurationMigration,v);let a=class extends p.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const s of r.added)await this.f(s,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(r=>this.g(r,n?.uri))])}async g(n,i){const r=this.a.inspect(n.key,{resource:i}),s=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of s){const d=r[t];if(!d)continue;const l=[];if(d.value!==void 0){const c=await this.h(n,t,d.value,i,void 0);for(const h of c??[])l.push([h,[]])}for(const{identifiers:c,value:h}of d.overrides??[])if(h!==void 0){const g=await this.h(n,t,h,i,c);for(const D of g??[])l.push([D,c])}l.length&&await Promise.allSettled(l.map(async([[c,h],g])=>this.a.updateValue(c,h.value,{resource:i,overrideIdentifiers:g},f)))}}async h(n,i,r,s,t){const f=l=>{const h=this.a.inspect(l,{resource:s})[i];if(h)return t?h.overrides?.find(({identifiers:g})=>(0,P.$1n)(g,t))?.value:h.value},d=await n.migrateFn(r,f);return Array.isArray(d)?d:[[n.key,d]]}};e.$vJ=a,e.$vJ=a=Je([qe(0,M.$Wi),qe(1,R.$zi)],a);let m=class extends p.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new $.$Nh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;L.$9n.as(N.$bo.Configuration).registerConfiguration({...e.$sJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,u.localize)(4,null)},default:[],markdownDescription:(0,u.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,u.localize)(6,null),scope:2}}})}};e.$wJ=m,e.$wJ=m=Je([qe(0,S.$an)],m)}),define(ke[366],Ee([1,0,35,15,17,23,242,365,85,5,38]),function(le,e,u,N,L,R,M,p,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$kgb=e.$jgb=void 0,e.$lgb=a,e.$mgb=m,e.$jgb=(0,S.$qi)("editorResolverService"),e.$kgb="workbench.editorAssociations";const P=A.$9n.as(b.$bo.Configuration),$={...p.$rJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};P.registerConfiguration($);var E;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(E||(e.RegisteredEditorPriority=E={}));var v;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function a(o){switch(o){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function m(o,n){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(n.scheme))return!1;const s=typeof o=="string"&&o.indexOf(L.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,R.$1g)(n);return u.$jk(typeof o=="string"?o.toLowerCase():o,s.toLowerCase())}}),define(ke[367],Ee([1,0,34,15,17,11,23,2,5,278,41,147,158]),function(le,e,u,N,L,R,M,p,b,S,A,P,$){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0,e.$rM=(0,b.$qi)("pathService");let v=E=class{constructor(m,o,n,i){this.d=m,this.e=o,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??m})()}hasValidBasename(m,o,n){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(m,i,o)):this.h(m,o,n)}h(m,o,n){return m.scheme===N.Schemas.file||m.scheme===N.Schemas.vscodeRemote?(0,u.$og)(n??(0,M.$1g)(m),o===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,o){if(m.remoteAuthority)return N.Schemas.vscodeRemote;const n=(0,S.$oM)(o.getWorkspace());if(n)return n;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:N.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?L.$gc:L.$hc)}async fileURI(m){let o="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?(o=m.substring(2),m="/"):(o=m.substring(2,i),m=m.substring(i)||"/")}return p.URI.from({scheme:N.Schemas.file,authority:o,path:m,query:"",fragment:""})}};e.$sM=v,e.$sM=v=E=Je([qe(1,$.$an),qe(2,P.$aM),qe(3,A.$zi)],v)}),define(ke[368],Ee([1,0,244,19,55,4,56,3,2,54,249,12,66,280,88,41,147,26,22,18,24,37]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=e.OnPortForward=e.$fM=e.$eM=e.TunnelSource=e.TunnelCloseReason=e.$cM=e.$bM=void 0,e.$dM=c,e.$gM=D,e.$hM=w,e.$iM=k,e.$jM=C;const t=10*1e3,f="remote.tunnels.toRestore",d="remote.tunnels.toRestoreExpiration",l=1e3*60*60*24*14;e.$bM="onTunnel",e.$cM=new s.$Hj("forwardedPortsViewEnabled",!1,u.localize(0,null));function c(j){const z=j.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}var h;(function(j){j.Other="Other",j.User="User",j.AutoForwardEnd="AutoForwardEnd"})(h||(e.TunnelCloseReason=h={}));var g;(function(j){j[j.User=0]="User",j[j.Auto=1]="Auto",j[j.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.$eM={source:g.User,description:u.localize(1,null)},e.$fM={source:g.Auto,description:u.localize(2,null)};function D(j,z,O){const T=j.get(k(z,O));if(T)return T;if((0,v.$$v)(z))for(const B of v.$0v){const W=k(B,O);if(j.has(W))return j.get(W)}else if((0,v.$aw)(z))for(const B of v.$_v){const W=k(B,O);if(j.has(W))return j.get(W)}}function w(j,z,O){const T=D(j,z,O);if(T)return T;const B=(0,v.$aw)(z)?"localhost":(0,v.$$v)(z)?"0.0.0.0":void 0;if(B)return D(j,B,O)}function k(j,z){return j+":"+z}var y;(function(j){j.Notify="notify",j.OpenBrowser="openBrowser",j.OpenBrowserOnce="openBrowserOnce",j.OpenPreview="openPreview",j.Silent="silent",j.Ignore="ignore"})(y||(e.OnPortForward=y={}));function C(j){return j&&"host"in j&&typeof j.host=="string"&&"port"in j&&typeof j.port=="number"&&(!("detail"in j)||typeof j.detail=="string")&&(!("pid"in j)||typeof j.pid=="string")}class I extends p.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new R.$be,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(O=>{(O.affectsConfiguration(I.c)||O.affectsConfiguration(I.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,O,T){let B=this.w(z,O,T,this.j,0);const W={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;B>=0;){const Z=this.j[B];Z.key===z?(W.onAutoForward=Z.onAutoForward??W.onAutoForward,W.elevateIfNeeded=Z.elevateIfNeeded!==void 0?Z.elevateIfNeeded:W.elevateIfNeeded,W.label=Z.label??W.label,W.requireLocalPort=Z.requireLocalPort,W.protocol=Z.protocol):(W.onAutoForward=W.onAutoForward??Z.onAutoForward,W.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:Z.elevateIfNeeded,W.label=W.label??Z.label,W.requireLocalPort=W.requireLocalPort!==void 0?W.requireLocalPort:void 0,W.protocol=W.protocol??Z.protocol),B=this.w(z,O,T,this.j,B+1)}return W.onAutoForward!==void 0||W.elevateIfNeeded!==void 0||W.label!==void 0||W.requireLocalPort!==void 0||W.protocol!==void 0?W:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,i.$4f)(z.host)&&(0,i.$8f)(z.port)}w(z,O,T,B,W){if(W>=B.length)return-1;const Z=!(0,v.$$v)(O)&&!(0,v.$aw)(O),X=B.slice(W).findIndex(Y=>(0,i.$8f)(Y.key)?Z?!1:Y.key===z:this.t(Y.key)?Z?!1:z>=Y.key.start&&z<=Y.key.end:this.u(Y.key)?z===Y.key.port&&O===Y.key.host:T?Y.key.test(T):!1);return X>=0?X+W:-1}y(){const z=this.r.getValue(I.c);if(!z||!(0,i.$6f)(z))return[];const O=[];for(const B in z){if(B===void 0)continue;const W=z[B];let Z;if(Number(B))Z=Number(B);else if((0,i.$4f)(B))if(I.g.test(B)){const x=B.match(I.g);Z={start:Number(x[1]),end:Number(x[2])}}else if(I.h.test(B)){const x=B.match(I.h);Z={host:x[1],port:Number(x[2])}}else{let x;try{x=RegExp(B)}catch{}x&&(Z=x)}Z&&O.push({key:Z,elevateIfNeeded:W.elevateIfNeeded,onAutoForward:W.onAutoForward,label:W.label,requireLocalPort:W.requireLocalPort,protocol:W.protocol})}const T=this.r.getValue(I.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(O)}z(z){function O(T,B){return(0,i.$8f)(T.key)?T.key:B.t(T.key)?T.key.start:B.u(T.key)?T.key.port:Number.MAX_VALUE}return z.sort((T,B)=>O(T,this)-O(B,this))}C(){return this.m}static providedActionToAction(z){switch(z){case v.ProvidedOnAutoForward.Notify:return y.Notify;case v.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case v.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case v.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case v.ProvidedOnAutoForward.Silent:return y.Silent;case v.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(z,O,T){const W=this.r.inspect(I.c).userRemoteValue;let Z;!W||!(0,i.$6f)(W)?Z={}:Z=(0,r.$Wn)(W),Z[`${z}`]||(Z[`${z}`]={});for(const x in O)Z[`${z}`][x]=O[x];return this.r.updateValue(I.c,Z,T)}}e.$kM=I;let F=class extends p.$Uc{constructor(z,O,T,B,W,Z,x,X,Y,ce){super(),this.H=z,this.I=O,this.J=T,this.L=B,this.M=W,this.N=Z,this.O=x,this.P=X,this.Q=Y,this.R=ce,this.c=new Map,this.g=new R.$be,this.onForwardPort=this.g.event,this.h=new R.$be,this.onClosePort=this.h.event,this.j=new R.$be,this.onPortName=this.j.event,this.n=new R.$be,this.onCandidatesChanged=this.n.event,this.t=new R.$be,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$be,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new I(T),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ne=>{const $e=await this.getAttributes(ne.map(Ce=>({port:Ce.tunnelRemotePort,host:Ce.tunnelRemoteHost})));for(const Ce of ne)if(Ce.localAddress){const ee=k(Ce.tunnelRemoteHost,Ce.tunnelRemotePort),U=w(this.m??new Map,Ce.tunnelRemoteHost,Ce.tunnelRemotePort);this.forwarded.set(ee,{remotePort:Ce.tunnelRemotePort,remoteHost:Ce.tunnelRemoteHost,localAddress:Ce.localAddress,protocol:$e?.get(Ce.tunnelRemotePort)?.protocol??v.TunnelProtocol.Http,localUri:await this.X(Ce.localAddress,$e?.get(Ce.tunnelRemotePort)),localPort:Ce.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:Ce.privacy,source:e.$eM}),this.f.set(ee,Ce)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ne=>{const $e=k(ne.tunnelRemoteHost,ne.tunnelRemotePort);if(!w(this.forwarded,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!w(this.detected,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&!w(this.c,ne.tunnelRemoteHost,ne.tunnelRemotePort)&&ne.localAddress){const Ce=w(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort),ee=(await this.getAttributes([{port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost}]))?.get(ne.tunnelRemotePort);this.forwarded.set($e,{remoteHost:ne.tunnelRemoteHost,remotePort:ne.tunnelRemotePort,localAddress:ne.localAddress,protocol:ee?.protocol??v.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,ee),localPort:ne.tunnelLocalPort,closeable:!0,runningProcess:Ce?.detail,hasRunningProcess:!!Ce,pid:Ce?.pid,privacy:ne.privacy,source:e.$eM})}await this.cb(),this.f.set($e,ne),this.g.fire(this.forwarded.get($e))})),this.B(this.H.onTunnelClosed(ne=>this.W(ne,h.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$bM))?(this.R.createKey(e.$cM.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,O){const T=k(z.host,z.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.cb(),this.h.fire(z))}X(z,O){if(z.startsWith("http"))return b.URI.parse(z);const T=O?.protocol??"http";return b.URI.parse(`${T}://${z}`)}async Y(z){const O=this.N.getWorkspace(),T=O.configuration?(0,M.$ej)(O.configuration.path):O.folders.length>0?(0,M.$ej)(O.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${z}.${this.L.remoteAuthority}.${T}`}async Z(){return this.Y(f)}async $(){return this.Y(d)}async ab(){const z=this.I.get(f,1);if(z)return this.I.remove(f,1),await this.cb(),z;const O=await this.Z();if(O)return this.I.get(O,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const O=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${O.map(T=>T.remotePort).join(", ")}`);for(const T of O){const B=w(this.detected,T.remoteHost,T.remotePort);T.source.source!==g.Extension&&!B||T.source.source===g.Extension&&B?await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,elevateIfNeeded:!0,source:T.source}):T.source.source===g.Extension&&!B&&this.D.set(k(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Z();this.w=this.B(new p.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async O=>{O.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}bb(){const z=this.I.keys(0,0).filter(O=>O.startsWith(d));for(const O of z){const T=this.I.getNumber(O,0);if(T&&T<Date.now()){this.s=Promise.resolve(void 0);const B=O.replace(d,f);this.I.remove(O,0),this.I.remove(B,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=Array.from(this.forwarded.values()),O=z.map(Z=>({remoteHost:Z.remoteHost,remotePort:Z.remotePort,localPort:Z.localPort,name:Z.name,localAddress:Z.localAddress,localUri:Z.localUri,protocol:Z.protocol,source:Z.source}));let T;z.length>0&&(T=JSON.stringify(O));const B=await this.Z(),W=await this.$();!T&&B&&W?(this.I.remove(B,0),this.I.remove(W,0)):T!==this.y&&B&&W&&(this.I.store(B,T,0,0),this.I.store(W,Date.now()+l,0,0)),this.y=T}}async eb(z,O,T){if(!z.tunnelLocalPort||!T?.requireLocalPort||z.tunnelLocalPort===O)return;const B=new Date;if(this.db.getTime()+t>B.getTime())return;this.db=B;const W=u.localize(3,null,O,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(W)}async forward(z,O){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.fb(z,O)}async fb(z,O){await this.Q.activateByEvent(e.$bM);const T=w(this.forwarded,z.remote.host,z.remote.port);O=O??(O!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const B=z.local!==void 0?z.local:z.remote.port;let W;if(T)return this.hb(T,z,O);{const Z=this.L.remoteAuthority,x=Z?{getAddress:async()=>(await this.M.resolveAuthority(Z)).authority}:void 0,X=k(z.remote.host,z.remote.port);this.c.set(X,!0),z=this.gb(X,z);const Y=await this.H.openTunnel(x,z.remote.host,z.remote.port,void 0,B,z.elevateIfNeeded?z.elevateIfNeeded:O?.elevateIfNeeded,z.privacy,O?.protocol);if(typeof Y=="string")W=Y;else if(Y&&Y.localAddress){const ce=w(this.m??new Map,z.remote.host,z.remote.port),ne=Y.protocol?Y.protocol===v.TunnelProtocol.Https?v.TunnelProtocol.Https:v.TunnelProtocol.Http:O?.protocol??v.TunnelProtocol.Http,$e={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:O?.label??z.name,closeable:!0,localAddress:Y.localAddress,protocol:ne,localUri:await this.X(Y.localAddress,O),runningProcess:ce?.detail,hasRunningProcess:!!ce,pid:ce?.pid,source:z.source??e.$eM,privacy:Y.privacy};return this.forwarded.set(X,$e),this.f.set(X,Y),this.c.delete(X),await this.cb(),await this.eb(Y,B,O),this.g.fire($e),Y}this.c.delete(X)}return W}gb(z,O){const T=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(T){const B=T.get(z);T.delete(z),B&&(O.name=B.name??O.name,O.local=("local"in B?B.local:"localPort"in B?B.localPort:void 0)??O.local,O.privacy=O.privacy)}return O}async hb(z,O,T){const B=T?.label??O.name;let W;(function(x){x[x.None=0]="None",x[x.Fire=1]="Fire",x[x.Reopen=2]="Reopen"})(W||(W={}));let Z=W.None;switch(B!==z.name&&(z.name=B,Z=W.Fire),(T?.protocol||z.protocol!==v.TunnelProtocol.Http)&&T?.protocol!==z.protocol&&(O.source=z.source,Z=W.Reopen),O.privacy&&z.privacy!==O.privacy&&(Z=W.Reopen),Z){case W.Fire:{this.g.fire();break}case W.Reopen:await this.close(z.remoteHost,z.remotePort,h.User),await this.fb(O,T)}return w(this.f,O.remote.host,O.remote.port)}async name(z,O,T){const B=w(this.forwarded,z,O),W=k(z,O);if(B){B.name=T,await this.cb(),this.j.fire({host:z,port:O});return}else this.detected.has(W)&&(this.detected.get(W).name=T,this.j.fire({host:z,port:O}))}async close(z,O,T){const B=k(z,O),W=this.forwarded.get(B);return T===h.AutoForwardEnd&&W&&W.source.source===g.Auto&&this.F.set(B,{local:W.localPort,name:W.name,privacy:W.privacy}),await this.H.closeTunnel(z,O),this.W({host:z,port:O},T)}address(z,O){const T=k(z,O);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const O of z){const T=w(this.m??new Map,O.remoteAddress.host,O.remoteAddress.port),B=typeof O.localAddress=="string"?O.localAddress:k(O.localAddress.host,O.localAddress.port);this.detected.set(k(O.remoteAddress.host,O.remoteAddress.port),{remoteHost:O.remoteAddress.host,remotePort:O.remoteAddress.port,localAddress:B,protocol:v.TunnelProtocol.Http,localUri:this.X(B),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:v.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:u.localize(4,null)}}),this.H.setEnvironmentTunnel(O.remoteAddress.host,O.remoteAddress.port,B,v.TunnelPrivacyId.ConstantPrivate,v.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let O=z;this.r&&(O=await this.r(z));const T=this.ib(O);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(B=>B.port).join(", ")}`),this.n.fire(T)}ib(z){const O=this.m??new Map,T=new Map;return this.m=T,z.forEach(B=>{const W=k(B.host,B.port);T.set(W,{host:B.host,port:B.port,detail:B.detail,pid:B.pid}),O.has(W)&&O.delete(W);const Z=w(this.forwarded,B.host,B.port);Z&&(Z.runningProcess=B.detail,Z.hasRunningProcess=!0,Z.pid=B.pid)}),O.forEach((B,W)=>{const Z=c(W);if(!Z)return;const x=w(this.forwarded,Z.host,Z.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0);const X=w(this.detected,Z.host,Z.port);X&&(X.runningProcess=void 0,X.hasRunningProcess=!1,X.pid=void 0)}),O}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const z=Array.from(this.forwarded.values()),O=await this.getAttributes(z.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(O)for(const T of z){const B=O.get(T.remotePort);(B?.protocol||T.protocol!==v.TunnelProtocol.Http)&&B?.protocol!==T.protocol&&await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},B),B&&B.label&&B.label!==T.name&&await this.name(T.remoteHost,T.remotePort,B.label)}}async getAttributes(z,O=!0){const T=new Map,B=new Map;z.forEach(Y=>{const ce=w(this.m??new Map,v.$0v[0],Y.port)??Y;if(ce){T.set(Y.port,ce);const ne=C(ce)?ce.pid:void 0;B.has(ne)||B.set(ne,[]),B.get(ne)?.push(Y.port)}});const W=new Map;if(z.forEach(Y=>{const ce=this.configPortsAttributes.getAttributes(Y.port,Y.host,T.get(Y.port)?.detail);ce&&W.set(Y.port,ce)}),this.G.length===0||!O)return W.size>0?W:void 0;const Z=await Promise.all((0,N.$Rb)(this.G.map(Y=>Array.from(B.entries()).map(ce=>{const ne=ce[1],$e=T.get(ne[0]);return Y.providePortAttributes(ne,$e?.pid,$e?.detail,n.CancellationToken.None)})))),x=new Map;if(Z.forEach(Y=>Y.forEach(ce=>{ce&&x.set(ce.port,ce)})),!W&&!x)return;const X=new Map;return z.forEach(Y=>{const ce=W.get(Y.port),ne=x.get(Y.port);X.set(Y.port,{elevateIfNeeded:ce?.elevateIfNeeded,label:ce?.label,onAutoForward:ce?.onAutoForward??I.providedActionToAction(ne?.autoForwardAction),requireLocalPort:ce?.requireLocalPort,protocol:ce?.protocol})}),X}addAttributesProvider(z){this.G.push(z)}};e.$lM=F,Je([(0,L.$Vh)(1e3)],F.prototype,"cb",null),e.$lM=F=Je([qe(0,v.$5v),qe(1,E.$Up),qe(2,S.$Wi),qe(3,m.$aM),qe(4,$.$Bl),qe(5,a.$zi),qe(6,P.$Wj),qe(7,A.$yw),qe(8,o.$uG),qe(9,s.$Ij)],F)}),define(ke[94],Ee([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$XK=e.$WK=void 0;class u{constructor(M,p){this.line=M,this.character=p}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,p){return new u(0,0)}with(M){return new u(0,0)}}e.$WK=u;class N{constructor(M,p,b,S){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(M,p),this.end=new u(b,S)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new N(0,0,0,0)}with(M){return new N(0,0,0,0)}}e.$XK=N;var L;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(ke[36],Ee([1,0,19,35,24,34,14,5,17,13,94,7]),function(le,e,u,N,L,R,M,p,b,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$iL=e.$bL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$$K=e.$0K=e.$9K=e.$8K=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.TextSearchCompleteMessageType=void 0,e.$5K=o,e.$6K=n,e.$7K=i,e.$_K=g,e.$aL=D,e.$cL=y,e.$dL=C,e.$eL=I,e.$fL=F,e.$gL=j,e.$hL=z,e.$jL=T,e.$lL=Z,e.$mL=x,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$YK="workbench.view.search",e.$ZK="workbench.panel.search",e.$1K="workbench.view.search",e.$2K="search-result",e.$3K="search.exclude";const $="\u27EA ",E=" characters skipped \u27EB",v=($.length+E.length+5)*2;e.$4K=(0,p.$qi)("searchService");var a;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text",Y[Y.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var m;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text",Y[Y.aiText=3]="aiText"})(m||(e.QueryType=m={}));function o(Y){return!!Y.preview}function n(Y){return!!Y.resource}function i(Y){return!!Y.message}var r;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class s{constructor(ce){this.resource=ce,this.results=[]}}e.$8K=s;class t{constructor(ce,ne,$e,Ce){this.ranges=ne,this.webviewIndex=Ce;const ee=Array.isArray(ne)?ne:[ne];if($e&&$e.matchLines===1&&f(ee)){ce=(0,M.$Wf)(ce,$e.matchLines);let U="",ie=0,be=0;const Pe=Math.floor($e.charsPerLine/5),oe=[];for(const ae of ee){const re=Math.max(ae.startColumn-Pe,0),G=ae.startColumn+$e.charsPerLine;if(re>be+Pe+v){const te=$+(re-be)+E;U+=te+ce.slice(re,G),ie+=re-(be+te.length)}else U+=ce.slice(be,G);oe.push(new l(0,ae.startColumn-ie,ae.endColumn-ie)),be=G}this.preview={text:U,matches:Array.isArray(this.ranges)?oe:oe[0]}}else{const U=Array.isArray(ne)?ne[0].startLineNumber:ne.startLineNumber;this.preview={text:ce,matches:(0,u.$2b)(ne,ie=>new d(ie.startLineNumber-U,ie.startColumn,ie.endLineNumber-U,ie.endColumn))}}}}e.$9K=t;function f(Y){const ce=Y[0].startLineNumber;for(const ne of Y)if(ne.startLineNumber!==ce||ne.endLineNumber!==ce)return!1;return!0}class d{constructor(ce,ne,$e,Ce){this.startLineNumber=ce,this.startColumn=ne,this.endLineNumber=$e,this.endColumn=Ce}}e.$0K=d;class l extends d{constructor(ce,ne,$e){super(ce,ne,ce,$e)}}e.$$K=l;var c;(function(Y){Y.List="list",Y.Tree="tree"})(c||(e.ViewMode=c={}));var h;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function g(Y,ce=!0){const ne=Y&&Y.files&&Y.files.exclude,$e=ce&&Y&&Y.search&&Y.search.exclude;if(!ne&&!$e)return;if(!ne||!$e)return ne||$e;let Ce=Object.create(null);return Ce=L.$Zn(Ce,L.$Wn(ne)),Ce=L.$Zn(Ce,L.$Wn($e),!0),Ce}function D(Y,ce){return Y.excludePattern&&N.$jk(Y.excludePattern,ce)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&N.$jk(Y.includePattern,ce)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(ne=>{const $e=ne.folder.fsPath;if(R.$qg(ce,$e)){const Ce=b.$mc($e,ce);return!ne.includePattern||!!N.$jk(ne.includePattern,Ce)}else return!1}):!1:!0}var w;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class k extends Error{constructor(ce,ne){super(ce),this.code=ne}}e.$bL=k;function y(Y){const ce=Y.message;if((0,S.$4)(Y))return new k(ce,w.canceled);try{const ne=JSON.parse(ce);return new k(ne.message,ne.code)}catch{return new k(ce,w.other)}}function C(Y){const ce={message:Y.message,code:Y.code};return new Error(JSON.stringify(ce))}function I(Y){return Y.type==="error"?!0:Y.type==="success"}function F(Y){return Y.type==="success"}function j(Y){return!!Y.path}function z(Y,ce,ne=!0){const $e=Y.searchPath?Y.searchPath:Y.relativePath;return ne?(0,M.$Tf)($e,ce):N.$jk(ce,$e)}class O{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$iL=O;function T(Y,ce){const ne={...Y||{},...ce||{}};return Object.keys(ne).filter($e=>{const Ce=ne[$e];return typeof Ce=="boolean"&&Ce})}class B{constructor(ce,ne){this.c=null,this.a={...ce.excludePattern||{},...ne.excludePattern||{}},this.b=N.$kk(this.a);let $e=ce.includePattern;ne.includePattern&&($e?$e={...$e,...ne.includePattern}:$e=ne.includePattern),$e&&(this.c=N.$kk($e))}matchesExcludesSync(ce,ne,$e){return!!(this.b&&this.b(ce,ne,$e))}includedInQuerySync(ce,ne,$e){return!(this.b&&this.b(ce,ne,$e)||this.c&&!this.c(ce,ne,$e))}includedInQuery(ce,ne,$e){const Ce=this.b(ce,ne,$e),ee=()=>this.c?!!this.c(ce,ne,$e):!0;return(0,P.$ch)(Ce)?Ce.then(U=>U?!1:ee()):ee()}hasSiblingExcludeClauses(){return W(this.a)}}e.$kL=B;function W(Y){for(const ce in Y)if(typeof Y[ce]!="boolean")return!0;return!1}function Z(Y){if(!Y)return;let ce;return ne=>(ce||(ce=(Y()||Promise.resolve([])).then($e=>$e?X($e):{})),ce.then($e=>!!$e[ne]))}function x(Y){if(!Y)return;let ce;return ne=>{if(!ce){const $e=Y();ce=$e?X($e):{}}return!!ce[ne]}}function X(Y){const ce={};for(const ne of Y)ce[ne]=!0;return ce}}),define(ke[43],Ee([1,0,19,7,22,4,3,77,15,125,23,14,2,230,5,12,263,41,60,28,20,16,8,67,36,6,58]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=e.$kkc=void 0;function h(F,j,z){return new A.$Sg(O=>k(O,z)).isEqual(F,j)}function g(F,j,z){return h(F.uri,j.uri,z)?0:(0,P.$mf)(F.uri.toString(),j.uri.toString())}function D(F,j,z){return F.index!==j.index?F.index<j.index?-1:1:h(F.uri,j.uri,z)?(0,P.$mf)(F.name,j.name):(0,P.$mf)(F.uri.toString(),j.uri.toString())}function w(F,j,z,O){const T=F.slice(0).sort((W,Z)=>z(W,Z,O)),B=j.slice(0).sort((W,Z)=>z(W,Z,O));return(0,u.$Eb)(T,B,(W,Z)=>z(W,Z,O))}function k(F,j){const z=j.getCapabilities(F.scheme);return!(z&&z&1024)}class y extends o.$Ji{static toExtHostWorkspace(j,z,O,T){if(!j)return{workspace:null,added:[],removed:[]};const{id:B,name:W,folders:Z,configuration:x,transient:X,isUntitled:Y}=j,ce=[],ne=z;z?Z.forEach((U,ie)=>{const be=$.URI.revive(U.uri),Pe=y.o(O||z,be,T);Pe?(Pe.name=U.name,Pe.index=U.index,ce.push(Pe)):ce.push({uri:be,name:U.name,index:ie})}):ce.push(...Z.map(({uri:U,name:ie,index:be})=>({uri:$.URI.revive(U),name:ie,index:be}))),ce.sort((U,ie)=>U.index<ie.index?-1:1);const $e=new y(B,W,ce,!!X,x?$.URI.revive(x):null,!!Y,U=>k(U,T)),{added:Ce,removed:ee}=w(ne?ne.workspaceFolders:[],$e.workspaceFolders,g,T);return{workspace:$e,added:Ce,removed:ee}}static o(j,z,O){for(let T=0;T<j.folders.length;T++){const B=j.workspaceFolders[T];if(h(B.uri,z,O))return B}}constructor(j,z,O,T,B,W,Z){super(j,O.map(x=>new o.$Ki(x)),T,B,Z),this.t=z,this.u=W,this.q=[],this.s=p.$wi.forUris(Z),O.forEach(x=>{this.q.push(x),this.s.set(x.uri,x)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,A.$3g)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let C=class{constructor(j,z,O,T,B){this.c=new R.$be,this.onDidChangeWorkspace=this.c.event,this.g=new R.$be,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$de,this.C=new Map,this.h=T,this.s=O,this.t=B,this.j=new S.$xm,this.k=new N.$ph,this.o=j.getProxy(l.$PM.MainThreadWorkspace),this.q=j.getProxy(l.$PM.MainThreadMessageService);const W=z.workspace;this.l=W?new y(W.id,W.name,[],!!W.transient,W.configuration?$.URI.revive(W.configuration):null,!!W.isUntitled,Z=>k(Z,O)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?$.URI.from({scheme:b.Schemas.untitled,path:(0,A.$1g)((0,A.$3g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,O,...T){const B=[];if(Array.isArray(T)&&T.forEach(Y=>{$.URI.isUri(Y.uri)&&!B.some(ce=>h(ce.uri,Y.uri,this.s))&&B.push({uri:Y.uri,name:Y.name||(0,A.$Zg)(Y.uri)})}),this.n||[z,O].some(Y=>typeof Y!="number"||Y<0)||O===0&&B.length===0)return!1;const W=this.x?this.x.workspaceFolders:[];if(z+O>W.length)return!1;const Z=W.slice(0);Z.splice(z,O,...B.map(Y=>({uri:Y.uri,name:Y.name||(0,A.$Zg)(Y.uri),index:void 0})));for(let Y=0;Y<Z.length;Y++){const ce=Z[Y];if(Z.some((ne,$e)=>$e!==Y&&h(ce.uri,ne.uri,this.s)))return!1}Z.forEach((Y,ce)=>Y.index=ce);const{added:x,removed:X}=w(W,Z,D,this.s);if(x.length===0&&X.length===0)return!1;if(this.o){const Y=j.displayName||j.name;this.o.$updateWorkspaceFolders(Y,z,O,B).then(void 0,ce=>{this.n=void 0;const ne={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(m.Severity.Error,(0,E.localize)(0,null,Y,ce.toString()),ne,[])})}return this.y(Z),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let O,T="";if(typeof j=="string"?(O=$.URI.file(j),T=j):typeof j<"u"&&(O=j,T=j.fsPath),!O)return T;const B=this.getWorkspaceFolder(O,!0);if(!B)return T;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let W=(0,A.$6g)(B.uri,O);return z&&B.name&&(W=`${B.name}/${W}`),W}y(j){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:O,removed:T}=y.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:T}))}findFiles(j,z,O,T,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let W="",Z=!0;return z===null?Z=!1:z!==void 0&&(typeof z=="string"?W=z:W=z.pattern),this.z(j,void 0,{exclude:W,maxResults:O,useDefaultExcludes:Z,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(j,z={},O,T=L.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${O.value}, entryPoint: findFiles2`),this.z(void 0,j,z,T)}async z(j,z,O,T=L.CancellationToken.None){if(T&&T.isCancellationRequested)return Promise.resolve([]);const B=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,W={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof O.useDefaultSearchExcludes=="boolean"?!O.useDefaultSearchExcludes:!1,maxResults:O.maxResults,excludePattern:B,shouldGlobSearch:typeof O.fuzzy=="boolean"?!O.fuzzy:!0,_reason:"startFileSearch"};let Z;if(j){const{includePattern:x,folder:X}=I(s.GlobPattern.from(j));Z=X,W.includePattern=x}else{const{includePattern:x,folder:X}=I(s.GlobPattern.from(z));Z=X,W.filePattern=x}return this.o.$startFileSearch(Z??null,W,T).then(x=>Array.isArray(x)?x.map(X=>$.URI.revive(X)):[])}async findTextInFiles(j,z,O,T,B=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const W=this.j.getNext(),Z=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:x,folder:X}=I(s.GlobPattern.from(z.include)),Y=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ce={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:Z,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:x,excludePattern:Y},ne=!1;if(this.u[W]=$e=>{if(ne)return;const Ce=$.URI.revive($e.resource);$e.results.forEach(ee=>{const U=(0,c.$Zh)(ee);(0,d.$5K)(U)?O({uri:Ce,preview:{text:U.preview.text,matches:(0,u.$2b)(U.preview.matches,ie=>new t.$TM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,u.$2b)(U.ranges,ie=>new t.$TM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):O({uri:Ce,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(j,X??null,ce,W,B);return delete this.u[W],$e||{}}catch($e){throw delete this.u[W],$e}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return $.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return $.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const O=this.t.transformOutgoingScheme(j),T=this.A++;return this.o.$registerEditSessionIdentityProvider(T,O),(0,M.$Sc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const O=await this.resolveWorkspaceFolder($.URI.revive(j));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const T=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!T),!T)return;const B=await T.provideEditSessionIdentity(O,z);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(j,z,O,T){this.h.info("Getting edit session identifier for workspaceFolder",j);const B=await this.resolveWorkspaceFolder($.URI.revive(j));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const W=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!W),!W)return;const Z=await W.provideEditSessionIdentityMatch?.(z,O,T);if(this.h.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(j){return(z,O,T)=>{const B=function(Z){z.call(O,Z)};return B.extension=j,this.B.event(B,void 0,T)}}async $onWillCreateEditSessionIdentity(j,z,O){const T=await this.resolveWorkspaceFolder($.URI.revive(j));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:T},z,async(B,W)=>{const Z=Date.now();await Promise.resolve(B),Date.now()-Z>O&&this.h.warn("SLOW edit session create-participant",W.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const O=this.t.transformOutgoingScheme(j),T=this.A++;return this.o.$registerCanonicalUriProvider(T,O),(0,M.$Sc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(j,z,O){const T=this.C.get(j.scheme);if(!T)return;const B=await T.provideCanonicalUri?.($.URI.revive(j),z,O);if(B)return B}async $provideCanonicalUri(j,z,O){return this.provideCanonicalUri($.URI.revive(j),{targetScheme:z},O)}};e.$kkc=C,e.$kkc=C=Je([qe(0,r.$aP),qe(1,i.$qP),qe(2,n.$6jc),qe(3,a.$Wj),qe(4,f.$ikc)],C),e.$lkc=(0,v.$qi)("IExtHostWorkspace");function I(F){let j,z;return F&&(typeof F=="string"?j=F:(j=F.pattern,z=$.URI.revive(F.baseUri))),{includePattern:j,folder:z}}}),define(ke[44],Ee([1,0,24,4,43,6,8,265,85,18,7,5,20,12,2]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=e.$nkc=e.$mkc=void 0;function a(f,d){if(d){const l=d.split(".");let c=f;for(let h=0;c&&h<l.length;h++)c=c[l[h]];return c}}function m(f){return f instanceof v.URI}function o(f){return f&&f.uri instanceof v.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&f.uri instanceof v.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function r(f){if(m(f))return{resource:f};if(o(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(i(f))return{resource:f.uri};if(f===null)return{resource:null}}let s=class{constructor(d,l,c){this.a=d.getProxy(R.$PM.MainThreadConfiguration),this.c=l,this.b=c,this.d=new A.$ph,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,l){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(d,l))}};e.$mkc=s,e.$mkc=s=Je([qe(0,$.$aP),qe(1,L.$lkc),qe(2,E.$Wj)],s);class t{constructor(d,l,c,h){this.a=new N.$be,this.b=d,this.f=h,this.c=l,this.e=p.$uo.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,l){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$uo.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(l,c))}getConfiguration(d,l,c){const h=r(l)||{},g=this.g(d?a(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,c?.identifier);function D(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(k){return typeof a(g,k)<"u"},get:(k,y)=>{this.h(d?`${d}.${k}`:k,h,c?.identifier);let C=a(g,k);if(typeof C>"u")C=y;else{let I;const F=(j,z)=>{if((0,S.$6f)(j)){let O;const T=()=>{I=I||(0,u.$Wn)(g),O=O||a(I,z)};return new Proxy(j,{get:(B,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return T(),()=>O;if(I)return O=O||a(I,z),O[W];const Z=B[W];return typeof W=="string"?F(Z,`${z}.${W}`):Z},set:(B,W,Z)=>(T(),O&&(O[W]=Z),!0),deleteProperty:(B,W)=>(T(),O&&delete O[W],!0),defineProperty:(B,W,Z)=>(T(),O&&Object.defineProperty(O,W,Z),!0)})}return Array.isArray(j)?(0,u.$Wn)(j):j};C=F(C,k)}return C},update:(k,y,C,I)=>{k=d?`${d}.${k}`:k;const F=D(C);return y!==void 0?this.b.$updateConfigurationOption(F,k,y,h,I):this.b.$removeConfigurationOption(F,k,h,I)},inspect:k=>{k=d?`${d}.${k}`:k;const y=this.e.inspect(k,h,this.c.workspace);if(y)return{key:k,defaultValue:(0,u.$Wn)(y.policy?.value??y.default?.value),globalValue:(0,u.$Wn)(y.user?.value??y.application?.value),workspaceValue:(0,u.$Wn)(y.workspace?.value),workspaceFolderValue:(0,u.$Wn)(y.workspaceFolder?.value),defaultLanguageValue:(0,u.$Wn)(y.default?.override),globalLanguageValue:(0,u.$Wn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,u.$Wn)(y.workspace?.override),workspaceFolderLanguageValue:(0,u.$Wn)(y.workspaceFolder?.override),languageIds:(0,u.$Wn)(y.overrideIdentifiers)}}};return typeof g=="object"&&(0,u.$Zn)(w,g,!1),Object.freeze(w)}g(d){const l=c=>(0,S.$6f)(c)?new Proxy(c,{get:(h,g)=>l(h[g]),set:(h,g,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(h,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(h,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return l(d)}h(d,l,c){const h=b.$lo.test(d)?4:this.d.get(d),g=c?`[${c.value}] `:"";if(h===4){typeof l?.resource>"u"&&this.f.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){l?.resource&&this.f.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,l){const c=new p.$wo(d,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,g)=>c.affectsConfiguration(h,r(g))})}k(d){return d.reduce((l,c)=>(l.set(c[0],c[1]),l),new Map)}}e.$nkc=t,e.$okc=(0,P.$qi)("IExtHostConfiguration")}),define(ke[95],Ee([1,0,2,7,4,6,8,43,72,44,22,42,20,28,5,15,11,12,91,309,13]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=e.$Rlc=e.$Qlc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(F){function j(O){if(O!=null)return O}F.from=j;function z(O){if(O!=null)return O}F.to=z})(s||(s={}));var t;(function(F){function j(O){if(O!=null)return O}F.from=j;function z(O){if(O!=null)return O}F.to=z})(t||(t={}));var f;(function(F){function j(O){if(O!=null)return O}F.from=j;function z(O){if(O!=null)return O}F.to=z})(f||(f={}));var d;(function(F){function j(T){if(T){const B=T;return B&&!!B.process}else return!1}F.is=j;function z(T){if(T==null)return;const B={process:T.process,args:T.args};return T.options&&(B.options=f.from(T.options)),B}F.from=z;function O(T){if(T!=null)return new M.$AN(T.process,T.args,T.options)}F.to=O})(d||(d={}));var l;(function(F){function j(O){if(O!=null)return O}F.from=j;function z(O){if(O!=null)return O}F.to=z})(l||(l={}));var c;(function(F){function j(T){if(T){const B=T;return B&&(!!B.commandLine||!!B.command)}else return!1}F.is=j;function z(T){if(T==null)return;const B={};return T.commandLine!==void 0?B.commandLine=T.commandLine:(B.command=T.command,B.args=T.args),T.options&&(B.options=l.from(T.options)),B}F.from=z;function O(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new M.$BN(T.commandLine,T.options):new M.$BN(T.command,T.args?T.args:[],T.options)}F.to=O})(c||(c={}));var h;(function(F){function j(T){if(T){const B=T;return B&&B.customExecution==="customExecution"}else return!1}F.is=j;function z(T){return{customExecution:"customExecution"}}F.from=z;function O(T,B){return B.get(T)}F.to=O})(h||(e.CustomExecutionDTO=h={}));var g;(function(F){function j(z,O){let T;return z.scope!==void 0&&typeof z.scope!="number"?T=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===M.TaskScope.Workspace&&O&&O.workspaceFile?T=O.workspaceFile:T=i.$VH),{id:z._id,workspaceFolder:T}}F.from=j})(g||(e.TaskHandleDTO=g={}));var D;(function(F){function j(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}F.from=j})(D||(D={}));var w;(function(F){function j(T,B){if(T==null)return[];const W=[];for(const Z of T){const x=z(Z,B);x&&W.push(x)}return W}F.fromMany=j;function z(T,B){if(T==null)return;let W;T.execution instanceof M.$AN?W=d.from(T.execution):T.execution instanceof M.$BN?W=c.from(T.execution):T.execution&&T.execution instanceof M.$CN&&(W=h.from(T.execution));const Z=s.from(T.definition);let x;return T.scope?typeof T.scope=="number"?x=T.scope:x=T.scope.uri:x=M.TaskScope.Workspace,!Z||!x?void 0:{_id:T._id,definition:Z,name:T.name,source:{extensionId:B.identifier.value,label:T.source,scope:x},execution:W,isBackground:T.isBackground,group:D.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}F.from=z;async function O(T,B,W){if(T==null)return;let Z;d.is(T.execution)?Z=d.to(T.execution):c.is(T.execution)?Z=c.to(T.execution):h.is(T.execution)&&(Z=h.to(T._id,W));const x=s.to(T.definition);let X;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?X=T.source.scope:X=await B.resolveWorkspaceFolder(u.URI.revive(T.source.scope)):X=M.TaskScope.Workspace),!x||!X)return;const Y=new M.$DN(x,X,T.name,T.source.label,Z,T.problemMatchers);return T.isBackground!==void 0&&(Y.isBackground=T.isBackground),T.group!==void 0&&(Y.group=M.$zN.from(T.group._id),Y.group&&T.group.isDefault&&(Y.group=new M.$zN(Y.group.id,Y.group.label),T.group.isDefault===!0&&(Y.group.isDefault=T.group.isDefault))),T.presentationOptions&&(Y.presentationOptions=t.to(T.presentationOptions)),T._id&&(Y._id=T._id),T.detail&&(Y.detail=T.detail),Y}F.to=O})(w||(e.TaskDTO=w={}));var k;(function(F){function j(O){return O}F.from=j;function z(O){if(O)return Object.assign(Object.create(null),O)}F.to=z})(k||(k={}));class y{#e;constructor(j,z,O){this._id=z,this.a=O,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let C=class{constructor(j,z,O,T,B,W,Z,x){this.q=new L.$be,this.r=new L.$be,this.s=new L.$be,this.u=new L.$be,this.a=j.getProxy(R.$PM.MainThreadTask),this.b=O,this.c=T,this.d=B,this.e=W,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Z,this.g=x,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,z,O){if(!O)return new M.$RM(()=>{});const T=this.x();return this.j.set(T,{type:z,provider:O,extension:j}),this.a.$registerTaskProvider(T,z),new M.$RM(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(j,z){this.a.$registerTaskSystem(j,z)}fetchTasks(j){return this.a.$fetchTasks(k.from(j)).then(async z=>{const O=[];for(const T of z){const B=await w.to(T,this.b,this.m);B&&O.push(B)}return O})}get taskExecutions(){const j=[];return this.k.forEach(z=>j.push(z)),j}terminateTask(j){if(!(j instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,z,O){const T=this.m.get(j.id);T&&(this.o.set(j.id,T),this.e.attachPtyToTerminal(z,await T.callback(O))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const z=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const z=await this.z(j.id);this.s.fire({execution:z,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const z=await this.z(j.id);this.u.fire({execution:z,exitCode:j.exitCode})}$provideTasks(j,z){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));const T=[],B=(0,N.$ih)(()=>O.provider.provideTasks(A.CancellationToken.None)).then(W=>this.v(z,T,O,W));return new Promise(W=>{B.then(Z=>{Promise.all(T).then(()=>{W(Z)})})})}async $resolveTask(j,z){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));if(z.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${O.type}].`);const T=await w.to(z,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const B=await O.provider.resolveTask(T,A.CancellationToken.None);if(!B)return;this.A(B,O);const W=w.from(B,O.extension);if(!W)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(W.execution)&&await this.y(W,B,!0),await this.w(W)}x(){return this.h++}async y(j,z,O){const T=await this.a.$createTaskId(j);!O&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,z.execution)),this.m.set(T,z.execution)}async z(j,z){if(typeof j=="string"){const B=this.l.get(j);if(!B)throw new r.$bb("Unexpected: The specified task is missing an execution");return B}const O=this.l.get(j.id);if(O)return O;let T;return z?T=Promise.resolve(new y(this,j.id,z)):T=w.to(j.task,this.b,this.m).then(B=>{if(!B)throw new r.$bb("Unexpected: Task does not exist.");return new y(this,j.id,B)}),this.l.set(j.id,T),T.then(B=>(this.k.set(j.id,B),B))}A(j,z){j._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const O=this.n.values();let T=O.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=O.next()}};e.$Qlc=C,e.$Qlc=C=Je([qe(0,$.$aP),qe(1,E.$qP),qe(2,p.$lkc),qe(3,b.$lP),qe(4,S.$okc),qe(5,P.$Mkc),qe(6,o.$Wj),qe(7,n.$2jc)],C);let I=class extends C{constructor(j,z,O,T,B,W,Z,x){super(j,z,O,T,B,W,Z,x),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:m.$h(0)})}async executeTask(j,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const O=w.from(z,j);if(O===void 0)throw new Error("Task is not valid");if(h.is(O.execution))await this.y(O,z,!1);else throw new r.$_;const T=await this.z(await this.a.$getTaskExecution(O),z);return this.a.$executeTask(O).catch(B=>{throw new Error(B)}),T}v(j,z,O,T){const B=[];if(T)for(const W of T){if(this.A(W,O),!W.definition||!j[W.definition.type]){const x=W.source?W.source:"No task source";this.f.warn(`The task [${x}, ${W.name}] uses an undefined task type. The task will be ignored in the future.`)}const Z=w.from(W,O.extension);Z&&h.is(Z.execution)?(B.push(Z),z.push(this.y(Z,W,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:O.extension}}async w(j){if(h.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,z,O){}};e.$Rlc=I,e.$Rlc=I=Je([qe(0,$.$aP),qe(1,E.$qP),qe(2,p.$lkc),qe(3,b.$lP),qe(4,S.$okc),qe(5,P.$Mkc),qe(6,o.$Wj),qe(7,n.$2jc)],I),e.$Slc=(0,v.$qi)("IExtHostTask")}),define(ke[369],Ee([1,0,36,29]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tL=void 0,e.$sL=L,e.$uL=R;function L(M){return"cellResults"in M}e.$tL="rawCell#";function R(M,p){let b=-1;const S=[];let A=[];return M.forEach($=>{$.range.startLineNumber!==b&&A.length>0&&(S.push([...A]),A=[]),A.push($),b=$.range.endLineNumber}),A.length>0&&S.push([...A]),S.map($=>{const E=[],v=$[0].range.startLineNumber,a=$[$.length-1].range.endLineNumber;for(let m=v;m<=a;m++)E.push(p.getLineContent(m));return new u.$9K(E.join(`
`)+`
`,$.map(m=>new N.$kt(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(ke[370],Ee([1,0,224,21,4,3,27,14,18,2,32,111,6,33,16,8,48,340,153,24,15,299,369,366]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(c=>c.apiEditor)}constructor(c,h,g,D,w,k){this.q=g,this.r=D,this.s=w,this.t=k,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new L.$be,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.$be,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.$be,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.$be,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$Zjc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=c.getProxy($.$PM.MainThreadNotebook),this.c=c.getProxy($.$PM.MainThreadNotebookDocuments),this.d=c.getProxy($.$PM.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const C=y.notebookEditor?.notebookUri,I=y.cell.handle,j=this.g.get(C)?.getCell(I);if(j)return j.apiCell}if(y&&y.$mid===14){const C=y.uri,I=this.g.get(C);if(I)return I.apiNotebook}return y}}),d.B(h)}getEditorById(c){const h=this.h.get(c);if(!h)throw new Error(`unknown text editor: ${c}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(c){for(const[h,g]of this.h)if(g.apiEditor===c)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(c,h){const g=this.g.get(c);if(!g&&!h)throw new Error(`NO notebook document for '${c}'`);return g}static u(c,h){if(!h)return;const g=h.filenamePattern.map(D=>v.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(h.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:h.displayName,filenamePattern:g,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,h,g){const D=d.a++,w=typeof g.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(D,g),this.b.$registerNotebookCellStatusBarItemProvider(D,w,h);let k;return w!==void 0&&(k=g.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(w))),new a.$RM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,w),k?.dispose()})}async createNotebookDocument(c){const h=await this.c.$tryCreateNotebook({viewType:c.viewType,content:c.content&&v.NotebookData.from(c.content)});return S.URI.revive(h)}async openNotebookDocument(c){const h=this.g.get(c);if(h)return h.apiNotebook;const g=await this.c.$tryOpenNotebook(c),D=this.g.get(S.URI.revive(g));return(0,b.$cg)(D?.apiNotebook)}async showNotebookDocument(c,h){S.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let g;typeof h=="object"?g={position:v.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(v.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:g={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(c.uri,c.notebookType,g),w=D&&this.h.get(D)?.apiEditor;if(w)return w;throw D?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,h,g,D){const w=this.f.get(c),k=S.URI.revive(h),y=this.g.get(k);if(!y||!w)return;const C=y.getCellFromIndex(g);if(!C)return;const I=await w.provideCellStatusBarItems(C.apiCell,D);if(!I)return;const F=new R.$Tc,j=this.p.add([F]),O=(Array.isArray(I)?I:[I]).map(T=>v.NotebookStatusBarItem.from(T,this.i,F));return{cacheId:j,items:O}}$releaseNotebookCellStatusBarItems(c){this.p.delete(c)}registerNotebookSerializer(c,h,g,D,w){if((0,p.$3e)(h))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:h,serializer:g,options:D}),this.b.$registerNotebookSerializer(k,{id:c.identifier,location:c.extensionLocation},h,v.NotebookDocumentContentOptions.from(D),d.u(c,w)),(0,R.$Sc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(c,h,g){const D=this.x.get(c);if(!D)throw new Error("NO serializer found");const w=await D.serializer.deserializeNotebook(h.buffer,g);return new m.$mw(v.NotebookData.from(w))}async $notebookToData(c,h,g){const D=this.x.get(c);if(!D)throw new Error("NO serializer found");const w=await D.serializer.serializeNotebook(v.NotebookData.to(h.value),g);return N.$Ce.wrap(w)}async $saveNotebook(c,h,g,D,w){const k=S.URI.revive(h),y=this.x.get(c);if(!y)throw new Error("NO serializer found");const C=this.g.get(k);if(!C)throw new Error("Document NOT found");if(C.versionId!==g)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new A.$fl((0,u.localize)(0,null,this.z(k)),6);await this.y(k,D);const I={metadata:(0,i.$5n)(C.apiNotebook.metadata,T=>!(y.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of C.apiNotebook.getCells()){const B=new a.$hO(T.kind,T.document.getText(),T.document.languageId,T.mime,y.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);B.metadata=(0,i.$5n)(T.metadata,W=>!(y.options?.transientCellMetadata??{})[W]),I.cells.push(B)}const F=await y.serializer.serializeNotebook(I,w);await this.s.value.writeFile(k,F);const j=this.s.getFileSystemProviderExtUri(k.scheme),z=await this.s.value.stat(k);return{name:j.basename(k),isFile:(z.type&A.FileType.File)!==0,isDirectory:(z.type&A.FileType.Directory)!==0,isSymbolicLink:(z.type&A.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((z.permissions??0)&A.FilePermission.Locked),etag:A.$ql({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(c,h,g,D,w){const k=this.x.get(c)?.serializer;if(!k)return{limitHit:!1,results:[]};const y=new M.$Cc;await(async(z,O,T)=>{await Promise.all(z.map(async B=>await Promise.all(B.filenamePatterns.map(W=>{const Z={_reason:T._reason,folderQueries:T.folderQueries,includePattern:T.includePattern,excludePattern:T.excludePattern,maxResults:T.maxResults,type:1,filePattern:W};return this.t.doInternalFileSearchWithCustomCallback(Z,O,x=>{x.forEach(X=>{y.has(X)||D.some(ce=>B.isFromSettings&&!ce.isFromSettings?!1:ce.filenamePatterns.some(ne=>(0,f.$mgb)(ne,X)))||y.add(X)})}).catch(x=>{if(x.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw x})}))))})(g,w,h);const I=new M.$Bc;let F=!1;const j=Array.from(y).map(async z=>{const O=[];try{if(w.isCancellationRequested)return;if(h.maxResults&&[...I.values()].reduce((Z,x)=>Z+x.cellResults.length,0)>h.maxResults){F=!0;return}const T=[],B=this.g.get(z);if(B)B.apiNotebook.getCells().forEach(x=>T.push({input:x.document.getText(),outputs:x.outputs.flatMap(X=>X.items.map(Y=>Y.data.toString()))}));else{const Z=await this.s.value.readFile(z),x=N.$Ce.fromString(Z.toString()),X=await k.deserializeNotebook(x.buffer,w);if(w.isCancellationRequested)return;v.NotebookData.from(X).cells.forEach(ce=>T.push({input:ce.source,outputs:ce.outputs.flatMap(ne=>ne.items.map($e=>$e.valueBytes.toString()))}))}if(w.isCancellationRequested)return;T.forEach((Z,x)=>{const X=h.contentPattern.pattern,Y=new s.$_Vb(Z.input,void 0,Z.outputs),ce=Y.findInInputs(X),ne=Y.findInOutputs(X),$e=ne.flatMap(Ce=>(0,t.$uL)(Ce.matches,Ce.textBuffer)).map((Ce,ee)=>(Ce.webviewIndex=ee,Ce));if(ce.length>0||ne.length>0){const Ce={index:x,contentResults:(0,t.$uL)(ce,Y.inputTextBuffer),webviewResults:$e};O.push(Ce)}});const W={resource:z,cellResults:O};I.set(z,W);return}catch{return}});return await Promise.all(j),{limitHit:F,results:[...I.values()]}}async y(c,h){const g=await this.s.value.stat(c);if(typeof h?.mtime=="number"&&typeof h.etag=="string"&&h.etag!==A.$pl&&typeof g.mtime=="number"&&typeof g.size=="number"&&h.mtime<g.mtime&&h.etag!==A.$ql({mtime:h.mtime,size:g.size}))throw new A.$fl((0,u.localize)(1,null),3,h)}z(c){return c.scheme===r.Schemas.file?c.fsPath:c.toString()}A(c,h,g){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const D=new n.$klc(h,this.d,c,g.visibleRanges.map(v.NotebookRange.to),g.selections.map(v.NotebookRange.to),typeof g.viewColumn=="number"?v.ViewColumn.to(g.viewColumn):void 0);this.h.set(h,D)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const g of c.value.removedDocuments){const D=S.URI.revive(g),w=this.g.get(D);w&&(w.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(w.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===D.toString()&&this.h.delete(k.id)}if(c.value.addedDocuments){const g=[];for(const D of c.value.addedDocuments){const w=S.URI.revive(D.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const k=new o.$jlc(this.c,this.q,this.r,w,D);g.push(...D.cells.map(y=>o.$ilc.asModelAddData(y))),this.g.get(w)?.dispose(),this.g.set(w,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(k.apiNotebook)}}if(c.value.addedEditors)for(const g of c.value.addedEditors){if(this.h.has(g.id))return;const D=S.URI.revive(g.documentUri),w=this.g.get(D);w&&this.A(w,g.id,g)}const h=[];if(c.value.removedEditors)for(const g of c.value.removedEditors){const D=this.h.get(g);D&&(this.h.delete(g),this.k?.id===D.id&&(this.k=void 0),h.push(D))}if(c.value.visibleEditors){this.l=c.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const g=new Set;this.l.forEach(D=>g.add(D.id));for(const D of this.h.values()){const w=g.has(D.id);D._acceptVisibility(w)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this.k=void 0:c.value.newActiveEditor&&(this.h.get(c.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${c.value.newActiveEditor}`),this.k=this.h.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(c){const h=E.$yP.String.with("notebookType","A notebook type"),g=new E.$AP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new E.$yP("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>N.$Ce.wrap(w))],new E.$zP("Notebook Data",w=>v.NotebookData.to(w.value))),D=new E.$AP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new E.$yP("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new m.$mw(v.NotebookData.from(w)))],new E.$zP("Bytes",w=>w.buffer));c.registerApiCommand(g),c.registerApiCommand(D)}}e.$tlc=d}),define(ke[371],Ee([1,0,17,22,47,35,23,39,36]),function(le,e,u,N,L,R,M,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=void 0;class S{constructor($,E,v){this.k=$,this.l=E,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&R.$kk($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&R.$kk($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const E=this.k.folderQueries||[];return new Promise((v,a)=>{const m=o=>{this.f++,$(o)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const n=o.toString(),i=u.$oc(n);this.j&&this.j(n,i)||this.v(m,{base:o,basename:i})}),Promise.all(E.map(o=>this.p(o,m))).then(o=>{v({limitHit:this.e,stats:o[0]||void 0})},o=>{a(new Error((0,L.$bj)(o)))})})}async p($,E){const v=new N.$me,a=this.q($),m=this.r(),o=new b.$kL(this.k,$),n=!o.hasSiblingExcludeClauses();let i;try{this.h.add(v),i=p.$0d.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,v.token),s=i.elapsed(),t=p.$0d.create();return this.g&&!this.e||(r&&r.forEach(f=>{const d=u.$hc.relative($.folder.path,f.path);if(n){const l=u.$oc(f.path);this.v(E,{base:$.folder,relativePath:d,basename:l});return}this.s(m,$.folder,d,E)}),this.g&&!this.e)?null:(this.u(m,o,E),{providerTime:s,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q($){const E=(0,b.$jL)(this.k.includePattern,$.includePattern),v=(0,b.$jL)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:v,includes:E,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},E,v,a){if(v===this.a){const o=u.$oc(this.a);this.v(a,{base:E,relativePath:this.a,basename:o})}function m(o){const n=u.$oc(o),i=u.$nc(o);let r=$[i];r||(r=$[i]=[],m(i)),r.push({base:E,relativePath:o,basename:n})}m(v)}u({rootEntries:$,pathToEntries:E},v,a){const m=this,o=this.a;function n(i){const r=(0,b.$mL)(()=>i.map(s=>s.basename));for(let s=0,t=i.length;s<t;s++){const f=i[s],{relativePath:d,basename:l}=f;if(v.matchesExcludesSync(d,l,o!==l?r:void 0))continue;const c=E[d];if(c)n(c);else{if(d===o)continue;m.v(a,f)}if(m.e)break}}n($)}v($,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(E))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch($,E,v,a){const m=this.c($.cacheKey),o=new S($,E,m&&m.token);let n=0;const i=r=>{n+=r.length,v(r.map(s=>this.d(s)))};return this.e(o,A.a,i,a).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:r.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new N.$me),this.b.get($)}d($){return $.relativePath?{resource:M.$4g($.base,$.relativePath)}:{resource:$.base}}e($,E,v,a){const m=a.onCancellationRequested(()=>{$.cancel()}),o=i=>{i&&(n.push(i),E>0&&n.length>=E&&(v(n),n=[]))};let n=[];return $.search(o).then(i=>(n.length&&v(n),m.dispose(),i),i=>(n.length&&v(n),m.dispose(),Promise.reject(i)))}}e.$llc=A}),define(ke[372],Ee([1,0,19,73,35,103,27,15,17,23,14,18,2,100,245,54,12,41,146,367,36]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=void 0,e.$uM=D;let s=class{constructor(k,y,C,I,F){this.a=k,this.b=y,this.c=C,this.d=I,this.e=F}text(k,y,C={}){k=this.f(k,C);const I=this.a.getValue(),F=y&&y.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(y?.map(o.$Li),C),type:2,contentPattern:k,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:I.search.usePCRE2||F||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(k,y){const C=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const I={...k,wordSeparators:C.editor.wordSeparators};return this.j(k,y)&&(I.isCaseSensitive=!0),this.k(k)&&(I.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),I}file(k,y={}){return{...this.h(k,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(k,y){return k?(k=Array.isArray(k)?k.map(c):c(k),y?this.parseSearchPaths(k):{pattern:f(...Array.isArray(k)?k:[k])}):{}}h(k=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),I=this.g(y.excludePattern,y.expandPatterns),F=k.length>1,j=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(T=>this.q(T,y,I)):k.map(T=>this.r(T,y,I,F))).filter(T=>!!T),z={_reason:y._reason,folderQueries:j,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:I.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const T=u.$Hb(u.$Rb(this.c.groups.map(Z=>Z.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const B=T.filter(Z=>(0,r.$aL)(z,Z.fsPath)),W=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...z,...W}}const O=y.extraFileResources&&y.extraFileResources.filter(T=>(0,r.$aL)(z,T.fsPath));return z.extraFileResources=O&&O.length?O:void 0,z}i(k){const y=[],C=new M.$Bc,I={};let F=!1;return k.forEach(j=>{if(j.scheme===p.Schemas.walkThrough)return;if((0,S.$8g)(j)){const O=this.b.getWorkspaceFolder(j)?.uri??j.with({path:b.$nc(j.fsPath)});let T=C.get(O);T||(F=!0,T={folder:O,includePattern:{}},y.push(T),C.set(O,T));const B=b.$mc(O.fsPath,j.fsPath);(0,P.$cg)(T.includePattern)[B.replace(/\\/g,"/")]=!0}else j.fsPath&&(F=!0,I[j.fsPath]=!0)}),{folderQueries:y,includePattern:I,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}j(k,y){if(y.isSmartCase){if(k.isRegExp){if(A.$Uf(k.pattern,!0))return!0}else if(A.$Uf(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,E.$BC)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const y=W=>b.$jc(W)||/^\.\.?([\/\\]|$)/.test(W),I=(Array.isArray(k)?k:d(k)).map(W=>{const Z=this.e.resolvedUserHome;return Z?(0,R.$rw)(W,Z.scheme===p.Schemas.file?Z.fsPath:Z.path):W}),F=N.$K(I,W=>y(W)?"searchPaths":"exprSegments"),j=(F.exprSegments||[]).map(W=>A.$bf(W,"/")).map(W=>A.$bf(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),l(W))),z={},O=this.m(F.searchPaths||[]);O&&O.length&&(z.searchPaths=O);const T=u.$Rb(j),B=f(...T);return B&&(z.pattern=B),z}l(k,y){return y.disregardExcludeSettings?void 0:(0,r.$_K)(k,!y.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const y=k.flatMap(I=>{let{pathPortion:F,globPortion:j}=t(I);return j&&(j=h(j)),this.n(F).flatMap(O=>this.o(O,j))}),C=new Map;return y.forEach(I=>{const F=I.searchPath.toString(),j=C.get(F);j?I.pattern&&(j.pattern=j.pattern||{},j.pattern[I.pattern]=!0):C.set(F,{searchPath:I.searchPath,pattern:I.pattern?f(I.pattern):void 0})}),Array.from(C.values())}n(k){if(b.$jc(k)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==p.Schemas.file?[{searchPath:y[0].uri.with({path:k})}]:[{searchPath:$.URI.file(b.$ic(k))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(k=c(k),k.startsWith("../")||k===".."){const I=b.$hc.resolve(y.path,k);return[{searchPath:y.with({path:I})}]}const C=h(k);return[{searchPath:y,pattern:C}]}else{if(k==="./"||k===".\\")return[];{const y=k.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(F=>{const j=y.match(new RegExp(`^${A.$8e(F.name)}(?:/(.*)|$)`));return j?{match:j,folder:F}:null}).filter(P.$_f);if(I.length)return I.map(F=>{const j=F.match[1];return{searchPath:F.folder.uri,pattern:j&&h(j)}});{const F=k.match(/\.[\/\\](.+)[\/\\]?/),j=F?F[1]:k,z=v.localize(0,null,j);throw new Error(z)}}}}o(k,y){const C=k.pattern&&y?`${k.pattern}/${y}`:k.pattern||y,I=[{searchPath:k.searchPath,pattern:C}];return C&&!C.endsWith("**")&&I.push({searchPath:k.searchPath,pattern:C+"/**"}),I}q(k,y,C){const I=this.r((0,o.$Li)(k.searchPath),y,C,!1);return I?{...I,includePattern:k.pattern}:null}r(k,y,C,I){let F;const j=$.URI.isUri(k)?k:k.uri;if(C.searchPaths){const W=C.searchPaths.filter(Z=>(0,S.$Wg)(Z.searchPath,j))[0];if(W&&!W.pattern)return null;W&&(F=W.pattern)}const z=this.a.getValue({resource:j}),T={...this.l(z,y)||{},...F||{}},B=$.URI.isUri(k)?(0,S.$1g)(k):k.name;return{folder:j,folderName:I?B:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!z.search.followSymlinks}}};e.$tM=s,e.$tM=s=Je([qe(0,a.$Wi),qe(1,o.$zi),qe(2,n.$ID),qe(3,m.$Wj),qe(4,i.$rM)],s);function t(w){const k=w.match(/[\*\{\}\(\)\[\]\?]/);if(k){const y=k.index,C=w.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let I=w.substr(0,C.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:w.substr((C.index||0)+1)}}}return{pathPortion:w}}function f(...w){return w.length?w.reduce((k,y)=>(k[y]=!0,k),Object.create(null)):void 0}function d(w){return L.$ik(w,",").map(k=>k.trim()).filter(k=>!!k.length)}function l(w){return[`**/${w}/**`,`**/${w}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function c(w){return w.replace(/\\/g,"/")}function h(w){return c(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(w){return w.replace(/([?*[\]])/g,"[$1]")}function D(w,k){w=u.$Mb(w,I=>I.toString());const y=[],C=k.getWorkspace();return w&&w.forEach(I=>{let F;if(k.getWorkbenchState()===2)F=(0,S.$6g)(C.folders[0].uri,I),F&&F!=="."&&(F="./"+F);else{const j=k.getWorkspaceFolder(I);if(j){const z=j.name;if(C.folders.filter(T=>T.name===z).length===1){const T=(0,S.$6g)(j.uri,I);T===""?F=`./${j.name}`:F=`./${j.name}/${T}`}else F=I.fsPath}}F&&y.push(g(F))}),y}}),define(ke[373],Ee([1,0,23,2,22,13,5,372,36,41,7]),function(le,e,u,N,L,R,M,p,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mtb=$,e.$ntb=a;const P=7e3;function $(m,o){const n=o.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],r=[];for(const c of n)if(/^workspaceContains:/.test(c)){const h=c.substr(18);h.indexOf("*")>=0||h.indexOf("?")>=0||m.forceUsingSearch?r.push(h):i.push(h)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:s,resolve:t}=(0,A.$jh)(),f=c=>t({activationEvent:c}),d=Promise.all(i.map(c=>E(m,c,f))).then(()=>{}),l=v(m,o.identifier,r,f);return Promise.all([d,l]).then(()=>{t(void 0)}),s}async function E(m,o,n){for(const i of m.folders)if(await m.exists(u.$4g(N.URI.revive(i),o))){n(`workspaceContains:${o}`);return}}async function v(m,o,n,i){if(n.length===0)return Promise.resolve(void 0);const r=new L.$me,s=m.checkExists(m.folders,n,r.token),t=setTimeout(async()=>{r.cancel(),m.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},P);let f=!1;try{f=await s}catch(d){R.$4(d)||R.$1(d)}r.dispose(),clearTimeout(t),f&&i(`workspaceContains:${n.join(",")}`)}function a(m,o,n,i){const r=m.get(M.$pi),s=m.get(b.$4K),f=r.createInstance(p.$tM).file(o.map(d=>(0,S.$Li)(N.URI.revive(d))),{_reason:"checkExists",includePattern:n,exists:!0});return s.fileSearch(f,i).then(d=>!!d.limitHit,d=>R.$4(d)?!1:Promise.reject(d))}}),define(ke[49],Ee([1,0,220,17,59,23,7,3,77,2,12,6,44,305,118,43,26,148,13,25,21,282,8,66,5,28,93,20,107,70,42,121,4,373,117,284,15,115,39,11,116]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f,d,l,c,h,g,D,w,k,y,C,I,F,j,z,O,T,B){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$4kc=e.$3kc=e.$2kc=e.$1kc=e.$Zkc=void 0,e.$Zkc=(0,d.$qi)("IHostUtils");let Z=W=class extends p.$Uc{constructor(U,ie,be,Pe,oe,ae,re,G,te,ge,we,Re,fe){super(),this.Y=Re,this.Z=fe,this.a=this.B(new y.$be),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ie,this.g=be,this.f=re,this.j=Pe,this.m=oe,this.s=ae,this.t=te,this.u=ge,this.w=we,this.y=this.g.getProxy(P.$PM.MainThreadWorkspace),this.z=this.g.getProxy(P.$PM.MainThreadTelemetry),this.C=this.g.getProxy(P.$PM.MainThreadExtensionService),this.D=new M.$ph,this.F=new M.$ph,this.G=new M.$ph,this.H=new M.$ph,this.I=new Ce(this.f.extensions.activationEvents),this.L=new o.$C$b(this.I,this.f.extensions.allExtensions);const Se=new i.$Mm(this.f.extensions.myExtensions);this.J=new o.$C$b(this.I,ne(this.L,Se)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Y(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Y(this.J)}`)),this.M=new v.$Ikc(this.g,this.s),this.N=new I.$Skc(this.g),this.O=G,this.h=U.createChild(new g.$oi([v.$Jkc,this.M],[I.$Tkc,this.N])),this.P=this.B(new E.$Hkc(this.J,this.L,{onExtensionActivationError:(Ae,Fe,q)=>{this.C.$onExtensionActivationError(Ae,n.$3(Fe),q)},actualActivateExtension:async(Ae,Fe)=>{if(o.$C$b.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,Fe),new E.$Gkc;const q=this.J.getExtensionDescription(Ae);return this.fb(q,Fe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),L.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){n.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(oe=>oe.identifier).filter(oe=>this.isActivated(oe)).map(oe=>this.eb(oe))}catch{}await Promise.all(U)}terminate(U,ie=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Pe=>{this.s.error(Pe)}),this.g.dispose();const be=this.$();Promise.race([(0,M.$rh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ie}`):this.s.info(`Extension host exiting with code ${ie}`),this.s.flush(),this.s.dispose(),this.c.exit(ie)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const ie=await this.C.$getExtension(U);return ie&&{...ie,identifier:new i.$Lm(ie.identifier.value),extensionLocation:S.URI.revive(ie.extensionLocation)}}ab(U,ie){return this.P.activateByEvent(U,ie)}bb(U,ie){return this.P.activateById(U,ie)}activateByIdWithErrors(U,ie){return this.bb(U,ie).then(()=>{const be=this.P.getActivatedExtension(U);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===j.Schemas.file&&this.c.fsRealpath){const ie=U.fsPath;this.R.has(ie)||this.R.set(ie,this.c.fsRealpath(ie));const be=await this.R.get(ie);return S.URI.file(be)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new $e(U))),this.Q}async db(U){const ie=b.$wi.forUris(be=>R.$Ug.ignorePathCasing(be));return await Promise.all(U.map(async be=>{if(this.wb(be)){const Pe=await this.cb(be.extensionLocation);ie.set(Pe,be)}})),ie}eb(U){let ie=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return ie;const be=this.P.getActivatedExtension(U);if(!be)return ie;try{typeof be.module.deactivate=="function"&&(ie=Promise.resolve(be.module.deactivate()).then(void 0,Pe=>(this.s.error(Pe),Promise.resolve(void 0))))}catch(Pe){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Pe)}try{(0,p.$Pc)(be.subscriptions)}catch(Pe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Pe)}return ie}async fb(U,ie){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,ie).then(be=>{const Pe=be.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Pe.codeLoadingTime,Pe.activateCallTime,Pe.activateResolvedTime,ie),this.gb(U,ie,"success",Pe),be},be=>{throw this.gb(U,ie,"failure"),be})}gb(U,ie,be,Pe){const oe=X(U,ie);this.z.$publicLog2("extensionActivationTimes",{...oe,...Pe||{},outcome:be})}hb(U,ie){const be=X(U,ie);this.z.$publicLog2("activatePlugin",be);const Pe=this.wb(U);if(!Pe)return Promise.resolve(new E.$Fkc(E.$Ckc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${U.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this.s.flush();const oe=new E.$Dkc(ie.startup);return Promise.all([this.xb(U,(0,R.$4g)(U.extensionLocation,Pe),oe),this.ib(U)]).then(ae=>(L.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),W.jb(this.s,U.identifier,ae[0],ae[1],oe))).then(ae=>(L.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),ae))}ib(U){const ie=this.Z.createLanguageModelAccessInformation(U),be=new s.$Lkc(U,this.M),Pe=new s.$Kkc(U.identifier.value,!1,this.M),oe=new F.$Ukc(U,this.N),ae=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,re=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([be.whenReady,Pe.whenReady,this.O.whenReady]).then(()=>{const G=this;let te,ge;const we=(0,m.$xG)(U,"ipc")?this.f.messagePorts?.get(i.$Lm.toKey(U.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Pe,secrets:oe,subscriptions:[],get languageModelAccessInformation(){return ie},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Re){return N.$kc(U.extensionLocation.fsPath,Re)},get storagePath(){return G.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return G.O.globalValue(U).fsPath},get logPath(){return N.$kc(G.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return S.URI.joinPath(G.f.logsLocation,U.identifier.value)},get storageUri(){return G.O.workspaceValue(U)},get globalStorageUri(){return G.O.globalValue(U)},get extensionMode(){return ae},get extension(){return te===void 0&&(te=new ce(G,U.identifier,U,re,!1)),te},get extensionRuntime(){return(0,m.$yG)(U,"extensionRuntime"),G.extensionRuntime},get environmentVariableCollection(){return G.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!ge){if(!we)return;const Re=y.Event.buffer(y.Event.fromDOMEventEmitter(we,"message",fe=>fe.data));we.start(),ge={onDidReceiveMessage:Re,postMessage:we.postMessage.bind(we)}}return ge}})})}static jb(U,ie,be,Pe,oe){return be=be||{activate:void 0,deactivate:void 0},this.kb(U,ie,be,Pe,oe).then(ae=>new E.$Ekc(!1,null,oe.build(),be,ae,Pe.subscriptions))}static kb(U,ie,be,Pe,oe){if(typeof be.activate=="function")try{oe.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const ae=typeof global=="object"?global:self,re=be.activate.apply(ae,[Pe]);return oe.activateCallStop(),oe.activateResolveStart(),Promise.resolve(re).then(G=>(oe.activateResolveStop(),G))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(be)}lb(U,ie){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:ie}).then(void 0,be=>{this.s.error(be)})}mb(U,ie=0){const Pe=Date.now();(0,T.$B)(()=>{for(let oe=ie;oe<U.length;oe+=1){const ae=U[oe];for(const re of ae.activationEvents??[])if(re==="onStartupFinished")if(Date.now()-Pe>50){this.mb(U,oe);break}else this.lb(ae,re)}})}nb(){this.C.$setPerformanceMarks(L.getMarks()),this.m.getConfigProvider().then(U=>{const ie=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(ie)this.mb(be);else for(const Pe of be)if(Pe.activationEvents)for(const oe of Pe.activationEvents)oe==="onStartupFinished"&&this.lb(Pe,oe)})}ob(){const U=this.ab("*",!0).then(void 0,ae=>{this.s.error(ae)});this.B(this.j.onDidChangeWorkspace(ae=>this.pb(ae.added)));const ie=this.j.workspace?this.j.workspace.folders:[],be=this.pb(ie),Pe=this.rb(),oe=Promise.all([Pe,U,be]).then(()=>{});return Promise.race([oe,(0,M.$rh)(1e4)]).then(()=>{this.nb()}),oe}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ie=>this.qb(U,ie))).then(()=>{})}async qb(U,ie){if(this.isActivated(ie.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,Pe={logService:this.s,folders:U.map(ae=>ae.uri),forceUsingSearch:be||!this.c.fsExists,exists:ae=>this.c.fsExists(ae.fsPath),checkExists:(ae,re,G)=>this.y.$checkExists(ae,re,G)},oe=await(0,C.$mtb)(Pe,ie);if(oe)return this.bb(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:oe.activationEvent}).then(void 0,ae=>this.s.error(ae))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:ie}=this.f.environment;if(!U||!ie)throw new Error(u.localize(0,null));const be=await this.xb(null,ie,new E.$Dkc(!1));if(!be||typeof be.run!="function")throw new Error(u.localize(1,null,ie.toString()));return new Promise((Pe,oe)=>{const ae=(te,ge)=>{te?(T.$t&&this.s.error("Test runner called back with error",te),oe(te)):(T.$t&&(ge?this.s.info(`Test runner called back with ${ge} failures.`):this.s.info("Test runner called back with successful outcome.")),Pe(typeof ge=="number"&&ge>0?1:0))},re=(0,R.$Rg)(ie),G=be.run(re,ae);G&&G.then&&G.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),Pe(0)}).catch(te=>{T.$t&&this.s.error("Test runner finished with error",te),oe(te instanceof Error&&te.stack?te.stack:String(te))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$rh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,ie){return this.S[U]=ie,(0,p.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:ie}=await this.ub(U);return ie?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const ie=U.indexOf("+");if(ie===-1)throw new t.$XM("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=U.substr(0,ie);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(U,ie){const be=O.$0d.create(!1),Pe=()=>`[resolveAuthority(${(0,f.$Fl)(U)},${ie})][${be.elapsed()}ms] `,oe=V=>this.s.info(`${Pe()}${V}`),ae=V=>this.s.warn(`${Pe()}${V}`),re=(V,Q=void 0)=>this.s.error(`${Pe()}${V}`,Q),G=V=>{if(V instanceof t.$XM)return{type:"error",error:{code:V._code,message:V._message,detail:V._detail}};throw V},te=async V=>{oe(`activating resolver for ${V}...`);const{resolver:Q,authorityPrefix:J}=await this.ub(V);if(!Q)throw re(`no resolver for ${J}`),new t.$XM(`No remote extension installed to resolve ${J}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:J,remoteAuthority:V}},ge=U.split(/@|%40/g).reverse();oe(`activating remote resolvers ${ge.join(" -> ")}`);let we;try{we=await Promise.all(ge.map(te)).catch(async V=>{if(!(V instanceof t.$XM)||V._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw V;return ae(`resolving nested authorities failed: ${V.message}`),[await te(U)]})}catch(V){return G(V)}const Re=new M.$Bh;Re.cancelAndSet(()=>oe("waiting..."),1e3);let fe,Se;for(const[V,{authorityPrefix:Q,resolver:J,remoteAuthority:he}]of we.entries())try{if(V===we.length-1)oe("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${Q}`),fe=await J.resolve(he,{resolveAttempt:ie,execServer:Se}),L.mark(`code/extHost/didResolveAuthorityOK/${Q}`),oe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,t.$WM.isManagedResolvedAuthority(fe)?fe:void 0));else{if(oe(`invoking resolveExecServer() for ${he}`),L.mark(`code/extHost/willResolveExecServer/${Q}`),Se=await J.resolveExecServer?.(he,{resolveAttempt:ie,execServer:Se}),!Se)throw new t.$XM(`Exec server was not available for ${he}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(pe){return L.mark(`code/extHost/didResolveAuthorityError/${Q}`),re("returned an error",pe),Re.dispose(),G(pe)}Re.dispose();const Ae={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures?{elevation:fe.tunnelFeatures.elevation,privacyOptions:fe.tunnelFeatures.privacyOptions,protocol:fe.tunnelFeatures.protocol===void 0?!0:fe.tunnelFeatures.protocol}:void 0},Fe={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};oe(`returned ${t.$WM.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let q;if(t.$WM.isManagedResolvedAuthority(fe)){const V=ie;this.Y.setFactory(V,fe.makeConnection),q={authority:U,connectTo:new f.$Cl(V),connectionToken:fe.connectionToken}}else q={authority:U,connectTo:new f.$Dl(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:q,options:Fe,tunnelInformation:Ae}}}async $getCanonicalURI(U,ie){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$Fl)(U)})`);const{resolver:be}=await this.ub(U);if(!be)return null;const Pe=S.URI.revive(ie);if(typeof be.getCanonicalURI>"u")return Pe;const oe=await(0,M.$ih)(()=>be.getCanonicalURI(Pe));return oe||Pe}async $startExtensionHost(U){U.toAdd.forEach(ae=>ae.extensionLocation=S.URI.revive(ae.extensionLocation));const{globalRegistry:ie,myExtensions:be}=x(this.I,this.L,this.J,U),Pe=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(be),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Y(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Y(this.J)}`)),this.tb()}$activateByEvent(U,ie){return ie===1?this.D.wait().then(be=>this.ab(U,!1)):this.G.wait().then(be=>this.ab(U,!1))}async $activate(U,ie){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,ie),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(ae=>ae.extensionLocation=S.URI.revive(ae.extensionLocation));const{globalRegistry:ie,myExtensions:be}=x(this.I,this.L,this.J,U),Pe=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(be),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Y(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Y(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const ie=r.$Ce.alloc(U),be=Math.random()%256;for(let Pe=0;Pe<U;Pe++)ie.writeUInt8(be,Pe);return ie}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$1kc=Z,e.$1kc=Z=W=Je([qe(0,d.$pi),qe(1,e.$Zkc),qe(2,h.$aP),qe(3,a.$lkc),qe(4,$.$okc),qe(5,A.$Wj),qe(6,l.$qP),qe(7,c.$rkc),qe(8,D.$oCb),qe(9,w.$Mkc),qe(10,z.$Wkc),qe(11,B.$Xkc),qe(12,k.$Qkc)],Z);function x(ee,U,ie,be){ee.addActivationEvents(be.addActivationEvents);const Pe=new o.$C$b(ee,U.getAllExtensionDescriptions());Pe.deltaExtensions(be.toAdd,be.toRemove);const oe=new i.$Mm(ie.getAllExtensionDescriptions().map(re=>re.identifier));for(const re of be.myToRemove)oe.delete(re);for(const re of be.myToAdd)oe.add(re);const ae=ne(Pe,oe);return{globalRegistry:Pe,myExtensions:ae}}function X(ee,U){return{id:ee.identifier.value,name:ee.name,extensionVersion:ee.version,publisherDisplayName:ee.publisher,activationEvents:ee.activationEvents?ee.activationEvents.join(","):null,isBuiltin:ee.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function Y(ee){return ee.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$2kc=(0,d.$qi)("IExtHostExtensionService");class ce{#e;#t;#i;constructor(U,ie,be,Pe,oe){this.#e=U,this.#t=ie,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=N.$ic((0,R.$Rg)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Pe,this.isFromDifferentExtensionHost=oe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$3kc=ce;function ne(ee,U){return ee.getAllExtensionDescriptions().filter(ie=>U.has(ie.identifier))}class $e{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$4kc=$e;class Ce{constructor(U){this.a=new i.$Nm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const ie of Object.keys(U))this.a.set(ie,U[ie])}}}),define(ke[374],Ee([1,0,59,2,6,44,26,25,20,28,5,49,12,14]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=void 0;let a=class{constructor(r,s,t,f,d,l,c){this.c=r,this.d=s,this.e=t,this.f=f,this.g=d,this.h=l,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),u.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new o(this.c,s,this.d,r,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,s,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const s of r.nodeModuleName)this.a.set(s,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(s=>r.alternativeModuleName(s))}};e.$amc=a,e.$amc=a=Je([qe(2,A.$pi),qe(3,R.$okc),qe(4,P.$2kc),qe(5,S.$qP),qe(6,$.$Wj)],a);let m=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&v.a.size){const s=(0,E.$8e)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${d}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const s=this.b.exec(this.c(r));if(!s)return;const[,t,f,d]=s,l=v.a.get(f);if(l!==void 0)return console.warn(`${f} as been renamed to ${l}, please update your imports`),t+l+d}c(r){return r.replace(/\\/g,"/")}};m=v=Je([qe(0,S.$qP)],m);class o{constructor(r,s,t,f,d){this.c=r,this.d=s,this.e=t,this.f=f,this.g=d,this.nodeModuleName="vscode",this.a=new p.$Nm}load(r,s){const t=this.d.findSubstr(s);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((d,l)=>f+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${f}`),this.b=this.c(M.$sG,this.e,this.f)}return this.b}}let n=class{constructor(r,s,t){this.e=r,this.f=s,this.nodeModuleName=["open","opn"],this.d=t.getProxy(L.$PM.MainThreadTelemetry);const f=t.getProxy(L.$PM.MainThreadWindow);this.c=(d,l)=>{const c=N.URI.parse(d);return l?this.g(d,l):c.scheme==="http"||c.scheme==="https"?f.$openUri(c,d,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?f.$openUri(c,d,{}):this.g(d,l)}}load(r,s,t){const f=this.e.findSubstr(s);return f&&(this.a=f.identifier.value,this.h()),this.b=t(r),this.c}g(r,s){return this.i(),this.b(r,s)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([qe(2,b.$aP)],n)}),define(ke[61],Ee([1,0,46,3,17,51,5,72,71,49,8,43,302,44]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=e.$5kc=void 0,e.$5kc=(0,M.$qi)("IExtHostVariableResolverProvider");class v extends $.$cQ{constructor(o,n,i,r,s,t,f){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const c=r.tabGroups.all.find(h=>h.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof A.$CO||c.input instanceof A.$HO)return c.input.modified;if(c.input instanceof A.$BO||c.input instanceof A.$GO||c.input instanceof A.$EO)return c.input.uri}}}super({getFolderUri:l=>{const c=t.folders.filter(h=>h.name===l);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,c)=>s.getConfiguration(void 0,l).get(c),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return L.$ic(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const l=d();if(l){const c=n.getWorkspaceFolder(l);if(c)return L.$ic(c.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>o.getExtension(l)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(R.env))}}let a=class extends N.$Uc{constructor(o,n,i,r,s){super(),this.b=o,this.c=n,this.g=i,this.h=r,this.j=s,this.a=new u.$V(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$6kc=a,e.$6kc=a=Je([qe(0,S.$2kc),qe(1,P.$lkc),qe(2,p.$lP),qe(3,E.$okc),qe(4,b.$Akc)],a)}),define(ke[96],Ee([1,0,7,4,2,25,5,6,71,49,20,8,43,143,294,44,61,3,57,33,16]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=e.$0kc=e.$9kc=e.$8kc=e.$7kc=void 0,e.$7kc=(0,M.$qi)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(g,D,w,k,y,C,I){this.N=D,this.O=w,this.P=k,this.Q=y,this.R=C,this.S=I,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$be,this.o=new N.$be,this.q=new N.$be,this.w=new N.$be,this.l=g.getProxy(p.$PM.MainThreadDebugService),this.A=new N.$be,this.C=new N.$be,this.y=new f(this.l),this.z=new Map,this.O.getExtensionRegistry().then(F=>{F.onDidChange(j=>{this.V(F)}),this.V(F)})}async $getVisualizerTreeItem(g,D){const w=this.W(D);if(!w)return;const k=await this.H.get(g)?.getTreeItem?.(w);return k?this.U(g,k):void 0}registerDebugVisualizationTree(g,D,w){const k=R.$Lm.toKey(g.identifier),y=this.jb(k,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,w),this.l.$registerDebugVisualizerTree(y,!!w.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren(g,D){const w=this.J.get(D)?.item;return w?(await this.H.get(g)?.getChildren?.(w))?.map(y=>this.U(g,y))||[]:[]}async $editVisualizerTreeItem(g,D){const w=this.J.get(g);if(!w)return;const k=await this.H.get(w.provider)?.editItem?.(w.item,D);return this.U(w.provider,k||w.item)}$disposeVisualizedTree(g){const D=this.J.get(g);if(!D)return;const w=[D.children];for(const k of w)if(k)for(const y of k)w.push(this.J.get(y)?.children),this.J.delete(y)}U(g,D){let w=this.I.get(D);return w||(w=this.F++,this.I.set(D,w),this.J.set(w,{provider:g,item:D})),r.DebugTreeItem.from(D,w)}asDebugSourceUri(g,D){const w=g;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let k=`debug:${encodeURIComponent(w.path||"")}`,y="?";return D&&(k+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),k+=`${y}ref=${w.sourceReference}`,L.URI.parse(k)}else{if(w.path)return L.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(g){const D=[];for(const w of g.getAllExtensionDescriptions())if(w.contributes){const k=w.contributes.debuggers;if(k&&k.length>0)for(const y of k)(0,v.$_G)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const g=[];return this.z.forEach(D=>g.push(D)),g}async $resolveDebugVisualizer(g,D){const w=this.L.get(g);if(!w)throw new Error(`No debug visualizer found with id '${g}'`);let{v:k,provider:y,extensionId:C}=w;if(k.visualization||(k=await y.resolveDebugVisualization?.(k,D)||k,w.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(C,k.visualization)}async $executeDebugVisualizerCommand(g){const D=this.L.get(g);if(!D)throw new Error(`No debug visualizer found with id '${g}'`);const w=D.v.visualization;w&&"command"in w&&this.S.executeCommand(w.command,...w.arguments||[])}W(g){const D=this.m.get(g.sessionId);return D&&{session:D.api,variable:g.variable,containerId:g.containerId,frameId:g.frameId,threadId:g.threadId}}async $provideDebugVisualizers(g,D,w,k){const y=this.W(w),C=this.jb(g,D),I=this.G.get(C);if(!y||!I)return[];const F=await I.provideDebugVisualization(y,k);return F?F.map(j=>{const z=++this.M;this.L.set(z,{v:j,provider:I,extensionId:g});const O=j.iconPath?this.lb(j.iconPath):void 0;return{id:z,name:j.name,iconClass:O?.iconClass,iconPath:O?.iconPath,visualization:this.kb(g,j.visualization)}}):[]}$disposeDebugVisualizers(g){for(const D of g)this.L.delete(D)}registerDebugVisualizationProvider(g,D,w){if(!g.contributes?.debugVisualizers?.some(C=>C.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const k=R.$Lm.toKey(g.identifier),y=this.jb(k,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,w),this.l.$registerDebugVisualizer(k,D),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(k,D),this.G.delete(D)})}addBreakpoints(g){const D=g.filter(y=>{const C=y.id;return this.z.has(C)?!1:(this.z.set(C,y),!0)});this.gb(D,[],[]);const w=[],k=new Map;for(const y of D)if(y instanceof P.$SN){let C=k.get(y.location.uri.toString());C||(C={type:"sourceMulti",uri:y.location.uri,lines:[]},k.set(y.location.uri.toString(),C),w.push(C)),C.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof P.$TN&&w.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(w)}removeBreakpoints(g){const D=g.filter(C=>this.z.delete(C.id));this.gb([],D,[]);const w=D.filter(C=>C instanceof P.$SN).map(C=>C.id),k=D.filter(C=>C instanceof P.$TN).map(C=>C.id),y=D.filter(C=>C instanceof P.$UN).map(C=>C.id);return this.l.$unregisterBreakpoints(w,k,y)}startDebugging(g,D,w){return this.l.$startDebugging(g?g.uri:void 0,D,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(g){return this.l.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,D,w){if(!D)return new P.$RM(()=>{});const k=this.d++;return this.f.push({type:g,handle:k,provider:D}),this.l.$registerDebugConfigurationProvider(g,w,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,k),new P.$RM(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(g,D,w){if(!w)return new P.$RM(()=>{});if(!this.cb(g,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:D,handle:k,factory:w}),this.l.$registerDebugAdapterDescriptorFactory(D,k),new P.$RM(()=>{this.h=this.h.filter(y=>y.factory!==w),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(g,D){if(!D)return new P.$RM(()=>{});const w=this.j++;return this.k.push({type:g,handle:w,factory:D}),new P.$RM(()=>{this.k=this.k.filter(k=>k.factory!==D)})}async $runInTerminal(g,D){return Promise.resolve(void 0)}async $substituteVariables(g,D){let w;const k=await this.ib(g);return k&&(w={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(w,D)}X(g,D){if(g.type==="implementation")return new l(g.implementation)}Y(){}async $startDASession(g,D){const w=this,k=await this.hb(D);return this.eb(this.$(k.type),k).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const C=this.Z(y),I=this.X(C,k);if(!I)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const F=I;return this.D.set(g,F),this.db(k).then(j=>(j&&this.E.set(g,j),F.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const O=z,T={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const B=await this.K.sign(O.arguments.value);T.body={signature:B},F.sendResponse(T)}else throw new Error("no signer")}catch(B){T.success=!1,T.message=B.message,F.sendResponse(T)}}else j&&j.onDidSendMessage&&j.onDidSendMessage(z),z=(0,v.$eH)(z,!0),w.l.$acceptDAMessage(g,z)}),F.onError(z=>{j&&j.onError&&j.onError(z),this.l.$acceptDAError(g,z.name,z.message,z.stack)}),F.onExit(z=>{j&&j.onExit&&j.onExit(z??void 0,void 0),this.l.$acceptDAExit(g,z??void 0,void 0)}),j&&j.onWillStartSession&&j.onWillStartSession(),F.startSession()))})}$sendDAMessage(g,D){D=(0,v.$dH)(D,!1);const w=this.E.get(g);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(D),this.D.get(g)?.sendMessage(D)}$stopDASession(g){const D=this.E.get(g);this.E.delete(g),D&&D.onWillStopSession&&D.onWillStopSession();const w=this.D.get(g);return this.D.delete(g),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const D=[],w=[],k=[];if(g.added)for(const y of g.added){const C=y.id;if(C&&!this.z.has(C)){let I;if(y.type==="function")I=new P.$TN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")I=new P.$UN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const F=L.URI.revive(y.uri);I=new P.$SN(new P.$4M(F,new P.$SM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,P.$QN)(I,C),this.z.set(C,I),D.push(I)}}if(g.removed)for(const y of g.removed){const C=this.z.get(y);C&&(this.z.delete(y),w.push(C))}if(g.changed){for(const y of g.changed)if(y.id){const C=this.z.get(y.id);if(C){if(C instanceof P.$TN&&y.type==="function"){const I=C;I.enabled=y.enabled,I.condition=y.condition,I.hitCondition=y.hitCondition,I.logMessage=y.logMessage,I.functionName=y.functionName}else if(C instanceof P.$SN&&y.type==="source"){const I=C;I.enabled=y.enabled,I.condition=y.condition,I.hitCondition=y.hitCondition,I.logMessage=y.logMessage,I.location=new P.$4M(L.URI.revive(y.uri),new P.$SM(y.line,y.character))}k.push(C)}}}this.gb(D,w,k)}async $acceptStackFrameFocus(g){let D;if(g){const w=await this.hb(g.sessionId);g.kind==="thread"?D=new P.$1N(w.api,g.threadId):D=new P.$ZN(w.api,g.threadId,g.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(g,D,w){return(0,u.$ih)(async()=>{const k=this.bb(g);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return k.provideDebugConfigurations(y,w)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(g,D,w,k){return(0,u.$ih)(async()=>{const y=this.bb(g);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(D);return y.resolveDebugConfiguration(C,w,k)})}$resolveDebugConfigurationWithSubstitutedVariables(g,D,w,k){return(0,u.$ih)(async()=>{const y=this.bb(g);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(C,w,k)})}async $provideDebugAdapter(g,D){const w=this.ab(g);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(D);return this.eb(w,k).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(g){const D=await this.hb(g);this.n.fire(D.api)}async $acceptDebugSessionTerminated(g){const D=await this.hb(g);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(g){this.u=g?await this.hb(g):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(g,D){(await this.hb(g))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(g,D){const k={session:(await this.hb(g)).api,event:D.event,body:D.body};this.w.fire(k)}Z(g){if(g instanceof P.$VN)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof P.$WN)return{type:"server",port:g.port,host:g.host};if(g instanceof P.$XN)return{type:"pipeServer",path:g.path};if(g instanceof P.$YN)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}$(g){const D=this.h.filter(w=>w.type===g);if(D.length>0)return D[0].factory}ab(g){const D=this.h.filter(w=>w.handle===g);if(D.length>0)return D[0].factory}bb(g){const D=this.f.filter(w=>w.handle===g);if(D.length>0)return D[0].provider}cb(g,D){if(g.contributes){const w=g.contributes.debuggers;if(w&&w.length>0){for(const k of w)if(k.label&&k.type&&k.type===D)return!0}}return!1}db(g){const w=g.configuration.type,k=this.k.filter(y=>y.type===w||y.type==="*").map(y=>(0,u.$ih)(()=>y.factory.createDebugAdapterTracker(g.api)).then(C=>C,C=>null));return Promise.race([Promise.all(k).then(y=>{const C=y.filter(I=>!!I);if(C.length>0)return new d(C)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(g,D){const w=D.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new P.$WN(w));if(g){const y=await this.O.getExtensionRegistry();return(0,u.$ih)(()=>g.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(C=>{if(C)return C})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,k))}fb(g,D){}gb(g,D,w){(g.length>0||D.length>0||w.length>0)&&this.A.fire(Object.freeze({added:g,removed:D,changed:w}))}async hb(g){if(g)if(typeof g=="string"){const D=this.m.get(g);if(D)return D}else{let D=this.m.get(g.id);if(!D){const w=await this.ib(g.folderUri),k=g.parent?this.m.get(g.parent):void 0;D=new t(this.l,g.id,g.type,g.name,w,g.configuration,k?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(g){if(g){const D=L.URI.revive(g);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(g,D){return`${g}\0${D}`}kb(g,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${g}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(g){const D=this.mb(g);let w,k;return"id"in D?k=n.ThemeIcon.asClassName(D):w=D,{iconPath:w,iconClass:k}}mb(g){if(g instanceof P.$NN)return{id:g.id};const D=typeof g=="object"&&"dark"in g?g.dark:g,w=typeof g=="object"&&"light"in g?g.light:g;return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof w=="string"?L.URI.file(w):w}}};e.$8kc=s,e.$8kc=s=Je([qe(0,A.$aP),qe(1,$.$lkc),qe(2,S.$2kc),qe(3,a.$okc),qe(4,b.$Akc),qe(5,m.$5kc),qe(6,i.$wP)],s);class t{constructor(g,D,w,k,y,C,I){this.f=g,this.g=D,this.h=w,this.j=k,this.k=y,this.l=C,this.m=I}get api(){const g=this;return this.d??=Object.freeze({id:g.g,type:g.h,get name(){return g.j},set name(D){g.j=D,g.f.$setDebugSessionName(g.g,D)},parentSession:g.m,workspaceFolder:g.k,configuration:g.l,customRequest(D,w){return g.f.$customDebugAdapterRequest(g.g,D,w)},getDebugProtocolBreakpoint(D){return g.f.$getDebugProtocolBreakpoint(g.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(g){this.j=g}get configuration(){return this.l}}e.$9kc=t;class f{constructor(g){this.value=Object.freeze({append(D){g.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$0kc=f;class d{constructor(g){this.d=g}onWillStartSession(){this.d.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(g):void 0)}onWillStopSession(){this.d.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.d.forEach(D=>D.onError?D.onError(g):void 0)}onExit(g,D){this.d.forEach(w=>w.onExit?w.onExit(g,D):void 0)}}class l extends E.$sob{constructor(g){super(),this.h=g,g.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.h.handleMessage(g)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let c=class extends s{constructor(g,D,w,k,y,C,I){super(g,D,w,k,y,C,I)}};e.$$kc=c,e.$$kc=c=Je([qe(0,A.$aP),qe(1,$.$lkc),qe(2,S.$2kc),qe(3,a.$okc),qe(4,b.$Akc),qe(5,m.$5kc),qe(6,i.$wP)],c)}),define(ke[375],Ee([1,0,13,59,2,6,322,12,84,107,28,258,20,67,49,90]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=e.$bmc=void 0;class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(p.$Wj),t=i.get($.$aP).getProxy(R.$PM.MainThreadErrors);u.setUnexpectedErrorHandler(f=>{r.error(f);const d=u.$3(f);t.$onUnexpectedError(d)})}static async installFullHandler(i){const r=i.get(p.$Wj),s=i.get($.$aP),t=i.get(v.$2kc),f=i.get(a.$uP),d=s.getProxy(R.$PM.MainThreadExtensionService),l=s.getProxy(R.$PM.MainThreadErrors),c=await t.getExtensionPathIndex(),h=new WeakMap;function g(k,y){if(h.has(k))return h.get(k).stack;let C="",I,F;for(const z of y)C+=`
	at ${z.toString()}`,F=z.getFileName(),!I&&F&&(I=c.findSubstr(L.URI.file(F)));const j=`${k.name||"Error"}: ${k.message||""}${C}`;return h.set(k,{extensionIdentifier:I?.identifier,stack:j}),j}const D=Symbol("prepareStackTrace wrapped");let w=g;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(k){if(k===g||!k||k[D]){w=k||g;return}w=function(y,C){return g(y,C),k.call(Error,y,C)},Object.assign(w,{[D]:!0})}}),u.setUnexpectedErrorHandler(k=>{r.error(k);const y=u.$3(k),C=h.get(k);if(!C?.extensionIdentifier){l.$onUnexpectedError(y);return}d.$onExtensionRuntimeError(C.extensionIdentifier,y);const I=f.onExtensionError(C.extensionIdentifier,k);r.trace("forwarded error to extension?",I,C)})}}e.$bmc=m;class o{constructor(i,r,s,t,f){this.a=s,this.b=new M.$K$b(i,null,t),r=o.e(r,this.b);const d=new S.$oi(...(0,b.$ps)());d.set(A.$qP,{_serviceBrand:void 0,...r,messagePorts:f}),d.set($.$aP,new $.$bP(this.b)),d.set(E.$ikc,new E.$jkc(t)),d.set(v.$Zkc,s);const l=new P.$7q(d,!0);l.invokeFunction(m.installEarlyHandler),this.d=l.invokeFunction(c=>c.get(p.$Wj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=l.invokeFunction(c=>c.get(v.$2kc)),this.c.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(R.$PM.MainThreadExtensionService);return L.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=L.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const s=i.environment.extensionDevelopmentLocationURI;return s&&(i.environment.extensionDevelopmentLocationURI=s.map(t=>L.URI.revive(r.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=L.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=L.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=L.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=L.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=L.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=L.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$cmc=o}),define(ke[376],Ee([1,0,7,11,231,251,141,96,71,49,20,42,8,61,43,295,296,44,33,377]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=void 0;let r=class extends p.$8kc{constructor(c,h,g,D,w,k,y,C){super(c,h,g,D,k,y,C),this.pb=w,this.nb=new d}X(c,h){switch(c.type){case"server":return new a.$hmc(c);case"pipeServer":return new a.$imc(c);case"executable":return new a.$jmc(c,h.type)}return super.X(c,h)}fb(c,h){const g=a.$jmc.platformAdapterExecutable(h.getAllExtensionDescriptions(),c.type);if(g)return new $.$VN(g.command,g.args,g.options)}Y(){return new M.$ycc}async $runInTerminal(c,h){if(c.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(T=>{this.nb.onTerminalClosed(T)}));const g=await this.P.getConfigProvider(),D=this.pb.getDefaultShell(!0),w=this.pb.getDefaultShellArgs(!0),k=c.title||L.localize(0,null),y=s(D,w,c);let C=await this.nb.checkout(y,k,!0),I,F=!1;if(C)I=c.cwd;else{const T={shellPath:D,shellArgs:w,cwd:c.cwd,name:k,iconPath:new $.$NN("debug"),env:c.env};F=!0,C=this.pb.createTerminalFromOptions(T,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(C,y)}C.show(!0);const j=await C.processId;F?await new Promise(T=>setTimeout(T,1e3)):(C.state.isInteractedWith&&C.sendText(""),g.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?C.sendText("cls"):D.indexOf("bash")>=0?C.sendText("clear"):N.$i?C.sendText("cls"):C.sendText("clear")));const z=(0,m.$lmc)(D,c.args,!!c.argsCanBeInterpretedByShell,I);C.sendText(z);const O=this.onDidTerminateDebugSession(T=>{T.id===h&&(this.nb.free(C),O.dispose())});return j}else if(c.kind==="external")return f(c,await this.P.getConfigProvider());return super.$runInTerminal(c,h)}};e.$mmc=r,e.$mmc=r=Je([qe(0,A.$aP),qe(1,v.$lkc),qe(2,S.$2kc),qe(3,o.$okc),qe(4,P.$Mkc),qe(5,b.$Akc),qe(6,E.$5kc),qe(7,n.$wP)],r);function s(l,c,h){const g=(0,i.createHash)("sha256");return g.update(JSON.stringify({shell:l,shellArgs:c})),g.update(JSON.stringify(Object.entries(h.env||{}).sort(([D],[w])=>D.localeCompare(w)))),g.digest("base64")}let t;function f(l,c){if(!t)if(N.$i)t=new R.$jbc;else if(N.$j)t=new R.$kbc;else if(N.$k)t=new R.$lbc;else throw new Error("external terminals not supported on this platform");const h=c.getConfiguration("terminal");return t.runInTerminal(l.title,l.cwd,l.args,l.env||{},h.external||{})}class d{constructor(){this.b=new Map}static{this.a=1e3}async checkout(c,h,g=!1){const w=[...this.b.entries()].map(([k,y])=>(0,u.$dh)(async C=>{if(k.name!==h||y.lastUsedAt!==-1&&await(0,m.$kmc)(await k.processId))return null;const I=Date.now();return y.lastUsedAt+d.a>I||C.isCancellationRequested?null:y.config!==c?(g&&k.dispose(),null):(y.lastUsedAt=I,k)}));return await(0,u.$vh)(w,k=>!!k)}insert(c,h){this.b.set(c,{lastUsedAt:Date.now(),config:h})}free(c){const h=this.b.get(c);h&&(h.lastUsedAt=-1)}onTerminalClosed(c){this.b.delete(c)}}}),define(ke[378],Ee([1,0,17,2,105,43,72,44,41,42,20,28,95,15,12,91,23,64,61]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0;let i=class extends $.$Qlc{constructor(s,t,f,d,l,c,h,g,D){super(s,t,f,d,l,c,h,g),this.C=f,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(E.Schemas.file,{scheme:E.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,t){const f=t;if(!t.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const d=$.TaskHandleDTO.from(f,this.C),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.z(l,t);return this.a.$executeTask(d).catch(()=>{}),c}else{const d=$.TaskDTO.from(t,s);if(d===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(d.execution)&&await this.y(d,t,!1);const l=await this.z(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),l}}v(s,t,f,d){const l=[];if(d)for(const c of d){this.A(c,f),(!c.definition||!s[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const h=$.TaskDTO.from(c,f.extension);h&&(l.push(h),$.CustomExecutionDTO.is(h.execution)&&t.push(this.y(h,c,!0)))}return{tasks:l,extension:f.extension}}async w(s){return s}async G(s){let t=s&&s.length>0?s[0]:void 0;if(!t){const f=N.URI.file((0,o.homedir)());t=new b.$Ki({uri:f,name:m.$1g(f),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,t){const f=N.URI.revive(s),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(f),c=await this.b.getWorkspaceFolders2()??[],h=await this.D.getResolver(),g=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(c);for(const D of t.variables)d.variables[D]=await h.resolveAsync(g,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(u.$uc);for(let w=0;w<D.length;w++)D[w]=await h.resolveAsync(g,D[w])}d.process=await L.win32.findExecutable(await h.resolveAsync(g,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(g,t.process.cwd):void 0,D)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(s,t,f){return L.win32.findExecutable(s,t,f)}};e.$emc=i,e.$emc=i=Je([qe(0,A.$aP),qe(1,P.$qP),qe(2,R.$lkc),qe(3,M.$lP),qe(4,p.$okc),qe(5,S.$Mkc),qe(6,v.$Wj),qe(7,a.$2jc),qe(8,n.$5kc)],i)}),define(ke[379],Ee([1,0,64,61]),function(le,e,u,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=void 0;class L extends N.$6kc{m(){return(0,u.homedir)()}}e.$Wmc=L}),define(ke[159],Ee([1,0,19,7,22,47,15,17,23,2,36]),function(le,e,u,N,L,R,M,p,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=e.$nlc=e.$mlc=void 0,e.$olc=a;class P{constructor(n,i,r){this.d=n,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const r=this.g.folderQueries||[],s=new L.$me(i);return new Promise((t,f)=>{this.a=new E(n);let d=!1;const l=(c,h)=>{if(!d&&!this.b){const g=this.h(c);a(c)&&typeof this.g.maxResults=="number"&&this.c+g>this.g.maxResults&&(this.b=!0,d=!0,s.cancel(),c=this.j(c,this.g.maxResults-this.c));const D=this.h(c);this.c+=D,(D>0||!a(c))&&this.a.add(c,h)}};Promise.all(r.map((c,h)=>this.k(c,g=>l(g,h),s.token))).then(c=>{s.dispose(),this.a.flush();const h=c.some(g=>!!g&&!!g.limitHit);t({limitHit:this.b||h,messages:(0,u.$Rb)(c.map(g=>g?.message?Array.isArray(g.message)?g.message:[g.message]:[])),stats:{type:this.f}})},c=>{s.dispose();const h=(0,R.$bj)(c);f(new Error(h))})})}h(n){return a(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const r=Array.isArray(n.ranges)?n.ranges:[n.ranges],s=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:r.slice(0,i),preview:{matches:s.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,r){const s=new A.$kL(this.g,n),t=[],f={report:c=>{if(!this.l(c))return;const h=n.folder.scheme===M.Schemas.file?(0,A.$lL)(()=>this.e.readdir(b.$3g(c.uri))):void 0,g=b.$6g(n.folder,c.uri);if(g){const D=s.includedInQuery(g,p.$oc(g),h);(0,N.$ch)(D)?t.push(D.then(w=>{w&&i(c)})):D&&i(c)}}},d=this.n(n);let l;return this.d.query.type===3?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,f,r):l=await this.d.provider.provideTextSearchResults($(this.d.query.contentPattern),d,f,r),t.length&&await Promise.all(t),l}l(n){if(a(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,A.$jL)(this.g.includePattern,n.includePattern),r=(0,A.$jL)(this.g.excludePattern,n.excludePattern),s={folder:S.URI.from(n.folder),excludes:r,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(s.usePCRE2=this.g.usePCRE2),s}}e.$mlc=P;function $(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class E{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new m(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!b.$Wg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$nlc=E;function v(o){return a(o)?{preview:{matches:(0,u.$2b)(o.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:o.preview.text},ranges:(0,u.$2b)(o.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function a(o){return!!o.preview}class m{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$plc=m}),define(ke[97],Ee([1,0,3,6,5,371,20,67,12,2,159]),function(le,e,u,N,L,R,M,p,b,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=e.$qlc=void 0,e.$slc=$,e.$qlc=(0,L.$qi)("IExtHostSearch");let P=class{constructor(a,m,o){this.n=a,this.o=m,this.q=o,this.c=this.n.getProxy(N.$PM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$llc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,m){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const o=this.d++;return this.e.set(o,m),this.c.$registerTextSearchProvider(o,this.s(a)),(0,u.$Sc)(()=>{this.g.delete(a),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(a,m){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const o=this.d++;return this.h.set(o,m),this.c.$registerAITextSearchProvider(o,this.s(a)),(0,u.$Sc)(()=>{this.i.delete(a),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(a,m){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const o=this.d++;return this.j.set(o,m),this.c.$registerFileSearchProvider(o,this.s(a)),(0,u.$Sc)(()=>{this.k.delete(a),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(a,m,o,n){const i=$(o),r=this.j.get(a);if(r)return this.l.fileSearch(i,r,s=>{this.c.$handleFileMatch(a,m,s.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,m,o){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,m,o,n){const i=this.e.get(a);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${a}`);const r=$(o);return this.t(r,i).search(t=>this.c.$handleTextMatch(a,m,t),n)}$provideAITextSearchResults(a,m,o,n){const i=this.h.get(a);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${a}`);const r=$(o);return this.v(r,i).search(t=>this.c.$handleTextMatch(a,m,t),n)}$enableExtensionHostSearch(){}t(a,m){return new A.$mlc({query:a,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(a,m){return new A.$mlc({query:a,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$rlc=P,e.$rlc=P=Je([qe(0,M.$aP),qe(1,p.$ikc),qe(2,b.$Wj)],P);function $(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(E),extraFileResources:v.extraFileResources&&v.extraFileResources.map(a=>S.URI.revive(a))}}function E(v){return{...v,folder:S.URI.revive(v.folder)}}}),define(ke[380],Ee([1,0,22,13,4,3,15,40,2,135,198,179,79,25,32,12,86,87,277,6,324,350,91,120,328,329,330,311,300,33,331,44,332,96,151,333,313,325,334,335,72,71,326,49,336,69,337,60,28,351,352,314,338,121,339,115,116,315,370,341,283,342,353,343,157,316,344,345,346,20,347,97,117,348,317,349,118,93,95,90,42,155,354,355,327,356,357,70,16,8,318,67,319,92,358,359,150,43,293,114,26,94]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f,d,l,c,h,g,D,w,k,y,C,I,F,j,z,O,T,B,W,Z,x,X,Y,ce,ne,$e,Ce,ee,U,ie,be,Pe,oe,ae,re,G,te,ge,we,Re,fe,Se,Ae,Fe,q,V,Q,J,he,pe,ze,Ve,Ze,tt,ot,it,st,De,Be,He,Le,Xe,se,ue,Ie,Ge,Me,nt,lt,wt,It,jt,Kt,xt,St,qt,Ht,et,ri){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=_t;function _t(ft){const $t=ft.get($e.$qP),ei=ft.get(ne.$6jc),ti=ft.get(Y.$qkc),zt=ft.get(x.$2kc),gt=ft.get(St.$lkc),Bt=ft.get(st.$uP),ii=ft.get(k.$okc),Ot=ft.get(lt.$ikc),xe=ft.get(Q.$aP),si=ft.get(tt.$Jkc),Gt=ft.get(ot.$rkc),Ut=ft.get(a.$Xj),mt=ft.get(a.$Wj),Tt=ft.get(Ie.$oCb),Lt=ft.get(t.$2jc),Wt=ft.get(xt.$8lc),Jt=ft.get(pe.$Tkc),Qt=ft.get(W.$Akc),oi=ft.get(ae.$Xkc),At=ft.get(f.$_jc),Nt=ft.get(be.$Qkc);xe.set(i.$QM.ExtHostFileSystemInfo,ei),xe.set(i.$QM.ExtHostLogLevelServiceShape,Ut),xe.set(i.$QM.ExtHostWorkspace,gt),xe.set(i.$QM.ExtHostConfiguration,ii),xe.set(i.$QM.ExtHostExtensionService,zt),xe.set(i.$QM.ExtHostStorage,si),xe.set(i.$QM.ExtHostTunnelService,Tt),xe.set(i.$QM.ExtHostWindow,Wt),xe.set(i.$QM.ExtHostSecretState,Jt),xe.set(i.$QM.ExtHostTelemetry,Bt),xe.set(i.$QM.ExtHostEditorTabs,Qt),xe.set(i.$QM.ExtHostManagedSockets,oi),xe.set(i.$QM.ExtHostAuthentication,At),xe.set(i.$QM.ExtHostChatProvider,Nt);const Ct=xe.set(i.$QM.ExtHostDecorations,ft.get(I.$alc)),Dt=xe.set(i.$QM.ExtHostDocumentsAndEditors,ft.get(B.$lP)),pt=xe.set(i.$QM.ExtHostCommands,ft.get(D.$wP)),Pt=xe.set(i.$QM.ExtHostTerminalService,ft.get(De.$Mkc)),li=xe.set(i.$QM.ExtHostTerminalShellIntegration,ft.get(Be.$Tlc)),kt=xe.set(i.$QM.ExtHostDebugService,ft.get(C.$7kc)),hi=xe.set(i.$QM.ExtHostSearch,ft.get(he.$qlc)),Zt=xe.set(i.$QM.ExtHostTask,ft.get(it.$Slc)),ai=xe.set(i.$QM.ExtHostOutputService,ft.get(Se.$Flc)),bi=xe.set(i.$QM.ExtHostLocalization,ft.get(oe.$Wkc)),ni=xe.set(i.$QM.ExtHostUrls,new wt.$5lc(xe)),Rt=xe.set(i.$QM.ExtHostDocuments,new T.$9jc(xe,Dt)),yi=xe.set(i.$QM.ExtHostDocumentContentProviders,new z.$clc(xe,Dt,mt)),Ne=xe.set(i.$QM.ExtHostDocumentSaveParticipant,new O.$dlc(mt,Rt,xe.getProxy(i.$PM.MainThreadBulkEdits))),je=xe.set(i.$QM.ExtHostNotebook,new G.$tlc(xe,pt,Dt,Rt,ti,hi)),ye=xe.set(i.$QM.ExtHostNotebookDocuments,new ge.$zlc(je)),_=xe.set(i.$QM.ExtHostNotebookEditors,new we.$Alc(mt,je)),Oe=xe.set(i.$QM.ExtHostNotebookKernels,new Re.$Blc(xe,$t,je,pt,mt)),Ke=xe.set(i.$QM.ExtHostNotebookRenderers,new fe.$Dlc(xe,je)),_e=xe.set(i.$QM.ExtHostNotebookDocumentSaveParticipant,new te.$ylc(mt,je,xe.getProxy(i.$PM.MainThreadBulkEdits))),Qe=xe.set(i.$QM.ExtHostEditors,new Le.$fkc(xe,Dt)),ht=xe.set(i.$QM.ExtHostTreeViews,new ue.$3lc(xe.getProxy(i.$PM.MainThreadTreeViews),pt,mt)),Et=xe.set(i.$QM.ExtHostEditorInsets,new g.$gkc(xe.getProxy(i.$PM.MainThreadEditorInsets),Qe,$t.remote)),Ft=xe.set(i.$QM.ExtHostDiagnostics,new F.$8jc(xe,mt,ei,Dt)),Xt=xe.set(i.$QM.ExtHostLanguages,new Pe.$wlc(xe,Rt,pt.converter,Ot)),ut=xe.set(i.$QM.ExtHostLanguageFeatures,new ie.$0jc(xe,Ot,Rt,pt,Ft,mt,Lt,Bt)),Yt=xe.set(i.$QM.ExtHostFileSystem,new X.$flc(xe,ut)),mi=xe.set(i.$QM.ExtHostFileSystemEventService,new ce.$glc(xe,mt,Dt)),pi=xe.set(i.$QM.ExtHostQuickOpen,(0,V.$Jlc)(xe,gt,pt)),Si=xe.set(i.$QM.ExtHostSCM,new J.$Llc(xe,pt,Rt,mt)),Mi=xe.set(i.$QM.ExtHostQuickDiff,new q.$Ilc(xe,Ot)),Li=xe.set(i.$QM.ExtHostShare,new ze.$Mlc(xe,Ot)),Vi=xe.set(i.$QM.ExtHostComments,(0,w.$hkc)(xe,pt,Rt)),Ki=xe.set(i.$QM.ExtHostProgress,new Fe.$Hlc(xe.getProxy(i.$PM.MainThreadProgress))),Hi=xe.set(i.$QM.ExtHostLabelService,new U.$vlc(xe)),Di=xe.set(i.$QM.ExtHostTheming,new Xe.$Zlc(xe)),Ni=xe.set(i.$QM.ExtHostTimeline,new se.$2lc(xe,pt)),Pi=xe.set(i.$QM.ExtHostWebviews,new It.$vkc(xe,$t.remote,gt,mt,Lt)),Ci=xe.set(i.$QM.ExtHostWebviewPanels,new jt.$ykc(xe,Pi,gt)),Gi=xe.set(i.$QM.ExtHostCustomEditors,new y.$zkc(xe,Rt,Gt,Pi,Ci)),Ji=xe.set(i.$QM.ExtHostWebviewViews,new Kt.$6lc(xe,Pi)),vi=xe.set(i.$QM.ExtHostTesting,new He.$Vlc(xe,mt,pt,Dt)),Qi=xe.set(i.$QM.ExtHostUriOpeners,new nt.$4lc(xe)),un=xe.set(i.$QM.ExtHostProfileContentHandlers,new Ae.$Glc(xe));xe.set(i.$QM.ExtHostInteractive,new ee.$ulc(xe,je,Dt,pt,mt));const ln=xe.set(i.$QM.ExtHostInlineChat,new Ce.$hlc(xe,pt,Rt,mt)),ki=xe.set(i.$QM.ExtHostChatAgents2,new l.$ckc(xe,mt,pt)),Oi=xe.set(i.$QM.ExtHostChatVariables,new c.$dkc(xe)),Zi=xe.set(i.$QM.ExtHostAiRelatedInformation,new r.$1jc(xe)),hn=xe.set(i.$QM.ExtHostAiEmbeddingVector,new Z.$elc(xe)),Ti=xe.set(i.$QM.ExtHostStatusBar,new Ze.$Plc(xe,pt.converter)),dn=xe.set(i.$QM.ExtHostSpeech,new Ve.$Nlc(xe)),Fi=Object.values(i.$QM);xe.assertRegistered(Fi);const Xi=new d.$bkc(xe,Dt),Yi=new h.$ekc(xe),Ii=new re.$xlc(xe,mt),xi=new j.$blc(xe);return s.$$jc.register(pt),function(We,di,fi){function at(de){return(ve,Ue,ct)=>{const yt=de(Mt=>{try{ve.call(Ue,Mt)}catch(Ui){N.$2(new Error(`[ExtensionListenerError] Extension '${We.identifier.value}' FAILED to handle event: ${Ui.toString()}`,{cause:Ui})),Bt.onExtensionError(We.identifier,Ui)}});return ct?.push(yt),yt}}const vt=function(){let de=!We.isUnderDevelopment;function ve(){de||(mt.info(`Extension '${We.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),de=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")ve();else{const yt=ct;typeof yt.scheme>"u"&&ve(),typeof yt.exclusive=="boolean"&&(0,et.$yG)(We,"documentFiltersExclusive")}return ct}}(),ci={getSession(de,ve,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,et.$yG)(We,"authLearnMore"),At.getSession(We,de,ve,Ue)},getSessions(de,ve){return(0,et.$yG)(We,"authGetSessions"),At.getSessions(We,de,ve)},async hasSession(de,ve){return(0,et.$yG)(We,"authSession"),!!await At.getSession(We,de,ve,{silent:!0})},get onDidChangeSessions(){return at(At.onDidChangeSessions)},registerAuthenticationProvider(de,ve,Ue,ct){return At.registerAuthenticationProvider(de,ve,Ue,ct)}},Ai={registerCommand(de,ve,Ue){return pt.registerCommand(!0,de,ve,Ue,void 0,We)},registerTextEditorCommand(de,ve,Ue){return pt.registerCommand(!0,de,(...ct)=>{const yt=Qe.getActiveTextEditor();if(!yt){mt.warn("Cannot execute "+de+" because there is no active text editor.");return}return yt.edit(Mt=>{ve.apply(Ue,[yt,Mt,...ct])}).then(Mt=>{Mt||mt.warn("Edits from command "+de+" were not applied.")},Mt=>{mt.warn("An error occurred while running command "+de,Mt)})},void 0,void 0,We)},registerDiffInformationCommand:(de,ve,Ue)=>((0,et.$yG)(We,"diffCommand"),pt.registerCommand(!0,de,async(...ct)=>{const yt=Dt.activeEditor(!0);if(!yt){mt.warn("Cannot execute "+de+" because there is no active text editor.");return}const Mt=await Qe.getDiffInformation(yt.id);ve.apply(Ue,[Mt,...ct])},void 0,void 0,We)),executeCommand(de,...ve){return pt.executeCommand(de,...ve)},getCommands(de=!1){return pt.getCommands(de)}},ji={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Yi.value},get shell(){return Pt.getDefaultShell(!1)},get onDidChangeShell(){return at(Pt.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$yG)(We,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$yG)(We,"telemetry"),at(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,st.$tP)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(de,ve){return st.$sP.validateSender(de),Bt.instantiateLogger(We,de,ve)},openExternal(de,ve){return Wt.openUri(de,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ve?.allowContributedOpeners})},async asExternalUri(de){if(de.scheme===$t.environment.appUriScheme)return ni.createAppUri(de);try{return await Wt.asExternalUri(de,{allowTunneling:!!$t.remote.authority})}catch(ve){if((0,M.$zg)(de,M.Schemas.http)||(0,M.$zg)(de,M.Schemas.https))return de;throw ve}},get remoteName(){return(0,m.$Cm)($t.remote.authority)},get remoteAuthority(){return(0,et.$yG)(We,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return at(mt.onDidChangeLogLevel)},get appQuality(){return(0,et.$yG)(We,"resolvers"),$t.quality},get appCommit(){return(0,et.$yG)(We,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(ji);const _i={createTestController(de,ve,Ue){return vi.createTestController(We,de,ve,Ue)},createTestObserver(){return(0,et.$yG)(We,"testObserver"),vi.createTestObserver()},runTests(de){return(0,et.$yG)(We,"testObserver"),vi.runTests(de)},get onDidChangeTestResults(){return(0,et.$yG)(We,"testObserver"),at(vi.onResultsChanged)},get testResults(){return(0,et.$yG)(We,"testObserver"),vi.results}},Ei=$t.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,en={getExtension(de,ve){(0,et.$xG)(We,"extensionsAny")||(ve=!1);const Ue=di.mine.getExtensionDescription(de);if(Ue)return new x.$3kc(zt,We.identifier,Ue,Ei,!1);if(ve){const ct=di.all.getExtensionDescription(de);if(ct)return new x.$3kc(zt,We.identifier,ct,Ei,!0)}},get all(){const de=[];for(const ve of di.mine.getAllExtensionDescriptions())de.push(new x.$3kc(zt,We.identifier,ve,Ei,!1));return de},get allAcrossExtensionHosts(){(0,et.$yG)(We,"extensionsAny");const de=new E.$Mm(di.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ve=[];for(const Ue of di.all.getAllExtensionDescriptions()){const ct=!de.has(Ue.identifier);ve.push(new x.$3kc(zt,We.identifier,Ue,Ei,ct))}return ve},get onDidChange(){return(0,et.$xG)(We,"extensionsAny")?at(L.Event.any(di.mine.onDidChange,di.all.onDidChange)):at(di.mine.onDidChange)}},fn={createDiagnosticCollection(de){return Ft.createDiagnosticCollection(We.identifier,de)},get onDidChangeDiagnostics(){return at(Ft.onDidChangeDiagnostics)},getDiagnostics:de=>Ft.getDiagnostics(de),getLanguages(){return Xt.getLanguages()},setTextDocumentLanguage(de,ve){return Xt.changeLanguage(de.uri,ve)},match(de,ve){const Ue=Ge.LanguageSelector.from(de);let ct;return(0,A.$Vt)(Ue)&&(ct=je.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Mt=>Mt.document===ve))?.apiNotebook),(0,A.$Ut)(Ue,ve.uri,ve.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(de,ve,Ue){return ut.registerCodeActionProvider(We,vt(de),ve,Ue)},registerDocumentPasteEditProvider(de,ve,Ue){return(0,et.$yG)(We,"documentPaste"),ut.registerDocumentPasteEditProvider(We,vt(de),ve,Ue)},registerCodeLensProvider(de,ve){return ut.registerCodeLensProvider(We,vt(de),ve)},registerDefinitionProvider(de,ve){return ut.registerDefinitionProvider(We,vt(de),ve)},registerDeclarationProvider(de,ve){return ut.registerDeclarationProvider(We,vt(de),ve)},registerImplementationProvider(de,ve){return ut.registerImplementationProvider(We,vt(de),ve)},registerTypeDefinitionProvider(de,ve){return ut.registerTypeDefinitionProvider(We,vt(de),ve)},registerHoverProvider(de,ve){return ut.registerHoverProvider(We,vt(de),ve,We.identifier)},registerEvaluatableExpressionProvider(de,ve){return ut.registerEvaluatableExpressionProvider(We,vt(de),ve,We.identifier)},registerInlineValuesProvider(de,ve){return ut.registerInlineValuesProvider(We,vt(de),ve,We.identifier)},registerDocumentHighlightProvider(de,ve){return ut.registerDocumentHighlightProvider(We,vt(de),ve)},registerMultiDocumentHighlightProvider(de,ve){return ut.registerMultiDocumentHighlightProvider(We,vt(de),ve)},registerLinkedEditingRangeProvider(de,ve){return ut.registerLinkedEditingRangeProvider(We,vt(de),ve)},registerReferenceProvider(de,ve){return ut.registerReferenceProvider(We,vt(de),ve)},registerRenameProvider(de,ve){return ut.registerRenameProvider(We,vt(de),ve)},registerNewSymbolNamesProvider(de,ve){return(0,et.$yG)(We,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider(We,vt(de),ve)},registerDocumentSymbolProvider(de,ve,Ue){return ut.registerDocumentSymbolProvider(We,vt(de),ve,Ue)},registerWorkspaceSymbolProvider(de){return ut.registerWorkspaceSymbolProvider(We,de)},registerDocumentFormattingEditProvider(de,ve){return ut.registerDocumentFormattingEditProvider(We,vt(de),ve)},registerDocumentRangeFormattingEditProvider(de,ve){return ut.registerDocumentRangeFormattingEditProvider(We,vt(de),ve)},registerOnTypeFormattingEditProvider(de,ve,Ue,...ct){return ut.registerOnTypeFormattingEditProvider(We,vt(de),ve,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(de,ve,Ue){return ut.registerDocumentSemanticTokensProvider(We,vt(de),ve,Ue)},registerDocumentRangeSemanticTokensProvider(de,ve,Ue){return ut.registerDocumentRangeSemanticTokensProvider(We,vt(de),ve,Ue)},registerSignatureHelpProvider(de,ve,Ue,...ct){return typeof Ue=="object"?ut.registerSignatureHelpProvider(We,vt(de),ve,Ue):ut.registerSignatureHelpProvider(We,vt(de),ve,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(de,ve,...Ue){return ut.registerCompletionItemProvider(We,vt(de),ve,Ue)},registerInlineCompletionItemProvider(de,ve,Ue){return ve.handleDidShowCompletionItem&&(0,et.$yG)(We,"inlineCompletionsAdditions"),ve.handleDidPartiallyAcceptCompletionItem&&(0,et.$yG)(We,"inlineCompletionsAdditions"),Ue&&(0,et.$yG)(We,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(We,vt(de),ve,Ue)},registerInlineEditProvider(de,ve){return(0,et.$yG)(We,"inlineEdit"),ut.registerInlineEditProvider(We,vt(de),ve)},registerDocumentLinkProvider(de,ve){return ut.registerDocumentLinkProvider(We,vt(de),ve)},registerColorProvider(de,ve){return ut.registerColorProvider(We,vt(de),ve)},registerFoldingRangeProvider(de,ve){return ut.registerFoldingRangeProvider(We,vt(de),ve)},registerSelectionRangeProvider(de,ve){return ut.registerSelectionRangeProvider(We,de,ve)},registerCallHierarchyProvider(de,ve){return ut.registerCallHierarchyProvider(We,de,ve)},registerTypeHierarchyProvider(de,ve){return ut.registerTypeHierarchyProvider(We,de,ve)},setLanguageConfiguration:(de,ve)=>ut.setLanguageConfiguration(We,de,ve),getTokenInformationAtPosition(de,ve){return(0,et.$yG)(We,"tokenInformation"),Xt.tokenAtPosition(de,ve)},registerInlayHintsProvider(de,ve){return ut.registerInlayHintsProvider(We,de,ve)},createLanguageStatusItem(de,ve){return Xt.createLanguageStatusItem(We,de,ve)},registerDocumentDropEditProvider(de,ve,Ue){return ut.registerDocumentOnDropEditProvider(We,de,ve,(0,et.$xG)(We,"documentPaste")?Ue:void 0)}},tn={get activeTextEditor(){return Qe.getActiveTextEditor()},get visibleTextEditors(){return Qe.getVisibleTextEditors()},get activeTerminal(){return Pt.activeTerminal},get terminals(){return Pt.terminals},async showTextDocument(de,ve,Ue){b.URI.isUri(de)&&de.scheme===M.Schemas.vscodeRemote&&!de.authority&&Lt.report("workspace.showTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(b.URI.isUri(de)?Promise.resolve(zi.openTextDocument(de)):Promise.resolve(de));return Qe.showTextDocument(ct,ve,Ue)},createTextEditorDecorationType(de){return Qe.createTextEditorDecorationType(We,de)},onDidChangeActiveTextEditor(de,ve,Ue){return at(Qe.onDidChangeActiveTextEditor)(de,ve,Ue)},onDidChangeVisibleTextEditors(de,ve,Ue){return at(Qe.onDidChangeVisibleTextEditors)(de,ve,Ue)},onDidChangeTextEditorSelection(de,ve,Ue){return at(Qe.onDidChangeTextEditorSelection)(de,ve,Ue)},onDidChangeTextEditorOptions(de,ve,Ue){return at(Qe.onDidChangeTextEditorOptions)(de,ve,Ue)},onDidChangeTextEditorVisibleRanges(de,ve,Ue){return at(Qe.onDidChangeTextEditorVisibleRanges)(de,ve,Ue)},onDidChangeTextEditorViewColumn(de,ve,Ue){return at(Qe.onDidChangeTextEditorViewColumn)(de,ve,Ue)},onDidCloseTerminal(de,ve,Ue){return at(Pt.onDidCloseTerminal)(de,ve,Ue)},onDidOpenTerminal(de,ve,Ue){return at(Pt.onDidOpenTerminal)(de,ve,Ue)},onDidChangeActiveTerminal(de,ve,Ue){return at(Pt.onDidChangeActiveTerminal)(de,ve,Ue)},onDidChangeTerminalDimensions(de,ve,Ue){return(0,et.$yG)(We,"terminalDimensions"),at(Pt.onDidChangeTerminalDimensions)(de,ve,Ue)},onDidChangeTerminalState(de,ve,Ue){return at(Pt.onDidChangeTerminalState)(de,ve,Ue)},onDidWriteTerminalData(de,ve,Ue){return(0,et.$yG)(We,"terminalDataWriteEvent"),at(Pt.onDidWriteTerminalData)(de,ve,Ue)},onDidExecuteTerminalCommand(de,ve,Ue){return(0,et.$yG)(We,"terminalExecuteCommandEvent"),at(Pt.onDidExecuteTerminalCommand)(de,ve,Ue)},onDidChangeTerminalShellIntegration(de,ve,Ue){return(0,et.$yG)(We,"terminalShellIntegration"),at(li.onDidChangeTerminalShellIntegration)(de,ve,Ue)},onDidStartTerminalShellExecution(de,ve,Ue){return(0,et.$yG)(We,"terminalShellIntegration"),at(li.onDidStartTerminalShellExecution)(de,ve,Ue)},onDidEndTerminalShellExecution(de,ve,Ue){return(0,et.$yG)(We,"terminalShellIntegration"),at(li.onDidEndTerminalShellExecution)(de,ve,Ue)},get state(){return Wt.getState(We)},onDidChangeWindowState(de,ve,Ue){return at(Wt.onDidChangeWindowState)(de,ve,Ue)},showInformationMessage(de,...ve){return Ii.showMessage(We,p.default.Info,de,ve[0],ve.slice(1))},showWarningMessage(de,...ve){return Ii.showMessage(We,p.default.Warning,de,ve[0],ve.slice(1))},showErrorMessage(de,...ve){return Ii.showMessage(We,p.default.Error,de,ve[0],ve.slice(1))},showQuickPick(de,ve,Ue){return pi.showQuickPick(We,de,ve,Ue)},showWorkspaceFolderPick(de){return pi.showWorkspaceFolderPick(de)},showInputBox(de,ve){return pi.showInput(de,ve)},showOpenDialog(de){return xi.showOpenDialog(We,de)},showSaveDialog(de){return xi.showSaveDialog(de)},createStatusBarItem(de,ve,Ue){let ct,yt,Mt;return typeof de=="string"?(ct=de,yt=ve,Mt=Ue):(yt=de,Mt=ve),Ti.createStatusBarEntry(We,ct,yt,Mt)},setStatusBarMessage(de,ve){return Ti.setStatusBarMessage(de,ve)},withScmProgress(de){return Lt.report("window.withScmProgress",We,"Use 'withProgress' instead."),Ki.withProgress(We,{location:Me.ProgressLocation.SourceControl},(ve,Ue)=>de({report(ct){}}))},withProgress(de,ve){return Ki.withProgress(We,de,ve)},createOutputChannel(de,ve){return ai.createOutputChannel(de,ve,We)},createWebviewPanel(de,ve,Ue,ct){return Ci.createWebviewPanel(We,de,ve,Ue,ct)},createWebviewTextEditorInset(de,ve,Ue,ct){return(0,et.$yG)(We,"editorInsets"),Et.createWebviewEditorInset(de,ve,Ue,ct,We)},createTerminal(de,ve,Ue){return typeof de=="object"?"pty"in de?Pt.createExtensionTerminal(de):Pt.createTerminalFromOptions(de):Pt.createTerminal(de,ve,Ue)},registerTerminalLinkProvider(de){return Pt.registerLinkProvider(de)},registerTerminalProfileProvider(de,ve){return Pt.registerProfileProvider(We,de,ve)},registerTerminalQuickFixProvider(de,ve){return(0,et.$yG)(We,"terminalQuickFixProvider"),Pt.registerTerminalQuickFixProvider(de,We.identifier.value,ve)},registerTreeDataProvider(de,ve){return ht.registerTreeDataProvider(de,ve,We)},createTreeView(de,ve){return ht.createTreeView(de,ve,We)},registerWebviewPanelSerializer:(de,ve)=>Ci.registerWebviewPanelSerializer(We,de,ve),registerCustomEditorProvider:(de,ve,Ue={})=>Gi.registerCustomEditorProvider(We,de,ve,Ue),registerFileDecorationProvider(de){return Ct.registerFileDecorationProvider(de,We)},registerUriHandler(de){return ni.registerUriHandler(We,de)},createQuickPick(){return pi.createQuickPick(We)},createInputBox(){return pi.createInputBox(We)},get activeColorTheme(){return Di.activeColorTheme},onDidChangeActiveColorTheme(de,ve,Ue){return at(Di.onDidChangeActiveColorTheme)(de,ve,Ue)},registerWebviewViewProvider(de,ve,Ue){return Ji.registerWebviewViewProvider(We,de,ve,Ue?.webviewOptions)},get activeNotebookEditor(){return je.activeNotebookEditor},onDidChangeActiveNotebookEditor(de,ve,Ue){return at(je.onDidChangeActiveNotebookEditor)(de,ve,Ue)},get visibleNotebookEditors(){return je.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(je.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(de,ve,Ue){return at(_.onDidChangeNotebookEditorSelection)(de,ve,Ue)},onDidChangeNotebookEditorVisibleRanges(de,ve,Ue){return at(_.onDidChangeNotebookEditorVisibleRanges)(de,ve,Ue)},showNotebookDocument(de,ve){return je.showNotebookDocument(de,ve)},registerExternalUriOpener(de,ve,Ue){return(0,et.$yG)(We,"externalUriOpener"),Qi.registerExternalUriOpener(We.identifier,de,ve,Ue)},registerProfileContentHandler(de,ve){return(0,et.$yG)(We,"profileContentHandlers"),un.registerProfileContentHandler(We,de,ve)},registerQuickDiffProvider(de,ve,Ue,ct){return(0,et.$yG)(We,"quickDiffProvider"),Mi.registerQuickDiffProvider(vt(de),ve,Ue,ct)},get tabGroups(){return Qt.tabGroups},registerShareProvider(de,ve){return(0,et.$yG)(We,"shareProvider"),Li.registerShareProvider(vt(de),ve)}},zi={get rootPath(){return Lt.report("workspace.rootPath",We,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(de){throw new N.$9("rootPath")},getWorkspaceFolder(de){return gt.getWorkspaceFolder(de)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(de){throw new N.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(de){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(de,ve,...Ue)=>gt.updateWorkspaceFolders(We,de,ve||0,...Ue),onDidChangeWorkspaceFolders:function(de,ve,Ue){return at(gt.onDidChangeWorkspace)(de,ve,Ue)},asRelativePath:(de,ve)=>gt.getRelativePath(de,ve),findFiles:(de,ve,Ue,ct)=>gt.findFiles(de,ve,Ue,We.identifier,ct),findFiles2:(de,ve,Ue)=>((0,et.$yG)(We,"findFiles2"),gt.findFiles2(de,ve,We.identifier,Ue)),findTextInFiles:(de,ve,Ue,ct)=>{(0,et.$yG)(We,"findTextInFiles");let yt,Mt;return typeof ve=="object"?(yt=ve,Mt=Ue):(yt={},Mt=ve,ct=Ue),gt.findTextInFiles(de,yt||{},Mt,We.identifier,ct)},save:de=>gt.save(de),saveAs:de=>gt.saveAs(de),saveAll:de=>gt.saveAll(de),applyEdit(de,ve){return Xi.applyWorkspaceEdit(de,We,ve)},createFileSystemWatcher:(de,ve,Ue,ct)=>{let yt;return typeof ve=="boolean"?yt={ignoreCreateEvents:!!ve,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:ve&&((0,et.$yG)(We,"createFileSystemWatcher"),yt={...ve,correlate:!0}),mi.createFileSystemWatcher(gt,We,de,yt)},get textDocuments(){return Rt.getAllDocumentData().map(de=>de.document)},set textDocuments(de){throw new N.$9("textDocuments")},openTextDocument(de){let ve;const Ue=de;if(typeof de=="string")ve=Promise.resolve(b.URI.file(de));else if(b.URI.isUri(de))ve=Promise.resolve(de);else if(!Ue||typeof Ue=="object")ve=Rt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ve.then(ct=>(ct.scheme===M.Schemas.vscodeRemote&&!ct.authority&&Lt.report("workspace.openTextDocument",We,"A URI of 'vscode-remote' scheme requires an authority."),Rt.ensureDocumentData(ct).then(yt=>yt.document)))},onDidOpenTextDocument:(de,ve,Ue)=>at(Rt.onDidAddDocument)(de,ve,Ue),onDidCloseTextDocument:(de,ve,Ue)=>at(Rt.onDidRemoveDocument)(de,ve,Ue),onDidChangeTextDocument:(de,ve,Ue)=>at(Rt.onDidChangeDocument)(de,ve,Ue),onDidSaveTextDocument:(de,ve,Ue)=>at(Rt.onDidSaveDocument)(de,ve,Ue),onWillSaveTextDocument:(de,ve,Ue)=>at(Ne.getOnWillSaveTextDocumentEvent(We))(de,ve,Ue),get notebookDocuments(){return je.notebookDocuments.map(de=>de.apiNotebook)},async openNotebookDocument(de,ve){let Ue;if(b.URI.isUri(de))Ue=de,await je.openNotebookDocument(de);else if(typeof de=="string")Ue=b.URI.revive(await je.createNotebookDocument({viewType:de,content:ve}));else throw new Error("Invalid arguments");return je.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(de,ve,Ue){return at(ye.onDidSaveNotebookDocument)(de,ve,Ue)},onDidChangeNotebookDocument(de,ve,Ue){return at(ye.onDidChangeNotebookDocument)(de,ve,Ue)},onWillSaveNotebookDocument(de,ve,Ue){return at(_e.getOnWillSaveNotebookDocumentEvent(We))(de,ve,Ue)},get onDidOpenNotebookDocument(){return at(je.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(je.onDidCloseNotebookDocument)},registerNotebookSerializer(de,ve,Ue,ct){return je.registerNotebookSerializer(We,de,ve,Ue,(0,et.$xG)(We,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(de,ve,Ue)=>at(fi.onDidChangeConfiguration)(de,ve,Ue),getConfiguration(de,ve){return ve=arguments.length===1?void 0:ve,fi.getConfiguration(de,ve,We)},registerTextDocumentContentProvider(de,ve){return yi.registerTextDocumentContentProvider(de,ve)},registerTaskProvider:(de,ve)=>(Lt.report("window.registerTaskProvider",We,"Use the corresponding function on the 'tasks' namespace instead"),Zt.registerTaskProvider(We,de,ve)),registerFileSystemProvider(de,ve,Ue){return(0,R.$Rc)(Yt.registerFileSystemProvider(We,de,ve,Ue),ti.addFileSystemProvider(de,ve,Ue))},get fs(){return ti.value},registerFileSearchProvider:(de,ve)=>((0,et.$yG)(We,"fileSearchProvider"),hi.registerFileSearchProvider(de,ve)),registerTextSearchProvider:(de,ve)=>((0,et.$yG)(We,"textSearchProvider"),hi.registerTextSearchProvider(de,ve)),registerAITextSearchProvider:(de,ve)=>((0,et.$yG)(We,"aiTextSearchProvider"),(0,et.$yG)(We,"textSearchProvider"),hi.registerAITextSearchProvider(de,ve)),registerRemoteAuthorityResolver:(de,ve)=>((0,et.$yG)(We,"resolvers"),zt.registerRemoteAuthorityResolver(de,ve)),registerResourceLabelFormatter:de=>((0,et.$yG)(We,"resolvers"),Hi.$registerResourceLabelFormatter(de)),getRemoteExecServer:de=>((0,et.$yG)(We,"resolvers"),zt.getRemoteExecServer(de)),onDidCreateFiles:(de,ve,Ue)=>at(mi.onDidCreateFile)(de,ve,Ue),onDidDeleteFiles:(de,ve,Ue)=>at(mi.onDidDeleteFile)(de,ve,Ue),onDidRenameFiles:(de,ve,Ue)=>at(mi.onDidRenameFile)(de,ve,Ue),onWillCreateFiles:(de,ve,Ue)=>at(mi.getOnWillCreateFileEvent(We))(de,ve,Ue),onWillDeleteFiles:(de,ve,Ue)=>at(mi.getOnWillDeleteFileEvent(We))(de,ve,Ue),onWillRenameFiles:(de,ve,Ue)=>at(mi.getOnWillRenameFileEvent(We))(de,ve,Ue),openTunnel:de=>((0,et.$yG)(We,"tunnels"),Tt.openTunnel(We,de).then(ve=>{if(!ve)throw new Error("cannot open tunnel");return ve})),get tunnels(){return(0,et.$yG)(We,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(de,ve,Ue)=>((0,et.$yG)(We,"tunnels"),at(Tt.onDidChangeTunnels)(de,ve,Ue)),registerPortAttributesProvider:(de,ve)=>((0,et.$yG)(We,"portsAttributes"),Tt.registerPortsAttributesProvider(de,ve)),registerTunnelProvider:(de,ve)=>((0,et.$yG)(We,"tunnelFactory"),Tt.registerTunnelProvider(de,ve)),registerTimelineProvider:(de,ve)=>((0,et.$yG)(We,"timeline"),Ni.registerTimelineProvider(de,ve,We.identifier,pt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:de=>((0,et.$yG)(We,"workspaceTrust"),gt.requestWorkspaceTrust(de)),onDidGrantWorkspaceTrust:(de,ve,Ue)=>at(gt.onDidGrantWorkspaceTrust)(de,ve,Ue),registerEditSessionIdentityProvider:(de,ve)=>((0,et.$yG)(We,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(de,ve)),onWillCreateEditSessionIdentity:(de,ve,Ue)=>((0,et.$yG)(We,"editSessionIdentityProvider"),at(gt.getOnWillCreateEditSessionIdentityEvent(We))(de,ve,Ue)),registerCanonicalUriProvider:(de,ve)=>((0,et.$yG)(We,"canonicalUriProvider"),gt.registerCanonicalUriProvider(de,ve)),getCanonicalUri:(de,ve,Ue)=>((0,et.$yG)(We,"canonicalUriProvider"),gt.provideCanonicalUri(de,ve,Ue))},gn={get inputBox(){return Lt.report("scm.inputBox",We,"Use 'SourceControl.inputBox' instead"),Si.getLastInputBox(We)},createSourceControl(de,ve,Ue){return Si.createSourceControl(We,de,ve,Ue)}},mn={createCommentController(de,ve){return Vi.createCommentController(We,de,ve)}},nn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){if((0,et.$xG)(We,"debugFocus"))return kt.activeStackItem},registerDebugVisualizationProvider(de,ve){return(0,et.$yG)(We,"debugVisualization"),kt.registerDebugVisualizationProvider(We,de,ve)},registerDebugVisualizationTreeProvider(de,ve){return(0,et.$yG)(We,"debugVisualization"),kt.registerDebugVisualizationTree(We,de,ve)},onDidStartDebugSession(de,ve,Ue){return at(kt.onDidStartDebugSession)(de,ve,Ue)},onDidTerminateDebugSession(de,ve,Ue){return at(kt.onDidTerminateDebugSession)(de,ve,Ue)},onDidChangeActiveDebugSession(de,ve,Ue){return at(kt.onDidChangeActiveDebugSession)(de,ve,Ue)},onDidReceiveDebugSessionCustomEvent(de,ve,Ue){return at(kt.onDidReceiveDebugSessionCustomEvent)(de,ve,Ue)},onDidChangeBreakpoints(de,ve,Ue){return at(kt.onDidChangeBreakpoints)(de,ve,Ue)},onDidChangeActiveStackItem(de,ve,Ue){return(0,et.$yG)(We,"debugFocus"),at(kt.onDidChangeActiveStackItem)(de,ve,Ue)},registerDebugConfigurationProvider(de,ve,Ue){return kt.registerDebugConfigurationProvider(de,ve,Ue||qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(de,ve){return kt.registerDebugAdapterDescriptorFactory(We,de,ve)},registerDebugAdapterTrackerFactory(de,ve){return kt.registerDebugAdapterTrackerFactory(de,ve)},startDebugging(de,ve,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?kt.startDebugging(de,ve,{parentSession:Ue}):kt.startDebugging(de,ve,Ue||{})},stopDebugging(de){return kt.stopDebugging(de)},addBreakpoints(de){return kt.addBreakpoints(de)},removeBreakpoints(de){return kt.removeBreakpoints(de)},asDebugSourceUri(de,ve){return kt.asDebugSourceUri(de,ve)}},Bi={registerTaskProvider:(de,ve)=>Zt.registerTaskProvider(We,de,ve),fetchTasks:de=>Zt.fetchTasks(de),executeTask:de=>Zt.executeTask(We,de),get taskExecutions(){return Zt.taskExecutions},onDidStartTask:(de,ve,Ue)=>at(Zt.onDidStartTask)(de,ve,Ue),onDidEndTask:(de,ve,Ue)=>at(Zt.onDidEndTask)(de,ve,Ue),onDidStartTaskProcess:(de,ve,Ue)=>at(Zt.onDidStartTaskProcess)(de,ve,Ue),onDidEndTaskProcess:(de,ve,Ue)=>at(Zt.onDidEndTaskProcess)(de,ve,Ue)},rn={createNotebookController(de,ve,Ue,ct,yt){return Oe.createNotebookController(We,de,ve,Ue,ct,(0,et.$xG)(We,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(de,ve)=>je.registerNotebookCellStatusBarItemProvider(We,de,ve),createRendererMessaging(de){return Ke.createRendererMessaging(We,de)},createNotebookControllerDetectionTask(de){return(0,et.$yG)(We,"notebookKernelSource"),Oe.createNotebookControllerDetectionTask(We,de)},registerKernelSourceActionProvider(de,ve){return(0,et.$yG)(We,"notebookKernelSource"),Oe.registerKernelSourceActionProvider(We,de,ve)},onDidChangeNotebookCellExecutionState(de,ve,Ue){return(0,et.$yG)(We,"notebookCellExecutionState"),at(Oe.onDidChangeNotebookCellExecutionState)(de,ve,Ue)}},sn={t(...de){if(typeof de[0]=="string"){const ve=de.shift(),Ue=!de||typeof de[0]!="object"?de:de[0];return bi.getMessage(We.identifier.value,{message:ve,args:Ue})}return bi.getMessage(We.identifier.value,de[0])},get bundle(){return bi.getBundle(We.identifier.value)},get uri(){return bi.getBundleUri(We.identifier.value)}},on={_version:1,registerInteractiveEditorSessionProvider(de,ve){return(0,et.$yG)(We,"interactive"),ln.registerProvider(We,de,ve)},registerInteractiveSessionProvider(de,ve){return(0,et.$yG)(We,"interactive"),R.$Uc.None},transferActiveChat(de){return(0,et.$yG)(We,"interactive"),ki.transferActiveChat(de)}},$n={getRelatedInformation(de,ve){return(0,et.$yG)(We,"aiRelatedInformation"),Zi.getRelatedInformation(We,de,ve)},registerRelatedInformationProvider(de,ve){return(0,et.$yG)(We,"aiRelatedInformation"),Zi.registerRelatedInformationProvider(We,de,ve)},registerEmbeddingVectorProvider(de,ve){return(0,et.$yG)(We,"aiRelatedInformation"),hn.registerEmbeddingVectorProvider(We,de,ve)}},bn={registerChatResponseProvider(de,ve,Ue){return(0,et.$yG)(We,"chatProvider"),Nt.registerLanguageModel(We,de,ve,Ue)},registerChatVariableResolver(de,ve,Ue){return(0,et.$yG)(We,"chatVariableResolver"),Oi.registerVariableResolver(We,de,ve,Ue)},registerMappedEditsProvider(de,ve){return(0,et.$yG)(We,"mappedEditsProvider"),ut.registerMappedEditsProvider(We,de,ve)},createChatParticipant(de,ve){return(0,et.$yG)(We,"chatParticipant"),ki.createChatAgent(We,de,ve)},createDynamicChatParticipant(de,ve,Ue,ct){return(0,et.$yG)(We,"chatParticipantAdditions"),ki.createDynamicChatAgent(We,de,ve,Ue,ct)}},an={get languageModels(){return(0,et.$yG)(We,"languageModels"),Nt.getLanguageModelIds()},onDidChangeLanguageModels:(de,ve,Ue)=>((0,et.$yG)(We,"languageModels"),Nt.onDidChangeProviders(de,ve,Ue)),sendChatRequest(de,ve,Ue,ct){return(0,et.$yG)(We,"languageModels"),Nt.sendChatRequest(We,de,ve,Ue,ct)}},cn={registerSpeechProvider(de,ve){return(0,et.$yG)(We,"speech"),dn.registerProvider(We.identifier,de,ve)}};return{version:$t.version,ai:$n,authentication:ci,commands:Ai,comments:mn,chat:bn,debug:nn,env:ji,extensions:en,interactive:on,l10n:sn,languages:fn,lm:an,notebooks:rn,scm:gn,speech:cn,tasks:Bi,tests:_i,window:tn,workspace:zi,Breakpoint:Me.$RN,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatResultFeedbackKind:Me.ChatResultFeedbackKind,ChatVariableLevel:Me.ChatVariableLevel,ChatCompletionItem:Me.$MO,CallHierarchyIncomingCall:Me.$dN,CallHierarchyItem:Me.$cN,CallHierarchyOutgoingCall:Me.$eN,CancellationError:N.$5,CancellationTokenSource:u.$me,CandidatePortSource:i.CandidatePortSource,CodeAction:Me.$_M,CodeActionKind:Me.$aN,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.$fN,Color:Me.$sN,ColorInformation:Me.$tN,ColorPresentation:Me.$uN,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CommentThreadApplicability:Me.CommentThreadApplicability,CompletionItem:Me.$mN,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.$nN,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.$CN,DebugAdapterExecutable:Me.$VN,DebugAdapterInlineImplementation:Me.$YN,DebugAdapterNamedPipeServer:Me.$XN,DebugAdapterServer:Me.$WN,DebugConfigurationProviderTriggerKind:qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.$cO,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.$6M,DiagnosticRelatedInformation:Me.$5M,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.$RM,DocumentHighlight:Me.$8M,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.$9M,DocumentLink:Me.$rN,DocumentSymbol:Me.$$M,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.$2N,InlineValueText:Me.$3N,InlineValueVariableLookup:Me.$4N,InlineValueEvaluatableExpression:Me.$5N,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:L.$be,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.$eO,FileDecoration2:Me.$eO,FileSystemError:Me.$8N,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Me.$9N,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.$TN,InlineCompletionItem:Me.$oN,InlineCompletionList:Me.$pN,Hover:Me.$7M,IndentAction:P.IndentAction,Location:Me.$4M,MarkdownString:Me.$gN,OverviewRulerLane:$.OverviewRulerLane,ParameterInformation:Me.$hN,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.$SM,ProcessExecution:Me.$AN,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.$dO,Range:Me.$TM,RelativePattern:Me.$PN,Selection:Me.$UM,SelectionRange:Me.$bN,SemanticTokens:Me.$_N,SemanticTokensBuilder:Me.$$N,SemanticTokensEdit:Me.$aO,SemanticTokensEdits:Me.$bO,SemanticTokensLegend:Me.$0N,ShellExecution:Me.$BN,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.$jN,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.$iN,SnippetString:Me.$3M,SourceBreakpoint:Me.$SN,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.$0M,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.$DN,TaskGroup:Me.$zN,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.$vN,TerminalQuickFixTerminalCommand:Me.$xN,TerminalQuickFixOpener:Me.$wN,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.$yN,TerminalExitReason:Me.TerminalExitReason,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.$YM,SnippetTextEdit:Me.$1M,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.$ON,ThemeIcon:Me.$NN,TreeItem:Me.$EN,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.$AO,UIKind:Ht.UIKind,Uri:b.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.$2M,DocumentPasteTriggerKind:Me.DocumentPasteTriggerKind,DocumentDropEdit:Me.$KN,DocumentDropOrPasteEditKind:Me.$LN,DocumentPasteEdit:Me.$MN,InlayHint:Me.$lN,InlayHintLabelPart:Me.$kN,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.$XM,ResolvedAuthority:Me.$VM,ManagedResolvedAuthority:Me.$WM,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.$oO,NotebookRange:Me.$gO,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.$hO,NotebookData:Me.$iO,NotebookRendererScript:Me.$mO,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.$kO,NotebookCellOutputItem:Me.$jO,NotebookCellStatusBarItem:Me.$lO,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.$ZM,NotebookKernelSourceAction:Me.$nO,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.$qO,LinkedEditingRanges:Me.$pO,TestResultState:Me.TestResultState,TestRunRequest:Me.$rO,TestMessage:Me.$sO,TestTag:Me.$tO,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:ri.TextSearchCompleteMessageType,DataTransfer:Me.$JN,DataTransferItem:Me.$FN,TestCoverageCount:Me.$uO,FileCoverage:Me.$wO,StatementCoverage:Me.$xO,BranchCoverage:Me.$yO,DeclarationCoverage:Me.$zO,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.$BO,TabInputTextDiff:Me.$CO,TabInputTextMerge:Me.$DO,TabInputCustom:Me.$EO,TabInputNotebook:Me.$GO,TabInputNotebookDiff:Me.$HO,TabInputWebview:Me.$FO,TabInputTerminal:Me.$IO,TabInputInteractiveWindow:Me.$JO,TabInputChat:Me.$KO,TabInputTextMultiDiff:Me.$LO,TelemetryTrustedValue:o.$_o,LogLevel:a.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatCopyKind:Me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,StackFrame:Me.$ZN,Thread:Me.$1N,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,PartialAcceptTriggerKind:Me.PartialAcceptTriggerKind,KeywordRecognitionStatus:Me.KeywordRecognitionStatus,ChatResponseMarkdownPart:Me.$NO,ChatResponseFileTreePart:Me.$OO,ChatResponseAnchorPart:Me.$PO,ChatResponseProgressPart:Me.$QO,ChatResponseReferencePart:Me.$SO,ChatResponseTextEditPart:Me.$TO,ChatResponseCommandButtonPart:Me.$RO,ChatRequestTurn:Me.$UO,ChatResponseTurn:Me.$VO,ChatLocation:Me.ChatLocation,LanguageModelChatSystemMessage:Me.$WO,LanguageModelChatUserMessage:Me.$XO,LanguageModelChatAssistantMessage:Me.$YO,LanguageModelSystemMessage:Me.$WO,LanguageModelUserMessage:Me.$XO,LanguageModelAssistantMessage:Me.$YO,LanguageModelError:Me.$ZO,NewSymbolName:Me.$7N,NewSymbolNameTag:Me.NewSymbolNameTag,InlineEdit:Me.$1O,InlineEditTriggerKind:Me.InlineEditTriggerKind}}}}),define(ke[381],Ee([1,0,84,157,43,151,44,33,72,42,95,96,97,118,70,91,150,69,60,117,90,71,149,12,61,115,116,120,121,155]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f,d,l,c,h,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$os)(l.$Wkc,l.$Vkc,1),(0,u.$os)(f.$Xj,t.$0lc,1),(0,u.$os)(a.$2jc,a.$3jc,1),(0,u.$os)(p.$wP,p.$vP,0),(0,u.$os)(h.$_jc,h.$akc,0),(0,u.$os)(g.$Qkc,g.$Rkc,0),(0,u.$os)(M.$okc,M.$mkc,0),(0,u.$os)(o.$qkc,o.$pkc,0),(0,u.$os)(P.$7kc,P.$$kc,0),(0,u.$os)(R.$alc,R.$_kc,0),(0,u.$os)(b.$lP,b.$kP,0),(0,u.$os)(c.$Xkc,c.$Ykc,0),(0,u.$os)(n.$6jc,n.$5jc,0),(0,u.$os)(N.$Flc,N.$Elc,1),(0,u.$os)($.$qlc,$.$rlc,0),(0,u.$os)(E.$Jkc,E.$Ikc,0),(0,u.$os)(A.$Slc,A.$Rlc,0),(0,u.$os)(S.$Mkc,S.$Pkc,0),(0,u.$os)(D.$Tlc,D.$Ulc,0),(0,u.$os)(v.$oCb,v.$pCb,0),(0,u.$os)(m.$8lc,m.$7lc,0),(0,u.$os)(L.$lkc,L.$kkc,0),(0,u.$os)(i.$Tkc,i.$Skc,0),(0,u.$os)(r.$uP,r.$rP,0),(0,u.$os)(s.$Akc,s.$Bkc,0),(0,u.$os)(d.$5kc,d.$6kc,0)}),define(ke[122],Ee([1,0,19,12,36,94]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=void 0,e.$nmc=M,e.$omc=p;function M(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}function p(P,$,E,v){const a=(0,u.$2b)(E,b),m=new L.$9K($,a,v),o=m.preview.matches;return{ranges:(0,u.$2b)(a,S),uri:P,preview:{text:m.preview.text,matches:(0,u.$2b)(o,S)}}}function b(P){return new L.$0K(P.start.line,P.start.character,P.end.line,P.end.character)}function S(P){return new R.$XK(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let A=class{constructor($,E){this.a=$,this.b=E}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$pmc=A,e.$pmc=A=Je([qe(1,N.$Wj)],A)}),define(ke[382],Ee([1,0,53,17,76,34,11,14,122,383]),function(le,e,u,N,L,R,M,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=P,e.$rmc=m,e.$smc=n;const A=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(i,r,s,t){const f=$(i,r,s,t),d=r.folder.fsPath;return{cmd:u.spawn(A,f.args,{cwd:d}),rgDiskPath:A,siblingClauses:f.siblingClauses,rgArgs:f,cwd:d}}function $(i,r,s,t){const f=["--files","--hidden","--case-sensitive","--no-require-git"];v([r],s,!1).forEach(l=>{const c=(0,b.$nmc)(l);if(f.push("-g",c),M.$j){const h=(0,L.$9l)(c);h!==c&&f.push("-g",h)}});const d=E([r],t,void 0,!1);return d.globArgs.forEach(l=>{const c=`!${(0,b.$nmc)(l)}`;if(f.push("-g",c),M.$j){const h=(0,L.$9l)(c);h!==c&&f.push("-g",h)}}),r.disregardIgnoreFiles!==!1?f.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),r.ignoreSymlinks||f.push("--follow"),i.exists&&f.push("--quiet"),f.push("--no-config"),r.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:d.siblingClauses}}function E(i,r,s,t=!0){const f=[];let d={};return i.forEach(l=>{const c=Object.assign({},l.excludePattern||{},r||{}),h=a(c,t?l.folder.fsPath:void 0,s);f.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:f,siblingClauses:d}}function v(i,r,s=!0){const t=[];return i.forEach(f=>{const d=Object.assign({},r||{},f.includePattern||{}),l=a(d,s?f.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function a(i,r,s){const t=[],f={};return Object.keys(i).forEach(d=>{if(s&&s.has(d)||!d)return;const l=i[d];d=o(r?m(r,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),t.push(n(d))):l&&l.when&&(f[d]=l)}),{globArgs:t,siblingClauses:f}}function m(i,r){return N.$jc(r)?r:N.$kc(i,r)}function o(i){return i=p.$bf(i,"\\"),p.$bf(i,"/")}function n(i){return R.$mg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[384],Ee([1,0,53,52,17,385,19,47,35,76,34,11,39,14,18,31,36,382,132]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=e.$tmc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class r{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&b.$kk(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,n.$pr)(this.b).normalizedLowercase),this.u=l.excludePattern&&b.$kk(l.excludePattern),this.t=new Map,l.folderQueries.forEach(c=>{const h=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),g=c.folder.fsPath;l.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==g).forEach(D=>{(0,A.$qg)(D,g)&&(h[L.$mc(g,D)]=!0)}),this.t.set(g,new t(h,g))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,c,h,g,D){if(this.m=$.$0d.create(!1),this.l)return D(null,this.j);c.forEach(w=>{const k=L.$oc(w.fsPath);this.u&&this.u(w.fsPath,k)||this.J(h,{relativePath:w.fsPath,searchPath:void 0})}),this.r=$.$0d.create(!1),this.w(l,(w,k)=>{this.x(this.y,this,w,h,g,y=>{if(y){const C=(0,p.$bj)(y);console.error(C),this.q.push(C),k(y,void 0)}else k(null,void 0)})},(w,k)=>{this.m.stop();const y=w?M.$Hb(w)[0]:null;D(y,this.j)})}w(l,c,h){const g=new Array(l.length),D=new Array(l.length);let w=!1,k=0;if(l.length===0)return h(null,[]);l.forEach((y,C)=>{c(y,(I,F)=>{if(I?(w=!0,g[C]=null,D[C]=I):(g[C]=F,D[C]=null),++k===l.length)return h(w?D:null,g)})})}x(l,c,...h){try{l.apply(c,h)}catch(g){h[h.length-1](g)}}y(l,c,h,g){const D=l.folder.fsPath,w=P.$j,k=()=>j&&j.kill();i.add(k);let y=B=>{i.delete(k),y=()=>{},g(B)},C="";const I=this.D(),F=(0,o.$qmc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),j=F.cmd,z=!Object.keys(F.siblingClauses).length,O=F.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let T=`${F.rgDiskPath} ${O}
 - cwd: ${F.cwd}`;F.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(F.rgArgs.siblingClauses)}`),h({message:T}),this.s=0,this.z(j,"utf8",h,(B,W,Z)=>{if(B){y(B);return}if(this.j){y();return}const X=(C+(w?S.$8l(W||""):W)).split(`
`);if(Z){const Y=X.length;X[Y-1]=X[Y-1].trim(),X[Y-1]||X.pop()}else C=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=X.length,z){for(const Y of X)if(this.J(c,{base:D,relativePath:Y,searchPath:this.N(l,Y)}),this.j){k();break}(Z||this.j)&&y();return}this.G(l,I,D,X,c),Z&&(this.H(I,D,c),y())})}spawnFindCmd(l){const c=this.t.get(l.folder.fsPath),h=c.getBasenameTerms(),g=c.getPathTerms(),D=["-L","."];if(h.length||g.length){D.push("-not","(","(");for(const w of h)D.push("-name",w),D.push("-o");for(const w of g)D.push("-path",w),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),u.spawn("find",D,{cwd:l.folder.fsPath})}readStdout(l,c,h){let g="";this.z(l,c,()=>{},(D,w,k)=>{if(D){h(D);return}g+=w,k&&h(null,g)})}z(l,c,h,g){let D=(y,C,I)=>{(y||I)&&(D=()=>{},this.r?.stop()),g(y,C,I)},w=!1;l.stdout?(this.A(l.stdout,c,D),l.stdout.once("data",()=>w=!0)):h({message:"stdout is null"});let k;l.stderr?k=this.B(l.stderr):h({message:"stderr is null"}),l.on("error",y=>{D(y)}),l.on("close",y=>{let C;!w&&(C=this.C(k,c))&&f(C)?D(new Error(`command failed with error code ${y}: ${this.C(k,c)}`)):(this.g&&y===0&&(this.j=!0),D(null,"",!0))})}A(l,c,h){const g=new R.StringDecoder(c);return l.on("data",D=>{h(null,g.write(D))}),g}B(l){const c=[];return l.on("data",h=>{c.push(h)}),c}C(l,c){const h=new R.StringDecoder(c);return l.map(g=>h.write(g)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:c},h,g,D){g.indexOf(this.b)!==-1&&this.J(D,{base:h,relativePath:this.b,searchPath:this.N(l,this.b)});const w=k=>{const y=L.$oc(k),C=L.$nc(k);let I=c[C];I||(I=c[C]=[],w(C)),I.push({base:h,relativePath:k,basename:y,searchPath:this.N(l,k)})};g.forEach(w)}H({rootEntries:l,pathToEntries:c},h,g){const D=this,w=this.t.get(h),k=this.b;function y(C){D.o++;const I=(0,m.$mL)(()=>C.map(F=>F.basename));for(let F=0,j=C.length;F<j;F++){const z=C[F],{relativePath:O,basename:T}=z;if(w.test(O,T,k!==T?I:void 0))continue;const B=c[O];if(B)y(B);else{if(D.p++,O===k)continue;D.J(g,z)}if(D.j)break}}y(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,c,h,g,D){const w=l.folder,k=(0,m.$mL)(()=>h);this.w(h,(y,C)=>{if(this.l||this.j)return C(null);const I=c?[c,y].join(L.sep):y;if(this.t.get(l.folder.fsPath).test(I,y,this.a.filePattern!==y?k:void 0))return C(null);const F=[w.fsPath,I].join(L.sep);N.lstat(F,(j,z)=>{if(j||this.l||this.j)return C(null);this.L(F,z,(O,T)=>O||this.l||this.j?C(null):T.isDirectory()?(this.o++,this.M(F,z,(B,W)=>B||this.l||this.j||(W=W||"",this.v[W])?C(null):(this.v[W]=!0,a.Promises.readdir(F).then(Z=>{if(this.l||this.j)return C(null);this.I(l,I,Z,g,x=>C(x||null))},Z=>{C(null)})))):(this.p++,I===this.b||this.h&&v.$8f(T.size)&&T.size>this.h||this.J(g,{base:w.fsPath,relativePath:I,searchPath:this.N(l,I)}),C(null,void 0)))})},y=>{const C=y&&M.$Hb(y);return D(C&&C.length>0?C[0]:void 0)})}J(l,c){this.K(c)&&(!this.d||this.d(c.relativePath,L.$oc(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(c))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$hL)(l,this.c);if(this.b)return(0,m.$hL)(l,this.b,!1)}return!0}L(l,c,h){return c.isSymbolicLink()?N.stat(l,h):h(null,c)}M(l,c,h){return c.isSymbolicLink()?N.realpath(l,(g,D)=>g?h(g):h(null,D)):h(null,l)}N(l,c){return l.folderName?L.$kc(l.folderName,c):c}}e.$tmc=r;class s{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new r(l)}search(l,c,h){this.c.walk(this.a,this.b,l,c,(g,D)=>{h(g,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$umc=s;class t{constructor(l,c){this.expression=l,this.c=c,this.d(l)}d(l){let c,h;Object.keys(l).filter(g=>l[g]).forEach(g=>{L.$jc(g)?(c=c||b.$fk(),c[g]=l[g]):(h=h||b.$fk(),h[g]=l[g])}),this.a=c&&b.$kk(c,{trimForExclusions:!0}),this.b=h&&b.$kk(h,{trimForExclusions:!0})}test(l,c,h){return this.b&&this.b(l,c,h)||this.a&&this.a(L.$kc(this.c,l),c,h)}getBasenameTerms(){const l=[];return this.a&&l.push(...b.$mk(this.a)),this.b&&l.push(...b.$mk(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...b.$nk(this.a)),this.b&&l.push(...b.$nk(this.b)),l}}function f(d){const l=d.trim().split(`
`),c=l[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return E.$Vf(l[l.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(ke[386],Ee([1,0,98,21,193,22]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9D=e.$1D=e.DecodeStreamErrorKind=e.$ZD=e.$YD=e.$XD=e.$VD=e.$UD=e.$TD=e.$SD=void 0,e.$WD=M,e.$2D=v,e.$3D=a,e.$4D=m,e.$5D=o,e.$6D=n,e.$7D=d,e.$8D=l,e.$SD="utf8",e.$TD="utf8bom",e.$UD="utf16be",e.$VD="utf16le";function M(c){return[e.$SD,e.$TD,e.$UD,e.$VD].some(h=>h===c)}e.$XD=[254,255],e.$YD=[255,254],e.$ZD=[239,187,191];const p=512,b=512,S=512*8,A=512*128;var P;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class $ extends Error{constructor(h,g){super(h),this.decodeStreamErrorKind=g}}e.$1D=$;class E{static async create(h){let g;if(h!==e.$SD)g=(await(0,L.$RD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(h));else{const D=new TextDecoder;g={write(w){return D.decode(w,{stream:!0})},end(){return D.decode()}}}return new E(g)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function v(c,h){const g=h.minBytesRequiredForDetection??h.guessEncoding?S:b;return new Promise((D,w)=>{const k=(0,u.$qe)(z=>z.join("")),y=[];let C=0,I;const F=new R.$me,j=async()=>{try{const z=await l({buffer:N.$Ce.concat(y),bytesRead:C},h.guessEncoding);if(z.seemsBinary&&h.acceptTextOnly)throw new $("Stream is binary but only text is accepted for decoding",1);z.encoding=await h.overwriteEncoding(z.encoding),I=await E.create(z.encoding);const O=I.write(N.$Ce.concat(y).buffer);k.write(O),y.length=0,C=0,D({stream:k,detected:z})}catch(z){F.cancel(),k.destroy(),w(z)}};(0,u.$ue)(c,{onData:async z=>{I?k.write(I.write(z.buffer)):(y.push(z),C+=z.byteLength,C>=g&&(c.pause(),await j(),setTimeout(()=>c.resume())))},onError:z=>k.error(z),onEnd:async()=>{I||await j(),k.end(I?.end())}},F.token)})}async function a(c,h,g){const w=(await(0,L.$RD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(h),g);let k=!1,y=!1;return{read(){if(y)return null;const C=c.read();if(typeof C!="string"){if(y=!0,!k&&g?.addBOM)switch(h){case e.$SD:case e.$TD:return N.$Ce.wrap(Uint8Array.from(e.$ZD));case e.$UD:return N.$Ce.wrap(Uint8Array.from(e.$XD));case e.$VD:return N.$Ce.wrap(Uint8Array.from(e.$YD))}const I=w.end();return I&&I.length>0?(k=!0,N.$Ce.wrap(I)):null}return k=!0,N.$Ce.wrap(w.write(C))}}}async function m(c){return(await(0,L.$RD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(c))}function o(c){return c===e.$TD||c===null?e.$SD:c}function n(c,h){if(!c||h<e.$XD.length)return null;const g=c.readUInt8(0),D=c.readUInt8(1);if(g===e.$XD[0]&&D===e.$XD[1])return e.$UD;if(g===e.$YD[0]&&D===e.$YD[1])return e.$VD;if(h<e.$ZD.length)return null;const w=c.readUInt8(2);return g===e.$ZD[0]&&D===e.$ZD[1]&&w===e.$ZD[2]?e.$TD:null}const i=["ascii","utf-16","utf-32"];async function r(c){const h=await(0,L.$RD)("jschardet","dist/jschardet.min.js"),g=c.slice(0,A),D=f(g.buffer),w=h.detect(D);if(!w||!w.encoding)return null;const k=w.encoding.toLowerCase();return 0<=i.indexOf(k)?null:t(w.encoding)}const s={ibm866:"cp866",big5:"cp950"};function t(c){const h=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[h]||h}function f(c){let h="";for(let g=0;g<c.length;g++)h+=String.fromCharCode(c[g]);return h}function d(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=c.match(/windows(\d+)/);return h?"windows-"+h[1]:c}}}function l({buffer:c,bytesRead:h},g){let D=n(c,h),w=!1;if(D!==e.$UD&&D!==e.$VD&&c){let k=!0,y=!0,C=!1;for(let I=0;I<h&&I<p;I++){const F=I%2===1,j=c.readUInt8(I)===0;if(j&&(C=!0),k&&(F&&!j||!F&&j)&&(k=!1),y&&(F&&j||!F&&!j)&&(y=!1),j&&!k&&!y)break}C&&(k?D=e.$VD:y?D=e.$UD:w=!0)}return g&&!w&&!D&&c?r(c.slice(0,h)).then(k=>({seemsBinary:!1,encoding:k})):{seemsBinary:w,encoding:D}}e.$9D={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[160],Ee([1,0,386,31,159]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cmc=void 0;class R extends L.$mlc{constructor(p,b,S=N,A="searchProcess"){super({query:p,provider:b},{readdir:P=>S.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,u.$7D)(P)},A)}}e.$Cmc=R}),define(ke[161],Ee([1,0,53,402,385,19,73,35,14,2,36,94,403,383,122]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=e.$vmc=void 0,e.$xmc=t,e.$ymc=d,e.$zmc=c,e.$Amc=h,e.$Bmc=D;const a=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(k){this.a=k}provideTextSearchResults(k,y,C,I){return this.a.appendLine(`provideTextSearchResults ${k.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((F,j)=>{I.onCancellationRequested(()=>X());const z=t(k,y),O=y.folder.fsPath,T=z.map(Ce=>Ce.match(/^-/)?Ce:`'${Ce}'`).join(" ");this.a.appendLine(`${a} ${T}
 - cwd: ${O}`);let B=u.spawn(a,z,{cwd:O});B.on("error",Ce=>{console.error(Ce),this.a.appendLine("Error: "+(Ce&&Ce.message)),j((0,A.$dL)(new A.$bL(Ce&&Ce.message,A.SearchErrorCode.rgProcessError)))});let W=!1;const Z=new i(y.maxResults,y.folder,y.previewOptions);Z.on("result",Ce=>{W=!0,ce="",C.report(Ce)});let x=!1;const X=()=>{x=!0,B?.kill(),Z?.cancel()};let Y=!1;Z.on("hitLimit",()=>{Y=!0,X()});let ce="";B.stdout.on("data",Ce=>{Z.handleData(Ce),W||(ce+=Ce)});let ne=!1;B.stdout.once("data",()=>ne=!0);let $e="";B.stderr.on("data",Ce=>{const ee=Ce.toString();this.a.appendLine(ee),$e.length+ee.length<1e6&&($e+=ee)}),B.on("close",()=>{if(this.a.appendLine(ne?"Got data from stdout":"No data from stdout"),this.a.appendLine(W?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),x)F({limitHit:Y});else{Z.flush(),B=null;let Ce;$e&&!ne&&(Ce=o($e))?j((0,A.$dL)(new A.$bL(Ce.message,Ce.code))):F({limitHit:Y})}})})}}e.$vmc=m;function o(w){const k=w.split(`
`),y=k[0].trim();if(k.some(I=>I.startsWith("regex parse error")))return new A.$bL(n(k),A.SearchErrorCode.regexParseError);const C=y.match(/grep config error: unknown encoding: (.*)/);if(C)return new A.$bL(`Unknown encoding: ${C[1]}`,A.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new A.$bL(y.charAt(0).toUpperCase()+y.substr(1),A.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new A.$bL(y.charAt(0).toUpperCase()+y.substr(1),A.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new A.$bL(y,A.SearchErrorCode.regexParseError)}function n(w){const k=["Regex parse error"],y=w.filter(C=>C.startsWith("PCRE2:"));if(y.length>=1){const C=y[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const I=C.split(":")[1];k.push(":"+I)}}return k.join("")}class i extends N.EventEmitter{constructor(k,y,C){super(),this.g=k,this.h=y,this.j=C,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new L.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(k,y){return super.on(k,y),this}handleData(k){if(this.b)return;const y=typeof k=="string"?k:this.d.write(k);this.k(y)}k(k){let y=k.indexOf(`
`);const C=this.a+k;if(y>=0)y+=this.a.length;else{this.a=C;return}let I=0;for(;y>=0;)this.m(C.substring(I,y).trim()),I=y+1,y=C.indexOf(`
`,I);this.a=C.substring(I)}m(k){if(this.b||!k)return;let y;try{y=JSON.parse(k)}catch{throw new Error(`malformed line from rg: ${k}`)}if(y.type==="match"){const C=r(y.data.path),I=S.URI.joinPath(this.h,C),F=this.n(y.data,I);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const C=r(y.data.path),I=S.URI.joinPath(this.h,C);this.o(y.data,I).forEach(j=>this.p(j))}}n(k,y){const C=k.line_number-1,I=r(k.lines),F=Buffer.from(I);let j=0,z=0,O=C;k.submatches.length===0&&k.submatches.push(I.length?{start:0,end:1,match:{text:I[0]}}:{start:0,end:0,match:{text:""}});const T=(0,R.$Hb)(k.submatches.map((B,W)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Z=r(B.match),x=F.slice(j,B.start).toString(),X=s(x),Y=X.numLines>0?X.lastLineLength:X.lastLineLength+z,ce=s(Z),ne=X.numLines+O,$e=ce.numLines+ne,Ce=ce.numLines>0?ce.lastLineLength:ce.lastLineLength+Y;return j=B.end,z=Ce,O=$e,new P.$XK(ne,Y,$e,Ce)}));return(0,v.$omc)(y,I,T,this.j)}o(k,y){const C=r(k.lines),I=k.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((F,j)=>({text:F,uri:y,lineNumber:I+j}))}p(k){this.emit("result",k)}}e.$wmc=i;function r(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function s(w){const k=/\n/g;let y=0,C=-1,I;for(;I=k.exec(w);)y++,C=I.index;const F=C>=0?w.length-C-1:w.length;return{numLines:y,lastLineLength:F}}function t(w,k){const y=["--hidden","--no-require-git"];y.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:I}=(0,M.$K)(k.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(I&&I.length){const j=new Set;I.forEach(z=>{j.add(z)}),y.push("-g","!*"),j.forEach(z=>{f(z).map(v.$nmc).forEach(O=>{y.push("-g",O)})})}C&&C.length&&C.forEach(j=>{y.push("-g",j)}),k.excludes.map(v.$nmc).forEach(j=>y.push("-g",`!${j}`)),k.maxFileSize&&y.push("--max-filesize",k.maxFileSize+""),k.useIgnoreFiles?k.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),k.followSymlinks&&y.push("--follow"),k.encoding&&k.encoding!=="utf8"&&y.push("--encoding",k.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,b.$8e)(w.pattern),w.isRegExp=!0),k.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),w.isRegExp&&(w.pattern=d(w.pattern),y.push("--engine","auto"));let F;if(w.isWordMatch){const z=(0,b.$ef)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",z)}else if(w.isRegExp){let j=c(w.pattern);j=h(j),y.push("--regexp",j)}else F=w.pattern,y.push("--fixed-strings");return y.push("--no-config"),k.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),w.isMultiline&&y.push("--multiline"),k.beforeContext&&y.push("--before-context",k.beforeContext+""),k.afterContext&&y.push("--after-context",k.afterContext+""),y.push("--"),F&&y.push(F),y.push("."),y}function f(w){return D(w).flatMap(y=>{const C=(0,p.$ik)(y,"/");return C.map((I,F)=>C.slice(0,F+1).join("/"))})}function d(w){const k=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(k);)w=w.replace(k,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(y);)w=w.replace(y,"$1\\x{$2}");return w}const l=w=>w.type==="Assertion"&&w.kind==="lookbehind";function c(w){let k;try{k=new $.RegExpParser().parsePattern(w)}catch{return w}let y="",C=0;const I=(z,O,T)=>{y+=w.slice(C,z)+T,C=O},F=[];return new $.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const O=F[0];if(!O)I(z.start,z.end,"\\r?\\n");else if(!F.some(l))if(O.type==="CharacterClass")if(O.negate){const T=w.slice(O.start+2,z.start)+w.slice(z.end,O.end-1);O.parent?.type==="Quantifier"?I(O.start,O.end,T?`[^${T}]`:"."):I(O.start,O.end,"(?!\\r?\\n"+(T?`|[${T}]`:"")+")")}else{const T=w.slice(O.start+1,z.start)+w.slice(z.end,O.end-1);I(O.start,O.end,T===""?"\\r?\\n":`(?:[${T}]|\\r?\\n)`)}else O.type==="Quantifier"&&I(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){F.unshift(z)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(z){F.unshift(z)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(z){F.unshift(z)},onCharacterClassLeave(){F.shift()},onAssertionEnter(z){l(z)&&F.push(z)},onAssertionLeave(z){F[0]===z&&F.shift()}}).visit(k),y+=w.slice(C),y}function h(w){return w.replace(/\n/g,"\\r?\\n")}function g(w){let k=!1,y=!1,C="",I="";for(let F=0;F<w.length;F++){const j=w[F];switch(j){case"\\":y?(k?I+="\\"+j:C+="\\"+j,y=!1):y=!0;break;case"{":if(y)k?I+=j:C+=j,y=!1;else{if(k)return{strInBraces:C+"{"+I+"{"+w.substring(F+1)};k=!0}break;case"}":if(y)k?I+=j:C+=j,y=!1;else{if(k)return{fixedStart:C,strInBraces:I,fixedEnd:w.substring(F+1)};C+=j}break;default:k?I+=(y?"\\":"")+j:C+=(y?"\\":"")+j,y=!1;break}}return{strInBraces:C+(k?"{"+I:"")}}function D(w){const{fixedStart:k,strInBraces:y,fixedEnd:C}=g(w);if(k===void 0||C===void 0)return[y];let I=(0,p.$ik)(y,",");I.length||(I=[""]);const F=D(C);return I.flatMap(j=>{const z=k+j;return F.map(O=>z+O)})}}),define(ke[387],Ee([1,0,22,161,108,15]),function(le,e,u,N,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;class M{constructor(S){this.b=S,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(S,A,P,$){const E=new N.$vmc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const v={...A,folder:A.folder.with({scheme:R.Schemas.file})},a=new L.$Zv(m=>P.report({...m,uri:m.uri.with({scheme:A.folder.scheme})}));return this.c($,m=>E.provideTextSearchResults(S,v,a,m))}else return this.c($,v=>E.provideTextSearchResults(S,A,P,v))}async c(S,A){const P=p(S);this.a.add(P);const $=await A(P.token);return this.a.delete(P),$}d(){this.a.forEach(S=>S.cancel())}}e.$Fmc=M;function p(b){const S=new u.$me;return b.onCancellationRequested(()=>S.cancel()),S}}),define(ke[388],Ee([1,0,31,161,160]),function(le,e,u,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=void 0;class R{constructor(b){this.a=b}search(b,S,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(E){A({message:E})}},$=new L.$Cmc(this.a,new N.$vmc(P),u);return new Promise((E,v)=>$.search(a=>{S(a.map(M))},b).then(a=>E({limitHit:a.limitHit,type:"success",stats:a.stats}),v))}}e.$Dmc=R;function M(p){return{path:p.resource&&p.resource.fsPath,results:p.results,numMatches:(p.results||[]).reduce((b,S)=>{if(S.ranges){const A=S;return b+(Array.isArray(A.ranges)?A.ranges.length:1)}else return b+1},0)}}}),define(ke[389],Ee([1,0,19,7,13,4,132,17,39,2,32,36,384,388]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class v{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let s;const t=o(r),f=new R.$be({onDidAddFirstListener:()=>{s=(0,N.$dh)(d=>this.doFileSearchWithEngine($.$umc,t,l=>f.fire(l),d)),s.then(d=>f.fire(d),d=>f.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}textSearch(r){let s;const t=o(r),f=new R.$be({onDidAddFirstListener:()=>{s=(0,N.$dh)(d=>this.f(t,l=>f.fire(l),d)),s.then(d=>f.fire(d),d=>f.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}f(r,s,t){return r.maxFileSize=this.g().maxFileSize,new E.$Dmc(r).search(t,s,s)}g(){return{maxFileSize:16*A.$sl.GB}}doFileSearch(r,s,t){return this.doFileSearchWithEngine($.$umc,r,s,t)}doFileSearchWithEngine(r,s,t,f,d=v.a){let l=0;const c=g=>{Array.isArray(g)?(l+=g.length,t(g.map(D=>this.h(D)))):g.relativePath?(l++,t(this.h(g))):t(g)};if(s.sortByScore){let g=this.l(s,c,f);if(!g){const D=s.maxResults?Object.assign({},s,{maxResults:null}):s,w=new r(D);g=this.j(w,s,t,c,f)}return new Promise((D,w)=>{g.then(([k,y])=>{const C=y.map(I=>this.h(I));this.o(C,t,d),D(k)},w)})}const h=new r(s);return this.r(h,c,d,f).then(g=>({limitHit:g.limitHit,type:"success",stats:{detailStats:g.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}h(r){return{path:r.base?(0,p.$kc)(r.base,r.relativePath):r.relativePath}}j(r,s,t,f,d){const l=new R.$be;let c=(0,N.$dh)(g=>{let D=[];const w=k=>{Array.isArray(k)?D=k:(f(k),l.fire(k))};return this.r(r,w,-1,g).then(k=>[k,D])}),h;if(s.cacheKey){h=this.k(s.cacheKey);const g={promise:c,event:l.event,resolved:!1};h.resultsToSearchCache[s.filePattern||""]=g,c.then(()=>{g.resolved=!0},D=>{delete h.resultsToSearchCache[s.filePattern||""]}),c=this.s(c)}return c.then(([g,D])=>{const w=h?h.scorerCache:Object.create(null),k=(typeof s.maxResults!="number"||s.maxResults>0)&&b.$0d.create(!1);return this.n(s,D,w,d).then(y=>{const C=k?k.elapsed():-1;return[{type:"success",stats:{detailStats:g.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:s.folderQueries.length,resultCount:y.length},messages:g.messages,limitHit:g.limitHit||typeof s.maxResults=="number"&&D.length>s.maxResults},y]})})}k(r){const s=this.b[r];return s||(this.b[r]=new a)}l(r,s,t){const f=r.cacheKey&&this.b[r.cacheKey];if(!f)return;const d=this.q(f,r.filePattern||"",s,t);if(d)return d.then(([l,c,h])=>{const g=b.$0d.create(!1);return this.n(r,c,f.scorerCache,t).then(D=>{const w=g.elapsed(),k={fromCache:!0,detailStats:h,type:this.d,resultCount:c.length,sortingTime:w};return[{type:"success",limitHit:l.limitHit||typeof r.maxResults=="number"&&c.length>r.maxResults,stats:k},D]})})}n(r,s,t,f){const d=(0,M.$pr)(r.filePattern||""),l=(h,g)=>(0,M.$or)(h,g,d,!0,m,t),c=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return u.$Gb(s,l,c,1e4,f)}o(r,s,t){if(t&&t>0)for(let f=0;f<r.length;f+=t)s(r.slice(f,f+t));else s(r)}q(r,s,t,f){const d=b.$0d.create(!1),l=s.indexOf(p.sep)>=0;let c;for(const w in r.resultsToSearchCache)if(s.startsWith(w)){if(l&&w.indexOf(p.sep)<0&&w!=="")continue;const k=r.resultsToSearchCache[w];c={promise:this.s(k.promise),event:k.event,resolved:k.resolved};break}if(!c)return null;const h=d.elapsed(),g=b.$0d.create(!1),D=c.event(t);return f&&f.onCancellationRequested(()=>{D.dispose()}),c.promise.then(([w,k])=>{if(f&&f.isCancellationRequested)throw(0,L.$6)();const y=[],C=(0,M.$pr)(s).normalizedLowercase;for(const I of k)(0,P.$hL)(I,C)&&y.push(I);return[w,y,{cacheWasResolved:c.resolved,cacheLookupTime:h,cacheFilterTime:g.elapsed(),cacheEntryCount:k.length}]})}r(r,s,t,f){return new Promise((d,l)=>{let c=[];f?.onCancellationRequested(()=>r.cancel()),r.search(h=>{h&&(t?(c.push(h),t>0&&c.length>=t&&(s(c),c=[])):s(h))},h=>{s(h)},(h,g)=>{c.length&&s(c),h?(s({message:"Search finished. Error: "+h.message}),l(h)):(s({message:"Search finished. Stats: "+JSON.stringify(g.stats)}),d(g))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,t){return r.then(s,t)}catch(s){return this.then(void 0,s)}finally(s){return r.finally(s)}}}}e.$Emc=v;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(i){return(0,p.$oc)(i.relativePath)}getItemDescription(i){return(0,p.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function o(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(r=>S.URI.revive(r))}}function n(i){return{...i,folder:S.URI.revive(i.folder)}}}),define(ke[390],Ee([1,0,3,15,2,31,12,28,20,97,67,36,389,387,122,160]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=void 0;let m=class extends S.$rlc{constructor(n,i,r,s){super(n,r,s),this.w=R,this.x=-1,this.y=null,this.z=!1,this.A=new u.$Tc;const t=new v.$pmc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new E.$Fmc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new v.$pmc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.file,new E.$Fmc(n))),this.A.add(this.C(N.Schemas.file,new $.$Emc("fileSearchProvider")))}C(n,i){const r=this.d++;return this.y=i,this.x=r,this.c.$registerFileSearchProvider(r,this.s(n)),(0,u.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(n,i,r,s){const t=(0,S.$slc)(r);if(n===this.x){const f=Date.now();return this.D(n,i,t,s).then(d=>{const l=Date.now()-f;return this.q.debug(`Ext host file search time: ${l}ms`),d})}return super.$provideFileSearchResults(n,i,r,s)}doInternalFileSearchWithCustomCallback(n,i,r){const s=t=>{if((0,P.$gL)(t)&&(t=[t]),Array.isArray(t)){r(t.map(f=>L.URI.file(f.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,s,i)}async D(n,i,r,s){return this.doInternalFileSearchWithCustomCallback(r,s,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new a.$Cmc(n,i,void 0,"textSearchProvider")}};e.$Gmc=m,e.$Gmc=m=Je([qe(0,b.$aP),qe(1,p.$qP),qe(2,A.$ikc),qe(3,M.$Wj)],m)}),define(ke[123],Ee([1,0,377,63,64,404,21,13,4,3,17,11,30,81,82]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$hi=e.$gi=e.$fi=void 0,e.$ii=d,e.$ji=l,e.$li=g,e.$mi=D;class a{traceSocketEvent(k,y){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,y)}constructor(k,y=""){this.f=!0,this.debugLabel=y,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,p.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const y=C=>{this.traceSocketEvent("read",C),k(M.$Ce.wrap(C))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(k){const y=C=>{k({type:0,hadError:C,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(k){const y=()=>{k()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,p.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,p.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$fi=a;var m;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var o;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(o||(o={}));class n extends S.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,y){this.socket.traceSocketEvent(k,y)}constructor(k,y,C,I){super(),this.f=this.B(new b.$be),this.g=this.B(new b.$be),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:C?.byteLength||0,recordInflateBytes:I}),this.a=this.B(new i(this,y,C,I,this.f,(F,j)=>this.m(F,j))),this.B(this.a.onError(F=>{console.error(F),(0,p.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new v.$ai,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let y=0;for(;y<k.byteLength;)this.a.writeMessage(k.slice(y,Math.min(y+262144,k.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(k,{compressed:y,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let I=2;k.byteLength<126?I+=0:k.byteLength<2**16?I+=2:I+=8;const F=M.$Ce.alloc(I),j=y?64:0,z=C&15;if(F.writeUInt8(128|j|z,0),k.byteLength<126)F.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){F.writeUInt8(126,1);let O=1;F.writeUInt8(k.byteLength>>>8&255,++O),F.writeUInt8(k.byteLength>>>0&255,++O)}else{F.writeUInt8(127,1);let O=1;F.writeUInt8(0,++O),F.writeUInt8(0,++O),F.writeUInt8(0,++O),F.writeUInt8(0,++O),F.writeUInt8(k.byteLength>>>24&255,++O),F.writeUInt8(k.byteLength>>>16&255,++O),F.writeUInt8(k.byteLength>>>8&255,++O),F.writeUInt8(k.byteLength>>>0&255,++O)}this.socket.write(M.$Ce.concat([F,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),C=y.readUInt8(0),I=(C&128)>>>7,F=(C&64)>>>6,j=C&15,z=y.readUInt8(1),O=(z&128)>>>7,T=z&127;this.j.state=2,this.j.readLen=2+(O?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=I,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!I,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),C=y.readUInt8(1),I=(C&128)>>>7;let F=C&127,j=1;F===126?F=y.readUInt8(++j)*2**8+y.readUInt8(++j):F===127&&(F=y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*0+y.readUInt8(++j)*2**24+y.readUInt8(++j)*2**16+y.readUInt8(++j)*2**8+y.readUInt8(++j));let z=0;I&&(z=y.readUInt8(++j)*2**24+y.readUInt8(++j)*2**16+y.readUInt8(++j)*2**8+y.readUInt8(++j)),this.j.state=3,this.j.readLen=F,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$gi=n;class i extends S.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:M.$Ce.alloc(0)}constructor(k,y,C,I,F,j){super(),this.n=k,this.r=F,this.s=j,this.a=this.B(new b.$be),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$be),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$be),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new r(this.n,I,C,{windowBits:15})),this.f=this.B(new s(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(k,y){this.g.push({data:k,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:y}=this.g.shift();if(this.f&&y.compressed){const C=await this.w(this.f,k);this.s(C,y)}else this.s(k,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,y){return new Promise((C,I)=>{k.write(y),k.flush(F=>C(F))})}acceptFrame(k,y,C){this.h.push({data:k,isCompressed:y,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const y=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,y,C){return new Promise((I,F)=>{k.write(y),C&&k.write(M.$Ce.fromByteArray([0,0,255,255])),k.flush(j=>I(j))})}}class r extends S.$Uc{get recordedInflateBytes(){return this.j?M.$Ce.concat(this.f):M.$Ce.alloc(0)}constructor(k,y,C,I){super(),this.h=k,this.j=y,this.a=this.B(new b.$be),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(I),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(M.$Ce.wrap(F))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=M.$Ce.concat(this.g);this.g.length=0,k(y)})}}class s extends S.$Uc{constructor(k,y){super(),this.g=k,this.a=this.B(new b.$be),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(M.$Ce.wrap(C))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=M.$Ce.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),k(y)})}}function t(w,k){if(k===0)return;const y=w.byteLength>>>2;for(let O=0;O<y;O++){const T=w.readUInt32BE(O*4);w.writeUInt32BE(T^k,O*4)}const C=y*4,I=w.byteLength-C,F=k>>>24&255,j=k>>>16&255,z=k>>>8&255;I>=1&&w.writeUInt8(w.readUInt8(C)^F,C),I>=2&&w.writeUInt8(w.readUInt8(C+1)^j,C+1),I>=3&&w.writeUInt8(w.readUInt8(C+2)^z,C+2)}e.$hi=process.env.XDG_RUNTIME_DIR;const f={2:107,1:103};function d(){const w=(0,$.$Mg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const k=process.platform!=="darwin"&&e.$hi?e.$hi:(0,L.tmpdir)(),y=(0,A.$kc)(k,`vscode-ipc-${w}.sock`);return c(y),y}function l(w,k,y){const I=(0,u.createHash)("sha256").update(w).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${y}-${k}-sock`;const F=y.substr(0,4),j=k.substr(0,6);let z;return process.platform!=="darwin"&&e.$hi&&!process.env.VSCODE_PORTABLE?z=(0,A.$kc)(e.$hi,`vscode-${I}-${F}-${j}.sock`):z=(0,A.$kc)(w,`${F}-${j}.sock`),c(z),z}function c(w){const k=f[P.$u];typeof k=="number"&&w.length>=k&&console.warn(`WARNING: IPC handle "${w}" is longer than ${k} chars, try a shorter --user-data-dir`)}class h extends E.$7h{static b(k){const y=b.Event.fromNodeEventEmitter(k,"connection");return b.Event.map(y,C=>({protocol:new v.$bi(new a(C,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(C,"close"))}))}constructor(k){super(h.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ki=h;function g(w){return new Promise((k,y)=>{const C=(0,N.createServer)();C.on("error",y),C.listen(w,()=>{C.removeListener("error",y),k(new h(C))})})}function D(w,k){return new Promise((y,C)=>{const I=(0,N.createConnection)(w,()=>{I.removeListener("error",C),y(v.$ci.fromSocket(new a(I,`ipc-client${k}`),k))});I.once("error",C)})}}),define(ke[391],Ee([1,0,63,64,173,123,7,3,11,54,12,139,267,268,110,88,21]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=e.$vcc=e.$ucc=e.$tcc=void 0;async function o(t,f,d,l,c){let h;for(let g=3;g&&(h?.dispose(),h=await new n(t,f,d,l,c).waitForReady(),!(c&&L.$Pg[c]||!L.$Pg[h.tunnelLocalPort]));g--);return h}class n extends p.$Uc{constructor(f,d,l,c,h){super(),this.m=d,this.n=h,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=f,this.b=u.createServer(),this.c=new M.$ph,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=g=>this.r(g),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const f=this.n??this.tunnelRemotePort,d=(0,a.$aw)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,L.$Qg)(f,2,1e3,d),c=null;return this.b.listen(l,this.m),await this.c.wait(),c=this.b.address(),c||(l=0,this.b.listen(l,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(f){f.pause();const d=(0,a.$$v)(this.tunnelRemoteHost)||(0,a.$aw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,$.$Ml)(this.a,d,this.tunnelRemotePort),c=l.getSocket(),h=l.readEntireBuffer();l.dispose(),h.byteLength>0&&f.write(h.buffer),f.on("end",()=>{f.localAddress&&this.j.delete(f.localAddress),c.end()}),f.on("close",()=>c.end()),f.on("error",()=>{f.localAddress&&this.j.delete(f.localAddress),c instanceof R.$fi?c.socket.destroy():c.end()}),c instanceof R.$fi?this.t(f,c):this.s(f,c),f.localAddress&&this.j.set(f.localAddress,()=>{f.end(),c.end()})}s(f,d){d.onClose(()=>f.destroy()),d.onEnd(()=>f.end()),d.onData(l=>f.write(l.buffer)),f.on("data",l=>d.write(m.$Ce.wrap(l))),f.resume()}t(f,d){const l=d.socket;l.on("end",()=>f.end()),l.on("close",()=>f.end()),l.on("error",()=>{f.destroy()}),l.pipe(f),f.pipe(l)}}e.$tcc=n;let i=class extends a.$dw{constructor(f,d,l,c,h){super(d,h),this.v=f,this.w=l,this.y=c}isPortPrivileged(f){return(0,a.$bw)(f,this.m,b.OS,N.release())}t(f,d,l,c,h,g,D,w){const k=this.s(d,l);if(k)return++k.refcount,k.value;if((0,a.$7v)(f))return this.u(f,d,l,h,g,D,w);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${h}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:f,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=o(y,c,d,l,h);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(d,l,C),C}}};e.$ucc=i,e.$ucc=i=Je([qe(0,E.$Gl),qe(1,A.$Wj),qe(2,v.$Jl),qe(3,P.$dk),qe(4,S.$Wi)],i);let r=class extends i{constructor(f,d,l,c,h){super(f,d,l,c,h)}};e.$vcc=r,e.$vcc=r=Je([qe(0,E.$Gl),qe(1,A.$Wj),qe(2,v.$Jl),qe(3,P.$dk),qe(4,S.$Wi)],r);let s=class extends p.$Uc{constructor(f,d,l,c,h){super(),this.b=f,this.c=d,this.f=l,this.g=c,this.h=h,this.a=new Map}async openTunnel(f,d,l,c,h,g,D,w,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${c} on local port ${g}.`),!this.a.has(f)){const y=new r(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(f,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(d,l,c,h,g,D,w,k)}};e.$wcc=s,e.$wcc=s=Je([qe(0,E.$Gl),qe(1,A.$Wj),qe(2,P.$dk),qe(3,v.$Jl),qe(4,S.$Wi)],s)}),define(ke[392],Ee([1,0,123,287,52,33,2,12,41]),function(le,e,u,N,L,R,M,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=e.$BP=void 0;class S{constructor($,E,v){this.b=$,this.c=E,this.f=v,this.a=N.createServer((a,m)=>this.h(a,m)),this.g().catch(a=>(E.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,E){const v=(m,o)=>{E.writeHead(m,{"content-type":"application/json"}),E.end(JSON.stringify(o||null),n=>n&&this.c.error(n))},a=[];$.setEncoding("utf8"),$.on("data",m=>a.push(m)),$.on("end",async()=>{try{const m=JSON.parse(a.join(""));let o;switch(m.type){case"open":o=await this.i(m);break;case"openExternal":o=await this.j(m);break;case"status":o=await this.l(m);break;case"extensionManagement":o=await this.k(m);break;default:v(404,`Unknown message type: ${m.type}`);break}v(200,o)}catch(m){const o=m instanceof Error?m.message:JSON.stringify(m);v(500,o),this.c.error("Error while processing pipe request",m)}})}async i($){const{fileURIs:E,folderURIs:v,forceNewWindow:a,diffMode:m,mergeMode:o,addMode:n,forceReuseWindow:i,gotoLineMode:r,waitMarkerFilePath:s,remoteAuthority:t}=$,f=[];if(Array.isArray(v))for(const h of v)try{f.push({folderUri:M.URI.parse(h)})}catch{}if(Array.isArray(E))for(const h of E)try{(0,b.$Vi)(h)?f.push({workspaceUri:M.URI.parse(h)}):f.push({fileUri:M.URI.parse(h)})}catch{}const d=s?M.URI.file(s):void 0,c={forceNewWindow:a,diffMode:m,mergeMode:o,addMode:n,gotoLineMode:r,forceReuseWindow:i,preferNewWindow:!i&&!d&&!n,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",f,c)}async j($){for(const E of $.uris){const v=M.URI.parse(E),a=v.scheme==="file"?v:E;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k($){const E=a=>a?.map(m=>/\.vsix$/i.test(m)?M.URI.parse(m):m),v={list:$.list,install:E($.install),uninstall:E($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&L.existsSync(this.f)&&L.unlinkSync(this.f)}}e.$BP=S;let A=class extends S{constructor($,E){super($,E,(0,u.$ii)())}};e.$CP=A,e.$CP=A=Je([qe(0,R.$wP),qe(1,p.$Wj)],A)}),define(ke[393],Ee([1,0,59,380,374,286,49,361,2,15,8,392,104,320,360]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=void 0;class a extends L.$amc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,r=i._load;i._load=function(d,l,c){return d=t(d),n.a.has(d)?n.a.get(d).load(d,b.URI.file((0,$.$Yq)(l.filename)),h=>r.apply(this,[h,l,c])):r.apply(this,arguments)};const s=i._resolveLookupPaths;i._resolveLookupPaths=(f,d)=>s.call(this,t(f),d);const t=f=>{for(const d of n.b){const l=d(f);if(l){f=l;break}}return f}}}class m extends M.$1kc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async vb(){this.h.createInstance(E.$Jmc);const n=this.h.invokeFunction(N.$9lc);if(this.h.createInstance(p.$Imc),this.f.remote.isRemote&&this.f.remote.authority){const s=this.h.createInstance(P.$CP);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}this.h.createInstance(v.$Kmc),await this.h.createInstance(a,n,{mine:this.J,all:this.L}).install(),u.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,R.$Hmc)(this.j,r,this,this.s,this.z,this.f),u.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,r){if(i.scheme!==S.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let s=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&u.mark(`code/extHost/willLoadExtensionCode/${t}`),s=le.__$__nodeRequire(i.fsPath)}finally{t&&u.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return s}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const r=n[i];r===null?delete process.env[i]:process.env[i]=r}}}e.$Lmc=m}),define(ke[394],Ee([1,0,53,21,4,3,125,11,23,2,31,12,266,66,110,88,391,28,20,70,368]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=void 0,e.$Mmc=s,e.$Nmc=t,e.$Omc=f,e.$Pmc=d,e.$Qmc=c,e.$Rmc=h,e.$Smc=g;function s(k){const y=k.trim().split(`
`),C=[];return y.forEach(F=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(F);j&&j.length>=3&&C.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),C.reduce((F,j)=>(F[j.socket]=j,F),{})}function t(...k){const y=[].concat(...k.map(d));return[...new Map(y.filter(C=>C.st==="0A").map(C=>{const I=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:f(I[0]),port:parseInt(I[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}function f(k){let y="";if(k.length===8)for(let C=k.length-2;C>=0;C-=2)y+=parseInt(k.substr(C,2),16),C!==0&&(y+=".");else for(let C=0;C<k.length;C+=8){const I=k.substring(C,C+8);let F="";for(let j=8;j>=2;j-=2)F+=I.substring(j-2,j),(j===6||j===2)&&(F=parseInt(F,16).toString(16),y+=`${F}`,F="",C+j!==k.length-6&&(y+=":"))}return y}function d(k){const y=k.trim().split(`
`),C=y.shift().trim().split(/\s+/).filter(F=>F!=="rx_queue"&&F!=="tm->when");return y.map(F=>F.trim().split(/\s+/).reduce((j,z,O)=>(j[C[O]||O]=z,j),{}))}function l(k){return!!k.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||k.indexOf("out/server-main.js")!==-1||k.indexOf("_productName=VSCode")!==-1}function c(k){const y=k.trim().split(`
`),C=[];return y.forEach(I=>{const F=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(I);F&&F.length>=4&&C.push({pid:parseInt(F[1],10),ppid:parseInt(F[2]),cmd:F[3]})}),C}async function h(k,y,C){const I=C.reduce((j,z)=>(j[z.pid]=z,j),{}),F=[];return k.forEach(({socket:j,ip:z,port:O})=>{const T=y[j]?y[j].pid:void 0,B=T?I[T]?.cmd:void 0;T&&B&&!l(B)&&F.push({host:z,port:O,detail:B,pid:T})}),F}function g(k,y,C){const I=new Map,F=c(y);for(const j of k){const z=C.get(j.port);if(z){I.set(j.port,z);continue}const O=F.find(T=>T.cmd.includes(`${j.port}`));if(O){let T=O,B;do B=F.find(W=>W.ppid===T.pid),B&&(T=B);while(B);I.set(j.port,{host:j.ip,port:j.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else I.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return I}let D=class extends i.$pCb{constructor(y,C,I,F){super(y,C,I),this.D=C,this.F=F,this.y=void 0,this.z=new Map,this.C=!1,p.$k&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const I=new M.$ym;let F=0;for(;this.C;){const j=new Date().getTime(),z=(await this.I()).filter(B=>(0,a.$$v)(B.host)||(0,a.$aw)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(B=>B.port).join(", ")}`);const O=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${O} ms.`),F++>3&&I.update(O),(!C||JSON.stringify(C)!==JSON.stringify(z))&&(C=z,await this.a.$onFoundNewCandidates(C));const T=this.G(I.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(B=>setTimeout(()=>B(),T))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",C="";try{y=await A.Promises.readFile("/proc/net/tcp","utf8"),C=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const I=t(y,C),F=await new Promise(x=>{(0,u.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(X,Y,ce)=>{x(Y)})}),j=s(F),z=await A.Promises.readdir("/proc"),O=[];for(const x of z)try{const X=Number(x),Y=b.$4g(S.URI.file("/proc"),x);if((await A.Promises.stat(Y.fsPath)).isDirectory()&&!isNaN(X)){const ne=await A.Promises.readlink(b.$4g(Y,"cwd").fsPath),$e=await A.Promises.readFile(b.$4g(Y,"cmdline").fsPath,"utf8");O.push({pid:X,cwd:ne,cmd:$e})}}catch{}const T=[],B=I.filter(x=>{const X=j[x.socket];return X||T.push(x),X}),W=h(B,j,O);let Z;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const x=await new Promise(X=>{(0,u.exec)("ps -F -A -l | grep root",(Y,ce,ne)=>{X(ce)})});this.z=g(T,x,this.z),Z=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${Z.map(X=>X.port).join(", ")}`)}return W.then(x=>Z?x.concat(Z):x)}w(y){return async C=>{const I=new m.$tcc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,z,O,T){const B=await y.makeConnection();return w.connect(B,z,O,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new E.$Cl(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await I.waitForReady();const F=new L.$be;return{localAddress:(0,r.$dM)(I.localAddress)??I.localAddress,remoteAddress:{port:I.tunnelRemotePort,host:I.tunnelRemoteHost},onDidDispose:F.event,dispose:()=>{I.dispose(),F.fire(),F.dispose()}}}}};e.$Tmc=D,e.$Tmc=D=Je([qe(0,n.$aP),qe(1,o.$qP),qe(2,P.$Wj),qe(3,v.$Jl)],D);class w extends $.$nsb{static connect(y,C,I,F){const j=new R.$Tc,z={onClose:j.add(new L.$be),onData:j.add(new L.$be),onEnd:j.add(new L.$be)};j.add(y.onDidReceiveMessage(T=>z.onData.fire(N.$Ce.wrap(T)))),j.add(y.onDidEnd(()=>z.onEnd.fire())),j.add(y.onDidClose(T=>z.onClose.fire({type:0,error:T,hadError:!!T})));const O=new w(y,F,z);return O.B(j),(0,$.$msb)(O,C,I,F,z)}constructor(y,C,I){super(C,I),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[395],Ee([1,0,84,363,378,376,390,393,394,96,49,97,95,42,70,93,362,321,12,379,61,281,106,110,141]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o,n,i,r,s,t,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$os)(A.$2kc,p.$Lmc,0),(0,u.$os)(n.$Xj,o.$Vmc,1),(0,u.$os)(n.$Wj,new t.$ni(s.$_lc,[!1],!0)),(0,u.$os)(f.$Jl,d.$ycc,1),(0,u.$os)(a.$rkc,m.$Umc,0),(0,u.$os)(S.$7kc,R.$mmc,0),(0,u.$os)(P.$qlc,M.$Gmc,0),(0,u.$os)($.$Slc,L.$emc,0),(0,u.$os)(E.$Mkc,N.$dmc,0),(0,u.$os)(v.$oCb,b.$Tmc,0),(0,u.$os)(r.$5kc,i.$Wmc,0)}),define(ke[405],Ee([1,0,63,406,59,13,82,123,264,114,375,21,31,104,7,135,288,304,381,395]),function(le,e,u,N,L,R,M,p,b,S,A,P,$,E,v,a,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let g=0;g<process.execArgv.length;g++)process.execArgv[g]==="--inspect-port=0"&&(process.execArgv.splice(g,1),g--)}();const n=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const h=globalThis._VSCODE_NODE_MODULES.module,g=h._load;h._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return g.apply(this,arguments)}})();const i=process.exit.bind(process),r=process.on.bind(process);function s(h){process.exit=function(g){if(h)i(g);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const g=new Error("An extension called process.crash() and this was prevented.");console.warn(g.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(g,D){g==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),r(g,D)}}let t=function(h){i()};function f(){const h=(0,o.$in)(process.env);if(h.type===3)return new Promise((g,D)=>{const w=k=>{const y=k[0],C=new M.$di;y.on("message",I=>C.fire(P.$Ce.wrap(I.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),g({onMessage:C.event,send:I=>y.postMessage(I.buffer)})};process.parentPort.on("message",k=>w(k.ports))});if(h.type===2)return new Promise((g,D)=>{let w=null;const k=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,C=3e5,I=new v.$Dh(()=>t("renderer disconnected for too long (1)"),y),F=new v.$Dh(()=>t("renderer disconnected for too long (2)"),C);process.on("message",(z,O)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const T=P.$Ce.wrap(Buffer.from(z.initialDataChunk,"base64"));let B;if(z.skipWebSocketFrames)B=new p.$fi(O,"extHost-socket");else{const W=P.$Ce.wrap(Buffer.from(z.inflateBytes,"base64"));B=new p.$gi(new p.$fi(O,"extHost-socket"),z.permessageDeflate,W,!1)}w?(I.cancel(),F.cancel(),w.beginAcceptReconnection(B,T),w.endAcceptReconnection(),w.sendResume()):(clearTimeout(k),w=new M.$ei({socket:B,initialChunk:T}),w.sendResume(),w.onDidDispose(()=>t("renderer disconnected")),g(w),w.onSocketClose(()=>{I.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;I.isScheduled()&&F.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const g=h.pipeName;return new Promise((D,w)=>{const k=u.createConnection(g,()=>{k.removeListener("error",w);const y=new M.$ei({socket:new p.$fi(k,"extHost-renderer")});y.sendResume(),D(y)});k.once("error",w),k.on("close",()=>{t("renderer closed the socket")})})}}async function d(){const h=await f();return new class{constructor(){this.a=new M.$di,this.onMessage=this.a.event,this.b=!1,h.onMessage(g=>{(0,S.$Um)(g,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(g)})}send(g){this.b||h.send(g)}async drain(){if(h.drain)return h.drain()}}}function l(h){return new Promise(g=>{const D=h.onMessage(w=>{D.dispose();const k=JSON.parse(w.toString()),y=k.commit,C=b.default.commit;if(y&&C&&y!==C&&i(55),k.parentPid){let I=0;setInterval(function(){try{process.kill(k.parentPid,0),I=0}catch(j){j&&j.code==="EPERM"?(I++,I>=3&&t(`parent process ${k.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):t(`parent process ${k.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let F;try{F=globalThis._VSCODE_NODE_MODULES["native-watchdog"],F.start(k.parentPid)}catch(j){(0,R.$1)(j)}}h.send((0,S.$Tm)(0)),g({protocol:h,initData:k})});h.send((0,S.$Tm)(1))})}async function c(){const h=[];process.on("unhandledRejection",(I,F)=>{h.push(F),setTimeout(()=>{const j=h.indexOf(F);j>=0&&F.catch(z=>{h.splice(j,1),(0,R.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),I&&(0,R.$1)(I))})},1e3)}),process.on("rejectionHandled",I=>{const F=h.indexOf(I);F>=0&&h.splice(F,1)}),process.on("uncaughtException",function(I){(0,R.$Z)(I)||(0,R.$1)(I)}),L.mark("code/extHost/willConnectToRenderer");const g=await d();L.mark("code/extHost/didConnectToRenderer");const D=await l(g);L.mark("code/extHost/didWaitForInitData");const{initData:w}=D;s(!!w.environment.extensionTestsLocationURI),w.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,w.environment.skipWorkspaceStorageLock=(0,a.boolean)(n.skipWorkspaceStorageLock,!1);const k=new class{constructor(){this.pid=process.pid}exit(F){i(F)}fsExists(F){return $.Promises.exists(F)}fsRealpath(F){return(0,E.$Xq)(F)}};let y=null;w.remote.authority&&n.transformURIs&&(y=(0,m.$ss)(w.remote.authority));const C=new A.$cmc(D.protocol,w,k,y);t=I=>C.terminate(I)}c().catch(h=>console.log(h))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f8d35f6a712c59f96078161799435d0e83461556/core/vs/workbench/api/node/extensionHostProcess.js.map
