/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/iterator","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(ge){for(var e=[],I=0,N=ge.length;I<N;I++)e[I]=Re[ge[I]];return e};define(Re[68],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=N,e.$Vh=R,e.$Wh=F;function I(M){return(m,g,E)=>{let T=null,k=null;if(typeof E.value=="function"?(T="value",k=E.value):typeof E.get=="function"&&(T="get",k=E.get),!k)throw new Error("not supported");E[T]=M(k,g)}}function N(M,m,g){let E=null,T=null;if(typeof g.value=="function"?(E="value",T=g.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(E="get",T=g.get),!T)throw new Error("not supported");const k=`$memoize$${m}`;g[E]=function(...u){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,u)}),this[k]}}function R(M,m,g){return I((E,T)=>{const k=`$debounce$${T}`,u=`$debounce$result$${T}`;return function(...w){this[u]||(this[u]=g?g():void 0),clearTimeout(this[k]),m&&(this[u]=m(this[u],...w),w=[this[u]]),this[k]=setTimeout(()=>{E.apply(this,w),this[u]=g?g():void 0},M)}})}function F(M,m,g){return I((E,T)=>{const k=`$throttle$timer$${T}`,u=`$throttle$result$${T}`,w=`$throttle$lastRun$${T}`,d=`$throttle$pending$${T}`;return function(...n){if(this[u]||(this[u]=g?g():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),m&&(this[u]=m(this[u],...n)),this[d])return;const o=this[w]+M;o<=Date.now()?(this[w]=Date.now(),E.apply(this,[this[u]]),this[u]=g?g():void 0):(this[d]=!0,this[k]=setTimeout(()=>{this[d]=!1,this[w]=Date.now(),E.apply(this,[this[u]]),this[u]=g?g():void 0},o-Date.now()))}})}}),define(Re[90],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=void 0;class I{constructor(R){this.a=R,this.b=0}nextId(){return this.a+ ++this.b}}e.$fP=I,e.$gP=new I("id#")}),define(Re[123],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Bn=M,e.$Cn=k,e.$Dn=u,e.$En=w,e.$Fn=d,e.$Gn=n,e.$Hn=o,e.$In=s,e.$Jn=r,e.$Kn=i,e.$Ln=a,e.$Mn=h;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var F;(function(t){t.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function M(t,b=!1){let c=0;const $=t.length;let v="",p=0,l=16,D=0;function f(q){let A=0,j=0;for(;A<q;){const K=t.charCodeAt(c);if(K>=48&&K<=57)j=j*16+K-48;else if(K>=65&&K<=70)j=j*16+K-65+10;else if(K>=97&&K<=102)j=j*16+K-97+10;else break;c++,A++}return A<q&&(j=-1),j}function S(q){c=q,v="",p=0,l=16,D=0}function y(){const q=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&E(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&E(t.charCodeAt(c)))for(c++;c<t.length&&E(t.charCodeAt(c));)c++;else return D=3,t.substring(q,c);let A=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&E(t.charCodeAt(c))){for(c++;c<t.length&&E(t.charCodeAt(c));)c++;A=c}else D=3;return t.substring(q,A)}function C(){let q="",A=c;for(;;){if(c>=$){q+=t.substring(A,c),D=2;break}const j=t.charCodeAt(c);if(j===34){q+=t.substring(A,c),c++;break}if(j===92){if(q+=t.substring(A,c),c++,c>=$){D=2;break}switch(t.charCodeAt(c++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=f(4);ie>=0?q+=String.fromCharCode(ie):D=4;break}default:D=5}A=c;continue}if(j>=0&&j<=31)if(g(j)){q+=t.substring(A,c),D=2;break}else D=6;c++}return q}function P(){if(v="",D=0,p=c,c>=$)return p=$,l=17;let q=t.charCodeAt(c);if(m(q)){do c++,v+=String.fromCharCode(q),q=t.charCodeAt(c);while(m(q));return l=15}if(g(q))return c++,v+=String.fromCharCode(q),q===13&&t.charCodeAt(c)===10&&(c++,v+=`
`),l=14;switch(q){case 123:return c++,l=1;case 125:return c++,l=2;case 91:return c++,l=3;case 93:return c++,l=4;case 58:return c++,l=6;case 44:return c++,l=5;case 34:return c++,v=C(),l=10;case 47:{const A=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<$&&!g(t.charCodeAt(c));)c++;return v=t.substring(A,c),l=12}if(t.charCodeAt(c+1)===42){c+=2;const j=$-1;let K=!1;for(;c<j;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,K=!0;break}c++}return K||(c++,D=1),v=t.substring(A,c),l=13}return v+=String.fromCharCode(q),c++,l=16}case 45:if(v+=String.fromCharCode(q),c++,c===$||!E(t.charCodeAt(c)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=y(),l=11;default:for(;c<$&&V(q);)c++,q=t.charCodeAt(c);if(p!==c){switch(v=t.substring(p,c),v){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return v+=String.fromCharCode(q),c++,l=16}}function V(q){if(m(q)||g(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=P();while(q>=12&&q<=15);return q}return{setPosition:S,getPosition:()=>c,scan:b?W:P,getToken:()=>l,getTokenValue:()=>v,getTokenOffset:()=>p,getTokenLength:()=>c-p,getTokenError:()=>D}}function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function k(t,b){const c=[],$=new Object;let v;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function D(f,S,y,C){p.value=f,p.offset=S,p.length=y,p.type=C,p.colonOffset=void 0,v=p}try{i(t,{onObjectBegin:(f,S)=>{if(b<=f)throw $;v=void 0,l=b>f,c.push("")},onObjectProperty:(f,S,y)=>{if(b<S||(D(f,S,y,"property"),c[c.length-1]=f,b<=S+y))throw $},onObjectEnd:(f,S)=>{if(b<=f)throw $;v=void 0,c.pop()},onArrayBegin:(f,S)=>{if(b<=f)throw $;v=void 0,c.push(0)},onArrayEnd:(f,S)=>{if(b<=f)throw $;v=void 0,c.pop()},onLiteralValue:(f,S,y)=>{if(b<S||(D(f,S,y,h(f)),b<=S+y))throw $},onSeparator:(f,S,y)=>{if(b<=S)throw $;if(f===":"&&v&&v.type==="property")v.colonOffset=S,l=!1,v=void 0;else if(f===","){const C=c[c.length-1];typeof C=="number"?c[c.length-1]=C+1:(l=!0,c[c.length-1]=""),v=void 0}}})}catch(f){if(f!==$)throw f}return{path:c,previousNode:v,isAtPropertyKey:l,matches:f=>{let S=0;for(let y=0;S<f.length&&y<c.length;y++)if(f[S]===c[y]||f[S]==="*")S++;else if(f[S]!=="**")return!1;return S===f.length}}}function u(t,b=[],c=F.DEFAULT){let $=null,v=[];const p=[];function l(f){Array.isArray(v)?v.push(f):$!==null&&(v[$]=f)}return i(t,{onObjectBegin:()=>{const f={};l(f),p.push(v),v=f,$=null},onObjectProperty:f=>{$=f},onObjectEnd:()=>{v=p.pop()},onArrayBegin:()=>{const f=[];l(f),p.push(v),v=f,$=null},onArrayEnd:()=>{v=p.pop()},onLiteralValue:l,onError:(f,S,y)=>{b.push({error:f,offset:S,length:y})}},c),v[0]}function w(t,b=[],c=F.DEFAULT){let $={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(f){$.type==="property"&&($.length=f-$.offset,$=$.parent)}function p(f){return $.children.push(f),f}i(t,{onObjectBegin:f=>{$=p({type:"object",offset:f,length:-1,parent:$,children:[]})},onObjectProperty:(f,S,y)=>{$=p({type:"property",offset:S,length:-1,parent:$,children:[]}),$.children.push({type:"string",value:f,offset:S,length:y,parent:$})},onObjectEnd:(f,S)=>{$.length=f+S-$.offset,$=$.parent,v(f+S)},onArrayBegin:(f,S)=>{$=p({type:"array",offset:f,length:-1,parent:$,children:[]})},onArrayEnd:(f,S)=>{$.length=f+S-$.offset,$=$.parent,v(f+S)},onLiteralValue:(f,S,y)=>{p({type:h(f),offset:S,length:y,parent:$,value:f}),v(S+y)},onSeparator:(f,S,y)=>{$.type==="property"&&(f===":"?$.colonOffset=S:f===","&&v(S))},onError:(f,S,y)=>{b.push({error:f,offset:S,length:y})}},c);const D=$.children[0];return D&&delete D.parent,D}function d(t,b){if(!t)return;let c=t;for(const $ of b)if(typeof $=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let v=!1;for(const p of c.children)if(Array.isArray(p.children)&&p.children[0].value===$){c=p.children[1],v=!0;break}if(!v)return}else{const v=$;if(c.type!=="array"||v<0||!Array.isArray(c.children)||v>=c.children.length)return;c=c.children[v]}return c}function n(t){if(!t.parent||!t.parent.children)return[];const b=n(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;b.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&b.push(c)}return b}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const b=Object.create(null);for(const c of t.children){const $=c.children[1];$&&(b[c.children[0].value]=o($))}return b}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,b,c=!1){return b>=t.offset&&b<t.offset+t.length||c&&b===t.offset+t.length}function r(t,b,c=!1){if(s(t,b,c)){const $=t.children;if(Array.isArray($))for(let v=0;v<$.length&&$[v].offset<=b;v++){const p=r($[v],b,c);if(p)return p}return t}}function i(t,b,c=F.DEFAULT){const $=M(t,!1);function v(re){return re?()=>re($.getTokenOffset(),$.getTokenLength()):()=>!0}function p(re){return re?Se=>re(Se,$.getTokenOffset(),$.getTokenLength()):()=>!0}const l=v(b.onObjectBegin),D=p(b.onObjectProperty),f=v(b.onObjectEnd),S=v(b.onArrayBegin),y=v(b.onArrayEnd),C=p(b.onLiteralValue),P=p(b.onSeparator),V=v(b.onComment),W=p(b.onError),q=c&&c.disallowComments,A=c&&c.allowTrailingComma;function j(){for(;;){const re=$.scan();switch($.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(re){case 12:case 13:q?K(10):V();break;case 16:K(1);break;case 15:case 14:break;default:return re}}}function K(re,Se=[],Le=[]){if(W(re),Se.length+Le.length>0){let ne=$.getToken();for(;ne!==17;){if(Se.indexOf(ne)!==-1){j();break}else if(Le.indexOf(ne)!==-1)break;ne=j()}}}function ie(re){const Se=$.getTokenValue();return re?C(Se):D(Se),j(),!0}function ce(){switch($.getToken()){case 11:{let re=0;try{re=JSON.parse($.getTokenValue()),typeof re!="number"&&(K(2),re=0)}catch{K(2)}C(re);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return j(),!0}function ve(){return $.getToken()!==10?(K(3,[],[2,5]),!1):(ie(!1),$.getToken()===6?(P(":"),j(),pe()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Ie(){l(),j();let re=!1;for(;$.getToken()!==2&&$.getToken()!==17;){if($.getToken()===5){if(re||K(4,[],[]),P(","),j(),$.getToken()===2&&A)break}else re&&K(6,[],[]);ve()||K(4,[],[2,5]),re=!0}return f(),$.getToken()!==2?K(7,[2],[]):j(),!0}function ue(){S(),j();let re=!1;for(;$.getToken()!==4&&$.getToken()!==17;){if($.getToken()===5){if(re||K(4,[],[]),P(","),j(),$.getToken()===4&&A)break}else re&&K(6,[],[]);pe()||K(4,[],[4,5]),re=!0}return y(),$.getToken()!==4?K(8,[4],[]):j(),!0}function pe(){switch($.getToken()){case 3:return ue();case 1:return Ie();case 10:return ie(!0);default:return ce()}}return j(),$.getToken()===17?c.allowEmptyContent?!0:(K(4,[],[]),!1):pe()?($.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function a(t,b){const c=M(t),$=[];let v,p=0,l;do switch(l=c.getPosition(),v=c.scan(),v){case 12:case 13:case 17:p!==l&&$.push(t.substring(p,l)),b!==void 0&&$.push(c.getTokenValue().replace(/[^\r\n]/g,b)),p=c.getPosition();break}while(v!==17);return $.join("")}function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(ge,e){typeof define=="function"&&define.amd?define(Re[124],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Ee,$e){for(var fe=0;fe<$e.length;fe++){var Q=$e[fe];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(Ee,Q.key,Q)}}function I(Ee,$e,fe){return $e&&e(Ee.prototype,$e),fe&&e(Ee,fe),Object.defineProperty(Ee,"prototype",{writable:!1}),Ee}function N(Ee,$e){if(Ee){if(typeof Ee=="string")return R(Ee,$e);var fe=Object.prototype.toString.call(Ee).slice(8,-1);if(fe==="Object"&&Ee.constructor&&(fe=Ee.constructor.name),fe==="Map"||fe==="Set")return Array.from(Ee);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return R(Ee,$e)}}function R(Ee,$e){($e==null||$e>Ee.length)&&($e=Ee.length);for(var fe=0,Q=new Array($e);fe<$e;fe++)Q[fe]=Ee[fe];return Q}function F(Ee,$e){var fe=typeof Symbol<"u"&&Ee[Symbol.iterator]||Ee["@@iterator"];if(fe)return(fe=fe.call(Ee)).next.bind(fe);if(Array.isArray(Ee)||(fe=N(Ee))||$e&&Ee&&typeof Ee.length=="number"){fe&&(Ee=fe);var Q=0;return function(){return Q>=Ee.length?{done:!0}:{done:!1,value:Ee[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=M();function m(Ee){ge.defaults=Ee}var g=/[&<>"']/,E=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function($e){return u[$e]};function d(Ee,$e){if($e){if(g.test(Ee))return Ee.replace(E,w)}else if(T.test(Ee))return Ee.replace(k,w);return Ee}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ee){return Ee.replace(n,function($e,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var s=/(^|[^\[])\^/g;function r(Ee,$e){Ee=typeof Ee=="string"?Ee:Ee.source,$e=$e||"";var fe={replace:function(Y,le){return le=le.source||le,le=le.replace(s,"$1"),Ee=Ee.replace(Y,le),fe},getRegex:function(){return new RegExp(Ee,$e)}};return fe}var i=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ee,$e,fe){if(Ee){var Q;try{Q=decodeURIComponent(o(fe)).replace(i,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}$e&&!a.test(fe)&&(fe=v($e,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var t={},b=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,$=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Ee,$e){t[" "+Ee]||(b.test(Ee)?t[" "+Ee]=Ee+"/":t[" "+Ee]=f(Ee,"/",!0)),Ee=t[" "+Ee];var fe=Ee.indexOf(":")===-1;return $e.substring(0,2)==="//"?fe?$e:Ee.replace(c,"$1")+$e:$e.charAt(0)==="/"?fe?$e:Ee.replace($,"$1")+$e:Ee+$e}var p={exec:function(){}};function l(Ee){for(var $e=1,fe,Q;$e<arguments.length;$e++){fe=arguments[$e];for(Q in fe)Object.prototype.hasOwnProperty.call(fe,Q)&&(Ee[Q]=fe[Q])}return Ee}function D(Ee,$e){var fe=Ee.replace(/\|/g,function(le,de,Te){for(var he=!1,Ce=de;--Ce>=0&&Te[Ce]==="\\";)he=!he;return he?"|":" |"}),Q=fe.split(/ \|/),Y=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>$e)Q.splice($e);else for(;Q.length<$e;)Q.push("");for(;Y<Q.length;Y++)Q[Y]=Q[Y].trim().replace(/\\\|/g,"|");return Q}function f(Ee,$e,fe){var Q=Ee.length;if(Q===0)return"";for(var Y=0;Y<Q;){var le=Ee.charAt(Q-Y-1);if(le===$e&&!fe)Y++;else if(le!==$e&&fe)Y++;else break}return Ee.slice(0,Q-Y)}function S(Ee,$e){if(Ee.indexOf($e[1])===-1)return-1;for(var fe=Ee.length,Q=0,Y=0;Y<fe;Y++)if(Ee[Y]==="\\")Y++;else if(Ee[Y]===$e[0])Q++;else if(Ee[Y]===$e[1]&&(Q--,Q<0))return Y;return-1}function y(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(Ee,$e){if($e<1)return"";for(var fe="";$e>1;)$e&1&&(fe+=Ee),$e>>=1,Ee+=Ee;return fe+Ee}function P(Ee,$e,fe,Q){var Y=$e.href,le=$e.title?d($e.title):null,de=Ee[1].replace(/\\([\[\]])/g,"$1");if(Ee[0].charAt(0)!=="!"){Q.state.inLink=!0;var Te={type:"link",raw:fe,href:Y,title:le,text:de,tokens:Q.inlineTokens(de)};return Q.state.inLink=!1,Te}return{type:"image",raw:fe,href:Y,title:le,text:d(de)}}function V(Ee,$e){var fe=Ee.match(/^(\s+)(?:```)/);if(fe===null)return $e;var Q=fe[1];return $e.split(`
`).map(function(Y){var le=Y.match(/^\s+/);if(le===null)return Y;var de=le[0];return de.length>=Q.length?Y.slice(Q.length):Y}).join(`
`)}var W=function(){function Ee(fe){this.options=fe||ge.defaults}var $e=Ee.prototype;return $e.space=function(Q){var Y=this.rules.block.newline.exec(Q);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},$e.code=function(Q){var Y=this.rules.block.code.exec(Q);if(Y){var le=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?le:f(le,`
`)}}},$e.fences=function(Q){var Y=this.rules.block.fences.exec(Q);if(Y){var le=Y[0],de=V(le,Y[3]||"");return{type:"code",raw:le,lang:Y[2]?Y[2].trim():Y[2],text:de}}},$e.heading=function(Q){var Y=this.rules.block.heading.exec(Q);if(Y){var le=Y[2].trim();if(/#$/.test(le)){var de=f(le,"#");(this.options.pedantic||!de||/ $/.test(de))&&(le=de.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:le,tokens:this.lexer.inline(le)}}},$e.hr=function(Q){var Y=this.rules.block.hr.exec(Q);if(Y)return{type:"hr",raw:Y[0]}},$e.blockquote=function(Q){var Y=this.rules.block.blockquote.exec(Q);if(Y){var le=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},$e.list=function(Q){var Y=this.rules.block.list.exec(Q);if(Y){var le,de,Te,he,Ce,Me,ze,z,L,G,H,ee,se=Y[1].trim(),Fe=se.length>1,Be={type:"list",raw:"",ordered:Fe,start:Fe?+se.slice(0,-1):"",loose:!1,items:[]};se=Fe?"\\d{1,9}\\"+se.slice(-1):"\\"+se,this.options.pedantic&&(se=Fe?se:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+se+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ee=!1,!(!(Y=Qe.exec(Q))||this.rules.block.hr.test(Q)));){if(le=Y[0],Q=Q.substring(le.length),z=Y[2].split(`
`,1)[0],L=Q.split(`
`,1)[0],this.options.pedantic?(he=2,H=z.trimLeft()):(he=Y[2].search(/[^ ]/),he=he>4?1:he,H=z.slice(he),he+=Y[1].length),Me=!1,!z&&/^ *$/.test(L)&&(le+=L+`
`,Q=Q.substring(L.length+1),ee=!0),!ee)for(var xe=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,he-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,he-1)+"}#");Q&&(G=Q.split(`
`,1)[0],z=G,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(z)||tt.test(z)||xe.test(z)||_e.test(Q)));){if(z.search(/[^ ]/)>=he||!z.trim())H+=`
`+z.slice(he);else if(!Me)H+=`
`+z;else break;!Me&&!z.trim()&&(Me=!0),le+=G+`
`,Q=Q.substring(G.length+1)}Be.loose||(ze?Be.loose=!0:/\n *\n *$/.test(le)&&(ze=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(H),de&&(Te=de[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:le,task:!!de,checked:Te,loose:!1,text:H}),Be.raw+=le}Be.items[Be.items.length-1].raw=le.trimRight(),Be.items[Be.items.length-1].text=H.trimRight(),Be.raw=Be.raw.trimRight();var nt=Be.items.length;for(Ce=0;Ce<nt;Ce++){this.lexer.state.top=!1,Be.items[Ce].tokens=this.lexer.blockTokens(Be.items[Ce].text,[]);var ct=Be.items[Ce].tokens.filter(function(je){return je.type==="space"}),ft=ct.every(function(je){for(var st=je.raw.split(""),X=0,Z=F(st),me;!(me=Z()).done;){var He=me.value;if(He===`
`&&(X+=1),X>1)return!0}return!1});!Be.loose&&ct.length&&ft&&(Be.loose=!0,Be.items[Ce].loose=!0)}return Be}},$e.html=function(Q){var Y=this.rules.block.html.exec(Q);if(Y){var le={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(Y[0]):d(Y[0]);le.type="paragraph",le.text=de,le.tokens=this.lexer.inline(de)}return le}},$e.def=function(Q){var Y=this.rules.block.def.exec(Q);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var le=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:Y[0],href:Y[2],title:Y[3]}}},$e.table=function(Q){var Y=this.rules.block.table.exec(Q);if(Y){var le={type:"table",header:D(Y[1]).map(function(ze){return{text:ze}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=Y[0];var de=le.align.length,Te,he,Ce,Me;for(Te=0;Te<de;Te++)/^ *-+: *$/.test(le.align[Te])?le.align[Te]="right":/^ *:-+: *$/.test(le.align[Te])?le.align[Te]="center":/^ *:-+ *$/.test(le.align[Te])?le.align[Te]="left":le.align[Te]=null;for(de=le.rows.length,Te=0;Te<de;Te++)le.rows[Te]=D(le.rows[Te],le.header.length).map(function(ze){return{text:ze}});for(de=le.header.length,he=0;he<de;he++)le.header[he].tokens=this.lexer.inline(le.header[he].text);for(de=le.rows.length,he=0;he<de;he++)for(Me=le.rows[he],Ce=0;Ce<Me.length;Ce++)Me[Ce].tokens=this.lexer.inline(Me[Ce].text);return le}}},$e.lheading=function(Q){var Y=this.rules.block.lheading.exec(Q);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},$e.paragraph=function(Q){var Y=this.rules.block.paragraph.exec(Q);if(Y){var le=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:le,tokens:this.lexer.inline(le)}}},$e.text=function(Q){var Y=this.rules.block.text.exec(Q);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},$e.escape=function(Q){var Y=this.rules.inline.escape.exec(Q);if(Y)return{type:"escape",raw:Y[0],text:d(Y[1])}},$e.tag=function(Q){var Y=this.rules.inline.tag.exec(Q);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):d(Y[0]):Y[0]}},$e.link=function(Q){var Y=this.rules.inline.link.exec(Q);if(Y){var le=Y[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var de=f(le.slice(0,-1),"\\");if((le.length-de.length)%2===0)return}else{var Te=S(Y[2],"()");if(Te>-1){var he=Y[0].indexOf("!")===0?5:4,Ce=he+Y[1].length+Te;Y[2]=Y[2].substring(0,Te),Y[0]=Y[0].substring(0,Ce).trim(),Y[3]=""}}var Me=Y[2],ze="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);z&&(Me=z[1],ze=z[3])}else ze=Y[3]?Y[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(le)?Me=Me.slice(1):Me=Me.slice(1,-1)),P(Y,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},$e.reflink=function(Q,Y){var le;if((le=this.rules.inline.reflink.exec(Q))||(le=this.rules.inline.nolink.exec(Q))){var de=(le[2]||le[1]).replace(/\s+/g," ");if(de=Y[de.toLowerCase()],!de||!de.href){var Te=le[0].charAt(0);return{type:"text",raw:Te,text:Te}}return P(le,de,le[0],this.lexer)}},$e.emStrong=function(Q,Y,le){le===void 0&&(le="");var de=this.rules.inline.emStrong.lDelim.exec(Q);if(de&&!(de[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=de[1]||de[2]||"";if(!Te||Te&&(le===""||this.rules.inline.punctuation.exec(le))){var he=de[0].length-1,Ce,Me,ze=he,z=0,L=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(L.lastIndex=0,Y=Y.slice(-1*Q.length+he);(de=L.exec(Y))!=null;)if(Ce=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Ce){if(Me=Ce.length,de[3]||de[4]){ze+=Me;continue}else if((de[5]||de[6])&&he%3&&!((he+Me)%3)){z+=Me;continue}if(ze-=Me,!(ze>0)){if(Me=Math.min(Me,Me+ze+z),Math.min(he,Me)%2){var G=Q.slice(1,he+de.index+Me);return{type:"em",raw:Q.slice(0,he+de.index+Me+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=Q.slice(2,he+de.index+Me-1);return{type:"strong",raw:Q.slice(0,he+de.index+Me+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},$e.codespan=function(Q){var Y=this.rules.inline.code.exec(Q);if(Y){var le=Y[2].replace(/\n/g," "),de=/[^ ]/.test(le),Te=/^ /.test(le)&&/ $/.test(le);return de&&Te&&(le=le.substring(1,le.length-1)),le=d(le,!0),{type:"codespan",raw:Y[0],text:le}}},$e.br=function(Q){var Y=this.rules.inline.br.exec(Q);if(Y)return{type:"br",raw:Y[0]}},$e.del=function(Q){var Y=this.rules.inline.del.exec(Q);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},$e.autolink=function(Q,Y){var le=this.rules.inline.autolink.exec(Q);if(le){var de,Te;return le[2]==="@"?(de=d(this.options.mangle?Y(le[1]):le[1]),Te="mailto:"+de):(de=d(le[1]),Te=de),{type:"link",raw:le[0],text:de,href:Te,tokens:[{type:"text",raw:de,text:de}]}}},$e.url=function(Q,Y){var le;if(le=this.rules.inline.url.exec(Q)){var de,Te;if(le[2]==="@")de=d(this.options.mangle?Y(le[0]):le[0]),Te="mailto:"+de;else{var he;do he=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(he!==le[0]);de=d(le[0]),le[1]==="www."?Te="http://"+de:Te=de}return{type:"link",raw:le[0],text:de,href:Te,tokens:[{type:"text",raw:de,text:de}]}}},$e.inlineText=function(Q,Y){var le=this.rules.inline.text.exec(Q);if(le){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):d(le[0]):le[0]:de=d(this.options.smartypants?Y(le[0]):le[0]),{type:"text",raw:le[0],text:de}}},Ee}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=r(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=r(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=r(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=r(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=r(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=r(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=l({},q),q.gfm=l({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=r(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=r(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=l({},q.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:r(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var A={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};A._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",A.punctuation=r(A.punctuation).replace(/punctuation/g,A._punctuation).getRegex(),A.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,A.escapedEmSt=/\\\*|\\_/g,A._comment=r(q._comment).replace("(?:-->|$)","-->").getRegex(),A.emStrong.lDelim=r(A.emStrong.lDelim).replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimAst=r(A.emStrong.rDelimAst,"g").replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimUnd=r(A.emStrong.rDelimUnd,"g").replace(/punct/g,A._punctuation).getRegex(),A._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,A._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,A._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,A.autolink=r(A.autolink).replace("scheme",A._scheme).replace("email",A._email).getRegex(),A._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,A.tag=r(A.tag).replace("comment",A._comment).replace("attribute",A._attribute).getRegex(),A._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,A._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,A._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,A.link=r(A.link).replace("label",A._label).replace("href",A._href).replace("title",A._title).getRegex(),A.reflink=r(A.reflink).replace("label",A._label).replace("ref",q._label).getRegex(),A.nolink=r(A.nolink).replace("ref",q._label).getRegex(),A.reflinkSearch=r(A.reflinkSearch,"g").replace("reflink",A.reflink).replace("nolink",A.nolink).getRegex(),A.normal=l({},A),A.pedantic=l({},A.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",A._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",A._label).getRegex()}),A.gfm=l({},A.normal,{escape:r(A.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),A.gfm.url=r(A.gfm.url,"i").replace("email",A.gfm._extended_email).getRegex(),A.breaks=l({},A.gfm,{br:r(A.br).replace("{2,}","*").getRegex(),text:r(A.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(Ee){var $e="",fe,Q,Y=Ee.length;for(fe=0;fe<Y;fe++)Q=Ee.charCodeAt(fe),Math.random()>.5&&(Q="x"+Q.toString(16)),$e+="&#"+Q+";";return $e}var ie=function(){function Ee(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ge.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:A.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=A.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=A.breaks:Q.inline=A.gfm),this.tokenizer.rules=Q}Ee.lex=function(Q,Y){var le=new Ee(Y);return le.lex(Q)},Ee.lexInline=function(Q,Y){var le=new Ee(Y);return le.inlineTokens(Q)};var $e=Ee.prototype;return $e.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},$e.blockTokens=function(Q,Y){var le=this;Y===void 0&&(Y=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(ze,z,L){return z+"    ".repeat(L.length)});for(var de,Te,he,Ce;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(de=ze.call({lexer:le},Q,Y))?(Q=Q.substring(de.raw.length),Y.push(de),!0):!1}))){if(de=this.tokenizer.space(Q)){Q=Q.substring(de.raw.length),de.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(de);continue}if(de=this.tokenizer.code(Q)){Q=Q.substring(de.raw.length),Te=Y[Y.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+de.raw,Te.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(de);continue}if(de=this.tokenizer.fences(Q)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.heading(Q)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.hr(Q)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.blockquote(Q)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.list(Q)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.html(Q)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.def(Q)){Q=Q.substring(de.raw.length),Te=Y[Y.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+de.raw,Te.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(Q)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.lheading(Q)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(he=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,z=Q.slice(1),L=void 0;le.options.extensions.startBlock.forEach(function(G){L=G.call({lexer:this},z),typeof L=="number"&&L>=0&&(ze=Math.min(ze,L))}),ze<1/0&&ze>=0&&(he=Q.substring(0,ze+1))}(),this.state.top&&(de=this.tokenizer.paragraph(he))){Te=Y[Y.length-1],Ce&&Te.type==="paragraph"?(Te.raw+=`
`+de.raw,Te.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(de),Ce=he.length!==Q.length,Q=Q.substring(de.raw.length);continue}if(de=this.tokenizer.text(Q)){Q=Q.substring(de.raw.length),Te=Y[Y.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+de.raw,Te.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(de);continue}if(Q){var Me="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return this.state.top=!0,Y},$e.inline=function(Q,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:Q,tokens:Y}),Y},$e.inlineTokens=function(Q,Y){var le=this;Y===void 0&&(Y=[]);var de,Te,he,Ce=Q,Me,ze,z;if(this.tokens.links){var L=Object.keys(this.tokens.links);if(L.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)L.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"["+C("a",Me[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Me.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(ze||(z=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(de=H.call({lexer:le},Q,Y))?(Q=Q.substring(de.raw.length),Y.push(de),!0):!1}))){if(de=this.tokenizer.escape(Q)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.tag(Q)){Q=Q.substring(de.raw.length),Te=Y[Y.length-1],Te&&de.type==="text"&&Te.type==="text"?(Te.raw+=de.raw,Te.text+=de.text):Y.push(de);continue}if(de=this.tokenizer.link(Q)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(de.raw.length),Te=Y[Y.length-1],Te&&de.type==="text"&&Te.type==="text"?(Te.raw+=de.raw,Te.text+=de.text):Y.push(de);continue}if(de=this.tokenizer.emStrong(Q,Ce,z)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.codespan(Q)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.br(Q)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.del(Q)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(de=this.tokenizer.autolink(Q,K)){Q=Q.substring(de.raw.length),Y.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(Q,K))){Q=Q.substring(de.raw.length),Y.push(de);continue}if(he=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=Q.slice(1),se=void 0;le.options.extensions.startInline.forEach(function(Fe){se=Fe.call({lexer:this},ee),typeof se=="number"&&se>=0&&(H=Math.min(H,se))}),H<1/0&&H>=0&&(he=Q.substring(0,H+1))}(),de=this.tokenizer.inlineText(he,j)){Q=Q.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(z=de.raw.slice(-1)),ze=!0,Te=Y[Y.length-1],Te&&Te.type==="text"?(Te.raw+=de.raw,Te.text+=de.text):Y.push(de);continue}if(Q){var G="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return Y},I(Ee,null,[{key:"rules",get:function(){return{block:q,inline:A}}}]),Ee}(),ce=function(){function Ee(fe){this.options=fe||ge.defaults}var $e=Ee.prototype;return $e.code=function(Q,Y,le){var de=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(Q,de);Te!=null&&Te!==Q&&(le=!0,Q=Te)}return Q=Q.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+d(de,!0)+'">'+(le?Q:d(Q,!0))+`</code></pre>
`:"<pre><code>"+(le?Q:d(Q,!0))+`</code></pre>
`},$e.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},$e.html=function(Q){return Q},$e.heading=function(Q,Y,le,de){if(this.options.headerIds){var Te=this.options.headerPrefix+de.slug(le);return"<h"+Y+' id="'+Te+'">'+Q+"</h"+Y+`>
`}return"<h"+Y+">"+Q+"</h"+Y+`>
`},$e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},$e.list=function(Q,Y,le){var de=Y?"ol":"ul",Te=Y&&le!==1?' start="'+le+'"':"";return"<"+de+Te+`>
`+Q+"</"+de+`>
`},$e.listitem=function(Q){return"<li>"+Q+`</li>
`},$e.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},$e.paragraph=function(Q){return"<p>"+Q+`</p>
`},$e.table=function(Q,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+Y+`</table>
`},$e.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},$e.tablecell=function(Q,Y){var le=Y.header?"th":"td",de=Y.align?"<"+le+' align="'+Y.align+'">':"<"+le+">";return de+Q+("</"+le+`>
`)},$e.strong=function(Q){return"<strong>"+Q+"</strong>"},$e.em=function(Q){return"<em>"+Q+"</em>"},$e.codespan=function(Q){return"<code>"+Q+"</code>"},$e.br=function(){return this.options.xhtml?"<br/>":"<br>"},$e.del=function(Q){return"<del>"+Q+"</del>"},$e.link=function(Q,Y,le){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return le;var de='<a href="'+d(Q)+'"';return Y&&(de+=' title="'+Y+'"'),de+=">"+le+"</a>",de},$e.image=function(Q,Y,le){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return le;var de='<img src="'+Q+'" alt="'+le+'"';return Y&&(de+=' title="'+Y+'"'),de+=this.options.xhtml?"/>":">",de},$e.text=function(Q){return Q},Ee}(),ve=function(){function Ee(){}var $e=Ee.prototype;return $e.strong=function(Q){return Q},$e.em=function(Q){return Q},$e.codespan=function(Q){return Q},$e.del=function(Q){return Q},$e.html=function(Q){return Q},$e.text=function(Q){return Q},$e.link=function(Q,Y,le){return""+le},$e.image=function(Q,Y,le){return""+le},$e.br=function(){return""},Ee}(),Ie=function(){function Ee(){this.seen={}}var $e=Ee.prototype;return $e.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},$e.getNextSafeSlug=function(Q,Y){var le=Q,de=0;if(this.seen.hasOwnProperty(le)){de=this.seen[Q];do de++,le=Q+"-"+de;while(this.seen.hasOwnProperty(le))}return Y||(this.seen[Q]=de,this.seen[le]=0),le},$e.slug=function(Q,Y){Y===void 0&&(Y={});var le=this.serialize(Q);return this.getNextSafeSlug(le,Y.dryrun)},Ee}(),ue=function(){function Ee(fe){this.options=fe||ge.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ve,this.slugger=new Ie}Ee.parse=function(Q,Y){var le=new Ee(Y);return le.parse(Q)},Ee.parseInline=function(Q,Y){var le=new Ee(Y);return le.parseInline(Q)};var $e=Ee.prototype;return $e.parse=function(Q,Y){Y===void 0&&(Y=!0);var le="",de,Te,he,Ce,Me,ze,z,L,G,H,ee,se,Fe,Be,Qe,xe,_e,et,tt,nt=Q.length;for(de=0;de<nt;de++){if(H=Q[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(tt=this.options.extensions.renderers[H.type].call({parser:this},H),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){le+=tt||"";continue}switch(H.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(L="",z="",Ce=H.header.length,Te=0;Te<Ce;Te++)z+=this.renderer.tablecell(this.parseInline(H.header[Te].tokens),{header:!0,align:H.align[Te]});for(L+=this.renderer.tablerow(z),G="",Ce=H.rows.length,Te=0;Te<Ce;Te++){for(ze=H.rows[Te],z="",Me=ze.length,he=0;he<Me;he++)z+=this.renderer.tablecell(this.parseInline(ze[he].tokens),{header:!1,align:H.align[he]});G+=this.renderer.tablerow(z)}le+=this.renderer.table(L,G);continue}case"blockquote":{G=this.parse(H.tokens),le+=this.renderer.blockquote(G);continue}case"list":{for(ee=H.ordered,se=H.start,Fe=H.loose,Ce=H.items.length,G="",Te=0;Te<Ce;Te++)Qe=H.items[Te],xe=Qe.checked,_e=Qe.task,Be="",Qe.task&&(et=this.renderer.checkbox(xe),Fe?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=et+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=et+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:et}):Be+=et),Be+=this.parse(Qe.tokens,Fe),G+=this.renderer.listitem(Be,_e,xe);le+=this.renderer.list(G,ee,se);continue}case"html":{le+=this.renderer.html(H.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;de+1<nt&&Q[de+1].type==="text";)H=Q[++de],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);le+=Y?this.renderer.paragraph(G):G;continue}default:{var ct='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return le},$e.parseInline=function(Q,Y){Y=Y||this.renderer;var le="",de,Te,he,Ce=Q.length;for(de=0;de<Ce;de++){if(Te=Q[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(he=this.options.extensions.renderers[Te.type].call({parser:this},Te),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){le+=he||"";continue}switch(Te.type){case"escape":{le+=Y.text(Te.text);break}case"html":{le+=Y.html(Te.text);break}case"link":{le+=Y.link(Te.href,Te.title,this.parseInline(Te.tokens,Y));break}case"image":{le+=Y.image(Te.href,Te.title,Te.text);break}case"strong":{le+=Y.strong(this.parseInline(Te.tokens,Y));break}case"em":{le+=Y.em(this.parseInline(Te.tokens,Y));break}case"codespan":{le+=Y.codespan(Te.text);break}case"br":{le+=Y.br();break}case"del":{le+=Y.del(this.parseInline(Te.tokens,Y));break}case"text":{le+=Y.text(Te.text);break}default:{var Me='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return le},Ee}();function pe(Ee,$e,fe){if(typeof Ee>"u"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof $e=="function"&&(fe=$e,$e=null),$e=l({},pe.defaults,$e||{}),y($e),fe){var Q=$e.highlight,Y;try{Y=ie.lex(Ee,$e)}catch(Ce){return fe(Ce)}var le=function(Me){var ze;if(!Me)try{$e.walkTokens&&pe.walkTokens(Y,$e.walkTokens),ze=ue.parse(Y,$e)}catch(z){Me=z}return $e.highlight=Q,Me?fe(Me):fe(null,ze)};if(!Q||Q.length<3||(delete $e.highlight,!Y.length))return le();var de=0;pe.walkTokens(Y,function(Ce){Ce.type==="code"&&(de++,setTimeout(function(){Q(Ce.text,Ce.lang,function(Me,ze){if(Me)return le(Me);ze!=null&&ze!==Ce.text&&(Ce.text=ze,Ce.escaped=!0),de--,de===0&&le()})},0))}),de===0&&le();return}function Te(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+d(Ce.message+"",!0)+"</pre>";throw Ce}try{var he=ie.lex(Ee,$e);if($e.walkTokens){if($e.async)return Promise.all(pe.walkTokens(he,$e.walkTokens)).then(function(){return ue.parse(he,$e)}).catch(Te);pe.walkTokens(he,$e.walkTokens)}return ue.parse(he,$e)}catch(Ce){Te(Ce)}}pe.options=pe.setOptions=function(Ee){return l(pe.defaults,Ee),m(pe.defaults),pe},pe.getDefaults=M,pe.defaults=ge.defaults,pe.use=function(){for(var Ee=arguments.length,$e=new Array(Ee),fe=0;fe<Ee;fe++)$e[fe]=arguments[fe];var Q=l.apply(void 0,[{}].concat($e)),Y=pe.defaults.extensions||{renderers:{},childTokens:{}},le;$e.forEach(function(de){if(de.extensions&&(le=!0,de.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var Ce=Y.renderers?Y.renderers[he.name]:null;Ce?Y.renderers[he.name]=function(){for(var Me=arguments.length,ze=new Array(Me),z=0;z<Me;z++)ze[z]=arguments[z];var L=he.renderer.apply(this,ze);return L===!1&&(L=Ce.apply(this,ze)),L}:Y.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[he.level]?Y[he.level].unshift(he.tokenizer):Y[he.level]=[he.tokenizer],he.start&&(he.level==="block"?Y.startBlock?Y.startBlock.push(he.start):Y.startBlock=[he.start]:he.level==="inline"&&(Y.startInline?Y.startInline.push(he.start):Y.startInline=[he.start]))}he.childTokens&&(Y.childTokens[he.name]=he.childTokens)})),de.renderer&&function(){var he=pe.defaults.renderer||new ce,Ce=function(z){var L=he[z];he[z]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var se=de.renderer[z].apply(he,H);return se===!1&&(se=L.apply(he,H)),se}};for(var Me in de.renderer)Ce(Me);Q.renderer=he}(),de.tokenizer&&function(){var he=pe.defaults.tokenizer||new W,Ce=function(z){var L=he[z];he[z]=function(){for(var G=arguments.length,H=new Array(G),ee=0;ee<G;ee++)H[ee]=arguments[ee];var se=de.tokenizer[z].apply(he,H);return se===!1&&(se=L.apply(he,H)),se}};for(var Me in de.tokenizer)Ce(Me);Q.tokenizer=he}(),de.walkTokens){var Te=pe.defaults.walkTokens;Q.walkTokens=function(he){var Ce=[];return Ce.push(de.walkTokens.call(this,he)),Te&&(Ce=Ce.concat(Te.call(this,he))),Ce}}le&&(Q.extensions=Y),pe.setOptions(Q)})},pe.walkTokens=function(Ee,$e){for(var fe=[],Q=function(){var Te=le.value;switch(fe=fe.concat($e.call(pe,Te)),Te.type){case"table":{for(var he=F(Te.header),Ce;!(Ce=he()).done;){var Me=Ce.value;fe=fe.concat(pe.walkTokens(Me.tokens,$e))}for(var ze=F(Te.rows),z;!(z=ze()).done;)for(var L=z.value,G=F(L),H;!(H=G()).done;){var ee=H.value;fe=fe.concat(pe.walkTokens(ee.tokens,$e))}break}case"list":{fe=fe.concat(pe.walkTokens(Te.items,$e));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[Te.type]?pe.defaults.extensions.childTokens[Te.type].forEach(function(se){fe=fe.concat(pe.walkTokens(Te[se],$e))}):Te.tokens&&(fe=fe.concat(pe.walkTokens(Te.tokens,$e)))}},Y=F(Ee),le;!(le=Y()).done;)Q();return fe},pe.parseInline=function(Ee,$e){if(typeof Ee>"u"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");$e=l({},pe.defaults,$e||{}),y($e);try{var fe=ie.lexInline(Ee,$e);return $e.walkTokens&&pe.walkTokens(fe,$e.walkTokens),ue.parseInline(fe,$e)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+d(Q.message+"",!0)+"</pre>";throw Q}},pe.Parser=ue,pe.parser=ue.parse,pe.Renderer=ce,pe.TextRenderer=ve,pe.Lexer=ie,pe.lexer=ie.lex,pe.Tokenizer=W,pe.Slugger=Ie,pe.parse=pe;var re=pe.options,Se=pe.setOptions,Le=pe.use,ne=pe.walkTokens,U=pe.parseInline,x=pe,be=ue.parse,Ne=ie.lex;ge.Lexer=ie,ge.Parser=ue,ge.Renderer=ce,ge.Slugger=Ie,ge.TextRenderer=ve,ge.Tokenizer=W,ge.getDefaults=M,ge.lexer=Ne,ge.marked=pe,ge.options=re,ge.parse=x,ge.parseInline=U,ge.parser=be,ge.setOptions=Se,ge.use=Le,ge.walkTokens=ne,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Re[125],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=I;function I(n){const o=F(n);if(o&&o.length>0)return new Uint32Array(o)}let N=0;const R=new Uint32Array(10);function F(n){if(N=0,M(n,k,4352),N>0||(M(n,u,4449),N>0)||(M(n,w,4520),N>0)||(M(n,d,12593),N))return R.subarray(0,N);if(n>=44032&&n<=55203){const o=n-44032,s=o%588,r=Math.floor(o/588),i=Math.floor(s/28),a=s%28-1;if(r<k.length?M(r,k,0):4352+r-12593<d.length&&M(4352+r,d,12593),i<u.length?M(i,u,0):4449+i-12593<d.length&&M(4449+i-12593,d,12593),a>=0&&(a<w.length?M(a,w,0):4520+a-12593<d.length&&M(4520+a-12593,d,12593)),N>0)return R.subarray(0,N)}}function M(n,o,s){n>=s&&n<s+o.length&&m(o[n-s])}function m(n){n!==0&&(R[N++]=n&255,n>>8&&(R[N++]=n>>8&255),n>>16&&(R[N++]=n>>16&255))}var g;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var E;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(E||(E={}));var T;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})(T||(T={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),d=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Re[126],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0,e.$vm=I,e.rot=N;function I(m,g,E){return Math.min(Math.max(m,g),E)}function N(m,g){return(g+m%g)%g}class R{constructor(){this.a=0}getNext(){return this.a++}}e.$xm=R;class F{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ym=F;class M{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const E=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$zm=M}),function(){function ge(R){const F=[];typeof R=="number"&&F.push("code/timeOrigin",R);function M(g){F.push(g,Date.now())}function m(){const g=[];for(let E=0;E<F.length;E+=2)g.push({name:F[E],startTime:F[E+1]});return g}return{mark:M,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const M of performance.getEntriesByType("mark"))F.push({name:M.name,startTime:Math.round(R+M.startTime)});return F}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function I(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=I(N))}(),define(Re[127],Ae([1,0,46]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2O=void 0;const N=Symbol("unset");class R{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert(g,E,T){this.d(g,k=>k._value=E,T)}mutate(g,E){this.d(g,T=>T._value=E(T._value===N?void 0:T._value))}delete(g){const E=this.c(g);if(!E)return;let T=E.length-1;const k=E[T].node._value;if(k!==N){for(this.b--,E[T].node._value=N;T>0;T--){const{node:u,part:w}=E[T];if(u.children?.size||u._value!==N)break;E[T-1].node.children.delete(w)}return k}}*deleteRecursive(g){const E=this.c(g);if(!E)return;const T=E[E.length-1].node;for(let k=E.length-1;k>0;k--){const u=E[k-1];if(u.node.children.delete(E[k].part),u.node.children.size>0||u.node._value!==N)break}for(const k of F(T))k._value!==N&&(this.b--,yield k._value)}find(g){let E=this.a;for(const T of g){const k=E.children?.get(T);if(!k)return;E=k}return E._value===N?void 0:E._value}hasKeyOrParent(g){let E=this.a;for(const T of g){const k=E.children?.get(T);if(!k)return!1;if(k._value!==N)return!0;E=k}return!1}hasKeyOrChildren(g){let E=this.a;for(const T of g){const k=E.children?.get(T);if(!k)return!1;E=k}return!0}hasKey(g){let E=this.a;for(const T of g){const k=E.children?.get(T);if(!k)return!1;E=k}return E._value!==N}c(g){const E=[{part:"",node:this.a}];let T=0;for(const k of g){const u=E[T].node.children?.get(k);if(!u)return;E.push({part:k,node:u}),T++}return E}d(g,E,T){let k=this.a;for(const d of g){if(k.children)if(k.children.has(d))k=k.children.get(d);else{const n=new M;k.children.set(d,n),k=n}else{const n=new M;k.children=new Map([[d,n]]),k=n}T?.(k)}const u=k._value===N?0:1;E(k);const w=k._value===N?0:1;this.b+=w-u}*values(){for(const{_value:g}of F(this.a))g!==N&&(yield g)}}e.$2O=R;function*F(m){const g=[m];for(;g.length>0;){const E=g.pop();if(yield E,E.children)for(const T of E.children.values())g.push(T)}}class M{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value(g){this._value=g===void 0?N:g}}}),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var N in I)(typeof exports=="object"?exports:ge)[N]=I[N]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function I(N){if(e[N])return e[N].exports;var R=e[N]={i:N,l:!1,exports:{}};return ge[N].call(R.exports,R,R.exports,I),R.l=!0,R.exports}return I.m=ge,I.c=e,I.d=function(N,R,F){I.o(N,R)||Object.defineProperty(N,R,{enumerable:!0,get:F})},I.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},I.t=function(N,R){if(1&R&&(N=I(N)),8&R||4&R&&typeof N=="object"&&N&&N.__esModule)return N;var F=Object.create(null);if(I.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:N}),2&R&&typeof N!="string")for(var M in N)I.d(F,M,function(m){return N[m]}.bind(null,M));return F},I.n=function(N){var R=N&&N.__esModule?function(){return N.default}:function(){return N};return I.d(R,"a",R),R},I.o=function(N,R){return Object.prototype.hasOwnProperty.call(N,R)},I.p="",I(I.s=0)}([function(ge,e,I){(function(N){var R;e=ge.exports=Le,R=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var L=Array.prototype.slice.call(arguments,0);L.unshift("SEMVER"),console.log.apply(console,L)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],g=e.src=[],E=0,T=E++;g[T]="0|[1-9]\\d*";var k=E++;g[k]="[0-9]+";var u=E++;g[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=E++;g[w]="("+g[T]+")\\.("+g[T]+")\\.("+g[T]+")";var d=E++;g[d]="("+g[k]+")\\.("+g[k]+")\\.("+g[k]+")";var n=E++;g[n]="(?:"+g[T]+"|"+g[u]+")";var o=E++;g[o]="(?:"+g[k]+"|"+g[u]+")";var s=E++;g[s]="(?:-("+g[n]+"(?:\\."+g[n]+")*))";var r=E++;g[r]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var i=E++;g[i]="[0-9A-Za-z-]+";var a=E++;g[a]="(?:\\+("+g[i]+"(?:\\."+g[i]+")*))";var h=E++,t="v?"+g[w]+g[s]+"?"+g[a]+"?";g[h]="^"+t+"$";var b="[v=\\s]*"+g[d]+g[r]+"?"+g[a]+"?",c=E++;g[c]="^"+b+"$";var $=E++;g[$]="((?:<|>)?=?)";var v=E++;g[v]=g[k]+"|x|X|\\*";var p=E++;g[p]=g[T]+"|x|X|\\*";var l=E++;g[l]="[v=\\s]*("+g[p]+")(?:\\.("+g[p]+")(?:\\.("+g[p]+")(?:"+g[s]+")?"+g[a]+"?)?)?";var D=E++;g[D]="[v=\\s]*("+g[v]+")(?:\\.("+g[v]+")(?:\\.("+g[v]+")(?:"+g[r]+")?"+g[a]+"?)?)?";var f=E++;g[f]="^"+g[$]+"\\s*"+g[l]+"$";var S=E++;g[S]="^"+g[$]+"\\s*"+g[D]+"$";var y=E++;g[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=E++;g[C]="(?:~>?)";var P=E++;g[P]="(\\s*)"+g[C]+"\\s+",m[P]=new RegExp(g[P],"g");var V=E++;g[V]="^"+g[C]+g[l]+"$";var W=E++;g[W]="^"+g[C]+g[D]+"$";var q=E++;g[q]="(?:\\^)";var A=E++;g[A]="(\\s*)"+g[q]+"\\s+",m[A]=new RegExp(g[A],"g");var j=E++;g[j]="^"+g[q]+g[l]+"$";var K=E++;g[K]="^"+g[q]+g[D]+"$";var ie=E++;g[ie]="^"+g[$]+"\\s*("+b+")$|^$";var ce=E++;g[ce]="^"+g[$]+"\\s*("+t+")$|^$";var ve=E++;g[ve]="(\\s*)"+g[$]+"\\s*("+b+"|"+g[l]+")",m[ve]=new RegExp(g[ve],"g");var Ie=E++;g[Ie]="^\\s*("+g[l]+")\\s+-\\s+("+g[l]+")\\s*$";var ue=E++;g[ue]="^\\s*("+g[D]+")\\s+-\\s+("+g[D]+")\\s*$";var pe=E++;g[pe]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)R(re,g[re]),m[re]||(m[re]=new RegExp(g[re]));function Se(L,G){if(L instanceof Le)return L;if(typeof L!="string"||L.length>F||!(G?m[c]:m[h]).test(L))return null;try{return new Le(L,G)}catch{return null}}function Le(L,G){if(L instanceof Le){if(L.loose===G)return L;L=L.version}else if(typeof L!="string")throw new TypeError("Invalid Version: "+L);if(L.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof Le))return new Le(L,G);R("SemVer",L,G),this.loose=G;var H=L.trim().match(G?m[c]:m[h]);if(!H)throw new TypeError("Invalid Version: "+L);if(this.raw=L,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var se=+ee;if(se>=0&&se<M)return se}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=Se,e.valid=function(L,G){var H=Se(L,G);return H?H.version:null},e.clean=function(L,G){var H=Se(L.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=Le,Le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Le.prototype.toString=function(){return this.version},Le.prototype.compare=function(L){return R("SemVer.compare",this.version,this.loose,L),L instanceof Le||(L=new Le(L,this.loose)),this.compareMain(L)||this.comparePre(L)},Le.prototype.compareMain=function(L){return L instanceof Le||(L=new Le(L,this.loose)),U(this.major,L.major)||U(this.minor,L.minor)||U(this.patch,L.patch)},Le.prototype.comparePre=function(L){if(L instanceof Le||(L=new Le(L,this.loose)),this.prerelease.length&&!L.prerelease.length)return-1;if(!this.prerelease.length&&L.prerelease.length)return 1;if(!this.prerelease.length&&!L.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],ee=L.prerelease[G];if(R("prerelease compare",G,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return U(H,ee)}while(++G)},Le.prototype.inc=function(L,G){switch(L){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+L)}return this.format(),this.raw=this.version,this},e.inc=function(L,G,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new Le(L,H).inc(G,ee).version}catch{return null}},e.diff=function(L,G){if(Ee(L,G))return null;var H=Se(L),ee=Se(G);if(H.prerelease.length||ee.prerelease.length){for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return"pre"+se;return"prerelease"}for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return se},e.compareIdentifiers=U;var ne=/^[0-9]+$/;function U(L,G){var H=ne.test(L),ee=ne.test(G);return H&&ee&&(L=+L,G=+G),H&&!ee?-1:ee&&!H?1:L<G?-1:L>G?1:0}function x(L,G,H){return new Le(L,H).compare(new Le(G,H))}function be(L,G,H){return x(L,G,H)>0}function Ne(L,G,H){return x(L,G,H)<0}function Ee(L,G,H){return x(L,G,H)===0}function $e(L,G,H){return x(L,G,H)!==0}function fe(L,G,H){return x(L,G,H)>=0}function Q(L,G,H){return x(L,G,H)<=0}function Y(L,G,H,ee){var se;switch(G){case"===":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),se=L===H;break;case"!==":typeof L=="object"&&(L=L.version),typeof H=="object"&&(H=H.version),se=L!==H;break;case"":case"=":case"==":se=Ee(L,H,ee);break;case"!=":se=$e(L,H,ee);break;case">":se=be(L,H,ee);break;case">=":se=fe(L,H,ee);break;case"<":se=Ne(L,H,ee);break;case"<=":se=Q(L,H,ee);break;default:throw new TypeError("Invalid operator: "+G)}return se}function le(L,G){if(L instanceof le){if(L.loose===G)return L;L=L.value}if(!(this instanceof le))return new le(L,G);R("comparator",L,G),this.loose=G,this.parse(L),this.semver===de?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(L,G){return U(G,L)},e.major=function(L,G){return new Le(L,G).major},e.minor=function(L,G){return new Le(L,G).minor},e.patch=function(L,G){return new Le(L,G).patch},e.compare=x,e.compareLoose=function(L,G){return x(L,G,!0)},e.rcompare=function(L,G,H){return x(G,L,H)},e.sort=function(L,G){return L.sort(function(H,ee){return e.compare(H,ee,G)})},e.rsort=function(L,G){return L.sort(function(H,ee){return e.rcompare(H,ee,G)})},e.gt=be,e.lt=Ne,e.eq=Ee,e.neq=$e,e.gte=fe,e.lte=Q,e.cmp=Y,e.Comparator=le;var de={};function Te(L,G){if(L instanceof Te)return L.loose===G?L:new Te(L.raw,G);if(L instanceof le)return new Te(L.value,G);if(!(this instanceof Te))return new Te(L,G);if(this.loose=G,this.raw=L,this.set=L.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+L);this.format()}function he(L){return!L||L.toLowerCase()==="x"||L==="*"}function Ce(L,G,H,ee,se,Fe,Be,Qe,xe,_e,et,tt,nt){return((G=he(H)?"":he(ee)?">="+H+".0.0":he(se)?">="+H+"."+ee+".0":">="+G)+" "+(Qe=he(xe)?"":he(_e)?"<"+(+xe+1)+".0.0":he(et)?"<"+xe+"."+(+_e+1)+".0":tt?"<="+xe+"."+_e+"."+et+"-"+tt:"<="+Qe)).trim()}function Me(L,G){for(var H=0;H<L.length;H++)if(!L[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<L.length;H++)if(R(L[H].semver),L[H].semver!==de&&L[H].semver.prerelease.length>0){var ee=L[H].semver;if(ee.major===G.major&&ee.minor===G.minor&&ee.patch===G.patch)return!0}return!1}return!0}function ze(L,G,H){try{G=new Te(G,H)}catch{return!1}return G.test(L)}function z(L,G,H,ee){var se,Fe,Be,Qe,xe;switch(L=new Le(L,ee),G=new Te(G,ee),H){case">":se=be,Fe=Q,Be=Ne,Qe=">",xe=">=";break;case"<":se=Ne,Fe=fe,Be=be,Qe="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(L,G,ee))return!1;for(var _e=0;_e<G.set.length;++_e){var et=G.set[_e],tt=null,nt=null;if(et.forEach(function(ct){ct.semver===de&&(ct=new le(">=0.0.0")),tt=tt||ct,nt=nt||ct,se(ct.semver,tt.semver,ee)?tt=ct:Be(ct.semver,nt.semver,ee)&&(nt=ct)}),tt.operator===Qe||tt.operator===xe||(!nt.operator||nt.operator===Qe)&&Fe(L,nt.semver)||nt.operator===xe&&Be(L,nt.semver))return!1}return!0}le.prototype.parse=function(L){var G=this.loose?m[ie]:m[ce],H=L.match(G);if(!H)throw new TypeError("Invalid comparator: "+L);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Le(H[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(L){return R("Comparator.test",L,this.loose),this.semver===de||(typeof L=="string"&&(L=new Le(L,this.loose)),Y(L,this.operator,this.semver,this.loose))},le.prototype.intersects=function(L,G){if(!(L instanceof le))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Te(L.value,G),ze(this.value,H,G);if(L.operator==="")return H=new Te(this.value,G),ze(L.semver,H,G);var ee=!(this.operator!==">="&&this.operator!==">"||L.operator!==">="&&L.operator!==">"),se=!(this.operator!=="<="&&this.operator!=="<"||L.operator!=="<="&&L.operator!=="<"),Fe=this.semver.version===L.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||L.operator!==">="&&L.operator!=="<="),Qe=Y(this.semver,"<",L.semver,G)&&(this.operator===">="||this.operator===">")&&(L.operator==="<="||L.operator==="<"),xe=Y(this.semver,">",L.semver,G)&&(this.operator==="<="||this.operator==="<")&&(L.operator===">="||L.operator===">");return ee||se||Fe&&Be||Qe||xe},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(L){return L.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(L){var G=this.loose;L=L.trim(),R("range",L,G);var H=G?m[ue]:m[Ie];L=L.replace(H,Ce),R("hyphen replace",L),L=L.replace(m[ve],"$1$2$3"),R("comparator trim",L,m[ve]),L=(L=(L=L.replace(m[P],"$1~")).replace(m[A],"$1^")).split(/\s+/).join(" ");var ee=G?m[ie]:m[ce],se=L.split(" ").map(function(Fe){return function(Be,Qe){return R("comp",Be),Be=function(xe,_e){return xe.trim().split(/\s+/).map(function(et){return function(tt,nt){R("caret",tt,nt);var ct=nt?m[K]:m[j];return tt.replace(ct,function(ft,je,st,X,Z){var me;return R("caret",tt,ft,je,st,X,Z),he(je)?me="":he(st)?me=">="+je+".0.0 <"+(+je+1)+".0.0":he(X)?me=je==="0"?">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":">="+je+"."+st+".0 <"+(+je+1)+".0.0":Z?(R("replaceCaret pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=je==="0"?st==="0"?">="+je+"."+st+"."+X+Z+" <"+je+"."+st+"."+(+X+1):">="+je+"."+st+"."+X+Z+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+X+Z+" <"+(+je+1)+".0.0"):(R("no pr"),me=je==="0"?st==="0"?">="+je+"."+st+"."+X+" <"+je+"."+st+"."+(+X+1):">="+je+"."+st+"."+X+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+X+" <"+(+je+1)+".0.0"),R("caret return",me),me})}(et,_e)}).join(" ")}(Be,Qe),R("caret",Be),Be=function(xe,_e){return xe.trim().split(/\s+/).map(function(et){return function(tt,nt){var ct=nt?m[W]:m[V];return tt.replace(ct,function(ft,je,st,X,Z){var me;return R("tilde",tt,ft,je,st,X,Z),he(je)?me="":he(st)?me=">="+je+".0.0 <"+(+je+1)+".0.0":he(X)?me=">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":Z?(R("replaceTilde pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=">="+je+"."+st+"."+X+Z+" <"+je+"."+(+st+1)+".0"):me=">="+je+"."+st+"."+X+" <"+je+"."+(+st+1)+".0",R("tilde return",me),me})}(et,_e)}).join(" ")}(Be,Qe),R("tildes",Be),Be=function(xe,_e){return R("replaceXRanges",xe,_e),xe.split(/\s+/).map(function(et){return function(tt,nt){tt=tt.trim();var ct=nt?m[S]:m[f];return tt.replace(ct,function(ft,je,st,X,Z,me){R("xRange",tt,ft,je,st,X,Z,me);var He=he(st),ye=He||he(X),ot=ye||he(Z);return je==="="&&ot&&(je=""),He?ft=je===">"||je==="<"?"<0.0.0":"*":je&&ot?(ye&&(X=0),ot&&(Z=0),je===">"?(je=">=",ye?(st=+st+1,X=0,Z=0):ot&&(X=+X+1,Z=0)):je==="<="&&(je="<",ye?st=+st+1:X=+X+1),ft=je+st+"."+X+"."+Z):ye?ft=">="+st+".0.0 <"+(+st+1)+".0.0":ot&&(ft=">="+st+"."+X+".0 <"+st+"."+(+X+1)+".0"),R("xRange return",ft),ft})}(et,_e)}).join(" ")}(Be,Qe),R("xrange",Be),Be=function(xe,_e){return R("replaceStars",xe,_e),xe.trim().replace(m[pe],"")}(Be,Qe),R("stars",Be),Be}(Fe,G)}).join(" ").split(/\s+/);return this.loose&&(se=se.filter(function(Fe){return!!Fe.match(ee)})),se=se.map(function(Fe){return new le(Fe,G)})},Te.prototype.intersects=function(L,G){if(!(L instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return L.set.some(function(se){return se.every(function(Fe){return ee.intersects(Fe,G)})})})})},e.toComparators=function(L,G){return new Te(L,G).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(L){if(!L)return!1;typeof L=="string"&&(L=new Le(L,this.loose));for(var G=0;G<this.set.length;G++)if(Me(this.set[G],L))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(L,G,H){var ee=null,se=null;try{var Fe=new Te(G,H)}catch{return null}return L.forEach(function(Be){Fe.test(Be)&&(ee&&se.compare(Be)!==-1||(se=new Le(ee=Be,H)))}),ee},e.minSatisfying=function(L,G,H){var ee=null,se=null;try{var Fe=new Te(G,H)}catch{return null}return L.forEach(function(Be){Fe.test(Be)&&(ee&&se.compare(Be)!==1||(se=new Le(ee=Be,H)))}),ee},e.validRange=function(L,G){try{return new Te(L,G).range||"*"}catch{return null}},e.ltr=function(L,G,H){return z(L,G,"<",H)},e.gtr=function(L,G,H){return z(L,G,">",H)},e.outside=z,e.prerelease=function(L,G){var H=Se(L,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(L,G,H){return L=new Te(L,H),G=new Te(G,H),L.intersects(G)},e.coerce=function(L){if(L instanceof Le)return L;if(typeof L!="string")return null;var G=L.match(m[y]);return G==null?null:Se((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,I(1))},function(ge,e){var I,N,R=ge.exports={};function F(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function m(o){if(I===setTimeout)return setTimeout(o,0);if((I===F||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:F}catch{I=F}try{N=typeof clearTimeout=="function"?clearTimeout:M}catch{N=M}})();var g,E=[],T=!1,k=-1;function u(){T&&g&&(T=!1,g.length?E=g.concat(E):k=-1,E.length&&w())}function w(){if(!T){var o=m(u);T=!0;for(var s=E.length;s;){for(g=E,E=[];++k<s;)g&&g[k].run();k=-1,s=E.length}g=null,T=!1,function(r){if(N===clearTimeout)return clearTimeout(r);if((N===M||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(r);try{N(r)}catch{try{return N.call(null,r)}catch{return N.call(this,r)}}}(o)}}function d(o,s){this.fun=o,this.array=s}function n(){}R.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)s[r-1]=arguments[r];E.push(new d(o,s)),E.length!==1||T||m(w)},d.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=n,R.addListener=n,R.once=n,R.off=n,R.removeListener=n,R.removeAllListeners=n,R.emit=n,R.prependListener=n,R.prependOnceListener=n,R.listeners=function(o){return[]},R.binding=function(o){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(o){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Re[128],Ae([1,0,14,6]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=R,e.$oe=F,e.$pe=M,e.$qe=m,e.$re=E,e.$se=T,e.$te=k,e.$ue=u,e.$ve=w,e.$we=d,e.$xe=n,e.$ye=o,e.$ze=s,e.$Ae=r,e.$Be=i;function R(a){const h=a;return h?typeof h.read=="function":!1}function F(a){const h=a;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}function M(a){const h=a;return h?F(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function m(a,h){return new g(a,h)}class g{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,I.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let b;switch(h){case"data":b=this.c.data;break;case"end":b=this.c.end;break;case"error":b=this.c.error;break}if(b){const c=b.indexOf(t);c>=0&&b.splice(c,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(b=>b())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(a,h){const t=[];let b;for(;(b=a.read())!==null;)t.push(b);return h(t)}function T(a,h,t){const b=[];let c;for(;(c=a.read())!==null&&b.length<t;)b.push(c);return c===null&&b.length>0?h(b):{read:()=>{if(b.length>0)return b.shift();if(typeof c<"u"){const $=c;return c=void 0,$}return a.read()}}}function k(a,h){return new Promise((t,b)=>{const c=[];u(a,{onData:$=>{h&&c.push($)},onError:$=>{h?b($):t(void 0)},onEnd:()=>{t(h?h(c):void 0)}})})}function u(a,h,t){a.on("error",b=>{t?.isCancellationRequested||h.onError(b)}),a.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),a.on("data",b=>{t?.isCancellationRequested||h.onData(b)})}function w(a,h){return new Promise((t,b)=>{const c=new N.$Tc,$=[],v=D=>{if($.push(D),$.length>h)return c.dispose(),a.pause(),t({stream:a,buffer:$,ended:!1})},p=D=>(c.dispose(),b(D)),l=()=>(c.dispose(),t({stream:a,buffer:$,ended:!0}));c.add((0,N.$Sc)(()=>a.removeListener("error",p))),a.on("error",p),c.add((0,N.$Sc)(()=>a.removeListener("end",l))),a.on("end",l),c.add((0,N.$Sc)(()=>a.removeListener("data",v))),a.on("data",v)})}function d(a,h){const t=m(h);return t.end(a),t}function n(){const a=m(()=>{throw new Error("not supported")});return a.end(),a}function o(a){let h=!1;return{read:()=>h?null:(h=!0,a)}}function s(a,h,t){const b=m(t);return u(a,{onData:c=>b.write(h.data(c)),onError:c=>b.error(h.error?h.error(c):c),onEnd:()=>b.end()}),b}function r(a,h,t){let b=!1;return{read:()=>{const c=h.read();return b?c:(b=!0,c!==null?t([a,c]):a)}}}function i(a,h,t){let b=!1;const c=m(t);return u(h,{onData:$=>b?c.write($):(b=!0,c.write(t([a,$]))),onError:$=>c.error($),onEnd:()=>{b||(b=!0,c.write(a)),c.end()}}),c}}),define(Re[22],Ae([1,0,40,128]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=E,e.$Ee=T,e.$Fe=k,e.$Ge=u,e.$He=w,e.$Ie=d,e.$Je=n,e.$Ke=o,e.$Le=s,e.$Me=r,e.$Ne=i,e.$Oe=a,e.$Pe=h,e.$Qe=t,e.$Re=b,e.$Se=c,e.$Te=$,e.$Ue=v,e.$Ve=p,e.$We=f;const R=typeof Buffer<"u",F=new I.$V(()=>new Uint8Array(256));let M,m;class g{static alloc(y){return R?new g(Buffer.allocUnsafe(y)):new g(new Uint8Array(y))}static wrap(y){return R&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new g(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&R?new g(Buffer.from(y)):(M||(M=new TextEncoder),new g(M.encode(y)))}static fromByteArray(y){const C=g.alloc(y.length);for(let P=0,V=y.length;P<V;P++)C.buffer[P]=y[P];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let W=0,q=y.length;W<q;W++)C+=y[W].byteLength}const P=g.alloc(C);let V=0;for(let W=0,q=y.length;W<q;W++){const A=y[W];P.set(A,V),V+=A.byteLength}return P}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=g.alloc(this.byteLength);return y.set(this),y}toString(){return R?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(y,C){return new g(this.buffer.subarray(y,C))}set(y,C){if(y instanceof g)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return u(this.buffer,y)}writeUInt32BE(y,C){w(this.buffer,y,C)}readUInt32LE(y){return d(this.buffer,y)}writeUInt32LE(y,C){n(this.buffer,y,C)}readUInt8(y){return o(this.buffer,y)}writeUInt8(y,C){s(this.buffer,y,C)}indexOf(y,C=0){return E(this.buffer,y instanceof g?y.buffer:y,C)}}e.$Ce=g;function E(S,y,C=0){const P=y.byteLength,V=S.byteLength;if(P===0)return 0;if(P===1)return S.indexOf(y[0]);if(P>V-C)return-1;const W=F.value;W.fill(y.length);for(let K=0;K<y.length;K++)W[y[K]]=y.length-K-1;let q=C+y.length-1,A=q,j=-1;for(;q<V;)if(S[q]===y[A]){if(A===0){j=q;break}q--,A--}else q+=Math.max(y.length-A,W[S[q]]),A=y.length-1;return j}function T(S,y){return S[y+0]<<0>>>0|S[y+1]<<8>>>0}function k(S,y,C){S[C+0]=y&255,y=y>>>8,S[C+1]=y&255}function u(S,y){return S[y]*2**24+S[y+1]*2**16+S[y+2]*2**8+S[y+3]}function w(S,y,C){S[C+3]=y,y=y>>>8,S[C+2]=y,y=y>>>8,S[C+1]=y,y=y>>>8,S[C]=y}function d(S,y){return S[y+0]<<0>>>0|S[y+1]<<8>>>0|S[y+2]<<16>>>0|S[y+3]<<24>>>0}function n(S,y,C){S[C+0]=y&255,y=y>>>8,S[C+1]=y&255,y=y>>>8,S[C+2]=y&255,y=y>>>8,S[C+3]=y&255}function o(S,y){return S[y]}function s(S,y,C){S[C]=y}function r(S){return N.$re(S,y=>g.concat(y))}function i(S){return N.$ye(S)}function a(S){return N.$te(S,y=>g.concat(y))}async function h(S){return S.ended?g.concat(S.buffer):g.concat([...S.buffer,await a(S.stream)])}function t(S){return N.$we(S,y=>g.concat(y))}function b(S){return N.$ze(S,{data:y=>typeof y=="string"?g.fromString(y):g.wrap(y)},y=>g.concat(y))}function c(S){return N.$qe(y=>g.concat(y),S)}function $(S,y){return N.$Ae(S,y,C=>g.concat(C))}function v(S,y){return N.$Be(S,y,C=>g.concat(C))}function p(S){let y=0,C=0,P=0;const V=new Uint8Array(Math.floor(S.length/4*3)),W=A=>{switch(C){case 3:V[P++]=y|A,C=0;break;case 2:V[P++]=y|A>>>2,y=A<<6,C=3;break;case 1:V[P++]=y|A>>>4,y=A<<4,C=2;break;default:y=A<<2,C=1}};for(let A=0;A<S.length;A++){const j=S.charCodeAt(A);if(j>=65&&j<=90)W(j-65);else if(j>=97&&j<=122)W(j-97+26);else if(j>=48&&j<=57)W(j-48+52);else if(j===43||j===45)W(62);else if(j===47||j===95)W(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${S[A]}`)}}const q=P;for(;C>0;)W(0);return g.wrap(V).slice(0,q)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:S},y=!0,C=!1){const P=C?D:l;let V="";const W=S.byteLength%3;let q=0;for(;q<S.byteLength-W;q+=3){const A=S[q+0],j=S[q+1],K=S[q+2];V+=P[A>>>2],V+=P[(A<<4|j>>>4)&63],V+=P[(j<<2|K>>>6)&63],V+=P[K&63]}if(W===1){const A=S[q+0];V+=P[A>>>2],V+=P[A<<4&63],y&&(V+="==")}else if(W===2){const A=S[q+0],j=S[q+1];V+=P[A>>>2],V+=P[(A<<4|j>>>4)&63],V+=P[j<<2&63],y&&(V+="=")}return V}}),define(Re[129],Ae([1,0,28,125,15]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.FuzzyScore=e.$sk=e.$rk=void 0,e.or=F,e.$tk=m,e.$uk=g,e.$vk=k,e.$wk=p,e.$xk=l,e.$yk=P,e.$zk=V,e.$Ak=W,e.$Bk=q,e.$Ck=x,e.$Ek=$e,e.$Fk=Y,e.$Gk=le;function F(...he){return function(Ce,Me){for(let ze=0,z=he.length;ze<z;ze++){const L=he[ze](Ce,Me);if(L)return L}return null}}e.$rk=M.bind(void 0,!1),e.$sk=M.bind(void 0,!0);function M(he,Ce,Me){if(!Me||Me.length<Ce.length)return null;let ze;return he?ze=R.$uf(Me,Ce):ze=Me.indexOf(Ce)===0,ze?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function m(he,Ce){const Me=Ce.toLowerCase().indexOf(he.toLowerCase());return Me===-1?null:[{start:Me,end:Me+he.length}]}function g(he,Ce){return E(he.toLowerCase(),Ce.toLowerCase(),0,0)}function E(he,Ce,Me,ze){if(Me===he.length)return[];if(ze===Ce.length)return null;if(he[Me]===Ce[ze]){let z=null;return(z=E(he,Ce,Me+1,ze+1))?a({start:ze,end:ze+1},z):null}return E(he,Ce,Me,ze+1)}function T(he){return 97<=he&&he<=122}function k(he){return 65<=he&&he<=90}function u(he){return 48<=he&&he<=57}function w(he){return he===32||he===9||he===10||he===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(he=>d.add(he.charCodeAt(0)));function n(he){return w(he)||d.has(he)}function o(he,Ce){return he===Ce||n(he)&&n(Ce)}const s=new Map;function r(he){if(s.has(he))return s.get(he);let Ce;const Me=(0,N.$pk)(he);return Me&&(Ce=Me),s.set(he,Ce),Ce}function i(he){return T(he)||k(he)||u(he)}function a(he,Ce){return Ce.length===0?Ce=[he]:he.end===Ce[0].start?Ce[0].start=he.start:Ce.unshift(he),Ce}function h(he,Ce){for(let Me=Ce;Me<he.length;Me++){const ze=he.charCodeAt(Me);if(k(ze)||u(ze)||Me>0&&!i(he.charCodeAt(Me-1)))return Me}return he.length}function t(he,Ce,Me,ze){if(Me===he.length)return[];if(ze===Ce.length)return null;if(he[Me]!==Ce[ze].toLowerCase())return null;{let z=null,L=ze+1;for(z=t(he,Ce,Me+1,ze+1);!z&&(L=h(Ce,L))<Ce.length;)z=t(he,Ce,Me+1,L),L++;return z===null?null:a({start:ze,end:ze+1},z)}}function b(he){let Ce=0,Me=0,ze=0,z=0,L=0;for(let Fe=0;Fe<he.length;Fe++)L=he.charCodeAt(Fe),k(L)&&Ce++,T(L)&&Me++,i(L)&&ze++,u(L)&&z++;const G=Ce/he.length,H=Me/he.length,ee=ze/he.length,se=z/he.length;return{upperPercent:G,lowerPercent:H,alphaPercent:ee,numericPercent:se}}function c(he){const{upperPercent:Ce,lowerPercent:Me}=he;return Me===0&&Ce>.6}function $(he){const{upperPercent:Ce,lowerPercent:Me,alphaPercent:ze,numericPercent:z}=he;return Me>.2&&Ce<.8&&ze>.6&&z<.2}function v(he){let Ce=0,Me=0,ze=0,z=0;for(let L=0;L<he.length;L++)ze=he.charCodeAt(L),k(ze)&&Ce++,T(ze)&&Me++,w(ze)&&z++;return(Ce===0||Me===0)&&z===0?he.length<=30:Ce<=5}function p(he,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!v(he))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Me=b(Ce);if(!$(Me)){if(!c(Me))return null;Ce=Ce.toLowerCase()}let ze=null,z=0;for(he=he.toLowerCase();z<Ce.length&&(ze=t(he,Ce,0,z))===null;)z=h(Ce,z+1);return ze}function l(he,Ce,Me=!1){if(!Ce||Ce.length===0)return null;let ze=null,z=0;for(he=he.toLowerCase(),Ce=Ce.toLowerCase();z<Ce.length&&(ze=D(he,Ce,0,z,Me),ze===null);)z=f(Ce,z+1);return ze}function D(he,Ce,Me,ze,z){let L=0;if(Me===he.length)return[];if(ze===Ce.length)return null;if(!o(he.charCodeAt(Me),Ce.charCodeAt(ze))){const ee=r(he.charCodeAt(Me));if(!ee)return null;for(let se=0;se<ee.length;se++)if(!o(ee[se],Ce.charCodeAt(ze+se)))return null;L+=ee.length-1}let G=null,H=ze+L+1;if(G=D(he,Ce,Me+1,H,z),!z)for(;!G&&(H=f(Ce,H))<Ce.length;)G=D(he,Ce,Me+1,H,z),H++;if(!G)return null;if(he.charCodeAt(Me)!==Ce.charCodeAt(ze)){const ee=r(he.charCodeAt(Me));if(!ee)return G;for(let se=0;se<ee.length;se++)if(ee[se]!==Ce.charCodeAt(ze+se))return G}return a({start:ze,end:ze+L+1},G)}function f(he,Ce){for(let Me=Ce;Me<he.length;Me++)if(n(he.charCodeAt(Me))||Me>0&&n(he.charCodeAt(Me-1)))return Me;return he.length}const S=F(e.$sk,p,m),y=F(e.$sk,p,g),C=new I.$Ec(1e4);function P(he,Ce,Me=!1){if(typeof he!="string"||typeof Ce!="string")return null;let ze=C.get(he);ze||(ze=new RegExp(R.$cf(he),"i"),C.set(he,ze));const z=ze.exec(Ce);return z?[{start:z.index,end:z.index+z[0].length}]:Me?y(he,Ce):S(he,Ce)}function V(he,Ce){const Me=$e(he,he.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?q(Me):null}function W(he,Ce,Me,ze,z,L){const G=Math.min(13,he.length);for(;Me<G;Me++){const H=$e(he,Ce,Me,ze,z,L,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,L]}function q(he){if(typeof he>"u")return[];const Ce=[],Me=he[1];for(let ze=he.length-1;ze>1;ze--){const z=he[ze]+Me,L=Ce[Ce.length-1];L&&L.end===z?L.end=z+1:Ce.push({start:z,end:z+1})}return Ce}const A=128;function j(){const he=[],Ce=[];for(let Me=0;Me<=A;Me++)Ce[Me]=0;for(let Me=0;Me<=A;Me++)he.push(Ce.slice(0));return he}function K(he){const Ce=[];for(let Me=0;Me<=he;Me++)Ce[Me]=0;return Ce}const ie=K(2*A),ce=K(2*A),ve=j(),Ie=j(),ue=j(),pe=!1;function re(he,Ce,Me,ze,z){function L(H,ee,se=" "){for(;H.length<ee;)H=se+H;return H}let G=` |   |${ze.split("").map(H=>L(H,3)).join("|")}
`;for(let H=0;H<=Me;H++)H===0?G+=" |":G+=`${Ce[H-1]}|`,G+=he[H].slice(0,z+1).map(ee=>L(ee.toString(),3)).join("|")+`
`;return G}function Se(he,Ce,Me,ze){he=he.substr(Ce),Me=Me.substr(ze),console.log(re(Ie,he,he.length,Me,Me.length)),console.log(re(ue,he,he.length,Me,Me.length)),console.log(re(ve,he,he.length,Me,Me.length))}function Le(he,Ce){if(Ce<0||Ce>=he.length)return!1;const Me=he.codePointAt(Ce);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$Mf(Me)}}function ne(he,Ce){if(Ce<0||Ce>=he.length)return!1;switch(he.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function U(he,Ce,Me){return Ce[he]!==Me[he]}function x(he,Ce,Me,ze,z,L,G=!1){for(;Ce<Me&&z<L;)he[Ce]===ze[z]&&(G&&(ie[Ce]=z),Ce+=1),z+=1;return Ce===Me}var be;(function(he){he[he.Diag=1]="Diag",he[he.Left=2]="Left",he[he.LeftLeft=3]="LeftLeft"})(be||(be={}));var Ne;(function(he){he.Default=[-100,0];function Ce(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}he.isDefault=Ce})(Ne||(e.FuzzyScore=Ne={}));class Ee{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Me){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Me}}e.$Dk=Ee;function $e(he,Ce,Me,ze,z,L,G=Ee.default){const H=he.length>A?A:he.length,ee=ze.length>A?A:ze.length;if(Me>=H||L>=ee||H-Me>ee-L||!x(Ce,Me,H,z,L,ee,!0))return;fe(H,ee,Me,L,Ce,z);let se=1,Fe=1,Be=Me,Qe=L;const xe=[!1];for(se=1,Be=Me;Be<H;se++,Be++){const ct=ie[Be],ft=ce[Be],je=Be+1<H?ce[Be+1]:ee;for(Fe=ct-L+1,Qe=ct;Qe<je;Fe++,Qe++){let st=Number.MIN_SAFE_INTEGER,X=!1;Qe<=ft&&(st=Q(he,Ce,Be,Me,ze,z,Qe,ee,L,ve[se-1][Fe-1]===0,xe));let Z=0;st!==Number.MAX_SAFE_INTEGER&&(X=!0,Z=st+Ie[se-1][Fe-1]);const me=Qe>ct,He=me?Ie[se][Fe-1]+(ve[se][Fe-1]>0?-5:0):0,ye=Qe>ct+1&&ve[se][Fe-1]>0,ot=ye?Ie[se][Fe-2]+(ve[se][Fe-2]>0?-5:0):0;if(ye&&(!me||ot>=He)&&(!X||ot>=Z))Ie[se][Fe]=ot,ue[se][Fe]=3,ve[se][Fe]=0;else if(me&&(!X||He>=Z))Ie[se][Fe]=He,ue[se][Fe]=2,ve[se][Fe]=0;else if(X)Ie[se][Fe]=Z,ue[se][Fe]=1,ve[se][Fe]=ve[se-1][Fe-1]+1;else throw new Error("not possible")}}if(pe&&Se(he,Me,ze,L),!xe[0]&&!G.firstMatchCanBeWeak)return;se--,Fe--;const _e=[Ie[se][Fe],L];let et=0,tt=0;for(;se>=1;){let ct=Fe;do{const ft=ue[se][ct];if(ft===3)ct=ct-2;else if(ft===2)ct=ct-1;else break}while(ct>=1);et>1&&Ce[Me+se-1]===z[L+Fe-1]&&!U(ct+L-1,ze,z)&&et+1>ve[se][ct]&&(ct=Fe),ct===Fe?et++:et=1,tt||(tt=ct),se--,Fe=ct-1,_e.push(Fe)}ee===H&&G.boostFullMatch&&(_e[0]+=2);const nt=tt-H;return _e[0]-=nt,_e}function fe(he,Ce,Me,ze,z,L){let G=he-1,H=Ce-1;for(;G>=Me&&H>=ze;)z[G]===L[H]&&(ce[G]=H,G--),H--}function Q(he,Ce,Me,ze,z,L,G,H,ee,se,Fe){if(Ce[Me]!==L[G])return Number.MIN_SAFE_INTEGER;let Be=1,Qe=!1;return G===Me-ze?Be=he[Me]===z[G]?7:5:U(G,z,L)&&(G===0||!U(G-1,z,L))?(Be=he[Me]===z[G]?7:5,Qe=!0):Le(L,G)&&(G===0||!Le(L,G-1))?Be=5:(Le(L,G-1)||ne(L,G-1))&&(Be=5,Qe=!0),Be>1&&Me===ze&&(Fe[0]=!0),Qe||(Qe=U(G,z,L)||Le(L,G-1)||ne(L,G-1)),Me===ze?G>ee&&(Be-=Qe?3:5):se?Be+=Qe?2:0:Be+=Qe?0:1,G+1===H&&(Be-=Qe?3:5),Be}function Y(he,Ce,Me,ze,z,L,G){return de(he,Ce,Me,ze,z,L,!0,G)}function le(he,Ce,Me,ze,z,L,G){return de(he,Ce,Me,ze,z,L,!1,G)}function de(he,Ce,Me,ze,z,L,G,H){let ee=$e(he,Ce,Me,ze,z,L,H);if(ee&&!G)return ee;if(he.length>=3){const se=Math.min(7,he.length-1);for(let Fe=Me+1;Fe<se;Fe++){const Be=Te(he,Fe);if(Be){const Qe=$e(Be,Be.toLowerCase(),Me,ze,z,L,H);Qe&&(Qe[0]-=3,(!ee||Qe[0]>ee[0])&&(ee=Qe))}}}return ee}function Te(he,Ce){if(Ce+1>=he.length)return;const Me=he[Ce],ze=he[Ce+1];if(Me!==ze)return he.slice(0,Ce)+ze+Me+he.slice(Ce+2)}}),define(Re[33],Ae([1,0,15]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(N||(N={})),function(R){const F="error",M="warning",m="warn",g="info",E="ignore";function T(u){return u?I.$tf(F,u)?R.Error:I.$tf(M,u)||I.$tf(m,u)?R.Warning:I.$tf(g,u)?R.Info:R.Ignore:R.Ignore}R.fromValue=T;function k(u){switch(u){case R.Error:return F;case R.Warning:return M;case R.Info:return g;default:return E}}R.toString=k}(N||(N={})),e.default=N}),define(Re[130],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(Re[52],Ae([1,0,18,15]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class R{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const d=w.charCodeAt(0),n=this.b.charCodeAt(this.c);return d-n}value(){return this.b[this.c]}}e.$si=R;class F{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,N.$nf)(w,this.b,0,w.length,this.c,this.d):(0,N.$pf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ti=F;class M{constructor(w=!0,d=!0){this.f=w,this.g=d}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let d=w.length-1;d>=0;d--,this.c--){const n=this.b.charCodeAt(d);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,N.$nf)(w,this.b,0,w.length,this.d,this.e):(0,N.$pf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ui=M;var m;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(m||(m={}));class g{constructor(w,d){this.f=w,this.g=d,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,N.$of)(w,this.c.scheme);if(this.d[this.e]===2)return(0,N.$of)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,N.$mf)(w,this.c.query);if(this.d[this.e]===5)return(0,N.$mf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$vi=g;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(T||(T={}));class k{static forUris(w=()=>!1,d=()=>!1){return new k(new g(w,d))}static forPaths(w=!1){return new k(new M(void 0,!w))}static forStrings(){return new k(new R)}static forConfigKeys(){return new k(new F)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,d){if(d){const n=d.slice(0);(0,I.$Xb)(n);for(const o of n)this.set(o,w)}else{const n=w.slice(0);(0,I.$Xb)(n);for(const o of n)this.set(o[0],o[1])}}set(w,d){const n=this.b.reset(w);let o;this.c||(this.c=new E,this.c.segment=n.value());const s=[];for(o=this.c;;){const i=n.cmp(o.segment);if(i>0)o.left||(o.left=new E,o.left.segment=n.value()),s.push([-1,o]),o=o.left;else if(i<0)o.right||(o.right=new E,o.right.segment=n.value()),s.push([1,o]),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new E,o.mid.segment=n.value()),s.push([0,o]),o=o.mid;else break}const r=o.value;o.value=d,o.key=w;for(let i=s.length-1;i>=0;i--){const a=s[i][1];a.updateHeight();const h=a.balanceFactor();if(h<-1||h>1){const t=s[i][0],b=s[i+1][0];if(t===1&&b===1)s[i][1]=a.rotateLeft();else if(t===-1&&b===-1)s[i][1]=a.rotateRight();else if(t===1&&b===-1)a.right=s[i+1][1]=s[i+1][1].rotateRight(),s[i][1]=a.rotateLeft();else if(t===-1&&b===1)a.left=s[i+1][1]=s[i+1][1].rotateLeft(),s[i][1]=a.rotateRight();else throw new Error;if(i>0)switch(s[i-1][0]){case-1:s[i-1][1].left=s[i][1];break;case 1:s[i-1][1].right=s[i][1];break;case 0:s[i-1][1].mid=s[i][1];break}else this.c=s[0][1]}}return r}get(w){return this.d(w)?.value}d(w){const d=this.b.reset(w);let n=this.c;for(;n;){const o=d.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(d.hasNext())d.next(),n=n.mid;else break}return n}has(w){const d=this.d(w);return!(d?.value===void 0&&d?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,d){const n=this.b.reset(w),o=[];let s=this.c;for(;s;){const r=n.cmp(s.segment);if(r>0)o.push([-1,s]),s=s.left;else if(r<0)o.push([1,s]),s=s.right;else if(n.hasNext())n.next(),o.push([0,s]),s=s.mid;else break}if(s){if(d?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const r=this.f(s.right);if(r.key){const{key:i,value:a,segment:h}=r;this.e(r.key,!1),s.key=i,s.value=a,s.segment=h}}else{const r=s.left??s.right;if(o.length>0){const[i,a]=o[o.length-1];switch(i){case-1:a.left=r;break;case 0:a.mid=r;break;case 1:a.right=r;break}}else this.c=r}for(let r=o.length-1;r>=0;r--){const i=o[r][1];i.updateHeight();const a=i.balanceFactor();if(a>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),o[r][1]=i.rotateLeft()):a<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),o[r][1]=i.rotateRight()),r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this.c=o[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const d=this.b.reset(w);let n=this.c,o;for(;n;){const s=d.cmp(n.segment);if(s>0)n=n.left;else if(s<0)n=n.right;else if(d.hasNext())d.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(w){return this.g(w,!1)}g(w,d){const n=this.b.reset(w);let o=this.c;for(;o;){const s=n.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this.h(o.mid):d?o.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[d,n]of this)w(n,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const d=[];return this.j(w,d),d[Symbol.iterator]()}j(w,d){w&&(w.left&&this.j(w.left,d),w.value&&d.push([w.key,w.value]),w.mid&&this.j(w.mid,d),w.right&&this.j(w.right,d))}_isBalanced(){const w=d=>{if(!d)return!0;const n=d.balanceFactor();return n<-1||n>1?!1:w(d.left)&&w(d.right)};return w(this.c)}}e.$wi=k}),define(Re[41],Ae([1,0,91]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Qj=R;var N;(function(M){function m(g){return g&&typeof g=="object"&&typeof g.id=="string"}M.isThemeColor=m})(N||(e.ThemeColor=N={}));function R(M){return{id:M}}var F;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function g(r){const i=m.exec(r.id);if(!i)return g(I.$Pj.error);const[,a,h]=i,t=["codicon","codicon-"+a];return h&&t.push("codicon-modifier-"+h.substring(1)),t}M.asClassNameArray=g;function E(r){return g(r).join(" ")}M.asClassName=E;function T(r){return"."+g(r).join(".")}M.asCSSSelector=T;function k(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||N.isThemeColor(r.color))}M.isThemeIcon=k;const u=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function w(r){const i=u.exec(r);if(!i)return;const[,a]=i;return{id:a}}M.fromString=w;function d(r){return{id:r}}M.fromId=d;function n(r,i){let a=r.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),i&&(a=`${a}~${i}`),{id:a}}M.modify=n;function o(r){const i=r.id.lastIndexOf("~");if(i!==-1)return r.id.substring(i+1)}M.getModifier=o;function s(r,i){return r.id===i.id&&r.color?.id===i.color?.id}M.isEqual=s})(F||(e.ThemeIcon=F={}))}),define(Re[131],Ae([1,0,129,15,41]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=g,e.$Ik=T,e.$Jk=u,e.$Kk=w,e.$Lk=n,e.$Mk=o;const F="$(",M=new RegExp(`\\$\\(${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${M.source}`,"g");function g(s){return s.replace(m,(r,i)=>i?r:`\\${r}`)}const E=new RegExp(`\\\\${M.source}`,"g");function T(s){return s.replace(E,r=>`\\${r}`)}const k=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function u(s){return s.indexOf(F)===-1?s:s.replace(k,(r,i,a,h)=>a?r:i||h||"")}function w(s){return s?s.replace(/\$\((.*?)\)/g,(r,i)=>` ${i} `).trim():""}const d=new RegExp(`\\$\\(${R.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(s){d.lastIndex=0;let r="";const i=[];let a=0;for(;;){const h=d.lastIndex,t=d.exec(s),b=s.substring(h,t?.index);if(b.length>0){r+=b;for(let c=0;c<b.length;c++)i.push(a)}if(!t)break;a+=t[0].length}return{text:r,iconOffsets:i}}function o(s,r,i=!1){const{text:a,iconOffsets:h}=r;if(!h||h.length===0)return(0,I.$yk)(s,a,i);const t=(0,N.$af)(a," "),b=a.length-t.length,c=(0,I.$yk)(s,t,i);if(c)for(const $ of c){const v=h[$.start+b]+b;$.start+=v,$.end+=v}return c}}),define(Re[35],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mg=void 0,e.$Lg=N;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(R){return I.test(R)}e.$Mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(m){for(let g=0;g<m.length;g++)m[g]=Math.floor(Math.random()*256);return m};const F=new Uint8Array(16),M=[];for(let m=0;m<256;m++)M.push(m.toString(16).padStart(2,"0"));return function(){R(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let g=0,E="";return E+=M[F[g++]],E+=M[F[g++]],E+=M[F[g++]],E+=M[F[g++]],E+="-",E+=M[F[g++]],E+=M[F[g++]],E+="-",E+=M[F[g++]],E+=M[F[g++]],E+="-",E+=M[F[g++]],E+=M[F[g++]],E+="-",E+=M[F[g++]],E+=M[F[g++]],E+=M[F[g++]],E+=M[F[g++]],E+=M[F[g++]],E+=M[F[g++]],E}}()}),define(Re[132],Ae([1,0,18,46,35]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.$It=void 0,e.$Gt=F,e.$Ht=M,e.$Jt=E;function F(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}function M(k,u,w){const d={id:(0,R.$Mg)(),name:k,uri:u,data:w};return{asString:async()=>"",asFile:()=>d,value:void 0}}class m{constructor(){this.a=new Map}get size(){let u=0;for(const w of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const w=[...this.a.keys()];return N.Iterable.some(this,([d,n])=>n.asFile())&&w.push("files"),T(g(u),w)}get(u){return this.a.get(this.b(u))?.[0]}append(u,w){const d=this.a.get(u);d?d.push(w):this.a.set(this.b(u),[w])}replace(u,w){this.a.set(this.b(u),[w])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,w]of this.a)for(const d of w)yield[u,d]}b(u){return g(u)}}e.$It=m;function g(k){return k.toLowerCase()}function E(k,u){return T(g(k),u.map(g))}function T(k,u){if(k==="*/*")return u.length>0;if(u.includes(k))return!0;const w=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[d,n,o]=w;return o==="*"?u.some(s=>s.startsWith(n+"/")):!1}e.$Kt=Object.freeze({create:k=>(0,I.$Mb)(k.map(u=>u.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$Kt.split(k).filter(u=>!u.startsWith("#"))})}),define(Re[133],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Nt=N;var I;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function N(R){let F=0,M=0,m=0,g=0;for(let E=0,T=R.length;E<T;E++){const k=R.charCodeAt(E);k===13?(F===0&&(M=E),F++,E+1<T&&R.charCodeAt(E+1)===10?(g|=2,E++):g|=3,m=E+1):k===10&&(g|=1,F===0&&(M=E),F++,m=E+1)}return F===0&&(M=R.length),[F,M,R.length-m,g]}}),define(Re[134],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[135],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=e.$au=e.IndentAction=void 0;var I;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class N{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let g=0,E=m.notIn.length;g<E;g++)switch(m.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,g){if(m.getTokenCount()===0)return!0;const E=m.findTokenIndexAtOffset(g-2),T=m.getStandardTokenType(E);return this.isOK(T)}g(m,g){for(let E=m;E<=g;E++){const T=String.fromCharCode(E);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$au=N;class R{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of m)F(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),F(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),F(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),F(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&F(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$bu=R;function F(M,m,g){M.has(m)?M.get(m).push(g):M.set(m,[g])}}),define(Re[136],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rC=e.NodeColor=e.$qC=void 0,e.$sC=R,e.$tC=F,e.$uC=E,e.$vC=T,e.$wC=k,e.$xC=u,e.$yC=w,e.$zC=d;class I{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$rC)return R(this.right);let o=this;for(;o.parent!==e.$rC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$rC?e.$rC:o.parent}prev(){if(this.left!==e.$rC)return F(this.left);let o=this;for(;o.parent!==e.$rC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$rC?e.$rC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$qC=I;var N;(function(n){n[n.Black=0]="Black",n[n.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$rC=new I(null,0),e.$rC.parent=e.$rC,e.$rC.left=e.$rC,e.$rC.right=e.$rC,e.$rC.color=0;function R(n){for(;n.left!==e.$rC;)n=n.left;return n}function F(n){for(;n.right!==e.$rC;)n=n.right;return n}function M(n){return n===e.$rC?0:n.size_left+n.piece.length+M(n.right)}function m(n){return n===e.$rC?0:n.lf_left+n.piece.lineFeedCnt+m(n.right)}function g(){e.$rC.parent=e.$rC}function E(n,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.$rC&&(s.left.parent=o),s.parent=o.parent,o.parent===e.$rC?n.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function T(n,o){const s=o.left;o.left=s.right,s.right!==e.$rC&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.$rC?n.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function k(n,o){let s,r;if(o.left===e.$rC?(r=o,s=r.right):o.right===e.$rC?(r=o,s=r.left):(r=R(o.right),s=r.right),r===n.root){n.root=s,s.color=0,o.detach(),g(),n.root.parent=e.$rC;return}const i=r.color===1;if(r===r.parent.left?r.parent.left=s:r.parent.right=s,r===o?(s.parent=r.parent,d(n,s)):(r.parent===o?s.parent=r:s.parent=r.parent,d(n,s),r.left=o.left,r.right=o.right,r.parent=o.parent,r.color=o.color,o===n.root?n.root=r:o===o.parent.left?o.parent.left=r:o.parent.right=r,r.left!==e.$rC&&(r.left.parent=r),r.right!==e.$rC&&(r.right.parent=r),r.size_left=o.size_left,r.lf_left=o.lf_left,d(n,r)),o.detach(),s.parent.left===s){const h=M(s),t=m(s);if(h!==s.parent.size_left||t!==s.parent.lf_left){const b=h-s.parent.size_left,c=t-s.parent.lf_left;s.parent.size_left=h,s.parent.lf_left=t,w(n,s.parent,b,c)}}if(d(n,s.parent),i){g();return}let a;for(;s!==n.root&&s.color===0;)s===s.parent.left?(a=s.parent.right,a.color===1&&(a.color=0,s.parent.color=1,E(n,s.parent),a=s.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.right.color===0&&(a.left.color=0,a.color=1,T(n,a),a=s.parent.right),a.color=s.parent.color,s.parent.color=0,a.right.color=0,E(n,s.parent),s=n.root)):(a=s.parent.left,a.color===1&&(a.color=0,s.parent.color=1,T(n,s.parent),a=s.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.left.color===0&&(a.right.color=0,a.color=1,E(n,a),a=s.parent.left),a.color=s.parent.color,s.parent.color=0,a.left.color=0,T(n,s.parent),s=n.root));s.color=0,g()}function u(n,o){for(d(n,o);o!==n.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,E(n,o)),o.parent.color=0,o.parent.parent.color=1,T(n,o.parent.parent))}else{const s=o.parent.parent.left;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,T(n,o)),o.parent.color=0,o.parent.parent.color=1,E(n,o.parent.parent))}n.root.color=0}function w(n,o,s,r){for(;o!==n.root&&o!==e.$rC;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=r),o=o.parent}function d(n,o){let s=0,r=0;if(o!==n.root){for(;o!==n.root&&o===o.parent.right;)o=o.parent;if(o!==n.root)for(o=o.parent,s=M(o.left)-o.size_left,r=m(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=r;o!==n.root&&(s!==0||r!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=r),o=o.parent}}}),define(Re[92],Ae([1,0,93,29,94,136,95]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KC=e.$JC=e.$IC=void 0,e.$GC=T,e.$HC=k;const m=65535;function g(s){let r;return s[s.length-1]<65536?r=new Uint16Array(s.length):r=new Uint32Array(s.length),r.set(s,0),r}class E{constructor(r,i,a,h,t){this.lineStarts=r,this.cr=i,this.lf=a,this.crlf=h,this.isBasicASCII=t}}function T(s,r=!0){const i=[0];let a=1;for(let h=0,t=s.length;h<t;h++){const b=s.charCodeAt(h);b===13?h+1<t&&s.charCodeAt(h+1)===10?(i[a++]=h+2,h++):i[a++]=h+1:b===10&&(i[a++]=h+1)}return r?g(i):i}function k(s,r){s.length=0,s[0]=0;let i=1,a=0,h=0,t=0,b=!0;for(let $=0,v=r.length;$<v;$++){const p=r.charCodeAt($);p===13?$+1<v&&r.charCodeAt($+1)===10?(t++,s[i++]=$+2,$++):(a++,s[i++]=$+1):p===10?(h++,s[i++]=$+1):b&&p!==9&&(p<32||p>126)&&(b=!1)}const c=new E(g(s),a,h,t,b);return s.length=0,c}class u{constructor(r,i,a,h,t){this.bufferIndex=r,this.start=i,this.end=a,this.lineFeedCnt=h,this.length=t}}e.$IC=u;class w{constructor(r,i){this.buffer=r,this.lineStarts=i}}e.$JC=w;class d{constructor(r,i){this.a=[],this.c=r,this.d=i,this.b=0,r.root!==F.$rC&&r.iterate(r.root,a=>(a!==F.$rC&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class n{constructor(r){this.a=r,this.b=[]}get(r){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartOffset<=r&&a.nodeStartOffset+a.node.piece.length>=r)return a}return null}get2(r){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<r&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=r)return a}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let i=!1;const a=this.b;for(let h=0;h<a.length;h++){const t=a[h];if(t.node.parent===null||t.nodeStartOffset>=r){a[h]=null,i=!0;continue}}if(i){const h=[];for(const t of a)t!==null&&h.push(t);this.b=h}}}class o{constructor(r,i,a){this.create(r,i,a)}create(r,i,a){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=F.$rC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=a;let h=null;for(let t=0,b=r.length;t<b;t++)if(r[t].buffer.length>0){r[t].lineStarts||(r[t].lineStarts=T(r[t].buffer));const c=new u(t+1,{line:0,column:0},{line:r[t].lineStarts.length-1,column:r[t].buffer.length-r[t].lineStarts[r[t].lineStarts.length-1]},r[t].lineStarts.length-1,r[t].buffer.length);this.a.push(r[t]),h=this.S(h,c)}this.h=new n(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const i=m,a=i-Math.floor(i/3),h=a*2;let t="",b=0;const c=[];if(this.iterate(this.root,$=>{const v=this.R($),p=v.length;if(b<=a||b+p<h)return t+=v,b+=p,!0;const l=t.replace(/\r\n|\r|\n/g,r);return c.push(new w(l,T(l))),t=v,b=p,!0}),b>0){const $=t.replace(/\r\n|\r|\n/g,r);c.push(new w($,T($)))}this.create(c,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new d(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let i=0;return this.iterate(this.root,h=>{if(h===F.$rC)return!0;const t=this.R(h),b=t.length,c=r.G(i),$=r.G(i+b),v=r.getValueInRange2(c,$);return i+=b,t===v})}getOffsetAt(r,i){let a=0,h=this.root;for(;h!==F.$rC;)if(h.left!==F.$rC&&h.lf_left+1>=r)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=r){a+=h.size_left;const t=this.B(h,r-h.lf_left-2);return a+=t+i-1}else r-=h.lf_left+h.piece.lineFeedCnt,a+=h.size_left+h.piece.length,h=h.right;return a}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let i=this.root,a=0;const h=r;for(;i!==F.$rC;)if(i.size_left!==0&&i.size_left>=r)i=i.left;else if(i.size_left+i.piece.length>=r){const t=this.A(i,r-i.size_left);if(a+=i.lf_left+t.index,t.index===0){const b=this.getOffsetAt(a+1,1),c=h-b;return new I.$jt(a+1,c+1)}return new I.$jt(a+1,t.remainder+1)}else if(r-=i.size_left+i.piece.length,a+=i.lf_left+i.piece.lineFeedCnt,i.right===F.$rC){const t=this.getOffsetAt(a+1,1),b=h-r-t;return new I.$jt(a+1,b+1)}else i=i.right;return new I.$jt(1,1)}getValueInRange(r,i){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const a=this.H(r.startLineNumber,r.startColumn),h=this.H(r.endLineNumber,r.endColumn),t=this.getValueInRange2(a,h);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(r,i){if(r.node===i.node){const c=r.node,$=this.a[c.piece.bufferIndex].buffer,v=this.u(c.piece.bufferIndex,c.piece.start);return $.substring(v+r.remainder,v+i.remainder)}let a=r.node;const h=this.a[a.piece.bufferIndex].buffer,t=this.u(a.piece.bufferIndex,a.piece.start);let b=h.substring(t+r.remainder,t+a.piece.length);for(a=a.next();a!==F.$rC;){const c=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);if(a===i.node){b+=c.substring($,$+i.remainder);break}else b+=c.substr($,a.piece.length);a=a.next()}return b}getLinesContent(){const r=[];let i=0,a="",h=!1;return this.iterate(this.root,t=>{if(t===F.$rC)return!0;const b=t.piece;let c=b.length;if(c===0)return!0;const $=this.a[b.bufferIndex].buffer,v=this.a[b.bufferIndex].lineStarts,p=b.start.line,l=b.end.line;let D=v[p]+b.start.column;if(h&&($.charCodeAt(D)===10&&(D++,c--),r[i++]=a,a="",h=!1,c===0))return!0;if(p===l)return!this.f&&$.charCodeAt(D+c-1)===13?(h=!0,a+=$.substr(D,c-1)):a+=$.substr(D,c),!0;a+=this.f?$.substring(D,Math.max(D,v[p+1]-this.e)):$.substring(D,v[p+1]).replace(/(\r\n|\r|\n)$/,""),r[i++]=a;for(let f=p+1;f<l;f++)a=this.f?$.substring(v[f],v[f+1]-this.e):$.substring(v[f],v[f+1]).replace(/(\r\n|\r|\n)$/,""),r[i++]=a;return!this.f&&$.charCodeAt(v[l]+b.end.column-1)===13?(h=!0,b.end.column===0?i--:a=$.substr(v[l],b.end.column-1)):a=$.substr(v[l],b.end.column),!0}),h&&(r[i++]=a,a=""),r[i++]=a,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const i=r.node.next();if(!i)return 0;const a=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start);return a.buffer.charCodeAt(h)}else{const i=this.a[r.node.piece.bufferIndex],h=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return i.buffer.charCodeAt(h)}}getLineCharCode(r,i){const a=this.H(r,i+1);return this.l(a)}getLineLength(r){if(r===this.getLineCount()){const i=this.getOffsetAt(r,1);return this.getLength()-i}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const i=this.G(r);return this.l(i)}findMatchesInNode(r,i,a,h,t,b,c,$,v,p,l){const D=this.a[r.piece.bufferIndex],f=this.u(r.piece.bufferIndex,r.piece.start),S=this.u(r.piece.bufferIndex,t),y=this.u(r.piece.bufferIndex,b);let C;const P={line:0,column:0};let V,W;i._wordSeparators?(V=D.buffer.substring(S,y),W=q=>q+S,i.reset(0)):(V=D.buffer,W=q=>q,i.reset(S));do if(C=i.next(V),C){if(W(C.index)>=y)return p;this.s(r,W(C.index)-f,P);const q=this.t(r.piece.bufferIndex,t,P),A=P.line===t.line?P.column-t.column+h:P.column+1,j=A+C[0].length;if(l[p++]=(0,M.$CC)(new N.$kt(a+q,A,a+q,j),C,$),W(C.index)+C[0].length>=y||p>=v)return p}while(C);return p}findMatchesLineByLine(r,i,a,h){const t=[];let b=0;const c=new M.$FC(i.wordSeparators,i.regex);let $=this.H(r.startLineNumber,r.startColumn);if($===null)return[];const v=this.H(r.endLineNumber,r.endColumn);if(v===null)return[];let p=this.s($.node,$.remainder);const l=this.s(v.node,v.remainder);if($.node===v.node)return this.findMatchesInNode($.node,c,r.startLineNumber,r.startColumn,p,l,i,a,h,b,t),t;let D=r.startLineNumber,f=$.node;for(;f!==v.node;){const y=this.t(f.piece.bufferIndex,p,f.piece.end);if(y>=1){const P=this.a[f.piece.bufferIndex].lineStarts,V=this.u(f.piece.bufferIndex,f.piece.start),W=P[p.line+y],q=D===r.startLineNumber?r.startColumn:1;if(b=this.findMatchesInNode(f,c,D,q,p,this.s(f,W-V),i,a,h,b,t),b>=h)return t;D+=y}const C=D===r.startLineNumber?r.startColumn-1:0;if(D===r.endLineNumber){const P=this.getLineContent(D).substring(C,r.endColumn-1);return b=this.n(i,c,P,r.endLineNumber,C,b,t,a,h),t}if(b=this.n(i,c,this.getLineContent(D).substr(C),D,C,b,t,a,h),b>=h)return t;D++,$=this.H(D,1),f=$.node,p=this.s($.node,$.remainder)}if(D===r.endLineNumber){const y=D===r.startLineNumber?r.startColumn-1:0,C=this.getLineContent(D).substring(y,r.endColumn-1);return b=this.n(i,c,C,r.endLineNumber,y,b,t,a,h),t}const S=D===r.startLineNumber?r.startColumn:1;return b=this.findMatchesInNode(v.node,c,D,S,p,l,i,a,h,b,t),t}n(r,i,a,h,t,b,c,$,v){const p=r.wordSeparators;if(!$&&r.simpleSearch){const D=r.simpleSearch,f=D.length,S=a.length;let y=-f;for(;(y=a.indexOf(D,y+f))!==-1;)if((!p||(0,M.$EC)(p,a,S,y,f))&&(c[b++]=new R.$vv(new N.$kt(h,y+1+t,h,y+1+f+t),null),b>=v))return b;return b}let l;i.reset(0);do if(l=i.next(a),l&&(c[b++]=(0,M.$CC)(new N.$kt(h,l.index+1+t,h,l.index+1+l[0].length+t),l,$),b>=v))return b;while(l);return b}insert(r,i,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==F.$rC){const{node:h,remainder:t,nodeStartOffset:b}=this.G(r),c=h.piece,$=c.bufferIndex,v=this.s(h,t);if(h.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&b+c.length===r&&i.length<m){this.F(h,i),this.y();return}if(b===r)this.o(i,h),this.h.validate(r);else if(b+h.piece.length>r){const p=[];let l=new u(c.bufferIndex,v,c.end,this.t(c.bufferIndex,v,c.end),this.u($,c.end)-this.u($,v));if(this.K()&&this.M(i)&&this.I(h,t)===10){const y={line:l.start.line+1,column:0};l=new u(l.bufferIndex,y,l.end,this.t(l.bufferIndex,y,l.end),l.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(h,t-1)===13){const y=this.s(h,t-1);this.C(h,y),i="\r"+i,h.piece.length===0&&p.push(h)}else this.C(h,v);else this.C(h,v);const D=this.w(i);l.length>0&&this.S(h,l);let f=h;for(let S=0;S<D.length;S++)f=this.S(f,D[S]);this.v(p)}else this.q(i,h)}else{const h=this.w(i);let t=this.T(null,h[0]);for(let b=1;b<h.length;b++)t=this.S(t,h[b])}this.y()}delete(r,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===F.$rC)return;const a=this.G(r),h=this.G(r+i),t=a.node,b=h.node;if(t===b){const D=this.s(t,a.remainder),f=this.s(t,h.remainder);if(a.nodeStartOffset===r){if(i===t.piece.length){const S=t.next();(0,F.$wC)(this,t),this.N(S),this.y();return}this.D(t,f),this.h.validate(r),this.N(t),this.y();return}if(a.nodeStartOffset+t.piece.length===r+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,f),this.y();return}const c=[],$=this.s(t,a.remainder);this.C(t,$),this.h.validate(r),t.piece.length===0&&c.push(t);const v=this.s(b,h.remainder);this.D(b,v),b.piece.length===0&&c.push(b);const p=t.next();for(let D=p;D!==F.$rC&&D!==b;D=D.next())c.push(D);const l=t.piece.length===0?t.prev():t;this.v(c),this.O(l),this.y()}o(r,i){const a=[];if(this.K()&&this.M(r)&&this.L(i)){const b=i.piece,c={line:b.start.line+1,column:0},$=new u(b.bufferIndex,c,b.end,this.t(b.bufferIndex,c,b.end),b.length-1);i.piece=$,r+=`
`,(0,F.$yC)(this,i,-1,-1),i.piece.length===0&&a.push(i)}const h=this.w(r);let t=this.T(i,h[h.length-1]);for(let b=h.length-2;b>=0;b--)t=this.T(t,h[b]);this.N(t),this.v(a)}q(r,i){this.Q(r,i)&&(r+=`
`);const a=this.w(r),h=this.S(i,a[0]);let t=h;for(let b=1;b<a.length;b++)t=this.S(t,a[b]);this.N(h)}s(r,i,a){const h=r.piece,t=r.piece.bufferIndex,b=this.a[t].lineStarts,$=b[h.start.line]+h.start.column+i;let v=h.start.line,p=h.end.line,l=0,D=0,f=0;for(;v<=p&&(l=v+(p-v)/2|0,f=b[l],l!==p);)if(D=b[l+1],$<f)p=l-1;else if($>=D)v=l+1;else break;return a?(a.line=l,a.column=$-f,null):{line:l,column:$-f}}t(r,i,a){if(a.column===0)return a.line-i.line;const h=this.a[r].lineStarts;if(a.line===h.length-1)return a.line-i.line;const t=h[a.line+1],b=h[a.line]+a.column;if(t>b+1)return a.line-i.line;const c=b-1;return this.a[r].buffer.charCodeAt(c)===13?a.line-i.line+1:a.line-i.line}u(r,i){return this.a[r].lineStarts[i.line]+i.column}v(r){for(let i=0;i<r.length;i++)(0,F.$wC)(this,r[i])}w(r){if(r.length>m){const p=[];for(;r.length>m;){const D=r.charCodeAt(m-1);let f;D===13||D>=55296&&D<=56319?(f=r.substring(0,m-1),r=r.substring(m-1)):(f=r.substring(0,m),r=r.substring(m));const S=T(f);p.push(new u(this.a.length,{line:0,column:0},{line:S.length-1,column:f.length-S[S.length-1]},S.length-1,f.length)),this.a.push(new w(f,S))}const l=T(r);return p.push(new u(this.a.length,{line:0,column:0},{line:l.length-1,column:r.length-l[l.length-1]},l.length-1,r.length)),this.a.push(new w(r,l)),p}let i=this.a[0].buffer.length;const a=T(r,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let p=0;p<a.length;p++)a[p]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+r,i+=1}else{if(i!==0)for(let p=0;p<a.length;p++)a[p]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=r}const t=this.a[0].buffer.length,b=this.a[0].lineStarts.length-1,c=t-this.a[0].lineStarts[b],$={line:b,column:c},v=new u(0,h,$,this.t(0,h,$),t-i);return this.g=$,[v]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,i=0){let a=this.root,h="";const t=this.h.get2(r);if(t){a=t.node;const b=this.B(a,r-t.nodeStartLineNumber-1),c=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===r)h=c.substring($+b,$+a.piece.length);else{const v=this.B(a,r-t.nodeStartLineNumber);return c.substring($+b,$+v-i)}}else{let b=0;const c=r;for(;a!==F.$rC;)if(a.left!==F.$rC&&a.lf_left>=r-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>r-1){const $=this.B(a,r-a.lf_left-2),v=this.B(a,r-a.lf_left-1),p=this.a[a.piece.bufferIndex].buffer,l=this.u(a.piece.bufferIndex,a.piece.start);return b+=a.size_left,this.h.set({node:a,nodeStartOffset:b,nodeStartLineNumber:c-(r-1-a.lf_left)}),p.substring(l+$,l+v-i)}else if(a.lf_left+a.piece.lineFeedCnt===r-1){const $=this.B(a,r-a.lf_left-2),v=this.a[a.piece.bufferIndex].buffer,p=this.u(a.piece.bufferIndex,a.piece.start);h=v.substring(p+$,p+a.piece.length);break}else r-=a.lf_left+a.piece.lineFeedCnt,b+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==F.$rC;){const b=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.B(a,0),$=this.u(a.piece.bufferIndex,a.piece.start);return h+=b.substring($,$+c-i),h}else{const c=this.u(a.piece.bufferIndex,a.piece.start);h+=b.substr(c,a.piece.length)}a=a.next()}return h}y(){let r=this.root,i=1,a=0;for(;r!==F.$rC;)i+=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;this.b=i,this.c=a,this.h.validate(this.c)}A(r,i){const a=r.piece,h=this.s(r,i),t=h.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===i){const b=this.t(r.piece.bufferIndex,a.start,h);if(b!==t)return{index:b,remainder:0}}return{index:t,remainder:h.column}}B(r,i){if(i<0)return 0;const a=r.piece,h=this.a[a.bufferIndex].lineStarts,t=a.start.line+i+1;return t>a.end.line?h[a.end.line]+a.end.column-h[a.start.line]-a.start.column:h[t]-h[a.start.line]-a.start.column}C(r,i){const a=r.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.end),b=i,c=this.u(a.bufferIndex,b),$=this.t(a.bufferIndex,a.start,b),v=$-h,p=c-t,l=a.length+p;r.piece=new u(a.bufferIndex,a.start,b,$,l),(0,F.$yC)(this,r,p,v)}D(r,i){const a=r.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.start),b=i,c=this.t(a.bufferIndex,b,a.end),$=this.u(a.bufferIndex,b),v=c-h,p=t-$,l=a.length+p;r.piece=new u(a.bufferIndex,b,a.end,c,l),(0,F.$yC)(this,r,p,v)}E(r,i,a){const h=r.piece,t=h.start,b=h.end,c=h.length,$=h.lineFeedCnt,v=i,p=this.t(h.bufferIndex,h.start,v),l=this.u(h.bufferIndex,i)-this.u(h.bufferIndex,t);r.piece=new u(h.bufferIndex,h.start,v,p,l),(0,F.$yC)(this,r,l-c,p-$);const D=new u(h.bufferIndex,a,b,this.t(h.bufferIndex,a,b),this.u(h.bufferIndex,b)-this.u(h.bufferIndex,a)),f=this.S(r,D);this.N(f)}F(r,i){this.Q(i,r)&&(i+=`
`);const a=this.K()&&this.L(i)&&this.M(r),h=this.a[0].buffer.length;this.a[0].buffer+=i;const t=T(i,!1);for(let f=0;f<t.length;f++)t[f]+=h;if(a){const f=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-f}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const b=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[b],$={line:b,column:c},v=r.piece.length+i.length,p=r.piece.lineFeedCnt,l=this.t(0,r.piece.start,$),D=l-p;r.piece=new u(r.piece.bufferIndex,r.piece.start,$,l,v),this.g=$,(0,F.$yC)(this,r,i.length,D)}G(r){let i=this.root;const a=this.h.get(r);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:r-a.nodeStartOffset};let h=0;for(;i!==F.$rC;)if(i.size_left>r)i=i.left;else if(i.size_left+i.piece.length>=r){h+=i.size_left;const t={node:i,remainder:r-i.size_left,nodeStartOffset:h};return this.h.set(t),t}else r-=i.size_left+i.piece.length,h+=i.size_left+i.piece.length,i=i.right;return null}H(r,i){let a=this.root,h=0;for(;a!==F.$rC;)if(a.left!==F.$rC&&a.lf_left>=r-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>r-1){const t=this.B(a,r-a.lf_left-2),b=this.B(a,r-a.lf_left-1);return h+=a.size_left,{node:a,remainder:Math.min(t+i-1,b),nodeStartOffset:h}}else if(a.lf_left+a.piece.lineFeedCnt===r-1){const t=this.B(a,r-a.lf_left-2);if(t+i-1<=a.piece.length)return{node:a,remainder:t+i-1,nodeStartOffset:h};i-=a.piece.length-t;break}else r-=a.lf_left+a.piece.lineFeedCnt,h+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==F.$rC;){if(a.piece.lineFeedCnt>0){const t=this.B(a,0),b=this.J(a);return{node:a,remainder:Math.min(i-1,t),nodeStartOffset:b}}else if(a.piece.length>=i-1){const t=this.J(a);return{node:a,remainder:i-1,nodeStartOffset:t}}else i-=a.piece.length;a=a.next()}return null}I(r,i){if(r.piece.lineFeedCnt<1)return-1;const a=this.a[r.piece.bufferIndex],h=this.u(r.piece.bufferIndex,r.piece.start)+i;return a.buffer.charCodeAt(h)}J(r){if(!r)return 0;let i=r.size_left;for(;r!==this.root;)r.parent.right===r&&(i+=r.parent.size_left+r.parent.piece.length),r=r.parent;return i}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===F.$rC||r.piece.lineFeedCnt===0)return!1;const i=r.piece,a=this.a[i.bufferIndex].lineStarts,h=i.start.line,t=a[h]+i.start.column;return h===a.length-1||a[h+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===F.$rC||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const i=r.prev();this.M(i)&&this.P(i,r)}}O(r){if(this.K()&&this.M(r)){const i=r.next();this.L(i)&&this.P(r,i)}}P(r,i){const a=[],h=this.a[r.piece.bufferIndex].lineStarts;let t;r.piece.end.column===0?t={line:r.piece.end.line-1,column:h[r.piece.end.line]-h[r.piece.end.line-1]-1}:t={line:r.piece.end.line,column:r.piece.end.column-1};const b=r.piece.length-1,c=r.piece.lineFeedCnt-1;r.piece=new u(r.piece.bufferIndex,r.piece.start,t,c,b),(0,F.$yC)(this,r,-1,-1),r.piece.length===0&&a.push(r);const $={line:i.piece.start.line+1,column:0},v=i.piece.length-1,p=this.t(i.piece.bufferIndex,$,i.piece.end);i.piece=new u(i.piece.bufferIndex,$,i.piece.end,p,v),(0,F.$yC)(this,i,-1,-1),i.piece.length===0&&a.push(i);const l=this.w(`\r
`);this.S(r,l[0]);for(let D=0;D<a.length;D++)(0,F.$wC)(this,a[D])}Q(r,i){if(this.K()&&this.M(r)){const a=i.next();if(this.L(a)){if(r+=`
`,a.piece.length===1)(0,F.$wC)(this,a);else{const h=a.piece,t={line:h.start.line+1,column:0},b=h.length-1,c=this.t(h.bufferIndex,t,h.end);a.piece=new u(h.bufferIndex,t,h.end,c,b),(0,F.$yC)(this,a,-1,-1)}return!0}}return!1}iterate(r,i){if(r===F.$rC)return i(F.$rC);const a=this.iterate(r.left,i);return a&&i(r)&&this.iterate(r.right,i)}R(r){if(r===F.$rC)return"";const i=this.a[r.piece.bufferIndex],a=r.piece,h=this.u(a.bufferIndex,a.start),t=this.u(a.bufferIndex,a.end);return i.buffer.substring(h,t)}getPieceContent(r){const i=this.a[r.bufferIndex],a=this.u(r.bufferIndex,r.start),h=this.u(r.bufferIndex,r.end);return i.buffer.substring(a,h)}S(r,i){const a=new F.$qC(i,1);if(a.left=F.$rC,a.right=F.$rC,a.parent=F.$rC,a.size_left=0,a.lf_left=0,this.root===F.$rC)this.root=a,a.color=0;else if(r.right===F.$rC)r.right=a,a.parent=r;else{const t=(0,F.$sC)(r.right);t.left=a,a.parent=t}return(0,F.$xC)(this,a),a}T(r,i){const a=new F.$qC(i,1);if(a.left=F.$rC,a.right=F.$rC,a.parent=F.$rC,a.size_left=0,a.lf_left=0,this.root===F.$rC)this.root=a,a.color=0;else if(r.left===F.$rC)r.left=a,a.parent=r;else{const h=(0,F.$tC)(r.left);h.right=a,a.parent=h}return(0,F.$xC)(this,a),a}U(r){let i="";return this.iterate(r,a=>(i+=this.R(a),!0)),i}}e.$KC=o}),define(Re[137],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N0=e.$M0=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const M=this.a.get(F);return this.a.delete(F),M}}addDragOperationTransfer(F,M){this.a.set(F,M)}}e.$M0=I;class N{constructor(F){this.identifier=F}}e.$N0=N}),define(Re[138],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Re[139],Ae([1,0,5,6,138]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=void 0,e.$aj=T;class F extends N.$Uc{constructor(u,w="",d="",n=!0,o){super(),this.h=this.B(new I.$be),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=w,this.u=d,this.w=n,this.C=o}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,w){this.C&&await this.C(u)}}e.$8i=F;class M extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new I.$be),this.onWillRun=this.f.event,this.m=this.B(new I.$be),this.onDidRun=this.m.event}async run(u,w){if(!u.enabled)return;this.f.fire({action:u});let d;try{await this.u(u,w)}catch(n){d=n}this.m.fire({action:u,error:d})}async u(u,w){await u.run(w)}}e.$9i=M;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let w=[];for(const d of u)d.length&&(w.length?w=[...w,new m,...d]:w=d);return w}static{this.ID="vs.actions.separator"}async run(){}}e.$0i=m;class g{get actions(){return this.a}constructor(u,w,d,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=w,this.class=n,this.a=d}async run(){}}e.$$i=g;class E extends F{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,R.localize(0,null),void 0,!1)}}e.$_i=E;function T(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked,run:async(...u)=>k.run(...u),tooltip:k.label}}}),define(Re[140],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Re[141],Ae([1,0,140]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=E,e.$Wm=T,e.$Xm=k;const N=60,R=N*60,F=R*24,M=F*7,m=F*30,g=F*365;function E(u,w,d,n){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,I.localize)(0,null,E(new Date().getTime()+o*1e3,!1));if(!n&&o<30)return(0,I.localize)(1,null);let s;return o<N?(s=o,w?s===1?d?(0,I.localize)(2,null,s):(0,I.localize)(3,null,s):d?(0,I.localize)(4,null,s):(0,I.localize)(5,null,s):s===1?d?(0,I.localize)(6,null,s):(0,I.localize)(7,null,s):d?(0,I.localize)(8,null,s):(0,I.localize)(9,null,s)):o<R?(s=Math.floor(o/N),w?s===1?d?(0,I.localize)(10,null,s):(0,I.localize)(11,null,s):d?(0,I.localize)(12,null,s):(0,I.localize)(13,null,s):s===1?d?(0,I.localize)(14,null,s):(0,I.localize)(15,null,s):d?(0,I.localize)(16,null,s):(0,I.localize)(17,null,s)):o<F?(s=Math.floor(o/R),w?s===1?d?(0,I.localize)(18,null,s):(0,I.localize)(19,null,s):d?(0,I.localize)(20,null,s):(0,I.localize)(21,null,s):s===1?d?(0,I.localize)(22,null,s):(0,I.localize)(23,null,s):d?(0,I.localize)(24,null,s):(0,I.localize)(25,null,s)):o<M?(s=Math.floor(o/F),w?s===1?(0,I.localize)(26,null,s):(0,I.localize)(27,null,s):s===1?(0,I.localize)(28,null,s):(0,I.localize)(29,null,s)):o<m?(s=Math.floor(o/M),w?s===1?d?(0,I.localize)(30,null,s):(0,I.localize)(31,null,s):d?(0,I.localize)(32,null,s):(0,I.localize)(33,null,s):s===1?d?(0,I.localize)(34,null,s):(0,I.localize)(35,null,s):d?(0,I.localize)(36,null,s):(0,I.localize)(37,null,s)):o<g?(s=Math.floor(o/m),w?s===1?d?(0,I.localize)(38,null,s):(0,I.localize)(39,null,s):d?(0,I.localize)(40,null,s):(0,I.localize)(41,null,s):s===1?d?(0,I.localize)(42,null,s):(0,I.localize)(43,null,s):d?(0,I.localize)(44,null,s):(0,I.localize)(45,null,s)):(s=Math.floor(o/g),w?s===1?d?(0,I.localize)(46,null,s):(0,I.localize)(47,null,s):d?(0,I.localize)(48,null,s):(0,I.localize)(49,null,s):s===1?d?(0,I.localize)(50,null,s):(0,I.localize)(51,null,s):d?(0,I.localize)(52,null,s):(0,I.localize)(53,null,s))}function T(u,w){const d=Math.abs(u/1e3);return d<1?w?(0,I.localize)(54,null,u):(0,I.localize)(55,null,u):d<N?w?(0,I.localize)(56,null,Math.round(u)/1e3):(0,I.localize)(57,null,Math.round(u)/1e3):d<R?w?(0,I.localize)(58,null,Math.round(u/(1e3*N))):(0,I.localize)(59,null,Math.round(u/(1e3*N))):d<F?w?(0,I.localize)(60,null,Math.round(u/(1e3*R))):(0,I.localize)(61,null,Math.round(u/(1e3*R))):(0,I.localize)(62,null,Math.round(u/(1e3*F)))}function k(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Re[142],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Re[42],Ae([1,0,18,17,142]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=g,e.$cj=E,e.$dj=T;function F(k,u){return u&&(k.stack||k.stacktrace)?R.localize(0,null,m(k),M(k.stack)||M(k.stacktrace)):m(k)}function M(k){return Array.isArray(k)?k.join(`
`):k}function m(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?R.localize(1,null,k.message):k.message||R.localize(2,null)}function g(k=null,u=!1){if(!k)return R.localize(3,null);if(Array.isArray(k)){const w=I.$Hb(k),d=g(w[0],u);return w.length>1?R.localize(4,null,d,w.length):d}if(N.$4f(k))return k;if(k.detail){const w=k.detail;if(w.error)return F(w.error,u);if(w.exception)return F(w.exception,u)}return k.stack?F(k,u):k.message?k.message:R.localize(5,null)}function E(k){const u=k;return u instanceof Error&&Array.isArray(u.actions)}function T(k,u){let w;return typeof k=="string"?w=new Error(k):w=k,w.actions=u,w}}),define(Re[143],Ae([1,0,40,19]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=m,e.$_q=g,e.$ar=E,e.$br=T,e.$cr=k,e.$dr=u,e.$er=w,e.$fr=d,e.$gr=n,e.$hr=o,e.$ir=v,e.$jr=p,e.$kr=l;const R=new I.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),F=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(D,f,S=!1){const y=D||"",C=f||"",P=R.value.collator.compare(y,C);return R.value.collatorIsNumeric&&P===0&&y!==C?y<C?-1:1:P}function g(D,f){const S=F.value.collator;return D=D||"",f=f||"",a(S,D,f)}function E(D,f){const S=F.value.collator;return D=D||"",f=f||"",c(D,f)||a(S,D,f)}function T(D,f){const S=F.value.collator;return D=D||"",f=f||"",b(D,f)||a(S,D,f)}function k(D,f){return D=D||"",f=f||"",D===f?0:D<f?-1:1}function u(D,f){const[S,y]=r(D),[C,P]=r(f);let V=R.value.collator.compare(y,P);if(V===0){if(R.value.collatorIsNumeric&&y!==P)return y<P?-1:1;if(V=R.value.collator.compare(S,C),R.value.collatorIsNumeric&&V===0&&S!==C)return S<C?-1:1}return V}function w(D,f){D=D||"",f=f||"";const S=i(D),y=i(f),C=F.value.collator,P=M.value.collator;return a(P,S,y)||a(C,D,f)}function d(D,f){D=D||"",f=f||"";const S=i(D),y=i(f),C=F.value.collator,P=M.value.collator;return a(P,S,y)||c(D,f)||a(C,D,f)}function n(D,f){D=D||"",f=f||"";const S=i(D),y=i(f),C=F.value.collator,P=M.value.collator;return a(P,S,y)||b(D,f)||a(C,D,f)}function o(D,f){D=D||"",f=f||"";const S=i(D).toLowerCase(),y=i(f).toLowerCase();return S!==y?S<y?-1:1:D!==f?D<f?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function r(D,f=!1){const S=D?s.exec(D):[];let y=[S&&S[1]||"",S&&S[3]||""];return f&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(D){const f=D?s.exec(D):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function a(D,f,S){const y=D.compare(f,S);return y!==0?y:f.length!==S.length?f.length<S.length?-1:1:0}function h(D){const f=D.charAt(0);return f.toLocaleUpperCase()!==f}function t(D){const f=D.charAt(0);return f.toLocaleLowerCase()!==f}function b(D,f){return h(D)&&t(f)?-1:t(D)&&h(f)?1:0}function c(D,f){return t(D)&&h(f)?-1:h(D)&&t(f)?1:0}function $(D,f,S=!1){return S||(D=D&&D.toLowerCase(),f=f&&f.toLowerCase()),D===f?0:D<f?-1:1}function v(D,f,S=!1){const y=D.split(N.sep),C=f.split(N.sep),P=y.length-1,V=C.length-1;let W,q;for(let A=0;;A++){if(W=P===A,q=V===A,W&&q)return m(y[A],C[A],S);if(W)return-1;if(q)return 1;const j=$(y[A],C[A],S);if(j!==0)return j}}function p(D,f,S){const y=D.toLowerCase(),C=f.toLowerCase(),P=l(D,f,S);if(P)return P;const V=y.endsWith(S),W=C.endsWith(S);if(V!==W)return V?-1:1;const q=m(y,C);return q!==0?q:y.localeCompare(C)}function l(D,f,S){const y=D.toLowerCase(),C=f.toLowerCase(),P=y.startsWith(S),V=C.startsWith(S);if(P!==V)return P?-1:1;if(P&&V){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}}),define(Re[47],Ae([1,0,19,21,15,17]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=M,e.$kg=m,e.$lg=g,e.$mg=E,e.$ng=T,e.$og=d,e.$pg=n,e.$qg=o,e.$rg=s,e.$sg=r,e.$tg=i,e.$ug=a,e.$vg=h,e.$wg=t,e.$xg=b,e.$yg=v;function M(p){return p===47||p===92}function m(p){return p.replace(/[\\/]/g,I.$hc.sep)}function g(p){return p.indexOf("/")===-1&&(p=m(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}function E(p,l=I.$hc.sep){if(!p)return"";const D=p.length,f=p.charCodeAt(0);if(M(f)){if(M(p.charCodeAt(1))&&!M(p.charCodeAt(2))){let y=3;const C=y;for(;y<D&&!M(p.charCodeAt(y));y++);if(C!==y&&!M(p.charCodeAt(y+1))){for(y+=1;y<D;y++)if(M(p.charCodeAt(y)))return p.slice(0,y+1).replace(/[\\/]/g,l)}}return l}else if(s(f)&&p.charCodeAt(1)===58)return M(p.charCodeAt(2))?p.slice(0,2)+l:p.slice(0,2);let S=p.indexOf("://");if(S!==-1){for(S+=3;S<D;S++)if(M(p.charCodeAt(S)))return p.slice(0,S+1)}return""}function T(p){if(!N.$i||!p||p.length<5)return!1;let l=p.charCodeAt(0);if(l!==92||(l=p.charCodeAt(1),l!==92))return!1;let D=2;const f=D;for(;D<p.length&&(l=p.charCodeAt(D),l!==92);D++);return!(f===D||(l=p.charCodeAt(D+1),isNaN(l)||l===92))}const k=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(p,l=N.$i){const D=l?k:u;return!(!p||p.length===0||/^\s+$/.test(p)||(D.lastIndex=0,D.test(p))||l&&w.test(p)||p==="."||p===".."||l&&p[p.length-1]==="."||l&&p.length!==p.trim().length||p.length>255)}function n(p,l,D){const f=p===l;return!D||f?f:!p||!l?!1:(0,R.$tf)(p,l)}function o(p,l,D,f=I.sep){if(p===l)return!0;if(!p||!l||l.length>p.length)return!1;if(D){if(!(0,R.$uf)(p,l))return!1;if(l.length===p.length)return!0;let y=l.length;return l.charAt(l.length-1)===f&&y--,p.charAt(y)===f}return l.charAt(l.length-1)!==f&&(l+=f),p.indexOf(l)===0}function s(p){return p>=65&&p<=90||p>=97&&p<=122}function r(p,l){return N.$i&&p.endsWith(":")&&(p+=I.sep),(0,I.$jc)(p)||(p=(0,I.$kc)(l,p)),p=(0,I.$ic)(p),N.$i?(p=(0,R.$bf)(p,I.sep),p.endsWith(":")&&(p+=I.sep)):(p=(0,R.$bf)(p,I.sep),p||(p=I.sep)),p}function i(p){const l=(0,I.$ic)(p);return N.$i?p.length>3?!1:a(l)&&(p.length===2||l.charCodeAt(2)===92):l===I.$hc.sep}function a(p,l=N.$i){return l?s(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}function h(p,l=N.$i){return a(p,l)?p[0]:void 0}function t(p,l,D){return l.length>p.length?-1:p===l?0:(D&&(p=p.toLowerCase(),l=l.toLowerCase()),p.indexOf(l))}function b(p){const l=p.split(":");let D,f,S;for(const y of l){const C=Number(y);(0,F.$8f)(C)?f===void 0?f=C:S===void 0&&(S=C):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:f!==void 0?f:void 0,column:S!==void 0?S:f!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",$="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(p,l,D=8){let f="";for(let y=0;y<D;y++){let C;y===0&&N.$i&&!l&&(D===3||D===4)?C=$:C=c,f+=C.charAt(Math.floor(Math.random()*C.length))}let S;return l?S=`${l}-${f}`:S=f,p?(0,I.$kc)(p,S):S}}),define(Re[69],Ae([1,0,19]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Is=F,e.$Js=M,e.$Ks=m,e.$Ls=E,e.$Hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(T){const k=(0,I.$pc)(T),u=N[k.toLowerCase()];return u!==void 0?u:M(T)}function M(T){const k=(0,I.$pc)(T);return R[k.toLowerCase()]}function m(T){for(const k in R)if(R[k]===T)return k}const g=/^(.+)\/(.+?)(;.+)?$/;function E(T,k){const u=g.exec(T);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:k?void 0:T}}),define(Re[53],Ae([1,0,22,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=R,e.$Yh=F,e.$Zh=m;function R(g){return JSON.stringify(g,M)}function F(g){let E=JSON.parse(g);return E=m(E),E}function M(g,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function m(g,E=0){if(!g||E>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return N.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof I.$Ce||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let T=0;T<g.length;++T)g[T]=m(g[T],E+1);else for(const T in g)Object.hasOwnProperty.call(g,T)&&(g[T]=m(g[T],E+1))}return g}}),define(Re[12],Ae([1,0,14,21,15,2,19]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Dg=e.$Cg=e.$Bg=e.Schemas=void 0,e.$zg=g,e.$Ag=E,e.$Eg=k;var m;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(m||(e.Schemas=m={}));function g(d,n){return F.URI.isUri(d)?(0,R.$tf)(d.scheme,n):(0,R.$uf)(d,n+":")}function E(d,...n){return n.some(o=>g(d,o))}e.$Bg="vscode-tkn",e.$Cg="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,o){this.f=k(n,o)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,m.vscodeRemoteResource)}set(n,o,s){this.a[n]=o,this.b[n]=s}setConnectionToken(n,o){this.c[n]=o}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(h){return I.$1(h),n}const o=n.authority;let s=this.a[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const r=this.b[o],i=this.c[o];let a=`path=${encodeURIComponent(n.path)}`;return typeof i=="string"&&(a+=`&${e.$Cg}=${encodeURIComponent(i)}`),F.URI.from({scheme:N.$o?this.d:m.vscodeRemoteResource,authority:`${s}:${r}`,path:this.g,query:a})}}e.$Dg=new T;function k(d,n){return M.$hc.join(n??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Fg="vs/../../extensions",e.$Gg="vs/../../node_modules",e.$Hg="vs/../../node_modules.asar",e.$Ig="vs/../../node_modules.asar.unpacked",e.$Jg="vscode-app";class u{static{this.a=e.$Jg}asBrowserUri(n){const o=this.b(n,ge);return this.uriToBrowserUri(o)}uriToBrowserUri(n){return n.scheme===m.vscodeRemote?e.$Dg.rewrite(n):n.scheme===m.file&&(N.$m||N.$q===`${m.vscodeFileResource}://${u.a}`)?n.with({scheme:m.vscodeFileResource,authority:n.authority||u.a,query:null,fragment:null}):n}asFileUri(n){const o=this.b(n,ge);return this.uriToFileUri(o)}uriToFileUri(n){return n.scheme===m.vscodeFileResource?n.with({scheme:m.file,authority:n.authority!==u.a?n.authority:null,query:null,fragment:null}):n}b(n,o){return F.URI.isUri(n)?n:F.URI.parse(o.toUrl(n))}}e.$Kg=new u;var w;(function(d){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(n.get("3"));const o="vscode-coi";function s(i){let a;typeof i=="string"?a=new URL(i).searchParams:i instanceof URL?a=i.searchParams:F.URI.isUri(i)&&(a=new URL(i.toString(!0)).searchParams);const h=a?.get(o);if(h)return n.get(h)}d.getHeadersFromQuery=s;function r(i,a,h){if(!globalThis.crossOriginIsolated)return;const t=a&&h?"3":h?"2":"1";i instanceof URLSearchParams?i.set(o,t):i[o]=t}d.addSearchParam=r})(w||(e.COI=w={}))}),define(Re[23],Ae([1,0,47,12,19,21,15,2]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0,e.$Rg=g,e.$ah=T,e.$bh=u;function g(w){return(0,m.$xc)(w,!0)}class E{constructor(d){this.a=d}compare(d,n,o=!1){return d===n?0:(0,M.$mf)(this.getComparisonKey(d,o),this.getComparisonKey(n,o))}isEqual(d,n,o=!1){return d===n?!0:!d||!n?!1:this.getComparisonKey(d,o)===this.getComparisonKey(n,o)}getComparisonKey(d,n=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,n,o=!1){if(d.scheme===n.scheme){if(d.scheme===N.Schemas.file)return I.$qg(g(d),g(n),this.a(d))&&d.query===n.query&&(o||d.fragment===n.fragment);if((0,e.$9g)(d.authority,n.authority))return I.$qg(d.path,n.path,this.a(d),"/")&&d.query===n.query&&(o||d.fragment===n.fragment)}return!1}joinPath(d,...n){return m.URI.joinPath(d,...n)}basenameOrAuthority(d){return(0,e.$1g)(d)||d.authority}basename(d){return R.$hc.basename(d.path)}extname(d){return R.$hc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let n;return d.scheme===N.Schemas.file?n=m.URI.file(R.$nc(g(d))).path:(n=R.$hc.dirname(d.path),d.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),n="/")),d.with({path:n})}normalizePath(d){if(!d.path.length)return d;let n;return d.scheme===N.Schemas.file?n=m.URI.file(R.$ic(g(d))).path:n=R.$hc.normalize(d.path),d.with({path:n})}relativePath(d,n){if(d.scheme!==n.scheme||!(0,e.$9g)(d.authority,n.authority))return;if(d.scheme===N.Schemas.file){const r=R.$mc(g(d),g(n));return F.$i?I.$kg(r):r}let o=d.path||"/";const s=n.path||"/";if(this.a(d)){let r=0;for(const i=Math.min(o.length,s.length);r<i&&!(o.charCodeAt(r)!==s.charCodeAt(r)&&o.charAt(r).toLowerCase()!==s.charAt(r).toLowerCase());r++);o=s.substr(0,r)+o.substr(r)}return R.$hc.relative(o,s)}resolvePath(d,n){if(d.scheme===N.Schemas.file){const o=m.URI.file(R.$lc(g(d),n));return d.with({authority:o.authority,path:o.path})}return n=I.$lg(n),d.with({path:R.$hc.resolve(d.path,n)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,n){return d===n||d!==void 0&&n!==void 0&&(0,M.$tf)(d,n)}hasTrailingPathSeparator(d,n=R.sep){if(d.scheme===N.Schemas.file){const o=g(d);return o.length>I.$mg(o).length&&o[o.length-1]===n}else{const o=d.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,n=R.sep){return(0,e.$0g)(d,n)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,n=R.sep){let o=!1;if(d.scheme===N.Schemas.file){const s=g(d);o=s!==void 0&&s.length===I.$mg(s).length&&s[s.length-1]===n}else{n="/";const s=d.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.$0g)(d,n)?d.with({path:d.path+"/"}):d}}e.$Sg=E,e.$Tg=new E(()=>!1),e.$Ug=new E(w=>w.scheme===N.Schemas.file?!F.$k:!0),e.$Vg=new E(w=>!0),e.$Wg=e.$Tg.isEqual.bind(e.$Tg),e.$Xg=e.$Tg.isEqualOrParent.bind(e.$Tg),e.$Yg=e.$Tg.getComparisonKey.bind(e.$Tg),e.$Zg=e.$Tg.basenameOrAuthority.bind(e.$Tg),e.$1g=e.$Tg.basename.bind(e.$Tg),e.$2g=e.$Tg.extname.bind(e.$Tg),e.$3g=e.$Tg.dirname.bind(e.$Tg),e.$4g=e.$Tg.joinPath.bind(e.$Tg),e.$5g=e.$Tg.normalizePath.bind(e.$Tg),e.$6g=e.$Tg.relativePath.bind(e.$Tg),e.$7g=e.$Tg.resolvePath.bind(e.$Tg),e.$8g=e.$Tg.isAbsolutePath.bind(e.$Tg),e.$9g=e.$Tg.isEqualAuthority.bind(e.$Tg),e.$0g=e.$Tg.hasTrailingPathSeparator.bind(e.$Tg),e.$$g=e.$Tg.removeTrailingPathSeparator.bind(e.$Tg),e.$_g=e.$Tg.addTrailingPathSeparator.bind(e.$Tg);function T(w,d){const n=[];for(let o=0;o<w.length;o++){const s=d(w[o]);w.some((r,i)=>i===o?!1:(0,e.$Xg)(s,d(r)))||n.push(w[o])}return n}var k;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function d(n){const o=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(i=>{const[a,h]=i.split(":");a&&h&&o.set(a,h)});const r=n.path.substring(0,n.path.indexOf(";"));return r&&o.set(w.META_DATA_MIME,r),o}w.parseMetaData=d})(k||(e.DataUri=k={}));function u(w,d,n){if(d){let o=w.path;return o&&o[0]!==R.$hc.sep&&(o=R.$hc.sep+o),w.with({scheme:n,authority:d,path:o})}return w.with({scheme:n})}}),define(Re[11],Ae([1,0,24,14,5,6,23,21,130,40]),function(ge,e,I,N,R,F,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.Promises=e.$Nh=e.$Mh=e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0,e.$ch=T,e.$dh=k,e.$eh=u,e.$fh=w,e.$gh=d,e.$hh=n,e.$ih=o,e.$jh=s,e.$rh=p,e.$sh=l,e.$th=D,e.$uh=f,e.$vh=S,e.$Kh=Ie,e.$Sh=Ee;function T(fe){return!!fe&&typeof fe.then=="function"}function k(fe){const Q=new I.$me,Y=fe(Q.token),le=new Promise((de,Te)=>{const he=Q.token.onCancellationRequested(()=>{he.dispose(),Te(new N.$5)});Promise.resolve(Y).then(Ce=>{he.dispose(),Q.dispose(),de(Ce)},Ce=>{he.dispose(),Q.dispose(),Te(Ce)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(de,Te){return le.then(de,Te)}catch(de){return this.then(void 0,de)}finally(de){return le.finally(de)}}}function u(fe,Q,Y){return new Promise((le,de)=>{const Te=Q.onCancellationRequested(()=>{Te.dispose(),le(Y)});fe.then(le,de).finally(()=>Te.dispose())})}function w(fe,Q){return new Promise((Y,le)=>{const de=Q.onCancellationRequested(()=>{de.dispose(),le(new N.$5)});fe.then(Y,le).finally(()=>de.dispose())})}async function d(fe){let Q=-1;const Y=fe.map((le,de)=>le.then(Te=>(Q=de,Te)));try{return await Promise.race(Y)}finally{fe.forEach((le,de)=>{de!==Q&&le.cancel()})}}function n(fe,Q,Y){let le;const de=setTimeout(()=>{le?.(void 0),Y?.()},Q);return Promise.race([fe.finally(()=>clearTimeout(de)),new Promise(Te=>le=Te)])}function o(fe){return new Promise((Q,Y)=>{const le=fe();T(le)?le.then(Q,Y):Q(le)})}function s(){let fe,Q;return{promise:new Promise((le,de)=>{fe=le,Q=de}),resolve:fe,reject:Q}}class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const Y=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(Y,Y).then(le)})}return new Promise((Y,le)=>{this.b.then(Y,le)})}return this.a=Q(),new Promise((Y,le)=>{this.a.then(de=>{this.a=null,Y(de)},de=>{this.a=null,le(de)})})}dispose(){this.f=!0}}e.$kh=r;class i{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$lh=i;class a{constructor(){this.a=new Map}queue(Q,Y){const de=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(Q)===de&&this.a.delete(Q)});return this.a.set(Q,de),de}}e.$mh=a;const h=(fe,Q)=>{let Y=!0;const le=setTimeout(()=>{Y=!1,Q()},fe);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(le),Y=!1}}},t=fe=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,fe())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class b{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,Y=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((de,Te)=>{this.d=de,this.f=Te}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=Y===g.$$d?t(le):h(Y,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$nh=b;class c{constructor(Q){this.a=new b(Q),this.b=new r}trigger(Q,Y){return this.a.trigger(()=>this.b.queue(Q),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$oh=c;class ${constructor(){this.a=!1,this.b=new Promise((Q,Y)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ph=$;class v extends ${constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$qh=v;function p(fe,Q){return Q?new Promise((Y,le)=>{const de=setTimeout(()=>{Te.dispose(),Y()},fe),Te=Q.onCancellationRequested(()=>{clearTimeout(de),Te.dispose(),le(new N.$5)})}):k(Y=>p(fe,Y))}function l(fe,Q=0,Y){const le=setTimeout(()=>{fe(),Y&&de.dispose()},Q),de=(0,F.$Sc)(()=>{clearTimeout(le),Y?.deleteAndLeak(de)});return Y?.add(de),de}function D(fe){const Q=[];let Y=0;const le=fe.length;function de(){return Y<le?fe[Y++]():null}function Te(he){he!=null&&Q.push(he);const Ce=de();return Ce?Ce.then(Te):Promise.resolve(Q)}return Promise.resolve(null).then(Te)}function f(fe,Q=le=>!!le,Y=null){let le=0;const de=fe.length,Te=()=>{if(le>=de)return Promise.resolve(Y);const he=fe[le++];return Promise.resolve(he()).then(Me=>Q(Me)?Promise.resolve(Me):Te())};return Te()}function S(fe,Q=le=>!!le,Y=null){if(fe.length===0)return Promise.resolve(Y);let le=fe.length;const de=()=>{le=-1;for(const Te of fe)Te.cancel?.()};return new Promise((Te,he)=>{for(const Ce of fe)Ce.then(Me=>{--le>=0&&Q(Me)?(de(),Te(Me)):le===0&&Te(Y)}).catch(Me=>{--le>=0&&(de(),he(Me))})})}class y{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new R.$be}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,le)=>{this.g.push({factory:Q,c:Y,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const Y=Q.factory();Y.then(Q.c,Q.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$wh=y;class C extends y{constructor(){super(1)}}e.$xh=C;class P{constructor(){this.a=new ue,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$yh=P;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new Se;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,Y=M.$Tg){const le=Y.getComparisonKey(Q);return this.a.get(le)?.size??0}queueFor(Q,Y,le=M.$Tg){const de=le.getComparisonKey(Q);let Te=this.a.get(de);if(!Te){Te=new C;const he=this.f++,Ce=R.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(he),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$4c),this.d.set(he,Ce),this.a.set(de,Te)}return Te.queue(Y)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$zh=V;class W{constructor(Q,Y){this.a=-1,typeof Q=="function"&&typeof Y=="number"&&this.setIfNotSet(Q,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},Y)}setIfNotSet(Q,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},Y))}}e.$Ah=W;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,Y,le=globalThis){this.cancel();const de=le.setInterval(()=>{Q()},Y);this.d=(0,F.$Sc)(()=>{le.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$Bh=q;class A{constructor(Q,Y){this.b=-1,this.a=Q,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ch=A;class j{constructor(Q,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=Q,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dh=j;class K extends A{constructor(Q,Y){super(Q,Y),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Eh=K;class ie extends F.$Uc{constructor(Q,Y){super(),this.g=Q,this.h=Y,this.a=[],this.b=this.B(new F.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of Q)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new A(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fh=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Hh=(fe,Q)=>{(0,m.$B)(()=>{if(Y)return;const le=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Hh=(fe,Q,Y)=>{const le=fe.requestIdleCallback(Q,typeof Y=="number"?{timeout:Y}:void 0);let de=!1;return{dispose(){de||(de=!0,fe.cancelIdleCallback(le))}}},e.$Gh=fe=>(0,e.$Hh)(globalThis,fe)}();class ce{constructor(Q,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$Hh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ih=ce;class ve extends ce{constructor(Q){super(globalThis,Q)}}e.$Jh=ve;async function Ie(fe,Q,Y){let le;for(let de=0;de<Y;de++)try{return await fe()}catch(Te){le=Te,await p(Q)}throw le}class ue{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,Y,le){return this.a={taskId:Q,cancel:()=>le?.(),promise:Y},Y.then(()=>this.d(Q),()=>this.d(Q)),Y}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:Y,resolve:le,reject:de}=s();this.b={run:Q,promise:Y,promiseResolve:le,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lh=ue;class pe{constructor(Q,Y=()=>Date.now()){this.d=Q,this.f=Y,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Mh=pe;var re;(function(fe){fe[fe.Resolved=0]="Resolved",fe[fe.Rejected=1]="Rejected"})(re||(re={}));class Se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,Y)=>{this.a=Q,this.b=Y})}complete(Q){return new Promise(Y=>{this.a(Q),this.d={outcome:0,value:Q},Y()})}error(Q){return new Promise(Y=>{this.b(Q),this.d={outcome:1,value:Q},Y()})}cancel(){return this.error(new N.$5)}}e.$Nh=Se;var Le;(function(fe){async function Q(le){let de;const Te=await Promise.all(le.map(he=>he.then(Ce=>Ce,Ce=>{de||(de=Ce)})));if(typeof de<"u")throw de;return Te}fe.settled=Q;function Y(le){return new Promise(async(de,Te)=>{try{await le(de,Te)}catch(he){Te(he)}})}fe.withAsyncBody=Y})(Le||(e.Promises=Le={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Oh=ne;class U{constructor(Q){this.b=Q,this.a=new E.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Ph=U;var x;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(x||(x={}));class be{static fromArray(Q){return new be(Y=>{Y.emitMany(Q)})}static fromPromise(Q){return new be(async Y=>{Y.emitMany(await Q)})}static fromPromises(Q){return new be(async Y=>{await Promise.all(Q.map(async le=>Y.emitOne(await le)))})}static merge(Q){return new be(async Y=>{await Promise.all(Q.map(async le=>{for await(const de of le)Y.emitOne(de)}))})}static{this.EMPTY=be.fromArray([])}constructor(Q){this.a=0,this.b=[],this.d=null,this.f=new R.$be,queueMicrotask(async()=>{const Y={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(Q(Y)),this.j()}catch(le){this.k(le)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.f.event)}while(!0)}}}static map(Q,Y){return new be(async le=>{for await(const de of Q)le.emitOne(Y(de))})}map(Q){return be.map(this,Q)}static filter(Q,Y){return new be(async le=>{for await(const de of Q)Y(de)&&le.emitOne(de)})}filter(Q){return be.filter(this,Q)}static coalesce(Q){return be.filter(Q,Y=>!!Y)}coalesce(){return be.coalesce(this)}static async toPromise(Q){const Y=[];for await(const le of Q)Y.push(le);return Y}toPromise(){return be.toPromise(this)}g(Q){this.a===0&&(this.b.push(Q),this.f.fire())}h(Q){this.a===0&&(this.b=this.b.concat(Q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Q){this.a===0&&(this.a=2,this.d=Q,this.f.fire())}}e.$Qh=be;class Ne extends be{constructor(Q,Y){super(Y),this.l=Q}cancel(){this.l.cancel()}}e.$Rh=Ne;function Ee(fe){const Q=new I.$me,Y=fe(Q.token);return new Ne(Q,async le=>{const de=Q.token.onCancellationRequested(()=>{de.dispose(),Q.dispose(),le.reject(new N.$5)});try{for await(const Te of Y){if(Q.token.isCancellationRequested)return;le.emitOne(Te)}de.dispose(),Q.dispose()}catch(Te){de.dispose(),Q.dispose(),le.reject(Te)}})}class $e{constructor(){this.a=new Se,this.b=new be(le=>{if(Q){le.reject(Q);return}return Y&&le.emitMany(Y),this.d=de=>le.reject(de),this.f=de=>le.emitOne(de),this.a.p});let Q,Y;this.f=le=>{Y||(Y=[]),Y.push(le)},this.d=le=>{Q||(Q=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$Th=$e}),define(Re[36],Ae([1,0,18,11,47,28,19,21,15]),function(ge,e,I,N,R,F,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=void 0,e.$fk=E,e.$ik=d,e.$jk=C,e.$kk=P,e.$lk=V,e.$mk=W,e.$nk=q,e.$ok=ie;function E(){return Object.create(null)}e.$gk="**",e.$hk="/";const T="[/\\\\]",k="[^/\\\\]",u=/\//g;function w(ce,ve){switch(ce){case 0:return"";case 1:return`${k}*?`;default:return`(?:${T}|${k}+${T}${ve?`|${T}${k}+`:""})*?`}}function d(ce,ve){if(!ce)return[];const Ie=[];let ue=!1,pe=!1,re="";for(const Se of ce){switch(Se){case ve:if(!ue&&!pe){Ie.push(re),re="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}re+=Se}return re&&Ie.push(re),Ie}function n(ce){if(!ce)return"";let ve="";const Ie=d(ce,e.$hk);if(Ie.every(ue=>ue===e.$gk))ve=".*";else{let ue=!1;Ie.forEach((pe,re)=>{if(pe===e.$gk){if(ue)return;ve+=w(2,re===Ie.length-1)}else{let Se=!1,Le="",ne=!1,U="";for(const x of pe){if(x!=="}"&&Se){Le+=x;continue}if(ne&&(x!=="]"||!U)){let be;x==="-"?be=x:(x==="^"||x==="!")&&!U?be="^":x===e.$hk?be="":be=(0,g.$8e)(x),U+=be;continue}switch(x){case"{":Se=!0;continue;case"[":ne=!0;continue;case"}":{const Ne=`(?:${d(Le,",").map(Ee=>n(Ee)).join("|")})`;ve+=Ne,Se=!1,Le="";break}case"]":{ve+="["+U+"]",ne=!1,U="";break}case"?":ve+=k;continue;case"*":ve+=w(1);continue;default:ve+=(0,g.$8e)(x)}}re<Ie.length-1&&(Ie[re+1]!==e.$gk||re+2<Ie.length)&&(ve+=T)}ue=pe===e.$gk})}return ve}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new F.$Ec(1e4),b=function(){return!1},c=function(){return null};function $(ce,ve){if(!ce)return c;let Ie;typeof ce!="string"?Ie=ce.pattern:Ie=ce,Ie=Ie.trim();const ue=`${Ie}_${!!ve.trimForExclusions}`;let pe=t.get(ue);if(pe)return v(pe,ce);let re;return o.test(Ie)?pe=l(Ie.substr(4),Ie):(re=s.exec(p(Ie,ve)))?pe=D(re[1],Ie):(ve.trimForExclusions?i:r).test(Ie)?pe=f(Ie,ve):(re=a.exec(p(Ie,ve)))?pe=S(re[1].substr(1),Ie,!0):(re=h.exec(p(Ie,ve)))?pe=S(re[1],Ie,!1):pe=y(Ie),t.set(ue,pe),v(pe,ce)}function v(ce,ve){if(typeof ve=="string")return ce;const Ie=function(ue,pe){return(0,R.$qg)(ue,ve.base,!m.$k)?ce((0,g.$af)(ue.substr(ve.base.length),M.sep),pe):null};return Ie.allBasenames=ce.allBasenames,Ie.allPaths=ce.allPaths,Ie.basenames=ce.basenames,Ie.patterns=ce.patterns,Ie}function p(ce,ve){return ve.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function l(ce,ve){return function(Ie,ue){return typeof Ie=="string"&&Ie.endsWith(ce)?ve:null}}function D(ce,ve){const Ie=`/${ce}`,ue=`\\${ce}`,pe=function(Se,Le){return typeof Se!="string"?null:Le?Le===ce?ve:null:Se===ce||Se.endsWith(Ie)||Se.endsWith(ue)?ve:null},re=[ce];return pe.basenames=re,pe.patterns=[ve],pe.allBasenames=re,pe}function f(ce,ve){const Ie=K(ce.slice(1,-1).split(",").map(Le=>$(Le,ve)).filter(Le=>Le!==c),ce),ue=Ie.length;if(!ue)return c;if(ue===1)return Ie[0];const pe=function(Le,ne){for(let U=0,x=Ie.length;U<x;U++)if(Ie[U](Le,ne))return ce;return null},re=Ie.find(Le=>!!Le.allBasenames);re&&(pe.allBasenames=re.allBasenames);const Se=Ie.reduce((Le,ne)=>ne.allPaths?Le.concat(ne.allPaths):Le,[]);return Se.length&&(pe.allPaths=Se),pe}function S(ce,ve,Ie){const ue=M.sep===M.$hc.sep,pe=ue?ce:ce.replace(u,M.sep),re=M.sep+pe,Se=M.$hc.sep+ce;let Le;return Ie?Le=function(ne,U){return typeof ne=="string"&&(ne===pe||ne.endsWith(re)||!ue&&(ne===ce||ne.endsWith(Se)))?ve:null}:Le=function(ne,U){return typeof ne=="string"&&(ne===pe||!ue&&ne===ce)?ve:null},Le.allPaths=[(Ie?"*/":"./")+ce],Le}function y(ce){try{const ve=new RegExp(`^${n(ce)}$`);return function(Ie){return ve.lastIndex=0,typeof Ie=="string"&&ve.test(Ie)?ce:null}}catch{return c}}function C(ce,ve,Ie){return!ce||typeof ve!="string"?!1:P(ce)(ve,void 0,Ie)}function P(ce,ve={}){if(!ce)return b;if(typeof ce=="string"||V(ce)){const Ie=$(ce,ve);if(Ie===c)return b;const ue=function(pe,re){return!!Ie(pe,re)};return Ie.allBasenames&&(ue.allBasenames=Ie.allBasenames),Ie.allPaths&&(ue.allPaths=Ie.allPaths),ue}return A(ce,ve)}function V(ce){const ve=ce;return ve?typeof ve.base=="string"&&typeof ve.pattern=="string":!1}function W(ce){return ce.allBasenames||[]}function q(ce){return ce.allPaths||[]}function A(ce,ve){const Ie=K(Object.getOwnPropertyNames(ce).map(Le=>j(Le,ce[Le],ve)).filter(Le=>Le!==c)),ue=Ie.length;if(!ue)return c;if(!Ie.some(Le=>!!Le.requiresSiblings)){if(ue===1)return Ie[0];const Le=function(x,be){let Ne;for(let Ee=0,$e=Ie.length;Ee<$e;Ee++){const fe=Ie[Ee](x,be);if(typeof fe=="string")return fe;(0,N.$ch)(fe)&&(Ne||(Ne=[]),Ne.push(fe))}return Ne?(async()=>{for(const Ee of Ne){const $e=await Ee;if(typeof $e=="string")return $e}return null})():null},ne=Ie.find(x=>!!x.allBasenames);ne&&(Le.allBasenames=ne.allBasenames);const U=Ie.reduce((x,be)=>be.allPaths?x.concat(be.allPaths):x,[]);return U.length&&(Le.allPaths=U),Le}const pe=function(Le,ne,U){let x,be;for(let Ne=0,Ee=Ie.length;Ne<Ee;Ne++){const $e=Ie[Ne];$e.requiresSiblings&&U&&(ne||(ne=(0,M.$oc)(Le)),x||(x=ne.substr(0,ne.length-(0,M.$pc)(Le).length)));const fe=$e(Le,ne,x,U);if(typeof fe=="string")return fe;(0,N.$ch)(fe)&&(be||(be=[]),be.push(fe))}return be?(async()=>{for(const Ne of be){const Ee=await Ne;if(typeof Ee=="string")return Ee}return null})():null},re=Ie.find(Le=>!!Le.allBasenames);re&&(pe.allBasenames=re.allBasenames);const Se=Ie.reduce((Le,ne)=>ne.allPaths?Le.concat(ne.allPaths):Le,[]);return Se.length&&(pe.allPaths=Se),pe}function j(ce,ve,Ie){if(ve===!1)return c;const ue=$(ce,Ie);if(ue===c)return c;if(typeof ve=="boolean")return ue;if(ve){const pe=ve.when;if(typeof pe=="string"){const re=(Se,Le,ne,U)=>{if(!U||!ue(Se,Le))return null;const x=pe.replace("$(basename)",()=>ne),be=U(x);return(0,N.$ch)(be)?be.then(Ne=>Ne?ce:null):be?ce:null};return re.requiresSiblings=!0,re}}return ue}function K(ce,ve){const Ie=ce.filter(Le=>!!Le.basenames);if(Ie.length<2)return ce;const ue=Ie.reduce((Le,ne)=>{const U=ne.basenames;return U?Le.concat(U):Le},[]);let pe;if(ve){pe=[];for(let Le=0,ne=ue.length;Le<ne;Le++)pe.push(ve)}else pe=Ie.reduce((Le,ne)=>{const U=ne.patterns;return U?Le.concat(U):Le},[]);const re=function(Le,ne){if(typeof Le!="string")return null;if(!ne){let x;for(x=Le.length;x>0;x--){const be=Le.charCodeAt(x-1);if(be===47||be===92)break}ne=Le.substr(x)}const U=ue.indexOf(ne);return U!==-1?pe[U]:null};re.basenames=ue,re.patterns=pe,re.allBasenames=ue;const Se=ce.filter(Le=>!Le.basenames);return Se.push(re),Se}function ie(ce,ve){return(0,I.$ub)(ce,ve,(Ie,ue)=>typeof Ie=="string"&&typeof ue=="string"?Ie===ue:typeof Ie!="string"&&typeof ue!="string"?Ie.base===ue.base&&Ie.pattern===ue.pattern:!1)}}),define(Re[54],Ae([1,0,14,131,23,15,2]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.MarkdownStringTextNewlineStyle=void 0,e.$Ok=E,e.$Pk=T,e.$Qk=k,e.$Rk=u,e.$Sk=w,e.$Tk=d,e.$Uk=n,e.$Vk=o;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class g{constructor(r="",i=!1){if(this.value=r,typeof this.value!="string")throw(0,I.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(r,i=0){return this.value+=u(this.supportThemeIcons?(0,N.$Hk)(r):r).replace(/([ \t]+)/g,(a,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(r){return this.value+=r,this}appendCodeblock(r,i){return this.value+=`
${w(i,r)}
`,this}appendLink(r,i,a){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(r),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(r,i){const a=new RegExp((0,F.$8e)(i),"g");return r.replace(a,(h,t)=>r.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$Nk=g;function E(s){return T(s)?!s.value:Array.isArray(s)?s.every(E):!0}function T(s){return s instanceof g?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function k(s,r){return s===r?!0:!s||!r?!1:s.value===r.value&&s.isTrusted===r.isTrusted&&s.supportThemeIcons===r.supportThemeIcons&&s.supportHtml===r.supportHtml&&(s.baseUri===r.baseUri||!!s.baseUri&&!!r.baseUri&&(0,R.$Wg)(M.URI.from(s.baseUri),M.URI.from(r.baseUri)))}function u(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w(s,r){const i=s.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,a=i>=3?i+1:3;return[`${"`".repeat(a)}${r}`,s,`${"`".repeat(a)}`].join(`
`)}function d(s){return s.replace(/"/g,"&quot;")}function n(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const r=[],i=s.split("|").map(h=>h.trim());s=i[0];const a=i[1];if(a){const h=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),b=h?h[1]:"",c=t?t[1]:"",$=isFinite(parseInt(c)),v=isFinite(parseInt(b));$&&r.push(`width="${c}"`),v&&r.push(`height="${b}"`)}return{href:s,dimensions:r}}}),define(Re[96],Ae([1,0,18,47,19,21,23,15]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ow=g,e.$pw=T,e.$qw=u,e.$rw=w,e.$sw=s,e.$tw=i,e.$uw=a,e.$vw=h,e.$ww=t,e.$xw=b;function g($,v){const{os:p,tildify:l,relative:D}=v;if(D){const y=E($,D,p);if(typeof y=="string")return y}let f=$.fsPath;if(p===1&&!F.$i?f=f.replace(/\//g,"\\"):p!==1&&F.$i&&(f=f.replace(/\\/g,"/")),p!==1&&l?.userHome){const y=l.userHome.fsPath;let C;$.scheme!==l.userHome.scheme&&$.path[0]===R.$hc.sep&&$.path[1]!==R.$hc.sep?C=l.userHome.with({path:$.path}).fsPath:C=f,f=u(C,y,p)}return(p===1?R.$gc:R.$hc).normalize(T(f,p===1))}function E($,v,p){const l=p===1?R.$gc:R.$hc,D=p===3?M.$Tg:M.$Vg,f=v.getWorkspace(),S=(0,I.$Ob)(f.folders);if(!S)return;$.scheme!==S.uri.scheme&&$.path[0]===R.$hc.sep&&$.path[1]!==R.$hc.sep&&($=S.uri.with({path:$.path}));const y=v.getWorkspaceFolder($);if(!y)return;let C;if(D.isEqual(y.uri,$)?C="":C=D.relativePath(y.uri,$)??"",C&&(C=l.normalize(C)),f.folders.length>1&&!v.noPrefix){const P=y.name?y.name:D.basenameOrAuthority(y.uri);C=C?`${P} \u2022 ${C}`:P}return C}function T($,v=F.$i){return(0,N.$ug)($,v)?$.charAt(0).toUpperCase()+$.slice(1):$}let k=Object.create(null);function u($,v,p=F.OS){if(p===1||!$||!v)return $;let l=k.original===v?k.normalized:void 0;l||(l=v,F.$i&&(l=(0,N.$kg)(l)),l=`${(0,m.$bf)(l,R.$hc.sep)}${R.$hc.sep}`,k={original:v,normalized:l});let D=$;return F.$i&&(D=(0,N.$kg)(D)),(p===3?D.startsWith(l):(0,m.$uf)(D,l))?`~/${D.substr(l.length)}`:$}function w($,v){return $.replace(/^~($|\/|\\)/,`${v}$1`)}const d="\u2026",n="\\\\",o="~";function s($,v=R.sep){const p=new Array($.length);let l=!1;for(let D=0;D<$.length;D++){const f=$[D];if(f===""){p[D]=`.${v}`;continue}if(!f){p[D]=f;continue}l=!0;let S="",y=f;y.indexOf(n)===0?(S=y.substr(0,y.indexOf(n)+n.length),y=y.substr(y.indexOf(n)+n.length)):y.indexOf(v)===0?(S=y.substr(0,y.indexOf(v)+v.length),y=y.substr(y.indexOf(v)+v.length)):y.indexOf(o)===0&&(S=y.substr(0,y.indexOf(o)+o.length),y=y.substr(y.indexOf(o)+o.length));const C=y.split(v);for(let P=1;l&&P<=C.length;P++)for(let V=C.length-P;l&&V>=0;V--){l=!1;let W=C.slice(V,V+P).join(v);for(let q=0;!l&&q<$.length;q++)if(q!==D&&$[q]&&$[q].indexOf(W)>-1){const A=V+P===C.length,j=V>0&&$[q].indexOf(v)>-1?v+W:W,K=$[q].endsWith(j);l=!A||K}if(!l){let q="";(C[0].endsWith(":")||S!=="")&&(V===1&&(V=0,P++,W=C[0]+v+W),V>0&&(q=C[0]+v),q=S+q),V>0&&(q=q+d+v),q=q+W,V+P<C.length&&(q=q+v+d),p[D]=q}}l&&(p[D]=f)}return p}var r;(function($){$[$.TEXT=0]="TEXT",$[$.VARIABLE=1]="VARIABLE",$[$.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function i($,v=Object.create(null)){const p=[];let l=!1,D="";for(const f of $)if(f==="$"||l&&f==="{")D&&p.push({value:D,type:r.TEXT}),D="",l=!0;else if(f==="}"&&l){const S=v[D];if(typeof S=="string")S.length&&p.push({value:S,type:r.VARIABLE});else if(S){const y=p[p.length-1];(!y||y.type!==r.SEPARATOR)&&p.push({value:S.label,type:r.SEPARATOR})}D="",l=!1}else D+=f;return D&&!l&&p.push({value:D,type:r.TEXT}),p.filter((f,S)=>{if(f.type===r.SEPARATOR){const y=p[S-1],C=p[S+1];return[y,C].every(P=>P&&(P.type===r.VARIABLE||P.type===r.TEXT)&&P.value.length>0)}return!0}).map(f=>f.value).join("")}function a($,v){return F.$j||v?$.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$j?"&":"&&"):$.replace(/&&|&/g,p=>p==="&"?"&&":"&")}function h($,v){return F.$j||v?$.replace(/\(&&\w\)|&&/g,""):F.$i?$.replace(/&&|&/g,p=>p==="&"?"&&":"&"):$.replace(/&&/g,"_")}function t($){return $.replace(/&/g,"&&")}function b($){if($.endsWith("]")){const v=$.lastIndexOf(" [",$.length-2);if(v!==-1){const p=c($.substring(0,v)),l=$.substring(v);return{name:p.name+l,parentPath:p.parentPath}}}return c($)}function c($){const v=$.indexOf("/")!==-1?R.$hc:R.$gc,p=v.basename($),l=v.dirname($);return p.length?{name:p,parentPath:l}:{name:l,parentPath:""}}}),define(Re[144],Ae([1,0,22,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=e.$sn=void 0,e.$un=m,e.$vn=E,e.$wn=T;function R(k){return k.toJSON()}class F{constructor(u){this.a=u}transformIncoming(u){const w=this.a.transformIncoming(u);return w===u?u:R(N.URI.from(w))}transformOutgoing(u){const w=this.a.transformOutgoing(u);return w===u?u:R(N.URI.from(w))}transformOutgoingURI(u){const w=this.a.transformOutgoing(u);return w===u?u:N.URI.from(w)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$sn=F,e.$tn=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function M(k,u,w){if(!k||w>200)return null;if(typeof k=="object"){if(k instanceof N.URI)return u.transformOutgoing(k);for(const d in k)if(Object.hasOwnProperty.call(k,d)){const n=M(k[d],u,w+1);n!==null&&(k[d]=n)}}return null}function m(k,u){const w=M(k,u,0);return w===null?k:w}function g(k,u,w,d){if(!k||d>200)return null;if(typeof k=="object"){if(k.$mid===1)return w?N.URI.revive(u.transformIncoming(k)):u.transformIncoming(k);if(k instanceof I.$Ce)return null;for(const n in k)if(Object.hasOwnProperty.call(k,n)){const o=g(k[n],u,w,d+1);o!==null&&(k[n]=o)}}return null}function E(k,u){const w=g(k,u,!1,0);return w===null?k:w}function T(k,u){const w=g(k,u,!0,0);return w===null?k:w}}),define(Re[145],Ae([1,0,15,21,22]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0,e.$tt=T,e.$ut=k;let F;function M(){return F||(F=new TextDecoder("UTF-16LE")),F}let m;function g(){return m||(m=new TextDecoder("UTF-16BE")),m}let E;function T(){return E||(E=N.$D()?M():g()),E}function k(d,n,o){const s=new Uint16Array(d.buffer,n,o);return o>0&&(s[0]===65279||s[0]===65534)?u(d,n,o):M().decode(s)}function u(d,n,o){const s=[];let r=0;for(let i=0;i<o;i++){const a=R.$Ee(d,n);n+=2,s[r++]=String.fromCharCode(a)}return s.join("")}class w{constructor(n){this.a=n|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const n=new Uint16Array(this.b.buffer,0,this.d);return T().decode(n)}f(){const n=this.e();this.d=0,this.c===null?this.c=[n]:this.c[this.c.length]=n}appendCharCode(n){const o=this.a-this.d;o<=1&&(o===0||I.$xf(n))&&this.f(),this.b[this.d++]=n}appendASCIICharCode(n){this.d===this.a&&this.f(),this.b[this.d++]=n}appendString(n){const o=n.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=n;return}for(let s=0;s<o;s++)this.b[this.d++]=n.charCodeAt(s)}}e.$vt=w}),define(Re[146],Ae([1,0,22,145]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$xt=M;function R(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class F{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,T,k,u){this.oldPosition=E,this.oldText=T,this.newPosition=k,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${R(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${R(this.oldText)}")`:`(replace@${this.oldPosition} "${R(this.oldText)}" with "${R(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,T,k){const u=T.length;I.$He(E,u,k),k+=4;for(let w=0;w<u;w++)I.$Fe(E,T.charCodeAt(w),k),k+=2;return k}static d(E,T){const k=I.$Ge(E,T);return T+=4,(0,N.$ut)(E,T,k)}writeSize(){return 8+F.a(this.oldText)+F.a(this.newText)}write(E,T){return I.$He(E,this.oldPosition,T),T+=4,I.$He(E,this.newPosition,T),T+=4,T=F.c(E,this.oldText,T),T=F.c(E,this.newText,T),T}static read(E,T,k){const u=I.$Ge(E,T);T+=4;const w=I.$Ge(E,T);T+=4;const d=F.d(E,T);T+=F.a(d);const n=F.d(E,T);return T+=F.a(n),k.push(new F(u,d,w,n)),T}}e.$wt=F;function M(g,E){return g===null||g.length===0?E:new m(g,E).compress()}class m{constructor(E,T){this.a=E,this.c=T,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,T=0,k=this.n(E),u=this.l(T);for(;E<this.f||T<this.h;){if(k===null){this.k(u),u=this.l(++T);continue}if(u===null){this.m(k),k=this.n(++E);continue}if(u.oldEnd<=k.newPosition){this.k(u),u=this.l(++T);continue}if(k.newEnd<=u.oldPosition){this.m(k),k=this.n(++E);continue}if(u.oldPosition<k.newPosition){const[s,r]=m.r(u,k.newPosition-u.oldPosition);this.k(s),u=r;continue}if(k.newPosition<u.oldPosition){const[s,r]=m.q(k,u.oldPosition-k.newPosition);this.m(s),k=r;continue}let n,o;if(u.oldEnd===k.newEnd)n=k,o=u,k=this.n(++E),u=this.l(++T);else if(u.oldEnd<k.newEnd){const[s,r]=m.q(k,u.oldLength);n=s,o=u,k=r,u=this.l(++T)}else{const[s,r]=m.r(u,k.newLength);n=k,o=s,k=this.n(++E),u=r}this.d[this.e++]=new F(n.oldPosition,n.oldText,o.newPosition,o.newText),this.g+=n.newLength-n.oldLength,this.j+=o.newLength-o.oldLength}const w=m.s(this.d);return m.t(w)}k(E){this.d[this.e++]=m.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=m.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,T){return new F(T.oldPosition-E,T.oldText,T.newPosition,T.newText)}static p(E,T){return new F(T.oldPosition,T.oldText,T.newPosition+E,T.newText)}static q(E,T){const k=E.newText.substr(0,T),u=E.newText.substr(T);return[new F(E.oldPosition,E.oldText,E.newPosition,k),new F(E.oldEnd,"",E.newPosition+T,u)]}static r(E,T){const k=E.oldText.substr(0,T),u=E.oldText.substr(T);return[new F(E.oldPosition,k,E.newPosition,E.newText),new F(E.oldPosition+T,u,E.newEnd,"")]}static s(E){if(E.length===0)return E;const T=[];let k=0,u=E[0];for(let w=1;w<E.length;w++){const d=E[w];u.oldEnd===d.oldPosition?u=new F(u.oldPosition,u.oldText+d.oldText,u.newPosition,u.newText+d.newText):(T[k++]=u,u=d)}return T[k++]=u,T}static t(E){if(E.length===0)return E;const T=[];let k=0;for(let u=0;u<E.length;u++){const w=E[u];w.oldText!==w.newText&&(T[k++]=w)}return T}}}),define(Re[147],Ae([1,0,36,19]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=R,e.$Vt=F;function R(M,m,g,E,T,k){if(Array.isArray(M)){let u=0;for(const w of M){const d=R(w,m,g,E,T,k);if(d===10)return d;d>u&&(u=d)}return u}else{if(typeof M=="string")return E?M==="*"?5:M===g?10:0:0;if(M){const{language:u,pattern:w,scheme:d,hasAccessToAllModels:n,notebookType:o}=M;if(!E&&!n)return 0;o&&T&&(m=T);let s=0;if(d)if(d===m.scheme)s=10;else if(d==="*")s=5;else return 0;if(u)if(u===g)s=10;else if(u==="*")s=Math.max(s,5);else return 0;if(o)if(o===k)s=10;else if(o==="*"&&k!==void 0)s=Math.max(s,5);else return 0;if(w){let r;if(typeof w=="string"?r=w:r={...w,base:(0,N.$ic)(w.base)},r===m.fsPath||(0,I.$jk)(r,m.fsPath))s=10;else return 0}return s}else return 0}}function F(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(F):!!M.notebookType}}),define(Re[148],Ae([1,0,5,15,29,94,92,133,146,6]),function(ge,e,I,N,R,F,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=void 0;class T extends E.$Uc{constructor(u,w,d,n,o,s,r){super(),this.m=this.B(new I.$be),this.onDidChangeContent=this.m.event,this.f=w,this.j=!s,this.g=n,this.h=o,this.c=new M.$KC(u,d,r)}equals(u){return!(u instanceof T)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,w){return this.c.getOffsetAt(u,w)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,w){const d=u+w,n=this.getPositionAt(u),o=this.getPositionAt(d);return new R.$kt(n.lineNumber,n.column,o.lineNumber,o.column)}getValueInRange(u,w=0){if(u.isEmpty())return"";const d=this.n(w);return this.c.getValueInRange(u,d)}getValueLengthInRange(u,w=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const d=this.getOffsetAt(u.startLineNumber,u.startColumn),n=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const s=this.n(w),r=this.getEOL();if(s.length!==r.length){const i=s.length-r.length,a=u.endLineNumber-u.startLineNumber;o=i*a}return n-d+o}getCharacterCountInRange(u,w=0){if(this.j){let d=0;const n=u.startLineNumber,o=u.endLineNumber;for(let s=n;s<=o;s++){const r=this.getLineContent(s),i=s===n?u.startColumn-1:0,a=s===o?u.endColumn-1:r.length;for(let h=i;h<a;h++)N.$xf(r.charCodeAt(h))?(d=d+1,h=h+1):d=d+1}return d+=this.n(w).length*(o-n),d}return this.getValueLengthInRange(u,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,w){return this.c.getLineCharCode(u,w)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const w=N.$if(this.getLineContent(u));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(u){const w=N.$kf(this.getLineContent(u));return w===-1?0:w+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,w,d){let n=this.g,o=this.h,s=this.j,r=!0,i=[];for(let v=0;v<u.length;v++){const p=u[v];r&&p._isTracked&&(r=!1);const l=p.range;if(p.text){let C=!0;s||(C=!N.$If(p.text),s=C),!n&&C&&(n=N.$Hf(p.text)),!o&&C&&(o=N.$Kf(p.text))}let D="",f=0,S=0,y=0;if(p.text){let C;[f,S,y,C]=(0,m.$Nt)(p.text);const P=this.getEOL();C===0||C===(P===`\r
`?2:1)?D=p.text:D=p.text.replace(/\r\n|\r|\n/g,P)}i[v]={sortIndex:v,identifier:p.identifier||null,range:l,rangeOffset:this.getOffsetAt(l.startLineNumber,l.startColumn),rangeLength:this.getValueLengthInRange(l),text:D,eolCount:f,firstLineLength:S,lastLineLength:y,forceMoveMarkers:!!p.forceMoveMarkers,isAutoWhitespaceEdit:p.isAutoWhitespaceEdit||!1}}i.sort(T.u);let a=!1;for(let v=0,p=i.length-1;v<p;v++){const l=i[v].range.getEndPosition(),D=i[v+1].range.getStartPosition();if(D.isBeforeOrEqual(l)){if(D.isBefore(l))throw new Error("Overlapping ranges are not allowed!");a=!0}}r&&(i=this.s(i));const h=d||w?T._getInverseEditRanges(i):[],t=[];if(w)for(let v=0;v<i.length;v++){const p=i[v],l=h[v];if(p.isAutoWhitespaceEdit&&p.range.isEmpty())for(let D=l.startLineNumber;D<=l.endLineNumber;D++){let f="";D===l.startLineNumber&&(f=this.getLineContent(p.range.startLineNumber),N.$if(f)!==-1)||t.push({lineNumber:D,oldContent:f})}}let b=null;if(d){let v=0;b=[];for(let p=0;p<i.length;p++){const l=i[p],D=h[p],f=this.getValueInRange(l.range),S=l.rangeOffset+v;v+=l.text.length-f.length,b[p]={sortIndex:l.sortIndex,identifier:l.identifier,range:D,text:f,textChange:new g.$wt(l.rangeOffset,f,S,l.text)}}a||b.sort((p,l)=>p.sortIndex-l.sortIndex)}this.g=n,this.h=o,this.j=s;const c=this.t(i);let $=null;if(w&&t.length>0){t.sort((v,p)=>p.lineNumber-v.lineNumber),$=[];for(let v=0,p=t.length;v<p;v++){const l=t[v].lineNumber;if(v>0&&t[v-1].lineNumber===l)continue;const D=t[v].oldContent,f=this.getLineContent(l);f.length===0||f===D||N.$if(f)!==-1||$.push(l)}}return this.m.fire(),new F.$zv(b,c,$)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let w=!1;const d=u[0].range,n=u[u.length-1].range,o=new R.$kt(d.startLineNumber,d.startColumn,n.endLineNumber,n.endColumn);let s=d.startLineNumber,r=d.startColumn;const i=[];for(let c=0,$=u.length;c<$;c++){const v=u[c],p=v.range;w=w||v.forceMoveMarkers,i.push(this.getValueInRange(new R.$kt(s,r,p.startLineNumber,p.startColumn))),v.text.length>0&&i.push(v.text),s=p.endLineNumber,r=p.endColumn}const a=i.join(""),[h,t,b]=(0,m.$Nt)(a);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:a,eolCount:h,firstLineLength:t,lastLineLength:b,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(u){u.sort(T.w);const w=[];for(let d=0;d<u.length;d++){const n=u[d],o=n.range.startLineNumber,s=n.range.startColumn,r=n.range.endLineNumber,i=n.range.endColumn;if(o===r&&s===i&&n.text.length===0)continue;n.text?(this.c.delete(n.rangeOffset,n.rangeLength),this.c.insert(n.rangeOffset,n.text,!0)):this.c.delete(n.rangeOffset,n.rangeLength);const a=new R.$kt(o,s,r,i);w.push({range:a,rangeLength:n.rangeLength,text:n.text,rangeOffset:n.rangeOffset,forceMoveMarkers:n.forceMoveMarkers})}return w}findMatchesLineByLine(u,w,d,n){return this.c.findMatchesLineByLine(u,w,d,n)}getPieceTree(){return this.c}static _getInverseEditRange(u,w){const d=u.startLineNumber,n=u.startColumn,[o,s,r]=(0,m.$Nt)(w);let i;if(w.length>0){const a=o+1;a===1?i=new R.$kt(d,n,d,n+s):i=new R.$kt(d,n,d+a-1,r+1)}else i=new R.$kt(d,n,d,n);return i}static _getInverseEditRanges(u){const w=[];let d=0,n=0,o=null;for(let s=0,r=u.length;s<r;s++){const i=u[s];let a,h;o?o.range.endLineNumber===i.range.startLineNumber?(a=d,h=n+(i.range.startColumn-o.range.endColumn)):(a=d+(i.range.startLineNumber-o.range.endLineNumber),h=i.range.startColumn):(a=i.range.startLineNumber,h=i.range.startColumn);let t;if(i.text.length>0){const b=i.eolCount+1;b===1?t=new R.$kt(a,h,a,h+i.firstLineLength):t=new R.$kt(a,h,a+b-1,i.lastLineLength+1)}else t=new R.$kt(a,h,a,h);d=t.endLineNumber,n=t.endColumn,w.push(t),o=i}return w}static u(u,w){const d=R.$kt.compareRangesUsingEnds(u.range,w.range);return d===0?u.sortIndex-w.sortIndex:d}static w(u,w){const d=R.$kt.compareRangesUsingEnds(u.range,w.range);return d===0?w.sortIndex-u.sortIndex:-d}}e.$LC=T}),define(Re[149],Ae([1,0,15,92,148]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=void 0;class F{constructor(g,E,T,k,u,w,d,n,o){this.a=g,this.b=E,this.c=T,this.d=k,this.e=u,this.f=w,this.g=d,this.h=n,this.j=o}k(g){const E=this.c+this.d+this.e,T=this.c+this.e;return E===0?g===1?`
`:`\r
`:T>E/2?`\r
`:`
`}create(g){const E=this.k(g),T=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let u=0,w=T.length;u<w;u++){const d=T[u].buffer.replace(/\r\n|\r|\n/g,E),n=(0,N.$GC)(d);T[u]=new N.$JC(d,n)}const k=new R.$LC(T,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&I.$Rf(g)&&(this.b=I.$Qf,g=g.substr(1));const E=g.charCodeAt(g.length-1);E===13||E>=55296&&E<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=E):(this.m(g,!1),this.c=!1,this.d=E)}m(g,E){!E&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const E=(0,N.$HC)(this.e,g);this.a.push(new N.$JC(g,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=I.$Hf(g)),this.k||(this.k=I.$Kf(g)))}finish(g=!0){return this.o(),new F(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const E=(0,N.$GC)(g.buffer);g.lineStarts=E,this.d===13&&this.f++}}}e.$MC=M}),define(Re[97],Ae([1,0,22,21]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbb=g,e.$ibb=T;var R;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(R||(R={}));function F(k){for(let u=0,w=k.length;u<w;u+=4){const d=k[u+0],n=k[u+1],o=k[u+2],s=k[u+3];k[u+0]=s,k[u+1]=o,k[u+2]=n,k[u+3]=d}}function M(k){const u=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return N.$D()||F(u),I.$Ce.wrap(u)}function m(k){const u=k.buffer;if(N.$D()||F(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const w=new Uint8Array(u.byteLength);return w.set(u),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function g(k){const u=new Uint32Array(E(k));let w=0;if(u[w++]=k.id,k.type==="full")u[w++]=1,u[w++]=k.data.length,u.set(k.data,w),w+=k.data.length;else{u[w++]=2,u[w++]=k.deltas.length;for(const d of k.deltas)u[w++]=d.start,u[w++]=d.deleteCount,d.data?(u[w++]=d.data.length,u.set(d.data,w),w+=d.data.length):u[w++]=0}return M(u)}function E(k){let u=0;if(u+=2,k.type==="full")u+=1+k.data.length;else{u+=1,u+=3*k.deltas.length;for(const w of k.deltas)w.data&&(u+=w.data.length)}return u}function T(k){const u=m(k);let w=0;const d=u[w++];if(u[w++]===1){const r=u[w++],i=u.subarray(w,w+r);return w+=r,{id:d,type:"full",data:i}}const o=u[w++],s=[];for(let r=0;r<o;r++){const i=u[w++],a=u[w++],h=u[w++];let t;h>0&&(t=u.subarray(w,w+h),w+=h),s[r]={start:i,deleteCount:a,data:t}}return{id:d,type:"delta",deltas:s}}}),define(Re[150],Ae([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Re[151],Ae([1,0,18,26,21,134,152,150]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=r,e.clampedFloat=a,e.stringSet=b,e.cursorStyleToString=y,e.filterValidationDecorations=de;var g;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=E;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class k{constructor(Z,me,He,ye){this.id=Z,this.name=me,this.defaultValue=He,this.schema=ye}applyUpdate(Z,me){return w(Z,me)}compute(Z,me,He){return He}}class u{constructor(Z,me){this.newValue=Z,this.didChange=me}}e.ApplyUpdateResult=u;function w(X,Z){if(typeof X!="object"||typeof Z!="object"||!X||!Z)return new u(Z,X!==Z);if(Array.isArray(X)||Array.isArray(Z)){const He=Array.isArray(X)&&Array.isArray(Z)&&I.$ub(X,Z);return new u(Z,!He)}let me=!1;for(const He in Z)if(Z.hasOwnProperty(He)){const ye=w(X[He],Z[He]);ye.didChange&&(X[He]=ye.newValue,me=!0)}return new u(X,me)}class d{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,me){return w(Z,me)}validate(Z){return this.defaultValue}}class n{constructor(Z,me,He,ye){this.id=Z,this.name=me,this.defaultValue=He,this.schema=ye}applyUpdate(Z,me){return w(Z,me)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,me,He){return He}}function o(X,Z){return typeof X>"u"?Z:X==="false"?!1:!!X}class s extends n{constructor(Z,me,He,ye=void 0){typeof ye<"u"&&(ye.type="boolean",ye.default=He),super(Z,me,He,ye)}validate(Z){return o(Z,this.defaultValue)}}function r(X,Z,me,He){if(typeof X>"u")return Z;let ye=parseInt(X,10);return isNaN(ye)?Z:(ye=Math.max(me,ye),ye=Math.min(He,ye),ye|0)}class i extends n{static clampedInt(Z,me,He,ye){return r(Z,me,He,ye)}constructor(Z,me,He,ye,ot,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=He,dt.minimum=ye,dt.maximum=ot),super(Z,me,He,dt),this.minimum=ye,this.maximum=ot}validate(Z){return i.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function a(X,Z,me,He){if(typeof X>"u")return Z;const ye=h.float(X,Z);return h.clamp(ye,me,He)}class h extends n{static clamp(Z,me,He){return Z<me?me:Z>He?He:Z}static float(Z,me){if(typeof Z=="number")return Z;if(typeof Z>"u")return me;const He=parseFloat(Z);return isNaN(He)?me:He}constructor(Z,me,He,ye,ot){typeof ot<"u"&&(ot.type="number",ot.default=He),super(Z,me,He,ot),this.validationFn=ye}validate(Z){return this.validationFn(h.float(Z,this.defaultValue))}}class t extends n{static string(Z,me){return typeof Z!="string"?me:Z}constructor(Z,me,He,ye=void 0){typeof ye<"u"&&(ye.type="string",ye.default=He),super(Z,me,He,ye)}validate(Z){return t.string(Z,this.defaultValue)}}function b(X,Z,me,He){return typeof X!="string"?Z:He&&X in He?He[X]:me.indexOf(X)===-1?Z:X}class c extends n{constructor(Z,me,He,ye,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=ye,ot.default=He),super(Z,me,He,ot),this.c=ye}validate(Z){return b(Z,this.defaultValue,this.c)}}class $ extends k{constructor(Z,me,He,ye,ot,dt,Pt=void 0){typeof Pt<"u"&&(Pt.type="string",Pt.enum=ot,Pt.default=ye),super(Z,me,He,Pt),this.c=ot,this.d=dt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function v(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,me,He){return He===0?Z.accessibilitySupport:He}}class l extends k{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertSpace:o(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function f(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var S;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(S||(e.TextEditorCursorStyle=S={}));function y(X){switch(X){case S.Line:return"line";case S.Block:return"block";case S.Underline:return"underline";case S.LineThin:return"line-thin";case S.BlockOutline:return"block-outline";case S.UnderlineThin:return"underline-thin"}}function C(X){switch(X){case"line":return S.Line;case"block":return S.Block;case"underline":return S.Underline;case"line-thin":return S.LineThin;case"block-outline":return S.BlockOutline;case"underline-thin":return S.UnderlineThin}}class P extends d{constructor(){super(142)}compute(Z,me,He){const ye=["monaco-editor"];return me.get(39)&&ye.push(me.get(39)),Z.extraEditorClassName&&ye.push(Z.extraEditorClassName),me.get(74)==="default"?ye.push("mouse-default"):me.get(74)==="copy"&&ye.push("mouse-copy"),me.get(111)&&ye.push("showUnused"),me.get(140)&&ye.push("showDeprecated"),ye.join(" ")}}class V extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Z,me,He){return He&&Z.emptySelectionClipboard}}class W extends k{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:m.localize(16,null),included:R.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:m.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{cursorMoveOnType:o(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":b(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":b(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(me.loop,this.defaultValue.loop)}}}class q extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?q.OFF:Z==="true"?q.ON:Z:Z?q.ON:q.OFF}}e.EditorFontLigatures=q;class A extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?A.OFF:Z==="true"?A.TRANSLATE:Z:Z?A.TRANSLATE:A.OFF}compute(Z,me,He){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=A;class j extends d{constructor(){super(50)}compute(Z,me,He){return Z.fontInfo}}class K extends n{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(Z){const me=h.float(Z,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(me,6,100)}compute(Z,me,He){return Z.fontInfo.fontSize}}class ie extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(i.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class ce extends k{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:He,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:He,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:He,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:He,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:He,description:m.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{multiple:b(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??b(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??b(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??b(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??b(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??b(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ve extends k{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:m.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),delay:i.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:o(me.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(me.above,this.defaultValue.above)}}}var Ie;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class ue extends d{constructor(){super(145)}compute(Z,me,He){return ue.computeLayout(me,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const me=Z.height/Z.lineHeight,He=Math.floor(Z.paddingTop/Z.lineHeight);let ye=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(ye=Math.max(ye,me-1));const ot=(He+Z.viewLineCount+ye)/(Z.pixelRatio*Z.height),dt=Math.floor(Z.viewLineCount/ot);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:ye,desiredRatio:ot,minimapLineCount:dt}}static c(Z,me){const He=Z.outerWidth,ye=Z.outerHeight,ot=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ye};const dt=me.stableMinimapLayoutInput,Pt=dt&&Z.outerHeight===dt.outerHeight&&Z.lineHeight===dt.lineHeight&&Z.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===dt.pixelRatio&&Z.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Z.paddingTop===dt.paddingTop&&Z.paddingBottom===dt.paddingBottom&&Z.minimap.enabled===dt.minimap.enabled&&Z.minimap.side===dt.minimap.side&&Z.minimap.size===dt.minimap.size&&Z.minimap.showSlider===dt.minimap.showSlider&&Z.minimap.renderCharacters===dt.minimap.renderCharacters&&Z.minimap.maxColumn===dt.minimap.maxColumn&&Z.minimap.scale===dt.minimap.scale&&Z.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Z.isViewportWrapping===dt.isViewportWrapping,Bt=Z.lineHeight,Yt=Z.typicalHalfwidthCharacterWidth,qt=Z.scrollBeyondLastLine,xt=Z.minimap.renderCharacters;let Et=ot>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Wt=Z.minimap.maxColumn,Ht=Z.minimap.size,Xe=Z.minimap.side,ri=Z.verticalScrollbarWidth,_t=Z.viewLineCount,ht=Z.remainingWidth,$t=Z.isViewportWrapping,ei=xt?2:3;let ti=Math.floor(ot*ye);const Lt=ti/ot;let gt=!1,zt=!1,ii=ei*Et,Tt=Et/ot,Ke=1;if(Ht==="fill"||Ht==="fit"){const{typicalViewportLineCount:jt,extraLinesBeforeFirstLine:Kt,extraLinesBeyondLastLine:Jt,desiredRatio:oi,minimapLineCount:Ct}=ue.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:qt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:ye,lineHeight:Bt,pixelRatio:ot});if(_t/Ct>1)gt=!0,zt=!0,Et=1,ii=1,Tt=Et/ot;else{let It=!1,Dt=Et+1;if(Ht==="fit"){const bt=Math.ceil((Kt+_t+Jt)*ii);$t&&Pt&&ht<=me.stableFitRemainingWidth?(It=!0,Dt=me.stableFitMaxMinimapScale):It=bt>ti}if(Ht==="fill"||It){gt=!0;const bt=Et;ii=Math.min(Bt*ot,Math.max(1,Math.floor(1/oi))),$t&&Pt&&ht<=me.stableFitRemainingWidth&&(Dt=me.stableFitMaxMinimapScale),Et=Math.min(Dt,Math.max(1,Math.floor(ii/ei))),Et>bt&&(Ke=Math.min(2,Et/bt)),Tt=Et/ot/Ke,ti=Math.ceil(Math.max(jt,Kt+_t+Jt)*ii),$t?(me.stableMinimapLayoutInput=Z,me.stableFitRemainingWidth=ht,me.stableFitMaxMinimapScale=Et):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const si=Math.floor(Wt*Tt),Gt=Math.min(si,Math.max(0,Math.floor((ht-ri-2)*Tt/(Yt+Tt)))+e.MINIMAP_GUTTER_WIDTH);let Ut=Math.floor(ot*Gt);const mt=Ut/ot;Ut=Math.floor(Ut*Ke);const Ft=xt?1:2,Mt=Xe==="left"?0:He-Gt-ri;return{renderMinimap:Ft,minimapLeft:Mt,minimapWidth:Gt,minimapHeightIsEditorHeight:gt,minimapIsSampling:zt,minimapScale:Et,minimapLineHeight:ii,minimapCanvasInnerWidth:Ut,minimapCanvasInnerHeight:ti,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:Lt}}static computeLayout(Z,me){const He=me.outerWidth|0,ye=me.outerHeight|0,ot=me.lineHeight|0,dt=me.lineNumbersDigitCount|0,Pt=me.typicalHalfwidthCharacterWidth,Bt=me.maxDigitWidth,Yt=me.pixelRatio,qt=me.viewLineCount,xt=Z.get(137),Et=xt==="inherit"?Z.get(136):xt,Wt=Et==="inherit"?Z.get(132):Et,Ht=Z.get(135),Xe=me.isDominatedByLongLines,ri=Z.get(57),_t=Z.get(68).renderType!==0,ht=Z.get(69),$t=Z.get(105),ei=Z.get(84),ti=Z.get(73),Lt=Z.get(103),gt=Lt.verticalScrollbarSize,zt=Lt.verticalHasArrows,ii=Lt.arrowSize,Tt=Lt.horizontalScrollbarSize,Ke=Z.get(43),si=Z.get(110)!=="never";let Gt=Z.get(66);Ke&&si&&(Gt+=16);let Ut=0;if(_t){const li=Math.max(dt,ht);Ut=Math.round(li*Bt)}let mt=0;ri&&(mt=ot*me.glyphMarginDecorationLaneCount);let Ft=0,Mt=Ft+mt,jt=Mt+Ut,Kt=jt+Gt;const Jt=He-mt-Ut-Gt;let oi=!1,Ct=!1,Nt=-1;Et==="inherit"&&Xe?(oi=!0,Ct=!0):Wt==="on"||Wt==="bounded"?Ct=!0:Wt==="wordWrapColumn"&&(Nt=Ht);const It=ue.c({outerWidth:He,outerHeight:ye,lineHeight:ot,typicalHalfwidthCharacterWidth:Pt,pixelRatio:Yt,scrollBeyondLastLine:$t,paddingTop:ei.top,paddingBottom:ei.bottom,minimap:ti,verticalScrollbarWidth:gt,viewLineCount:qt,remainingWidth:Jt,isViewportWrapping:Ct},me.memory||new T);It.renderMinimap!==0&&It.minimapLeft===0&&(Ft+=It.minimapWidth,Mt+=It.minimapWidth,jt+=It.minimapWidth,Kt+=It.minimapWidth);const Dt=Jt-It.minimapWidth,bt=Math.max(1,Math.floor((Dt-gt-2)/Pt)),St=zt?ii:0;return Ct&&(Nt=Math.max(1,bt),Wt==="bounded"&&(Nt=Math.min(Nt,Ht))),{width:He,height:ye,glyphMarginLeft:Ft,glyphMarginWidth:mt,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:Mt,lineNumbersWidth:Ut,decorationsLeft:jt,decorationsWidth:Gt,contentLeft:Kt,contentWidth:Dt,minimap:It,viewportColumn:bt,isWordWrapMinified:oi,isViewportWrapping:Ct,wrappingColumn:Nt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Tt,overviewRuler:{top:St,width:gt,height:ye-2*St,right:0}}}}e.EditorLayoutInfoComputer=ue;class pe extends k{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(Z){return b(Z,"simple",["simple","advanced"])}compute(Z,me,He){return me.get(2)===2?"advanced":He}}var re;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(re||(e.ShowLightbulbIconMode=re={}));class Se extends k{constructor(){const Z={enabled:re.On};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[re.Off,re.OnCode,re.On],default:Z.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:b(Z.enabled,this.defaultValue.enabled,[re.Off,re.OnCode,re.On])}}}class Le extends k{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:m.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:b(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends k{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:m.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:b(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),padding:o(me.padding,this.defaultValue.padding)}}}class U extends k{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):i.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,me,He){return He<0?i.clampedInt(-He*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class x extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>h.clamp(Z,0,150),{markdownDescription:m.localize(66,null)})}compute(Z,me,He){return Z.fontInfo.lineHeight}}class be extends k{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:Z.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:m.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Z.showRegionSectionHeaders,description:m.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Z.showMarkSectionHeaders,description:m.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Z.sectionHeaderFontSize,description:m.localize(80,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),autohide:o(me.autohide,this.defaultValue.autohide),size:b(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(me.side,this.defaultValue.side,["right","left"]),showSlider:b(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(me.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(me.scale,1,1,3),maxColumn:i.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Ne(X){return X==="ctrlCmd"?R.$j?"metaKey":"ctrlKey":"altKey"}class Ee extends k{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(82,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{top:i.clampedInt(me.top,0,0,1e3),bottom:i.clampedInt(me.bottom,0,0,1e3)}}}class $e extends k{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:m.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:m.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),cycle:o(me.cycle,this.defaultValue.cycle)}}}class fe extends d{constructor(){super(143)}compute(Z,me,He){return Z.pixelRatio}}class Q extends k{constructor(){const Z={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(85,null),m.localize(86,null),m.localize(87,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Z.strings,description:m.localize(88,null)},comments:{anyOf:me,default:Z.comments,description:m.localize(89,null)},other:{anyOf:me,default:Z.other,description:m.localize(90,null)}},default:Z,markdownDescription:m.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Yt=Z?"on":"off";return{comments:Yt,strings:Yt,other:Yt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:me,comments:He,strings:ye}=Z,ot=["on","inline","off"];let dt,Pt,Bt;return typeof me=="boolean"?dt=me?"on":"off":dt=b(me,this.defaultValue.other,ot),typeof He=="boolean"?Pt=He?"on":"off":Pt=b(He,this.defaultValue.comments,ot),typeof ye=="boolean"?Bt=ye?"on":"off":Bt=b(ye,this.defaultValue.strings,ot),{other:dt,comments:Pt,strings:Bt}}}var Y;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class le extends k{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null),m.localize(95,null)],default:"on",description:m.localize(96,null)})}validate(Z){let me=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(me=4,He=Z):Z==="interval"?me=3:Z==="relative"?me=2:Z==="on"?me=1:me=0),{renderType:me,renderFn:He}}}function de(X){const Z=X.get(98);return Z==="editable"?X.get(91):Z!=="on"}class Te extends k{constructor(){const Z=[],me={type:"number",description:m.localize(97,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:m.localize(98,null),format:"color-hex"}}}]},default:Z,description:m.localize(99,null)})}validate(Z){if(Array.isArray(Z)){const me=[];for(const He of Z)if(typeof He=="number")me.push({column:i.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const ye=He;me.push({column:i.clampedInt(ye.column,0,0,1e4),color:ye.color})}return me.sort((He,ye)=>He.column-ye.column),me}return this.defaultValue}}class he extends k{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ce(X,Z){if(typeof X!="string")return Z;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Me extends k{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(100,null),m.localize(101,null),m.localize(102,null)],default:"auto",description:m.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(104,null),m.localize(105,null),m.localize(106,null)],default:"auto",description:m.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:m.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:m.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:m.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:m.localize(111,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z,He=i.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ye=i.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(me.vertical,this.defaultValue.vertical),horizontal:Ce(me.horizontal,this.defaultValue.horizontal),useShadows:o(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:i.clampedInt(me.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:ye,verticalSliderSize:i.clampedInt(me.verticalSliderSize,ye,0,1e3),scrollByPage:o(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends k{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:m.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:m.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:m.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:m.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:m.localize(118,null)}})}applyUpdate(Z,me){let He=!1;me.allowedCharacters&&Z&&(N.$1n(Z.allowedCharacters,me.allowedCharacters)||(Z={...Z,allowedCharacters:me.allowedCharacters},He=!0)),me.allowedLocales&&Z&&(N.$1n(Z.allowedLocales,me.allowedLocales)||(Z={...Z,allowedLocales:me.allowedLocales},He=!0));const ye=super.applyUpdate(Z,me);return He?new u(ye.newValue,!0):ye}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{nonBasicASCII:ee(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,me){if(typeof Z!="object"||!Z)return me;const He={};for(const[ye,ot]of Object.entries(Z))ot===!0&&(He[ye]=!0);return He}}class z extends k{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:m.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(120,null),m.localize(121,null),m.localize(122,null)],description:m.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:m.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:m.localize(125,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),mode:b(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:b(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily)}}}class L extends k{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:m.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(127,null),m.localize(128,null),m.localize(129,null)],description:m.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:m.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:m.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showToolbar:b(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends k{constructor(){const Z={enabled:F.$Us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$Us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:m.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null)],default:Z.bracketPairs,description:m.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(139,null),m.localize(140,null),m.localize(141,null)],default:Z.bracketPairsHorizontal,description:m.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:m.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:m.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(145,null),m.localize(146,null),m.localize(147,null)],default:Z.highlightActiveIndentation,description:m.localize(148,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{bracketPairs:ee(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(X,Z,me){const He=me.indexOf(X);return He===-1?Z:me[He]}class se extends k{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(149,null),m.localize(150,null)],default:Z.insertMode,description:m.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:m.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:m.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:m.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(155,null),m.localize(156,null),m.localize(157,null),m.localize(158,null)],default:Z.selectionMode,markdownDescription:m.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:m.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:m.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:m.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:m.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:m.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(196,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertMode:b(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:b(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(me.showIcons,this.defaultValue.showIcons),showStatusBar:o(me.showStatusBar,this.defaultValue.showStatusBar),preview:o(me.preview,this.defaultValue.preview),previewMode:b(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(me.showMethods,this.defaultValue.showMethods),showFunctions:o(me.showFunctions,this.defaultValue.showFunctions),showConstructors:o(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(me.showFields,this.defaultValue.showFields),showVariables:o(me.showVariables,this.defaultValue.showVariables),showClasses:o(me.showClasses,this.defaultValue.showClasses),showStructs:o(me.showStructs,this.defaultValue.showStructs),showInterfaces:o(me.showInterfaces,this.defaultValue.showInterfaces),showModules:o(me.showModules,this.defaultValue.showModules),showProperties:o(me.showProperties,this.defaultValue.showProperties),showEvents:o(me.showEvents,this.defaultValue.showEvents),showOperators:o(me.showOperators,this.defaultValue.showOperators),showUnits:o(me.showUnits,this.defaultValue.showUnits),showValues:o(me.showValues,this.defaultValue.showValues),showConstants:o(me.showConstants,this.defaultValue.showConstants),showEnums:o(me.showEnums,this.defaultValue.showEnums),showEnumMembers:o(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(me.showKeywords,this.defaultValue.showKeywords),showWords:o(me.showWords,this.defaultValue.showWords),showColors:o(me.showColors,this.defaultValue.showColors),showFiles:o(me.showFiles,this.defaultValue.showFiles),showReferences:o(me.showReferences,this.defaultValue.showReferences),showFolders:o(me.showFolders,this.defaultValue.showFolders),showTypeParameters:o(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(me.showSnippets,this.defaultValue.showSnippets),showUsers:o(me.showUsers,this.defaultValue.showUsers),showIssues:o(me.showIssues,this.defaultValue.showIssues)}}}class Fe extends k{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(198,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Z.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends k{constructor(){const Z=[];super(130,"wordSegmenterLocales",Z,{anyOf:[{description:m.localize(199,null),type:"string"},{description:m.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Z){if(typeof Z=="string"&&(Z=[Z]),Array.isArray(Z)){const me=[];for(const He of Z)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&me.push(He)}catch{}return me}return this.defaultValue}}var Qe;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Qe||(e.WrappingIndent=Qe={}));class xe extends k{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(201,null),m.localize(202,null),m.localize(203,null),m.localize(204,null)],description:m.localize(205,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,me,He){return me.get(2)===2?0:He}}class _e extends d{constructor(){super(146)}compute(Z,me,He){const ye=me.get(145);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:ye.isWordWrapMinified,isViewportWrapping:ye.isViewportWrapping,wrappingColumn:ye.wrappingColumn}}}class et extends k{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(208,null),m.localize(209,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showDropSelector:b(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends k{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(212,null),m.localize(213,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:o(me.enabled,this.defaultValue.enabled),showPasteSelector:b(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",ft="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.$j?ct:R.$k?ft:nt,fontWeight:"normal",fontSize:R.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(X){return e.editorOptionsRegistry[X.id]=X,X}var st;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",X[X.quickSuggestions=89]="quickSuggestions",X[X.quickSuggestionsDelay=90]="quickSuggestionsDelay",X[X.readOnly=91]="readOnly",X[X.readOnlyMessage=92]="readOnlyMessage",X[X.renameOnType=93]="renameOnType",X[X.renderControlCharacters=94]="renderControlCharacters",X[X.renderFinalNewline=95]="renderFinalNewline",X[X.renderLineHighlight=96]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=98]="renderValidationDecorations",X[X.renderWhitespace=99]="renderWhitespace",X[X.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",X[X.roundedSelection=101]="roundedSelection",X[X.rulers=102]="rulers",X[X.scrollbar=103]="scrollbar",X[X.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=105]="scrollBeyondLastLine",X[X.scrollPredominantAxis=106]="scrollPredominantAxis",X[X.selectionClipboard=107]="selectionClipboard",X[X.selectionHighlight=108]="selectionHighlight",X[X.selectOnLineNumbers=109]="selectOnLineNumbers",X[X.showFoldingControls=110]="showFoldingControls",X[X.showUnused=111]="showUnused",X[X.snippetSuggestions=112]="snippetSuggestions",X[X.smartSelect=113]="smartSelect",X[X.smoothScrolling=114]="smoothScrolling",X[X.stickyScroll=115]="stickyScroll",X[X.stickyTabStops=116]="stickyTabStops",X[X.stopRenderingLineAfter=117]="stopRenderingLineAfter",X[X.suggest=118]="suggest",X[X.suggestFontSize=119]="suggestFontSize",X[X.suggestLineHeight=120]="suggestLineHeight",X[X.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",X[X.suggestSelection=122]="suggestSelection",X[X.tabCompletion=123]="tabCompletion",X[X.tabIndex=124]="tabIndex",X[X.unicodeHighlighting=125]="unicodeHighlighting",X[X.unusualLineTerminators=126]="unusualLineTerminators",X[X.useShadowDOM=127]="useShadowDOM",X[X.useTabStops=128]="useTabStops",X[X.wordBreak=129]="wordBreak",X[X.wordSegmenterLocales=130]="wordSegmenterLocales",X[X.wordSeparators=131]="wordSeparators",X[X.wordWrap=132]="wordWrap",X[X.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=135]="wordWrapColumn",X[X.wordWrapOverride1=136]="wordWrapOverride1",X[X.wordWrapOverride2=137]="wordWrapOverride2",X[X.wrappingIndent=138]="wrappingIndent",X[X.wrappingStrategy=139]="wrappingStrategy",X[X.showDeprecated=140]="showDeprecated",X[X.inlayHints=141]="inlayHints",X[X.editorClassName=142]="editorClassName",X[X.pixelRatio=143]="pixelRatio",X[X.tabFocusMode=144]="tabFocusMode",X[X.layoutInfo=145]="layoutInfo",X[X.wrappingInfo=146]="wrappingInfo",X[X.defaultColorDecorators=147]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(214,null)})),acceptSuggestionOnEnter:je(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(215,null),""],markdownDescription:m.localize(216,null)})),accessibilitySupport:je(new p),accessibilityPageSize:je(new i(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(217,null),tags:["accessibility"]})),ariaLabel:je(new t(4,"ariaLabel",m.localize(218,null))),ariaRequired:je(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:je(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(220,null),m.localize(221,null),""],description:m.localize(222,null)})),autoClosingComments:je(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(223,null),m.localize(224,null),""],description:m.localize(225,null)})),autoClosingDelete:je(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(226,null),""],description:m.localize(227,null)})),autoClosingOvertype:je(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(228,null),""],description:m.localize(229,null)})),autoClosingQuotes:je(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(230,null),m.localize(231,null),""],description:m.localize(232,null)})),autoIndent:je(new $(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[m.localize(233,null),m.localize(234,null),m.localize(235,null),m.localize(236,null),m.localize(237,null)],description:m.localize(238,null)})),automaticLayout:je(new s(13,"automaticLayout",!1)),autoSurround:je(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(239,null),m.localize(240,null),m.localize(241,null),""],description:m.localize(242,null)})),bracketPairColorization:je(new G),bracketPairGuides:je(new H),stickyTabStops:je(new s(116,"stickyTabStops",!1,{description:m.localize(243,null)})),codeLens:je(new s(17,"codeLens",!0,{description:m.localize(244,null)})),codeLensFontFamily:je(new t(18,"codeLensFontFamily","",{description:m.localize(245,null)})),codeLensFontSize:je(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(246,null)})),colorDecorators:je(new s(20,"colorDecorators",!0,{description:m.localize(247,null)})),colorDecoratorActivatedOn:je(new c(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(248,null),m.localize(249,null),m.localize(250,null)],description:m.localize(251,null)})),colorDecoratorsLimit:je(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(252,null)})),columnSelection:je(new s(22,"columnSelection",!1,{description:m.localize(253,null)})),comments:je(new l),contextmenu:je(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new s(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(254,null)})),cursorBlinking:je(new $(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:m.localize(255,null)})),cursorSmoothCaretAnimation:je(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(256,null),m.localize(257,null),m.localize(258,null)],description:m.localize(259,null)})),cursorStyle:je(new $(28,"cursorStyle",S.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:m.localize(260,null)})),cursorSurroundingLines:je(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(261,null)})),cursorSurroundingLinesStyle:je(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(262,null),m.localize(263,null)],markdownDescription:m.localize(264,null)})),cursorWidth:je(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(265,null)})),disableLayerHinting:je(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new s(34,"domReadOnly",!1)),dragAndDrop:je(new s(35,"dragAndDrop",!0,{description:m.localize(266,null)})),emptySelectionClipboard:je(new V),dropIntoEditor:je(new et),stickyScroll:je(new Le),experimentalWhitespaceRendering:je(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(267,null),m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),extraEditorClassName:je(new t(39,"extraEditorClassName","")),fastScrollSensitivity:je(new h(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:m.localize(271,null)})),find:je(new W),fixedOverflowWidgets:je(new s(42,"fixedOverflowWidgets",!1)),folding:je(new s(43,"folding",!0,{description:m.localize(272,null)})),foldingStrategy:je(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(273,null),m.localize(274,null)],description:m.localize(275,null)})),foldingHighlight:je(new s(45,"foldingHighlight",!0,{description:m.localize(276,null)})),foldingImportsByDefault:je(new s(46,"foldingImportsByDefault",!1,{description:m.localize(277,null)})),foldingMaximumRegions:je(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(278,null)})),unfoldOnClickAfterEndOfLine:je(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(279,null)})),fontFamily:je(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(280,null)})),fontInfo:je(new j),fontLigatures2:je(new q),fontSize:je(new K),fontWeight:je(new ie),fontVariations:je(new A),formatOnPaste:je(new s(55,"formatOnPaste",!1,{description:m.localize(281,null)})),formatOnType:je(new s(56,"formatOnType",!1,{description:m.localize(282,null)})),glyphMargin:je(new s(57,"glyphMargin",!0,{description:m.localize(283,null)})),gotoLocation:je(new ce),hideCursorInOverviewRuler:je(new s(59,"hideCursorInOverviewRuler",!1,{description:m.localize(284,null)})),hover:je(new ve),inDiffEditor:je(new s(61,"inDiffEditor",!1)),letterSpacing:je(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>h.clamp(X,-5,20),{description:m.localize(285,null)})),lightbulb:je(new Se),lineDecorationsWidth:je(new U),lineHeight:je(new x),lineNumbers:je(new le),lineNumbersMinChars:je(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new s(70,"linkedEditing",!1,{description:m.localize(286,null)})),links:je(new s(71,"links",!0,{description:m.localize(287,null)})),matchBrackets:je(new c(72,"matchBrackets","always",["always","near","never"],{description:m.localize(288,null)})),minimap:je(new be),mouseStyle:je(new c(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new h(75,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:m.localize(289,null)})),mouseWheelZoom:je(new s(76,"mouseWheelZoom",!1,{markdownDescription:R.$j?m.localize(290,null):m.localize(291,null)})),multiCursorMergeOverlapping:je(new s(77,"multiCursorMergeOverlapping",!0,{description:m.localize(292,null)})),multiCursorModifier:je(new $(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ne,{markdownEnumDescriptions:[m.localize(293,null),m.localize(294,null)],markdownDescription:m.localize(295,null)})),multiCursorPaste:je(new c(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(296,null),m.localize(297,null)],markdownDescription:m.localize(298,null)})),multiCursorLimit:je(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(299,null)})),occurrencesHighlight:je(new c(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(300,null),m.localize(301,null),m.localize(302,null)],markdownDescription:m.localize(303,null)})),overviewRulerBorder:je(new s(82,"overviewRulerBorder",!0,{description:m.localize(304,null)})),overviewRulerLanes:je(new i(83,"overviewRulerLanes",3,0,3)),padding:je(new Ee),pasteAs:je(new tt),parameterHints:je(new $e),peekWidgetDefaultFocus:je(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(305,null),m.localize(306,null)],description:m.localize(307,null)})),definitionLinkOpensInPeek:je(new s(88,"definitionLinkOpensInPeek",!1,{description:m.localize(308,null)})),quickSuggestions:je(new Q),quickSuggestionsDelay:je(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(309,null)})),readOnly:je(new s(91,"readOnly",!1)),readOnlyMessage:je(new he),renameOnType:je(new s(93,"renameOnType",!1,{description:m.localize(310,null),markdownDeprecationMessage:m.localize(311,null)})),renderControlCharacters:je(new s(94,"renderControlCharacters",!0,{description:m.localize(312,null),restricted:!0})),renderFinalNewline:je(new c(95,"renderFinalNewline",R.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(313,null)})),renderLineHighlight:je(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(314,null)],description:m.localize(315,null)})),renderLineHighlightOnlyWhenFocus:je(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(316,null)})),renderValidationDecorations:je(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(317,null),m.localize(318,null),m.localize(319,null),""],description:m.localize(320,null)})),revealHorizontalRightPadding:je(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new s(101,"roundedSelection",!0,{description:m.localize(321,null)})),rulers:je(new Te),scrollbar:je(new Me),scrollBeyondLastColumn:je(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(322,null)})),scrollBeyondLastLine:je(new s(105,"scrollBeyondLastLine",!0,{description:m.localize(323,null)})),scrollPredominantAxis:je(new s(106,"scrollPredominantAxis",!0,{description:m.localize(324,null)})),selectionClipboard:je(new s(107,"selectionClipboard",!0,{description:m.localize(325,null),included:R.$k})),selectionHighlight:je(new s(108,"selectionHighlight",!0,{description:m.localize(326,null)})),selectOnLineNumbers:je(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:je(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(327,null),m.localize(328,null),m.localize(329,null)],description:m.localize(330,null)})),showUnused:je(new s(111,"showUnused",!0,{description:m.localize(331,null)})),showDeprecated:je(new s(140,"showDeprecated",!0,{description:m.localize(332,null)})),inlayHints:je(new ne),snippetSuggestions:je(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(333,null),m.localize(334,null),m.localize(335,null),m.localize(336,null)],description:m.localize(337,null)})),smartSelect:je(new Fe),smoothScrolling:je(new s(114,"smoothScrolling",!1,{description:m.localize(338,null)})),stopRenderingLineAfter:je(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new se),inlineSuggest:je(new z),inlineEdit:je(new L),inlineCompletionsAccessibilityVerbose:je(new s(149,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(339,null)})),suggestFontSize:je(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new s(121,"suggestOnTriggerCharacters",!0,{description:m.localize(342,null)})),suggestSelection:je(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(343,null),m.localize(344,null),m.localize(345,null)],description:m.localize(346,null)})),tabCompletion:je(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(347,null),m.localize(348,null),m.localize(349,null)],description:m.localize(350,null)})),tabIndex:je(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new ze),unusualLineTerminators:je(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(351,null),m.localize(352,null),m.localize(353,null)],description:m.localize(354,null)})),useShadowDOM:je(new s(127,"useShadowDOM",!0)),useTabStops:je(new s(128,"useTabStops",!0,{description:m.localize(355,null)})),wordBreak:je(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(356,null),m.localize(357,null)],description:m.localize(358,null)})),wordSegmenterLocales:je(new Be),wordSeparators:je(new t(131,"wordSeparators",M.$Vs,{description:m.localize(359,null)})),wordWrap:je(new c(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(360,null),m.localize(361,null),m.localize(362,null),m.localize(363,null)],description:m.localize(364,null)})),wordWrapBreakAfterCharacters:je(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(365,null)})),wordWrapOverride1:je(new c(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new c(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new P),defaultColorDecorators:je(new s(147,"defaultColorDecorators",!1,{markdownDescription:m.localize(366,null)})),pixelRatio:je(new fe),tabFocusMode:je(new s(144,"tabFocusMode",!1,{markdownDescription:m.localize(367,null)})),layoutInfo:je(new ue),wrappingInfo:je(new _e),wrappingIndent:je(new xe),wrappingStrategy:je(new pe)}}),define(Re[153],Ae([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[154],Ae([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[155],Ae([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Re[156],Ae([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[157],Ae([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[158],Ae([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Re[159],Ae([9,10]),function(ge,e){return ge.create("vs/platform/log/common/log",e)}),define(Re[160],Ae([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Re[161],Ae([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[162],Ae([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Re[163],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Re[164],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[165],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[166],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[167],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Re[168],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[169],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Re[170],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[171],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[172],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[173],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[174],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Re[175],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[176],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Re[177],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Re[178],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Re[179],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Re[180],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[181],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[182],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[183],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[184],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[185],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Re[186],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[187],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[188],Ae([1,0,14,155]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.TokenType=void 0;var R;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(R||(e.TokenType=R={}));function F(...E){switch(E.length){case 1:return(0,N.localize)(0,null,E[0]);case 2:return(0,N.localize)(1,null,E[0],E[1]);case 3:return(0,N.localize)(2,null,E[0],E[1],E[2]);default:return}}const M=(0,N.localize)(3,null),m=(0,N.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const k=this.d,u=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:u};this.g.push({offset:k,lexeme:u,additionalInfo:T}),this.f.push(w)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const k=this.c.substring(this.d,this.e),u=g.b.get(k);u?this.k(u):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,k=!1,u=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(m);return}const d=this.c.charCodeAt(T);if(k)k=!1;else if(d===47&&!u){T++;break}else d===91?u=!0:d===92?k=!0:d===93&&(u=!1);T++}for(;T<this.c.length&&g.a.has(this.c.charCodeAt(T));)T++;this.e=T;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$lj=g}),define(Re[189],Ae([1,0,23,33,157,301]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=g,e.$Bp=E,e.$Cp=T,e.$Dp=k,e.$Ep=u,e.$Fp=w,e.$Gp=d;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function g(s){return s=s.trim(),s==="*"||M.test(s)}function E(s){if(!g(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=s.match(M);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}function T(s){if(!s)return null;const r=s.majorBase,i=s.majorMustEqual,a=s.minorBase;let h=s.minorMustEqual;const t=s.patchBase;let b=s.patchMustEqual;s.hasCaret&&(r===0||(h=!1),b=!1);let c=0;if(s.preRelease){const $=m.exec(s.preRelease);if($){const[,v,p,l]=$;c=Date.UTC(Number(v),Number(p)-1,Number(l))}}return{majorBase:r,majorMustEqual:i,minorBase:a,minorMustEqual:h,patchBase:t,patchMustEqual:b,isMinimum:s.hasGreaterEquals,notBefore:c}}function k(s,r,i){let a;typeof s=="string"?a=T(E(s)):a=s;let h;r instanceof Date?h=r.getTime():typeof r=="string"&&(h=new Date(r).getTime());let t;if(typeof i=="string"?t=T(E(i)):t=i,!a||!t)return!1;const b=a.majorBase,c=a.minorBase,$=a.patchBase;let v=t.majorBase,p=t.minorBase,l=t.patchBase;const D=t.notBefore;let f=t.majorMustEqual,S=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?b>v?!0:b<v?!1:c>p?!0:c<p||h&&h<D?!1:$>=l:(b===1&&v===0&&(!f||!S||!y)&&(v=1,p=0,l=0,f=!0,S=!1,y=!1),b<v?!1:b>v?!f:c<p?!1:c>p?!S:$<l?!1:$>l?!y:!(h&&h<D))}function u(s,r,i,a,h){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([N.default.Error,R.localize(0,null)]),t;if(typeof a.name!="string")return t.push([N.default.Error,R.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([N.default.Error,R.localize(2,null,"version")]),t;if(!a.engines)return t.push([N.default.Error,R.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([N.default.Error,R.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!o(a.extensionDependencies))return t.push([N.default.Error,R.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!o(a.activationEvents))return t.push([N.default.Error,R.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([N.default.Error,R.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([N.default.Warning,R.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([N.default.Error,R.localize(9,null,"main")]),t;{const $=(0,I.$4g)(i,a.main);(0,I.$Xg)($,i)||t.push([N.default.Warning,R.localize(10,null,$.path,i.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([N.default.Error,R.localize(11,null,"browser")]),t;{const $=(0,I.$4g)(i,a.browser);(0,I.$Xg)($,i)||t.push([N.default.Warning,R.localize(12,null,$.path,i.path)])}}if(!F.valid(a.version))return t.push([N.default.Error,R.localize(13,null)]),t;const b=[];if(!w(s,r,a,h,b))for(const $ of b)t.push([N.default.Error,$]);return t}function w(s,r,i,a,h){return a||typeof i.main>"u"&&typeof i.browser>"u"?!0:n(s,r,i.engines.vscode,h)}function d(s,r,i){return s==="*"||n(r,i,s)}function n(s,r,i,a=[]){const h=T(E(i));if(!h)return a.push(R.localize(14,null,i)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return a.push(R.localize(15,null,i)),!1}else if(!h.majorMustEqual)return a.push(R.localize(16,null,i)),!1;return k(s,r,h)?!0:(a.push(R.localize(17,null,s,i)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let r=0,i=s.length;r<i;r++)if(typeof s[r]!="string")return!1;return!0}}),define(Re[70],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=void 0;class I{constructor(R,F=[],M=!1){this.ctor=R,this.staticArguments=F,this.supportsDelayedInstantiation=M}}e.$ni=I}),define(Re[55],Ae([1,0,70]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$os=F,e.$ps=M;const N=[];var R;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function F(m,g,E){g instanceof I.$ni||(g=new I.$ni(g,[],!!E)),N.push([m,g])}function M(){return N}}),define(Re[190],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;class I{constructor(F,M){this.key=F,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$5q=I;class N{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const M of this.a.values())M.outgoing.size===0&&F.push(M);return F}insertEdge(F,M){const m=this.lookupOrInsertNode(F),g=this.lookupOrInsertNode(M);m.outgoing.set(g.key,g),g.incoming.set(m.key,m)}removeNode(F){const M=this.b(F);this.a.delete(M);for(const m of this.a.values())m.outgoing.delete(M),m.incoming.delete(M)}lookupOrInsertNode(F){const M=this.b(F);let m=this.a.get(M);return m||(m=new I(M,F),this.a.set(M,m)),m}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[M,m]of this.a)F.push(`${M}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,M]of this.a){const m=new Set([F]),g=this.c(M,m);if(g)return g}}c(F,M){for(const[m,g]of F.outgoing){if(M.has(m))return[...M,m].join(" -> ");M.add(m);const E=this.c(g,M);if(E)return E;M.delete(m)}}}e.$6q=N}),define(Re[3],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e._util=void 0,e.$qi=R,e.$ri=F;var I;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function m(g){return g[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=m})(I||(e._util=I={})),e.$pi=R("instantiationService");function N(M,m,g){m[I.DI_TARGET]===m?m[I.DI_DEPENDENCIES].push({id:M,index:g}):(m[I.DI_DEPENDENCIES]=[{id:M,index:g}],m[I.DI_TARGET]=m)}function R(M){if(I.serviceIds.has(M))return I.serviceIds.get(M);const m=function(g,E,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(m,g,T)};return m.toString=()=>M,I.serviceIds.set(M,m),m}function F(M){return M}}),define(Re[48],Ae([1,0,17,2,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Wi=void 0,e.$Xi=F,e.$Yi=M,e.$Zi=g,e.$1i=E,e.$2i=T,e.$3i=k,e.$4i=u,e.$5i=d,e.$6i=n,e.$7i=o,e.$Wi=(0,R.$qi)("configurationService");function F(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof N.URI)}function M(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof N.URI)}var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function g(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function T(s,r){const i=Object.create(null);for(const a in s)k(i,a,s[a],r);return i}function k(s,r,i,a){const h=r.split("."),t=h.pop();let b=s;for(let c=0;c<h.length;c++){const $=h[c];let v=b[$];switch(typeof v){case"undefined":v=b[$]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${h.slice(0,c+1).join(".")} is ${JSON.stringify(v)}`);return}b=v}if(typeof b=="object"&&b!==null)try{b[t]=i}catch{a(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(b)}`)}else a(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(b)}`)}function u(s,r){const i=r.split(".");w(s,i)}function w(s,r){const i=r.shift();if(r.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const a=s[i];typeof a=="object"&&!Array.isArray(a)&&(w(a,r),Object.keys(a).length===0&&delete s[i])}}function d(s,r,i){function a(b,c){let $=b;for(const v of c){if(typeof $!="object"||$===null)return;$=$[v]}return $}const h=r.split("."),t=a(s,h);return typeof t>"u"?i:t}function n(s,r,i){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in s?I.$6f(s[a])&&I.$6f(r[a])?n(s[a],r[a],i):i&&(s[a]=r[a]):s[a]=r[a])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Re[31],Ae([1,0,21,15,188,3,154,14]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$oj=e.$nj=e.ContextKeyExprType=void 0,e.$mj=E,e.$pj=b,e.$qj=c,e.$Jj=re;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",I.$j),g.set("isLinux",I.$k),g.set("isWindows",I.$i),g.set("isWeb",I.$o),g.set("isMacNative",I.$j&&!I.$o),g.set("isEdge",I.$H),g.set("isFirefox",I.$F),g.set("isChrome",I.$E),g.set("isSafari",I.$G);function E(ne,U){if(g.get(ne)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(ne,U)}const T=Object.prototype.hasOwnProperty;var k;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const u={regexParsingWithErrorRecovery:!0},w=(0,M.localize)(0,null),d=(0,M.localize)(1,null),n=(0,M.localize)(2,null),o=(0,M.localize)(3,null),s=(0,M.localize)(4,null),r=(0,M.localize)(5,null),i=(0,M.localize)(6,null),a=(0,M.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=u){this.k=U,this.d=new R.$lj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const be=this.D(),Ne=be.type===17?r:void 0;throw this.h.push({message:s,offset:be.offset,lexeme:R.$lj.getLexeme(be),additionalInfo:Ne}),h.c}return x}catch(x){if(x!==h.c)throw x;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const x=this.o();U.push(x)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const x=this.s();U.push(x)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),v.INSTANCE;case 12:return this.z(),p.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,o),x?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const x=this.l();return this.A(1,o),x}case 17:{const x=U.lexeme;if(this.z(),this.y(9)){const Ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ne.type!==10)throw this.B("REGEX",Ne);const Ee=Ne.lexeme,$e=Ee.lastIndexOf("/"),fe=$e===Ee.length-1?void 0:this.w(Ee.substring($e+1));let Q;try{Q=new RegExp(Ee.substring(1,$e),fe)}catch{throw this.B("REGEX",Ne)}return j.create(x,Q)}switch(Ne.type){case 10:case 19:{const Ee=[Ne.lexeme];this.z();let $e=this.D(),fe=0;for(let Te=0;Te<Ne.lexeme.length;Te++)Ne.lexeme.charCodeAt(Te)===40?fe++:Ne.lexeme.charCodeAt(Te)===41&&fe--;for(;!this.E()&&$e.type!==15&&$e.type!==16;){switch($e.type){case 0:fe++;break;case 1:fe--;break;case 10:case 18:for(let Te=0;Te<$e.lexeme.length;Te++)$e.lexeme.charCodeAt(Te)===40?fe++:Ne.lexeme.charCodeAt(Te)===41&&fe--}if(fe<0)break;Ee.push(R.$lj.getLexeme($e)),this.z(),$e=this.D()}const Q=Ee.join(""),Y=Q.lastIndexOf("/"),le=Y===Q.length-1?void 0:this.w(Q.substring(Y+1));let de;try{de=new RegExp(Q.substring(1,Y),le)}catch{throw this.B("REGEX",Ne)}return t.regex(x,de)}case 18:{const Ee=Ne.lexeme;this.z();let $e=null;if(!(0,N.$3e)(Ee)){const fe=Ee.indexOf("/"),Q=Ee.lastIndexOf("/");if(fe!==Q&&fe>=0){const Y=Ee.slice(fe+1,Q),le=Ee[Q+1]==="i"?"i":"";try{$e=new RegExp(Y,le)}catch{throw this.B("REGEX",Ne)}}}if($e===null)throw this.B("REGEX",Ne);return j.create(x,$e)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,n);const Ne=this.u();return t.notIn(x,Ne)}switch(this.D().type){case 3:{this.z();const Ne=this.u();if(this.x().type===18)return t.equals(x,Ne);switch(Ne){case"true":return t.has(x);case"false":return t.not(x);default:return t.equals(x,Ne)}}case 4:{this.z();const Ne=this.u();if(this.x().type===18)return t.notEquals(x,Ne);switch(Ne){case"true":return t.not(x);case"false":return t.has(x);default:return t.notEquals(x,Ne)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),A.create(x,this.u());case 7:return this.z(),V.create(x,this.u());case 8:return this.z(),W.create(x,this.u());case 13:return this.z(),t.in(x,this.u());default:return t.has(x)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:a}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,x){if(this.C(U))return this.z();throw this.B(x,this.D())}B(U,x,be){const Ne=(0,M.localize)(8,null,U,R.$lj.getLexeme(x)),Ee=x.offset,$e=R.$lj.getLexeme(x);return this.h.push({message:Ne,offset:Ee,lexeme:$e,additionalInfo:be}),h.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$nj=h;class t{static false(){return v.INSTANCE}static true(){return p.INSTANCE}static has(U){return l.create(U)}static equals(U,x){return D.create(U,x)}static notEquals(U,x){return y.create(U,x)}static regex(U,x){return j.create(U,x)}static in(U,x){return f.create(U,x)}static notIn(U,x){return S.create(U,x)}static not(U){return C.create(U)}static and(...U){return ce.create(U,null,!0)}static or(...U){return ve.create(U,null,!0)}static greater(U,x){return V.create(U,x)}static greaterEquals(U,x){return W.create(U,x)}static smaller(U,x){return q.create(U,x)}static smallerEquals(U,x){return A.create(U,x)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$oj=t;function b(ne){const U=new h({regexParsingWithErrorRecovery:!1});return ne.map(x=>(U.parse(x),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,M.localize)(9,null,be.additionalInfo):(0,M.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function c(ne,U){const x=ne?ne.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!x&&!be?!0:!x||!be?!1:x.equals(be)}function $(ne,U){return ne.cmp(U)}class v{static{this.INSTANCE=new v}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return p.INSTANCE}}e.$rj=v;class p{static{this.INSTANCE=new p}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return v.INSTANCE}}e.$sj=p;class l{static create(U,x=null){const be=g.get(U);return typeof be=="boolean"?be?p.INSTANCE:v.INSTANCE:new l(U,x)}constructor(U,x){this.key=U,this.c=x,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=g.get(this.key);return typeof U=="boolean"?U?p.INSTANCE:v.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$tj=l;class D{static create(U,x,be=null){if(typeof x=="boolean")return x?l.create(U,be):C.create(U,be);const Ne=g.get(U);return typeof Ne=="boolean"?x===(Ne?"true":"false")?p.INSTANCE:v.INSTANCE:new D(U,x,be)}constructor(U,x,be){this.c=U,this.d=x,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:pe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=g.get(this.c);if(typeof U=="boolean"){const x=U?"true":"false";return this.d===x?p.INSTANCE:v.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$uj=D;class f{static create(U,x){return new f(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:pe(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const x=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(x)?x.includes(be):typeof be=="string"&&typeof x=="object"&&x!==null?T.call(x,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$vj=f;class S{static create(U,x){return new S(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=11,this.c=f.create(U,x)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$wj=S;class y{static create(U,x,be=null){if(typeof x=="boolean")return x?C.create(U,be):l.create(U,be);const Ne=g.get(U);return typeof Ne=="boolean"?x===(Ne?"true":"false")?v.INSTANCE:p.INSTANCE:new y(U,x,be)}constructor(U,x,be){this.c=U,this.d=x,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:pe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=g.get(this.c);if(typeof U=="boolean"){const x=U?"true":"false";return this.d===x?v.INSTANCE:p.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$xj=y;class C{static create(U,x=null){const be=g.get(U);return typeof be=="boolean"?be?v.INSTANCE:p.INSTANCE:new C(U,x)}constructor(U,x){this.c=U,this.d=x,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=g.get(this.c);return typeof U=="boolean"?U?v.INSTANCE:p.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$yj=C;function P(ne,U){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?U(ne):v.INSTANCE}class V{static create(U,x,be=null){return P(x,Ne=>new V(U,Ne,be))}constructor(U,x,be){this.c=U,this.d=x,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:pe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$zj=V;class W{static create(U,x,be=null){return P(x,Ne=>new W(U,Ne,be))}constructor(U,x,be){this.c=U,this.d=x,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:pe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Aj=W;class q{static create(U,x,be=null){return P(x,Ne=>new q(U,Ne,be))}constructor(U,x,be){this.c=U,this.d=x,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:pe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Bj=q;class A{static create(U,x,be=null){return P(x,Ne=>new A(U,Ne,be))}constructor(U,x,be){this.c=U,this.d=x,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:pe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Cj=A;class j{static create(U,x){return new j(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const x=this.f?this.f.source:"",be=U.f?U.f.source:"";return x<be?-1:x>be?1:0}equals(U){if(U.type===this.type){const x=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&x===be}return!1}substituteConstants(){return this}evaluate(U){const x=U.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Dj=j;class K{static create(U){return new K(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new K(this.c.map(U))}negate(){return this.c}}e.$Ej=K;function ie(ne){let U=null;for(let x=0,be=ne.length;x<be;x++){const Ne=ne[x].substituteConstants();if(ne[x]!==Ne&&U===null){U=[];for(let Ee=0;Ee<x;Ee++)U[Ee]=ne[Ee]}U!==null&&(U[x]=Ne)}return U===null?ne:U}class ce{static create(U,x,be){return ce.d(U,x,be)}constructor(U,x){this.expr=U,this.c=x,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let x=0,be=this.expr.length;x<be;x++){const Ne=$(this.expr[x],U.expr[x]);if(Ne!==0)return Ne}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].equals(U.expr[x]))return!1;return!0}return!1}substituteConstants(){const U=ie(this.expr);return U===this.expr?this:ce.create(U,this.c,!1)}evaluate(U){for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].evaluate(U))return!1;return!0}static d(U,x,be){const Ne=[];let Ee=!1;for(const $e of U)if($e){if($e.type===1){Ee=!0;continue}if($e.type===0)return v.INSTANCE;if($e.type===6){Ne.push(...$e.expr);continue}Ne.push($e)}if(Ne.length===0&&Ee)return p.INSTANCE;if(Ne.length!==0){if(Ne.length===1)return Ne[0];Ne.sort($);for(let $e=1;$e<Ne.length;$e++)Ne[$e-1].equals(Ne[$e])&&(Ne.splice($e,1),$e--);if(Ne.length===1)return Ne[0];for(;Ne.length>1;){const $e=Ne[Ne.length-1];if($e.type!==9)break;Ne.pop();const fe=Ne.pop(),Q=Ne.length===0,Y=ve.create($e.expr.map(le=>ce.create([le,fe],null,be)),null,Q);Y&&(Ne.push(Y),Ne.sort($))}if(Ne.length===1)return Ne[0];if(be){for(let $e=0;$e<Ne.length;$e++)for(let fe=$e+1;fe<Ne.length;fe++)if(Ne[$e].negate().equals(Ne[fe]))return v.INSTANCE;if(Ne.length===1)return Ne[0]}return new ce(Ne,x)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const x of this.expr)U.push(...x.keys());return U}map(U){return new ce(this.expr.map(x=>x.map(U)),null)}negate(){if(!this.c){const U=[];for(const x of this.expr)U.push(x.negate());this.c=ve.create(U,this,!0)}return this.c}}e.$Fj=ce;class ve{static create(U,x,be){return ve.d(U,x,be)}constructor(U,x){this.expr=U,this.c=x,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let x=0,be=this.expr.length;x<be;x++){const Ne=$(this.expr[x],U.expr[x]);if(Ne!==0)return Ne}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let x=0,be=this.expr.length;x<be;x++)if(!this.expr[x].equals(U.expr[x]))return!1;return!0}return!1}substituteConstants(){const U=ie(this.expr);return U===this.expr?this:ve.create(U,this.c,!1)}evaluate(U){for(let x=0,be=this.expr.length;x<be;x++)if(this.expr[x].evaluate(U))return!0;return!1}static d(U,x,be){let Ne=[],Ee=!1;if(U){for(let $e=0,fe=U.length;$e<fe;$e++){const Q=U[$e];if(Q){if(Q.type===0){Ee=!0;continue}if(Q.type===1)return p.INSTANCE;if(Q.type===9){Ne=Ne.concat(Q.expr);continue}Ne.push(Q)}}if(Ne.length===0&&Ee)return v.INSTANCE;Ne.sort($)}if(Ne.length!==0){if(Ne.length===1)return Ne[0];for(let $e=1;$e<Ne.length;$e++)Ne[$e-1].equals(Ne[$e])&&(Ne.splice($e,1),$e--);if(Ne.length===1)return Ne[0];if(be){for(let $e=0;$e<Ne.length;$e++)for(let fe=$e+1;fe<Ne.length;fe++)if(Ne[$e].negate().equals(Ne[fe]))return p.INSTANCE;if(Ne.length===1)return Ne[0]}return new ve(Ne,x)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const x of this.expr)U.push(...x.keys());return U}map(U){return new ve(this.expr.map(x=>x.map(U)),null)}negate(){if(!this.c){const U=[];for(const x of this.expr)U.push(x.negate());for(;U.length>1;){const x=U.shift(),be=U.shift(),Ne=[];for(const Ee of Le(x))for(const $e of Le(be))Ne.push(ce.create([Ee,$e],null,!1));U.unshift(ve.create(Ne,null,!1))}this.c=ve.create(U,this,!0)}return this.c}}e.$Gj=ve;class Ie extends l{static{this.d=[]}static all(){return Ie.d.values()}constructor(U,x,be){super(U,null),this.f=x,typeof be=="object"?Ie.d.push({...be,key:U}):be!==!0&&Ie.d.push({key:U,description:be,type:x!=null?typeof x:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return y.create(this.key,U)}}e.$Hj=Ie,e.$Ij=(0,F.$qi)("contextKeyService");function ue(ne,U){return ne<U?-1:ne>U?1:0}function pe(ne,U,x,be){return ne<x?-1:ne>x?1:U<be?-1:U>be?1:0}function re(ne,U){if(ne.type===0||U.type===1)return!0;if(ne.type===9)return U.type===9?Se(ne.expr,U.expr):!1;if(U.type===9){for(const x of U.expr)if(re(ne,x))return!0;return!1}if(ne.type===6){if(U.type===6)return Se(U.expr,ne.expr);for(const x of ne.expr)if(re(x,U))return!0;return!1}return ne.equals(U)}function Se(ne,U){let x=0,be=0;for(;x<ne.length&&be<U.length;){const Ne=ne[x].cmp(U[be]);if(Ne<0)return!1;Ne===0&&x++,be++}return x===ne.length}function Le(ne){return ne.type===9?ne.expr:[ne]}}),define(Re[191],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=void 0,e.$xi=(0,I.$qi)("environmentService"),e.$yi=(0,I.$ri)(e.$xi)}),define(Re[98],Ae([1,0,156,3]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.ExtensionGalleryErrorCode=e.$1o=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$To=R,e.$Uo=F,e.$Vo=M,e.$Wo=m,e.$Xo=g,e.$Yo=E,e.$No="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Oo=new RegExp(e.$No),e.$Po="__web_extension",e.$Qo="skipWalkthrough",e.$Ro="extensionsSync",e.$So="dependecyOrPackExtensionInstall";function R(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function F(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(i,a){switch(i){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function m(i,a){return a==="web"&&!i.includes("web")}function g(i,a,h){return m(a,h)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===h}function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var T;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var k;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var u;(function(i){i.Install="install",i.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var w;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$Zo=(0,N.$qi)("extensionGalleryService");var d;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(d||(e.ExtensionManagementErrorCode=d={}));var n;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(n||(e.ExtensionSignaturetErrorCode=n={}));class o extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$1o=o;var s;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class r extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$2o=r,e.$3o=(0,N.$qi)("extensionManagementService"),e.$4o="extensionsIdentifiers/disabled",e.$5o="extensionsIdentifiers/enabled",e.$6o=(0,N.$qi)("IGlobalExtensionEnablementService"),e.$7o=(0,N.$qi)("IExtensionTipsService"),e.$8o=(0,I.localize2)(0,"Extensions"),e.$9o=(0,I.localize2)(1,"Preferences")}),define(Re[43],Ae([1,0,52,19,15,17,2,158,3,21,12,40]),function(ge,e,I,N,R,F,M,m,g,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$pl=e.FileKind=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.FileOperationResult=e.$hl=e.$gl=e.$fl=e.$dl=e.FileChangeType=e.$cl=e.FileOperation=e.$9k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Wk=void 0,e.$Xk=u,e.$Yk=n,e.$Zk=s,e.$1k=r,e.$2k=i,e.$3k=a,e.$4k=h,e.$5k=t,e.$6k=b,e.$7k=c,e.$8k=$,e.$0k=l,e.$$k=D,e.$_k=f,e.$al=S,e.$bl=y,e.$el=q,e.$ql=ve,e.$rl=Ie,e.$tl=pe,e.$Wk=(0,g.$qi)("fileService");function u(re){return re.create===!0}var w;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var d;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(d||(e.FilePermission=d={}));function n(re){const Se=re;return!!Se&&typeof Se.onDidChange=="function"}var o;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function s(re){return!!(re.capabilities&2)}function r(re){return!!(re.capabilities&8)}function i(re){return!!(re.capabilities&131072)}function a(re){return!!(re.capabilities&4)}function h(re){return!!(re.capabilities&16)}function t(re){return s(re)?!!(re.capabilities&16384):!1}function b(re){return s(re)?!!(re.capabilities&32768):!1}function c(re){return!!(re.capabilities&65536)}function $(re){return!!(re.capabilities&2048)}var v;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class p extends Error{static create(Se,Le){const ne=new p(Se.toString(),Le);return f(ne,Le),ne}constructor(Se,Le){super(Se),this.code=Le}}e.$9k=p;function l(re,Se){return p.create(re,Se)}function D(re){return re||l((0,m.localize)(0,null),v.Unknown)}function f(re,Se){return re.name=Se?`${Se} (FileSystemError)`:"FileSystemError",re}function S(re){if(!re)return v.Unknown;if(re instanceof p)return re.code;const Se=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Se)return v.Unknown;switch(Se[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}function y(re){if(re instanceof A)return re.fileOperationResult;switch(S(re)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}var C;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class P{constructor(Se,Le,ne){this.resource=Se,this.operation=Le,this.target=ne}isOperation(Se){return this.operation===Se}}e.$cl=P;var V;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class W{static{this.a=null}constructor(Se,Le){this.c=Le,this.b=void 0,this.d=new k.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawAdded.map(U=>[U,!0])),ne}),this.f=new k.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawUpdated.map(U=>[U,!0])),ne}),this.g=new k.$V(()=>{const ne=I.$wi.forUris(()=>this.c);return ne.fill(this.rawDeleted.map(U=>[U,!0])),ne}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ne of Se){switch(ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}this.b!==W.a&&(typeof ne.cId=="number"?this.b===void 0?this.b=ne.cId:this.b!==ne.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains(Se,...Le){return this.h(Se,{includeChildren:!1},...Le)}affects(Se,...Le){return this.h(Se,{includeChildren:!0},...Le)}h(Se,Le,...ne){if(!Se)return!1;const U=ne.length>0;return!!((!U||ne.includes(1))&&(this.d.value.get(Se)||Le.includeChildren&&this.d.value.findSuperstr(Se))||(!U||ne.includes(0))&&(this.f.value.get(Se)||Le.includeChildren&&this.f.value.findSuperstr(Se))||(!U||ne.includes(2))&&(this.g.value.findSubstr(Se)||Le.includeChildren&&this.g.value.findSuperstr(Se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Se){return this.b===Se}hasCorrelation(){return typeof this.b=="number"}}e.$dl=W;function q(re,Se,Le){return!re||!Se||re===Se||Se.length>re.length?!1:(Se.charAt(Se.length-1)!==N.sep&&(Se+=N.sep),Le?(0,R.$uf)(re,Se):re.indexOf(Se)===0)}class A extends Error{constructor(Se,Le,ne){super(Se),this.fileOperationResult=Le,this.options=ne}}e.$fl=A;class j extends A{constructor(Se,Le,ne,U){super(Se,Le,U),this.fileOperationResult=Le,this.size=ne}}e.$gl=j;class K extends A{constructor(Se,Le,ne){super(Se,2,ne),this.stat=Le}}e.$hl=K;var ie;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$il={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$jl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$kl="files.associations",e.$ll="files.exclude",e.$ml="files.readonlyInclude",e.$nl="files.readonlyExclude",e.$ol="files.readonlyFromPermissions";var ce;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$pl="";function ve(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function Ie(re,Se){if(!Se.hasProvider(M.URI.from({scheme:re.scheme})))return new Promise(Le=>{const ne=Se.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===re.scheme&&U.added&&(ne.dispose(),Le())})})}class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize(Se){return(0,F.$8f)(Se)||(Se=0),Se<ue.KB?(0,m.localize)(1,null,Se.toFixed(0)):Se<ue.MB?(0,m.localize)(2,null,(Se/ue.KB).toFixed(2)):Se<ue.GB?(0,m.localize)(3,null,(Se/ue.MB).toFixed(2)):Se<ue.TB?(0,m.localize)(4,null,(Se/ue.GB).toFixed(2)):(0,m.localize)(5,null,(Se/ue.TB).toFixed(2))}}e.$sl=ue;function pe(re){const Se=typeof re=="string"||re?.scheme===T.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===T.Schemas.file?1024*ue.MB:Se?10*ue.MB:E.$o?50*ue.MB:1024*ue.MB}}),define(Re[71],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=void 0;class I{constructor(...R){this.a=new Map;for(const[F,M]of R)this.set(F,M)}set(R,F){const M=this.a.get(R);return this.a.set(R,F),M}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$oi=I}),define(Re[192],Ae([1,0,11,14,6,70,190,3,71,193]),function(ge,e,I,N,R,F,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=void 0;const T=!1;class k extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new g.$oi,s=!1,r,i=T){this.i=o,this.j=s,this.k=r,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(m.$pi,this),this._globalGraph=i?r?._globalGraph??new M.$6q(a=>a):void 0}dispose(){if(!this.f){this.f=!0,(0,R.$Pc)(this.h),this.h.clear();for(const o of this.g)(0,R.$Oc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o){this.m();const s=new class extends u{dispose(){this.h.delete(s),super.dispose()}}(o,this.j,this,this.l);return this.h.add(s),s}invokeFunction(o,...s){this.m();const r=d.traceInvocation(this.l,o);let i=!1;try{return o({get:h=>{if(i)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(h,r);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...s)}finally{i=!0,r.stop()}}createInstance(o,...s){this.m();let r,i;return o instanceof F.$ni?(r=d.traceCreation(this.l,o.ctor),i=this.o(o.ctor,o.staticArguments.concat(s),r)):(r=d.traceCreation(this.l,o),i=this.o(o,s,r)),r.stop(),i}o(o,s=[],r){const i=m._util.getServiceDependencies(o).sort((t,b)=>t.index-b.index),a=[];for(const t of i){const b=this.s(t.id,r);b||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(b)}const h=i.length>0?i[0].index:s.length;if(s.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${s.length} static arguments`);const t=h-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,h)}return Reflect.construct(o,s.concat(a))}q(o,s){if(this.i.get(o)instanceof F.$ni)this.i.set(o,s);else if(this.k)this.k.q(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const s=this.i.get(o);return!s&&this.k?this.k.r(o):s}s(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const r=this.r(o);return r instanceof F.$ni?this.u(o,r,s.branch(o,!0)):(s.branch(o,!1),r)}u(o,s,r){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,s,r)}finally{this.t.delete(o)}}v(o,s,r){const i=new M.$6q(t=>t.id.toString());let a=0;const h=[{id:o,desc:s,_trace:r}];for(;h.length;){const t=h.pop();if(i.lookupOrInsertNode(t),a++>1e3)throw new k(i);for(const b of m._util.getServiceDependencies(t.desc.ctor)){const c=this.r(b.id);if(c||this.y(`[createInstance] ${o} depends on ${b.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(b.id)),c instanceof F.$ni){const $={id:b.id,desc:c,_trace:t._trace.branch(b.id,!0)};i.insertEdge(t,$),h.push($)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new k(i);break}for(const{data:b}of t){if(this.r(b.id)instanceof F.$ni){const $=this.w(b.id,b.desc.ctor,b.desc.staticArguments,b.desc.supportsDelayedInstantiation,b._trace);this.q(b.id,$)}i.removeNode(b)}}return this.r(o)}w(o,s,r=[],i,a){if(this.i.get(o)instanceof F.$ni)return this.x(o,s,r,i,a,this.g);if(this.k)return this.k.w(o,s,r,i,a);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}x(o,s,r=[],i,a,h){if(i){const t=new u(void 0,this.j,this,this.l);t.c=String(o);const b=new Map,c=new I.$Jh(()=>{const $=t.o(s,r,a);for(const[v,p]of b){const l=$[v];if(typeof l=="function")for(const D of p)D.disposable=l.apply($,D.listener)}return b.clear(),h.add($),$});return new Proxy(Object.create(null),{get($,v){if(!c.isInitialized&&typeof v=="string"&&(v.startsWith("onDid")||v.startsWith("onWill"))){let D=b.get(v);return D||(D=new E.$5c,b.set(v,D)),(S,y,C)=>{if(c.isInitialized)return c.value[v](S,y,C);{const P={listener:[S,y,C],disposable:void 0},V=D.push(P);return(0,R.$Sc)(()=>{V(),P.disposable?.dispose()})}}}if(v in $)return $[v];const p=c.value;let l=p[v];return typeof l!="function"||(l=l.bind(p),$[v]=l),l},set($,v,p){return c.value[v]=p,!0},getPrototypeOf($){return s.prototype}})}else{const t=this.o(s,r,a);return h.add(t),t}}y(o,s){if(s&&console.warn(o),this.j)throw new Error(o)}}e.$7q=u;var w;(function(n){n[n.None=0]="None",n[n.Creation=1]="Creation",n[n.Invocation=2]="Invocation",n[n.Branch=3]="Branch"})(w||(w={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new d(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(o,s){return o?new d(1,s.name):d.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const r=new d(3,o.toString());return this.h.push([o,s,r]),r}stop(){const o=Date.now()-this.g;d.f+=o;let s=!1;function r(a,h){const t=[],b=new Array(a+1).join("	");for(const[c,$,v]of h.h)if($&&v){s=!0,t.push(`${b}CREATES -> ${c}`);const p=r(a+1,v);p&&t.push(p)}else t.push(`${b}uses -> ${c}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(o>2||s)&&d.all.add(i.join(`
`))}}e.$8q=d}),define(Re[13],Ae([1,0,159,42,5,99,6,28,21,23,17,2,31,3]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$Zj=e.LogLevel=e.$Xj=e.$Wj=void 0,e.$Yj=n,e.log=s,e.$$j=l,e.$_j=D,e.$ak=f,e.$bk=S,e.$Wj=(0,w.$qi)("logService"),e.$Xj=(0,w.$qi)("loggerService");function d(){return new Date().toISOString()}function n(y){return(0,T.$8f)(y)}var o;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Zj=o.Info;function s(y,C,P){switch(C){case o.Trace:y.trace(P);break;case o.Debug:y.debug(P);break;case o.Info:y.info(P);break;case o.Warning:y.warn(P);break;case o.Error:y.error(P);break;case o.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function r(y,C=!1){let P="";for(let V=0;V<y.length;V++){let W=y[V];if(W instanceof Error&&(W=(0,N.$bj)(W,C)),typeof W=="object")try{W=JSON.stringify(W)}catch{}P+=(V>0?" ":"")+W}return P}class i extends M.$Uc{constructor(){super(...arguments),this.b=e.$Zj,this.c=this.B(new R.$be),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==o.Off&&this.b<=C}}e.$2j=i;class a extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...P){this.f(o.Trace)&&this.g(o.Trace,r([C,...P],!0))}debug(C,...P){this.f(o.Debug)&&this.g(o.Debug,r([C,...P]))}info(C,...P){this.f(o.Info)&&this.g(o.Info,r([C,...P]))}warn(C,...P){this.f(o.Warning)&&this.g(o.Warning,r([C,...P]))}error(C,...P){if(this.f(o.Error))if(C instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=C.stack,this.g(o.Error,r(V))}else this.g(o.Error,r([C,...P]))}flush(){}}e.$3j=a;class h extends i{constructor(C=e.$Zj){super(),this.setLevel(C),this.g=!g.$i}trace(C,...P){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,...P):console.log(`[main ${d()}]`,C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,...P):console.log(`[main ${d()}]`,C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,C,...P):console.log(`[main ${d()}]`,C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,C,...P):console.warn(`[main ${d()}]`,C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,C,...P):console.error(`[main ${d()}]`,C,...P))}flush(){}}e.$4j=h;class t extends i{constructor(C=e.$Zj,P=!0){super(),this.g=P,this.setLevel(C)}trace(C,...P){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...P):console.log(C,...P))}debug(C,...P){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...P):console.log(C,...P))}info(C,...P){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...P):console.log(C,...P))}warn(C,...P){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...P):console.log(C,...P))}error(C,...P){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...P):console.error(C,...P))}flush(){}}e.$5j=t;class b extends i{constructor(C,P=e.$Zj){super(),this.g=C,this.setLevel(P)}trace(C,...P){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(C),...P])}debug(C,...P){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(C),...P])}info(C,...P){this.f(o.Info)&&this.g.log(o.Info,[this.h(C),...P])}warn(C,...P){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(C),...P])}error(C,...P){this.f(o.Error)&&this.g.log(o.Error,[this.h(C),...P])}h(C){return typeof C=="string"?C:(0,N.$bj)(C,this.f(o.Trace))}flush(){}}e.$6j=b;class c extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const P of this.g)P.setLevel(C);super.setLevel(C)}trace(C,...P){for(const V of this.g)V.trace(C,...P)}debug(C,...P){for(const V of this.g)V.debug(C,...P)}info(C,...P){for(const V of this.g)V.info(C,...P)}warn(C,...P){for(const V of this.g)V.warn(C,...P)}error(C,...P){for(const V of this.g)V.error(C,...P)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$7j=c;class $ extends M.$Uc{constructor(C,P,V){if(super(),this.h=C,this.j=P,this.b=new m.$Bc,this.c=this.B(new R.$be),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$be),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$be),this.onDidChangeVisibility=this.g.event,V)for(const W of V)this.b.set(W.resource,{logger:void 0,info:W})}m(C){return(0,T.$4f)(C)?[...this.b.values()].find(P=>P.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,P){const V=this.n(C),W=(0,T.$4f)(C)?C:P?.id??(0,F.$ej)(V.toString()).toString(16);let q=this.b.get(V)?.logger;const A=P?.logLevel==="always"?o.Trace:P?.logLevel;q||(q=this.s(V,A??this.getLogLevel(V)??this.h,{...P,id:W}));const j={logger:q,info:{resource:V,id:W,logLevel:A,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(j.info),this.b.set(V,j),q}n(C){return(0,T.$4f)(C)?(0,E.$4g)(this.j,`${C}.log`):C}setLogLevel(C,P){if(k.URI.isUri(C)){const V=C,W=P,q=this.b.get(V);q&&W!==q.info.logLevel&&(q.info.logLevel=W===this.h?void 0:W,q.logger?.setLevel(W),this.b.set(q.info.resource,q),this.f.fire([V,W]))}else{this.h=C;for(const[V,W]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,P){const V=this.m(C);V&&P!==!V.info.hidden&&(V.info.hidden=!P,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,P]))}getLogLevel(C){let P;return C&&(P=this.b.get(C)?.info.logLevel),P??this.h}registerLogger(C){const P=this.b.get(C.resource);P?P.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const P=this.b.get(C);P&&(P.logger&&P.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$8j=$;class v{constructor(){this.onDidChangeLogLevel=new R.$be().event}setLevel(C){}getLevel(){return o.Info}trace(C,...P){}debug(C,...P){}info(C,...P){}warn(C,...P){}error(C,...P){}critical(C,...P){}dispose(){}flush(){}}e.$9j=v;class p extends v{}e.$0j=p;function l(y){if(y.verbose)return o.Trace;if(typeof y.logLevel=="string"){const C=S(y.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Zj}function D(y){switch(y){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function f(y){switch(y){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function S(y){switch(y){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$ck=new u.$Hj("logLevel",D(o.Info))}),define(Re[194],Ae([1,0,6,13]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yQ=void 0;class R extends I.$Uc{constructor(M,m=[]){super(),this.a=new N.$7j([M,...m]),this.B(M.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...m){this.a.trace(M,...m)}debug(M,...m){this.a.debug(M,...m)}info(M,...m){this.a.info(M,...m)}warn(M,...m){this.a.warn(M,...m)}error(M,...m){this.a.error(M,...m)}flush(){this.a.flush()}}e.$yQ=R}),define(Re[100],Ae([1,0,33,160,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var M;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(g){function E(d,n){return n-d}g.compare=E;const T=Object.create(null);T[g.Error]=(0,N.localize)(0,null),T[g.Warning]=(0,N.localize)(1,null),T[g.Info]=(0,N.localize)(2,null);function k(d){return T[d]||""}g.toString=k;function u(d){switch(d){case I.default.Error:return g.Error;case I.default.Warning:return g.Warning;case I.default.Info:return g.Info;case I.default.Ignore:return g.Hint}}g.fromSeverity=u;function w(d){switch(d){case g.Error:return I.default.Error;case g.Warning:return I.default.Warning;case g.Info:return I.default.Info;case g.Hint:return I.default.Ignore}}g.toSeverity=w}(M||(e.MarkerSeverity=M={}));var m;(function(g){const E="";function T(u){return k(u,!0)}g.makeKey=T;function k(u,w){const d=[E];return u.source?d.push(u.source.replace("\xA6","\\\xA6")):d.push(E),u.code?typeof u.code=="string"?d.push(u.code.replace("\xA6","\\\xA6")):d.push(u.code.value.replace("\xA6","\\\xA6")):d.push(E),u.severity!==void 0&&u.severity!==null?d.push(M.toString(u.severity)):d.push(E),u.message&&w?d.push(u.message.replace("\xA6","\\\xA6")):d.push(E),u.startLineNumber!==void 0&&u.startLineNumber!==null?d.push(u.startLineNumber.toString()):d.push(E),u.startColumn!==void 0&&u.startColumn!==null?d.push(u.startColumn.toString()):d.push(E),u.endLineNumber!==void 0&&u.endLineNumber!==null?d.push(u.endLineNumber.toString()):d.push(E),u.endColumn!==void 0&&u.endColumn!==null?d.push(u.endColumn.toString()):d.push(E),d.push(E),d.join("\xA6")}g.makeKeyOptionalMessage=k})(m||(e.IMarkerData=m={})),e.$Tt=(0,R.$qi)("markerService")}),define(Re[195],Ae([1,0,5,33,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wv=e.$Vv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Tv=e.Severity=void 0,e.$Uv=m,e.Severity=N.default,e.$Tv=(0,R.$qi)("notificationService");var F;(function(k){k[k.DEFAULT=0]="DEFAULT",k[k.SILENT=1]="SILENT",k[k.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var M;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function m(k){if(k){const u=k;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var g;(function(k){k[k.OFF=0]="OFF",k[k.ERROR=1]="ERROR"})(g||(e.NotificationsFilter=g={}));class E{constructor(){this.progress=new T,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Vv=E;class T{infinite(){}done(){}total(u){}worked(u){}}e.$Wv=T}),define(Re[196],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=void 0,e.$dk=(0,I.$qi)("productService"),e.$ek="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,I,N){var R=arguments.length,F=R<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,I):N,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(ge,e,I,N);else for(var m=ge.length-1;m>=0;m--)(M=ge[m])&&(F=(R<3?M(F):R>3?M(e,I,F):M(e,I))||F);return R>3&&F&&Object.defineProperty(e,I,F),F},Ve=this&&this.__param||function(ge,e){return function(I,N){e(I,N,ge)}};define(Re[101],Ae([1,0,11,24,6,3]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.ProgressLocation=e.$Xv=void 0,e.$Xv=(0,F.$qi)("progressService");var M;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$Yv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Zv=m;class g{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const w=this.d;this.d=()=>{w?.(),u()}}):Promise.resolve()}}e.$1v=g;let E=class extends R.$Uc{constructor(u,w){super(),this.a=new I.$Nh,w.withProgress(u,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,R.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$2v=E,e.$2v=E=Je([Ve(1,e.$Xv)],E);class T extends R.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new R.$Tc)}start(u){this.stop();const w=++this.a,d=new N.$me;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,R.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,R.$Sc)(()=>d.cancel())),this.b.add((0,R.$Sc)(()=>this.c?this.c.done():void 0)),{id:w,token:d.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$3v=T,e.$4v=(0,F.$qi)("editorProgressService")}),define(Re[30],Ae([1,0,56,17]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=void 0;class R{constructor(){this.a=new Map}add(M,m){I.ok(N.$4f(M)),I.ok(N.$6f(m)),I.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,m)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$9n=new R}),define(Re[72],Ae([1,0,5,30]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=void 0,e.$0n={JSONContribution:"base.contributions.json"};function R(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class F{constructor(){this.b=new I.$be,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,E){this.a[R(g)]=E,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const M=new F;N.$9n.add(e.$0n.JSONContribution,M)}),define(Re[57],Ae([1,0,18,5,17,153,48,72,30]),function(ge,e,I,N,R,F,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.ConfigurationScope=e.$bo=e.EditPresentationTypes=void 0,e.$mo=n,e.$no=o,e.$oo=s,e.$po=i,e.$qo=a;var E;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$bo={Configuration:"base.contributions.configuration"};var T;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.$co={properties:{},patternProperties:{}},e.$do={properties:{},patternProperties:{}},e.$eo={properties:{},patternProperties:{}},e.$fo={properties:{},patternProperties:{}},e.$go={properties:{},patternProperties:{}},e.$ho={properties:{},patternProperties:{}},e.$io="vscode://schemas/settings/resourceLanguage",e.$jo="vscode://schemas/settings/configurationDefaults";const k=g.$9n.as(m.$0n.JSONContribution);class u{constructor(){this.h=new Set,this.i=new N.$be,this.onDidSchemaChange=this.i.event,this.j=new N.$be,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$io,this.g),this.v()}registerConfiguration(t,b=!0){this.registerConfigurations([t],b)}registerConfigurations(t,b=!0){const c=new Set;this.n(t,b,c),k.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const b=new Set;this.o(t,b),k.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:b})}updateConfigurations({add:t,remove:b}){const c=new Set;this.o(b,c),this.n(t,!1,c),k.registerSchema(e.$io,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const b=new Set;this.k(t,b),this.i.fire(),this.j.fire({properties:b,defaultsOverrides:!0})}k(t,b){const c=[];for(const{overrides:$,source:v}of t)for(const p in $)if(b.add(p),e.$lo.test(p)){const l=this.a.get(p),D=l?.valuesSources??new Map;if(v)for(const C of Object.keys($[p]))D.set(C,v);const f={...l?.value||{},...$[p]};this.a.set(p,{source:v,value:f,valuesSources:D});const S=(0,M.$7i)(p),y={type:"object",default:f,description:F.localize(1,null,S),$ref:e.$io,defaultDefaultValue:f,source:R.$4f(v)?void 0:v,defaultValueSource:v};c.push(...n(p)),this.d[p]=y,this.b.properties[p]=y}else{this.a.set(p,{value:$[p],source:v});const l=this.d[p];l&&(this.w(p,l),this.r(p,l))}this.m(c)}deregisterDefaultConfigurations(t){const b=new Set;this.l(t,b),this.i.fire(),this.j.fire({properties:b,defaultsOverrides:!0})}l(t,b){for(const{overrides:c,source:$}of t)for(const v in c){const p=this.a.get(v),l=R.$4f($)?$:$?.id,D=R.$4f(p?.source)?p?.source:p?.source?.id;if(l===D)if(b.add(v),this.a.delete(v),e.$lo.test(v))delete this.d[v],delete this.b.properties[v];else{const f=this.d[v];f&&(this.w(v,f),this.r(v,f))}}this.u()}deltaConfiguration(t){let b=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),b=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),b=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:b})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const b of t)this.h.add(b);this.u()}n(t,b,c){t.forEach($=>{this.p($,b,$.extensionInfo,$.restrictedProperties,void 0,c),this.c.push($),this.q($)})}o(t,b){const c=$=>{if($.properties)for(const v in $.properties){b.add(v);const p=this.d[v];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[v],this.s(v,$.properties[v])}$.allOf?.forEach(v=>c(v))};for(const $ of t){c($);const v=this.c.indexOf($);v!==-1&&this.c.splice(v,1)}}p(t,b=!0,c,$,v=3,p){v=R.$ag(t.scope)?v:t.scope;const l=t.properties;if(l)for(const f in l){const S=l[f];if(b&&i(f,S)){delete l[f];continue}if(S.source=c,S.defaultDefaultValue=l[f].default,this.w(f,S),e.$lo.test(f)?S.scope=void 0:(S.scope=R.$ag(S.scope)?v:S.scope,S.restricted=R.$ag(S.restricted)?!!$?.includes(f):S.restricted),l[f].hasOwnProperty("included")&&!l[f].included){this.f[f]=l[f],delete l[f];continue}else this.d[f]=l[f],l[f].policy?.name&&this.e.set(l[f].policy.name,f);!l[f].deprecationMessage&&l[f].markdownDeprecationMessage&&(l[f].deprecationMessage=l[f].markdownDeprecationMessage),p.add(f)}const D=t.allOf;if(D)for(const f of D)this.p(f,b,c,$,v,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const b=c=>{const $=c.properties;if($)for(const p in $)this.r(p,$[p]);c.allOf?.forEach(b)};b(t)}r(t,b){switch(e.$co.properties[t]=b,b.scope){case 1:e.$do.properties[t]=b;break;case 2:e.$eo.properties[t]=b;break;case 6:e.$fo.properties[t]=b;break;case 3:e.$go.properties[t]=b;break;case 4:e.$ho.properties[t]=b;break;case 5:e.$ho.properties[t]=b,this.g.properties[t]=b;break}}s(t,b){switch(delete e.$co.properties[t],b.scope){case 1:delete e.$do.properties[t];break;case 2:delete e.$eo.properties[t];break;case 6:delete e.$fo.properties[t];break;case 3:delete e.$go.properties[t];break;case 4:case 5:delete e.$ho.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const b=`[${t}]`,c={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$io};this.w(b,c),e.$co.properties[b]=c,e.$do.properties[b]=c,e.$eo.properties[b]=c,e.$fo.properties[b]=c,e.$go.properties[b]=c,e.$ho.properties[b]=c}}v(){const t={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$io};e.$co.patternProperties[e.$ko]=t,e.$do.patternProperties[e.$ko]=t,e.$eo.patternProperties[e.$ko]=t,e.$fo.patternProperties[e.$ko]=t,e.$go.patternProperties[e.$ko]=t,e.$ho.patternProperties[e.$ko]=t,this.i.fire()}w(t,b){const c=this.a.get(t);let $=c?.value,v=c?.source;R.$$f($)&&($=b.defaultDefaultValue,v=void 0),R.$$f($)&&($=s(b.type)),b.default=$,b.defaultValueSource=v}}const w="\\[([^\\]]+)\\]",d=new RegExp(w,"g");e.$ko=`^(${w})+$`,e.$lo=new RegExp(e.$ko);function n(h){const t=[];if(e.$lo.test(h)){let b=d.exec(h);for(;b?.length;){const c=b[1].trim();c&&t.push(c),b=d.exec(h)}}return(0,I.$Mb)(t)}function o(h){return h.reduce((t,b)=>`${t}[${b}]`,"")}function s(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const r=new u;g.$9n.add(e.$bo.Configuration,r);function i(h,t){return h.trim()?e.$lo.test(h)?F.localize(7,null,h):r.getConfigurationProperties()[h]!==void 0?F.localize(8,null,h):t.policy?.name&&r.getPolicyConfigurations().get(t.policy?.name)!==void 0?F.localize(9,null,h,t.policy?.name,r.getPolicyConfigurations().get(t.policy?.name)):null:F.localize(6,null)}function a(){const h=[],t=r.getConfigurationProperties();for(const b of Object.keys(t))h.push([b,t[b].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Re[197],Ae([1,0,18,5,123,6,28,26,17,2,48,57,30]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$uo=e.$to=e.$so=e.$ro=void 0,e.$vo=i;function w(b){return Object.isFrozen(b)?b:m.$Xn(b)}class d{constructor(c={},$=[],v=[],p){this.b=c,this.c=$,this.d=v,this.raw=p,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map($=>{if($ instanceof d)return $;const v=new n("");return v.parseRaw($),v.configurationModel});this.f=c.reduce(($,v)=>v===$?v:$.merge(v),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,T.$5i)(this.contents,c):this.contents}inspect(c,$){const v=this;return{get value(){return w(v.rawConfiguration.getValue(c))},get override(){return $?w(v.rawConfiguration.getOverrideValue(c,$)):void 0},get merged(){return w($?v.rawConfiguration.override($).getValue(c):v.rawConfiguration.getValue(c))},get overrides(){const p=[];for(const{contents:l,identifiers:D,keys:f}of v.rawConfiguration.overrides){const S=new d(l,f).getValue(c);S!==void 0&&p.push({identifiers:D,value:S})}return p.length?w(p):void 0}}}getOverrideValue(c,$){const v=this.i($);return v?c?(0,T.$5i)(v,c):v:void 0}getKeysForOverrideIdentifier(c){const $=[];for(const v of this.overrides)v.identifiers.includes(c)&&$.push(...v.keys);return I.$Mb($)}getAllOverrideIdentifiers(){const c=[];for(const $ of this.overrides)c.push(...$.identifiers);return I.$Mb(c)}override(c){let $=this.a.get(c);return $||($=this.g(c),this.a.set(c,$)),$}merge(...c){const $=m.$Wn(this.contents),v=m.$Wn(this.overrides),p=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const D of c)if(l.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h($,D.contents);for(const f of D.overrides){const[S]=v.filter(y=>I.$ub(y.identifiers,f.identifiers));S?(this.h(S.contents,f.contents),S.keys.push(...f.keys),S.keys=I.$Mb(S.keys)):v.push(m.$Wn(f))}for(const f of D.keys)p.indexOf(f)===-1&&p.push(f)}return new d($,p,v,l.every(D=>D instanceof d)?void 0:l)}g(c){const $=this.i(c);if(!$||typeof $!="object"||!Object.keys($).length)return this;const v={};for(const p of I.$Mb([...Object.keys(this.contents),...Object.keys($)])){let l=this.contents[p];const D=$[p];D&&(typeof l=="object"&&typeof D=="object"?(l=m.$Wn(l),this.h(l,D)):l=D),v[p]=l}return new d(v,this.keys,this.overrides)}h(c,$){for(const v of Object.keys($)){if(v in c&&g.$6f(c[v])&&g.$6f($[v])){this.h(c[v],$[v]);continue}c[v]=m.$Wn($[v])}}i(c){let $=null,v=null;const p=l=>{l&&(v?this.h(v,l):v=m.$Wn(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===c?$=l.contents:l.identifiers.includes(c)&&p(l.contents);return p($),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,$){this.j(c,$,!0)}setValue(c,$){this.j(c,$,!1)}removeValue(c){const $=this.keys.indexOf(c);$!==-1&&(this.keys.splice($,1),(0,T.$4i)(this.contents,c),k.$lo.test(c)&&this.overrides.splice(this.overrides.findIndex(v=>I.$ub(v.identifiers,(0,k.$mo)(c))),1))}j(c,$,v){(0,T.$3i)(this.contents,c,$,p=>console.error(p)),v=v||this.keys.indexOf(c)===-1,v&&this.keys.push(c),k.$lo.test(c)&&this.overrides.push({identifiers:(0,k.$mo)(c),keys:Object.keys(this.contents[c]),contents:(0,T.$2i)(this.contents[c],p=>console.error(p))})}}e.$ro=d;class n{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,$){if(!g.$ag(c)){const v=this.g(c);this.parseRaw(v,$)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,$){this.a=c;const{contents:v,keys:p,overrides:l,restricted:D,hasExcludedProperties:f}=this.h(c,$);this.b=new d(v,p,l,f?[c]:void 0),this.c=D||[]}g(c){let $={},v=null,p=[];const l=[],D=[];function f(y){Array.isArray(p)?p.push(y):v!==null&&(p[v]=y)}const S={onObjectBegin:()=>{const y={};f(y),l.push(p),p=y,v=null},onObjectProperty:y=>{v=y},onObjectEnd:()=>{p=l.pop()},onArrayBegin:()=>{const y=[];f(y),l.push(p),p=y,v=null},onArrayEnd:()=>{p=l.pop()},onLiteralValue:f,onError:(y,C,P)=>{D.push({error:y,offset:C,length:P})}};if(c)try{R.$Kn(c,S),$=p[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return $}h(c,$){const v=u.$9n.as(k.$bo.Configuration).getConfigurationProperties(),p=this.i(c,v,!0,$);c=p.raw;const l=(0,T.$2i)(c,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),D=Object.keys(c),f=this.j(c,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:l,keys:D,overrides:f,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}i(c,$,v,p){let l=!1;if(!p?.scopes&&!p?.skipRestricted&&!p?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:l};const D={},f=[];for(const S in c)if(k.$lo.test(S)&&v){const y=this.i(c[S],$,!1,p);D[S]=y.raw,l=l||y.hasExcludedProperties,f.push(...y.restricted)}else{const y=$[S],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&f.push(S),!p.exclude?.includes(S)&&(p.include?.includes(S)||(C===void 0||p.scopes===void 0||p.scopes.includes(C))&&!(p.skipRestricted&&y?.restricted))?D[S]=c[S]:l=!0}return{raw:D,restricted:f,hasExcludedProperties:l}}j(c,$){const v=[];for(const p of Object.keys(c))if(k.$lo.test(p)){const l={};for(const D in c[p])l[D]=c[p][D];v.push({identifiers:(0,k.$mo)(p),keys:Object.keys(l),contents:(0,T.$2i)(l,$)})}return v}}e.$so=n;class o extends F.$Uc{constructor(c,$,v,p){super(),this.c=c,this.f=$,this.g=p,this.b=this.B(new N.$be),this.onDidChange=this.b.event,this.a=new n(this.c.toString()),this.B(this.g.watch(v.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&v.isEqual(l.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$to=o;class s{constructor(c,$,v,p,l,D,f,S,y,C,P,V,W){this.a=c,this.b=$,this.c=v,this.overrideIdentifiers=p,this.d=l,this.f=D,this.g=f,this.h=S,this.i=y,this.j=C,this.k=P,this.l=V,this.m=W}get value(){return w(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class r{constructor(c,$,v,p,l=new d,D=new d,f=new M.$Bc,S=new d,y=new M.$Bc){this.c=c,this.d=$,this.f=v,this.g=p,this.h=l,this.i=D,this.j=f,this.l=S,this.m=y,this.a=null,this.b=new M.$Bc,this.n=null}getValue(c,$,v){return this.p(c,$,v).getValue(c)}updateValue(c,$,v={}){let p;v.resource?(p=this.m.get(v.resource),p||(p=new d,this.m.set(v.resource,p))):p=this.l,$===void 0?p.removeValue(c):p.setValue(c,$),v.resource||(this.a=null)}inspect(c,$,v){const p=this.p(c,$,v),l=this.t($.resource,v),D=$.resource?this.m.get($.resource)||this.l:this.l,f=new Set;for(const S of p.overrides)for(const y of S.identifiers)p.getOverrideValue(c,y)!==void 0&&f.add(y);return new s(c,$,p.getValue(c),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this.i:void 0,l||void 0,D)}keys(c){const $=this.t(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,$){this.j.set(c,$),this.b.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,$){const v=[];if(!$){const{added:p,updated:l,removed:D}=h(this.c,c);$=[...p,...l,...D]}for(const p of $)for(const l of(0,k.$mo)(p)){const D=this.c.getKeysForOverrideIdentifier(l),f=c.getKeysForOverrideIdentifier(l),S=[...f.filter(y=>D.indexOf(y)===-1),...D.filter(y=>f.indexOf(y)===-1),...D.filter(y=>!m.$1n(this.c.override(l).getValue(y),c.override(l).getValue(y)))];v.push([l,S])}return this.updateDefaultConfiguration(c),{keys:$,overrides:v}}compareAndUpdatePolicyConfiguration(c){const{added:$,updated:v,removed:p}=h(this.d,c),l=[...$,...v,...p];return l.length&&this.updatePolicyConfiguration(c),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:$,updated:v,removed:p,overrides:l}=h(this.applicationConfiguration,c),D=[...$,...v,...p];return D.length&&this.updateApplicationConfiguration(c),{keys:D,overrides:l}}compareAndUpdateLocalUserConfiguration(c){const{added:$,updated:v,removed:p,overrides:l}=h(this.localUserConfiguration,c),D=[...$,...v,...p];return D.length&&this.updateLocalUserConfiguration(c),{keys:D,overrides:l}}compareAndUpdateRemoteUserConfiguration(c){const{added:$,updated:v,removed:p,overrides:l}=h(this.remoteUserConfiguration,c),D=[...$,...v,...p];return D.length&&this.updateRemoteUserConfiguration(c),{keys:D,overrides:l}}compareAndUpdateWorkspaceConfiguration(c){const{added:$,updated:v,removed:p,overrides:l}=h(this.workspaceConfiguration,c),D=[...$,...v,...p];return D.length&&this.updateWorkspaceConfiguration(c),{keys:D,overrides:l}}compareAndUpdateFolderConfiguration(c,$){const v=this.folderConfigurations.get(c),{added:p,updated:l,removed:D,overrides:f}=h(v,$),S=[...p,...l,...D];return(S.length||!v)&&this.updateFolderConfiguration(c,$),{keys:S,overrides:f}}compareAndDeleteFolderConfiguration(c){const $=this.folderConfigurations.get(c);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:v,updated:p,removed:l,overrides:D}=h($,void 0);return{keys:[...v,...p,...l],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(c,$,v){let p=this.q($,v);return $.overrideIdentifier&&(p=p.override($.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(p=p.merge(this.d)),p}q({resource:c},$){let v=this.r();if($&&c){const p=$.getFolder(c);p&&(v=this.s(p.uri)||v);const l=this.m.get(c);l&&(v=v.merge(l))}return v}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(c){let $=this.b.get(c);if(!$){const v=this.r(),p=this.j.get(c);p?($=v.merge(p),this.b.set(c,$)):$=v}return $}t(c,$){if($&&c){const v=$.getFolder(c);if(v)return this.j.get(v.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,$)=>{const{contents:v,overrides:p,keys:l}=this.j.get($);return c.push([$,{contents:v,overrides:p,keys:l}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach($=>c.add($)),this.userConfiguration.keys.forEach($=>c.add($)),this.i.keys.forEach($=>c.add($)),this.j.forEach($=>$.keys.forEach(v=>c.add(v))),[...c.values()]}u(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach($=>c.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>c.add($)),this.i.getAllOverrideIdentifiers().forEach($=>c.add($)),this.j.forEach($=>$.getAllOverrideIdentifiers().forEach(v=>c.add(v))),[...c.values()]}v(c){const $=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(v=>$.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(v=>$.add(v)),this.i.getKeysForOverrideIdentifier(c).forEach(v=>$.add(v)),this.j.forEach(v=>v.getKeysForOverrideIdentifier(c).forEach(p=>$.add(p))),[...$.values()]}static parse(c){const $=this.w(c.defaults),v=this.w(c.policy),p=this.w(c.application),l=this.w(c.user),D=this.w(c.workspace),f=c.folders.reduce((S,y)=>(S.set(E.URI.revive(y[0]),this.w(y[1])),S),new M.$Bc);return new r($,v,p,l,new d,D,f,new d,new M.$Bc)}static w(c){return new d(c.contents,c.keys,c.overrides)}}e.$uo=r;function i(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const c=new Set,$=new Map;for(const p of b)p.keys.forEach(l=>c.add(l)),p.overrides.forEach(([l,D])=>{const f=(0,M.$yc)($,l,new Set);D.forEach(S=>f.add(S))});const v=[];return $.forEach((p,l)=>v.push([l,[...p.values()]])),{keys:[...c.values()],overrides:v}}class a{constructor(c,$,v,p){this.change=c,this.f=$,this.g=v,this.h=p,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of c.keys)this.affectedKeys.add(l);for(const[,l]of c.overrides)for(const D of l)this.affectedKeys.add(D);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(c,$){const v=this.a+c,p=this.d.indexOf(v);if(p<0)return!1;const l=p+v.length;if(l>=this.d.length)return!1;const D=this.d.charCodeAt(l);if(D!==this.b&&D!==this.c)return!1;if($){const f=this.previousConfiguration?this.previousConfiguration.getValue(c,$,this.f?.workspace):void 0,S=this.g.getValue(c,$,this.h);return!m.$1n(f,S)}return!0}}e.$wo=a;function h(b,c){const{added:$,removed:v,updated:p}=t(c?.rawConfiguration,b?.rawConfiguration),l=[],D=b?.getAllOverrideIdentifiers()||[],f=c?.getAllOverrideIdentifiers()||[];if(c){const S=f.filter(y=>!D.includes(y));for(const y of S)l.push([y,c.getKeysForOverrideIdentifier(y)])}if(b){const S=D.filter(y=>!f.includes(y));for(const y of S)l.push([y,b.getKeysForOverrideIdentifier(y)])}if(c&&b){for(const S of D)if(f.includes(S)){const y=t({contents:b.getOverrideValue(void 0,S)||{},keys:b.getKeysForOverrideIdentifier(S)},{contents:c.getOverrideValue(void 0,S)||{},keys:c.getKeysForOverrideIdentifier(S)});l.push([S,[...y.added,...y.removed,...y.updated]])}}return{added:$,removed:v,updated:p,overrides:l}}function t(b,c){const $=b?c?b.keys.filter(l=>c.keys.indexOf(l)===-1):[...b.keys]:[],v=c?b?c.keys.filter(l=>b.keys.indexOf(l)===-1):[...c.keys]:[],p=[];if(b&&c){for(const l of c.keys)if(b.keys.indexOf(l)!==-1){const D=(0,T.$5i)(c.contents,l),f=(0,T.$5i)(b.contents,l);m.$1n(D,f)||p.push(l)}}return{added:$,removed:v,updated:p}}}),define(Re[102],Ae([1,0,14,3]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.RemoteAuthorityResolverErrorCode=e.$Dl=e.$Cl=e.RemoteConnectionType=e.$Bl=void 0,e.$Fl=E,e.$Bl=(0,N.$qi)("remoteAuthorityResolverService");var R;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(R||(e.RemoteConnectionType=R={}));class F{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Cl=F;class M{constructor(k,u){this.host=k,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Dl=M;var m;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class g extends I.$bb{static isNotAvailable(k){return k instanceof g&&k._code===m.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof g&&k._code===m.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof g&&k._code===m.NoResolverFound}static isInvalidAuthority(k){return k instanceof g&&k._code===m.InvalidAuthority}static isHandled(k){return k instanceof g&&k.isHandled}constructor(k,u=m.Unknown,w){super(k),this._message=k,this._code=u,this._detail=w,this.isHandled=u===m.NotAvailable&&w===!0,Object.setPrototypeOf(this,g.prototype)}}e.$El=g;function E(T){const k=T.indexOf("+");return k===-1?T:T.substring(0,k)}}),define(Re[58],Ae([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=N,e.$Cm=R,e.$Dm=F,e.$Em=M;function N(g){return g.scheme===I.Schemas.vscodeRemote?g.authority:void 0}function R(g){if(!g)return;const E=g.indexOf("+");return E<0?g:g.substr(0,E)}function F(g){const{host:E,port:T}=m(g);if(typeof T>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:T}}function M(g,E){let{host:T,port:k}=m(g);return typeof k>"u"&&(k=E),{host:T,port:k}}function m(g){const E=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const T=g.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const k=g.match(/(.*):(\d+)$/);return k?{host:k[1],port:parseInt(k[2],10)}:{host:g,port:void 0}}}),define(Re[20],Ae([1,0,15,3,58]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Nm=e.$Mm=e.$Lm=e.TargetPlatform=e.ExtensionType=e.$Km=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0,e.$Jm=F,e.$Om=k,e.$Pm=u,e.$Qm=w,e.$Rm=d,e.$Fm="extensions.user.cache",e.$Gm="extensions.builtin.cache",e.$Hm="undefined_publisher",e.$Im=["ui","workspace","web"];function F(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.$Km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(M||(e.ExtensionType=M={}));var m;(function(n){n.WIN32_X64="win32-x64",n.WIN32_ARM64="win32-arm64",n.LINUX_X64="linux-x64",n.LINUX_ARM64="linux-arm64",n.LINUX_ARMHF="linux-armhf",n.ALPINE_X64="alpine-x64",n.ALPINE_ARM64="alpine-arm64",n.DARWIN_X64="darwin-x64",n.DARWIN_ARM64="darwin-arm64",n.WEB="web",n.UNIVERSAL="universal",n.UNKNOWN="unknown",n.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const r=typeof o=="string"?o:o.value,i=typeof s=="string"?s:s.value;return I.$tf(r,i)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Lm=g;class E{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const s of o)this.add(s)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$Mm=E;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,s){this.c.set(g.toKey(o),s)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Nm=T;function k(n){return u(n)}function u(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}function w(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}function d(n,o){if(o){const s=`onResolveRemoteAuthority:${(0,R.$Cm)(o)}`;return!!n.activationEvents?.includes(s)}return!1}e.$Sm=(0,N.$qi)("IBuiltinExtensionsScannerService")}),define(Re[103],Ae([1,0,14,20]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dG=e.$cG=void 0;class R{constructor(){this.a=new Map,this.b=new WeakMap}register(M,m){this.a.set(M,m)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const m=Object.create(null);for(const g of M){const E=this.readActivationEvents(g);E.length>0&&(m[N.$Lm.toKey(g.identifier)]=E)}return m}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const m=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let g=0;g<m.length;g++)m[g]==="onUri"&&(m[g]=`onUri:${N.$Lm.toKey(M.identifier)}`);if(!M.contributes)return m;for(const g in M.contributes){const E=this.a.get(g);if(!E)continue;const T=M.contributes[g],k=Array.isArray(T)?T:[T];try{E(k,m)}catch(u){(0,I.$1)(u)}}return m}}e.$cG=R,e.$dG=new R}),define(Re[198],Ae([1,0,21,73,35]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=M,e.$$o=m;function F(g){if(I.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function M(g,E,T,k,u,w,d,n,o){const s=Object.create(null);s["common.machineId"]=w,s["common.sqmId"]=d,s.sessionID=(0,R.$Mg)()+Date.now(),s.commitHash=k,s.version=u,s["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.$h)(I.$u),s["common.nodePlatform"]=N.$ec,s["common.nodeArch"]=T,s["common.product"]=o||"desktop",n&&(s["common.msftInternal"]=n);let r=0;const i=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),I.$l&&(s["common.snap"]="true");const a=F(E);return a&&(s["common.platformDetail"]=a),s}function m(g){const E=N.env.USERDNSDOMAIN;if(!E)return!1;const T=E.toLowerCase();return g.some(k=>T===k)}}),define(Re[199],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=void 0,e.$Vl=(0,I.$qi)("telemetryService"),e.$Wl=(0,I.$qi)("customEndpointTelemetryService"),e.$Xl="telemetry.currentSessionDate",e.$Yl="telemetry.firstSessionDate",e.$Zl="telemetry.lastSessionDate",e.$1l="telemetry.machineId",e.$2l="telemetry.sqmId",e.$3l="telemetry",e.$4l="telemetry.telemetryLevel",e.$5l="telemetry.enableCrashReporter",e.$6l="telemetry.enableTelemetry";var N;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var R;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(Re[59],Ae([1,0,26,17,58,198,199]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=void 0,e.$gp=T,e.$hp=k,e.$ip=u,e.$jp=w,e.$kp=n,e.$lp=s,e.$mp=r,e.$np=h;class m{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.$_o=m;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ap=g,e.$bp=new g;class E{async publicLog(b,c,$){}async publicLogError(b,c,$){}}e.$cp=E,e.$dp="telemetry",e.$ep="extensionTelemetryLog",e.$fp={log:()=>null,flush:()=>Promise.resolve(null)};function T(t,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!t.enableTelemetry)}function k(t,b){return b.extensionTestsLocationURI?!0:!(b.isBuilt||b.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const b=t.getValue(M.$4l),c=t.getValue(M.$5l);if(t.getValue(M.$6l)===!1||c===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(t){const b={},c={},$={};o(t,$);for(let v in $){v=v.length>150?v.substr(v.length-149):v;const p=$[v];typeof p=="number"?c[v]=p:typeof p=="boolean"?c[v]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${p.length}`),b[v]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(b[v]=p)}return{properties:b,measurements:c}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(t){if(!t)return"none";const b=(0,R.$Cm)(t);return d.has(b)?b:"other"}function o(t,b,c=0,$){if(t)for(const v of Object.getOwnPropertyNames(t)){const p=t[v],l=$?$+v:v;Array.isArray(p)?b[l]=(0,I.$2n)(p):p instanceof Date?b[l]=p.toISOString():(0,N.$6f)(p)?c<2?o(p,b,c+1,l+"."):b[l]=(0,I.$2n)(p):b[l]=p}}function s(t,b){const c=t.msftInternalDomains||[],$=b.getValue("telemetry.internalTesting");return(0,F.$$o)(c)||$}function r(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,b){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const $=[];for(const D of b)for(;;){const f=D.exec(t);if(!f)break;$.push([f.index,D.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(c="";;){const D=p.exec(t);if(!D)break;const f=$.some(([S,y])=>D.index<y&&S<p.lastIndex);!v.test(D[0])&&!f&&(c+=t.substring(l,D.index)+"<REDACTED: user-file-path>",l=p.lastIndex)}return l<t.length&&(c+=t.substr(l)),c}function a(t){if(!t)return t;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of b)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function h(t,b){return(0,I.$Yn)(t,c=>{if(c instanceof m||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let $=c.replaceAll("%20"," ");$=i($,b);for(const v of b)$=$.replace(v,"");return $=a($),$}})}}),define(Re[200],Ae([1,0,15,98,20,21,2,14,73,59]),function(ge,e,I,N,R,F,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$pp=void 0,e.$op=T,e.$qp=d,e.$rp=n,e.$sp=o,e.$tp=s,e.$up=r,e.$vp=i,e.$wp=a,e.$yp=h,e.$zp=b;function T(c,$){return c.uuid&&$.uuid?c.uuid===$.uuid:c.id===$.id?!0:(0,I.$of)(c.id,$.id)===0}const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create($){const v=$.manifest?$.manifest.version:$.version,p=$.manifest?$.targetPlatform:$.properties.targetPlatform;return new u($.identifier,v,p)}static parse($){const v=k.exec($);return v&&v[1]&&v[2]?new u({id:v[1]},v[2],v[4]||void 0):null}constructor($,v,p="undefined"){this.version=v,this.targetPlatform=p,this.id=$.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals($){return $ instanceof u?T(this,$)&&this.version===$.version&&this.targetPlatform===$.targetPlatform:!1}}e.$pp=u;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(c){const $=w.exec(c);return $&&$[1]?[o($[1]),$[2]]:[o(c),void 0]}function n(c,$){return`${c}.${$}`}function o(c){return c.toLowerCase()}function s(c,$){return o(n(c??R.$Hm,$))}function r(c,$){const v=[],p=l=>{for(const D of v)if(D.some(f=>T($(f),$(l))))return D;return null};for(const l of c){const D=p(l);D?D.push(l):v.push([l])}return v}function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function a(c){return{id:new E.$_o(c.identifier.id),name:new E.$_o(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$xp=new R.$Lm("pprice.better-merge");function h(c,$){const v=[],p=$.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const l=p.shift();if(l&&v.every(D=>!T(D.identifier,{id:l}))){const D=c.filter(f=>T(f.identifier,{id:l}));D.length===1&&(v.push(D[0]),p.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}async function t(c,$){if(!F.$k)return!1;let v;try{v=(await c.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await c.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){$.debug("Error while getting the os-release file.",(0,m.$0)(l))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function b(c,$){const v=await t(c,$),p=(0,N.$Vo)(v?"alpine":F.$u,g.$fc);return $.debug("ComputeTargetPlatform:",p),p}}),define(Re[201],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=I,e.$ds=N,e.$es=R,e.$fs=F,e.$gs=M,e.$hs=m;function I(g){return[...g.entries()]}function N(g){return g?[...g.entries()]:[]}function R(g){return new Map(g)}function F(g){return new Map(g??[])}function M(g){return Array.from(g.entries()).map(E=>[E[0],I(E[1].map),N(E[1].descriptionMap)])}function m(g){return new Map(g.map(E=>[E[0],{map:R(E[1]),descriptionMap:F(E[2])}]))}}),define(Re[202],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fsb=void 0;class I{constructor(R){this.b=R,this.a=new Map}dispose(){for(const R of this.a.values())R.dispose()}startBuffering(R,F,M=5){const m=F(g=>{const E=typeof g=="string"?g:g.data;let T=this.a.get(R);if(T){T.data.push(E);return}const k=setTimeout(()=>this.flushBuffer(R),M);T={data:[E],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(R),m.dispose()}},this.a.set(R,T)});return m}stopBuffering(R){this.a.get(R)?.dispose()}flushBuffer(R){const F=this.a.get(R);F&&(this.a.delete(R),this.b(R,F.data.join("")))}}e.$Fsb=I}),define(Re[203],Ae([1,0,11,91,302,41,5,17,2,161,72,30]),function(ge,e,I,N,R,F,M,m,g,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0w=e.$9w=e.$8w=e.$7w=e.$6w=e.$5w=e.IconFontDefinition=e.IconContribution=e.$2w=void 0,e.$3w=o,e.$4w=s,e.$2w={IconContribution:"base.contributions.icons"};var u;(function(h){function t(b,c){let $=b.defaults;for(;F.ThemeIcon.isThemeIcon($);){const v=n.getIcon($.id);if(!v)return;$=v.defaults}return $}h.getDefinition=t})(u||(e.IconContribution=u={}));var w;(function(h){function t(c){return{weight:c.weight,style:c.style,src:c.src.map($=>({format:$.format,location:$.location.toString()}))}}h.toJSONObject=t;function b(c){const $=v=>(0,m.$4f)(v)?v:void 0;if(c&&Array.isArray(c.src)&&c.src.every(v=>(0,m.$4f)(v.format)&&(0,m.$4f)(v.location)))return{weight:$(c.weight),style:$(c.style),src:c.src.map(v=>({format:v.format,location:g.URI.parse(v.location)}))}}h.fromJSONObject=b})(w||(e.IconFontDefinition=w={}));class d{constructor(){this.a=new M.$be,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${F.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,b,c,$){const v=this.b[t];if(v){if(c&&!v.description){v.description=c,this.d.properties[t].markdownDescription=`${c} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=c),this.a.fire()}return v}const p={id:t,description:c,defaults:b,deprecationMessage:$};this.b[t]=p;const l={$ref:"#/definitions/icons"};return $&&(l.deprecationMessage=$),c&&(l.markdownDescription=`${c}: $(${t})`),this.d.properties[t]=l,this.e.enum.push(t),this.e.enumDescriptions.push(c||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const b=this.e.enum.indexOf(t);b!==-1&&(this.e.enum.splice(b,1),this.e.enumDescriptions.splice(b,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,b){const c=this.f[t];return c||(this.f[t]=b,this.a.fire(),b)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(v,p)=>v.id.localeCompare(p.id),b=v=>{for(;F.ThemeIcon.isThemeIcon(v.defaults);)v=this.b[v.defaults.id];return`codicon codicon-${v?v.id:""}`},c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const $=Object.keys(this.b).map(v=>this.b[v]);for(const v of $.filter(p=>!!p.description).sort(t))c.push(`|<i class="${b(v)}"></i>|${v.id}|${F.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const v of $.filter(p=>!F.ThemeIcon.isThemeIcon(p.defaults)).sort(t))c.push(`|<i class="${b(v)}"></i>|${v.id}|`);return c.join(`
`)}}const n=new d;k.$9n.add(e.$2w.IconContribution,n);function o(h,t,b,c){return n.registerIcon(h,t,b,c)}function s(){return n}function r(){const h=(0,R.$Lj)();for(const t in h){const b="\\"+h[t].toString(16);n.registerIcon(t,{fontCharacter:b})}}r(),e.$5w="vscode://schemas/icons";const i=k.$9n.as(T.$0n.JSONContribution);i.registerSchema(e.$5w,n.getIconSchema());const a=new I.$Ch(()=>i.notifySchemaChanged(e.$5w),200);n.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$6w=o("widget-close",N.$Pj.close,(0,E.localize)(2,null)),e.$7w=o("goto-previous-location",N.$Pj.arrowUp,(0,E.localize)(3,null)),e.$8w=o("goto-next-location",N.$Pj.arrowDown,(0,E.localize)(4,null)),e.$9w=F.ThemeIcon.modify(N.$Pj.sync,"spin"),e.$0w=F.ThemeIcon.modify(N.$Pj.loading,"spin")}),define(Re[204],Ae([1,0,5,2,48,3,13]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=e.$cw=e.$_v=e.$0v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$6v=e.$5v=void 0,e.$7v=E,e.$8v=k,e.$9v=u,e.$$v=w,e.$aw=d,e.$bw=n,e.$5v=(0,F.$qi)("tunnelService"),e.$6v=(0,F.$qi)("sharedTunnelsService");var m;(function(r){r.Http="http",r.Https="https"})(m||(e.TunnelProtocol=m={}));var g;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(g||(e.TunnelPrivacyId=g={}));function E(r){return!!r.forwardPort}var T;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function k(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(i)return{address:i[1],port:+i[2]}}function u(r){if(r.scheme!=="http"&&r.scheme!=="https"||!r.query)return;const i=r.query.split("&");for(const a of i){const h=a.split("=")[1];if(/^https?:/.exec(h)){const t=k(N.URI.parse(h));if(t)return t}}}e.$0v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(r){return e.$0v.indexOf(r)>=0}e.$_v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function d(r){return e.$_v.indexOf(r)>=0}function n(r,i,a,h){if(a===1)return!1;if(a===2&&d(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(t?.length===4&&parseInt(t[1])>=18)return!1}return r<1024}class o{constructor(i,a,h){this.remoteAddress=i,this.localAddress=a,this.b=h,this.a=new I.$be,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$cw=o;let s=class{constructor(i,a){this.k=i,this.l=a,this.a=new I.$be,this.onTunnelOpened=this.a.event,this.b=new I.$be,this.onTunnelClosed=this.b.event,this.c=new I.$be,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],a=Array.from(this.e.values());for(const h of a){const t=Array.from(h.values());for(const b of t){const c=await b.value;c&&typeof c!="string"&&i.push(c)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:a}of i.values())await a.then(h=>typeof h!="string"?h?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,a,h,t,b){this.q(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:h,privacy:t,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(d(i)||w(i))&&(i=e.$0v[0]);const h=this.s(i,a);if(h)return++h.refcount,h.value}openTunnel(i,a,h,t,b,c=!1,$,v){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${h} on local port ${b}.`);const p=this.f??i;if(!p)return;if(a||(a="localhost"),t||(t=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.t(p,a,h,t,b,c,$,v);return l?l.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(a,h),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(a,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.o(D);return(D.tunnelRemoteHost!==a||D.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),$&&D.privacy!==$&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this.e.get(i.tunnelRemoteHost);if(a){const h=a.get(i.tunnelRemotePort);h&&(h.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,h))}}}}async p(i,a,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const t=h.value.then(async b=>{b&&typeof b!="string"&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(a),t}}async closeTunnel(i,a){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const h=this.e.get(i);if(h&&h.has(a)){const t=h.get(a);t.refcount=0,await this.p(i,a,t)}}q(i,a,h){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(a,{refcount:1,value:h})}async r(i,a){const h=this.e.get(i);if(h){const t=h.get(a),b=t?await t.value:void 0;(!b||typeof b=="string")&&h.delete(a),h.size===0&&this.e.delete(i)}}s(i,a){const h=[i];w(i)?(h.push(...e.$0v),h.push(...e.$_v)):d(i)&&h.push(...e.$_v);const t=h.map(b=>this.e.get(b));for(const b of t){const c=b?.get(a);if(c)return c}}canTunnel(i){return!!k(i)}u(i,a,h,t,b,c,$){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${h} on local port ${t}.`);const v=h;this.j.add(v);const p=t===void 0?h:t,l={elevationRequired:b?this.isPortPrivileged(p):!1},D={remoteAddress:{host:a,port:h},localAddressPort:t,privacy:c,public:c?c!==g.Private:void 0,protocol:$},f=i.forwardPort(D,l);return f?(this.q(a,h,f),f.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(v)})):this.j.delete(v),f}};e.$dw=s,e.$dw=s=Je([Ve(0,M.$Wj),Ve(1,R.$Wi)],s)}),define(Re[205],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ew=void 0,e.$ew=(0,I.$qi)("editSessionIdentityService");var N;(function(R){R[R.Complete=100]="Complete",R[R.Partial=50]="Partial",R[R.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Re[206],Ae([1,0,12]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=N,e.$nM=R,e.$oM=F,e.$pM=M,e.$qM=m;function N(g){return g.scheme!==I.Schemas.file&&g.scheme!==I.Schemas.vscodeRemote}function R(g){if(g.folders.length)return g.folders.every(E=>N(E.uri))?g.folders[0].uri:void 0;if(g.configuration&&N(g.configuration))return g.configuration}function F(g){return R(g)?.scheme}function M(g){return R(g)?.authority}function m(g){return R(g)!==void 0}}),define(Re[49],Ae([1,0,162,19,52,23,2,3,12]),function(ge,e,I,N,R,F,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Ki=e.$Ji=e.WorkbenchState=e.$Di=e.$Ci=e.$zi=void 0,e.$Ai=E,e.$Bi=T,e.$Ei=k,e.$Fi=u,e.$Gi=w,e.$Hi=n,e.$Ii=o,e.$Li=i,e.$Qi=a,e.$Ri=h,e.$Ti=t,e.$Ui=b,e.$Vi=c,e.$zi=(0,m.$qi)("contextService");function E($){const v=$;return typeof v?.id=="string"&&M.URI.isUri(v.uri)}function T($){return typeof $?.id=="string"&&!E($)&&!u($)}e.$Ci={id:"ext-dev"},e.$Di={id:"empty-window"};function k($,v){if(typeof $=="string"||typeof $>"u")return typeof $=="string"?{id:(0,N.$oc)($)}:v?e.$Ci:e.$Di;const p=$;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}function u($){const v=$;return typeof v?.id=="string"&&M.URI.isUri(v.configPath)}function w($){const v=$;if(v?.uri)return{id:v.id,uri:M.URI.revive(v.uri)};const p=$;if(p?.configPath)return{id:p.id,configPath:M.URI.revive(p.configPath)};if($?.id)return{id:$.id}}var d;(function($){$[$.EMPTY=1]="EMPTY",$[$.FOLDER=2]="FOLDER",$[$.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function n($){const v=$;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}function o($){const v=$;return!!(v&&typeof v=="object"&&M.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}class s{constructor(v,p,l,D,f){this.h=v,this.j=l,this.k=D,this.l=f,this.c=R.$wi.forUris(this.l,()=>!0),this.folders=p}update(v){this.h=v.id,this.k=v.configuration,this.j=v.transient,this.l=v.l,this.folders=v.folders}get folders(){return this.g}set folders(v){this.g=v,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(v){this.k=v}getFolder(v){return v&&this.c.findSubstr(v)||null}n(){this.c=R.$wi.forUris(this.l,()=>!0);for(const v of this.folders)this.c.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ji=s;class r{constructor(v,p){this.raw=p,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,F.$4g)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ki=r;function i($){return new r({uri:$,index:0,name:(0,F.$Zg)($)},{uri:$.toString()})}e.$Mi="code-workspace",e.$Ni=`.${e.$Mi}`,e.$Oi=[{name:(0,I.localize)(0,null),extensions:[e.$Mi]}],e.$Pi="workspace.json";function a($,v){return F.$Ug.isEqualOrParent($,v.untitledWorkspacesHome)}function h($){let v;return M.URI.isUri($)?v=$:v=$.configuration,v?.scheme===g.Schemas.tmp}e.$Si="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t($){return $.id===e.$Si}function b($,v){return!a($,v)&&!h($)}function c($){return(typeof $=="string"?(0,N.$pc)($):(0,F.$2g)($))===e.$Ni}}),define(Re[74],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=void 0;class I{static{this.a=!1}constructor(R){this.d=R,this.b=new Map,this.c=1}add(R){const F=this.c++;return this.b.set(F,R),this.e(),F}get(R,F){return this.b.has(R)?this.b.get(R)[F]:void 0}delete(R){this.b.delete(R),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Zjc=I}),define(Re[44],Ae([1,0,12,23,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6jc=e.$5jc=void 0;class F{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new N.$Sg(m=>{const g=this.b.get(m.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos(m,g){g===null?this.b.delete(m.scheme):this.b.set(m.scheme,g)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$5jc=F,e.$6jc=(0,R.$qi)("IExtHostFileSystemInfo")}),define(Re[27],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=void 0,e.$qP=(0,I.$qi)("IExtHostInitDataService")}),define(Re[207],Ae([1,0,168,13,194,27]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;let M=class extends R.$yQ{constructor(g,E,T){const k=T.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",u=T.remote.isRemote?(0,I.localize)(0,null):g?(0,I.localize)(1,null):(0,I.localize)(2,null);super(E.createLogger(k,{name:u}))}};e.$_lc=M,e.$_lc=M=Je([Ve(1,N.$Xj),Ve(2,F.$qP)],M)}),define(Re[208],Ae([1,0,11]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=e.$Kkc=void 0;class N{constructor(M,m,g){this.h=new Map,this.a=M,this.b=m,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new I.$Ch(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of E.values())T.complete()}catch(T){for(const k of E.values())k.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,m){let g=this.f[M];return typeof g>"u"&&(g=m),g}update(M,m){this.f[M]=m;const g=this.h.get(M);if(g!==void 0)return g.p;const E=new I.$Nh;return this.h.set(M,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Kkc=N;class R extends N{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,m){super(M.identifier.value,!0,m),this.j=M}}e.$Lkc=R}),define(Re[209],Ae([1,0,5,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=void 0;class R{constructor(M){this.c=M,this.a=new I.$be,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$be,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,m,g,E){const k=this.c.getNotebookDocument(N.URI.revive(M)).acceptModelChanged(m.value,g,E);this.b.fire(k)}$acceptDirtyStateChanged(M,m){this.c.getNotebookDocument(N.URI.revive(M)).acceptDirty(m)}$acceptModelSaved(M){const m=this.c.getNotebookDocument(N.URI.revive(M));this.a.fire(m.apiNotebook)}}e.$zlc=R}),define(Re[16],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=e.$aP=void 0,e.$aP=(0,I.$qi)("IExtHostRpcService");class N{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$bP=N}),define(Re[210],Ae([1,0,20,5]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=void 0;class R{#e;constructor(M,m){this.b=new N.$be,this.onDidChange=this.b.event,this.a=I.$Lm.toKey(M.identifier),this.#e=m,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(M){return this.#e.get(this.a,M)}store(M,m){return this.#e.store(this.a,M,m)}delete(M){return this.#e.delete(this.a,M)}}e.$Ukc=R}),define(Re[60],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=e.$ikc=void 0,e.$ikc=(0,I.$qi)("IURITransformerService");class N{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$jkc=N}),define(Re[211],Ae([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnb=R,e.$Ynb=M;class N{constructor(){this.buffers=[]}add(g){let E=this.buffers.indexOf(g);return E<0&&(E=this.buffers.length,this.buffers.push(g)),E}}function R(m,g){if(g.serializeBuffersForPostMessage){const E=new N,k=JSON.stringify(m,(w,d)=>{if(d instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(d)};if(ArrayBuffer.isView(d)){const n=F(d);if(n)return{$$vscode_array_buffer_reference$$:!0,index:E.add(d.buffer),view:{type:n,byteLength:d.byteLength,byteOffset:d.byteOffset}}}return d}),u=E.buffers.map(w=>{const d=new Uint8Array(w);return I.$Ce.wrap(d)});return{message:k,buffers:u}}else return{message:JSON.stringify(m),buffers:[]}}function F(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(m,g){const E=g.map(u=>{const w=new ArrayBuffer(u.byteLength);return new Uint8Array(w).set(u.buffer),w}),T=g.length?(u,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const d=w,{index:n}=d,o=E[n];if(d.view)switch(d.view.type){case 1:return new Int8Array(o,d.view.byteOffset,d.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,d.view.byteOffset,d.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,d.view.byteOffset,d.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,d.view.byteOffset,d.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,d.view.byteOffset,d.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,d.view.byteOffset,d.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,d.view.byteOffset,d.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,d.view.byteOffset,d.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,d.view.byteOffset,d.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,d.view.byteOffset,d.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,d.view.byteOffset,d.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return w}:void 0;return{message:JSON.parse(m,T),arrayBuffers:E}}}),define(Re[104],Ae([1,0,177,17,2,6,3,30,43,12,42,139,33]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$BF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$sF=e.EditorInputCapabilities=e.$rF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=void 0,e.$iF=n,e.$jF=o,e.$kF=s,e.$lF=r,e.$mF=i,e.$nF=a,e.$oF=h,e.$pF=t,e.$qF=b,e.$tF=D,e.$uF=S,e.$vF=y,e.$wF=C,e.$xF=P,e.$yF=V,e.$zF=W,e.$AF=ce,e.$CF=ue,e.$DF=re,e.$EF=Se,e.$FF=Le,e.$dF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$eF={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$fF="workbench.editor.sidebysideEditor",e.$gF="workbench.editors.textDiffEditor",e.$hF="workbench.editors.binaryResourceDiffEditor";var w;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var d;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function n(ne){const U=ne;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function o(ne){const U=ne;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function s(ne,U,x){for(const be of x.visibleEditorPanes)if(be.group.id===U&&ne.matches(be.input))return be.getViewState()}function r(ne){if(D(ne))return!1;const U=ne;return R.URI.isUri(U?.resource)}function i(ne){if(D(ne))return!1;const U=ne;return U?.original!==void 0&&U.modified!==void 0}function a(ne){if(D(ne))return!1;const U=ne;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function h(ne){if(D(ne)||i(ne))return!1;const U=ne;return U?.primary!==void 0&&U.secondary!==void 0}function t(ne){if(D(ne))return!1;const U=ne;return U?U.resource===void 0||U.resource.scheme===E.Schemas.untitled||U.forceUntitled===!0:!1}function b(ne){if(D(ne))return!1;const U=ne;return R.URI.isUri(U?.base?.resource)&&R.URI.isUri(U?.input1?.resource)&&R.URI.isUri(U?.input2?.resource)&&R.URI.isUri(U?.result?.resource)}var c;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(c||(e.Verbosity=c={}));var $;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})($||(e.SaveReason=$={}));class v{constructor(){this.a=new Map}registerSource(U,x){let be=this.a.get(U);return be||(be={source:U,label:x},this.a.set(U,be)),be.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$rF=new v;var p;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})(p||(e.EditorInputCapabilities=p={}));class l extends F.$Uc{}e.$sF=l;function D(ne){return ne instanceof l}function f(ne){const U=ne;return R.URI.isUri(U?.preferredResource)}function S(ne){const U=ne;return D(U?.primary)&&D(U?.secondary)}function y(ne){const U=ne;return D(U?.modified)&&D(U?.original)}function C(ne,U,x,be,Ne){return Le(be,[(0,k.$aj)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const Ee={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(U,Ee)}}),(0,k.$aj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Ne.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function P(ne){return D(ne?.editor)}function V(ne){const U=ne;return P(ne)&&U?.group!==void 0}function W(ne){const U=ne;return typeof U?.groupId=="number"&&D(U.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var A;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_STICKY=12]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=13]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(A||(e.GroupModelChangeKind=A={}));var j;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class K{getOriginalUri(U,x){if(!U)return;if(b(U))return e.$BF.getOriginalUri(U.result,x);if(x?.supportSideBySide){const{primary:Ne,secondary:Ee}=this.a(U);if(Ne&&Ee){if(x?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(Ne,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(Ee,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===j.ANY)return this.getOriginalUri(Ne,{filterByScheme:x.filterByScheme})??this.getOriginalUri(Ee,{filterByScheme:x.filterByScheme});U=x.supportSideBySide===j.PRIMARY?Ne:Ee}}if(i(U)||a(U)||h(U)||b(U))return;const be=f(U)?U.preferredResource:U.resource;return!be||!x||!x.filterByScheme?be:this.b(be,x.filterByScheme)}a(U){return S(U)||h(U)?{primary:U.primary,secondary:U.secondary}:y(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,x){if(!U)return;if(b(U))return e.$BF.getCanonicalUri(U.result,x);if(x?.supportSideBySide){const{primary:Ne,secondary:Ee}=this.a(U);if(Ne&&Ee){if(x?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(Ne,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(Ee,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===j.ANY)return this.getCanonicalUri(Ne,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(Ee,{filterByScheme:x.filterByScheme});U=x.supportSideBySide===j.PRIMARY?Ne:Ee}}if(i(U)||a(U)||h(U)||b(U))return;const be=U.resource;return!be||!x||!x.filterByScheme?be:this.b(be,x.filterByScheme)}b(U,x){if(Array.isArray(x)){if(x.some(be=>U.scheme===be))return U}else if(x===U.scheme)return U}}var ie;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function ce(ne,U,x,be){if(!ne.isSticky(U))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return x===ie.MOUSE||x===ie.KEYBOARD;case"mouse":return x===ie.MOUSE;case"keyboard":return x===ie.KEYBOARD}return!1}e.$BF=new K;var ve;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ve||(e.CloseDirection=ve={}));class Ie{constructor(){this.c=new Map,this.d=new Map}start(U){const x=this.a=U.get(M.$pi);for(const[be,Ne]of this.c)this.e(be,Ne,x);this.c.clear()}e(U,x,be){const Ne=be.createInstance(x);this.d.set(U,Ne)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,N.$cg)(this.b)}registerEditorSerializer(U,x){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,x,this.a):this.c.set(U,x),(0,F.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}m.$9n.add(e.$dF.EditorFactory,new Ie);async function ue(ne,U,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async be=>{const Ne=R.URI.revive(be.fileUri);if(!Ne){x.info("Cannot resolve the path because it is not valid.",be);return}if(!await U.canHandleResource(Ne)){x.info("Cannot resolve the path because it cannot be handled",be);return}let $e=be.exists,fe=be.type;if(typeof $e!="boolean"||typeof fe!="number")try{fe=(await U.stat(Ne)).isDirectory?g.FileType.Directory:g.FileType.Unknown,$e=!0}catch(Y){x.error(Y),$e=!1}if(!$e&&be.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",be);return}if(fe===g.FileType.Directory){x.info("Cannot resolve the path because it is a directory",be);return}const Q={...be.options,pinned:!0};return $e?{resource:Ne,options:Q}:{resource:Ne,options:Q,forceUntitled:!0}}))}var pe;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(pe||(e.EditorsOrder=pe={}));function re(ne){const U=ne;if(!U)return!1;const x=U;if(x.modified)return re(x.modified);const be=U;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function Se(ne){return(0,T.$cj)(ne)}function Le(ne,U,x){const be=(0,T.$dj)(ne,U);return be.forceMessage=x?.forceMessage,be.forceSeverity=x?.forceSeverity,be.allowDialog=x?.allowDialog,be}}),define(Re[212],Ae([1,0,5,178,3,6,28,30,18,26,91,203]),function(ge,e,I,N,R,F,M,m,g,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NF=e.$MF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$LF=e.ViewContentGroups=e.$JF=e.ViewContainerLocation=e.Extensions=e.$IF=e.$HF=e.$GF=void 0,e.$KF=d,e.$GF="views",e.$HF=(0,N.localize)(0,null),e.$IF=(0,k.$3w)("default-view-icon",T.$Pj.window,(0,N.localize)(1,null));var u;(function(b){b.ViewContainersRegistry="workbench.registry.view.containers",b.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var w;(function(b){b[b.Sidebar=0]="Sidebar",b[b.Panel=1]="Panel",b[b.AuxiliaryBar=2]="AuxiliaryBar"})(w||(e.ViewContainerLocation=w={})),e.$JF=[0,1,2];function d(b){switch(b){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class n extends F.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$be),this.onDidRegister=this.c.event,this.f=this.B(new I.$be),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(c,$,v){const p=this.get(c.id);if(p)return p;const l=c;return l.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:l.openCommandActionDescriptor??{id:l.id},(0,M.$yc)(this.g,$,[]).push(l),v?.isDefault&&this.h.push(l),this.c.fire({viewContainer:l,viewContainerLocation:$}),l}deregisterViewContainer(c){for(const $ of this.g.keys()){const v=this.g.get($),p=v?.indexOf(c);if(p!==-1){v?.splice(p,1),v.length===0&&this.g.delete($),this.f.fire({viewContainer:c,viewContainerLocation:$});return}}}get(c){return this.all.filter($=>$.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter($=>this.getViewContainers($).filter(v=>v?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find($=>this.getViewContainerLocation($)===c)}}m.$9n.add(u.ViewContainersRegistry,new n);var o;(function(b){b.Open="2_open",b.Debug="4_debug",b.SCM="5_scm",b.More="9_more"})(o||(e.ViewContentGroups=o={}));function s(b,c){const $=b.group??o.More,v=c.group??o.More;return $!==v?$.localeCompare(v):(b.order??5)-(c.order??5)}class r extends F.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$be),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$be),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$be),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$be),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(c,$){this.registerViews2([{views:c,viewContainer:$}])}registerViews2(c){c.forEach(({views:$,viewContainer:v})=>this.r($,v)),this.c.fire(c)}deregisterViews(c,$){const v=this.s(c,$);v.length&&this.f.fire({views:v,viewContainer:$})}moveViews(c,$){for(const v of this.m.keys())if(v!==$){const p=this.s(c,v);p.length&&(this.r(p,$),this.g.fire({views:p,from:v,to:$}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const $ of this.j){const v=(this.m.get($)||[]).filter(p=>p.id===c)[0];if(v)return v}return null}getViewContainer(c){for(const $ of this.j)if((this.m.get($)||[]).filter(p=>p.id===c)[0])return $;return null}registerViewWelcomeContent(c,$){return this.n.add(c,$),this.h.fire(c),(0,F.$Sc)(()=>{this.n.delete(c,$),this.h.fire(c)})}registerViewWelcomeContent2(c,$){const v=new Map;for(const[p,l]of $)this.n.add(c,l),v.set(p,(0,F.$Sc)(()=>{this.n.delete(c,l),this.h.fire(c)}));return this.h.fire(c),v}getViewWelcomeContent(c){const $=[];return this.n.forEach(c,v=>$.push(v)),$.sort(s)}r(c,$){let v=this.m.get($);v||(v=[],this.m.set($,v),this.j.push($));for(const p of c){if(this.getView(p.id)!==null)throw new Error((0,N.localize)(2,null,p.id));v.push(p)}}s(c,$){const v=this.m.get($);if(!v)return[];const p=[],l=[];for(const D of v)c.includes(D)?p.push(D):l.push(D);return p.length&&(l.length?this.m.set($,l):(this.m.delete($),this.j.splice(this.j.indexOf($),1))),p}}m.$9n.add(u.ViewsRegistry,new r),e.$LF=(0,R.$qi)("viewDescriptorService");var i;(function(b){b[b.Default=0]="Default",b[b.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var a;(function(b){b[b.None=0]="None",b[b.Collapsed=1]="Collapsed",b[b.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class h{constructor(c,$){this.c=!1,this.d=!1,(0,E.$Zn)(this,c),this.d=!!$,this.resolve=async v=>{if($&&!this.c){const p=await $(v);p&&(this.tooltip=this.tooltip??p.tooltip,this.command=this.command??p.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$MF=h;class t extends Error{constructor(c){super((0,N.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$NF=t}),define(Re[213],Ae([1,0,179,31]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0,e.$RF=new N.$Hj("chatSessionResponseVote","",{type:"string",description:(0,I.localize)(0,null)}),e.$SF=new N.$Hj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,I.localize)(1,null)}),e.$TF=new N.$Hj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,I.localize)(2,null)}),e.$UF=new N.$Hj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,I.localize)(3,null)}),e.$VF=new N.$Hj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,I.localize)(4,null)}),e.$WF=new N.$Hj("chatResponse",!1,{type:"boolean",description:(0,I.localize)(5,null)}),e.$XF=new N.$Hj("chatRequest",!1,{type:"boolean",description:(0,I.localize)(6,null)}),e.$YF=new N.$Hj("chatInputHasText",!1,{type:"boolean",description:(0,I.localize)(7,null)}),e.$ZF=new N.$Hj("chatInputHasFocus",!1,{type:"boolean",description:(0,I.localize)(8,null)}),e.$1F=new N.$Hj("inChatInput",!1,{type:"boolean",description:(0,I.localize)(9,null)}),e.$2F=new N.$Hj("inChat",!1,{type:"boolean",description:(0,I.localize)(10,null)}),e.$3F=new N.$Hj("hasChatProvider",!1,{type:"boolean",description:(0,I.localize)(11,null)}),e.$4F=new N.$Hj("chatCursorAtTop",!1),e.$5F=new N.$Hj("chatInputHasAgent",!1),e.$6F=new N.$Hj("chatLocation",void 0)}),define(Re[214],Ae([1,0,5,46,6,31,3,213]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5G=e.$4G=e.$3G=e.ChatAgentLocation=void 0;var g;(function(k){k.Panel="panel",k.Terminal="terminal",k.Notebook="notebook",k.Editor="editor"})(g||(e.ChatAgentLocation=g={})),function(k){function u(w){switch(w){case"panel":return k.Panel;case"terminal":return k.Terminal;case"notebook":return k.Notebook;case"editor":return k.Editor}return k.Panel}k.fromRaw=u}(g||(e.ChatAgentLocation=g={})),e.$3G=(0,M.$qi)("chatAgentService");let E=class{static{this.AGENT_LEADER="@"}constructor(u){this.f=u,this.b=[],this.d=new I.$be,this.onDidChangeAgents=this.d.event,this.e=m.$3F.bindTo(this.f)}registerAgent(u,w){if(this.getAgent(u))throw new Error(`Agent already registered: ${JSON.stringify(u)}`);const n=this,o=w.slashCommands;w={...w,get slashCommands(){return o.filter(r=>!r.when||n.f.contextMatchesRules(F.$oj.deserialize(r.when)))}};const s={data:w};return this.b.push(s),(0,R.$Sc)(()=>{this.b=this.b.filter(r=>r!==s),this.d.fire(void 0)})}registerAgentImplementation(u,w){const d=this.g(u);if(!d)throw new Error(`Unknown agent: ${JSON.stringify(u)}`);if(d.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(u)}`);return d.data.isDefault&&this.e.set(!0),d.impl=w,this.d.fire(new T(d.data,w)),(0,R.$Sc)(()=>{d.impl=void 0,this.d.fire(void 0),d.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(u,w){const d={data:u,impl:w};return this.b.push(d),this.d.fire(new T(u,w)),(0,R.$Sc)(()=>{this.b=this.b.filter(n=>n!==d),this.d.fire(void 0)})}updateAgent(u,w){const d=this.g(u);if(!d?.impl)throw new Error(`No activated agent with id ${JSON.stringify(u)} registered`);d.data.metadata={...d.data.metadata,...w},this.d.fire(new T(d.data,d.impl))}getDefaultAgent(u){return this.getActivatedAgents().find(w=>!!w.isDefault&&w.locations.includes(u))}getContributedDefaultAgent(u){return this.getAgents().find(w=>!!w.isDefault&&w.locations.includes(u))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),u=>!!u.data.metadata.isSecondary)?.data}g(u){return this.b.find(w=>w.data.id===u)}getAgent(u){return this.g(u)?.data}getAgents(){return this.b.map(u=>u.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(u=>!!u.impl).map(u=>new T(u.data,u.impl))}getAgentsByName(u){return this.getAgents().filter(w=>w.name===u)}async invokeAgent(u,w,d,n,o){const s=this.g(u);if(!s?.impl)throw new Error(`No activated agent with id ${u}`);return await s.impl.invoke(w,d,n,o)}async getFollowups(u,w,d,n,o){const s=this.g(u);if(!s?.impl)throw new Error(`No activated agent with id ${u}`);return s.impl?.provideFollowups?s.impl.provideFollowups(w,d,n,o):[]}};e.$4G=E,e.$4G=E=Je([Ve(0,F.$Ij)],E);class T{constructor(u,w){this.b=u,this.d=w}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(u,w,d,n){return this.d.invoke(u,w,d,n)}async provideFollowups(u,w,d,n){return this.d.provideFollowups?this.d.provideFollowups(u,w,d,n):[]}provideWelcomeMessage(u){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(u)}provideSampleQuestions(u){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(u)}}e.$5G=T}),define(Re[215],Ae([1,0,2,29,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bG=e.$aG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$$F=F,e.$_F=M;function F(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof I.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(N.$kt.isIRange)}function M(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(F)}var m;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var g;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(g||(e.ChatCopyKind=g={})),e.$aG=(0,R.$qi)("IChatService"),e.$bG="accessibility.voice.keywordActivation"}),define(Re[216],Ae([1,0,5,11,180]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sob=void 0;class F{constructor(){this.f=new Map,this.m=[],this.n=new I.$be,this.o=new I.$be,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(m){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=m}onEvent(m){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=m}onRequest(m){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.u("response",m)}sendRequest(m,g,E,T){const k={command:m};if(g&&Object.keys(g).length>0&&(k.arguments=g),this.u("request",k),typeof T=="number"){const u=setTimeout(()=>{clearTimeout(u);const w=this.f.get(k.seq);if(w){this.f.delete(k.seq);const d={type:"response",seq:0,request_seq:k.seq,success:!1,command:m,message:(0,R.localize)(0,null,T,m)};w(d)}},T)}return E&&this.f.set(k.seq,E),k.seq}acceptMessage(m){this.k?this.k(m):(this.m.push(m),this.m.length===1&&this.s())}q(m,g){return m.type!=="event"||g.type!=="event"}async s(){let m;for(;this.m.length;){if((!m||this.q(this.m[0],m))&&await(0,N.$rh)(0),m=this.m.shift(),!m)return;switch(m.type){case"event":this.j?.(m);break;case"request":this.g?.(m);break;case"response":{const g=m,E=this.f.get(g.request_seq);E&&(this.f.delete(g.request_seq),E(g));break}}}}u(m,g){g.type=m,g.seq=this.d++,this.sendMessage(g)}async w(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((g,E)=>m.set(E,g)),await(0,N.$rh)(500),m.forEach((g,E)=>{g({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$sob=F}),define(Re[217],Ae([1,0,2,181,31,3]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$iJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$gJ=e.MemoryRangeType=e.State=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=void 0,e.$fJ=g,e.$hJ=T,e.$6H="workbench.view.debug",e.$7H="workbench.debug.variablesView",e.$8H="workbench.debug.watchExpressionsView",e.$9H="workbench.debug.callStackView",e.$0H="workbench.debug.loadedScriptsView",e.$$H="workbench.debug.breakPointsView",e.$_H="workbench.debug.disassemblyView",e.$aI="workbench.panel.repl",e.$bI="workbench.panel.repl.view",e.$cI=new R.$Hj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$dI=new R.$Hj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$eI=new R.$Hj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$fI="debugUx",e.$gI=new R.$Hj(e.$fI,"default",{type:"string",description:N.localize(3,null)}),e.$hI=new R.$Hj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$iI=new R.$Hj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$jI=new R.$Hj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$kI=new R.$Hj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$lI=new R.$Hj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$mI=new R.$Hj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$nI=new R.$Hj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$oI=new R.$Hj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$pI=new R.$Hj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$qI=new R.$Hj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$rI=new R.$Hj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$sI=new R.$Hj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$tI=new R.$Hj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$uI=new R.$Hj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$vI=new R.$Hj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$wI=new R.$Hj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$xI=new R.$Hj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$yI=new R.$Hj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$zI=new R.$Hj("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$AI=new R.$Hj("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$BI=new R.$Hj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$CI=new R.$Hj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$DI=new R.$Hj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$EI=new R.$Hj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$FI=new R.$Hj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$GI=new R.$Hj("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$HI=new R.$Hj("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$II=new R.$Hj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$JI=new R.$Hj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$KI=new R.$Hj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$LI=new R.$Hj("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$MI=new R.$Hj("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$NI=new R.$Hj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$OI=new R.$Hj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$PI=new R.$Hj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$QI=new R.$Hj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$RI=new R.$Hj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$SI=new R.$Hj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$TI=new R.$Hj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$UI=new R.$Hj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$VI=new R.$Hj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$WI=new R.$Hj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$XI=new R.$Hj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$YI=new R.$Hj("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$ZI=new R.$Hj("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$1I=new R.$Hj("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$2I=new R.$Hj("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$3I=new R.$Hj("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$4I=new R.$Hj("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$5I=new R.$Hj("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$6I=new R.$Hj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$7I=new R.$Hj("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$8I=new R.$Hj("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$9I=new R.$Hj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$0I=new R.$Hj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$$I=new R.$Hj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$_I=new R.$Hj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const M=i=>N.localize(61,null,i);e.$aJ=M,e.$bJ="editor.contrib.debug",e.$cJ="editor.contrib.breakpoint",e.$dJ="debug",e.$eJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var m;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(m||(e.State=m={}));function g(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$gJ="vscode-debug-memory";function T(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var k;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(k||(e.DataBreakpointSetType=k={}));var u;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var w;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(w||(e.DebuggerString=w={})),e.$iJ=(0,F.$qi)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var n;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(n||(e.DebugVisualizationType=n={}));var o;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var s;(function(i){i.deserialize=a=>a,i.serialize=a=>a})(s||(e.IDebugVisualizationTreeItem=s={}));var r;(function(i){i.deserialize=a=>({id:a.id,name:a.name,iconPath:a.iconPath&&{light:I.URI.revive(a.iconPath.light),dark:I.URI.revive(a.iconPath.dark)},iconClass:a.iconClass,visualization:a.visualization}),i.serialize=a=>a})(r||(e.IDebugVisualization=r={}))}),define(Re[218],Ae([1,0,15,2,19,26,12,29,24,18]),function(ge,e,I,N,R,F,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hH=void 0,e.$8G=k,e.$9G=u,e.$0G=w,e.$$G=d,e.$_G=n,e.$aH=o,e.$bH=s,e.$cH=i,e.$dH=t,e.$eH=b,e.$fH=$,e.$gH=p;const T=/{([^}]+)}/g;function k(D,f,S){return D.replace(T,function(y,C){return f&&C.length>0&&C[0]!=="_"?y:S&&S.hasOwnProperty(C)?S[C]:y})}function u(D){const f={};for(const S of Object.keys(D))S.startsWith("!")||(f[S]=D[S]);return f}function w(D){return D.configuration.request==="attach"&&!d(D)&&(!D.parentSession||w(D.parentSession))}function d(D){let f=D.configuration.type;if(f)return f==="vslsShare"&&(f=D.configuration.adapterProxy.configuration.type),(0,I.$tf)(f,"extensionhost")||(0,I.$tf)(f,"pwa-extensionhost")?D:D.parentSession?d(D.parentSession):void 0}function n(D){return D.type&&(D.label||D.program||D.runtime)}function o(D,f,S){let y,C=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=P.exec(D);){const W=V.index+1,q=W+V[0].length;if(W<=f&&q>=S){y=V[0],C=W;break}}if(y){const W=/\w+/g;let q=null;for(;(q=W.exec(y))&&!(q.index+1+C+q[0].length>=S););q&&(y=y.substring(0,W.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}async function s(D,f,S,y){if(D.evaluatableExpressionProvider.has(f)){const C=D.evaluatableExpressionProvider.ordered(f),P=(0,E.$Hb)(await Promise.all(C.map(async V=>{try{return await V.provideEvaluatableExpression(f,S,y??g.CancellationToken.None)}catch{return}})));if(P.length>0){let V=P[0].expression;const W=P[0].range;return V||(V=f.getLineContent(S.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:V}}}else{const C=f.getLineContent(S.lineNumber),{start:P,end:V}=o(C,S.column,S.column),W=C.substring(P-1,V);return{matchingExpression:W,range:new m.$kt(S.lineNumber,P,S.lineNumber,P+W.length)}}return null}const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(r))}function a(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return N.URI.parse(D.path);if((0,R.$jc)(D.path))return N.URI.file(D.path)}return D.path}function h(D){if(typeof D.path=="object"){const f=N.URI.revive(D.path);if(f)return f.scheme===M.Schemas.file?f.fsPath:f.toString()}return D.path}function t(D,f){const S=f?a:h,y=(0,F.$Wn)(D);return c(y,(C,P)=>{C&&P&&(P.path=S(P))}),y}function b(D,f){const S=f?a:h,y=(0,F.$Wn)(D);return c(y,(C,P)=>{!C&&P&&(P.path=S(P))}),y}function c(D,f){switch(D.type){case"event":{const S=D;switch(S.event){case"output":f(!1,S.body.source);break;case"loadedSource":f(!1,S.body.source);break;case"breakpoint":f(!1,S.body.breakpoint.source);break;default:break}break}case"request":{const S=D;switch(S.command){case"setBreakpoints":f(!0,S.arguments.source);break;case"breakpointLocations":f(!0,S.arguments.source);break;case"source":f(!0,S.arguments.source);break;case"gotoTargets":f(!0,S.arguments.source);break;case"launchVSCode":S.arguments.args.forEach(y=>f(!1,y));break;default:break}break}case"response":{const S=D;if(S.success&&S.body)switch(S.command){case"stackTrace":S.body.stackFrames.forEach(y=>f(!1,y.source));break;case"loadedSources":S.body.sources.forEach(y=>f(!1,y));break;case"scopes":S.body.scopes.forEach(y=>f(!1,y.source));break;case"setFunctionBreakpoints":S.body.breakpoints.forEach(y=>f(!1,y.source));break;case"setBreakpoints":S.body.breakpoints.forEach(y=>f(!1,y.source));break;case"disassemble":S.body?.instructions.forEach(C=>f(!1,C.location));break;default:break}break}}}function $(D){return D.filter(f=>!f.presentation?.hidden).sort((f,S)=>f.presentation?S.presentation?f.presentation.group?S.presentation.group?f.presentation.group!==S.presentation.group?f.presentation.group.localeCompare(S.presentation.group):v(f.presentation.order,S.presentation.order):-1:S.presentation.group?1:v(f.presentation.order,S.presentation.order):-1:S.presentation?1:0)}function v(D,f){return typeof D!="number"?typeof f!="number"?0:1:typeof f!="number"?-1:D-f}async function p(D,f){const S=D.getValue("debug.saveBeforeStart",{overrideIdentifier:f.activeTextEditorLanguageId});if(S!=="none"&&(await f.saveAll(),S==="allEditorsInActiveGroup")){const y=f.activeEditorPane;y&&y.input.resource?.scheme===M.Schemas.untitled&&await f.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}const l=(D,f)=>!D||!f?D===f:D.name===f.name&&D.path===f.path&&D.sourceReference===f.sourceReference;e.$hH=l}),define(Re[219],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vK=e.CellExecutionUpdateType=void 0;var N;(function(R){R[R.Output=1]="Output",R[R.OutputItems=2]="OutputItems",R[R.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$vK=(0,I.$qi)("INotebookExecutionService")}),define(Re[220],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mib=e.$lib=e.ProxyKernelState=e.$kib=void 0,e.$kib=100;var N;(function(R){R[R.Disconnected=1]="Disconnected",R[R.Connected=2]="Connected",R[R.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$lib=(0,I.$qi)("INotebookKernelService"),e.$mib=(0,I.$qi)("INotebookKernelHistoryService")}),define(Re[221],Ae([1,0,6,29,149,95]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Vb=void 0;class M extends I.$Uc{constructor(g,E,T){super(),this._source=g,this.b=E,this.c=T,this.a=void 0}f(g){const E=g.getLineCount();return new N.$kt(1,1,E,this.g(g,E))}g(g,E){if(E<1||E>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const g=new R.$MC;g.acceptChunk(this._source);const E=g.finish(!0),{textBuffer:T,disposable:k}=E.create(1);this.b=T,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const E=new R.$MC;E.acceptChunk(g);const T=E.finish(!0),{textBuffer:k,disposable:u}=T.create(1);return this.B(u),k})),this.a}findInInputs(g){const T=new F.$AC(g,!1,!1,null).parseSearchRequest();if(!T)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,T,!0,5e3)}findInOutputs(g){const T=new F.$AC(g,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(k=>{const u=k.findMatchesLineByLine(this.f(k),T,!0,5e3);if(u.length!==0)return{textBuffer:k,matches:u}}).filter(k=>!!k):[]}}e.$_Vb=M}),define(Re[50],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BL=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(F){F.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var N;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class R{static fromExtHostTestItem(M,m,g=M.parent){if(M._isRoot)return new R([m]);const E=[M.id];for(let T=g;T&&T.id!==m;T=T.parent)E.push(T.id);return E.push(m),new R(E.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const m=M.indexOf("\0");return m===-1?M:M.slice(0,m)}static fromString(M){return new R(M.split("\0"))}static join(M,m){return new R([...M.path,m])}static joinToString(M,m){return M.toString()+"\0"+m}static parentId(M){const m=M.lastIndexOf("\0");return m===-1?void 0:M.slice(0,m)}static localId(M){const m=M.lastIndexOf("\0");return m===-1?M:M.slice(m+1)}static isChild(M,m){return m.startsWith(M)&&m[M.length]==="\0"}static compare(M,m){return M===m?0:R.isChild(M,m)?2:R.isChild(m,M)?3:1}constructor(M,m=M.length){if(this.path=M,this.d=m,M.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new R(this.path,1)}get parentId(){return this.d>1?new R(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new R(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new R(this.path,M)}compare(M){if(typeof M=="string")return R.compare(this.toString(),M);for(let m=0;m<M.d&&m<this.d;m++)if(M.path[m]!==this.path[m])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$BL=R}),define(Re[61],Ae([1,0,2,93,29,50]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$JL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$IL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$HL=e.$GL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$FL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$EL=e.$DL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$CL=e.TestResultState=void 0;var M;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$CL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var m;(function(A){A[A.Run=1]="Run",A[A.Debug=2]="Debug",A[A.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var g;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable",A[A.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$DL=[2,4,8,16,32,64];const E=A=>"runId"in A;e.$EL=E;var T;(function(A){A.serialize=j=>({range:j.range.toJSON(),uri:j.uri.toJSON()}),A.deserialize=(j,K)=>({range:R.$kt.lift(K.range),uri:j.asCanonicalUri(I.URI.revive(K.uri))})})(T||(e.IRichLocation=T={}));var k;(function(A){A[A.Error=0]="Error",A[A.Output=1]="Output"})(k||(e.TestMessageType=k={}));var u;(function(A){A.serialize=j=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&T.serialize(j.location)}),A.deserialize=(j,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&T.deserialize(j,K.location)})})(u||(e.ITestErrorMessage=u={}));const w=(A,j)=>`${j?"s":"e"}${A}`;e.$FL=w;var d;(function(A){A.serialize=j=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&T.serialize(j.location)}),A.deserialize=(j,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&T.deserialize(j,K.location)})})(d||(e.ITestOutputMessage=d={}));var n;(function(A){A.serialize=j=>j.type===0?u.serialize(j):d.serialize(j),A.deserialize=(j,K)=>K.type===0?u.deserialize(j,K):d.deserialize(j,K)})(n||(e.ITestMessage=n={}));var o;(function(A){A.serializeWithoutMessages=j=>({state:j.state,duration:j.duration,messages:[]}),A.serialize=j=>({state:j.state,duration:j.duration,messages:j.messages.map(n.serialize)}),A.deserialize=(j,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(ie=>n.deserialize(j,ie))})})(o||(e.ITestTaskState=o={}));const s="\0",r=(A,j)=>A+s+j;e.$GL=r;const i=A=>{const j=A.indexOf(s);return{ctrlId:A.slice(0,j),tagId:A.slice(j+1)}};e.$HL=i;var a;(function(A){A.serialize=j=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?.toJSON(),range:j.range?.toJSON()||null,description:j.description,error:j.error,sortText:j.sortText}),A.deserialize=(j,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?j.asCanonicalUri(I.URI.revive(K.uri)):void 0,range:K.range?R.$kt.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(a||(e.ITestItem=a={}));var h;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(A){A.serialize=j=>({expand:j.expand,item:a.serialize(j.item)}),A.deserialize=(j,K)=>({controllerId:F.$BL.root(K.item.extId),expand:K.expand,item:a.deserialize(j,K.item)})})(t||(e.InternalTestItem=t={}));var b;(function(A){A.serialize=j=>{let K;return j.item&&(K={},j.item.label!==void 0&&(K.label=j.item.label),j.item.tags!==void 0&&(K.tags=j.item.tags),j.item.busy!==void 0&&(K.busy=j.item.busy),j.item.uri!==void 0&&(K.uri=j.item.uri?.toJSON()),j.item.range!==void 0&&(K.range=j.item.range?.toJSON()),j.item.description!==void 0&&(K.description=j.item.description),j.item.error!==void 0&&(K.error=j.item.error),j.item.sortText!==void 0&&(K.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:K}},A.deserialize=j=>{let K;return j.item&&(K={},j.item.label!==void 0&&(K.label=j.item.label),j.item.tags!==void 0&&(K.tags=j.item.tags),j.item.busy!==void 0&&(K.busy=j.item.busy),j.item.range!==void 0&&(K.range=j.item.range?R.$kt.lift(j.item.range):null),j.item.description!==void 0&&(K.description=j.item.description),j.item.error!==void 0&&(K.error=j.item.error),j.item.sortText!==void 0&&(K.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:K}}})(b||(e.ITestItemUpdate=b={}));const c=(A,j)=>{j.expand!==void 0&&(A.expand=j.expand),j.item!==void 0&&(A.item=A.item?Object.assign(A.item,j.item):j.item)};e.$IL=c;var $;(function(A){A.serializeWithoutMessages=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(o.serializeWithoutMessages)}),A.serialize=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(o.serialize)}),A.deserialize=(j,K)=>({...t.deserialize(j,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(ie=>o.deserialize(j,ie)),retired:!0})})($||(e.TestResultItem=$={}));var v;(function(A){A.empty=()=>({covered:0,total:0}),A.sum=(j,K)=>{j.covered+=K.covered,j.total+=K.total}})(v||(e.ICoverageCount=v={}));var p;(function(A){A.serialize=j=>({id:j.id,statement:j.statement,branch:j.branch,declaration:j.declaration,uri:j.uri.toJSON()}),A.deserialize=(j,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:j.asCanonicalUri(I.URI.revive(K.uri))})})(p||(e.IFileCoverage=p={}));function l(A){return{...A,location:A.location?.toJSON()}}function D(A){return A.location=A.location?N.$jt.isIPosition(A.location)?N.$jt.lift(A.location):R.$kt.lift(A.location):void 0,A}e.$JL=3;var f;(function(A){A[A.Declaration=0]="Declaration",A[A.Statement=1]="Statement",A[A.Branch=2]="Branch"})(f||(e.DetailType=f={}));var S;(function(A){A.serialize=j=>j.type===0?C.serialize(j):P.serialize(j),A.deserialize=j=>j.type===0?C.deserialize(j):P.deserialize(j)})(S||(e.CoverageDetails=S={}));var y;(function(A){A.serialize=l,A.deserialize=D})(y||(e.IBranchCoverage=y={}));var C;(function(A){A.serialize=l,A.deserialize=D})(C||(e.IDeclarationCoverage=C={}));var P;(function(A){A.serialize=j=>({...l(j),branches:j.branches?.map(y.serialize)}),A.deserialize=j=>({...D(j),branches:j.branches?.map(y.deserialize)})})(P||(e.IStatementCoverage=P={}));var V;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.DocumentSynced=2]="DocumentSynced",A[A.Remove=3]="Remove",A[A.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",A[A.Retire=5]="Retire",A[A.AddTag=6]="AddTag",A[A.RemoveTag=7]="RemoveTag"})(V||(e.TestDiffOpType=V={}));var W;(function(A){A.deserialize=(j,K)=>K.op===0?{op:K.op,item:t.deserialize(j,K.item)}:K.op===1?{op:K.op,item:b.deserialize(K.item)}:K.op===2?{op:K.op,uri:j.asCanonicalUri(I.URI.revive(K.uri)),docv:K.docv}:K,A.serialize=j=>j.op===0?{op:j.op,item:t.serialize(j.item)}:j.op===1?{op:j.op,item:b.serialize(j.item)}:j})(W||(e.TestsDiffOp=W={}));class q{constructor(j){this.k=j,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(j){const K=this.v();for(const ie of j)switch(ie.op){case 0:this.l(t.deserialize(this.k,ie.item),K);break;case 1:this.o(b.deserialize(ie.item),K);break;case 3:this.p(ie.itemId,K);break;case 5:this.q(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.c.set(ie.tag.id,ie.tag);break;case 7:this.c.delete(ie.id);break}K.complete?.()}l(j,K){const ie=F.$BL.parentId(j.item.extId)?.toString();let ce;if(!ie)ce=this.w(j),this.g.add(ce),this.f.set(j.item.extId,ce);else if(this.f.has(ie)){const ve=this.f.get(ie);ve.children.add(j.item.extId),ce=this.w(j,ve),this.f.set(j.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(j)}`);return}return K.add?.(ce),j.expand===2&&this.h++,ce}o(j,K){const ie=this.f.get(j.extId);if(ie)return j.expand!==void 0&&(ie.expand===2&&this.h--,j.expand===2&&this.h++),(0,e.$IL)(ie,j),K.update?.(ie),ie}p(j,K){const ie=this.f.get(j);if(!ie)return;const ce=F.$BL.parentId(ie.item.extId)?.toString();ce?this.f.get(ce).children.delete(ie.item.extId):this.g.delete(ie);const ve=[[j]];for(;ve.length;)for(const Ie of ve.pop()){const ue=this.f.get(Ie);ue&&(ve.push(ue.children),this.f.delete(Ie),K.remove?.(ue,ue!==ie),ue.expand===2&&this.h--)}}q(j){}updatePendingRoots(j){this.j+=j}v(){return{}}}e.$KL=q}),define(Re[75],Ae([1,0,11,5,6,56,61,50]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.TestItemEventOp=void 0;var g;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const E=(r,i)=>r===i,k=Object.entries({range:(r,i)=>r===i?!0:!r||!i?!1:r.equalsRange(i),busy:E,label:E,description:E,error:E,sortText:E,tags:(r,i)=>!(r.length!==i.length||r.some(a=>!i.includes(a)))}),u=(r,i)=>{let a;for(const[h,t]of k)t(r[h],i[h])||(a?a[h]=i[h]:a={[h]:i[h]});return a};class w extends R.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new I.$Ch(()=>this.flushDiff(),200)),this.g=this.B(new N.$be),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===i.uri){a.docv=i.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===i.item.extId){(0,M.$IL)(a.item,i.item);return}if(a.op===0&&a.item.item.extId===i.item.extId){(0,M.$IL)(a.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,a){const h=this.tree.get(i);if(h){if((h.expandLevels===void 0||a>h.expandLevels)&&(h.expandLevels=a),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,a-1):t.wait().then(()=>this.L(h,a-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,a-1)):this.L(h,a-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,a){switch(a.op){case 3:this.O(m.$BL.joinToString(i.fullId,a.id));break;case 0:this.z(a.item,i);break;case 5:for(const h of a.ops)this.w(i,h);break;case 1:this.C(a.new,a.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:a.update}});break;case 6:this.y(i.actual.uri);break;default:(0,F.$cd)(a)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,a){const h=m.$BL.fromExtHostTestItem(i,this.root.id,a?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==a?.actual&&this.s.getChildren(t.parent).delete(i.id);let b=this.tree.get(h.toString());if(!b){b={fullId:h,actual:i,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(b.fullId.toString(),b),this.G(i,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:b.expand,item:this.s.toITestItem(i)}}),this.I(i,b,a);return}if(b.actual===i){this.H(i,b,a);return}if(b.actual.uri?.toString()!==i.uri?.toString())return this.O(h.toString()),this.z(i,a);const c=this.s.getChildren(b.actual),$=b.actual,v=u(this.s.toITestItem($),this.s.toITestItem(i));this.s.getApiFor($).listener=void 0,b.actual=i,b.resolveBarrier=void 0,b.expand=0,v&&(v.hasOwnProperty("tags")&&(this.C(i.tags,$.tags,h.toString()),delete v.tags),this.w(b,{op:4,update:v})),this.I(i,b,a);for(const[l,D]of c)this.s.getChildren(i).get(D.id)||this.O(m.$BL.joinToString(h,D.id));const p=b.expandLevels;p!==void 0&&queueMicrotask(()=>{b.expand===1&&(b.expandLevels=void 0,this.expand(h.toString(),p))}),this.y(b.actual.uri)}C(i,a,h){const t=new Set(a.map(b=>b.id));for(const b of i)t.delete(b.id)||this.D(b);this.pushDiff({op:1,item:{extId:h,item:{tags:i.map(b=>(0,M.$GL)(this.s.controllerId,b.id))}}}),t.forEach(this.F,this)}D(i){const a=this.j.get(i.id);a?a.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$GL)(this.s.controllerId,i.id)}}))}F(i){const a=this.j.get(i);a&&!--a.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,M.$GL)(this.s.controllerId,i)}))}G(i,a){this.s.getApiFor(i).parent=a&&a.actual!==this.root?a.actual:void 0}H(i,a,h){this.G(i,h);const t=this.s.getApiFor(i);t.parent=h?.actual,t.listener=b=>this.w(a,b),this.J(a)}I(i,a,h){this.H(i,a,h);for(const[t,b]of this.s.getChildren(i))this.z(b,a)}J(i){let a;this.h?i.resolveBarrier?a=i.resolveBarrier.isOpen()?3:2:a=i.actual.canResolveChildren?1:0:a=0,a!==i.expand&&(i.expand=a,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:a}}),a===1&&i.expandLevels!==void 0&&this.M(i))}L(i,a){if(a<0)return;const h=[];for(const[t,b]of this.s.getChildren(i.actual)){const c=this.expand(m.$BL.joinToString(i.fullId,b.id),a);(0,I.$ch)(c)&&h.push(c)}if(h.length)return Promise.all(h).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const b=new I.$ph;return b.open(),b}i.expand=2,this.N(i);const a=i.resolveBarrier=new I.$ph,h=b=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,b)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(b){h(b)}return(0,I.$ch)(t)?t.catch(h).then(()=>{a.open(),this.J(i)}):(a.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const a=this.tree.get(i);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const h=[a];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const b of t.actual.tags)this.F(b.id);this.tree.delete(t.fullId.toString());for(const[b,c]of this.s.getChildren(t.actual))h.push(this.tree.get(m.$BL.joinToString(t.fullId,c.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$3O=w;class d extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$4O=d;class n extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$5O=n;class o extends Error{constructor(i,a,h){super(`TestItem with ID "${i}" is from controller "${a}" and cannot be added as a child of an item from controller "${h}".`)}}e.$6O=o;const s=(r,i,a)=>{let h=new Map;return{get size(){return h.size},forEach(t,b){for(const c of h.values())t.call(b,c,this)},[Symbol.iterator](){return h.entries()},replace(t){const b=new Map,c=new Set(h.keys()),$={op:5,ops:[]};for(const v of t){if(!(v instanceof a))throw new n(v.id);const p=i(v).controllerId;if(p!==r.controllerId)throw new o(v.id,p,r.controllerId);if(b.has(v.id))throw new d(v.id);b.set(v.id,v),c.delete(v.id),$.ops.push({op:0,item:v})}for(const v of c.keys())$.ops.push({op:3,id:v});r.listener?.($),h=b},add(t){if(!(t instanceof a))throw new n(t.id);h.set(t.id,t),r.listener?.({op:0,item:t})},delete(t){h.delete(t)&&r.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$7O=s}),define(Re[105],Ae([1,0,75]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$8O=void 0;const N=new WeakMap,R=(M,m)=>{const g={controllerId:m};return N.set(M,g),g};e.$8O=R;const F=M=>{const m=N.get(M);if(!m)throw new I.$5O(M?.id||"<unknown>");return m};e.$9O=F}),define(Re[76],Ae([1,0,12,2]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fxb=e.$Exb=e.$Dxb=void 0,e.$Gxb=R,e.$Hxb=M,e.$Dxb="vscode-cdn.net",e.$Exb=`vscode-resource.${e.$Dxb}`,e.$Fxb=`'self' https://*.${e.$Dxb}`;function R(m,g){return m.scheme===I.Schemas.http||m.scheme===I.Schemas.https?m:(g&&g.authority&&g.isRemote&&m.scheme===I.Schemas.file&&(m=N.URI.from({scheme:I.Schemas.vscodeRemote,authority:g.authority,path:m.path})),N.URI.from({scheme:I.Schemas.https,authority:`${m.scheme}+${F(m.authority)}.${e.$Exb}`,path:m.path,fragment:m.fragment,query:m.query}))}function F(m){return m.replace(/./g,g=>{const E=g.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?g:"-"+E.toString(16).padStart(4,"0")})}function M(m){return m.replace(/-([0-9a-f]{4})/g,(g,E)=>String.fromCharCode(parseInt(E,16)))}}),define(Re[222],Ae([1,0,5,6,76]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=void 0;class F{constructor(m,g,E){this.d=m,this.e=g,this.f=E,this.a=0,this.b=new N.$Tc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const T=g.getVisibleTextEditors();for(const k of this.c.values())T.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,g,E,T,k){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===m){u=i;break}if(!u)throw new Error("not a visible editor");const w=this,d=this.a++,n=new I.$be,o=new I.$be,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,R.$Gxb)(i,w.f)}get cspSource(){return R.$Fxb}set options(i){this.b=i,w.d.$setOptions(d,i)}get options(){return this.b}set html(i){this.a=i,w.d.$setHtml(d,i)}get html(){return this.a}get onDidReceiveMessage(){return n.event}postMessage(i){return w.d.$postMessage(d,i)}},r=new class{constructor(){this.editor=m,this.line=g,this.height=E,this.webview=s,this.onDidDispose=o.event}dispose(){w.c.has(d)&&(w.c.delete(d),w.d.$disposeEditorInset(d),o.fire(),o.dispose(),n.dispose())}};return this.d.$createEditorInset(d,u.id,u.value.document.uri,g+1,E,T||{},k.identifier,k.extensionLocation),this.c.set(d,{editor:m,inset:r,onDidReceiveMessage:n}),r}$onDidDispose(m){const g=this.c.get(m);g&&g.inset.dispose()}$onDidReceiveMessage(m,g){this.c.get(m)?.onDidReceiveMessage.fire(g)}}e.$gkc=F}),define(Re[106],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=e.$RL=void 0,e.$RL="__",e.$SL=(0,I.$qi)("IAuthenticationService"),e.$TL=(0,I.$qi)("IAuthenticationExtensionsService")}),define(Re[223],Ae([1,0,3]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=e.VariableKind=e.$YP=void 0,e.$YP=(0,I.$qi)("configurationResolverService");var N;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator",F.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class R extends Error{constructor(M,m){super(m),this.variable=M}}e.$ZP=R}),define(Re[224],Ae([1,0,19,73,17,26,21,96,184,223,15]),function(ge,e,I,N,R,F,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cQ=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,d,n,o){this.h=new Map,this.a=w,this.b=d,this.g=n,o&&(this.c=o.then(s=>this.i(s)))}i(w){if(M.$i){const d=Object.create(null);return Object.keys(w).forEach(n=>{d[n.toLowerCase()]=w[n]}),d}return w}resolveWithEnvironment(w,d,n){return this.l({env:this.i(w),userHome:void 0},d?d.uri:void 0,n)}async resolveAsync(w,d){const n={env:await this.c,userHome:await this.g};return this.l(n,w?w.uri:void 0,d)}async j(w,d,n,o){const s=F.$Wn(d);M.$i&&s.windows?Object.keys(s.windows).forEach(i=>s[i]=s.windows[i]):M.$j&&s.osx?Object.keys(s.osx).forEach(i=>s[i]=s.osx[i]):M.$k&&s.linux&&Object.keys(s.linux).forEach(i=>s[i]=s.linux[i]),delete s.windows,delete s.osx,delete s.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,w?w.uri:void 0,s,n,o)}async resolveAnyAsync(w,d,n){return this.j(w,d,n)}async resolveAnyMap(w,d,n){const o=new Map;return{newConfig:await this.j(w,d,n,o),resolvedVariables:o}}resolveWithInteractionReplace(w,d,n,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,d,n,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,d){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,d)}async l(w,d,n,o,s){if(R.$4f(n))return this.m(w,d,n,o,s);if(Array.isArray(n))return Promise.all(n.map(r=>this.l(w,d,r,o,s)));if(R.$6f(n)){const r=Object.create(null),i=await Promise.all(Object.keys(n).map(async a=>[await this.m(w,d,a,o,s),await this.l(w,d,n[a],o,s)]));for(const[a,h]of i)r[a]=h;return r}return n}m(w,d,n,o,s){return(0,T.$lf)(n,k.VARIABLE_REGEXP,async(r,i)=>{if(i.includes(k.VARIABLE_LHS))return r;let a=await this.o(w,r,i,d,o);return s?.set(i,a),a!==r&&R.$4f(a)&&a.match(k.VARIABLE_REGEXP)&&(a=await this.m(w,d,a,o,s)),a})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,d,n,o,s){let r;const i=n.split(":");i.length>1&&(n=i[0],r=i[1]);const a=b=>{const c=this.a.getFilePath();if(c)return(0,m.$pw)(c);throw new E.$ZP(b,(0,g.localize)(0,null,d))},h=b=>{const c=a(b);if(this.a.getWorkspaceFolderPathForFile){const $=this.a.getWorkspaceFolderPathForFile();if($)return(0,m.$pw)($)}throw new E.$ZP(b,(0,g.localize)(1,null,d,I.$oc(c)))},t=b=>{if(r){const c=this.a.getFolderUri(r);if(c)return c;throw new E.$ZP(b,(0,g.localize)(2,null,d,r))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new E.$ZP(b,(0,g.localize)(3,null,d)):new E.$ZP(b,(0,g.localize)(4,null,d))};switch(n){case"env":if(r){if(w.env){const b=w.env[M.$i?r.toLowerCase():r];if(R.$4f(b))return b}return""}throw new E.$ZP(E.VariableKind.Env,(0,g.localize)(5,null,d));case"config":if(r){const b=this.a.getConfigurationValue(o,r);if(R.$ag(b))throw new E.$ZP(E.VariableKind.Config,(0,g.localize)(6,null,d,r));if(R.$6f(b))throw new E.$ZP(E.VariableKind.Config,(0,g.localize)(7,null,d,r));return b}throw new E.$ZP(E.VariableKind.Config,(0,g.localize)(8,null,d));case"command":return this.p(E.VariableKind.Command,d,r,s,"command");case"input":return this.p(E.VariableKind.Input,d,r,s,"input");case"extensionInstallFolder":if(r){const b=await this.a.getExtension(r);if(!b)throw new E.$ZP(E.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,d,r));return this.n(b.extensionLocation)}throw new E.$ZP(E.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,d));default:switch(n){case"workspaceRoot":case"workspaceFolder":return(0,m.$pw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return o||r?(0,m.$pw)(this.n(t(E.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$pw)(I.$oc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new E.$ZP(E.VariableKind.UserHome,(0,g.localize)(11,null,d))}case"lineNumber":{const b=this.a.getLineNumber();if(b)return b;throw new E.$ZP(E.VariableKind.LineNumber,(0,g.localize)(12,null,d))}case"selectedText":{const b=this.a.getSelectedText();if(b)return b;throw new E.$ZP(E.VariableKind.SelectedText,(0,g.localize)(13,null,d))}case"file":return a(E.VariableKind.File);case"fileWorkspaceFolder":return h(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$oc(h(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||r?I.$mc(this.n(t(E.VariableKind.RelativeFile)),a(E.VariableKind.RelativeFile)):a(E.VariableKind.RelativeFile);case"relativeFileDirname":{const b=I.$nc(a(E.VariableKind.RelativeFileDirname));if(o||r){const c=I.$mc(this.n(t(E.VariableKind.RelativeFileDirname)),b);return c.length===0?".":c}return b}case"fileDirname":return I.$nc(a(E.VariableKind.FileDirname));case"fileExtname":return I.$pc(a(E.VariableKind.FileExtname));case"fileBasename":return I.$oc(a(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const b=I.$oc(a(E.VariableKind.FileBasenameNoExtension));return b.slice(0,b.length-I.$pc(b).length)}case"fileDirnameBasename":return I.$oc(I.$nc(a(E.VariableKind.FileDirnameBasename)));case"execPath":{const b=this.a.getExecPath();return b||d}case"execInstallFolder":{const b=this.a.getAppRoot();return b||d}case"pathSeparator":case"/":return I.sep;default:try{const b=r?`${n}:${r}`:n;return this.p(E.VariableKind.Unknown,d,b,s,void 0)}catch{return d}}}}p(w,d,n,o,s){if(n&&o){const r=s===void 0?o[n]:o[s+":"+n];if(typeof r=="string")return r;throw new E.$ZP(w,(0,g.localize)(14,null,d))}return d}}e.$cQ=k}),define(Re[107],Ae([1,0,3,104]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$ID=void 0,e.$JD=E,e.$KD=u,e.$LD=w,e.$ID=(0,I.$qi)("editorGroupsService");var R;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(R||(e.GroupDirection=R={}));var F;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var M;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var m;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var g;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function E(d){const n=d;return(0,N.$tF)(n?.editor)&&(0,N.$tF)(n?.replacement)}var T;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var k;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function u(d){const n=d;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}function w(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Re[225],Ae([1,0,3,107]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PD=e.$OD=e.$ND=e.$MD=void 0,e.$QD=R,e.$MD=(0,I.$qi)("editorService"),e.$ND=-1,e.$OD=-2,e.$PD=-3;function R(F){const M=F;return typeof F=="number"||(0,N.$KD)(M)}}),define(Re[226],Ae([1,0,3,191]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=void 0,e.$aM=(0,I.$ri)(N.$xi)}),define(Re[108],Ae([1,0,20,5,19,6,11]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$b=e.$E$b=e.$D$b=e.$C$b=e.$B$b=void 0;class m{constructor(r,i){this.versionId=r,this.removedDueToLooping=i}}e.$B$b=m;class g{static isHostExtension(r,i,a){if(i.getExtensionDescription(r))return!1;const h=a.getExtensionDescription(r);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(r,i){this.j=r,this.c=new N.$be,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(n),this.f=new I.$Nm,this.g=[],this.h=new Map;for(const r of this.e){if(this.f.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.f.set(r.identifier,r),this.g.push(r);const i=this.j.readActivationEvents(r);for(const a of i)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(r)}}set(r){return this.e=r,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(r,i){this.e=o(this.e,i),this.e=this.e.concat(r);const a=g.l(this.e);return this.e=o(this.e,a.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new m(this.d,a)}static l(r){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(c){this.d.has(c)||(this.d.add(c),this.e.push(c))}addArc(c,$){this.addNode(c),this.addNode($),this.c.has(c)?this.c.get(c).push($):this.c.set(c,[$])}getArcs(c){return this.c.has(c)?this.c.get(c):[]}hasOnlyGoodArcs(c,$){const v=i.getArcs(c);for(let p=0;p<v.length;p++)if(!$.has(v[p]))return!1;return!0}getNodes(){return this.e}},a=new I.$Nm;for(const c of r)if(a.set(c.identifier,c),c.extensionDependencies)for(const $ of c.extensionDependencies)i.addArc(I.$Lm.toKey(c.identifier),I.$Lm.toKey($));const h=new Set;i.getNodes().filter(c=>i.getArcs(c).length===0).forEach(c=>h.add(c));const t=i.getNodes().filter(c=>!h.has(c));let b;do{b=!1;for(let c=0;c<t.length;c++){const $=t[c];i.hasOnlyGoodArcs($,h)&&(t.splice(c,1),c--,h.add($),b=!0)}}while(b);return t.map(c=>a.get(c))}containsActivationEvent(r){return this.h.has(r)}containsExtension(r){return this.f.has(r)}getExtensionDescriptionsForActivationEvent(r){const i=this.h.get(r);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(r){const i=this.f.get(r);return i||void 0}getExtensionDescriptionByUUID(r){for(const i of this.g)if(i.uuid===r)return i}getExtensionDescriptionByIdOrUUID(r,i){return this.getExtensionDescription(r)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$C$b=g;class E{constructor(r,i){this.versionId=r,this.extensions=i}}e.$D$b=E;class T{constructor(r){this.d=new w,this.c=new g(r,[])}async acquireLock(r){const i=await this.d.acquire(r);return new k(this,i)}deltaExtensions(r,i,a){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,a)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,i){return this.c.getExtensionDescriptionByIdOrUUID(r,i)}}e.$E$b=T;class k extends F.$Uc{constructor(r,i){super(),this.f=r,this.c=!1,this.B(i)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$F$b=k;class u{constructor(r){this.name=r;const i=(0,M.$jh)();this.promise=i.promise,this.c=i.resolve}resolve(r){this.c(r)}}class w{constructor(){this.c=[],this.d=!1}async acquire(r){const i=new u(r);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{i&&(clearTimeout(a),i=!1,this.d=!1,this.e())};r.resolve((0,F.$Sc)(h))}}var d;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(d||(d={}));function n(s,r){const i=s.isBuiltin?0:s.isUnderDevelopment?2:1,a=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(i!==a)return i-a;const h=R.$hc.basename(s.extensionLocation.path),t=R.$hc.basename(r.extensionLocation.path);return h<t?-1:h>t?1:0}function o(s,r){const i=new I.$Mm(r);return s.filter(a=>!i.has(a.identifier))}}),define(Re[77],Ae([1,0,22]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Tm=M,e.$Um=m;var N;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(N||(e.UIKind=N={}));var R;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(R||(e.ExtensionHostExitCode=R={}));var F;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function M(E){const T=I.$Ce.alloc(1);switch(E){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function m(E,T){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var g;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Re[62],Ae([1,0,3,5,13,27,77,58,59,26,2,6,171]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uP=e.$sP=e.$rP=void 0,e.$tP=n;let w=class extends k.$Uc{constructor(s,r){super(),this.s=s,this.t=r,this.a=this.B(new N.$be),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$be),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=T.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:g.$ep,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(r.onDidChangeLogLevel(i=>{(0,R.$Yj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,r,i){const a=this.getTelemetryDetails(),h=new d(r,i,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(s,r,i){this.f=s,this.g=r,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const r=Object.create(null);switch(r["common.extname"]=`${s.publisher}.${s.name}`,r["common.extversion"]=s.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.sqmid"]=this.s.telemetryInfo.sqmId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=n(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:r["common.uikind"]="web";break;case M.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,m.$Cm)((0,g.$kp)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const r=this.getTelemetryDetails();this.r.forEach((i,a)=>{const h=i.filter(t=>!t.isDisposed);h.length===0?this.r.delete(a):this.r.set(a,h)}),this.r.forEach(i=>{for(const a of i)a.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,r){const a=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!a)return this.r.delete(s.value),!1;let h=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(r),h=!0);return h}};e.$rP=w,e.$rP=w=Je([Ve(0,F.$qP),Ve(1,R.$Xj)],w);class d{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,r,i,a,h,t,b){this.g=i,this.h=a,this.i=h,this.j=t,this.a=new N.$be,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled}}updateTelemetryEnablements(s,r){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let r="properties"in s?s.properties??{}:s;return r=(0,g.$np)(r,[]),this.c&&(r=(0,E.$Zn)(r,this.c)),this.b||(r=(0,E.$Zn)(r,this.j)),"properties"in s?s.properties=r:s=r,s}k(s,r){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(s,r),this.h.trace(s,r))}logUsage(s,r){this.d.isUsageEnabled&&this.k(s,r)}logError(s,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,r);else{const i={name:s.name,message:s.message,stack:s.stack,cause:s.cause},a=(0,g.$np)(i,[]),h=new Error(a.message,{cause:a.cause});h.stack=a.stack,h.name=a.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(h,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const s=this,r={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$sP=d;function n(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$uP=(0,I.$qi)("IExtHostTelemetry")}),define(Re[25],Ae([1,0,5,2,200,103,20,3]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DG=e.ActivationKind=e.$AG=e.$zG=e.$wG=e.ExtensionHostStartup=e.$vG=e.$uG=e.$tG=e.$sG=void 0,e.$xG=u,e.$yG=w,e.$BG=s,e.$CG=r,e.$sG=Object.freeze({identifier:new M.$Lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$tG="extensions.webWorker",e.$uG=(0,m.$qi)("extensionService");class g{constructor(h){this.dependency=h}}e.$vG=g;var E;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class T{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,b){this.c=h,this.d=t.slice(0),this.e=b.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$dG.createActivationEventsMap(this.d)}}set(h,t,b){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const c=[],$=[],v=[],p=[],l=k(this.d),D=k(t),f=(V,W)=>V.extensionLocation.toString()===W.extensionLocation.toString()||V.isBuiltin===W.isBuiltin||V.isUserBuiltin===W.isUserBuiltin||V.isUnderDevelopment===W.isUnderDevelopment;for(const V of this.d){const W=D.get(V.identifier);if(!W){c.push(V.identifier),l.delete(V.identifier);continue}if(!f(V,W)){c.push(V.identifier),l.delete(V.identifier);continue}}for(const V of t){const W=l.get(V.identifier);if(!W){$.push(V);continue}if(!f(W,V)){c.push(W.identifier),l.delete(W.identifier);continue}}const S=new M.$Mm(this.e),y=new M.$Mm(b);for(const V of this.e)y.has(V)||v.push(V);for(const V of b)S.has(V)||p.push(V);const C=F.$dG.createActivationEventsMap($),P={versionId:h,toRemove:c,toAdd:$,addActivationEvents:C,myToRemove:v,myToAdd:p};return this.delta(P),P}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:b,myToRemove:c,myToAdd:$}=h,v=new M.$Mm(t),p=new M.$Mm(c);for(let l=0;l<this.d.length;l++)v.has(this.d[l].identifier)&&(this.d.splice(l,1),l--);for(let l=0;l<this.e.length;l++)p.has(this.e[l])&&(this.e.splice(l,1),l--);for(const l of b)this.d.push(l);for(const l of $)this.e.push(l);return this.f=null,h}containsExtension(h){for(const t of this.e)if(M.$Lm.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const b=F.$dG.readActivationEvents(t);for(const c of b)h.add(c)}return h}}e.$wG=T;function k(a){const h=new M.$Nm;for(const t of a)h.set(t.identifier,t);return h}function u(a,h){return a.enabledApiProposals?a.enabledApiProposals.includes(h):!1}function w(a,h){if(!u(a,h))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}class d{constructor(h,t,b,c){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=b,this.activationReason=c}}e.$zG=d;class n{constructor(h,t){this.description=h,this.value=t}}e.$AG=n;var o;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,R.$tp)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}function r(a,h){return{identifier:new M.$Lm((0,R.$rp)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!h,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$DG=i}),define(Re[227],Ae([1,0,14,108,20,25,13,11]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkc=e.$Gkc=e.$Fkc=e.$Ekc=e.$Dkc=e.$Ckc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(s,r,i,a){this.startup=s,this.codeLoadingTime=r,this.activateCallTime=i,this.activateResolvedTime=a}}e.$Ckc=g;class E{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,r){return s===-1||r===-1?-1:r-s}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Dkc=E;class T{constructor(s,r,i,a,h,t){this.activationFailed=s,this.activationFailedError=r,this.activationTimes=i,this.module=a,this.exports=h,this.subscriptions=t}}e.$Ekc=T;class k extends T{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Fkc=k;class u extends T{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Gkc=u;class w extends T{constructor(s){super(!0,s,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let d=class{constructor(s,r,i,a){this.g=a,this.a=s,this.b=r,this.c=i,this.d=new R.$Nm,this.f=Object.create(null)}dispose(){for(const[s,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const s=[];for(const[r,i]of this.d)s.push(i.wait());await Promise.all(s)}isActivated(s){const r=this.d.get(s);return!!(r&&r.value)}getActivatedExtension(s){const r=this.d.get(s);if(!r||!r.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return r.value}async activateByEvent(s,r){if(this.f[s])return;const i=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(i.map(a=>({id:a.identifier,reason:{startup:r,extensionId:a.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,r){const i=this.a.getExtensionDescription(s);if(!i)throw new Error(`Extension '${s.value}' is not known`);return this.h([{id:i.identifier,reason:r}])}async h(s){const r=s.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(r.map(i=>i.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const r=this.a.getExtensionDescription(s.id);if(!r){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new w(h));return this.c.onExtensionActivationError(s.id,h,new F.$vG(s.id.value)),t}const i=[],a=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const h of a){if(this.m(h))continue;const t=this.d.get(h);if(t){i.push(t);continue}if(this.l(h)){i.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:s.reason}));continue}const b=this.a.getExtensionDescription(h);if(b){if(!b.main&&!b.browser)continue;i.push(this.j({id:b.identifier,reason:s.reason}));continue}const c=r.displayName||r.identifier.value,$=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${h}'`),v=this.k(s,r.displayName,[],new w($));return this.c.onExtensionActivationError(r.identifier,$,new F.$vG(h)),v}return this.k(s,r.displayName,i,null)}k(s,r,i,a){const h=new n(s.id,r,s.reason,i,a,this.c,this.g);return this.d.set(s.id,h),h}l(s){return N.$C$b.isHostExtension(s,this.a,this.b)}m(s){const r=this.b.getExtensionDescription(s);return r?!r.main&&!r.browser:!1}};e.$Hkc=d,e.$Hkc=d=Je([Ve(3,M.$Wj)],d);let n=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,r,i,a,h,t,b){this.c=s,this.d=r,this.f=i,this.g=a,this.h=h,this.j=t,this.k=b,this.a=new m.$ph,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const r=this.g[s];if(r.value&&!r.value.activationFailed){this.g.splice(s,1),s--;continue}if(r.value&&r.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);i.detail=r.value.activationFailedError,this.h=new w(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const r=new Error;if(s&&s.name&&(r.name=s.name),s&&s.message?r.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(r.stack=s.stack),this.h=new w(r),this.b&&I.$4(s))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};n=Je([Ve(6,M.$Wj)],n)}),define(Re[228],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[229],Ae([1,0,186,14,33,98,72,30,20,228,196,103]),function(ge,e,I,N,R,F,M,m,g,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=void 0;const u=m.$9n.as(M.$0n.JSONContribution);class w{constructor(h,t,b){this.a=h,this.b=t,this.c=b}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(R.default.Error,h)}warn(h){this.d(R.default.Warning,h)}info(h){this.d(R.default.Info,h)}}e.$mG=w;class d{static a(h){const t=new g.$Mm;for(let b=0,c=h.length;b<c;b++)t.add(h[b].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new d(t,[]);if(!t||!t.length)return new d([],h);const b=this.a(h),c=this.a(t),$=t.filter(p=>!b.has(p.description.identifier)),v=h.filter(p=>!c.has(p.description.identifier));return new d($,v)}constructor(h,t){this.added=h,this.removed=t}}e.$nG=d;class n{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=d.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,N.$1)(h)}}}e.$oG=n;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$pG={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$Km},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$No}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$No}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new n(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&k.$dG.register(h.extensionPoint,h.activationEventsGenerator),e.$pG.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,u.registerSchema(s,e.$pG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$qG=r;const i={ExtensionsRegistry:"ExtensionsRegistry"};m.$9n.add(i.ExtensionsRegistry,new r),e.$rG=m.$9n.as(i.ExtensionsRegistry),u.registerSchema(s,e.$pG),u.registerSchema(T.$ek,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Re[230],Ae([1,0,182,17,26,229,31,5]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UH=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var E;(function(u){function w(d,n,o){if(!d)return;const s=N.$4f(d.type)?d.type:void 0;if(!s||s.length===0){o.error(I.localize(3,null));return}const r=[];if(Array.isArray(d.required))for(const i of d.required)N.$4f(i)&&r.push(i);return{extensionId:n.value,taskType:s,required:r,properties:d.properties?R.$Wn(d.properties):{},when:d.when?M.$oj.deserialize(d.when):void 0}}u.from=w})(E||(E={}));const T=F.$rG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,w)=>{for(const d of u)d.type&&w.push(`onTaskType:${d.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:g}});class k{constructor(){this.d=new m.$be,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,d)=>{T.setHandler((n,o)=>{this.c=void 0;try{for(const s of o.removed){const r=s.value;for(const i of r)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const s of o.added){const r=s.value;for(const i of r){const a=E.from(i,s.description.identifier,s.collector);a&&(this.a[a.taskType]=a)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const d of this.all()){const n={type:"object",additionalProperties:!1};d.required.length>0&&(n.required=d.required.slice(0)),d.properties!==void 0?n.properties=R.$Wn(d.properties):n.properties=Object.create(null),n.properties.type={type:"string",enum:[d.taskType]},w.push(n)}this.c={oneOf:w}}return this.c}}e.$UH=new k}),define(Re[231],Ae([1,0,183,17,23,26,31,230]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$5H=e.JsonSchemaVersion=e.ExecutionEngine=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$YH=e.ShellQuoting=e.$XH=e.$WH=e.$VH=void 0,e.$VH="settings",e.$WH=new M.$Hj("taskRunning",!1,I.localize(0,null)),e.$XH=I.localize2(2,"Tasks");var g;(function(A){A[A.Escape=1]="Escape",A[A.Strong=2]="Strong",A[A.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$YH="$customized",function(A){function j(K){if(!K)return A.Strong;switch(K.toLowerCase()){case"escape":return A.Escape;case"strong":return A.Strong;case"weak":return A.Weak;default:return A.Strong}}A.from=j}(g||(e.ShellQuoting=g={}));var E;(function(A){A.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var T;(function(A){A[A.Always=1]="Always",A[A.Silent=2]="Silent",A[A.Never=3]="Never"})(T||(e.RevealKind=T={})),function(A){function j(K){switch(K.toLowerCase()){case"always":return A.Always;case"silent":return A.Silent;case"never":return A.Never;default:return A.Always}}A.fromString=j}(T||(e.RevealKind=T={}));var k;(function(A){A[A.Never=1]="Never",A[A.OnProblem=2]="OnProblem",A[A.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(A){function j(K){switch(K.toLowerCase()){case"always":return A.Always;case"never":return A.Never;case"onproblem":return A.OnProblem;default:return A.OnProblem}}A.fromString=j}(k||(e.RevealProblemKind=k={}));var u;(function(A){A[A.Shared=1]="Shared",A[A.Dedicated=2]="Dedicated",A[A.New=3]="New"})(u||(e.PanelKind=u={})),function(A){function j(K){switch(K.toLowerCase()){case"shared":return A.Shared;case"dedicated":return A.Dedicated;case"new":return A.New;default:return A.Shared}}A.fromString=j}(u||(e.PanelKind=u={}));var w;(function(A){A.defaults={echo:!0,reveal:T.Always,revealProblems:k.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var d;(function(A){A[A.Shell=1]="Shell",A[A.Process=2]="Process",A[A.CustomExecution=3]="CustomExecution"})(d||(e.RuntimeType=d={})),function(A){function j(ie){switch(ie.toLowerCase()){case"shell":return A.Shell;case"process":return A.Process;case"customExecution":return A.CustomExecution;default:return A.Process}}A.fromString=j;function K(ie){switch(ie){case A.Shell:return"shell";case A.Process:return"process";case A.CustomExecution:return"customExecution";default:return"process"}}A.toString=K}(d||(e.RuntimeType=d={}));var n;(function(A){function j(K){return N.$4f(K)?K:K.value}A.value=j})(n||(e.CommandString=n={}));var o;(function(A){A.Clean={_id:"clean",isDefault:!1},A.Build={_id:"build",isDefault:!1},A.Rebuild={_id:"rebuild",isDefault:!1},A.Test={_id:"test",isDefault:!1};function j(ie){return ie===A.Clean._id||ie===A.Build._id||ie===A.Rebuild._id||ie===A.Test._id}A.is=j;function K(ie){if(ie!==void 0)return N.$4f(ie)?j(ie)?{_id:ie,isDefault:!1}:void 0:ie}A.from=K})(o||(e.TaskGroup=o={}));var s;(function(A){A[A.Global=1]="Global",A[A.Workspace=2]="Workspace",A[A.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var r;(function(A){A.Workspace="workspace",A.Extension="extension",A.InMemory="inMemory",A.WorkspaceFile="workspaceFile",A.User="user";function j(K){switch(K){case A.User:return 2;case A.WorkspaceFile:return 5;default:return 6}}A.toConfigurationTarget=j})(r||(e.TaskSourceKind=r={}));var i;(function(A){A.parallel="parallel",A.sequence="sequence"})(i||(e.DependsOrder=i={}));var a;(function(A){A[A.default=1]="default",A[A.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var h;(function(A){A.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(j,K,ie,ce,ve,Ie){this._label="",this._id=j,K&&(this._label=K),ie&&(this.type=ie),this.runOptions=ce,this.configurationProperties=ve,this._source=Ie}getDefinition(j){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,K=!1){if(j===void 0)return!1;if(N.$4f(j))return j===this._label||j===this.configurationProperties.identifier||K&&j===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$ZH=t;class b extends t{constructor(j,K,ie,ce,ve,Ie,ue,pe){super(j,ie,void 0,ue,pe,K),this.command={},this._source=K,this.hasDefinedMatchers=Ie,ve&&(this.command=ve)}clone(){return new b(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case d.Shell:K="shell";break;case d.Process:K="process";break;case d.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(j){return j instanceof b}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const j=this.d();if(!j)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const ie={type:e.$YH,folder:j,id:K};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$1g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new b(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$1H=b;class c extends t{constructor(j,K,ie,ce,ve,Ie,ue){super(j,ie,ce,Ie,ue,K),this._source=K,this.configures=ve}static is(j){return j instanceof c}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$1g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$VH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const j=this.d();if(!j)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const ie={type:e.$YH,folder:j,id:K};return JSON.stringify(ie)}}e.$2H=c;class $ extends t{constructor(j,K,ie,ce,ve,Ie,ue,pe,re){super(j,ie,ce,pe,re,K),this.defines=ve,this.hasDefinedMatchers=ue,this.command=Ie,this.icon=re.icon,this.hide=re.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof $}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new $(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$3H=$;class v extends t{constructor(j,K,ie,ce,ve,Ie){super(j,ie,ce,ve,Ie,K),this._source=K}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new v(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$4H=v;var p;(function(A){A[A.Process=1]="Process",A[A.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(A){A._default=A.Terminal}(p||(e.ExecutionEngine=p={}));var l;(function(A){A[A.V0_1_0=1]="V0_1_0",A[A.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class D{constructor(j){this.c=new Map;for(let K=0;K<j.length;K++)this.c.set(j[K].uri.toString(),K)}compare(j,K){const ie=j.getWorkspaceFolder(),ce=K.getWorkspaceFolder();if(ie&&ce){let ve=this.c.get(ie.uri.toString());ve=ve===void 0?0:ve+1;let Ie=this.c.get(ce.uri.toString());return Ie=Ie===void 0?0:Ie+1,ve===Ie?j._label.localeCompare(K._label):ve-Ie}else return!ie&&ce?-1:ie&&!ce?1:0}}e.$5H=D;var f;(function(A){A.DependsOnStarted="dependsOnStarted",A.AcquiredInput="acquiredInput",A.Start="start",A.ProcessStarted="processStarted",A.Active="active",A.Inactive="inactive",A.Changed="changed",A.Terminated="terminated",A.ProcessEnded="processEnded",A.End="end"})(f||(e.TaskEventKind=f={}));var S;(function(A){A.SingleRun="singleRun",A.Background="background"})(S||(e.TaskRunType=S={}));var y;(function(A){A[A.System=0]="System",A[A.User=1]="User",A[A.FolderOpen=2]="FolderOpen",A[A.ConfigurationChange=3]="ConfigurationChange",A[A.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(A){function j(pe){return{taskId:pe._id,taskName:pe.configurationProperties.name,runType:pe.configurationProperties.isBackground?"background":"singleRun",group:pe.configurationProperties.group,__task:pe}}function K(pe,re,Se){return{...j(pe),kind:"start",terminalId:re,resolvedVariables:Se}}A.start=K;function ie(pe,re,Se){return{...j(pe),kind:"processStarted",terminalId:re,processId:Se}}A.processStarted=ie;function ce(pe,re,Se){return{...j(pe),kind:"processEnded",terminalId:re,exitCode:Se}}A.processEnded=ce;function ve(pe,re,Se){return{...j(pe),kind:"terminated",exitReason:Se,terminalId:re}}A.terminated=ve;function Ie(pe,re,Se){return{...j(re),kind:pe,terminalId:Se}}A.general=Ie;function ue(){return{kind:"changed"}}A.changed=ue})(C||(e.TaskEvent=C={}));var P;(function(A){function j(ie){const ce=Object.keys(ie).sort();let ve="";for(const Ie of ce){let ue=ie[Ie];ue instanceof Object?ue=j(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),ve+=Ie+","+ue+","}return ve}function K(ie){const ve={_key:j(ie),type:ie.taskType};return Object.assign(ve,ie),ve}A.create=K})(P||(e.KeyedTaskIdentifier=P={}));var V;(function(A){A.AutoDetect="task.autoDetect",A.SaveBeforeRun="task.saveBeforeRun",A.ShowDecorations="task.showDecorations",A.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",A.SlowProviderWarning="task.slowProviderWarning",A.QuickOpenHistory="task.quickOpen.history",A.QuickOpenDetail="task.quickOpen.detail",A.QuickOpenSkip="task.quickOpen.skip",A.QuickOpenShowAll="task.quickOpen.showAll",A.AllowAutomaticTasks="task.allowAutomaticTasks",A.Reconnection="task.reconnection",A.VerboseLogging="task.verboseLogging"})(V||(e.TaskSettingId=V={}));var W;(function(A){A.Tasks="tasks",A.SuppressTaskName="tasks.suppressTaskName",A.Windows="tasks.windows",A.Osx="tasks.osx",A.Linux="tasks.linux",A.ShowOutput="tasks.showOutput",A.IsShellCommand="tasks.isShellCommand",A.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var q;(function(A){function j(K,ie){const ce=m.$UH.get(K.type);if(ce===void 0){const pe=F.$Wn(K);return delete pe._key,P.create(pe)}const ve=Object.create(null);ve.type=ce.taskType;const Ie=new Set;ce.required.forEach(pe=>Ie.add(pe));const ue=ce.properties;for(const pe of Object.keys(ue)){const re=K[pe];if(re!=null)ve[pe]=re;else if(Ie.has(pe)){const Se=ue[pe];if(Se.default!==void 0)ve[pe]=F.$Wn(Se.default);else switch(Se.type){case"boolean":ve[pe]=!1;break;case"number":case"integer":ve[pe]=0;break;case"string":ve[pe]="";break;default:ie.error(I.localize(1,null,JSON.stringify(K,void 0,0),pe));return}}}return P.create(ve)}A.createTaskIdentifier=j})(q||(e.TaskDefinition=q={}))}),define(Re[232],Ae([1,0,14]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=e.$G$b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,m)=>{this.b=M,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,I.$1)(M))}then(M,m){return this.j().then(M,m)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$G$b=N;class R extends N{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$H$b=R}),define(Re[34],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$jw=void 0,e.$kw=R,e.$lw=F;class I{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++I.count}}e.$jw=I;const N=[];function R(m){const g=new I(m);return N[g.nid]=g,g}function F(m){return N[m].sid}class M{constructor(g){this.value=g}}e.$mw=M}),define(Re[4],Ae([1,0,34]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$OM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var R;(function(n){n[n.UnknownInput=0]="UnknownInput",n[n.TextInput=1]="TextInput",n[n.TextDiffInput=2]="TextDiffInput",n[n.TextMergeInput=3]="TextMergeInput",n[n.NotebookInput=4]="NotebookInput",n[n.NotebookDiffInput=5]="NotebookDiffInput",n[n.CustomEditorInput=6]="CustomEditorInput",n[n.WebviewEditorInput=7]="WebviewEditorInput",n[n.TerminalEditorInput=8]="TerminalEditorInput",n[n.InteractiveEditorInput=9]="InteractiveEditorInput",n[n.ChatEditorInput=10]="ChatEditorInput",n[n.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(R||(e.TabInputKind=R={}));var F;(function(n){n[n.TAB_OPEN=0]="TAB_OPEN",n[n.TAB_CLOSE=1]="TAB_CLOSE",n[n.TAB_UPDATE=2]="TAB_UPDATE",n[n.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var M;(function(n){n[n.Editable=0]="Editable",n[n.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var m;(function(n){n[n.Int8Array=1]="Int8Array",n[n.Uint8Array=2]="Uint8Array",n[n.Uint8ClampedArray=3]="Uint8ClampedArray",n[n.Int16Array=4]="Int16Array",n[n.Uint16Array=5]="Uint16Array",n[n.Int32Array=6]="Int32Array",n[n.Uint32Array=7]="Uint32Array",n[n.Float32Array=8]="Float32Array",n[n.Float64Array=9]="Float64Array",n[n.BigInt64Array=10]="BigInt64Array",n[n.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var g;(function(n){n[n.Text=1]="Text",n[n.Error=2]="Error",n[n.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var E;(function(n){n[n.Default=0]="Default",n[n.InCenter=1]="InCenter",n[n.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",n[n.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var T;(function(n){n[n.None=0]="None",n[n.Process=1]="Process",n[n.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class k{static{this.a=0}static mixin(o){return o._id=k.a++,o}}e.$OM=k;var u;(function(n){n.label="a",n.kind="b",n.detail="c",n.documentation="d",n.sortText="e",n.filterText="f",n.preselect="g",n.insertText="h",n.insertTextRules="i",n.range="j",n.commitCharacters="k",n.additionalTextEdits="l",n.kindModifier="m",n.commandIdent="n",n.commandId="o",n.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var w;(function(n){n.defaultRanges="a",n.completions="b",n.isIncomplete="c",n.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var d;(function(n){n[n.Workspace=0]="Workspace",n[n.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$PM={MainThreadAuthentication:(0,I.$kw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$kw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$kw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$kw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$kw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$kw)("MainThreadClipboard"),MainThreadCommands:(0,I.$kw)("MainThreadCommands"),MainThreadComments:(0,I.$kw)("MainThreadComments"),MainThreadConfiguration:(0,I.$kw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$kw)("MainThreadConsole"),MainThreadDebugService:(0,I.$kw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$kw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$kw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$kw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$kw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$kw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$kw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$kw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$kw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$kw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$kw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$kw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$kw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$kw)("MainThreadLanguages"),MainThreadLogger:(0,I.$kw)("MainThreadLogger"),MainThreadMessageService:(0,I.$kw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$kw)("MainThreadOutputService"),MainThreadProgress:(0,I.$kw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$kw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$kw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$kw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$kw)("MainThreadSecretState"),MainThreadStorage:(0,I.$kw)("MainThreadStorage"),MainThreadSpeech:(0,I.$kw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$kw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$kw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,I.$kw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,I.$kw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$kw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$kw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$kw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$kw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$kw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$kw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$kw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$kw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$kw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$kw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$kw)("MainThreadSCM"),MainThreadSearch:(0,I.$kw)("MainThreadSearch"),MainThreadShare:(0,I.$kw)("MainThreadShare"),MainThreadTask:(0,I.$kw)("MainThreadTask"),MainThreadWindow:(0,I.$kw)("MainThreadWindow"),MainThreadLabelService:(0,I.$kw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$kw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$kw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$kw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$kw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$kw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$kw)("MainThreadInteractive"),MainThreadInlineChat:(0,I.$kw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$kw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$kw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$kw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$kw)("MainThreadTimeline"),MainThreadTesting:(0,I.$kw)("MainThreadTesting"),MainThreadLocalization:(0,I.$kw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$kw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$kw)("MainThreadAiEmbeddingVector")},e.$QM={ExtHostCommands:(0,I.$kw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$kw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$kw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$kw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$kw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$kw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$kw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$kw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$kw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$kw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$kw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$kw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$kw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$kw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$kw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$kw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$kw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$kw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$kw)("ExtHostStatusBar"),ExtHostShare:(0,I.$kw)("ExtHostShare"),ExtHostExtensionService:(0,I.$kw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$kw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$kw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,I.$kw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,I.$kw)("ExtHostSCM"),ExtHostSearch:(0,I.$kw)("ExtHostSearch"),ExtHostTask:(0,I.$kw)("ExtHostTask"),ExtHostWorkspace:(0,I.$kw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$kw)("ExtHostWindow"),ExtHostWebviews:(0,I.$kw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$kw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$kw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$kw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$kw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$kw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$kw)("ExtHostProgress"),ExtHostComments:(0,I.$kw)("ExtHostComments"),ExtHostSecretState:(0,I.$kw)("ExtHostSecretState"),ExtHostStorage:(0,I.$kw)("ExtHostStorage"),ExtHostUrls:(0,I.$kw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$kw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$kw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$kw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$kw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$kw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$kw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$kw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$kw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$kw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$kw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$kw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$kw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,I.$kw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$kw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$kw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$kw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$kw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$kw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$kw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$kw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$kw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$kw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$kw)("ExtHostTimeline"),ExtHostTesting:(0,I.$kw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$kw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$kw)("ExtHostLocalization")}}),define(Re[78],Ae([1,0,3,13,4,16]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4jc=e.$3jc=e.$2jc=void 0,e.$2jc=(0,I.$qi)("IExtHostApiDeprecationService");let M=class{constructor(g,E){this.c=E,this.a=new Set,this.b=g.getProxy(R.$PM.MainThreadTelemetry)}report(g,E,T){const k=this.d(g,E);this.a.has(k)||(this.a.add(k),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:g}))}d(g,E){return`${g}-${E.identifier.value}`}};e.$3jc=M,e.$3jc=M=Je([Ve(0,F.$aP),Ve(1,N.$Wj)],M),e.$4jc=Object.freeze(new class{report(m,g,E){}})}),define(Re[233],Ae([1,0,4]),function(ge,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class N{constructor(F){const M=F.getProxy(I.$PM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(m){return M.$writeText(m)}})}}e.$ekc=N}),define(Re[234],Ae([1,0,26,4,27,16]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;let M=class{constructor(T,k){this.a=T.getProxy(N.$PM.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(T,k){const u=this,w=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){u.e(T,k,w,arguments)}})}e(T,k,u,w){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:g(w,this.b)}),this.c&&this.f(T,u,w)}};e.$$lc=M,e.$$lc=M=Je([Ve(0,F.$aP),Ve(1,R.$qP)],M);const m=1e5;function g(E,T){const k=[];if(E.length)for(let u=0;u<E.length;u++){let w=E[u];if(typeof w>"u")w="undefined";else if(w instanceof Error){const d=w;d.stack?w=d.stack:w=d.toString()}k.push(w)}if(T){const u=new Error().stack;u&&k.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,I.$2n)(k);return u.length>m?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Re[235],Ae([1,0,2,4,25]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=void 0;class F{constructor(m){this.a=m.getProxy(N.$PM.MainThreadDialogs)}showOpenDialog(m,g){return g?.allowUIResources&&(0,R.$yG)(m,"showLocal"),this.a.$showOpenDialog(g).then(E=>E?E.map(T=>I.URI.revive(T)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(g=>g?I.URI.revive(g):void 0)}}e.$blc=F}),define(Re[236],Ae([1,0,6,4]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=void 0;class R{constructor(M){this.b=0,this.a=M.getProxy(N.$PM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,M),(0,I.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$vlc=R}),define(Re[79],Ae([1,0,21,15,2,3,13,4,27,16]),function(ge,e,I,N,R,F,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=e.$Vkc=void 0;let T=class{constructor(u,w,d){this.f=d,this.d=new Map,this.a=w.getProxy(m.$PM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===I.$g}getMessage(u,w){const{message:d,args:n,comment:o}=w;if(this.c)return(0,N.$5e)(d,n??{});let s=d;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const r=this.d.get(u)?.contents[s];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,N.$5e)(r??d,n??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let w;const d=await this.g(u);if(!d){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const n=await this.a.$fetchBundleContents(d),o=JSON.parse(n);w=u.isBuiltin?o.contents?.bundle:o}catch(n){this.f.error(`Failed to load translations for ${u.identifier.value} from ${d}: ${n.message}`);return}w&&this.d.set(u.identifier.value,{contents:w,uri:d})}async g(u){if(u.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return R.URI.revive(w)}return u.l10n?R.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Vkc=T,e.$Vkc=T=Je([Ve(0,g.$qP),Ve(1,E.$aP),Ve(2,M.$Wj)],T),e.$Wkc=(0,F.$qi)("IExtHostLocalizationService")}),define(Re[237],Ae([1,0,13,4,27,16,2,53]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;let g=class extends I.$8j{constructor(k,u){super(u.logLevel,u.logsLocation,u.loggers.map(w=>(0,m.$Zh)(w))),this.r=k.getProxy(N.$PM.MainThreadLogger)}$setLogLevel(k,u){u?this.setLogLevel(M.URI.revive(u),k):this.setLogLevel(k)}setVisibility(k,u){super.setVisibility(k,u),this.r.$setVisibility(k,u)}s(k,u,w){return new E(this.r,k,u,w)}};e.$0lc=g,e.$0lc=g=Je([Ve(0,F.$aP),Ve(1,R.$qP)],g);class E extends I.$3j{constructor(k,u,w,d){super(d?.logLevel==="always"),this.r=k,this.s=u,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(u,d).then(()=>{this.u(this.n),this.m=!0})}g(k,u){const w=[[k,u]];this.m?this.u(w):this.n.push(...w)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Re[80],Ae([1,0,4,3,6,16,22]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ykc=e.$Xkc=void 0,e.$Xkc=(0,N.$qi)("IExtHostManagedSockets");let m=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(I.$PM.MainThreadManagedSockets)}setFactory(k,u){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(k,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const u=++this.b,w=await this.c.makeConnection(),d=new R.$Tc;return this.d.set(u,new E(u,w,d)),d.add((0,R.$Sc)(()=>this.d.delete(u))),d.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),d.dispose()})),d.add(w.onDidClose(n=>{this.a.$onDidManagedSocketClose(u,n?.stack??n?.message),d.dispose()})),d.add(w.onDidReceiveMessage(n=>this.a.$onDidManagedSocketHaveData(u,M.$Ce.wrap(n)))),u}$remoteSocketWrite(k,u){this.d.get(k)?.actual.send(u.buffer)}$remoteSocketEnd(k){const u=this.d.get(k);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$Ykc=m,e.$Ykc=m=Je([Ve(0,F.$aP)],m);class g{constructor(k,u){this.socketFactoryId=k,this.makeConnection=u}}class E extends R.$Uc{constructor(k,u,w){super(),this.socketId=k,this.actual=u,this.B(w)}}}),define(Re[238],Ae([1,0,4,13,25]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=void 0;function F(m){return m&&m.title}let M=class{constructor(g,E){this.b=E,this.a=g.getProxy(I.$PM.MainThreadMessageService)}showMessage(g,E,T,k,u){const w={source:{identifier:g.identifier,label:g.displayName||g.name}};let d;typeof k=="string"||F(k)?d=[k,...u]:(w.modal=k?.modal,w.useCustom=k?.useCustom,w.detail=k?.detail,d=u),w.useCustom&&(0,R.$yG)(g,"resolvers");const n=[];let o=!1;for(let s=0;s<d.length;s++){const r=d[s];if(typeof r=="string")n.push({title:r,handle:s,isCloseAffordance:!1});else if(typeof r=="object"){const{title:i,isCloseAffordance:a}=r;n.push({title:i,isCloseAffordance:!!a,handle:s}),a&&(o?this.b.warn(`[${g.identifier}] Only one message item can have 'isCloseAffordance':`,r):o=!0)}else this.b.warn(`[${g.identifier}] Invalid message item:`,r)}return this.a.$showMessage(E,T,w,n).then(s=>{if(typeof s=="number")return d[s]})}};e.$xlc=M,e.$xlc=M=Je([Ve(1,N.$Wj)],M)}),define(Re[239],Ae([1,0,6,17,2,25,4]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=void 0;class m{constructor(E){this.b=new Map,this.a=E.getProxy(M.$PM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,T,k){if((0,F.$yG)(E,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,k),this.a.$registerProfileContentHandler(T,k.name,k.description,E.identifier.value),(0,I.$Sc)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(E,T,k,u){const w=this.b.get(E);if(!w)throw new Error(`Unknown handler with id: ${E}`);return w.saveProfile(T,k,u)}async $readProfile(E,T,k){const u=this.b.get(E);if(!u)throw new Error(`Unknown handler with id: ${E}`);return u.readProfile((0,N.$4f)(T)?T:R.URI.revive(T),k)}}e.$Glc=m}),define(Re[81],Ae([1,0,4,5,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tkc=e.$Skc=void 0;class F{constructor(m){this.b=new N.$be,this.onDidChangePassword=this.b.event,this.a=m.getProxy(I.$PM.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,g){return this.a.$getPassword(m,g)}store(m,g,E){return this.a.$setPassword(m,g,E)}delete(m,g){return this.a.$deletePassword(m,g)}}e.$Skc=F,e.$Tkc=(0,R.$qi)("IExtHostSecretState")}),define(Re[240],Ae([1,0,24,6,4]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nlc=void 0;class F{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(R.$PM.MainThreadSpeech)}async $createSpeechToTextSession(m,g,E){const T=this.c.get(m);if(!T)return;const k=new N.$Tc,u=new I.$me;this.d.set(g,u);const w=k.add(T.provideSpeechToTextSession(u.token,E?{language:E}:void 0));k.add(w.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,d)})),k.add(u.token.onCancellationRequested(()=>k.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}async $createKeywordRecognitionSession(m,g){const E=this.c.get(m);if(!E)return;const T=new N.$Tc,k=new I.$me;this.d.set(g,k);const u=T.add(E.provideKeywordRecognitionSession(k.token));T.add(u.onDidChange(w=>{k.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(g,w)})),T.add(k.token.onCancellationRequested(()=>T.dispose()))}async $cancelKeywordRecognitionSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,g,E){const T=F.a++;return this.c.set(T,E),this.b.$registerProvider(T,g,{extension:m,displayName:m.value}),(0,N.$Sc)(()=>{this.b.$unregisterProvider(T),this.c.delete(T)})}}e.$Nlc=F}),define(Re[82],Ae([1,0,4,5,3]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=e.$Ikc=void 0;class F{constructor(m,g){this.c=g,this.b=new N.$be,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(I.$PM.MainThreadStorage)}registerExtensionStorageKeysToSync(m,g){this.a.$registerExtensionStorageKeysToSync(m,g)}async initializeExtensionStorage(m,g,E){const T=await this.a.$initializeExtensionStorage(m,g);let k;return T&&(k=this.d(m,g,T)),k||E}setValue(m,g,E){return this.a.$setValue(m,g,E)}$acceptValue(m,g,E){const T=this.d(m,g,E);T&&this.b.fire({shared:m,key:g,value:T})}d(m,g,E){try{return JSON.parse(E)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${m}): ${T}`)}}}e.$Ikc=F,e.$Jkc=(0,R.$qi)("IExtHostStorage")}),define(Re[241],Ae([1,0,6,12,2,4]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4lc=void 0;class M{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(F.$PM.MainThreadUriOpeners)}registerExternalUriOpener(g,E,T,k){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const u=k.schemes.find(w=>!M.a.has(w));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(E,T),this.b.$registerUriOpener(E,k.schemes,g,k.label),(0,I.$Sc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(g,E,T){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener with id: ${g}`);const u=R.URI.revive(E);return k.canOpenExternalUri(u,T)}async $openUri(g,E,T){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener id: '${g}'`);return k.openExternalUri(R.URI.revive(E.resolvedUri),{sourceUri:R.URI.revive(E.sourceUri)},T)}}e.$4lc=M}),define(Re[242],Ae([1,0,4,2,6,14,20]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=void 0;class m{static{this.a=0}constructor(E){this.c=new M.$Mm,this.d=new Map,this.b=E.getProxy(I.$PM.MainThreadUrls)}registerUriHandler(E,T){const k=E.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const u=m.a++;return this.c.add(k),this.d.set(u,T),this.b.$registerUriHandler(u,k,E.displayName||E.name),(0,R.$Sc)(()=>{this.c.delete(k),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(E,T){const k=this.d.get(E);if(!k)return Promise.resolve(void 0);try{k.handleUri(N.URI.revive(T))}catch(u){(0,F.$1)(u)}return Promise.resolve(void 0)}async createAppUri(E){return N.URI.revive(await this.b.$createAppUri(E))}}e.$5lc=m}),define(Re[63],Ae([1,0,5,6,12,26,2,189,211,76,4]),function(ge,e,I,N,R,F,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=e.$tkc=void 0,e.$ukc=u,e.$wkc=n,e.$xkc=o;class k{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,h,t,b,c,$,v){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$be,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$be,this._onDidDispose=this.#h.event,this.#e=a,this.#t=h,this.#o=t,this.#n=b,this.#s=c,this.#r=$,this.#l=u($),this.#d=w($),this.#i=v}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,E.$Gxb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===R.Schemas.https||a.scheme===R.Schemas.http){let h=a.toString();return h.endsWith("/")||(h+="/"),h+" "+E.$Fxb}return E.$Fxb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),F.$1n(this.#o,a)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const h=(0,g.$Xnb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const h=this.#r.extensionLocation?.scheme===R.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(b,c,$,v,p,l)=>{const D=M.URI.from({scheme:v||"file",path:decodeURIComponent(p)}),f=(0,E.$Gxb)(D,{isRemote:h,authority:t}).toString();return`${c}${f}${l}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(b,c,$,v,p,l)=>{const D=M.URI.from({scheme:v||"file",path:decodeURIComponent(p)}),f=(0,E.$Gxb)(D,{isRemote:h,authority:t}).toString();return`${c}${f}${l}`})}}e.$tkc=k;function u(i){try{const a=(0,m.$Cp)((0,m.$Bp)(i.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}function w(i){try{const a=(0,m.$Cp)((0,m.$Bp)(i.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class d extends N.$Uc{constructor(a,h,t,b,c){super(),this.c=h,this.f=t,this.g=b,this.h=c,this.b=new Map,this.a=a.getProxy(T.$PM.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,h,t){const b=this.j(a);if(b){const{message:c}=(0,g.$Ynb)(h,t.value);b._onMessageEmitter.fire(c)}}$onMissingCsp(a,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,h,t){const b=new k(a,this.a,s(h),this.c,this.f,t,this.h);this.b.set(a,b);const c=b._onDidDispose(()=>{c.dispose(),this.deleteWebview(a)});return b}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$vkc=d;function n(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,a,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||r(i,a)}}function s(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(a=>M.URI.from(a))}}function r(i,a){return[...(a?.getWorkspaceFolders()||[]).map(h=>h.uri),i.extensionLocation]}}),define(Re[109],Ae([1,0,5,4,2,12,15,3,16,25]),function(ge,e,I,N,R,F,M,m,g,E){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=e.$7lc=void 0;let k=class{static{T=this}static{this.a={focused:!0,active:!0}}getState(w){const d=this.d;return{get focused(){return d.focused},get active(){return(0,E.$yG)(w,"windowActivity"),d.active}}}constructor(w){this.c=new I.$be,this.onDidChangeWindowState=this.c.event,this.d=T.a,this.b=w.getProxy(N.$PM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:d,isActive:n})=>{this.onDidChangeWindowProperty("focused",d),this.onDidChangeWindowProperty("active",n)})}$onDidChangeWindowFocus(w){this.onDidChangeWindowProperty("focused",w)}$onDidChangeWindowActive(w){this.onDidChangeWindowProperty("active",w)}onDidChangeWindowProperty(w,d){d!==this.d[w]&&(this.d={...this.d,[w]:d},this.c.fire(this.d))}openUri(w,d){let n;if(typeof w=="string"){n=w;try{w=R.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,M.$3e)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,n,d)}async asExternalUri(w,d){if((0,M.$3e)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const n=await this.b.$asExternalUri(w,d);return R.URI.from(n)}};e.$7lc=k,e.$7lc=k=T=Je([Ve(0,g.$aP)],k),e.$8lc=(0,m.$qi)("IExtHostWindow")}),define(Re[243],Ae([1,0,234,27,16]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=void 0;let F=class extends I.$$lc{constructor(m,g){super(m,g)}f(m,g,E){g.apply(console,E)}};e.$goc=F,e.$goc=F=Je([Ve(0,R.$aP),Ve(1,N.$qP)],F)}),define(Re[244],Ae([1,0,11,22,24,14,5,6,144,232,34]),function(ge,e,I,N,R,F,M,m,g,E,T){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=e.ResponsiveState=e.RequestInitiator=void 0,e.$I$b=o,e.$J$b=s;function u(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const w="$$ref$$",d={[w]:-1};class n{constructor(C,P){this.jsonString=C,this.referencedBuffers=P}}function o(y,C=null,P=!1){const V=[];return{jsonString:(P?u:JSON.stringify)(y,(q,A)=>{if(typeof A>"u")return d;if(typeof A=="object"){if(A instanceof N.$Ce){const j=V.push(A)-1;return{[w]:j}}if(C)return C(q,A)}return A}),referencedBuffers:V}}function s(y,C,P){return JSON.parse(y,(V,W)=>{if(W){const q=W[w];if(typeof q=="number")return C[q];if(P&&W.$mid===1)return P.transformIncoming(W)}return W})}function r(y,C){return JSON.stringify(y,C)}function i(y){return y?(C,P)=>P&&P.$mid===1?y.transformOutgoing(P):P:null}var a;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var h;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},b=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class $ extends m.$Uc{static{k=b}static{this.a=3*1e3}constructor(C,P=null,V=null){super(),this[k]=!0,this.b=this.B(new M.$be),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=P,this.g=V,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,q=T.$jw.count;W<q;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$Ch(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const P=this.w[C];delete this.w[C],P.resolveErr(F.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+$.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+$.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,g.$vn)(C,this.g):C}getProxy(C){const{nid:P,sid:V}=C;return this.s[P]||(this.s[P]=this.J(P,V)),this.s[P]}J(C,P){const V={get:(W,q)=>(typeof q=="string"&&!W[q]&&q.charCodeAt(0)===36&&(W[q]=(...A)=>this.U(C,q,A)),q===c?P:W[q])};return new Proxy(Object.create(null),V)}set(C,P){return this.m[C.nid]=P,P}assertRegistered(C){for(let P=0,V=C.length;P<V;P++){const W=C[P];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(C){if(this.j)return;const P=C.byteLength,V=p.read(C,0),W=V.readUInt8(),q=V.readUInt32();switch(W){case 1:case 2:{let{rpcId:A,method:j,args:K}=D.deserializeRequestJSONArgs(V);this.g&&(K=(0,g.$vn)(K,this.g)),this.M(P,q,A,j,K,W===2);break}case 3:case 4:{let{rpcId:A,method:j,args:K}=D.deserializeRequestMixedArgs(V);this.g&&(K=(0,g.$vn)(K,this.g)),this.M(P,q,A,j,K,W===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.G(q);break}case 6:{this.N(P,q);break}case 7:{this.O(P,q,void 0);break}case 9:{let A=D.deserializeReplyOKJSON(V);this.g&&(A=(0,g.$vn)(A,this.g)),this.O(P,q,A);break}case 10:{const A=D.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(P,q,A);break}case 8:{const A=D.deserializeReplyOKVSBuffer(V);this.O(P,q,A);break}case 11:{let A=D.deserializeReplyErrError(V);this.g&&(A=(0,g.$vn)(A,this.g)),this.P(P,q,A);break}case 12:{this.P(P,q,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,P,V,W,q,A){this.f?.logIncoming(C,P,1,`receiveRequest ${(0,T.$lw)(V)}.${W}(`,q);const j=String(P);let K,ie;if(A){const ve=new R.$me;q.push(ve.token),K=this.Q(V,W,q),ie=()=>ve.cancel()}else K=this.Q(V,W,q),ie=t;this.u[j]=ie;const ce=D.serializeAcknowledged(P);this.f?.logOutgoing(ce.byteLength,P,1,"ack"),this.c.send(ce),K.then(ve=>{delete this.u[j];const Ie=D.serializeReplyOK(P,ve,this.h);this.f?.logOutgoing(Ie.byteLength,P,1,"reply:",ve),this.c.send(Ie)},ve=>{delete this.u[j];const Ie=D.serializeReplyErr(P,ve);this.f?.logOutgoing(Ie.byteLength,P,1,"replyErr:",ve),this.c.send(Ie)})}N(C,P){this.f?.logIncoming(C,P,1,"receiveCancel");const V=String(P);this.u[V]?.()}O(C,P,V){this.f?.logIncoming(C,P,0,"receiveReply:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W],q.resolveOk(V)}P(C,P,V){this.f?.logIncoming(C,P,0,"receiveReplyErr:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W];let A;V&&(V.$isError?(A=new Error,A.name=V.name,A.message=V.message,A.stack=V.stack):A=V),q.resolveErr(A)}Q(C,P,V){try{return Promise.resolve(this.S(C,P,V))}catch(W){return Promise.reject(W)}}S(C,P,V){const W=this.m[C];if(!W)throw new Error("Unknown actor "+(0,T.$lw)(C));const q=W[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,T.$lw)(C));return q.apply(W,V)}U(C,P,V){if(this.j)return new E.$H$b;let W=null;if(V.length>0&&R.CancellationToken.isCancellationToken(V[V.length-1])&&(W=V.pop()),W&&W.isCancellationRequested)return Promise.reject(F.$6());const q=D.serializeRequestArguments(V,this.h),A=++this.t,j=String(A),K=new E.$G$b,ie=new m.$Tc;W&&ie.add(W.onCancellationRequested(()=>{const ve=D.serializeCancel(A);this.f?.logOutgoing(ve.byteLength,A,0,"cancel"),this.c.send(D.serializeCancel(A))})),this.w[j]=new v(K,ie),this.F(A);const ce=D.serializeRequest(A,C,P,q,!!W);return this.f?.logOutgoing(ce.byteLength,A,0,`request: ${(0,T.$lw)(C)}.${P}(`,V),this.c.send(ce),K}}e.$K$b=$;class v{constructor(C,P){this.a=C,this.b=P}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class p{static alloc(C,P,V){const W=new p(N.$Ce.alloc(V+1+4),0);return W.writeUInt8(C),W.writeUInt32(P),W}static read(C,P){return new p(C,P)}get buffer(){return this.a}constructor(C,P){this.a=C,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+C).toString();return this.b+=C,V}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+C).toString();return this.b+=C,V}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+C);return this.b+=C,P}static sizeMixedArray(C){let P=0;P+=1;for(let V=0,W=C.length;V<W;V++){const q=C[V];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let A=0;A<q.buffers.length;++A)P+=this.sizeVSBuffer(q.buffers[A]);break;case 4:break}}return P}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let P=0,V=C.length;P<V;P++){const W=C[P];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let q=0;q<W.buffers.length;++q)this.writeBuffer(W.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const P=new Array(C);for(let V=0;V<C;V++)switch(this.readUInt8()){case 1:P[V]=this.readLongString();break;case 2:P[V]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),A=this.readLongString(),j=[];for(let K=0;K<q;++K)j.push(this.readVSBuffer());P[V]=new T.$mw(s(A,j,null));break}case 4:P[V]=void 0;break}return P}}var l;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(l||(l={}));class D{static a(C){for(let P=0,V=C.length;P<V;P++)if(C[P]instanceof N.$Ce||C[P]instanceof T.$mw||typeof C[P]>"u")return!0;return!1}static serializeRequestArguments(C,P){if(this.a(C)){const V=[];for(let W=0,q=C.length;W<q;W++){const A=C[W];if(A instanceof N.$Ce)V[W]={type:2,value:A};else if(typeof A>"u")V[W]={type:4};else if(A instanceof T.$mw){const{jsonString:j,referencedBuffers:K}=o(A.value,P);V[W]={type:3,value:N.$Ce.fromString(j),buffers:K}}else V[W]={type:1,value:N.$Ce.fromString(r(A,P))}}return{type:1,args:V}}return{type:0,args:r(C,P)}}static serializeRequest(C,P,V,W,q){switch(W.type){case 0:return this.b(C,P,V,W.args,q);case 1:return this.c(C,P,V,W.args,q)}}static b(C,P,V,W,q){const A=N.$Ce.fromString(V),j=N.$Ce.fromString(W);let K=0;K+=p.sizeUInt8(),K+=p.sizeShortString(A),K+=p.sizeLongString(j);const ie=p.alloc(q?2:1,C,K);return ie.writeUInt8(P),ie.writeShortString(A),ie.writeLongString(j),ie.buffer}static deserializeRequestJSONArgs(C){const P=C.readUInt8(),V=C.readShortString(),W=C.readLongString();return{rpcId:P,method:V,args:JSON.parse(W)}}static c(C,P,V,W,q){const A=N.$Ce.fromString(V);let j=0;j+=p.sizeUInt8(),j+=p.sizeShortString(A),j+=p.sizeMixedArray(W);const K=p.alloc(q?4:3,C,j);return K.writeUInt8(P),K.writeShortString(A),K.writeMixedArray(W),K.buffer}static deserializeRequestMixedArgs(C){const P=C.readUInt8(),V=C.readShortString(),W=C.readMixedArray(),q=new Array(W.length);for(let A=0,j=W.length;A<j;A++){const K=W[A];typeof K=="string"?q[A]=JSON.parse(K):q[A]=K}return{rpcId:P,method:V,args:q}}static serializeAcknowledged(C){return p.alloc(5,C,0).buffer}static serializeCancel(C){return p.alloc(6,C,0).buffer}static serializeReplyOK(C,P,V){if(typeof P>"u")return this.d(C);if(P instanceof N.$Ce)return this.e(C,P);if(P instanceof T.$mw){const{jsonString:W,referencedBuffers:q}=o(P.value,V,!0);return this.g(C,W,q)}else return this.f(C,u(P,V))}static d(C){return p.alloc(7,C,0).buffer}static e(C,P){let V=0;V+=p.sizeVSBuffer(P);const W=p.alloc(8,C,V);return W.writeVSBuffer(P),W.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,P){const V=N.$Ce.fromString(P);let W=0;W+=p.sizeLongString(V);const q=p.alloc(9,C,W);return q.writeLongString(V),q.buffer}static g(C,P,V){const W=N.$Ce.fromString(P);let q=0;q+=p.sizeUInt32,q+=p.sizeLongString(W);for(const j of V)q+=p.sizeVSBuffer(j);const A=p.alloc(10,C,q);A.writeUInt32(V.length),A.writeLongString(W);for(const j of V)A.writeBuffer(j);return A.buffer}static deserializeReplyOKJSON(C){const P=C.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(C,P){const V=C.readUInt32(),W=C.readLongString(),q=[];for(let A=0;A<V;++A)q.push(C.readVSBuffer());return new T.$mw(s(W,q,P))}static serializeReplyErr(C,P){const V=P?u(F.$3(P),null):void 0;if(typeof V!="string")return this.h(C);const W=N.$Ce.fromString(V);let q=0;q+=p.sizeLongString(W);const A=p.alloc(11,C,q);return A.writeLongString(W),A.buffer}static deserializeReplyErrError(C){const P=C.readLongString();return JSON.parse(P)}static h(C){return p.alloc(12,C,0).buffer}}var f;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var S;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(S||(S={}))}),define(Re[245],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=void 0;const I=function(F){const M=m=>{globalThis.removeEventListener("message",M);const g=m.data;Object.defineProperties(globalThis,{postMessage:{value(E,T){g.postMessage(E,T)}},onmessage:{get(){return g.onmessage},set(E){g.onmessage=E}}}),g.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",M)}.toString();class N extends EventTarget{constructor(F,M,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${I})('${M}'))`,E=new Blob([g],{type:"application/javascript"}),T=URL.createObjectURL(E),k=new MessageChannel,u=T,w={type:"_newWorker",id:u,port:k.port2,url:T,options:m};F(w,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{F({type:"_terminateWorker",id:u}),URL.revokeObjectURL(T),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(d){k.port1.onmessage=d}},onmessageerror:{get(){return k.port1.onmessageerror},set(d){k.port1.onmessageerror=d}}}),k.port1.addEventListener("messageerror",d=>{const n=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(n)}),k.port1.addEventListener("message",d=>{const n=new MessageEvent("message",{data:d.data});this.dispatchEvent(n)}),k.port1.start()}}e.$ioc=N}),define(Re[246],Ae([1,0,22,28,12,55,3]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uK=e.$rK=void 0,e.$sK=T,e.$tK=k,e.$rK=(0,M.$qi)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],g=new RegExp(`^[${m.join("")}]+`),E=7;function T(w){if(w.scheme!==R.Schemas.vscodeNotebookCell)return;const d=w.fragment.indexOf("s");if(d<0)return;const n=parseInt(w.fragment.substring(0,d).replace(g,""),E),o=(0,I.$Ve)(w.fragment.substring(d+1)).toString();if(!isNaN(n))return{handle:n,notebook:w.with({scheme:o,fragment:null})}}function k(w,d){const n=d.toString(E),s=`${n.length<m.length?m[n.length-1]:"z"}${n}s${(0,I.$We)(I.$Ce.fromString(w.scheme),!0,!0)}`;return w.with({scheme:R.Schemas.vscodeNotebookCell,fragment:s})}class u{constructor(){this.a=new N.$Bc}getNotebook(d){if(d.scheme===R.Schemas.vscodeNotebookCell){const n=T(d);if(n){const o=this.a.get(n.notebook);if(o)return o}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$uK=u,(0,F.$os)(e.$rK,u,1)}),define(Re[83],Ae([1,0,22,36,46,69,12,19,21,31,246]),function(ge,e,I,N,R,F,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=e.$LK=e.CellStatusbarAlignment=e.$KK=e.NotebookEditorPriority=e.$HK=e.$GK=e.$EK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$DK=e.$CK=e.$BK=e.$AK=e.CellKind=e.$zK=e.$yK=e.$xK=void 0,e.$FK=b,e.$IK=$,e.$JK=v,e.$MK=D,e.$NK=S,e.$xK="workbench.editor.notebook",e.$yK="workbench.editor.notebookTextDiffEditor",e.$zK="workbench.editor.interactive";var k;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(k||(e.CellKind=k={})),e.$AK=["application/json","application/javascript","text/html","image/svg+xml",F.$Hs.latex,F.$Hs.markdown,"image/png","image/jpeg",F.$Hs.text],e.$BK=[F.$Hs.latex,F.$Hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$Hs.text],e.$CK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$DK="_notAvailable";var u;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var w;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var d;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var n;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(n||(e.NotebookRendererMatch=n={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var r;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(r||(e.SelectionStateType=r={}));var i;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var a;(function(K){K.scheme=M.Schemas.vscodeNotebookCell;function ie(re,Se){return(0,T.$tK)(re,Se)}K.generate=ie;function ce(re){return(0,T.$sK)(re)}K.parse=ce;function ve(re,Se){return re.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${Se??""},${re.scheme!==M.Schemas.file?re.scheme:""}`})}K.generateCellOutputUri=ve;function Ie(re){if(re.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const Se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!Se)return;const Le=Se[1]&&Se[1]!==""?Se[1]:void 0,ne=Se[2];return{outputId:Le,notebook:re.with({scheme:ne||M.Schemas.file,fragment:null})}}K.parseCellOutputUri=Ie;function ue(re,Se,Le){return K.generate(re,Se).with({scheme:Le})}K.generateCellPropertyUri=ue;function pe(re,Se){if(re.scheme===Se)return K.parse(re.with({scheme:K.scheme}))}K.parseCellPropertyUri=pe})(a||(e.CellUri=a={}));const h=K=>g.$i?K.replace(/\//g,"\\"):K;class t{constructor(ie=[],ce=e.$AK){this.e=ce,this.d=[...new Set(ie)].map(ve=>({pattern:ve,matches:N.$kk(h(ve))}))}sort(ie){const ce=new Map(R.Iterable.map(ie,Ie=>[Ie,h(Ie)]));let ve=[];for(const{matches:Ie}of this.d)for(const[ue,pe]of ce)if(Ie(pe)){ve.push(ue),ce.delete(ue);break}return ce.size&&(ve=ve.concat([...ce.keys()].sort((Ie,ue)=>this.e.indexOf(Ie)-this.e.indexOf(ue)))),ve}prioritize(ie,ce){const ve=this.f(ie);if(ve===-1){this.d.unshift({pattern:ie,matches:N.$kk(h(ie))});return}const Ie=new Set(ce.map(pe=>this.f(pe,ve)));Ie.delete(-1);const ue=Array.from(Ie).sort();this.d.splice(ve+1,0,...ue.map(pe=>this.d[pe]));for(let pe=ue.length-1;pe>=0;pe--)this.d.splice(ue[pe],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,ce=this.d.length){const ve=h(ie);for(let Ie=0;Ie<ce;Ie++)if(this.d[Ie].matches(ve))return Ie;return-1}}e.$EK=t;function b(K,ie,ce,ve=(Ie,ue)=>Ie===ue){const Ie=[];function ue(Se,Le,ne){if(Le===0&&ne.length===0)return;const U=Ie[Ie.length-1];U&&U.start+U.deleteCount===Se?(U.deleteCount+=Le,U.toInsert.push(...ne)):Ie.push({start:Se,deleteCount:Le,toInsert:ne})}let pe=0,re=0;for(;;){if(pe===K.length){ue(pe,0,ie.slice(re));break}if(re===ie.length){ue(pe,K.length-pe,[]);break}const Se=K[pe],Le=ie[re];if(ve(Se,Le)){pe+=1,re+=1;continue}ce(Le)?(ue(pe,1,[]),pe+=1):(ue(pe,0,[Le]),re+=1)}return Ie}e.$GK=new E.$Hj("notebookEditorCursorAtBoundary","none"),e.$HK=new E.$Hj("notebookEditorCursorAtLineBoundary","none");var c;(function(K){K.default="default",K.option="option"})(c||(e.NotebookEditorPriority=c={}));function $(K){const ie=K;return!!((typeof ie.include=="string"||N.$lk(ie.include))&&(typeof ie.exclude=="string"||N.$lk(ie.exclude)))}function v(K,ie,ce){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ie)>=0||K.viewType===ie)return!0;if(K.filenamePattern){const ve=$(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Ie=$(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(N.$jk(ve,(0,m.$oc)(ce.fsPath).toLowerCase()))return!(Ie&&N.$jk(Ie,(0,m.$oc)(ce.fsPath).toLowerCase()))}return!1}e.$KK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics"};var p;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class l{static{this.d="notebook/"}static create(ie){return`${l.d}${ie}`}static parse(ie){if(ie.startsWith(l.d))return ie.substring(l.d.length)}}e.$LK=l;function D(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const f=new TextDecoder;function S(K){const ie=[];let ce=!1;for(const pe of K)(ie.length===0||ce)&&(ie.push(pe),ce=!0);let ve=P(ie);const Ie=I.$Ce.concat(ie.map(pe=>I.$Ce.wrap(pe))),ue=j(Ie);return ve=ve||ue.byteLength!==Ie.byteLength,{data:ue,didCompression:ve}}e.$OK="\x1B[A";const y=e.$OK.split("").map(K=>K.charCodeAt(0)),C=10;function P(K){let ie=!1;return K.forEach((ce,ve)=>{if(ve===0||ce.length<e.$OK.length)return;const Ie=K[ve-1],ue=ce.subarray(0,e.$OK.length);if(ue[0]===y[0]&&ue[1]===y[1]&&ue[2]===y[2]){const pe=Ie.lastIndexOf(C);if(pe===-1)return;ie=!0,K[ve-1]=Ie.subarray(0,pe),K[ve]=ce.subarray(e.$OK.length)}}),ie}function V(K){let ie=K;do K=ie,ie=K.replace(/[^\n]\x08/gm,"");while(ie.length<K.length);return K}function W(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ie=K.match(/^(.*)\r+/m)[1];let ce=K.match(/\r+(.*)$/m)[1];ce=ce+ie.slice(ce.length,ie.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return K}const q=8,A=13;function j(K){return!K.buffer.includes(q)&&!K.buffer.includes(A)?K:I.$Ce.fromString(W(V(f.decode(K.buffer))))}}),define(Re[7],Ae([1,0,18,14,54,28,69,15,17,2,35,20,43,102,83]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d){"use strict";var n,o,s,r,i,a,h,t,b,c,$,v,p,l,D,f,S;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$1O=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$ZO=e.$YO=e.$XO=e.$WO=e.ChatLocation=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$MO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$zO=e.$yO=e.$xO=e.$wO=e.$uO=e.$tO=e.$sO=e.$rO=e.TestRunProfileKind=e.TestResultState=e.$qO=e.$pO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$oO=e.NotebookVariablesRequestKind=e.$nO=e.$mO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$lO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.ColorThemeKind=e.$fO=e.$eO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$dO=e.$cO=e.DebugConsoleMode=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$9N=e.$8N=e.FileChangeType=e.$7N=e.NewSymbolNameTag=e.$6N=e.$5N=e.$4N=e.$3N=e.InlineCompletionTriggerKind=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$PN=e.ConfigurationTarget=e.$ON=e.$NN=e.$MN=e.$LN=e.DocumentPasteTriggerKind=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$EN=e.ViewBadge=e.ProgressLocation=e.$DN=e.$CN=e.TaskScope=e.ShellQuoting=e.$BN=e.$AN=e.$zN=e.TaskPanelKind=e.TaskRevealKind=e.$yN=e.TerminalLocation=e.$xN=e.$wN=e.$vN=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$uN=e.$tN=e.$sN=e.$rN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$pN=e.$oN=e.$nN=e.$mN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$lN=e.$kN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.LanguageStatusSeverity=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.CodeActionTriggerKind=e.$$M=e.$0M=e.SymbolTag=e.SymbolKind=e.$9M=e.$8M=e.DocumentHighlightKind=e.$7M=e.$6M=e.$5M=e.$4M=e.DiagnosticSeverity=e.DiagnosticTag=e.$3M=e.$2M=e.FileEditType=e.$1M=e.$ZM=e.$YM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$qN=dt,e.$QN=ae,e.$vO=wt;function y(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const De=te.length===1?[]:te[1];return Reflect.construct(B,De,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[De,...Ge]=te;return Reflect.construct(B,Ge,De.constructor)}}})}var C;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var P;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let V=n=class{static from(...O){let te=O;return new n(function(){if(te){for(const De of te)De&&typeof De.dispose=="function"&&De.dispose();te=void 0}})}#e;constructor(O){this.#e=O}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$RM=V,e.$RM=V=n=Je([y],V);let W=o=class{static Min(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let De=1;De<O.length;De++){const Ge=O[De];Ge.isBefore(te)&&(te=Ge)}return te}static Max(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let De=1;De<O.length;De++){const Ge=O[De];Ge.isAfter(te)&&(te=Ge)}return te}static isPosition(O){if(!O)return!1;if(O instanceof o)return!0;const{line:te,character:De}=O;return typeof te=="number"&&typeof De=="number"}static of(O){if(O instanceof o)return O;if(this.isPosition(O))return new o(O.line,O.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(O,te){if(O<0)throw(0,N.$7)("line must be non-negative");if(te<0)throw(0,N.$7)("character must be non-negative");this.c=O,this.e=te}isBefore(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<O.e}isBeforeOrEqual(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<=O.e}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this.c===O.c&&this.e===O.e}compareTo(O){return this.c<O.c?-1:this.c>O.line?1:this.e<O.e?-1:this.e>O.e?1:0}translate(O,te=0){if(O===null||te===null)throw(0,N.$7)();let De;return typeof O>"u"?De=0:typeof O=="number"?De=O:(De=typeof O.lineDelta=="number"?O.lineDelta:0,te=typeof O.characterDelta=="number"?O.characterDelta:0),De===0&&te===0?this:new o(this.line+De,this.character+te)}with(O,te=this.character){if(O===null||te===null)throw(0,N.$7)();let De;return typeof O>"u"?De=this.line:typeof O=="number"?De=O:(De=typeof O.line=="number"?O.line:this.line,te=typeof O.character=="number"?O.character:this.character),De===this.line&&te===this.character?this:new o(De,te)}toJSON(){return{line:this.line,character:this.character}}};e.$SM=W,e.$SM=W=o=Je([y],W);let q=s=class{static isRange(O){return O instanceof s?!0:O?W.isPosition(O.start)&&W.isPosition(O.end):!1}static of(O){if(O instanceof s)return O;if(this.isRange(O))return new s(O.start,O.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(O,te,De,Ge){let Ye,lt;if(typeof O=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"?(Ye=new W(O,te),lt=new W(De,Ge)):W.isPosition(O)&&W.isPosition(te)&&(Ye=W.of(O),lt=W.of(te)),!Ye||!lt)throw new Error("Invalid arguments");Ye.isBefore(lt)?(this.c=Ye,this.e=lt):(this.c=lt,this.e=Ye)}contains(O){return s.isRange(O)?this.contains(O.start)&&this.contains(O.end):W.isPosition(O)?!(W.of(O).isBefore(this.c)||this.e.isBefore(O)):!1}isEqual(O){return this.c.isEqual(O.c)&&this.e.isEqual(O.e)}intersection(O){const te=W.Max(O.start,this.c),De=W.Min(O.end,this.e);if(!te.isAfter(De))return new s(te,De)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const te=W.Min(O.start,this.c),De=W.Max(O.end,this.end);return new s(te,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(O,te=this.end){if(O===null||te===null)throw(0,N.$7)();let De;return O?W.isPosition(O)?De=O:(De=O.start||this.start,te=O.end||this.end):De=this.start,De.isEqual(this.c)&&te.isEqual(this.end)?this:new s(De,te)}toJSON(){return[this.start,this.end]}};e.$TM=q,e.$TM=q=s=Je([y],q);let A=r=class extends q{static isSelection(O){return O instanceof r?!0:O?q.isRange(O)&&W.isPosition(O.anchor)&&W.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(O,te,De,Ge){let Ye,lt;if(typeof O=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"?(Ye=new W(O,te),lt=new W(De,Ge)):W.isPosition(O)&&W.isPosition(te)&&(Ye=W.of(O),lt=W.of(te)),!Ye||!lt)throw new Error("Invalid arguments");super(Ye,lt),this.f=Ye,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$UM=A,e.$UM=A=r=Je([y],A);const j=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,N.$7)("connectionToken")};class K{static isResolvedAuthority(O){return O&&typeof O=="object"&&typeof O.host=="string"&&typeof O.port=="number"&&(O.connectionToken===void 0||typeof O.connectionToken=="string")}constructor(O,te,De){if(typeof O!="string"||O.length===0)throw(0,N.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,N.$7)("port");typeof De<"u"&&j(De),this.host=O,this.port=Math.round(te),this.connectionToken=De}}e.$VM=K;class ie{static isManagedResolvedAuthority(O){return O&&typeof O=="object"&&typeof O.makeConnection=="function"&&(O.connectionToken===void 0||typeof O.connectionToken=="string")}constructor(O,te){this.makeConnection=O,this.connectionToken=te,typeof te<"u"&&j(te)}}e.$WM=ie;class ce extends Error{static NotAvailable(O,te){return new ce(O,w.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(O){return new ce(O,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(O,te=w.RemoteAuthorityResolverErrorCode.Unknown,De){super(O),this._message=O,this._code=te,this._detail=De,Object.setPrototypeOf(this,ce.prototype)}}e.$XM=ce;var ve;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ve||(e.EndOfLine=ve={}));var Ie;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Ie||(e.EnvironmentVariableMutatorType=Ie={}));let ue=i=class{static isTextEdit(O){return O instanceof i?!0:O?q.isRange(O)&&typeof O.newText=="string":!1}static replace(O,te){return new i(O,te)}static insert(O,te){return i.replace(new q(O,O),te)}static delete(O){return i.replace(O,"")}static setEndOfLine(O){const te=new i(new q(new W(0,0),new W(0,0)),"");return te.newEol=O,te}get range(){return this.c}set range(O){if(O&&!q.isRange(O))throw(0,N.$7)("range");this.c=O}get newText(){return this.e||""}set newText(O){if(O&&typeof O!="string")throw(0,N.$7)("newText");this.e=O}get newEol(){return this.f}set newEol(O){if(O&&typeof O!="number")throw(0,N.$7)("newEol");this.f=O}constructor(O,te){this.c=O,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$YM=ue,e.$YM=ue=i=Je([y],ue);let pe=a=class{static isNotebookCellEdit(O){return O instanceof a?!0:O?fi.isNotebookRange(O)&&Array.isArray(O.newCells):!1}static replaceCells(O,te){return new a(O,te)}static insertCells(O,te){return new a(new fi(O,O),te)}static deleteCells(O){return new a(O,[])}static updateCellMetadata(O,te){const De=new a(new fi(O,O),[]);return De.newCellMetadata=te,De}static updateNotebookMetadata(O){const te=new a(new fi(0,0),[]);return te.newNotebookMetadata=O,te}constructor(O,te){this.range=O,this.newCells=te}};e.$ZM=pe,e.$ZM=pe=a=Je([y],pe);class re{static isSnippetTextEdit(O){return O instanceof re?!0:O?q.isRange(O.range)&&ne.isSnippetString(O.snippet):!1}static replace(O,te){return new re(O,te)}static insert(O,te){return re.replace(new q(O,O),te)}constructor(O,te){this.range=O,this.snippet=te}}e.$1M=re;var Se;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(Se||(e.FileEditType=Se={}));let Le=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(O,te,De,Ge){this.c.push({_type:1,from:O,to:te,options:De,metadata:Ge})}createFile(O,te,De){this.c.push({_type:1,from:void 0,to:O,options:te,metadata:De})}deleteFile(O,te,De){this.c.push({_type:1,from:O,to:void 0,options:te,metadata:De})}e(O,te,De){this.c.push({_type:3,metadata:De,uri:O,edit:{editType:5,metadata:te},notebookMetadata:te})}f(O,te,De,Ge){const Ye=te.start,lt=te.end;(Ye!==lt||De.length>0)&&this.c.push({_type:5,uri:O,index:Ye,count:lt-Ye,cells:De,metadata:Ge})}g(O,te,De,Ge){this.c.push({_type:3,metadata:Ge,uri:O,edit:{editType:3,index:te,metadata:De}})}replace(O,te,De,Ge){this.c.push({_type:2,uri:O,edit:new ue(te,De),metadata:Ge})}insert(O,te,De,Ge){this.replace(O,new q(te,te),De,Ge)}delete(O,te,De){this.replace(O,te,"",De)}has(O){return this.c.some(te=>te._type===2&&te.uri.toString()===O.toString())}set(O,te){if(te)for(const De of te){if(!De)continue;let Ge,Ye;Array.isArray(De)?(Ge=De[0],Ye=De[1]):Ge=De,pe.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(O,Ge.range.start,Ge.newCellMetadata,Ye):Ge.newNotebookMetadata?this.e(O,Ge.newNotebookMetadata,Ye):this.f(O,Ge.range,Ge.newCells,Ye):re.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:O,range:Ge.range,edit:Ge.snippet,metadata:Ye}):this.c.push({_type:2,uri:O,edit:Ge,metadata:Ye})}else{for(let De=0;De<this.c.length;De++){const Ge=this.c[De];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===O.toString()&&(this.c[De]=void 0);break}}(0,I.$Ib)(this.c)}}get(O){const te=[];for(const De of this.c)De._type===2&&De.uri.toString()===O.toString()&&te.push(De.edit);return te}entries(){const O=new F.$Bc;for(const te of this.c)if(te._type===2){let De=O.get(te.uri);De||(De=[te.uri,[]],O.set(te.uri,De)),De[1].push(te.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$2M=Le,e.$2M=Le=Je([y],Le);let ne=h=class{static isSnippetString(O){return O instanceof h?!0:O?typeof O.value=="string":!1}static c(O){return O.replace(/\$|}|\\/g,"\\$&")}constructor(O){this.e=1,this.value=O||""}appendText(O){return this.value+=h.c(O),this}appendTabstop(O=this.e++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,te=this.e++){if(typeof O=="function"){const De=new h;De.e=this.e,O(De),this.e=De.e,O=De.value}else O=h.c(O);return this.value+="${",this.value+=te,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,te=this.e++){const De=O.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(O,te){if(typeof te=="function"){const De=new h;De.e=this.e,te(De),this.e=De.e,te=De.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$3M=ne,e.$3M=ne=h=Je([y],ne);var U;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let be=t=class{static isLocation(O){return O instanceof t?!0:O?q.isRange(O.range)&&E.URI.isUri(O.uri):!1}constructor(O,te){if(this.uri=O,te)if(q.isRange(te))this.range=q.of(te);else if(W.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$4M=be,e.$4M=be=t=Je([y],be);let Ne=class{static is(O){return O?typeof O.message=="string"&&O.location&&q.isRange(O.location.range)&&E.URI.isUri(O.location.uri):!1}constructor(O,te){this.location=O,this.message=te}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.location.range.isEqual(te.location.range)&&O.location.uri.toString()===te.location.uri.toString()}};e.$5M=Ne,e.$5M=Ne=Je([y],Ne);let Ee=class{constructor(O,te,De=x.Error){if(!q.isRange(O))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=O,this.message=te,this.severity=De}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.severity===te.severity&&O.code===te.code&&O.severity===te.severity&&O.source===te.source&&O.range.isEqual(te.range)&&(0,I.$ub)(O.tags,te.tags)&&(0,I.$ub)(O.relatedInformation,te.relatedInformation,Ne.isEqual)}};e.$6M=Ee,e.$6M=Ee=Je([y],Ee);let $e=class{constructor(O,te){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=te}};e.$7M=$e,e.$7M=$e=Je([y],$e);var fe;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(fe||(e.DocumentHighlightKind=fe={}));let Q=class{constructor(O,te=fe.Text){this.range=O,this.kind=te}toJSON(){return{range:this.range,kind:fe[this.kind]}}};e.$8M=Q,e.$8M=Q=Je([y],Q);let Y=class{constructor(O,te){this.uri=O,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(O=>O.toJSON())}}};e.$9M=Y,e.$9M=Y=Je([y],Y);var le;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var de;(function(B){B[B.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Te=b=class{static validate(O){if(!O.name)throw new Error("name must not be falsy")}constructor(O,te,De,Ge,Ye){this.name=O,this.kind=te,this.containerName=Ye,typeof De=="string"&&(this.containerName=De),Ge instanceof be?this.location=Ge:De instanceof q&&(this.location=new be(Ge,De)),b.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$0M=Te,e.$0M=Te=b=Je([y],Te);let he=c=class{static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children?.forEach(c.validate)}constructor(O,te,De,Ge,Ye){this.name=O,this.detail=te,this.kind=De,this.range=Ge,this.selectionRange=Ye,this.children=[],c.validate(this)}};e.$$M=he,e.$$M=he=c=Je([y],he);var Ce;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let Me=class{constructor(O,te){this.title=O,this.kind=te}};e.$_M=Me,e.$_M=Me=Je([y],Me);let ze=class{static{$=this}static{this.c="."}constructor(O){this.value=O}append(O){return new $(this.value?this.value+$.c+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+$.c)}};e.$aN=ze,e.$aN=ze=$=Je([y],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let z=class{constructor(O,te){if(this.range=O,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$bN=z,e.$bN=z=Je([y],z);class L{constructor(O,te,De,Ge,Ye,lt){this.kind=O,this.name=te,this.detail=De,this.uri=Ge,this.range=Ye,this.selectionRange=lt}}e.$cN=L;class G{constructor(O,te){this.fromRanges=te,this.from=O}}e.$dN=G;class H{constructor(O,te){this.fromRanges=te,this.to=O}}e.$eN=H;var ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let se=class{constructor(O,te){this.range=O,this.command=te}get isResolved(){return!!this.command}};e.$fN=se,e.$fN=se=Je([y],se);let Fe=v=class{#e;static isMarkdownString(O){return O instanceof v?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}constructor(O,te=!1){this.#e=new R.$Nk(O,{supportThemeIcons:te})}get value(){return this.#e.value}set value(O){this.#e.value=O}get isTrusted(){return this.#e.isTrusted}set isTrusted(O){this.#e.isTrusted=O}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(O){this.#e.supportThemeIcons=O}get supportHtml(){return this.#e.supportHtml}set supportHtml(O){this.#e.supportHtml=O}get baseUri(){return this.#e.baseUri}set baseUri(O){this.#e.baseUri=O}appendText(O){return this.#e.appendText(O),this}appendMarkdown(O){return this.#e.appendMarkdown(O),this}appendCodeblock(O,te){return this.#e.appendCodeblock(te??"",O),this}};e.$gN=Fe,e.$gN=Fe=v=Je([y],Fe);let Be=class{constructor(O,te){this.label=O,this.documentation=te}};e.$hN=Be,e.$hN=Be=Je([y],Be);let Qe=class{constructor(O,te){this.label=O,this.documentation=te,this.parameters=[]}};e.$iN=Qe,e.$iN=Qe=Je([y],Qe);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$jN=xe,e.$jN=xe=Je([y],xe);var _e;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(_e||(e.SignatureHelpTriggerKind=_e={}));var et;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(et||(e.InlayHintKind=et={}));let tt=class{constructor(O){this.value=O}};e.$kN=tt,e.$kN=tt=Je([y],tt);let nt=class{constructor(O,te,De){this.position=O,this.label=te,this.kind=De}};e.$lN=nt,e.$lN=nt=Je([y],nt);var ct;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ct||(e.CompletionTriggerKind=ct={}));var ft;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(ft||(e.CompletionItemKind=ft={}));var je;(function(B){B[B.Deprecated=1]="Deprecated"})(je||(e.CompletionItemTag=je={}));let st=class{constructor(O,te){this.label=O,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ft[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$mN=st,e.$mN=st=Je([y],st);let X=class{constructor(O=[],te=!1){this.items=O,this.isIncomplete=te}};e.$nN=X,e.$nN=X=Je([y],X);let Z=class{constructor(O,te,De){this.insertText=O,this.range=te,this.command=De}};e.$oN=Z,e.$oN=Z=Je([y],Z);let me=class{constructor(O){this.commands=void 0,this.suppressSuggestions=void 0,this.items=O}};e.$pN=me,e.$pN=me=Je([y],me);var He;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(He||(e.PartialAcceptTriggerKind=He={}));var ye;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(ye||(e.ViewColumn=ye={}));var ot;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function dt(B,O){return`${k.$Lm.toKey(B)}.${O}`}var Pt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Bt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Bt||(e.TextDocumentSaveReason=Bt={}));var Yt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Yt||(e.TextEditorRevealType=Yt={}));var qt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(qt||(e.TextEditorSelectionChangeKind=qt={}));var xt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(xt||(e.TextDocumentChangeReason=xt={}));var Et;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Et||(e.DecorationRangeBehavior=Et={})),function(B){function O(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=O}(qt||(e.TextEditorSelectionChangeKind=qt={}));var Wt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Wt||(e.SyntaxTokenType=Wt={})),function(B){function O(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=O}(Wt||(e.SyntaxTokenType=Wt={}));let Ht=class{constructor(O,te){if(te&&!E.URI.isUri(te))throw(0,N.$7)("target");if(!q.isRange(O)||O.isEmpty)throw(0,N.$7)("range");this.range=O,this.target=te}};e.$rN=Ht,e.$rN=Ht=Je([y],Ht);let Xe=class{constructor(O,te,De,Ge){this.red=O,this.green=te,this.blue=De,this.alpha=Ge}};e.$sN=Xe,e.$sN=Xe=Je([y],Xe);let ri=class{constructor(O,te){if(te&&!(te instanceof Xe))throw(0,N.$7)("color");if(!q.isRange(O)||O.isEmpty)throw(0,N.$7)("range");this.range=O,this.color=te}};e.$tN=ri,e.$tN=ri=Je([y],ri);let _t=class{constructor(O){if(!O||typeof O!="string")throw(0,N.$7)("label");this.label=O}};e.$uN=_t,e.$uN=_t=Je([y],_t);var ht;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ht||(e.ColorFormat=ht={}));var $t;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})($t||(e.SourceControlInputBoxValidationType=$t={}));var ei;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ei||(e.TerminalExitReason=ei={}));class ti{constructor(O,te,De){if(this.startIndex=O,this.length=te,this.tooltip=De,typeof O!="number"||O<0)throw(0,N.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,N.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,N.$7)("tooltip")}}e.$vN=ti;class Lt{constructor(O){this.uri=O}}e.$wN=Lt;class gt{constructor(O){this.terminalCommand=O}}e.$xN=gt;var zt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(zt||(e.TerminalLocation=zt={}));class ii{constructor(O){if(this.options=O,typeof O!="object")throw(0,N.$7)("options")}}e.$yN=ii;var Tt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Tt||(e.TaskRevealKind=Tt={}));var Ke;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Ke||(e.TaskPanelKind=Ke={}));let si=class{static{p=this}static{this.Clean=new p("clean","Clean")}static{this.Build=new p("build","Build")}static{this.Rebuild=new p("rebuild","Rebuild")}static{this.Test=new p("test","Test")}static from(O){switch(O){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}constructor(O,te){if(this.label=te,typeof O!="string"||typeof te!="string")throw(0,N.$7)("name");this.c=O}get id(){return this.c}};e.$zN=si,e.$zN=si=p=Je([y],si);function Gt(B){let O="";for(let te=0;te<B.length;te++)O+=B[te].replace(/,/g,",,")+",";return O}let Ut=class{constructor(O,te,De){if(typeof O!="string")throw(0,N.$7)("process");this.e=[],this.c=O,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=De):this.f=te)}get process(){return this.c}set process(O){if(typeof O!="string")throw(0,N.$7)("process");this.c=O}get args(){return this.e}set args(O){Array.isArray(O)||(O=[]),this.e=O}get options(){return this.f}set options(O){this.f=O}computeId(){const O=[];if(O.push("process"),this.c!==void 0&&O.push(this.c),this.e&&this.e.length>0)for(const te of this.e)O.push(te);return Gt(O)}};e.$AN=Ut,e.$AN=Ut=Je([y],Ut);let mt=class{constructor(O,te,De){if(this.f=[],Array.isArray(te)){if(!O)throw(0,N.$7)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,N.$7)("command");this.e=O,this.f=te,this.g=De}else{if(typeof O!="string")throw(0,N.$7)("commandLine");this.c=O,this.g=te}}get commandLine(){return this.c}set commandLine(O){if(typeof O!="string")throw(0,N.$7)("commandLine");this.c=O}get command(){return this.e?this.e:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,N.$7)("command");this.e=O}get args(){return this.f}set args(O){this.f=O||[]}get options(){return this.g}set options(O){this.g=O}computeId(){const O=[];if(O.push("shell"),this.c!==void 0&&O.push(this.c),this.e!==void 0&&O.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)O.push(typeof te=="string"?te:te.value);return Gt(O)}};e.$BN=mt,e.$BN=mt=Je([y],mt);var Ft;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Ft||(e.ShellQuoting=Ft={}));var Mt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Mt||(e.TaskScope=Mt={}));class jt{constructor(O){this.c=O}computeId(){return"customExecution"+(0,T.$Mg)()}set callback(O){this.c=O}get callback(){return this.c}}e.$CN=jt;let Kt=class{static{l=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(O,te,De,Ge,Ye,lt){this.k=!1,this.l=this.definition=O;let pt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=De,this.execution=Ge,pt=Ye,this.k=!0):te===Mt.Global||te===Mt.Workspace?(this.target=te,this.o=this.name=De,this.w=this.source=Ge,this.execution=Ye,pt=lt):(this.target=te,this.o=this.name=De,this.w=this.source=Ge,this.execution=Ye,pt=lt),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(O){this.j=O}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ut?this.l={type:l.e,id:this.q.computeId()}:this.q instanceof mt?this.l={type:l.f,id:this.q.computeId()}:this.q instanceof jt?this.l={type:l.c,id:this.q.computeId()}:this.l={type:l.g,id:(0,T.$Mg)()}}get definition(){return this.l}set definition(O){if(O==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=O}get scope(){return this.m}set target(O){this.B(),this.m=O}get name(){return this.o}set name(O){if(typeof O!="string")throw(0,N.$7)("name");this.B(),this.o=O}get execution(){return this.q}set execution(O){O===null&&(O=void 0),this.B(),this.q=O;const te=this.l.type;(l.g===te||l.e===te||l.f===te||l.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(O){if(Array.isArray(O))this.B(),this.r=O,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.B(),this.u=O}get source(){return this.w}set source(O){if(typeof O!="string"||O.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=O}get group(){return this.x}set group(O){O===null&&(O=void 0),this.B(),this.x=O}get detail(){return this.A}set detail(O){O===null&&(O=void 0),this.A=O}get presentationOptions(){return this.y}set presentationOptions(O){O==null&&(O=Object.create(null)),this.B(),this.y=O}get runOptions(){return this.z}set runOptions(O){O==null&&(O=Object.create(null)),this.B(),this.z=O}};e.$DN=Kt,e.$DN=Kt=l=Je([y],Kt);var Jt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Jt||(e.ProgressLocation=Jt={}));var oi;(function(B){function O(te){const De=te;return(0,g.$8f)(De.value)?De.tooltip&&!(0,g.$4f)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=O})(oi||(e.ViewBadge=oi={}));let Ct=D=class{static isTreeItem(O,te){const De=O;if(De.checkboxState!==void 0){const Ge=(0,g.$8f)(De.checkboxState)?De.checkboxState:(0,g.$6f)(De.checkboxState)&&(0,g.$8f)(De.checkboxState.state)?De.checkboxState.state:void 0,Ye=!(0,g.$8f)(De.checkboxState)&&(0,g.$6f)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==It.Checked&&Ge!==It.Unchecked||Ye!==void 0&&!(0,g.$4f)(Ye))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(O instanceof D)return!0;if(De.label!==void 0&&!(0,g.$4f)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,g.$4f)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,g.$4f)(De.iconPath)&&!E.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,g.$4f)(De.iconPath.id))){const Ge=De.iconPath;if(!Ge||!(0,g.$4f)(Ge.light)&&!E.URI.isUri(Ge.light)&&!(0,g.$4f)(Ge.dark)&&!E.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,g.$4f)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!E.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,g.$4f)(De.tooltip)&&!(De.tooltip instanceof Fe)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Nt.None&&De.collapsibleState>Nt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,g.$4f)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(O,te=Nt.None){this.collapsibleState=te,E.URI.isUri(O)?this.resourceUri=O:this.label=O}};e.$EN=Ct,e.$EN=Ct=D=Je([y],Ct);var Nt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Nt||(e.TreeItemCollapsibleState=Nt={}));var It;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(It||(e.TreeItemCheckboxState=It={}));let Dt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(O){this.value=O}};e.$FN=Dt,e.$FN=Dt=Je([y],Dt);class bt extends Dt{}e.$GN=bt;class St extends bt{#e;constructor(O){super(""),this.#e=O}asFile(){return this.#e}}e.$HN=St;class li{constructor(O,te,De,Ge){this.name=O,this.uri=te,this._itemId=De,this.c=Ge}data(){return this.c()}}e.$IN=li;let yt=class{#e=new Map;constructor(O){for(const[te,De]of O??[]){const Ge=this.#e.get(this.#t(te));Ge?Ge.push(De):this.#e.set(this.#t(te),[De])}}get(O){return this.#e.get(this.#t(O))?.[0]}set(O,te){this.#e.set(this.#t(O),[te])}forEach(O,te){for(const[De,Ge]of this.#e)for(const Ye of Ge)O.call(te,Ye,De,this)}*[Symbol.iterator](){for(const[O,te]of this.#e)for(const De of te)yield[O,De]}#t(O){return O.toLowerCase()}};e.$JN=yt,e.$JN=yt=Je([y],yt);let hi=class{constructor(O,te,De){this.insertText=O,this.title=te,this.kind=De}};e.$KN=hi,e.$KN=hi=Je([y],hi);var Qt;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(Qt||(e.DocumentPasteTriggerKind=Qt={}));class ai{static{this.c="."}constructor(O){this.value=O}append(...O){return new ai((this.value?[this.value,...O]:O).join(ai.c))}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+ai.c)}}e.$LN=ai,ai.Empty=new ai("");class pi{constructor(O,te,De){this.title=te,this.insertText=O,this.kind=De}}e.$MN=pi;let ni=class{constructor(O,te){this.id=O,this.color=te}static isThemeIcon(O){return typeof O.id!="string"?(console.log("INVALID ThemeIcon, invalid id",O.id),!1):!0}};e.$NN=ni,e.$NN=ni=Je([y],ni),ni.File=new ni("file"),ni.Folder=new ni("folder");let Rt=class{constructor(O){this.id=O}};e.$ON=Rt,e.$ON=Rt=Je([y],Rt);var yi;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(yi||(e.ConfigurationTarget=yi={}));let we=class{get base(){return this.c}set base(O){this.c=O,this.e=E.URI.file(O)}get baseUri(){return this.e}set baseUri(O){this.e=O,this.c=O.fsPath}constructor(O,te){if(typeof O!="string"&&(!O||!E.URI.isUri(O)&&!E.URI.isUri(O.uri)))throw(0,N.$7)("base");if(typeof te!="string")throw(0,N.$7)("pattern");typeof O=="string"?this.baseUri=E.URI.file(O):E.URI.isUri(O)?this.baseUri=O:this.baseUri=O.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$PN=we,e.$PN=we=Je([y],we);const Pe=new WeakMap;function ae(B,O){Pe.set(B,O)}let J=class{constructor(O,te,De,Ge,Ye){this.enabled=typeof O=="boolean"?O:!0,typeof te=="string"&&(this.condition=te),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=Pe.get(this)??(0,T.$Mg)()),this.c}};e.$RN=J,e.$RN=J=Je([y],J);let ke=class extends J{constructor(O,te,De,Ge,Ye,lt){if(super(te,De,Ge,Ye,lt),O===null)throw(0,N.$7)("location");this.location=O}};e.$SN=ke,e.$SN=ke=Je([y],ke);let We=class extends J{constructor(O,te,De,Ge,Ye,lt){super(te,De,Ge,Ye,lt),this.functionName=O}};e.$TN=We,e.$TN=We=Je([y],We);let Ze=class extends J{constructor(O,te,De,Ge,Ye,lt,pt,Vt){if(super(Ge,Ye,lt,pt,Vt),!te)throw(0,N.$7)("dataId");this.label=O,this.dataId=te,this.canPersist=De}};e.$UN=Ze,e.$UN=Ze=Je([y],Ze);let qe=class{constructor(O,te,De){this.command=O,this.args=te||[],this.options=De}};e.$VN=qe,e.$VN=qe=Je([y],qe);let ut=class{constructor(O,te){this.port=O,this.host=te}};e.$WN=ut,e.$WN=ut=Je([y],ut);let kt=class{constructor(O){this.path=O}};e.$XN=kt,e.$XN=kt=Je([y],kt);let Ot=class{constructor(O){this.implementation=O}};e.$YN=Ot,e.$YN=Ot=Je([y],Ot);class Zt{constructor(O,te,De){this.session=O,this.threadId=te,this.frameId=De}}e.$ZN=Zt;class at{constructor(O,te){this.session=O,this.threadId=te}}e.$1N=at;let Xt=class{constructor(O,te){this.range=O,this.expression=te}};e.$2N=Xt,e.$2N=Xt=Je([y],Xt);var mi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(mi||(e.InlineCompletionTriggerKind=mi={}));let bi=class{constructor(O,te){this.range=O,this.text=te}};e.$3N=bi,e.$3N=bi=Je([y],bi);let Di=class{constructor(O,te,De=!0){this.range=O,this.variableName=te,this.caseSensitiveLookup=De}};e.$4N=Di,e.$4N=Di=Je([y],Di);let Mi=class{constructor(O,te){this.range=O,this.expression=te}};e.$5N=Mi,e.$5N=Mi=Je([y],Mi);let Ni=class{constructor(O,te){this.frameId=O,this.stoppedLocation=te}};e.$6N=Ni,e.$6N=Ni=Je([y],Ni);var qi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(qi||(e.NewSymbolNameTag=qi={}));class Hi{constructor(O,te){this.newSymbolName=O,this.tags=te}}e.$7N=Hi;var Gi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Gi||(e.FileChangeType=Gi={}));let Si=f=class extends Error{static FileExists(O){return new f(O,u.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(O){return new f(O,u.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(O){return new f(O,u.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(O){return new f(O,u.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(O){return new f(O,u.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(O){return new f(O,u.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}constructor(O,te=u.FileSystemProviderErrorCode.Unknown,De){super(E.URI.isUri(O)?O.toString(!0):O),this.code=De?.name??"Unknown",(0,u.$_k)(this,te),Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$8N=Si,e.$8N=Si=f=Je([y],Si);let Ti=class{constructor(O,te,De){this.start=O,this.end=te,this.kind=De}};e.$9N=Ti,e.$9N=Ti=Je([y],Ti);var Ii;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Ii||(e.FoldingRangeKind=Ii={}));var Pi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Pi||(e.CommentThreadCollapsibleState=Pi={}));var Ki;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var Ji;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Ji||(e.CommentState=Ji={}));var wi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));var Qi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Qi||(e.CommentThreadApplicability=Qi={}));class un{constructor(O,te=[]){this.tokenTypes=O,this.tokenModifiers=te}}e.$0N=un;function ln(B){return typeof B>"u"||(0,g.$5f)(B)}class ki{constructor(O){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,O){this.m=!0;for(let te=0,De=O.tokenTypes.length;te<De;te++)this.k.set(O.tokenTypes[te],te);for(let te=0,De=O.tokenModifiers.length;te<De;te++)this.l.set(O.tokenModifiers[te],te)}}push(O,te,De,Ge,Ye){if(typeof O=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(O,te,De,Ge,Ye);if(q.isRange(O)&&typeof te=="string"&&ln(De))return this.o(O,te,De);throw(0,N.$7)()}o(O,te,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,Ye=O.start.character,lt=O.end.character-O.start.character,pt=this.k.get(te);let Vt=0;if(De)for(const ui of De){if(!this.l.has(ui))throw new Error("`tokenModifier` is not in the provided legend");const gi=this.l.get(ui);Vt|=1<<gi>>>0}this.q(Ge,Ye,lt,pt,Vt)}q(O,te,De,Ge,Ye){if(this.f&&(O<this.c||O===this.c&&te<this.e)){this.f=!1;const Vt=this.g.length/5|0;let ui=0,gi=0;for(let $i=0;$i<Vt;$i++){let vi=this.g[5*$i],Wi=this.g[5*$i+1];vi===0?(vi=ui,Wi+=gi):vi+=ui,this.g[5*$i]=vi,this.g[5*$i+1]=Wi,ui=vi,gi=Wi}}let lt=O,pt=te;this.f&&this.j>0&&(lt-=this.c,lt===0&&(pt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=pt,this.g[this.j++]=De,this.g[this.j++]=Ge,this.g[this.j++]=Ye,this.c=O,this.e=te}static r(O){const te=[],De=O.length/5|0;for(let pt=0;pt<De;pt++)te[pt]=pt;te.sort((pt,Vt)=>{const ui=O[5*pt],gi=O[5*Vt];if(ui===gi){const $i=O[5*pt+1],vi=O[5*Vt+1];return $i-vi}return ui-gi});const Ge=new Uint32Array(O.length);let Ye=0,lt=0;for(let pt=0;pt<De;pt++){const Vt=5*te[pt],ui=O[Vt+0],gi=O[Vt+1],$i=O[Vt+2],vi=O[Vt+3],Wi=O[Vt+4],Mn=ui-Ye,or=Mn===0?gi-lt:gi,Vi=5*pt;Ge[Vi+0]=Mn,Ge[Vi+1]=or,Ge[Vi+2]=$i,Ge[Vi+3]=vi,Ge[Vi+4]=Wi,Ye=ui,lt=gi}return Ge}build(O){return this.f?new Fi(new Uint32Array(this.g),O):new Fi(ki.r(this.g),O)}}e.$$N=ki;class Fi{constructor(O,te){this.resultId=te,this.data=O}}e.$_N=Fi;class Zi{constructor(O,te,De){this.start=O,this.deleteCount=te,this.data=De}}e.$aO=Zi;class hn{constructor(O,te){this.resultId=te,this.edits=O}}e.$bO=hn;var Oi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Oi||(e.DebugConsoleMode=Oi={}));class dn{constructor(O){this.name=O}}e.$cO=dn;let Li=class{static{this.Back={iconPath:new ni("arrow-left")}}constructor(){}};e.$dO=Li,e.$dO=Li=Je([y],Li);var Xi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Xi||(e.QuickPickItemKind=Xi={}));var Yi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Yi||(e.InputBoxValidationSeverity=Yi={}));var Ci;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Ci||(e.ExtensionKind=Ci={}));class xi{static validate(O){if(typeof O.badge=="string"){let te=(0,m.$Df)(O.badge,0);if(te<O.badge.length&&(te+=(0,m.$Df)(O.badge,te)),O.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(O.badge&&!ni.isThemeIcon(O.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}constructor(O,te,De){this.badge=O,this.tooltip=te,this.color=De}}e.$eO=xi;let Ue=class{constructor(O){this.kind=O}};e.$fO=Ue,e.$fO=Ue=Je([y],Ue);var di;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(di||(e.ColorThemeKind=di={}));class fi{static isNotebookRange(O){return O instanceof fi?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(O,te){if(O<0)throw(0,N.$7)("start must be positive");if(te<0)throw(0,N.$7)("end must be positive");O<=te?(this.c=O,this.e=te):(this.c=te,this.e=O)}with(O){let te=this.c,De=this.e;return O.start!==void 0&&(te=O.start),O.end!==void 0&&(De=O.end),te===this.c&&De===this.e?this:new fi(te,De)}}e.$gO=fi;class it{static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(te=>it.isNotebookCellData(te))}static isNotebookCellData(O){return!0}constructor(O,te,De,Ge,Ye,lt,pt){this.kind=O,this.value=te,this.languageId=De,this.mime=Ge,this.outputs=Ye??[],this.metadata=lt,this.executionSummary=pt,it.validate(this)}}e.$hO=it;class vt{constructor(O){this.cells=O}}e.$iO=vt;class ci{static isNotebookCellOutputItem(O){return O instanceof ci?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const te={name:O.name,message:O.message,stack:O.stack};return ci.json(te,"application/vnd.code.notebook.error")}static stdout(O){return ci.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return ci.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,te="application/octet-stream"){return new ci(O,te)}static#e=new TextEncoder;static text(O,te=M.$Hs.text){const De=ci.#e.encode(String(O));return new ci(De,te)}static json(O,te="text/x-json"){const De=JSON.stringify(O,void 0,"	");return ci.text(De,te)}constructor(O,te){this.data=O,this.mime=te;const De=(0,M.$Ls)(te,!0);if(!De)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$jO=ci;class Ri{static isNotebookCellOutput(O){return O instanceof Ri?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&Array.isArray(O.items)}static ensureUniqueMimeTypes(O,te=!1){const De=new Set,Ge=new Set;for(let Ye=0;Ye<O.length;Ye++){const lt=O[Ye],pt=(0,M.$Ls)(lt.mime);if(!De.has(pt)||(0,d.$MK)(pt)){De.add(pt);continue}Ge.add(Ye),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ge.size===0?O:O.filter((Ye,lt)=>!Ge.has(lt))}constructor(O,te,De){this.items=Ri.ensureUniqueMimeTypes(O,!0),typeof te=="string"?(this.id=te,this.metadata=De):(this.id=(0,T.$Mg)(),this.metadata=te??De)}}e.$kO=Ri;var zi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(zi||(e.NotebookCellKind=zi={}));var _i;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(_i||(e.NotebookCellExecutionState=_i={}));var Ei;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ei||(e.NotebookCellStatusBarAlignment=Ei={}));var en;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(O,te){this.text=O,this.alignment=te}}e.$lO=fn;var tn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(tn||(e.NotebookControllerAffinity=tn={}));var Ui;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(Ui||(e.NotebookControllerAffinity2=Ui={}));class gn{constructor(O,te=[]){this.uri=O,this.provides=(0,I.$3b)(te)}}e.$mO=gn;class mn{constructor(O){this.label=O}}e.$nO=mn;var nn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let ji=class{constructor(O,te){this.label=O,this.timestamp=te}};e.$oO=ji,e.$oO=ji=Je([y],ji);var rn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(O,te){this.ranges=O,this.wordPattern=te}}e.$pO=$n;class pn{constructor(O){this.c=O}get autoForwardAction(){return this.c}}e.$qO=pn;var an;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var cn;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let _=class{constructor(O=void 0,te=void 0,De=void 0,Ge=!1){this.include=O,this.exclude=te,this.profile=De,this.continuous=Ge}};e.$rO=_,e.$rO=_=Je([y],_);let oe=S=class{static diff(O,te,De){const Ge=new S(O);return Ge.expectedOutput=te,Ge.actualOutput=De,Ge}constructor(O){this.message=O}};e.$sO=oe,e.$sO=oe=S=Je([y],oe);let Oe=class{constructor(O){this.id=O}};e.$tO=Oe,e.$tO=Oe=Je([y],Oe);class rt{constructor(O,te){this.covered=O,this.total=te,wt(this)}}e.$uO=rt;function wt(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class At{static fromDetails(O,te){const De=new rt(0,0),Ge=new rt(0,0),Ye=new rt(0,0);for(const pt of te)if("branches"in pt){De.total+=1,De.covered+=pt.executed?1:0;for(const Vt of pt.branches)Ge.total+=1,Ge.covered+=Vt.executed?1:0}else Ye.total+=1,Ye.covered+=pt.executed?1:0;const lt=new At(O,De,Ge.total>0?Ge:void 0,Ye.total>0?Ye:void 0);return lt.detailedCoverage=te,lt}constructor(O,te,De,Ge){this.uri=O,this.statementCoverage=te,this.branchCoverage=De,this.declarationCoverage=Ge}}e.$wO=At;class Bi{get executionCount(){return+this.executed}set executionCount(O){this.executed=O}constructor(O,te,De=[]){this.executed=O,this.location=te,this.branches=De}}e.$xO=Bi;class Nn{get executionCount(){return+this.executed}set executionCount(O){this.executed=O}constructor(O,te,De){this.executed=O,this.location=te,this.label=De}}e.$yO=Nn;class Tn{get executionCount(){return+this.executed}set executionCount(O){this.executed=O}constructor(O,te,De){this.name=O,this.executed=te,this.location=De}}e.$zO=Tn;var bn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(bn||(e.ExternalUriOpenerPriority=bn={}));var vn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(vn||(e.WorkspaceTrustState=vn={}));var wn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn||(e.PortAutoForwardAction=wn={}));class Fn{constructor(O,te,De,Ge,Ye,lt){this.kind=O,this.name=te,this.detail=De,this.uri=Ge,this.range=Ye,this.selectionRange=lt}}e.$AO=Fn;class On{constructor(O){this.uri=O}}e.$BO=On;class Ln{constructor(O,te){this.original=O,this.modified=te}}e.$CO=Ln;class zn{constructor(O,te,De,Ge){this.base=O,this.input1=te,this.input2=De,this.result=Ge}}e.$DO=zn;class Un{constructor(O,te){this.uri=O,this.viewType=te}}e.$EO=Un;class jn{constructor(O){this.viewType=O}}e.$FO=jn;class Bn{constructor(O,te){this.uri=O,this.notebookType=te}}e.$GO=Bn;class Wn{constructor(O,te,De){this.original=O,this.modified=te,this.notebookType=De}}e.$HO=Wn;class Vn{constructor(){}}e.$IO=Vn;class qn{constructor(O,te){this.uri=O,this.inputBoxUri=te}}e.$JO=qn;class Hn{constructor(){}}e.$KO=Hn;class Gn{constructor(O){this.textDiffs=O}}e.$LO=Gn;var yn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var kn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var En;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(En||(e.ChatVariableLevel=En={}));class Kn{constructor(O,te){this.label=O,this.values=te}}e.$MO=Kn;var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Dn||(e.InteractiveEditorResponseFeedbackKind=Dn={}));var Sn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Sn||(e.ChatResultFeedbackKind=Sn={}));class Jn{constructor(O){this.value=typeof O=="string"?new Fe(O):O}}e.$NO=Jn;class Qn{constructor(O,te){this.value=O,this.baseUri=te}}e.$OO=Qn;class Zn{constructor(O,te){this.value=O,this.title=te}}e.$PO=Zn;class Xn{constructor(O){this.value=O}}e.$QO=Xn;class Yn{constructor(O){this.value=O}}e.$RO=Yn;class xn{constructor(O){this.value=O}}e.$SO=xn;class _n{constructor(O,te){this.uri=O,this.edits=Array.isArray(te)?te:[te]}}e.$TO=_n;class er{constructor(O,te,De,Ge){this.prompt=O,this.command=te,this.variables=De,this.participant=Ge}}e.$UO=er;class tr{constructor(O,te,De,Ge){this.response=O,this.result=te,this.participant=De,this.command=Ge}}e.$VO=tr;var In;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(In||(e.ChatLocation=In={}));class ir{constructor(O){this.content=O}}e.$WO=ir;class nr{constructor(O,te){this.content=O,this.name=te}}e.$XO=nr;class rr{constructor(O,te){this.content=O,this.name=te}}e.$YO=rr;class Ai extends Error{static NotFound(O){return new Ai(O,Ai.NotFound.name)}static NoPermissions(O){return new Ai(O,Ai.NoPermissions.name)}constructor(O,te,De){super(O,{cause:De}),this.name="LanguageModelError",this.code=te??""}}e.$ZO=Ai;var Pn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}));var Cn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Cn||(e.SpeechToTextStatus=Cn={}));var Rn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Rn||(e.KeywordRecognitionStatus=Rn={}));class sr{constructor(O,te){this.text=O,this.range=te}}e.$1O=sr;var An;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(An||(e.InlineEditTriggerKind=An={}))}),define(Re[247],Ae([1,0,4,7]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$PM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,m,g){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(M);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(m,g)??[]}getRelatedInformation(M,m,g){return this.c.$getAiRelatedInformation(m,g)}registerRelatedInformationProvider(M,m,g){const E=this.b;return this.b++,this.a.set(E,g),this.c.$registerAiRelatedInformationProvider(E,m),new N.$RM(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$1jc=R}),define(Re[84],Ae([1,0,5,4,7,20,106,3,16]),function(ge,e,I,N,R,F,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=e.$_jc=void 0,e.$_jc=(0,m.$qi)("IExtHostAuthentication");let E=class{constructor(u){this.b=new Map,this.c=new I.$be,this.onDidChangeSessions=this.c.event,this.d=new T,this.f=new T,this.a=u.getProxy(N.$PM.MainThreadAuthentication)}async getSession(u,w,d,n={}){const o=F.$Lm.toKey(u.identifier),s=[...d].sort().join(" ");return await this.d.getOrCreate(`${o} ${w} ${s}`,async()=>{await this.a.$ensureProvider(w);const r=u.displayName||u.name;return this.a.$getSession(w,d,o,r,n)})}async getSessions(u,w,d){const n=F.$Lm.toKey(u.identifier),o=[...d].sort().join(" ");return await this.f.getOrCreate(`${n} ${o}`,async()=>{await this.a.$ensureProvider(w);const s=u.displayName||u.name;return this.a.$getSessions(w,d,n,s)})}async removeSession(u,w){const d=this.b.get(u);return d?d.provider.removeSession(w):this.a.$removeSession(u,w)}registerAuthenticationProvider(u,w,d,n){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:w,provider:d,options:n??{supportsMultipleAccounts:!1}});const o=d.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(u,s));return this.a.$registerAuthenticationProvider(u,w,n?.supportsMultipleAccounts??!1),new R.$RM(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}$createSession(u,w,d){const n=this.b.get(u);if(n)return Promise.resolve(n.provider.createSession(w,d));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$removeSession(u,w){const d=this.b.get(u);if(d)return Promise.resolve(d.provider.removeSession(w));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$getSessions(u,w){const d=this.b.get(u);if(d)return Promise.resolve(d.provider.getSessions(w));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,w){return u.startsWith(M.$RL)||this.c.fire({provider:{id:u,label:w}}),Promise.resolve()}};e.$akc=E,e.$akc=E=Je([Ve(0,g.$aP)],E);class T{constructor(){this.a=new Map}getOrCreate(u,w){const d=this.a.get(u);if(d)return d;const n=w().finally(()=>this.a.delete(u));return this.a.set(u,n),n}}}),define(Re[110],Ae([1,0,2,4,7,3,16,13,18,15,19,25]),function(ge,e,I,N,R,F,M,m,g,E,T,k){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=e.$_kc=void 0;let w=class{static{u=this}static{this.c=0}static{this.d=250}constructor(n,o){this.h=o,this.f=new Map,this.g=n.getProxy(N.$PM.MainThreadDecorations)}registerFileDecorationProvider(n,o){const s=u.c++;this.f.set(s,{provider:n,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const r=n.onDidChangeFileDecorations&&n.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(s,null);return}const a=(0,g.$3b)(i);if(a.length<=u.d){this.g.$onDidChange(s,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,a.length);const h=a.map(c=>({uri:c,rank:(0,E.$9e)(c.path,"/")})),t=(0,g.$zb)(h,(c,$)=>c.rank-$.rank||(0,E.$mf)(c.uri.path,$.uri.path)),b=[];e:for(const c of t){let $;for(const v of c){const p=(0,T.$nc)(v.uri.path);if($!==p&&($=p,b.push(v.uri)>=u.d))break e}}this.g.$onDidChange(s,b)});return new R.$RM(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(n,o,s){if(!this.f.has(n))return Object.create(null);const r=Object.create(null),{provider:i,extensionDescription:a}=this.f.get(n);return await Promise.all(o.map(async h=>{try{const{uri:t,id:b}=h,c=await Promise.resolve(i.provideFileDecoration(I.URI.revive(t),s));if(!c)return;try{R.$eO.validate(c),c.badge&&typeof c.badge!="string"&&(0,k.$yG)(a,"codiconDecoration"),r[b]=[c.propagate,c.tooltip,c.badge,c.color]}catch($){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${$}`)}}catch(t){this.h.error(t)}})),r}};e.$_kc=w,e.$_kc=w=u=Je([Ve(0,M.$aP),Ve(1,m.$Wj)],w),e.$alc=(0,F.$qi)("IExtHostDecorations")}),define(Re[248],Ae([1,0,14,2,7,4,12,24,15]),function(ge,e,I,N,R,F,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clc=void 0;class E{static{this.a=0}constructor(k,u,w){this.d=u,this.e=w,this.b=new Map,this.c=k.getProxy(F.$PM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,u){if(Object.keys(M.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const w=E.a++;this.b.set(w,u),this.c.$registerTextContentProvider(w,k);let d;if(typeof u.onDidChange=="function"){let n;d=u.onDidChange(async o=>{if(o.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;n&&await n;const s=this.$provideTextDocumentContent(w,o).then(async r=>{if(!r&&typeof r!="string")return;const i=this.d.getDocument(o);if(!i)return;const a=(0,g.$gf)(r);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(o,r)}).catch(I.$1).finally(()=>{n===s&&(n=void 0)});n=s})}return new R.$RM(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(k,u){const w=this.b.get(k);return w?Promise.resolve(w.provideTextDocumentContent(N.URI.revive(u),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$clc=E}),define(Re[111],Ae([1,0,56,12,15,303,152,7,18]),function(ge,e,I,N,R,F,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eP=e.$dP=void 0,e.$cP=T;const E=new Map;function T(d,n){n?E.set(d,n):E.delete(d)}function k(d){return E.get(d)}class u extends F.$Pv{constructor(n,o,s,r,i,a,h){super(o,s,r,i),this.c=n,this.m=a,this.q=h,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(n){return(0,g.$ub)(this.f,n)}get document(){if(!this.a){const n=this;this.a={get uri(){return n.d},get fileName(){return n.d.fsPath},get isUntitled(){return n.d.scheme===N.Schemas.untitled},get languageId(){return n.m},get version(){return n.h},get isClosed(){return n.b},get isDirty(){return n.q},save(){return n.r()},getText(o){return o?n.s(o):n.getText()},get eol(){return n.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return n.f.length},lineAt(o){return n.t(o)},offsetAt(o){return n.u(o)},positionAt(o){return n.v(o)},validateRange(o){return n.w(o)},validatePosition(o){return n.x(o)},getWordRangeAtPosition(o,s){return n.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(n){(0,I.ok)(!this.b),this.m=n}_acceptIsDirty(n){(0,I.ok)(!this.b),this.q=n}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(n){const o=this.w(n);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,r=o.start.line,i=o.end.line,a=[];a.push(this.f[r].substring(o.start.character));for(let h=r+1;h<i;h++)a.push(this.f[h]);return a.push(this.f[i].substring(0,o.end.character)),a.join(s)}t(n){let o;if(n instanceof m.$SM?o=n.line:typeof n=="number"&&(o=n),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new w(o,this.f[o],o===this.f.length-1)}u(n){return n=this.x(n),this.l(),this.j.getPrefixSum(n.line-1)+n.character}v(n){n=Math.floor(n),n=Math.max(0,n),this.l();const o=this.j.getIndexOf(n),s=this.f[o.index].length;return new m.$SM(o.index,Math.min(o.remainder,s))}w(n){if(!(n instanceof m.$TM))throw new Error("Invalid argument");const o=this.x(n.start),s=this.x(n.end);return o===n.start&&s===n.end?n:new m.$TM(o.line,o.character,s.line,s.character)}x(n){if(!(n instanceof m.$SM))throw new Error("Invalid argument");if(this.f.length===0)return n.with(0,0);let{line:o,character:s}=n,r=!1;if(o<0)o=0,s=0,r=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,r=!0;else{const i=this.f[o].length;s<0?(s=0,r=!0):s>i&&(s=i,r=!0)}return r?new m.$SM(o,s):n}y(n,o){const s=this.x(n);if(!o)o=k(this.m);else if((0,R.$ff)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const r=(0,M.$Zs)(s.character+1,(0,M.$Xs)(o),this.f[s.line],0);if(r)return new m.$TM(s.line,r.startColumn-1,s.line,r.endColumn-1)}}e.$dP=u;class w{constructor(n,o,s){this.a=n,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$TM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$TM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$eP=w}),define(Re[249],Ae([1,0,4,7]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(I.$PM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,m,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(M);if(!E)throw new Error("Embedding vector provider not found");const T=await E.provideEmbeddingVector(m,g);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(M,m,g){const E=this.b;return this.b++,this.a.set(E,g),this.c.$registerAiEmbeddingVectorProvider(m,E),new N.$RM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$elc=R}),define(Re[64],Ae([1,0,4,43,7,22,3,16,44,6,11,23,12]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=e.$pkc=void 0;let d=w=class{constructor(o,s){this.b=new Map,this.c=new T.$zh,this.a=o.getProxy(I.$PM.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(i){try{let a;const h=r.b.get(i.scheme);return h?(await r.a.$ensureActivation(i.scheme),a=await h.impl.stat(i)):a=await r.a.$stat(i),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===N.FilePermission.Readonly?1:void 0}}catch(a){w.e(a)}},async readDirectory(i){try{const a=r.b.get(i.scheme);return a?(await r.a.$ensureActivation(i.scheme),(await a.impl.readDirectory(i)).slice()):await r.a.$readdir(i)}catch(a){return w.e(a)}},async createDirectory(i){try{const a=r.b.get(i.scheme);return a&&!a.isReadonly?(await r.a.$ensureActivation(i.scheme),await r.d(a.impl,a.extUri,i)):await r.a.$mkdir(i)}catch(a){return w.e(a)}},async readFile(i){try{const a=r.b.get(i.scheme);return a?(await r.a.$ensureActivation(i.scheme),(await a.impl.readFile(i)).slice()):(await r.a.$readFile(i)).buffer}catch(a){return w.e(a)}},async writeFile(i,a){try{const h=r.b.get(i.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(i.scheme),await r.d(h.impl,h.extUri,h.extUri.dirname(i)),await r.c.queueFor(i,()=>Promise.resolve(h.impl.writeFile(i,a,{create:!0,overwrite:!0})))):await r.a.$writeFile(i,F.$Ce.wrap(a))}catch(h){return w.e(h)}},async delete(i,a){try{const h=r.b.get(i.scheme);return h&&!h.isReadonly&&!a?.useTrash?(await r.a.$ensureActivation(i.scheme),await h.impl.delete(i,{recursive:!1,...a})):await r.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(h){return w.e(h)}},async rename(i,a,h){try{return await r.a.$rename(i,a,{overwrite:!1,...h})}catch(t){return w.e(t)}},async copy(i,a,h){try{return await r.a.$copy(i,a,{overwrite:!1,...h})}catch(t){return w.e(t)}},isWritableFileSystem(i){const a=s.getCapabilities(i);if(typeof a=="number")return!(a&2048)}})}async d(o,s,r){const i=[];for(;!s.isEqual(r,s.dirname(r));)try{if(!((await o.stat(r)).type&N.FileType.Directory))throw R.$8N.FileExists(`Unable to create folder '${r.scheme===u.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(N.$al(a)!==N.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(s.basename(r)),r=s.dirname(r)}for(let a=i.length-1;a>=0;a--){r=s.joinPath(r,i[a]);try{await o.createDirectory(r)}catch(h){if(N.$al(h)!==N.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof R.$8N)throw o;if(o instanceof N.$9k)switch(o.code){case N.FileSystemProviderErrorCode.FileExists:throw R.$8N.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw R.$8N.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw R.$8N.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw R.$8N.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw R.$8N.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw R.$8N.Unavailable(o.message);default:throw new R.$8N(o.message,o.name)}if(!(o instanceof Error))throw new R.$8N(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw R.$8N.Unavailable(o.message);switch(o.name){case N.FileSystemProviderErrorCode.FileExists:throw R.$8N.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw R.$8N.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw R.$8N.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw R.$8N.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw R.$8N.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw R.$8N.Unavailable(o.message);default:throw new R.$8N(o.message,o.name)}}addFileSystemProvider(o,s,r){return this.b.set(o,{impl:s,extUri:r?.isCaseSensitive?k.$Tg:k.$Vg,isReadonly:!!r?.isReadonly}),(0,E.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??k.$Tg}};e.$pkc=d,e.$pkc=d=w=Je([Ve(0,m.$aP),Ve(1,g.$6jc)],d),e.$qkc=(0,M.$qi)("IExtHostConsumerFileSystem")}),define(Re[85],Ae([1,0,3,27,13,64,2]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=e.$rkc=void 0,e.$rkc=(0,I.$qi)("IExtensionStoragePaths");let m=class{constructor(E,T,k){this.d=T,this.f=k,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(E){return M.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,T=await this.g(E);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(M.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(E){if(this.c)return M.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return M.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$skc=m,e.$skc=m=Je([Ve(0,N.$qP),Ve(1,R.$Wj),Ve(2,F.$qkc)],m)}),define(Re[250],Ae([1,0,7,16,5]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlc=void 0;let F=class{constructor(m){this.a=new I.$fO(I.ColorThemeKind.Dark),this.b=new R.$be}get activeColorTheme(){return this.a}$onColorThemeChange(m){let g;switch(m){case"light":g=I.ColorThemeKind.Light;break;case"hcDark":g=I.ColorThemeKind.HighContrast;break;case"hcLight":g=I.ColorThemeKind.HighContrastLight;break;default:g=I.ColorThemeKind.Dark}this.a=new I.$fO(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Zlc=F,e.$Zlc=F=Je([Ve(0,N.$aP)],F)}),define(Re[86],Ae([1,0,24,5,6,174,3,13,204,4,27,16,7]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pCb=e.$oCb=e.TunnelDtoConverter=void 0;class w extends g.$cw{}var d;(function(o){function s(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=s;function r(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==g.TunnelPrivacyId.ConstantPrivate&&i.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=r})(d||(e.TunnelDtoConverter=d={})),e.$oCb=(0,M.$qi)("IExtHostTunnelService");let n=class extends R.$Uc{constructor(s,r,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$be,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(E.$PM.MainThreadTunnelService)}async openTunnel(s,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const i=await this.a.$openTunnel(r,s.displayName);if(i){const a=new w(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,r){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:s,provider:r}),this.a.$registerPortsAttributesProvider(s,i),new u.$RM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(s,r,i,a,h){const t=[];for(const c of s){const $=this.r.get(c);if(!$)return[];t.push(...await Promise.all(r.map(async v=>{let p;try{p=await $.provider.providePortAttributes({port:v,pid:i,commandLine:a},h)}catch{p=await $.provider.providePortAttributes(v,i,a,h)}return{providedAttributes:p,port:v}})))}const b=t.filter(c=>!!c.providedAttributes);return b.length>0?b.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,h)=>await s.provideTunnel(a,h,I.CancellationToken.None)??void 0;const i=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions,protocol:r.tunnelFeatures.protocol===void 0?!0:r.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,R.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,r){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const i=s.tunnelFactory??(r?this.w(r):void 0);if(i){this.b=i;let a=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const h=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,R.$Sc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,r){if(this.g.has(s.host)){const i=this.g.get(s.host);i.has(s.port)&&(r&&i.get(s.port).disposeListener.dispose(),await i.get(s.port).tunnel.dispose(),i.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(s,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const a=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const h=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:a,disposeListener:h}),d.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(s){const r=await Promise.all(s.map(a=>this.f(a.host,a.port,a.detail??""))),i=s.filter((a,h)=>r[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(a=>a.port).join(", ")} to ${i.map(a=>a.port).join(", ")}`),i}};e.$pCb=n,e.$pCb=n=Je([Ve(0,k.$aP),Ve(1,T.$qP),Ve(2,m.$Wj)],n)}),define(Re[8],Ae([1,0,18,22,132,251,54,28,124,53,69,26,127,23,17,2,29,87,100,105,104,214,83,50,61,225,25,7]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s,r,i,a,h,t,b,c,$,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$0O=K,e.$$O=ce,e.$_O=ve;var l;(function(we){function Pe(J){const{selectionStartLineNumber:ke,selectionStartColumn:We,positionLineNumber:Ze,positionColumn:qe}=J,ut=new p.$SM(ke-1,We-1),kt=new p.$SM(Ze-1,qe-1);return new p.$UM(ut,kt)}we.to=Pe;function ae(J){const{anchor:ke,active:We}=J;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}we.from=ae})(l||(e.Selection=l={}));var D;(function(we){function Pe(J){if(!J)return;const{start:ke,end:We}=J;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}we.from=Pe;function ae(J){if(!J)return;const{startLineNumber:ke,startColumn:We,endLineNumber:Ze,endColumn:qe}=J;return new p.$TM(ke-1,We-1,Ze-1,qe-1)}we.to=ae})(D||(e.Range=D={}));var f;(function(we){function Pe(J){return{uri:J.uri,range:D.from(J.range)}}we.from=Pe;function ae(J){return new p.$4M(n.URI.revive(J.uri),D.to(J.range))}we.to=ae})(f||(e.Location=f={}));var S;(function(we){function Pe(ae){switch(ae){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 3:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}we.to=Pe})(S||(e.TokenType=S={}));var y;(function(we){function Pe(J){return new p.$SM(J.lineNumber-1,J.column-1)}we.to=Pe;function ae(J){return{lineNumber:J.line+1,column:J.character+1}}we.from=ae})(y||(e.Position=y={}));var C;(function(we){function Pe(ke,We,Ze){return(0,I.$Hb)((0,I.$3b)(ke).map(qe=>ae(qe,We,Ze)))}we.from=Pe;function ae(ke,We,Ze){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Ze?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:J(ke.scheme,We),pattern:me.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Ze?.isBuiltin}}function J(ke,We){return We&&typeof ke=="string"?We.transformOutgoingScheme(ke):ke}})(C||(e.DocumentSelector=C={}));var P;(function(we){function Pe(J){switch(J){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}we.from=Pe;function ae(J){switch(J){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}we.to=ae})(P||(e.DiagnosticTag=P={}));var V;(function(we){function Pe(J){let ke;return J.code&&((0,d.$4f)(J.code)||(0,d.$8f)(J.code)?ke=String(J.code):ke={value:String(J.code.value),target:J.code.target}),{...D.from(J.range),message:J.message,source:J.source,code:ke,severity:q.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(W.from),tags:Array.isArray(J.tags)?(0,I.$Hb)(J.tags.map(P.from)):void 0}}we.from=Pe;function ae(J){const ke=new p.$6M(D.to(J),J.message,q.to(J.severity));return ke.source=J.source,ke.code=(0,d.$4f)(J.code)?J.code:J.code?.value,ke.relatedInformation=J.relatedInformation&&J.relatedInformation.map(W.to),ke.tags=J.tags&&(0,I.$Hb)(J.tags.map(P.to)),ke}we.to=ae})(V||(e.Diagnostic=V={}));var W;(function(we){function Pe(J){return{...D.from(J.location.range),message:J.message,resource:J.location.uri}}we.from=Pe;function ae(J){return new p.$5M(new p.$4M(J.resource,D.to(J)),J.message)}we.to=ae})(W||(e.DiagnosticRelatedInformation=W={}));var q;(function(we){function Pe(J){switch(J){case p.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}we.from=Pe;function ae(J){switch(J){case r.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}we.to=ae})(q||(e.DiagnosticSeverity=q={}));var A;(function(we){function Pe(J){return typeof J=="number"&&J>=p.ViewColumn.One?J-1:J===p.ViewColumn.Beside?$.$OD:$.$ND}we.from=Pe;function ae(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=ae})(A||(e.ViewColumn=A={}));function j(we){return typeof we.range<"u"}function K(we){return we.length===0?!0:!!j(we[0])}var ie;(function(we){function Pe(qe){return qe.map(we.from)}we.fromMany=Pe;function ae(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function J(qe){let ut;if(ae(qe)){const{language:at,value:Xt}=qe;ut={value:"```"+at+`
`+Xt+"\n```\n"}}else p.$gN.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const kt=Object.create(null);ut.uris=kt;const Ot=at=>{try{let Xt=n.URI.parse(at,!0);Xt=Xt.with({query:ke(Xt.query,kt)}),kt[at]=Xt}catch{}return""},Zt=new g.marked.Renderer;return Zt.link=Ot,Zt.image=at=>typeof at=="string"?Ot(M.$Vk(at).href):"",(0,g.marked)(ut.value,{renderer:Zt}),ut}we.from=J;function ke(qe,ut){if(!qe)return qe;let kt;try{kt=(0,E.$Yh)(qe)}catch{}if(!kt)return qe;let Ot=!1;return kt=(0,k.$Yn)(kt,Zt=>{if(n.URI.isUri(Zt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[at]=Zt,Ot=!0,at}else return}),Ot?JSON.stringify(kt):qe}function We(qe){const ut=new p.$gN(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?n.URI.from(qe.baseUri):void 0,ut}we.to=We;function Ze(qe){if(qe)return typeof qe=="string"?qe:we.from(qe)}we.fromStrict=Ze})(ie||(e.MarkdownString=ie={}));function ce(we){return K(we)?we.map(Pe=>({range:D.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?ie.fromMany(Pe.hoverMessage):Pe.hoverMessage?ie.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):we.map(Pe=>({range:D.from(Pe)}))}function ve(we){return typeof we>"u"?we:typeof we=="string"?n.URI.file(we):we}var Ie;(function(we){function Pe(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?ve(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}we.from=Pe})(Ie||(e.ThemableDecorationAttachmentRenderOptions=Ie={}));var ue;(function(we){function Pe(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ve(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?Ie.from(ae.before):void 0,after:ae.after?Ie.from(ae.after):void 0}}we.from=Pe})(ue||(e.ThemableDecorationRenderOptions=ue={}));var pe;(function(we){function Pe(ae){if(typeof ae>"u")return ae;switch(ae){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Pe})(pe||(e.DecorationRangeBehavior=pe={}));var re;(function(we){function Pe(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?pe.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?ue.from(ae.light):void 0,dark:ae.dark?ue.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ve(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?Ie.from(ae.before):void 0,after:ae.after?Ie.from(ae.after):void 0}}we.from=Pe})(re||(e.DecorationRenderOptions=re={}));var Se;(function(we){function Pe(J){return{text:J.newText,eol:J.newEol&&ft.from(J.newEol),range:D.from(J.range)}}we.from=Pe;function ae(J){const ke=new p.$YM(D.to(J.range),J.text);return ke.newEol=typeof J.eol>"u"?void 0:ft.to(J.eol),ke}we.to=ae})(Se||(e.TextEdit=Se={}));var Le;(function(we){function Pe(J,ke){const We={edits:[]};if(J instanceof p.$2M){const Ze=new m.$Cc;for(const qe of J._allEntries())qe._type===1&&n.URI.isUri(qe.to)&&qe.from===void 0&&Ze.add(qe.to);for(const qe of J._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,N.$We)(N.$Ce.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),We.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?We.edits.push({resource:qe.uri,textEdit:Se.from(qe.edit),versionId:Ze.has(qe.uri)?void 0:ke?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?We.edits.push({resource:qe.uri,textEdit:{range:D.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ze.has(qe.uri)?void 0:ke?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?We.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&We.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:ke?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(qt.from)}})}return We}we.from=Pe;function ae(J){const ke=new p.$2M,We=new m.$Bc;for(const Ze of J.edits)if(Ze.textEdit){const qe=Ze,ut=n.URI.revive(qe.resource),kt=D.to(qe.textEdit.range),Ot=qe.textEdit.text,Zt=qe.textEdit.insertAsSnippet;let at;Zt?at=p.$1M.replace(kt,new p.$3M(Ot)):at=p.$YM.replace(kt,Ot);const Xt=We.get(ut);Xt?Xt.push(at):We.set(ut,[at])}else ke.renameFile(n.URI.revive(Ze.oldResource),n.URI.revive(Ze.newResource),Ze.options);for(const[Ze,qe]of We)ke.set(Ze,qe);return ke}we.to=ae})(Le||(e.WorkspaceEdit=Le={}));var ne;(function(we){const Pe=Object.create(null);Pe[p.SymbolKind.File]=0,Pe[p.SymbolKind.Module]=1,Pe[p.SymbolKind.Namespace]=2,Pe[p.SymbolKind.Package]=3,Pe[p.SymbolKind.Class]=4,Pe[p.SymbolKind.Method]=5,Pe[p.SymbolKind.Property]=6,Pe[p.SymbolKind.Field]=7,Pe[p.SymbolKind.Constructor]=8,Pe[p.SymbolKind.Enum]=9,Pe[p.SymbolKind.Interface]=10,Pe[p.SymbolKind.Function]=11,Pe[p.SymbolKind.Variable]=12,Pe[p.SymbolKind.Constant]=13,Pe[p.SymbolKind.String]=14,Pe[p.SymbolKind.Number]=15,Pe[p.SymbolKind.Boolean]=16,Pe[p.SymbolKind.Array]=17,Pe[p.SymbolKind.Object]=18,Pe[p.SymbolKind.Key]=19,Pe[p.SymbolKind.Null]=20,Pe[p.SymbolKind.EnumMember]=21,Pe[p.SymbolKind.Struct]=22,Pe[p.SymbolKind.Event]=23,Pe[p.SymbolKind.Operator]=24,Pe[p.SymbolKind.TypeParameter]=25;function ae(ke){return typeof Pe[ke]=="number"?Pe[ke]:6}we.from=ae;function J(ke){for(const We in Pe)if(Pe[We]===ke)return Number(We);return p.SymbolKind.Property}we.to=J})(ne||(e.SymbolKind=ne={}));var U;(function(we){function Pe(J){switch(J){case p.SymbolTag.Deprecated:return 1}}we.from=Pe;function ae(J){switch(J){case 1:return p.SymbolTag.Deprecated}}we.to=ae})(U||(e.SymbolTag=U={}));var x;(function(we){function Pe(J){return{name:J.name,kind:ne.from(J.kind),tags:J.tags&&J.tags.map(U.from),containerName:J.containerName,location:fe.from(J.location)}}we.from=Pe;function ae(J){const ke=new p.$0M(J.name,ne.to(J.kind),J.containerName,fe.to(J.location));return ke.tags=J.tags&&J.tags.map(U.to),ke}we.to=ae})(x||(e.WorkspaceSymbol=x={}));var be;(function(we){function Pe(J){const ke={name:J.name||"!!MISSING: name!!",detail:J.detail,range:D.from(J.range),selectionRange:D.from(J.selectionRange),kind:ne.from(J.kind),tags:J.tags?.map(U.from)??[]};return J.children&&(ke.children=J.children.map(Pe)),ke}we.from=Pe;function ae(J){const ke=new p.$$M(J.name,J.detail,ne.to(J.kind),D.to(J.range),D.to(J.selectionRange));return(0,I.$Lb)(J.tags)&&(ke.tags=J.tags.map(U.to)),J.children&&(ke.children=J.children.map(ae)),ke}we.to=ae})(be||(e.DocumentSymbol=be={}));var Ne;(function(we){function Pe(J){const ke=new p.$cN(ne.to(J.kind),J.name,J.detail||"",n.URI.revive(J.uri),D.to(J.range),D.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}we.to=Pe;function ae(J,ke,We){if(ke=ke??J._sessionId,We=We??J._itemId,ke===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:We,name:J.name,detail:J.detail,kind:ne.from(J.kind),uri:J.uri,range:D.from(J.range),selectionRange:D.from(J.selectionRange),tags:J.tags?.map(U.from)}}we.from=ae})(Ne||(e.CallHierarchyItem=Ne={}));var Ee;(function(we){function Pe(ae){return new p.$dN(Ne.to(ae.from),ae.fromRanges.map(J=>D.to(J)))}we.to=Pe})(Ee||(e.CallHierarchyIncomingCall=Ee={}));var $e;(function(we){function Pe(ae){return new p.$eN(Ne.to(ae.to),ae.fromRanges.map(J=>D.to(J)))}we.to=Pe})($e||(e.CallHierarchyOutgoingCall=$e={}));var fe;(function(we){function Pe(J){return{range:J.range&&D.from(J.range),uri:J.uri}}we.from=Pe;function ae(J){return new p.$4M(n.URI.revive(J.uri),D.to(J.range))}we.to=ae})(fe||(e.location=fe={}));var Q;(function(we){function Pe(J){const ke=J,We=J;return{originSelectionRange:ke.originSelectionRange?D.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:We.uri,range:D.from(ke.targetRange?ke.targetRange:We.range),targetSelectionRange:ke.targetSelectionRange?D.from(ke.targetSelectionRange):void 0}}we.from=Pe;function ae(J){return{targetUri:n.URI.revive(J.uri),targetRange:D.to(J.range),targetSelectionRange:J.targetSelectionRange?D.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?D.to(J.originSelectionRange):void 0}}we.to=ae})(Q||(e.DefinitionLink=Q={}));var Y;(function(we){function Pe(J){return{range:D.from(J.range),contents:ie.fromMany(J.contents)}}we.from=Pe;function ae(J){return new p.$7M(J.contents.map(ie.to),D.to(J.range))}we.to=ae})(Y||(e.Hover=Y={}));var le;(function(we){function Pe(J){return{range:D.from(J.range),expression:J.expression}}we.from=Pe;function ae(J){return new p.$2N(D.to(J.range),J.expression)}we.to=ae})(le||(e.EvaluatableExpression=le={}));var de;(function(we){function Pe(J){if(J instanceof p.$3N)return{type:"text",range:D.from(J.range),text:J.text};if(J instanceof p.$4N)return{type:"variable",range:D.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof p.$5N)return{type:"expression",range:D.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Pe;function ae(J){switch(J.type){case"text":return{range:D.to(J.range),text:J.text};case"variable":return{range:D.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:D.to(J.range),expression:J.expression}}}we.to=ae})(de||(e.InlineValue=de={}));var Te;(function(we){function Pe(J){return{frameId:J.frameId,stoppedLocation:D.from(J.stoppedLocation)}}we.from=Pe;function ae(J){return new p.$6N(J.frameId,D.to(J.stoppedLocation))}we.to=ae})(Te||(e.InlineValueContext=Te={}));var he;(function(we){function Pe(J){return{range:D.from(J.range),kind:J.kind}}we.from=Pe;function ae(J){return new p.$8M(D.to(J.range),J.kind)}we.to=ae})(he||(e.DocumentHighlight=he={}));var Ce;(function(we){function Pe(J){return{uri:J.uri,highlights:J.highlights.map(he.from)}}we.from=Pe;function ae(J){return new p.$9M(n.URI.revive(J.uri),J.highlights.map(he.to))}we.to=ae})(Ce||(e.MultiDocumentHighlight=Ce={}));var Me;(function(we){function Pe(ae){switch(ae){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}we.to=Pe})(Me||(e.CompletionTriggerKind=Me={}));var ze;(function(we){function Pe(ae){return{triggerKind:Me.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}we.to=Pe})(ze||(e.CompletionContext=ze={}));var z;(function(we){function Pe(J){switch(J){case p.CompletionItemTag.Deprecated:return 1}}we.from=Pe;function ae(J){switch(J){case 1:return p.CompletionItemTag.Deprecated}}we.to=ae})(z||(e.CompletionItemTag=z={}));var L;(function(we){const Pe=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function ae(We){return Pe.get(We)??9}we.from=ae;const J=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function ke(We){return J.get(We)??p.CompletionItemKind.Property}we.to=ke})(L||(e.CompletionItemKind=L={}));var G;(function(we){function Pe(ae,J){const ke=new p.$mN(ae.label);return ke.insertText=ae.insertText,ke.kind=L.to(ae.kind),ke.tags=ae.tags?.map(z.to),ke.detail=ae.detail,ke.documentation=M.$Pk(ae.documentation)?ie.to(ae.documentation):ae.documentation,ke.sortText=ae.sortText,ke.filterText=ae.filterText,ke.preselect=ae.preselect,ke.commitCharacters=ae.commitCharacters,o.$kt.isIRange(ae.range)?ke.range=D.to(ae.range):typeof ae.range=="object"&&(ke.range={inserting:D.to(ae.range.insert),replacing:D.to(ae.range.replace)}),ke.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?ke.insertText=new p.$3M(ae.insertText):(ke.insertText=ae.insertText,ke.textEdit=ke.range instanceof p.$TM?new p.$YM(ke.range,ke.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(ke.additionalTextEdits=ae.additionalTextEdits.map(We=>Se.to(We))),ke.command=J&&ae.command?J.fromInternal(ae.command):void 0,ke}we.to=Pe})(G||(e.CompletionItem=G={}));var H;(function(we){function Pe(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:ie.fromStrict(J.documentation)}}we.from=Pe;function ae(J){return{label:J.label,documentation:M.$Pk(J.documentation)?ie.to(J.documentation):J.documentation}}we.to=ae})(H||(e.ParameterInformation=H={}));var ee;(function(we){function Pe(J){return{label:J.label,documentation:ie.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(H.from):[],activeParameter:J.activeParameter}}we.from=Pe;function ae(J){return{label:J.label,documentation:M.$Pk(J.documentation)?ie.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(H.to):[],activeParameter:J.activeParameter}}we.to=ae})(ee||(e.SignatureInformation=ee={}));var se;(function(we){function Pe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.from):[]}}we.from=Pe;function ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ee.to):[]}}we.to=ae})(se||(e.SignatureHelp=se={}));var Fe;(function(we){function Pe(ae,J){const ke=new p.$lN(y.to(J.position),typeof J.label=="string"?J.label:J.label.map(Be.to.bind(void 0,ae)),J.kind&&Qe.to(J.kind));return ke.textEdits=J.textEdits&&J.textEdits.map(Se.to),ke.tooltip=M.$Pk(J.tooltip)?ie.to(J.tooltip):J.tooltip,ke.paddingLeft=J.paddingLeft,ke.paddingRight=J.paddingRight,ke}we.to=Pe})(Fe||(e.InlayHint=Fe={}));var Be;(function(we){function Pe(ae,J){const ke=new p.$kN(J.label);return ke.tooltip=M.$Pk(J.tooltip)?ie.to(J.tooltip):J.tooltip,s.Command.is(J.command)&&(ke.command=ae.fromInternal(J.command)),J.location&&(ke.location=fe.to(J.location)),ke}we.to=Pe})(Be||(e.InlayHintLabelPart=Be={}));var Qe;(function(we){function Pe(J){return J}we.from=Pe;function ae(J){return J}we.to=ae})(Qe||(e.InlayHintKind=Qe={}));var xe;(function(we){function Pe(J){return{range:D.from(J.range),url:J.target,tooltip:J.tooltip}}we.from=Pe;function ae(J){let ke;if(J.url)try{ke=typeof J.url=="string"?n.URI.parse(J.url,!0):n.URI.revive(J.url)}catch{}return new p.$rN(D.to(J.range),ke)}we.to=ae})(xe||(e.DocumentLink=xe={}));var _e;(function(we){function Pe(J){const ke=new p.$uN(J.label);return J.textEdit&&(ke.textEdit=Se.to(J.textEdit)),J.additionalTextEdits&&(ke.additionalTextEdits=J.additionalTextEdits.map(We=>Se.to(We))),ke}we.to=Pe;function ae(J){return{label:J.label,textEdit:J.textEdit?Se.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ke=>Se.from(ke)):void 0}}we.from=ae})(_e||(e.ColorPresentation=_e={}));var et;(function(we){function Pe(J){return new p.$sN(J[0],J[1],J[2],J[3])}we.to=Pe;function ae(J){return[J.red,J.green,J.blue,J.alpha]}we.from=ae})(et||(e.Color=et={}));var tt;(function(we){function Pe(J){return{range:D.from(J.range)}}we.from=Pe;function ae(J){return new p.$bN(D.to(J.range))}we.to=ae})(tt||(e.SelectionRange=tt={}));var nt;(function(we){function Pe(ae){switch(ae){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}we.to=Pe})(nt||(e.TextDocumentSaveReason=nt={}));var ct;(function(we){function Pe(J){switch(J){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.Interval:return 3;case p.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Pe;function ae(J){switch(J){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 3:return p.TextEditorLineNumbersStyle.Interval;case 1:default:return p.TextEditorLineNumbersStyle.On}}we.to=ae})(ct||(e.TextEditorLineNumbersStyle=ct={}));var ft;(function(we){function Pe(J){if(J===p.EndOfLine.CRLF)return 1;if(J===p.EndOfLine.LF)return 0}we.from=Pe;function ae(J){if(J===1)return p.EndOfLine.CRLF;if(J===0)return p.EndOfLine.LF}we.to=ae})(ft||(e.EndOfLine=ft={}));var je;(function(we){function Pe(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Pe})(je||(e.ProgressLocation=je={}));var st;(function(we){function Pe(J){const ke={start:J.start+1,end:J.end+1};return J.kind&&(ke.kind=X.from(J.kind)),ke}we.from=Pe;function ae(J){const ke={start:J.start-1,end:J.end-1};return J.kind&&(ke.kind=X.to(J.kind)),ke}we.to=ae})(st||(e.FoldingRange=st={}));var X;(function(we){function Pe(J){if(J)switch(J){case p.FoldingRangeKind.Comment:return s.$6t.Comment;case p.FoldingRangeKind.Imports:return s.$6t.Imports;case p.FoldingRangeKind.Region:return s.$6t.Region}}we.from=Pe;function ae(J){if(J)switch(J.value){case s.$6t.Comment.value:return p.FoldingRangeKind.Comment;case s.$6t.Imports.value:return p.FoldingRangeKind.Imports;case s.$6t.Region.value:return p.FoldingRangeKind.Region}}we.to=ae})(X||(e.FoldingRangeKind=X={}));var Z;(function(we){function Pe(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?D.from(ae.selection):void 0,override:typeof ae.override=="boolean"?a.$eF.id:void 0}}we.from=Pe})(Z||(e.TextEditorOpenOptions=Z={}));var me;(function(we){function Pe(We){return We instanceof p.$PN?We.toJSON():typeof We=="string"?We:ae(We)||J(We)?new p.$PN(We.baseUri??We.base,We.pattern).toJSON():We}we.from=Pe;function ae(We){const Ze=We;return Ze?n.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function J(We){const Ze=We;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function ke(We){return typeof We=="string"?We:new p.$PN(n.URI.revive(We.baseUri),We.pattern)}we.to=ke})(me||(e.GlobPattern=me={}));var He;(function(we){function Pe(ae){if(ae){if(Array.isArray(ae))return ae.map(Pe);if(typeof ae=="string")return ae;{const J=ae;return{language:J.language,scheme:J.scheme,pattern:me.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}we.from=Pe})(He||(e.LanguageSelector=He={}));var ye;(function(we){function Pe(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(ke=>Array.isArray(ke)&&ke.every(We=>We&&typeof We=="object"&&"uri"in We&&n.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ze=>Ze instanceof p.$TM)))}we.is=Pe;function ae(J){return{documents:J.documents.map(ke=>ke.map(We=>({uri:n.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ze=>D.from(Ze))})))}}we.from=ae})(ye||(e.MappedEditsContext=ye={}));var ot;(function(we){function Pe(J){return{start:J.start,end:J.end}}we.from=Pe;function ae(J){return new p.$gO(J.start,J.end)}we.to=ae})(ot||(e.NotebookRange=ot={}));var dt;(function(we){function Pe(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}we.to=Pe;function ae(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}we.from=ae})(dt||(e.NotebookCellExecutionSummary=dt={}));var Pt;(function(we){function Pe(ae){if(ae===t.NotebookCellExecutionState.Unconfirmed)return p.NotebookCellExecutionState.Pending;if(ae===t.NotebookCellExecutionState.Pending)return;if(ae===t.NotebookCellExecutionState.Executing)return p.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}we.to=Pe})(Pt||(e.NotebookCellExecutionState=Pt={}));var Bt;(function(we){function Pe(J){switch(J){case p.NotebookCellKind.Markup:return t.CellKind.Markup;case p.NotebookCellKind.Code:default:return t.CellKind.Code}}we.from=Pe;function ae(J){switch(J){case t.CellKind.Markup:return p.NotebookCellKind.Markup;case t.CellKind.Code:default:return p.NotebookCellKind.Code}}we.to=ae})(Bt||(e.NotebookCellKind=Bt={}));var Yt;(function(we){function Pe(J){const ke={metadata:J.metadata??Object.create(null),cells:[]};for(const We of J.cells)p.$hO.validate(We),ke.cells.push(qt.from(We));return ke}we.from=Pe;function ae(J){const ke=new p.$iO(J.cells.map(qt.to));return(0,d.$eg)(J.metadata)||(ke.metadata=J.metadata),ke}we.to=ae})(Yt||(e.NotebookData=Yt={}));var qt;(function(we){function Pe(J){return{cellKind:Bt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Et.from):[]}}we.from=Pe;function ae(J){return new p.$hO(Bt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Et.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}we.to=ae})(qt||(e.NotebookCellData=qt={}));var xt;(function(we){function Pe(J){return{mime:J.mime,valueBytes:N.$Ce.wrap(J.data)}}we.from=Pe;function ae(J){return new p.$jO(J.valueBytes.buffer,J.mime)}we.to=ae})(xt||(e.NotebookCellOutputItem=xt={}));var Et;(function(we){function Pe(J){return{outputId:J.id,items:J.items.map(xt.from),metadata:J.metadata}}we.from=Pe;function ae(J){const ke=J.items.map(xt.to);return new p.$kO(ke,J.outputId,J.metadata)}we.to=ae})(Et||(e.NotebookCellOutput=Et={}));var Wt;(function(we){function Pe(ke){return J(ke)?{include:me.from(ke.include)??void 0,exclude:me.from(ke.exclude)??void 0}:me.from(ke)??void 0}we.from=Pe;function ae(ke){return J(ke)?{include:me.to(ke.include),exclude:me.to(ke.exclude)}:me.to(ke)}we.to=ae;function J(ke){const We=ke;return We?!(0,d.$ag)(We.include)&&!(0,d.$ag)(We.exclude):!1}})(Wt||(e.NotebookExclusiveDocumentPattern=Wt={}));var Ht;(function(we){function Pe(ae,J,ke){const We=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(We,ke),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}we.from=Pe})(Ht||(e.NotebookStatusBarItem=Ht={}));var Xe;(function(we){function Pe(ae,J,ke){const We=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:J.toInternal(We,ke),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}we.from=Pe})(Xe||(e.NotebookKernelSourceAction=Xe={}));var ri;(function(we){function Pe(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}we.from=Pe})(ri||(e.NotebookDocumentContentOptions=ri={}));var _t;(function(we){function Pe(J){return{uri:J.uri,provides:J.provides}}we.from=Pe;function ae(J){return new p.$mO(n.URI.revive(J.uri),J.provides)}we.to=ae})(_t||(e.NotebookRendererScript=_t={}));var ht;(function(we){function Pe(J){return{message:ie.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:D.from(J.location.range),uri:J.location.uri}}}we.from=Pe;function ae(J){const ke=new p.$sO(typeof J.message=="string"?J.message:ie.to(J.message));return ke.actualOutput=J.actual,ke.expectedOutput=J.expected,ke.contextValue=J.contextValue,ke.location=J.location?fe.to(J.location):void 0,ke}we.to=ae})(ht||(e.TestMessage=ht={}));var $t;(function(we){we.namespace=c.$GL,we.denamespace=c.$HL})($t||(e.TestTag=$t={}));var ei;(function(we){function Pe(J){const ke=(0,i.$9O)(J).controllerId;return{extId:b.$BL.fromExtHostTestItem(J,ke).toString(),label:J.label,uri:n.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(We=>$t.namespace(ke,We.id)),range:o.$kt.lift(D.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&ie.fromStrict(J.error)||null}}we.from=Pe;function ae(J){return{parent:void 0,error:void 0,id:b.$BL.fromString(J.extId).localId,label:J.label,uri:n.URI.revive(J.uri),tags:(J.tags||[]).map(ke=>{const{tagId:We}=$t.denamespace(ke);return new p.$tO(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}we.toPlain=ae})(ei||(e.TestItem=ei={})),function(we){function Pe(J){return{id:J.id}}we.from=Pe;function ae(J){return new p.$tO(J.id)}we.to=ae}($t||(e.TestTag=$t={}));var ti;(function(we){const Pe=(J,ke)=>{const We=J.value;if(!We)return;const Ze={...ei.toPlain(We.item),parent:ke,taskStates:We.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(ht.to)})),children:[]};if(J.children)for(const qe of J.children.values()){const ut=Pe(qe,Ze);ut&&Ze.children.push(ut)}return Ze};function ae(J){const ke=new u.$2O;for(const qe of J.items)ke.insert(b.$BL.fromString(qe.item.extId).path,qe);const We=[ke.nodes],Ze=[];for(;We.length;)for(const qe of We.pop())qe.value?Ze.push(qe):qe.children&&We.push(qe.children.values());return{completedAt:J.completedAt,results:Ze.map(qe=>Pe(qe)).filter(d.$_f)}}we.to=ae})(ti||(e.TestResults=ti={}));var Lt;(function(we){function Pe(We){return{covered:We.covered,total:We.total}}function ae(We){return"line"in We?y.from(We):D.from(We)}function J(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:ae(We.location),type:1,branches:We.branches.length?We.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&ae(Ze.location),label:Ze.label})):void 0}:{type:0,name:We.name,count:We.executed,location:ae(We.location)}}we.fromDetails=J;function ke(We,Ze){return p.$vO(Ze.statementCoverage),p.$vO(Ze.branchCoverage),p.$vO(Ze.declarationCoverage),{id:We,uri:Ze.uri,statement:Pe(Ze.statementCoverage),branch:Ze.branchCoverage&&Pe(Ze.branchCoverage),declaration:Ze.declarationCoverage&&Pe(Ze.declarationCoverage)}}we.fromFile=ke})(Lt||(e.TestCoverage=Lt={}));var gt;(function(we){function Pe(ae){switch(ae){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}we.to=Pe})(gt||(e.CodeActionTriggerKind=gt={}));var zt;(function(we){function Pe(J){const ke=new p.$AO(ne.to(J.kind),J.name,J.detail||"",n.URI.revive(J.uri),D.to(J.range),D.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}we.to=Pe;function ae(J,ke,We){if(ke=ke??J._sessionId,We=We??J._itemId,ke===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:We,kind:ne.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:D.from(J.range),selectionRange:D.from(J.selectionRange),tags:J.tags?.map(U.from)}}we.from=ae})(zt||(e.TypeHierarchyItem=zt={}));var ii;(function(we){function Pe(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}we.from=Pe})(ii||(e.ViewBadge=ii={}));var Tt;(function(we){function Pe(We,Ze,qe){const ut=Ze.fileData;return ut?new p.$HN(new p.$IN(ut.name,n.URI.revive(ut.uri),ut.id,(0,F.$db)(()=>qe(ut.id)))):We===T.$Hs.uriList&&Ze.uriListData?new p.$GN(ke(Ze.uriListData)):new p.$GN(Ze.asString)}we.to=Pe;async function ae(We,Ze){const qe=await Ze.asString();if(We===T.$Hs.uriList)return{asString:qe,fileData:void 0,uriListData:J(qe)};const ut=Ze.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}we.from=ae;function J(We){return R.$Kt.split(We).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return n.URI.parse(Ze)}catch{}return Ze})}function ke(We){return R.$Kt.create(We.map(Ze=>typeof Ze=="string"?Ze:n.URI.revive(Ze)))}})(Tt||(e.DataTransferItem=Tt={}));var Ke;(function(we){function Pe(J,ke){const We=J.items.map(([Ze,qe])=>[Ze,Tt.to(Ze,qe,ke)]);return new p.$JN(We)}we.toDataTransfer=Pe;async function ae(J){const ke={items:[]},We=[];for(const[Ze,qe]of J)We.push((async()=>{ke.items.push([Ze,await Tt.from(Ze,qe)])})());return await Promise.all(We),ke}we.from=ae})(Ke||(e.DataTransfer=Ke={}));var si;(function(we){function Pe(J,ke){return{kind:"reply",agentId:J.participant??ke?.agentId??"",subCommand:J.command??ke?.command,message:J.prompt,title:J.label}}we.from=Pe;function ae(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}we.to=ae})(si||(e.ChatFollowup=si={}));var Gt;(function(we){function Pe(ae){return"commandId"in ae?{kind:"command",title:ae.title??"",commandId:ae.commandId??"",when:ae.when??"",args:ae.args}:{kind:"reply",message:ae.message,title:ae.title,tooltip:ae.tooltip}}we.from=Pe})(Gt||(e.ChatInlineFollowup=Gt={}));var Ut;(function(we){function Pe(J){switch(J.role){case 0:return new p.$WO(J.content);case 1:return new p.$XO(J.content);case 2:return new p.$YO(J.content)}}we.to=Pe;function ae(J){if(J instanceof p.$WO)return{role:0,content:J.content};if(J instanceof p.$XO)return{role:1,content:J.content};if(J instanceof p.$YO)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}we.from=ae})(Ut||(e.LanguageModelMessage=Ut={}));var mt;(function(we){function Pe(ke){const We={};for(const Ze of Object.keys(ke))We[Ze]=ke[Ze].map(we.to);return We}we.objectTo=Pe;function ae(ke){return{level:Ft.to(ke.level),kind:ke.kind,value:(0,n.$wc)(ke.value)?n.URI.revive(ke.value):ke.value,description:ke.description}}we.to=ae;function J(ke){return{level:Ft.from(ke.level),kind:ke.kind,value:ke.value,description:ke.description}}we.from=J})(mt||(e.ChatVariable=mt={}));var Ft;(function(we){function Pe(J){switch(J){case"short":return p.ChatVariableLevel.Short;case"medium":return p.ChatVariableLevel.Medium;case"full":default:return p.ChatVariableLevel.Full}}we.to=Pe;function ae(J){switch(J){case p.ChatVariableLevel.Short:return"short";case p.ChatVariableLevel.Medium:return"medium";case p.ChatVariableLevel.Full:default:return"full"}}we.from=ae})(Ft||(e.ChatVariableLevel=Ft={}));var Mt;(function(we){function Pe(ae){switch(ae){case 1:return p.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return p.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return p.InteractiveEditorResponseFeedbackKind.Undone;case 3:return p.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return p.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Pe})(Mt||(e.InteractiveEditorResponseFeedbackKind=Mt={}));var jt;(function(we){function Pe(J){return{kind:"markdownContent",content:ie.from(J.value)}}we.from=Pe;function ae(J){return new p.$NO(ie.to(J.content))}we.to=ae})(jt||(e.ChatResponseMarkdownPart=jt={}));var Kt;(function(we){function Pe(J){const{value:ke,baseUri:We}=J;function Ze(qe,ut){return qe.map(kt=>{const Ot=n.URI.joinPath(ut,kt.name);return{label:kt.name,uri:Ot,children:kt.children&&Ze(kt.children,Ot)}})}return{kind:"treeData",treeData:{label:(0,w.$1g)(We),uri:We,children:Ze(ke,We)}}}we.from=Pe;function ae(J){const ke=(0,E.$Zh)(J.treeData);function We(ut){return ut.map(kt=>({name:kt.label,children:kt.children&&We(kt.children)}))}const Ze=ke.uri,qe=ke.children?We(ke.children):[];return new p.$OO(qe,Ze)}we.to=ae})(Kt||(e.ChatResponseFilesPart=Kt={}));var Jt;(function(we){function Pe(J){return{kind:"inlineReference",name:J.title,inlineReference:n.URI.isUri(J.value)?J.value:f.from(J.value)}}we.from=Pe;function ae(J){const ke=(0,E.$Zh)(J);return new p.$PO(n.URI.isUri(ke.inlineReference)?ke.inlineReference:f.to(ke.inlineReference),J.name)}we.to=ae})(Jt||(e.ChatResponseAnchorPart=Jt={}));var oi;(function(we){function Pe(J){return{kind:"progressMessage",content:ie.from(J.value)}}we.from=Pe;function ae(J){return new p.$QO(J.content.value)}we.to=ae})(oi||(e.ChatResponseProgressPart=oi={}));var Ct;(function(we){function Pe(J,ke,We){return{kind:"command",command:ke.toInternal(J.value,We)??{command:J.value.command,title:J.value.title}}}we.from=Pe;function ae(J,ke){return new p.$RO(ke.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}we.to=ae})(Ct||(e.ChatResponseCommandButtonPart=Ct={}));var Nt;(function(we){function Pe(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(ke=>Se.from(ke))}}we.from=Pe;function ae(J){return new p.$TO(n.URI.revive(J.uri),J.edits.map(ke=>Se.to(ke)))}we.to=ae})(Nt||(e.ChatResponseTextEditPart=Nt={}));var It;(function(we){function Pe(J){return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:n.URI.isUri(J.value.value)||!J.value.value?J.value.value:f.from(J.value.value)}}:{kind:"reference",reference:n.URI.isUri(J.value)?J.value:f.from(J.value)}}we.from=Pe;function ae(J){const ke=(0,E.$Zh)(J),We=Ze=>n.URI.isUri(Ze)?Ze:f.to(Ze);return new p.$SO("variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&We(ke.reference.value)}:We(ke.reference))}we.to=ae})(It||(e.ChatResponseReferencePart=It={}));var Dt;(function(we){function Pe(ke,We,Ze){return ke instanceof p.$NO?jt.from(ke):ke instanceof p.$PO?Jt.from(ke):ke instanceof p.$SO?It.from(ke):ke instanceof p.$QO?oi.from(ke):ke instanceof p.$OO?Kt.from(ke):ke instanceof p.$RO?Ct.from(ke,We,Ze):ke instanceof p.$TO?Nt.from(ke):{kind:"content",content:""}}we.from=Pe;function ae(ke,We){switch(ke.kind){case"reference":return It.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(ke,We)}}we.to=ae;function J(ke,We){switch(ke.kind){case"markdownContent":return jt.to(ke);case"inlineReference":return Jt.to(ke);case"progressMessage":return;case"treeData":return Kt.to(ke);case"command":return Ct.to(ke,We)}}we.toContent=J})(Dt||(e.ChatResponsePart=Dt={}));var bt;(function(we){function Pe(J,ke){return"markdownContent"in ke?((0,v.$yG)(J,"chatParticipantAdditions"),{content:ie.from(ke.markdownContent),kind:"markdownContent"}):"content"in ke?"vulnerabilities"in ke&&ke.vulnerabilities?((0,v.$yG)(J,"chatParticipantAdditions"),{content:ke.content,vulnerabilities:ke.vulnerabilities,kind:"vulnerability"}):typeof ke.content=="string"?{content:ke.content,kind:"content"}:((0,v.$yG)(J,"chatParticipantAdditions"),{content:ie.from(ke.content),kind:"markdownContent"}):"documents"in ke?{documents:ke.documents.map(We=>({uri:We.uri,version:We.version,ranges:We.ranges.map(Ze=>D.from(Ze))})),kind:"usedContext"}:"reference"in ke?{reference:"uri"in ke.reference?{uri:ke.reference.uri,range:D.from(ke.reference.range)}:ke.reference,kind:"reference"}:"inlineReference"in ke?{inlineReference:"uri"in ke.inlineReference?{uri:ke.inlineReference.uri,range:D.from(ke.inlineReference.range)}:ke.inlineReference,name:ke.title,kind:"inlineReference"}:"participant"in ke?((0,v.$yG)(J,"chatParticipantAdditions"),{agentId:ke.participant,command:ke.command,kind:"agentDetection"}):"message"in ke?{content:ie.from(ke.message),kind:"progressMessage"}:void 0}we.from=Pe;function ae(J,ke){switch(J.kind){case"markdownContent":return{content:J.content.value};case"inlineReference":return{inlineReference:(0,n.$wc)(J.inlineReference)?n.URI.revive(J.inlineReference):f.to(J.inlineReference),title:J.name};case"command":return{command:ke.fromInternal(J.command)??{command:J.command.id,title:J.command.title}};default:return}}we.toProgressContent=ae})(bt||(e.ChatResponseProgress=bt={}));var St;(function(we){function Pe(ae){return{prompt:ae.message,command:ae.command,attempt:ae.attempt??0,enableCommandDetection:ae.enableCommandDetection??!0,variables:ae.variables.variables.map(yt.to),location:li.to(ae.location)}}we.to=Pe})(St||(e.ChatAgentRequest=St={}));var li;(function(we){function Pe(ae){switch(ae){case h.ChatAgentLocation.Notebook:return p.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return p.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return p.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return p.ChatLocation.Editor}}we.to=Pe})(li||(e.ChatLocation=li={}));var yt;(function(we){function Pe(ae){return{name:ae.name,range:ae.range&&[ae.range.start,ae.range.endExclusive],values:ae.values.map(mt.to)}}we.to=Pe})(yt||(e.ChatAgentResolvedVariable=yt={}));var hi;(function(we){function Pe(ae){return{label:ae.label,values:ae.values.map(mt.from),insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation}}we.from=Pe})(hi||(e.ChatAgentCompletionItem=hi={}));var Qt;(function(we){function Pe(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}we.to=Pe})(Qt||(e.ChatAgentResult=Qt={}));var ai;(function(we){function Pe(ae,J,ke){if(J.action.kind==="vote")return;const We=Qt.to(ae);return J.action.kind==="command"?{action:{kind:"command",commandButton:bt.toProgressContent(J.action.commandButton,ke)},result:We}:J.action.kind==="followUp"?{action:{kind:"followUp",followup:si.to(J.action.followup)},result:We}:{action:J.action,result:We}}we.to=Pe})(ai||(e.ChatAgentUserActionEvent=ai={}));var pi;(function(we){function Pe(ae,J,ke){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:J.toInternal(ae,ke)}we.from=Pe})(pi||(e.TerminalQuickFix=pi={}));var ni;(function(we){function Pe(ae){return{kind:Rt.to(ae.kind)}}we.to=Pe})(ni||(e.PartialAcceptInfo=ni={}));var Rt;(function(we){function Pe(ae){switch(ae){case 0:return p.PartialAcceptTriggerKind.Word;case 1:return p.PartialAcceptTriggerKind.Line;case 2:return p.PartialAcceptTriggerKind.Suggest;default:return p.PartialAcceptTriggerKind.Unknown}}we.to=Pe})(Rt||(e.PartialAcceptTriggerKind=Rt={}));var yi;(function(we){function Pe(ae,J){return{id:J,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}we.from=Pe})(yi||(e.DebugTreeItem=yi={}))}),define(Re[252],Ae([1,0,4,16,8,34]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bkc=void 0;let M=class{constructor(g,E){this.a=g.getProxy(I.$PM.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>E.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,E,T){const k=new F.$mw(R.WorkspaceEdit.from(g,this.b));return this.a.$tryApplyWorkspaceEdit(k,void 0,T?.isRefactoring??!1)}};e.$bkc=M,e.$bkc=M=Je([Ve(0,N.$aP)],M)}),define(Re[253],Ae([1,0,18,11,42,5,46,6,65,17,2,163,20,4,8,7,215,25]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=void 0;class r{constructor(t,b,c,$,v,p){this.i=t,this.j=b,this.k=c,this.l=$,this.m=v,this.n=p,this.b=g.$0d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let b=function($){if(t.c){const v=new Error("Response stream has been closed");throw Error.captureStackTrace(v,$),v}};const t=this;this.b.reset();const c=$=>{typeof this.d>"u"&&"content"in $&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,$)};this.g={markdown($){b(this.markdown);const v=new n.$NO($),p=d.ChatResponseMarkdownPart.from(v);return c(p),this},filetree($,v){b(this.filetree);const p=new n.$OO($,v),l=d.ChatResponseFilesPart.from(p);return c(l),this},anchor($,v){b(this.anchor);const p=new n.$PO($,v),l=d.ChatResponseAnchorPart.from(p);return c(l),this},button($){b(this.anchor);const v=new n.$RO($),p=d.ChatResponseCommandButtonPart.from(v,t.m,t.n);return c(p),this},progress($){b(this.progress);const v=new n.$QO($),p=d.ChatResponseProgressPart.from(v);return c(p),this},reference($){if(b(this.reference),"variableName"in $&&!$.value){const v=t.j.variables.variables.find(p=>p.name===$.variableName);if(v){let p;if(v.references?.length)p=v.references.map(l=>({kind:"reference",reference:{variableName:$.variableName,value:l.reference}}));else{const l=new n.$SO($);p=[d.ChatResponseReferencePart.from(l)]}return p.forEach(l=>c(l)),this}}else{const v=new n.$SO($),p=d.ChatResponseReferencePart.from(v);c(p)}return this},textEdit($,v){b(this.textEdit),(0,s.$yG)(t.i,"chatParticipantAdditions");const p=new n.$TO($,v),l=d.ChatResponseTextEditPart.from(p);return c(l),this},push($){if(b(this.push),$ instanceof n.$TO&&(0,s.$yG)(t.i,"chatParticipantAdditions"),$ instanceof n.$SO)this.reference($.value);else{const v=d.ChatResponsePart.from($,t.m,t.n);c(v)}return this},report($){if(b(this.report),"placeholder"in $&&"resolvedContent"in $)return;const v=d.ChatResponseProgress.from(t.i,$);if(!v){t.l.error("Unknown progress type: "+JSON.stringify($));return}return c(v),this}}}return this.g}}class i{static{this.b=0}constructor(t,b,c){this.i=b,this.j=c,this.c=new Map,this.g=new m.$4c,this.d=t.getProxy(w.$PM.MainThreadChatAgents2)}transferActiveChat(t){this.d.$transferActiveChatSession(t)}createChatAgent(t,b,c){const $=i.b++,v=new a(t,b,this.d,$,c);return this.c.set($,v),this.d.$registerAgent($,t.identifier,b,{},void 0),v.apiAgent}createDynamicChatAgent(t,b,c,$,v){const p=i.b++,l=new a(t,b,this.d,p,v);return this.c.set(p,l),this.d.$registerAgent(p,t.identifier,b,{isSticky:!0},{name:c,description:$}),l.apiAgent}async $invokeAgent(t,b,c,$){const v=this.c.get(t);if(!v)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let p=this.g.get(b.sessionId);p||(p=new m.$Tc,this.g.set(b.sessionId,p));const l=new r(v.extension,b,this.d,this.i,this.j.converter,p);try{const D=await this.k(b.agentId,c),f=v.invoke(d.ChatAgentRequest.to(b),{history:D},l.apiObject,$);return await(0,N.$eh)(Promise.resolve(f).then(S=>{if(S?.metadata)try{JSON.stringify(S.metadata)}catch(y){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${v.extension.identifier.value}] [@${v.id}] ${C}`,v.extension),{errorDetails:{message:C},timings:l.timings}}return{errorDetails:S?.errorDetails,timings:l.timings,metadata:S?.metadata}}),$)}catch(D){return this.i.error(D,v.extension),{errorDetails:{message:(0,k.localize)(0,null,(0,R.$bj)(D)),responseIsIncomplete:!0}}}finally{l.close()}}async k(t,b){const c=[];for(const $ of b.history){const v=d.ChatAgentResult.to($.result),p=t===$.request.agentId?v:{...v,metadata:void 0};c.push(new n.$UO($.request.message,$.request.command,$.request.variables.variables.map(d.ChatAgentResolvedVariable.to),$.request.agentId));const l=(0,I.$Hb)($.response.map(D=>d.ChatResponsePart.toContent(D,this.j.converter)));c.push(new n.$VO(l,p,$.request.agentId,$.request.command))}return c}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,b,c,$,v){const p=this.c.get(b);if(!p)return Promise.resolve([]);const l=await this.k(p.id,$),D=d.ChatAgentResult.to(c);return(await p.provideFollowups(D,{history:l},v)).filter(f=>{const S=!f.participant||M.Iterable.some(this.c.values(),y=>y.id===f.participant&&u.$Lm.equals(y.extension.identifier,p.extension.identifier));return S||this.i.warn(`[@${p.id}] ChatFollowup refers to an unknown participant: ${f.participant}`),S}).map(f=>d.ChatFollowup.from(f,t))}$acceptFeedback(t,b,c,$){const v=this.c.get(t);if(!v)return;const p=d.ChatAgentResult.to(b);let l;switch(c){case o.InteractiveSessionVoteDirection.Down:l=n.ChatResultFeedbackKind.Unhelpful;break;case o.InteractiveSessionVoteDirection.Up:l=n.ChatResultFeedbackKind.Helpful;break}v.acceptFeedback(Object.freeze($?{result:p,kind:l,reportIssue:$}:{result:p,kind:l}))}$acceptAction(t,b,c){const $=this.c.get(t);if(!$||c.action.kind==="vote")return;const v=d.ChatAgentUserActionEvent.to(b,c,this.j.converter);v&&$.acceptAction(Object.freeze(v))}async $invokeCompletionProvider(t,b,c){const $=this.c.get(t);return $?(await $.invokeCompletionProvider(b,c)).map(d.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,b){const c=this.c.get(t);if(c)return await c.provideWelcomeMessage(b)}async $provideSampleQuestions(t,b){const c=this.c.get(t);if(c)return(await c.provideSampleQuestions(b)).map($=>d.ChatFollowup.from($,void 0))}}e.$ckc=i;class a{constructor(t,b,c,$,v){this.extension=t,this.id=b,this.u=c,this.w=$,this.x=v,this.n=new F.$be,this.o=new F.$be}acceptFeedback(t){this.n.fire(t)}acceptAction(t){this.o.fire(t)}async invokeCompletionProvider(t,b){return this.q?await this.q.provider.provideCompletionItems(t,b)??[]:[]}async provideFollowups(t,b,c){if(!this.b)return[];const $=await this.b.provideFollowups(t,b,c);return $?$.filter(v=>!(v&&"commandId"in v)).filter(v=>!(v&&"message"in v)):[]}async provideWelcomeMessage(t){if(!this.s)return[];const b=await this.s.provideWelcomeMessage(t);return b?b.map(c=>typeof c=="string"?c:d.MarkdownString.from(c)):[]}async provideSampleQuestions(t){if(!this.s||!this.s.provideSampleQuestions)return[];const b=await this.s.provideSampleQuestions(t);return b||[]}get apiAgent(){let t=!1,b=!1;const c=()=>{t||b||(b=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof T.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof n.$NN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.i||typeof this.i=="string"?this.i:d.MarkdownString.from(this.i),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:d.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:d.MarkdownString.from(this.k),sampleRequest:this.l,supportIssueReporting:this.p,requester:this.t}),b=!1}))},$=this;return{get id(){return $.id},get fullName(){return(0,s.$yG)($.extension,"defaultChatParticipant"),$.c??$.extension.displayName??$.extension.name},set fullName(v){(0,s.$yG)($.extension,"defaultChatParticipant"),$.c=v,c()},get iconPath(){return $.d},set iconPath(v){$.d=v,c()},get requestHandler(){return $.x},set requestHandler(v){(0,E.$bg)(typeof v=="function","Invalid request handler"),$.x=v},get followupProvider(){return $.b},set followupProvider(v){$.b=v,c()},get isDefault(){return(0,s.$yG)($.extension,"defaultChatParticipant"),$.g},set isDefault(v){(0,s.$yG)($.extension,"defaultChatParticipant"),$.g=v,c()},get helpTextPrefix(){return(0,s.$yG)($.extension,"defaultChatParticipant"),$.i},set helpTextPrefix(v){(0,s.$yG)($.extension,"defaultChatParticipant"),$.i=v,c()},get helpTextVariablesPrefix(){return(0,s.$yG)($.extension,"defaultChatParticipant"),$.j},set helpTextVariablesPrefix(v){(0,s.$yG)($.extension,"defaultChatParticipant"),$.j=v,c()},get helpTextPostfix(){return(0,s.$yG)($.extension,"defaultChatParticipant"),$.k},set helpTextPostfix(v){(0,s.$yG)($.extension,"defaultChatParticipant"),$.k=v,c()},get isSecondary(){return(0,s.$yG)($.extension,"defaultChatParticipant"),$.m},set isSecondary(v){(0,s.$yG)($.extension,"defaultChatParticipant"),$.m=v,c()},get sampleRequest(){return $.l},set sampleRequest(v){$.l=v,c()},get supportIssueReporting(){return(0,s.$yG)($.extension,"chatParticipantAdditions"),$.p},set supportIssueReporting(v){(0,s.$yG)($.extension,"chatParticipantAdditions"),$.p=v,c()},get onDidReceiveFeedback(){return $.n.event},set participantVariableProvider(v){if((0,s.$yG)($.extension,"chatParticipantAdditions"),$.q=v,v){if(!v.triggerCharacters.length)throw new Error("triggerCharacters are required");$.u.$registerAgentCompletionsProvider($.w,v.triggerCharacters)}else $.u.$unregisterAgentCompletionsProvider($.w)},get participantVariableProvider(){return(0,s.$yG)($.extension,"chatParticipantAdditions"),$.q},set welcomeMessageProvider(v){(0,s.$yG)($.extension,"defaultChatParticipant"),$.s=v,c()},get welcomeMessageProvider(){return(0,s.$yG)($.extension,"defaultChatParticipant"),$.s},onDidPerformAction:(0,s.$xG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(v){$.t=v,c()},get requester(){return $.t},dispose(){t=!0,$.b=void 0,$.n.dispose(),$.u.$unregisterAgent($.w)}}}invoke(t,b,c,$){return this.x(t,b,c,$)}}}),define(Re[254],Ae([1,0,14,6,4,8,7,25]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;class g{static{this.a=0}constructor(k){this.b=new Map,this.c=k.getProxy(R.$PM.MainThreadChatVariables)}async $resolveVariable(k,u,w,d){const n=this.b.get(k);if(n)try{if(n.resolver.resolve2){(0,m.$yG)(n.extension,"chatParticipantAdditions");const o=new E(u,this.c),s=await n.resolver.resolve2(n.data.name,{prompt:w},o.apiObject,d);if(s)return s.map(F.ChatVariable.from)}else{const o=await n.resolver.resolve(n.data.name,{prompt:w},d);if(o)return o.map(F.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(k,u,w,d){const n=g.a++;return this.b.set(n,{extension:k,data:{name:u,description:w},resolver:d}),this.c.$registerVariable(n,{name:u,description:w}),(0,N.$Sc)(()=>{this.b.delete(n),this.c.$unregisterVariable(n)})}}e.$dkc=g;class E{constructor(k,u){this.c=k,this.d=u,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let u=function(d){if(k.a){const n=new Error("Response stream has been closed");throw Error.captureStackTrace(n,d),n}};const k=this,w=d=>{this.d.$handleProgressChunk(this.c,d)};this.b={progress(d){u(this.progress);const n=new M.$QO(d),o=F.ChatResponseProgressPart.from(n);return w(o),this},reference(d){u(this.reference);const n=new M.$SO(d),o=F.ChatResponseReferencePart.from(n);return w(o),this},push(d){return u(this.push),d instanceof M.$SO?w(F.ChatResponseReferencePart.from(d)):d instanceof M.$QO&&w(F.ChatResponseProgressPart.from(d)),this}}}return this.b}}}),define(Re[255],Ae([1,0,11,68,5,6,2,87,20,8,7,4,25]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=w;function w(d,n,o){const s=d.getProxy(k.$PM.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$Nm,n.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const D=this.b.get(l.handle);return D?D.value:l}else if(l&&l.$mid===7){const D=l,f=this.b.get(D.commentControlHandle);if(!f)return D;const S=f.getCommentThread(D.commentThreadHandle);return S?S.value:D}else if(l&&(l.$mid===9||l.$mid===8)){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const f=D.getCommentThread(l.thread.commentThreadHandle);return f?l.$mid===8?f.value:{thread:f.value,text:l.text}:l}else if(l&&l.$mid===10){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const f=D.getCommentThread(l.thread.commentThreadHandle);if(!f)return l;const S=l.commentUniqueId,y=f.getCommentByUniqueId(S);return y||l}else if(l&&l.$mid===11){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const f=D.getCommentThread(l.thread.commentThreadHandle);if(!f)return l;const S=l.text,y=l.commentUniqueId,C=f.getCommentByUniqueId(y);return C?(typeof C.body=="string"?C.body=S:C.body=new T.$gN(S),C):l}return l}})}createCommentController(l,D,f){const S=r.a++,y=new a(l,S,D,f);this.b.set(y.handle,y);const C=this.c.get(l.identifier)||[];return C.push(y),this.c.set(l.identifier,C),y.value}async $createCommentThreadTemplate(l,D,f){const S=this.b.get(l);S&&S.$createCommentThreadTemplate(D,f)}async $setActiveComment(l,D){const f=this.b.get(l);f&&f.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(l,D,f){const S=this.b.get(l);S&&S.$updateCommentThreadTemplate(D,f)}$deleteCommentThread(l,D){this.b.get(l)?.$deleteCommentThread(D)}async $provideCommentingRanges(l,D,f){const S=this.b.get(l);if(!S||!S.commentingRangeProvider)return Promise.resolve(void 0);const y=await o.ensureDocumentData(M.URI.revive(D));return(0,I.$ih)(async()=>{const C=await S.commentingRangeProvider.provideCommentingRanges(y.document,f);let P;return Array.isArray(C)?P={ranges:C,fileComments:!1}:C?P={ranges:C.ranges||[],fileComments:C.fileComments||!1}:P=C??void 0,P}).then(C=>{let P;return C&&(P={ranges:C.ranges.map(V=>E.Range.from(V)),fileComments:C.fileComments}),P})}$toggleReaction(l,D,f,S,y){const C=this.b.get(l);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,I.$ih)(()=>{const P=C.getCommentThread(D);if(P){const V=P.getCommentByUniqueId(S.uniqueIdInThread);if(C!==void 0&&V&&C.reactionHandler)return C.reactionHandler(V,b(y))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,typeof l=="object"?((0,u.$yG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=l.resolved,this.b.applicability=l.applicability):this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,D,f,S,y,C,P,V){this.m=D,this.n=f,this.o=S,this.p=y,this.q=C,this.extensionDescription=P,this.r=V,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new R.$be,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$Vc,this.l.value=new F.$Tc,this.n===void 0&&(this.n=`${l}.${this.handle}`),s.$createCommentThread(D,this.handle,this.n,this.o,E.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{s.$deleteCommentThread(D,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(q){W.range=q},get comments(){return W.comments},set comments(q){W.comments=q},get collapsibleState(){return W.collapsibleState},set collapsibleState(q){W.collapsibleState=q},get canReply(){return W.canReply},set canReply(q){W.canReply=q},get contextValue(){return W.contextValue},set contextValue(q){W.contextValue=q},get label(){return W.label},set label(q){W.label=q},get state(){return W.state},set state(q){W.state=q},dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$Tc);const l=f=>Object.prototype.hasOwnProperty.call(this.b,f),D={};l("range")&&(D.range=E.Range.from(this.p)),l("label")&&(D.label=this.label),l("contextValue")&&(D.contextValue=this.contextValue??null),l("comments")&&(D.comments=this.q.map(f=>h(this,f,this.k,this.extensionDescription))),l("collapsibleState")&&(D.collapseState=c(this.g)),l("canReply")&&(D.canReply=this.canReply),l("state")&&(D.state=$(this.h)),l("applicability")&&(D.applicability=v(this.h)),l("isTemplate")&&(D.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(l){for(const D of this.k){const f=D[0],S=D[1];if(l===S)return f}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Je([(0,N.$Vh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,l?.resourceHints&&(0,u.$yG)(this.h,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,l?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,u.$yG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,u.$yG)(this.h,"activeComment"),this.f}constructor(l,D,f,S){this.h=l,this.i=D,this.j=f,this.k=S,this.a=new Map,s.$registerCommentController(this.handle,f,S,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(C){y.options=C},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(C){y.commentingRangeProvider=C},get reactionHandler(){return y.reactionHandler},set reactionHandler(C){y.reactionHandler=C},get activeCommentThread(){return y.activeCommentThread},createCommentThread(C,P,V){return y.createCommentThread(C,P,V).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(l,D,f){D===void 0&&(0,u.$yG)(this.h,"fileComments");const S=new i(this.id,this.handle,void 0,l,D,f,this.h,!1);return this.a.set(S.handle,S),S}$setActiveComment(l){if(!l){this.e=void 0,this.f=void 0;return}const D=this.a.get(l.commentThreadHandle);D&&(this.e=l.uniqueIdInThread?D.getCommentByUniqueId(l.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(l,D){const f=new i(this.id,this.handle,void 0,M.URI.revive(l),E.Range.to(D),[],this.h,!0);return f.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(l,D){const f=this.a.get(l);f&&(f.range=E.Range.to(D))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.g.forEach(l=>l.dispose())}}function h(p,l,D,f){let S=D.get(l);return S||(S=++p.commentHandle,D.set(l,S)),l.state!==void 0&&(0,u.$yG)(f,"commentsDraftState"),l.reactions?.some(y=>y.reactors!==void 0)&&(0,u.$yG)(f,"commentReactor"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:S,body:typeof l.body=="string"?l.body:E.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(y=>t(y)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(p){return{label:p.label,iconPath:p.iconPath?E.$_O(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted,reactors:p.reactors&&p.reactors.length>0&&typeof p.reactors[0]!="string"?p.reactors.map(l=>l.name):p.reactors}}function b(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?M.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1,reactors:p.reactors?.map(l=>({name:l}))}}function c(p){if(p!==void 0)switch(p){case T.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function $(p){let l;if(typeof p=="object"?l=p.resolved:l=p,l!==void 0)switch(l){case T.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}function v(p){let l;if(typeof p=="object"&&(l=p.applicability),l!==void 0)switch(l){case T.CommentThreadApplicability.Current:return m.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return m.CommentThreadApplicability.Outdated}return m.CommentThreadApplicability.Current}return new r}}),define(Re[256],Ae([1,0,24,99,6,12,23,2,8,63,74,4,7]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class w{constructor(b,c){this.document=b,this.b=c,this.a=1,this.c=new T.$Zjc("custom documents")}addEdit(b){return this.c.add([b])}async undo(b,c){await this.f(b).undo(),c||this.disposeBackup()}async redo(b,c){await this.f(b).redo(),c||this.disposeBackup()}disposeEdits(b){for(const c of b)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const b=h(this.document.uri)+this.a++;return(0,M.$4g)(this.b,b)}updateBackup(b){this.d?.delete(),this.d=b}disposeBackup(){this.d?.delete(),this.d=void 0}f(b){const c=this.c.get(b,0);if(!c)throw new Error("No edit found");return c}}class d{constructor(){this.a=new Map}get(b,c){return this.a.get(this.b(b,c))}add(b,c,$){const v=this.b(b,c.uri);if(this.a.has(v))throw new Error(`Document already exists for viewType:${b} resource:${c.uri}`);const p=new w(c,$);return this.a.set(v,p),p}delete(b,c){const $=this.b(b,c.uri);this.a.delete($)}b(b,c){return`${b}@@@${c}`}}var n;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(n||(n={}));class o{constructor(){this.a=new Map}addTextProvider(b,c,$){return this.b(0,b,c,$)}addCustomProvider(b,c,$){return this.b(1,b,c,$)}get(b){return this.a.get(b)}b(b,c,$,v){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:b,extension:$,provider:v}),new u.$RM(()=>this.a.delete(c))}}class s{constructor(b,c,$,v,p){this.d=c,this.f=$,this.g=v,this.h=p,this.b=new o,this.c=new d,this.a=b.getProxy(k.$PM.MainThreadCustomEditors)}registerCustomEditorProvider(b,c,$,v){const p=new R.$Tc;return i($)?(p.add(this.b.addTextProvider(c,b,$)),this.a.$registerTextEditorProvider((0,E.$wkc)(b),c,v.webviewOptions||{},{supportsMove:!!$.moveCustomTextEditor},(0,E.$ukc)(b))):(p.add(this.b.addCustomProvider(c,b,$)),r($)&&p.add($.onDidChangeCustomDocument(l=>{const D=this.i(c,l.document.uri);if(a(l)){const f=D.addEdit(l);this.a.$onDidEdit(l.document.uri,c,f,l.label)}else this.a.$onContentChange(l.document.uri,c)})),this.a.$registerCustomEditorProvider((0,E.$wkc)(b),c,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,E.$ukc)(b))),u.$RM.from(p,new u.$RM(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(b,c,$,v,p){const l=this.b.get(c);if(!l)throw new Error(`No provider found for '${c}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${c}'`);const D=m.URI.revive(b),f=await l.provider.openCustomDocument(D,{backupId:$,untitledDocumentData:v?.buffer},p);let S;return r(l.provider)&&this.f&&(S=this.f.workspaceValue(l.extension)??this.f.globalValue(l.extension)),this.c.add(c,f,S),{editable:r(l.provider)}}async $disposeCustomDocument(b,c){const $=this.b.get(c);if(!$)throw new Error(`No provider found for '${c}'`);if($.type!==1)throw new Error(`Invalid provider type for '${c}'`);const v=m.URI.revive(b),{document:p}=this.i(c,v);this.c.delete(c,p),p.dispose()}async $resolveCustomEditor(b,c,$,v,p,l){const D=this.b.get($);if(!D)throw new Error(`No provider found for '${$}'`);const f=g.ViewColumn.to(p),S=this.g.createNewWebview(c,v.contentOptions,D.extension),y=this.h.createNewWebviewPanel(c,$,v.title,f,v.options,S,v.active),C=m.URI.revive(b);switch(D.type){case 1:{const{document:P}=this.i($,C);return D.provider.resolveCustomEditor(P,y,l)}case 0:{const P=this.d.getDocument(C);return D.provider.resolveCustomTextEditor(P,y,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(b,c,$){this.i(c,b).disposeEdits($)}async $onMoveCustomEditor(b,c,$){const v=this.b.get($);if(!v)throw new Error(`No provider found for '${$}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${$}'`);const p=this.h.getWebviewPanel(b);if(!p)throw new Error("No webview found");const l=m.URI.revive(c),D=this.d.getDocument(l);await v.provider.moveCustomTextEditor(D,p,I.CancellationToken.None)}async $undo(b,c,$,v){return this.i(c,b).undo($,v)}async $redo(b,c,$,v){return this.i(c,b).redo($,v)}async $revert(b,c,$){const v=this.i(c,b);await this.j(c).revertCustomDocument(v.document,$),v.disposeBackup()}async $onSave(b,c,$){const v=this.i(c,b);await this.j(c).saveCustomDocument(v.document,$),v.disposeBackup()}async $onSaveAs(b,c,$,v){const p=this.i(c,b);return this.j(c).saveCustomDocumentAs(p.document,m.URI.revive($),v)}async $backup(b,c,$){const v=this.i(c,b),l=await this.j(c).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},$);return v.updateBackup(l),l.id}i(b,c){const $=this.c.get(b,m.URI.revive(c));if(!$)throw new Error("No custom document found");return $}j(b){const $=this.b.get(b)?.provider;if(!$||!r($))throw new Error("Custom document is not editable");return $}}e.$zkc=s;function r(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const b=t.scheme===F.Schemas.file||t.scheme===F.Schemas.untitled?t.fsPath:t.toString();return(0,N.$ej)(b)+""}}),define(Re[257],Ae([1,0,164,100,2,4,7,8,5,13,28,44]),function(ge,e,I,N,R,F,M,m,g,E,T,k){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=e.$7jc=void 0;class w{#e;#t;#i;constructor(o,s,r,i,a,h,t,b){this.d=o,this.e=s,this.f=r,this.g=i,this.h=a,this.c=!1,this.f=Math.max(i,r),this.#i=new T.$Bc(c=>h.getComparisonKey(c)),this.#e=t,this.#t=b}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let r=[];if(R.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),r=[o]}else if(Array.isArray(o)){r=[];let h;o=[...o].sort(w.k);for(const t of o){const[b,c]=t;if((!h||b.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=b,r.push(b),this.#i.set(b,[])),c)this.#i.get(b)?.push(...c);else{const $=this.#i.get(b);$&&($.length=0)}}}if(this.#t.fire(r),!this.#e)return;const i=[];let a=0;for(const h of r){let t=[];const b=this.#i.get(h);if(b)if(b.length>this.g){t=[];const c=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let $=0;$<4;$++)for(const v of b)if(v.severity===c[$]&&t.push({...m.Diagnostic.from(v),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,I.localize)(0,null,b.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=b.map(c=>({...m.Diagnostic.from(c),modelVersionId:this.h(h)}));if(i.push([h,t]),a+=t.length,a>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[r,i]of this)o.call(s,r,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$7jc=w;let d=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const s=new T.$Bc;for(const r of o)s.set(r,r);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,r,i){this.j=s,this.k=r,this.l=i,this.g=new Map,this.h=new g.$fe({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,u._mapper),this.f=o.getProxy(F.$PM.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:r,f:i,h:a,j:h,k:t,l:b}=this,c=new class{$changeMany(p,l){i.$changeMany(p,l),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,p,l.length===0?"CLEARING":l)}$clear(p){i.$clear(p),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,p)}dispose(){i.dispose()}};let $;if(!s)s="_generated_diagnostic_collection_name_#"+u.c++,$=s;else if(!r.has(s))$=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do $=s+u.c++;while(r.has($))}return new class extends w{constructor(){super(s,$,u.e,u.d,p=>b.getDocument(p)?.version,t.extUri,c,a),r.set($,this)}dispose(){super.dispose(),r.delete($)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,r=[];for(const i of this.g.values())i.forEach((a,h)=>{let t=s.get(a.toString());typeof t>"u"&&(t=r.length,s.set(a.toString(),t),r.push([a,[]])),r[t][1]=r[t][1].concat(...h)});return r}}m(o){let s=[];for(const r of this.g.values())r.has(o)&&(s=s.concat(r.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",r=new w(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(s,r),this.n=r}for(const[s,r]of o)this.n.set(R.URI.revive(s),r.map(m.Diagnostic.to))}};e.$8jc=d,e.$8jc=d=u=Je([Ve(1,E.$Wj),Ve(2,k.$6jc)],d)}),define(Re[258],Ae([1,0,2,14,7,8,193,34]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=void 0;class g{constructor(T,k,u,w={timeout:1500,errors:3}){this.c=T,this.d=k,this.f=u,this.g=w,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(k,u,w)=>{const n={dispose:this.a.push([k,u,T])};return Array.isArray(w)&&w.push(n),n}}async $participateInSave(T,k){const u=I.URI.revive(T);let w=!1;const d=setTimeout(()=>w=!0,this.g.timeout),n=[];try{for(const o of[...this.a]){if(w)break;const s=this.d.getDocument(u),r=await this.h(o,{document:s,reason:F.TextDocumentSaveReason.to(k)});n.push(r)}}finally{clearTimeout(d)}return n}h([T,k,u],w){const d=this.b.get(T);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(u,T,k,w).then(()=>!0,n=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(n),!(n instanceof Error)||n.message!=="concurrent_edits"){const o=this.b.get(T);this.b.set(T,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,k,u,w){const d=[],n=Date.now(),{document:o,reason:s}=w,{version:r}=o,i=Object.freeze({document:o,reason:s,waitUntil(a){if(Object.isFrozen(d))throw(0,N.$8)("waitUntil can not be called async");d.push(Promise.resolve(a))}});try{k.apply(u,[i])}catch(a){return Promise.reject(a)}return Object.freeze(d),new Promise((a,h)=>{const t=setTimeout(()=>h(new Error("timeout")),this.g.timeout);return Promise.all(d).then(b=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-n}ms`),clearTimeout(t),a(b)}).catch(b=>{clearTimeout(t),h(b)})}).then(a=>{const h={edits:[]};for(const t of a)if(Array.isArray(t)&&t.every(b=>b instanceof R.$YM))for(const{newText:b,newEol:c,range:$}of t)h.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:$&&F.Range.from($),text:b,eol:c&&F.EndOfLine.from(c)}});if(h.edits.length!==0)return r===o.version?this.f.$tryApplyWorkspaceEdit(new m.$mw(h)):Promise.reject(new Error("concurrent_edits"))})}}e.$dlc=g}),define(Re[259],Ae([1,0,5,6,2,4,111,8,17,26,7]),function(ge,e,I,N,R,F,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=void 0;class k{constructor(w,d){this.a=new I.$be,this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Tc,this.h=new Map,this.f=w.getProxy(F.$PM.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(n=>{for(const o of n)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(n=>{for(const o of n)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const d=this.g.getDocument(w);if(d)return d}getDocument(w){const d=this.getDocumentData(w);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return d.document}ensureDocumentData(w){const d=this.g.getDocument(w);if(d)return Promise.resolve(d);let n=this.h.get(w.toString());return n||(n=this.f.$tryOpenDocument(w).then(o=>{this.h.delete(w.toString());const s=R.URI.revive(o);return(0,g.$cg)(this.g.getDocument(s))},o=>(this.h.delete(w.toString()),Promise.reject(o))),this.h.set(w.toString(),n)),n}createDocumentData(w){return this.f.$tryCreateDocument(w).then(d=>R.URI.revive(d))}$acceptModelLanguageChanged(w,d){const n=R.URI.revive(w),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(d),this.a.fire(o.document)}$acceptModelSaved(w){const d=R.URI.revive(w),n=this.g.getDocument(d);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(n.document)}$acceptDirtyStateChanged(w,d){const n=R.URI.revive(w),o=this.g.getDocument(n);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,d,n){const o=R.URI.revive(w),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(n),s.onEvents(d);let r;d.isUndoing?r=T.TextDocumentChangeReason.Undo:d.isRedoing&&(r=T.TextDocumentChangeReason.Redo),this.c.fire((0,E.$Xn)({document:s.document,contentChanges:d.changes.map(i=>({range:m.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:r}))}setWordDefinitionFor(w,d){(0,M.$cP)(w,d)}}e.$9jc=k}),define(Re[66],Ae([1,0,260,5,17,2,3,4,16,8,7]),function(ge,e,I,N,R,F,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=e.$Akc=void 0,e.$Akc=(0,M.$qi)("IExtHostEditorTabs");class k{constructor(o,s,r){this.e=r,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.$BO(F.URI.revive(this.b.input.uri));case 2:return new T.$CO(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified));case 3:return new T.$DO(F.URI.revive(this.b.input.base),F.URI.revive(this.b.input.input1),F.URI.revive(this.b.input.input2),F.URI.revive(this.b.input.result));case 6:return new T.$EO(F.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.$FO(this.b.input.viewType);case 4:return new T.$GO(F.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.$HO(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.$IO;case 9:return new T.$JO(F.URI.revive(this.b.input.uri),F.URI.revive(this.b.input.inputBoxUri));case 10:return new T.$KO;case 11:return new T.$LO(this.b.input.diffEditors.map(o=>new T.$CO(F.URI.revive(o.original),F.URI.revive(o.modified))));default:return}}}class u{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const r of o.tabs)r.isActive&&(this.d=r.id),this.c.push(new k(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return E.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(r=>r.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(r=>r.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const r=new k(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,r),o.tabDto.isActive&&(this.d=r.tabId),r}else if(o.kind===1){const r=this.c.splice(o.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(o.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,r),r}const s=this.c.find(r=>r.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let w=class{constructor(o){this.b=new N.$be,this.c=new N.$be,this.e=[],this.a=o.getProxy(m.$PM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(r=>r.apiObject))},get activeTabGroup(){const r=o.d;return(0,R.$cg)(o.e.find(a=>a.groupId===r)?.apiObject)},close:async(r,i)=>{const a=Array.isArray(r)?r:[r];return a.length?d(a[0])?this.j(a,i):this.i(a,i):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(c=>c.groupId)),r=new Set(o.map(c=>c.groupId)),i=(0,I.$L)(s,r),a=this.e.filter(c=>i.removed.includes(c.groupId)).map(c=>c.apiObject),h=[],t=[];this.e=o.map(c=>{const $=new u(c,()=>this.d);return i.added.includes($.groupId)?h.push($.apiObject):t.push($.apiObject),$});const b=(0,R.$cg)(o.find(c=>c.isActive===!0)?.groupId);b!==void 0&&this.d!==b&&(this.d=b),this.c.fire(Object.freeze({opened:h,closed:a,changed:t}))}$acceptTabGroupUpdate(o){const s=this.e.find(r=>r.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const r=s.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(o){for(const s of this.e)for(const r of s.tabs)if(r.apiObject===o)return r}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const r=[];for(const i of o){const a=this.g(i);if(!a)throw new Error("Tab close: Invalid tab not found!");r.push(a.tabId)}return this.a.$closeTab(r,s)}async j(o,s){const r=[];for(const i of o){const a=this.h(i);if(!a)throw new Error("Group close: Invalid group not found!");r.push(a.groupId)}return this.a.$closeGroup(r,s)}};e.$Bkc=w,e.$Bkc=w=Je([Ve(0,g.$aP)],w);function d(n){return n.tabs!==void 0}}),define(Re[261],Ae([1,0,2,4,6,7,8,304,15,22,25,54]),function(ge,e,I,N,R,F,M,m,g,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;class u{constructor(){this.a=[]}add(n){this.b=void 0,this.a.push(n)}delete(n){const o=this.a.indexOf(n);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const n=this.a.sort(),o=[];let s,r,i=14,a=14;for(const h of n){let t=s?(0,g.$vf)(s,h):0;for(t===0?r=1:r=a;t<h.length;t++)t+1===h.length?(i=a,a=9):a+=1,o.push([r,h.toUpperCase().charCodeAt(t),a]),o.push([r,h.toLowerCase().charCodeAt(t),a]),r=a;s=h,a=i}o.push([9,58,10]),o.push([10,47,12]),this.b=new m.$12(o)}}provideDocumentLinks(n){this.c();const o=[],s=m.$22.computeLinks({getLineContent(r){return n.lineAt(r-1).text},getLineCount(){return n.lineCount}},this.b);for(const r of s){const i=M.DocumentLink.to(r);i.target&&o.push(i)}return o}}class w{constructor(n,o){this.i=o,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=n.getProxy(N.$PM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(n,o,s,r={}){if(w.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(n,"*",this.b));const i=this.h++;this.b.add(o),this.d.add(o),this.c.set(i,s);let a=2;r.isCaseSensitive&&(a+=1024),r.isReadonly&&(a+=2048),typeof s.copy=="function"&&(a+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,T.$yG)(n,"fsChunks"),a+=4);let h;r.isReadonly&&(0,k.$Pk)(r.isReadonly)&&r.isReadonly.value!==""&&(h={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(i,o,a,h).catch(b=>{console.error(`FAILED to register filesystem provider of ${n.identifier.value}-extension for the scheme ${o}`),console.error(b)});const t=s.onDidChangeFile(b=>{const c=[];for(const $ of b){const{uri:v,type:p}=$;if(v.scheme!==o)continue;let l;switch(p){case F.FileChangeType.Changed:l=0;break;case F.FileChangeType.Created:l=1;break;case F.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:v,type:l})}this.a.$onFileSystemChange(i,c)});return(0,R.$Sc)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(n){if(!n)throw new Error("MISSING provider");if(typeof n.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof n.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof n.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof n.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof n.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof n.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof n.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof n.rename!="function")throw new Error("Provider does NOT implement rename")}static k(n){const{type:o,ctime:s,mtime:r,size:i,permissions:a}=n;return{type:o,ctime:s,mtime:r,size:i,permissions:a}}$stat(n,o){return Promise.resolve(this.l(n).stat(I.URI.revive(o))).then(s=>w.k(s))}$readdir(n,o){return Promise.resolve(this.l(n).readDirectory(I.URI.revive(o)))}$readFile(n,o){return Promise.resolve(this.l(n).readFile(I.URI.revive(o))).then(s=>E.$Ce.wrap(s))}$writeFile(n,o,s,r){return Promise.resolve(this.l(n).writeFile(I.URI.revive(o),s.buffer,r))}$delete(n,o,s){return Promise.resolve(this.l(n).delete(I.URI.revive(o),s))}$rename(n,o,s,r){return Promise.resolve(this.l(n).rename(I.URI.revive(o),I.URI.revive(s),r))}$copy(n,o,s,r){const i=this.l(n);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(I.URI.revive(o),I.URI.revive(s),r))}$mkdir(n,o){return Promise.resolve(this.l(n).createDirectory(I.URI.revive(o)))}$watch(n,o,s,r){const i=this.l(n).watch(I.URI.revive(s),r);this.f.set(o,i)}$unwatch(n,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(n,o,s){const r=this.l(n);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(I.URI.revive(o),s))}$close(n,o){const s=this.l(n);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(n,o,s,r){const i=this.l(n);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const a=E.$Ce.alloc(r);return Promise.resolve(i.read(o,s,a.buffer,0,r)).then(h=>a.slice(0,h))}$write(n,o,s,r){const i=this.l(n);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(o,s,r.buffer,0,r.byteLength))}l(n){const o=this.c.get(n);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.$flc=w}),define(Re[262],Ae([1,0,5,36,2,4,8,7,40]),function(ge,e,I,N,R,F,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,d,n,o,s,r){this.a=Math.random(),this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const i=(0,N.$kk)(s),a=typeof s=="string",h=r?.correlate,t=o(b=>{if(!(typeof b.session=="number"&&b.session!==this.a)&&!(h&&typeof b.session>"u")){if(!r?.ignoreCreateEvents)for(const c of b.created){const $=R.URI.revive(c);i($.fsPath)&&(!a||d.getWorkspaceFolder($))&&this.b.fire($)}if(!r?.ignoreChangeEvents)for(const c of b.changed){const $=R.URI.revive(c);i($.fsPath)&&(!a||d.getWorkspaceFolder($))&&this.c.fire($)}if(!r?.ignoreDeleteEvents)for(const c of b.deleted){const $=R.URI.revive(c);i($.fsPath)&&(!a||d.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=m.$RM.from(this.i(w,n,s,r,r?.correlate),this.b,this.c,this.d,t)}i(w,d,n,o,s){const r=m.$RM.from();if(typeof n=="string")return r;const i=w.getProxy(F.$PM.MainThreadFileSystemEventService);let a=!1;return(n.pattern.includes(N.$gk)||n.pattern.includes(N.$hk))&&(a=!0),i.$watch(d.identifier.value,this.a,n.baseUri,{recursive:a,excludes:o?.excludes??[]},!!s),m.$RM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class T{constructor(w){this.a=w,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(R.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(R.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(R.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(w,d,n){this.j=w,this.k=d,this.l=n,this.a=new I.$be,this.b=new I.$be,this.c=new I.$be,this.d=new I.$be,this.g=new I.$de,this.h=new I.$de,this.i=new I.$de,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,d,n,o){return new E(this.j,w,d,this.a.event,M.GlobPattern.from(n),o)}$onFileEvent(w){this.a.fire(new T(w))}$onDidRunFileOperation(w,d){switch(w){case 2:this.b.fire(Object.freeze({files:d.map(n=>({oldUri:R.URI.revive(n.source),newUri:R.URI.revive(n.target)}))}));break;case 1:this.d.fire(Object.freeze({files:d.map(n=>R.URI.revive(n.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:d.map(n=>R.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,d){return(n,o,s)=>{const r=function(a){n.call(o,a)};return r.extension=w,d.event(r,void 0,s)}}async $onWillRunFileOperation(w,d,n,o){switch(w){case 2:return await this.n(this.g,{files:d.map(s=>({oldUri:R.URI.revive(s.source),newUri:R.URI.revive(s.target)}))},n,o);case 1:return await this.n(this.i,{files:d.map(s=>R.URI.revive(s.target))},n,o);case 0:case 3:return await this.n(this.h,{files:d.map(s=>R.URI.revive(s.target))},n,o)}}async n(w,d,n,o){const s=new Set,r=[];if(await w.fireAsync(d,o,async(a,h)=>{const t=Date.now(),b=await Promise.resolve(a);b instanceof m.$2M&&(r.push([h.extension,b]),s.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>n&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||r.length===0)return;const i={edits:[]};for(const[,a]of r){const{edits:h}=M.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(h)}return{edit:i,extensionNames:Array.from(s)}}}e.$glc=k}),define(Re[263],Ae([1,0,18,11,24,14,90,6,26,65,15,17,2,29,305,87,97,166,20,8,7,25,74,4]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s,r,i,a,h,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=void 0;class c{constructor(z,L){this.d=z,this.e=L}async provideDocumentSymbols(z,L){const G=this.d.getDocument(z),H=await this.e.provideDocumentSymbols(G,L);if(!(0,I.$Kb)(H))return H[0]instanceof a.$$M?H.map(i.DocumentSymbol.from):c.f(H)}static f(z){z=z.slice(0).sort((H,ee)=>{let se=H.location.range.start.compareTo(ee.location.range.start);return se===0&&(se=ee.location.range.end.compareTo(H.location.range.end)),se});const L=[],G=[];for(const H of z){const ee={name:H.name||"!!MISSING: name!!",kind:i.SymbolKind.from(H.kind),tags:H.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:i.Range.from(H.location.range),selectionRange:i.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(ee),L.push(ee);break}const se=G[G.length-1];if(w.$kt.containsRange(se.range,ee.range)&&!w.$kt.equalsRange(se.range,ee.range)){se.children?.push(ee),G.push(ee);break}G.pop()}}return L}}class ${constructor(z,L,G,H,ee,se){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.l=se,this.d=new t.$Zjc("CodeLens"),this.e=new Map}async provideCodeLenses(z,L){const G=this.f.getDocument(z),H=await this.h.provideCodeLenses(G,L);if(!H||L.isCancellationRequested)return;const ee=this.d.add(H),se=new m.$Tc;this.e.set(ee,se);const Fe={cacheId:ee,lenses:[]};for(let Be=0;Be<H.length;Be++)Fe.lenses.push({cacheId:[ee,Be],range:i.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,se)});return Fe}async resolveCodeLens(z,L){const G=z.cacheId&&this.d.get(...z.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,L),H||(H=G),L.isCancellationRequested)return;const ee=z.cacheId&&this.e.get(z.cacheId[0]);if(ee){if(!H.command){const se=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,se),this.l.error(se);return}return z.command=this.g.toInternal(H.command,ee),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function v(ze){return Array.isArray(ze)?ze.map(i.DefinitionLink.from):ze?[i.DefinitionLink.from(ze)]:[]}class p{constructor(z,L){this.d=z,this.e=L}async provideDefinition(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideDefinition(H,ee,G);return v(se)}}class l{constructor(z,L){this.d=z,this.e=L}async provideDeclaration(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideDeclaration(H,ee,G);return v(se)}}class D{constructor(z,L){this.d=z,this.e=L}async provideImplementation(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideImplementation(H,ee,G);return v(se)}}class f{constructor(z,L){this.d=z,this.e=L}async provideTypeDefinition(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideTypeDefinition(H,ee,G);return v(se)}}class S{constructor(z,L){this.d=z,this.e=L}async provideHover(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideHover(H,ee,G);if(!(!se||(0,I.$Kb)(se.contents)))return se.range||(se.range=H.getWordRangeAtPosition(ee)),se.range||(se.range=new a.$TM(ee,ee)),i.Hover.from(se)}}class y{constructor(z,L){this.d=z,this.e=L}async provideEvaluatableExpression(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideEvaluatableExpression(H,ee,G);if(se)return i.EvaluatableExpression.from(se)}}class C{constructor(z,L){this.d=z,this.e=L}async provideInlineValues(z,L,G,H){const ee=this.d.getDocument(z),se=await this.e.provideInlineValues(ee,i.Range.to(L),i.InlineValueContext.to(G),H);if(Array.isArray(se))return se.map(Fe=>i.InlineValue.from(Fe))}}class P{constructor(z,L){this.d=z,this.e=L}async provideDocumentHighlights(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideDocumentHighlights(H,ee,G);if(Array.isArray(se))return se.map(i.DocumentHighlight.from)}}class V{constructor(z,L){this.d=z,this.e=L}async provideMultiDocumentHighlights(z,L,G,H){const ee=this.d.getDocument(z),se=G.map(Qe=>this.d.getDocument(Qe)),Fe=i.Position.to(L),Be=await this.e.provideMultiDocumentHighlights(ee,Fe,se,H);if(Array.isArray(Be))return Be.map(i.MultiDocumentHighlight.from)}}class W{constructor(z,L){this.d=z,this.e=L}async provideLinkedEditingRanges(z,L,G){const H=this.d.getDocument(z),ee=i.Position.to(L),se=await this.e.provideLinkedEditingRanges(H,ee,G);if(se&&Array.isArray(se.ranges))return{ranges:(0,I.$Hb)(se.ranges.map(i.Range.from)),wordPattern:se.wordPattern}}}class q{constructor(z,L){this.d=z,this.e=L}async provideReferences(z,L,G,H){const ee=this.d.getDocument(z),se=i.Position.to(L),Fe=await this.e.provideReferences(ee,se,G,H);if(Array.isArray(Fe))return Fe.map(i.location.from)}}class A{static{this.d=1e3}constructor(z,L,G,H,ee,se,Fe){this.g=z,this.h=L,this.j=G,this.k=H,this.l=ee,this.m=se,this.n=Fe,this.e=new t.$Zjc("CodeAction"),this.f=new Map}async provideCodeActions(z,L,G,H){const ee=this.g.getDocument(z),se=d.$mt.isISelection(L)?i.Selection.to(L):i.Range.to(L),Fe=[];for(const tt of this.j.getDiagnostics(z))if(se.intersection(tt.range)&&Fe.push(tt)>A.d)break;const Be={diagnostics:Fe,only:G.only?new a.$aN(G.only):void 0,triggerKind:i.CodeActionTriggerKind.to(G.trigger)},Qe=await this.k.provideCodeActions(ee,se,Be,H);if(!(0,I.$Lb)(Qe)||H.isCancellationRequested)return;const xe=this.e.add(Qe),_e=new m.$Tc;this.f.set(xe,_e);const et=[];for(let tt=0;tt<Qe.length;tt++){const nt=Qe[tt];if(nt)if(A.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,_e)});else{Be.only&&(nt.kind?Be.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=nt.ranges??[];et.push({cacheId:[xe,tt],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,_e),diagnostics:nt.diagnostics&&nt.diagnostics.map(i.Diagnostic.from),edit:nt.edit&&i.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,h.$xG)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,h.$xG)(this.m,"codeActionRanges")?(0,I.$Hb)(ct.map(i.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:xe,actions:et}}async resolveCodeAction(z,L){const[G,H]=z,ee=this.e.get(G,H);if(!ee||A.o(ee))return{};if(!this.k.resolveCodeAction)return{};const se=await this.k.resolveCodeAction(ee,L)??ee;let Fe;se.edit&&(Fe=i.WorkspaceEdit.from(se.edit,void 0));let Be;if(se.command){const Qe=this.f.get(G);Qe&&(Be=this.h.toInternal(se.command,Qe))}return{edit:Fe,command:Be}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class j{constructor(z,L,G,H,ee){this.e=z,this.f=L,this.g=G,this.h=H,this.j=ee,this.d=new t.$Zjc("DocumentPasteEdit")}async prepareDocumentPaste(z,L,G,H){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(z),se=L.map(Qe=>i.Range.to(Qe)),Fe=i.DataTransfer.toDataTransfer(G,()=>{throw new F.$$});if(await this.g.prepareDocumentPaste(ee,se,Fe,H),H.isCancellationRequested)return;const Be=Array.from(Fe).filter(([,Qe])=>!(Qe instanceof a.$GN));return i.DataTransfer.from(Be)}async providePasteEdits(z,L,G,H,ee,se){if(!this.g.provideDocumentPasteEdits)return[];const Fe=this.f.getDocument(L),Be=G.map(et=>i.Range.to(et)),Qe=i.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolvePasteFileData(this.h,z,et)).buffer),xe=await this.g.provideDocumentPasteEdits(Fe,Be,Qe,{only:ee.only?new a.$LN(ee.only):void 0,triggerKind:ee.triggerKind},se);if(!xe||se.isCancellationRequested)return[];const _e=this.d.add(xe);return xe.map((et,tt)=>({_cacheId:[_e,tt],title:et.title??(0,s.localize)(0,null,this.j.displayName||this.j.name),kind:et.kind,yieldTo:et.yieldTo?.map(nt=>nt.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?i.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,L){const[G,H]=z,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const se=await this.g.resolveDocumentPasteEdit(ee,L)??ee;return{additionalEdit:se.additionalEdit?i.WorkspaceEdit.from(se.additionalEdit,void 0):void 0}}releasePasteEdits(z){this.d.delete(z)}}class K{constructor(z,L){this.d=z,this.e=L}async provideDocumentFormattingEdits(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideDocumentFormattingEdits(H,L,G);if(Array.isArray(ee))return ee.map(i.TextEdit.from)}}class ie{constructor(z,L){this.d=z,this.e=L}async provideDocumentRangeFormattingEdits(z,L,G,H){const ee=this.d.getDocument(z),se=i.Range.to(L),Fe=await this.e.provideDocumentRangeFormattingEdits(ee,se,G,H);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,L,G,H){(0,k.$bg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(z),se=L.map(i.Range.to),Fe=await this.e.provideDocumentRangesFormattingEdits(ee,se,G,H);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}}class ce{constructor(z,L){this.d=z,this.e=L,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,L,G,H,ee){const se=this.d.getDocument(z),Fe=i.Position.to(L),Be=await this.e.provideOnTypeFormattingEdits(se,Fe,G,H,ee);if(Array.isArray(Be))return Be.map(i.TextEdit.from)}}class ve{constructor(z,L){this.e=z,this.f=L,this.d=new t.$Zjc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,L){const G=await this.e.provideWorkspaceSymbols(z,L);if(!(0,I.$Lb)(G))return{symbols:[]};const H=this.d.add(G),ee={cacheId:H,symbols:[]};for(let se=0;se<G.length;se++){const Fe=G[se];if(!Fe||!Fe.name){this.f.warn("INVALID SymbolInformation",Fe);continue}ee.symbols.push({...i.WorkspaceSymbol.from(Fe),cacheId:[H,se]})}return ee}async resolveWorkspaceSymbol(z,L){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const G=this.d.get(...z.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,L);return H&&(0,g.$Zn)(z,i.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class Ie{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideRenameEdits(z,L,G,H){const ee=this.d.getDocument(z),se=i.Position.to(L);try{const Fe=await this.e.provideRenameEdits(ee,se,G,H);return Fe?i.WorkspaceEdit.from(Fe):void 0}catch(Fe){const Be=Ie.g(Fe);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(z,L,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(z),ee=i.Position.to(L);try{const se=await this.e.prepareRename(H,ee,G);let Fe,Be;if(a.$TM.isRange(se)?(Fe=se,Be=H.getText(se)):(0,k.$6f)(se)&&(Fe=se.range,Be=se.placeholder),!Fe||!Be)return;if(Fe.start.line>ee.line||Fe.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Fe),text:Be}}catch(se){const Fe=Ie.g(se);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(se)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ue{constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideNewSymbolNames(z,L,G){const H=this.d.getDocument(z),ee=i.Range.to(L);try{const se=await this.e.provideNewSymbolNames(H,ee,G);return se?se.map(Fe=>typeof Fe=="string"?{newSymbolName:Fe}:{newSymbolName:Fe.newSymbolName,tags:Fe.tags}):void 0}catch(se){this.f.error(ue.g(se)??JSON.stringify(se,null,"	"));return}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class pe{constructor(z,L){this.resultId=z,this.tokens=L}}class re{constructor(z,L){this.f=z,this.g=L,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,L,G){const H=this.f.getDocument(z),ee=L!==0?this.d.get(L):null;let se=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return ee&&this.d.delete(L),se?(se=re.h(se),this.o(re.n(ee,se),se)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return re.j(z)?re.k(z)?z:new a.$_N(new Uint32Array(z.data),z.resultId):re.l(z)?re.m(z)?z:new a.$bO(z.edits.map(L=>new a.$aO(L.start,L.deleteCount,L.data?new Uint32Array(L.data):L.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const L of z.edits)if(!(L.data instanceof Uint32Array))return!1;return!0}static n(z,L){if(!re.j(L)||!z||!z.tokens)return L;const G=z.tokens,H=G.length,ee=L.data,se=ee.length;let Fe=0;const Be=Math.min(H,se);for(;Fe<Be&&G[Fe]===ee[Fe];)Fe++;if(Fe===H&&Fe===se)return new a.$bO([],L.resultId);let Qe=0;const xe=Be-Fe;for(;Qe<xe&&G[H-Qe-1]===ee[se-Qe-1];)Qe++;return new a.$bO([{start:Fe,deleteCount:H-Fe-Qe,data:ee.subarray(Fe,se-Qe)}],L.resultId)}o(z,L){if(re.j(z)){const G=this.e++;return this.d.set(G,new pe(z.resultId,z.data)),(0,o.$hbb)({id:G,type:"full",data:z.data})}if(re.l(z)){const G=this.e++;return re.j(L)?this.d.set(G,new pe(L.resultId,L.data)):this.d.set(G,new pe(z.resultId)),(0,o.$hbb)({id:G,type:"delta",deltas:(z.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class Se{constructor(z,L){this.d=z,this.e=L}async provideDocumentRangeSemanticTokens(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideDocumentRangeSemanticTokens(H,i.Range.to(L),G);return ee?this.f(ee):null}f(z){return(0,o.$hbb)({id:0,type:"full",data:z.data})}}class Le{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,L,G,H,ee){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.d=new t.$Zjc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,L,G,H){const ee=this.f.getDocument(z),se=i.Position.to(L),Fe=ee.getWordRangeAtPosition(se)||new a.$TM(se,se),Be=Fe.with({end:se}),Qe=new E.$0d,xe=await this.h.provideCompletionItems(ee,se,H,i.CompletionContext.to(G));if(!xe||H.isCancellationRequested)return;const _e=Array.isArray(xe)?new a.$nN(xe):xe,et=Le.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),tt=new m.$Tc;this.e.set(et,tt);const nt=[],ct={x:et,b:nt,a:{replace:i.Range.from(Fe),insert:i.Range.from(Be)},c:_e.isIncomplete||void 0,d:Qe.elapsed()};for(let ft=0;ft<_e.items.length;ft++){const je=_e.items[ft],st=this.l(je,[et,ft],Be,Fe);nt.push(st)}return ct}async resolveCompletionItem(z,L){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...z);if(!G)return;const H=this.l(G,z),ee=await this.h.resolveCompletionItem(G,L);if(!ee)return;const se=this.l(ee,z);return(H.h!==se.h||H.i!==se.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==se.n||H.o!==se.o||!(0,g.$1n)(H.p,se.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,L,G,H){const ee=this.e.get(L[0]);if(!ee)throw Error("DisposableStore is missing...");const se=this.g.toInternal(z.command,ee),Fe={x:L,a:z.label,b:z.kind!==void 0?i.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(i.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:i.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(i.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe.h=z.textEdit.newText):typeof z.insertText=="string"?Fe.h=z.insertText:z.insertText instanceof a.$3M&&(Fe.h=z.insertText.value,Fe.i|=4);let Be;return z.textEdit?Be=z.textEdit.range:z.range&&(Be=z.range),a.$TM.isRange(Be)?Fe.j=i.Range.from(Be):Be&&(!G?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Fe.j={insert:i.Range.from(Be.inserting),replace:i.Range.from(Be.replacing)}),Fe}}class ne{async provideInlineCompletions(z,L,G,H){}disposeCompletions(z){}handleDidShowCompletionItem(z,L,G){}handlePartialAccept(z,L,G,H){}}class U extends ne{constructor(z,L,G,H){super(),this.f=z,this.g=L,this.h=G,this.j=H,this.d=new be,this.e=(0,h.$xG)(this.f,"inlineCompletionsAdditions"),this.k={[n.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[n.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$xG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,L,G,H){const ee=this.g.getDocument(z),se=i.Position.to(L),Fe=await this.h.provideInlineCompletionItems(ee,se,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:i.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Fe||H.isCancellationRequested)return;const Be=Array.isArray(Fe)?Fe:Fe.items,Qe=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],xe=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:Be}),items:Be.map((tt,nt)=>{let ct;tt.command&&(_e||(_e=new m.$Tc),ct=this.j.toInternal(tt.command,_e));const ft=tt.insertText;return{insertText:typeof ft=="string"?ft:{snippet:ft.value},filterText:tt.filterText,range:tt.range?i.Range.from(tt.range):void 0,command:ct,idx:nt,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:Qe.map(tt=>(_e||(_e=new m.$Tc),this.j.toInternal(tt,_e))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,L,G){const H=this.d.get(z)?.items[L];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(z,L,G,H){const ee=this.d.get(z)?.items[L];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,G),this.h.handleDidPartiallyAcceptCompletionItem(ee,i.PartialAcceptInfo.to(H)))}}class x{async provideInlineEdits(z,L,G){const H=this.f.getDocument(z),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[L.triggerKind]},G);if(!ee||G.isCancellationRequested)return;let se;const Fe=this.d.createReferenceId({dispose(){se?.dispose()},item:ee});let Be;ee.accepted&&(se||(se=new m.$Tc),Be=this.h.toInternal(ee.accepted,se));let Qe;return ee.rejected&&(se||(se=new m.$Tc),Qe=this.h.toInternal(ee.rejected,se)),{pid:Fe,text:ee.text,range:i.Range.from(ee.range),accepted:Be,rejected:Qe}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,L,G,H){this.f=L,this.g=G,this.h=H,this.d=new be,this.e={[n.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[n.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const L=this.e++;return this.d.set(L,z),L}disposeReferenceId(z){const L=this.d.get(z);return this.d.delete(z),L}get(z){return this.d.get(z)}}class Ne{constructor(z,L){this.e=z,this.f=L,this.d=new t.$Zjc("SignatureHelp")}async provideSignatureHelp(z,L,G,H){const ee=this.e.getDocument(z),se=i.Position.to(L),Fe=this.g(G),Be=await this.f.provideSignatureHelp(ee,se,H,Fe);if(Be){const Qe=this.d.add([Be]);return{...i.SignatureHelp.from(Be),id:Qe}}}g(z){let L;if(z.activeSignatureHelp){const G=i.SignatureHelp.to(z.activeSignatureHelp),H=this.d.get(z.activeSignatureHelp.id,0);H?(L=H,L.activeSignature=G.activeSignature,L.activeParameter=G.activeParameter):L=G}return{...z,activeSignatureHelp:L}}releaseSignatureHelp(z){this.d.delete(z)}}class Ee{constructor(z,L,G,H,ee){this.f=z,this.g=L,this.h=G,this.j=H,this.k=ee,this.d=new t.$Zjc("InlayHints"),this.e=new Map}async provideInlayHints(z,L,G){const H=this.f.getDocument(z),ee=i.Range.to(L),se=await this.h.provideInlayHints(H,ee,G);if(!Array.isArray(se)||se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`);return}if(G.isCancellationRequested)return;const Fe=this.d.add(se);this.e.set(Fe,new m.$Tc);const Be={hints:[],cacheId:Fe};for(let Qe=0;Qe<se.length;Qe++)this.l(se[Qe],ee)&&Be.hints.push(this.m(se[Qe],[Fe,Qe]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(L)}`),Be}async resolveInlayHint(z,L){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...z);if(!G)return;const H=await this.h.resolveInlayHint(G,L);if(H&&this.l(H))return this.m(H,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,L){return z.label.length===0||Array.isArray(z.label)&&z.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(L&&!L.contains(z.position))}m(z,L){const G=this.e.get(L[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:L,tooltip:i.MarkdownString.fromStrict(z.tooltip),position:i.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(i.TextEdit.from),kind:z.kind&&i.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")H.label=z.label;else{const ee=[];H.label=ee;for(const se of z.label){if(!se.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Fe={label:se.value,tooltip:i.MarkdownString.fromStrict(se.tooltip)};a.$4M.isLocation(se.location)&&(Fe.location=i.location.from(se.location)),se.command&&(Fe.command=this.g.toInternal(se.command,G)),ee.push(Fe)}}return H}}class $e{constructor(z,L){this.e=z,this.f=L,this.d=new t.$Zjc("DocumentLink")}async provideLinks(z,L){const G=this.e.getDocument(z),H=await this.f.provideDocumentLinks(G,L);if(!(!Array.isArray(H)||H.length===0)&&!L.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter($e.g).map(i.DocumentLink.from)};{const ee=this.d.add(H),se={links:[],cacheId:ee};for(let Fe=0;Fe<H.length;Fe++){if(!$e.g(H[Fe]))continue;const Be=i.DocumentLink.from(H[Fe]);Be.cacheId=[ee,Fe],se.links.push(Be)}return se}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,L){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...z);if(!G)return;const H=await this.f.resolveDocumentLink(G,L);if(!(!H||!$e.g(H)))return i.DocumentLink.from(H)}releaseLinks(z){this.d.delete(z)}}class fe{constructor(z,L){this.d=z,this.e=L}async provideColors(z,L){const G=this.d.getDocument(z),H=await this.e.provideDocumentColors(G,L);return Array.isArray(H)?H.map(se=>({color:i.Color.from(se.color),range:i.Range.from(se.range)})):[]}async provideColorPresentations(z,L,G){const H=this.d.getDocument(z),ee=i.Range.to(L.range),se=i.Color.to(L.color),Fe=await this.e.provideColorPresentations(se,{document:H,range:ee},G);if(Array.isArray(Fe))return Fe.map(i.ColorPresentation.from)}}class Q{constructor(z,L){this.d=z,this.e=L}async provideFoldingRanges(z,L,G){const H=this.d.getDocument(z),ee=await this.e.provideFoldingRanges(H,L,G);if(Array.isArray(ee))return ee.map(i.FoldingRange.from)}}class Y{constructor(z,L,G){this.d=z,this.e=L,this.f=G}async provideSelectionRanges(z,L,G){const H=this.d.getDocument(z),ee=L.map(i.Position.to),se=await this.e.provideSelectionRanges(H,ee,G);if(!(0,I.$Lb)(se))return[];if(se.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let Be=0;Be<ee.length;Be++){const Qe=[];Fe.push(Qe);let xe=ee[Be],_e=se[Be];for(;;){if(!_e.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(_e)),!_e.parent)break;xe=_e.range,_e=_e.parent}}return Fe}}class le{constructor(z,L){this.f=z,this.g=L,this.d=new M.$fP(""),this.e=new Map}async prepareSession(z,L,G){const H=this.f.getDocument(z),ee=i.Position.to(L),se=await this.g.prepareCallHierarchy(H,ee,G);if(!se)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(se)?se.map(Be=>this.h(Fe,Be)):[this.h(Fe,se)]}async provideCallsTo(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,G);if(ee)return ee.map(se=>({from:this.h(z,se.from),fromRanges:se.fromRanges.map(Fe=>i.Range.from(Fe))}))}async provideCallsFrom(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(ee)return ee.map(se=>({to:this.h(z,se.to),fromRanges:se.fromRanges.map(Fe=>i.Range.from(Fe))}))}releaseSession(z){this.e.delete(z)}h(z,L){const G=this.e.get(z),H=i.CallHierarchyItem.from(L,z,G.size.toString(36));return G.set(H._itemId,L),H}j(z,L){return this.e.get(z)?.get(L)}}class de{constructor(z,L){this.f=z,this.g=L,this.d=new M.$fP(""),this.e=new Map}async prepareSession(z,L,G){const H=this.f.getDocument(z),ee=i.Position.to(L),se=await this.g.prepareTypeHierarchy(H,ee,G);if(!se)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(se)?se.map(Be=>this.h(Fe,Be)):[this.h(Fe,se)]}async provideSupertypes(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,G);if(ee)return ee.map(se=>this.h(z,se))}async provideSubtypes(z,L,G){const H=this.j(z,L);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,G);if(ee)return ee.map(se=>this.h(z,se))}releaseSession(z){this.e.delete(z)}h(z,L){const G=this.e.get(z),H=i.TypeHierarchyItem.from(L,z,G.size.toString(36));return G.set(H._itemId,L),H}j(z,L){return this.e.get(z)?.get(L)}}class Te{constructor(z,L,G,H,ee){this.e=z,this.f=L,this.g=G,this.h=H,this.j=ee,this.d=new t.$Zjc("DocumentDropEdit")}async provideDocumentOnDropEdits(z,L,G,H,ee){const se=this.f.getDocument(L),Fe=i.Position.to(G),Be=i.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolveDocumentOnDropFileData(this.h,z,et)).buffer),Qe=await this.g.provideDocumentDropEdits(se,Fe,Be,ee);if(!Qe)return;const xe=(0,I.$3b)(Qe),_e=this.d.add(xe);return xe.map((et,tt)=>({_cacheId:[_e,tt],title:et.title??(0,s.localize)(1,null,this.j.displayName||this.j.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(nt=>nt.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?i.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolveDropEdit(z,L){const[G,H]=z,ee=this.d.get(G,H);if(!ee||!this.g.resolveDocumentDropEdit)return{};const se=await this.g.resolveDocumentDropEdit(ee,L)??ee;return{additionalEdit:se.additionalEdit?i.WorkspaceEdit.from(se.additionalEdit,void 0):void 0}}releaseDropEdits(z){this.d.delete(z)}}class he{constructor(z,L){this.d=z,this.e=L}async provideMappedEdits(z,L,G,H){const ee=u.URI.revive(z),se=this.d.getDocument(ee),Fe=G.documents.map(xe=>xe.map(_e=>({uri:u.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(et=>i.Range.to(et))}))),Be={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(se,L,Be,H);return Qe?i.WorkspaceEdit.from(Qe):null}}class Ce{constructor(z,L){this.adapter=z,this.extension=L}}class Me{static{this.d=0}constructor(z,L,G,H,ee,se,Fe,Be){this.g=L,this.h=G,this.j=H,this.k=ee,this.l=se,this.m=Fe,this.n=Be,this.f=new Map,this.e=z.getProxy(b.$PM.MainThreadLanguageFeatures)}o(z,L){return i.DocumentSelector.from(z,this.g,L)}p(z){return new a.$RM(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Me.d++}async s(z,L,G,H,ee,se=!1){const Fe=this.f.get(z);if(!Fe||!(Fe.adapter instanceof L))return H;const Be=Date.now();se||this.l.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Qe=G(Fe.adapter,Fe.extension);return Promise.resolve(Qe).catch(xe=>{(0,F.$4)(xe)||(this.l.error(`[${Fe.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(Fe.extension.identifier,xe))}).finally(()=>{se||this.l.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),R.CancellationToken.isCancellationToken(ee)?(0,N.$fh)(Qe,ee):Qe}t(z,L){const G=this.q();return this.f.set(G,new Ce(z,L)),G}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,L,G,H){const ee=this.t(new c(this.h,G),z),se=H&&H.label||Me.u(z);return this.e.$registerDocumentSymbolProvider(ee,this.o(L,z),se),this.p(ee)}$provideDocumentSymbols(z,L,G){return this.s(z,c,H=>H.provideDocumentSymbols(u.URI.revive(L),G),void 0,G)}registerCodeLensProvider(z,L,G){const H=this.q(),ee=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ce(new $(this.h,this.j.converter,G,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(H,this.o(L,z),ee);let se=this.p(H);if(ee!==void 0){const Fe=G.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));se=a.$RM.from(se,Fe)}return se}$provideCodeLenses(z,L,G){return this.s(z,$,H=>H.provideCodeLenses(u.URI.revive(L),G),void 0,G)}$resolveCodeLens(z,L,G){return this.s(z,$,H=>H.resolveCodeLens(L,G),void 0,void 0)}$releaseCodeLenses(z,L){this.s(z,$,G=>Promise.resolve(G.releaseCodeLenses(L)),void 0,void 0)}registerDefinitionProvider(z,L,G){const H=this.t(new p(this.h,G),z);return this.e.$registerDefinitionSupport(H,this.o(L,z)),this.p(H)}$provideDefinition(z,L,G,H){return this.s(z,p,ee=>ee.provideDefinition(u.URI.revive(L),G,H),[],H)}registerDeclarationProvider(z,L,G){const H=this.t(new l(this.h,G),z);return this.e.$registerDeclarationSupport(H,this.o(L,z)),this.p(H)}$provideDeclaration(z,L,G,H){return this.s(z,l,ee=>ee.provideDeclaration(u.URI.revive(L),G,H),[],H)}registerImplementationProvider(z,L,G){const H=this.t(new D(this.h,G),z);return this.e.$registerImplementationSupport(H,this.o(L,z)),this.p(H)}$provideImplementation(z,L,G,H){return this.s(z,D,ee=>ee.provideImplementation(u.URI.revive(L),G,H),[],H)}registerTypeDefinitionProvider(z,L,G){const H=this.t(new f(this.h,G),z);return this.e.$registerTypeDefinitionSupport(H,this.o(L,z)),this.p(H)}$provideTypeDefinition(z,L,G,H){return this.s(z,f,ee=>ee.provideTypeDefinition(u.URI.revive(L),G,H),[],H)}registerHoverProvider(z,L,G,H){const ee=this.t(new S(this.h,G),z);return this.e.$registerHoverProvider(ee,this.o(L,z)),this.p(ee)}$provideHover(z,L,G,H){return this.s(z,S,ee=>ee.provideHover(u.URI.revive(L),G,H),void 0,H)}registerEvaluatableExpressionProvider(z,L,G,H){const ee=this.t(new y(this.h,G),z);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(L,z)),this.p(ee)}$provideEvaluatableExpression(z,L,G,H){return this.s(z,y,ee=>ee.provideEvaluatableExpression(u.URI.revive(L),G,H),void 0,H)}registerInlineValuesProvider(z,L,G,H){const ee=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,se=this.t(new C(this.h,G),z);this.e.$registerInlineValuesProvider(se,this.o(L,z),ee);let Fe=this.p(se);if(ee!==void 0){const Be=G.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(ee));Fe=a.$RM.from(Fe,Be)}return Fe}$provideInlineValues(z,L,G,H,ee){return this.s(z,C,se=>se.provideInlineValues(u.URI.revive(L),G,H,ee),void 0,ee)}registerDocumentHighlightProvider(z,L,G){const H=this.t(new P(this.h,G),z);return this.e.$registerDocumentHighlightProvider(H,this.o(L,z)),this.p(H)}registerMultiDocumentHighlightProvider(z,L,G){const H=this.t(new V(this.h,G),z);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(L,z)),this.p(H)}$provideDocumentHighlights(z,L,G,H){return this.s(z,P,ee=>ee.provideDocumentHighlights(u.URI.revive(L),G,H),void 0,H)}$provideMultiDocumentHighlights(z,L,G,H,ee){return this.s(z,V,se=>se.provideMultiDocumentHighlights(u.URI.revive(L),G,H.map(Fe=>u.URI.revive(Fe)),ee),void 0,ee)}registerLinkedEditingRangeProvider(z,L,G){const H=this.t(new W(this.h,G),z);return this.e.$registerLinkedEditingRangeProvider(H,this.o(L,z)),this.p(H)}$provideLinkedEditingRanges(z,L,G,H){return this.s(z,W,async ee=>{const se=await ee.provideLinkedEditingRanges(u.URI.revive(L),G,H);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Me.w(se.wordPattern):void 0}},void 0,H)}registerReferenceProvider(z,L,G){const H=this.t(new q(this.h,G),z);return this.e.$registerReferenceSupport(H,this.o(L,z)),this.p(H)}$provideReferences(z,L,G,H,ee){return this.s(z,q,se=>se.provideReferences(u.URI.revive(L),G,H,ee),void 0,ee)}registerCodeActionProvider(z,L,G,H){const ee=new m.$Tc,se=this.t(new A(this.h,this.j.converter,this.k,G,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(se,this.o(L,z),{providedKinds:H?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:H?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this.j.converter.toInternal(Fe.command,ee)}))},Me.u(z),!!G.resolveCodeAction),ee.add(this.p(se)),ee}$provideCodeActions(z,L,G,H,ee){return this.s(z,A,se=>se.provideCodeActions(u.URI.revive(L),G,H,ee),void 0,ee)}$resolveCodeAction(z,L,G){return this.s(z,A,H=>H.resolveCodeAction(L,G),{},void 0)}$releaseCodeActions(z,L){this.s(z,A,G=>Promise.resolve(G.releaseCodeActions(L)),void 0,void 0)}registerDocumentFormattingEditProvider(z,L,G){const H=this.t(new K(this.h,G),z);return this.e.$registerDocumentFormattingSupport(H,this.o(L,z),z.identifier,z.displayName||z.name),this.p(H)}$provideDocumentFormattingEdits(z,L,G,H){return this.s(z,K,ee=>ee.provideDocumentFormattingEdits(u.URI.revive(L),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(z,L,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",ee=this.t(new ie(this.h,G),z);return this.e.$registerRangeFormattingSupport(ee,this.o(L,z),z.identifier,z.displayName||z.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(z,L,G,H,ee){return this.s(z,ie,se=>se.provideDocumentRangeFormattingEdits(u.URI.revive(L),G,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(z,L,G,H,ee){return this.s(z,ie,se=>se.provideDocumentRangesFormattingEdits(u.URI.revive(L),G,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(z,L,G,H){const ee=this.t(new ce(this.h,G),z);return this.e.$registerOnTypeFormattingSupport(ee,this.o(L,z),H,z.identifier),this.p(ee)}$provideOnTypeFormattingEdits(z,L,G,H,ee,se){return this.s(z,ce,Fe=>Fe.provideOnTypeFormattingEdits(u.URI.revive(L),G,H,ee,se),void 0,se)}registerWorkspaceSymbolProvider(z,L){const G=this.t(new ve(L,this.l),z);return this.e.$registerNavigateTypeSupport(G,typeof L.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(z,L,G){return this.s(z,ve,H=>H.provideWorkspaceSymbols(L,G),{symbols:[]},G)}$resolveWorkspaceSymbol(z,L,G){return this.s(z,ve,H=>H.resolveWorkspaceSymbol(L,G),void 0,void 0)}$releaseWorkspaceSymbols(z,L){this.s(z,ve,G=>G.releaseWorkspaceSymbols(L),void 0,void 0)}registerRenameProvider(z,L,G){const H=this.t(new Ie(this.h,G,this.l),z);return this.e.$registerRenameSupport(H,this.o(L,z),Ie.supportsResolving(G)),this.p(H)}$provideRenameEdits(z,L,G,H,ee){return this.s(z,Ie,se=>se.provideRenameEdits(u.URI.revive(L),G,H,ee),void 0,ee)}$resolveRenameLocation(z,L,G,H){return this.s(z,Ie,ee=>ee.resolveRenameLocation(u.URI.revive(L),G,H),void 0,H)}registerNewSymbolNamesProvider(z,L,G){const H=this.t(new ue(this.h,G,this.l),z);return this.e.$registerNewSymbolNamesProvider(H,this.o(L,z)),this.p(H)}$provideNewSymbolNames(z,L,G,H){return this.s(z,ue,ee=>ee.provideNewSymbolNames(u.URI.revive(L),G,H),void 0,H)}registerDocumentSemanticTokensProvider(z,L,G,H){const ee=this.t(new re(this.h,G),z),se=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(L,z),H,se);let Fe=this.p(ee);if(se){const Be=G.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(se));Fe=a.$RM.from(Fe,Be)}return Fe}$provideDocumentSemanticTokens(z,L,G,H){return this.s(z,re,ee=>ee.provideDocumentSemanticTokens(u.URI.revive(L),G,H),null,H)}$releaseDocumentSemanticTokens(z,L){this.s(z,re,G=>G.releaseDocumentSemanticColoring(L),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,L,G,H){const ee=this.t(new Se(this.h,G),z);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(L,z),H),this.p(ee)}$provideDocumentRangeSemanticTokens(z,L,G,H){return this.s(z,Se,ee=>ee.provideDocumentRangeSemanticTokens(u.URI.revive(L),G,H),null,H)}registerCompletionItemProvider(z,L,G,H){const ee=this.t(new Le(this.h,this.j.converter,G,this.m,z),z);return this.e.$registerCompletionsProvider(ee,this.o(L,z),H,Le.supportsResolving(G),z.identifier),this.p(ee)}$provideCompletionItems(z,L,G,H,ee){return this.s(z,Le,se=>se.provideCompletionItems(u.URI.revive(L),G,H,ee),void 0,ee)}$resolveCompletionItem(z,L,G){return this.s(z,Le,H=>H.resolveCompletionItem(L,G),void 0,G)}$releaseCompletionItems(z,L){this.s(z,Le,G=>G.releaseCompletionItems(L),void 0,void 0)}registerInlineCompletionsProvider(z,L,G,H){const ee=new U(z,this.h,G,this.j.converter),se=this.t(ee,z);return this.e.$registerInlineCompletionsSupport(se,this.o(L,z),ee.supportsHandleEvents,r.$Lm.toKey(z.identifier.value),H?.yieldTo?.map(Fe=>r.$Lm.toKey(Fe))||[]),this.p(se)}$provideInlineCompletions(z,L,G,H,ee){return this.s(z,ne,se=>se.provideInlineCompletions(u.URI.revive(L),G,H,ee),void 0,ee)}$handleInlineCompletionDidShow(z,L,G,H){this.s(z,ne,async ee=>{ee.handleDidShowCompletionItem(L,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,L,G,H,ee){this.s(z,ne,async se=>{se.handlePartialAccept(L,G,H,ee)},void 0,void 0)}$freeInlineCompletionsList(z,L){this.s(z,ne,async G=>{G.disposeCompletions(L)},void 0,void 0)}registerInlineEditProvider(z,L,G){const H=new x(z,this.h,G,this.j.converter),ee=this.t(H,z);return this.e.$registerInlineEditProvider(ee,this.o(L,z),z.identifier),this.p(ee)}$provideInlineEdit(z,L,G,H){return this.s(z,x,ee=>ee.provideInlineEdits(u.URI.revive(L),G,H),void 0,H)}$freeInlineEdit(z,L){this.s(z,x,async G=>{G.disposeEdit(L)},void 0,void 0)}registerSignatureHelpProvider(z,L,G,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,se=this.t(new Ne(this.h,G),z);return this.e.$registerSignatureHelpProvider(se,this.o(L,z),ee),this.p(se)}$provideSignatureHelp(z,L,G,H,ee){return this.s(z,Ne,se=>se.provideSignatureHelp(u.URI.revive(L),G,H,ee),void 0,ee)}$releaseSignatureHelp(z,L){this.s(z,Ne,G=>G.releaseSignatureHelp(L),void 0,void 0)}registerInlayHintsProvider(z,L,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new Ee(this.h,this.j.converter,G,this.l,z),z);this.e.$registerInlayHintsProvider(ee,this.o(L,z),typeof G.resolveInlayHint=="function",H,Me.u(z));let se=this.p(ee);if(H!==void 0){const Fe=G.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));se=a.$RM.from(se,Fe)}return se}$provideInlayHints(z,L,G,H){return this.s(z,Ee,ee=>ee.provideInlayHints(u.URI.revive(L),G,H),void 0,H)}$resolveInlayHint(z,L,G){return this.s(z,Ee,H=>H.resolveInlayHint(L,G),void 0,G)}$releaseInlayHints(z,L){this.s(z,Ee,G=>G.releaseHints(L),void 0,void 0)}registerDocumentLinkProvider(z,L,G){const H=this.t(new $e(this.h,G),z);return this.e.$registerDocumentLinkProvider(H,this.o(L,z),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(z,L,G){return this.s(z,$e,H=>H.provideLinks(u.URI.revive(L),G),void 0,G,L.scheme==="output")}$resolveDocumentLink(z,L,G){return this.s(z,$e,H=>H.resolveLink(L,G),void 0,void 0,!0)}$releaseDocumentLinks(z,L){this.s(z,$e,G=>G.releaseLinks(L),void 0,void 0,!0)}registerColorProvider(z,L,G){const H=this.t(new fe(this.h,G),z);return this.e.$registerDocumentColorProvider(H,this.o(L,z)),this.p(H)}$provideDocumentColors(z,L,G){return this.s(z,fe,H=>H.provideColors(u.URI.revive(L),G),[],G)}$provideColorPresentations(z,L,G,H){return this.s(z,fe,ee=>ee.provideColorPresentations(u.URI.revive(L),G,H),void 0,H)}registerFoldingRangeProvider(z,L,G){const H=this.q(),ee=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ce(new Q(this.h,G),z)),this.e.$registerFoldingRangeProvider(H,this.o(L,z),z.identifier,ee);let se=this.p(H);if(ee!==void 0){const Fe=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));se=a.$RM.from(se,Fe)}return se}$provideFoldingRanges(z,L,G,H){return this.s(z,Q,ee=>ee.provideFoldingRanges(u.URI.revive(L),G,H),void 0,H)}registerSelectionRangeProvider(z,L,G){const H=this.t(new Y(this.h,G,this.l),z);return this.e.$registerSelectionRangeProvider(H,this.o(L,z)),this.p(H)}$provideSelectionRanges(z,L,G,H){return this.s(z,Y,ee=>ee.provideSelectionRanges(u.URI.revive(L),G,H),[],H)}registerCallHierarchyProvider(z,L,G){const H=this.t(new le(this.h,G),z);return this.e.$registerCallHierarchyProvider(H,this.o(L,z)),this.p(H)}$prepareCallHierarchy(z,L,G,H){return this.s(z,le,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(L),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(z,L,G,H){return this.s(z,le,ee=>ee.provideCallsTo(L,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(z,L,G,H){return this.s(z,le,ee=>ee.provideCallsFrom(L,G,H),void 0,H)}$releaseCallHierarchy(z,L){this.s(z,le,G=>Promise.resolve(G.releaseSession(L)),void 0,void 0)}registerTypeHierarchyProvider(z,L,G){const H=this.t(new de(this.h,G),z);return this.e.$registerTypeHierarchyProvider(H,this.o(L,z)),this.p(H)}$prepareTypeHierarchy(z,L,G,H){return this.s(z,de,ee=>Promise.resolve(ee.prepareSession(u.URI.revive(L),G,H)),void 0,H)}$provideTypeHierarchySupertypes(z,L,G,H){return this.s(z,de,ee=>ee.provideSupertypes(L,G,H),void 0,H)}$provideTypeHierarchySubtypes(z,L,G,H){return this.s(z,de,ee=>ee.provideSubtypes(L,G,H),void 0,H)}$releaseTypeHierarchy(z,L){this.s(z,de,G=>Promise.resolve(G.releaseSession(L)),void 0,void 0)}registerDocumentOnDropEditProvider(z,L,G,H){const ee=this.q();return this.f.set(ee,new Ce(new Te(this.e,this.h,G,ee,z),z)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(L,z),(0,h.$xG)(z,"documentPaste")&&H?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(z,L,G,H,ee,se){return this.s(z,Te,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(L,u.URI.revive(G),H,ee,se)),void 0,void 0)}$resolveDropEdit(z,L,G){return this.s(z,Te,H=>H.resolveDropEdit(L,G),{},void 0)}$releaseDropEdits(z,L){this.s(z,Te,G=>Promise.resolve(G.releaseDropEdits(L)),void 0,void 0)}registerMappedEditsProvider(z,L,G){const H=this.t(new he(this.h,G),z);return this.e.$registerMappedEditsProvider(H,this.o(L,z)),this.p(H)}$provideMappedEdits(z,L,G,H,ee){return this.s(z,he,se=>Promise.resolve(se.provideMappedEdits(L,G,H,ee)),null,ee)}registerDocumentPasteEditProvider(z,L,G,H){const ee=this.q();return this.f.set(ee,new Ce(new j(this.e,this.h,G,ee,z),z)),this.e.$registerPasteEditProvider(ee,this.o(L,z),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(se=>se.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(z,L,G,H,ee){return this.s(z,j,se=>se.prepareDocumentPaste(u.URI.revive(L),G,H,ee),void 0,ee)}$providePasteEdits(z,L,G,H,ee,se,Fe){return this.s(z,j,Be=>Be.providePasteEdits(L,u.URI.revive(G),H,ee,se,Fe),void 0,Fe)}$resolvePasteEdit(z,L,G){return this.s(z,j,H=>H.resolvePasteEdit(L,G),{},void 0)}$releasePasteEdits(z,L){this.s(z,j,G=>Promise.resolve(G.releasePasteEdits(L)),void 0,void 0)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:Me.w(z.decreaseIndentPattern),increaseIndentPattern:Me.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Me.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Me.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:Me.w(z.beforeText),afterText:z.afterText?Me.w(z.afterText):void 0,previousLineText:z.previousLineText?Me.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(Me.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(L=>a.SyntaxTokenType.toString(L)):void 0}}static D(z){return z.map(Me.C)}setLanguageConfiguration(z,L,G){const{wordPattern:H}=G;if(H&&(0,T.$ff)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(L,H):this.h.setWordDefinitionFor(L,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const ee=this.q(),se={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Me.w(G.wordPattern):void 0,indentationRules:G.indentationRules?Me.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Me.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Me.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,L,se),this.p(ee)}$setWordDefinitions(z){for(const L of z)this.h.setWordDefinitionFor(L.languageId,new RegExp(L.regexSource,L.regexFlags))}}e.$0jc=Me}),define(Re[88],Ae([1,0,6,4,8,7,101,20,11,5,167,106,14,3,16,84,13]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=e.$Qkc=void 0,e.$Qkc=(0,w.$qi)("IExtHostLanguageModels");class r{constructor(t,b){this.option=t,this.stream=new g.$Th,this.stream=b??new g.$Th}}class i{constructor(){this.a=new Map,this.b=new g.$Th,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let b=this.a.get(t.index);b||(this.a.size===0?b=new r(t.index,this.b):b=new r(t.index),this.a.set(t.index,b)),b.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const b of this.f())b.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let a=class{static{s=this}static{this.a=1}constructor(t,b,c){this.j=b,this.k=c,this.c=new E.$be,this.d=new E.$be,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new m.$Nm,this.i=new Map,this.o=new Set,this.b=t.getProxy(N.$PM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,b,c,$){const v=s.a++;this.f.set(v,{extension:t.identifier,provider:c,languageModelId:b});let p;return $.auth&&(p={providerLabel:t.displayName||t.name,accountLabel:typeof $.auth=="object"?$.auth.label:void 0}),this.b.$registerLanguageModelProvider(v,b,{extension:t.identifier,identifier:b,model:$.name??"",auth:p}),(0,I.$Sc)(()=>{this.f.delete(v),this.b.$unregisterProvider(v)})}async $provideLanguageModelResponse(t,b,c,$,v,p){const l=this.f.get(t);if(!l)return;const D=new M.$Zv(async f=>{if(p.isCancellationRequested){this.j.warn(`[CHAT](${l.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(b,{index:f.index,part:f.part})});return l.provider.provideLanguageModelResponse2($.map(R.LanguageModelMessage.to),v,m.$Lm.toKey(c),D,p)}$updateLanguageModels(t){const b=[],c=[];if(t.added)for(const $ of t.added)this.g.set($.identifier,$),b.push($.model);if(t.removed)for(const $ of t.removed){this.g.delete($),c.push($);for(const[v,p]of this.i)p.languageModelId===$&&(p.res.reject(new u.$5),this.i.delete(v))}this.d.fire(Object.freeze({added:Object.freeze(b),removed:Object.freeze(c)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const b=new Array;for(const{from:c,to:$,enabled:v}of t){const p=this.h.get(c)??new m.$Mm;if(p.has($)!==v){v?p.add($):p.delete($),this.h.set(c,p);const D={from:c,to:$};b.push(D),this.c.fire(D)}}}async sendChatRequest(t,b,c,$,v){const p=t.identifier,l=await this.b.$prepareChatAccess(p,b,$.justification);if(!l||!this.g.has(b))throw F.$ZO.NotFound(`Language model '${b}' is unknown.`);if(this.m(p,l)&&(!await this.l(t,{identifier:l.extension,displayName:l.auth.providerLabel},$.justification,$.silent)||!this.h.get(p)?.has(l.extension)))throw F.$ZO.NoPermissions(`Language model '${b}' cannot be used by '${p.value}'.`);const D=Math.random()*1e6|0,f=this.b.$fetchResponse(p,b,D,c.map(R.LanguageModelMessage.from),$.modelOptions??{},v),S=new g.$ph,y=new i;this.i.set(D,{languageModelId:b,res:y});let C;if(f.catch(P=>{S.isOpen()?y.reject(P):C=P}).finally(()=>{this.i.delete(D),y.resolve(),S.open()}),await S.wait(),C)throw new F.$ZO(`Language model '${b}' errored, check cause for more details`,"Unknown",C);return y.apiObject}async $handleResponseFragment(t,b){const c=this.i.get(t);c&&c.res.handleFragment(b)}async l(t,b,c,$){const v=k.$RL+b.identifier.value;if(await this.k.getSession(t,v,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:b.identifier,enabled:!0}]),!0;if($)return!1;try{const l=c?(0,T.localize)(0,null,b.displayName,c):(0,T.localize)(1,null,b.displayName);return await this.k.getSession(t,v,[],{forceNewSession:{detail:l}}),this.$updateModelAccesslist([{from:t.identifier,to:b.identifier,enabled:!0}]),!0}catch{return!1}}m(t,b){return!!b.auth&&!m.$Lm.equals(b.extension,t)}async n(t){for(const b of this.o)try{await this.l(b,{identifier:t.extension,displayName:""},void 0,!0)}catch(c){this.j.error("Fake Auth request failed"),this.j.error(c)}}createLanguageModelAccessInformation(t){this.o.add(t);const b=this,c=E.Event.signal(E.Event.filter(this.c.event,v=>m.$Lm.equals(v.from,t.identifier))),$=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(c,$)},canSendRequest(v){const p=b.g.get(v);if(!p)return;if(!b.m(t.identifier,p))return!0;const l=b.h.get(t.identifier);if(l)return l.has(p.extension)}}}};e.$Rkc=a,e.$Rkc=a=s=Je([Ve(0,d.$aP),Ve(1,o.$Wj),Ve(2,n.$_jc)],a)}),define(Re[264],Ae([1,0,4,8,7,33,11,6,25]),function(ge,e,I,N,R,F,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlc=void 0;class E{constructor(k,u,w,d){this.c=u,this.d=w,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(I.$PM.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,u){await this.a.$changeLanguage(k,u);const w=this.c.getDocumentData(k);if(!w)throw new Error(`document '${k.toString()}' NOT found`);return w.document}async tokenAtPosition(k,u){const w=k.version,d=N.Position.from(u),n=await this.a.$tokensAtPosition(k.uri,d),o={type:R.StandardTokenType.Other,range:k.getWordRangeAtPosition(u)??new R.$TM(u.line,u.character,u.line,u.character)};if(!n)return o;const s={range:N.Range.to(n.range),type:N.TokenType.to(n.type)};return!s.range.contains(u)||w!==k.version?o:s}createLanguageStatusItem(k,u,w){const d=this.f++,n=this.a,o=this.g,s=`${k.identifier.value}/${u}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(s);const r={selector:w,id:u,name:k.displayName??k.name,severity:R.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const a=new m.$Tc,h=()=>{if(i?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${u}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,M.$sh)(()=>{a.clear(),this.a.$setLanguageStatus(d,{id:s,name:r.name??k.displayName??k.name,source:k.displayName??k.name,selector:N.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===R.LanguageStatusSeverity.Error?F.default.Error:r.severity===R.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:r.command&&this.d.toInternal(r.command,a),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},t={dispose(){a.dispose(),i?.dispose(),n.$removeLanguageStatus(d),o.delete(s)},get id(){return r.id},get name(){return r.name},set name(b){r.name=b,h()},get selector(){return r.selector},set selector(b){r.selector=b,h()},get text(){return r.text},set text(b){r.text=b,h()},set text2(b){(0,g.$yG)(k,"languageStatusText"),r.text=b,h()},get text2(){return(0,g.$yG)(k,"languageStatusText"),r.text},get detail(){return r.detail},set detail(b){r.detail=b,h()},get severity(){return r.severity},set severity(b){r.severity=b,h()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(b){r.accessibilityInformation=b,h()},get command(){return r.command},set command(b){r.command=b,h()},get busy(){return r.busy},set busy(b){r.busy=b,h()}};return h(),t}}e.$wlc=E}),define(Re[265],Ae([1,0,12,2,8,7,83]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=e.$ilc=void 0;class m{constructor(k,u,w,d){this.start=k,this.deletedCount=u,this.deletedItems=w,this.items=d}asApiEvent(){return{range:new F.$gO(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(k){return{EOL:k.eol,lines:k.source,languageId:k.language,uri:k.uri,isDirty:!1,versionId:1}}constructor(k,u,w){this.notebook=k,this.h=u,this.j=w,this.handle=w.handle,this.uri=N.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(R.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(R.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:R.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return k.g},set mime(d){k.g=d},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(w)}return this.f}setOutputs(k){this.a=k.map(R.NotebookCellOutput.to)}setOutputItems(k,u,w){const d=w.map(R.NotebookCellOutputItem.to),n=this.a.find(o=>o.id===k);if(n&&(u||(n.items.length=0),n.items.push(...d),n.items.length>1&&n.items.every(o=>M.$MK(o.mime)))){const o=new Map,s=[];n.items.forEach(r=>{let i;o.has(r.mime)?i=o.get(r.mime):(i=[],o.set(r.mime,i),s.push(r.mime)),i.push(r.data)}),n.items.length=0,s.forEach(r=>{const i=M.$NK(o.get(r));n.items.push({mime:r,data:i.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(R.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$ilc=g;class E{static{this.a=0}constructor(k,u,w,d,n){this.k=k,this.l=u,this.m=w,this.uri=d,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=n.viewType,this.f=Object.freeze(n.metadata??Object.create(null)),this.r([[0,0,n.cells]],!0,void 0),this.g=n.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,u={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===I.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(w){return w=k.n(w),k.b[w].apiCell},getCells(w){return(w?k.p(w):k.b).map(n=>n.apiCell)},save(){return k.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,u,w){this.g=k.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:w});const d={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},n=[];for(const s of k.rawEvents)s.kind===M.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,d.contentChanges):s.kind===M.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,d.contentChanges):s.kind===M.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),n.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===M.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),n.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),n.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===M.NotebookCellsChangeType.ChangeCellContent?n.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),n.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),n.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<n.length;s++){const r=n[s],i=o.get(r.cell);if(i===void 0){const a=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});o.set(r.cell,a-1)}else d.cellChanges[i]={...d.cellChanges[i],...r}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let u=k.start|0,w=k.end|0;return u<0&&(u=0),w>this.b.length&&(w=this.b.length),k.with({start:u,end:w})}p(k){k=this.o(k);const u=[];for(let w=k.start;w<k.end;w++)u.push(this.b[w]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,u,w){if(this.j)return;const d=[],n=[],o=[];if(k.reverse().forEach(s=>{const i=s[2].map(t=>{const b=new g(this,this.l,t);return u||n.push(g.asModelAddData(t)),b}),a=new m(s[0],s[1],[],i),h=this.b.splice(s[0],s[1],...i);for(const t of h)o.push(t.uri),a.deletedItems.push(t.apiCell);d.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:n,removedDocuments:o}),w)for(const s of d)w.push(s.asApiEvent())}s(k,u,w,d){const n=this.b.splice(k,u);this.b.splice(w,0,...n);const o=[new m(k,u,n.map(s=>s.apiCell),[]),new m(w,0,[],n)];for(const s of o)d.push(s.asApiEvent())}t(k,u){this.b[k].setOutputs(u)}u(k,u,w,d){this.b[k].setOutputItems(u,w,d)}v(k,u){const w=this.b[k];w.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(w.uri,u)}w(k,u){const w=this.b[k];w.apiCell.mime=u}x(k,u){this.b[k].setMetadata(u)}y(k,u){this.b[k].setInternalMetadata(u)}getCellFromApiCell(k){return this.b.find(u=>u.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(u=>u.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$jlc=E}),define(Re[266],Ae([1,0,5,2,8,7,34]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ylc=void 0;class m{constructor(E,T,k,u={timeout:1500,errors:3}){this.b=E,this.c=T,this.d=k,this.f=u,this.a=new I.$de}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(T,k,u)=>{const w=function(n){T.call(k,n)};return w.extension=E,this.a.event(w,void 0,u)}}async $participateInSave(E,T,k){const u=N.URI.revive(E),w=this.c.getNotebookDocument(u);if(!w)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:R.TextDocumentSaveReason.to(T)},k,async(o,s)=>{const r=Date.now(),i=await await Promise.resolve(o);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!k.isCancellationRequested&&i&&(i instanceof F.$2M?d.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),k.isCancellationRequested)return!1;if(d.length===0)return!0;const n={edits:[]};for(const o of d){const{edits:s}=R.WorkspaceEdit.from(o);n.edits=n.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(new M.$mw(n))}}e.$ylc=m}),define(Re[112],Ae([1,0,14,8,7]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,g,E,T,k,u){this.id=m,this.f=g,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=T,this.c=u}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(g){this.selections=[g]},get selections(){return m.a},set selections(g){if(!Array.isArray(g)||!g.every(R.$gO.isNotebookRange))throw(0,I.$7)("selections");m.a=g,m.g(g)},get visibleRanges(){return m.b},revealRange(g,E){m.f.$tryRevealRange(m.id,N.NotebookRange.from(g),E??R.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(N.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$klc=F}),define(Re[267],Ae([1,0,5,13,8]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Alc=void 0;let F=class{constructor(m,g){this.c=m,this.d=g,this.a=new I.$be,this.b=new I.$be,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,g);const E=this.d.getEditorById(m);g.visibleRanges&&E._acceptVisibleRanges(g.visibleRanges.ranges.map(R.NotebookRange.to)),g.selections&&E._acceptSelections(g.selections.selections.map(R.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const g in m)this.d.getEditorById(g)._acceptViewColumn(R.ViewColumn.to(m[g]))}};e.$Alc=F,e.$Alc=F=Je([Ve(0,N.$Wj)],F)}),define(Re[268],Ae([1,0,5,4,112]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=void 0;class F{constructor(m,g){this.c=g,this.a=new Map,this.b=m.getProxy(N.$PM.MainThreadNotebookRenderers)}$postRendererMessage(m,g,E){const T=this.c.getEditorById(m);this.a.get(g)?.fire({editor:T.apiEditor,message:E})}createRendererMessaging(m,g){if(!m.contributes?.notebookRenderer?.some(T=>T.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(T,k,u)=>this.d(g).event(T,k,u),postMessage:(T,k)=>{R.$klc.apiEditorsToExtHost.has(T)&&([T,k]=[k,T]);const u=k&&R.$klc.apiEditorsToExtHost.get(k);return this.b.$postMessage(u?.id,g,T)}}}d(m){let g=this.a.get(m);return g||(g=new I.$be({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete(m)}}),this.a.set(m,g),g)}}e.$Dlc=F}),define(Re[269],Ae([1,0,8,101,24,68,14]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=void 0;class m{constructor(k){this.b=0,this.c=new Map,this.a=k}async withProgress(k,u,w){const d=this.b++,{title:n,location:o,cancellable:s}=u,r={label:k.displayName||k.name,id:k.identifier.value};return this.a.$startProgress(d,{location:I.ProgressLocation.from(o),title:n,source:r,cancellable:s},k.isUnderDevelopment?void 0:k.identifier.value).catch(M.$2),this.d(d,w,!!s)}d(k,u,w){let d;w&&(d=new R.$me,this.c.set(k,d));const n=s=>{this.a.$progressEnd(s),this.c.delete(s),d?.dispose()};let o;try{o=u(new E(this.a,k),w&&d?d.token:R.CancellationToken.None)}catch(s){throw n(k),s}return o.then(s=>n(k),s=>n(k)),o}$acceptProgressCanceled(k){const u=this.c.get(k);u&&(u.cancel(),this.c.delete(k))}}e.$Hlc=m;function g(T,k){return T.message=k.message,typeof k.increment=="number"&&(typeof T.increment=="number"?T.increment+=k.increment:T.increment=k.increment),T}class E extends N.$Zv{constructor(k,u){super(w=>this.throttledReport(w)),this.c=k,this.d=u}throttledReport(k){this.c.$progressReport(this.d,k)}}Je([(0,F.$Wh)(100,(T,k)=>g(T,k),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Re[270],Ae([1,0,2,4,11,8]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=void 0;class M{static{this.a=0}constructor(g,E){this.d=E,this.c=new Map,this.b=g.getProxy(N.$PM.MainThreadQuickDiff)}$provideOriginalResource(g,E,T){const k=I.URI.revive(E),u=this.c.get(g);return u?(0,R.$ih)(()=>u.provideOriginalResource(k,T)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(g,E,T,k){const u=M.a++;return this.c.set(u,E),this.b.$registerQuickDiffProvider(u,F.DocumentSelector.from(g,this.d),T,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Ilc=M}),define(Re[271],Ae([1,0,24,5,6,4,2,7,14,18,33,41,25,8]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=d;function d(n,o,s){const r=n.getProxy(F.$PM.MainThreadQuickOpen);class i{constructor(l,D){this.e=new Map,this.f=0,this.a=l,this.b=D}showQuickPick(l,D,f,S=I.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),C=++this.f,P=r.$show(C,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},S),V={},W=P.then(()=>V);return Promise.race([W,y]).then(q=>{if(q===V)return;const A=(0,u.$xG)(l,"quickPickItemTooltip");return y.then(j=>{const K=[];for(let ie=0;ie<j.length;ie++){const ce=j[ie];if(typeof ce=="string")K.push({label:ce,handle:ie});else if(ce.kind===m.QuickPickItemKind.Separator)K.push({type:"separator",label:ce.label});else{ce.tooltip&&!A&&console.warn(`Extension '${l.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`);const ve=ce.iconPath?c(ce.iconPath):void 0;K.push({label:ce.label,iconPath:ve?.iconPath,iconClass:ve?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:A?w.MarkdownString.fromStrict(ce.tooltip):void 0,handle:ie})}}return f&&typeof f.onDidSelectItem=="function"&&(this.c=ie=>{f.onDidSelectItem(j[ie])}),r.$setItems(C,K),P.then(ie=>{if(typeof ie=="number")return j[ie];if(Array.isArray(ie))return ie.map(ce=>j[ce])})})}).then(void 0,q=>{if(!(0,g.$4)(q))return r.$setError(C,q),Promise.reject(q)})}$onItemSelected(l){this.c?.(l)}showInput(l,D=I.CancellationToken.None){return this.d=l?.validateInput,r.$input(l,typeof this.d=="function",D).then(void 0,f=>{if(!(0,g.$4)(f))return Promise.reject(f)})}async $validateInput(l){if(!this.d)return;const D=await this.d(l);if(!D||typeof D=="string")return D;let f;switch(D.severity){case m.InputBoxValidationSeverity.Info:f=T.default.Info;break;case m.InputBoxValidationSeverity.Warning:f=T.default.Warning;break;case m.InputBoxValidationSeverity.Error:f=T.default.Error;break;default:f=D.message?T.default.Error:T.default.Ignore;break}return{content:D.message,severity:f}}async showWorkspaceFolderPick(l,D=I.CancellationToken.None){const f=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!f)return;const S=await this.a.getWorkspaceFolders2();if(S)return S.find(y=>y.uri.toString()===f.uri.toString())}createQuickPick(l){const D=new $(l,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(l){const D=new v(l,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(l,D){this.e.get(l)?._fireDidChangeValue(D)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,D){const f=this.e.get(l);f instanceof $&&f._fireDidChangeActive(D)}$onDidChangeSelection(l,D){const f=this.e.get(l);f instanceof $&&f._fireDidChangeSelection(D)}$onDidTriggerButton(l,D){this.e.get(l)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(l,D,f){const S=this.e.get(l);S instanceof $&&S._fireDidTriggerItemButton(D,f)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class a{static{this.a=1}constructor(l,D){this.x=l,this.y=D,this._id=$.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$be,this.q=new N.$be,this.r=new N.$be,this.s=new N.$be,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((D,f)=>{const S=D===m.$dO.Back?-1:f;this.o.set(S,D)}),this.z({buttons:l.map((D,f)=>({...c(D.iconPath),tooltip:D.tooltip,handle:D===m.$dO.Back?-1:f}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const D=this.o.get(l);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,R.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(l){if(!this.v){for(const D of Object.keys(l)){const f=l[D];this.u[D]=f===void 0?null:f}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function h(p){if(p instanceof m.$NN)return{id:p.id};const l=b(p),D=t(p);return{dark:typeof l=="string"?M.URI.file(l):l,light:typeof D=="string"?M.URI.file(D):D}}function t(p){return typeof p=="object"&&"light"in p?p.light:p}function b(p){return typeof p=="object"&&"dark"in p?p.dark:p}function c(p){const l=h(p);let D,f;return"id"in l?f=k.ThemeIcon.asClassName(l):D=l,{iconPath:D,iconClass:f}}class $ extends a{constructor(l,D){super(l.identifier,D),this.O=l,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$be,this.L=[],this.M=new N.$be,this.N=new N.$be,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((S,y)=>{this.C.set(y,S),this.D.set(S,y)});const D=(0,u.$xG)(this.O,"quickPickItemTooltip"),f=[];for(let S=0;S<l.length;S++){const y=l[S];if(y.kind===m.QuickPickItemKind.Separator)f.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?c(y.iconPath):void 0;f.push({handle:S,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?w.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((P,V)=>({...c(P.iconPath),tooltip:P.tooltip,handle:V}))})}}this.z({items:f})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(l){const D=(0,E.$Hb)(l.map(f=>this.C.get(f)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(l){const D=(0,E.$Hb)(l.map(f=>this.C.get(f)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(l,D){const f=this.C.get(l);if(!f||!f.buttons||!f.buttons.length)return;const S=f.buttons[D];S&&this.N.fire({button:S,item:f})}}class v extends a{constructor(l,D){super(l.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:T.default.Error}):this.z({validationMessage:l.message,severity:l.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new i(o,s)}}),define(Re[272],Ae([1,0,2,5,68,6,11,4,18,143,13,20,41,8,25,12,21]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=e.$Klc=void 0;function r(C){return C instanceof I.URI}function i(C,P){return C.scheme===n.Schemas.file&&P.scheme===n.Schemas.file&&o.$k?C.toString()===P.toString():C.toString().toLowerCase()===P.toString().toLowerCase()}function a(C){if(C)return typeof C.iconPath=="string"?I.URI.file(C.iconPath):I.URI.isUri(C.iconPath)||u.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function h(C){if(C.icon){if(I.URI.isUri(C.icon))return C.icon;if(u.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const P=C.icon;return{light:P.light,dark:P.dark}}}else return}function t(C,P){if(!C.iconPath&&!P.iconPath)return 0;if(C.iconPath){if(!P.iconPath)return 1}else return-1;const V=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,W=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,E.$ir)(V,W)}function b(C,P){let V=0;if(C.strikeThrough!==P.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==P.faded)return C.faded?1:-1;if(C.tooltip!==P.tooltip)return(C.tooltip||"").localeCompare(P.tooltip||"");if(V=t(C,P),V!==0)return V;if(C.light&&P.light)V=t(C.light,P.light);else{if(C.light)return 1;if(P.light)return-1}if(V!==0)return V;if(C.dark&&P.dark)V=t(C.dark,P.dark);else{if(C.dark)return 1;if(P.dark)return-1}return V}function c(C,P){if(C.command!==P.command)return C.command<P.command?-1:1;if(C.title!==P.title)return C.title<P.title?-1:1;if(C.tooltip!==P.tooltip){if(C.tooltip!==void 0&&P.tooltip!==void 0)return C.tooltip<P.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(C.arguments===P.arguments)return 0;if(C.arguments)if(P.arguments){if(C.arguments.length!==P.arguments.length)return C.arguments.length-P.arguments.length}else return 1;else return-1;for(let V=0;V<C.arguments.length;V++){const W=C.arguments[V],q=P.arguments[V];if(W!==q&&!(r(W)&&r(q)&&i(W,q)))return W<q?-1:1}return 0}function $(C,P){let V=(0,E.$ir)(C.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(V!==0)return V;if(C.command&&P.command)V=c(C.command,P.command);else{if(C.command)return 1;if(P.command)return-1}if(V!==0)return V;if(C.decorations&&P.decorations)V=b(C.decorations,P.decorations);else{if(C.decorations)return 1;if(P.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)V=(0,E.$ir)(C.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)V=(0,E.$ir)(C.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return V}function v(C,P){for(let V=0;V<C.length;V++)if(C[V]!==P[V])return!1;return!0}function p(C,P){return C.command===P.command&&C.title===P.title&&C.tooltip===P.tooltip&&(C.arguments&&P.arguments?v(C.arguments,P.arguments):C.arguments===P.arguments)}function l(C,P){return(0,g.$ub)(C,P,p)}class D{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,d.$yG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,d.$yG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,d.$yG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,V,W,q,A){this.k=P,this.l=q,this.m=A,this.d="",this.e=new N.$be,this.f="",this.h=!0,this.j=!0,this.#t=V,this.#e=W}showValidationMessage(P,V){(0,d.$yG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,V)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$Klc=D;class f{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,V,W,q,A,j,K){this.q=P,this.s=V,this.t=W,this.u=q,this.v=A,this.multiDiffEditorEnableViewChanges=j,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$be,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$be,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=f.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,V){const W=this.h.get(P);return W?(0,M.$ih)(()=>this.s.executeCommand(W.command,...W.arguments||[],V)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort($),W=(0,g.$Db)(this.o,P,$).map(j=>{const K=j.toInsert.map(ie=>{const ce=this.e++;this.g.set(ce,ie);const ve=ie.resourceUri;let Ie;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const fe=new F.$Tc;Ie=this.s.converter.toInternal(ie.command,fe),this.j.set(ce,fe)}else this.h.set(ce,ie.command);const ue=(0,d.$xG)(this.w,"scmMultiDiffEditor"),pe=ue?ie.multiDiffEditorOriginalUri:void 0,re=ue?ie.multiFileDiffEditorModifiedUri:void 0,Se=a(ie.decorations),Le=ie.decorations&&a(ie.decorations.light)||Se,ne=ie.decorations&&a(ie.decorations.dark)||Se,U=[Le,ne],x=ie.decorations&&ie.decorations.tooltip||"",be=ie.decorations&&!!ie.decorations.strikeThrough,Ne=ie.decorations&&!!ie.decorations.faded,Ee=ie.contextValue||"";return{rawResource:[ce,ve,U,x,be,Ne,Ee,Ie,pe,re],handle:ce}});return{start:j.start,deleteCount:j.deleteCount,toInsert:K}}),q=W.map(({start:j,deleteCount:K,toInsert:ie})=>[j,K,ie.map(ce=>ce.rawResource)]),A=W.reverse();for(const{start:j,deleteCount:K,toInsert:ie}of A){const ce=ie.map(Ie=>Ie.handle),ve=this.n.splice(j,K,...ce);for(const Ie of ve)this.g.delete(Ie),this.h.delete(Ie),this.j.get(Ie)?.dispose(),this.j.delete(Ie)}return this.o=P,q}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let V;(0,d.$xG)(this.x,"quickDiffProvider")&&(V=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:V})}get historyProvider(){return(0,d.$yG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,d.$yG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new F.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new F.$Tc,this.o=P;const V=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:V})}get actionButton(){return(0,d.$yG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,d.$yG)(this.x,"scmActionButton"),this.p.value=new F.$Tc,this.q=P;const V=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(W=>W.map(q=>this.y.converter.toInternal(q,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:V??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&l(this.t,P))return;this.s.value=new F.$Tc,this.t=P;const V=(P||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:V})}get selected(){return this.u}constructor(P,V,W,q,A,j,K){this.x=P,this.y=q,this.z=A,this.A=j,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$Vc,this.m=void 0,this.n=new F.$Vc,this.o=void 0,this.p=new F.$Vc,this.s=new F.$Vc,this.t=void 0,this.u=!1,this.v=new N.$be,this.onDidChangeSelection=this.v.event,this.w=S.d++,this.C=new Map,this.D=new Set,this.#e=W;const ie=I.URI.from({scheme:n.Schemas.vscodeSourceControl,path:`${A}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new D(P,V,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,A,j,K,ie)}createResourceGroup(P,V,W){const q=(0,d.$xG)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,A=new f(this.#e,this.y,this.w,P,V,q,this.x),j=N.Event.once(A.onDidDispose)(()=>this.C.delete(A));return this.C.set(A,j),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const P=[],V=[];for(const[W,q]of this.C){q.dispose();const A=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});N.Event.once(W.onDidDispose)(()=>{this.D.delete(W),A.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),P.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const j=W._takeResourceStateSnapshot();j.length>0&&V.push([W.handle,j]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,P,V),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(V=>{const W=V._takeResourceStateSnapshot();W.length!==0&&P.push([V.handle,W])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,R.$Vh)(100)],S.prototype,"eventuallyAddResourceGroups",null),Je([(0,R.$Vh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,V,W,q){this.l=V,this.m=W,this.n=q,this.g=new Map,this.h=new k.$Nm,this.j=new N.$be,this.e=P.getProxy(m.$PM.MainThreadSCM),this.f=P.getProxy(m.$PM.MainThreadTelemetry),V.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const j=this.g.get(A.sourceControlHandle);if(!j)return A;const K=j.getResourceGroup(A.groupHandle);return K?K.getResourceState(A.handle):A}else if(A&&A.$mid===4){const j=this.g.get(A.sourceControlHandle);return j?j.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const j=this.g.get(A.handle);return j||A}return A}})}createSourceControl(P,V,W,q){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,V,W,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const A=s.d++,j=new S(P,this.m,this.e,this.l,V,W,q);this.g.set(A,j);const K=this.h.get(P.identifier)||[];return K.push(j),this.h.set(P.identifier,K),j}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const V=this.h.get(P.identifier),W=V&&V[V.length-1];return W&&W.inputBox}$provideOriginalResource(P,V,W){const q=I.URI.revive(V);this.n.trace("ExtHostSCM#$provideOriginalResource",P,q.toString());const A=this.g.get(P);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$ih)(()=>A.quickDiffProvider.provideOriginalResource(q,W)).then(j=>j||null)}$onInputBoxValueChange(P,V){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const W=this.g.get(P);return W&&W.inputBox.$onInputBoxValueChange(V),Promise.resolve(void 0)}$executeResourceCommand(P,V,W,q){this.n.trace("ExtHostSCM#$executeResourceCommand",P,V,W);const A=this.g.get(P);if(!A)return Promise.resolve(void 0);const j=A.getResourceGroup(V);return j?j.$executeResourceCommand(W,q):Promise.resolve(void 0)}$validateInput(P,V,W){this.n.trace("ExtHostSCM#$validateInput",P);const q=this.g.get(P);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,M.$ih)(()=>q.inputBox.validateInput(V,W)).then(A=>{if(!A)return Promise.resolve(void 0);const j=w.MarkdownString.fromStrict(A.message);return j?Promise.resolve([j,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,V,W,q){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(V,W,q)??void 0}async $provideHistoryItems(P,V,W,q){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(V,W,q))?.map(K=>({...K,icon:h(K)}))??void 0}async $provideHistoryItemSummary(P,V,W,q){const A=this.g.get(P)?.historyProvider;if(typeof A?.provideHistoryItemSummary!="function")return;const j=await A.provideHistoryItemSummary(V,W,q);return j?{...j,icon:h(j)}:void 0}async $provideHistoryItemChanges(P,V,W,q){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(V,W,q)??void 0}};e.$Llc=y,e.$Llc=y=s=Je([Ve(3,T.$Wj)],y)}),define(Re[273],Ae([1,0,4,8,2]),function(ge,e,I,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;class F{static{this.a=0}constructor(m,g){this.d=g,this.c=new Map,this.b=m.getProxy(I.$PM.MainThreadShare)}async $provideShare(m,g,E){return await this.c.get(m)?.provideShare({selection:N.Range.to(g.selection),resourceUri:R.URI.revive(g.resourceUri)},E)??void 0}registerShareProvider(m,g){const E=F.a++;return this.c.set(E,g),this.b.$registerShareProvider(E,N.DocumentSelector.from(m,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Mlc=F}),define(Re[274],Ae([1,0,7,4,170,6,8,17]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plc=e.$Olc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$ON("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$ON("statusBarItem.warningForeground")]])}#e;#t;constructor(u,w,d,n,o,s=I.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new F.$Tc,this.#e=u,this.#t=w,o&&n){this.c=(0,I.$qN)(n.identifier,o);const i=d.get(this.c);i&&(s=i.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,r=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(g.a++);this.e=n,this.f=o,this.g=s,this.h=this.u(r)}u(u){if((0,m.$8f)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!g.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new F.$Tc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let w;this.m?w=this.m:w=(0,R.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=g.b.get(this.o.id));const n=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,w,this.k,n,this.r?.internal,d,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Olc=g;class E{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,R.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const w={message:u};return this.b.unshift(w),this.c(),new I.$RM(()=>{const d=this.b.indexOf(w);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class T{constructor(u,w){this.e=new Map,this.a=u.getProxy(N.$PM.MainThreadStatusBar),this.b=w,this.c=new E(this)}$acceptStaticEntries(u){for(const w of u)this.e.set(w.entryId,w)}createStatusBarEntry(u,w,d,n){return new g(this.a,this.b,this.e,u,w,d,n)}setStatusBarMessage(u,w){const d=this.c.setMessage(u);let n;return typeof w=="number"?n=setTimeout(()=>d.dispose(),w):typeof w<"u"&&w.then(()=>d.dispose(),()=>d.dispose()),new I.$RM(()=>{d.dispose(),clearTimeout(n)})}}e.$Plc=T}),define(Re[113],Ae([1,0,29,105,50,75,61,8,2]),function(ge,e,I,N,R,F,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=e.$oP=e.$nP=e.$mP=void 0;const E=(i,a,h,t)=>{let b=a;return{enumerable:!0,configurable:!1,get(){return b},set(c){if(!h(b,c)){const $=b;b=c,i.listener?.(t(c,$))}}}},T=(i,a)=>i===a,k={range:(i,a)=>i===a?!0:!i||!a?!1:i.isEqual(a),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(i,a)=>!(i.length!==a.length||i.some(h=>!a.find(t=>h.id===t.id)))},u=i=>a=>({op:4,update:i(a)}),w=(i,a)=>({range:(()=>{let h;const t=u(b=>({range:I.$kt.lift(m.Range.from(b))}));return{enumerable:!0,configurable:!1,get(){return h},set(b){i.listener?.({op:6}),k.range(h,b)||(h=b,i.listener?.(t(b)))}}})(),label:E(i,a,k.label,u(h=>({label:h}))),description:E(i,void 0,k.description,u(h=>({description:h}))),sortText:E(i,void 0,k.sortText,u(h=>({sortText:h}))),canResolveChildren:E(i,!1,k.canResolveChildren,h=>({op:2,state:h})),busy:E(i,!1,k.busy,u(h=>({busy:h}))),error:E(i,void 0,k.error,u(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:E(i,[],k.tags,(h,t)=>({op:1,new:h.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),d=i=>{const a=R.$BL.fromString(i.extId),h=new o(a.controllerId,a.localId,i.label,g.URI.revive(i.uri)||void 0);return h.range=m.Range.to(i.range||void 0),h.description=i.description||void 0,h.sortText=i.sortText||void 0,h.tags=i.tags.map(t=>m.TestTag.to({id:(0,M.$HL)(t).tagId})),h},n=i=>{let a;for(const h of i.tests){const t=d(h.item);(0,N.$9O)(t).parent=a,a=t}return a};e.$mP=n;class o{constructor(a,h,t,b){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const c=(0,N.$8O)(this,a);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:b,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof s?void 0:c.parent}},children:{value:(0,F.$7O)(c,N.$9O,o),enumerable:!0,writable:!1},...w(c,t)})}}e.$nP=o;class s extends o{constructor(a,h){super(a,a,h,void 0),this._isRoot=!0}}e.$oP=s;class r extends F.$3O{constructor(a,h,t){super({controllerId:a,getDocumentVersion:b=>b&&t.getDocument(b)?.version,getApiFor:N.$9O,getChildren:b=>b.children,root:new s(a,h),toITestItem:m.TestItem.from})}}e.$pP=r}),define(Re[32],Ae([1,0,17,7,8,26,4,18,13,53,29,93,2,6,3,16,113,22,34,42,65,59,62,35]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s,r,i,a,h,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=void 0;let c=class{#e;#t;#i;constructor(f,S,y){this.b=new Map,this.c=new Map,this.#e=f.getProxy(M.$PM.MainThreadCommands),this.d=S,this.#i=y,this.#t=f.getProxy(M.$PM.MainThreadTelemetry),this.converter=new $(this,C=>{const P=this.c.get(C);return P?.result===p.Void?P:void 0},S),this.f=[{processArgument(C){return(0,E.$Zh)(C)}},{processArgument(C){return(0,F.$Yn)(C,function(P){if(T.$kt.isIRange(P))return R.Range.to(P);if(k.$jt.isIPosition(P))return R.Position.to(P);if(T.$kt.isIRange(P.range)&&u.URI.isUri(P.uri))return R.location.to(P);if(P instanceof s.$Ce)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const S=this.registerCommand(!1,f.id,async(...y)=>{const C=f.args.map((V,W)=>{if(!V.validate(y[W]))throw new Error(`Invalid argument '${V.name}' when running '${f.id}', received: ${typeof y[W]=="object"?JSON.stringify(y[W],null,"	"):y[W]} `);return V.convert(y[W])}),P=await this.executeCommand(f.internalId,...C);return f.result.convert(P,y,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new N.$RM(()=>{S.dispose(),this.c.delete(f.id)})}registerCommand(f,S,y,C,P,V){if(this.d.trace("ExtHostCommands#registerCommand",S),!S.trim().length)throw new Error("invalid id");if(this.b.has(S))throw new Error(`command '${S}' already exists`);return this.b.set(S,{callback:y,thisArg:C,metadata:P,extension:V}),f&&this.#e.$registerCommand(S),new N.$RM(()=>{this.b.delete(S)&&f&&this.#e.$unregisterCommand(S)})}executeCommand(f,...S){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,S,!0)}async g(f,S,y){if(this.b.has(f))return this.#e.$fireCommandActivationEvent(f),this.h(f,S,!1);{let C=!1;const P=(0,F.$Yn)(S,function(V){if(V instanceof N.$SM)return R.Position.from(V);if(V instanceof N.$TM)return R.Range.from(V);if(V instanceof N.$4M)return R.location.from(V);if(N.$gO.isNotebookRange(V))return R.NotebookRange.from(V);if(V instanceof ArrayBuffer)return C=!0,s.$Ce.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return C=!0,s.$Ce.wrap(V);if(V instanceof s.$Ce)return C=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(f,C?new r.$mw(P):P,y);return(0,E.$Zh)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(f,S,!1);throw V}}}async h(f,S,y){const C=this.b.get(f);if(!C)throw new Error("Unknown command");const{callback:P,thisArg:V,metadata:W}=C;if(W?.args)for(let A=0;A<W.args.length;A++)try{(0,I.$ig)(S[A],W.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${W.args[A].name}' - ${W.args[A].description}`)}const q=a.$0d.create();try{return await P.apply(V,S)}catch(A){if(f===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...S);j&&(f=j.command)}if(this.d.error(A,f,C.extension?.identifier),!y)throw A;if(C.extension?.identifier){const j=this.#i.onExtensionError(C.extension.identifier,A);this.d.trace("forwarded error to extension?",j,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$bj)(A)),this.id=f,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,f,q.elapsed())}}j(f,S,y){f.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new h.$_o(S),duration:y})}$executeContributedCommand(f,...S){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const y=this.b.get(f);return y?(S=S.map(C=>this.f.reduce((P,V)=>V.processArgument(P,y.extension?.identifier),C)),this.h(f,S,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),this.#e.$getCommands().then(S=>(f&&(S=S.filter(y=>y[0]!=="_")),S))}$getContributedCommandMetadata(){const f=Object.create(null);for(const[S,y]of this.b){const{metadata:C}=y;C&&(f[S]=C)}return Promise.resolve(f)}};e.$vP=c,e.$vP=c=Je([Ve(0,n.$aP),Ve(1,g.$Wj),Ve(2,t.$uP)],c),e.$wP=(0,d.$qi)("IExtHostCommands");class ${constructor(f,S,y){this.d=f,this.f=S,this.g=y,this.delegatingCommandId=`__vsc${(0,b.$Mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,S){if(!f)return;const y={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return y;const C=this.f(f.command);if(C)y.id=C.internalId,y.arguments=C.args.map((P,V)=>P.convert(f.arguments&&f.arguments[V]));else if((0,m.$Lb)(f.arguments)){const P=`${f.command} /${++this.c}`;this.b.set(P,f),S.add((0,w.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),y.$ident=P,y.id=this.delegatingCommandId,y.arguments=[P],this.g.trace("CommandsConverter#CREATE",f.command,P)}return y}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const S=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],S?S.command:"MISSING"),S?this.d.executeCommand(S.command,...S.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.$xP=$;class v{static{this.Uri=new v("uri","Uri of a text document",f=>u.URI.isUri(f),f=>f)}static{this.Position=new v("position","A position in a text document",f=>N.$SM.isPosition(f),R.Position.from)}static{this.Range=new v("range","A range in a text document",f=>N.$TM.isRange(f),R.Range.from)}static{this.Selection=new v("selection","A selection in a text document",f=>N.$UM.isSelection(f),R.Selection.from)}static{this.Number=new v("number","",f=>typeof f=="number",f=>f)}static{this.String=new v("string","",f=>typeof f=="string",f=>f)}static{this.StringArray=v.Arr(v.String)}static Arr(f){return new v(`${f.name}_array`,`Array of ${f.name}, ${f.description}`,S=>Array.isArray(S)&&S.every(y=>f.validate(y)),S=>S.map(y=>f.convert(y)))}static{this.CallHierarchyItem=new v("item","A call hierarchy item",f=>f instanceof N.$cN,R.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new v("item","A type hierarchy item",f=>f instanceof N.$AO,R.TypeHierarchyItem.from)}static{this.TestItem=new v("testItem","A VS Code TestItem",f=>f instanceof o.$nP,R.TestItem.from)}constructor(f,S,y,C){this.name=f,this.description=S,this.validate=y,this.convert=C}optional(){return new v(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,S){return new v(f??this.name,S??this.description,this.validate,this.convert)}}e.$yP=v;class p{static{this.Void=new p("no result",f=>f)}constructor(f,S){this.description=f,this.convert=S}}e.$zP=p;class l{constructor(f,S,y,C,P){this.id=f,this.internalId=S,this.description=y,this.args=C,this.result=P}}e.$AP=l}),define(Re[275],Ae([1,0,18,12,2,87,97,31,32,8,7]),function(ge,e,I,N,R,F,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$jc=void 0;const k=[new g.$AP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of DocumentHighlight-instances.",w(E.DocumentHighlight.to))),new g.$AP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$yP.Uri],new g.$zP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,o)=>{if((0,I.$Kb)(n))return;class s extends T.$0M{static to(i){const a=new s(i.name,E.SymbolKind.to(i.kind),i.containerName||"",new T.$4M(o[0],E.Range.to(i.range)));return a.detail=i.detail,a.range=a.location.range,a.selectionRange=E.Range.to(i.selectionRange),a.children=i.children?i.children.map(s.to):[],a}}return n.map(s.to)})),new g.$AP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$yP.Uri,new g.$yP("options","Formatting options",n=>!0,n=>n)],new g.$zP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new g.$AP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$yP.Uri,g.$yP.Range,new g.$yP("options","Formatting options",n=>!0,n=>n)],new g.$zP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new g.$AP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$yP.Uri,g.$yP.Position,new g.$yP("ch","Trigger character",n=>typeof n=="string",n=>n),new g.$yP("options","Formatting options",n=>!0,n=>n)],new g.$zP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new g.$AP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$AP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$AP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$AP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of Location or LocationLink instances.",d)),new g.$AP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of Location-instances.",w(E.location.to))),new g.$AP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of Hover-instances.",w(E.Hover.to))),new g.$AP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$yP.Uri,new g.$yP("position","A position in a text document",n=>Array.isArray(n)&&n.every(o=>T.$SM.isPosition(o)),n=>n.map(E.Position.from))],new g.$zP("A promise that resolves to an array of ranges.",n=>n.map(o=>{let s;for(const r of o.reverse())s=new T.$bN(E.Range.to(r),s);return s}))),new g.$AP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$yP.String.with("query","Search string")],new g.$zP("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(E.WorkspaceSymbol.to))),new g.$AP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of CallHierarchyItem-instances",n=>n.map(E.CallHierarchyItem.to))),new g.$AP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$yP.CallHierarchyItem],new g.$zP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",n=>n.map(E.CallHierarchyIncomingCall.to))),new g.$AP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$yP.CallHierarchyItem],new g.$zP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",n=>n.map(E.CallHierarchyOutgoingCall.to))),new g.$AP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to a range and placeholder text.",n=>{if(n)return{range:E.Range.to(n.range),placeholder:n.text}})),new g.$AP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$yP.Uri,g.$yP.Position,g.$yP.String.with("newName","The new symbol name")],new g.$zP("A promise that resolves to a WorkspaceEdit.",n=>{if(n){if(n.rejectReason)throw new Error(n.rejectReason);return E.WorkspaceEdit.to(n)}})),new g.$AP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$yP.Uri,g.$yP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$zP("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(E.DocumentLink.to))),new g.$AP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$yP.Uri],new g.$zP("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new T.$0N(n.tokenTypes,n.tokenModifiers)})),new g.$AP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$yP.Uri],new g.$zP("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,M.$ibb)(n);if(o.type==="full")return new T.$_N(o.data,void 0)})),new g.$AP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$yP.Uri,g.$yP.Range.optional()],new g.$zP("A promise that resolves to SemanticTokensLegend.",n=>{if(n)return new T.$0N(n.tokenTypes,n.tokenModifiers)})),new g.$AP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$yP.Uri,g.$yP.Range],new g.$zP("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const o=(0,M.$ibb)(n);if(o.type==="full")return new T.$_N(o.data,void 0)})),new g.$AP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$yP.Uri,g.$yP.Position,g.$yP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$yP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$zP("A promise that resolves to a CompletionList-instance.",(n,o,s)=>{if(!n)return new T.$nN([]);const r=n.suggestions.map(i=>E.CompletionItem.to(i,s));return new T.$nN(r,n.incomplete)})),new g.$AP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$yP.Uri,g.$yP.Position,g.$yP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$zP("A promise that resolves to SignatureHelp.",n=>{if(n)return E.SignatureHelp.to(n)})),new g.$AP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$yP.Uri,g.$yP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$zP("A promise that resolves to an array of CodeLens-instances.",(n,o,s)=>w(r=>new T.$fN(E.Range.to(r.range),r.command&&s.fromInternal(r.command)))(n))),new g.$AP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$yP.Uri,new g.$yP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>T.$TM.isRange(n),n=>T.$UM.isSelection(n)?E.Selection.from(n):E.Range.from(n)),g.$yP.String.with("kind","Code action kind to return code actions for").optional(),g.$yP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$zP("A promise that resolves to an array of Command-instances.",(n,o,s)=>w(r=>{if(r._isSynthetic){if(!r.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(r.command)}else{const i=new T.$_M(r.title,r.kind?new T.$aN(r.kind):void 0);return r.edit&&(i.edit=E.WorkspaceEdit.to(r.edit)),r.command&&(i.command=s.fromInternal(r.command)),i.isPreferred=r.isPreferred,i}})(n))),new g.$AP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$yP.Uri],new g.$zP("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(o=>new T.$tN(E.Range.to(o.range),E.Color.to(o.color))):[])),new g.$AP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$yP("color","The color to show and insert",n=>n instanceof T.$sN,E.Color.from),new g.$yP("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:E.Range.from(n.range)}))],new g.$zP("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(E.ColorPresentation.to):[])),new g.$AP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$yP.Uri,g.$yP.Range],new g.$zP("A promise that resolves to an array of Inlay objects",(n,o,s)=>n.map(E.InlayHint.to.bind(void 0,s)))),new g.$AP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$yP.Uri],new g.$zP("A promise that resolves to an array of FoldingRange objects",(n,o)=>{if(n)return n.map(E.FoldingRange.to)})),new g.$AP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$zP("A promise that resolves to an array of NotebookContentProvider static info objects.",w(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(o=>E.NotebookExclusiveDocumentPattern.to(o))})))),new g.$AP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$yP.Uri,g.$yP.Range,new g.$yP("context","An InlineValueContext",n=>n&&typeof n.frameId=="number"&&n.stoppedLocation instanceof T.$TM,n=>E.InlineValueContext.from(n))],new g.$zP("A promise that resolves to an array of InlineValue objects",n=>n.map(E.InlineValue.to))),new g.$AP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$yP("uriOrString","Uri-instance or string (only http/https)",n=>R.URI.isUri(n)||typeof n=="string"&&(0,N.$Ag)(n,N.Schemas.http,N.Schemas.https),n=>n),new g.$yP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[E.ViewColumn.from(n),void 0]:[E.ViewColumn.from(n.viewColumn),E.TextEditorOpenOptions.from(n)])).optional(),g.$yP.String.with("label","").optional()],g.$zP.Void),new g.$AP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$yP.Uri.with("resource","Resource to open"),g.$yP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$yP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[E.ViewColumn.from(n),void 0]:[E.ViewColumn.from(n.viewColumn),E.TextEditorOpenOptions.from(n)])).optional()],g.$zP.Void),new g.$AP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$yP.Uri.with("left","Left-hand side resource of the diff editor"),g.$yP.Uri.with("right","Right-hand side resource of the diff editor"),g.$yP.String.with("title","Human readable title for the diff editor").optional(),new g.$yP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[E.ViewColumn.from(n.viewColumn),E.TextEditorOpenOptions.from(n)]).optional()],g.$zP.Void),new g.$AP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$yP.String.with("title","Human readable title for the changes editor"),new g.$yP("resourceList","List of resources to compare",n=>{for(const o of n){if(o.length!==3)return!1;const[s,r,i]=o;if(!R.URI.isUri(s)||!R.URI.isUri(r)&&r!==void 0&&r!==null||!R.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},n=>n)],g.$zP.Void),new g.$AP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$yP.Uri,g.$yP.Position],new g.$zP("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(E.TypeHierarchyItem.to))),new g.$AP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$yP.TypeHierarchyItem],new g.$zP("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(E.TypeHierarchyItem.to))),new g.$AP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$yP.TypeHierarchyItem],new g.$zP("A promise that resolves to an array of TypeHierarchyItem-instances",n=>n.map(E.TypeHierarchyItem.to))),new g.$AP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$yP.TestItem],g.$zP.Void),new g.$AP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$yP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$zP.Void),new g.$AP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$yP.String.with("name","The context key name"),new g.$yP("value","The context key value",()=>!0,n=>n)],g.$zP.Void),new g.$AP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$yP.Uri,g.$yP.StringArray,new g.$yP("MappedEditsContext","Mapped Edits Context",n=>E.MappedEditsContext.is(n),n=>E.MappedEditsContext.from(n))],new g.$zP("A promise that resolves to a workspace edit or null",n=>n?E.WorkspaceEdit.to(n):null))];class u{static register(o){k.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",m.$pj)}}e.$$jc=u;function w(n){return o=>{if(Array.isArray(o))return o.map(n)}}function d(n){if(!Array.isArray(n))return;const o=[];for(const s of n)F.$2t(s)?o.push(E.DefinitionLink.to(s)):o.push(E.location.to(s));return o}}),define(Re[276],Ae([1,0,11,6,2,4,32,8,7]),function(ge,e,I,N,R,F,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hlc=void 0;class E{static{this.a=0}constructor(w,d){this.extension=w,this.provider=d,this.handle=E.a++}}class T{constructor(w){this.session=w,this.responses=[]}}class k{static{this.a=0}constructor(w,d,n,o){this.f=n,this.g=o,this.b=new Map,this.d=new Map,this.e=w.getProxy(F.$PM.MainThreadInlineChat),d.registerApiCommand(new M.$AP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$yP("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?m.Range.from(s.initialRange):void 0,initialSelection:g.$UM.isSelection(s.initialSelection)?m.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?m.Position.from(s.position):void 0}})],M.$zP.Void))}registerProvider(w,d,n){const o=new E(w,d);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,n?.label??w.displayName??w.name,w.identifier,typeof d.handleInteractiveEditorResponseFeedback=="function",typeof d.provideFollowups=="function",n?.supportReportIssue??!1),(0,N.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(w,d,n,o){const s=this.b.get(w);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(R.URI.revive(d)),i=m.Selection.to(n),a=await s.provider.prepareInteractiveEditorSession({document:r,selection:i},o);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=k.a++;return this.d.set(h,new T(a)),{id:h,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:m.Range.from(a.wholeRange),message:a.message}}async $provideResponse(w,d,n,o){const s=this.b.get(w);if(!s)return;const r=this.d.get(d.id);if(!r)return;const i={prompt:n.prompt,selection:m.Selection.to(n.selection),wholeRange:m.Range.to(n.wholeRange),attempt:n.attempt,live:n.live,previewDocument:this.f.getDocument(R.URI.revive(n.previewDocument)),withIntentDetection:n.withIntentDetection};let a=!1;const h={report:async D=>{if(!n.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||o.isCancellationRequested||await this.e.$handleProgressChunk(n.requestId,{message:D.message,edits:D.edits?.map(m.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:g.$gN.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(r.session,i,h,o));let b;try{b=await(0,I.$eh)(t,o)}finally{a=!0}if(!b)return;const c=r.responses.push(b)-1,$={wholeRange:m.Range.from(b.wholeRange),placeholder:b.placeholder};if(!k.h(b))return{...$,id:c,type:"editorEdit",message:m.MarkdownString.from(b.contents),edits:[]};const{edits:v,contents:p}=b,l=p!==void 0?m.MarkdownString.from(p):void 0;return v instanceof g.$2M?{...$,id:c,type:"bulkEdit",edits:m.WorkspaceEdit.from(v),message:l}:{...$,id:c,type:"editorEdit",edits:v.map(m.TextEdit.from),message:l}}async $provideFollowups(w,d,n,o){const s=this.b.get(w),r=this.d.get(d),i=r?.responses[n];if(s&&i&&s.provider.provideFollowups){const a=Promise.resolve(s.provider.provideFollowups(r.session,i,o));return(await(0,I.$eh)(a,o))?.map(m.ChatInlineFollowup.from)}}$handleFeedback(w,d,n,o){const s=this.b.get(w),r=this.d.get(d),i=r?.responses[n];if(s&&i){const a=m.InteractiveEditorResponseFeedbackKind.to(o);s.provider.handleInteractiveEditorResponseFeedback?.(r.session,i,a)}}$releaseSession(w,d){}static h(w){return typeof w=="object"&&typeof w.edits=="object"}}e.$hlc=k}),define(Re[277],Ae([1,0,2,32]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulc=void 0;class R{constructor(M,m,g,E,T){this.a=m,this.b=g,this.c=E;const k=new N.$AP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$yP("showOptions","Show Options",u=>!0,u=>u),new N.$yP("resource","Interactive resource Uri",u=>!0,u=>u),new N.$yP("controllerId","Notebook controller Id",u=>!0,u=>u),new N.$yP("title","Interactive editor title",u=>!0,u=>u)],new N.$zP("Notebook and input URI",u=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const w=this.a.getEditorById(u.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri),notebookEditor:w.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(M,m,g,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:g,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$ulc=R}),define(Re[278],Ae([1,0,18,11,24,5,6,28,2,20,13,4,32,8,7,76,219,25,34,220]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=void 0,e.$Clc=v;let a=class{constructor(l,D,f,S,y){this.m=D,this.n=f,this.o=S,this.q=y,this.b=new m.$Bc,this.c=new m.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new F.$be,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=l.getProxy(k.$PM.MainThreadNotebookKernels);const C=new u.$AP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$yP("options","Select kernel options",V=>!0,V=>{if(V&&"notebookEditor"in V&&"id"in V){const W=this.n.getIdByEditor(V.notebookEditor);return{id:V.id,extension:V.extension,notebookEditorId:W}}else if(V&&"notebookEditor"in V){const W=this.n.getIdByEditor(V.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${V.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return V})],u.$zP.Void),P=new u.$AP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$yP.Uri],new u.$zP("A promise that resolves to an array of variables",(V,W)=>V.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(P)}createNotebookController(l,D,f,S,y,C){for(const Se of this.j.values())if(Se.controller.id===D&&E.$Lm.equals(l.identifier,Se.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const P=this.k++,V=this;this.q.trace(`NotebookController[${P}], CREATED by ${l.identifier.value}, ${D}`);const W=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${l.identifier}'`);let q=!1;const A=new F.$be,j=new F.$be,K={id:v(l.identifier,D),notebookType:f,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:S||l.identifier.value,preloads:C?C.map(w.NotebookRendererScript.from):[]};let ie=y??W,ce,ve;this.a.$addKernel(P,K).catch(Se=>{console.log(Se),q=!0});let Ie=0;const ue=()=>{if(q)return;const Se=++Ie;Promise.resolve().then(()=>{Se===Ie&&this.a.$updateKernel(P,K)})},pe=new m.$Bc,re={get id(){return D},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return K.label},set label(Se){K.label=Se??l.displayName??l.name,ue()},get detail(){return K.detail??""},set detail(Se){K.detail=Se,ue()},get description(){return K.description??""},set description(Se){K.description=Se,ue()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(Se){K.supportedLanguages=Se,ue()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(Se){K.supportsExecutionOrder=Se,ue()},get rendererScripts(){return K.preloads?K.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(Se){ie=Se??W},get interruptHandler(){return ce},set interruptHandler(Se){ce=Se,K.supportsInterrupt=!!Se,ue()},set variableProvider(Se){(0,s.$yG)(l,"notebookVariableProvider"),ve=Se,K.hasVariableProvider=!!Se,Se?.onDidChangeVariables(Le=>V.a.$variablesUpdated(Le.uri)),ue()},get variableProvider(){return ve},createNotebookCellExecution(Se){if(q)throw new Error("notebook controller is DISPOSED");if(!pe.has(Se.notebook.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Le=>Le.toString())),new Error(`notebook controller is NOT associated to notebook: ${Se.notebook.uri.toString()}`);return V._createNotebookCellExecution(Se,v(l.identifier,this.id))},createNotebookExecution(Se){if((0,s.$yG)(l,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!pe.has(Se.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(Le=>Le.toString())),new Error(`notebook controller is NOT associated to notebook: ${Se.uri.toString()}`);return V._createNotebookExecution(Se,v(l.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${P}], DISPOSED`),q=!0,this.j.delete(P),A.dispose(),j.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(Se,Le){Le===d.NotebookControllerAffinity2.Hidden&&(0,s.$yG)(l,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(P,Se.uri,Le)},onDidReceiveMessage:j.event,postMessage(Se,Le){return(0,s.$yG)(l,"notebookMessaging"),V.a.$postMessage(P,Le&&V.n.getIdByEditor(Le),Se)},asWebviewUri(Se){return(0,s.$yG)(l,"notebookMessaging"),(0,n.$Gxb)(Se,V.m.remote)}};return this.j.set(P,{extensionId:l.identifier,controller:re,onDidReceiveMessage:j,onDidChangeSelection:A,associatedNotebooks:pe}),re}getIdByController(l){for(const[D,f]of this.j)if(f.controller===l)return v(f.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,D){const f=this.g++,S=this;this.q.trace(`NotebookControllerDetectionTask[${f}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(f,D);const y={dispose:()=>{this.f.delete(f),S.a.$removeKernelDetectionTask(f)}};return this.f.set(f,y),y}registerKernelSourceActionProvider(l,D,f){const S=this.i++,y=typeof f.onDidChangeNotebookKernelSourceActions=="function"?S:void 0,C=this;this.h.set(S,f),this.q.trace(`NotebookKernelSourceActionProvider[${S}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(S,S,D);let P;return y!==void 0&&(P=f.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(S),C.a.$removeKernelSourceActionProvider(S,S),P?.dispose()}}}async $provideKernelSourceActions(l,D){const f=this.h.get(l);if(f){const S=new M.$Tc;return(await f.provideNotebookKernelSourceActions(D)??[]).map(C=>w.NotebookKernelSourceAction.from(C,this.o.converter,S))}return[]}$acceptNotebookAssociation(l,D,f){const S=this.j.get(l);if(S){const y=this.n.getNotebookDocument(g.URI.revive(D));f?S.associatedNotebooks.set(y.uri,!0):S.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,y.uri.toString(),f),S.onDidChangeSelection.fire({selected:f,notebook:y.apiNotebook})}}async $executeCells(l,D,f){const S=this.j.get(l);if(!S)return;const y=this.n.getNotebookDocument(g.URI.revive(D)),C=[];for(const P of f){const V=y.getCell(P);V&&C.push(V.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,y.uri.toString(),C.length),await S.controller.executeHandler.call(S.controller,C,y.apiNotebook,S.controller)}catch(P){this.q.error(`NotebookController[${l}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(l,D,f){const S=this.j.get(l);if(!S)return;const y=this.n.getNotebookDocument(g.URI.revive(D));if(S.controller.interruptHandler)await S.controller.interruptHandler.call(S.controller,y.apiNotebook);else for(const C of f){const P=y.getCell(C);P&&this.b.get(P.uri)?.cancel()}if(S.controller.interruptHandler){const C=this.c.get(y.uri);f.length&&Array.isArray(C)&&C.length&&C.forEach(P=>P.dispose())}}async $provideVariables(l,D,f,S,y,C,P){const V=this.j.get(l);if(!V)return;const W=this.n.getNotebookDocument(g.URI.revive(f)),q=V.controller.variableProvider;if(!q)return;let A;if(S!==void 0){if(A=this.s[S],!A)return}else this.s={};const j=y==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(W.apiNotebook,A,j,C,P);let ie=0;for await(const ce of K){if(P.isCancellationRequested)return;const ve={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,interfaces:ce.variable.interfaces,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:V.extensionId.value};if(this.s[ve.id]=ce.variable,this.a.$receiveVariable(D,ve),ie++>=i.$kib)return}}$acceptKernelMessageFromRenderer(l,D,f){const S=this.j.get(l);if(!S)return;const y=this.n.getEditorById(D);S.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:f}))}$cellExecutionChanged(l,D,f){const y=this.n.getNotebookDocument(g.URI.revive(l)).getCell(D);if(y){const C=f?w.NotebookCellExecutionState.to(f):d.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:y.apiCell,state:C})}}_createNotebookCellExecution(l,D){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const S=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!S)throw new Error("invalid cell");if(this.b.has(S.uri))throw new Error(`duplicate execution for ${S.uri}`);const y=new t(D,S,this.a);this.b.set(S.uri,y);const C=y.onDidChangeState(()=>{y.state===h.Resolved&&(y.dispose(),C.dispose(),this.b.delete(S.uri))});return y.asApiObject()}_createNotebookExecution(l,D){const f=this.n.getNotebookDocument(l.uri),S=l.getCells().find(P=>{const V=f.getCellFromApiCell(P);return V&&this.b.has(V.uri)});if(S)throw new Error(`duplicate cell execution for ${S.document.uri}`);if(this.c.has(f.uri))throw new Error(`duplicate notebook execution for ${f.uri}`);const y=new c(D,f,this.a),C=y.onDidChangeState(()=>{y.state===b.Resolved&&(y.dispose(),C.dispose(),this.c.delete(f.uri))});return this.c.set(f.uri,[y,C]),y.asApiObject()}};e.$Blc=a,e.$Blc=a=Je([Ve(4,T.$Wj)],a);var h;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(h||(h={}));class t extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(l,D,f){super(),this.m=D,this.n=f,this.b=t.a++,this.c=new F.$be,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new R.$me),this.h=new $(10,S=>this.s(S)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const D=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new r.$mw(D))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let D=this.m;if(l&&(D=this.m.notebook.getCellFromApiCell(l)),!D)throw new Error("INVALID cell");return D.handle}y(l){return l.map(D=>{const f=d.$kO.ensureUniqueMimeTypes(D.items,!0);return f===D.items?w.NotebookCellOutput.from(D):w.NotebookCellOutput.from({items:f,id:D.id,metadata:D.metadata})})}async z(l,D,f){const S=this.w(D),y=this.y((0,I.$3b)(l));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:S,append:f,outputs:y})}async C(l,D,f){return l=d.$kO.ensureUniqueMimeTypes((0,I.$3b)(l),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:l.map(w.NotebookCellOutputItem.from),outputId:D.id,append:f})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(f){l.j=f,l.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(f){if(l.f===h.Resolved||l.f===h.Started)throw new Error("Cannot call start again");l.f=h.Started,l.c.fire(),l.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,S,y){if(l.f===h.Resolved)throw new Error("Cannot call resolve twice");l.f=h.Resolved,l.c.fire(),l.h.flush();const C=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;l.n.$completeExecution(l.b,new r.$mw({runEndTime:S,lastRunSuccess:f,error:C}))},clearOutput(f){return l.t(),l.z([],f,!1)},appendOutput(f,S){return l.t(),l.z(f,S,!0)},replaceOutput(f,S){return l.t(),l.z(f,S,!1)},appendOutputItems(f,S){return l.t(),l.C(f,S,!0)},replaceOutputItems(f,S){return l.t(),l.C(f,S,!1)}})}}var b;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(b||(b={}));class c extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(l,D,f){super(),this.h=D,this.j=f,this.b=c.a++,this.c=new F.$be,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new R.$me),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===b.Resolved||this.f===b.Started)throw new Error("Cannot call start again");this.f=b.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===b.Resolved)throw new Error("Cannot call resolve twice");this.f=b.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class ${constructor(l,D){this.f=l,this.g=D,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new N.$Nh,this.b=Date.now(),(0,N.$rh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>l.complete())}}function v(p,l){return`${p.value}/${l}`}}),define(Re[51],Ae([1,0,5,4,3,2,16,6,7,172,14,201,24,35,202,41,11,8,32]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=e.$Okc=e.$Nkc=e.$Mkc=void 0,e.$Mkc=(0,R.$qi)("IExtHostTerminalService");class i extends m.$Uc{constructor(f,S,y,C){super(),this.u=f,this._id=S,this.w=y,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new I.$be),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(V=>this.g=V);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(V,W=!0){P.C(),P.u.$sendText(P._id,V,W)},show(V){P.C(),P.u.$show(P._id,V)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??S?.cwd??void 0,env:f.env??void 0,icon:v(f.iconPath)??void 0,color:n.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:S?.forceShellIntegration??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this.z(f.location,S?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,S,y,C,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:n.ThemeColor.isThemeColor(P)?P.id:void 0,location:S?.location||this.z(f,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,S){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in f?{viewColumn:s.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,S){this.j=Object.freeze({code:f,reason:S})}setDimensions(f,S){return f===this.f&&S===this.h||f===0||S===0?!1:(this.f=f,this.h=S,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(S=>{S!==f&&(this.b=Promise.resolve(f))})}}e.$Nkc=i;class a{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new I.$be,this.onProcessData=this.a.event,this.b=new I.$be,this.d=new I.$be,this.onDidChangeProperty=this.d.event,this.f=new I.$be,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${S}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,S){this.g.setDimensions?.({columns:f,rows:S})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(S=>this.a.fire(S)),this.g.onDidClose?.((S=void 0)=>{this.f.fire(S===void 0?void 0:S)}),this.g.onDidOverrideDimensions?.(S=>{S&&this.d.fire({type:"overrideDimensions",value:{cols:S.columns,rows:S.rows}})}),this.g.onDidChangeName?.(S=>{this.d.fire({type:"title",value:S})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends m.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,S,y){super(),this.Q=S,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$be,this.onDidCloseTerminal=this.H.event,this.I=new I.$be,this.onDidOpenTerminal=this.I.event,this.J=new I.$be,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$be,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$be,this.onDidChangeTerminalState=this.M.event,this.N=new I.$be,this.onDidChangeShell=this.N.event,this.O=new I.$be({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$be({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(N.$PM.MainThreadTerminalService),this.y=new d.$Fsb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:C=>{const P=V=>{const W=V;return this.getTerminalById(W.instanceId)?.value};switch(C?.$mid){case 15:return P(C);default:{if(Array.isArray(C))for(let V=0;V<C.length&&C[V].$mid===15;V++)C[V]=P(C[V]);return C}}}}),this.B({dispose:()=>{for(const[C,P]of this.g)P.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,S){const y=new i(this.a,(0,w.$Mg)(),f,f.name),C=new a(f.pty);return y.createExtensionTerminal(f.location,S,this.R(f,S).resolvedExtHostIdentifier,v(f.iconPath),p(f.color)).then(P=>{const V=this.S(P,C);this.h[P]=V}),this.f.push(y),y.value}R(f,S){if(S=S||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const y=f.location.parentTerminal;if(y){const C=this.f.find(P=>P.value===y);C&&(S.resolvedExtHostIdentifier=C._id)}}else f.location&&typeof f.location!="object"?S.location=f.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(f,S){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const C=new a(S),P=this.S(f,C);this.h[f]=P}async $acceptActiveTerminalChanged(f){const S=this.b;if(f===null){this.b=void 0,S!==this.b&&this.J.fire(this.b);return}const y=this.getTerminalById(f);y&&(this.b=y,S!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,S){const y=this.getTerminalById(f);y&&this.O.fire({terminal:y.value,data:S})}async $acceptTerminalDimensions(f,S,y){const C=this.getTerminalById(f);C&&C.setDimensions(S,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(f,S){const y=this.getTerminalById(f);y&&this.P.fire({terminal:y.value,...S})}async $acceptTerminalMaximumDimensions(f,S,y){this.g.get(f)?.resize(S,y)}async $acceptTerminalTitleChange(f,S){const y=this.getTerminalById(f);y&&(y.name=S)}async $acceptTerminalClosed(f,S,y){const C=this.X(this.f,f);if(C!==null){const P=this.f.splice(C,1)[0];P.setExitStatus(S,y),this.H.fire(P.value)}}$acceptTerminalOpened(f,S,y,C){if(S){const W=this.X(this.f,S);if(W!==null){this.f[W]._id=f,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const P={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:F.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},V=new i(this.a,f,P,y);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(f,S){this.getTerminalById(f)?._setProcessId(S)}async $startExtensionTerminal(f,S){const y=this.getTerminalById(f);if(!y)return{message:(0,E.localize)(0,null,f)};y.isOpen||await new Promise(P=>{const V=this.onDidOpenTerminal(async W=>{W===y.value&&(V.dispose(),P())})});const C=this.g.get(f);C?C.startSendingEvents(S):this.j[f]={initialDimensions:S}}S(f,S){const y=new m.$Tc;y.add(S.onProcessReady(P=>this.a.$sendProcessReady(f,P.pid,P.cwd,P.windowsPty))),y.add(S.onDidChangeProperty(P=>this.a.$sendProcessProperty(f,P))),this.y.startBuffering(f,S.onProcessData),y.add(S.onProcessExit(P=>this.U(f,P))),this.g.set(f,S);const C=this.j[f];return C&&S instanceof a&&(S.startSendingEvents(C.initialDimensions),delete this.j[f]),y}$acceptProcessAckDataEvent(f,S){this.g.get(f)?.acknowledgeDataEvent(S)}$acceptProcessInput(f,S){this.g.get(f)?.input(S)}$acceptTerminalInteraction(f){const S=this.getTerminalById(f);S?.setInteractedWith()&&this.M.fire(S.value)}$acceptTerminalSelection(f,S){this.getTerminalById(f)?.setSelection(S)}$acceptProcessResize(f,S,y){try{this.g.get(f)?.resize(S,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(f,S){this.g.get(f)?.shutdown(S)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(S=>this.a.$sendProcessProperty(f,{type:"initialCwd",value:S}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(S=>this.a.$sendProcessProperty(f,{type:"cwd",value:S}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new g.$RM(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,S,y){if(this.C.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this.C.set(S,y),this.a.$registerProfileProvider(S,f.identifier.value),new g.$RM(()=>{this.C.delete(S),this.a.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(f,S,y){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,y),this.a.$registerQuickFixProvider(f,S),new g.$RM(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,S){const y=new u.$me().token;if(y.isCancellationRequested)return;const C=this.D.get(f);if(!C)return;const P=await C.provideTerminalQuickFixes(S,y);if(P===null||Array.isArray(P)&&P.length===0)return;const V=new m.$Tc;if(this.w.value=V,!Array.isArray(P))return P?s.TerminalQuickFix.from(P,this.Q.converter,V):void 0;const W=[];for(const q of P){const A=s.TerminalQuickFix.from(q,this.Q.converter,V);A&&W.push(A)}return W}async $createContributedProfileTerminal(f,S){const y=new u.$me().token;let C=await this.C.get(f)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,S);return}this.createTerminalFromOptions(C.options,S)}}async $provideLinks(f,S){const y=this.getTerminalById(f);if(!y)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const P=new u.$me;this.G.set(f,P);const V=[],W={terminal:y.value,line:S},q=[];for(const K of this.z)q.push(o.Promises.withAsyncBody(async ie=>{P.token.onCancellationRequested(()=>ie({provider:K,links:[]}));const ce=await K.provideTerminalLinks(W,P.token)||[];P.token.isCancellationRequested||ie({provider:K,links:ce})}));const A=await Promise.all(q);if(P.token.isCancellationRequested)return[];const j=new Map;for(const K of A)K&&K.links.length>0&&V.push(...K.links.map(ie=>{const ce={id:h++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return j.set(ce.id,{provider:K.provider,link:ie}),ce}));return this.F.set(f,j),V}$activateLink(f,S){const y=this.F.get(f)?.get(S);y&&y.provider.handleTerminalLink(y.link)}U(f,S){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const y=this.h[f];y&&(y.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,S)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const S=this.f.findIndex(y=>y.value===f);return S>=0?S:null}W(f,S){const y=this.X(f,S);return y!==null?f[y]:null}X(f,S){const y=f.findIndex(C=>C._id===S);return y>=0?y:null}getEnvironmentVariableCollection(f){let S=this.n.get(f.identifier.value);return S||(S=new b,this.Z(f.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}Y(f,S){const y=(0,k.$cs)(S.map),C=(0,k.$ds)(S.descriptionMap);this.a.$setEnvironmentVariableCollection(f,S.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(f){f.forEach(S=>{const y=S[0],C=new b(S[1]);this.Z(y,C)})}$acceptDefaultProfile(f,S){const y=this.s;this.s=f,this.u=S,y?.path!==f.path&&this.N.fire(f.path)}Z(f,S){this.n.set(f,S),S.onDidChangeCollection(()=>{this.Y(f,S)})}};e.$Okc=t,e.$Okc=t=Je([Ve(1,r.$wP),Ve(2,M.$aP)],t);class b{get persistent(){return this.b}set persistent(f){this.b=f,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(f){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$be,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const S=this.h(f);let y=this.a.get(S);return y||(y=new c(this,f),this.a.set(S,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(f,S,y,C){this.f(f,{value:S,type:g.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(f,S,y,C){this.f(f,{value:S,type:g.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(f,S,y,C){this.f(f,{value:S,type:g.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(f,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(f,S.scope),C=this.map.get(y),P=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==S.value||C.type!==S.type||C.options?.applyAtProcessCreation!==P.applyAtProcessCreation||C.options?.applyAtShellIntegration!==P.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const V=this.g(f,S.scope),W={variable:f,...S,options:P};this.map.set(V,W),this.d.fire()}}get(f,S){const y=this.g(f,S),C=this.map.get(y);return C?l(C):void 0}g(f,S){const y=this.h(S);return y.length?`${f}:::${y}`:f}h(f){return this.j(f?.workspaceFolder)??""}j(f){return f?f.uri.toString():void 0}getVariableMap(f){const S=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(f)&&S.set(C.variable,l(C));return S}delete(f,S){const y=this.g(f,S);this.map.delete(y),this.d.fire()}clear(f){if(f?.workspaceFolder){for(const[S,y]of this.map)y.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(S);this.k(f)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(f,S){const y=this.h(S),C=this.descriptionMap.get(y);if(!C||C.description!==f){let P;typeof f=="string"?P=f:P=f?.value.split(`

`)[0];const V={description:P,scope:S};this.descriptionMap.set(y,V),this.d.fire()}}getDescription(f){const S=this.h(f);return this.descriptionMap.get(S)?.description}k(f){const S=this.h(f);this.descriptionMap.delete(S)}}class c{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,S){this.b=f,this.d=S,this.a=new I.$be}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,S,y){this.b.replace(f,S,y,this.d)}append(f,S,y){this.b.append(f,S,y,this.d)}prepend(f,S,y){this.b.prepend(f,S,y,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,S){this.b.getVariableMap(this.d).forEach((y,C)=>f.call(S,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let $=class extends t{constructor(f,S){super(!1,f,S)}createTerminal(f,S,y){throw new T.$_}createTerminalFromOptions(f,S){throw new T.$_}};e.$Pkc=$,e.$Pkc=$=Je([Ve(0,r.$wP),Ve(1,M.$aP)],$);function v(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function p(D){return n.ThemeColor.isThemeColor(D)?D:void 0}function l(D){const f={...D};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Re[114],Ae([1,0,6,3,4,16,51,5,2,11]),function(ge,e,I,N,R,F,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=e.$Tlc=void 0,e.$Tlc=(0,N.$qi)("IExtHostTerminalShellIntegration");let T=class extends I.$Uc{constructor(n,o){super(),this.h=o,this.b=new Map,this.c=new m.$be,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$be,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$be,this.onDidEndTerminalShellExecution=this.g.event,this.a=n.getProxy(R.$PM.MainThreadTerminalShellIntegration),this.B((0,I.$Sc)(()=>{for(const[s,r]of this.b)r.dispose();this.b.clear()}))}$shellIntegrationChange(n){const o=this.h.getTerminalById(n);if(!o)return;const s=o.value;let r=this.b.get(n);r||(r=new k(o.value,this.f),this.b.set(n,r),r.store.add(o.onWillDispose(()=>this.b.get(n)?.dispose())),r.store.add(r.onDidRequestShellExecution(i=>this.a.$executeCommand(n,i))),r.store.add(r.onDidRequestEndExecution(i=>this.g.fire(i))),r.store.add(r.onDidRequestChangeShellIntegration(i=>this.c.fire(i))),o.shellIntegration=r.value),this.c.fire({terminal:s,shellIntegration:r.value})}$shellExecutionStart(n,o,s){this.b.has(n)||this.$shellIntegrationChange(n),this.b.get(n)?.startShellExecution(o,s)}$shellExecutionEnd(n,o,s){this.b.get(n)?.endShellExecution(o,s)}$shellExecutionData(n,o){this.b.get(n)?.emitData(o)}$cwdChange(n,o){this.b.get(n)?.setCwd(o)}$closeTerminal(n){this.b.get(n)?.dispose(),this.b.delete(n)}};e.$Ulc=T,e.$Ulc=T=Je([Ve(0,F.$aP),Ve(1,M.$Mkc)],T);class k extends I.$Uc{get currentExecution(){return this.a}constructor(n,o){super(),this.j=n,this.m=o,this.b=!1,this.store=this.B(new I.$Tc),this.f=this.B(new m.$be),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$be),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$be),this.onDidRequestEndExecution=this.h.event;const s=this;this.value={get cwd(){return s.c},executeCommand(r){s.g.fire(r);const i=s.startShellExecution(r,s.c,!0).value;return s.b=!0,i}}}startShellExecution(n,o,s){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0,void 0),this.h.fire({execution:this.a.value,exitCode:void 0}));const r=this.a=new u(this.j,n,o);s?queueMicrotask(()=>this.m.fire(r.value)):this.m.fire(this.a.value)}return this.a}emitData(n){this.currentExecution?.emitData(n)}endShellExecution(n,o){this.a&&(this.a.endExecution(n,o),this.h.fire({execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(n){let o=!1;g.URI.isUri(this.c)?o=!g.URI.isUri(n)||this.c.toString()!==n.toString():this.c!==n&&(o=!0),o&&(this.c=n,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class u{constructor(n,o,s){this.terminal=n,this.c=o,this.cwd=s,this.b=!1;const r=this;this.value={get terminal(){return r.terminal},get commandLine(){return r.c},get cwd(){return r.cwd},readData(){return r.d()}}}d(){if(!this.a){if(this.b)return E.$Qh.EMPTY;this.a=new w}return this.a.createIterable()}emitData(n){this.a?.emitData(n)}endExecution(n,o){n&&(this.c=n),this.a?.endExecution(),this.a=void 0,this.b=!0}}class w extends I.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){const n=this.a=new E.$ph;return new E.$Qh(async s=>{this.b.push(s),await n.wait()})}emitData(n){for(const o of this.b)o.emitOne(n)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Re[279],Ae([1,0,11,22,24,5,251,99,6,17,35,13,4,16,113,8,7,50,75,61]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ylc=e.$Xlc=e.$Wlc=e.$Vlc=void 0;let a=class extends g.$Uc{constructor(P,V,W,q){super(),this.w=q,this.f=this.B(new F.$be),this.g=new Map,this.s=this.B(new F.$be),this.onResultsChanged=this.f.event,this.results=[],this.h=P.getProxy(u.$PM.MainThreadTesting),this.m=new D(this.h),this.j=new c(this.h,V),W.registerArgumentProcessor({processArgument:A=>{switch(A?.$mid){case 16:{const j=A,K=j.tests[j.tests.length-1].item.extId;return this.g.get(s.$BL.root(K))?.collection.tree.get(K)?.actual??(0,d.$mP)(A)}case 18:{const{test:j,message:K}=A,ie=j.item.extId;return{test:this.g.get(s.$BL.root(ie))?.collection.tree.get(ie)?.actual??(0,d.$mP)({$mid:16,tests:[j]}),message:n.TestMessage.to(K)}}default:return A}}}),W.registerCommand(!1,"testing.getExplorerSelection",async()=>{const A=await W.executeCommand("_testing.getExplorerSelection"),j=K=>{const ie=this.g.get(s.$BL.root(K));if(ie)return s.$BL.isRoot(K)?ie.controller:ie.collection.tree.get(K)?.actual};return{include:A?.include.map(j).filter(E.$_f)||[],exclude:A?.exclude.map(j).filter(E.$_f)||[]}})}createTestController(P,V,W,q){if(this.g.has(V))throw new Error(`Attempt to insert a duplicate controller with ID "${V}"`);const A=new g.$Tc,j=A.add(new d.$pP(V,W,this.w));j.root.label=W;const K=new Map,ie=new Set,ce=this.h,ve={items:j.root.children,get label(){return W},set label(ue){W=ue,j.root.label=ue,ce.$updateController(V,{label:W})},get refreshHandler(){return q},set refreshHandler(ue){q=ue,ce.$updateController(V,{canRefresh:!!ue})},get id(){return V},createRunProfile:(ue,pe,re,Se,Le,ne)=>{let U=(0,m.$ej)(ue);for(;K.has(U);)U++;return new S(this.h,K,ie,this.s.event,V,U,ue,pe,re,Se,Le,ne)},createTestItem(ue,pe,re){return new d.$nP(V,ue,pe,re)},createTestRun:(ue,pe,re=!0)=>this.j.createTestRun(V,j,ue,pe,re),invalidateTestResults:ue=>{if(ue===void 0)this.h.$markTestRetired(void 0);else{const pe=ue instanceof Array?ue:[ue];this.h.$markTestRetired(pe.map(re=>s.$BL.fromExtHostTestItem(re,V).toString()))}},set resolveHandler(ue){j.resolveHandler=ue},get resolveHandler(){return j.resolveHandler},dispose:()=>{A.dispose()}};ce.$registerTestController(V,W,!!q),A.add((0,g.$Sc)(()=>ce.$unregisterTestController(V)));const Ie={controller:ve,collection:j,profiles:K,extension:P,activeProfiles:ie};return this.g.set(V,Ie),A.add((0,g.$Sc)(()=>this.g.delete(V))),A.add(j.onDidGenerateDiff(ue=>ce.$publishDiff(V,ue.map(i.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(P,V=R.CancellationToken.None){const W=$(P);if(!W)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(W.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:P.include?.map(A=>s.$BL.fromExtHostTestItem(A,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:y[W.kind],profileId:W.profileId,controllerId:W.controllerId}],exclude:P.exclude?.map(A=>A.id)},V)}$syncTests(){for(const{collection:P}of this.g.values())P.flushDiff();return Promise.resolve()}async $getCoverageDetails(P,V){return(await this.j.getCoverageDetails(P,V))?.map(n.TestCoverage.fromDetails)}async $disposeRun(P){this.j.disposeTestRun(P)}$configureRunProfile(P,V){this.g.get(P)?.profiles.get(V)?.configureHandler?.()}$setDefaultRunProfiles(P){const V=new Map;for(const[W,q]of Object.entries(P)){const A=this.g.get(W);if(!A)continue;const j=new Map,K=q.filter(ce=>!A.activeProfiles.has(ce)),ie=[...A.activeProfiles].filter(ce=>!q.includes(ce));for(const ce of K)j.set(ce,!0),A.activeProfiles.add(ce);for(const ce of ie)j.set(ce,!1),A.activeProfiles.delete(ce);j.size&&V.set(W,j)}this.s.fire(V)}async $refreshTests(P,V){await this.g.get(P)?.controller.refreshHandler?.(V)}$publishTestResults(P){this.results=Object.freeze(P.map(n.TestResults.to).concat(this.results).sort((V,W)=>W.completedAt-V.completedAt).slice(0,32)),this.f.fire()}async $expandTest(P,V){const W=this.g.get(s.$BL.fromString(P).controllerId)?.collection;W&&(await W.expand(P,V<0?1/0:V),W.flushDiff())}$acceptDiff(P){this.m.applyDiff(P.map(V=>i.TestsDiffOp.deserialize({asCanonicalUri:W=>W},V)))}async $runControllerTests(P,V){return Promise.all(P.map(W=>this.y(W,!1,V)))}async $startContinuousRun(P,V){const W=new R.$me(V),q=await Promise.all(P.map(A=>this.y(A,!0,W.token)));return!V.isCancellationRequested&&!q.some(A=>A.error)&&await new Promise(A=>V.onCancellationRequested(A)),W.dispose(!0),q}async y(P,V,W){const q=this.g.get(P.controllerId);if(!q)return{};const{collection:A,profiles:j}=q,K=j.get(P.profileId);if(!K)return{};const ie=P.testIds.map(ue=>A.tree.get(ue)).filter(E.$_f),ce=P.excludeExtIds.map(ue=>q.collection.tree.get(ue)).filter(E.$_f).filter(ue=>ie.some(pe=>pe.fullId.compare(ue.fullId)===2));if(!ie.length)return{};const ve=new o.$rO(ie.some(ue=>ue.actual instanceof d.$oP)?void 0:ie.map(ue=>ue.actual),ce.map(ue=>ue.actual),K,V),Ie=(0,i.$EL)(P)&&this.j.prepareForMainThreadTestRun(ve,v.fromInternal(P,q.collection),K,W);try{return await K.runHandler(ve,W),{}}catch(ue){return{error:String(ue)}}finally{Ie&&Ie.hasRunningTasks&&!W.isCancellationRequested&&await F.Event.toPromise(Ie.onEnd)}}$cancelExtensionTestRun(P){P===void 0?this.j.cancelAllRuns():this.j.cancelRunById(P)}};e.$Vlc=a,e.$Vlc=a=Je([Ve(0,w.$aP),Ve(1,k.$Wj)],a);const h=1e4;var t;(function(C){C[C.Running=0]="Running",C[C.Cancelling=1]="Cancelling",C[C.Ended=2]="Ended"})(t||(t={}));class b extends g.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(P,V,W,q,A){super(),this.y=P,this.z=V,this.C=W,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new F.$be),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new R.$me(A));const j=this.B(new I.$Ch(()=>this.F(),h));this.B(this.j.token.onCancellationRequested(()=>j.schedule()));const K=new F.$be;this.s=K.event,this.B((0,g.$Sc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(P,V){const[,W,q]=s.$BL.fromString(P).path,A=this.w.get(q);if(!A)return[];const j=this.g.get(W);if(!j)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(j.run,A,V)??[]}createRun(P){const V=this.y.id,W=this.y.controllerId,q=(0,T.$Mg)(),A=ce=>(ve,...Ie)=>{if(K){this.C.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ve)&&(this.H(ve),ce(ve,...Ie))},j=(ce,ve)=>{const Ie=ve instanceof Array?ve.map(n.TestMessage.from):[n.TestMessage.from(ve)];if(ce.uri&&ce.range){const ue={range:n.Range.from(ce.range),uri:ce.uri};for(const pe of Ie)pe.location=pe.location||ue}this.z.$appendTestMessagesInRun(V,q,s.$BL.fromExtHostTestItem(ce,W).toString(),Ie)};let K=!1;const ie={isPersisted:this.y.isPersisted,token:this.j.token,name:P,onDidDispose:this.s,addCoverage:ce=>{const ve=ce.uri.toString(),Ie=new s.$BL([V,q,ve]).toString();this.w.set(ve,ce),this.z.$appendCoverage(V,q,n.TestCoverage.fromFile(Ie,ce))},enqueued:A(ce=>{this.z.$updateTestStateInRun(V,q,s.$BL.fromExtHostTestItem(ce,W).toString(),1)}),skipped:A(ce=>{this.z.$updateTestStateInRun(V,q,s.$BL.fromExtHostTestItem(ce,W).toString(),5)}),started:A(ce=>{this.z.$updateTestStateInRun(V,q,s.$BL.fromExtHostTestItem(ce,W).toString(),2)}),errored:A((ce,ve,Ie)=>{j(ce,ve),this.z.$updateTestStateInRun(V,q,s.$BL.fromExtHostTestItem(ce,W).toString(),6,Ie)}),failed:A((ce,ve,Ie)=>{j(ce,ve),this.z.$updateTestStateInRun(V,q,s.$BL.fromExtHostTestItem(ce,W).toString(),4,Ie)}),passed:A((ce,ve)=>{this.z.$updateTestStateInRun(V,q,s.$BL.fromExtHostTestItem(ce,this.y.controllerId).toString(),3,ve)}),appendOutput:(ce,ve,Ie)=>{K||(Ie&&(this.y.isIncluded(Ie)?this.H(Ie):Ie=void 0),this.z.$appendOutputToRun(V,q,N.$Ce.fromString(ce),ve&&n.location.from(ve),Ie&&s.$BL.fromExtHostTestItem(Ie,W).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(V,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:ie}),this.z.$startedTestRunTask(V,{id:q,name:P,running:!0}),ie}F(){for(const{run:P}of this.g.values())P.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(P){if(!(P instanceof d.$nP))throw new r.$5O(P.id);if(this.h.has(s.$BL.fromExtHostTestItem(P,this.y.controllerId).toString()))return;const V=[],W=this.y.colllection.root;for(;;){const q=n.TestItem.from(P);if(V.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),P===W))break;P=P.parent||W}this.z.$addTestsToRun(this.y.controllerId,this.y.id,V)}dispose(){this.G(),super.dispose()}}class c{get trackers(){return this.c.values()}constructor(P,V){this.g=P,this.h=V,this.c=new Map,this.f=new Map}getCoverageDetails(P,V){const W=s.$BL.root(P);return this.f.get(W)?.getCoverageDetails(P,V)||[]}disposeTestRun(P){this.f.get(P)?.dispose(),this.f.delete(P);for(const[V,{id:W}]of this.c)W===P&&this.c.delete(V)}prepareForMainThreadTestRun(P,V,W,q){return this.j(P,V,W,q)}cancelRunById(P){this.f.get(P)?.cancel()}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,V,W,q,A){const j=this.c.get(W);if(j)return j.createRun(q);const K=v.fromPublic(P,V,W,A),ie=$(W);this.g.$startedExtensionTestRun({controllerId:P,continuous:!!W.continuous,profile:ie&&{group:y[ie.kind],id:ie.profileId},exclude:W.exclude?.map(ve=>s.$BL.fromExtHostTestItem(ve,V.root.id).toString())??[],id:K.id,include:W.include?.map(ve=>s.$BL.fromExtHostTestItem(ve,V.root.id).toString())??[V.root.id],persist:A});const ce=this.j(W,K,W.profile);return F.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ce.createRun(q)}j(P,V,W,q){const A=new b(V,this.g,this.h,W,q);return this.c.set(P,A),this.f.set(A.id,A),A}}e.$Wlc=c;const $=C=>{if(C.profile){if(!(C.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return C.profile}};class v{static fromPublic(P,V,W,q){return new v(P,(0,T.$Mg)(),W.include?.map(A=>s.$BL.fromExtHostTestItem(A,P).toString())??[P],W.exclude?.map(A=>s.$BL.fromExtHostTestItem(A,P).toString())??[],q,V)}static fromInternal(P,V){return new v(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,V)}constructor(P,V,W,q,A,j){this.controllerId=P,this.id=V,this.isPersisted=A,this.colllection=j,this.c=W.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(P){const V=s.$BL.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const W of this.f)if(V===W||V.startsWith(W))return!1;for(const W of this.c)if(V===W||V.startsWith(W))return!0;return!1}}e.$Xlc=v;class p{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(P){this.j=P,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,n.TestItem.toPlain(P.item)),this.c.has(P)||this.f.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.f.delete(P);const V=s.$BL.parentId(P.item.extId);if(V&&this.h.has(V.toString())){this.h.add(P.item.extId);return}this.g.add(P)}getChangeEvent(){const{c:P,f:V,g:W}=this;return{get added(){return[...P].map(q=>q.revived)},get updated(){return[...V].map(q=>q.revived)},get removed(){return[...W].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class l extends i.$KL{constructor(){super(...arguments),this.s=new F.$be,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(P){return this.f.get(P)}getMirroredTestDataByReference(P){return this.f.get(P.id)}w(P,V){return{...P,revived:n.TestItem.toPlain(P.item),depth:V?V.depth+1:0,children:new Set}}v(){return new p(this.s)}}class D{constructor(P){this.f=P}checkout(){this.c||(this.c=this.g());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(V=>V.revived)},dispose:(0,M.$db)(()=>{--P.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}g(){const P=new l({asCanonicalUri:V=>V});return this.f.$subscribeToDiffs(),{observers:0,tests:P}}}const f=(C,P,V,W)=>{V?Object.assign(V,W):P.$updateTestRunConfig(C.controllerId,C.profileId,W)};class S{#e;#t;#i;#n;#s;get label(){return this.f}set label(P){P!==this.f&&(this.f=P,f(this,this.#e,this.#n,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,f(this,this.#e,this.#n,{supportsContinuousRun:P}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(P){P!==this.isDefault&&(P?this.#t.add(this.profileId):this.#t.delete(this.profileId),f(this,this.#e,this.#n,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,f(this,this.#e,this.#n,{tag:P?n.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,f(this,this.#e,this.#n,{hasConfigurationHandler:!!P}))}get onDidChangeDefault(){return F.Event.chain(this.#i,P=>P.map(V=>V.get(this.controllerId)?.get(this.profileId)).filter(E.$_f))}constructor(P,V,W,q,A,j,K,ie,ce,ve=!1,Ie=void 0,ue=!1){this.controllerId=A,this.profileId=j,this.f=K,this.kind=ie,this.runHandler=ce,this._tag=Ie,this.g=ue,this.#e=P,this.#s=V,this.#t=W,this.#i=q,V.set(j,this);const pe=y[ie];if(typeof pe!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);ve&&W.add(j),this.#n={profileId:j,controllerId:A,tag:Ie?n.TestTag.namespace(this.controllerId,Ie.id):null,label:K,group:pe,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:ue},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Ylc=S;const y={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Re[115],Ae([1,0,56,14,90,8,7]),function(ge,e,I,N,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jP=e.$iP=e.$hP=void 0;class m{static{this.c=new R.$fP("TextEditorDecorationType")}constructor(u,w,d){const n=m.c.nextId();u.$registerTextEditorDecorationType(w.identifier,n,F.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:n,dispose(){u.$removeTextEditorDecorationType(n)}})}}e.$hP=m;class g{constructor(u,w){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,w){this.k();let d=null;if(u instanceof M.$SM)d=new M.$TM(u,u);else if(u instanceof M.$TM)d=u;else throw new Error("Unrecognized location");this.l(d,w,!1)}insert(u,w){this.k(),this.l(new M.$TM(u,u),w,!0)}delete(u){this.k();let w=null;if(u instanceof M.$TM)w=u;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(u,w,d){const n=this.c.validateRange(u);this.g.push({range:n,text:w,forceMoveMarkers:d})}setEndOfLine(u){if(this.k(),u!==M.EndOfLine.LF&&u!==M.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=u}}class E{constructor(u,w,d,n){this.c=u,this.d=w,this._accept(d),this.e=n;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.n(s)},get indentSize(){return o.g},set indentSize(s){o.p(s)},get insertSpaces(){return o.j},set insertSpaces(s){o.s(s)},get cursorStyle(){return o.k},set cursorStyle(s){o.t(s)},get lineNumbers(){return o.l},set lineNumbers(s){o.u(s)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=F.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const w=Math.floor(u);return w>0?w:null}if(typeof u=="string"){const w=parseInt(u,10);return isNaN(w)?null:w>0?w:null}return null}n(u){const w=this.m(u);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const w=Math.floor(u);return w>0?w:null}if(typeof u=="string"){const w=parseInt(u,10);return isNaN(w)?null:w>0?w:null}return null}p(u){const w=this.o(u);if(w!==null){if(typeof w=="number"){if(this.h===w)return;this.g=w,this.h=w}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const w=this.q(u);if(typeof w=="boolean"){if(this.j===w)return;this.j=w}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(u)})))}assign(u){const w={};let d=!1;if(typeof u.tabSize<"u"){const n=this.m(u.tabSize);n==="auto"?(d=!0,w.tabSize=n):typeof n=="number"&&this.f!==n&&(this.f=n,d=!0,w.tabSize=n)}if(typeof u.indentSize<"u"){const n=this.o(u.indentSize);n==="tabSize"?(d=!0,w.indentSize=n):typeof n=="number"&&this.h!==n&&(this.g=n,this.h=n,d=!0,w.indentSize=n)}if(typeof u.insertSpaces<"u"){const n=this.q(u.insertSpaces);n==="auto"?(d=!0,w.insertSpaces=n):this.j!==n&&(this.j=n,d=!0,w.insertSpaces=n)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,d=!0,w.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,d=!0,w.lineNumbers=F.TextEditorLineNumbersStyle.from(u.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,w))}v(u,w){w.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(d)})}}e.$iP=E;class T{constructor(u,w,d,n,o,s,r,i){this.id=u,this.j=w,this.k=d,this.g=!1,this.h=new Set,this.c=o,this.d=new E(this.j,this.id,s,d),this.e=r,this.f=i;const a=this;this.value=Object.freeze({get document(){return n.value},set document(h){throw new N.$9("document")},get selection(){return a.c&&a.c[0]},set selection(h){if(!(h instanceof M.$UM))throw(0,N.$7)("selection");a.c=[h],a.l()},get selections(){return a.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof M.$UM)))throw(0,N.$7)("selections");a.c=h,a.l()},get visibleRanges(){return a.e},set visibleRanges(h){throw new N.$9("visibleRanges")},get options(){return a.d.value},set options(h){a.g||a.d.assign(h)},get viewColumn(){return a.f},set viewColumn(h){throw new N.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const b=new g(n.value,t);return h(b),a.m(b)},insertSnippet(h,t,b={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=a.c.map($=>F.Range.from($));else if(t instanceof M.$SM){const{lineNumber:$,column:v}=F.Position.from(t);c=[{startLineNumber:$,startColumn:v,endLineNumber:$,endColumn:v}]}else if(t instanceof M.$TM)c=[F.Range.from(t)];else{c=[];for(const $ of t)if($ instanceof M.$TM)c.push(F.Range.from($));else{const{lineNumber:v,column:p}=F.Position.from($);c.push({startLineNumber:v,startColumn:p,endLineNumber:v,endColumn:p})}}return w.$tryInsertSnippet(u,n.value.version,h.value,c,b)},setDecorations(h,t){const b=t.length===0;b&&!a.h.has(h.key)||(b?a.h.delete(h.key):a.h.add(h.key),a.n(()=>{if(F.$0O(t))return w.$trySetDecorations(u,h.key,F.$$O(t));{const c=new Array(4*t.length);for(let $=0,v=t.length;$<v;$++){const p=t[$];c[4*$]=p.start.line+1,c[4*$+1]=p.start.character+1,c[4*$+2]=p.end.line+1,c[4*$+3]=p.end.character+1}return w.$trySetDecorationsFast(u,h.key,c)}}))},revealRange(h,t){a.n(()=>w.$tryRevealRange(u,F.Range.from(h),t||M.TextEditorRevealType.Default))},show(h){w.$tryShowEditor(u,F.ViewColumn.from(h))},hide(){w.$tryHideEditor(u)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,I.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,I.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,I.ok)(!this.g),this.f=u}_acceptSelections(u){(0,I.ok)(!this.g),this.c=u}async l(){const u=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const w=u.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const d=w.edits.map(o=>o.range);d.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=d.length-1;o<s;o++){const r=d[o].end;if(d[o+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=w.edits.map(o=>({range:F.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,n,{setEndOfLine:typeof w.setEndOfLine=="number"?F.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$jP=T}),define(Re[67],Ae([1,0,56,5,6,2,3,4,111,16,115,8,13,28,12,46,40]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=e.$kP=void 0;class s{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(a,h){this.h=a,this.i=h,this.a=null,this.b=new Map,this.c=new w.$Bc,this.d=new N.$be,this.e=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const h=[],t=[],b=[];if(a.removedDocuments)for(const c of a.removedDocuments){const $=F.URI.revive(c),v=this.c.get($);v?.unref()&&(this.c.delete($),h.push(v.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const $=F.URI.revive(c.uri);let v=this.c.get($);if(v&&$.scheme!==d.Schemas.vscodeNotebookCell&&$.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${$} already exists!'`);v||(v=new s(new g.$dP(this.h.getProxy(m.$PM.MainThreadDocuments),$,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty)),this.c.set($,v),t.push(v.value)),v.ref()}if(a.removedEditors)for(const c of a.removedEditors){const $=this.b.get(c);this.b.delete(c),$&&b.push($)}if(a.addedEditors)for(const c of a.addedEditors){const $=F.URI.revive(c.documentUri);I.ok(this.c.has($),`document '${$}' does not exist`),I.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const v=this.c.get($).value,p=new T.$jP(c.id,this.h.getProxy(m.$PM.MainThreadTextEditors),this.i,new o.$V(()=>v.document),c.selections.map(k.Selection.to),c.options,c.visibleRanges.map(l=>k.Range.to(l)),typeof c.editorPosition=="number"?k.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,p)}a.newActiveEditor!==void 0&&(I.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,R.$Pc)(h),(0,R.$Pc)(b),a.removedDocuments&&this.e.fire(h),a.addedDocuments&&this.d.fire(t),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return n.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const h=this.b.get(this.a);return a?h:h?.value}allEditors(){return[...this.b.values()]}};e.$kP=r,e.$kP=r=Je([Ve(0,E.$aP),Ve(1,u.$Wj)],r),e.$lP=(0,M.$qi)("IExtHostDocumentsAndEditors")}),define(Re[280],Ae([1,0,18,5,4,115,8,7]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;class g{constructor(T,k){this.i=k,this.a=new N.$be,this.b=new N.$be,this.c=new N.$be,this.d=new N.$be,this.f=new N.$be,this.g=new N.$be,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(R.$PM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(u=>this.g.fire(u)),this.i.onDidChangeActiveTextEditor(u=>this.f.fire(u))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const k=this.i.allEditors();return T?k:k.map(u=>u.value)}async showTextDocument(T,k,u){let w;typeof k=="number"?w={position:M.ViewColumn.from(k),preserveFocus:u}:typeof k=="object"?w={position:M.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?M.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:w={preserveFocus:!1};const d=await this.h.$tryShowTextDocument(T.uri,w),n=d&&this.i.getEditor(d);if(n)return n.value;throw d?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,k){return new F.$hP(this.h,T,k).value}$acceptEditorPropertiesChanged(T,k){const u=this.i.getEditor(T);if(!u)throw new Error("unknown text editor");if(k.options&&u._acceptOptions(k.options),k.selections){const w=k.selections.selections.map(M.Selection.to);u._acceptSelections(w)}if(k.visibleRanges){const w=I.$Hb(k.visibleRanges.map(M.Range.to));u._acceptVisibleRanges(w)}if(k.options&&this.b.fire({textEditor:u.value,options:{...k.options,lineNumbers:M.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const w=m.TextEditorSelectionChangeKind.fromValue(k.selections.source),d=k.selections.selections.map(M.Selection.to);this.a.fire({textEditor:u.value,selections:d,kind:w})}if(k.visibleRanges){const w=I.$Hb(k.visibleRanges.map(M.Range.to));this.c.fire({textEditor:u.value,visibleRanges:w})}}$acceptEditorPositionData(T){for(const k in T){const u=this.i.getEditor(k);if(!u)throw new Error("Unknown text editor");const w=M.ViewColumn.to(T[k]);u.value.viewColumn!==w&&(u._acceptViewColumn(w),this.d.fire({textEditor:u.value,viewColumn:w}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.$fkc=g}),define(Re[281],Ae([1,0,2,3,4,6,7,8,20,17]),function(ge,e,I,N,R,F,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2lc=e.$1lc=void 0,e.$1lc=(0,N.$qi)("IExtHostTimeline");class T{constructor(w,d){this.b=new Map,this.c=new Map,this.a=w.getProxy(R.$PM.MainThreadTimeline),d.registerArgumentProcessor({processArgument:(n,o)=>{if(n&&n.$mid===12)if(this.b.get(n.source)&&g.$Lm.equals(o,this.b.get(n.source)?.extension)){const s=n.uri===void 0?void 0:I.URI.revive(n.uri);return this.c.get(n.source)?.get(k(s))?.get(n.handle)}else return;return n}})}async $getTimeline(w,d,n,o){return this.b.get(w)?.provider.provideTimeline(I.URI.revive(d),n,o)}registerTimelineProvider(w,d,n,o){const s=new F.$Tc,r=this.d(d.id,o,s).bind(this);let i;d.onDidChange&&(i=d.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:d.id}),this));const a=this.c;return this.f({...d,scheme:w,onDidChange:void 0,async provideTimeline(h,t,b){t?.resetCache&&(s.clear(),a.get(d.id)?.clear());const c=await d.provideTimeline(h,t,b);if(c==null)return;const $=r(h,t);return{...c,source:d.id,items:c.items.map($)}},dispose(){for(const h of a.values())h.get(d.id)?.clear();i?.dispose(),s.dispose()}},n)}d(w,d,n){return(o,s)=>{let r;if(s?.cacheResults){let i=this.c.get(w);i===void 0&&(i=new Map,this.c.set(w,i));const a=k(o);r=i.get(a),r===void 0&&(r=new Map,i.set(a,r))}return i=>{const{iconPath:a,...h}=i,t=`${w}|${i.id??i.timestamp}`;r?.set(t,i);let b,c,$;i.iconPath&&(a instanceof M.$NN?$={id:a.id,color:a.color}:I.URI.isUri(a)?(b=a,c=a):{light:b,dark:c}=a);let v;return M.$gN.isMarkdownString(h.tooltip)?v=m.MarkdownString.from(h.tooltip):(0,E.$4f)(h.tooltip)?v=h.tooltip:M.$gN.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=m.MarkdownString.from(h.detail)):(0,E.$4f)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=h.detail),{...h,id:h.id??void 0,handle:t,source:w,command:i.command?d.toInternal(i.command,n):void 0,icon:b,iconDark:c,themeIcon:$,tooltip:v,accessibilityInformation:i.accessibilityInformation}}}}f(w,d){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:d}),(0,F.$Sc)(()=>{for(const o of this.c.values())o.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$2lc=T;function k(u){return u?.toString()}}),define(Re[282],Ae([1,0,173,23,2,5,6,212,11,7,17,18,8,54,24,137,25]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=void 0;function s(a,h){if((0,T.$4f)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter(b=>b.length===2&&typeof b[0]=="number"&&typeof b[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class r extends M.$Uc{constructor(h,t,b){super(),this.f=h,this.g=t,this.h=b,this.a=new Map,this.b=new n.$M0;function c($){return $&&$.$treeViewId&&($.$treeItemHandle||$.$selectedTreeItems||$.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:$=>c($)?this.r($):Array.isArray($)&&$.length>0?$.map(v=>c(v)?this.r(v):v):$})}registerTreeDataProvider(h,t,b){const c=this.createTreeView(h,{treeDataProvider:t},b);return{dispose:()=>c.dispose()}}createTreeView(h,t,b){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],$=t.dragAndDropController?.dragMimeTypes??[],v=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,l=this.m(h,t,b),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:$,hasHandleDrag:v,hasHandleDrop:p,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},f=this.f.$registerTreeViewDataProvider(h,D),S={get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get activeItem(){return(0,o.$yG)(b,"treeViewActiveItem"),l.focusedElement},get onDidChangeActiveItem(){return(0,o.$yG)(b,"treeViewActiveItem"),l.onDidChangeActiveItem},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeCheckboxState(){return l.onDidChangeCheckboxState},get message(){return l.message},set message(y){(0,w.$Pk)(y)&&(0,o.$yG)(b,"treeViewMarkdownMessage"),l.message=y},get title(){return l.title},set title(y){l.title=y},get description(){return l.description},set description(y){l.description=y},get badge(){return l.badge},set badge(y){y!==void 0&&E.ViewBadge.isViewBadge(y)?l.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(l.badge=void 0)},reveal:(y,C)=>l.reveal(y,C),dispose:async()=>{await f,this.a.delete(h),l.dispose()}};return this.B(S),S}$getChildren(h,t){const b=this.a.get(h);return b?b.getChildren(t):Promise.reject(new m.$NF(h))}async $handleDrop(h,t,b,c,$,v,p,l){const D=this.a.get(h);if(!D)return Promise.reject(new m.$NF(h));const f=u.DataTransfer.toDataTransfer(b,async S=>(await this.f.$resolveDropFileData(h,t,S)).buffer);return p===h&&l&&await this.j(f,D,l,$,v),D.onDrop(f,c,$)}async j(h,t,b,c,$){const v=this.b.removeDragOperationTransfer($);if(v)(await v)?.forEach((p,l)=>{p&&h.set(l,p)});else if($&&t.handleDrag){const p=t.handleDrag(b,h,c);this.b.addDragOperationTransfer($,p),await p}return h}async $handleDrag(h,t,b,c){const $=this.a.get(h);if(!$)return Promise.reject(new m.$NF(h));const v=await this.j(new E.$JN,$,t,c,b);if(!(!v||c.isCancellationRequested))return u.DataTransfer.from(v)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new m.$NF(h);return t.hasResolve}$resolve(h,t,b){const c=this.a.get(h);if(!c)throw new m.$NF(h);return c.resolveTreeItem(t,b)}$setExpanded(h,t,b){const c=this.a.get(h);if(!c)throw new m.$NF(h);c.setExpanded(t,b)}$setSelectionAndFocus(h,t,b){const c=this.a.get(h);if(!c)throw new m.$NF(h);c.setSelectionAndFocus(t,b)}$setVisible(h,t){const b=this.a.get(h);if(!b){if(!t)return;throw new m.$NF(h)}b.setVisible(t)}$changeCheckboxState(h,t){const b=this.a.get(h);if(!b)throw new m.$NF(h);b.setCheckboxState(t)}m(h,t,b){const c=this.B(new i(h,t,this.f,this.g.converter,this.h,b));return this.a.set(h,c),c}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$3lc=r;class i extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,T.$ag)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,b,c,$,v){if(super(),this.I=h,this.J=b,this.L=c,this.M=$,this.N=v,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$be),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$be),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$be),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$be),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$be),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$be),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$be),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$me,v.contributes&&v.contributes.views)for(const f in v.contributes.views)for(const S of v.contributes.views[f])S.id===h&&(this.P=S.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(f=>this.F.fire({message:!1,element:f})));let p,l;const D=F.Event.debounce(this.F.event,(f,S)=>(f||(f={message:!1,elements:[]}),S.element!==!1&&(p||(p=new Promise(y=>l=y),this.G=this.G.then(()=>p)),Array.isArray(S.element)?f.elements.push(...S.element):f.elements.push(S.element)),S.message&&(f.message=!0),f),200,!0);this.B(D(({message:f,elements:S})=>{S.length&&(this.H=this.H.then(()=>{const y=l;return p=null,this.$(S).then(()=>y())})),f&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let b=this.X(h);return b||(b=await this.Y(t)),b?b.map(c=>c.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const b=(0,T.$ag)(t.select)?!0:t.select,c=(0,T.$ag)(t.focus)?!1:t.focus,$=(0,T.$ag)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(v=>this.W(h,v[v.length-1]).then(p=>this.J.$reveal(this.I,{item:p.item,parentChain:v.map(l=>l.item)},{select:b,focus:c,expand:$})),v=>this.M.error(v)):this.J.$reveal(this.I,void 0,{select:b,focus:c,expand:$})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=u.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const b=this.getExtensionElement(h);b&&(t?this.u.fire(Object.freeze({element:b})):this.w.fire(Object.freeze({element:b})))}setSelectionAndFocus(h,t){const b=!(0,k.$ub)(this.s,h);this.s=h;const c=this.t!==t;this.t=t,b&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async b=>{const c=this.getExtensionElement(b.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:b.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(b=>b!==void 0);t.forEach(b=>{b.treeItem.checkboxState=b.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(b=>[b.extensionItem,b.newState])})}async handleDrag(h,t,b){const c=[];for(const $ of h){const v=this.getExtensionElement($);v&&c.push(v)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,b),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,b){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,g.$ih)(()=>this.g?.handleDrop?this.g.handleDrop(c,h,b):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const b=this.j.get(h);if(b){const c=this.m.get(b);if(c){const $=await this.f.resolveTreeItem(c.extensionItem,b,t)??c.extensionItem;return this.hb($),c.item.tooltip=this.eb($.tooltip),c.item.command=this.fb(c.disposableStore,$.command),c.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(b=>this.W(t,b[b.length-1]).then(c=>(b.push(c),b))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,g.$ih)(()=>this.f.getParent(h))}W(h,t){const b=this.m.get(h);return b?Promise.resolve(b):(0,g.$ih)(()=>this.f.getTreeItem(h)).then(c=>this.kb(h,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const $=this.getExtensionElement(c);if($){const v=this.m.get($);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const b=this.getExtensionElement(h);t=b?this.m.get(b):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new d.$me(this.Z.token);try{const b=h?this.m.get(h):void 0,c=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const $=(0,k.$Hb)(c||[]),v=await Promise.all((0,k.$Hb)($).map(l=>this.f.getTreeItem(l)));if(t.token.isCancellationRequested)return;const p=v.map((l,D)=>l?this.db($[D],l,b):null);return(0,k.$Hb)(p)}finally{t.dispose()}}$(h){if(h.some(b=>!b))return this.Z.dispose(!0),this.Z=new d.$me,this.tb(),this.J.$refresh(this.I);{const b=this.ab(h);if(b.length)return this.bb(b)}return Promise.resolve(void 0)}ab(h){const t=new Set,b=h.map($=>this.m.get($));for(const $ of b)if($&&!t.has($.item.handle)){let v=$;for(;v&&v.parent&&b.findIndex(p=>v&&v.parent&&p&&p.item.handle===v.parent.item.handle)===-1;){const p=this.j.get(v.parent.item.handle);v=p?this.m.get(p):void 0}v&&!v.parent&&t.add($.item.handle)}const c=[];return t.forEach($=>{const v=this.j.get($);if(v){const p=this.m.get(v);p&&(!p.parent||!t.has(p.parent.item.handle))&&c.push($)}}),c}bb(h){const t={};return Promise.all(h.map(b=>this.cb(b).then(c=>{c&&(t[b]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const b=this.m.get(t);if(b)return this.rb(t),(0,g.$ih)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const $=this.ib(t,c,b.parent);return this.pb(t,$,b,b.parent),b.dispose(),$}return null})}return Promise.resolve(null)}db(h,t,b){const c=this.ib(h,t,b);if(t.id&&this.j.has(c.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(h,c),this.qb(c,b),c}eb(h){return E.$gN.isMarkdownString(h)?u.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,b,c;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,b=h.checkboxState.tooltip,c=h.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:b,accessibilityInformation:c}}hb(h){if(!E.$EN.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,b){this.hb(t);const c=this.B(new M.$Tc),$=this.kb(h,t,b),v=this.lb(t);return{item:{handle:$,parentHandle:b?b.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:v,iconDark:this.mb(t)||v,themeIcon:this.jb(t),collapsibleState:(0,T.$ag)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:b,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(h){return h.iconPath instanceof E.$NN?h.iconPath:void 0}kb(h,{id:t,label:b,resourceUri:c},$,v){if(t)return`${i.b}/${t}`;const p=s(b,this.N),l=$?$.item.handle:i.a;let D=p?p.label:c?(0,N.$1g)(c):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const f=this.m.has(h)?this.m.get(h).item.handle:void 0,S=this.X($)||[];let y,C=0;do{if(y=`${l}/${C}:${D}`,v||!this.j.has(y)||f===y)break;C++}while(C<=S.length);return y}lb(h){if(h.iconPath&&!(h.iconPath instanceof E.$NN))return typeof h.iconPath=="string"||R.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof E.$NN)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return R.URI.isUri(h)?h:R.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,b,c){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==b.item.handle&&this.j.delete(b.item.handle),this.ob(h,t);const $=this.X(c)||[],v=$.filter(p=>p.item.handle===b.item.handle)[0];v&&$.splice($.indexOf(v),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const b of t.children){const c=this.j.get(b.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const b of t.children){const c=this.j.get(b.item.handle);c&&this.sb(c)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[283],Ae([1,0,5,6,2,35,8,63,4,7]),function(ge,e,I,N,R,F,M,m,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=void 0;class T extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(d,n,o,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$be),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$be),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=n,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,R.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(d){this.#l||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#u=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,n){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:M.ViewColumn.from(d),preserveFocus:!!n})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends N.$Uc{static c(){return(0,F.$Mg)()}constructor(d,n,o){super(),this.j=n,this.m=o,this.g=new Map,this.h=new Map,this.f=d.getProxy(g.$PM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,n,o,s,r={}){const i=typeof s=="object"?s.viewColumn:s,a={viewColumn:M.ViewColumn.from(i),preserveFocus:typeof s=="object"&&!!s.preserveFocus},h=(0,m.$ukc)(d),t=k.c();this.f.$createWebviewPanel((0,m.$wkc)(d),t,n,{title:o,panelOptions:u(r),webviewOptions:(0,m.$xkc)(d,this.m,r),serializeBuffersForPostMessage:h},a);const b=this.j.createNewWebview(t,r,d);return this.createNewWebviewPanel(t,n,o,i,r,b,!0)}$onDidChangeWebviewPanelViewStates(d){const n=Object.keys(d);n.sort((o,s)=>{const r=d[o],i=d[s];return r.active?1:i.active?-1:+r.visible-+i.visible});for(const o of n){const s=this.getWebviewPanel(o);if(!s)continue;const r=d[o];s._updateViewState({active:r.active,visible:r.visible,viewColumn:M.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,n,o){if(this.h.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.h.set(n,{serializer:o,extension:d}),this.f.$registerSerializer(n,{serializeBuffersForPostMessage:(0,m.$ukc)(d)}),new E.$RM(()=>{this.h.delete(n),this.f.$unregisterSerializer(n)})}async $deserializeWebviewPanel(d,n,o,s){const r=this.h.get(n);if(!r)throw new Error(`No serializer found for '${n}'`);const{serializer:i,extension:a}=r,h=this.j.createNewWebview(d,o.webviewOptions,a),t=this.createNewWebviewPanel(d,n,o.title,s,o.panelOptions,h,o.active);await i.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(d,n,o,s,r,i,a){const h=new T(d,this.f,i,{viewType:n,title:o,viewColumn:s,panelOptions:r,active:a});return this.g.set(d,h),h}getWebviewPanel(d){return this.g.get(d)}}e.$ykc=k;function u(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(Re[284],Ae([1,0,5,6,63,8,4,7]),function(ge,e,I,N,R,F,M,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class g extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(k,u,w,d,n,o){super(),this.#s=!1,this.#u=this.B(new I.$be),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$be),this.onDidDispose=this.#l.event,this.#i=w,this.#a=d,this.#e=k,this.#t=u,this.#n=n,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#o}set description(k){this.a(),this.#o!==k&&(this.#o=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(k){k===this.#r||this.#s||(this.#r=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=F.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(k,u){this.d=u,this.b=new Map,this.c=new Map,this.a=k.getProxy(M.$PM.MainThreadWebviewViews)}registerWebviewViewProvider(k,u,w,d){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:w,extension:k}),this.a.$registerWebviewViewProvider((0,R.$wkc)(k),u,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,R.$ukc)(k)}),new m.$RM(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(k,u,w,d,n){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:s,extension:r}=o,i=this.d.createNewWebview(k,{},r),a=new g(k,this.a,u,w,i,!0);this.c.set(k,a),await s.resolveWebviewView(a,{state:d},n)}async $onDidChangeWebviewViewVisibility(k,u){this.e(k)._setVisible(u)}async $disposeWebviewView(k){const u=this.e(k);this.c.delete(k),u.dispose(),this.d.deleteWebview(k)}e(k){const u=this.c.get(k);if(!u)throw new Error("No webview found");return u}}e.$6lc=E}),define(Re[285],Ae([1,0,5,30,31,3]),function(ge,e,I,N,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=e.OutputChannelUpdateMode=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=void 0,e.$XL="text/x-code-output",e.$YL="output",e.$ZL="Log",e.$1L="text/x-code-log-output",e.$2L="log",e.$3L="workbench.panel.output",e.$4L=new R.$Hj("inOutput",!1),e.$5L=new R.$Hj("activeLogOutput",!1),e.$6L=new R.$Hj("activeLogOutput.levelSettable",!1),e.$7L=new R.$Hj("activeLogOutput.level",""),e.$8L=new R.$Hj("activeLogOutput.levelIsDefault",!1),e.$9L=new R.$Hj("outputView.scrollLock",!1),e.$0L=(0,F.$qi)("outputService");var M;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$$L={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new I.$be,this.onDidRegisterChannel=this.b.event,this.c=new I.$be,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(T=>E.push(T)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}N.$9n.add(e.$$L.OutputChannels,new m),e.$_L=new R.$Hj("activeOutputChannel","")}),define(Re[116],Ae([1,0,4,3,16,20,13,285,64,27,44,141,22,17,43,5,6]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=e.$Elc=void 0;class s extends M.$3j{get disposed(){return this.n}constructor(h,t,b,c,$){super(),this.id=h,this.name=t,this.r=b,this.s=c,this.extension=$,this.m=0,this.n=!1,this.visible=!1,this.setLevel(b.getLevel()),this.B(b.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=u.$Ce.fromString(t).byteLength,(0,M.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends s{appendLine(h){this.append(h)}}let i=class{constructor(h,t,b,c,$,v){this.i=t,this.j=b,this.k=c,this.l=$,this.m=v,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(I.$PM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.$Xm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,b]of this.g)b.visible=t===this.h}createOutputChannel(h,t,b){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,$=(0,w.$4f)(t)?t:void 0;if((0,w.$4f)($)&&!$.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const p=this.i.environment.extensionLogLevel?.find(([D])=>F.$Lm.equals(b.identifier,D))?.[1];p&&(v=(0,M.$bk)(p));const l=c?this.o(h,v,b):this.n(h,$,b);return l.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),c?this.r(h,v??this.m.getLevel(),l):this.q(h,l)}async n(h,t,b){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,$=this.k.extUri.joinPath(c,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.l.createLogger($,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(h,$,t,b.identifier.value);return new s(p,h,v,this.a,b)}async o(h,t,b){const c=await this.p(b),$=h.replace(/[\\/:\*\?"<>\|]/g,""),v=this.k.extUri.joinPath(c,`${$}.log`),p=`${b.identifier.value}.${$}`,l=this.l.createLogger(v,{id:p,name:h,logLevel:t,extensionId:b.identifier.value});return new r(p,h,l,this.a,b)}p(h){let t=this.d.get(h.identifier.value);if(!t){const b=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(b)}catch(c){if((0,d.$al)(c)!==d.FileSystemProviderErrorCode.FileExists)throw c}return b})())}return t}q(h,t){let b=!1;const c=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return h},append($){c(),t.then(v=>v.append($))},appendLine($){c(),t.then(v=>v.appendLine($))},clear(){c(),t.then($=>$.clear())},replace($){c(),t.then(v=>v.replace($))},show($,v){c(),t.then(p=>p.show($,v))},hide(){c(),t.then($=>$.hide())},dispose(){b=!0,t.then($=>$.dispose())}}}r(h,t,b){const c=new o.$Tc,$=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},v=c.add(new n.$be);function p(l){t=l,v.fire(l)}return b.then(l=>{c.add(l),l.logLevel!==t&&p(l.logLevel),c.add(l.onDidChangeLogLevel(D=>p(D)))}),{...this.q(h,b),get logLevel(){return t},onDidChangeLogLevel:v.event,trace(l,...D){$(),b.then(f=>f.trace(l,...D))},debug(l,...D){$(),b.then(f=>f.debug(l,...D))},info(l,...D){$(),b.then(f=>f.info(l,...D))},warn(l,...D){$(),b.then(f=>f.warn(l,...D))},error(l,...D){$(),b.then(f=>f.error(l,...D))},dispose(){c.dispose()}}}};e.$Elc=i,e.$Elc=i=Je([Ve(0,R.$aP),Ve(1,E.$qP),Ve(2,g.$qkc),Ve(3,T.$6jc),Ve(4,M.$Xj),Ve(5,M.$Wj)],i),e.$Flc=(0,N.$qi)("IExtHostOutputService")}),define(Re[117],Ae([1,0,3,11]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=void 0,e.$an=(0,I.$qi)("remoteAgentService"),e.$bn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(R){let F=1/0;for(let m=0;m<this.maxSampleCount;m++){const g=await R.getRoundTripTime();if(g===void 0)return;F=Math.min(F,g/2),await(0,N.$rh)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(F):M=this.initial.reduce((m,g)=>m+g,0)/this.initial.length,this.lastMeasurement={initial:M,current:F,average:this.average.reduce((m,g)=>m+g,0)/this.average.length,high:typeof M>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[286],Ae([1,0,176,57,30,49,48,6,5,117,21,26,11]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=void 0,e.$qJ=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$rJ=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$sJ=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$tJ=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$uJ={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new g.$be,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(r){this.migrations.push(...r)}}const d=new w;R.$9n.add(e.$uJ.ConfigurationMigration,d);let n=class extends m.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(r,i){super(),this.a=r,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const h of a.added)await this.f(h,d.migrations)})),this.c(d.migrations),this.B(d.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(r){await this.f(void 0,r);for(const i of this.b.getWorkspace().folders)await this.f(i,r)}async f(r,i){await Promise.all([i.map(a=>this.g(a,r?.uri))])}async g(r,i){const a=this.a.inspect(r.key,{resource:i}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,b]of h){const c=a[t];if(!c)continue;const $=[];if(c.value!==void 0){const v=await this.h(r,t,c.value,i,void 0);for(const p of v??[])$.push([p,[]])}for(const{identifiers:v,value:p}of c.overrides??[])if(p!==void 0){const l=await this.h(r,t,p,i,v);for(const D of l??[])$.push([D,v])}$.length&&await Promise.allSettled($.map(async([[v,p],l])=>this.a.updateValue(v,p.value,{resource:i,overrideIdentifiers:l},b)))}}async h(r,i,a,h,t){const b=$=>{const p=this.a.inspect($,{resource:h})[i];if(p)return t?p.overrides?.find(({identifiers:l})=>(0,k.$1n)(l,t))?.value:p.value},c=await r.migrateFn(a,b);return Array.isArray(c)?c:[[r.key,c]]}};e.$vJ=n,e.$vJ=n=Je([Ve(0,M.$Wi),Ve(1,F.$zi)],n);let o=class extends m.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(r){super(),this.b=r,this.a=new u.$Nh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!T.$i&&(await this.b.getEnvironment())?.os!==1)return;R.$9n.as(N.$bo.Configuration).registerConfiguration({...e.$sJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$wJ=o,e.$wJ=o=Je([Ve(0,E.$an)],o)}),define(Re[287],Ae([1,0,36,12,19,23,185,286,57,3,30]),function(ge,e,I,N,R,F,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$kgb=e.$jgb=void 0,e.$lgb=n,e.$mgb=o,e.$jgb=(0,E.$qi)("editorResolverService"),e.$kgb="workbench.editorAssociations";const k=T.$9n.as(g.$bo.Configuration),u={...m.$rJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(u);var w;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(w||(e.RegisteredEditorPriority=w={}));var d;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function n(s){switch(s){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}function o(s,r){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(r.scheme))return!1;const h=typeof s=="string"&&s.indexOf(R.$hc.sep)>=0?`${r.scheme}:${r.path}`:(0,F.$1g)(r);return I.$jk(typeof s=="string"?s.toLowerCase():s,h.toLowerCase())}}),define(Re[288],Ae([1,0,47,12,19,21,23,2,3,206,49,226,117]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0,e.$rM=(0,g.$qi)("pathService");let d=w=class{constructor(o,s,r,i){this.d=o,this.e=s,this.f=r,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??o})()}hasValidBasename(o,s,r){return typeof s=="string"||typeof s>"u"?this.a.then(i=>this.h(o,i,s)):this.h(o,s,r)}h(o,s,r){return o.scheme===N.Schemas.file||o.scheme===N.Schemas.vscodeRemote?(0,I.$og)(r??(0,M.$1g)(o),s===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return N.Schemas.vscodeRemote;const r=(0,E.$oM)(s.getWorkspace());if(r)return r;const i=s.getWorkspace().folders[0];if(i)return i.uri.scheme;const a=s.getWorkspace().configuration;return a?a.scheme:N.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?R.$gc:R.$hc)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(s=o.substring(2),o="/"):(s=o.substring(2,i),o=o.substring(i)||"/")}return m.URI.from({scheme:N.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$sM=d,e.$sM=d=w=Je([Ve(1,u.$an),Ve(2,k.$aM),Ve(3,T.$zi)],d)}),define(Re[118],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$XK=e.$WK=void 0;class I{constructor(M,m){this.line=M,this.character=m}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,m){return new I(0,0)}with(M){return new I(0,0)}}e.$WK=I;class N{constructor(M,m,g,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(M,m),this.end=new I(g,E)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new N(0,0,0,0)}with(M){return new N(0,0,0,0)}}e.$XK=N;var R;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}))}),define(Re[45],Ae([1,0,18,36,26,47,15,3,19,14,118,11]),function(ge,e,I,N,R,F,M,m,g,E,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kL=e.$iL=e.$bL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$$K=e.$0K=e.$9K=e.$8K=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.TextSearchCompleteMessageType=void 0,e.$5K=s,e.$6K=r,e.$7K=i,e.$_K=l,e.$aL=D,e.$cL=y,e.$dL=C,e.$eL=P,e.$fL=V,e.$gL=W,e.$hL=q,e.$jL=j,e.$lL=ce,e.$mL=ve,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.$YK="workbench.view.search",e.$ZK="workbench.panel.search",e.$1K="workbench.view.search",e.$2K="search-result",e.$3K="search.exclude";const u="\u27EA ",w=" characters skipped \u27EB",d=(u.length+w.length+5)*2;e.$4K=(0,m.$qi)("searchService");var n;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text",ue[ue.aiText=2]="aiText"})(n||(e.SearchProviderType=n={}));var o;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text",ue[ue.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(ue){return!!ue.preview}function r(ue){return!!ue.resource}function i(ue){return!!ue.message}var a;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class h{constructor(pe){this.resource=pe,this.results=[]}}e.$8K=h;class t{constructor(pe,re,Se,Le){this.ranges=re,this.webviewIndex=Le;const ne=Array.isArray(re)?re:[re];if(Se&&Se.matchLines===1&&b(ne)){pe=(0,M.$Wf)(pe,Se.matchLines);let U="",x=0,be=0;const Ne=Math.floor(Se.charsPerLine/5),Ee=[];for(const $e of ne){const fe=Math.max($e.startColumn-Ne,0),Q=$e.startColumn+Se.charsPerLine;if(fe>be+Ne+d){const Y=u+(fe-be)+w;U+=Y+pe.slice(fe,Q),x+=fe-(be+Y.length)}else U+=pe.slice(be,Q);Ee.push(new $(0,$e.startColumn-x,$e.endColumn-x)),be=Q}this.preview={text:U,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const U=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:pe,matches:(0,I.$2b)(re,x=>new c(x.startLineNumber-U,x.startColumn,x.endLineNumber-U,x.endColumn))}}}}e.$9K=t;function b(ue){const pe=ue[0].startLineNumber;for(const re of ue)if(re.startLineNumber!==pe||re.endLineNumber!==pe)return!1;return!0}class c{constructor(pe,re,Se,Le){this.startLineNumber=pe,this.startColumn=re,this.endLineNumber=Se,this.endColumn=Le}}e.$0K=c;class $ extends c{constructor(pe,re,Se){super(pe,re,pe,Se)}}e.$$K=$;var v;(function(ue){ue.List="list",ue.Tree="tree"})(v||(e.ViewMode=v={}));var p;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function l(ue,pe=!0){const re=ue&&ue.files&&ue.files.exclude,Se=pe&&ue&&ue.search&&ue.search.exclude;if(!re&&!Se)return;if(!re||!Se)return re||Se;let Le=Object.create(null);return Le=R.$Zn(Le,R.$Wn(re)),Le=R.$Zn(Le,R.$Wn(Se),!0),Le}function D(ue,pe){return ue.excludePattern&&N.$jk(ue.excludePattern,pe)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&N.$jk(ue.includePattern,pe)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(re=>{const Se=re.folder.fsPath;if(F.$qg(pe,Se)){const Le=g.$mc(Se,pe);return!re.includePattern||!!N.$jk(re.includePattern,Le)}else return!1}):!1:!0}var f;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(f||(e.SearchErrorCode=f={}));class S extends Error{constructor(pe,re){super(pe),this.code=re}}e.$bL=S;function y(ue){const pe=ue.message;if((0,E.$4)(ue))return new S(pe,f.canceled);try{const re=JSON.parse(pe);return new S(re.message,re.code)}catch{return new S(pe,f.other)}}function C(ue){const pe={message:ue.message,code:ue.code};return new Error(JSON.stringify(pe))}function P(ue){return ue.type==="error"?!0:ue.type==="success"}function V(ue){return ue.type==="success"}function W(ue){return!!ue.path}function q(ue,pe,re=!0){const Se=ue.searchPath?ue.searchPath:ue.relativePath;return re?(0,M.$Tf)(Se,pe):N.$jk(pe,Se)}class A{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$iL=A;function j(ue,pe){const re={...ue||{},...pe||{}};return Object.keys(re).filter(Se=>{const Le=re[Se];return typeof Le=="boolean"&&Le})}class K{constructor(pe,re){this.c=null,this.a={...pe.excludePattern||{},...re.excludePattern||{}},this.b=N.$kk(this.a);let Se=pe.includePattern;re.includePattern&&(Se?Se={...Se,...re.includePattern}:Se=re.includePattern),Se&&(this.c=N.$kk(Se))}matchesExcludesSync(pe,re,Se){return!!(this.b&&this.b(pe,re,Se))}includedInQuerySync(pe,re,Se){return!(this.b&&this.b(pe,re,Se)||this.c&&!this.c(pe,re,Se))}includedInQuery(pe,re,Se){const Le=this.b(pe,re,Se),ne=()=>this.c?!!this.c(pe,re,Se):!0;return(0,k.$ch)(Le)?Le.then(U=>U?!1:ne()):ne()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$kL=K;function ie(ue){for(const pe in ue)if(typeof ue[pe]!="boolean")return!0;return!1}function ce(ue){if(!ue)return;let pe;return re=>(pe||(pe=(ue()||Promise.resolve([])).then(Se=>Se?Ie(Se):{})),pe.then(Se=>!!Se[re]))}function ve(ue){if(!ue)return;let pe;return re=>{if(!pe){const Se=ue();pe=Se?Ie(Se):{}}return!!pe[re]}}function Ie(ue){const pe={};for(const re of ue)pe[re]=!0;return pe}}),define(Re[37],Ae([1,0,18,11,24,5,6,52,12,126,23,15,2,175,3,13,195,49,44,27,16,8,7,60,45,4,53]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s,r,i,a,h,t,b,c,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=e.$kkc=void 0;function p(V,W,q){return new T.$Sg(A=>S(A,q)).isEqual(V,W)}function l(V,W,q){return p(V.uri,W.uri,q)?0:(0,k.$mf)(V.uri.toString(),W.uri.toString())}function D(V,W,q){return V.index!==W.index?V.index<W.index?-1:1:p(V.uri,W.uri,q)?(0,k.$mf)(V.name,W.name):(0,k.$mf)(V.uri.toString(),W.uri.toString())}function f(V,W,q,A){const j=V.slice(0).sort((ie,ce)=>q(ie,ce,A)),K=W.slice(0).sort((ie,ce)=>q(ie,ce,A));return(0,I.$Eb)(j,K,(ie,ce)=>q(ie,ce,A))}function S(V,W){const q=W.getCapabilities(V.scheme);return!(q&&q&1024)}class y extends s.$Ji{static toExtHostWorkspace(W,q,A,j){if(!W)return{workspace:null,added:[],removed:[]};const{id:K,name:ie,folders:ce,configuration:ve,transient:Ie,isUntitled:ue}=W,pe=[],re=q;q?ce.forEach((U,x)=>{const be=u.URI.revive(U.uri),Ne=y.o(A||q,be,j);Ne?(Ne.name=U.name,Ne.index=U.index,pe.push(Ne)):pe.push({uri:be,name:U.name,index:x})}):pe.push(...ce.map(({uri:U,name:x,index:be})=>({uri:u.URI.revive(U),name:x,index:be}))),pe.sort((U,x)=>U.index<x.index?-1:1);const Se=new y(K,ie,pe,!!Ie,ve?u.URI.revive(ve):null,!!ue,U=>S(U,j)),{added:Le,removed:ne}=f(re?re.workspaceFolders:[],Se.workspaceFolders,l,j);return{workspace:Se,added:Le,removed:ne}}static o(W,q,A){for(let j=0;j<W.folders.length;j++){const K=W.workspaceFolders[j];if(p(K.uri,q,A))return K}}constructor(W,q,A,j,K,ie,ce){super(W,A.map(ve=>new s.$Ki(ve)),j,K,ce),this.t=q,this.u=ie,this.q=[],this.s=m.$wi.forUris(ce),A.forEach(ve=>{this.q.push(ve),this.s.set(ve.uri,ve)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,q){return q&&this.s.get(W)&&(W=(0,T.$3g)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let C=class{constructor(W,q,A,j,K){this.c=new F.$be,this.onDidChangeWorkspace=this.c.event,this.g=new F.$be,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new F.$de,this.C=new Map,this.h=j,this.s=A,this.t=K,this.j=new E.$xm,this.k=new N.$ph,this.o=W.getProxy($.$PM.MainThreadWorkspace),this.q=W.getProxy($.$PM.MainThreadMessageService);const ie=q.workspace;this.l=ie?new y(ie.id,ie.name,[],!!ie.transient,ie.configuration?u.URI.revive(ie.configuration):null,!!ie.isUntitled,ce=>S(ce,A)):void 0}$initializeWorkspace(W,q){this.v=q,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:g.Schemas.untitled,path:(0,T.$1g)((0,T.$3g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,q,A,...j){const K=[];if(Array.isArray(j)&&j.forEach(ue=>{u.URI.isUri(ue.uri)&&!K.some(pe=>p(pe.uri,ue.uri,this.s))&&K.push({uri:ue.uri,name:ue.name||(0,T.$Zg)(ue.uri)})}),this.n||[q,A].some(ue=>typeof ue!="number"||ue<0)||A===0&&K.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+A>ie.length)return!1;const ce=ie.slice(0);ce.splice(q,A,...K.map(ue=>({uri:ue.uri,name:ue.name||(0,T.$Zg)(ue.uri),index:void 0})));for(let ue=0;ue<ce.length;ue++){const pe=ce[ue];if(ce.some((re,Se)=>Se!==ue&&p(pe.uri,re.uri,this.s)))return!1}ce.forEach((ue,pe)=>ue.index=pe);const{added:ve,removed:Ie}=f(ie,ce,D,this.s);if(ve.length===0&&Ie.length===0)return!1;if(this.o){const ue=W.displayName||W.name;this.o.$updateWorkspaceFolders(ue,q,A,K).then(void 0,pe=>{this.n=void 0;const re={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(o.Severity.Error,(0,w.localize)(0,null,ue,pe.toString()),re,[])})}return this.y(ce),!0}getWorkspaceFolder(W,q){if(this.x)return this.x.getWorkspaceFolder(W,q)}async getWorkspaceFolder2(W,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,q)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,q){let A,j="";if(typeof W=="string"?(A=u.URI.file(W),j=W):typeof W<"u"&&(A=W,j=W.fsPath),!A)return j;const K=this.getWorkspaceFolder(A,!0);if(!K)return j;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,T.$6g)(K.uri,A);return q&&K.name&&(ie=`${K.name}/${ie}`),ie}y(W){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:q,added:A,removed:j}=y.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:A,removed:j}))}findFiles(W,q,A,j,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let ie="",ce=!0;return q===null?ce=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(W,void 0,{exclude:ie,maxResults:A,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(W,q={},A,j=R.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${A.value}, entryPoint: findFiles2`),this.z(void 0,W,q,j)}async z(W,q,A,j=R.CancellationToken.None){if(j&&j.isCancellationRequested)return Promise.resolve([]);const K=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,ie={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof A.useDefaultSearchExcludes=="boolean"?!A.useDefaultSearchExcludes:!1,maxResults:A.maxResults,excludePattern:K,shouldGlobSearch:typeof A.fuzzy=="boolean"?!A.fuzzy:!0,_reason:"startFileSearch"};let ce;if(W){const{includePattern:ve,folder:Ie}=P(h.GlobPattern.from(W));ce=Ie,ie.includePattern=ve}else{const{includePattern:ve,folder:Ie}=P(h.GlobPattern.from(q));ce=Ie,ie.filePattern=ve}return this.o.$startFileSearch(ce??null,ie,j).then(ve=>Array.isArray(ve)?ve.map(Ie=>u.URI.revive(Ie)):[])}async findTextInFiles(W,q,A,j,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),ce=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ve,folder:Ie}=P(h.GlobPattern.from(q.include)),ue=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,pe={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ce,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ve,excludePattern:ue},re=!1;if(this.u[ie]=Se=>{if(re)return;const Le=u.URI.revive(Se.resource);Se.results.forEach(ne=>{const U=(0,v.$Zh)(ne);(0,c.$5K)(U)?A({uri:Le,preview:{text:U.preview.text,matches:(0,I.$2b)(U.preview.matches,x=>new t.$TM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,I.$2b)(U.ranges,x=>new t.$TM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):A({uri:Le,text:U.text,lineNumber:U.lineNumber})})},K.isCancellationRequested)return{};try{const Se=await this.o.$startTextSearch(W,Ie??null,pe,ie,K);return delete this.u[ie],Se||{}}catch(Se){throw delete this.u[ie],Se}}$handleTextSearchResult(W,q){this.u[q]?.(W)}async save(W){const q=await this.o.$save(W,{saveAs:!1});return u.URI.revive(q)}async saveAs(W){const q=await this.o.$save(W,{saveAs:!0});return u.URI.revive(q)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,q){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,q);const A=this.t.transformOutgoingScheme(W),j=this.A++;return this.o.$registerEditSessionIdentityProvider(j,A),(0,M.$Sc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(W,q){this.h.info("Getting edit session identifier for workspaceFolder",W);const A=await this.resolveWorkspaceFolder(u.URI.revive(W));if(!A){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",A);const j=this.w.get(A.uri.scheme);if(this.h.info(`Provider for scheme ${A.uri.scheme} is defined: `,!!j),!j)return;const K=await j.provideEditSessionIdentity(A,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(W,q,A,j){this.h.info("Getting edit session identifier for workspaceFolder",W);const K=await this.resolveWorkspaceFolder(u.URI.revive(W));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ie=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ie),!ie)return;const ce=await ie.provideEditSessionIdentityMatch?.(q,A,j);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(W){return(q,A,j)=>{const K=function(ce){q.call(A,ce)};return K.extension=W,this.B.event(K,void 0,j)}}async $onWillCreateEditSessionIdentity(W,q,A){const j=await this.resolveWorkspaceFolder(u.URI.revive(W));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:j},q,async(K,ie)=>{const ce=Date.now();await Promise.resolve(K),Date.now()-ce>A&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(W,q){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,q);const A=this.t.transformOutgoingScheme(W),j=this.A++;return this.o.$registerCanonicalUriProvider(j,A),(0,M.$Sc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(W,q,A){const j=this.C.get(W.scheme);if(!j)return;const K=await j.provideCanonicalUri?.(u.URI.revive(W),q,A);if(K)return K}async $provideCanonicalUri(W,q,A){return this.provideCanonicalUri(u.URI.revive(W),{targetScheme:q},A)}};e.$kkc=C,e.$kkc=C=Je([Ve(0,a.$aP),Ve(1,i.$qP),Ve(2,r.$6jc),Ve(3,n.$Wj),Ve(4,b.$ikc)],C),e.$lkc=(0,d.$qi)("IExtHostWorkspace");function P(V){let W,q;return V&&(typeof V=="string"?W=V:(W=V.pattern,q=u.URI.revive(V.baseUri))),{includePattern:W,folder:q}}}),define(Re[38],Ae([1,0,26,5,37,4,7,197,57,17,11,3,16,13,2]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=e.$nkc=e.$mkc=void 0;function n(b,c){if(c){const $=c.split(".");let v=b;for(let p=0;v&&p<$.length;p++)v=v[$[p]];return v}}function o(b){return b instanceof d.URI}function s(b){return b&&b.uri instanceof d.URI&&b.languageId&&typeof b.languageId=="string"}function r(b){return b&&!b.uri&&b.languageId&&typeof b.languageId=="string"}function i(b){return b&&b.uri instanceof d.URI&&(!b.name||typeof b.name=="string")&&(!b.index||typeof b.index=="number")}function a(b){if(o(b))return{resource:b};if(s(b))return{resource:b.uri,overrideIdentifier:b.languageId};if(r(b))return{overrideIdentifier:b.languageId};if(i(b))return{resource:b.uri};if(b===null)return{resource:null}}let h=class{constructor(c,$,v){this.a=c.getProxy(F.$PM.MainThreadConfiguration),this.c=$,this.b=v,this.d=new T.$ph,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,$){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(c,$))}};e.$mkc=h,e.$mkc=h=Je([Ve(0,u.$aP),Ve(1,R.$lkc),Ve(2,w.$Wj)],h);class t{constructor(c,$,v,p){this.a=new N.$be,this.b=c,this.f=p,this.c=$,this.e=m.$uo.parse(v),this.d=this.k(v.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,$){const v={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$uo.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j($,v))}getConfiguration(c,$,v){const p=a($)||{},l=this.g(c?n(this.e.getValue(void 0,p,this.c.workspace),c):this.e.getValue(void 0,p,this.c.workspace));c&&this.h(c,p,v?.identifier);function D(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(S){return typeof n(l,S)<"u"},get:(S,y)=>{this.h(c?`${c}.${S}`:S,p,v?.identifier);let C=n(l,S);if(typeof C>"u")C=y;else{let P;const V=(W,q)=>{if((0,E.$6f)(W)){let A;const j=()=>{P=P||(0,I.$Wn)(l),A=A||n(P,q)};return new Proxy(W,{get:(K,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return j(),()=>A;if(P)return A=A||n(P,q),A[ie];const ce=K[ie];return typeof ie=="string"?V(ce,`${q}.${ie}`):ce},set:(K,ie,ce)=>(j(),A&&(A[ie]=ce),!0),deleteProperty:(K,ie)=>(j(),A&&delete A[ie],!0),defineProperty:(K,ie,ce)=>(j(),A&&Object.defineProperty(A,ie,ce),!0)})}return Array.isArray(W)?(0,I.$Wn)(W):W};C=V(C,S)}return C},update:(S,y,C,P)=>{S=c?`${c}.${S}`:S;const V=D(C);return y!==void 0?this.b.$updateConfigurationOption(V,S,y,p,P):this.b.$removeConfigurationOption(V,S,p,P)},inspect:S=>{S=c?`${c}.${S}`:S;const y=this.e.inspect(S,p,this.c.workspace);if(y)return{key:S,defaultValue:(0,I.$Wn)(y.policy?.value??y.default?.value),globalValue:(0,I.$Wn)(y.user?.value??y.application?.value),workspaceValue:(0,I.$Wn)(y.workspace?.value),workspaceFolderValue:(0,I.$Wn)(y.workspaceFolder?.value),defaultLanguageValue:(0,I.$Wn)(y.default?.override),globalLanguageValue:(0,I.$Wn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,I.$Wn)(y.workspace?.override),workspaceFolderLanguageValue:(0,I.$Wn)(y.workspaceFolder?.override),languageIds:(0,I.$Wn)(y.overrideIdentifiers)}}};return typeof l=="object"&&(0,I.$Zn)(f,l,!1),Object.freeze(f)}g(c){const $=v=>(0,E.$6f)(v)?new Proxy(v,{get:(p,l)=>$(p[l]),set:(p,l,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(p,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(p,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return $(c)}h(c,$,v){const p=g.$lo.test(c)?4:this.d.get(c),l=v?`[${v.value}] `:"";if(p===4){typeof $?.resource>"u"&&this.f.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){$?.resource&&this.f.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,$){const v=new m.$wo(c,$,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(p,l)=>v.affectsConfiguration(p,a(l))})}k(c){return c.reduce(($,v)=>($.set(v[0],v[1]),$),new Map)}}e.$nkc=t,e.$okc=(0,k.$qi)("IExtHostConfiguration")}),define(Re[119],Ae([1,0,2,11,5,4,7,37,67,38,24,51,16,27,3,12,21,13,78,231,14]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Slc=e.$Rlc=e.$Qlc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(h||(h={}));var t;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(t||(t={}));var b;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(b||(b={}));var c;(function(V){function W(j){if(j){const K=j;return K&&!!K.process}else return!1}V.is=W;function q(j){if(j==null)return;const K={process:j.process,args:j.args};return j.options&&(K.options=b.from(j.options)),K}V.from=q;function A(j){if(j!=null)return new M.$AN(j.process,j.args,j.options)}V.to=A})(c||(c={}));var $;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})($||($={}));var v;(function(V){function W(j){if(j){const K=j;return K&&(!!K.commandLine||!!K.command)}else return!1}V.is=W;function q(j){if(j==null)return;const K={};return j.commandLine!==void 0?K.commandLine=j.commandLine:(K.command=j.command,K.args=j.args),j.options&&(K.options=$.from(j.options)),K}V.from=q;function A(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new M.$BN(j.commandLine,j.options):new M.$BN(j.command,j.args?j.args:[],j.options)}V.to=A})(v||(v={}));var p;(function(V){function W(j){if(j){const K=j;return K&&K.customExecution==="customExecution"}else return!1}V.is=W;function q(j){return{customExecution:"customExecution"}}V.from=q;function A(j,K){return K.get(j)}V.to=A})(p||(e.CustomExecutionDTO=p={}));var l;(function(V){function W(q,A){let j;return q.scope!==void 0&&typeof q.scope!="number"?j=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===M.TaskScope.Workspace&&A&&A.workspaceFile?j=A.workspaceFile:j=i.$VH),{id:q._id,workspaceFolder:j}}V.from=W})(l||(e.TaskHandleDTO=l={}));var D;(function(V){function W(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}V.from=W})(D||(D={}));var f;(function(V){function W(j,K){if(j==null)return[];const ie=[];for(const ce of j){const ve=q(ce,K);ve&&ie.push(ve)}return ie}V.fromMany=W;function q(j,K){if(j==null)return;let ie;j.execution instanceof M.$AN?ie=c.from(j.execution):j.execution instanceof M.$BN?ie=v.from(j.execution):j.execution&&j.execution instanceof M.$CN&&(ie=p.from(j.execution));const ce=h.from(j.definition);let ve;return j.scope?typeof j.scope=="number"?ve=j.scope:ve=j.scope.uri:ve=M.TaskScope.Workspace,!ce||!ve?void 0:{_id:j._id,definition:ce,name:j.name,source:{extensionId:K.identifier.value,label:j.source,scope:ve},execution:ie,isBackground:j.isBackground,group:D.from(j.group),presentationOptions:t.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}V.from=q;async function A(j,K,ie){if(j==null)return;let ce;c.is(j.execution)?ce=c.to(j.execution):v.is(j.execution)?ce=v.to(j.execution):p.is(j.execution)&&(ce=p.to(j._id,ie));const ve=h.to(j.definition);let Ie;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?Ie=j.source.scope:Ie=await K.resolveWorkspaceFolder(I.URI.revive(j.source.scope)):Ie=M.TaskScope.Workspace),!ve||!Ie)return;const ue=new M.$DN(ve,Ie,j.name,j.source.label,ce,j.problemMatchers);return j.isBackground!==void 0&&(ue.isBackground=j.isBackground),j.group!==void 0&&(ue.group=M.$zN.from(j.group._id),ue.group&&j.group.isDefault&&(ue.group=new M.$zN(ue.group.id,ue.group.label),j.group.isDefault===!0&&(ue.group.isDefault=j.group.isDefault))),j.presentationOptions&&(ue.presentationOptions=t.to(j.presentationOptions)),j._id&&(ue._id=j._id),j.detail&&(ue.detail=j.detail),ue}V.to=A})(f||(e.TaskDTO=f={}));var S;(function(V){function W(A){return A}V.from=W;function q(A){if(A)return Object.assign(Object.create(null),A)}V.to=q})(S||(S={}));class y{#e;constructor(W,q,A){this._id=q,this.a=A,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let C=class{constructor(W,q,A,j,K,ie,ce,ve){this.q=new R.$be,this.r=new R.$be,this.s=new R.$be,this.u=new R.$be,this.a=W.getProxy(F.$PM.MainThreadTask),this.b=A,this.c=j,this.d=K,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ve,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,q,A){if(!A)return new M.$RM(()=>{});const j=this.x();return this.j.set(j,{type:q,provider:A,extension:W}),this.a.$registerTaskProvider(j,q),new M.$RM(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(W,q){this.a.$registerTaskSystem(W,q)}fetchTasks(W){return this.a.$fetchTasks(S.from(W)).then(async q=>{const A=[];for(const j of q){const K=await f.to(j,this.b,this.m);K&&A.push(K)}return A})}get taskExecutions(){const W=[];return this.k.forEach(q=>W.push(q)),W}terminateTask(W){if(!(W instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,q,A){const j=this.m.get(W.id);j&&(this.o.set(W.id,j),this.e.attachPtyToTerminal(q,await j.callback(A))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const q=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const q=await this.z(W.id);this.s.fire({execution:q,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const q=await this.z(W.id);this.u.fire({execution:q,exitCode:W.exitCode})}$provideTasks(W,q){const A=this.j.get(W);if(!A)return Promise.reject(new Error("no handler found"));const j=[],K=(0,N.$ih)(()=>A.provider.provideTasks(T.CancellationToken.None)).then(ie=>this.v(q,j,A,ie));return new Promise(ie=>{K.then(ce=>{Promise.all(j).then(()=>{ie(ce)})})})}async $resolveTask(W,q){const A=this.j.get(W);if(!A)return Promise.reject(new Error("no handler found"));if(q.definition.type!==A.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${A.type}].`);const j=await f.to(q,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const K=await A.provider.resolveTask(j,T.CancellationToken.None);if(!K)return;this.A(K,A);const ie=f.from(K,A.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(ie.execution)&&await this.y(ie,K,!0),await this.w(ie)}x(){return this.h++}async y(W,q,A){const j=await this.a.$createTaskId(W);!A&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,q.execution)),this.m.set(j,q.execution)}async z(W,q){if(typeof W=="string"){const K=this.l.get(W);if(!K)throw new a.$bb("Unexpected: The specified task is missing an execution");return K}const A=this.l.get(W.id);if(A)return A;let j;return q?j=Promise.resolve(new y(this,W.id,q)):j=f.to(W.task,this.b,this.m).then(K=>{if(!K)throw new a.$bb("Unexpected: Task does not exist.");return new y(this,W.id,K)}),this.l.set(W.id,j),j.then(K=>(this.k.set(W.id,K),K))}A(W,q){W._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const A=this.n.values();let j=A.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=A.next()}};e.$Qlc=C,e.$Qlc=C=Je([Ve(0,u.$aP),Ve(1,w.$qP),Ve(2,m.$lkc),Ve(3,g.$lP),Ve(4,E.$okc),Ve(5,k.$Mkc),Ve(6,s.$Wj),Ve(7,r.$2jc)],C);let P=class extends C{constructor(W,q,A,j,K,ie,ce,ve){super(W,q,A,j,K,ie,ce,ve),this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(W,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const A=f.from(q,W);if(A===void 0)throw new Error("Task is not valid");if(p.is(A.execution))await this.y(A,q,!1);else throw new a.$_;const j=await this.z(await this.a.$getTaskExecution(A),q);return this.a.$executeTask(A).catch(K=>{throw new Error(K)}),j}v(W,q,A,j){const K=[];if(j)for(const ie of j){if(this.A(ie,A),!ie.definition||!W[ie.definition.type]){const ve=ie.source?ie.source:"No task source";this.f.warn(`The task [${ve}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=f.from(ie,A.extension);ce&&p.is(ce.execution)?(K.push(ce),q.push(this.y(ce,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:A.extension}}async w(W){if(p.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,q,A){}};e.$Rlc=P,e.$Rlc=P=Je([Ve(0,u.$aP),Ve(1,w.$qP),Ve(2,m.$lkc),Ve(3,g.$lP),Ve(4,E.$okc),Ve(5,k.$Mkc),Ve(6,s.$Wj),Ve(7,r.$2jc)],P),e.$Slc=(0,d.$qi)("IExtHostTask")}),define(Re[289],Ae([1,0,45,29]),function(ge,e,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tL=void 0,e.$sL=R,e.$uL=F;function R(M){return"cellResults"in M}e.$tL="rawCell#";function F(M,m){let g=-1;const E=[];let T=[];return M.forEach(u=>{u.range.startLineNumber!==g&&T.length>0&&(E.push([...T]),T=[]),T.push(u),g=u.range.endLineNumber}),T.length>0&&E.push([...T]),E.map(u=>{const w=[],d=u[0].range.startLineNumber,n=u[u.length-1].range.endLineNumber;for(let o=d;o<=n;o++)w.push(m.getLineContent(o));return new I.$9K(w.join(`
`)+`
`,u.map(o=>new N.$kt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Re[290],Ae([1,0,169,22,5,6,28,15,17,2,43,74,4,32,8,7,34,265,112,26,12,221,289,287]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s,r,i,a,h,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(v=>v.apiEditor)}constructor(v,p,l,D,f,S){this.q=l,this.r=D,this.s=f,this.t=S,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new R.$be,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.$be,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.$be,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.$be,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$Zjc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=v.getProxy(u.$PM.MainThreadNotebook),this.c=v.getProxy(u.$PM.MainThreadNotebookDocuments),this.d=v.getProxy(u.$PM.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const C=y.notebookEditor?.notebookUri,P=y.cell.handle,W=this.g.get(C)?.getCell(P);if(W)return W.apiCell}if(y&&y.$mid===14){const C=y.uri,P=this.g.get(C);if(P)return P.apiNotebook}return y}}),c.B(p)}getEditorById(v){const p=this.h.get(v);if(!p)throw new Error(`unknown text editor: ${v}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(v){for(const[p,l]of this.h)if(l.apiEditor===v)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(v,p){const l=this.g.get(v);if(!l&&!p)throw new Error(`NO notebook document for '${v}'`);return l}static u(v,p){if(!p)return;const l=p.filenamePattern.map(D=>d.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(p.filenamePattern&&!l){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:v.identifier,providerDisplayName:v.displayName||v.name,displayName:p.displayName,filenamePattern:l,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(v,p,l){const D=c.a++,f=typeof l.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(D,l),this.b.$registerNotebookCellStatusBarItemProvider(D,f,p);let S;return f!==void 0&&(S=l.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(f))),new n.$RM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,f),S?.dispose()})}async createNotebookDocument(v){const p=await this.c.$tryCreateNotebook({viewType:v.viewType,content:v.content&&d.NotebookData.from(v.content)});return E.URI.revive(p)}async openNotebookDocument(v){const p=this.g.get(v);if(p)return p.apiNotebook;const l=await this.c.$tryOpenNotebook(v),D=this.g.get(E.URI.revive(l));return(0,g.$cg)(D?.apiNotebook)}async showNotebookDocument(v,p){E.URI.isUri(v)&&(v=await this.openNotebookDocument(v));let l;typeof p=="object"?l={position:d.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(d.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:l={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(v.uri,v.notebookType,l),f=D&&this.h.get(D)?.apiEditor;if(f)return f;throw D?new Error(`Could NOT open editor for "${v.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(v,p,l,D){const f=this.f.get(v),S=E.URI.revive(p),y=this.g.get(S);if(!y||!f)return;const C=y.getCellFromIndex(l);if(!C)return;const P=await f.provideCellStatusBarItems(C.apiCell,D);if(!P)return;const V=new F.$Tc,W=this.p.add([V]),A=(Array.isArray(P)?P:[P]).map(j=>d.NotebookStatusBarItem.from(j,this.i,V));return{cacheId:W,items:A}}$releaseNotebookCellStatusBarItems(v){this.p.delete(v)}registerNotebookSerializer(v,p,l,D,f){if((0,m.$3e)(p))throw new Error("viewType cannot be empty or just whitespace");const S=this.w++;return this.x.set(S,{viewType:p,serializer:l,options:D}),this.b.$registerNotebookSerializer(S,{id:v.identifier,location:v.extensionLocation},p,d.NotebookDocumentContentOptions.from(D),c.u(v,f)),(0,F.$Sc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(v,p,l){const D=this.x.get(v);if(!D)throw new Error("NO serializer found");const f=await D.serializer.deserializeNotebook(p.buffer,l);return new o.$mw(d.NotebookData.from(f))}async $notebookToData(v,p,l){const D=this.x.get(v);if(!D)throw new Error("NO serializer found");const f=await D.serializer.serializeNotebook(d.NotebookData.to(p.value),l);return N.$Ce.wrap(f)}async $saveNotebook(v,p,l,D,f){const S=E.URI.revive(p),y=this.x.get(v);if(!y)throw new Error("NO serializer found");const C=this.g.get(S);if(!C)throw new Error("Document NOT found");if(C.versionId!==l)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new T.$fl((0,I.localize)(0,null,this.z(S)),6);await this.y(S,D);const P={metadata:(0,i.$5n)(C.apiNotebook.metadata,j=>!(y.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of C.apiNotebook.getCells()){const K=new n.$hO(j.kind,j.document.getText(),j.document.languageId,j.mime,y.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);K.metadata=(0,i.$5n)(j.metadata,ie=>!(y.options?.transientCellMetadata??{})[ie]),P.cells.push(K)}const V=await y.serializer.serializeNotebook(P,f);await this.s.value.writeFile(S,V);const W=this.s.getFileSystemProviderExtUri(S.scheme),q=await this.s.value.stat(S);return{name:W.basename(S),isFile:(q.type&T.FileType.File)!==0,isDirectory:(q.type&T.FileType.Directory)!==0,isSymbolicLink:(q.type&T.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&T.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((q.permissions??0)&T.FilePermission.Locked),etag:T.$ql({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(v,p,l,D,f){const S=this.x.get(v)?.serializer;if(!S)return{limitHit:!1,results:[]};const y=new M.$Cc;await(async(q,A,j)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(ie=>{const ce={_reason:j._reason,folderQueries:j.folderQueries,includePattern:j.includePattern,excludePattern:j.excludePattern,maxResults:j.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(ce,A,ve=>{ve.forEach(Ie=>{y.has(Ie)||D.some(pe=>K.isFromSettings&&!pe.isFromSettings?!1:pe.filenamePatterns.some(re=>(0,b.$mgb)(re,Ie)))||y.add(Ie)})}).catch(ve=>{if(ve.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ve})}))))})(l,f,p);const P=new M.$Bc;let V=!1;const W=Array.from(y).map(async q=>{const A=[];try{if(f.isCancellationRequested)return;if(p.maxResults&&[...P.values()].reduce((ce,ve)=>ce+ve.cellResults.length,0)>p.maxResults){V=!0;return}const j=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(ve=>j.push({input:ve.document.getText(),outputs:ve.outputs.flatMap(Ie=>Ie.items.map(ue=>ue.data.toString()))}));else{const ce=await this.s.value.readFile(q),ve=N.$Ce.fromString(ce.toString()),Ie=await S.deserializeNotebook(ve.buffer,f);if(f.isCancellationRequested)return;d.NotebookData.from(Ie).cells.forEach(pe=>j.push({input:pe.source,outputs:pe.outputs.flatMap(re=>re.items.map(Se=>Se.valueBytes.toString()))}))}if(f.isCancellationRequested)return;j.forEach((ce,ve)=>{const Ie=p.contentPattern.pattern,ue=new h.$_Vb(ce.input,void 0,ce.outputs),pe=ue.findInInputs(Ie),re=ue.findInOutputs(Ie),Se=re.flatMap(Le=>(0,t.$uL)(Le.matches,Le.textBuffer)).map((Le,ne)=>(Le.webviewIndex=ne,Le));if(pe.length>0||re.length>0){const Le={index:ve,contentResults:(0,t.$uL)(pe,ue.inputTextBuffer),webviewResults:Se};A.push(Le)}});const ie={resource:q,cellResults:A};P.set(q,ie);return}catch{return}});return await Promise.all(W),{limitHit:V,results:[...P.values()]}}async y(v,p){const l=await this.s.value.stat(v);if(typeof p?.mtime=="number"&&typeof p.etag=="string"&&p.etag!==T.$pl&&typeof l.mtime=="number"&&typeof l.size=="number"&&p.mtime<l.mtime&&p.etag!==T.$ql({mtime:p.mtime,size:l.size}))throw new T.$fl((0,I.localize)(1,null),3,p)}z(v){return v.scheme===a.Schemas.file?v.fsPath:v.toString()}A(v,p,l){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const D=new r.$klc(p,this.d,v,l.visibleRanges.map(d.NotebookRange.to),l.selections.map(d.NotebookRange.to),typeof l.viewColumn=="number"?d.ViewColumn.to(l.viewColumn):void 0);this.h.set(p,D)}$acceptDocumentAndEditorsDelta(v){if(v.value.removedDocuments)for(const l of v.value.removedDocuments){const D=E.URI.revive(l),f=this.g.get(D);f&&(f.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(f.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===D.toString()&&this.h.delete(S.id)}if(v.value.addedDocuments){const l=[];for(const D of v.value.addedDocuments){const f=E.URI.revive(D.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const S=new s.$jlc(this.c,this.q,this.r,f,D);l.push(...D.cells.map(y=>s.$ilc.asModelAddData(y))),this.g.get(f)?.dispose(),this.g.set(f,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:l}),this.m.fire(S.apiNotebook)}}if(v.value.addedEditors)for(const l of v.value.addedEditors){if(this.h.has(l.id))return;const D=E.URI.revive(l.documentUri),f=this.g.get(D);f&&this.A(f,l.id,l)}const p=[];if(v.value.removedEditors)for(const l of v.value.removedEditors){const D=this.h.get(l);D&&(this.h.delete(l),this.k?.id===D.id&&(this.k=void 0),p.push(D))}if(v.value.visibleEditors){this.l=v.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const l=new Set;this.l.forEach(D=>l.add(D.id));for(const D of this.h.values()){const f=l.has(D.id);D._acceptVisibility(f)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}v.value.newActiveEditor===null?this.k=void 0:v.value.newActiveEditor&&(this.h.get(v.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${v.value.newActiveEditor}`),this.k=this.h.get(v.value.newActiveEditor)),v.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(v){const p=w.$yP.String.with("notebookType","A notebook type"),l=new w.$AP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new w.$yP("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>N.$Ce.wrap(f))],new w.$zP("Notebook Data",f=>d.NotebookData.to(f.value))),D=new w.$AP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new w.$yP("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new o.$mw(d.NotebookData.from(f)))],new w.$zP("Bytes",f=>f.buffer));v.registerApiCommand(l),v.registerApiCommand(D)}}e.$tlc=c}),define(Re[291],Ae([1,0,19,24,42,36,23,65,45]),function(ge,e,I,N,R,F,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=void 0;class E{constructor(u,w,d){this.k=u,this.l=w,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&F.$kk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&F.$kk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const w=this.k.folderQueries||[];return new Promise((d,n)=>{const o=s=>{this.f++,u(s)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const r=s.toString(),i=I.$oc(r);this.j&&this.j(r,i)||this.v(o,{base:s,basename:i})}),Promise.all(w.map(s=>this.p(s,o))).then(s=>{d({limitHit:this.e,stats:s[0]||void 0})},s=>{n(new Error((0,R.$bj)(s)))})})}async p(u,w){const d=new N.$me,n=this.q(u),o=this.r(),s=new g.$kL(this.k,u),r=!s.hasSiblingExcludeClauses();let i;try{this.h.add(d),i=m.$0d.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},n,d.token),h=i.elapsed(),t=m.$0d.create();return this.g&&!this.e||(a&&a.forEach(b=>{const c=I.$hc.relative(u.folder.path,b.path);if(r){const $=I.$oc(b.path);this.v(w,{base:u.folder,relativePath:c,basename:$});return}this.s(o,u.folder,c,w)}),this.g&&!this.e)?null:(this.u(o,s,w),{providerTime:h,postProcessTime:t.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(u){const w=(0,g.$jL)(this.k.includePattern,u.includePattern),d=(0,g.$jL)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:d,includes:w,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},w,d,n){if(d===this.a){const s=I.$oc(this.a);this.v(n,{base:w,relativePath:this.a,basename:s})}function o(s){const r=I.$oc(s),i=I.$nc(s);let a=u[i];a||(a=u[i]=[],o(i)),a.push({base:w,relativePath:s,basename:r})}o(d)}u({rootEntries:u,pathToEntries:w},d,n){const o=this,s=this.a;function r(i){const a=(0,g.$mL)(()=>i.map(h=>h.basename));for(let h=0,t=i.length;h<t;h++){const b=i[h],{relativePath:c,basename:$}=b;if(d.matchesExcludesSync(c,$,s!==$?a:void 0))continue;const v=w[c];if(v)r(v);else{if(c===s)continue;o.v(n,b)}if(o.e)break}}r(u)}v(u,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(w))}}class T{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,w,d,n){const o=this.c(u.cacheKey),s=new E(u,w,o&&o.token);let r=0;const i=a=>{r+=a.length,d(a.map(h=>this.d(h)))};return this.e(s,T.a,i,n).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:a.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new N.$me),this.b.get(u)}d(u){return u.relativePath?{resource:M.$4g(u.base,u.relativePath)}:{resource:u.base}}e(u,w,d,n){const o=n.onCancellationRequested(()=>{u.cancel()}),s=i=>{i&&(r.push(i),w>0&&r.length>=w&&(d(r),r=[]))};let r=[];return u.search(s).then(i=>(r.length&&d(r),o.dispose(),i),i=>(r.length&&d(r),o.dispose(),Promise.reject(i)))}}e.$llc=T}),define(Re[292],Ae([1,0,18,260,36,96,28,12,19,23,15,17,2,95,187,48,13,49,107,288,45]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=void 0,e.$uM=D;let h=class{constructor(S,y,C,P,V){this.a=S,this.b=y,this.c=C,this.d=P,this.e=V}text(S,y,C={}){S=this.f(S,C);const P=this.a.getValue(),V=y&&y.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(y?.map(s.$Li),C),type:2,contentPattern:S,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:P.search.usePCRE2||V||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(S,y){const C=this.a.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const P={...S,wordSeparators:C.editor.wordSeparators};return this.j(S,y)&&(P.isCaseSensitive=!0),this.k(S)&&(P.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),P}file(S,y={}){return{...this.h(S,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(S,y){return S?(S=Array.isArray(S)?S.map(v):v(S),y?this.parseSearchPaths(S):{pattern:b(...Array.isArray(S)?S:[S])}):{}}h(S=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),P=this.g(y.excludePattern,y.expandPatterns),V=S.length>1,W=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(j=>this.q(j,y,P)):S.map(j=>this.r(j,y,P,V))).filter(j=>!!j),q={_reason:y._reason,folderQueries:W,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:P.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const j=I.$Hb(I.$Rb(this.c.groups.map(ce=>ce.editors.map(ve=>ve.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const K=j.filter(ce=>(0,a.$aL)(q,ce.fsPath)),ie=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const A=y.extraFileResources&&y.extraFileResources.filter(j=>(0,a.$aL)(q,j.fsPath));return q.extraFileResources=A&&A.length?A:void 0,q}i(S){const y=[],C=new M.$Bc,P={};let V=!1;return S.forEach(W=>{if(W.scheme===m.Schemas.walkThrough)return;if((0,E.$8g)(W)){const A=this.b.getWorkspaceFolder(W)?.uri??W.with({path:g.$nc(W.fsPath)});let j=C.get(A);j||(V=!0,j={folder:A,includePattern:{}},y.push(j),C.set(A,j));const K=g.$mc(A.fsPath,W.fsPath);(0,k.$cg)(j.includePattern)[K.replace(/\\/g,"/")]=!0}else W.fsPath&&(V=!0,P[W.fsPath]=!0)}),{folderQueries:y,includePattern:P,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(S,y){if(y.isSmartCase){if(S.isRegExp){if(T.$Uf(S.pattern,!0))return!0}else if(T.$Uf(S.pattern))return!0}return!!S.isCaseSensitive}k(S){return S.isMultiline||S.isRegExp&&(0,w.$BC)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const y=ie=>g.$jc(ie)||/^\.\.?([\/\\]|$)/.test(ie),P=(Array.isArray(S)?S:c(S)).map(ie=>{const ce=this.e.resolvedUserHome;return ce?(0,F.$rw)(ie,ce.scheme===m.Schemas.file?ce.fsPath:ce.path):ie}),V=N.$K(P,ie=>y(ie)?"searchPaths":"exprSegments"),W=(V.exprSegments||[]).map(ie=>T.$bf(ie,"/")).map(ie=>T.$bf(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),$(ie))),q={},A=this.m(V.searchPaths||[]);A&&A.length&&(q.searchPaths=A);const j=I.$Rb(W),K=b(...j);return K&&(q.pattern=K),q}l(S,y){return y.disregardExcludeSettings?void 0:(0,a.$_K)(S,!y.disregardSearchExcludeSettings)}m(S){if(!S||!S.length)return[];const y=S.flatMap(P=>{let{pathPortion:V,globPortion:W}=t(P);return W&&(W=p(W)),this.n(V).flatMap(A=>this.o(A,W))}),C=new Map;return y.forEach(P=>{const V=P.searchPath.toString(),W=C.get(V);W?P.pattern&&(W.pattern=W.pattern||{},W.pattern[P.pattern]=!0):C.set(V,{searchPath:P.searchPath,pattern:P.pattern?b(P.pattern):void 0})}),Array.from(C.values())}n(S){if(g.$jc(S)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==m.Schemas.file?[{searchPath:y[0].uri.with({path:S})}]:[{searchPath:u.URI.file(g.$ic(S))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(S=v(S),S.startsWith("../")||S===".."){const P=g.$hc.resolve(y.path,S);return[{searchPath:y.with({path:P})}]}const C=p(S);return[{searchPath:y,pattern:C}]}else{if(S==="./"||S===".\\")return[];{const y=S.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(V=>{const W=y.match(new RegExp(`^${T.$8e(V.name)}(?:/(.*)|$)`));return W?{match:W,folder:V}:null}).filter(k.$_f);if(P.length)return P.map(V=>{const W=V.match[1];return{searchPath:V.folder.uri,pattern:W&&p(W)}});{const V=S.match(/\.[\/\\](.+)[\/\\]?/),W=V?V[1]:S,q=d.localize(0,null,W);throw new Error(q)}}}}o(S,y){const C=S.pattern&&y?`${S.pattern}/${y}`:S.pattern||y,P=[{searchPath:S.searchPath,pattern:C}];return C&&!C.endsWith("**")&&P.push({searchPath:S.searchPath,pattern:C+"/**"}),P}q(S,y,C){const P=this.r((0,s.$Li)(S.searchPath),y,C,!1);return P?{...P,includePattern:S.pattern}:null}r(S,y,C,P){let V;const W=u.URI.isUri(S)?S:S.uri;if(C.searchPaths){const ie=C.searchPaths.filter(ce=>(0,E.$Wg)(ce.searchPath,W))[0];if(ie&&!ie.pattern)return null;ie&&(V=ie.pattern)}const q=this.a.getValue({resource:W}),j={...this.l(q,y)||{},...V||{}},K=u.URI.isUri(S)?(0,E.$1g)(S):S.name;return{folder:W,folderName:P?K:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!q.search.followSymlinks}}};e.$tM=h,e.$tM=h=Je([Ve(0,n.$Wi),Ve(1,s.$zi),Ve(2,r.$ID),Ve(3,o.$Wj),Ve(4,i.$rM)],h);function t(f){const S=f.match(/[\*\{\}\(\)\[\]\?]/);if(S){const y=S.index,C=f.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let P=f.substr(0,C.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:f.substr((C.index||0)+1)}}}return{pathPortion:f}}function b(...f){return f.length?f.reduce((S,y)=>(S[y]=!0,S),Object.create(null)):void 0}function c(f){return R.$ik(f,",").map(S=>S.trim()).filter(S=>!!S.length)}function $(f){return[`**/${f}/**`,`**/${f}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function v(f){return f.replace(/\\/g,"/")}function p(f){return v(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(f){return f.replace(/([?*[\]])/g,"[$1]")}function D(f,S){f=I.$Mb(f,P=>P.toString());const y=[],C=S.getWorkspace();return f&&f.forEach(P=>{let V;if(S.getWorkbenchState()===2)V=(0,E.$6g)(C.folders[0].uri,P),V&&V!=="."&&(V="./"+V);else{const W=S.getWorkspaceFolder(P);if(W){const q=W.name;if(C.folders.filter(j=>j.name===q).length===1){const j=(0,E.$6g)(W.uri,P);j===""?V=`./${W.name}`:V=`./${W.name}/${j}`}else V=P.fsPath}}V&&y.push(l(V))}),y}}),define(Re[293],Ae([1,0,23,2,24,14,3,292,45,49,11]),function(ge,e,I,N,R,F,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mtb=u,e.$ntb=n;const k=7e3;function u(o,s){const r=s.activationEvents;if(!r)return Promise.resolve(void 0);const i=[],a=[];for(const v of r)if(/^workspaceContains:/.test(v)){const p=v.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||o.forceUsingSearch?a.push(p):i.push(p)}if(i.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:h,resolve:t}=(0,T.$jh)(),b=v=>t({activationEvent:v}),c=Promise.all(i.map(v=>w(o,v,b))).then(()=>{}),$=d(o,s.identifier,a,b);return Promise.all([c,$]).then(()=>{t(void 0)}),h}async function w(o,s,r){for(const i of o.folders)if(await o.exists(I.$4g(N.URI.revive(i),s))){r(`workspaceContains:${s}`);return}}async function d(o,s,r,i){if(r.length===0)return Promise.resolve(void 0);const a=new R.$me,h=o.checkExists(o.folders,r,a.token),t=setTimeout(async()=>{a.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},k);let b=!1;try{b=await h}catch(c){F.$4(c)||F.$1(c)}a.dispose(),clearTimeout(t),b&&i(`workspaceContains:${r.join(",")}`)}function n(o,s,r,i){const a=o.get(M.$pi),h=o.get(g.$4K),b=a.createInstance(m.$tM).file(s.map(c=>(0,E.$Li)(N.URI.revive(c))),{_reason:"checkExists",includePattern:r,exists:!0});return h.fileSearch(b,i).then(c=>!!c.limitHit,c=>F.$4(c)?!1:Promise.reject(c))}}),define(Re[39],Ae([1,0,165,19,89,23,11,6,52,2,13,4,38,227,82,37,25,108,14,20,22,208,7,102,3,27,85,16,71,86,51,88,5,293,81,210,12,79,65,21,80]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s,r,i,a,h,t,b,c,$,v,p,l,D,f,S,y,C,P,V,W,q,A,j,K){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$4kc=e.$3kc=e.$2kc=e.$1kc=e.$Zkc=void 0,e.$Zkc=(0,c.$qi)("IHostUtils");let ce=ie=class extends m.$Uc{constructor(U,x,be,Ne,Ee,$e,fe,Q,Y,le,de,Te,he){super(),this.Y=Te,this.Z=he,this.a=this.B(new y.$be),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=be,this.f=fe,this.j=Ne,this.m=Ee,this.s=$e,this.t=Y,this.u=le,this.w=de,this.y=this.g.getProxy(k.$PM.MainThreadWorkspace),this.z=this.g.getProxy(k.$PM.MainThreadTelemetry),this.C=this.g.getProxy(k.$PM.MainThreadExtensionService),this.D=new M.$ph,this.F=new M.$ph,this.G=new M.$ph,this.H=new M.$ph,this.I=new Le(this.f.extensions.activationEvents),this.L=new s.$C$b(this.I,this.f.extensions.allExtensions);const Ce=new i.$Mm(this.f.extensions.myExtensions);this.J=new s.$C$b(this.I,re(this.L,Ce)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ue(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ue(this.J)}`)),this.M=new d.$Ikc(this.g,this.s),this.N=new P.$Skc(this.g),this.O=Q,this.h=U.createChild(new l.$oi([d.$Jkc,this.M],[P.$Tkc,this.N])),this.P=this.B(new w.$Hkc(this.J,this.L,{onExtensionActivationError:(Me,ze,z)=>{this.C.$onExtensionActivationError(Me,r.$3(ze),z)},actualActivateExtension:async(Me,ze)=>{if(s.$C$b.isHostExtension(Me,this.J,this.L))return await this.C.$activateExtension(Me,ze),new w.$Gkc;const z=this.J.getExtensionDescription(Me);return this.fb(z,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),R.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){r.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this.eb(Ee))}catch{}await Promise.all(U)}terminate(U,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(Ne=>{this.s.error(Ne)}),this.g.dispose();const be=this.$();Promise.race([(0,M.$rh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const x=await this.C.$getExtension(U);return x&&{...x,identifier:new i.$Lm(x.identifier.value),extensionLocation:E.URI.revive(x.extensionLocation)}}ab(U,x){return this.P.activateByEvent(U,x)}bb(U,x){return this.P.activateById(U,x)}activateByIdWithErrors(U,x){return this.bb(U,x).then(()=>{const be=this.P.getActivatedExtension(U);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===W.Schemas.file&&this.c.fsRealpath){const x=U.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const be=await this.R.get(x);return E.URI.file(be)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new Se(U))),this.Q}async db(U){const x=g.$wi.forUris(be=>F.$Ug.ignorePathCasing(be));return await Promise.all(U.map(async be=>{if(this.wb(be)){const Ne=await this.cb(be.extensionLocation);x.set(Ne,be)}})),x}eb(U){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return x;const be=this.P.getActivatedExtension(U);if(!be)return x;try{typeof be.module.deactivate=="function"&&(x=Promise.resolve(be.module.deactivate()).then(void 0,Ne=>(this.s.error(Ne),Promise.resolve(void 0))))}catch(Ne){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Ne)}try{(0,m.$Pc)(be.subscriptions)}catch(Ne){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Ne)}return x}async fb(U,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,x).then(be=>{const Ne=be.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Ne.codeLoadingTime,Ne.activateCallTime,Ne.activateResolvedTime,x),this.gb(U,x,"success",Ne),be},be=>{throw this.gb(U,x,"failure"),be})}gb(U,x,be,Ne){const Ee=Ie(U,x);this.z.$publicLog2("extensionActivationTimes",{...Ee,...Ne||{},outcome:be})}hb(U,x){const be=Ie(U,x);this.z.$publicLog2("activatePlugin",be);const Ne=this.wb(U);if(!Ne)return Promise.resolve(new w.$Fkc(w.$Ckc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${U.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const Ee=new w.$Dkc(x.startup);return Promise.all([this.xb(U,(0,F.$4g)(U.extensionLocation,Ne),Ee),this.ib(U)]).then($e=>(R.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),ie.jb(this.s,U.identifier,$e[0],$e[1],Ee))).then($e=>(R.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),$e))}ib(U){const x=this.Z.createLanguageModelAccessInformation(U),be=new h.$Lkc(U,this.M),Ne=new h.$Kkc(U.identifier.value,!1,this.M),Ee=new V.$Ukc(U,this.N),$e=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,fe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([be.whenReady,Ne.whenReady,this.O.whenReady]).then(()=>{const Q=this;let Y,le;const de=(0,o.$xG)(U,"ipc")?this.f.messagePorts?.get(i.$Lm.toKey(U.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Ne,secrets:Ee,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Te){return N.$kc(U.extensionLocation.fsPath,Te)},get storagePath(){return Q.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return Q.O.globalValue(U).fsPath},get logPath(){return N.$kc(Q.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return E.URI.joinPath(Q.f.logsLocation,U.identifier.value)},get storageUri(){return Q.O.workspaceValue(U)},get globalStorageUri(){return Q.O.globalValue(U)},get extensionMode(){return $e},get extension(){return Y===void 0&&(Y=new pe(Q,U.identifier,U,fe,!1)),Y},get extensionRuntime(){return(0,o.$yG)(U,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!le){if(!de)return;const Te=y.Event.buffer(y.Event.fromDOMEventEmitter(de,"message",he=>he.data));de.start(),le={onDidReceiveMessage:Te,postMessage:de.postMessage.bind(de)}}return le}})})}static jb(U,x,be,Ne,Ee){return be=be||{activate:void 0,deactivate:void 0},this.kb(U,x,be,Ne,Ee).then($e=>new w.$Ekc(!1,null,Ee.build(),be,$e,Ne.subscriptions))}static kb(U,x,be,Ne,Ee){if(typeof be.activate=="function")try{Ee.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${x.value}`);const $e=typeof global=="object"?global:self,fe=be.activate.apply($e,[Ne]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(fe).then(Q=>(Ee.activateResolveStop(),Q))}catch($e){return Promise.reject($e)}else return Promise.resolve(be)}lb(U,x){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:x}).then(void 0,be=>{this.s.error(be)})}mb(U,x=0){const Ne=Date.now();(0,j.$B)(()=>{for(let Ee=x;Ee<U.length;Ee+=1){const $e=U[Ee];for(const fe of $e.activationEvents??[])if(fe==="onStartupFinished")if(Date.now()-Ne>50){this.mb(U,Ee);break}else this.lb($e,fe)}})}nb(){this.C.$setPerformanceMarks(R.getMarks()),this.m.getConfigProvider().then(U=>{const x=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(x)this.mb(be);else for(const Ne of be)if(Ne.activationEvents)for(const Ee of Ne.activationEvents)Ee==="onStartupFinished"&&this.lb(Ne,Ee)})}ob(){const U=this.ab("*",!0).then(void 0,$e=>{this.s.error($e)});this.B(this.j.onDidChangeWorkspace($e=>this.pb($e.added)));const x=this.j.workspace?this.j.workspace.folders:[],be=this.pb(x),Ne=this.rb(),Ee=Promise.all([Ne,U,be]).then(()=>{});return Promise.race([Ee,(0,M.$rh)(1e4)]).then(()=>{this.nb()}),Ee}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(U,x))).then(()=>{})}async qb(U,x){if(this.isActivated(x.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,Ne={logService:this.s,folders:U.map($e=>$e.uri),forceUsingSearch:be||!this.c.fsExists,exists:$e=>this.c.fsExists($e.fsPath),checkExists:($e,fe,Q)=>this.y.$checkExists($e,fe,Q)},Ee=await(0,C.$mtb)(Ne,x);if(Ee)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:Ee.activationEvent}).then(void 0,$e=>this.s.error($e))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:x}=this.f.environment;if(!U||!x)throw new Error(I.localize(0,null));const be=await this.xb(null,x,new w.$Dkc(!1));if(!be||typeof be.run!="function")throw new Error(I.localize(1,null,x.toString()));return new Promise((Ne,Ee)=>{const $e=(Y,le)=>{Y?(j.$t&&this.s.error("Test runner called back with error",Y),Ee(Y)):(j.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),Ne(typeof le=="number"&&le>0?1:0))},fe=(0,F.$Rg)(x),Q=be.run(fe,$e);Q&&Q.then&&Q.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),Ne(0)}).catch(Y=>{j.$t&&this.s.error("Test runner finished with error",Y),Ee(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$rh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,x){return this.S[U]=x,(0,m.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:x}=await this.ub(U);return x?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const x=U.indexOf("+");if(x===-1)throw new t.$XM("Not an authority that can be resolved!",b.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=U.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(U,x){const be=A.$0d.create(!1),Ne=()=>`[resolveAuthority(${(0,b.$Fl)(U)},${x})][${be.elapsed()}ms] `,Ee=L=>this.s.info(`${Ne()}${L}`),$e=L=>this.s.warn(`${Ne()}${L}`),fe=(L,G=void 0)=>this.s.error(`${Ne()}${L}`,G),Q=L=>{if(L instanceof t.$XM)return{type:"error",error:{code:L._code,message:L._message,detail:L._detail}};throw L},Y=async L=>{Ee(`activating resolver for ${L}...`);const{resolver:G,authorityPrefix:H}=await this.ub(L);if(!G)throw fe(`no resolver for ${H}`),new t.$XM(`No remote extension installed to resolve ${H}.`,b.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:L}},le=U.split(/@|%40/g).reverse();Ee(`activating remote resolvers ${le.join(" -> ")}`);let de;try{de=await Promise.all(le.map(Y)).catch(async L=>{if(!(L instanceof t.$XM)||L._code!==b.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw L;return $e(`resolving nested authorities failed: ${L.message}`),[await Y(U)]})}catch(L){return Q(L)}const Te=new M.$Bh;Te.cancelAndSet(()=>Ee("waiting..."),1e3);let he,Ce;for(const[L,{authorityPrefix:G,resolver:H,remoteAuthority:ee}]of de.entries())try{if(L===de.length-1)Ee("invoking final resolve()..."),R.mark(`code/extHost/willResolveAuthority/${G}`),he=await H.resolve(ee,{resolveAttempt:x,execServer:Ce}),R.mark(`code/extHost/didResolveAuthorityOK/${G}`),Ee("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$WM.isManagedResolvedAuthority(he)?he:void 0));else{if(Ee(`invoking resolveExecServer() for ${ee}`),R.mark(`code/extHost/willResolveExecServer/${G}`),Ce=await H.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Ce}),!Ce)throw new t.$XM(`Exec server was not available for ${ee}`,b.RemoteAuthorityResolverErrorCode.NoResolverFound);R.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(se){return R.mark(`code/extHost/didResolveAuthorityError/${G}`),fe("returned an error",se),Te.dispose(),Q(se)}Te.dispose();const Me={environmentTunnels:he.environmentTunnels,features:he.tunnelFeatures?{elevation:he.tunnelFeatures.elevation,privacyOptions:he.tunnelFeatures.privacyOptions,protocol:he.tunnelFeatures.protocol===void 0?!0:he.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:he.extensionHostEnv,isTrusted:he.isTrusted,authenticationSession:he.authenticationSessionForInitializingExtensions?{id:he.authenticationSessionForInitializingExtensions.id,providerId:he.authenticationSessionForInitializingExtensions.providerId}:void 0};Ee(`returned ${t.$WM.isManagedResolvedAuthority(he)?"managed authority":`${he.host}:${he.port}`}`);let z;if(t.$WM.isManagedResolvedAuthority(he)){const L=x;this.Y.setFactory(L,he.makeConnection),z={authority:U,connectTo:new b.$Cl(L),connectionToken:he.connectionToken}}else z={authority:U,connectTo:new b.$Dl(he.host,he.port),connectionToken:he.connectionToken};return{type:"ok",value:{authority:z,options:ze,tunnelInformation:Me}}}async $getCanonicalURI(U,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,b.$Fl)(U)})`);const{resolver:be}=await this.ub(U);if(!be)return null;const Ne=E.URI.revive(x);if(typeof be.getCanonicalURI>"u")return Ne;const Ee=await(0,M.$ih)(()=>be.getCanonicalURI(Ne));return Ee||Ne}async $startExtensionHost(U){U.toAdd.forEach($e=>$e.extensionLocation=E.URI.revive($e.extensionLocation));const{globalRegistry:x,myExtensions:be}=ve(this.I,this.L,this.J,U),Ne=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Ne),this.L.set(x.getAllExtensionDescriptions()),this.J.set(be),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ue(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ue(this.J)}`)),this.tb()}$activateByEvent(U,x){return x===1?this.D.wait().then(be=>this.ab(U,!1)):this.G.wait().then(be=>this.ab(U,!1))}async $activate(U,x){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,x),!0):!1}async $deltaExtensions(U){U.toAdd.forEach($e=>$e.extensionLocation=E.URI.revive($e.extensionLocation));const{globalRegistry:x,myExtensions:be}=ve(this.I,this.L,this.J,U),Ne=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Ne),this.L.set(x.getAllExtensionDescriptions()),this.J.set(be),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ue(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ue(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const x=a.$Ce.alloc(U),be=Math.random()%256;for(let Ne=0;Ne<U;Ne++)x.writeUInt8(be,Ne);return x}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$1kc=ce,e.$1kc=ce=ie=Je([Ve(0,c.$pi),Ve(1,e.$Zkc),Ve(2,p.$aP),Ve(3,n.$lkc),Ve(4,u.$okc),Ve(5,T.$Wj),Ve(6,$.$qP),Ve(7,v.$rkc),Ve(8,D.$oCb),Ve(9,f.$Mkc),Ve(10,q.$Wkc),Ve(11,K.$Xkc),Ve(12,S.$Qkc)],ce);function ve(ne,U,x,be){ne.addActivationEvents(be.addActivationEvents);const Ne=new s.$C$b(ne,U.getAllExtensionDescriptions());Ne.deltaExtensions(be.toAdd,be.toRemove);const Ee=new i.$Mm(x.getAllExtensionDescriptions().map(fe=>fe.identifier));for(const fe of be.myToRemove)Ee.delete(fe);for(const fe of be.myToAdd)Ee.add(fe);const $e=re(Ne,Ee);return{globalRegistry:Ne,myExtensions:$e}}function Ie(ne,U){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function ue(ne){return ne.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$2kc=(0,c.$qi)("IExtHostExtensionService");class pe{#e;#t;#i;constructor(U,x,be,Ne,Ee){this.#e=U,this.#t=x,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=N.$ic((0,F.$Rg)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Ne,this.isFromDifferentExtensionHost=Ee}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$3kc=pe;function re(ne,U){return ne.getAllExtensionDescriptions().filter(x=>U.has(x.identifier))}class Se{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$4kc=Se;class Le{constructor(U){this.a=new i.$Nm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const x of Object.keys(U))this.a.set(x,U[x])}}}),define(Re[294],Ae([1,0,89,2,4,38,25,20,16,27,3,39,13,15]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$amc=void 0;let n=class{constructor(a,h,t,b,c,$,v){this.c=a,this.d=h,this.e=t,this.f=b,this.g=c,this.h=$,this.i=v,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new s(this.c,h,this.d,a,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,h,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const h of a.nodeModuleName)this.a.set(h,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(h=>a.alternativeModuleName(h))}};e.$amc=n,e.$amc=n=Je([Ve(2,T.$pi),Ve(3,F.$okc),Ve(4,k.$2kc),Ve(5,E.$qP),Ve(6,u.$Wj)],n);let o=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&d.a.size){const h=(0,w.$8e)(this.c(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",b=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${c}\\/)(${b})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const h=this.b.exec(this.c(a));if(!h)return;const[,t,b,c]=h,$=d.a.get(b);if($!==void 0)return console.warn(`${b} as been renamed to ${$}, please update your imports`),t+$+c}c(a){return a.replace(/\\/g,"/")}};o=d=Je([Ve(0,E.$qP)],o);class s{constructor(a,h,t,b,c){this.c=a,this.d=h,this.e=t,this.f=b,this.g=c,this.nodeModuleName="vscode",this.a=new m.$Nm}load(a,h){const t=this.d.findSubstr(h);if(t){let b=this.a.get(t.identifier);return b||(b=this.c(t,this.e,this.f),this.a.set(t.identifier,b)),b}if(!this.b){let b="";this.d.forEach((c,$)=>b+=`	${$} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${b}`),this.b=this.c(M.$sG,this.e,this.f)}return this.b}}let r=class{constructor(a,h,t){this.e=a,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(R.$PM.MainThreadTelemetry);const b=t.getProxy(R.$PM.MainThreadWindow);this.c=(c,$)=>{const v=N.URI.parse(c);return $?this.g(c,$):v.scheme==="http"||v.scheme==="https"?b.$openUri(v,c,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?b.$openUri(v,c,{}):this.g(c,$)}}load(a,h,t){const b=this.e.findSubstr(h);return b&&(this.a=b.identifier.value,this.h()),this.b=t(a),this.c}g(a,h){return this.i(),this.b(a,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Je([Ve(2,g.$aP)],r)}),define(Re[120],Ae([1,0,40,6,19,73,3,67,66,39,7,37,224,38]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=e.$5kc=void 0,e.$5kc=(0,M.$qi)("IExtHostVariableResolverProvider");class d extends u.$cQ{constructor(s,r,i,a,h,t,b){function c(){if(i){const $=i.activeEditor();if($)return $.document.uri;const v=a.tabGroups.all.find(p=>p.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof T.$CO||v.input instanceof T.$HO)return v.input.modified;if(v.input instanceof T.$BO||v.input instanceof T.$GO||v.input instanceof T.$EO)return v.input.uri}}}super({getFolderUri:$=>{const v=t.folders.filter(p=>p.name===$);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:($,v)=>h.getConfiguration(void 0,$).get(v),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=c();if($)return R.$ic($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const $=c();if($){const v=r.getWorkspaceFolder($);if(v)return R.$ic(v.uri.fsPath)}}},getSelectedText:()=>{if(i){const $=i.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(i){const $=i.activeEditor();if($)return String($.selection.end.line+1)}},getExtension:$=>s.getExtension($)},void 0,b?Promise.resolve(b):void 0,Promise.resolve(F.env))}}let n=class extends N.$Uc{constructor(s,r,i,a,h){super(),this.b=s,this.c=r,this.g=i,this.h=a,this.j=h,this.a=new I.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async $=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$6kc=n,e.$6kc=n=Je([Ve(0,E.$2kc),Ve(1,k.$lkc),Ve(2,m.$lP),Ve(3,w.$okc),Ve(4,g.$Akc)],n)}),define(Re[121],Ae([1,0,11,5,2,20,3,4,66,39,16,7,37,216,218,38,120,6,41,32,8]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s,r,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=e.$0kc=e.$9kc=e.$8kc=e.$7kc=void 0,e.$7kc=(0,M.$qi)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(l,D,f,S,y,C,P){this.N=D,this.O=f,this.P=S,this.Q=y,this.R=C,this.S=P,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$be,this.o=new N.$be,this.q=new N.$be,this.w=new N.$be,this.l=l.getProxy(m.$PM.MainThreadDebugService),this.A=new N.$be,this.C=new N.$be,this.y=new b(this.l),this.z=new Map,this.O.getExtensionRegistry().then(V=>{V.onDidChange(W=>{this.V(V)}),this.V(V)})}async $getVisualizerTreeItem(l,D){const f=this.W(D);if(!f)return;const S=await this.H.get(l)?.getTreeItem?.(f);return S?this.U(l,S):void 0}registerDebugVisualizationTree(l,D,f){const S=F.$Lm.toKey(l.identifier),y=this.jb(S,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,f),this.l.$registerDebugVisualizerTree(y,!!f.editItem),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren(l,D){const f=this.J.get(D)?.item;return f?(await this.H.get(l)?.getChildren?.(f))?.map(y=>this.U(l,y))||[]:[]}async $editVisualizerTreeItem(l,D){const f=this.J.get(l);if(!f)return;const S=await this.H.get(f.provider)?.editItem?.(f.item,D);return this.U(f.provider,S||f.item)}$disposeVisualizedTree(l){const D=this.J.get(l);if(!D)return;const f=[D.children];for(const S of f)if(S)for(const y of S)f.push(this.J.get(y)?.children),this.J.delete(y)}U(l,D){let f=this.I.get(D);return f||(f=this.F++,this.I.set(D,f),this.J.set(f,{provider:l,item:D})),a.DebugTreeItem.from(D,f)}asDebugSourceUri(l,D){const f=l;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let S=`debug:${encodeURIComponent(f.path||"")}`,y="?";return D&&(S+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),S+=`${y}ref=${f.sourceReference}`,R.URI.parse(S)}else{if(f.path)return R.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(l){const D=[];for(const f of l.getAllExtensionDescriptions())if(f.contributes){const S=f.contributes.debuggers;if(S&&S.length>0)for(const y of S)(0,d.$_G)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const l=[];return this.z.forEach(D=>l.push(D)),l}async $resolveDebugVisualizer(l,D){const f=this.L.get(l);if(!f)throw new Error(`No debug visualizer found with id '${l}'`);let{v:S,provider:y,extensionId:C}=f;if(S.visualization||(S=await y.resolveDebugVisualization?.(S,D)||S,f.v=S),!S.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(C,S.visualization)}async $executeDebugVisualizerCommand(l){const D=this.L.get(l);if(!D)throw new Error(`No debug visualizer found with id '${l}'`);const f=D.v.visualization;f&&"command"in f&&this.S.executeCommand(f.command,...f.arguments||[])}W(l){const D=this.m.get(l.sessionId);return D&&{session:D.api,variable:l.variable,containerId:l.containerId,frameId:l.frameId,threadId:l.threadId}}async $provideDebugVisualizers(l,D,f,S){const y=this.W(f),C=this.jb(l,D),P=this.G.get(C);if(!y||!P)return[];const V=await P.provideDebugVisualization(y,S);return V?V.map(W=>{const q=++this.M;this.L.set(q,{v:W,provider:P,extensionId:l});const A=W.iconPath?this.lb(W.iconPath):void 0;return{id:q,name:W.name,iconClass:A?.iconClass,iconPath:A?.iconPath,visualization:this.kb(l,W.visualization)}}):[]}$disposeDebugVisualizers(l){for(const D of l)this.L.delete(D)}registerDebugVisualizationProvider(l,D,f){if(!l.contributes?.debugVisualizers?.some(C=>C.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const S=F.$Lm.toKey(l.identifier),y=this.jb(S,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,f),this.l.$registerDebugVisualizer(S,D),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizer(S,D),this.G.delete(D)})}addBreakpoints(l){const D=l.filter(y=>{const C=y.id;return this.z.has(C)?!1:(this.z.set(C,y),!0)});this.gb(D,[],[]);const f=[],S=new Map;for(const y of D)if(y instanceof k.$SN){let C=S.get(y.location.uri.toString());C||(C={type:"sourceMulti",uri:y.location.uri,lines:[]},S.set(y.location.uri.toString(),C),f.push(C)),C.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof k.$TN&&f.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(f)}removeBreakpoints(l){const D=l.filter(C=>this.z.delete(C.id));this.gb([],D,[]);const f=D.filter(C=>C instanceof k.$SN).map(C=>C.id),S=D.filter(C=>C instanceof k.$TN).map(C=>C.id),y=D.filter(C=>C instanceof k.$UN).map(C=>C.id);return this.l.$unregisterBreakpoints(f,S,y)}startDebugging(l,D,f){return this.l.$startDebugging(l?l.uri:void 0,D,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(l){return this.l.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,D,f){if(!D)return new k.$RM(()=>{});const S=this.d++;return this.f.push({type:l,handle:S,provider:D}),this.l.$registerDebugConfigurationProvider(l,f,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,S),new k.$RM(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(l,D,f){if(!f)return new k.$RM(()=>{});if(!this.cb(l,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this.g++;return this.h.push({type:D,handle:S,factory:f}),this.l.$registerDebugAdapterDescriptorFactory(D,S),new k.$RM(()=>{this.h=this.h.filter(y=>y.factory!==f),this.l.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(l,D){if(!D)return new k.$RM(()=>{});const f=this.j++;return this.k.push({type:l,handle:f,factory:D}),new k.$RM(()=>{this.k=this.k.filter(S=>S.factory!==D)})}async $runInTerminal(l,D){return Promise.resolve(void 0)}async $substituteVariables(l,D){let f;const S=await this.ib(l);return S&&(f={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(f,D)}X(l,D){if(l.type==="implementation")return new $(l.implementation)}Y(){}async $startDASession(l,D){const f=this,S=await this.hb(D);return this.eb(this.$(S.type),S).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const C=this.Z(y),P=this.X(C,S);if(!P)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const V=P;return this.D.set(l,V),this.db(S).then(W=>(W&&this.E.set(l,W),V.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const A=q,j={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const K=await this.K.sign(A.arguments.value);j.body={signature:K},V.sendResponse(j)}else throw new Error("no signer")}catch(K){j.success=!1,j.message=K.message,V.sendResponse(j)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(q),q=(0,d.$eH)(q,!0),f.l.$acceptDAMessage(l,q)}),V.onError(q=>{W&&W.onError&&W.onError(q),this.l.$acceptDAError(l,q.name,q.message,q.stack)}),V.onExit(q=>{W&&W.onExit&&W.onExit(q??void 0,void 0),this.l.$acceptDAExit(l,q??void 0,void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),V.startSession()))})}$sendDAMessage(l,D){D=(0,d.$dH)(D,!1);const f=this.E.get(l);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(D),this.D.get(l)?.sendMessage(D)}$stopDASession(l){const D=this.E.get(l);this.E.delete(l),D&&D.onWillStopSession&&D.onWillStopSession();const f=this.D.get(l);return this.D.delete(l),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const D=[],f=[],S=[];if(l.added)for(const y of l.added){const C=y.id;if(C&&!this.z.has(C)){let P;if(y.type==="function")P=new k.$TN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")P=new k.$UN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const V=R.URI.revive(y.uri);P=new k.$SN(new k.$4M(V,new k.$SM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,k.$QN)(P,C),this.z.set(C,P),D.push(P)}}if(l.removed)for(const y of l.removed){const C=this.z.get(y);C&&(this.z.delete(y),f.push(C))}if(l.changed){for(const y of l.changed)if(y.id){const C=this.z.get(y.id);if(C){if(C instanceof k.$TN&&y.type==="function"){const P=C;P.enabled=y.enabled,P.condition=y.condition,P.hitCondition=y.hitCondition,P.logMessage=y.logMessage,P.functionName=y.functionName}else if(C instanceof k.$SN&&y.type==="source"){const P=C;P.enabled=y.enabled,P.condition=y.condition,P.hitCondition=y.hitCondition,P.logMessage=y.logMessage,P.location=new k.$4M(R.URI.revive(y.uri),new k.$SM(y.line,y.character))}S.push(C)}}}this.gb(D,f,S)}async $acceptStackFrameFocus(l){let D;if(l){const f=await this.hb(l.sessionId);l.kind==="thread"?D=new k.$1N(f.api,l.threadId):D=new k.$ZN(f.api,l.threadId,l.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(l,D,f){return(0,I.$ih)(async()=>{const S=this.bb(l);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return S.provideDebugConfigurations(y,f)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(l,D,f,S){return(0,I.$ih)(async()=>{const y=this.bb(l);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(D);return y.resolveDebugConfiguration(C,f,S)})}$resolveDebugConfigurationWithSubstitutedVariables(l,D,f,S){return(0,I.$ih)(async()=>{const y=this.bb(l);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(C,f,S)})}async $provideDebugAdapter(l,D){const f=this.ab(l);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.hb(D);return this.eb(f,S).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(l){const D=await this.hb(l);this.n.fire(D.api)}async $acceptDebugSessionTerminated(l){const D=await this.hb(l);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(l){this.u=l?await this.hb(l):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(l,D){(await this.hb(l))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(l,D){const S={session:(await this.hb(l)).api,event:D.event,body:D.body};this.w.fire(S)}Z(l){if(l instanceof k.$VN)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof k.$WN)return{type:"server",port:l.port,host:l.host};if(l instanceof k.$XN)return{type:"pipeServer",path:l.path};if(l instanceof k.$YN)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}$(l){const D=this.h.filter(f=>f.type===l);if(D.length>0)return D[0].factory}ab(l){const D=this.h.filter(f=>f.handle===l);if(D.length>0)return D[0].factory}bb(l){const D=this.f.filter(f=>f.handle===l);if(D.length>0)return D[0].provider}cb(l,D){if(l.contributes){const f=l.contributes.debuggers;if(f&&f.length>0){for(const S of f)if(S.label&&S.type&&S.type===D)return!0}}return!1}db(l){const f=l.configuration.type,S=this.k.filter(y=>y.type===f||y.type==="*").map(y=>(0,I.$ih)(()=>y.factory.createDebugAdapterTracker(l.api)).then(C=>C,C=>null));return Promise.race([Promise.all(S).then(y=>{const C=y.filter(P=>!!P);if(C.length>0)return new c(C)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(l,D){const f=D.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new k.$WN(f));if(l){const y=await this.O.getExtensionRegistry();return(0,I.$ih)(()=>l.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(C=>{if(C)return C})}const S=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,S))}fb(l,D){}gb(l,D,f){(l.length>0||D.length>0||f.length>0)&&this.A.fire(Object.freeze({added:l,removed:D,changed:f}))}async hb(l){if(l)if(typeof l=="string"){const D=this.m.get(l);if(D)return D}else{let D=this.m.get(l.id);if(!D){const f=await this.ib(l.folderUri),S=l.parent?this.m.get(l.parent):void 0;D=new t(this.l,l.id,l.type,l.name,f,l.configuration,S?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(l){if(l){const D=R.URI.revive(l);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(l,D){return`${l}\0${D}`}kb(l,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${l}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(l){const D=this.mb(l);let f,S;return"id"in D?S=r.ThemeIcon.asClassName(D):f=D,{iconPath:f,iconClass:S}}mb(l){if(l instanceof k.$NN)return{id:l.id};const D=typeof l=="object"&&"dark"in l?l.dark:l,f=typeof l=="object"&&"light"in l?l.light:l;return{dark:typeof D=="string"?R.URI.file(D):D,light:typeof f=="string"?R.URI.file(f):f}}};e.$8kc=h,e.$8kc=h=Je([Ve(0,T.$aP),Ve(1,u.$lkc),Ve(2,E.$2kc),Ve(3,n.$okc),Ve(4,g.$Akc),Ve(5,o.$5kc),Ve(6,i.$wP)],h);class t{constructor(l,D,f,S,y,C,P){this.f=l,this.g=D,this.h=f,this.j=S,this.k=y,this.l=C,this.m=P}get api(){const l=this;return this.d??=Object.freeze({id:l.g,type:l.h,get name(){return l.j},set name(D){l.j=D,l.f.$setDebugSessionName(l.g,D)},parentSession:l.m,workspaceFolder:l.k,configuration:l.l,customRequest(D,f){return l.f.$customDebugAdapterRequest(l.g,D,f)},getDebugProtocolBreakpoint(D){return l.f.$getDebugProtocolBreakpoint(l.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(l){this.j=l}get configuration(){return this.l}}e.$9kc=t;class b{constructor(l){this.value=Object.freeze({append(D){l.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$0kc=b;class c{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach(D=>D.onError?D.onError(l):void 0)}onExit(l,D){this.d.forEach(f=>f.onExit?f.onExit(l,D):void 0)}}class $ extends w.$sob{constructor(l){super(),this.h=l,l.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends h{constructor(l,D,f,S,y,C,P){super(l,D,f,S,y,C,P)}};e.$$kc=v,e.$$kc=v=Je([Ve(0,T.$aP),Ve(1,u.$lkc),Ve(2,E.$2kc),Ve(3,n.$okc),Ve(4,g.$Akc),Ve(5,o.$5kc),Ve(6,i.$wP)],v)}),define(Re[295],Ae([1,0,14,89,2,4,244,13,55,71,27,192,16,60,39,62]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=e.$bmc=void 0;class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const a=i.get(m.$Wj),t=i.get(u.$aP).getProxy(F.$PM.MainThreadErrors);I.setUnexpectedErrorHandler(b=>{a.error(b);const c=I.$3(b);t.$onUnexpectedError(c)})}static async installFullHandler(i){const a=i.get(m.$Wj),h=i.get(u.$aP),t=i.get(d.$2kc),b=i.get(n.$uP),c=h.getProxy(F.$PM.MainThreadExtensionService),$=h.getProxy(F.$PM.MainThreadErrors),v=await t.getExtensionPathIndex(),p=new WeakMap;function l(S,y){if(p.has(S))return p.get(S).stack;let C="",P,V;for(const q of y)C+=`
	at ${q.toString()}`,V=q.getFileName(),!P&&V&&(P=v.findSubstr(R.URI.file(V)));const W=`${S.name||"Error"}: ${S.message||""}${C}`;return p.set(S,{extensionIdentifier:P?.identifier,stack:W}),W}const D=Symbol("prepareStackTrace wrapped");let f=l;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return f},set(S){if(S===l||!S||S[D]){f=S||l;return}f=function(y,C){return l(y,C),S.call(Error,y,C)},Object.assign(f,{[D]:!0})}}),I.setUnexpectedErrorHandler(S=>{a.error(S);const y=I.$3(S),C=p.get(S);if(!C?.extensionIdentifier){$.$onUnexpectedError(y);return}c.$onExtensionRuntimeError(C.extensionIdentifier,y);const P=b.onExtensionError(C.extensionIdentifier,S);a.trace("forwarded error to extension?",P,C)})}}e.$bmc=o;class s{constructor(i,a,h,t,b){this.a=h,this.b=new M.$K$b(i,null,t),a=s.e(a,this.b);const c=new E.$oi(...(0,g.$ps)());c.set(T.$qP,{_serviceBrand:void 0,...a,messagePorts:b}),c.set(u.$aP,new u.$bP(this.b)),c.set(w.$ikc,new w.$jkc(t)),c.set(d.$Zkc,h);const $=new k.$7q(c,!0);$.invokeFunction(o.installEarlyHandler),this.d=$.invokeFunction(v=>v.get(m.$Wj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=$.invokeFunction(v=>v.get(d.$2kc)),this.c.initialize(),$.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const a=this.b.getProxy(F.$PM.MainThreadExtensionService);return R.URI.revive(await a.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,a){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=R.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=R.URI.revive(a.transformIncomingURIs(i.environment.appRoot));const h=i.environment.extensionDevelopmentLocationURI;return h&&(i.environment.extensionDevelopmentLocationURI=h.map(t=>R.URI.revive(a.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=R.URI.revive(a.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=R.URI.revive(a.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=R.URI.revive(a.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=R.URI.revive(a.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=R.URI.revive(a.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=R.URI.revive(a.transformIncomingURIs(i.logsLocation)),i.workspace=a.transformIncomingURIs(i.workspace),i}}e.$cmc=s}),define(Re[296],Ae([1,0,18,11,24,42,12,19,23,2,45]),function(ge,e,I,N,R,F,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$plc=e.$nlc=e.$mlc=void 0,e.$olc=n;class k{constructor(r,i,a){this.d=r,this.e=i,this.f=a,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(r,i){const a=this.g.folderQueries||[],h=new R.$me(i);return new Promise((t,b)=>{this.a=new w(r);let c=!1;const $=(v,p)=>{if(!c&&!this.b){const l=this.h(v);n(v)&&typeof this.g.maxResults=="number"&&this.c+l>this.g.maxResults&&(this.b=!0,c=!0,h.cancel(),v=this.j(v,this.g.maxResults-this.c));const D=this.h(v);this.c+=D,(D>0||!n(v))&&this.a.add(v,p)}};Promise.all(a.map((v,p)=>this.k(v,l=>$(l,p),h.token))).then(v=>{h.dispose(),this.a.flush();const p=v.some(l=>!!l&&!!l.limitHit);t({limitHit:this.b||p,messages:(0,I.$Rb)(v.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.f}})},v=>{h.dispose();const p=(0,F.$bj)(v);b(new Error(p))})})}h(r){return n(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,i){const a=Array.isArray(r.ranges)?r.ranges:[r.ranges],h=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:a.slice(0,i),preview:{matches:h.slice(0,i),text:r.preview.text},uri:r.uri}}async k(r,i,a){const h=new T.$kL(this.g,r),t=[],b={report:v=>{if(!this.l(v))return;const p=r.folder.scheme===M.Schemas.file?(0,T.$lL)(()=>this.e.readdir(g.$3g(v.uri))):void 0,l=g.$6g(r.folder,v.uri);if(l){const D=h.includedInQuery(l,m.$oc(l),p);(0,N.$ch)(D)?t.push(D.then(f=>{f&&i(v)})):D&&i(v)}}},c=this.n(r);let $;return this.d.query.type===3?$=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,c,b,a):$=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),c,b,a),t.length&&await Promise.all(t),$}l(r){if(n(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const i=(0,T.$jL)(this.g.includePattern,r.includePattern),a=(0,T.$jL)(this.g.excludePattern,r.excludePattern),h={folder:E.URI.from(r.folder),excludes:a,includes:i,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.e.toCanonicalName(r.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$mlc=k;function u(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class w{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(r,i){this.d&&(this.b!==i||!g.$Wg(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:r.uri,results:[]}),this.d.results.push(d(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$nlc=w;function d(s){return n(s)?{preview:{matches:(0,I.$2b)(s.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:s.preview.text},ranges:(0,I.$2b)(s.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function n(s){return!!s.preview}class o{static{this.a=4e3}static{this.b=50}constructor(r,i){this.g=r,this.h=i,this.c=0,this.d=[],this.e=0}addItem(r,i){r&&this.j(r,i)}addItems(r,i){r&&this.k(r,i)}j(r,i){this.d.push(r),this.e+=i,this.l()}k(r,i){this.d=this.d.concat(r),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$plc=o}),define(Re[122],Ae([1,0,6,4,3,291,16,60,13,2,296]),function(ge,e,I,N,R,F,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=e.$qlc=void 0,e.$slc=u,e.$qlc=(0,R.$qi)("IExtHostSearch");let k=class{constructor(n,o,s){this.n=n,this.o=o,this.q=s,this.c=this.n.getProxy(N.$PM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new F.$llc}s(n){return this.o.transformOutgoingScheme(n)}registerTextSearchProvider(n,o){if(this.g.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this.g.add(n);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.s(n)),(0,I.$Sc)(()=>{this.g.delete(n),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(n,o){if(this.i.has(n))throw new Error(`an AI text search provider for the scheme '${n}'is already registered`);this.i.add(n);const s=this.d++;return this.h.set(s,o),this.c.$registerAITextSearchProvider(s,this.s(n)),(0,I.$Sc)(()=>{this.i.delete(n),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(n,o){if(this.k.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this.k.add(n);const s=this.d++;return this.j.set(s,o),this.c.$registerFileSearchProvider(s,this.s(n)),(0,I.$Sc)(()=>{this.k.delete(n),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(n,o,s,r){const i=u(s),a=this.j.get(n);if(a)return this.l.fileSearch(i,a,h=>{this.c.$handleFileMatch(n,o,h.map(t=>t.resource))},r);throw new Error("3 unknown provider: "+n)}async doInternalFileSearchWithCustomCallback(n,o,s){return{messages:[]}}$clearCache(n){return this.l.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,o,s,r){const i=this.e.get(n);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${n}`);const a=u(s);return this.t(a,i).search(t=>this.c.$handleTextMatch(n,o,t),r)}$provideAITextSearchResults(n,o,s,r){const i=this.h.get(n);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${n}`);const a=u(s);return this.v(a,i).search(t=>this.c.$handleTextMatch(n,o,t),r)}$enableExtensionHostSearch(){}t(n,o){return new T.$mlc({query:n,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(n,o){return new T.$mlc({query:n,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$rlc=k,e.$rlc=k=Je([Ve(0,M.$aP),Ve(1,m.$ikc),Ve(2,g.$Wj)],k);function u(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(w),extraFileResources:d.extraFileResources&&d.extraFileResources.map(n=>E.URI.revive(n))}}function w(d){return{...d,folder:E.URI.revive(d.folder)}}}),define(Re[297],Ae([1,0,24,14,5,6,12,33,2,151,147,135,94,20,43,13,58,59,205,4,247,275,78,84,252,253,254,233,222,32,255,38,256,121,110,257,235,248,258,259,67,66,249,39,261,64,262,44,27,276,277,236,263,88,264,79,80,238,290,266,209,267,278,268,116,239,269,270,271,16,272,122,81,273,240,274,82,85,119,62,51,114,279,280,250,281,282,86,8,7,241,60,242,63,283,284,109,37,217,77,25,118]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s,r,i,a,h,t,b,c,$,v,p,l,D,f,S,y,C,P,V,W,q,A,j,K,ie,ce,ve,Ie,ue,pe,re,Se,Le,ne,U,x,be,Ne,Ee,$e,fe,Q,Y,le,de,Te,he,Ce,Me,ze,z,L,G,H,ee,se,Fe,Be,Qe,xe,_e,et,tt,nt,ct,ft,je,st,X,Z,me,He,ye,ot,dt,Pt,Bt,Yt,qt,xt,Et,Wt,Ht,Xe,ri){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=_t;function _t(ht){const $t=ht.get(Se.$qP),ei=ht.get(re.$6jc),ti=ht.get(ue.$qkc),Lt=ht.get(ve.$2kc),gt=ht.get(Et.$lkc),zt=ht.get(tt.$uP),ii=ht.get(S.$okc),Tt=ht.get(dt.$ikc),Ke=ht.get(G.$aP),si=ht.get(xe.$Jkc),Gt=ht.get(_e.$rkc),Ut=ht.get(n.$Xj),mt=ht.get(n.$Wj),Ft=ht.get(me.$oCb),Mt=ht.get(t.$2jc),jt=ht.get(xt.$8lc),Kt=ht.get(se.$Tkc),Jt=ht.get(ie.$Akc),oi=ht.get($e.$Xkc),Ct=ht.get(b.$_jc),Nt=ht.get(be.$Qkc);Ke.set(i.$QM.ExtHostFileSystemInfo,ei),Ke.set(i.$QM.ExtHostLogLevelServiceShape,Ut),Ke.set(i.$QM.ExtHostWorkspace,gt),Ke.set(i.$QM.ExtHostConfiguration,ii),Ke.set(i.$QM.ExtHostExtensionService,Lt),Ke.set(i.$QM.ExtHostStorage,si),Ke.set(i.$QM.ExtHostTunnelService,Ft),Ke.set(i.$QM.ExtHostWindow,jt),Ke.set(i.$QM.ExtHostSecretState,Kt),Ke.set(i.$QM.ExtHostTelemetry,zt),Ke.set(i.$QM.ExtHostEditorTabs,Jt),Ke.set(i.$QM.ExtHostManagedSockets,oi),Ke.set(i.$QM.ExtHostAuthentication,Ct),Ke.set(i.$QM.ExtHostChatProvider,Nt);const It=Ke.set(i.$QM.ExtHostDecorations,ht.get(P.$alc)),Dt=Ke.set(i.$QM.ExtHostDocumentsAndEditors,ht.get(K.$lP)),bt=Ke.set(i.$QM.ExtHostCommands,ht.get(D.$wP)),St=Ke.set(i.$QM.ExtHostTerminalService,ht.get(nt.$Mkc)),li=Ke.set(i.$QM.ExtHostTerminalShellIntegration,ht.get(ct.$Tlc)),yt=Ke.set(i.$QM.ExtHostDebugService,ht.get(C.$7kc)),hi=Ke.set(i.$QM.ExtHostSearch,ht.get(ee.$qlc)),Qt=Ke.set(i.$QM.ExtHostTask,ht.get(et.$Slc)),ai=Ke.set(i.$QM.ExtHostOutputService,ht.get(Ce.$Flc)),pi=Ke.set(i.$QM.ExtHostLocalization,ht.get(Ee.$Wkc)),ni=Ke.set(i.$QM.ExtHostUrls,new Pt.$5lc(Ke)),Rt=Ke.set(i.$QM.ExtHostDocuments,new j.$9jc(Ke,Dt)),yi=Ke.set(i.$QM.ExtHostDocumentContentProviders,new q.$clc(Ke,Dt,mt)),we=Ke.set(i.$QM.ExtHostDocumentSaveParticipant,new A.$dlc(mt,Rt,Ke.getProxy(i.$PM.MainThreadBulkEdits))),Pe=Ke.set(i.$QM.ExtHostNotebook,new Q.$tlc(Ke,bt,Dt,Rt,ti,hi)),ae=Ke.set(i.$QM.ExtHostNotebookDocuments,new le.$zlc(Pe)),J=Ke.set(i.$QM.ExtHostNotebookEditors,new de.$Alc(mt,Pe)),ke=Ke.set(i.$QM.ExtHostNotebookKernels,new Te.$Blc(Ke,$t,Pe,bt,mt)),We=Ke.set(i.$QM.ExtHostNotebookRenderers,new he.$Dlc(Ke,Pe)),Ze=Ke.set(i.$QM.ExtHostNotebookDocumentSaveParticipant,new Y.$ylc(mt,Pe,Ke.getProxy(i.$PM.MainThreadBulkEdits))),qe=Ke.set(i.$QM.ExtHostEditors,new je.$fkc(Ke,Dt)),ut=Ke.set(i.$QM.ExtHostTreeViews,new Z.$3lc(Ke.getProxy(i.$PM.MainThreadTreeViews),bt,mt)),kt=Ke.set(i.$QM.ExtHostEditorInsets,new l.$gkc(Ke.getProxy(i.$PM.MainThreadEditorInsets),qe,$t.remote)),Ot=Ke.set(i.$QM.ExtHostDiagnostics,new V.$8jc(Ke,mt,ei,Dt)),Zt=Ke.set(i.$QM.ExtHostLanguages,new Ne.$wlc(Ke,Rt,bt.converter,Tt)),at=Ke.set(i.$QM.ExtHostLanguageFeatures,new x.$0jc(Ke,Tt,Rt,bt,Ot,mt,Mt,zt)),Xt=Ke.set(i.$QM.ExtHostFileSystem,new Ie.$flc(Ke,at)),mi=Ke.set(i.$QM.ExtHostFileSystemEventService,new pe.$glc(Ke,mt,Dt)),bi=Ke.set(i.$QM.ExtHostQuickOpen,(0,L.$Jlc)(Ke,gt,bt)),Di=Ke.set(i.$QM.ExtHostSCM,new H.$Llc(Ke,bt,Rt,mt)),Mi=Ke.set(i.$QM.ExtHostQuickDiff,new z.$Ilc(Ke,Tt)),Ni=Ke.set(i.$QM.ExtHostShare,new Fe.$Mlc(Ke,Tt)),qi=Ke.set(i.$QM.ExtHostComments,(0,f.$hkc)(Ke,bt,Rt)),Hi=Ke.set(i.$QM.ExtHostProgress,new ze.$Hlc(Ke.getProxy(i.$PM.MainThreadProgress))),Gi=Ke.set(i.$QM.ExtHostLabelService,new U.$vlc(Ke)),Si=Ke.set(i.$QM.ExtHostTheming,new st.$Zlc(Ke)),Ti=Ke.set(i.$QM.ExtHostTimeline,new X.$2lc(Ke,bt)),Ii=Ke.set(i.$QM.ExtHostWebviews,new Bt.$vkc(Ke,$t.remote,gt,mt,Mt)),Pi=Ke.set(i.$QM.ExtHostWebviewPanels,new Yt.$ykc(Ke,Ii,gt)),Ki=Ke.set(i.$QM.ExtHostCustomEditors,new y.$zkc(Ke,Rt,Gt,Ii,Pi)),Ji=Ke.set(i.$QM.ExtHostWebviewViews,new qt.$6lc(Ke,Ii)),wi=Ke.set(i.$QM.ExtHostTesting,new ft.$Vlc(Ke,mt,bt,Dt)),Qi=Ke.set(i.$QM.ExtHostUriOpeners,new ot.$4lc(Ke)),un=Ke.set(i.$QM.ExtHostProfileContentHandlers,new Me.$Glc(Ke));Ke.set(i.$QM.ExtHostInteractive,new ne.$ulc(Ke,Pe,Dt,bt,mt));const ln=Ke.set(i.$QM.ExtHostInlineChat,new Le.$hlc(Ke,bt,Rt,mt)),ki=Ke.set(i.$QM.ExtHostChatAgents2,new $.$ckc(Ke,mt,bt)),Fi=Ke.set(i.$QM.ExtHostChatVariables,new v.$dkc(Ke)),Zi=Ke.set(i.$QM.ExtHostAiRelatedInformation,new a.$1jc(Ke)),hn=Ke.set(i.$QM.ExtHostAiEmbeddingVector,new ce.$elc(Ke)),Oi=Ke.set(i.$QM.ExtHostStatusBar,new Qe.$Plc(Ke,bt.converter)),dn=Ke.set(i.$QM.ExtHostSpeech,new Be.$Nlc(Ke)),Li=Object.values(i.$QM);Ke.assertRegistered(Li);const Xi=new c.$bkc(Ke,Dt),Yi=new p.$ekc(Ke),Ci=new fe.$xlc(Ke,mt),xi=new W.$blc(Ke);return h.$$jc.register(bt),function(Ue,di,fi){function it(_){return(oe,Oe,rt)=>{const wt=_(At=>{try{oe.call(Oe,At)}catch(Bi){N.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${Bi.toString()}`,{cause:Bi})),zt.onExtensionError(Ue.identifier,Bi)}});return rt?.push(wt),wt}}const vt=function(){let _=!Ue.isUnderDevelopment;function oe(){_||(mt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Oe(rt){if(Array.isArray(rt))rt.forEach(Oe);else if(typeof rt=="string")oe();else{const wt=rt;typeof wt.scheme>"u"&&oe(),typeof wt.exclusive=="boolean"&&(0,Xe.$yG)(Ue,"documentFiltersExclusive")}return rt}}(),ci={getSession(_,oe,Oe){return typeof Oe?.forceNewSession=="object"&&Oe.forceNewSession.learnMore&&(0,Xe.$yG)(Ue,"authLearnMore"),Ct.getSession(Ue,_,oe,Oe)},getSessions(_,oe){return(0,Xe.$yG)(Ue,"authGetSessions"),Ct.getSessions(Ue,_,oe)},async hasSession(_,oe){return(0,Xe.$yG)(Ue,"authSession"),!!await Ct.getSession(Ue,_,oe,{silent:!0})},get onDidChangeSessions(){return it(Ct.onDidChangeSessions)},registerAuthenticationProvider(_,oe,Oe,rt){return Ct.registerAuthenticationProvider(_,oe,Oe,rt)}},Ri={registerCommand(_,oe,Oe){return bt.registerCommand(!0,_,oe,Oe,void 0,Ue)},registerTextEditorCommand(_,oe,Oe){return bt.registerCommand(!0,_,(...rt)=>{const wt=qe.getActiveTextEditor();if(!wt){mt.warn("Cannot execute "+_+" because there is no active text editor.");return}return wt.edit(At=>{oe.apply(Oe,[wt,At,...rt])}).then(At=>{At||mt.warn("Edits from command "+_+" were not applied.")},At=>{mt.warn("An error occurred while running command "+_,At)})},void 0,void 0,Ue)},registerDiffInformationCommand:(_,oe,Oe)=>((0,Xe.$yG)(Ue,"diffCommand"),bt.registerCommand(!0,_,async(...rt)=>{const wt=Dt.activeEditor(!0);if(!wt){mt.warn("Cannot execute "+_+" because there is no active text editor.");return}const At=await qe.getDiffInformation(wt.id);oe.apply(Oe,[At,...rt])},void 0,void 0,Ue)),executeCommand(_,...oe){return bt.executeCommand(_,...oe)},getCommands(_=!1){return bt.getCommands(_)}},zi={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Yi.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return it(St.onDidChangeShell)},get isTelemetryEnabled(){return zt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return it(zt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$yG)(Ue,"telemetry"),zt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$yG)(Ue,"telemetry"),it(zt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$tP)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,oe){return tt.$sP.validateSender(_),zt.instantiateLogger(Ue,_,oe)},openExternal(_,oe){return jt.openUri(_,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===$t.environment.appUriScheme)return ni.createAppUri(_);try{return await jt.asExternalUri(_,{allowTunneling:!!$t.remote.authority})}catch(oe){if((0,M.$zg)(_,M.Schemas.http)||(0,M.$zg)(_,M.Schemas.https))return _;throw oe}},get remoteName(){return(0,o.$Cm)($t.remote.authority)},get remoteAuthority(){return(0,Xe.$yG)(Ue,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return it(mt.onDidChangeLogLevel)},get appQuality(){return(0,Xe.$yG)(Ue,"resolvers"),$t.quality},get appCommit(){return(0,Xe.$yG)(Ue,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(zi);const _i={createTestController(_,oe,Oe){return wi.createTestController(Ue,_,oe,Oe)},createTestObserver(){return(0,Xe.$yG)(Ue,"testObserver"),wi.createTestObserver()},runTests(_){return(0,Xe.$yG)(Ue,"testObserver"),wi.runTests(_)},get onDidChangeTestResults(){return(0,Xe.$yG)(Ue,"testObserver"),it(wi.onResultsChanged)},get testResults(){return(0,Xe.$yG)(Ue,"testObserver"),wi.results}},Ei=$t.remote.isRemote?ye.ExtensionKind.Workspace:ye.ExtensionKind.UI,en={getExtension(_,oe){(0,Xe.$xG)(Ue,"extensionsAny")||(oe=!1);const Oe=di.mine.getExtensionDescription(_);if(Oe)return new ve.$3kc(Lt,Ue.identifier,Oe,Ei,!1);if(oe){const rt=di.all.getExtensionDescription(_);if(rt)return new ve.$3kc(Lt,Ue.identifier,rt,Ei,!0)}},get all(){const _=[];for(const oe of di.mine.getAllExtensionDescriptions())_.push(new ve.$3kc(Lt,Ue.identifier,oe,Ei,!1));return _},get allAcrossExtensionHosts(){(0,Xe.$yG)(Ue,"extensionsAny");const _=new w.$Mm(di.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),oe=[];for(const Oe of di.all.getAllExtensionDescriptions()){const rt=!_.has(Oe.identifier);oe.push(new ve.$3kc(Lt,Ue.identifier,Oe,Ei,rt))}return oe},get onDidChange(){return(0,Xe.$xG)(Ue,"extensionsAny")?it(R.Event.any(di.mine.onDidChange,di.all.onDidChange)):it(di.mine.onDidChange)}},fn={createDiagnosticCollection(_){return Ot.createDiagnosticCollection(Ue.identifier,_)},get onDidChangeDiagnostics(){return it(Ot.onDidChangeDiagnostics)},getDiagnostics:_=>Ot.getDiagnostics(_),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(_,oe){return Zt.changeLanguage(_.uri,oe)},match(_,oe){const Oe=He.LanguageSelector.from(_);let rt;return(0,T.$Vt)(Oe)&&(rt=Pe.notebookDocuments.find(wt=>wt.apiNotebook.getCells().find(At=>At.document===oe))?.apiNotebook),(0,T.$Ut)(Oe,oe.uri,oe.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(_,oe,Oe){return at.registerCodeActionProvider(Ue,vt(_),oe,Oe)},registerDocumentPasteEditProvider(_,oe,Oe){return(0,Xe.$yG)(Ue,"documentPaste"),at.registerDocumentPasteEditProvider(Ue,vt(_),oe,Oe)},registerCodeLensProvider(_,oe){return at.registerCodeLensProvider(Ue,vt(_),oe)},registerDefinitionProvider(_,oe){return at.registerDefinitionProvider(Ue,vt(_),oe)},registerDeclarationProvider(_,oe){return at.registerDeclarationProvider(Ue,vt(_),oe)},registerImplementationProvider(_,oe){return at.registerImplementationProvider(Ue,vt(_),oe)},registerTypeDefinitionProvider(_,oe){return at.registerTypeDefinitionProvider(Ue,vt(_),oe)},registerHoverProvider(_,oe){return at.registerHoverProvider(Ue,vt(_),oe,Ue.identifier)},registerEvaluatableExpressionProvider(_,oe){return at.registerEvaluatableExpressionProvider(Ue,vt(_),oe,Ue.identifier)},registerInlineValuesProvider(_,oe){return at.registerInlineValuesProvider(Ue,vt(_),oe,Ue.identifier)},registerDocumentHighlightProvider(_,oe){return at.registerDocumentHighlightProvider(Ue,vt(_),oe)},registerMultiDocumentHighlightProvider(_,oe){return at.registerMultiDocumentHighlightProvider(Ue,vt(_),oe)},registerLinkedEditingRangeProvider(_,oe){return at.registerLinkedEditingRangeProvider(Ue,vt(_),oe)},registerReferenceProvider(_,oe){return at.registerReferenceProvider(Ue,vt(_),oe)},registerRenameProvider(_,oe){return at.registerRenameProvider(Ue,vt(_),oe)},registerNewSymbolNamesProvider(_,oe){return(0,Xe.$yG)(Ue,"newSymbolNamesProvider"),at.registerNewSymbolNamesProvider(Ue,vt(_),oe)},registerDocumentSymbolProvider(_,oe,Oe){return at.registerDocumentSymbolProvider(Ue,vt(_),oe,Oe)},registerWorkspaceSymbolProvider(_){return at.registerWorkspaceSymbolProvider(Ue,_)},registerDocumentFormattingEditProvider(_,oe){return at.registerDocumentFormattingEditProvider(Ue,vt(_),oe)},registerDocumentRangeFormattingEditProvider(_,oe){return at.registerDocumentRangeFormattingEditProvider(Ue,vt(_),oe)},registerOnTypeFormattingEditProvider(_,oe,Oe,...rt){return at.registerOnTypeFormattingEditProvider(Ue,vt(_),oe,[Oe].concat(rt))},registerDocumentSemanticTokensProvider(_,oe,Oe){return at.registerDocumentSemanticTokensProvider(Ue,vt(_),oe,Oe)},registerDocumentRangeSemanticTokensProvider(_,oe,Oe){return at.registerDocumentRangeSemanticTokensProvider(Ue,vt(_),oe,Oe)},registerSignatureHelpProvider(_,oe,Oe,...rt){return typeof Oe=="object"?at.registerSignatureHelpProvider(Ue,vt(_),oe,Oe):at.registerSignatureHelpProvider(Ue,vt(_),oe,typeof Oe>"u"?[]:[Oe,...rt])},registerCompletionItemProvider(_,oe,...Oe){return at.registerCompletionItemProvider(Ue,vt(_),oe,Oe)},registerInlineCompletionItemProvider(_,oe,Oe){return oe.handleDidShowCompletionItem&&(0,Xe.$yG)(Ue,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$yG)(Ue,"inlineCompletionsAdditions"),Oe&&(0,Xe.$yG)(Ue,"inlineCompletionsAdditions"),at.registerInlineCompletionsProvider(Ue,vt(_),oe,Oe)},registerInlineEditProvider(_,oe){return(0,Xe.$yG)(Ue,"inlineEdit"),at.registerInlineEditProvider(Ue,vt(_),oe)},registerDocumentLinkProvider(_,oe){return at.registerDocumentLinkProvider(Ue,vt(_),oe)},registerColorProvider(_,oe){return at.registerColorProvider(Ue,vt(_),oe)},registerFoldingRangeProvider(_,oe){return at.registerFoldingRangeProvider(Ue,vt(_),oe)},registerSelectionRangeProvider(_,oe){return at.registerSelectionRangeProvider(Ue,_,oe)},registerCallHierarchyProvider(_,oe){return at.registerCallHierarchyProvider(Ue,_,oe)},registerTypeHierarchyProvider(_,oe){return at.registerTypeHierarchyProvider(Ue,_,oe)},setLanguageConfiguration:(_,oe)=>at.setLanguageConfiguration(Ue,_,oe),getTokenInformationAtPosition(_,oe){return(0,Xe.$yG)(Ue,"tokenInformation"),Zt.tokenAtPosition(_,oe)},registerInlayHintsProvider(_,oe){return at.registerInlayHintsProvider(Ue,_,oe)},createLanguageStatusItem(_,oe){return Zt.createLanguageStatusItem(Ue,_,oe)},registerDocumentDropEditProvider(_,oe,Oe){return at.registerDocumentOnDropEditProvider(Ue,_,oe,(0,Xe.$xG)(Ue,"documentPaste")?Oe:void 0)}},tn={get activeTextEditor(){return qe.getActiveTextEditor()},get visibleTextEditors(){return qe.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(_,oe,Oe){g.URI.isUri(_)&&_.scheme===M.Schemas.vscodeRemote&&!_.authority&&Mt.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(g.URI.isUri(_)?Promise.resolve(Ui.openTextDocument(_)):Promise.resolve(_));return qe.showTextDocument(rt,oe,Oe)},createTextEditorDecorationType(_){return qe.createTextEditorDecorationType(Ue,_)},onDidChangeActiveTextEditor(_,oe,Oe){return it(qe.onDidChangeActiveTextEditor)(_,oe,Oe)},onDidChangeVisibleTextEditors(_,oe,Oe){return it(qe.onDidChangeVisibleTextEditors)(_,oe,Oe)},onDidChangeTextEditorSelection(_,oe,Oe){return it(qe.onDidChangeTextEditorSelection)(_,oe,Oe)},onDidChangeTextEditorOptions(_,oe,Oe){return it(qe.onDidChangeTextEditorOptions)(_,oe,Oe)},onDidChangeTextEditorVisibleRanges(_,oe,Oe){return it(qe.onDidChangeTextEditorVisibleRanges)(_,oe,Oe)},onDidChangeTextEditorViewColumn(_,oe,Oe){return it(qe.onDidChangeTextEditorViewColumn)(_,oe,Oe)},onDidCloseTerminal(_,oe,Oe){return it(St.onDidCloseTerminal)(_,oe,Oe)},onDidOpenTerminal(_,oe,Oe){return it(St.onDidOpenTerminal)(_,oe,Oe)},onDidChangeActiveTerminal(_,oe,Oe){return it(St.onDidChangeActiveTerminal)(_,oe,Oe)},onDidChangeTerminalDimensions(_,oe,Oe){return(0,Xe.$yG)(Ue,"terminalDimensions"),it(St.onDidChangeTerminalDimensions)(_,oe,Oe)},onDidChangeTerminalState(_,oe,Oe){return it(St.onDidChangeTerminalState)(_,oe,Oe)},onDidWriteTerminalData(_,oe,Oe){return(0,Xe.$yG)(Ue,"terminalDataWriteEvent"),it(St.onDidWriteTerminalData)(_,oe,Oe)},onDidExecuteTerminalCommand(_,oe,Oe){return(0,Xe.$yG)(Ue,"terminalExecuteCommandEvent"),it(St.onDidExecuteTerminalCommand)(_,oe,Oe)},onDidChangeTerminalShellIntegration(_,oe,Oe){return(0,Xe.$yG)(Ue,"terminalShellIntegration"),it(li.onDidChangeTerminalShellIntegration)(_,oe,Oe)},onDidStartTerminalShellExecution(_,oe,Oe){return(0,Xe.$yG)(Ue,"terminalShellIntegration"),it(li.onDidStartTerminalShellExecution)(_,oe,Oe)},onDidEndTerminalShellExecution(_,oe,Oe){return(0,Xe.$yG)(Ue,"terminalShellIntegration"),it(li.onDidEndTerminalShellExecution)(_,oe,Oe)},get state(){return jt.getState(Ue)},onDidChangeWindowState(_,oe,Oe){return it(jt.onDidChangeWindowState)(_,oe,Oe)},showInformationMessage(_,...oe){return Ci.showMessage(Ue,m.default.Info,_,oe[0],oe.slice(1))},showWarningMessage(_,...oe){return Ci.showMessage(Ue,m.default.Warning,_,oe[0],oe.slice(1))},showErrorMessage(_,...oe){return Ci.showMessage(Ue,m.default.Error,_,oe[0],oe.slice(1))},showQuickPick(_,oe,Oe){return bi.showQuickPick(Ue,_,oe,Oe)},showWorkspaceFolderPick(_){return bi.showWorkspaceFolderPick(_)},showInputBox(_,oe){return bi.showInput(_,oe)},showOpenDialog(_){return xi.showOpenDialog(Ue,_)},showSaveDialog(_){return xi.showSaveDialog(_)},createStatusBarItem(_,oe,Oe){let rt,wt,At;return typeof _=="string"?(rt=_,wt=oe,At=Oe):(wt=_,At=oe),Oi.createStatusBarEntry(Ue,rt,wt,At)},setStatusBarMessage(_,oe){return Oi.setStatusBarMessage(_,oe)},withScmProgress(_){return Mt.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Hi.withProgress(Ue,{location:ye.ProgressLocation.SourceControl},(oe,Oe)=>_({report(rt){}}))},withProgress(_,oe){return Hi.withProgress(Ue,_,oe)},createOutputChannel(_,oe){return ai.createOutputChannel(_,oe,Ue)},createWebviewPanel(_,oe,Oe,rt){return Pi.createWebviewPanel(Ue,_,oe,Oe,rt)},createWebviewTextEditorInset(_,oe,Oe,rt){return(0,Xe.$yG)(Ue,"editorInsets"),kt.createWebviewEditorInset(_,oe,Oe,rt,Ue)},createTerminal(_,oe,Oe){return typeof _=="object"?"pty"in _?St.createExtensionTerminal(_):St.createTerminalFromOptions(_):St.createTerminal(_,oe,Oe)},registerTerminalLinkProvider(_){return St.registerLinkProvider(_)},registerTerminalProfileProvider(_,oe){return St.registerProfileProvider(Ue,_,oe)},registerTerminalQuickFixProvider(_,oe){return(0,Xe.$yG)(Ue,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(_,Ue.identifier.value,oe)},registerTreeDataProvider(_,oe){return ut.registerTreeDataProvider(_,oe,Ue)},createTreeView(_,oe){return ut.createTreeView(_,oe,Ue)},registerWebviewPanelSerializer:(_,oe)=>Pi.registerWebviewPanelSerializer(Ue,_,oe),registerCustomEditorProvider:(_,oe,Oe={})=>Ki.registerCustomEditorProvider(Ue,_,oe,Oe),registerFileDecorationProvider(_){return It.registerFileDecorationProvider(_,Ue)},registerUriHandler(_){return ni.registerUriHandler(Ue,_)},createQuickPick(){return bi.createQuickPick(Ue)},createInputBox(){return bi.createInputBox(Ue)},get activeColorTheme(){return Si.activeColorTheme},onDidChangeActiveColorTheme(_,oe,Oe){return it(Si.onDidChangeActiveColorTheme)(_,oe,Oe)},registerWebviewViewProvider(_,oe,Oe){return Ji.registerWebviewViewProvider(Ue,_,oe,Oe?.webviewOptions)},get activeNotebookEditor(){return Pe.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,oe,Oe){return it(Pe.onDidChangeActiveNotebookEditor)(_,oe,Oe)},get visibleNotebookEditors(){return Pe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return it(Pe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,oe,Oe){return it(J.onDidChangeNotebookEditorSelection)(_,oe,Oe)},onDidChangeNotebookEditorVisibleRanges(_,oe,Oe){return it(J.onDidChangeNotebookEditorVisibleRanges)(_,oe,Oe)},showNotebookDocument(_,oe){return Pe.showNotebookDocument(_,oe)},registerExternalUriOpener(_,oe,Oe){return(0,Xe.$yG)(Ue,"externalUriOpener"),Qi.registerExternalUriOpener(Ue.identifier,_,oe,Oe)},registerProfileContentHandler(_,oe){return(0,Xe.$yG)(Ue,"profileContentHandlers"),un.registerProfileContentHandler(Ue,_,oe)},registerQuickDiffProvider(_,oe,Oe,rt){return(0,Xe.$yG)(Ue,"quickDiffProvider"),Mi.registerQuickDiffProvider(vt(_),oe,Oe,rt)},get tabGroups(){return Jt.tabGroups},registerShareProvider(_,oe){return(0,Xe.$yG)(Ue,"shareProvider"),Ni.registerShareProvider(vt(_),oe)}},Ui={get rootPath(){return Mt.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(_){throw new N.$9("rootPath")},getWorkspaceFolder(_){return gt.getWorkspaceFolder(_)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(_){throw new N.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(_){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(_,oe,...Oe)=>gt.updateWorkspaceFolders(Ue,_,oe||0,...Oe),onDidChangeWorkspaceFolders:function(_,oe,Oe){return it(gt.onDidChangeWorkspace)(_,oe,Oe)},asRelativePath:(_,oe)=>gt.getRelativePath(_,oe),findFiles:(_,oe,Oe,rt)=>gt.findFiles(_,oe,Oe,Ue.identifier,rt),findFiles2:(_,oe,Oe)=>((0,Xe.$yG)(Ue,"findFiles2"),gt.findFiles2(_,oe,Ue.identifier,Oe)),findTextInFiles:(_,oe,Oe,rt)=>{(0,Xe.$yG)(Ue,"findTextInFiles");let wt,At;return typeof oe=="object"?(wt=oe,At=Oe):(wt={},At=oe,rt=Oe),gt.findTextInFiles(_,wt||{},At,Ue.identifier,rt)},save:_=>gt.save(_),saveAs:_=>gt.saveAs(_),saveAll:_=>gt.saveAll(_),applyEdit(_,oe){return Xi.applyWorkspaceEdit(_,Ue,oe)},createFileSystemWatcher:(_,oe,Oe,rt)=>{let wt;return typeof oe=="boolean"?wt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!rt,correlate:!1}:oe&&((0,Xe.$yG)(Ue,"createFileSystemWatcher"),wt={...oe,correlate:!0}),mi.createFileSystemWatcher(gt,Ue,_,wt)},get textDocuments(){return Rt.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new N.$9("textDocuments")},openTextDocument(_){let oe;const Oe=_;if(typeof _=="string")oe=Promise.resolve(g.URI.file(_));else if(g.URI.isUri(_))oe=Promise.resolve(_);else if(!Oe||typeof Oe=="object")oe=Rt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(rt=>(rt.scheme===M.Schemas.vscodeRemote&&!rt.authority&&Mt.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),Rt.ensureDocumentData(rt).then(wt=>wt.document)))},onDidOpenTextDocument:(_,oe,Oe)=>it(Rt.onDidAddDocument)(_,oe,Oe),onDidCloseTextDocument:(_,oe,Oe)=>it(Rt.onDidRemoveDocument)(_,oe,Oe),onDidChangeTextDocument:(_,oe,Oe)=>it(Rt.onDidChangeDocument)(_,oe,Oe),onDidSaveTextDocument:(_,oe,Oe)=>it(Rt.onDidSaveDocument)(_,oe,Oe),onWillSaveTextDocument:(_,oe,Oe)=>it(we.getOnWillSaveTextDocumentEvent(Ue))(_,oe,Oe),get notebookDocuments(){return Pe.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,oe){let Oe;if(g.URI.isUri(_))Oe=_,await Pe.openNotebookDocument(_);else if(typeof _=="string")Oe=g.URI.revive(await Pe.createNotebookDocument({viewType:_,content:oe}));else throw new Error("Invalid arguments");return Pe.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(_,oe,Oe){return it(ae.onDidSaveNotebookDocument)(_,oe,Oe)},onDidChangeNotebookDocument(_,oe,Oe){return it(ae.onDidChangeNotebookDocument)(_,oe,Oe)},onWillSaveNotebookDocument(_,oe,Oe){return it(Ze.getOnWillSaveNotebookDocumentEvent(Ue))(_,oe,Oe)},get onDidOpenNotebookDocument(){return it(Pe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return it(Pe.onDidCloseNotebookDocument)},registerNotebookSerializer(_,oe,Oe,rt){return Pe.registerNotebookSerializer(Ue,_,oe,Oe,(0,Xe.$xG)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(_,oe,Oe)=>it(fi.onDidChangeConfiguration)(_,oe,Oe),getConfiguration(_,oe){return oe=arguments.length===1?void 0:oe,fi.getConfiguration(_,oe,Ue)},registerTextDocumentContentProvider(_,oe){return yi.registerTextDocumentContentProvider(_,oe)},registerTaskProvider:(_,oe)=>(Mt.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(Ue,_,oe)),registerFileSystemProvider(_,oe,Oe){return(0,F.$Rc)(Xt.registerFileSystemProvider(Ue,_,oe,Oe),ti.addFileSystemProvider(_,oe,Oe))},get fs(){return ti.value},registerFileSearchProvider:(_,oe)=>((0,Xe.$yG)(Ue,"fileSearchProvider"),hi.registerFileSearchProvider(_,oe)),registerTextSearchProvider:(_,oe)=>((0,Xe.$yG)(Ue,"textSearchProvider"),hi.registerTextSearchProvider(_,oe)),registerAITextSearchProvider:(_,oe)=>((0,Xe.$yG)(Ue,"aiTextSearchProvider"),(0,Xe.$yG)(Ue,"textSearchProvider"),hi.registerAITextSearchProvider(_,oe)),registerRemoteAuthorityResolver:(_,oe)=>((0,Xe.$yG)(Ue,"resolvers"),Lt.registerRemoteAuthorityResolver(_,oe)),registerResourceLabelFormatter:_=>((0,Xe.$yG)(Ue,"resolvers"),Gi.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Xe.$yG)(Ue,"resolvers"),Lt.getRemoteExecServer(_)),onDidCreateFiles:(_,oe,Oe)=>it(mi.onDidCreateFile)(_,oe,Oe),onDidDeleteFiles:(_,oe,Oe)=>it(mi.onDidDeleteFile)(_,oe,Oe),onDidRenameFiles:(_,oe,Oe)=>it(mi.onDidRenameFile)(_,oe,Oe),onWillCreateFiles:(_,oe,Oe)=>it(mi.getOnWillCreateFileEvent(Ue))(_,oe,Oe),onWillDeleteFiles:(_,oe,Oe)=>it(mi.getOnWillDeleteFileEvent(Ue))(_,oe,Oe),onWillRenameFiles:(_,oe,Oe)=>it(mi.getOnWillRenameFileEvent(Ue))(_,oe,Oe),openTunnel:_=>((0,Xe.$yG)(Ue,"tunnels"),Ft.openTunnel(Ue,_).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Xe.$yG)(Ue,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(_,oe,Oe)=>((0,Xe.$yG)(Ue,"tunnels"),it(Ft.onDidChangeTunnels)(_,oe,Oe)),registerPortAttributesProvider:(_,oe)=>((0,Xe.$yG)(Ue,"portsAttributes"),Ft.registerPortsAttributesProvider(_,oe)),registerTunnelProvider:(_,oe)=>((0,Xe.$yG)(Ue,"tunnelFactory"),Ft.registerTunnelProvider(_,oe)),registerTimelineProvider:(_,oe)=>((0,Xe.$yG)(Ue,"timeline"),Ti.registerTimelineProvider(_,oe,Ue.identifier,bt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:_=>((0,Xe.$yG)(Ue,"workspaceTrust"),gt.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,oe,Oe)=>it(gt.onDidGrantWorkspaceTrust)(_,oe,Oe),registerEditSessionIdentityProvider:(_,oe)=>((0,Xe.$yG)(Ue,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(_,oe)),onWillCreateEditSessionIdentity:(_,oe,Oe)=>((0,Xe.$yG)(Ue,"editSessionIdentityProvider"),it(gt.getOnWillCreateEditSessionIdentityEvent(Ue))(_,oe,Oe)),registerCanonicalUriProvider:(_,oe)=>((0,Xe.$yG)(Ue,"canonicalUriProvider"),gt.registerCanonicalUriProvider(_,oe)),getCanonicalUri:(_,oe,Oe)=>((0,Xe.$yG)(Ue,"canonicalUriProvider"),gt.provideCanonicalUri(_,oe,Oe))},gn={get inputBox(){return Mt.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Di.getLastInputBox(Ue)},createSourceControl(_,oe,Oe){return Di.createSourceControl(Ue,_,oe,Oe)}},mn={createCommentController(_,oe){return qi.createCommentController(Ue,_,oe)}},nn={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get activeStackItem(){if((0,Xe.$xG)(Ue,"debugFocus"))return yt.activeStackItem},registerDebugVisualizationProvider(_,oe){return(0,Xe.$yG)(Ue,"debugVisualization"),yt.registerDebugVisualizationProvider(Ue,_,oe)},registerDebugVisualizationTreeProvider(_,oe){return(0,Xe.$yG)(Ue,"debugVisualization"),yt.registerDebugVisualizationTree(Ue,_,oe)},onDidStartDebugSession(_,oe,Oe){return it(yt.onDidStartDebugSession)(_,oe,Oe)},onDidTerminateDebugSession(_,oe,Oe){return it(yt.onDidTerminateDebugSession)(_,oe,Oe)},onDidChangeActiveDebugSession(_,oe,Oe){return it(yt.onDidChangeActiveDebugSession)(_,oe,Oe)},onDidReceiveDebugSessionCustomEvent(_,oe,Oe){return it(yt.onDidReceiveDebugSessionCustomEvent)(_,oe,Oe)},onDidChangeBreakpoints(_,oe,Oe){return it(yt.onDidChangeBreakpoints)(_,oe,Oe)},onDidChangeActiveStackItem(_,oe,Oe){return(0,Xe.$yG)(Ue,"debugFocus"),it(yt.onDidChangeActiveStackItem)(_,oe,Oe)},registerDebugConfigurationProvider(_,oe,Oe){return yt.registerDebugConfigurationProvider(_,oe,Oe||Wt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,oe){return yt.registerDebugAdapterDescriptorFactory(Ue,_,oe)},registerDebugAdapterTrackerFactory(_,oe){return yt.registerDebugAdapterTrackerFactory(_,oe)},startDebugging(_,oe,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?yt.startDebugging(_,oe,{parentSession:Oe}):yt.startDebugging(_,oe,Oe||{})},stopDebugging(_){return yt.stopDebugging(_)},addBreakpoints(_){return yt.addBreakpoints(_)},removeBreakpoints(_){return yt.removeBreakpoints(_)},asDebugSourceUri(_,oe){return yt.asDebugSourceUri(_,oe)}},ji={registerTaskProvider:(_,oe)=>Qt.registerTaskProvider(Ue,_,oe),fetchTasks:_=>Qt.fetchTasks(_),executeTask:_=>Qt.executeTask(Ue,_),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(_,oe,Oe)=>it(Qt.onDidStartTask)(_,oe,Oe),onDidEndTask:(_,oe,Oe)=>it(Qt.onDidEndTask)(_,oe,Oe),onDidStartTaskProcess:(_,oe,Oe)=>it(Qt.onDidStartTaskProcess)(_,oe,Oe),onDidEndTaskProcess:(_,oe,Oe)=>it(Qt.onDidEndTaskProcess)(_,oe,Oe)},rn={createNotebookController(_,oe,Oe,rt,wt){return ke.createNotebookController(Ue,_,oe,Oe,rt,(0,Xe.$xG)(Ue,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(_,oe)=>Pe.registerNotebookCellStatusBarItemProvider(Ue,_,oe),createRendererMessaging(_){return We.createRendererMessaging(Ue,_)},createNotebookControllerDetectionTask(_){return(0,Xe.$yG)(Ue,"notebookKernelSource"),ke.createNotebookControllerDetectionTask(Ue,_)},registerKernelSourceActionProvider(_,oe){return(0,Xe.$yG)(Ue,"notebookKernelSource"),ke.registerKernelSourceActionProvider(Ue,_,oe)},onDidChangeNotebookCellExecutionState(_,oe,Oe){return(0,Xe.$yG)(Ue,"notebookCellExecutionState"),it(ke.onDidChangeNotebookCellExecutionState)(_,oe,Oe)}},sn={t(..._){if(typeof _[0]=="string"){const oe=_.shift(),Oe=!_||typeof _[0]!="object"?_:_[0];return pi.getMessage(Ue.identifier.value,{message:oe,args:Oe})}return pi.getMessage(Ue.identifier.value,_[0])},get bundle(){return pi.getBundle(Ue.identifier.value)},get uri(){return pi.getBundleUri(Ue.identifier.value)}},on={_version:1,registerInteractiveEditorSessionProvider(_,oe){return(0,Xe.$yG)(Ue,"interactive"),ln.registerProvider(Ue,_,oe)},registerInteractiveSessionProvider(_,oe){return(0,Xe.$yG)(Ue,"interactive"),F.$Uc.None},transferActiveChat(_){return(0,Xe.$yG)(Ue,"interactive"),ki.transferActiveChat(_)}},$n={getRelatedInformation(_,oe){return(0,Xe.$yG)(Ue,"aiRelatedInformation"),Zi.getRelatedInformation(Ue,_,oe)},registerRelatedInformationProvider(_,oe){return(0,Xe.$yG)(Ue,"aiRelatedInformation"),Zi.registerRelatedInformationProvider(Ue,_,oe)},registerEmbeddingVectorProvider(_,oe){return(0,Xe.$yG)(Ue,"aiRelatedInformation"),hn.registerEmbeddingVectorProvider(Ue,_,oe)}},pn={registerChatResponseProvider(_,oe,Oe){return(0,Xe.$yG)(Ue,"chatProvider"),Nt.registerLanguageModel(Ue,_,oe,Oe)},registerChatVariableResolver(_,oe,Oe){return(0,Xe.$yG)(Ue,"chatVariableResolver"),Fi.registerVariableResolver(Ue,_,oe,Oe)},registerMappedEditsProvider(_,oe){return(0,Xe.$yG)(Ue,"mappedEditsProvider"),at.registerMappedEditsProvider(Ue,_,oe)},createChatParticipant(_,oe){return(0,Xe.$yG)(Ue,"chatParticipant"),ki.createChatAgent(Ue,_,oe)},createDynamicChatParticipant(_,oe,Oe,rt){return(0,Xe.$yG)(Ue,"chatParticipantAdditions"),ki.createDynamicChatAgent(Ue,_,oe,Oe,rt)}},an={get languageModels(){return(0,Xe.$yG)(Ue,"languageModels"),Nt.getLanguageModelIds()},onDidChangeLanguageModels:(_,oe,Oe)=>((0,Xe.$yG)(Ue,"languageModels"),Nt.onDidChangeProviders(_,oe,Oe)),sendChatRequest(_,oe,Oe,rt){return(0,Xe.$yG)(Ue,"languageModels"),Nt.sendChatRequest(Ue,_,oe,Oe,rt)}},cn={registerSpeechProvider(_,oe){return(0,Xe.$yG)(Ue,"speech"),dn.registerProvider(Ue.identifier,_,oe)}};return{version:$t.version,ai:$n,authentication:ci,commands:Ri,comments:mn,chat:pn,debug:nn,env:zi,extensions:en,interactive:on,l10n:sn,languages:fn,lm:an,notebooks:rn,scm:gn,speech:cn,tasks:ji,tests:_i,window:tn,workspace:Ui,Breakpoint:ye.$RN,TerminalOutputAnchor:ye.TerminalOutputAnchor,ChatResultFeedbackKind:ye.ChatResultFeedbackKind,ChatVariableLevel:ye.ChatVariableLevel,ChatCompletionItem:ye.$MO,CallHierarchyIncomingCall:ye.$dN,CallHierarchyItem:ye.$cN,CallHierarchyOutgoingCall:ye.$eN,CancellationError:N.$5,CancellationTokenSource:I.$me,CandidatePortSource:i.CandidatePortSource,CodeAction:ye.$_M,CodeActionKind:ye.$aN,CodeActionTriggerKind:ye.CodeActionTriggerKind,CodeLens:ye.$fN,Color:ye.$sN,ColorInformation:ye.$tN,ColorPresentation:ye.$uN,ColorThemeKind:ye.ColorThemeKind,CommentMode:ye.CommentMode,CommentState:ye.CommentState,CommentThreadCollapsibleState:ye.CommentThreadCollapsibleState,CommentThreadState:ye.CommentThreadState,CommentThreadApplicability:ye.CommentThreadApplicability,CompletionItem:ye.$mN,CompletionItemKind:ye.CompletionItemKind,CompletionItemTag:ye.CompletionItemTag,CompletionList:ye.$nN,CompletionTriggerKind:ye.CompletionTriggerKind,ConfigurationTarget:ye.ConfigurationTarget,CustomExecution:ye.$CN,DebugAdapterExecutable:ye.$VN,DebugAdapterInlineImplementation:ye.$YN,DebugAdapterNamedPipeServer:ye.$XN,DebugAdapterServer:ye.$WN,DebugConfigurationProviderTriggerKind:Wt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:ye.DebugConsoleMode,DebugVisualization:ye.$cO,DecorationRangeBehavior:ye.DecorationRangeBehavior,Diagnostic:ye.$6M,DiagnosticRelatedInformation:ye.$5M,DiagnosticSeverity:ye.DiagnosticSeverity,DiagnosticTag:ye.DiagnosticTag,Disposable:ye.$RM,DocumentHighlight:ye.$8M,DocumentHighlightKind:ye.DocumentHighlightKind,MultiDocumentHighlight:ye.$9M,DocumentLink:ye.$rN,DocumentSymbol:ye.$$M,EndOfLine:ye.EndOfLine,EnvironmentVariableMutatorType:ye.EnvironmentVariableMutatorType,EvaluatableExpression:ye.$2N,InlineValueText:ye.$3N,InlineValueVariableLookup:ye.$4N,InlineValueEvaluatableExpression:ye.$5N,InlineCompletionTriggerKind:ye.InlineCompletionTriggerKind,EventEmitter:R.$be,ExtensionKind:ye.ExtensionKind,ExtensionMode:ye.ExtensionMode,ExternalUriOpenerPriority:ye.ExternalUriOpenerPriority,FileChangeType:ye.FileChangeType,FileDecoration:ye.$eO,FileDecoration2:ye.$eO,FileSystemError:ye.$8N,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:ye.$9N,FoldingRangeKind:ye.FoldingRangeKind,FunctionBreakpoint:ye.$TN,InlineCompletionItem:ye.$oN,InlineCompletionList:ye.$pN,Hover:ye.$7M,IndentAction:k.IndentAction,Location:ye.$4M,MarkdownString:ye.$gN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:ye.$hN,PortAutoForwardAction:ye.PortAutoForwardAction,Position:ye.$SM,ProcessExecution:ye.$AN,ProgressLocation:ye.ProgressLocation,QuickInputButtons:ye.$dO,Range:ye.$TM,RelativePattern:ye.$PN,Selection:ye.$UM,SelectionRange:ye.$bN,SemanticTokens:ye.$_N,SemanticTokensBuilder:ye.$$N,SemanticTokensEdit:ye.$aO,SemanticTokensEdits:ye.$bO,SemanticTokensLegend:ye.$0N,ShellExecution:ye.$BN,ShellQuoting:ye.ShellQuoting,SignatureHelp:ye.$jN,SignatureHelpTriggerKind:ye.SignatureHelpTriggerKind,SignatureInformation:ye.$iN,SnippetString:ye.$3M,SourceBreakpoint:ye.$SN,StandardTokenType:ye.StandardTokenType,StatusBarAlignment:ye.StatusBarAlignment,SymbolInformation:ye.$0M,SymbolKind:ye.SymbolKind,SymbolTag:ye.SymbolTag,Task:ye.$DN,TaskGroup:ye.$zN,TaskPanelKind:ye.TaskPanelKind,TaskRevealKind:ye.TaskRevealKind,TaskScope:ye.TaskScope,TerminalLink:ye.$vN,TerminalQuickFixTerminalCommand:ye.$xN,TerminalQuickFixOpener:ye.$wN,TerminalLocation:ye.TerminalLocation,TerminalProfile:ye.$yN,TerminalExitReason:ye.TerminalExitReason,TextDocumentSaveReason:ye.TextDocumentSaveReason,TextEdit:ye.$YM,SnippetTextEdit:ye.$1M,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:ye.TextEditorLineNumbersStyle,TextEditorRevealType:ye.TextEditorRevealType,TextEditorSelectionChangeKind:ye.TextEditorSelectionChangeKind,SyntaxTokenType:ye.SyntaxTokenType,TextDocumentChangeReason:ye.TextDocumentChangeReason,ThemeColor:ye.$ON,ThemeIcon:ye.$NN,TreeItem:ye.$EN,TreeItemCheckboxState:ye.TreeItemCheckboxState,TreeItemCollapsibleState:ye.TreeItemCollapsibleState,TypeHierarchyItem:ye.$AO,UIKind:Ht.UIKind,Uri:g.URI,ViewColumn:ye.ViewColumn,WorkspaceEdit:ye.$2M,DocumentPasteTriggerKind:ye.DocumentPasteTriggerKind,DocumentDropEdit:ye.$KN,DocumentDropOrPasteEditKind:ye.$LN,DocumentPasteEdit:ye.$MN,InlayHint:ye.$lN,InlayHintLabelPart:ye.$kN,InlayHintKind:ye.InlayHintKind,RemoteAuthorityResolverError:ye.$XM,ResolvedAuthority:ye.$VM,ManagedResolvedAuthority:ye.$WM,SourceControlInputBoxValidationType:ye.SourceControlInputBoxValidationType,ExtensionRuntime:ye.ExtensionRuntime,TimelineItem:ye.$oO,NotebookRange:ye.$gO,NotebookCellKind:ye.NotebookCellKind,NotebookCellExecutionState:ye.NotebookCellExecutionState,NotebookCellData:ye.$hO,NotebookData:ye.$iO,NotebookRendererScript:ye.$mO,NotebookCellStatusBarAlignment:ye.NotebookCellStatusBarAlignment,NotebookEditorRevealType:ye.NotebookEditorRevealType,NotebookCellOutput:ye.$kO,NotebookCellOutputItem:ye.$jO,NotebookCellStatusBarItem:ye.$lO,NotebookControllerAffinity:ye.NotebookControllerAffinity,NotebookControllerAffinity2:ye.NotebookControllerAffinity2,NotebookEdit:ye.$ZM,NotebookKernelSourceAction:ye.$nO,NotebookVariablesRequestKind:ye.NotebookVariablesRequestKind,PortAttributes:ye.$qO,LinkedEditingRanges:ye.$pO,TestResultState:ye.TestResultState,TestRunRequest:ye.$rO,TestMessage:ye.$sO,TestTag:ye.$tO,TestRunProfileKind:ye.TestRunProfileKind,TextSearchCompleteMessageType:ri.TextSearchCompleteMessageType,DataTransfer:ye.$JN,DataTransferItem:ye.$FN,TestCoverageCount:ye.$uO,FileCoverage:ye.$wO,StatementCoverage:ye.$xO,BranchCoverage:ye.$yO,DeclarationCoverage:ye.$zO,WorkspaceTrustState:ye.WorkspaceTrustState,LanguageStatusSeverity:ye.LanguageStatusSeverity,QuickPickItemKind:ye.QuickPickItemKind,InputBoxValidationSeverity:ye.InputBoxValidationSeverity,TabInputText:ye.$BO,TabInputTextDiff:ye.$CO,TabInputTextMerge:ye.$DO,TabInputCustom:ye.$EO,TabInputNotebook:ye.$GO,TabInputNotebookDiff:ye.$HO,TabInputWebview:ye.$FO,TabInputTerminal:ye.$IO,TabInputInteractiveWindow:ye.$JO,TabInputChat:ye.$KO,TabInputTextMultiDiff:ye.$LO,TelemetryTrustedValue:s.$_o,LogLevel:n.LogLevel,EditSessionIdentityMatch:r.EditSessionIdentityMatch,InteractiveSessionVoteDirection:ye.InteractiveSessionVoteDirection,ChatCopyKind:ye.ChatCopyKind,InteractiveEditorResponseFeedbackKind:ye.InteractiveEditorResponseFeedbackKind,StackFrame:ye.$ZN,Thread:ye.$1N,RelatedInformationType:ye.RelatedInformationType,SpeechToTextStatus:ye.SpeechToTextStatus,PartialAcceptTriggerKind:ye.PartialAcceptTriggerKind,KeywordRecognitionStatus:ye.KeywordRecognitionStatus,ChatResponseMarkdownPart:ye.$NO,ChatResponseFileTreePart:ye.$OO,ChatResponseAnchorPart:ye.$PO,ChatResponseProgressPart:ye.$QO,ChatResponseReferencePart:ye.$SO,ChatResponseTextEditPart:ye.$TO,ChatResponseCommandButtonPart:ye.$RO,ChatRequestTurn:ye.$UO,ChatResponseTurn:ye.$VO,ChatLocation:ye.ChatLocation,LanguageModelChatSystemMessage:ye.$WO,LanguageModelChatUserMessage:ye.$XO,LanguageModelChatAssistantMessage:ye.$YO,LanguageModelSystemMessage:ye.$WO,LanguageModelUserMessage:ye.$XO,LanguageModelAssistantMessage:ye.$YO,LanguageModelError:ye.$ZO,NewSymbolName:ye.$7N,NewSymbolNameTag:ye.NewSymbolNameTag,InlineEdit:ye.$1O,InlineEditTriggerKind:ye.InlineEditTriggerKind}}}}),define(Re[298],Ae([1,0,55,116,37,110,38,32,67,51,119,121,122,82,86,78,109,64,44,81,62,66,237,13,120,79,80,84,88,114]),function(ge,e,I,N,R,F,M,m,g,E,T,k,u,w,d,n,o,s,r,i,a,h,t,b,c,$,v,p,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$os)($.$Wkc,$.$Vkc,1),(0,I.$os)(b.$Xj,t.$0lc,1),(0,I.$os)(n.$2jc,n.$3jc,1),(0,I.$os)(m.$wP,m.$vP,0),(0,I.$os)(p.$_jc,p.$akc,0),(0,I.$os)(l.$Qkc,l.$Rkc,0),(0,I.$os)(M.$okc,M.$mkc,0),(0,I.$os)(s.$qkc,s.$pkc,0),(0,I.$os)(k.$7kc,k.$$kc,0),(0,I.$os)(F.$alc,F.$_kc,0),(0,I.$os)(g.$lP,g.$kP,0),(0,I.$os)(v.$Xkc,v.$Ykc,0),(0,I.$os)(r.$6jc,r.$5jc,0),(0,I.$os)(N.$Flc,N.$Elc,1),(0,I.$os)(u.$qlc,u.$rlc,0),(0,I.$os)(w.$Jkc,w.$Ikc,0),(0,I.$os)(T.$Slc,T.$Rlc,0),(0,I.$os)(E.$Mkc,E.$Pkc,0),(0,I.$os)(D.$Tlc,D.$Ulc,0),(0,I.$os)(d.$oCb,d.$pCb,0),(0,I.$os)(o.$8lc,o.$7lc,0),(0,I.$os)(R.$lkc,R.$kkc,0),(0,I.$os)(i.$Tkc,i.$Skc,0),(0,I.$os)(a.$uP,a.$rP,0),(0,I.$os)(h.$Akc,h.$Bkc,0),(0,I.$os)(c.$5kc,c.$6kc,0)}),define(Re[299],Ae([1,0,297,39,2,294,7,11,243]),function(ge,e,I,N,R,F,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=void 0;class E extends F.$amc{j(){}getModule(w,d){for(const n of this.b){const o=n(w);if(o){w=o;break}}if(this.a.has(w))return this.a.get(w).load(w,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends N.$1kc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(g.$goc);const w=this.h.invokeFunction(I.$9lc);this.r=this.h.createInstance(E,w,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(w){return w.browser}async xb(w,d,n){d=d.with({path:k(d.path,".js")});const o=w?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=R.URI.revive(await this.C.$asBrowserUri(d)),r=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),r.status!==200)throw new Error(r.statusText);const i=await r.text(),a=`${d.toString(!0)}#vscode-extension`,h=`${i}
//# sourceURL=${a}`;let t;try{t=new Function("module","exports","require",h)}catch(v){throw console.error(o?`Loading code for extension ${o} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${d.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}w&&await this.w.initializeLocalizedMessages(w);const b={},c={exports:b},$=v=>{const p=this.r.getModule(v,d);if(p===void 0)throw new Error(`Cannot load module '${v}'`);return p};try{return n.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(c,b,$),c.exports!==b?c.exports:b}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),n.codeLoadingStop()}}async $setRemoteEnvironment(w){}async Bb(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+w;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,m.$rh)(10)}}e.$hoc=T;function k(u,w){return u.endsWith(w)?u:u+w}}),define(Re[300],Ae([1,0,70,55,13,39,207,85,299]),function(ge,e,I,N,R,F,M,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,N.$os)(R.$Wj,new I.$ni(M.$_lc,[!0],!0)),(0,N.$os)(F.$2kc,g.$hoc,0),(0,N.$os)(m.$rkc,m.$skc,0)}),define(Re[306],Ae([1,0,22,5,77,295,245,19,89,12,2,298,300]),function(ge,e,I,N,R,F,M,m,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(t){return/^(file|vscode-remote):/i.test(t)}const d=fetch.bind(self);function n(t){self.fetch=async function(b,c){return b instanceof Request||w(String(b))&&(b=(await t(T.URI.parse(String(b)))).toString(!0)),d(b,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(b,c,$,v,p){(async()=>(w(c.toString())&&(c=(await t(T.URI.parse(c.toString()))).toString(!0)),super.open(b,c,$??!0,v,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(b,c){if(/^file:/i.test(b.toString()))b=E.$Kg.uriToBrowserUri(T.URI.parse(b.toString())).toString(!0);else if(/^vscode-remote:/i.test(b.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function(f){function S(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const y=fetch.bind(self);self.fetch=function(P,V){return P instanceof Request?y(P,V):y(S(P),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,V,W,q,A){return super.open(P,S(V),W??!0,q,A)}};const C=importScripts.bind(self);self.importScripts=(...P)=>{C(...P.map(S))},C(f)}.toString()}('${b}'))`;c=c||{},c.name=`${name} -> ${c.name||m.$oc(b.toString())}`;const p=new Blob([v],{type:"application/javascript"}),l=URL.createObjectURL(p);return new t(l,c)}}else self.Worker=class extends M.$ioc{constructor(t,b){super(u,t,{name:m.$oc(t.toString()),...b})}};const o=new class{constructor(){this.pid=void 0}exit(t){k()}};class s{constructor(){const b=new MessageChannel,c=new N.$be;let $=!1;u(b.port2,[b.port2]),b.port1.onmessage=v=>{const{data:p}=v;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const l=I.$Ce.wrap(new Uint8Array(p,0,p.byteLength));if((0,R.$Um)(l,2)){$=!0,i("received terminate message from renderer");return}c.fire(l)},this.protocol={onMessage:c.event,send:v=>{if(!$){const p=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);b.port1.postMessage(p,[p])}}}}}function r(t){return new Promise(b=>{const c=t.onMessage($=>{c.dispose();const v=JSON.parse($.toString());t.send((0,R.$Tm)(0)),b({protocol:t,initData:v})});t.send((0,R.$Tm)(1))})}let i=t=>k();function a(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(b){a(b)&&r(t.protocol).then(c=>{g.mark("code/extHost/didWaitForInitData");const $=new F.$cmc(c.protocol,c.initData,o,null,b.data);n(v=>$.asBrowserUri(v)),i=v=>$.terminate(v)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f8d35f6a712c59f96078161799435d0e83461556/core/vs/workbench/api/worker/extensionHostWorker.js.map
