/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var V=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/equals","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/arrays","vs/base/common/event","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/promise","vs/base/common/cancellation","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/amdX","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],H=function(q){for(var e=[],A=0,y=q.length;A<y;A++)e[A]=V[q[A]];return e};define(V[27],H([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class A{static get(){const E=new Map,O=new Map,r=new Map,u=new Map;function i(c,n){c.has(n.detail)||c.set(n.detail,-n.timestamp)}function a(c,n){const t=c.get(n.detail);t&&(t>=0||c.set(n.detail,t+n.timestamp))}let g=[];typeof q=="function"&&typeof q.getStats=="function"&&(g=q.getStats().slice(0).sort((c,n)=>c.timestamp-n.timestamp));for(const c of g)switch(c.type){case 10:i(E,c);break;case 11:case 12:a(E,c);break;case 21:i(O,c);break;case 22:a(O,c);break;case 33:i(r,c);break;case 34:a(r,c);break;case 31:i(u,c);break;case 32:a(u,c);break}let l=0;r.forEach(c=>l+=c);function $(c){const n=[];return c.forEach((t,s)=>n.push([s,t])),n}return{amdLoad:$(E),amdInvoke:$(O),nodeRequire:$(r),nodeEval:$(u),nodeRequireTotal:l}}static toMarkdownTable(E,O){let r="";const u=[];return E.forEach((i,a)=>{u[a]=i.length}),O.forEach(i=>{i.forEach((a,g)=>{typeof a>"u"&&(a=i[g]="-");const l=a.toString().length;u[g]=Math.max(l,u[g])})}),E.forEach((i,a)=>{r+=`| ${i+" ".repeat(u[a]-i.toString().length)} `}),r+=`|
`,E.forEach((i,a)=>{r+=`| ${"-".repeat(u[a])} `}),r+=`|
`,O.forEach(i=>{i.forEach((a,g)=>{typeof a<"u"&&(r+=`| ${a+" ".repeat(u[g]-a.toString().length)} `)}),r+=`|
`}),r}}e.$U=A}),define(V[7],H([0,1,13]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=E,e.$8c=O,e.$9c=r,e.$0c=u;const y=(i,a)=>i===a;e.$6c=y;function E(i=e.$6c){return(a,g)=>A.$ub(a,g,i)}function O(){return(i,a)=>JSON.stringify(i)===JSON.stringify(a)}function r(){return(i,a)=>i.equals(a)}function u(i,a,g){return!i||!a?i===a:g(i,a)}}),define(V[4],H([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$c=void 0,e.$_c=O,e.$ad=$;class A{constructor(n,t,s){this.owner=n,this.debugNameSource=t,this.referenceFn=s}getDebugName(n){return O(n,this)}}e.$$c=A;const y=new Map,E=new WeakMap;function O(c,n){const t=E.get(c);if(t)return t;const s=r(c,n);if(s){let d=y.get(s)??0;d++,y.set(s,d);const T=d===1?s:`${s}#${d}`;return E.set(c,T),T}}function r(c,n){const t=E.get(c);if(t)return t;const s=n.owner?g(n.owner)+".":"";let d;const T=n.debugNameSource;if(T!==void 0)if(typeof T=="function"){if(d=T(),d!==void 0)return s+d}else return s+T;const L=n.referenceFn;if(L!==void 0&&(d=$(L),d!==void 0))return s+d;if(n.owner!==void 0){const I=u(n.owner,c);if(I!==void 0)return s+I}}function u(c,n){for(const t in c)if(c[t]===n)return t}const i=new Map,a=new WeakMap;function g(c){const n=a.get(c);if(n)return n;const t=l(c);let s=i.get(t)??0;s++,i.set(t,s);const d=s===1?t:`${t}#${s}`;return a.set(c,d),d}function l(c){const n=c.constructor;return n?n.name:"Object"}function $(c){const n=c.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(n);return(s?s[1]:void 0)?.trim()}}),define(V[5],H([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hd=void 0,e.$Fd=y,e.$Gd=E;let A;function y(t){A=t}function E(){return A}class O{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([u(c("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[u(" "),a(g(s.oldValue,70),{color:"red",strikeThrough:!0}),u(" "),a(g(s.newValue,60),{color:"green"})]:[u(" (unchanged)")]:[u(" "),a(g(s.newValue,60),{color:"green"}),u(" (initial)")]}handleObservableChanged(s,d){console.log(...this.b([i("observable value changed"),a(s.debugName,{color:"BlueViolet"}),...this.c(d)]))}formatChanges(s){if(s.size!==0)return a(" (changed deps: "+[...s].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const d=s.handleChange;this.d.set(s,new Set),s.handleChange=(T,L)=>(this.d.get(s).add(T),d.apply(s,[T,L]))}handleDerivedRecomputed(s,d){const T=this.d.get(s);console.log(...this.b([i("derived recomputed"),a(s.debugName,{color:"BlueViolet"}),...this.c(d),this.formatChanges(T),{data:[{fn:s._computeFn}]}])),T.clear()}handleFromEventObservableTriggered(s,d){console.log(...this.b([i("observable from event triggered"),a(s.debugName,{color:"BlueViolet"}),...this.c(d),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const d=s.handleChange;this.d.set(s,new Set),s.handleChange=(T,L)=>(this.d.get(s).add(T),d.apply(s,[T,L]))}handleAutorunTriggered(s){const d=this.d.get(s);console.log(...this.b([i("autorun"),a(s.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:s._runFn}]}])),d.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let d=s.getDebugName();d===void 0&&(d=""),console.log(...this.b([i("transaction"),a(d,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Hd=O;function r(t){const s=new Array,d=[];let T="";function L(k){if("length"in k)for(const f of k)f&&L(f);else"text"in k?(T+=`%c${k.text}`,s.push(k.style),k.data&&d.push(...k.data)):"data"in k&&d.push(...k.data)}L(t);const I=[T,...s];return I.push(...d),I}function u(t){return a(t,{color:"black"})}function i(t){return a(n(`${t}: `,10),{color:"black",bold:!0})}function a(t,s={color:"black"}){function d(L){return Object.entries(L).reduce((I,[k,f])=>`${I}${k}:${f};`,"")}const T={color:s.color};return s.strikeThrough&&(T["text-decoration"]="line-through"),s.bold&&(T["font-weight"]="bold"),{text:t,style:d(T)}}function g(t,s){switch(typeof t){case"number":return""+t;case"string":return t.length+2<=s?`"${t}"`:`"${t.substr(0,s-7)}"+...`;case"boolean":return t?"true":"false";case"undefined":return"undefined";case"object":return t===null?"null":Array.isArray(t)?l(t,s):$(t,s);case"symbol":return t.toString();case"function":return`[[Function${t.name?" "+t.name:""}]]`;default:return""+t}}function l(t,s){let d="[ ",T=!0;for(const L of t){if(T||(d+=", "),d.length-5>s){d+="...";break}T=!1,d+=`${g(L,s-d.length)}`}return d+=" ]",d}function $(t,s){let d="{ ",T=!0;for(const[L,I]of Object.entries(t)){if(T||(d+=", "),d.length-5>s){d+="...";break}T=!1,d+=`${L}: ${g(I,s-d.length)}`}return d+=" }",d}function c(t,s){let d="";for(let T=1;T<=s;T++)d+=t;return d}function n(t,s){for(;t.length<s;)t+=" ";return t}}),define(V[8],H([0,1,28,2,4,5]),function(q,e,A,y,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nd=void 0,e.$hd=r,e.$id=u,e.$jd=i,e.$kd=a,e.$ld=g,e.$md=l;function r(n){return new c(new E.$$c(void 0,void 0,n),n,void 0,void 0)}function u(n,t){return new c(new E.$$c(n.owner,n.debugName,n.debugReferenceFn??t),t,void 0,void 0)}function i(n,t){return new c(new E.$$c(n.owner,n.debugName,n.debugReferenceFn??t),t,n.createEmptyChangeSummary,n.handleChange)}function a(n,t){const s=new y.$Tc,d=i({owner:n.owner,debugName:n.debugName,debugReferenceFn:n.debugReferenceFn,createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(T,L)=>{s.clear(),t(T,L,s)});return(0,y.$Sc)(()=>{d.dispose(),s.dispose()})}function g(n){const t=new y.$Tc,s=u({owner:void 0,debugName:void 0,debugReferenceFn:n},d=>{t.clear(),n(d,t)});return(0,y.$Sc)(()=>{s.dispose(),t.dispose()})}function l(n,t){let s;return u({debugReferenceFn:t},d=>{const T=n.read(d),L=s;s=T,t({lastValue:L,newValue:T})})}var $;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})($||($={}));class c{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(t,s,d,T){this.h=t,this._runFn=s,this.i=d,this.j=T,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,O.$Gd)()?.handleAutorunCreated(this),this.k(),(0,y.$Lc)(this)}dispose(){this.c=!0;for(const t of this.e)t.removeObserver(this);this.e.clear(),(0,y.$Mc)(this)}k(){if(this.a===3)return;const t=this.f;this.f=this.e,this.e=t,this.a=3;const s=this.c;try{if(!s){(0,O.$Gd)()?.handleAutorunTriggered(this);const d=this.g;this.g=this.i?.(),this._runFn(this,d)}}finally{s||(0,O.$Gd)()?.handleAutorunFinished(this);for(const d of this.f)d.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const t of this.e)if(t.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,A.$fd)(()=>this.b>=0)}handlePossibleChange(t){this.a===3&&this.e.has(t)&&!this.f.has(t)&&(this.a=1)}handleChange(t,s){this.e.has(t)&&!this.f.has(t)&&(!this.j||this.j({changedObservable:t,change:s,didChange:T=>T===t},this.g))&&(this.a=2)}readObservable(t){if(this.c)return t.get();t.addObserver(this);const s=t.get();return this.e.add(t),this.f.delete(t),s}}e.$nd=c,function(n){n.Observer=c}(r||(e.$hd=r={}))}),define(V[6],H([0,1,7,4,5]),function(q,e,A,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.$1d=e.$Xd=e.$Sd=e.$Rd=void 0,e.$Od=r,e.$Pd=i,e.$Qd=g,e.$Td=c,e.$Ud=t,e.$Vd=s,e.$Wd=d,e.$Yd=L,e.$Zd=I,e.$2d=f;let O;function r(w){O=w}let u;function i(w){u=w}let a;function g(w){a=w}class l{get TChange(){return null}reportChanges(){this.get()}read(C){return C?C.readObservable(this):this.get()}map(C,D){const b=D===void 0?void 0:C,R=D===void 0?C:D;return a({owner:b,debugName:()=>{const p=(0,y.$ad)(R);if(p!==void 0)return p;const m=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(R.toString());if(m)return`${this.debugName}.${m[2]}`;if(!b)return`${this.debugName} (mapped)`},debugReferenceFn:R},p=>R(this.read(p),p))}recomputeInitiallyAndOnChange(C,D){return C.add(O(this,D)),this}keepObserved(C){return C.add(u(this)),this}get a(){return this.get()}}e.$Rd=l;class $ extends l{constructor(){super(...arguments),this.b=new Set}addObserver(C){const D=this.b.size;this.b.add(C),D===0&&this.c()}removeObserver(C){this.b.delete(C)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Sd=$;function c(w,C){const D=new T(w,C);try{w(D)}finally{D.finish()}}let n;function t(w){if(n)w(n);else{const C=new T(w,void 0);n=C;try{w(C)}finally{C.finish(),n=void 0}}}async function s(w,C){const D=new T(w,C);try{await w(D)}finally{D.finish()}}function d(w,C,D){w?C(w):c(C,D)}class T{constructor(C,D){this._fn=C,this.b=D,this.a=[],(0,E.$Gd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,y.$ad)(this._fn)}updateObserver(C,D){this.a.push({observer:C,observable:D}),C.beginUpdate(D)}finish(){const C=this.a;for(let D=0;D<C.length;D++){const{observer:b,observable:R}=C[D];b.endUpdate(R)}this.a=null,(0,E.$Gd)()?.handleEndTransaction()}}e.$Xd=T;function L(w,C){let D;return typeof w=="string"?D=new y.$$c(void 0,w,void 0):D=new y.$$c(w,void 0,void 0),new k(D,C,A.$6c)}function I(w,C){return new k(new y.$$c(w.owner,w.debugName,void 0),C,w.equalsFn??A.$6c)}class k extends ${get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(C,D,b){super(),this.e=C,this.g=b,this.d=D}get(){return this.d}set(C,D,b){if(this.g(this.d,C))return;let R;D||(D=R=new T(()=>{},()=>`Setting ${this.debugName}`));try{const p=this.d;this.h(C),(0,E.$Gd)()?.handleObservableChanged(this,{oldValue:p,newValue:C,change:b,didChange:!0,hadValue:!0});for(const U of this.b)D.updateObserver(U,this),U.handleChange(this,b)}finally{R&&R.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(C){this.d=C}}e.$1d=k;function f(w,C){let D;return typeof w=="string"?D=new y.$$c(void 0,w,void 0):D=new y.$$c(w,void 0,void 0),new S(D,C,A.$6c)}class S extends k{h(C){this.d!==C&&(this.d&&this.d.dispose(),this.d=C)}dispose(){this.d?.dispose()}}e.$3d=S}),define(V[9],H([0,1,28,7,2,6,4,5]),function(q,e,A,y,E,O,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Id=i,e.$Jd=a,e.$Kd=g,e.$Ld=l,e.$Md=$;function i(t,s){return s!==void 0?new n(new r.$$c(t,void 0,s),s,void 0,void 0,void 0,y.$6c):new n(new r.$$c(void 0,void 0,t),t,void 0,void 0,void 0,y.$6c)}function a(t,s){return new n(new r.$$c(t.owner,t.debugName,t.debugReferenceFn),s,void 0,void 0,t.onLastObserverRemoved,t.equalsFn??y.$6c)}(0,O.$Qd)(a);function g(t,s){return new n(new r.$$c(t.owner,t.debugName,void 0),s,t.createEmptyChangeSummary,t.handleChange,void 0,t.equalityComparer??y.$6c)}function l(t,s){let d,T;s===void 0?(d=t,T=void 0):(T=t,d=s);const L=new E.$Tc;return new n(new r.$$c(T,void 0,d),I=>(L.clear(),d(I,L)),void 0,void 0,()=>L.dispose(),y.$6c)}function $(t,s){let d,T;s===void 0?(d=t,T=void 0):(T=t,d=s);const L=new E.$Tc;return new n(new r.$$c(T,void 0,d),I=>{L.clear();const k=d(I);return k&&L.add(k),k},void 0,void 0,()=>L.dispose(),y.$6c)}var c;(function(t){t[t.initial=0]="initial",t[t.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",t[t.stale=2]="stale",t[t.upToDate=3]="upToDate"})(c||(c={}));class n extends O.$Sd{get debugName(){return this.m.getDebugName(this)??"(anonymous)"}constructor(s,d,T,L,I=void 0,k){super(),this.m=s,this._computeFn=d,this.n=T,this.p=L,this.q=I,this.s=k,this.e=0,this.g=void 0,this.h=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.n?.(),(0,u.$Gd)()?.handleDerivedCreated(this)}f(){this.e=0,this.g=void 0;for(const s of this.j)s.removeObserver(this);this.j.clear(),this.q?.()}get(){if(this.b.size===0){const s=this._computeFn(this,this.n?.());return this.f(),s}else{do{if(this.e===1){for(const s of this.j)if(s.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.u()}while(this.e!==3);return this.g}}u(){if(this.e===3)return;const s=this.k;this.k=this.j,this.j=s;const d=this.e!==0,T=this.g;this.e=3;const L=this.l;this.l=this.n?.();try{this.g=this._computeFn(this,L)}finally{for(const k of this.k)k.removeObserver(this);this.k.clear()}const I=d&&!this.s(T,this.g);if((0,u.$Gd)()?.handleDerivedRecomputed(this,{oldValue:T,newValue:this.g,change:void 0,didChange:I,hadValue:d}),I)for(const k of this.b)k.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(s){this.h++;const d=this.h===1;if(this.e===3&&(this.e=1,!d))for(const T of this.b)T.handlePossibleChange(this);if(d)for(const T of this.b)T.beginUpdate(this)}endUpdate(s){if(this.h--,this.h===0){const d=[...this.b];for(const T of d)T.endUpdate(this)}(0,A.$fd)(()=>this.h>=0)}handlePossibleChange(s){if(this.e===3&&this.j.has(s)&&!this.k.has(s)){this.e=1;for(const d of this.b)d.handlePossibleChange(this)}}handleChange(s,d){if(this.j.has(s)&&!this.k.has(s)){const T=this.p?this.p({changedObservable:s,change:d,didChange:I=>I===s},this.l):!0,L=this.e===3;if(T&&(this.e===1||L)&&(this.e=2,L))for(const I of this.b)I.handlePossibleChange(this)}}readObservable(s){s.addObserver(this);const d=s.get();return this.j.add(s),this.k.delete(s),d}addObserver(s){const d=!this.b.has(s)&&this.h>0;super.addObserver(s),d&&s.beginUpdate(this)}removeObserver(s){const d=this.b.has(s)&&this.h>0;super.removeObserver(s),d&&s.endUpdate(this)}}e.$Nd=n}),define(V[29],H([0,1,8,6,9,30,4,7]),function(q,e,A,y,E,O,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$6d=e.$5d=e.$4d=void 0,e.$8d=$,e.$9d=c;class i{get cachedValue(){return this.a}constructor(t){this.b=t,this.a=(0,y.$Yd)(this,void 0)}getValue(){let t=this.a.get();return t||(t=this.b(),this.a.set(t,void 0)),t}}e.$4d=i;class a{constructor(t){this.a=(0,y.$Yd)(this,void 0),this.promiseResult=this.a,this.promise=t.then(s=>((0,y.$Td)(d=>{this.a.set(new g(s,void 0),d)}),s),s=>{throw(0,y.$Td)(d=>{this.a.set(new g(void 0,s),d)}),s})}}e.$5d=a;class g{constructor(t,s){this.data=t,this.error=s}getDataOrThrow(){if(this.error)throw this.error;return this.data}}e.$6d=g;class l{constructor(t){this.b=t,this.a=new i(()=>new a(this.b())),this.cachedPromiseResult=(0,E.$Id)(this,s=>this.a.cachedValue.read(s)?.promiseResult.read(s))}getPromise(){return this.a.getValue().promise}}e.$7d=l;function $(n,t,s){return t||(t=d=>d!=null),new Promise((d,T)=>{let L=!0,I=!1;const k=n.map(S=>({isFinished:t(S),error:s?s(S):!1,state:S})),f=(0,A.$hd)(S=>{const{isFinished:w,error:C,state:D}=k.read(S);(w||C)&&(L?I=!0:f.dispose(),C?T(C===!0?D:C):d(D))});L=!1,I&&f.dispose()})}function c(n,t){let s,d;t===void 0?(s=n,d=void 0):(d=n,s=t);let T;return new E.$Nd(new r.$$c(d,void 0,s),L=>(T&&T.dispose(!0),T=new O.$me,s(L,T.token)),void 0,void 0,()=>T?.dispose(),u.$6c)}}),define(V[31],H([0,1,14,2,8,6,4,9,5]),function(q,e,A,y,E,O,r,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dd=e.$zd=e.$rd=void 0,e.$od=a,e.$pd=l,e.$qd=$,e.$sd=n,e.$td=s,e.$ud=T,e.$vd=L,e.$wd=I,e.$xd=k,e.$yd=f,e.$Ad=w,e.$Bd=C,e.$Cd=D,e.$Ed=p;function a(U){return new g(U)}class g extends O.$Rd{constructor(m){super(),this.b=m}get debugName(){return this.toString()}get(){return this.b}addObserver(m){}removeObserver(m){}toString(){return`Const: ${this.b}`}}function l(U){const m=(0,O.$Yd)("promiseValue",{});return U.then(o=>{m.set({value:o},void 0)}),m}function $(U,m){return new c(U,m)}class c extends O.$Sd{constructor(m,o){super(),this.j=m,this._getValue=o,this.g=!1,this.n=N=>{const F=this._getValue(N),z=this.e,W=!this.g||z!==F;let G=!1;W&&(this.e=F,this.g&&(G=!0,(0,O.$Wd)(c.globalTransaction,K=>{(0,i.$Gd)()?.handleFromEventObservableTriggered(this,{oldValue:z,newValue:F,change:void 0,didChange:W,hadValue:this.g});for(const Y of this.b)K.updateObserver(Y,this),Y.handleChange(this,void 0)},()=>{const K=this.k();return"Event fired"+(K?`: ${K}`:"")})),this.g=!0),G||(0,i.$Gd)()?.handleFromEventObservableTriggered(this,{oldValue:z,newValue:F,change:void 0,didChange:W,hadValue:this.g})}}k(){return(0,r.$ad)(this._getValue)}get debugName(){const m=this.k();return"From Event"+(m?`: ${m}`:"")}c(){this.h=this.j(this.n)}f(){this.h.dispose(),this.h=void 0,this.g=!1,this.e=void 0}get(){return this.h?(this.g||this.n(void 0),this.e):this._getValue(void 0)}}e.$rd=c,function(U){U.Observer=c;function m(o,N){let F=!1;c.globalTransaction===void 0&&(c.globalTransaction=o,F=!0);try{N()}finally{F&&(c.globalTransaction=void 0)}}U.batchEventsGlobally=m}($||(e.$qd=$={}));function n(U,m){return new t(U,m)}class t extends O.$Sd{constructor(m,o){super(),this.debugName=m,this.g=o,this.j=()=>{(0,O.$Td)(N=>{for(const F of this.b)N.updateObserver(F,this),F.handleChange(this,void 0)},()=>this.debugName)}}c(){this.e=this.g(this.j)}f(){this.e.dispose(),this.e=void 0}get(){}}function s(U){return typeof U=="string"?new d(U):new d(void 0,U)}class d extends O.$Sd{get debugName(){return new r.$$c(this.g,this.e,void 0).getDebugName(this)??"Observable Signal"}constructor(m,o){super(),this.e=m,this.g=o}trigger(m,o){if(!m){(0,O.$Td)(N=>{this.trigger(N,o)},()=>`Trigger signal ${this.debugName}`);return}for(const N of this.b)m.updateObserver(N,this),N.handleChange(this,o)}get(){}}function T(U,m,o){const N=(0,O.$Yd)("debounced",void 0);let F;return o.add((0,E.$hd)(z=>{const W=U.read(z);F&&clearTimeout(F),F=setTimeout(()=>{(0,O.$Td)(G=>{N.set(W,G)})},m)})),N}function L(U,m){let o=!1,N,F;return $(z=>{const W=(0,E.$hd)(G=>{const K=U.read(G);o?(F&&clearTimeout(F),F=setTimeout(()=>{N=K,z()},m)):(o=!0,N=K)});return{dispose(){W.dispose(),o=!1,N=void 0}}},()=>o?N:U.get())}function I(U,m,o){const N=(0,O.$Yd)("triggeredRecently",!1);let F;return o.add(U(()=>{N.set(!0,void 0),F&&clearTimeout(F),F=setTimeout(()=>{N.set(!1,void 0)},m)})),N}function k(U){const m=new S(!1,void 0);return U.addObserver(m),(0,y.$Sc)(()=>{U.removeObserver(m)})}(0,O.$Pd)(k);function f(U,m){const o=new S(!0,m);return U.addObserver(o),m?m(U.get()):U.reportChanges(),(0,y.$Sc)(()=>{U.removeObserver(o)})}(0,O.$Od)(f);class S{constructor(m,o){this.b=m,this.c=o,this.a=0}beginUpdate(m){this.a++}endUpdate(m){this.a--,this.a===0&&this.b&&(this.c?this.c(m.get()):m.reportChanges())}handlePossibleChange(m){}handleChange(m,o){}}e.$zd=S;function w(U,m){let o;return(0,u.$Id)(U,F=>(o=m(F,o),o))}function C(U,m){let o;const N=s("derivedObservableWithWritableCache"),F=(0,u.$Id)(U,z=>(N.read(z),o=m(z,o),o));return Object.assign(F,{clearCache:z=>{o=void 0,N.trigger(z)},setCache:(z,W)=>{o=z,N.trigger(W)}})}function D(U,m,o,N){let F=new b(o,N);return(0,u.$Jd)({debugReferenceFn:o,owner:U,onLastObserverRemoved:()=>{F.dispose(),F=new b(o)}},W=>(F.setItems(m.read(W)),F.getItems()))}class b{constructor(m,o){this.c=m,this.e=o,this.a=new Map,this.b=[]}dispose(){this.a.forEach(m=>m.store.dispose()),this.a.clear()}setItems(m){const o=[],N=new Set(this.a.keys());for(const F of m){const z=this.e?this.e(F):F;let W=this.a.get(z);if(W)N.delete(z);else{const G=new y.$Tc;W={out:this.c(F,G),store:G},this.a.set(z,W)}o.push(W.out)}for(const F of N)this.a.get(F).store.dispose(),this.a.delete(F);this.b=o}getItems(){return this.b}}class R{constructor(m){this.observable=m}get onDidChange(){return A.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}e.$Dd=R;function p(U,m){return m instanceof R?m.observable:$(m.onDidChange,()=>m.value)}}),define(V[15],H([0,1,6,9,8,31,29,5]),function(q,e,A,y,E,O,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedWithCancellationToken=e.waitForState=e.PromiseResult=e.ObservablePromise=e.ObservableLazyPromise=e.ObservableLazy=e.wasEventTriggeredRecently=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return A.$Yd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return A.$2d}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return A.$Td}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return A.$Wd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return y.$Id}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return y.$Jd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return y.$Kd}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return y.$Ld}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return E.$hd}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return E.$md}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return E.$jd}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return E.$ld}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return E.$id}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return E.$kd}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return O.$od}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return O.$ud}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return O.$Ad}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return O.$Bd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return O.$xd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return O.$yd}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return O.$qd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return O.$pd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return O.$td}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return O.$sd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return O.$wd}}),Object.defineProperty(e,"ObservableLazy",{enumerable:!0,get:function(){return r.$4d}}),Object.defineProperty(e,"ObservableLazyPromise",{enumerable:!0,get:function(){return r.$7d}}),Object.defineProperty(e,"ObservablePromise",{enumerable:!0,get:function(){return r.$5d}}),Object.defineProperty(e,"PromiseResult",{enumerable:!0,get:function(){return r.$6d}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return r.$8d}}),Object.defineProperty(e,"derivedWithCancellationToken",{enumerable:!0,get:function(){return r.$9d}}),!1&&(0,u.$Fd)(new u.$Hd)}),define(V[32],H([0,1,10,2]),function(q,e,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ne=E,e.$oe=O,e.$pe=r,e.$qe=u,e.$re=a,e.$se=g,e.$te=l,e.$ue=$,e.$ve=c,e.$we=n,e.$xe=t,e.$ye=s,e.$ze=d,e.$Ae=T,e.$Be=L;function E(I){const k=I;return k?typeof k.read=="function":!1}function O(I){const k=I;return k?[k.on,k.pause,k.resume,k.destroy].every(f=>typeof f=="function"):!1}function r(I){const k=I;return k?O(k.stream)&&Array.isArray(k.buffer)&&typeof k.ended=="boolean":!1}function u(I,k){return new i(I,k)}class i{constructor(k,f){this.e=k,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(k){if(!this.a.destroyed){if(this.a.flowing)this.g(k);else if(this.b.data.push(k),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(k){this.a.destroyed||(this.a.flowing?this.h(k):this.b.error.push(k))}end(k){this.a.destroyed||(typeof k<"u"&&this.write(k),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(k){this.c.data.slice(0).forEach(f=>f(k))}h(k){this.c.error.length===0?(0,A.$1)(k):this.c.error.slice(0).forEach(f=>f(k))}i(){this.c.end.slice(0).forEach(k=>k())}on(k,f){if(!this.a.destroyed)switch(k){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(k,f){if(this.a.destroyed)return;let S;switch(k){case"data":S=this.c.data;break;case"end":S=this.c.end;break;case"error":S=this.c.error;break}if(S){const w=S.indexOf(f);w>=0&&S.splice(w,1)}}j(){if(this.b.data.length>0){const k=this.e(this.b.data);this.g(k),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(S=>S())}}k(){if(this.c.error.length>0){for(const k of this.b.error)this.h(k);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(I,k){const f=[];let S;for(;(S=I.read())!==null;)f.push(S);return k(f)}function g(I,k,f){const S=[];let w;for(;(w=I.read())!==null&&S.length<f;)S.push(w);return w===null&&S.length>0?k(S):{read:()=>{if(S.length>0)return S.shift();if(typeof w<"u"){const C=w;return w=void 0,C}return I.read()}}}function l(I,k){return new Promise((f,S)=>{const w=[];$(I,{onData:C=>{k&&w.push(C)},onError:C=>{k?S(C):f(void 0)},onEnd:()=>{f(k?k(w):void 0)}})})}function $(I,k,f){I.on("error",S=>{f?.isCancellationRequested||k.onError(S)}),I.on("end",()=>{f?.isCancellationRequested||k.onEnd()}),I.on("data",S=>{f?.isCancellationRequested||k.onData(S)})}function c(I,k){return new Promise((f,S)=>{const w=new y.$Tc,C=[],D=p=>{if(C.push(p),C.length>k)return w.dispose(),I.pause(),f({stream:I,buffer:C,ended:!1})},b=p=>(w.dispose(),S(p)),R=()=>(w.dispose(),f({stream:I,buffer:C,ended:!0}));w.add((0,y.$Sc)(()=>I.removeListener("error",b))),I.on("error",b),w.add((0,y.$Sc)(()=>I.removeListener("end",R))),I.on("end",R),w.add((0,y.$Sc)(()=>I.removeListener("data",D))),I.on("data",D)})}function n(I,k){const f=u(k);return f.end(I),f}function t(){const I=u(()=>{throw new Error("not supported")});return I.end(),I}function s(I){let k=!1;return{read:()=>k?null:(k=!0,I)}}function d(I,k,f){const S=u(f);return $(I,{onData:w=>S.write(k.data(w)),onError:w=>S.error(k.error?k.error(w):w),onEnd:()=>S.end()}),S}function T(I,k,f){let S=!1;return{read:()=>{const w=k.read();return S?w:(S=!0,w!==null?f([I,w]):I)}}}function L(I,k,f){let S=!1;const w=u(f);return $(k,{onData:C=>S?w.write(C):(S=!0,w.write(f([I,C]))),onError:C=>w.error(C),onEnd:()=>{S||(S=!0,w.write(I)),w.end()}}),w}}),define(V[16],H([0,1,33,32]),function(q,e,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=void 0,e.$De=a,e.$Ee=g,e.$Fe=l,e.$Ge=$,e.$He=c,e.$Ie=n,e.$Je=t,e.$Ke=s,e.$Le=d,e.$Me=T,e.$Ne=L,e.$Oe=I,e.$Pe=k,e.$Qe=f,e.$Re=S,e.$Se=w,e.$Te=C,e.$Ue=D,e.$Ve=b,e.$We=U;const E=typeof Buffer<"u",O=new A.$V(()=>new Uint8Array(256));let r,u;class i{static alloc(o){return E?new i(Buffer.allocUnsafe(o)):new i(new Uint8Array(o))}static wrap(o){return E&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new i(o)}static fromString(o,N){return!(N?.dontUseNodeBuffer||!1)&&E?new i(Buffer.from(o)):(r||(r=new TextEncoder),new i(r.encode(o)))}static fromByteArray(o){const N=i.alloc(o.length);for(let F=0,z=o.length;F<z;F++)N.buffer[F]=o[F];return N}static concat(o,N){if(typeof N>"u"){N=0;for(let W=0,G=o.length;W<G;W++)N+=o[W].byteLength}const F=i.alloc(N);let z=0;for(let W=0,G=o.length;W<G;W++){const K=o[W];F.set(K,z),z+=K.byteLength}return F}constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}clone(){const o=i.alloc(this.byteLength);return o.set(this),o}toString(){return E?this.buffer.toString():(u||(u=new TextDecoder),u.decode(this.buffer))}slice(o,N){return new i(this.buffer.subarray(o,N))}set(o,N){if(o instanceof i)this.buffer.set(o.buffer,N);else if(o instanceof Uint8Array)this.buffer.set(o,N);else if(o instanceof ArrayBuffer)this.buffer.set(new Uint8Array(o),N);else if(ArrayBuffer.isView(o))this.buffer.set(new Uint8Array(o.buffer,o.byteOffset,o.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(o){return $(this.buffer,o)}writeUInt32BE(o,N){c(this.buffer,o,N)}readUInt32LE(o){return n(this.buffer,o)}writeUInt32LE(o,N){t(this.buffer,o,N)}readUInt8(o){return s(this.buffer,o)}writeUInt8(o,N){d(this.buffer,o,N)}indexOf(o,N=0){return a(this.buffer,o instanceof i?o.buffer:o,N)}}e.$Ce=i;function a(m,o,N=0){const F=o.byteLength,z=m.byteLength;if(F===0)return 0;if(F===1)return m.indexOf(o[0]);if(F>z-N)return-1;const W=O.value;W.fill(o.length);for(let Q=0;Q<o.length;Q++)W[o[Q]]=o.length-Q-1;let G=N+o.length-1,K=G,Y=-1;for(;G<z;)if(m[G]===o[K]){if(K===0){Y=G;break}G--,K--}else G+=Math.max(o.length-K,W[m[G]]),K=o.length-1;return Y}function g(m,o){return m[o+0]<<0>>>0|m[o+1]<<8>>>0}function l(m,o,N){m[N+0]=o&255,o=o>>>8,m[N+1]=o&255}function $(m,o){return m[o]*2**24+m[o+1]*2**16+m[o+2]*2**8+m[o+3]}function c(m,o,N){m[N+3]=o,o=o>>>8,m[N+2]=o,o=o>>>8,m[N+1]=o,o=o>>>8,m[N]=o}function n(m,o){return m[o+0]<<0>>>0|m[o+1]<<8>>>0|m[o+2]<<16>>>0|m[o+3]<<24>>>0}function t(m,o,N){m[N+0]=o&255,o=o>>>8,m[N+1]=o&255,o=o>>>8,m[N+2]=o&255,o=o>>>8,m[N+3]=o&255}function s(m,o){return m[o]}function d(m,o,N){m[N]=o}function T(m){return y.$re(m,o=>i.concat(o))}function L(m){return y.$ye(m)}function I(m){return y.$te(m,o=>i.concat(o))}async function k(m){return m.ended?i.concat(m.buffer):i.concat([...m.buffer,await I(m.stream)])}function f(m){return y.$we(m,o=>i.concat(o))}function S(m){return y.$ze(m,{data:o=>typeof o=="string"?i.fromString(o):i.wrap(o)},o=>i.concat(o))}function w(m){return y.$qe(o=>i.concat(o),m)}function C(m,o){return y.$Ae(m,o,N=>i.concat(N))}function D(m,o){return y.$Be(m,o,N=>i.concat(N))}function b(m){let o=0,N=0,F=0;const z=new Uint8Array(Math.floor(m.length/4*3)),W=K=>{switch(N){case 3:z[F++]=o|K,N=0;break;case 2:z[F++]=o|K>>>2,o=K<<6,N=3;break;case 1:z[F++]=o|K>>>4,o=K<<4,N=2;break;default:o=K<<2,N=1}};for(let K=0;K<m.length;K++){const Y=m.charCodeAt(K);if(Y>=65&&Y<=90)W(Y-65);else if(Y>=97&&Y<=122)W(Y-97+26);else if(Y>=48&&Y<=57)W(Y-48+52);else if(Y===43||Y===45)W(62);else if(Y===47||Y===95)W(63);else{if(Y===61)break;throw new SyntaxError(`Unexpected base64 character ${m[K]}`)}}const G=F;for(;N>0;)W(0);return i.wrap(z).slice(0,G)}const R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function U({buffer:m},o=!0,N=!1){const F=N?p:R;let z="";const W=m.byteLength%3;let G=0;for(;G<m.byteLength-W;G+=3){const K=m[G+0],Y=m[G+1],Q=m[G+2];z+=F[K>>>2],z+=F[(K<<4|Y>>>4)&63],z+=F[(Y<<2|Q>>>6)&63],z+=F[Q&63]}if(W===1){const K=m[G+0];z+=F[K>>>2],z+=F[K<<4&63],o&&(z+="==")}else if(W===2){const K=m[G+0],Y=m[G+1];z+=F[K>>>2],z+=F[(K<<4|Y>>>4)&63],z+=F[Y<<2&63],o&&(z+="=")}return z}}),define(V[34],H([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=void 0,e.$$d=Symbol("MicrotaskDelay")}),define(V[17],H([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Nt=y;var A;(function(E){E[E.Unknown=0]="Unknown",E[E.Invalid=3]="Invalid",E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(A||(e.StringEOL=A={}));function y(E){let O=0,r=0,u=0,i=0;for(let a=0,g=E.length;a<g;a++){const l=E.charCodeAt(a);l===13?(O===0&&(r=a),O++,a+1<g&&E.charCodeAt(a+1)===10?(i|=2,a++):i|=3,u=a+1):l===10&&(i|=1,O===0&&(r=a),O++,u=a+1)}return O===0&&(r=E.length),[O,r,E.length-u,i]}}),define(V[18],H([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var A;(function(i){i[i.Null=0]="Null",i[i.PlainText=1]="PlainText"})(A||(e.LanguageId=A={}));var y;(function(i){i[i.NotSet=-1]="NotSet",i[i.None=0]="None",i[i.Italic=1]="Italic",i[i.Bold=2]="Bold",i[i.Underline=4]="Underline",i[i.Strikethrough=8]="Strikethrough"})(y||(e.FontStyle=y={}));var E;(function(i){i[i.None=0]="None",i[i.DefaultForeground=1]="DefaultForeground",i[i.DefaultBackground=2]="DefaultBackground"})(E||(e.ColorId=E={}));var O;(function(i){i[i.Other=0]="Other",i[i.Comment=1]="Comment",i[i.String=2]="String",i[i.RegEx=3]="RegEx"})(O||(e.StandardTokenType=O={}));var r;(function(i){i[i.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",i[i.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",i[i.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",i[i.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",i[i.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",i[i.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",i[i.ITALIC_MASK=2048]="ITALIC_MASK",i[i.BOLD_MASK=4096]="BOLD_MASK",i[i.UNDERLINE_MASK=8192]="UNDERLINE_MASK",i[i.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",i[i.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",i[i.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",i[i.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",i[i.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",i[i.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",i[i.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",i[i.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",i[i.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",i[i.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",i[i.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",i[i.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",i[i.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class u{static getLanguageId(a){return(a&255)>>>0}static getTokenType(a){return(a&768)>>>8}static containsBalancedBrackets(a){return(a&1024)!==0}static getFontStyle(a){return(a&30720)>>>11}static getForeground(a){return(a&16744448)>>>15}static getBackground(a){return(a&4278190080)>>>24}static getClassNameFromMetadata(a){let l="mtk"+this.getForeground(a);const $=this.getFontStyle(a);return $&1&&(l+=" mtki"),$&2&&(l+=" mtkb"),$&4&&(l+=" mtku"),$&8&&(l+=" mtks"),l}static getInlineStyleFromMetadata(a,g){const l=this.getForeground(a),$=this.getFontStyle(a);let c=`color: ${g[l]};`;$&1&&(c+="font-style: italic;"),$&2&&(c+="font-weight: bold;");let n="";return $&4&&(n+=" underline"),$&8&&(n+=" line-through"),n&&(c+=`text-decoration:${n};`),c}static getPresentationFromMetadata(a){const g=this.getForeground(a),l=this.getFontStyle(a);return{foreground:g,italic:!!(l&1),bold:!!(l&2),underline:!!(l&4),strikethrough:!!(l&8)}}}e.$Lt=u}),define(V[35],H([0,1,13]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QC=void 0;class y{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,u){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=u}replace(r,u,i){if(r>=this.a.length)return;if(u===0){this.insert(r,i);return}else if(i===0){this.delete(r,u);return}const a=this.a.slice(0,r),g=this.a.slice(r+u),l=E(i,this.b);this.a=a.concat(l,g)}delete(r,u){u===0||r>=this.a.length||this.a.splice(r,u)}insert(r,u){if(u===0||r>=this.a.length)return;const i=[];for(let a=0;a<u;a++)i[a]=this.b;this.a=(0,A.$Wb)(this.a,r,i)}}e.$QC=y;function E(O,r){const u=[];for(let i=0;i<O;i++)u[i]=r;return u}}),define(V[11],H([0,1,18]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=void 0;class y{static{this.defaultTokenMetadata=(32768|2<<24)>>>0}static createEmpty(r,u){const i=y.defaultTokenMetadata,a=new Uint32Array(2);return a[0]=r.length,a[1]=i,new y(a,r,u)}constructor(r,u,i){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=u,this.d=i}equals(r){return r instanceof y?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,u,i){if(this.c!==r.c||this.b!==r.b)return!1;const a=u<<1,g=a+(i<<1);for(let l=a;l<g;l++)if(this.a[l]!==r.a[l])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const u=this.a[(r<<1)+1],i=A.$Lt.getLanguageId(u);return this.d.decodeLanguageId(i)}getStandardTokenType(r){const u=this.a[(r<<1)+1];return A.$Lt.getTokenType(u)}getForeground(r){const u=this.a[(r<<1)+1];return A.$Lt.getForeground(u)}getClassName(r){const u=this.a[(r<<1)+1];return A.$Lt.getClassNameFromMetadata(u)}getInlineStyle(r,u){const i=this.a[(r<<1)+1];return A.$Lt.getInlineStyleFromMetadata(i,u)}getPresentation(r){const u=this.a[(r<<1)+1];return A.$Lt.getPresentationFromMetadata(u)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return y.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,u,i){return new E(this,r,u,i)}static convertToEndOffset(r,u){const a=(r.length>>>1)-1;for(let g=0;g<a;g++)r[g<<1]=r[g+1<<1];r[a<<1]=u}static findIndexInTokensArray(r,u){if(r.length<=2)return 0;let i=0,a=(r.length>>>1)-1;for(;i<a;){const g=i+Math.floor((a-i)/2),l=r[g<<1];if(l===u)return g+1;l<u?i=g+1:l>u&&(a=g)}return i}withInserted(r){if(r.length===0)return this;let u=0,i=0,a="";const g=new Array;let l=0;for(;;){const $=u<this.b?this.a[u<<1]:-1,c=i<r.length?r[i]:null;if($!==-1&&(c===null||$<=c.offset)){a+=this.c.substring(l,$);const n=this.a[(u<<1)+1];g.push(a.length,n),u++,l=$}else if(c){if(c.offset>l){a+=this.c.substring(l,c.offset);const n=this.a[(u<<1)+1];g.push(a.length,n),l=c.offset}a+=c.text,g.push(a.length,c.tokenMetadata),i++}else break}return new y(new Uint32Array(g),a,this.d)}}e.$Ot=y;class E{constructor(r,u,i,a){this.a=r,this.b=u,this.c=i,this.d=a,this.e=r.findTokenIndexAtOffset(u),this.f=0;for(let g=this.e,l=r.getCount();g<l&&!(r.getStartOffset(g)>=i);g++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof E?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const u=this.a.getEndOffset(this.e+r);return Math.min(this.c,u)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,u){return this.a.getInlineStyle(this.e+r,u)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(V[36],H([0,1,11]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qt=e.$Pt=void 0,e.$Rt=E,e.$Pt=new Uint32Array(0).buffer;class y{static deleteBeginning(r,u){return r===null||r===e.$Pt?r:y.delete(r,0,u)}static deleteEnding(r,u){if(r===null||r===e.$Pt)return r;const i=E(r),a=i[i.length-2];return y.delete(r,u,a)}static delete(r,u,i){if(r===null||r===e.$Pt||u===i)return r;const a=E(r),g=a.length>>>1;if(u===0&&a[a.length-2]===i)return e.$Pt;const l=A.$Ot.findIndexInTokensArray(a,u),$=l>0?a[l-1<<1]:0,c=a[l<<1];if(i<c){const T=i-u;for(let L=l;L<g;L++)a[L<<1]-=T;return r}let n,t;$!==u?(a[l<<1]=u,n=l+1<<1,t=u):(n=l<<1,t=$);const s=i-u;for(let T=l+1;T<g;T++){const L=a[T<<1]-s;L>t&&(a[n++]=L,a[n++]=a[(T<<1)+1],t=L)}if(n===a.length)return r;const d=new Uint32Array(n);return d.set(a.subarray(0,n),0),d.buffer}static append(r,u){if(u===e.$Pt)return r;if(r===e.$Pt)return u;if(r===null)return r;if(u===null)return null;const i=E(r),a=E(u),g=a.length>>>1,l=new Uint32Array(i.length+a.length);l.set(i,0);let $=i.length;const c=i[i.length-2];for(let n=0;n<g;n++)l[$++]=a[n<<1]+c,l[$++]=a[(n<<1)+1];return l.buffer}static insert(r,u,i){if(r===null||r===e.$Pt)return r;const a=E(r),g=a.length>>>1;let l=A.$Ot.findIndexInTokensArray(a,u);l>0&&a[l-1<<1]===u&&l--;for(let $=l;$<g;$++)a[$<<1]+=i;return r}}e.$Qt=y;function E(O){return O instanceof Uint32Array?O:new Uint32Array(O)}}),define(V[37],H([0,1,13,16,48,17,36,19]),function(q,e,A,y,E,O,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$St=void 0;class i{static deserialize(g,l,$){const c=new Uint32Array(g.buffer),n=(0,y.$Ge)(g,l);l+=4;const t=(0,y.$Ge)(g,l);l+=4;const s=[];for(let d=0;d<t;d++){const T=(0,y.$Ge)(g,l);l+=4,s.push(c.subarray(l/4,l/4+T/4)),l+=T}return $.push(new i(n,s)),l}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(g,l){this.a=g,this.b=l}getLineRange(){return new u.$Bv(this.a,this.a+this.b.length)}getLineTokens(g){return this.b[g-this.a]}appendLineTokens(g){this.b.push(g)}serializeSize(){let g=0;g+=4,g+=4;for(let l=0;l<this.b.length;l++){const $=this.b[l];if(!($ instanceof Uint32Array))throw new Error("Not supported!");g+=4,g+=$.byteLength}return g}serialize(g,l){(0,y.$He)(g,this.a,l),l+=4,(0,y.$He)(g,this.b.length,l),l+=4;for(let $=0;$<this.b.length;$++){const c=this.b[$];if(!(c instanceof Uint32Array))throw new Error("Not supported!");(0,y.$He)(g,c.byteLength,l),l+=4,g.set(new Uint8Array(c.buffer),l),l+=c.byteLength}return l}applyEdit(g,l){const[$,c]=(0,O.$Nt)(l);this.c(g),this.d(new E.$jt(g.startLineNumber,g.startColumn),$,c)}c(g){if(g.startLineNumber===g.endLineNumber&&g.startColumn===g.endColumn)return;const l=g.startLineNumber-this.a,$=g.endLineNumber-this.a;if($<0){const c=$-l;this.a-=c;return}if(!(l>=this.b.length)){if(l<0&&$>=this.b.length){this.a=0,this.b=[];return}if(l===$){this.b[l]=r.$Qt.delete(this.b[l],g.startColumn-1,g.endColumn-1);return}if(l>=0)if(this.b[l]=r.$Qt.deleteEnding(this.b[l],g.startColumn-1),$<this.b.length){const c=r.$Qt.deleteBeginning(this.b[$],g.endColumn-1);this.b[l]=r.$Qt.append(this.b[l],c),this.b.splice(l+1,$-l)}else this.b[l]=r.$Qt.append(this.b[l],null),this.b=this.b.slice(0,l+1);else{const c=-l;this.a-=c,this.b[$]=r.$Qt.deleteBeginning(this.b[$],g.endColumn-1),this.b=this.b.slice($)}}}d(g,l,$){if(l===0&&$===0)return;const c=g.lineNumber-this.a;if(c<0){this.a+=l;return}if(!(c>=this.b.length)){if(l===0){this.b[c]=r.$Qt.insert(this.b[c],g.column-1,$);return}this.b[c]=r.$Qt.deleteEnding(this.b[c],g.column-1),this.b[c]=r.$Qt.insert(this.b[c],g.column-1,$),this.e(g.lineNumber,l)}}e(g,l){if(l===0)return;const $=[];for(let c=0;c<l;c++)$[c]=null;this.b=A.$Wb(this.b,g,$)}}e.$St=i}),define(V[20],H([0,1,16,37]),function(q,e,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RC=void 0;class E{static deserialize(r){let u=0;const i=(0,A.$Ge)(r,u);u+=4;const a=[];for(let g=0;g<i;g++)u=y.$St.deserialize(r,u,a);return a}constructor(){this.a=[]}add(r,u){if(this.a.length>0){const i=this.a[this.a.length-1];if(i.endLineNumber+1===r){i.appendLineTokens(u);return}}this.a.push(new y.$St(r,[u]))}finalize(){return this.a}serialize(){const r=this.b(),u=new Uint8Array(r);return this.c(u),u}b(){let r=0;r+=4;for(let u=0;u<this.a.length;u++)r+=this.a[u].serializeSize();return r}c(r){let u=0;(0,A.$He)(r,this.a.length,u),u+=4;for(let i=0;i<this.a.length;i++)u=this.a[i].serialize(r,u)}}e.$RC=E}),define(V[38],H([0,1,21,3,22,49]),function(q,e,A,y,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=r,e.$kg=u,e.$lg=i,e.$mg=a,e.$ng=g,e.$og=n,e.$pg=t,e.$qg=s,e.$rg=d,e.$sg=T,e.$tg=L,e.$ug=I,e.$vg=k,e.$wg=f,e.$xg=S,e.$yg=D;function r(b){return b===47||b===92}function u(b){return b.replace(/[\\/]/g,A.$hc.sep)}function i(b){return b.indexOf("/")===-1&&(b=u(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function a(b,R=A.$hc.sep){if(!b)return"";const p=b.length,U=b.charCodeAt(0);if(r(U)){if(r(b.charCodeAt(1))&&!r(b.charCodeAt(2))){let o=3;const N=o;for(;o<p&&!r(b.charCodeAt(o));o++);if(N!==o&&!r(b.charCodeAt(o+1))){for(o+=1;o<p;o++)if(r(b.charCodeAt(o)))return b.slice(0,o+1).replace(/[\\/]/g,R)}}return R}else if(d(U)&&b.charCodeAt(1)===58)return r(b.charCodeAt(2))?b.slice(0,2)+R:b.slice(0,2);let m=b.indexOf("://");if(m!==-1){for(m+=3;m<p;m++)if(r(b.charCodeAt(m)))return b.slice(0,m+1)}return""}function g(b){if(!y.$i||!b||b.length<5)return!1;let R=b.charCodeAt(0);if(R!==92||(R=b.charCodeAt(1),R!==92))return!1;let p=2;const U=p;for(;p<b.length&&(R=b.charCodeAt(p),R!==92);p++);return!(U===p||(R=b.charCodeAt(p+1),isNaN(R)||R===92))}const l=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(b,R=y.$i){const p=R?l:$;return!(!b||b.length===0||/^\s+$/.test(b)||(p.lastIndex=0,p.test(b))||R&&c.test(b)||b==="."||b===".."||R&&b[b.length-1]==="."||R&&b.length!==b.trim().length||b.length>255)}function t(b,R,p){const U=b===R;return!p||U?U:!b||!R?!1:(0,E.$tf)(b,R)}function s(b,R,p,U=A.sep){if(b===R)return!0;if(!b||!R||R.length>b.length)return!1;if(p){if(!(0,E.$uf)(b,R))return!1;if(R.length===b.length)return!0;let o=R.length;return R.charAt(R.length-1)===U&&o--,b.charAt(o)===U}return R.charAt(R.length-1)!==U&&(R+=U),b.indexOf(R)===0}function d(b){return b>=65&&b<=90||b>=97&&b<=122}function T(b,R){return y.$i&&b.endsWith(":")&&(b+=A.sep),(0,A.$jc)(b)||(b=(0,A.$kc)(R,b)),b=(0,A.$ic)(b),y.$i?(b=(0,E.$bf)(b,A.sep),b.endsWith(":")&&(b+=A.sep)):(b=(0,E.$bf)(b,A.sep),b||(b=A.sep)),b}function L(b){const R=(0,A.$ic)(b);return y.$i?b.length>3?!1:I(R)&&(b.length===2||R.charCodeAt(2)===92):R===A.$hc.sep}function I(b,R=y.$i){return R?d(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}function k(b,R=y.$i){return I(b,R)?b[0]:void 0}function f(b,R,p){return R.length>b.length?-1:b===R?0:(p&&(b=b.toLowerCase(),R=R.toLowerCase()),b.indexOf(R))}function S(b){const R=b.split(":");let p,U,m;for(const o of R){const N=Number(o);(0,O.$8f)(N)?U===void 0?U=N:m===void 0&&(m=N):p=p?[p,o].join(":"):o}if(!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:U!==void 0?U:void 0,column:m!==void 0?m:U!==void 0?1:void 0}}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",C="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(b,R,p=8){let U="";for(let o=0;o<p;o++){let N;o===0&&y.$i&&!R&&(p===3||p===4)?N=C:N=w,U+=N.charAt(Math.floor(Math.random()*N.length))}let m;return R?m=`${R}-${U}`:m=U,b?(0,A.$kc)(b,m):m}}),define(V[23],H([0,1,10,3,22,12,21]),function(q,e,A,y,E,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Dg=e.$Cg=e.$Bg=e.Schemas=void 0,e.$zg=i,e.$Ag=a,e.$Eg=l;var u;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.vscodeManagedRemoteResource="vscode-managed-remote-resource",n.vscodeUserData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.vscodeChatCodeBlock="vscode-chat-code-block",n.vscodeChatSesssion="vscode-chat-editor",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp",n.vsls="vsls",n.vscodeSourceControl="vscode-scm",n.commentsInput="comment",n.codeSetting="code-setting"})(u||(e.Schemas=u={}));function i(n,t){return O.URI.isUri(n)?(0,E.$tf)(n.scheme,t):(0,E.$uf)(n,t+":")}function a(n,...t){return t.some(s=>i(n,s))}e.$Bg="vscode-tkn",e.$Cg="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(t){this.d=t}setDelegate(t){this.e=t}setServerRootPath(t,s){this.f=l(t,s)}getServerRootPath(){return this.f}get g(){return r.$hc.join(this.f,u.vscodeRemoteResource)}set(t,s,d){this.a[t]=s,this.b[t]=d}setConnectionToken(t,s){this.c[t]=s}getPreferredWebSchema(){return this.d}rewrite(t){if(this.e)try{return this.e(t)}catch(k){return A.$1(k),t}const s=t.authority;let d=this.a[s];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const T=this.b[s],L=this.c[s];let I=`path=${encodeURIComponent(t.path)}`;return typeof L=="string"&&(I+=`&${e.$Cg}=${encodeURIComponent(L)}`),O.URI.from({scheme:y.$o?this.d:u.vscodeRemoteResource,authority:`${d}:${T}`,path:this.g,query:I})}}e.$Dg=new g;function l(n,t){return r.$hc.join(t??"/",`${n.quality??"oss"}-${n.commit??"dev"}`)}e.$Fg="vs/../../extensions",e.$Gg="vs/../../node_modules",e.$Hg="vs/../../node_modules.asar",e.$Ig="vs/../../node_modules.asar.unpacked",e.$Jg="vscode-app";class ${static{this.a=e.$Jg}asBrowserUri(t){const s=this.b(t,q);return this.uriToBrowserUri(s)}uriToBrowserUri(t){return t.scheme===u.vscodeRemote?e.$Dg.rewrite(t):t.scheme===u.file&&(y.$m||y.$q===`${u.vscodeFileResource}://${$.a}`)?t.with({scheme:u.vscodeFileResource,authority:t.authority||$.a,query:null,fragment:null}):t}asFileUri(t){const s=this.b(t,q);return this.uriToFileUri(s)}uriToFileUri(t){return t.scheme===u.vscodeFileResource?t.with({scheme:u.file,authority:t.authority!==$.a?t.authority:null,query:null,fragment:null}):t}b(t,s){return O.URI.isUri(t)?t:O.URI.parse(s.toUrl(t))}}e.$Kg=new $;var c;(function(n){const t=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);n.CoopAndCoep=Object.freeze(t.get("3"));const s="vscode-coi";function d(L){let I;typeof L=="string"?I=new URL(L).searchParams:L instanceof URL?I=L.searchParams:O.URI.isUri(L)&&(I=new URL(L.toString(!0)).searchParams);const k=I?.get(s);if(k)return t.get(k)}n.getHeadersFromQuery=d;function T(L,I,k){if(!globalThis.crossOriginIsolated)return;const f=I&&k?"3":k?"2":"1";L instanceof URLSearchParams?L.set(s,f):L[s]=f}n.addSearchParam=T})(c||(e.COI=c={}))}),define(V[39],H([0,1,27,23,3,12]),function(q,e,A,y,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RD=g;class r{constructor($,c,n){this.id=$,this.dependencies=c,this.callback=n}}class u{static{this.INSTANCE=new u}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,c,n)=>{typeof $!="string"&&(n=c,c=$,$=null),(typeof c!="object"||!Array.isArray(c))&&(n=c,c=null),this.c.push(new r($,c,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const c=await(this.a?this.i($):this.b?this.h($):this.j($));if(!c)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}h($){return new Promise((c,n)=>{const t=document.createElement("script");t.setAttribute("async","async"),t.setAttribute("type","text/javascript");const s=()=>{t.removeEventListener("load",d),t.removeEventListener("error",T)},d=L=>{s(),c(this.c.pop())},T=L=>{s(),n(L)};t.addEventListener("load",d),t.addEventListener("error",T),this.f&&($=this.f.createScriptURL($)),t.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(t)})}i($){return new Promise((c,n)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),c(this.c.pop())}catch(t){n(t)}})}async j($){try{const c=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,t=globalThis._VSCODE_NODE_MODULES.module,s=O.URI.parse($).fsPath,d=c.readFileSync(s).toString(),T=t.wrap(d.replace(/^#!.*/,""));return new n.Script(T).runInThisContext().apply(),this.c.pop()}catch(c){throw c}}}const i=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function g(l,$,c){if(A.$T){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[l]&&(l=a[l]);const n=`${l}/${$}`;if(i.has(n))return i.get(n);let t;if(/^\w[\w\d+.-]*:\/\//.test(n))t=n;else{const L=`${c&&!E.$o?y.$Hg:y.$Gg}/${n}`;t=y.$Kg.asBrowserUri(L).toString(!0)}const s=u.INSTANCE.load(t);return i.set(n,s),s}else return await new Promise((n,t)=>{q([l],n,t)})}}),define(V[24],H([0,1,38,23,21,3,22,12]),function(q,e,A,y,E,O,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0,e.$Rg=i,e.$ah=g,e.$bh=$;function i(c){return(0,u.$xc)(c,!0)}class a{constructor(n){this.a=n}compare(n,t,s=!1){return n===t?0:(0,r.$mf)(this.getComparisonKey(n,s),this.getComparisonKey(t,s))}isEqual(n,t,s=!1){return n===t?!0:!n||!t?!1:this.getComparisonKey(n,s)===this.getComparisonKey(t,s)}getComparisonKey(n,t=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,t,s=!1){if(n.scheme===t.scheme){if(n.scheme===y.Schemas.file)return A.$qg(i(n),i(t),this.a(n))&&n.query===t.query&&(s||n.fragment===t.fragment);if((0,e.$9g)(n.authority,t.authority))return A.$qg(n.path,t.path,this.a(n),"/")&&n.query===t.query&&(s||n.fragment===t.fragment)}return!1}joinPath(n,...t){return u.URI.joinPath(n,...t)}basenameOrAuthority(n){return(0,e.$1g)(n)||n.authority}basename(n){return E.$hc.basename(n.path)}extname(n){return E.$hc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let t;return n.scheme===y.Schemas.file?t=u.URI.file(E.$nc(i(n))).path:(t=E.$hc.dirname(n.path),n.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),t="/")),n.with({path:t})}normalizePath(n){if(!n.path.length)return n;let t;return n.scheme===y.Schemas.file?t=u.URI.file(E.$ic(i(n))).path:t=E.$hc.normalize(n.path),n.with({path:t})}relativePath(n,t){if(n.scheme!==t.scheme||!(0,e.$9g)(n.authority,t.authority))return;if(n.scheme===y.Schemas.file){const T=E.$mc(i(n),i(t));return O.$i?A.$kg(T):T}let s=n.path||"/";const d=t.path||"/";if(this.a(n)){let T=0;for(const L=Math.min(s.length,d.length);T<L&&!(s.charCodeAt(T)!==d.charCodeAt(T)&&s.charAt(T).toLowerCase()!==d.charAt(T).toLowerCase());T++);s=d.substr(0,T)+s.substr(T)}return E.$hc.relative(s,d)}resolvePath(n,t){if(n.scheme===y.Schemas.file){const s=u.URI.file(E.$lc(i(n),t));return n.with({authority:s.authority,path:s.path})}return t=A.$lg(t),n.with({path:E.$hc.resolve(n.path,t)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,t){return n===t||n!==void 0&&t!==void 0&&(0,r.$tf)(n,t)}hasTrailingPathSeparator(n,t=E.sep){if(n.scheme===y.Schemas.file){const s=i(n);return s.length>A.$mg(s).length&&s[s.length-1]===t}else{const s=n.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,t=E.sep){return(0,e.$0g)(n,t)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,t=E.sep){let s=!1;if(n.scheme===y.Schemas.file){const d=i(n);s=d!==void 0&&d.length===A.$mg(d).length&&d[d.length-1]===t}else{t="/";const d=n.path;s=d.length===1&&d.charCodeAt(d.length-1)===47}return!s&&!(0,e.$0g)(n,t)?n.with({path:n.path+"/"}):n}}e.$Sg=a,e.$Tg=new a(()=>!1),e.$Ug=new a(c=>c.scheme===y.Schemas.file?!O.$k:!0),e.$Vg=new a(c=>!0),e.$Wg=e.$Tg.isEqual.bind(e.$Tg),e.$Xg=e.$Tg.isEqualOrParent.bind(e.$Tg),e.$Yg=e.$Tg.getComparisonKey.bind(e.$Tg),e.$Zg=e.$Tg.basenameOrAuthority.bind(e.$Tg),e.$1g=e.$Tg.basename.bind(e.$Tg),e.$2g=e.$Tg.extname.bind(e.$Tg),e.$3g=e.$Tg.dirname.bind(e.$Tg),e.$4g=e.$Tg.joinPath.bind(e.$Tg),e.$5g=e.$Tg.normalizePath.bind(e.$Tg),e.$6g=e.$Tg.relativePath.bind(e.$Tg),e.$7g=e.$Tg.resolvePath.bind(e.$Tg),e.$8g=e.$Tg.isAbsolutePath.bind(e.$Tg),e.$9g=e.$Tg.isEqualAuthority.bind(e.$Tg),e.$0g=e.$Tg.hasTrailingPathSeparator.bind(e.$Tg),e.$$g=e.$Tg.removeTrailingPathSeparator.bind(e.$Tg),e.$_g=e.$Tg.addTrailingPathSeparator.bind(e.$Tg);function g(c,n){const t=[];for(let s=0;s<c.length;s++){const d=n(c[s]);c.some((T,L)=>L===s?!1:(0,e.$Xg)(d,n(T)))||t.push(c[s])}return t}var l;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function n(t){const s=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(L=>{const[I,k]=L.split(":");I&&k&&s.set(I,k)});const T=t.path.substring(0,t.path.indexOf(";"));return T&&s.set(c.META_DATA_MIME,T),s}c.parseMetaData=n})(l||(e.DataUri=l={}));function $(c,n,t){if(n){let s=c.path;return s&&s[0]!==E.$hc.sep&&(s=E.$hc.sep+s),c.with({scheme:t,authority:n,path:s})}return c.with({scheme:t})}}),define(V[25],H([0,1,30,10,14,2,24,3,34,33]),function(q,e,A,y,E,O,r,u,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.Promises=e.$Nh=e.$Mh=e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=void 0,e.$ch=g,e.$dh=l,e.$eh=$,e.$fh=c,e.$gh=n,e.$hh=t,e.$ih=s,e.$jh=d,e.$rh=b,e.$sh=R,e.$th=p,e.$uh=U,e.$vh=m,e.$Kh=ue,e.$Sh=le;function g(j){return!!j&&typeof j.then=="function"}function l(j){const h=new A.$me,v=j(h.token),P=new Promise((M,B)=>{const Z=h.token.onCancellationRequested(()=>{Z.dispose(),B(new y.$5)});Promise.resolve(v).then(_=>{Z.dispose(),h.dispose(),M(_)},_=>{Z.dispose(),h.dispose(),B(_)})});return new class{cancel(){h.cancel(),h.dispose()}then(M,B){return P.then(M,B)}catch(M){return this.then(void 0,M)}finally(M){return P.finally(M)}}}function $(j,h,v){return new Promise((P,M)=>{const B=h.onCancellationRequested(()=>{B.dispose(),P(v)});j.then(P,M).finally(()=>B.dispose())})}function c(j,h){return new Promise((v,P)=>{const M=h.onCancellationRequested(()=>{M.dispose(),P(new y.$5)});j.then(v,P).finally(()=>M.dispose())})}async function n(j){let h=-1;const v=j.map((P,M)=>P.then(B=>(h=M,B)));try{return await Promise.race(v)}finally{j.forEach((P,M)=>{M!==h&&P.cancel()})}}function t(j,h,v){let P;const M=setTimeout(()=>{P?.(void 0),v?.()},h);return Promise.race([j.finally(()=>clearTimeout(M)),new Promise(B=>P=B)])}function s(j){return new Promise((h,v)=>{const P=j();g(P)?P.then(h,v):h(P)})}function d(){let j,h;return{promise:new Promise((P,M)=>{j=P,h=M}),resolve:j,reject:h}}class T{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(h){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=h,!this.b){const v=()=>{if(this.b=null,this.f)return;const P=this.queue(this.d);return this.d=null,P};this.b=new Promise(P=>{this.a.then(v,v).then(P)})}return new Promise((v,P)=>{this.b.then(v,P)})}return this.a=h(),new Promise((v,P)=>{this.a.then(M=>{this.a=null,v(M)},M=>{this.a=null,P(M)})})}dispose(){this.f=!0}}e.$kh=T;class L{constructor(){this.a=Promise.resolve(null)}queue(h){return this.a=this.a.then(()=>h(),()=>h())}}e.$lh=L;class I{constructor(){this.a=new Map}queue(h,v){const M=(this.a.get(h)??Promise.resolve()).catch(()=>{}).then(v).finally(()=>{this.a.get(h)===M&&this.a.delete(h)});return this.a.set(h,M),M}}e.$mh=I;const k=(j,h)=>{let v=!0;const P=setTimeout(()=>{v=!1,h()},j);return{isTriggered:()=>v,dispose:()=>{clearTimeout(P),v=!1}}},f=j=>{let h=!0;return queueMicrotask(()=>{h&&(h=!1,j())}),{isTriggered:()=>h,dispose:()=>{h=!1}}};class S{constructor(h){this.defaultDelay=h,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(h,v=this.defaultDelay){this.g=h,this.h(),this.b||(this.b=new Promise((M,B)=>{this.d=M,this.f=B}).then(()=>{if(this.b=null,this.d=null,this.g){const M=this.g;return this.g=null,M()}}));const P=()=>{this.a=null,this.d?.(null)};return this.a=v===i.$$d?f(P):k(v,P),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new y.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$nh=S;class w{constructor(h){this.a=new S(h),this.b=new T}trigger(h,v){return this.a.trigger(()=>this.b.queue(h),v)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$oh=w;class C{constructor(){this.a=!1,this.b=new Promise((h,v)=>{this.d=h})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$ph=C;class D extends C{constructor(h){super(),this.f=setTimeout(()=>this.open(),h)}open(){clearTimeout(this.f),super.open()}}e.$qh=D;function b(j,h){return h?new Promise((v,P)=>{const M=setTimeout(()=>{B.dispose(),v()},j),B=h.onCancellationRequested(()=>{clearTimeout(M),B.dispose(),P(new y.$5)})}):l(v=>b(j,v))}function R(j,h=0,v){const P=setTimeout(()=>{j(),v&&M.dispose()},h),M=(0,O.$Sc)(()=>{clearTimeout(P),v?.deleteAndLeak(M)});return v?.add(M),M}function p(j){const h=[];let v=0;const P=j.length;function M(){return v<P?j[v++]():null}function B(Z){Z!=null&&h.push(Z);const _=M();return _?_.then(B):Promise.resolve(h)}return Promise.resolve(null).then(B)}function U(j,h=P=>!!P,v=null){let P=0;const M=j.length,B=()=>{if(P>=M)return Promise.resolve(v);const Z=j[P++];return Promise.resolve(Z()).then(X=>h(X)?Promise.resolve(X):B())};return B()}function m(j,h=P=>!!P,v=null){if(j.length===0)return Promise.resolve(v);let P=j.length;const M=()=>{P=-1;for(const B of j)B.cancel?.()};return new Promise((B,Z)=>{for(const _ of j)_.then(X=>{--P>=0&&h(X)?(M(),B(X)):P===0&&B(v)}).catch(X=>{--P>=0&&(M(),Z(X))})})}class o{constructor(h){this.a=0,this.b=!1,this.f=h,this.g=[],this.d=0,this.h=new E.$be}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(h){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((v,P)=>{this.g.push({factory:h,c:v,e:P}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const h=this.g.shift();this.d++;const v=h.factory();v.then(h.c,h.e),v.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$wh=o;class N extends o{constructor(){super(1)}}e.$xh=N;class F{constructor(){this.a=new te,this.b=0}queue(h){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,h())):this.a.run(this.b++,h())}}e.$yh=F;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const h=new x;return this.b.add(h),h.p}g(){for(const[,h]of this.a)if(h.size>0)return!1;return!0}queueSize(h,v=r.$Tg){const P=v.getComparisonKey(h);return this.a.get(P)?.size??0}queueFor(h,v,P=r.$Tg){const M=P.getComparisonKey(h);let B=this.a.get(M);if(!B){B=new N;const Z=this.f++,_=E.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(M),this.h(),this.d?.deleteAndDispose(Z),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$4c),this.d.set(Z,_),this.a.set(M,B)}return B.queue(v)}h(){this.g()&&this.j()}j(){for(const h of this.b)h.complete();this.b.clear()}dispose(){for(const[,h]of this.a)h.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$zh=z;class W{constructor(h,v){this.a=-1,typeof h=="function"&&typeof v=="number"&&this.setIfNotSet(h,v)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(h,v){this.cancel(),this.a=setTimeout(()=>{this.a=-1,h()},v)}setIfNotSet(h,v){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,h()},v))}}e.$Ah=W;class G{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(h,v,P=globalThis){this.cancel();const M=P.setInterval(()=>{h()},v);this.d=(0,O.$Sc)(()=>{P.clearInterval(M),this.d=void 0})}dispose(){this.cancel()}}e.$Bh=G;class K{constructor(h,v){this.b=-1,this.a=h,this.d=v,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(h=this.d){this.cancel(),this.b=setTimeout(this.f,h)}get delay(){return this.d}set delay(h){this.d=h}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ch=K;class Y{constructor(h,v){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.a=h,this.b=v,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(h=this.b){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(h/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Dh=Y;class Q extends K{constructor(h,v){super(h,v),this.j=[]}work(h){this.j.push(h),this.isScheduled()||this.schedule()}h(){const h=this.j;this.j=[],this.a?.(h)}dispose(){this.j=[],super.dispose()}}e.$Eh=Q;class he extends O.$Uc{constructor(h,v){super(),this.g=h,this.h=v,this.a=[],this.b=this.B(new O.$Vc),this.f=!1}get pending(){return this.a.length}work(h){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+h.length>this.g.maxBufferedWork)return!1}else if(this.pending+h.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const v of h)this.a.push(v);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Fh=he,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Hh=(j,h)=>{(0,u.$B)(()=>{if(v)return;const P=Date.now()+15;h(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,P-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:e.$Hh=(j,h,v)=>{const P=j.requestIdleCallback(h,typeof v=="number"?{timeout:v}:void 0);let M=!1;return{dispose(){M||(M=!0,j.cancelIdleCallback(P))}}},e.$Gh=j=>(0,e.$Hh)(globalThis,j)}();class ee{constructor(h,v){this.g=!1,this.d=()=>{try{this.j=v()}catch(P){this.l=P}finally{this.g=!0}},this.f=(0,e.$Hh)(h,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ih=ee;class oe extends ee{constructor(h){super(globalThis,h)}}e.$Jh=oe;async function ue(j,h,v){let P;for(let M=0;M<v;M++)try{return await j()}catch(B){P=B,await b(h)}throw P}class te{isRunning(h){return typeof h=="number"?this.a?.taskId===h:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(h,v,P){return this.a={taskId:h,cancel:()=>P?.(),promise:v},v.then(()=>this.d(h),()=>this.d(h)),v}d(h){this.a&&h===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const h=this.b;this.b=void 0,h.run().then(h.promiseResolve,h.promiseReject)}}queue(h){if(this.b)this.b.run=h;else{const{promise:v,resolve:P,reject:M}=d();this.b={run:h,promise:v,promiseResolve:P,promiseReject:M}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lh=te;class ce{constructor(h,v=()=>Date.now()){this.d=h,this.f=v,this.a=0,this.b=0}increment(){const h=this.f();return h-this.a>this.d&&(this.a=h,this.b=0),this.b++,this.b}}e.$Mh=ce;var ne;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((h,v)=>{this.a=h,this.b=v})}complete(h){return new Promise(v=>{this.a(h),this.d={outcome:0,value:h},v()})}error(h){return new Promise(v=>{this.b(h),this.d={outcome:1,value:h},v()})}cancel(){return this.error(new y.$5)}}e.$Nh=x;var ie;(function(j){async function h(P){let M;const B=await Promise.all(P.map(Z=>Z.then(_=>_,_=>{M||(M=_)})));if(typeof M<"u")throw M;return B}j.settled=h;function v(P){return new Promise(async(M,B)=>{try{await P(M,B)}catch(Z){B(Z)}})}j.withAsyncBody=v})(ie||(e.Promises=ie={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(h){this.a=void 0,this.b=void 0,this.d=!1,this.promise=h.then(v=>(this.a=v,this.d=!0,v),v=>{throw this.b=v,this.d=!0,v})}requireValue(){if(!this.d)throw new y.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Oh=se;class de{constructor(h){this.b=h,this.a=new a.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Ph=de;var re;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(re||(re={}));class J{static fromArray(h){return new J(v=>{v.emitMany(h)})}static fromPromise(h){return new J(async v=>{v.emitMany(await h)})}static fromPromises(h){return new J(async v=>{await Promise.all(h.map(async P=>v.emitOne(await P)))})}static merge(h){return new J(async v=>{await Promise.all(h.map(async P=>{for await(const M of P)v.emitOne(M)}))})}static{this.EMPTY=J.fromArray([])}constructor(h){this.a=0,this.b=[],this.d=null,this.f=new E.$be,queueMicrotask(async()=>{const v={emitOne:P=>this.g(P),emitMany:P=>this.h(P),reject:P=>this.k(P)};try{await Promise.resolve(h(v)),this.j()}catch(P){this.k(P)}finally{v.emitOne=void 0,v.emitMany=void 0,v.reject=void 0}})}[Symbol.asyncIterator](){let h=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(h<this.b.length)return{done:!1,value:this.b[h++]};if(this.a===1)return{done:!0,value:void 0};await E.Event.toPromise(this.f.event)}while(!0)}}}static map(h,v){return new J(async P=>{for await(const M of h)P.emitOne(v(M))})}map(h){return J.map(this,h)}static filter(h,v){return new J(async P=>{for await(const M of h)v(M)&&P.emitOne(M)})}filter(h){return J.filter(this,h)}static coalesce(h){return J.filter(h,v=>!!v)}coalesce(){return J.coalesce(this)}static async toPromise(h){const v=[];for await(const P of h)v.push(P);return v}toPromise(){return J.toPromise(this)}g(h){this.a===0&&(this.b.push(h),this.f.fire())}h(h){this.a===0&&(this.b=this.b.concat(h),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(h){this.a===0&&(this.a=2,this.d=h,this.f.fire())}}e.$Qh=J;class ae extends J{constructor(h,v){super(v),this.l=h}cancel(){this.l.cancel()}}e.$Rh=ae;function le(j){const h=new A.$me,v=j(h.token);return new ae(h,async P=>{const M=h.token.onCancellationRequested(()=>{M.dispose(),h.dispose(),P.reject(new y.$5)});try{for await(const B of v){if(h.token.isCancellationRequested)return;P.emitOne(B)}M.dispose(),h.dispose()}catch(B){M.dispose(),h.dispose(),P.reject(B)}})}class fe{constructor(){this.a=new x,this.b=new J(P=>{if(h){P.reject(h);return}return v&&P.emitMany(v),this.d=M=>P.reject(M),this.f=M=>P.emitOne(M),this.a.p});let h,v;this.f=P=>{v||(v=[]),v.push(P)},this.d=P=>{h||(h=P)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(h){this.d(h),this.a.complete()}emitOne(h){this.f(h)}}e.$Th=fe}),define(V[26],H([0,1,40]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=void 0,e.$OC=y,e.$PC=E,e.$NC=new class{clone(){return this}equals(O){return this===O}};function y(O,r){return new A.$Yt([new A.$Xt(0,"",O)],r)}function E(O,r){const u=new Uint32Array(2);return u[0]=0,u[1]=(O<<0|0|0|32768|2<<24)>>>0,new A.$Zt(u,r===null?e.$NC:r)}}),define(V[41],H([0,1,25,10,3,42,17,19,50,26,35,20,11]),function(q,e,A,y,E,O,r,u,i,a,g,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XC=e.$WC=e.$VC=e.$UC=e.$TC=e.$SC=void 0;var c;(function(k){k[k.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(c||(c={}));class n{constructor(f,S){this.tokenizationSupport=S,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(f)}getStartState(f){return this.store.getStartState(f,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$SC=n;class t extends n{constructor(f,S,w,C){super(f,S),this._textModel=w,this._languageIdCodec=C}updateTokensUntilLine(f,S){const w=this._textModel.getLanguageId();for(;;){const C=this.getFirstInvalidLine();if(!C||C.lineNumber>S)break;const D=this._textModel.getLineContent(C.lineNumber),b=L(this._languageIdCodec,w,this.tokenizationSupport,D,!0,C.startState);f.add(C.lineNumber,b.tokens),this.store.setEndState(C.lineNumber,b.endState)}}getTokenTypeIfInsertingCharacter(f,S){const w=this.getStartState(f.lineNumber);if(!w)return 0;const C=this._textModel.getLanguageId(),D=this._textModel.getLineContent(f.lineNumber),b=D.substring(0,f.column-1)+S+D.substring(f.column-1),R=L(this._languageIdCodec,C,this.tokenizationSupport,b,!0,w),p=new $.$Ot(R.tokens,b,this._languageIdCodec);if(p.getCount()===0)return 0;const U=p.findTokenIndexAtOffset(f.column-1);return p.getStandardTokenType(U)}tokenizeLineWithEdit(f,S,w){const C=f.lineNumber,D=f.column,b=this.getStartState(C);if(!b)return null;const R=this._textModel.getLineContent(C),p=R.substring(0,D-1)+w+R.substring(D-1+S),U=this._textModel.getLanguageIdAtPosition(C,0),m=L(this._languageIdCodec,U,this.tokenizationSupport,p,!0,b);return new $.$Ot(m.tokens,p,this._languageIdCodec)}hasAccurateTokensForLine(f){const S=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<S}isCheapToTokenize(f){const S=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<S||f===S&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,S,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(S<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,w),{heuristicTokens:!1};let C=this.b(S);const D=this._textModel.getLanguageId();for(let b=S;b<=w;b++){const R=this._textModel.getLineContent(b),p=L(this._languageIdCodec,D,this.tokenizationSupport,R,!0,C);f.add(b,p.tokens),C=p.endState}return{heuristicTokens:!0}}b(f){let S=this._textModel.getLineFirstNonWhitespaceColumn(f);const w=[];let C=null;for(let R=f-1;S>1&&R>=1;R--){const p=this._textModel.getLineFirstNonWhitespaceColumn(R);if(p!==0&&p<S&&(w.push(this._textModel.getLineContent(R)),S=p,C=this.getStartState(R),C))break}C||(C=this.tokenizationSupport.getInitialState()),w.reverse();const D=this._textModel.getLanguageId();let b=C;for(const R of w)b=L(this._languageIdCodec,D,this.tokenizationSupport,R,!1,b).endState;return b}}e.$TC=t;class s{constructor(f){this.d=f,this.a=new d,this.b=new T,this.b.addRange(new i.$rt(1,f+1))}getEndState(f){return this.a.getEndState(f)}setEndState(f,S){if(!S)throw new y.$cb("Cannot set null/undefined state");this.b.delete(f);const w=this.a.setEndState(f,S);return w&&f<this.d&&this.b.addRange(new i.$rt(f+1,f+2)),w}acceptChange(f,S){this.d+=S-f.length,this.a.acceptChange(f,S),this.b.addRangeAndResize(new i.$rt(f.startLineNumber,f.endLineNumberExclusive),S)}acceptChanges(f){for(const S of f){const[w]=(0,r.$Nt)(S.text);this.acceptChange(new u.$Bv(S.range.startLineNumber,S.range.endLineNumber+1),w+1)}}invalidateEndStateRange(f){this.b.addRange(new i.$rt(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(f,S){return f===1?S:this.getEndState(f-1)}getFirstInvalidLine(f){const S=this.getFirstInvalidEndStateLineNumber();if(S===null)return null;const w=this.getStartState(S,f);if(!w)throw new y.$cb("Start state must be defined");return{lineNumber:S,startState:w}}}e.$UC=s;class d{constructor(){this.a=new g.$QC(null)}getEndState(f){return this.a.get(f)}setEndState(f,S){const w=this.a.get(f);return w&&w.equals(S)?!1:(this.a.set(f,S),!0)}acceptChange(f,S){let w=f.length;S>0&&w>0&&(w--,S--),this.a.replace(f.startLineNumber,w,S)}acceptChanges(f){for(const S of f){const[w]=(0,r.$Nt)(S.text);this.acceptChange(new u.$Bv(S.range.startLineNumber,S.range.endLineNumber+1),w+1)}}}e.$VC=d;class T{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const f=this.a[0];return f.start+1===f.endExclusive?this.a.shift():this.a[0]=new i.$rt(f.start+1,f.endExclusive),f.start}delete(f){const S=this.a.findIndex(w=>w.contains(f));if(S!==-1){const w=this.a[S];w.start===f?w.endExclusive===f+1?this.a.splice(S,1):this.a[S]=new i.$rt(f+1,w.endExclusive):w.endExclusive===f+1?this.a[S]=new i.$rt(w.start,f):this.a.splice(S,1,new i.$rt(w.start,f),new i.$rt(f+1,w.endExclusive))}}addRange(f){i.$rt.addRange(f,this.a)}addRangeAndResize(f,S){let w=0;for(;!(w>=this.a.length||f.start<=this.a[w].endExclusive);)w++;let C=w;for(;!(C>=this.a.length||f.endExclusive<this.a[C].start);)C++;const D=S-f.length;for(let b=C;b<this.a.length;b++)this.a[b]=this.a[b].delta(D);if(w===C){const b=new i.$rt(f.start,f.start+S);b.isEmpty||this.a.splice(w,0,b)}else{const b=Math.min(f.start,this.a[w].start),R=Math.max(f.endExclusive,this.a[C-1].endExclusive),p=new i.$rt(b,R+D);p.isEmpty?this.a.splice(w,C-w):this.a.splice(w,C-w,p)}}toString(){return this.a.map(f=>f.toString()).join(" + ")}}e.$WC=T;function L(k,f,S,w,C,D){let b=null;if(S)try{b=S.tokenizeEncoded(w,C,D.clone())}catch(R){(0,y.$1)(R)}return b||(b=(0,a.$PC)(k.encodeLanguageId(f),D)),$.$Ot.convertToEndOffset(b.tokens,w.length),b}class I{constructor(f,S){this.b=f,this.d=S,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,A.$Gh)(f=>{this.f=!1,this.h(f)}))}h(f){const S=Date.now()+f.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<S?(0,E.$B)(w):this.g())};w()}j(){const f=this.b._textModel.getLineCount(),S=new l.$RC,w=O.$0d.create(!1);do if(w.elapsed()>1||this.l(S)>=f)break;while(this.k());this.d.setTokens(S.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(f){const S=this.b?.getFirstInvalidLine();return S?(this.b.updateTokensUntilLine(f,S.lineNumber),S.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(f,S){this.b.store.invalidateEndStateRange(new u.$Bv(f,S))}}e.$XC=I}),define(V[43],H([0,1,14,2,42,18,40]),function(q,e,A,y,E,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3Kb=void 0;class u extends y.$Uc{constructor(a,g,l,$,c,n,t){super(),this.c=a,this.f=g,this.g=l,this.h=$,this.j=c,this.m=n,this.n=t,this.a=[],this.b=this.B(new A.$be),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(a,g,l){throw new Error("Not supported!")}createBackgroundTokenizer(a,g){if(this.h)return this.h(a,g)}tokenizeEncoded(a,g,l){const $=Math.random()*1e4<1,c=this.n||$,n=c?new E.$0d(!0):void 0,t=this.c.tokenizeLine2(a,l,500);if(c){const d=n.elapsed();($||d>32)&&this.m(d,a.length,$)}if(t.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${a.substring(0,100)}`),new r.$Zt(t.tokens,l);if(this.g){const d=this.a,T=t.tokens;for(let L=0,I=T.length>>>1;L<I;L++){const k=T[(L<<1)+1],f=O.$Lt.getLanguageId(k);d[f]||(d[f]=!0,this.b.fire(f))}}let s;return l.equals(t.ruleStack)?s=l:s=t.ruleStack,new r.$Zt(t.tokens,s)}}e.$3Kb=u}),define(V[44],H([0,1,26,2,15]),function(q,e,A,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Kb=void 0;class O extends y.$Uc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(u,i,a){super(),this.a=u,this.b=i,this.c=a,this.B((0,E.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(u,i,a){throw new Error("Not supported!")}tokenizeEncoded(u,i,a){return u.length>=this.c.get()?(0,A.$PC)(this.a,a):this.b.tokenizeEncoded(u,i,a)}createBackgroundTokenizer(u,i){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(u,i)}}e.$4Kb=O}),define(V[45],H([0,1,39,25,15,3,19,51,41,20,11,43,44]),function(q,e,A,y,E,O,r,u,i,a,g,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Kb=void 0;class c extends u.$Pv{constructor(s,d,T,L,I,k,f,S){super(s,d,T,L),this.s=I,this.t=k,this.u=f,this.a=null,this.b=!1,this.c=(0,E.observableValue)(this,-1),this.q=new y.$Ch(()=>this.w(),10),this.c.set(S,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,d){this.t=s,this.u=d,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,d){this.a&&(this.a.store.invalidateEndStateRange(new r.$Bv(s,d)),this.q.schedule())}async v(){this.a=null;const s=this.t,d=this.u,T=await this.s.getOrCreateGrammar(s,d);if(!(this.b||s!==this.t||d!==this.u||!T)){if(T.grammar){const L=new $.$4Kb(this.u,new l.$3Kb(T.grammar,T.initialState,!1,void 0,()=>!1,(I,k,f)=>{this.s.reportTokenizationTime(I,s,T.sourceExtensionId,k,f)},!1),this.c);this.a=new i.$SC(this.f.length,L)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:d}=await(0,A.$RD)("vscode-textmate","release/main.js");this.m=d}const s=new Date().getTime();for(;;){let d=0;const T=new a.$RC,L=new n;for(;;){const f=this.a.getFirstInvalidLine();if(f===null||d>200)break;d++;const S=this.f[f.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded(S,!0,f.startState);if(this.a.store.setEndState(f.lineNumber,w.endState)){const D=this.m(f.startState,w.endState);L.setState(f.lineNumber,D)}else L.setState(f.lineNumber,null);if(g.$Ot.convertToEndOffset(w.tokens,S.length),T.add(f.lineNumber,w.tokens),new Date().getTime()-s>20)break}if(d===0)break;const I=L.getStateDeltas();if(this.s.setTokensAndStates(this.h,T.serialize(),I),new Date().getTime()-s>20){(0,O.$B)(()=>this.w());return}}}}e.$9Kb=c;class n{constructor(){this.a=-1,this.b=[]}setState(s,d){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(d):this.b.push({startLineNumber:s,stateDeltas:[d]}),this.a=s}getStateDeltas(){return this.b}}}),define(V[46],H([0,1,24]),function(q,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Kb=void 0;class y{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(O){if(this.a[O.scopeName]){const r=this.a[O.scopeName];A.$Wg(r.location,O.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${O.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${O.location.toString()}`)}this.a[O.scopeName]=O}getGrammarDefinition(O){return this.a[O]||null}}e.$6Kb=y}),define(V[47],H([0,1,2,46]),function(q,e,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Kb=e.$7Kb=void 0,e.$7Kb="No TM Grammar registered for this language.";class E extends A.$Uc{constructor(r,u,i,a){super(),this.a=r,this.b=i.INITIAL,this.c=new y.$6Kb,this.f={},this.g={},this.h=new Map,this.j=this.B(new i.Registry({onigLib:a,loadGrammar:async g=>{const l=this.c.getGrammarDefinition(g);if(!l)return this.a.logTrace(`No grammar found for scope ${g}`),null;const $=l.location;try{const c=await this.a.readFile($);return i.parseRawGrammar(c,$.path)}catch(c){return this.a.logError(`Unable to load and parse grammar for scope ${g} from ${$}`,c),null}},getInjections:g=>{const l=g.split(".");let $=[];for(let c=1;c<=l.length;c++){const n=l.slice(0,c).join(".");$=[...$,...this.f[n]||[]]}return $}}));for(const g of u){if(this.c.register(g),g.injectTo){for(const l of g.injectTo){let $=this.f[l];$||(this.f[l]=$=[]),$.push(g.scopeName)}if(g.embeddedLanguages)for(const l of g.injectTo){let $=this.g[l];$||(this.g[l]=$=[]),$.push(g.embeddedLanguages)}}g.language&&this.h.set(g.language,g.scopeName)}}has(r){return this.h.has(r)}setTheme(r,u){this.j.setTheme(r,u)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,u){const i=this.h.get(r);if(typeof i!="string")throw new Error(e.$7Kb);const a=this.c.getGrammarDefinition(i);if(!a)throw new Error(e.$7Kb);const g=a.embeddedLanguages;if(this.g[i]){const c=this.g[i];for(const n of c)for(const t of Object.keys(n))g[t]=n[t]}const l=Object.keys(g).length>0;let $;try{$=await this.j.loadGrammarWithConfiguration(i,u,{embeddedLanguages:g,tokenTypes:a.tokenTypes,balancedBracketSelectors:a.balancedBracketSelectors,unbalancedBracketSelectors:a.unbalancedBracketSelectors})}catch(c){throw c.message&&c.message.startsWith("No grammar provided for")?new Error(e.$7Kb):c}return{languageId:r,grammar:$,initialState:this.b,containsEmbeddedLanguages:l,sourceExtensionId:a.sourceExtensionId}}}e.$8Kb=E}),define(V[52],H([0,1,12,47,45]),function(q,e,A,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=void 0,e.create=O;function O(u,i){return new r(u,i)}class r{constructor(i,a){this.f=a,this.b=new Map,this.c=[],this.a=i.host;const g=a.grammarDefinitions.map(l=>({location:A.URI.revive(l.location),language:l.language,scopeName:l.scopeName,embeddedLanguages:l.embeddedLanguages,tokenTypes:l.tokenTypes,injectTo:l.injectTo,balancedBracketSelectors:l.balancedBracketSelectors,unbalancedBracketSelectors:l.unbalancedBracketSelectors,sourceExtensionId:l.sourceExtensionId}));this.d=this.g(g)}async g(i){const a=this.f.textmateMainUri,g=await new Promise((t,s)=>{q([a],t,s)}),l=await new Promise((t,s)=>{q([this.f.onigurumaMainUri],t,s)}),c=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await l.loadWASM(c);const n=Promise.resolve({createOnigScanner:t=>l.createOnigScanner(t),createOnigString:t=>l.createOnigString(t)});return new y.$8Kb({logTrace:t=>{},logError:(t,s)=>console.error(t,s),readFile:t=>this.a.readFile(t)},i,g,n)}acceptNewModel(i){const a=A.URI.revive(i.uri),g=this;this.b.set(i.controllerId,new E.$9Kb(a,i.lines,i.EOL,i.versionId,{async getOrCreateGrammar(l,$){const c=await g.d;return c?(g.c[$]||(g.c[$]=c.createGrammar(l,$)),g.c[$]):Promise.resolve(null)},setTokensAndStates(l,$,c){g.a.setTokensAndStates(i.controllerId,l,$,c)},reportTokenizationTime(l,$,c,n,t){g.a.reportTokenizationTime(l,$,c,n,t)}},i.languageId,i.encodedLanguageId,i.maxTokenizationLineLength))}acceptModelChanged(i,a){this.b.get(i).onEvents(a)}retokenize(i,a,g){this.b.get(i).retokenize(a,g)}acceptModelLanguageChanged(i,a,g){this.b.get(i).onLanguageId(a,g)}acceptRemovedModel(i){const a=this.b.get(i);a&&(a.dispose(),this.b.delete(i))}async acceptTheme(i,a){(await this.d)?.setTheme(i,a)}acceptMaxTokenizationLineLength(i,a){this.b.get(i).acceptMaxTokenizationLineLength(a)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f8d35f6a712c59f96078161799435d0e83461556/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
